/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/strings","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/process","os","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/files/common/watcher","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ie=function(J){for(var e=[],L=0,n=J.length;L<n;L++)e[L]=ne[J[L]];return e};define(ne[98],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function L(n,T){if(!n)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=L}),define(ne[48],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function L(k){return k?k.replace(/\$\((.*?)\)/g,(R,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=L;class n{constructor(R,C,E){this.id=R,this.definition=C,this.description=E,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function T(k,R){const C=["codicon","codicon-"+k];return R&&C.push("codicon-modifier-"+R),C}e.getClassNamesArray=T;var _;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function C(b){if(b instanceof n)return["codicon","codicon-"+b.id];const f=R.exec(b.id);if(!f)return C(n.error);let[,S,d]=f;const w=["codicon","codicon-"+S];return d&&w.push("codicon-modifier-"+d.substr(1)),w}k.asClassNameArray=C;function E(b){return C(b).join(" ")}k.asClassName=E;function P(b){return"."+C(b).join(".")}k.asCSSSelector=P})(_=e.CSSIcon||(e.CSSIcon={}))}),define(ne[66],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const L=Object.prototype.hasOwnProperty;function n(P){const b=[];for(let f in P)L.call(P,f)&&b.push(P[f]);return b}e.values=n;function T(P,b){for(let f in P)if(L.call(P,f)&&b({key:f,value:P[f]},function(){delete P[f]})===!1)return}e.forEach=T;function _(P,b){const f=Object.create(null);for(const S of P){const d=b(S);let w=f[d];w||(w=f[d]=[]),w.push(S)}return f}e.groupBy=_;function k(P){const b=Object.create(null);return P&&P.forEach((f,S)=>{b[S]=f}),b}e.fromMap=k;function R(P,b){const f=[],S=[];for(let d of P)b.has(d)||f.push(d);for(let d of b)P.has(d)||S.push(d);return{removed:f,added:S}}e.diffSets=R;function C(P,b){const f=[],S=[];for(let[d,w]of P)b.has(d)||f.push(w);for(let[d,w]of b)P.has(d)||S.push(w);return{removed:f,added:S}}e.diffMaps=C;class E{constructor(){this.map=new Map}add(b,f){let S=this.map.get(b);S||(S=new Set,this.map.set(b,S)),S.add(f)}delete(b,f){const S=this.map.get(b);!S||(S.delete(f),S.size===0&&this.map.delete(b))}forEach(b,f){const S=this.map.get(b);!S||S.forEach(f)}}e.SetMap=E}),define(ne[53],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function L(k){return(R,C,E)=>{let P=null,b=null;if(typeof E.value=="function"?(P="value",b=E.value):typeof E.get=="function"&&(P="get",b=E.get),!b)throw new Error("not supported");E[P]=k(b,C)}}e.createDecorator=L;function n(k,R,C){let E=null,P=null;if(typeof C.value=="function"?(E="value",P=C.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(E="get",P=C.get),!P)throw new Error("not supported");const b=`$memoize$${R}`;C[E]=function(...f){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,f)}),this[b]}}e.memoize=n;function T(k,R,C){return L((E,P)=>{const b=`$debounce$${P}`,f=`$debounce$result$${P}`;return function(...S){this[f]||(this[f]=C?C():void 0),clearTimeout(this[b]),R&&(this[f]=R(this[f],...S),S=[this[f]]),this[b]=setTimeout(()=>{E.apply(this,S),this[f]=C?C():void 0},k)}})}e.debounce=T;function _(k,R,C){return L((E,P)=>{const b=`$throttle$timer$${P}`,f=`$throttle$result$${P}`,S=`$throttle$lastRun$${P}`,d=`$throttle$pending$${P}`;return function(...w){if(this[f]||(this[f]=C?C():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...w)),this[d])return;const p=this[S]+k;p<=Date.now()?(this[S]=Date.now(),E.apply(this,[this[f]]),this[f]=C?C():void 0):(this[d]=!0,this[b]=setTimeout(()=>{this[d]=!1,this[S]=Date.now(),E.apply(this,[this[f]]),this[f]=C?C():void 0},p-Date.now()))}})}e.throttle=_}),define(ne[8],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(a=>{a(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=L,e.errorHandler=new L;function n(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=n;function T(u){C(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=T;function _(u){C(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=_;function k(u){if(u instanceof Error){let{name:r,message:a}=u;const i=u.stacktrace||u.stack;return{$isError:!0,name:r,message:a,stack:i}}return u}e.transformErrorForSerialization=k;const R="Canceled";function C(u){return u instanceof Error&&u.name===R&&u.message===R}e.isPromiseCanceledError=C;class E extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=E;function P(){const u=new Error(R);return u.name=u.message,u}e.canceled=P;function b(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=b;function f(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=f;function S(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function d(u){const r=new Error(`${u} has been disposed`);return r.name="DISPOSED",r}e.disposed=d;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=w;class p extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=p;class v extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=v;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function g(u){const r=u;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=g;function l(u,r=Object.create(null)){const a=new Error(u);return r.actions&&(a.actions=r.actions),a}e.createErrorWithActions=l}),define(ne[16],ie([0,1,8]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(F,j=0){return F[F.length-(1+j)]}e.tail=n;function T(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=T;function _(F,j,B=(z,V)=>z===V){if(F===j)return!0;if(!F||!j||F.length!==j.length)return!1;for(let z=0,V=F.length;z<V;z++)if(!B(F[z],j[z]))return!1;return!0}e.equals=_;function k(F,j,B){let z=0,V=F.length-1;for(;z<=V;){const te=(z+V)/2|0,se=B(F[te],j);if(se<0)z=te+1;else if(se>0)V=te-1;else return te}return-(z+1)}e.binarySearch=k;function R(F,j){let B=0,z=F.length;if(z===0)return 0;for(;B<z;){const V=Math.floor((B+z)/2);j(F[V])?z=V:B=V+1}return B}e.findFirstInSorted=R;function C(F,j,B){if(F=F|0,F>=j.length)throw new TypeError("invalid index");let z=j[Math.floor(j.length*Math.random())],V=[],te=[],se=[];for(let ce of j){const he=B(ce,z);he<0?V.push(ce):he>0?te.push(ce):se.push(ce)}return F<V.length?C(F,V,B):F<V.length+se.length?se[0]:C(F-(V.length+se.length),te,B)}e.quickSelect=C;function E(F,j){const B=[];let z;for(const V of F.slice(0).sort(j))!z||j(z[0],V)!==0?(z=[V],B.push(z)):z.push(V);return B}e.groupBy=E;function P(F,j,B){const z=[];function V(ce,he,me){if(he===0&&me.length===0)return;const ve=z[z.length-1];ve&&ve.start+ve.deleteCount===ce?(ve.deleteCount+=he,ve.toInsert.push(...me)):z.push({start:ce,deleteCount:he,toInsert:me})}let te=0,se=0;for(;;){if(te===F.length){V(te,0,j.slice(se));break}if(se===j.length){V(te,F.length-te,[]);break}const ce=F[te],he=j[se],me=B(ce,he);me===0?(te+=1,se+=1):me<0?(V(te,1,[]),te+=1):me>0&&(V(te,0,[he]),se+=1)}return z}e.sortedDiff=P;function b(F,j,B){const z=P(F,j,B),V=[],te=[];for(const se of z)V.push(...F.slice(se.start,se.start+se.deleteCount)),te.push(...se.toInsert);return{removed:V,added:te}}e.delta=b;function f(F,j,B){if(B===0)return[];const z=F.slice(0,B).sort(j);return d(F,j,z,B,F.length),z}e.top=f;function S(F,j,B,z,V){return B===0?Promise.resolve([]):new Promise((te,se)=>{(async()=>{const ce=F.length,he=F.slice(0,B).sort(j);for(let me=B,ve=Math.min(B+z,ce);me<ce;me=ve,ve=Math.min(ve+z,ce)){if(me>B&&await new Promise(ge=>setTimeout(ge)),V&&V.isCancellationRequested)throw(0,L.canceled)();d(F,j,he,me,ve)}return he})().then(te,se)})}e.topAsync=S;function d(F,j,B,z,V){for(const te=B.length;z<V;z++){const se=F[z];if(j(se,B[te-1])<0){B.pop();const ce=R(B,he=>j(se,he)<0);B.splice(ce,0,se)}}}function w(F){return F.filter(j=>!!j)}e.coalesce=w;function p(F){let j=0;for(let B=0;B<F.length;B++)F[B]&&(F[j]=F[B],j+=1);F.length=j}e.coalesceInPlace=p;function v(F,j,B){F.splice(B,0,F.splice(j,1)[0])}e.move=v;function y(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=y;function g(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=g;function l(F,j=B=>B){const B=new Set;return F.filter(z=>{const V=j(z);return B.has(V)?!1:(B.add(V),!0)})}e.distinct=l;function u(F){const j=Object.create(null);return B=>{const z=F(B);return j[z]?!1:(j[z]=!0,!0)}}e.uniqueFilter=u;function r(F,j){const B=a(F,j);if(B!==-1)return F[B]}e.findLast=r;function a(F,j){for(let B=F.length-1;B>=0;B--){const z=F[B];if(j(z))return B}return-1}e.lastIndex=a;function i(F,j){return F.length>0?F[0]:j}e.firstOrDefault=i;function t(F,j,B=(z,V)=>z===V){let z=0;for(let V=0,te=Math.min(F.length,j.length);V<te&&B(F[V],j[V]);V++)z++;return z}e.commonPrefixLength=t;function s(F){return[].concat(...F)}e.flatten=s;function o(F,j){let B=typeof j=="number"?F:0;typeof j=="number"?B=F:(B=0,j=F);const z=[];if(B<=j)for(let V=B;V<j;V++)z.push(V);else for(let V=B;V>j;V--)z.push(V);return z}e.range=o;function c(F,j,B){return F.reduce((z,V)=>(z[j(V)]=B?B(V):V,z),Object.create(null))}e.index=c;function h(F,j){return F.push(j),()=>m(F,j)}e.insert=h;function m(F,j){const B=F.indexOf(j);if(B>-1)return F.splice(B,1),j}e.remove=m;function I(F,j,B){const z=F.slice(0,j),V=F.slice(j);return z.concat(B,V)}e.arrayInsert=I;function O(F,j){let B;if(typeof j=="number"){let z=j;B=()=>{const V=Math.sin(z++)*179426549;return V-Math.floor(V)}}else B=Math.random;for(let z=F.length-1;z>0;z-=1){const V=Math.floor(B()*(z+1)),te=F[z];F[z]=F[V],F[V]=te}}e.shuffle=O;function A(F,j){const B=F.indexOf(j);B>-1&&(F.splice(B,1),F.unshift(j))}e.pushToStart=A;function N(F,j){const B=F.indexOf(j);B>-1&&(F.splice(B,1),F.push(j))}e.pushToEnd=N;function $(F,j){return Array.isArray(F)?F.map(j):j(F)}e.mapArrayOrNot=$;function D(F){return Array.isArray(F)?F:[F]}e.asArray=D;function M(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=M;function W(F,j){for(const B of F){const z=j(B);if(z!==void 0)return z}}e.mapFind=W;function U(F,j,B){const z=ee(F,j),V=F.length,te=B.length;F.length=V+te;for(let se=V-1;se>=z;se--)F[se+te]=F[se];for(let se=0;se<te;se++)F[se+z]=B[se]}e.insertInto=U;function x(F,j,B,z){const V=ee(F,j),te=F.splice(V,B);return U(F,V,z),te}e.splice=x;function ee(F,j){return j<0?Math.max(j+F.length,0):Math.min(j,F.length)}function G(F,j){return(B,z)=>j(F(B),F(z))}e.compareBy=G;const q=(F,j)=>F-j;e.numberComparator=q;function Y(F,j){if(F.length===0)return;let B=F[0];for(let z=1;z<F.length;z++){const V=F[z];j(V,B)>0&&(B=V)}return B}e.findMaxBy=Y;function H(F,j){if(F.length===0)return;let B=F[0];for(let z=1;z<F.length;z++){const V=F[z];j(V,B)>=0&&(B=V)}return B}e.findLastMaxBy=H;function Z(F,j){return Y(F,(B,z)=>-j(B,z))}e.findMinBy=Z;class K{constructor(j){this.items=j,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(j){let B=this.firstIdx;for(;B<this.items.length&&j(this.items[B]);)B++;const z=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,z}takeFromEndWhile(j){let B=this.lastIdx;for(;B>=0&&j(this.items[B]);)B--;const z=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,z}peek(){return this.items[this.firstIdx]}dequeue(){const j=this.items[this.firstIdx];return this.firstIdx++,j}takeCount(j){const B=this.items.slice(this.firstIdx,this.firstIdx+j);return this.firstIdx+=j,B}}e.ArrayQueue=K}),define(ne[67],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(n){const T=this;let _=!1,k;return function(){return _||(_=!0,k=n.apply(T,arguments)),k}}e.once=L}),define(ne[54],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(n){function T(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}n.is=T;const _=Object.freeze([]);function k(){return _}n.empty=k;function*R(u){yield u}n.single=R;function C(u){return u||_}n.from=C;function E(u){return!u||u[Symbol.iterator]().next().done===!0}n.isEmpty=E;function P(u){return u[Symbol.iterator]().next().value}n.first=P;function b(u,r){for(const a of u)if(r(a))return!0;return!1}n.some=b;function f(u,r){for(const a of u)if(r(a))return a}n.find=f;function*S(u,r){for(const a of u)r(a)&&(yield a)}n.filter=S;function*d(u,r){let a=0;for(const i of u)yield r(i,a++)}n.map=d;function*w(...u){for(const r of u)for(const a of r)yield a}n.concat=w;function*p(u){for(const r of u)for(const a of r)yield a}n.concatNested=p;function v(u,r,a){let i=a;for(const t of u)i=r(i,t);return i}n.reduce=v;function*y(u,r,a=u.length){for(r<0&&(r+=u.length),a<0?a+=u.length:a>u.length&&(a=u.length);r<a;r++)yield u[r]}n.slice=y;function g(u,r=Number.POSITIVE_INFINITY){const a=[];if(r===0)return[a,u];const i=u[Symbol.iterator]();for(let t=0;t<r;t++){const s=i.next();if(s.done)return[a,n.empty()];a.push(s.value)}return[a,{[Symbol.iterator](){return i}}]}n.consume=g;function l(u,r,a=(i,t)=>i===t){const i=u[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const s=i.next(),o=t.next();if(s.done!==o.done)return!1;if(s.done)return!0;if(!a(s.value,o.value))return!1}}n.equals=l})(L=e.Iterable||(e.Iterable={}))}),define(ne[35],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var n;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(r){r.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function k(r,a=!1){let i=0,t=r.length,s="",o=0,c=16,h=0;function m(M){let W=0,U=0;for(;W<M;){const x=r.charCodeAt(i);if(x>=48&&x<=57)U=U*16+x-48;else if(x>=65&&x<=70)U=U*16+x-65+10;else if(x>=97&&x<=102)U=U*16+x-97+10;else break;i++,W++}return W<M&&(U=-1),U}function I(M){i=M,s="",o=0,c=16,h=0}function O(){const M=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&E(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&E(r.charCodeAt(i)))for(i++;i<r.length&&E(r.charCodeAt(i));)i++;else return h=3,r.substring(M,i);let W=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&E(r.charCodeAt(i))){for(i++;i<r.length&&E(r.charCodeAt(i));)i++;W=i}else h=3;return r.substring(M,W)}function A(){let M="",W=i;for(;;){if(i>=t){M+=r.substring(W,i),h=2;break}const U=r.charCodeAt(i);if(U===34){M+=r.substring(W,i),i++;break}if(U===92){if(M+=r.substring(W,i),i++,i>=t){h=2;break}switch(r.charCodeAt(i++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const ee=m(4);ee>=0?M+=String.fromCharCode(ee):h=4;break}default:h=5}W=i;continue}if(U>=0&&U<=31)if(C(U)){M+=r.substring(W,i),h=2;break}else h=6;i++}return M}function N(){if(s="",h=0,o=i,i>=t)return o=t,c=17;let M=r.charCodeAt(i);if(R(M)){do i++,s+=String.fromCharCode(M),M=r.charCodeAt(i);while(R(M));return c=15}if(C(M))return i++,s+=String.fromCharCode(M),M===13&&r.charCodeAt(i)===10&&(i++,s+=`
`),c=14;switch(M){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,s=A(),c=10;case 47:{const W=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<t&&!C(r.charCodeAt(i));)i++;return s=r.substring(W,i),c=12}if(r.charCodeAt(i+1)===42){i+=2;const U=t-1;let x=!1;for(;i<U;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,x=!0;break}i++}return x||(i++,h=1),s=r.substring(W,i),c=13}return s+=String.fromCharCode(M),i++,c=16}case 45:if(s+=String.fromCharCode(M),i++,i===t||!E(r.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),c=11;default:for(;i<t&&$(M);)i++,M=r.charCodeAt(i);if(o!==i){switch(s=r.substring(o,i),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(M),i++,c=16}}function $(M){if(R(M)||C(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function D(){let M;do M=N();while(M>=12&&M<=15);return M}return{setPosition:I,getPosition:()=>i,scan:a?D:N,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>h}}e.createScanner=k;function R(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function C(r){return r===10||r===13||r===8232||r===8233}function E(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function b(r,a){const i=[],t=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function h(m,I,O,A){o.value=m,o.offset=I,o.length=O,o.type=A,o.colonOffset=void 0,s=o}try{g(r,{onObjectBegin:(m,I)=>{if(a<=m)throw t;s=void 0,c=a>m,i.push("")},onObjectProperty:(m,I,O)=>{if(a<I||(h(m,I,O,"property"),i[i.length-1]=m,a<=I+O))throw t},onObjectEnd:(m,I)=>{if(a<=m)throw t;s=void 0,i.pop()},onArrayBegin:(m,I)=>{if(a<=m)throw t;s=void 0,i.push(0)},onArrayEnd:(m,I)=>{if(a<=m)throw t;s=void 0,i.pop()},onLiteralValue:(m,I,O)=>{if(a<I||(h(m,I,O,u(m)),a<=I+O))throw t},onSeparator:(m,I,O)=>{if(a<=I)throw t;if(m===":"&&s&&s.type==="property")s.colonOffset=I,c=!1,s=void 0;else if(m===","){const A=i[i.length-1];typeof A=="number"?i[i.length-1]=A+1:(c=!0,i[i.length-1]=""),s=void 0}}})}catch(m){if(m!==t)throw m}return{path:i,previousNode:s,isAtPropertyKey:c,matches:m=>{let I=0;for(let O=0;I<m.length&&O<i.length;O++)if(m[I]===i[O]||m[I]==="*")I++;else if(m[I]!=="**")return!1;return I===m.length}}}e.getLocation=b;function f(r,a=[],i=_.DEFAULT){let t=null,s=[];const o=[];function c(m){Array.isArray(s)?s.push(m):t!==null&&(s[t]=m)}return g(r,{onObjectBegin:()=>{const m={};c(m),o.push(s),s=m,t=null},onObjectProperty:m=>{t=m},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const m=[];c(m),o.push(s),s=m,t=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:c,onError:(m,I,O)=>{a.push({error:m,offset:I,length:O})}},i),s[0]}e.parse=f;function S(r,a=[],i=_.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(m){t.type==="property"&&(t.length=m-t.offset,t=t.parent)}function o(m){return t.children.push(m),m}g(r,{onObjectBegin:m=>{t=o({type:"object",offset:m,length:-1,parent:t,children:[]})},onObjectProperty:(m,I,O)=>{t=o({type:"property",offset:I,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:m,offset:I,length:O,parent:t})},onObjectEnd:(m,I)=>{t.length=m+I-t.offset,t=t.parent,s(m+I)},onArrayBegin:(m,I)=>{t=o({type:"array",offset:m,length:-1,parent:t,children:[]})},onArrayEnd:(m,I)=>{t.length=m+I-t.offset,t=t.parent,s(m+I)},onLiteralValue:(m,I,O)=>{o({type:u(m),offset:I,length:O,parent:t,value:m}),s(I+O)},onSeparator:(m,I,O)=>{t.type==="property"&&(m===":"?t.colonOffset=I:m===","&&s(I))},onError:(m,I,O)=>{a.push({error:m,offset:I,length:O})}},i);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=S;function d(r,a){if(!r)return;let i=r;for(let t of a)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===t){i=o.children[1],s=!0;break}if(!s)return}else{const s=t;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=d;function w(r){if(!r.parent||!r.parent.children)return[];const a=w(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;a.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&a.push(i)}return a}e.getNodePath=w;function p(r){switch(r.type){case"array":return r.children.map(p);case"object":{const a=Object.create(null);for(let i of r.children){const t=i.children[1];t&&(a[i.children[0].value]=p(t))}return a}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=p;function v(r,a,i=!1){return a>=r.offset&&a<r.offset+r.length||i&&a===r.offset+r.length}e.contains=v;function y(r,a,i=!1){if(v(r,a,i)){const t=r.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=a;s++){const o=y(t[s],a,i);if(o)return o}return r}}e.findNodeAtOffset=y;function g(r,a,i=_.DEFAULT){const t=k(r,!1);function s(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(K){return K?F=>K(F,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=s(a.onObjectBegin),h=o(a.onObjectProperty),m=s(a.onObjectEnd),I=s(a.onArrayBegin),O=s(a.onArrayEnd),A=o(a.onLiteralValue),N=o(a.onSeparator),$=s(a.onComment),D=o(a.onError),M=i&&i.disallowComments,W=i&&i.allowTrailingComma;function U(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:M||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(K){case 12:case 13:M?x(10):$();break;case 16:x(1);break;case 15:case 14:break;default:return K}}}function x(K,F=[],j=[]){if(D(K),F.length+j.length>0){let B=t.getToken();for(;B!==17;){if(F.indexOf(B)!==-1){U();break}else if(j.indexOf(B)!==-1)break;B=U()}}}function ee(K){const F=t.getTokenValue();return K?A(F):h(F),U(),!0}function G(){switch(t.getToken()){case 11:{let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&(x(2),K=0)}catch{x(2)}A(K);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return U(),!0}function q(){return t.getToken()!==10?(x(3,[],[2,5]),!1):(ee(!1),t.getToken()===6?(N(":"),U(),Z()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function Y(){c(),U();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||x(4,[],[]),N(","),U(),t.getToken()===2&&W)break}else K&&x(6,[],[]);q()||x(4,[],[2,5]),K=!0}return m(),t.getToken()!==2?x(7,[2],[]):U(),!0}function H(){I(),U();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||x(4,[],[]),N(","),U(),t.getToken()===4&&W)break}else K&&x(6,[],[]);Z()||x(4,[],[4,5]),K=!0}return O(),t.getToken()!==4?x(8,[4],[]):U(),!0}function Z(){switch(t.getToken()){case 3:return H();case 1:return Y();case 10:return ee(!0);default:return G()}}return U(),t.getToken()===17?i.allowEmptyContent?!0:(x(4,[],[]),!1):Z()?(t.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.visit=g;function l(r,a){let i=k(r),t=[],s,o=0,c;do switch(c=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:o!==c&&t.push(r.substring(o,c)),a!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,a)),o=i.getPosition();break}while(s!==17);return t.join("")}e.stripComments=l;function u(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ne[49],ie([0,1,35]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(E,P,b){let f,S,d,w,p;if(P){for(w=P.offset,p=w+P.length,d=w;d>0&&!C(E,d-1);)d--;let c=p;for(;c<E.length&&!C(E,c);)c++;S=E.substring(d,c),f=k(S,b)}else S=E,f=0,d=0,w=0,p=E.length;const v=R(b,E);let y=!1,g=0,l;b.insertSpaces?l=_(" ",b.tabSize||4):l="	";const u=(0,L.createScanner)(S,!1);let r=!1;function a(){return v+_(l,f+g)}function i(){let c=u.scan();for(y=!1;c===15||c===14;)y=y||c===14,c=u.scan();return r=c===16||u.getTokenError()!==0,c}const t=[];function s(c,h,m){!r&&h<p&&m>w&&E.substring(h,m)!==c&&t.push({offset:h,length:m-h,content:c})}let o=i();if(o!==17){const c=u.getTokenOffset()+d,h=_(l,f);s(h,d,c)}for(;o!==17;){let c=u.getTokenOffset()+u.getTokenLength()+d,h=i(),m="";for(;!y&&(h===12||h===13);){const O=u.getTokenOffset()+d;s(" ",c,O),c=u.getTokenOffset()+u.getTokenLength()+d,m=h===12?a():"",h=i()}if(h===2)o!==1&&(g--,m=a());else if(h===4)o!==3&&(g--,m=a());else{switch(o){case 3:case 1:g++,m=a();break;case 5:case 12:m=a();break;case 13:y?m=a():m=" ";break;case 6:m=" ";break;case 10:if(h===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?m=" ":h!==5&&h!==17&&(r=!0);break;case 16:r=!0;break}y&&(h===12||h===13)&&(m=a())}const I=u.getTokenOffset()+d;s(m,c,I),o=h}return t}e.format=n;function T(E,P){const b=JSON.stringify(E,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?b.replace(/\r\n|\r|\n/g,P.eol):b}e.toFormattedString=T;function _(E,P){let b="";for(let f=0;f<P;f++)b+=E;return b}function k(E,P){let b=0,f=0;const S=P.tabSize||4;for(;b<E.length;){const d=E.charAt(b);if(d===" ")f++;else if(d==="	")f+=S;else break;b++}return Math.floor(f/S)}function R(E,P){for(let b=0;b<P.length;b++){const f=P.charAt(b);if(f==="\r")return b+1<P.length&&P.charAt(b+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=R;function C(E,P){return`\r
`.indexOf(E.charAt(P))!==-1}e.isEOL=C}),define(ne[68],ie([0,1,35,49]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(E,P,b){return _(E,P,void 0,b)}e.removeProperty=T;function _(E,P,b,f,S){const d=P.slice(),w=[],p=(0,L.parseTree)(E,w);let v,y;for(;d.length>0&&(y=d.pop(),v=(0,L.findNodeAtLocation)(p,d),v===void 0&&b!==void 0);)typeof y=="string"?b={[y]:b}:b=[b];if(v)if(v.type==="object"&&typeof y=="string"&&Array.isArray(v.children)){const g=(0,L.findNodeAtLocation)(v,[y]);if(g!==void 0)if(b===void 0){if(!g.parent)throw new Error("Malformed AST");const l=v.children.indexOf(g.parent);let u,r=g.parent.offset+g.parent.length;if(l>0){const a=v.children[l-1];u=a.offset+a.length}else u=v.offset+1,v.children.length>1&&(r=v.children[1].offset);return k(E,{offset:u,length:r-u,content:""},f)}else return k(E,{offset:g.offset,length:g.length,content:JSON.stringify(b)},f);else{if(b===void 0)return[];const l=`${JSON.stringify(y)}: ${JSON.stringify(b)}`,u=S?S(v.children.map(a=>a.children[0].value)):v.children.length;let r;if(u>0){const a=v.children[u-1];r={offset:a.offset+a.length,length:0,content:","+l}}else v.children.length===0?r={offset:v.offset+1,length:0,content:l}:r={offset:v.offset+1,length:0,content:l+","};return k(E,r,f)}}else if(v.type==="array"&&typeof y=="number"&&Array.isArray(v.children))if(b!==void 0){const g=`${JSON.stringify(b)}`;let l;if(v.children.length===0||y===0)l={offset:v.offset+1,length:0,content:v.children.length===0?g:g+","};else{const u=y===-1||y>v.children.length?v.children.length:y,r=v.children[u-1];l={offset:r.offset+r.length,length:0,content:","+g}}return k(E,l,f)}else{const g=y,l=v.children[g];let u;if(v.children.length===1)u={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===g){const r=v.children[g-1],a=r.offset+r.length,i=v.offset+v.length;u={offset:a,length:i-2-a,content:""}}else u={offset:l.offset,length:v.children[g+1].offset-l.offset,content:""};return k(E,u,f)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${v.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return k(E,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(b)},f)}}e.setProperty=_;function k(E,P,b){let f=R(E,P),S=P.offset,d=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;S>0&&!(0,n.isEOL)(f,S-1);)S--;for(;d<f.length&&!(0,n.isEOL)(f,d);)d++}const w=(0,n.format)(f,{offset:S,length:d-S},b);for(let v=w.length-1;v>=0;v--){const y=w[v];f=R(f,y),S=Math.min(S,y.offset),d=Math.max(d,y.offset+y.length),d+=y.content.length-y.length}const p=E.length-(f.length-d)-S;return[{offset:S,length:p,content:f.substring(S,d)}]}e.withFormatting=k;function R(E,P){return E.substring(0,P.offset)+P.content+E.substring(P.offset+P.length)}e.applyEdit=R;function C(E,P){let b=P.slice(0).sort((S,d)=>{const w=S.offset-d.offset;return w===0?S.length-d.length:w}),f=E.length;for(let S=b.length-1;S>=0;S--){let d=b[S];if(d.offset+d.length<=f)E=R(E,d);else throw new Error("Overlapping edit");f=d.offset}return E}e.applyEdits=C}),define(ne[99],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new L(()=>T(this.getValue()))}}e.Lazy=L}),define(ne[2],ie([0,1,67,54]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const T=!1;let _=null;function k(t){_=t}if(e.setDisposableTracker=k,T){const t="__is_disposable_tracked__";k(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==y.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==y.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function R(t){return _?.trackDisposable(t),t}function C(t){_?.markAsDisposed(t)}function E(t,s){_?.setParent(t,s)}function P(t,s){if(!!_)for(const o of t)_.setParent(o,s)}function b(t){return _?.markAsSingleton(t),t}e.markAsSingleton=b;class f extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=f;function S(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=S;function d(t){if(n.Iterable.is(t)){let s=[];for(const o of t)if(o)try{o.dispose()}catch(c){s.push(c)}if(s.length===1)throw s[0];if(s.length>1)throw new f(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=d;function w(...t){const s=p(()=>d(t));return P(t,s),s}e.combinedDisposable=w;function p(t){const s=R({dispose:(0,L.once)(()=>{C(s),t()})});return s}e.toDisposable=p;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return E(s,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new v,R(this),E(this._store,this)}dispose(){C(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&E(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&E(s,null),s}}e.MutableDisposable=g;class l{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class u{constructor(){this.references=new Map}acquire(s,...o){let c=this.references.get(s);c||(c={counter:0,object:this.createReferencedObject(s,...o)},this.references.set(s,c));const{object:h}=c,m=(0,L.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(s,c.object),this.references.delete(s))});return c.counter++,{object:h,dispose:m}}}e.ReferenceCollection=u;class r{constructor(s){this.referenceCollection=s}async acquire(s,...o){const c=this.referenceCollection.acquire(s,...o);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(h){throw c.dispose(),h}}}e.AsyncReferenceCollection=r;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a;function i(t){const s=new v;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=i}),define(ne[100],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(_){this.element=_,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class n{constructor(){this._first=L.Undefined,this._last=L.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===L.Undefined}clear(){let _=this._first;for(;_!==L.Undefined;){const k=_.next;_.prev=L.Undefined,_.next=L.Undefined,_=k}this._first=L.Undefined,this._last=L.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,k){const R=new L(_);if(this._first===L.Undefined)this._first=R,this._last=R;else if(k){const E=this._last;this._last=R,R.prev=E,E.next=R}else{const E=this._first;this._first=R,R.next=E,E.prev=R}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(R))}}shift(){if(this._first!==L.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==L.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==L.Undefined&&_.next!==L.Undefined){const k=_.prev;k.next=_.next,_.next.prev=k}else _.prev===L.Undefined&&_.next===L.Undefined?(this._first=L.Undefined,this._last=L.Undefined):_.next===L.Undefined?(this._last=this._last.prev,this._last.next=L.Undefined):_.prev===L.Undefined&&(this._first=this._first.next,this._first.prev=L.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==L.Undefined;)yield _.element,_=_.next}}e.LinkedList=n}),function(){function J(T){const _=[];typeof T=="number"&&_.push("code/timeOrigin",T);function k(C){_.push(C,Date.now())}function R(){const C=[];for(let E=0;E<_.length;E+=2)C.push({name:_[E],startTime:_[E+1]});return C}return{mark:k,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const k of performance.getEntriesByType("mark"))_.push({name:k.name,startTime:Math.round(T+k.startTime)});return _}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=L(n))}(),define(ne[4],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const L="en";let n=!1,T=!1,_=!1,k=!1,R=!1,C=!1,E=!1,P=!1,b,f=L,S,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const p=typeof w?.versions?.electron=="string",v=p&&w?.type==="renderer";if(e.isElectronSandboxed=v&&w?.sandboxed,typeof navigator=="object"&&!v)d=navigator.userAgent,n=d.indexOf("Windows")>=0,T=d.indexOf("Macintosh")>=0,P=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=d.indexOf("Linux")>=0,C=!0,b=navigator.language,f=b;else if(typeof w=="object"){n=w.platform==="win32",T=w.platform==="darwin",_=w.platform==="linux",k=_&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,E=p,b=L,f=L;const s=w.env.VSCODE_NLS_CONFIG;if(s)try{const o=JSON.parse(s),c=o.availableLanguages["*"];b=o.locale,f=c||L,S=o._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var y;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function g(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let l=0;T?l=1:n?l=3:_&&(l=2),e.isWindows=n,e.isMacintosh=T,e.isLinux=_,e.isLinuxSnap=k,e.isNative=R,e.isElectron=E,e.isWeb=C,e.isIOS=P,e.platform=l,e.userAgent=d,e.language=f;var u;(function(s){function o(){return e.language}s.value=o;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=c;function h(){return e.language==="en"}s.isDefault=h})(u=e.Language||(e.Language={})),e.locale=b,e.translationsConfigFile=S,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let h=0,m=s.length;h<m;h++){const I=s[h];if(I.id===c.data.vscodeScheduleAsyncWork){s.splice(h,1),I.callback();return}}});let o=0;return c=>{const h=++o;s.push({id:h,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||P?2:n?1:3;let a=!0,i=!1;function t(){if(!i){i=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,a=new Uint16Array(s.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=t}),define(ne[31],ie([0,1,4]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.process!="undefined"){const T=L.globals.vscode.process;n={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ne[9],ie([0,1,31]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,T=97,_=90,k=122,R=46,C=47,E=92,P=58,b=63;class f extends Error{constructor(l,u,r){let a;typeof u=="string"&&u.indexOf("not ")===0?(a="must not be",u=u.replace(/^not /,"")):a="must be";const i=l.indexOf(".")!==-1?"property":"argument";let t=`The "${l}" ${i} ${a} of type ${u}`;t+=`. Received type ${typeof r}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function S(g,l){if(typeof g!="string")throw new f(l,"string",g)}function d(g){return g===C||g===E}function w(g){return g===C}function p(g){return g>=n&&g<=_||g>=T&&g<=k}function v(g,l,u,r){let a="",i=0,t=-1,s=0,o=0;for(let c=0;c<=g.length;++c){if(c<g.length)o=g.charCodeAt(c);else{if(r(o))break;o=C}if(r(o)){if(!(t===c-1||s===1))if(s===2){if(a.length<2||i!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const h=a.lastIndexOf(u);h===-1?(a="",i=0):(a=a.slice(0,h),i=a.length-1-a.lastIndexOf(u)),t=c,s=0;continue}else if(a.length!==0){a="",i=0,t=c,s=0;continue}}l&&(a+=a.length>0?`${u}..`:"..",i=2)}else a.length>0?a+=`${u}${g.slice(t+1,c)}`:a=g.slice(t+1,c),i=c-t-1;t=c,s=0}else o===R&&s!==-1?++s:s=-1}return a}function y(g,l){if(l===null||typeof l!="object")throw new f("pathObject","Object",l);const u=l.dir||l.root,r=l.base||`${l.name||""}${l.ext||""}`;return u?u===l.root?`${u}${r}`:`${u}${g}${r}`:r}e.win32={resolve(...g){let l="",u="",r=!1;for(let a=g.length-1;a>=-1;a--){let i;if(a>=0){if(i=g[a],S(i,"path"),i.length===0)continue}else l.length===0?i=L.cwd():(i=L.env[`=${l}`]||L.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==l.toLowerCase()&&i.charCodeAt(2)===E)&&(i=`${l}\\`));const t=i.length;let s=0,o="",c=!1;const h=i.charCodeAt(0);if(t===1)d(h)&&(s=1,c=!0);else if(d(h))if(c=!0,d(i.charCodeAt(1))){let m=2,I=m;for(;m<t&&!d(i.charCodeAt(m));)m++;if(m<t&&m!==I){const O=i.slice(I,m);for(I=m;m<t&&d(i.charCodeAt(m));)m++;if(m<t&&m!==I){for(I=m;m<t&&!d(i.charCodeAt(m));)m++;(m===t||m!==I)&&(o=`\\\\${O}\\${i.slice(I,m)}`,s=m)}}}else s=1;else p(h)&&i.charCodeAt(1)===P&&(o=i.slice(0,2),s=2,t>2&&d(i.charCodeAt(2))&&(c=!0,s=3));if(o.length>0)if(l.length>0){if(o.toLowerCase()!==l.toLowerCase())continue}else l=o;if(r){if(l.length>0)break}else if(u=`${i.slice(s)}\\${u}`,r=c,c&&l.length>0)break}return u=v(u,!r,"\\",d),r?`${l}\\${u}`:`${l}${u}`||"."},normalize(g){S(g,"path");const l=g.length;if(l===0)return".";let u=0,r,a=!1;const i=g.charCodeAt(0);if(l===1)return w(i)?"\\":g;if(d(i))if(a=!0,d(g.charCodeAt(1))){let s=2,o=s;for(;s<l&&!d(g.charCodeAt(s));)s++;if(s<l&&s!==o){const c=g.slice(o,s);for(o=s;s<l&&d(g.charCodeAt(s));)s++;if(s<l&&s!==o){for(o=s;s<l&&!d(g.charCodeAt(s));)s++;if(s===l)return`\\\\${c}\\${g.slice(o)}\\`;s!==o&&(r=`\\\\${c}\\${g.slice(o,s)}`,u=s)}}}else u=1;else p(i)&&g.charCodeAt(1)===P&&(r=g.slice(0,2),u=2,l>2&&d(g.charCodeAt(2))&&(a=!0,u=3));let t=u<l?v(g.slice(u),!a,"\\",d):"";return t.length===0&&!a&&(t="."),t.length>0&&d(g.charCodeAt(l-1))&&(t+="\\"),r===void 0?a?`\\${t}`:t:a?`${r}\\${t}`:`${r}${t}`},isAbsolute(g){S(g,"path");const l=g.length;if(l===0)return!1;const u=g.charCodeAt(0);return d(u)||l>2&&p(u)&&g.charCodeAt(1)===P&&d(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let l,u;for(let i=0;i<g.length;++i){const t=g[i];S(t,"path"),t.length>0&&(l===void 0?l=u=t:l+=`\\${t}`)}if(l===void 0)return".";let r=!0,a=0;if(typeof u=="string"&&d(u.charCodeAt(0))){++a;const i=u.length;i>1&&d(u.charCodeAt(1))&&(++a,i>2&&(d(u.charCodeAt(2))?++a:r=!1))}if(r){for(;a<l.length&&d(l.charCodeAt(a));)a++;a>=2&&(l=`\\${l.slice(a)}`)}return e.win32.normalize(l)},relative(g,l){if(S(g,"from"),S(l,"to"),g===l)return"";const u=e.win32.resolve(g),r=e.win32.resolve(l);if(u===r||(g=u.toLowerCase(),l=r.toLowerCase(),g===l))return"";let a=0;for(;a<g.length&&g.charCodeAt(a)===E;)a++;let i=g.length;for(;i-1>a&&g.charCodeAt(i-1)===E;)i--;const t=i-a;let s=0;for(;s<l.length&&l.charCodeAt(s)===E;)s++;let o=l.length;for(;o-1>s&&l.charCodeAt(o-1)===E;)o--;const c=o-s,h=t<c?t:c;let m=-1,I=0;for(;I<h;I++){const A=g.charCodeAt(a+I);if(A!==l.charCodeAt(s+I))break;A===E&&(m=I)}if(I!==h){if(m===-1)return r}else{if(c>h){if(l.charCodeAt(s+I)===E)return r.slice(s+I+1);if(I===2)return r.slice(s+I)}t>h&&(g.charCodeAt(a+I)===E?m=I:I===2&&(m=3)),m===-1&&(m=0)}let O="";for(I=a+m+1;I<=i;++I)(I===i||g.charCodeAt(I)===E)&&(O+=O.length===0?"..":"\\..");return s+=m,O.length>0?`${O}${r.slice(s,o)}`:(r.charCodeAt(s)===E&&++s,r.slice(s,o))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const l=e.win32.resolve(g);if(l.length<=2)return g;if(l.charCodeAt(0)===E){if(l.charCodeAt(1)===E){const u=l.charCodeAt(2);if(u!==b&&u!==R)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(p(l.charCodeAt(0))&&l.charCodeAt(1)===P&&l.charCodeAt(2)===E)return`\\\\?\\${l}`;return g},dirname(g){S(g,"path");const l=g.length;if(l===0)return".";let u=-1,r=0;const a=g.charCodeAt(0);if(l===1)return d(a)?g:".";if(d(a)){if(u=r=1,d(g.charCodeAt(1))){let s=2,o=s;for(;s<l&&!d(g.charCodeAt(s));)s++;if(s<l&&s!==o){for(o=s;s<l&&d(g.charCodeAt(s));)s++;if(s<l&&s!==o){for(o=s;s<l&&!d(g.charCodeAt(s));)s++;if(s===l)return g;s!==o&&(u=r=s+1)}}}}else p(a)&&g.charCodeAt(1)===P&&(u=l>2&&d(g.charCodeAt(2))?3:2,r=u);let i=-1,t=!0;for(let s=l-1;s>=r;--s)if(d(g.charCodeAt(s))){if(!t){i=s;break}}else t=!1;if(i===-1){if(u===-1)return".";i=u}return g.slice(0,i)},basename(g,l){l!==void 0&&S(l,"ext"),S(g,"path");let u=0,r=-1,a=!0,i;if(g.length>=2&&p(g.charCodeAt(0))&&g.charCodeAt(1)===P&&(u=2),l!==void 0&&l.length>0&&l.length<=g.length){if(l===g)return"";let t=l.length-1,s=-1;for(i=g.length-1;i>=u;--i){const o=g.charCodeAt(i);if(d(o)){if(!a){u=i+1;break}}else s===-1&&(a=!1,s=i+1),t>=0&&(o===l.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=s))}return u===r?r=s:r===-1&&(r=g.length),g.slice(u,r)}for(i=g.length-1;i>=u;--i)if(d(g.charCodeAt(i))){if(!a){u=i+1;break}}else r===-1&&(a=!1,r=i+1);return r===-1?"":g.slice(u,r)},extname(g){S(g,"path");let l=0,u=-1,r=0,a=-1,i=!0,t=0;g.length>=2&&g.charCodeAt(1)===P&&p(g.charCodeAt(0))&&(l=r=2);for(let s=g.length-1;s>=l;--s){const o=g.charCodeAt(s);if(d(o)){if(!i){r=s+1;break}continue}a===-1&&(i=!1,a=s+1),o===R?u===-1?u=s:t!==1&&(t=1):u!==-1&&(t=-1)}return u===-1||a===-1||t===0||t===1&&u===a-1&&u===r+1?"":g.slice(u,a)},format:y.bind(null,"\\"),parse(g){S(g,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return l;const u=g.length;let r=0,a=g.charCodeAt(0);if(u===1)return d(a)?(l.root=l.dir=g,l):(l.base=l.name=g,l);if(d(a)){if(r=1,d(g.charCodeAt(1))){let m=2,I=m;for(;m<u&&!d(g.charCodeAt(m));)m++;if(m<u&&m!==I){for(I=m;m<u&&d(g.charCodeAt(m));)m++;if(m<u&&m!==I){for(I=m;m<u&&!d(g.charCodeAt(m));)m++;m===u?r=m:m!==I&&(r=m+1)}}}}else if(p(a)&&g.charCodeAt(1)===P){if(u<=2)return l.root=l.dir=g,l;if(r=2,d(g.charCodeAt(2))){if(u===3)return l.root=l.dir=g,l;r=3}}r>0&&(l.root=g.slice(0,r));let i=-1,t=r,s=-1,o=!0,c=g.length-1,h=0;for(;c>=r;--c){if(a=g.charCodeAt(c),d(a)){if(!o){t=c+1;break}continue}s===-1&&(o=!1,s=c+1),a===R?i===-1?i=c:h!==1&&(h=1):i!==-1&&(h=-1)}return s!==-1&&(i===-1||h===0||h===1&&i===s-1&&i===t+1?l.base=l.name=g.slice(t,s):(l.name=g.slice(t,i),l.base=g.slice(t,s),l.ext=g.slice(i,s))),t>0&&t!==r?l.dir=g.slice(0,t-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let l="",u=!1;for(let r=g.length-1;r>=-1&&!u;r--){const a=r>=0?g[r]:L.cwd();S(a,"path"),a.length!==0&&(l=`${a}/${l}`,u=a.charCodeAt(0)===C)}return l=v(l,!u,"/",w),u?`/${l}`:l.length>0?l:"."},normalize(g){if(S(g,"path"),g.length===0)return".";const l=g.charCodeAt(0)===C,u=g.charCodeAt(g.length-1)===C;return g=v(g,!l,"/",w),g.length===0?l?"/":u?"./":".":(u&&(g+="/"),l?`/${g}`:g)},isAbsolute(g){return S(g,"path"),g.length>0&&g.charCodeAt(0)===C},join(...g){if(g.length===0)return".";let l;for(let u=0;u<g.length;++u){const r=g[u];S(r,"path"),r.length>0&&(l===void 0?l=r:l+=`/${r}`)}return l===void 0?".":e.posix.normalize(l)},relative(g,l){if(S(g,"from"),S(l,"to"),g===l||(g=e.posix.resolve(g),l=e.posix.resolve(l),g===l))return"";const u=1,r=g.length,a=r-u,i=1,t=l.length-i,s=a<t?a:t;let o=-1,c=0;for(;c<s;c++){const m=g.charCodeAt(u+c);if(m!==l.charCodeAt(i+c))break;m===C&&(o=c)}if(c===s)if(t>s){if(l.charCodeAt(i+c)===C)return l.slice(i+c+1);if(c===0)return l.slice(i+c)}else a>s&&(g.charCodeAt(u+c)===C?o=c:c===0&&(o=0));let h="";for(c=u+o+1;c<=r;++c)(c===r||g.charCodeAt(c)===C)&&(h+=h.length===0?"..":"/..");return`${h}${l.slice(i+o)}`},toNamespacedPath(g){return g},dirname(g){if(S(g,"path"),g.length===0)return".";const l=g.charCodeAt(0)===C;let u=-1,r=!0;for(let a=g.length-1;a>=1;--a)if(g.charCodeAt(a)===C){if(!r){u=a;break}}else r=!1;return u===-1?l?"/":".":l&&u===1?"//":g.slice(0,u)},basename(g,l){l!==void 0&&S(l,"ext"),S(g,"path");let u=0,r=-1,a=!0,i;if(l!==void 0&&l.length>0&&l.length<=g.length){if(l===g)return"";let t=l.length-1,s=-1;for(i=g.length-1;i>=0;--i){const o=g.charCodeAt(i);if(o===C){if(!a){u=i+1;break}}else s===-1&&(a=!1,s=i+1),t>=0&&(o===l.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=s))}return u===r?r=s:r===-1&&(r=g.length),g.slice(u,r)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===C){if(!a){u=i+1;break}}else r===-1&&(a=!1,r=i+1);return r===-1?"":g.slice(u,r)},extname(g){S(g,"path");let l=-1,u=0,r=-1,a=!0,i=0;for(let t=g.length-1;t>=0;--t){const s=g.charCodeAt(t);if(s===C){if(!a){u=t+1;break}continue}r===-1&&(a=!1,r=t+1),s===R?l===-1?l=t:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||r===-1||i===0||i===1&&l===r-1&&l===u+1?"":g.slice(l,r)},format:y.bind(null,"/"),parse(g){S(g,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return l;const u=g.charCodeAt(0)===C;let r;u?(l.root="/",r=1):r=0;let a=-1,i=0,t=-1,s=!0,o=g.length-1,c=0;for(;o>=r;--o){const h=g.charCodeAt(o);if(h===C){if(!s){i=o+1;break}continue}t===-1&&(s=!1,t=o+1),h===R?a===-1?a=o:c!==1&&(c=1):a!==-1&&(c=-1)}if(t!==-1){const h=i===0&&u?1:i;a===-1||c===0||c===1&&a===t-1&&a===i+1?l.base=l.name=g.slice(h,t):(l.name=g.slice(h,a),l.base=g.slice(h,t),l.ext=g.slice(a,t))}return i>0?l.dir=g.slice(0,i-1):u&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=L.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=L.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=L.platform==="win32"?e.win32.join:e.posix.join,e.resolve=L.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=L.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=L.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=L.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=L.platform==="win32"?e.win32.extname:e.posix.extname,e.format=L.platform==="win32"?e.win32.format:e.posix.format,e.parse=L.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=L.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=L.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=L.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[101],ie([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(b){b.text="text/plain",b.binary="application/octet-stream",b.unknown="application/unknown",b.markdown="text/markdown",b.latex="text/latex"})(n=e.Mimes||(e.Mimes={}));const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},_={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(b){const f=(0,L.extname)(b),S=T[f.toLowerCase()];return S!==void 0?S:R(b)}e.getMediaOrTextMime=k;function R(b){const f=(0,L.extname)(b);return _[f.toLowerCase()]}e.getMediaMime=R;function C(b){for(const f in _)if(_[f]===b)return f}e.getExtensionForMimeType=C;const E=/^(.+)\/(.+?)(;.+)?$/;function P(b,f){const S=E.exec(b);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:f?void 0:b}e.normalizeMimeType=P}),define(ne[102],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(L=e.Source||(e.Source={}));var n;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(_,...k){const R=k.reduce((P,b)=>(P[b]=!0,P),{}),C=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(_).filter(P=>!R[P]).forEach(P=>{for(let b=0;b<C.length;b++)if(P.search(C[b])!==-1){delete _[P];break}})}e.sanitizeProcessEnvironment=T}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var n in L)(typeof exports=="object"?exports:J)[n]=L[n]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function L(n){if(e[n])return e[n].exports;var T=e[n]={i:n,l:!1,exports:{}};return J[n].call(T.exports,T,T.exports,L),T.l=!0,T.exports}return L.m=J,L.c=e,L.d=function(n,T,_){L.o(n,T)||Object.defineProperty(n,T,{enumerable:!0,get:_})},L.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},L.t=function(n,T){if(1&T&&(n=L(n)),8&T||4&T&&typeof n=="object"&&n&&n.__esModule)return n;var _=Object.create(null);if(L.r(_),Object.defineProperty(_,"default",{enumerable:!0,value:n}),2&T&&typeof n!="string")for(var k in n)L.d(_,k,function(R){return n[R]}.bind(null,k));return _},L.n=function(n){var T=n&&n.__esModule?function(){return n.default}:function(){return n};return L.d(T,"a",T),T},L.o=function(n,T){return Object.prototype.hasOwnProperty.call(n,T)},L.p="",L(L.s=0)}([function(J,e,L){(function(n){var T;e=J.exports=j,T=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var _=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],C=e.src=[],E=0,P=E++;C[P]="0|[1-9]\\d*";var b=E++;C[b]="[0-9]+";var f=E++;C[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=E++;C[S]="("+C[P]+")\\.("+C[P]+")\\.("+C[P]+")";var d=E++;C[d]="("+C[b]+")\\.("+C[b]+")\\.("+C[b]+")";var w=E++;C[w]="(?:"+C[P]+"|"+C[f]+")";var p=E++;C[p]="(?:"+C[b]+"|"+C[f]+")";var v=E++;C[v]="(?:-("+C[w]+"(?:\\."+C[w]+")*))";var y=E++;C[y]="(?:-?("+C[p]+"(?:\\."+C[p]+")*))";var g=E++;C[g]="[0-9A-Za-z-]+";var l=E++;C[l]="(?:\\+("+C[g]+"(?:\\."+C[g]+")*))";var u=E++,r="v?"+C[S]+C[v]+"?"+C[l]+"?";C[u]="^"+r+"$";var a="[v=\\s]*"+C[d]+C[y]+"?"+C[l]+"?",i=E++;C[i]="^"+a+"$";var t=E++;C[t]="((?:<|>)?=?)";var s=E++;C[s]=C[b]+"|x|X|\\*";var o=E++;C[o]=C[P]+"|x|X|\\*";var c=E++;C[c]="[v=\\s]*("+C[o]+")(?:\\.("+C[o]+")(?:\\.("+C[o]+")(?:"+C[v]+")?"+C[l]+"?)?)?";var h=E++;C[h]="[v=\\s]*("+C[s]+")(?:\\.("+C[s]+")(?:\\.("+C[s]+")(?:"+C[y]+")?"+C[l]+"?)?)?";var m=E++;C[m]="^"+C[t]+"\\s*"+C[c]+"$";var I=E++;C[I]="^"+C[t]+"\\s*"+C[h]+"$";var O=E++;C[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=E++;C[A]="(?:~>?)";var N=E++;C[N]="(\\s*)"+C[A]+"\\s+",R[N]=new RegExp(C[N],"g");var $=E++;C[$]="^"+C[A]+C[c]+"$";var D=E++;C[D]="^"+C[A]+C[h]+"$";var M=E++;C[M]="(?:\\^)";var W=E++;C[W]="(\\s*)"+C[M]+"\\s+",R[W]=new RegExp(C[W],"g");var U=E++;C[U]="^"+C[M]+C[c]+"$";var x=E++;C[x]="^"+C[M]+C[h]+"$";var ee=E++;C[ee]="^"+C[t]+"\\s*("+a+")$|^$";var G=E++;C[G]="^"+C[t]+"\\s*("+r+")$|^$";var q=E++;C[q]="(\\s*)"+C[t]+"\\s*("+a+"|"+C[c]+")",R[q]=new RegExp(C[q],"g");var Y=E++;C[Y]="^\\s*("+C[c]+")\\s+-\\s+("+C[c]+")\\s*$";var H=E++;C[H]="^\\s*("+C[h]+")\\s+-\\s+("+C[h]+")\\s*$";var Z=E++;C[Z]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)T(K,C[K]),R[K]||(R[K]=new RegExp(C[K]));function F(re,ae){if(re instanceof j)return re;if(typeof re!="string"||re.length>_||!(ae?R[i]:R[u]).test(re))return null;try{return new j(re,ae)}catch{return null}}function j(re,ae){if(re instanceof j){if(re.loose===ae)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>_)throw new TypeError("version is longer than "+_+" characters");if(!(this instanceof j))return new j(re,ae);T("SemVer",re,ae),this.loose=ae;var ue=re.trim().match(ae?R[i]:R[u]);if(!ue)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ce=+be;if(Ce>=0&&Ce<k)return Ce}return be}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=F,e.valid=function(re,ae){var ue=F(re,ae);return ue?ue.version:null},e.clean=function(re,ae){var ue=F(re.trim().replace(/^[=v]+/,""),ae);return ue?ue.version:null},e.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(re){return T("SemVer.compare",this.version,this.loose,re),re instanceof j||(re=new j(re,this.loose)),this.compareMain(re)||this.comparePre(re)},j.prototype.compareMain=function(re){return re instanceof j||(re=new j(re,this.loose)),z(this.major,re.major)||z(this.minor,re.minor)||z(this.patch,re.patch)},j.prototype.comparePre=function(re){if(re instanceof j||(re=new j(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var ae=0;do{var ue=this.prerelease[ae],be=re.prerelease[ae];if(T("prerelease compare",ae,ue,be),ue===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ue===void 0)return-1;if(ue!==be)return z(ue,be)}while(++ae)},j.prototype.inc=function(re,ae){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,ae,ue,be){typeof ue=="string"&&(be=ue,ue=void 0);try{return new j(re,ue).inc(ae,be).version}catch{return null}},e.diff=function(re,ae){if(ce(re,ae))return null;var ue=F(re),be=F(ae);if(ue.prerelease.length||be.prerelease.length){for(var Ce in ue)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ue[Ce]!==be[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in ue)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ue[Ce]!==be[Ce])return Ce},e.compareIdentifiers=z;var B=/^[0-9]+$/;function z(re,ae){var ue=B.test(re),be=B.test(ae);return ue&&be&&(re=+re,ae=+ae),ue&&!be?-1:be&&!ue?1:re<ae?-1:re>ae?1:0}function V(re,ae,ue){return new j(re,ue).compare(new j(ae,ue))}function te(re,ae,ue){return V(re,ae,ue)>0}function se(re,ae,ue){return V(re,ae,ue)<0}function ce(re,ae,ue){return V(re,ae,ue)===0}function he(re,ae,ue){return V(re,ae,ue)!==0}function me(re,ae,ue){return V(re,ae,ue)>=0}function ve(re,ae,ue){return V(re,ae,ue)<=0}function ge(re,ae,ue,be){var Ce;switch(ae){case"===":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Ce=re===ue;break;case"!==":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Ce=re!==ue;break;case"":case"=":case"==":Ce=ce(re,ue,be);break;case"!=":Ce=he(re,ue,be);break;case">":Ce=te(re,ue,be);break;case">=":Ce=me(re,ue,be);break;case"<":Ce=se(re,ue,be);break;case"<=":Ce=ve(re,ue,be);break;default:throw new TypeError("Invalid operator: "+ae)}return Ce}function ye(re,ae){if(re instanceof ye){if(re.loose===ae)return re;re=re.value}if(!(this instanceof ye))return new ye(re,ae);T("comparator",re,ae),this.loose=ae,this.parse(re),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(re,ae){return z(ae,re)},e.major=function(re,ae){return new j(re,ae).major},e.minor=function(re,ae){return new j(re,ae).minor},e.patch=function(re,ae){return new j(re,ae).patch},e.compare=V,e.compareLoose=function(re,ae){return V(re,ae,!0)},e.rcompare=function(re,ae,ue){return V(ae,re,ue)},e.sort=function(re,ae){return re.sort(function(ue,be){return e.compare(ue,be,ae)})},e.rsort=function(re,ae){return re.sort(function(ue,be){return e.rcompare(ue,be,ae)})},e.gt=te,e.lt=se,e.eq=ce,e.neq=he,e.gte=me,e.lte=ve,e.cmp=ge,e.Comparator=ye;var Re={};function Ee(re,ae){if(re instanceof Ee)return re.loose===ae?re:new Ee(re.raw,ae);if(re instanceof ye)return new Ee(re.value,ae);if(!(this instanceof Ee))return new Ee(re,ae);if(this.loose=ae,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function De(re){return!re||re.toLowerCase()==="x"||re==="*"}function _e(re,ae,ue,be,Ce,Fe,Le,Me,Oe,Q,oe,le,fe){return((ae=De(ue)?"":De(be)?">="+ue+".0.0":De(Ce)?">="+ue+"."+be+".0":">="+ae)+" "+(Me=De(Oe)?"":De(Q)?"<"+(+Oe+1)+".0.0":De(oe)?"<"+Oe+"."+(+Q+1)+".0":le?"<="+Oe+"."+Q+"."+oe+"-"+le:"<="+Me)).trim()}function Ne(re,ae){for(var ue=0;ue<re.length;ue++)if(!re[ue].test(ae))return!1;if(ae.prerelease.length){for(ue=0;ue<re.length;ue++)if(T(re[ue].semver),re[ue].semver!==Re&&re[ue].semver.prerelease.length>0){var be=re[ue].semver;if(be.major===ae.major&&be.minor===ae.minor&&be.patch===ae.patch)return!0}return!1}return!0}function $e(re,ae,ue){try{ae=new Ee(ae,ue)}catch{return!1}return ae.test(re)}function xe(re,ae,ue,be){var Ce,Fe,Le,Me,Oe;switch(re=new j(re,be),ae=new Ee(ae,be),ue){case">":Ce=te,Fe=ve,Le=se,Me=">",Oe=">=";break;case"<":Ce=se,Fe=me,Le=te,Me="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(re,ae,be))return!1;for(var Q=0;Q<ae.set.length;++Q){var oe=ae.set[Q],le=null,fe=null;if(oe.forEach(function(pe){pe.semver===Re&&(pe=new ye(">=0.0.0")),le=le||pe,fe=fe||pe,Ce(pe.semver,le.semver,be)?le=pe:Le(pe.semver,fe.semver,be)&&(fe=pe)}),le.operator===Me||le.operator===Oe||(!fe.operator||fe.operator===Me)&&Fe(re,fe.semver)||fe.operator===Oe&&Le(re,fe.semver))return!1}return!0}ye.prototype.parse=function(re){var ae=this.loose?R[ee]:R[G],ue=re.match(ae);if(!ue)throw new TypeError("Invalid comparator: "+re);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new j(ue[2],this.loose):this.semver=Re},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(re){return T("Comparator.test",re,this.loose),this.semver===Re||(typeof re=="string"&&(re=new j(re,this.loose)),ge(re,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(re,ae){if(!(re instanceof ye))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new Ee(re.value,ae),$e(this.value,ue,ae);if(re.operator==="")return ue=new Ee(this.value,ae),$e(re.semver,ue,ae);var be=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),Fe=this.semver.version===re.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Me=ge(this.semver,"<",re.semver,ae)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),Oe=ge(this.semver,">",re.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return be||Ce||Fe&&Le||Me||Oe},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(re){var ae=this.loose;re=re.trim(),T("range",re,ae);var ue=ae?R[H]:R[Y];re=re.replace(ue,_e),T("hyphen replace",re),re=re.replace(R[q],"$1$2$3"),T("comparator trim",re,R[q]),re=(re=(re=re.replace(R[N],"$1~")).replace(R[W],"$1^")).split(/\s+/).join(" ");var be=ae?R[ee]:R[G],Ce=re.split(" ").map(function(Fe){return function(Le,Me){return T("comp",Le),Le=function(Oe,Q){return Oe.trim().split(/\s+/).map(function(oe){return function(le,fe){T("caret",le,fe);var pe=fe?R[x]:R[U];return le.replace(pe,function(Te,we,Pe,ke,Ie){var Ae;return T("caret",le,Te,we,Pe,ke,Ie),De(we)?Ae="":De(Pe)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":De(ke)?Ae=we==="0"?">="+we+"."+Pe+".0 <"+we+"."+(+Pe+1)+".0":">="+we+"."+Pe+".0 <"+(+we+1)+".0.0":Ie?(T("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=we==="0"?Pe==="0"?">="+we+"."+Pe+"."+ke+Ie+" <"+we+"."+Pe+"."+(+ke+1):">="+we+"."+Pe+"."+ke+Ie+" <"+we+"."+(+Pe+1)+".0":">="+we+"."+Pe+"."+ke+Ie+" <"+(+we+1)+".0.0"):(T("no pr"),Ae=we==="0"?Pe==="0"?">="+we+"."+Pe+"."+ke+" <"+we+"."+Pe+"."+(+ke+1):">="+we+"."+Pe+"."+ke+" <"+we+"."+(+Pe+1)+".0":">="+we+"."+Pe+"."+ke+" <"+(+we+1)+".0.0"),T("caret return",Ae),Ae})}(oe,Q)}).join(" ")}(Le,Me),T("caret",Le),Le=function(Oe,Q){return Oe.trim().split(/\s+/).map(function(oe){return function(le,fe){var pe=fe?R[D]:R[$];return le.replace(pe,function(Te,we,Pe,ke,Ie){var Ae;return T("tilde",le,Te,we,Pe,ke,Ie),De(we)?Ae="":De(Pe)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":De(ke)?Ae=">="+we+"."+Pe+".0 <"+we+"."+(+Pe+1)+".0":Ie?(T("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=">="+we+"."+Pe+"."+ke+Ie+" <"+we+"."+(+Pe+1)+".0"):Ae=">="+we+"."+Pe+"."+ke+" <"+we+"."+(+Pe+1)+".0",T("tilde return",Ae),Ae})}(oe,Q)}).join(" ")}(Le,Me),T("tildes",Le),Le=function(Oe,Q){return T("replaceXRanges",Oe,Q),Oe.split(/\s+/).map(function(oe){return function(le,fe){le=le.trim();var pe=fe?R[I]:R[m];return le.replace(pe,function(Te,we,Pe,ke,Ie,Ae){T("xRange",le,Te,we,Pe,ke,Ie,Ae);var ze=De(Pe),je=ze||De(ke),Be=je||De(Ie);return we==="="&&Be&&(we=""),ze?Te=we===">"||we==="<"?"<0.0.0":"*":we&&Be?(je&&(ke=0),Be&&(Ie=0),we===">"?(we=">=",je?(Pe=+Pe+1,ke=0,Ie=0):Be&&(ke=+ke+1,Ie=0)):we==="<="&&(we="<",je?Pe=+Pe+1:ke=+ke+1),Te=we+Pe+"."+ke+"."+Ie):je?Te=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Be&&(Te=">="+Pe+"."+ke+".0 <"+Pe+"."+(+ke+1)+".0"),T("xRange return",Te),Te})}(oe,Q)}).join(" ")}(Le,Me),T("xrange",Le),Le=function(Oe,Q){return T("replaceStars",Oe,Q),Oe.trim().replace(R[Z],"")}(Le,Me),T("stars",Le),Le}(Fe,ae)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Fe){return!!Fe.match(be)})),Ce=Ce.map(function(Fe){return new ye(Fe,ae)})},Ee.prototype.intersects=function(re,ae){if(!(re instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(be){return re.set.some(function(Ce){return Ce.every(function(Fe){return be.intersects(Fe,ae)})})})})},e.toComparators=function(re,ae){return new Ee(re,ae).set.map(function(ue){return ue.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new j(re,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Ne(this.set[ae],re))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(re,ae,ue){var be=null,Ce=null;try{var Fe=new Ee(ae,ue)}catch{return null}return re.forEach(function(Le){Fe.test(Le)&&(be&&Ce.compare(Le)!==-1||(Ce=new j(be=Le,ue)))}),be},e.minSatisfying=function(re,ae,ue){var be=null,Ce=null;try{var Fe=new Ee(ae,ue)}catch{return null}return re.forEach(function(Le){Fe.test(Le)&&(be&&Ce.compare(Le)!==1||(Ce=new j(be=Le,ue)))}),be},e.validRange=function(re,ae){try{return new Ee(re,ae).range||"*"}catch{return null}},e.ltr=function(re,ae,ue){return xe(re,ae,"<",ue)},e.gtr=function(re,ae,ue){return xe(re,ae,">",ue)},e.outside=xe,e.prerelease=function(re,ae){var ue=F(re,ae);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(re,ae,ue){return re=new Ee(re,ue),ae=new Ee(ae,ue),re.intersects(ae)},e.coerce=function(re){if(re instanceof j)return re;if(typeof re!="string")return null;var ae=re.match(R[O]);return ae==null?null:F((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,L(1))},function(J,e){var L,n,T=J.exports={};function _(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function R(p){if(L===setTimeout)return setTimeout(p,0);if((L===_||!L)&&setTimeout)return L=setTimeout,setTimeout(p,0);try{return L(p,0)}catch{try{return L.call(null,p,0)}catch{return L.call(this,p,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:_}catch{L=_}try{n=typeof clearTimeout=="function"?clearTimeout:k}catch{n=k}})();var C,E=[],P=!1,b=-1;function f(){P&&C&&(P=!1,C.length?E=C.concat(E):b=-1,E.length&&S())}function S(){if(!P){var p=R(f);P=!0;for(var v=E.length;v;){for(C=E,E=[];++b<v;)C&&C[b].run();b=-1,v=E.length}C=null,P=!1,function(y){if(n===clearTimeout)return clearTimeout(y);if((n===k||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(y);try{n(y)}catch{try{return n.call(null,y)}catch{return n.call(this,y)}}}(p)}}function d(p,v){this.fun=p,this.array=v}function w(){}T.nextTick=function(p){var v=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)v[y-1]=arguments[y];E.push(new d(p,v)),E.length!==1||P||R(S)},d.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=w,T.addListener=w,T.once=w,T.off=w,T.removeListener=w,T.removeAllListeners=w,T.emit=w,T.prependListener=w,T.prependOnceListener=w,T.listeners=function(p){return[]},T.binding=function(p){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(p){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(ne[103],ie([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(R,C,E){this.level=R,this.key=C,this.value=E,this.forward=[]}}const T=void 0;class _{constructor(R,C=2**16){this.comparator=R,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(C)|0),this._header=new n(this._maxLevel,T,T)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,T,T)}has(R){return Boolean(_._search(this,R,this.comparator))}get(R){return _._search(this,R,this.comparator)?.value}set(R,C){return _._insert(this,R,C,this.comparator)&&(this._size+=1),this}delete(R){const C=_._delete(this,R,this.comparator);return C&&(this._size-=1),C}forEach(R,C){let E=this._header.forward[0];for(;E;)R.call(C,E.value,E.key,this),E=E.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",C=this._header.forward[0];for(;C;)R+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return R}static _search(R,C,E){let P=R._header;for(let b=R._level-1;b>=0;b--)for(;P.forward[b]&&E(P.forward[b].key,C)<0;)P=P.forward[b];if(P=P.forward[0],P&&E(P.key,C)===0)return P}static _insert(R,C,E,P){let b=[],f=R._header;for(let S=R._level-1;S>=0;S--){for(;f.forward[S]&&P(f.forward[S].key,C)<0;)f=f.forward[S];b[S]=f}if(f=f.forward[0],f&&P(f.key,C)===0)return f.value=E,!1;{let S=_._randomLevel(R);if(S>R._level){for(let d=R._level;d<S;d++)b[d]=R._header;R._level=S}f=new n(S,C,E);for(let d=0;d<S;d++)f.forward[d]=b[d].forward[d],b[d].forward[d]=f;return!0}}static _randomLevel(R,C=.5){let E=1;for(;Math.random()<C&&E<R._maxLevel;)E+=1;return E}static _delete(R,C,E){let P=[],b=R._header;for(let f=R._level-1;f>=0;f--){for(;b.forward[f]&&E(b.forward[f].key,C)<0;)b=b.forward[f];P[f]=b}if(b=b.forward[0],!b||E(b.key,C)!==0)return!1;for(let f=0;f<R._level&&P[f].forward[f]===b;f++)P[f].forward[f]=b.forward[f];for(;R._level>0&&R._header.forward[R._level-1]===T;)R._level-=1;return!0}}e.SkipList=_}),define(ne[104],ie([0,1,4]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=L.globals.performance&&typeof L.globals.performance.now=="function";class T{constructor(k){this._highResolution=n&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new T(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?L.globals.performance.now():Date.now()}}e.StopWatch=T}),define(ne[3],ie([0,1,8,67,2,100,104]),function(J,e,L,n,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(l){l.None=()=>T.Disposable.None;function u(x){return(ee,G=null,q)=>{let Y=!1,H;return H=x(Z=>{if(!Y)return H?H.dispose():Y=!0,ee.call(G,Z)},null,q),Y&&H.dispose(),H}}l.once=u;function r(x,ee){return c((G,q=null,Y)=>x(H=>G.call(q,ee(H)),null,Y))}l.map=r;function a(x,ee){return c((G,q=null,Y)=>x(H=>{ee(H),G.call(q,H)},null,Y))}l.forEach=a;function i(x,ee){return c((G,q=null,Y)=>x(H=>ee(H)&&G.call(q,H),null,Y))}l.filter=i;function t(x){return x}l.signal=t;function s(...x){return(ee,G=null,q)=>(0,T.combinedDisposable)(...x.map(Y=>Y(H=>ee.call(G,H),null,q)))}l.any=s;function o(x,ee,G){let q=G;return r(x,Y=>(q=ee(q,Y),q))}l.reduce=o;function c(x){let ee;const G=new f({onFirstListenerAdd(){ee=x(G.fire,G)},onLastListenerRemove(){ee.dispose()}});return G.event}function h(x,ee,G,q=100,Y=!1){let H,Z,K=0;return x(F=>{K++,H=G(H,F),Y&&!Z&&(ee(H),H=void 0),clearTimeout(Z),Z=setTimeout(()=>{const j=H;H=void 0,Z=void 0,(!Y||K>1)&&ee(j),K=0},q)})}l.debouncedListener=h;function m(x,ee,G=100,q=!1,Y){let H,Z,K,F=0;const j=new f({leakWarningThreshold:Y,onFirstListenerAdd(){H=x(B=>{F++,Z=ee(Z,B),q&&!K&&(j.fire(Z),Z=void 0),clearTimeout(K),K=setTimeout(()=>{const z=Z;Z=void 0,K=void 0,(!q||F>1)&&j.fire(z),F=0},G)})},onLastListenerRemove(){H.dispose()}});return j.event}l.debounce=m;function I(x,ee=(G,q)=>G===q){let G=!0,q;return i(x,Y=>{const H=G||!ee(Y,q);return G=!1,q=Y,H})}l.latch=I;function O(x,ee){return[l.filter(x,ee),l.filter(x,G=>!ee(G))]}l.split=O;function A(x,ee=!1,G=[]){let q=G.slice(),Y=x(K=>{q?q.push(K):Z.fire(K)});const H=()=>{q&&q.forEach(K=>Z.fire(K)),q=null},Z=new f({onFirstListenerAdd(){Y||(Y=x(K=>Z.fire(K)))},onFirstListenerDidAdd(){q&&(ee?setTimeout(H):H())},onLastListenerRemove(){Y&&Y.dispose(),Y=null}});return Z.event}l.buffer=A;class N{constructor(ee){this.event=ee}map(ee){return new N(r(this.event,ee))}forEach(ee){return new N(a(this.event,ee))}filter(ee){return new N(i(this.event,ee))}reduce(ee,G){return new N(o(this.event,ee,G))}latch(){return new N(I(this.event))}debounce(ee,G=100,q=!1,Y){return new N(m(this.event,ee,G,q,Y))}on(ee,G,q){return this.event(ee,G,q)}once(ee,G,q){return u(this.event)(ee,G,q)}}function $(x){return new N(x)}l.chain=$;function D(x,ee,G=q=>q){const q=(...K)=>Z.fire(G(...K)),Y=()=>x.on(ee,q),H=()=>x.removeListener(ee,q),Z=new f({onFirstListenerAdd:Y,onLastListenerRemove:H});return Z.event}l.fromNodeEventEmitter=D;function M(x,ee,G=q=>q){const q=(...K)=>Z.fire(G(...K)),Y=()=>x.addEventListener(ee,q),H=()=>x.removeEventListener(ee,q),Z=new f({onFirstListenerAdd:Y,onLastListenerRemove:H});return Z.event}l.fromDOMEventEmitter=M;function W(x){return new Promise(ee=>u(x)(ee))}l.toPromise=W;function U(x,ee){return ee(void 0),x(G=>ee(G))}l.runAndSubscribe=U})(R=e.Event||(e.Event={}));class C{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${C._idPool++}`}start(u){this._stopWatch=new k.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let E=-1;function P(l){const u=E;return E=l,{dispose(){E=u}}}e.setGlobalLeakWarningThreshold=P;class b{constructor(u,r=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let r=E;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||u<r)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(a)||0;if(this._stacks.set(a,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,s=0;for(const[o,c]of this._stacks)(!t||s<c)&&(t=o,s=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class f{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=E>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0}get event(){return this._event||(this._event=(u,r,a)=>{this._listeners||(this._listeners=new _.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[u,r]:u);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,r);const s=this._leakageMon?.check(this._listeners.size),o=(0,T.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof T.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,a]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(i){(0,L.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class S extends f{async fireAsync(u,r,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,u]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[i,t]=this._asyncDeliveryQueue.shift(),s=[],o={...t,token:r,waitUntil:c=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");a&&(c=a(c,typeof i=="function"?i:i[0])),s.push(c)}};try{typeof i=="function"?i.call(void 0,o):i[0].call(i[1],o)}catch(c){(0,L.onUnexpectedError)(c);continue}Object.freeze(s),await Promise.allSettled(s).then(c=>{for(const h of c)h.status==="rejected"&&(0,L.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=S;class d extends f{constructor(u){super(u);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=d;class w extends d{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=w;class p extends f{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=p;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const r={event:u,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const a=()=>{this.hasListeners&&this.unhook(r);const i=this.events.indexOf(r);this.events.splice(i,1)};return(0,T.toDisposable)((0,n.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(r=>this.emitter.fire(r))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class y{constructor(){this.buffers=[]}wrapEvent(u){return(r,a,i)=>u(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>r.call(a,t)):r.call(a,t)},void 0,i)}bufferEvents(u){const r=[];this.buffers.push(r);const a=u();return this.buffers.pop(),r.forEach(i=>i()),a}}e.EventBufferer=y;class g{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=T.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(ne[25],ie([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(R,C){const E=setTimeout(R.bind(C),0);return{dispose(){clearTimeout(E)}}});var T;(function(R){function C(E){return E===R.None||E===R.Cancelled||E instanceof _?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}R.isCancellationToken=C,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(T=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new L.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=T.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=k}),define(ne[105],ie([0,1,25]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new L.CancellationTokenSource,R=this.task(k.token);return this.result={promise:R,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=n;class T{constructor(k){this.computeFn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const R=JSON.stringify(k);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(k)),this.lastCache}}e.LRUCachedComputed=T}),define(ne[40],ie([0,1,8,2]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(g){const l=g;return l?[l.on,l.pause,l.resume,l.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=T;function _(g){const l=g;return l?T(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=_;function k(g,l){return new R(g,l)}e.newWriteableStream=k;class R{constructor(l,u){this.reducer=l,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(u=>u(l))}emitError(l){this.listeners.error.length===0?(0,L.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(u=>u(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,u){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(l,u){if(this.state.destroyed)return;let r;switch(l){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const a=r.indexOf(u);a>=0&&r.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(g,l){const u=[];let r;for(;(r=g.read())!==null;)u.push(r);return l(u)}e.consumeReadable=C;function E(g,l,u){const r=[];let a;for(;(a=g.read())!==null&&r.length<u;)r.push(a);return a===null&&r.length>0?l(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a!="undefined"){const i=a;return a=void 0,i}return g.read()}}}e.peekReadable=E;function P(g,l){return new Promise((u,r)=>{const a=[];b(g,{onData:i=>{l&&a.push(i)},onError:i=>{l?r(i):u(void 0)},onEnd:()=>{u(l?l(a):void 0)}})})}e.consumeStream=P;function b(g,l){let u=!1;return g.on("error",r=>{u||l.onError(r)}),g.on("end",()=>{u||l.onEnd()}),g.on("data",r=>{u||l.onData(r)}),(0,n.toDisposable)(()=>u=!0)}e.listenStream=b;function f(g,l){return new Promise((u,r)=>{const a=new n.DisposableStore,i=[],t=c=>{if(i.push(c),i.length>l)return a.dispose(),g.pause(),u({stream:g,buffer:i,ended:!1})},s=c=>r(c),o=()=>u({stream:g,buffer:i,ended:!0});a.add((0,n.toDisposable)(()=>g.removeListener("error",s))),g.on("error",s),a.add((0,n.toDisposable)(()=>g.removeListener("end",o))),g.on("end",o),a.add((0,n.toDisposable)(()=>g.removeListener("data",t))),g.on("data",t)})}e.peekStream=f;function S(g,l){const u=k(l);return u.end(g),u}e.toStream=S;function d(){const g=k(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=d;function w(g){let l=!1;return{read:()=>l?null:(l=!0,g)}}e.toReadable=w;function p(g,l,u){const r=k(u);return b(g,{onData:a=>r.write(l.data(a)),onError:a=>r.error(l.error?l.error(a):a),onEnd:()=>r.end()}),r}e.transform=p;function v(g,l,u){let r=!1;return{read:()=>{const a=l.read();return r?a:(r=!0,a!==null?u([g,a]):g)}}}e.prefixedReadable=v;function y(g,l,u){let r=!1;const a=k(u);return b(l,{onData:i=>r?a.write(i):(r=!0,a.write(u([g,i]))),onError:i=>a.error(i),onEnd:()=>{r||(r=!0,a.write(g)),a.end()}}),a}e.prefixedStream=y}),define(ne[17],ie([0,1,40]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let T,_;class k{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return n?new k(Buffer.allocUnsafe(h)):new k(new Uint8Array(h))}static wrap(h){return n&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new k(h)}static fromString(h,m){return!(m?.dontUseNodeBuffer||!1)&&n?new k(Buffer.from(h)):(T||(T=new TextEncoder),new k(T.encode(h)))}static fromByteArray(h){const m=k.alloc(h.length);for(let I=0,O=h.length;I<O;I++)m.buffer[I]=h[I];return m}static concat(h,m){if(typeof m=="undefined"){m=0;for(let A=0,N=h.length;A<N;A++)m+=h[A].byteLength}const I=k.alloc(m);let O=0;for(let A=0,N=h.length;A<N;A++){const $=h[A];I.set($,O),O+=$.byteLength}return I}clone(){const h=k.alloc(this.byteLength);return h.set(this),h}toString(){return n?this.buffer.toString():(_||(_=new TextDecoder),_.decode(this.buffer))}slice(h,m){return new k(this.buffer.subarray(h,m))}set(h,m){if(h instanceof k)this.buffer.set(h.buffer,m);else if(h instanceof Uint8Array)this.buffer.set(h,m);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),m);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),m);else throw new Error("Unkown argument 'array'")}readUInt32BE(h){return E(this.buffer,h)}writeUInt32BE(h,m){P(this.buffer,h,m)}readUInt32LE(h){return b(this.buffer,h)}writeUInt32LE(h,m){f(this.buffer,h,m)}readUInt8(h){return S(this.buffer,h)}writeUInt8(h,m){d(this.buffer,h,m)}}e.VSBuffer=k;function R(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0}e.readUInt16LE=R;function C(c,h,m){c[m+0]=h&255,h=h>>>8,c[m+1]=h&255}e.writeUInt16LE=C;function E(c,h){return c[h]*2**24+c[h+1]*2**16+c[h+2]*2**8+c[h+3]}e.readUInt32BE=E;function P(c,h,m){c[m+3]=h,h=h>>>8,c[m+2]=h,h=h>>>8,c[m+1]=h,h=h>>>8,c[m]=h}e.writeUInt32BE=P;function b(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0|c[h+2]<<16>>>0|c[h+3]<<24>>>0}e.readUInt32LE=b;function f(c,h,m){c[m+0]=h&255,h=h>>>8,c[m+1]=h&255,h=h>>>8,c[m+2]=h&255,h=h>>>8,c[m+3]=h&255}e.writeUInt32LE=f;function S(c,h){return c[h]}e.readUInt8=S;function d(c,h,m){c[m]=h}e.writeUInt8=d;function w(c){return L.consumeReadable(c,h=>k.concat(h))}e.readableToBuffer=w;function p(c){return L.toReadable(c)}e.bufferToReadable=p;function v(c){return L.consumeStream(c,h=>k.concat(h))}e.streamToBuffer=v;async function y(c){return c.ended?k.concat(c.buffer):k.concat([...c.buffer,await v(c.stream)])}e.bufferedStreamToBuffer=y;function g(c){return L.toStream(c,h=>k.concat(h))}e.bufferToStream=g;function l(c){return L.transform(c,{data:h=>typeof h=="string"?k.fromString(h):k.wrap(h)},h=>k.concat(h))}e.streamToBufferReadableStream=l;function u(c){return L.newWriteableStream(h=>k.concat(h),c)}e.newWriteableBufferStream=u;function r(c,h){return L.prefixedReadable(c,h,m=>k.concat(m))}e.prefixedBufferReadable=r;function a(c,h){return L.prefixedStream(c,h,m=>k.concat(m))}e.prefixedBufferStream=a;function i(c){let h=0,m=0,I=0;const O=new Uint8Array(Math.floor(c.length/4*3)),A=$=>{switch(m){case 3:O[I++]=h|$,m=0;break;case 2:O[I++]=h|$>>>2,h=$<<6,m=3;break;case 1:O[I++]=h|$>>>4,h=$<<4,m=2;break;default:h=$<<2,m=1}};for(let $=0;$<c.length;$++){const D=c.charCodeAt($);if(D>=65&&D<=90)A(D-65);else if(D>=97&&D<=122)A(D-97+26);else if(D>=48&&D<=57)A(D-48+52);else if(D===43||D===45)A(62);else if(D===47||D===95)A(63);else{if(D===61)break;throw new SyntaxError(`Unexpected base64 character ${c[$]}`)}}const N=I;for(;m>0;)A(0);return k.wrap(O).slice(0,N)}e.decodeBase64=i;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:c},h=!0,m=!1){const I=m?s:t;let O="";const A=c.byteLength%3;let N=0;for(;N<c.byteLength-A;N+=3){const $=c[N+0],D=c[N+1],M=c[N+2];O+=I[$>>>2],O+=I[($<<4|D>>>4)&63],O+=I[(D<<2|M>>>6)&63],O+=I[M&63]}if(A===1){const $=c[N+0];O+=I[$>>>2],O+=I[$<<4&63],h&&(O+="==")}else if(A===2){const $=c[N+0],D=c[N+1];O+=I[$>>>2],O+=I[($<<4|D>>>4)&63],O+=I[D<<2&63],h&&(O+="=")}return O}e.encodeBase64=o}),define(ne[27],ie([0,1,105,99]),function(J,e,L,n){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function _(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=_;const k=/{(\d+)}/g;function R(Q,...oe){return oe.length===0?Q:Q.replace(k,function(le,fe){const pe=parseInt(fe,10);return isNaN(pe)||pe<0||pe>=oe.length?le:oe[pe]})}e.format=R;const C=/{([^}]+)}/g;function E(Q,oe){return Q.replace(C,(le,fe)=>oe[fe]??le)}e.format2=E;function P(Q){return Q.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function b(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function f(Q,oe){let le=0;const fe=oe.charCodeAt(0);for(let pe=Q.length-1;pe>=0;pe--)Q.charCodeAt(pe)===fe&&le++;return le}e.count=f;function S(Q,oe,le="\u2026"){return Q.length<=oe?Q:`${Q.substr(0,oe)}${le}`}e.truncate=S;function d(Q,oe=" "){const le=w(Q,oe);return p(le,oe)}e.trim=d;function w(Q,oe){if(!Q||!oe)return Q;const le=oe.length;if(le===0||Q.length===0)return Q;let fe=0;for(;Q.indexOf(oe,fe)===fe;)fe=fe+le;return Q.substring(fe)}e.ltrim=w;function p(Q,oe){if(!Q||!oe)return Q;const le=oe.length,fe=Q.length;if(le===0||fe===0)return Q;let pe=fe,Te=-1;for(;Te=Q.lastIndexOf(oe,pe-1),!(Te===-1||Te+le!==pe);){if(Te===0)return"";pe=Te}return Q.substring(0,pe)}e.rtrim=p;function v(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function y(Q){return Q.replace(/\*/g,"")}e.stripWildcards=y;function g(Q,oe,le={}){if(!Q)throw new Error("Cannot create regex from empty string");oe||(Q=b(Q)),le.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let fe="";return le.global&&(fe+="g"),le.matchCase||(fe+="i"),le.multiline&&(fe+="m"),le.unicode&&(fe+="u"),new RegExp(Q,fe)}e.createRegExp=g;function l(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function u(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function r(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=r;function a(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=a;function i(Q){for(let oe=0,le=Q.length;oe<le;oe++){const fe=Q.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function t(Q,oe=0,le=Q.length){for(let fe=oe;fe<le;fe++){const pe=Q.charCodeAt(fe);if(pe!==32&&pe!==9)return Q.substring(oe,fe)}return Q.substring(oe,le)}e.getLeadingWhitespace=t;function s(Q,oe=Q.length-1){for(let le=oe;le>=0;le--){const fe=Q.charCodeAt(le);if(fe!==32&&fe!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function o(Q,oe){return Q<oe?-1:Q>oe?1:0}e.compare=o;function c(Q,oe,le=0,fe=Q.length,pe=0,Te=oe.length){for(;le<fe&&pe<Te;le++,pe++){let ke=Q.charCodeAt(le),Ie=oe.charCodeAt(pe);if(ke<Ie)return-1;if(ke>Ie)return 1}const we=fe-le,Pe=Te-pe;return we<Pe?-1:we>Pe?1:0}e.compareSubstring=c;function h(Q,oe){return m(Q,oe,0,Q.length,0,oe.length)}e.compareIgnoreCase=h;function m(Q,oe,le=0,fe=Q.length,pe=0,Te=oe.length){for(;le<fe&&pe<Te;le++,pe++){let ke=Q.charCodeAt(le),Ie=oe.charCodeAt(pe);if(ke===Ie)continue;if(ke>=128||Ie>=128)return c(Q.toLowerCase(),oe.toLowerCase(),le,fe,pe,Te);I(ke)&&(ke-=32),I(Ie)&&(Ie-=32);const Ae=ke-Ie;if(Ae!==0)return Ae}const we=fe-le,Pe=Te-pe;return we<Pe?-1:we>Pe?1:0}e.compareSubstringIgnoreCase=m;function I(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=I;function O(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=O;function A(Q,oe){return Q.length===oe.length&&m(Q,oe)===0}e.equalsIgnoreCase=A;function N(Q,oe){const le=oe.length;return oe.length>Q.length?!1:m(Q,oe,0,le)===0}e.startsWithIgnoreCase=N;function $(Q,oe){let le,fe=Math.min(Q.length,oe.length);for(le=0;le<fe;le++)if(Q.charCodeAt(le)!==oe.charCodeAt(le))return le;return fe}e.commonPrefixLength=$;function D(Q,oe){let le,fe=Math.min(Q.length,oe.length);const pe=Q.length-1,Te=oe.length-1;for(le=0;le<fe;le++)if(Q.charCodeAt(pe-le)!==oe.charCodeAt(Te-le))return le;return fe}e.commonSuffixLength=D;function M(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=M;function W(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=W;function U(Q,oe){return(Q-55296<<10)+(oe-56320)+65536}e.computeCodePoint=U;function x(Q,oe,le){const fe=Q.charCodeAt(le);if(M(fe)&&le+1<oe){const pe=Q.charCodeAt(le+1);if(W(pe))return U(fe,pe)}return fe}e.getNextCodePoint=x;function ee(Q,oe){const le=Q.charCodeAt(oe-1);if(W(le)&&oe>1){const fe=Q.charCodeAt(oe-2);if(M(fe))return U(fe,le)}return le}class G{constructor(oe,le=0){this._str=oe,this._len=oe.length,this._offset=le}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=ee(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=x(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=G;class q{constructor(oe,le=0){this._iterator=new G(oe,le)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let pe=oe.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Te=le.offset,we=oe.getGraphemeBreakType(le.nextCodePoint());if(xe(pe,we)){le.setOffset(Te);break}pe=we}return le.offset-fe}prevGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let pe=oe.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Te=le.offset,we=oe.getGraphemeBreakType(le.prevCodePoint());if(xe(we,pe)){le.setOffset(Te);break}pe=we}return fe-le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function Y(Q,oe){return new q(Q,oe).nextGraphemeLength()}e.nextCharLength=Y;function H(Q,oe){return new q(Q,oe).prevGraphemeLength()}e.prevCharLength=H;function Z(Q,oe){oe>0&&W(Q.charCodeAt(oe))&&oe--;const le=oe+Y(Q,oe);return[le-H(Q,le),le]}e.getCharContainingOffset=Z;const K=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(Q){return K.test(Q)}e.containsRTL=F;const j=/^[\t\n\r\x20-\x7E]*$/;function B(Q){return j.test(Q)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=z;function V(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=V;function te(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=te;function se(Q,oe){if(Q.length<oe)return Q;const le=/\b/g;let fe=0;for(;le.test(Q)&&!(Q.length-le.lastIndex<oe);)fe=le.lastIndex,le.lastIndex+=1;return Q.substring(fe).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function ve(Q){return Q&&(Q=Q.replace(ce,""),Q=Q.replace(he,""),Q=Q.replace(me,"")),Q}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ge;function ye(Q){return ge(Q)?Q.substr(1):Q}e.stripUTF8BOM=ye;function Re(Q,oe){if(!Q||!oe||Q.length<oe.length)return!1;const le=oe.length,fe=Q.toLowerCase();let pe=0,Te=-1;for(;pe<le;){const we=fe.indexOf(oe[pe],Te+1);if(we<0)return!1;Te=we,pe++}return!0}e.fuzzyContains=Re;function Ee(Q,oe=!1){return Q?(oe&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=Ee;function De(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=De;function _e(Q,oe=1){if(oe===0)return"";let le=-1;do le=Q.indexOf(`
`,le+1),oe--;while(oe>0&&le>=0);return le===-1?Q:(Q[le-1]==="\r"&&le--,Q.substr(0,le))}e.getNLines=_e;function Ne(Q){const oe=90-65+1;return Q=Q%(2*oe),Q<oe?String.fromCharCode(97+Q):String.fromCharCode(65+Q-oe)}e.singleLetterHash=Ne;function $e(Q){return ae.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=$e;function xe(Q,oe){return Q===0?oe!==5&&oe!==7:Q===2&&oe===3?!1:Q===4||Q===2||Q===3||oe===4||oe===2||oe===3?!0:!(Q===8&&(oe===8||oe===9||oe===11||oe===12)||(Q===11||Q===9)&&(oe===9||oe===10)||(Q===12||Q===10)&&oe===10||oe===5||oe===13||oe===7||Q===1||Q===13&&oe===14||Q===6&&oe===6)}var re;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ue()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const le=this._data,fe=le.length/3;let pe=1;for(;pe<=fe;)if(oe<le[3*pe])pe=2*pe;else if(oe>le[3*pe+1])pe=2*pe+1;else return le[3*pe+2];return 0}}ae._INSTANCE=null;function ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function be(Q,oe){if(Q===0)return 0;const le=Ce(Q,oe);if(le!==void 0)return le;const fe=new G(oe,Q);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=be;function Ce(Q,oe){const le=new G(oe,Q);let fe=le.prevCodePoint();for(;Fe(fe)||fe===65039||fe===8419;){if(le.offset===0)return;fe=le.prevCodePoint()}if(!te(fe))return;let pe=le.offset;return pe>0&&le.prevCodePoint()===8205&&(pe=le.offset),pe}function Fe(Q){return 127995<=Q&&Q<=127999}var Le;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Le||(Le={})),e.noBreakWhitespace="\xA0";class Me{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Me.cache.get(Array.from(oe))}static getLocales(){return Me._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Me,T=Me,Me.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')),Me.cache=new L.LRUCachedComputed(Q=>{function oe(Ie){const Ae=new Map;for(let ze=0;ze<Ie.length;ze+=2)Ae.set(Ie[ze],Ie[ze+1]);return Ae}function le(Ie,Ae){const ze=new Map(Ie);for(const[je,Be]of Ae)ze.set(je,Be);return ze}function fe(Ie,Ae){if(!Ie)return Ae;const ze=new Map;for(const[je,Be]of Ie)Ae.has(je)&&ze.set(je,Be);return ze}const pe=T.ambiguousCharacterData.getValue();let Te=Q.filter(Ie=>!Ie.startsWith("_")&&Ie in pe);Te.length===0&&(Te=["_default"]);let we;for(const Ie of Te){const Ae=oe(pe[Ie]);we=fe(we,Ae)}const Pe=oe(pe._common),ke=le(Pe,we);return new Me(ke)}),Me._locales=new n.Lazy(()=>Object.keys(Me.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(oe){return Oe.getData().has(oe)}static get codePoints(){return Oe.getData()}}e.InvisibleCharacters=Oe,Oe._data=void 0}),define(ne[106],ie([0,1,27]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(v){return T(v,0)}e.hash=n;function T(v,y){switch(typeof v){case"object":return v===null?_(349,y):Array.isArray(v)?C(v,y):E(v,y);case"string":return R(v,y);case"boolean":return k(v,y);case"number":return _(v,y);case"undefined":return _(937,y);default:return _(617,y)}}e.doHash=T;function _(v,y){return(y<<5)-y+v|0}e.numberHash=_;function k(v,y){return _(v?433:863,y)}function R(v,y){y=_(149417,y);for(let g=0,l=v.length;g<l;g++)y=_(v.charCodeAt(g),y);return y}e.stringHash=R;function C(v,y){return y=_(104579,y),v.reduce((g,l)=>T(l,g),y)}function E(v,y){return y=_(181387,y),Object.keys(v).sort().reduce((g,l)=>(g=R(l,g),T(v[l],g)),y)}class P{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=T(y,this._value),this._value}}e.Hasher=P;var b;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function f(v,y,g=32){const l=g-y,u=~((1<<l)-1);return(v<<y|(u&v)>>>l)>>>0}function S(v,y=0,g=v.byteLength,l=0){for(let u=0;u<g;u++)v[y+u]=l}function d(v,y,g="0"){for(;v.length<y;)v=g+v;return v}function w(v,y=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(g=>g.toString(16).padStart(2,"0")).join(""):d((v>>>0).toString(16),y/4)}e.toHexString=w;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const g=y.length;if(g===0)return;const l=this._buff;let u=this._buffLen,r=this._leftoverHighSurrogate,a,i;for(r!==0?(a=r,i=-1,r=0):(a=y.charCodeAt(0),i=0);;){let t=a;if(L.isHighSurrogate(a))if(i+1<g){const s=y.charCodeAt(i+1);L.isLowSurrogate(s)?(i++,t=L.computeCodePoint(a,s)):t=65533}else{r=a;break}else L.isLowSurrogate(a)&&(t=65533);if(u=this._push(l,u,t),i++,i<g)a=y.charCodeAt(i);else break}this._buffLen=u,this._leftoverHighSurrogate=r}_push(y,g,l){return l<128?y[g++]=l:l<2048?(y[g++]=192|(l&1984)>>>6,y[g++]=128|(l&63)>>>0):l<65536?(y[g++]=224|(l&61440)>>>12,y[g++]=128|(l&4032)>>>6,y[g++]=128|(l&63)>>>0):(y[g++]=240|(l&1835008)>>>18,y[g++]=128|(l&258048)>>>12,y[g++]=128|(l&4032)>>>6,y[g++]=128|(l&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=p._bigBlock32,g=this._buffDV;for(let c=0;c<64;c+=4)y.setUint32(c,g.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)y.setUint32(c,f(y.getUint32(c-12,!1)^y.getUint32(c-32,!1)^y.getUint32(c-56,!1)^y.getUint32(c-64,!1),1),!1);let l=this._h0,u=this._h1,r=this._h2,a=this._h3,i=this._h4,t,s,o;for(let c=0;c<80;c++)c<20?(t=u&r|~u&a,s=1518500249):c<40?(t=u^r^a,s=1859775393):c<60?(t=u&r|u&a|r&a,s=2400959708):(t=u^r^a,s=3395469782),o=f(l,5)+t+i+s+y.getUint32(c*4,!1)&4294967295,i=a,a=r,r=f(u,30),u=l,l=o;this._h0=this._h0+l&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))});var Pt=this&&this.__classPrivateFieldSet||function(J,e,L,n,T){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?T.call(J,L):T?T.value=L:e.set(J,L),L},Ke=this&&this.__classPrivateFieldGet||function(J,e,L,n){if(L==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return L==="m"?n:L==="a"?n.call(J):n?n.value:e.get(J)};define(ne[39],ie([0,1,16,27]),function(J,e,L,n){"use strict";var T,_,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(i,t,s){let o=i.get(t);return o===void 0&&(o=s,i.set(t,o)),o}e.getOrSet=R;function C(i){const t=[];return i.forEach((s,o)=>{t.push(`${o} => ${s}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=C;function E(i){const t=[];return i.forEach(s=>{t.push(s)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=E;class P{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=P;class b{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class f{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var S;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(S||(S={}));class d{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(p||(p={}));class v{constructor(t){this._iter=t}static forUris(t=()=>!1){return new v(new d(t))}static forPaths(t=!1){return new v(new f(void 0,!t))}static forStrings(){return new v(new P)}static forConfigKeys(){return new v(new b)}clear(){this._root=void 0}fill(t,s){if(s){const o=s.slice(0);(0,L.shuffle)(o);for(let c of o)this.set(c,t)}else{const o=t.slice(0);(0,L.shuffle)(o);for(let c of o)this.set(c[0],c[1])}}set(t,s){const o=this._iter.reset(t);let c;this._root||(this._root=new w,this._root.segment=o.value());const h=[];for(c=this._root;;){const I=o.cmp(c.segment);if(I>0)c.left||(c.left=new w,c.left.segment=o.value()),h.push([-1,c]),c=c.left;else if(I<0)c.right||(c.right=new w,c.right.segment=o.value()),h.push([1,c]),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new w,c.mid.segment=o.value()),h.push([0,c]),c=c.mid;else break}const m=c.value;c.value=s,c.key=t;for(let I=h.length-1;I>=0;I--){const O=h[I][1];O.updateHeight();const A=O.balanceFactor();if(A<-1||A>1){const N=h[I][0],$=h[I+1][0];if(N===1&&$===1)h[I][1]=O.rotateLeft();else if(N===-1&&$===-1)h[I][1]=O.rotateRight();else if(N===1&&$===-1)O.right=h[I+1][1]=h[I+1][1].rotateRight(),h[I][1]=O.rotateLeft();else if(N===-1&&$===1)O.left=h[I+1][1]=h[I+1][1].rotateLeft(),h[I][1]=O.rotateRight();else throw new Error;if(I>0)switch(h[I-1][0]){case-1:h[I-1][1].left=h[I][1];break;case 1:h[I-1][1].right=h[I][1];break;case 0:h[I-1][1].mid=h[I][1];break}else this._root=h[0][1]}}return m}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const o=this._iter.reset(t),c=[];let h=this._root;for(;h;){const m=o.cmp(h.segment);if(m>0)c.push([-1,h]),h=h.left;else if(m<0)c.push([1,h]),h=h.right;else if(o.hasNext())o.next(),c.push([0,h]),h=h.mid;else break}if(!!h){if(s?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const m=this._min(h.right),{key:I,value:O,segment:A}=m;this._delete(m.key,!1),h.key=I,h.value=O,h.segment=A}else{const m=h.left??h.right;if(c.length>0){const[I,O]=c[c.length-1];switch(I){case-1:O.left=m;break;case 0:O.mid=m;break;case 1:O.right=m;break}}else this._root=m}for(let m=c.length-1;m>=0;m--){const I=c[m][1];I.updateHeight();const O=I.balanceFactor();if(O>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),c[m][1]=I.rotateLeft()):O<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),c[m][1]=I.rotateRight()),m>0)switch(c[m-1][0]){case-1:c[m-1][1].left=c[m][1];break;case 1:c[m-1][1].right=c[m][1];break;case 0:c[m-1][1].mid=c[m][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let o=this._root,c;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[s,o]of this)t(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=v;class y{constructor(t,s){this.uri=t,this.value=s}}class g{constructor(t,s){this[T]="ResourceMap",t instanceof g?(this.map=new Map(t.map),this.toKey=s??g.defaultToKey):(this.map=new Map,this.toKey=t??g.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new y(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[o,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=g,g.defaultToKey=i=>i.toString();var l;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class u{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const o=this._map.get(t);if(!!o)return s!==0&&this.touch(o,s),o.value}set(t,s,o=0){let c=this._map.get(t);if(c)c.value=s,o!==0&&this.touch(c,o);else{switch(c={key:t,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const o=this._state;let c=this._head;for(;c;){if(s?t.bind(s)(c.value,c.key,this):t(c.value,c.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const h={value:o.key,done:!1};return o=o.next,h}else return{value:void 0,done:!0}}};return c}values(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const h={value:o.value,done:!1};return o=o.next,h}else return{value:void 0,done:!0}}};return c}entries(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const h={value:[o.key,o.value],done:!1};return o=o.next,h}else return{value:void 0,done:!0}}};return c}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>t;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,o=t.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const o=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(o.previous=c,c.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const o=t.next,c=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=c,c.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,o)=>{t.push([o,s])}),t}fromJSON(t){this.clear();for(const[s,o]of t)this.set(s,o)}}e.LinkedMap=u;class r extends u{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class a{constructor(t){k.set(this,void 0),Pt(this,k,t,"f")}get size(){return Ke(this,k,"f").size}forEach(t,s){Ke(this,k,"f").forEach(t,s)}get(t){return Ke(this,k,"f").get(t)}has(t){return Ke(this,k,"f").has(t)}entries(){return Ke(this,k,"f").entries()}keys(){return Ke(this,k,"f").keys()}values(){return Ke(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ke(this,k,"f").entries()}}e.ReadonlyMapView=a}),define(ne[69],ie([0,1,39]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new L.LRUCache(1e4);function T(E){return C(E,"NFC",n)}e.normalizeNFC=T;const _=new L.LRUCache(1e4);function k(E){return C(E,"NFD",_)}e.normalizeNFD=k;const R=/[^\u0000-\u0080]/;function C(E,P,b){if(!E)return E;const f=b.get(E);if(f)return f;let S;return R.test(E)?S=E.normalize(P):S=E,b.set(E,S),S}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(P){return k(P).replace(E,"")}}()}),define(ne[15],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function L(h){return Array.isArray(h)}e.isArray=L;function n(h){return typeof h=="string"}e.isString=n;function T(h){return Array.isArray(h)&&h.every(m=>n(m))}e.isStringArray=T;function _(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=_;function k(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=k;function R(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=R;function C(h){return h===!0||h===!1}e.isBoolean=C;function E(h){return typeof h=="undefined"}e.isUndefined=E;function P(h){return!b(h)}e.isDefined=P;function b(h){return E(h)||h===null}e.isUndefinedOrNull=b;function f(h,m){if(!h)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=f;function S(h){if(b(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=S;function d(...h){const m=[];for(let I=0;I<h.length;I++){const O=h[I];if(b(O))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);m.push(O)}return m}e.assertAllDefined=d;const w=Object.prototype.hasOwnProperty;function p(h){if(!_(h))return!1;for(let m in h)if(w.call(h,m))return!1;return!0}e.isEmptyObject=p;function v(h){return typeof h=="function"}e.isFunction=v;function y(...h){return h.length>0&&h.every(v)}e.areFunctions=y;function g(h,m){const I=Math.min(h.length,m.length);for(let O=0;O<I;O++)l(h[O],m[O])}e.validateConstraints=g;function l(h,m){if(n(m)){if(typeof h!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(v(m)){try{if(h instanceof m)return}catch{}if(!b(h)&&h.constructor===m||m.length===1&&m.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function u(h){let m=[],I=Object.getPrototypeOf(h);for(;Object.prototype!==I;)m=m.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return m}e.getAllPropertyNames=u;function r(h){const m=[];for(const I of u(h))typeof h[I]=="function"&&m.push(I);return m}e.getAllMethodNames=r;function a(h,m){const I=A=>function(){const N=Array.prototype.slice.call(arguments,0);return m(A,N)};let O={};for(const A of h)O[A]=I(A);return O}e.createProxyObject=a;function i(h){return h===null?void 0:h}e.withNullAsUndefined=i;function t(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=t;function s(h){return class{constructor(){return new Proxy({},{get(m,I){if(m[I])return m[I];throw new Error(`Not Implemented: ${h}->${String(I)}`)}})}}}e.NotImplementedProxy=s;function o(h,m="Unreachable"){throw new Error(m)}e.assertNever=o;function c(h){return!!h&&typeof h.then=="function"&&typeof h.catch=="function"}e.isPromise=c}),define(ne[41],ie([0,1,9,4,27,15]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function R(s){return s.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=R;function C(s){return s.indexOf("/")===-1&&(s=R(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=C;function E(s,o=L.posix.sep){if(!s)return"";const c=s.length,h=s.charCodeAt(0);if(k(h)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let I=3;const O=I;for(;I<c&&!k(s.charCodeAt(I));I++);if(O!==I&&!k(s.charCodeAt(I+1))){for(I+=1;I<c;I++)if(k(s.charCodeAt(I)))return s.slice(0,I+1).replace(/[\\/]/g,o)}}return o}else if(v(h)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let m=s.indexOf("://");if(m!==-1){for(m+=3;m<c;m++)if(k(s.charCodeAt(m)))return s.slice(0,m+1)}return""}e.getRoot=E;function P(s){if(!n.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let c=2;const h=c;for(;c<s.length&&(o=s.charCodeAt(c),o!==92);c++);return!(h===c||(o=s.charCodeAt(c+1),isNaN(o)||o===92))}e.isUNC=P;const b=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,o=n.isWindows){const c=o?b:f;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||o&&S.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function w(s,o,c){const h=s===o;return!c||h?h:!s||!o?!1:(0,T.equalsIgnoreCase)(s,o)}e.isEqual=w;function p(s,o,c,h=L.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(c){if(!(0,T.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let I=o.length;return o.charAt(o.length-1)===h&&I--,s.charAt(I)===h}return o.charAt(o.length-1)!==h&&(o+=h),s.indexOf(o)===0}e.isEqualOrParent=p;function v(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=v;function y(s,o){return n.isWindows&&s.endsWith(":")&&(s+=L.sep),(0,L.isAbsolute)(s)||(s=(0,L.join)(o,s)),s=(0,L.normalize)(s),n.isWindows?(s=(0,T.rtrim)(s,L.sep),s.endsWith(":")&&(s+=L.sep)):(s=(0,T.rtrim)(s,L.sep),s||(s=L.sep)),s}e.sanitizeFilePath=y;function g(s){const o=(0,L.normalize)(s);return n.isWindows?s.length>3?!1:l(o)&&(s.length===2||o.charCodeAt(2)===92):o===L.posix.sep}e.isRootOrDriveLetter=g;function l(s,o){return(o!==void 0?o:n.isWindows)?v(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function u(s){return l(s)?s[0]:void 0}e.getDriveLetter=u;function r(s,o,c){return o.length>s.length?-1:s===o?0:(c&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=r;function a(s){const o=s.split(":");let c,h,m;for(const I of o){const O=Number(I);(0,_.isNumber)(O)?h===void 0?h=O:m===void 0&&(m=O):c=c?[c,I].join(":"):I}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:h!==void 0?h:void 0,column:m!==void 0?m:h!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(s,o,c=8){let h="";for(let I=0;I<c;I++)h+=i.charAt(Math.floor(Math.random()*i.length));let m;return o?m=`${o}-${h}`:m=h,s?(0,L.join)(s,m):m}e.randomPath=t}),define(ne[28],ie([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const p=Array.isArray(w)?[]:{};return Object.keys(w).forEach(v=>{w[v]&&typeof w[v]=="object"?p[v]=n(w[v]):p[v]=w[v]}),p}e.deepClone=n;function T(w){if(!w||typeof w!="object")return w;const p=[w];for(;p.length>0;){const v=p.shift();Object.freeze(v);for(const y in v)if(_.call(v,y)){const g=v[y];typeof g=="object"&&!Object.isFrozen(g)&&p.push(g)}}return w}e.deepFreeze=T;const _=Object.prototype.hasOwnProperty;function k(w,p){return R(w,p,new Set)}e.cloneAndChange=k;function R(w,p,v){if((0,L.isUndefinedOrNull)(w))return w;const y=p(w);if(typeof y!="undefined")return y;if((0,L.isArray)(w)){const g=[];for(const l of w)g.push(R(l,p,v));return g}if((0,L.isObject)(w)){if(v.has(w))throw new Error("Cannot clone recursive data-structure");v.add(w);const g={};for(let l in w)_.call(w,l)&&(g[l]=R(w[l],p,v));return v.delete(w),g}return w}function C(w,p,v=!0){return(0,L.isObject)(w)?((0,L.isObject)(p)&&Object.keys(p).forEach(y=>{y in w?v&&((0,L.isObject)(w[y])&&(0,L.isObject)(p[y])?C(w[y],p[y],v):w[y]=p[y]):w[y]=p[y]}),w):p}e.mixin=C;function E(w,p){if(w===p)return!0;if(w==null||p===null||p===void 0||typeof w!=typeof p||typeof w!="object"||Array.isArray(w)!==Array.isArray(p))return!1;let v,y;if(Array.isArray(w)){if(w.length!==p.length)return!1;for(v=0;v<w.length;v++)if(!E(w[v],p[v]))return!1}else{const g=[];for(y in w)g.push(y);g.sort();const l=[];for(y in p)l.push(y);if(l.sort(),!E(g,l))return!1;for(v=0;v<g.length;v++)if(!E(w[g[v]],p[g[v]]))return!1}return!0}e.equals=E;function P(w){const p=new Set;return JSON.stringify(w,(v,y)=>{if((0,L.isObject)(y)||Array.isArray(y)){if(p.has(y))return"[Circular]";p.add(y)}return y})}e.safeStringify=P;function b(w,p,v){const y=p(w);return typeof y=="undefined"?v:y}e.getOrDefault=b;function f(w,p){const v=Object.create(null);return!w||!p||Object.keys(p).forEach(g=>{const l=w[g],u=p[g];E(l,u)||(v[g]=u)}),v}e.distinct=f;function S(w,p){const v=p.toLowerCase(),y=Object.keys(w).find(g=>g.toLowerCase()===v);return y?w[y]:w[p]}e.getCaseInsensitive=S;function d(w,p){const v=Object.create(null);for(const[y,g]of Object.entries(w))p(y,g)&&(v[y]=g);return v}e.filter=d}),define(ne[7],ie([0,1,9,4]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,_=/^\//,k=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!T.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!_.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(i,t){return!i&&!t?"file":i}function E(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==b&&(t=b+t):t=b;break}return t}const P="",b="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(t,s,o,c,h,m=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=C(t,m),this.authority=s||P,this.path=E(this.scheme,o||P),this.query=c||P,this.fragment=h||P,R(this,m))}static isUri(t){return t instanceof S?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return g(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:o,path:c,query:h,fragment:m}=t;return s===void 0?s=this.scheme:s===null&&(s=P),o===void 0?o=this.authority:o===null&&(o=P),c===void 0?c=this.path:c===null&&(c=P),h===void 0?h=this.query:h===null&&(h=P),m===void 0?m=this.fragment:m===null&&(m=P),s===this.scheme&&o===this.authority&&c===this.path&&h===this.query&&m===this.fragment?this:new w(s,o,c,h,m)}static parse(t,s=!1){const o=f.exec(t);return o?new w(o[2]||P,a(o[4]||P),a(o[5]||P),a(o[7]||P),a(o[9]||P),s):new w(P,P,P,P,P)}static file(t){let s=P;if(n.isWindows&&(t=t.replace(/\\/g,b)),t[0]===b&&t[1]===b){const o=t.indexOf(b,2);o===-1?(s=t.substring(2),t=b):(s=t.substring(2,o),t=t.substring(o)||b)}return new w("file",s,t,P,P)}static from(t){const s=new w(t.scheme,t.authority,t.path,t.query,t.fragment);return R(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return n.isWindows&&t.scheme==="file"?o=S.file(L.win32.join(g(t,!0),...s)).path:o=L.posix.join(t.path,...s),t.with({path:o})}toString(t=!1){return l(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof S)return t;{const s=new w(t);return s._formatted=t.external,s._fsPath=t._sep===d?t.fsPath:null,s}}else return t}}e.URI=S;const d=n.isWindows?1:void 0;class w extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(t=!1){return t?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=d),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(i,t){let s,o=-1;for(let c=0;c<i.length;c++){const h=i.charCodeAt(c);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47)o!==-1&&(s+=encodeURIComponent(i.substring(o,c)),o=-1),s!==void 0&&(s+=i.charAt(c));else{s===void 0&&(s=i.substr(0,c));const m=p[h];m!==void 0?(o!==-1&&(s+=encodeURIComponent(i.substring(o,c)),o=-1),s+=m):o===-1&&(o=c)}}return o!==-1&&(s+=encodeURIComponent(i.substring(o))),s!==void 0?s:i}function y(i){let t;for(let s=0;s<i.length;s++){const o=i.charCodeAt(s);o===35||o===63?(t===void 0&&(t=i.substr(0,s)),t+=p[o]):t!==void 0&&(t+=i[s])}return t!==void 0?t:i}function g(i,t){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,n.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function l(i,t){const s=t?y:v;let o="",{scheme:c,authority:h,path:m,query:I,fragment:O}=i;if(c&&(o+=c,o+=":"),(h||c==="file")&&(o+=b,o+=b),h){let A=h.indexOf("@");if(A!==-1){const N=h.substr(0,A);h=h.substr(A+1),A=N.indexOf(":"),A===-1?o+=s(N,!1):(o+=s(N.substr(0,A),!1),o+=":",o+=s(N.substr(A+1),!1)),o+="@"}h=h.toLowerCase(),A=h.indexOf(":"),A===-1?o+=s(h,!1):(o+=s(h.substr(0,A),!1),o+=h.substr(A))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const A=m.charCodeAt(1);A>=65&&A<=90&&(m=`/${String.fromCharCode(A+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const A=m.charCodeAt(0);A>=65&&A<=90&&(m=`${String.fromCharCode(A+32)}:${m.substr(2)}`)}o+=s(m,!0)}return I&&(o+="?",o+=s(I,!1)),O&&(o+="#",o+=t?O:v(O,!1)),o}function u(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+u(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(r)?i.replace(r,t=>u(t)):i}}),define(ne[107],ie([0,1,7]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(E){const P=E;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=n;function T(E){const P=[];let b;try{const f=JSON.parse(E.arguments),S=f[f.length-1];S&&S.__$stack&&(f.pop(),b=S.__$stack),P.push(...f)}catch{P.push("Unable to log remote console arguments",E.arguments)}return{args:P,stack:b}}e.parse=T;function _(E){if(typeof E!="string")return _(T(E).stack);const P=E;if(P){const b=k(P),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(f&&f.length===4)return{uri:L.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=_;function k(E){if(!E)return E;const P=E.indexOf(`
`);return P===-1?E:E.substring(0,P)}function R(E,P){const{args:b,stack:f}=T(E),S=typeof b[0]=="string"&&b.length===1;let d=k(f);d&&(d=`(${d.trim()})`);let w=[];if(typeof b[0]=="string"?d&&S?w=[`%c[${P}] %c${b[0]} %c${d}`,C("blue"),C(""),C("grey")]:w=[`%c[${P}] %c${b[0]}`,C("blue"),C(""),...b.slice(1)]:w=[`%c[${P}]%`,C("blue"),...b],d&&!S&&w.push(d),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,w)}e.log=R;function C(E){return`color: ${E}`}}),define(ne[108],ie([0,1,17,27,7]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function _(P){return JSON.stringify(P,C)}e.stringify=_;function k(P){let b=JSON.parse(P);return b=E(b),b}e.parse=k;var R;(function(P){P[P.Uri=1]="Uri",P[P.Regexp=2]="Regexp",P[P.ScmResource=3]="ScmResource",P[P.ScmResourceGroup=4]="ScmResourceGroup",P[P.ScmProvider=5]="ScmProvider",P[P.CommentController=6]="CommentController",P[P.CommentThread=7]="CommentThread",P[P.CommentThreadReply=8]="CommentThreadReply",P[P.CommentNode=9]="CommentNode",P[P.CommentThreadNode=10]="CommentThreadNode",P[P.TimelineActionContext=11]="TimelineActionContext",P[P.NotebookCellActionContext=12]="NotebookCellActionContext",P[P.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function C(P,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,n.regExpFlags)(b)}:b}function E(P,b=0){if(!P||b>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return T.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof L.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let f=0;f<P.length;++f)P[f]=E(P[f],b+1);else for(const f in P)Object.hasOwnProperty.call(P,f)&&(P[f]=E(P[f],b+1))}return P}e.revive=E}),define(ne[18],ie([0,1,4,7]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(T=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,E,P){this._hosts[C]=E,this._ports[C]=P}setConnectionToken(C,E){this._connectionTokens[C]=E}rewrite(C){if(this._delegate)return this._delegate(C);const E=C.authority;let P=this._hosts[E];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const b=this._ports[E],f=this._connectionTokens[E];let S=`path=${encodeURIComponent(C.path)}`;return typeof f=="string"&&(S+=`&tkn=${encodeURIComponent(f)}`),n.URI.from({scheme:L.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${P}:${b}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new _;class k{asBrowserUri(C,E){const P=this.toUri(C,E);return P.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===T.file&&(L.isNative||typeof L.globals.importScripts=="function"&&L.globals.origin===`${T.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?P.with({scheme:T.vscodeFileResource,authority:P.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(C,E){const P=this.toUri(C,E);return P.scheme===T.vscodeFileResource?P.with({scheme:T.file,authority:P.authority!==k.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(C,E){return n.URI.isUri(C)?C:n.URI.parse(E.toUrl(C))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(ne[19],ie([0,1,41,18,9,4,27,7]),function(J,e,L,n,T,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(S){return(0,R.uriToFsPath)(S,!0)}e.originalFSPath=C;class E{constructor(d){this._ignorePathCasing=d}compare(d,w,p=!1){return d===w?0:(0,k.compare)(this.getComparisonKey(d,p),this.getComparisonKey(w,p))}isEqual(d,w,p=!1){return d===w?!0:!d||!w?!1:this.getComparisonKey(d,p)===this.getComparisonKey(w,p)}getComparisonKey(d,w=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,w,p=!1){if(d.scheme===w.scheme){if(d.scheme===n.Schemas.file)return L.isEqualOrParent(C(d),C(w),this._ignorePathCasing(d))&&d.query===w.query&&(p||d.fragment===w.fragment);if((0,e.isEqualAuthority)(d.authority,w.authority))return L.isEqualOrParent(d.path,w.path,this._ignorePathCasing(d),"/")&&d.query===w.query&&(p||d.fragment===w.fragment)}return!1}joinPath(d,...w){return R.URI.joinPath(d,...w)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return T.posix.basename(d.path)}extname(d){return T.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let w;return d.scheme===n.Schemas.file?w=R.URI.file(T.dirname(C(d))).path:(w=T.posix.dirname(d.path),d.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),w="/")),d.with({path:w})}normalizePath(d){if(!d.path.length)return d;let w;return d.scheme===n.Schemas.file?w=R.URI.file(T.normalize(C(d))).path:w=T.posix.normalize(d.path),d.with({path:w})}relativePath(d,w){if(d.scheme!==w.scheme||!(0,e.isEqualAuthority)(d.authority,w.authority))return;if(d.scheme===n.Schemas.file){const y=T.relative(C(d),C(w));return _.isWindows?L.toSlashes(y):y}let p=d.path||"/",v=w.path||"/";if(this._ignorePathCasing(d)){let y=0;for(const g=Math.min(p.length,v.length);y<g&&!(p.charCodeAt(y)!==v.charCodeAt(y)&&p.charAt(y).toLowerCase()!==v.charAt(y).toLowerCase());y++);p=v.substr(0,y)+p.substr(y)}return T.posix.relative(p,v)}resolvePath(d,w){if(d.scheme===n.Schemas.file){const p=R.URI.file(T.resolve(C(d),w));return d.with({authority:p.authority,path:p.path})}return w=L.toPosixPath(w),d.with({path:T.posix.resolve(d.path,w)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,w){return d===w||d!==void 0&&w!==void 0&&(0,k.equalsIgnoreCase)(d,w)}hasTrailingPathSeparator(d,w=T.sep){if(d.scheme===n.Schemas.file){const p=C(d);return p.length>L.getRoot(p).length&&p[p.length-1]===w}else{const p=d.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,w=T.sep){return(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,w=T.sep){let p=!1;if(d.scheme===n.Schemas.file){const v=C(d);p=v!==void 0&&v.length===L.getRoot(v).length&&v[v.length-1]===w}else{w="/";const v=d.path;p=v.length===1&&v.charCodeAt(v.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path+"/"}):d}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(S=>S.scheme===n.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new E(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(S,d){const w=[];for(let p=0;p<S.length;p++){const v=d(S[p]);S.some((y,g)=>g===p?!1:(0,e.isEqualOrParent)(v,d(y)))||w.push(S[p])}return w}e.distinctParents=P;var b;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function d(w){const p=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(g=>{const[l,u]=g.split(":");l&&u&&p.set(l,u)});const y=w.path.substring(0,w.path.indexOf(";"));return y&&p.set(S.META_DATA_MIME,y),p}S.parseMetaData=d})(b=e.DataUri||(e.DataUri={}));function f(S,d,w){if(d){let p=S.path;return p&&p[0]!==T.posix.sep&&(p=T.posix.sep+p),S.with({scheme:w,authority:d,path:p})}return S.with({scheme:w})}e.toLocalResource=f}),define(ne[5],ie([0,1,25,8,3,2,19,4]),function(J,e,L,n,T,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(K){return!!K&&typeof K.then=="function"}e.isThenable=C;function E(K){const F=new L.CancellationTokenSource,j=K(F.token),B=new Promise((z,V)=>{const te=F.token.onCancellationRequested(()=>{te.dispose(),F.dispose(),V((0,n.canceled)())});Promise.resolve(j).then(se=>{te.dispose(),F.dispose(),z(se)},se=>{te.dispose(),F.dispose(),V(se)})});return new class{cancel(){F.cancel()}then(z,V){return B.then(z,V)}catch(z){return this.then(void 0,z)}finally(z){return B.finally(z)}}}e.createCancelablePromise=E;function P(K,F,j){return Promise.race([K,new Promise(B=>F.onCancellationRequested(()=>B(j)))])}e.raceCancellation=P;async function b(K){let F=-1;const j=K.map((z,V)=>z.then(te=>(F=V,te))),B=await Promise.race(j);return K.forEach((z,V)=>{V!==F&&z.cancel()}),B}e.raceCancellablePromises=b;function f(K,F,j){let B;const z=setTimeout(()=>{B?.(void 0),j?.()},F);return Promise.race([K.finally(()=>clearTimeout(z)),new Promise(V=>B=V)])}e.raceTimeout=f;function S(K){return new Promise((F,j)=>{const B=K();C(B)?B.then(F,j):F(B)})}e.asPromise=S;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(j,j).then(B)})}return new Promise((j,B)=>{this.queuedPromise.then(j,B)})}return this.activePromise=F(),new Promise((j,B)=>{this.activePromise.then(z=>{this.activePromise=null,j(z)},z=>{this.activePromise=null,B(z)})})}}e.Throttler=d;class w{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=w;class p{constructor(){this.promiseMap=new Map}queue(F,j){const z=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(F)===z&&this.promiseMap.delete(F)});return this.promiseMap.set(F,z),z}}e.SequencerByKey=p;const v=(K,F)=>{let j=!0;const B=setTimeout(()=>{j=!1,F()},K);return{isTriggered:()=>j,dispose:()=>{clearTimeout(B),j=!1}}},y=K=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,K())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,j=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,V)=>{this.doResolve=z,this.doReject=V}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}}));const B=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=j===e.MicrotaskDelay?y(B):v(j,B),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,n.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class l{constructor(F){this.delayer=new g(F),this.throttler=new d}trigger(F,j){return this.delayer.trigger(()=>this.throttler.queue(F),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,j)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class r extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function a(K,F){return F?new Promise((j,B)=>{const z=setTimeout(()=>{V.dispose(),j()},K),V=F.onCancellationRequested(()=>{clearTimeout(z),V.dispose(),B((0,n.canceled)())})}):E(j=>a(K,j))}e.timeout=a;function i(K,F=0){const j=setTimeout(K,F);return(0,_.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=i;function t(K){const F=[];let j=0;const B=K.length;function z(){return j<B?K[j++]():null}function V(te){te!=null&&F.push(te);const se=z();return se?se.then(V):Promise.resolve(F)}return Promise.resolve(null).then(V)}e.sequence=t;function s(K,F=B=>!!B,j=null){let B=0;const z=K.length,V=()=>{if(B>=z)return Promise.resolve(j);const te=K[B++];return Promise.resolve(te()).then(ce=>F(ce)?Promise.resolve(ce):V())};return V()}e.first=s;function o(K,F=B=>!!B,j=null){if(K.length===0)return Promise.resolve(j);let B=K.length;const z=()=>{B=-1;for(const V of K)V.cancel?.()};return new Promise((V,te)=>{for(const se of K)se.then(ce=>{--B>=0&&F(ce)?(z(),V(ce)):B===0&&V(j)}).catch(ce=>{--B>=0&&(z(),te(ce))})})}e.firstParallel=o;class c{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((j,B)=>{this.outstandingPromises.push({factory:F,c:j,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const j=F.factory();j.then(F.c,F.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class h extends c{constructor(){super(1)}}e.Queue=h;class m{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const F=new ee;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueFor(F,j=k.extUri){const B=j.getComparisonKey(F);let z=this.queues.get(B);return z||(z=new h,T.Event.once(z.onFinished)(()=>{z?.dispose(),this.queues.delete(B),this.onDidQueueFinish()}),this.queues.set(B,z)),z}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=m;class I{constructor(F,j){this._token=-1,typeof F=="function"&&typeof j=="number"&&this.setIfNotSet(F,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},j)}setIfNotSet(F,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},j))}}e.TimeoutTimer=I;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,j){this.cancel(),this._token=setInterval(()=>{F()},j)}}e.IntervalTimer=O;class A{constructor(F,j){this.timeoutToken=-1,this.runner=F,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class N{constructor(F,j){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class $ extends A{constructor(F,j){super(F,j);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=$;class D extends _.Disposable{constructor(F,j,B,z){super();this.maxWorkChunkSize=F,this.maxPendingWork=j,this.throttleDelay=B,this.handler=z,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new A(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=D,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,R.setTimeout0)(()=>{if(F)return;const j=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,j-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(K,F)=>{const j=requestIdleCallback(K,typeof F=="number"?{timeout:F}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(j))}}}}();class M{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=M;async function W(K,F,j){let B;for(let z=0;z<j;z++)try{return await K()}catch(V){B=V,await a(F)}throw B}e.retry=W;class U{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,j,B){return this._pending={taskId:F,cancel:()=>B?.(),promise:j},j.then(()=>this.donePending(F),()=>this.donePending(F)),j}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let j,B;const z=new Promise((V,te)=>{j=V,B=te});this._next={run:F,promise:z,promiseResolve:j,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=U;class x{constructor(F,j=()=>Date.now()){this.interval=F,this.nowFn=j,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class ee{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,j)=>{this.completeCallback=F,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(j=>{this.completeCallback(F),this.resolved=!0,j()})}error(F){return new Promise(j=>{this.errorCallback(F),this.rejected=!0,j()})}cancel(){new Promise(F=>{this.errorCallback((0,n.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=ee;var G;(function(K){async function F(B){let z;const V=await Promise.all(B.map(te=>te.then(se=>se,se=>{z||(z=se)})));if(typeof z!="undefined")throw z;return V}K.settled=F;function j(B){return new Promise(async(z,V)=>{try{await B(z,V)}catch(te){V(te)}})}K.withAsyncBody=j})(G=e.Promises||(e.Promises={}));var q;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(q||(q={}));class Y{constructor(F){this._state=0,this._results=[],this._error=null,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const j={emitOne:B=>this.emitOne(B),emitMany:B=>this.emitMany(B),reject:B=>this.reject(B)};try{await Promise.resolve(F(j)),this.resolve()}catch(B){this.reject(B)}finally{j.emitOne=void 0,j.emitMany=void 0,j.reject=void 0}})}static fromArray(F){return new Y(j=>{j.emitMany(F)})}static fromPromise(F){return new Y(async j=>{j.emitMany(await F)})}static fromPromises(F){return new Y(async j=>{await Promise.all(F.map(async B=>j.emitOne(await B)))})}static merge(F){return new Y(async j=>{await Promise.all(F.map(async B=>{for await(const z of B)j.emitOne(z)}))})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===1)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(F,j){return new Y(async B=>{for await(const z of F)B.emitOne(j(z))})}map(F){return Y.map(this,F)}static filter(F,j){return new Y(async B=>{for await(const z of F)j(z)&&B.emitOne(z)})}filter(F){return Y.filter(this,F)}static coalesce(F){return Y.filter(F,j=>!!j)}coalesce(){return Y.coalesce(this)}static async toPromise(F){const j=[];for await(const B of F)j.push(B);return j}toPromise(){return Y.toPromise(this)}emitOne(F){this._state===0&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===0&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(F){this._state===0&&(this._state=2,this._error=F,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class H extends Y{constructor(F,j){super(j);this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=H;function Z(K){const F=new L.CancellationTokenSource,j=K(F.token);return new H(F,async B=>{const z=F.token.onCancellationRequested(()=>{z.dispose(),F.dispose(),B.reject((0,n.canceled)())});try{for await(const V of j){if(F.token.isCancellationRequested)return;B.emitOne(V)}z.dispose(),F.dispose()}catch(V){z.dispose(),F.dispose(),B.reject(V)}})}e.createCancelableAsyncIterable=Z}),define(ne[109],ie([0,1,5,41,39,9,27]),function(J,e,L,n,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const C="**",E="/",P="[/\\\\]",b="[^/\\\\]",f=/\//g;function S(q){switch(q){case 0:return"";case 1:return`${b}*?`;default:return`(?:${P}|${b}+${P}|${P}${b}+)*?`}}function d(q,Y){if(!q)return[];const H=[];let Z=!1,K=!1,F="";for(const j of q){switch(j){case Y:if(!Z&&!K){H.push(F),F="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":K=!0;break;case"]":K=!1;break}F+=j}return F&&H.push(F),H}e.splitGlobAware=d;function w(q){if(!q)return"";let Y="";const H=d(q,E);if(H.every(Z=>Z===C))Y=".*";else{let Z=!1;H.forEach((K,F)=>{if(K===C){Z||(Y+=S(2),Z=!0);return}let j=!1,B="",z=!1,V="";for(const te of K){if(te!=="}"&&j){B+=te;continue}if(z&&(te!=="]"||!V)){let se;te==="-"?se=te:(te==="^"||te==="!")&&!V?se="^":te===E?se="":se=k.escapeRegExpCharacters(te),V+=se;continue}switch(te){case"{":j=!0;continue;case"[":z=!0;continue;case"}":{Y+=`(?:${d(B,",").map(he=>w(he)).join("|")})`,j=!1,B="";break}case"]":Y+="["+V+"]",z=!1,V="";break;case"?":Y+=b;continue;case"*":Y+=S(1);continue;default:Y+=k.escapeRegExpCharacters(te)}}F<H.length-1&&(H[F+1]!==C||F+2<H.length)&&(Y+=P),Z=!1})}return Y}const p=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new T.LRUCache(1e4),a=function(){return!1},i=function(){return null};function t(q,Y){if(!q)return i;let H;typeof q!="string"?H=q.pattern:H=q,H=H.trim();const Z=`${H}_${!!Y.trimForExclusions}`;let K=r.get(Z);if(K)return s(K,q);let F;if(p.test(H)){const j=H.substr(4);K=function(B,z){return typeof B=="string"&&B.endsWith(j)?H:null}}else(F=v.exec(o(H,Y)))?K=c(F[1],H):(Y.trimForExclusions?g:y).test(H)?K=h(H,Y):(F=l.exec(o(H,Y)))?K=m(F[1].substr(1),H,!0):(F=u.exec(o(H,Y)))?K=m(F[1],H,!1):K=I(H);return r.set(Z,K),s(K,q)}function s(q,Y){return typeof Y=="string"?q:function(H,Z){return n.isEqualOrParent(H,Y.base)?q(_.relative(Y.base,H),Z):null}}function o(q,Y){return Y.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function c(q,Y){const H=`/${q}`,Z=`\\${q}`,K=function(j,B){return typeof j!="string"?null:B?B===q?Y:null:j===q||j.endsWith(H)||j.endsWith(Z)?Y:null},F=[q];return K.basenames=F,K.patterns=[Y],K.allBasenames=F,K}function h(q,Y){const H=G(q.slice(1,-1).split(",").map(B=>t(B,Y)).filter(B=>B!==i),q),Z=H.length;if(!Z)return i;if(Z===1)return H[0];const K=function(B,z){for(let V=0,te=H.length;V<te;V++)if(H[V](B,z))return q;return null},F=H.find(B=>!!B.allBasenames);F&&(K.allBasenames=F.allBasenames);const j=H.reduce((B,z)=>z.allPaths?B.concat(z.allPaths):B,[]);return j.length&&(K.allPaths=j),K}function m(q,Y,H){const Z=_.sep===_.posix.sep,K=Z?q:q.replace(f,_.sep),F=_.sep+K,j=_.posix.sep+q,B=H?function(z,V){return typeof z=="string"&&(z===K||z.endsWith(F)||!Z&&(z===q||z.endsWith(j)))?Y:null}:function(z,V){return typeof z=="string"&&(z===K||!Z&&z===q)?Y:null};return B.allPaths=[(H?"*/":"./")+q],B}function I(q){try{const Y=new RegExp(`^${w(q)}$`);return function(H){return Y.lastIndex=0,typeof H=="string"&&Y.test(H)?q:null}}catch{return i}}function O(q,Y,H){return!q||typeof Y!="string"?!1:A(q)(Y,void 0,H)}e.match=O;function A(q,Y={}){if(!q)return a;if(typeof q=="string"||M(q)){const H=t(q,Y);if(H===i)return a;const Z=function(K,F){return!!H(K,F)};return H.allBasenames&&(Z.allBasenames=H.allBasenames),H.allPaths&&(Z.allPaths=H.allPaths),Z}return x(q,Y)}e.parse=A;function N(q){if(!q)return;let Y;return H=>(Y||(Y=(q()||Promise.resolve([])).then(Z=>Z?D(Z):{})),Y.then(Z=>!!Z[H]))}e.hasSiblingPromiseFn=N;function $(q){if(!q)return;let Y;return H=>{if(!Y){const Z=q();Y=Z?D(Z):{}}return!!Y[H]}}e.hasSiblingFn=$;function D(q){const Y={};for(const H of q)Y[H]=!0;return Y}function M(q){const Y=q;return Y&&typeof Y.base=="string"&&typeof Y.pattern=="string"}e.isRelativePattern=M;function W(q){return q.allBasenames||[]}e.getBasenameTerms=W;function U(q){return q.allPaths||[]}e.getPathTerms=U;function x(q,Y){const H=G(Object.getOwnPropertyNames(q).map(B=>ee(B,q[B],Y)).filter(B=>B!==i)),Z=H.length;if(!Z)return i;if(!H.some(B=>!!B.requiresSiblings)){if(Z===1)return H[0];const B=function(te,se){for(let ce=0,he=H.length;ce<he;ce++){const me=H[ce](te,se);if(me)return me}return null},z=H.find(te=>!!te.allBasenames);z&&(B.allBasenames=z.allBasenames);const V=H.reduce((te,se)=>se.allPaths?te.concat(se.allPaths):te,[]);return V.length&&(B.allPaths=V),B}const K=function(B,z,V){let te;for(let se=0,ce=H.length;se<ce;se++){const he=H[se];he.requiresSiblings&&V&&(z||(z=_.basename(B)),te||(te=z.substr(0,z.length-_.extname(B).length)));const me=he(B,z,te,V);if(me)return me}return null},F=H.find(B=>!!B.allBasenames);F&&(K.allBasenames=F.allBasenames);const j=H.reduce((B,z)=>z.allPaths?B.concat(z.allPaths):B,[]);return j.length&&(K.allPaths=j),K}function ee(q,Y,H){if(Y===!1)return i;const Z=t(q,H);if(Z===i)return i;if(typeof Y=="boolean")return Z;if(Y){const K=Y.when;if(typeof K=="string"){const F=(j,B,z,V)=>{if(!V||!Z(j,B))return null;const te=K.replace("$(basename)",z),se=V(te);return(0,L.isThenable)(se)?se.then(ce=>ce?q:null):se?q:null};return F.requiresSiblings=!0,F}}return Z}function G(q,Y){const H=q.filter(B=>!!B.basenames);if(H.length<2)return q;const Z=H.reduce((B,z)=>{const V=z.basenames;return V?B.concat(V):B},[]);let K;if(Y){K=[];for(let B=0,z=Z.length;B<z;B++)K.push(Y)}else K=H.reduce((B,z)=>{const V=z.patterns;return V?B.concat(V):B},[]);const F=function(B,z){if(typeof B!="string")return null;if(!z){let te;for(te=B.length;te>0;te--){const se=B.charCodeAt(te-1);if(se===47||se===92)break}z=B.substr(te)}const V=Z.indexOf(z);return V!==-1?K[V]:null};F.basenames=Z,F.patterns=K,F.allBasenames=Z;const j=q.filter(B=>!B.basenames);return j.push(F),j}}),define(ne[110],ie([0,1,7]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(P){return P.toJSON()}class T{constructor(b){this._uriTransformer=b}transformIncoming(b){const f=this._uriTransformer.transformIncoming(b);return f===b?b:n(L.URI.from(f))}transformOutgoing(b){const f=this._uriTransformer.transformOutgoing(b);return f===b?b:n(L.URI.from(f))}transformOutgoingURI(b){const f=this._uriTransformer.transformOutgoing(b);return f===b?b:L.URI.from(f)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function _(P,b,f){if(!P||f>200)return null;if(typeof P=="object"){if(P instanceof L.URI)return b.transformOutgoing(P);for(let S in P)if(Object.hasOwnProperty.call(P,S)){const d=_(P[S],b,f+1);d!==null&&(P[S]=d)}}return null}function k(P,b){const f=_(P,b,0);return f===null?P:f}e.transformOutgoingURIs=k;function R(P,b,f,S){if(!P||S>200)return null;if(typeof P=="object"){if(P.$mid===1)return f?L.URI.revive(b.transformIncoming(P)):b.transformIncoming(P);for(let d in P)if(Object.hasOwnProperty.call(P,d)){const w=R(P[d],b,f,S+1);w!==null&&(P[d]=w)}}return null}function C(P,b){const f=R(P,b,!1,0);return f===null?P:f}e.transformIncomingURIs=C;function E(P,b){const f=R(P,b,!0,0);return f===null?P:f}e.transformAndReviveIncomingURIs=E}),define(ne[29],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(C){return L.test(C)}e.isUUID=n;const T=new Uint8Array(16),_=[];for(let C=0;C<256;C++)_.push(C.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(C){for(let E=0;E<C.length;E++)C[E]=Math.floor(Math.random()*256);return C};function R(){k(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let C=0,E="";return E+=_[T[C++]],E+=_[T[C++]],E+=_[T[C++]],E+=_[T[C++]],E+="-",E+=_[T[C++]],E+=_[T[C++]],E+="-",E+=_[T[C++]],E+=_[T[C++]],E+="-",E+=_[T[C++]],E+=_[T[C++]],E+="-",E+=_[T[C++]],E+=_[T[C++]],E+=_[T[C++]],E+=_[T[C++]],E+=_[T[C++]],E+=_[T[C++]],E}e.generateUuid=R}),define(ne[111],ie([0,1,247]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(_="utf8"){this.stringDecoder=new L.StringDecoder(_),this.remaining=null}write(_){const k=[],R=this.remaining?this.remaining+this.stringDecoder.write(_):this.stringDecoder.write(_);if(R.length<1)return k;let C=0,E,P=C;for(;P<R.length;)if(E=R.charCodeAt(P),E===13||E===10){if(k.push(R.substring(C,P)),P++,P<R.length){const b=E;E=R.charCodeAt(P),(b===13&&E===10||b===10&&E===13)&&P++}C=P}else P++;return this.remaining=C<R.length?R.substr(C):null,k}end(){return this.remaining}}e.LineDecoder=n}),define(ne[112],ie([0,1,32]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function T(k){const R=k.replace(/\-/g,":").toLowerCase();return!n.has(R)}function _(){const k=(0,L.networkInterfaces)();for(let R in k){const C=k[R];if(C){for(const{mac:E}of C)if(T(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=_}),define(ne[113],ie([0,1,32,8,39,29,112]),function(J,e,L,n,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=T.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,b=0;const f=(0,L.networkInterfaces)();for(let S in f){const d=f[S];if(d)for(const{mac:w,internal:p}of d)p||(b+=1,this._isVirtualMachineMacAddress(w.toUpperCase())&&(P+=1))}this._value=b>0?P/b:0}return this._value}};let R;async function C(){return R||(R=(async()=>await E()||_.generateUuid())()),R}e.getMachineId=C;async function E(){try{const P=await new Promise((f,S)=>{J(["crypto"],f,S)}),b=(0,k.getMac)();return P.createHash("sha256").update(b,"utf8").digest("hex")}catch(P){n.onUnexpectedError(P);return}}}),define(ne[22],ie([0,1,50,32,248,5,41,69,9,4,19,7]),function(J,e,L,n,T,_,k,R,C,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function S(M,W=f.UNLINK){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return W===f.UNLINK?w(M):d(M)}async function d(M){try{const W=(0,k.randomPath)((0,n.tmpdir)());try{await L.promises.rename(M,W)}catch{return w(M)}w(W).catch(U=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function w(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function p(M){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");L.rmdirSync(M,{recursive:!0})}e.rimrafSync=p;async function v(M,W){return l(await(W?y(M):(0,T.promisify)(L.readdir)(M)))}async function y(M){try{return await(0,T.promisify)(L.readdir)(M,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const W=[],U=await v(M);for(const x of U){let ee=!1,G=!1,q=!1;try{const Y=await e.Promises.lstat((0,C.join)(M,x));ee=Y.isFile(),G=Y.isDirectory(),q=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}W.push({name:x,isFile:()=>ee,isDirectory:()=>G,isSymbolicLink:()=>q})}return W}function g(M){return l(L.readdirSync(M))}e.readdirSync=g;function l(M){return M.map(W=>typeof W=="string"?E.isMacintosh?(0,R.normalizeNFC)(W):W:(W.name=E.isMacintosh?(0,R.normalizeNFC)(W.name):W.name,W))}async function u(M){const W=await v(M),U=[];for(const x of W)await a.existsDirectory((0,C.join)(M,x))&&U.push(x);return U}function r(M,W=1e3){return new Promise(U=>{let x=!1;const ee=setInterval(()=>{x||(x=!0,L.access(M,G=>{x=!1,G&&(clearInterval(ee),U(void 0))}))},W)})}e.whenDeleted=r;var a;(function(M){async function W(ee){let G;try{if(G=await e.Promises.lstat(ee),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(E.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw Y}throw q}}M.stat=W;async function U(ee){try{const{stat:G,symbolicLink:q}=await M.stat(ee);return G.isFile()&&q?.dangling!==!0}catch{}return!1}M.existsFile=U;async function x(ee){try{const{stat:G,symbolicLink:q}=await M.stat(ee);return G.isDirectory()&&q?.dangling!==!0}catch{}return!1}M.existsDirectory=x})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new _.ResourceQueue;function t(M,W,U){return i.queueFor(b.URI.file(M),P.extUriBiasedIgnorePathCase).queue(()=>{const x=h(U);return new Promise((ee,G)=>o(M,W,x,q=>q?G(q):ee()))})}let s=!0;function o(M,W,U,x){if(!s)return L.writeFile(M,W,{mode:U.mode,flag:U.flag},x);L.open(M,U.flag,U.mode,(ee,G)=>{if(ee)return x(ee);L.writeFile(G,W,q=>{if(q)return L.close(G,()=>x(q));L.fdatasync(G,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),s=!1),L.close(G,H=>x(H))))})})}function c(M,W,U){const x=h(U);if(!s)return L.writeFileSync(M,W,{mode:x.mode,flag:x.flag});const ee=L.openSync(M,x.flag,x.mode);try{L.writeFileSync(ee,W);try{L.fdatasyncSync(ee)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),s=!1}}finally{L.closeSync(ee)}}e.writeFileSync=c;function h(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function m(M,W){if(M===W)return;async function U(x){try{const ee=await e.Promises.lstat(x);if(ee.isDirectory()||ee.isSymbolicLink())return;await e.Promises.utimes(x,ee.atime,new Date)}catch{}}try{await e.Promises.rename(M,W),await U(W)}catch(x){if(M.toLowerCase()!==W.toLowerCase()&&x.code==="EXDEV"||M.endsWith("."))await I(M,W,{preserveSymlinks:!1}),await S(M,f.MOVE),await U(W);else throw x}}async function I(M,W,U){return A(M,W,{root:{source:M,target:W},options:U,handledSourcePaths:new Set})}const O=511;async function A(M,W,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:x,symbolicLink:ee}=await a.stat(M);if(ee){if(U.options.preserveSymlinks)try{return await D(M,W,U)}catch(G){console.warn("[node.js fs] copy of symlink failed: ",G)}if(ee.dangling)return}return x.isDirectory()?N(M,W,x.mode&O,U):$(M,W,x.mode&O)}async function N(M,W,U,x){await e.Promises.mkdir(W,{recursive:!0,mode:U});const ee=await v(M);for(const G of ee)await A((0,C.join)(M,G),(0,C.join)(W,G),x)}async function $(M,W,U){await e.Promises.copyFile(M,W),await e.Promises.chmod(W,U)}async function D(M,W,U){let x=await e.Promises.readlink(M);(0,k.isEqualOrParent)(x,U.root.source,!E.isLinux)&&(x=(0,C.join)(U.root.target,x.substr(U.root.source.length+1))),await e.Promises.symlink(x,W)}e.Promises=new class{get access(){return(0,T.promisify)(L.access)}get stat(){return(0,T.promisify)(L.stat)}get lstat(){return(0,T.promisify)(L.lstat)}get utimes(){return(0,T.promisify)(L.utimes)}get read(){return(0,T.promisify)(L.read)}get readFile(){return(0,T.promisify)(L.readFile)}get write(){return(0,T.promisify)(L.write)}get appendFile(){return(0,T.promisify)(L.appendFile)}get fdatasync(){return(0,T.promisify)(L.fdatasync)}get truncate(){return(0,T.promisify)(L.truncate)}get rename(){return(0,T.promisify)(L.rename)}get copyFile(){return(0,T.promisify)(L.copyFile)}get open(){return(0,T.promisify)(L.open)}get close(){return(0,T.promisify)(L.close)}get symlink(){return(0,T.promisify)(L.symlink)}get readlink(){return(0,T.promisify)(L.readlink)}get chmod(){return(0,T.promisify)(L.chmod)}get mkdir(){return(0,T.promisify)(L.mkdir)}get unlink(){return(0,T.promisify)(L.unlink)}get rmdir(){return(0,T.promisify)(L.rmdir)}get realpath(){return(0,T.promisify)(L.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return u}get writeFile(){return t}get rm(){return S}get move(){return m}get copy(){return I}}}),define(ne[114],ie([0,1,50,9,4,27,22]),function(J,e,L,n,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(f){if(T.isLinux)return f;const S=(0,n.dirname)(f);if(f===S)return f;const d=((0,n.basename)(f)||f).toLowerCase();try{const p=(0,k.readdirSync)(S).filter(v=>v.toLowerCase()===d);if(p.length===1){const v=R(S);if(v)return(0,n.join)(v,p[0])}else if(p.length>1){const v=p.indexOf(d);if(v>=0){const y=R(S);if(y)return(0,n.join)(y,p[v])}}}catch{}return null}e.realcaseSync=R;async function C(f){if(T.isLinux)return f;const S=(0,n.dirname)(f);if(f===S)return f;const d=((0,n.basename)(f)||f).toLowerCase();try{const p=(await k.Promises.readdir(S)).filter(v=>v.toLowerCase()===d);if(p.length===1){const v=await C(S);if(v)return(0,n.join)(v,p[0])}else if(p.length>1){const v=p.indexOf(d);if(v>=0){const y=await C(S);if(y)return(0,n.join)(y,p[v])}}}catch{}return null}e.realcase=C;async function E(f){try{return await k.Promises.realpath(f)}catch{const d=b(f);return await k.Promises.access(d,L.constants.R_OK),d}}e.realpath=E;function P(f){try{return L.realpathSync(f)}catch{const d=b(f);return L.accessSync(d,L.constants.R_OK),d}}e.realpathSync=P;function b(f){return(0,_.rtrim)((0,n.normalize)(f),n.sep)}}),define(ne[115],ie([0,1,55]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(R,C,E,P=1){let b=!1;return new Promise(f=>{const S=setTimeout(()=>{if(!b)return b=!0,f(0)},E);T(R,C,P,d=>{if(!b)return b=!0,clearTimeout(S),f(d)})})}e.findFreePort=n;function T(R,C,E,P){if(C===0)return P(0);const b=new L.Socket;b.once("connect",()=>(k(b),T(R+E,C-1,E,P))),b.once("data",()=>{}),b.once("error",f=>(k(b),f.code!=="ECONNREFUSED"?T(R+E,C-1,E,P):P(R))),b.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function _(R,C,E){let P=!1,b,f=1;const S=L.createServer({pauseOnConnect:!0});function d(w,p){P||(P=!0,S.removeAllListeners(),S.close(),b&&clearTimeout(b),p(w))}return new Promise(w=>{b=setTimeout(()=>{d(0,w)},E),S.on("listening",()=>{d(R,w)}),S.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&f<C?(R++,f++,S.listen(R,"127.0.0.1")):d(0,w)}),S.on("close",()=>{d(0,w)}),S.listen(R,"127.0.0.1")})}e.findFreePortFaster=_;function k(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(C){console.error(C)}}}),define(ne[70],ie([0,1,32,9,22]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const _=/^\d+$/,k=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var C;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(C||(C={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class b{constructor(u,r,a){this.exePath=u,this.displayName=r,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await T.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:l=!1}={}){return l?E===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:l=!1,findPreview:u=!1}={}){const r=f({useAlternateBitness:l});if(!r)return null;const a=n.join(r,"PowerShell");if(!await T.SymlinkSupport.existsDirectory(a))return null;let i=-1,t=null;for(const c of await T.Promises.readdir(a)){let h=-1;if(u){const I=c.indexOf("-");if(I<0)continue;const O=c.substring(0,I);if(!_.test(O)||c.substring(I+1)!=="preview")continue;h=parseInt(O,10)}else{if(!_.test(c))continue;h=parseInt(c,10)}if(h<=i)continue;const m=n.join(a,c,"pwsh.exe");!await T.SymlinkSupport.existsFile(m)||(t=m,i=h)}if(!t)return null;const s=r.includes("x86")?" (x86)":"",o=u?" Preview":"";return new b(t,`PowerShell${o}${s}`,!0)}async function d({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const u=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await T.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:r,pwshMsixName:a}=l?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const i of await T.Promises.readdir(u))if(r.test(i)){const t=n.join(u,i,"pwsh.exe");return new b(t,a)}return null}function w(){const l=n.join(L.homedir(),".dotnet","tools","pwsh.exe");return new b(l,".NET Core PowerShell Global Tool")}function p(){const l=n.join(process.env.windir,E===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(l,"Windows PowerShell",!0)}async function*v(){let l=await S();l&&(yield l),l=await S({useAlternateBitness:!0}),l&&(yield l),l=await d(),l&&(yield l),l=w(),l&&(yield l),l=await S({findPreview:!0}),l&&(yield l),l=await d({findPreview:!0}),l&&(yield l),l=await S({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=p(),l&&(yield l)}async function*y(){for await(const l of v())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=y;async function g(){for await(const l of y())return l;return null}e.getFirstAvailablePowerShellInstallation=g}),define(ne[116],ie([0,1,45,18]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function T(k){return new Promise((R,C)=>{let E;const P=new Map;function b(S,d,w,p,v){const y=P.get(d);if(S===k||y){const g={name:f(w),cmd:w,pid:S,ppid:d,load:p,mem:v};P.set(S,g),S===k&&(E=g),y&&(y.children||(y.children=[]),y.children.push(g),y.children.length>1&&(y.children=y.children.sort((l,u)=>l.pid-u.pid)))}}function f(S){const d=/--vscode-window-kind=shared-process/,w=/--vscode-window-kind=issue-reporter/,p=/--vscode-window-kind=process-explorer/,v=/--utility-sub-type=network/,y=/--crashes-directory/,g=/\\pipe\\winpty-control/,l=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(y.exec(S))return"electron-crash-reporter";if(g.exec(S))return"winpty-process";if(l.exec(S))return"console-window-host (Windows internal process)";let r=u.exec(S);if(r&&r.length===2)return r[1]==="renderer"?d.exec(S)?"shared-process":w.exec(S)?"issue-reporter":p.exec(S)?"process-explorer":"window":r[1]==="utility"&&v.exec(S)?"utility-network-service":r[1];const a=/[a-zA-Z-]+\.js/g;let i="";do r=a.exec(S),r&&(i+=r+" ");while(r);return i&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${i}`:S}if(process.platform==="win32"){const S=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,w)=>{J(["windows-process-tree"],d,w)}).then(d=>{d.getProcessList(k,w=>{d.getProcessCpuUsage(w,p=>{const v=new Map;p.forEach(y=>{const g=S(y.commandLine||"");v.set(y.pid,{name:f(g),cmd:g,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),E=v.get(k),E?(v.forEach(y=>{const g=v.get(y.ppid);g&&(g.children||(g.children=[]),g.children.push(y))}),v.forEach(y=>{y.children&&(y.children=y.children.sort((g,l)=>g.pid-l.pid))}),R(E)):C(new Error(`Root process ${k} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let S=function(){let d=[E];const w=[];for(;d.length;){const v=d.shift();v&&(w.push(v.pid),v.children&&(d=d.concat(v.children)))}let p=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);p+=" "+w.join(" "),(0,L.exec)(p,{},(v,y,g)=>{if(v||g)C(v||new Error(g.toString()));else{const l=y.toString().split(`
`);for(let u=0;u<w.length;u++){const r=P.get(w[u]);r.load=parseFloat(l[u])}if(!E){C(new Error(`Root process ${k} not found`));return}R(E)}})};(0,L.exec)("which ps",{},(d,w,p)=>{if(d||p)if(process.platform!=="linux")C(d||new Error(p.toString()));else{const v=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,L.exec)(v,{},(y,g,l)=>{y||l?C(y||new Error(l.toString())):(_(g,b),S())})}else{const v=w.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${v} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,l,u)=>{g||u&&!u.includes("screen size is bogus")?C(g||new Error(u.toString())):(_(l,b),process.platform==="linux"?S():E?R(E):C(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=T;function _(k,R){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=k.toString().split(`
`);for(const P of E){const b=C.exec(P.trim());b&&b.length===6&&R(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}});var de=this&&this.__decorate||function(J,e,L,n){var T=arguments.length,_=T<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,L):n,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(J,e,L,n);else for(var R=J.length-1;R>=0;R--)(k=J[R])&&(_=(T<3?k(_):T>3?k(e,L,_):k(e,L))||_);return T>3&&_&&Object.defineProperty(e,L,_),_};define(ne[36],ie([0,1,16,5,17,25,53,8,3,2,108,27,15]),function(J,e,L,n,T,_,k,R,C,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function d(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function p(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(v||(v={}));class y{constructor(q){this.buffer=q,this.pos=0}read(q){const Y=this.buffer.slice(this.pos,this.pos+q);return this.pos+=Y.byteLength,Y}}class g{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var l;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object"})(l||(l={}));function u(G){const q=T.VSBuffer.alloc(4);return q.writeUInt32BE(G,0),q}function r(G){return G.read(4).readUInt32BE(0)}function a(G){const q=T.VSBuffer.alloc(1);return q.writeUInt8(G,0),q}const i={Undefined:a(l.Undefined),String:a(l.String),Buffer:a(l.Buffer),VSBuffer:a(l.VSBuffer),Array:a(l.Array),Object:a(l.Object)},t=typeof Buffer!="undefined";function s(G,q){if(typeof q=="undefined")G.write(i.Undefined);else if(typeof q=="string"){const Y=T.VSBuffer.fromString(q);G.write(i.String),G.write(u(Y.byteLength)),G.write(Y)}else if(t&&Buffer.isBuffer(q)){const Y=T.VSBuffer.wrap(q);G.write(i.Buffer),G.write(u(Y.byteLength)),G.write(Y)}else if(q instanceof T.VSBuffer)G.write(i.VSBuffer),G.write(u(q.byteLength)),G.write(q);else if(Array.isArray(q)){G.write(i.Array),G.write(u(q.length));for(const Y of q)s(G,Y)}else{const Y=T.VSBuffer.fromString(JSON.stringify(q));G.write(i.Object),G.write(u(Y.byteLength)),G.write(Y)}}function o(G){switch(G.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return G.read(r(G)).toString();case l.Buffer:return G.read(r(G)).buffer;case l.VSBuffer:return G.read(r(G));case l.Array:{const Y=r(G),H=[];for(let Z=0;Z<Y;Z++)H.push(o(G));return H}case l.Object:return JSON.parse(G.read(r(G)).toString())}}class c{constructor(q,Y,H=null,Z=1e3){this.protocol=q,this.ctx=Y,this.logger=H,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(q,Y){this.channels.set(q,Y),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const Y=this.send([q.type]);this.logger&&this.logger.logOutgoing(Y,0,1,p(q.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([q.type,q.id],q.data);this.logger&&this.logger.logOutgoing(Y,q.id,1,p(q.type),q.data);return}}}send(q,Y=void 0){const H=new g;return s(H,q),s(H,Y),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const Y=new y(q),H=o(Y),Z=o(Y),K=H[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${d(K)}: ${H[2]}.${H[3]}`,Z),this.onPromise({type:K,id:H[1],channelName:H[2],name:H[3],arg:Z});case 102:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${d(K)}: ${H[2]}.${H[3]}`,Z),this.onEventListen({type:K,id:H[1],channelName:H[2],name:H[3],arg:Z});case 101:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${d(K)}`),this.disposeActiveRequest({type:K,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${d(K)}`),this.disposeActiveRequest({type:K,id:H[1]})}}onPromise(q){const Y=this.channels.get(q.channelName);if(!Y){this.collectPendingRequest(q);return}const H=new _.CancellationTokenSource;let Z;try{Z=Y.call(this.ctx,q.name,q.arg,H.token)}catch(j){Z=Promise.reject(j)}const K=q.id;Z.then(j=>{this.sendResponse({id:K,data:j,type:201}),this.activeRequests.delete(q.id)},j=>{j instanceof Error?this.sendResponse({id:K,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:K,data:j,type:203}),this.activeRequests.delete(q.id)});const F=(0,E.toDisposable)(()=>H.cancel());this.activeRequests.set(q.id,F)}onEventListen(q){const Y=this.channels.get(q.channelName);if(!Y){this.collectPendingRequest(q);return}const H=q.id,K=Y.listen(this.ctx,q.name,q.arg)(F=>this.sendResponse({id:H,data:F,type:204}));this.activeRequests.set(q.id,K)}disposeActiveRequest(q){const Y=this.activeRequests.get(q.id);Y&&(Y.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let Y=this.pendingRequests.get(q.channelName);Y||(Y=[],this.pendingRequests.set(q.channelName,Y));const H=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:q,timeoutTimer:H})}flushPendingRequests(q){const Y=this.pendingRequests.get(q);if(Y){for(const H of Y)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var h;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor(q,Y=null){this.protocol=q,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=Y}getChannel(q){const Y=this;return{call(H,Z,K){return Y.isDisposed?Promise.reject(R.canceled()):Y.requestPromise(q,H,Z,K)},listen(H,Z){return Y.isDisposed?Promise.reject(R.canceled()):Y.requestEvent(q,H,Z)}}}requestPromise(q,Y,H,Z=_.CancellationToken.None){const K=this.lastRequestId++,j={id:K,type:100,channelName:q,name:Y,arg:H};if(Z.isCancellationRequested)return Promise.reject(R.canceled());let B;return new Promise((V,te)=>{if(Z.isCancellationRequested)return te(R.canceled());const se=()=>{const ve=ge=>{switch(ge.type){case 201:this.handlers.delete(K),V(ge.data);break;case 202:{this.handlers.delete(K);const ye=new Error(ge.data.message);ye.stack=ge.data.stack,ye.name=ge.data.name,te(ye);break}case 203:this.handlers.delete(K),te(ge.data);break}};this.handlers.set(K,ve),this.sendRequest(j)};let ce=null;this.state===v.Idle?se():(ce=(0,n.createCancelablePromise)(ve=>this.whenInitialized()),ce.then(()=>{ce=null,se()}));const he=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:K,type:101}),te(R.canceled())},me=Z.onCancellationRequested(he);B=(0,E.combinedDisposable)((0,E.toDisposable)(he),me),this.activeRequests.add(B)}).finally(()=>{this.activeRequests.delete(B)})}requestEvent(q,Y,H){const Z=this.lastRequestId++,F={id:Z,type:102,channelName:q,name:Y,arg:H};let j=null;const B=new C.Emitter({onFirstListenerAdd:()=>{j=(0,n.createCancelablePromise)(V=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add(B),this.sendRequest(F)})},onLastListenerRemove:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete(B),this.sendRequest({id:Z,type:103}))}}),z=V=>B.fire(V.data);return this.handlers.set(Z,z),B.event}sendRequest(q){switch(q.type){case 100:case 102:{const Y=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(Y,q.id,0,`${d(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Y=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(Y,q.id,0,d(q.type));return}}}send(q,Y=void 0){const H=new g;return s(H,q),s(H,Y),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const Y=new y(q),H=o(Y),Z=o(Y),K=H[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,p(K)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],0,p(K),Z),this.onResponse({type:H[0],id:H[1],data:Z})}}onResponse(q){if(q.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(q.id);Y&&Y(q)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}de([k.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class I{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:Y,onDidClientDisconnect:H})=>{C.Event.once(Y.onMessage)(K=>{const F=new y(K),j=o(F),B=new c(Y,j),z=new m(Y);this.channels.forEach((te,se)=>B.registerChannel(se,te));const V={channelServer:B,channelClient:z,ctx:j};this._connections.add(V),this._onDidAddConnection.fire(V),H(()=>{B.dispose(),z.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const q=[];return this._connections.forEach(Y=>q.push(Y)),q}getChannel(q,Y){const H=this;return{call(Z,K,F){let j;if((0,f.isFunction)(Y)){let z=(0,L.getRandomElement)(H.connections.filter(Y));j=z?Promise.resolve(z):C.Event.toPromise(C.Event.filter(H.onDidAddConnection,Y))}else j=Y.routeCall(H,Z,K);const B=j.then(z=>z.channelClient.getChannel(q));return A(B).call(Z,K,F)},listen(Z,K){if((0,f.isFunction)(Y))return H.getMulticastEvent(q,Y,Z,K);const F=Y.routeEvent(H,Z,K).then(j=>j.channelClient.getChannel(q));return A(F).listen(Z,K)}}}getMulticastEvent(q,Y,H,Z){const K=this;let F=new E.DisposableStore;const j=new C.Emitter({onFirstListenerAdd:()=>{F=new E.DisposableStore;const B=new C.EventMultiplexer,z=new Map,V=se=>{const he=se.channelClient.getChannel(q).listen(H,Z),me=B.add(he);z.set(se,me)},te=se=>{const ce=z.get(se);!ce||(ce.dispose(),z.delete(se))};K.connections.filter(Y).forEach(V),C.Event.filter(K.onDidAddConnection,Y)(V,void 0,F),K.onDidRemoveConnection(te,void 0,F),B.event(j.fire,j,F),F.add(B)},onLastListenerRemove:()=>{F.dispose()}});return j.event}registerChannel(q,Y){this.channels.set(q,Y),this._connections.forEach(H=>{H.channelServer.registerChannel(q,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class O{constructor(q,Y,H=null){const Z=new g;s(Z,Y),q.send(Z.buffer),this.channelClient=new m(q,H),this.channelServer=new c(q,Y,H)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,Y){this.channelServer.registerChannel(q,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function A(G){return{call(q,Y,H){return G.then(Z=>Z.call(q,Y,H))},listen(q,Y){const H=new C.Relay;return G.then(Z=>H.input=Z.listen(q,Y)),H.event}}}e.getDelayedChannel=A;function N(G){let q=!1;return{call(Y,H,Z){return q?G.call(Y,H,Z):(0,n.timeout)(0).then(()=>q=!0).then(()=>G.call(Y,H,Z))},listen(Y,H){if(q)return G.listen(Y,H);const Z=new C.Relay;return(0,n.timeout)(0).then(()=>q=!0).then(()=>Z.input=G.listen(Y,H)),Z.event}}}e.getNextTickChannel=N;class ${constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const Y of q.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await C.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=$;var D;(function(G){function q(K,F){const j=K,B=F&&F.disableMarshalling,z=new Map;for(const V in j)H(V)&&z.set(V,C.Event.buffer(j[V],!0));return new class{listen(V,te,se){const ce=z.get(te);if(ce)return ce;if(Z(te)){const he=j[te];if(typeof he=="function")return he.call(j,se)}throw new Error(`Event not found: ${te}`)}call(V,te,se){const ce=j[te];if(typeof ce=="function"){if(!B&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,P.revive)(se[he]);return ce.apply(j,se)}throw new Error(`Method not found: ${te}`)}}}G.fromService=q;function Y(K,F){const j=F&&F.disableMarshalling;return new Proxy({},{get(B,z){if(typeof z=="string")return F?.properties?.has(z)?F.properties.get(z):Z(z)?function(V){return K.listen(z,V)}:H(z)?K.listen(z):async function(...V){let te;F&&!(0,f.isUndefinedOrNull)(F.context)?te=[F.context,...V]:te=V;const se=await K.call(z,te);return j?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String(z)}`)}})}G.toService=Y;function H(K){return K[0]==="o"&&K[1]==="n"&&b.isUpperAsciiLetter(K.charCodeAt(2))}function Z(K){return/^onDynamic/.test(K)&&b.isUpperAsciiLetter(K.charCodeAt(9))}})(D=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){let q=G.toString();if(q!=="[object Object]")return q}return G}function U(G){return Array.isArray(G)?G.map(W):W(G)}function x(G,q,Y,H,Z,K,F){F=U(F);const j=M[Z],B=j[H%j.length];let z=[`%c[${G}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(K)?(z=z.concat(F),z.push(")")):z.push(F),console.log.apply(console,z)}e.logWithColors=x;class ee{constructor(q,Y){this._outgoingPrefix=q,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,Y,H,Z,K){this._totalOutgoing+=q,x(this._outgoingPrefix,this._totalOutgoing,q,Y,H,Z,K)}logIncoming(q,Y,H,Z,K){this._totalIncoming+=q,x(this._incomingPrefix,this._totalIncoming,q,Y,H,Z,K)}}e.IPCLogger=ee}),define(ne[117],ie([0,1,17,3,36]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class _{constructor(C){this.port=C,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",E=>L.VSBuffer.wrap(E.data)),C.start()}send(C){this.port.postMessage(C.buffer)}disconnect(){this.port.close()}}e.Protocol=_;class k extends T.IPCClient{constructor(C,E){const P=new _(C);super(P,E);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=k}),define(ne[71],ie([0,1,17,3,2,36]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let o=0;function c(m,I){if(!s.has(m)){const O=String(++o);s.set(m,O)}return s.get(m)}function h(m,I,O,A){if(!t.enableDiagnostics)return;const N=c(m,I);if(A instanceof L.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const $=L.VSBuffer.alloc(A.byteLength);$.set(A),t.records.push({timestamp:Date.now(),id:N,label:I,type:O,buff:$})}else t.records.push({timestamp:Date.now(),id:N,label:I,type:O,data:A})}t.traceSocketEvent=h})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function P(){return E||(E=L.VSBuffer.alloc(0)),E}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const I=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),I}if(this._chunks[0].byteLength>s){const I=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),I}let c=L.VSBuffer.alloc(s),h=0,m=0;for(;s>0;){const I=this._chunks[m];if(I.byteLength>s){const O=I.slice(0,s);c.set(O,h),h+=s,o&&(this._chunks[m]=I.slice(s),this._totalLength-=s),s-=s}else c.set(I,h),h+=I.byteLength,o?(this._chunks.shift(),this._totalLength-=I.byteLength):m++,s-=I.byteLength}return c}}e.ChunkStream=b;var f;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(f||(f={}));function S(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class w{constructor(s,o,c,h){this.type=s,this.id=o,this.ack=c,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends T.Disposable{constructor(s){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,h=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new w(c,h,m,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=L.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const c=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,c}_bufferTake(){const s=L.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class y extends T.Disposable{constructor(s){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new w(1,0,0,s))}}e.Protocol=y;class g extends _.IPCClient{constructor(s,o,c=null){super(s,o,c);this.protocol=s}static fromSocket(s,o){return new g(new y(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=g;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class u{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,c=this._first;for(;c;)s[o++]=c.data,c=c.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new u(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const s=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let c=0;for(let h=0;h<a._HISTORY_LENGTH;h++)s-this.lastRuns[h]<=o&&c++;return 1-c/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class i{constructor(s,o=null,c=a.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new w(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new w(7,0,0,P());this._socketWriter.write(s)}sendResume(){const s=new w(8,0,0,P());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new w(3,0,this._incomingAckId,P());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let c=0,h=o.length;c<h;c++)this._socketWriter.write(o[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new w(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let c=0,h=o.length;c<h;c++)this._socketWriter.write(o[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new w(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(s){const o=new w(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,c=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&c>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const m=Math.max(2e4-o,2e4-c,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},m)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new w(3,0,this._incomingAckId,P());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(ne[118],ie([0,1,72,3,36,117]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends T.IPCServer{static getOnDidClientConnect(){const C=n.Event.fromNodeEventEmitter(L.ipcRenderer,"vscode:createMessageChannel",(E,P)=>P);return n.Event.map(C,E=>{const{port1:P,port2:b}=new MessageChannel,S={protocol:new _.Protocol(P),onDidClientDisconnect:n.Event.fromDOMEventEmitter(P,"close")};return L.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[b]),S})}constructor(){super(k.getOnDidClientConnect())}}e.Server=k}),define(ne[119],ie([0,1,17,8]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(R,C){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((P,b)=>{E.open(R.type||"GET",R.url||"",!0,R.user,R.password),_(E,R),E.responseType="arraybuffer",E.onerror=f=>b(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=f=>{P({res:{statusCode:E.status,headers:k(E)},stream:(0,L.bufferToStream)(L.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=f=>b(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(E.timeout=R.timeout),E.send(R.data),C.onCancellationRequested(()=>{E.abort(),b((0,n.canceled)())})})}e.request=T;function _(R,C){if(C.headers){e:for(let E in C.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(E,C.headers[E])}}}function k(R){const C=Object.create(null);for(const E of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const P=E.indexOf(":");C[E.substr(0,P).trim().toLowerCase()]=E.substr(P+1).trim()}return C}}),define(ne[73],ie([0,1,5,3,2,15]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function R(b){const f=b;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var C;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(C||(C={}));class E extends T.Disposable{constructor(f,S=Object.create(null)){super();this.database=f,this.options=S,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((S,d)=>this.accept(d,S)),f.deleted?.forEach(S=>this.accept(S,void 0))}accept(f,S){if(this.state===C.Closed)return;let d=!1;(0,_.isUndefinedOrNull)(S)?d=this.cache.delete(f):this.cache.get(f)!==S&&(this.cache.set(f,S),d=!0),d&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,S){const d=this.cache.get(f);return(0,_.isUndefinedOrNull)(d)?S:d}getBoolean(f,S){const d=this.get(f);return(0,_.isUndefinedOrNull)(d)?S:d==="true"}getNumber(f,S){const d=this.get(f);return(0,_.isUndefinedOrNull)(d)?S:parseInt(d,10)}async set(f,S){if(this.state===C.Closed)return;if((0,_.isUndefinedOrNull)(S))return this.delete(f);const d=String(S);if(this.cache.get(f)!==d)return this.cache.set(f,d),this.pendingInserts.set(f,d),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===C.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((S,d)=>this.items.set(d,S)),f.delete&&f.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=P}),define(ne[120],ie([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[56],ie([0,1,120]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,T=n*60,_=T*24,k=_*7,R=_*30,C=_*365;function E(b,f){typeof b!="number"&&(b=b.getTime());const S=Math.round((new Date().getTime()-b)/1e3);if(S<-30)return(0,L.localize)(0,null,E(new Date().getTime()+S*1e3,!1));if(S<30)return(0,L.localize)(1,null);let d;return S<n?(d=S,f?d===1?(0,L.localize)(2,null,d):(0,L.localize)(3,null,d):d===1?(0,L.localize)(4,null,d):(0,L.localize)(5,null,d)):S<T?(d=Math.floor(S/n),f?d===1?(0,L.localize)(6,null,d):(0,L.localize)(7,null,d):d===1?(0,L.localize)(8,null,d):(0,L.localize)(9,null,d)):S<_?(d=Math.floor(S/T),f?d===1?(0,L.localize)(10,null,d):(0,L.localize)(11,null,d):d===1?(0,L.localize)(12,null,d):(0,L.localize)(13,null,d)):S<k?(d=Math.floor(S/_),f?d===1?(0,L.localize)(14,null,d):(0,L.localize)(15,null,d):d===1?(0,L.localize)(16,null,d):(0,L.localize)(17,null,d)):S<R?(d=Math.floor(S/k),f?d===1?(0,L.localize)(18,null,d):(0,L.localize)(19,null,d):d===1?(0,L.localize)(20,null,d):(0,L.localize)(21,null,d)):S<C?(d=Math.floor(S/R),f?d===1?(0,L.localize)(22,null,d):(0,L.localize)(23,null,d):d===1?(0,L.localize)(24,null,d):(0,L.localize)(25,null,d)):(d=Math.floor(S/C),f?d===1?(0,L.localize)(26,null,d):(0,L.localize)(27,null,d):d===1?(0,L.localize)(28,null,d):(0,L.localize)(29,null,d))}e.fromNow=E;function P(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ne[121],ie([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[37],ie([0,1,16,15,121]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(E,P){return P&&(E.stack||E.stacktrace)?T.localize(0,null,R(E),k(E.stack)||k(E.stacktrace)):R(E)}function k(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?T.localize(1,null,E.message):E.message||T.localize(2,null)}function C(E=null,P=!1){if(!E)return T.localize(3,null);if(Array.isArray(E)){const b=L.coalesce(E),f=C(b[0],P);return b.length>1?T.localize(4,null,f,b.length):f}if(n.isString(E))return E;if(E.detail){const b=E.detail;if(b.error)return _(b.error,P);if(b.exception)return _(b.exception,P)}return E.stack?_(E,P):E.message?E.message:T.localize(5,null)}e.toErrorMessage=C}),define(ne[122],ie([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(ne[74],ie([0,1,45,41,18,28,9,4,31,102,15,111,22,122]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function d(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(r,a){if(R.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};a&&(i.cwd=a);const t=L.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(s=>{t.once("error",o=>{s({success:!1,error:o})}),t.once("exit",(o,c)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?d(i.status):1})}else if(R.isLinux||R.isMacintosh)try{const i=T.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{L.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,o,c)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function p(r){!r||(delete r.DEBUG,R.isMacintosh&&delete r.DYLD_LIBRARY_PATH,R.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=p;function v(r=C.env){return r.comspec||"cmd.exe"}e.getWindowsShell=v;class y{constructor(a,i,t,s){if(i!==void 0&&t!==void 0&&s!==void 0)this.cmd=a,this.args=i,this.shell=t,this.options=s;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(C.env).forEach(c=>{o[c]=C.env[c]}),Object.keys(this.options.env).forEach(c=>{o[c]=this.options.env[c]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const i=a.lastIndexOf(k.sep);return i!==-1&&(a=a.substring(i+1)),y.WellKnowCommands[a]?a:"other"}start(a){return R.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(C.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(i=>{let t,s;const o=new Promise((c,h)=>{t=c,s=h});if(i){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=L.exec(c,this.options,(h,m,I)=>{this.childProcess=null;const O=h;O&&O.killed?s({killed:this.terminateRequested,stdout:m.toString(),stderr:I.toString()}):this.handleExec(t,a,h,m,I)})}else{let c=null;const h=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,t,a,s);const I={terminated:this.terminateRequested};P.isNumber(m)&&(I.cmdCode=m),t(I)};if(this.shell&&R.isWindows){const m=_.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let I=!1,O=!1;const A=[];let N=this.ensureQuotes(this.cmd);A.push(N.value),I=N.quoted,this.args&&this.args.forEach(D=>{N=this.ensureQuotes(D),A.push(N.value),O=O&&N.quoted});const $=["/s","/c"];I?O?$.push('"'+A.join(" ")+'"'):A.length>1?$.push('"'+A[0]+'" '+A.slice(1).join(" ")):$.push('"'+A[0]+'"'):$.push(A.join(" ")),c=L.spawn(v(),$,m)}else this.cmd&&(c=L.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(P.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",m=>{this.childProcess=null,s({terminated:this.terminateRequested,error:m})}),c.pid&&(this.childProcess.on("close",h),this.handleSpawn(c,t,a,s,!0)))}return o})}handleClose(a,i,t,s){}ensureQuotes(a){return y.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,w(a,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!R.isWindows)return a(!1);const i=L.spawn(v(),["/s","/c"]);i.on("error",t=>a(!0)),i.on("exit",t=>a(!1))})}}e.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class g extends y{constructor(a,i,t,s){super(a,i,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,i,t,s,o){[s,o].forEach((c,h)=>{const m=new b.LineDecoder;m.write(c).forEach(A=>{i({line:A,source:h===0?0:1})});const O=m.end();O&&i({line:O,source:h===0?0:1})}),a({terminated:this.terminateRequested,error:t})}handleSpawn(a,i,t,s,o){const c=new b.LineDecoder,h=new b.LineDecoder;a.stdout.on("data",m=>{c.write(m).forEach(O=>t({line:O,source:0}))}),a.stderr.on("data",m=>{h.write(m).forEach(O=>t({line:O,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=h}handleClose(a,i,t,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=g;function l(r){let a=[],i=!1;const t=function(s){if(i){a.push(s);return}(!r.send(s,c=>{if(c&&console.error(c),i=!1,a.length>0){const h=a.slice(0);a=[],h.forEach(m=>t(m))}})||R.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=l;var u;(function(r){async function a(i,t,s){if(k.isAbsolute(i))return i;if(t===void 0&&(t=C.cwd()),k.dirname(i)!=="."||(s===void 0&&P.isString(C.env.PATH)&&(s=C.env.PATH.split(k.delimiter)),s===void 0||s.length===0))return k.join(t,i);async function c(h){if(await f.Promises.exists(h)){let m;try{m=await f.Promises.stat(h)}catch(I){I.message.startsWith("EACCES")&&(m=await f.Promises.lstat(h))}return m?!m.isDirectory():!1}return!1}for(let h of s){let m;if(k.isAbsolute(h)?m=k.join(h,i):m=k.join(t,h,i),await c(m))return m;let I=m+".com";if(await c(I)||(I=m+".exe",await c(I)))return I}return k.join(t,i)}r.findExecutable=a})(u=e.win32||(e.win32={}))}),define(ne[123],ie([0,1,32,4,70,74]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(S,d){return S===1?n.isWindows?b():_.getWindowsShell(d):E(S,d)}e.getSystemShell=k;function R(S,d){return S===1?n.isWindows?f(d):_.getWindowsShell(d):E(S,d)}e.getSystemShellSync=R;let C=null;function E(S,d){if(n.isLinux&&S===2||n.isMacintosh&&S===3)return"/bin/bash";if(!C){let w;if(n.isWindows)w="/bin/bash";else{if(w=d.SHELL,!w)try{w=(0,L.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}C=w}return C}let P=null;async function b(){return P||(P=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),P}function f(S){if(P)return P;const d=n.isWindows&&parseFloat((0,L.release)())>=10,w=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${S.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?p:_.getWindowsShell(S)}}),define(ne[57],ie([0,1,45,5,17,25,107,8,3,2,28,74,36]),function(J,e,L,n,T,_,k,R,C,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends f.ChannelServer{constructor(p){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",v=>T.VSBuffer.wrap(Buffer.from(v,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=S;class d{constructor(p,v){this.modulePath=p,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new C.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new n.Delayer(y),this.child=null,this._client=null}getChannel(p){const v=this;return{call(y,g,l){return v.requestPromise(p,y,g,l)},listen(y,g){return v.requestEvent(p,y,g)}}}requestPromise(p,v,y,g=_.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(p),u=(0,n.createCancelablePromise)(i=>l.call(v,y,i)),r=g.onCancellationRequested(()=>u.cancel()),a=(0,E.toDisposable)(()=>u.cancel());return this.activeRequests.add(a),u.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(p,v,y){if(!this.disposeDelayer)return C.Event.None;this.disposeDelayer.cancel();let g;const l=new C.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(p).listen(v,y)(l.fire,l),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,b.removeDangerousEnvVariables)(v.env),this.child=(0,L.fork)(this.modulePath,p,v);const y=new C.Emitter;C.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,k.isRemoteConsoleLog)(t)){(0,k.log)(t,`IPC Library: ${this.options.serverName}`);return}y.fire(T.VSBuffer.wrap(Buffer.from(t,"base64")))});const l=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,u=t=>this.child&&this.child.connected&&l.send(t.buffer.toString("base64")),r=y.event,a={send:u,onMessage:r};this._client=new f.ChannelClient(a);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",i),this.activeRequests.forEach(o=>(0,E.dispose)(o)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(p){let v=this.channels.get(p);return v||(v=this.client.getChannel(p),this.channels.set(p,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=d}),define(ne[124],ie([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[125],ie([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[126],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ne[127],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ne[128],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(ne[129],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[130],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[131],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[132],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[133],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[134],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ne[135],ie([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[136],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[137],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ne[138],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[139],ie([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[140],ie([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[141],ie([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[142],ie([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[143],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[144],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[145],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[146],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[147],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[148],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[149],ie([0,1,4]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var n;(function(k){k.Team="team",k.Internal="internal",k.Insiders="insider",k.Public="public"})(n=e.TargetPopulation||(e.TargetPopulation={}));var T;(function(k){k.Market="X-MSEdge-Market",k.CorpNet="X-FD-Corpnet",k.ApplicationVersion="X-VSCode-AppVersion",k.Build="X-VSCode-Build",k.ClientId="X-MSEdge-ClientId",k.ExtensionName="X-VSCode-ExtensionName",k.Language="X-VSCode-Language",k.TargetPopulation="X-VSCode-TargetPopulation"})(T=e.Filters||(e.Filters={}));class _{constructor(R,C,E,P){this.version=R,this.appName=C,this.machineId=E,this.targetPopulation=P}getFilterValue(R){switch(R){case T.ApplicationVersion:return this.version;case T.Build:return this.appName;case T.ClientId:return this.machineId;case T.Language:return L.language;case T.ExtensionName:return"vscode-core";case T.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,C=Object.values(T);for(let E of C)R.set(E,this.getFilterValue(E));return R}}e.AssignmentFilterProvider=_}),define(ne[75],ie([0,1,56,53,18,9,31,19,7]),function(J,e,L,n,T,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(w,p,v){this._args=w,this.paths=p,this.productService=v}get appRoot(){return(0,_.dirname)(T.FileAccess.asFileUri("",J).fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file((0,_.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const w=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,_.join)(this.userDataPath,"logs",w)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,_.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(C.URI.file((0,_.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return C.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return C.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=k.env.VSCODE_PORTABLE;return w?C.URI.file((0,_.join)(w,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,_.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,_.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,_.resolve)(w):(0,_.normalize)((0,_.join)(T.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const w=this.args["extensions-download-dir"];return w?(0,_.resolve)(w):(0,_.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,_.resolve)(w);const p=k.env.VSCODE_EXTENSIONS;if(p)return p;const v=k.env.VSCODE_PORTABLE;return v?(0,_.join)(v,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(p=>/^[^:/?#]+?:\/\//.test(p)?C.URI.parse(p):C.URI.file((0,_.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?C.URI.parse(w):C.URI.file((0,_.normalize)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return C.URI.file((0,_.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],E.prototype,"appRoot",null),de([n.memoize],E.prototype,"userHome",null),de([n.memoize],E.prototype,"userDataPath",null),de([n.memoize],E.prototype,"appSettingsHome",null),de([n.memoize],E.prototype,"tmpDir",null),de([n.memoize],E.prototype,"cacheHome",null),de([n.memoize],E.prototype,"userRoamingDataHome",null),de([n.memoize],E.prototype,"settingsResource",null),de([n.memoize],E.prototype,"userDataSyncHome",null),de([n.memoize],E.prototype,"userDataSyncLogResource",null),de([n.memoize],E.prototype,"sync",null),de([n.memoize],E.prototype,"machineSettingsResource",null),de([n.memoize],E.prototype,"globalStorageHome",null),de([n.memoize],E.prototype,"workspaceStorageHome",null),de([n.memoize],E.prototype,"keybindingsResource",null),de([n.memoize],E.prototype,"keyboardLayoutResource",null),de([n.memoize],E.prototype,"argvResource",null),de([n.memoize],E.prototype,"snippetsHome",null),de([n.memoize],E.prototype,"isExtensionDevelopment",null),de([n.memoize],E.prototype,"untitledWorkspacesHome",null),de([n.memoize],E.prototype,"installSourcePath",null),de([n.memoize],E.prototype,"builtinExtensionsPath",null),de([n.memoize],E.prototype,"extensionsPath",null),de([n.memoize],E.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],E.prototype,"extensionDevelopmentKind",null),de([n.memoize],E.prototype,"extensionTestsLocationURI",null),de([n.memoize],E.prototype,"debugExtensionHost",null),de([n.memoize],E.prototype,"serviceMachineIdResource",null),de([n.memoize],E.prototype,"telemetryLogResource",null),de([n.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function P(d,w){return S(d["inspect-extensions"],d["inspect-brk-extensions"],5870,w,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=P;function b(d,w){return S(d["inspect-search"],d["inspect-brk-search"],5876,w,d.extensionEnvironment)}e.parseSearchPort=b;function f(d,w){return S(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,w,d.extensionEnvironment)}e.parsePtyHostPort=f;function S(d,w,p,v,y,g){const u=Number(w||d)||(v?null:p),r=u?Boolean(!!w):!1;let a;if(g)try{a=JSON.parse(g)}catch{}return{port:u,break:r,debugId:y,env:a}}}),define(ne[150],ie([0,1,249,4,126]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const _={o:(0,T.localize)(0,null),e:(0,T.localize)(1,null),t:(0,T.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,T.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,T.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,T.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,T.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,T.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,T.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,T.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,T.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,T.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,T.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,T.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,T.localize)(14,null)},category:{type:"string",cat:"e",description:(0,T.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,T.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,T.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,T.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,T.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,T.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,T.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,T.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,T.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,T.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,T.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,T.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,T.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,T.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,T.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,T.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,T.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,T.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(d,w,p=k){const v={},y=[],g=[];for(let a in w){const i=w[a];i.alias&&(v[a]=i.alias),i.type==="string"||i.type==="string[]"?(y.push(a),i.deprecates&&y.push(i.deprecates)):i.type==="boolean"&&(g.push(a),i.deprecates&&g.push(i.deprecates))}const l=L(d,{string:y,boolean:g,alias:v}),u={},r=l;u._=l._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(let a in w){const i=w[a];i.alias&&delete r[i.alias];let t=r[a];i.deprecates&&r.hasOwnProperty(i.deprecates)&&(t||(t=r[i.deprecates],t&&p.onDeprecatedOption(i.deprecates,a)),delete r[i.deprecates]),typeof t!="undefined"&&(i.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):i.type==="string"&&Array.isArray(t)&&(t=t.pop(),p.onMultipleValues(a,t)),u[a]=t),delete r[a]}for(let a in r)p.onUnknownOption(a);return u}e.parseArgs=R;function C(d,w){let p="";return w.args&&(Array.isArray(w.args)?p=` <${w.args.join("> <")}>`:p=` <${w.args}>`),w.alias?`-${w.alias} --${d}${p}`:`--${d}${p}`}function E(d,w){let p=0,v=[];for(const u in d){const r=d[u],a=C(u,r);p=Math.max(p,a.length),v.push([a,r.description])}let y=p+2+1;if(w-y<25)return v.reduce((u,r)=>u.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let g=w-y-1,l=[];for(const u of v){let r=u[0],a=b(u[1],g),i=P(y-r.length-2);l.push("  "+r+i+a[0]);for(let t=1;t<a.length;t++)l.push(P(y)+a[t])}return l}e.formatOptions=E;function P(d){return" ".repeat(d)}function b(d,w){let p=[];for(;d.length;){let v=d.length<w?d.length:d.lastIndexOf(" ",w),y=d.slice(0,v).trim();d=d.slice(v),p.push(y)}return p}function f(d,w,p,v,y){const g=process.stdout.isTTY&&process.stdout.columns||80,l=y?.noInputFiles!==!0?`[${(0,T.localize)(33,null)}...]`:"",u=[`${d} ${p}`];u.push(""),u.push(`${(0,T.localize)(34,null)}: ${w} [${(0,T.localize)(35,null)}]${l}`),u.push(""),y?.noPipe!==!0&&(n.isWindows?u.push((0,T.localize)(36,null,w)):u.push((0,T.localize)(37,null,w)),u.push(""));const r={};for(const a in v){const i=v[a];if(i.description&&i.cat){let t=r[i.cat];t||(r[i.cat]=t={}),t[a]=i}}for(let a in r){const i=a;let t=r[i];t&&(u.push(_[i]),u.push(...E(t,g)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=f;function S(d,w){return`${d||(0,T.localize)(38,null)}
${w||(0,T.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=S}),function(){"use strict";function J(e,L,n,T){function _(R){const C=k(R),E=[C];return e.isAbsolute(C)||E.unshift(T),e.resolve(...E)}function k(R){const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,n);const P=R["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(b,"AppData","Roaming")}break;case"darwin":E=e.join(L.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,n)}return{getUserDataPath:_}}if(typeof define=="function")define(ne[151],ie([0,152,32,18,19,31]),function(e,L,n,T,_,k){const R=_.dirname(T.FileAccess.asFileUri("",e)),C=e.__$__nodeRequire(_.joinPath(R,"package.json").fsPath);return J(L,n,C.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),L=require("path"),n=require("os");module.exports=J(L,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[153],ie([0,1,32,75,151]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class _ extends n.AbstractNativeEnvironmentService{constructor(R,C){super(R,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,T.getUserDataPath)(R)},C)}}e.NativeEnvironmentService=_}),define(ne[154],ie([0,1,7]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,T=/^([^@:]+@)?([^:]+):(.+)$/,_=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,C=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(p){const v=p.match(k);return v?v[1]:null}function P(p){if(p.indexOf("://")===-1){const v=p.match(n);return v?E(v[2]):null}try{const v=L.URI.parse(p);if(v.authority)return E(v.authority)}catch{}return null}function b(p,v){const y=new Set;let g;for(;g=R.exec(p);){const u=P(g[1]);u&&y.add(u)}const l=new Set(v);return Array.from(y).map(u=>l.has(u)?u:u.replace(C,"a"))}e.getDomainsOfRemotes=b;function f(p){const v=p.match(_);return v?v[2]:null}function S(p,v,y){return p&&v?(y&&v.endsWith(".git")&&(v=v.substr(0,v.length-4)),v.indexOf("/")===0?`${p}${v}`:`${p}/${v}`):null}function d(p,v){if(p.indexOf("://")===-1){const y=p.match(T);if(y)return S(y[2],y[3],v)}try{const y=L.URI.parse(p);if(y.authority)return S(f(y.authority),y.path,v)}catch{}return null}function w(p,v=!1){const y=[];let g;for(;g=R.exec(p);){const l=d(g[1],v);l&&y.push(l)}return y}e.getRemotes=w}),define(ne[155],ie([0,1,28]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;function T(_,k){const R=C=>{if(typeof C!="string")return;const E=n.exec(C);if(!E)return;const P=k[E[1]]??C;return typeof P=="string"?P:typeof P.message=="string"?P.message:C};return(0,L.cloneAndChange)(_,R)}e.localizeManifest=T}),define(ne[156],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(_){this.channel=_}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(_,k,R,C){return this.channel.call("promptImportantExtensionsInstallNotification",[_,k,R,C])}promptWorkspaceRecommendations(_){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class n{constructor(_){this.service=_}listen(_,k){throw new Error(`Event not found: ${k}`)}call(_,k,R){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(ne[76],ie([0,1,135]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function _(f){return f=f.trim(),f==="*"||n.test(f)}e.isValidVersionStr=_;function k(f){if(!_(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=f.match(n);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=k;function R(f){if(!f)return null;let S=f.majorBase,d=f.majorMustEqual,w=f.minorBase,p=f.minorMustEqual,v=f.patchBase,y=f.patchMustEqual;f.hasCaret&&(S===0||(p=!1),y=!1);let g=0;if(f.preRelease){const l=T.exec(f.preRelease);if(l){const[,u,r,a]=l;g=Date.UTC(Number(u),Number(r)-1,Number(a))}}return{majorBase:S,majorMustEqual:d,minorBase:w,minorMustEqual:p,patchBase:v,patchMustEqual:y,isMinimum:f.hasGreaterEquals,notBefore:g}}e.normalizeVersion=R;function C(f,S,d){let w;typeof f=="string"?w=R(k(f)):w=f;let p;S instanceof Date?p=S.getTime():typeof S=="string"&&(p=new Date(S).getTime());let v;if(typeof d=="string"?v=R(k(d)):v=d,!w||!v)return!1;let y=w.majorBase,g=w.minorBase,l=w.patchBase,u=v.majorBase,r=v.minorBase,a=v.patchBase,i=v.notBefore,t=v.majorMustEqual,s=v.minorMustEqual,o=v.patchMustEqual;return v.isMinimum?y>u?!0:y<u?!1:g>r?!0:g<r||p&&p<i?!1:l>=a:(y===1&&u===0&&(!t||!s||!o)&&(u=1,r=0,a=0,t=!0,s=!1,o=!1),y<u?!1:y>u?!t:g<r?!1:g>r?!s:l<a?!1:l>a?!o:!(p&&p<i))}e.isValidVersion=C;function E(f,S,d,w){return d.isBuiltin||typeof d.main=="undefined"?!0:b(f,S,d.engines.vscode,w)}e.isValidExtensionVersion=E;function P(f,S,d){return f==="*"||b(S,d,f)}e.isEngineValid=P;function b(f,S,d,w=[]){let p=R(k(d));if(!p)return w.push(L.localize(0,null,d)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return w.push(L.localize(1,null,d)),!1}else if(!p.majorMustEqual)return w.push(L.localize(2,null,d)),!1;return C(f,S,p)?!0:(w.push(L.localize(3,null,f,d)),!1)}}),define(ne[51],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(T,_=[],k=!1){this.ctor=T,this.staticArguments=_,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=L}),define(ne[77],ie([0,1,51]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function T(k,R,C){R instanceof L.SyncDescriptor||(R=new L.SyncDescriptor(R,[],C)),n.push([k,R])}e.registerSingleton=T;function _(){return n}e.getSingletonServiceDescriptors=_}),define(ne[157],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=L;class n{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let k of this._nodes.values())k.outgoing.size===0&&_.push(k);return _}insertEdge(_,k){const R=this.lookupOrInsertNode(_),C=this.lookupOrInsertNode(k);R.outgoing.set(this._hashFn(k),C),C.incoming.set(this._hashFn(_),R)}removeNode(_){const k=this._hashFn(_);this._nodes.delete(k);for(let R of this._nodes.values())R.outgoing.delete(k),R.incoming.delete(k)}lookupOrInsertNode(_){const k=this._hashFn(_);let R=this._nodes.get(k);return R||(R=new L(_),this._nodes.set(k,R)),R}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[k,R]of this._nodes)_.push(`${k}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return _.join(`
`)}findCycleSlow(){for(let[_,k]of this._nodes){const R=new Set([_]),C=this._findCycle(k,R);if(C)return C}}_findCycle(_,k){for(let[R,C]of _.outgoing){if(k.has(R))return[...k,R].join(" -> ");k.add(R);const E=this._findCycle(C,k);if(E)return E;k.delete(R)}}}e.Graph=n}),define(ne[6],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function R(C){return C[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=R})(L=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function n(k,R,C,E){R[L.DI_TARGET]===R?R[L.DI_DEPENDENCIES].push({id:k,index:C,optional:E}):(R[L.DI_DEPENDENCIES]=[{id:k,index:C,optional:E}],R[L.DI_TARGET]=R)}function T(k){if(L.serviceIds.has(k))return L.serviceIds.get(k);const R=function(C,E,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(R,C,P,!1)};return R.toString=()=>k,L.serviceIds.set(k,R),R}e.createDecorator=T;function _(k){return k}e.refineServiceDecorator=_}),define(ne[158],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(ne[20],ie([0,1,15,7,6]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function _(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationOverrides=_;function k(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||L.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=k;var R;(function(p){p[p.USER=1]="USER",p[p.USER_LOCAL=2]="USER_LOCAL",p[p.USER_REMOTE=3]="USER_REMOTE",p[p.WORKSPACE=4]="WORKSPACE",p[p.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",p[p.DEFAULT=6]="DEFAULT",p[p.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(p){switch(p){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function E(p,v){const y=Object.create(null);for(let g in p)P(y,g,p[g],v);return y}e.toValuesTree=E;function P(p,v,y,g){const l=v.split("."),u=l.pop();let r=p;for(let a=0;a<l.length;a++){let i=l[a],t=r[i];switch(typeof t){case"undefined":t=r[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${v} as ${l.slice(0,a+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[u]=y}catch{g(`Ignoring ${v} as ${l.join(".")} is ${JSON.stringify(r)}`)}else g(`Ignoring ${v} as ${l.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=P;function b(p,v){const y=v.split(".");f(p,y)}e.removeFromValueTree=b;function f(p,v){const y=v.shift();if(v.length===0){delete p[y];return}if(Object.keys(p).indexOf(y)!==-1){const g=p[y];typeof g=="object"&&!Array.isArray(g)&&(f(g,v),Object.keys(g).length===0&&delete p[y])}}function S(p,v,y){function g(r,a){let i=r;for(const t of a){if(typeof i!="object"||i===null)return;i=i[t]}return i}const l=v.split("."),u=g(p,l);return typeof u=="undefined"?y:u}e.getConfigurationValue=S;function d(p,v,y){Object.keys(v).forEach(g=>{g!=="__proto__"&&(g in p?L.isObject(p[g])&&L.isObject(v[g])?d(p[g],v[g],y):y&&(p[g]=v[g]):p[g]=v[g])})}e.merge=d;function w(p,v,y){const g=p.inspect(v),l=p.inspect(y);return typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:g.defaultValue}e.getMigratedSettingValue=w}),define(ne[159],ie([0,1,4,27,6]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=L.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",L.isMacintosh),k.set("isLinux",L.isLinux),k.set("isWindows",L.isWindows),k.set("isWeb",L.isWeb),k.set("isMacNative",L.isMacintosh&&!L.isWeb),k.set("isEdge",_.indexOf("Edg/")>=0),k.set("isFirefox",_.indexOf("Firefox")>=0),k.set("isChrome",_.indexOf("Chrome")>=0),k.set("isSafari",_.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var C;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return f.INSTANCE}static true(){return S.INSTANCE}static has(D){return d.create(D)}static equals(D,M){return w.create(D,M)}static notEquals(D,M){return y.create(D,M)}static regex(D,M){return t.create(D,M)}static in(D,M){return p.create(D,M)}static not(D){return g.create(D)}static and(...D){return c.create(D,null)}static or(...D){return h.create(D,null,!0)}static greater(D,M){return u.create(D,M)}static greaterEquals(D,M){return r.create(D,M)}static smaller(D,M){return a.create(D,M)}static smallerEquals(D,M){return i.create(D,M)}static deserialize(D,M=!1){if(!!D)return this._deserializeOrExpression(D,M)}static _deserializeOrExpression(D,M){let W=D.split("||");return h.create(W.map(U=>this._deserializeAndExpression(U,M)),null,!0)}static _deserializeAndExpression(D,M){let W=D.split("&&");return c.create(W.map(U=>this._deserializeOne(U,M)),null)}static _deserializeOne(D,M){if(D=D.trim(),D.indexOf("!=")>=0){let W=D.split("!=");return y.create(W[0].trim(),this._deserializeValue(W[1],M))}if(D.indexOf("==")>=0){let W=D.split("==");return w.create(W[0].trim(),this._deserializeValue(W[1],M))}if(D.indexOf("=~")>=0){let W=D.split("=~");return t.create(W[0].trim(),this._deserializeRegexValue(W[1],M))}if(D.indexOf(" in ")>=0){let W=D.split(" in ");return p.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const W=D.split(">=");return r.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const W=D.split(">");return u.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const W=D.split("<=");return i.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const W=D.split("<");return a.create(W[0].trim(),W[1].trim())}return/^\!\s*/.test(D)?g.create(D.substr(1).trim()):d.create(D)}static _deserializeValue(D,M){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;let W=/^'([^']*)'$/.exec(D);return W?W[1].trim():D}static _deserializeRegexValue(D,M){if((0,n.isFalsyOrWhitespace)(D)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let W=D.indexOf("/"),U=D.lastIndexOf("/");if(W===U||W<0){if(M)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}let x=D.slice(W+1,U),ee=D[U+1]==="i"?"i":"";try{return new RegExp(x,ee)}catch(G){if(M)throw new Error(`bad regexp-value '${D}', parse error: ${G}`);return console.warn(`bad regexp-value '${D}', parse error: ${G}`),null}}}e.ContextKeyExpr=E;function P($,D){const M=$?$.substituteConstants():void 0,W=D?D.substituteConstants():void 0;return!M&&!W?!0:!M||!W?!1:M.equals(W)}e.expressionsAreEqualWithConstantSubstitution=P;function b($,D){return $.cmp(D)}class f{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class S{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class d{constructor(D,M){this.key=D,this.negated=M,this.type=2}static create(D,M=null){const W=k.get(D);return typeof W=="boolean"?W?S.INSTANCE:f.INSTANCE:new d(D,M)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=k.get(this.key);return typeof D=="boolean"?D?S.INSTANCE:f.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=d;class w{constructor(D,M,W){this.key=D,this.value=M,this.negated=W,this.type=4}static create(D,M,W=null){if(typeof M=="boolean")return M?d.create(D,W):g.create(D,W);const U=k.get(D);return typeof U=="boolean"?M===(U?"true":"false")?S.INSTANCE:f.INSTANCE:new w(D,M,W)}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=k.get(this.key);if(typeof D=="boolean"){const M=D?"true":"false";return this.value===M?S.INSTANCE:f.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class p{constructor(D,M){this.key=D,this.valueKey=M,this.type=10,this.negated=null}static create(D,M){return new p(D,M)}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const M=D.getValue(this.valueKey),W=D.getValue(this.key);return Array.isArray(M)?M.indexOf(W)>=0:typeof W=="string"&&typeof M=="object"&&M!==null?R.call(M,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=p;class v{constructor(D){this._actual=D,this.type=11}static create(D){return new v(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new v(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class y{constructor(D,M,W){this.key=D,this.value=M,this.negated=W,this.type=5}static create(D,M,W=null){if(typeof M=="boolean")return M?g.create(D,W):d.create(D,W);const U=k.get(D);return typeof U=="boolean"?M===(U?"true":"false")?f.INSTANCE:S.INSTANCE:new y(D,M,W)}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=k.get(this.key);if(typeof D=="boolean"){const M=D?"true":"false";return this.value===M?f.INSTANCE:S.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class g{constructor(D,M){this.key=D,this.negated=M,this.type=3}static create(D,M=null){const W=k.get(D);return typeof W=="boolean"?W?f.INSTANCE:S.INSTANCE:new g(D,M)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=k.get(this.key);return typeof D=="boolean"?D?f.INSTANCE:S.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function l($,D){if(typeof $=="string"){const M=parseFloat($);isNaN(M)||($=M)}return typeof $=="string"||typeof $=="number"?D($):f.INSTANCE}class u{constructor(D,M,W){this.key=D,this.value=M,this.negated=W,this.type=12}static create(D,M,W=null){return l(M,U=>new u(D,U,W))}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=u;class r{constructor(D,M,W){this.key=D,this.value=M,this.negated=W,this.type=13}static create(D,M,W=null){return l(M,U=>new r(D,U,W))}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class a{constructor(D,M,W){this.key=D,this.value=M,this.negated=W,this.type=14}static create(D,M,W=null){return l(M,U=>new a(D,U,W))}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class i{constructor(D,M,W){this.key=D,this.value=M,this.negated=W,this.type=15}static create(D,M,W=null){return l(M,U=>new i(D,U,W))}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class t{constructor(D,M){this.key=D,this.regexp=M,this.type=7,this.negated=null}static create(D,M){return new t(D,M)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const M=this.regexp?this.regexp.source:"",W=D.regexp?D.regexp.source:"";return M<W?-1:M>W?1:0}equals(D){if(D.type===this.type){const M=this.regexp?this.regexp.source:"",W=D.regexp?D.regexp.source:"";return this.key===D.key&&M===W}return!1}substituteConstants(){return this}evaluate(D){let M=D.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(D){this._actual=D,this.type=8}static create(D){return new s(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new s(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function o($){let D=null;for(let M=0,W=$.length;M<W;M++){const U=$[M].substituteConstants();if($[M]!==U&&D===null){D=[];for(let x=0;x<M;x++)D[x]=$[x]}D!==null&&(D[M]=U)}return D===null?$:D}class c{constructor(D,M){this.expr=D,this.negated=M,this.type=6}static create(D,M){return c._normalizeArr(D,M)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let M=0,W=this.expr.length;M<W;M++){const U=b(this.expr[M],D.expr[M]);if(U!==0)return U}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let M=0,W=this.expr.length;M<W;M++)if(!this.expr[M].equals(D.expr[M]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:c.create(D,this.negated)}evaluate(D){for(let M=0,W=this.expr.length;M<W;M++)if(!this.expr[M].evaluate(D))return!1;return!0}static _normalizeArr(D,M){const W=[];let U=!1;for(const x of D)if(!!x){if(x.type===1){U=!0;continue}if(x.type===0)return f.INSTANCE;if(x.type===6){W.push(...x.expr);continue}W.push(x)}if(W.length===0&&U)return S.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(b);for(let x=1;x<W.length;x++)W[x-1].equals(W[x])&&(W.splice(x,1),x--);if(W.length===1)return W[0];for(;W.length>1;){const x=W[W.length-1];if(x.type!==9)break;W.pop();const ee=W.pop(),G=W.length===0,q=h.create(x.expr.map(Y=>c.create([Y,ee],null)),null,G);q&&(W.push(q),W.sort(b))}return W.length===1?W[0]:new c(W,M)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(let M of this.expr)D.push(...M.keys());return D}map(D){return new c(this.expr.map(M=>M.map(D)),null)}negate(){if(!this.negated){const D=[];for(let M of this.expr)D.push(M.negate());this.negated=h.create(D,this,!0)}return this.negated}}class h{constructor(D,M){this.expr=D,this.negated=M,this.type=9}static create(D,M,W){return h._normalizeArr(D,M,W)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let M=0,W=this.expr.length;M<W;M++){const U=b(this.expr[M],D.expr[M]);if(U!==0)return U}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let M=0,W=this.expr.length;M<W;M++)if(!this.expr[M].equals(D.expr[M]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:h.create(D,this.negated,!1)}evaluate(D){for(let M=0,W=this.expr.length;M<W;M++)if(this.expr[M].evaluate(D))return!0;return!1}static _normalizeArr(D,M,W){let U=[],x=!1;if(D){for(let ee=0,G=D.length;ee<G;ee++){const q=D[ee];if(!!q){if(q.type===0){x=!0;continue}if(q.type===1)return S.INSTANCE;if(q.type===9){U=U.concat(q.expr);continue}U.push(q)}}if(U.length===0&&x)return f.INSTANCE;U.sort(b)}if(U.length!==0){if(U.length===1)return U[0];for(let ee=1;ee<U.length;ee++)U[ee-1].equals(U[ee])&&(U.splice(ee,1),ee--);if(U.length===1)return U[0];if(W){for(let ee=0;ee<U.length;ee++)for(let G=ee+1;G<U.length;G++)A(U[ee],U[G])&&(U.splice(G,1),G--);if(U.length===1)return U[0]}return new h(U,M)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(let M of this.expr)D.push(...M.keys());return D}map(D){return new h(this.expr.map(M=>M.map(D)),null)}negate(){if(!this.negated){let D=[];for(let M of this.expr)D.push(M.negate());for(;D.length>1;){const M=D.shift(),W=D.shift(),U=[];for(const ee of N(M))for(const G of N(W))U.push(c.create([ee,G],null));const x=D.length===0;D.unshift(h.create(U,null,x))}this.negated=D[0]}return this.negated}}class m extends d{constructor(D,M,W){super(D,null);this._defaultValue=M,typeof W=="object"?m._info.push({...W,key:D}):W!==!0&&m._info.push({key:D,description:W,type:M!=null?typeof M:void 0})}static all(){return m._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return w.create(this.key,D)}notEqualsTo(D){return y.create(this.key,D)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function I($,D){return $<D?-1:$>D?1:0}function O($,D,M,W){return $<M?-1:$>M?1:D<W?-1:D>W?1:0}function A($,D){if(D.type===6&&$.type!==9&&$.type!==6){for(const U of D.expr)if($.equals(U))return!0}const M=$.negate(),W=N(M).concat(N(D));W.sort(b);for(let U=0;U<W.length;U++){const ee=W[U].negate();for(let G=U+1;G<W.length;G++){const q=W[G];if(ee.equals(q))return!0}}return!1}e.implies=A;function N($){return $.type===9?$.expr:[$]}}),define(ne[78],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function n(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=n}),define(ne[79],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(ne[13],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[30],ie([0,1,18,130,6]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var _;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(_=e.TargetPlatform||(e.TargetPlatform={}));function k(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function C(g,l){switch(g){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function E(g,l){return l==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function P(g,l,u){return E(l,u)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===u?!0:b(u).includes(g)}e.isTargetPlatformCompatible=P;function b(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function f(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=f;var S;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var d;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var w;(function(g){g.Install="install",g.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var p;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var v;(function(g){g.Unsupported="Unsupported",g.UnsupportedPreRelease="UnsupportedPreRelease",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(l,u){super(l);this.code=u,this.name=u}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")});var X=this&&this.__param||function(J,e){return function(L,n){e(L,n,J)}};define(ne[160],ie([0,1,2,30]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let T=class extends L.Disposable{constructor(k){super();k.removeDeprecatedExtensions(),k.migrateUnsupportedExtensions()}};T=de([X(0,n.IExtensionManagementService)],T),e.ExtensionsCleaner=T}),define(ne[161],ie([0,1,3,2,28,7,110,30]),function(J,e,L,n,T,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(w,p){return _.URI.revive(p?p.transformIncoming(w):w)}function E(w,p){return p?p.transformOutgoingURI(w):w}function P(w,p){p=p||k.DefaultURITransformer;const v=w.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...w,manifest:void 0},p),manifest:v}}function b(w,p){return p?(0,T.cloneAndChange)(w,v=>v instanceof _.URI?p.transformOutgoingURI(v):void 0):w}class f{constructor(p,v){this.service=p,this.getUriTransformer=v,this.onInstallExtension=L.Event.buffer(p.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(p.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(p.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(p.onDidUninstallExtension,!0)}listen(p,v){const y=this.getUriTransformer(p);switch(v){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,g=>g.map(l=>({...l,local:l.local?b(l.local,y):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(p,v,y){const g=this.getUriTransformer(p);switch(v){case"zip":return this.service.zip(P(y[0],g)).then(l=>E(l,g));case"unzip":return this.service.unzip(C(y[0],g));case"install":return this.service.install(C(y[0],g),y[1]);case"getManifest":return this.service.getManifest(C(y[0],g));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(y[0]);case"installFromGallery":return this.service.installFromGallery(y[0],y[1]);case"uninstall":return this.service.uninstall(P(y[0],g),y[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(P(y[0],g));case"getInstalled":return this.service.getInstalled(y[0]).then(l=>l.map(u=>b(u,g)));case"updateMetadata":return this.service.updateMetadata(P(y[0],g),y[1]).then(l=>b(l,g));case"updateExtensionScope":return this.service.updateExtensionScope(P(y[0],g),y[1]).then(l=>b(l,g));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class S extends n.Disposable{constructor(p){super();this.channel=p,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(v=>this._onInstallExtension.fire({identifier:v.identifier,source:this.isUriComponents(v.source)?_.URI.revive(v.source):v.source}))),this._register(this.channel.listen("onDidInstallExtensions")(v=>this._onDidInstallExtensions.fire(v.map(y=>({...y,local:y.local?P(y.local,null):y.local,source:this.isUriComponents(y.source)?_.URI.revive(y.source):y.source}))))),this._register(this.channel.listen("onUninstallExtension")(v=>this._onUninstallExtension.fire(v))),this._register(this.channel.listen("onDidUninstallExtension")(v=>this._onDidUninstallExtension.fire(v)))}isUriComponents(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(p){const v=await this.getTargetPlatform();return p.allTargetPlatforms.some(y=>(0,R.isTargetPlatformCompatible)(y,p.allTargetPlatforms,v))}zip(p){return Promise.resolve(this.channel.call("zip",[p]).then(v=>_.URI.revive(v)))}unzip(p){return Promise.resolve(this.channel.call("unzip",[p]))}install(p,v){return Promise.resolve(this.channel.call("install",[p,v])).then(y=>P(y,null))}getManifest(p){return Promise.resolve(this.channel.call("getManifest",[p]))}installFromGallery(p,v){return Promise.resolve(this.channel.call("installFromGallery",[p,v])).then(y=>P(y,null))}uninstall(p,v){return Promise.resolve(this.channel.call("uninstall",[p,v]))}reinstallFromGallery(p){return Promise.resolve(this.channel.call("reinstallFromGallery",[p]))}getInstalled(p=null){return Promise.resolve(this.channel.call("getInstalled",[p])).then(v=>v.map(y=>P(y,null)))}updateMetadata(p,v){return Promise.resolve(this.channel.call("updateMetadata",[p,v])).then(y=>P(y,null))}updateExtensionScope(p,v){return Promise.resolve(this.channel.call("updateExtensionScope",[p,v])).then(y=>P(y,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=S;class d{constructor(p){this.service=p}listen(p,v){throw new Error("Invalid listen")}call(p,v,y){switch(v){case"getConfigBasedTips":return this.service.getConfigBasedTips(_.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=d}),define(ne[80],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function T(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=T;var _;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(_=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[14],ie([0,1,39,9,27,15,7,137,6]),function(J,e,L,n,T,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function E(U){return U.create===!0}e.isFileOpenForWriteOptions=E;var P;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var b;(function(U){U[U.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var f;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=S;function d(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=d;function w(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function p(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=p;function v(U){return S(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var y;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(x,ee){super(x);this.code=ee}}e.FileSystemProviderError=g;function l(U,x){const ee=new g(U.toString(),x);return r(ee,x),ee}e.createFileSystemProviderError=l;function u(U){return U||l((0,R.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=u;function r(U,x){return U.name=x?`${x} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=r;function a(U){if(!U)return y.Unknown;if(U instanceof g)return U.code;const x=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!x)return y.Unknown;switch(x[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=a;function i(U){if(U instanceof m)return U.fileOperationResult;switch(a(U)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var t;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class s{constructor(x,ee,G){this.resource=x,this.operation=ee,this.target=G}isOperation(x){return this.operation===x}}e.FileOperationEvent=s;var o;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class c{constructor(x,ee){this.added=void 0,this.updated=void 0,this.deleted=void 0;const G=new Map;for(const q of x){const Y=G.get(q.type);Y?Y.push([q.resource,q]):G.set(q.type,[[q.resource,q]])}for(const[q,Y]of G)switch(q){case 1:this.added=L.TernarySearchTree.forUris(()=>ee),this.added.fill(Y);break;case 0:this.updated=L.TernarySearchTree.forUris(()=>ee),this.updated.fill(Y);break;case 2:this.deleted=L.TernarySearchTree.forUris(()=>ee),this.deleted.fill(Y);break}}contains(x,...ee){return this.doContains(x,{includeChildren:!1},...ee)}affects(x,...ee){return this.doContains(x,{includeChildren:!0},...ee)}doContains(x,ee,...G){if(!x)return!1;const q=G.length>0;return!!((!q||G.includes(1))&&(this.added?.get(x)||ee.includeChildren&&this.added?.findSuperstr(x))||(!q||G.includes(0))&&(this.updated?.get(x)||ee.includeChildren&&this.updated?.findSuperstr(x))||(!q||G.includes(2))&&(this.deleted?.findSubstr(x)||ee.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawUpdated(){return this.updated}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function h(U,x,ee){return!U||!x||U===x||x.length>U.length?!1:(x.charAt(x.length-1)!==n.sep&&(x+=n.sep),ee?(0,T.startsWithIgnoreCase)(U,x):U.indexOf(x)===0)}e.isParent=h;class m extends Error{constructor(x,ee,G){super(x);this.fileOperationResult=ee,this.options=G}}e.FileOperationError=m;class I extends m{constructor(x,ee,G){super(x,2,G);this.stat=ee}}e.NotModifiedSinceFileOperationError=I;var O;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=N;async function $(U,x){if(!x.hasProvider(k.URI.from({scheme:U.scheme})))return new Promise(ee=>{const G=x.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===U.scheme&&q.added&&(G.dispose(),ee())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class D{static formatSize(x){return(0,_.isNumber)(x)||(x=0),x<D.KB?(0,R.localize)(1,null,x.toFixed(0)):x<D.MB?(0,R.localize)(2,null,(x/D.KB).toFixed(2)):x<D.GB?(0,R.localize)(3,null,(x/D.MB).toFixed(2)):x<D.TB?(0,R.localize)(4,null,(x/D.GB).toFixed(2)):(0,R.localize)(5,null,(x/D.TB).toFixed(2))}}e.ByteSize=D,D.KB=1024,D.MB=D.KB*D.KB,D.GB=D.MB*D.KB,D.TB=D.GB*D.KB;var M;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function W(U){return{maxFileSize:U===0?300*D.MB:16*D.GB,maxHeapSize:U===0?700*D.MB:2*700*D.MB}}e.getPlatformLimits=W}),define(ne[162],ie([0,1,81,40,14]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let _=class{constructor(R){this.fileService=R}async checksum(R){const C=(await this.fileService.readFileStream(R)).value;return new Promise((E,P)=>{const b=(0,L.createHash)("md5");(0,n.listenStream)(C,{onData:f=>b.update(f.buffer),onError:f=>P(f),onEnd:()=>E(b.digest("base64").replace(/=+$/,""))})})}};_=de([X(0,T.IFileService)],_),e.ChecksumService=_}),define(ne[163],ie([0,1,250,127,150,14]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(f,S){const d={onUnknownOption:p=>{console.warn((0,n.localize)(0,null,p))},onMultipleValues:(p,v)=>{console.warn((0,n.localize)(1,null,p,v))},onDeprecatedOption:(p,v)=>{console.warn((0,n.localize)(2,null,p,v))}},w=(0,T.parseArgs)(f,T.OPTIONS,S?d:void 0);return w.goto&&w._.forEach(p=>L(/^(\w:)?[^:]+(:\d*){0,2}$/.test(p),(0,n.localize)(3,null))),w["max-memory"]&&L(parseInt(w["max-memory"])>=_.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${_.MIN_MAX_MEMORY_SIZE_MB} MB.`),w}function R(f){const S=f.findIndex(d=>!/^-/.test(d));if(S>-1)return[...f.slice(0,S),...f.slice(S+1)]}function C(f){let[,...S]=f;process.env.VSCODE_DEV&&(S=R(S)||[]);const d=!b(process.env);return k(S,d)}e.parseMainProcessArgv=C;function E(f){const[,,...S]=f;return k(S,!0)}e.parseCLIProcessArgv=E;function P(f,...S){const d=f.indexOf("--");return d===-1?f.push(...S):f.splice(d,0,...S),f}e.addArg=P;function b(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(ne[164],ie([0,1,45,9,128,25,37,8,4,29,123,163,5]),function(J,e,L,n,T,_,k,R,C,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let d;async function w(v,y,g){return y["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(g)&&!y["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(g)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=f.Promises.withAsyncBody(async(l,u)=>{const r=new _.CancellationTokenSource,a=setTimeout(()=>{r.dispose(!0),u(new Error((0,T.localize)(0,null)))},S);try{l(await p(v,r.token))}catch(i){!(0,R.isPromiseCanceledError)(i)&&!r.token.isCancellationRequested?u(new Error((0,T.localize)(1,null,(0,k.toErrorMessage)(i)))):l({})}finally{clearTimeout(a),r.dispose()}})),d)}e.getResolvedShellEnv=w;async function p(v,y){const g=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",g);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",l);const u=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(u+"(.*)"+u),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",a);const i=await(0,P.getSystemShell)(C.OS,a);return v.trace("getUnixShellEnvironment#shell",i),new Promise((t,s)=>{if(y.isCancellationRequested)return s((0,R.canceled)());const o=(0,n.basename)(i);let c,h;const m=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${m} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,h=["-Login","-Command"]):(c=`'${process.execPath}' ${m} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,o==="tcsh"?h=["-ic"]:h=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),c);const I=(0,L.spawn)(i,[...h,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});y.onCancellationRequested(()=>(I.kill(),s((0,R.canceled)()))),I.on("error",N=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(N)),s(N)});const O=[];I.stdout.on("data",N=>O.push(N));const A=[];I.stderr.on("data",N=>A.push(N)),I.on("close",(N,$)=>{const D=Buffer.concat(O).toString("utf8");v.trace("getUnixShellEnvironment#raw",D);const M=Buffer.concat(A).toString("utf8");if(M.trim()&&v.trace("getUnixShellEnvironment#stderr",M),N||$)return s(new Error((0,T.localize)(2,null,N,$)));const W=r.exec(D),U=W?W[1]:"{}";try{const x=JSON.parse(U);g?x.ELECTRON_RUN_AS_NODE=g:delete x.ELECTRON_RUN_AS_NODE,l?x.ELECTRON_NO_ATTACH_CONSOLE=l:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",x),t(x)}catch(x){v.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(x)),s(x)}})})}}),define(ne[165],ie([0,1,17,37,8,3,2,40,7,29,14]),function(J,e,L,n,T,_,k,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends k.Disposable{constructor(S,d){super();this.channel=S,this.extraCapabilities=d,this.onDidChangeCapabilities=_.Event.None,this._onDidChange=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(S){return this.channel.call("stat",[S])}readdir(S){return this.channel.call("readdir",[S])}async readFile(S,d){const{buffer:w}=await this.channel.call("readFile",[S,d]);return w}readFileStream(S,d,w){const p=(0,R.newWriteableStream)(y=>L.VSBuffer.concat(y.map(g=>L.VSBuffer.wrap(g))).buffer),v=this.channel.listen("readFileStream",[S,d])(y=>{if(y instanceof L.VSBuffer)p.write(y.buffer);else{if(y==="end")p.end();else{let g=y;g instanceof Error||(g=(0,P.createFileSystemProviderError)((0,n.toErrorMessage)(g),P.FileSystemProviderErrorCode.Unknown)),p.error(g),p.end()}v.dispose()}});return w.onCancellationRequested(()=>{p.error((0,T.canceled)()),p.end(),v.dispose()}),p}writeFile(S,d,w){return this.channel.call("writeFile",[S,L.VSBuffer.wrap(d),w])}open(S,d){return this.channel.call("open",[S,d])}close(S){return this.channel.call("close",[S])}async read(S,d,w,p,v){const[y,g]=await this.channel.call("read",[S,d,v]);return w.set(y.buffer.slice(0,g),p),g}write(S,d,w,p,v){return this.channel.call("write",[S,d,L.VSBuffer.wrap(w),p,v])}mkdir(S){return this.channel.call("mkdir",[S])}delete(S,d){return this.channel.call("delete",[S,d])}rename(S,d,w){return this.channel.call("rename",[S,d,w])}copy(S,d,w){return this.channel.call("copy",[S,d,w])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(S=>{if(Array.isArray(S)){const d=S;this._onDidChange.fire(d.map(w=>({resource:C.URI.revive(w.resource),type:w.type})))}else{const d=S;this._onDidWatchError.fire(d)}}))}watch(S,d){const w=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,w,S,d]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,w]))}}e.DiskFileSystemProviderClient=b}),define(ne[82],ie([0,1,17,8,138,14]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(P,b,f,S,d,w){let p;try{await R(P,b,f,S,d,w)}catch(v){p=v}finally{p&&d.errorTransformer&&(p=d.errorTransformer(p)),typeof p!="undefined"&&f.error(p),f.end()}}e.readFileIntoStream=k;async function R(P,b,f,S,d,w){C(w);const p=await P.open(b,{create:!1});try{C(w);let v=0,y=0,g=d&&typeof d.length=="number"?d.length:void 0,l=L.VSBuffer.alloc(Math.min(d.bufferSize,typeof g=="number"?g:d.bufferSize)),u=d&&typeof d.position=="number"?d.position:0,r=0;do y=await P.read(p,u,l.buffer,r,l.byteLength-r),u+=y,r+=y,v+=y,typeof g=="number"&&(g-=y),r===l.byteLength&&(await f.write(S(l)),l=L.VSBuffer.alloc(Math.min(d.bufferSize,typeof g=="number"?g:d.bufferSize)),r=0);while(y>0&&(typeof g!="number"||g>0)&&C(w)&&E(v,d));if(r>0){let a=r;typeof g=="number"&&(a=Math.min(r,g)),f.write(S(l.slice(0,a)))}}catch(v){throw(0,_.ensureFileSystemProviderError)(v)}finally{await P.close(p)}}function C(P){if(P.isCancellationRequested)throw(0,n.canceled)();return!0}function E(P,b){if(b?.limits){if(typeof b.limits.memory=="number"&&P>b.limits.memory)throw(0,_.createFileSystemProviderError)((0,T.localize)(0,null),_.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&P>b.limits.size)throw(0,_.createFileSystemProviderError)((0,T.localize)(1,null),_.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[58],ie([0,1,2,4,7,14]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class k extends L.Disposable{constructor(b,f,S){super();this.onFileChanges=b,this.onLogMessage=f,this.verboseLogging=S,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const b=new L.DisposableStore;this.watcherDisposables.value=b,this.watcher=this.createWatcher(b),this.watcher.setVerboseLogging(this.verboseLogging),b.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),b.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),b.add(this.watcher.onDidError(f=>this.onError(f)))}onError(b){this.restartCounter<k.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${b}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${b}`)}restart(b){this.restartCounter++,this.init(),this.watch(b)}async watch(b){this.requests=b,await this.watcher?.watch(b)}async setVerboseLogging(b){this.verboseLogging=b,await this.watcher?.setVerboseLogging(b)}error(b){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${b}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=k,k.MAX_RESTARTS=5;function R(P){return P.map(b=>({type:b.type,resource:T.URI.file(b.path)}))}e.toFileChanges=R;function C(P){const b=new E;for(const f of P)b.processEvent(f);return b.coalesce()}e.coalesceEvents=C;class E{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(b){return n.isLinux?b.path:b.path.toLowerCase()}processEvent(b){const f=this.mapPathToChange.get(this.toKey(b));let S=!1;if(f){const d=f.type,w=b.type;f.path!==b.path&&(b.type===2||b.type===1)?S=!0:d===1&&w===2?(this.mapPathToChange.delete(this.toKey(b)),this.coalesced.delete(f)):d===2&&w===1?f.type=0:d===1&&w===0||(f.type=w)}else S=!0;S&&(this.coalesced.add(b),this.mapPathToChange.set(this.toKey(b),b))}coalesce(){const b=[],f=[];return Array.from(this.coalesced).filter(S=>S.type!==2?(b.push(S),!1):!0).sort((S,d)=>S.path.length-d.path.length).filter(S=>f.some(d=>(0,_.isParent)(S.path,d,!n.isLinux))?!1:(f.push(S.path),!0)).concat(b)}}}),define(ne[166],ie([0,1,50,5,25,41,109,2,69,9,4,114,22,58]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcher=void 0;class d extends R.Disposable{constructor(v,y,g,l){super();this.request=v,this.onDidFilesChange=y,this.onLogMessage=g,this.verboseLogging=l,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(d.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(u=>(0,k.parse)(u)),this.cts=new T.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;this.trace(`Request to start watching: ${v} (excludes: ${this.request.excludes}))}`);const y=await f.Promises.stat(v);this._register(await this.doWatch(v,y.isDirectory()))}catch(v){v.code!=="ENOENT"&&this.error(v)}}async normalizePath(v){let y=v.path;try{y=await f.Promises.realpath(v.path),v.path===y&&(y=await(0,b.realcase)(v.path)??v.path),v.path!==y&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${y})`)}catch{}return y}async doWatch(v,y){if(P.isMacintosh&&(0,_.isEqualOrParent)(v,"/Volumes/"))return this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const g=new T.CancellationTokenSource(this.cts.token);let l=new R.DisposableStore;try{const u=(0,L.watch)(v);l.add((0,R.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const r=new Set;if(y)try{for(const i of await f.Promises.readdir(v))r.add(i)}catch(i){this.error(i)}const a=new Map;l.add((0,R.toDisposable)(()=>{for(const[,i]of a)i.dispose();a.clear()})),u.on("error",(i,t)=>{this.error(`Failed to watch ${v} for changes using fs.watch() (${i}, ${t})`)}),u.on("change",(i,t)=>{if(g.token.isCancellationRequested)return;this.trace(`["${i}"] ${t} (fs.watch() raw event)`);let s="";if(t&&(s=t.toString(),P.isMacintosh&&(s=(0,C.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(y)if(i==="rename"){a.get(s)?.dispose();const o=setTimeout(async()=>{if(a.delete(s),s===(0,E.basename)(v)&&!await f.Promises.exists(v))this.onFileChange({path:this.request.path,type:2});else{const c=await this.existsChildStrictCase((0,E.join)(v,s));if(g.token.isCancellationRequested)return;let h;c?r.has(s)?h=0:(h=1,r.add(s)):(r.delete(s),h=2),this.onFileChange({path:(0,E.join)(this.request.path,s),type:h})}},d.FILE_DELETE_HANDLER_DELAY);a.set(s,(0,R.toDisposable)(()=>clearTimeout(o)))}else{let o;r.has(s)?o=0:(o=1,r.add(s)),this.onFileChange({path:(0,E.join)(this.request.path,s),type:o})}else if(i==="rename"||s!==(0,E.basename)(v)){const o=setTimeout(async()=>{const c=await f.Promises.exists(v);g.token.isCancellationRequested||(c?(this.onFileChange({path:this.request.path,type:0}),l.add(await this.doWatch(v,!1))):this.onFileChange({path:this.request.path,type:2}))},d.FILE_DELETE_HANDLER_DELAY);l.clear(),l.add((0,R.toDisposable)(()=>clearTimeout(o)))}else this.onFileChange({path:this.request.path,type:0})})}catch(u){await f.Promises.exists(v)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${v} for changes using fs.watch() (${u.toString()})`)}return(0,R.toDisposable)(()=>{g.dispose(!0),l.dispose()})}onFileChange(v){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),this.excludes.some(y=>y(v.path))?this.verboseLogging&&this.trace(` >> ignored ${v.path}`):this.fileChangesBuffer.push(v),this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const g=(0,S.coalesceEvents)(y);if(this.verboseLogging)for(const l of g)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);g.length>0&&this.onDidFilesChange(g)}).catch(()=>{}))}async existsChildStrictCase(v){if(P.isLinux)return await f.Promises.exists(v);try{return(await f.Promises.readdir((0,E.dirname)(v))).some(g=>g===(0,E.basename)(v))}catch{return!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcher=d,d.FILE_DELETE_HANDLER_DELAY=25,d.FILE_CHANGES_HANDLER_DELAY=50;async function w(p,v,y,g=512){const l=await f.Promises.open(p,"r"),u=Buffer.allocUnsafe(g),r=new T.CancellationTokenSource(y);let a,i=!1;const t={path:p,excludes:[]},s=new d(t,o=>{(async()=>{for(const{type:c}of o)if(c===0){if(i)return;i=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:h}=await f.Promises.read(l,u,0,g,null);if(!h||r.token.isCancellationRequested)break;v(u.slice(0,h))}}catch(h){a=new Error(h),r.dispose(!0)}finally{i=!1}}})()});return new Promise((o,c)=>{r.token.onCancellationRequested(async()=>{s.dispose();try{await f.Promises.close(l)}catch(h){a=new Error(h)}a?c(a):o()})})}e.watchFileContents=w}),define(ne[167],ie([0,1,18,36,57,58]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class k extends _.AbstractRecursiveWatcherClient{constructor(C,E,P){super(C,E,P);this.init()}createWatcher(C){const E=C.add(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(E.onDidProcessExit(({code:P,signal:b})=>this.onError(`terminated by itself with code ${P}, signal: ${b}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(E.getChannel("watcher")))}}e.ParcelWatcherClient=k}),define(ne[83],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...T){this._entries=new Map;for(let[_,k]of T)this.set(_,k)}set(T,_){const k=this._entries.get(T);return this._entries.set(T,_),k}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=L}),define(ne[168],ie([0,1,5,8,51,157,6,83]),function(J,e,L,n,T,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class E extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class P{constructor(d=new R.ServiceCollection,w=!1,p){this._activeInstantiations=new Set,this._services=d,this._strict=w,this._parent=p,this._services.set(k.IInstantiationService,this)}createChild(d){return new P(d,this._strict,this)}invokeFunction(d,...w){let p=f.traceInvocation(d),v=!1;try{return d({get:g=>{if(v)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(g,p);if(!l)throw new Error(`[invokeFunction] unknown service '${g}'`);return l}},...w)}finally{v=!0,p.stop()}}createInstance(d,...w){let p,v;return d instanceof T.SyncDescriptor?(p=f.traceCreation(d.ctor),v=this._createInstance(d.ctor,d.staticArguments.concat(w),p)):(p=f.traceCreation(d),v=this._createInstance(d,w,p)),p.stop(),v}_createInstance(d,w=[],p){let v=k._util.getServiceDependencies(d).sort((l,u)=>l.index-u.index),y=[];for(const l of v){let u=this._getOrCreateServiceInstance(l.id,p);if(!u&&this._strict&&!l.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${l.id}.`);y.push(u)}let g=v.length>0?v[0].index:w.length;if(w.length!==g){console.warn(`[createInstance] First service dependency of ${d.name} at position ${g+1} conflicts with ${w.length} static arguments`);let l=g-w.length;l>0?w=w.concat(new Array(l)):w=w.slice(0,g)}return new d(...[...w,...y])}_setServiceInstance(d,w){if(this._services.get(d)instanceof T.SyncDescriptor)this._services.set(d,w);else if(this._parent)this._parent._setServiceInstance(d,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let w=this._services.get(d);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):w}_getOrCreateServiceInstance(d,w){let p=this._getServiceInstanceOrDescriptor(d);return p instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,p,w.branch(d,!0)):(w.branch(d,!1),p)}_safeCreateAndCacheServiceInstance(d,w,p){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,w,p)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,w,p){const v=new _.Graph(l=>l.id.toString());let y=0;const g=[{id:d,desc:w,_trace:p}];for(;g.length;){const l=g.pop();if(v.lookupOrInsertNode(l),y++>1e3)throw new E(v);for(let u of k._util.getServiceDependencies(l.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(u.id);if(!r&&!u.optional&&console.warn(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`),r instanceof T.SyncDescriptor){const a={id:u.id,desc:r,_trace:l._trace.branch(u.id,!0)};v.insertEdge(l,a),g.push(a)}}}for(;;){const l=v.roots();if(l.length===0){if(!v.isEmpty())throw new E(v);break}for(const{data:u}of l){if(this._getServiceInstanceOrDescriptor(u.id)instanceof T.SyncDescriptor){const a=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,a)}v.removeNode(u)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,w,p=[],v,y){if(this._services.get(d)instanceof T.SyncDescriptor)return this._createServiceInstance(w,p,v,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,w,p,v,y);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(d,w=[],p,v){if(p){const y=new L.IdleValue(()=>this._createInstance(d,w,v));return new Proxy(Object.create(null),{get(g,l){if(l in g)return g[l];let u=y.value,r=u[l];return typeof r!="function"||(r=r.bind(u),g[l]=r),r},set(g,l,u){return y.value[l]=u,!0}})}else return this._createInstance(d,w,v)}}e.InstantiationService=P;var b;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(b||(b={}));class f{constructor(d,w){this.type=d,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return C?new f(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(d){return C?new f(0,d.name):f._None}branch(d,w){let p=new f(2,d.toString());return this._dep.push([d,w,p]),p}stop(){let d=Date.now()-this._start;f._totals+=d;let w=!1;function p(y,g){let l=[],u=new Array(y+1).join("	");for(const[r,a,i]of g._dep)if(a&&i){w=!0,l.push(`${u}CREATES -> ${r}`);let t=p(y+1,i);t&&l.push(t)}else l.push(`${u}uses -> ${r}`);return l.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(d>2||w)&&console.log(v.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ne[169],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class L{constructor(T,_){this.server=T,this.router=_}getChannel(T){return this.server.getChannel(T,this.router)}registerChannel(T,_){this.server.registerChannel(T,_)}}e.MessagePortMainProcessService=L}),define(ne[170],ie([0,1,36,51,77,6]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(S,d,w){const p=w.getChannel(S);return R(d)?new d.channelClientCtor(p):L.ProxyChannel.toService(p,d?.proxyOptions)}}function R(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,_.createDecorator)("mainProcessService");let C=class extends k{constructor(S,d,w){super(S,d,w)}};C=de([X(2,e.IMainProcessService)],C);function E(f,S,d){(0,T.registerSingleton)(f,new n.SyncDescriptor(C,[S,d],d?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,_.createDecorator)("sharedProcessService");let P=class extends k{constructor(S,d,w){super(S,d,w)}};P=de([X(2,e.ISharedProcessService)],P);function b(f,S,d){(0,T.registerSingleton)(f,new n.SyncDescriptor(P,[S,d],d?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=b}),define(ne[59],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,L.createDecorator)("localizationsService");function n(T){if(typeof T.languageId!="string"||!Array.isArray(T.translations)||T.translations.length===0)return!1;for(const _ of T.translations)if(typeof _.id!="string"||typeof _.path!="string")return!1;return!(T.languageName&&typeof T.languageName!="string"||T.localizedLanguageName&&typeof T.localizedLanguageName!="string")}e.isValidLocalization=n}),define(ne[171],ie([0,1,2,59]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let T=class extends L.Disposable{constructor(k){super();this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};T=de([X(0,n.ILocalizationsService)],T),e.LocalizationsUpdater=T}),define(ne[10],ie([0,1,37,3,2,4,6]),function(J,e,L,n,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function R(){return new Date().toISOString()}var C;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function E(a,i,t){switch(i){case C.Trace:a.trace(t);break;case C.Debug:a.debug(t);break;case C.Info:a.info(t);break;case C.Warning:a.warn(t);break;case C.Error:a.error(t);break;case C.Critical:a.critical(t);break;default:throw new Error("Invalid log level")}}e.log=E;function P(a){let i="";for(let t=0;t<a.length;t++){let s=a[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}i+=(t>0?" ":"")+s}return i}e.format=P;class b extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class f extends b{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(C.Trace)&&this.log(C.Trace,P([i,...t]))}debug(i,...t){this.checkLogLevel(C.Debug)&&this.log(C.Debug,P([i,...t]))}info(i,...t){this.checkLogLevel(C.Info)&&this.log(C.Info,P([i,...t]))}warn(i,...t){this.checkLogLevel(C.Warning)&&this.log(C.Warning,P([i,...t]))}error(i,...t){if(this.checkLogLevel(C.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(C.Error,P(s))}else this.log(C.Error,P([i,...t]))}critical(i,...t){this.checkLogLevel(C.Critical)&&this.log(C.Critical,P([i,...t]))}flush(){}}e.AbstractMessageLogger=f;class S extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!_.isWindows}trace(i,...t){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}debug(i,...t){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}info(i,...t){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}warn(i,...t){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,i,...t):console.warn(`[main ${R()}]`,i,...t))}error(i,...t){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}critical(i,...t){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class d extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=d;class w extends b{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,L.toErrorMessage)(i,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class p extends b{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const s of this.logServices)s.trace(i,...t)}debug(i,...t){for(const s of this.logServices)s.debug(i,...t)}info(i,...t){for(const s of this.logServices)s.info(i,...t)}warn(i,...t){for(const s of this.logServices)s.warn(i,...t)}error(i,...t){for(const s of this.logServices)s.error(i,...t)}critical(i,...t){for(const s of this.logServices)s.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=p;class v extends T.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=v;class y extends T.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,t?.always?C.Trace:this.logLevel,t),this.loggers.set(i.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class g{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return C.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=g;function l(a){if(a.verbose)return C.Trace;if(typeof a.logLevel=="string"){const i=u(a.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function u(a){switch(a){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=u;function r(a){switch(a){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=r}),define(ne[172],ie([0,1,5,8,2,9,22,13,10]),function(J,e,L,n,T,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends T.Disposable{constructor(b,f){super();this.environmentService=b,this.logService=f,this._register(new L.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,_.basename)(this.environmentService.logsPath),f=(0,_.dirname)(this.environmentService.logsPath),w=(await k.Promises.readdir(f)).filter(v=>/^\d{8}T\d{6}$/.test(v)).sort().filter(v=>v!==b),p=w.slice(0,Math.max(0,w.length-9));p.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${p.join(", ")}'`),await Promise.all(p.map(v=>k.Promises.rm((0,_.join)(f,v)))))}catch(b){(0,n.onUnexpectedError)(b)}}};E=de([X(0,R.IEnvironmentService),X(1,C.ILogService)],E),e.LogsDataCleaner=E}),define(ne[173],ie([0,1,5,8,2,9,22,13,10]),function(J,e,L,n,T,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class mt extends T.Disposable{constructor(b,f,S){super();this.backupWorkspacesPath=b,this.environmentService=f,this.logService=S,this._register(new L.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const b=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),S=JSON.parse(b).emptyWorkspaceInfos.map(w=>w.backupFolder),d=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(d.map(async w=>{w.length===mt.NON_EMPTY_WORKSPACE_ID_LENGTH||w===mt.EXTENSION_DEV_EMPTY_WINDOW_ID||S.indexOf(w)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${w}.`),await k.Promises.rm((0,_.join)(this.environmentService.workspaceStorageHome.fsPath,w)))}))}catch(b){(0,n.onUnexpectedError)(b)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",E=de([X(1,R.INativeEnvironmentService),X(2,C.ILogService)],E),e.StorageDataCleaner=E}),define(ne[174],ie([0,1,45,5,37,3,2,18,9,22,13,10]),function(J,e,L,n,T,_,k,R,C,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends k.Disposable{constructor(d,w){super();this.environmentService=d,this.logService=w,this.processesLimiter=new n.Limiter(5)}async postUninstall(d){const w=this.parseScript(d,"uninstall");return w&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(w.script,"uninstall",w.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),p=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${p}`)))),E.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,p=>this.logService.error("Error while removing extension storage path",p))}parseScript(d,w){const p=`vscode:${w}`;if(d.location.scheme===R.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[p]=="string"){const v=d.manifest.scripts[p].split(" ");return v.length<2||v[0]!=="node"||!v[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${p} should be a node script`),null):{script:(0,C.join)(d.location.fsPath,v[1]),args:v.slice(2)||[]}}return null}runLifecycleHook(d,w,p,v,y){return new Promise((g,l)=>{const u=this.start(d,w,p,y);let r;const a=i=>{r&&(clearTimeout(r),r=null),i?l(i):g(void 0)};u.on("error",i=>{a((0,T.toErrorMessage)(i)||"Unknown")}),u.on("exit",(i,t)=>{a(i?`post-${w} process exited with code ${i}`:void 0)}),v&&(r=setTimeout(()=>{r=null,u.kill(),l("timed out")},5e3))})}start(d,w,p,v){const y={silent:!0,execArgv:void 0},g=(0,L.fork)(d,[`--type=extension-post-${w}`,...p],y);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const l=_.Event.fromNodeEventEmitter(g.stdout,"data"),u=_.Event.fromNodeEventEmitter(g.stderr,"data");l(i=>this.logService.info(v.identifier.id,v.manifest.version,`post-${w}`,i)),u(i=>this.logService.error(v.identifier.id,v.manifest.version,`post-${w}`,i));const r=_.Event.any(_.Event.map(l,i=>({data:`%c${i}`,format:[""]})),_.Event.map(u,i=>({data:`%c${i}`,format:["color: red"]})));return _.Event.debounce(r,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(v.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),g}getExtensionStoragePath(d){return(0,C.join)(this.environmentService.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};f=de([X(0,P.IEnvironmentService),X(1,b.ILogService)],f),e.ExtensionsLifecycle=f}),define(ne[175],ie([0,1,16,5,8,3,2,9,58,10]),function(J,e,L,n,T,_,k,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends k.Disposable{constructor(f){super();this.logService=f,this._onDidChangeFile=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(f,S){return S.recursive?this.watchRecursive(f,S):this.watchNonRecursive(f,S)}watchRecursive(f,S){const d={path:this.toFilePath(f),excludes:S.excludes},w=(0,L.insert)(this.recursiveFoldersToWatch,d);return this.refreshRecursiveWatchers(),(0,k.toDisposable)(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(f=>(0,T.onUnexpectedError)(f))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(f=>this._onDidChangeFile.fire((0,C.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(f,S){return f.watch(S)}watchNonRecursive(f,S){const d=new k.DisposableStore,w=d.add(this.createNonRecursiveWatcher({path:this.toFilePath(f),excludes:S.excludes},p=>this._onDidChangeFile.fire((0,C.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===E.LogLevel.Trace));return d.add(this.logService.onDidChangeLogLevel(()=>{w.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})),d}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,R.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(ne[176],ie([0,1,16,5,17,25,3,54,2,39,18,177,19,40,136,14,82,10]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class Xe extends C.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new n.ThrottledWorker(Xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Xe.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new w.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new n.ThrottledWorker(Xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Xe.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new w.FileChangesEvent(u,!0)))),this.nonRecursiveWatchedResources=E.TernarySearchTree.forUris(u=>{const r=this.getProvider(u.scheme);return r?!this.isPathCaseSensitive(r):!1}),this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(l,u){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:u});const r=new C.DisposableStore;return r.add(u.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(u)))),r.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:l}))),typeof u.onDidWatchError=="function"&&r.add(u.onDidWatchError(a=>this._onDidWatchError.fire(new Error(a)))),(0,C.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:u}),this.provider.delete(l),(0,C.dispose)(r)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(r){u.push(r)}}),!this.provider.has(l)&&await n.Promises.settled(u)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,u){const r=this.provider.get(l.scheme);return!!(r&&r.capabilities&u)}listCapabilities(){return R.Iterable.map(this.provider,([l,u])=>({scheme:l,capabilities:u.capabilities}))}async withProvider(l){if(!(0,f.isAbsolutePath)(l))throw new w.FileOperationError((0,d.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const u=this.provider.get(l.scheme);if(!u){const r=new Error;throw r.name="ENOPRO",r.message=(0,d.localize)(1,null,l.toString()),r}return u}async withReadProvider(l){const u=await this.withProvider(l);if((0,w.hasOpenReadWriteCloseCapability)(u)||(0,w.hasReadWriteCapability)(u)||(0,w.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const u=await this.withProvider(l);if((0,w.hasOpenReadWriteCloseCapability)(u)||(0,w.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,u){try{return await this.doResolveFile(l,u)}catch(r){throw(0,w.toFileSystemProviderErrorCode)(r)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,d.localize)(2,null,this.resourceForError(l)),1):(0,w.ensureFileSystemProviderError)(r)}}async doResolveFile(l,u){const r=await this.withProvider(l),a=this.isPathCaseSensitive(r),i=u?.resolveTo,t=u?.resolveSingleChildDescendants,s=u?.resolveMetadata,o=await r.stat(l);let c;return this.toFileStat(r,l,o,void 0,!!s,(h,m)=>(c||(c=E.TernarySearchTree.forUris(()=>!a),c.set(l,!0),i&&c.fill(!0,i)),c.get(h.resource)||c.findSuperstr(h.resource.with({query:null,fragment:null}))?!0:h.isDirectory&&t?m===1:!1))}async toFileStat(l,u,r,a,i,t){const{providerExtUri:s}=this.getExtUri(l),o={resource:u,name:s.basename(u),isFile:(r.type&w.FileType.File)!=0,isDirectory:(r.type&w.FileType.Directory)!=0,isSymbolicLink:(r.type&w.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&w.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,w.etag)({mtime:r.mtime,size:r.size})};if(o.isDirectory&&t(o,a)){try{const c=await l.readdir(u),h=await n.Promises.settled(c.map(async([m,I])=>{try{const O=s.joinPath(u,m),A=i?await l.stat(O):{type:I};return await this.toFileStat(l,O,A,c.length,i,t)}catch(O){return this.logService.trace(O),null}}));o.children=(0,L.coalesce)(h)}catch(c){this.logService.trace(c),o.children=[]}return o}return o}async resolveAll(l){return n.Promises.settled(l.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(l){const u=await this.withProvider(l);try{return!!await u.stat(l)}catch{return!1}}async canCreateFile(l,u){try{await this.doValidateCreateFile(l,u)}catch(r){return r}return!0}async doValidateCreateFile(l,u){if(!u?.overwrite&&await this.exists(l))throw new w.FileOperationError((0,d.localize)(3,null,this.resourceForError(l)),3,u)}async createFile(l,u=T.VSBuffer.fromString(""),r){await this.doValidateCreateFile(l,r);const a=await this.writeFile(l,u);return this._onDidRunOperation.fire(new w.FileOperationEvent(l,0,a)),a}async writeFile(l,u,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:i}=this.getExtUri(a);try{await this.validateWriteFile(a,l,r)||await this.mkdirp(a,i.dirname(l));let s;if((0,w.hasReadWriteCapability)(a)&&!(u instanceof T.VSBuffer))if((0,S.isReadableStream)(u)){const o=await(0,S.peekStream)(u,3);o.ended?s=T.VSBuffer.concat(o.buffer):s=o}else s=(0,S.peekReadable)(u,o=>T.VSBuffer.concat(o),3);else s=u;!(0,w.hasOpenReadWriteCloseCapability)(a)||(0,w.hasReadWriteCapability)(a)&&s instanceof T.VSBuffer?await this.doWriteUnbuffered(a,l,r,s):await this.doWriteBuffered(a,l,r,s instanceof T.VSBuffer?(0,T.bufferToReadable)(s):s)}catch(t){throw new w.FileOperationError((0,d.localize)(4,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(t).toString()),(0,w.toFileOperationResult)(t),r)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,u,r){if(!!r?.unlock&&!(l.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(u)));let i;try{i=await l.stat(u)}catch{return}if((i.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,d.localize)(6,null,this.resourceForError(u)),0,r);if(this.throwIfFileIsReadonly(u,i),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==w.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&r.mtime<i.mtime&&r.etag!==(0,w.etag)({mtime:r.mtime,size:i.size}))throw new w.FileOperationError((0,d.localize)(7,null),3,r);return i}async readFile(l,u,r){const a=await this.withReadProvider(l);return u?.atomic?this.doReadFileAtomic(a,l,u,r):this.doReadFile(a,l,u,r)}async doReadFileAtomic(l,u,r,a){return new Promise((i,t)=>{this.writeQueue.queueFor(u,this.getExtUri(l).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(l,u,r,a);i(s)}catch(s){t(s)}})})}async doReadFile(l,u,r,a){const i=await this.doReadFileStream(l,u,{...r,preferUnbuffered:!0},a);return{...i,value:await(0,T.streamToBuffer)(i.value)}}async readFileStream(l,u,r){const a=await this.withReadProvider(l);return this.doReadFileStream(a,l,u,r)}async doReadFileStream(l,u,r,a){const i=new _.CancellationTokenSource(a),t=this.validateReadFile(u,r).then(o=>o,o=>{throw i.cancel(),o});let s;try{return typeof r?.etag=="string"&&r.etag!==w.ETAG_DISABLED&&await t,r?.atomic&&(0,w.hasFileAtomicReadCapability)(l)||!((0,w.hasOpenReadWriteCloseCapability)(l)||(0,w.hasFileReadStreamCapability)(l))||(0,w.hasReadWriteCapability)(l)&&r?.preferUnbuffered?s=this.readFileUnbuffered(l,u,r):(0,w.hasFileReadStreamCapability)(l)?s=this.readFileStreamed(l,u,i.token,r):s=this.readFileBuffered(l,u,i.token,r),{...await t,value:s}}catch(o){s&&await(0,S.consumeStream)(s);const c=(0,d.localize)(8,null,this.resourceForError(u),(0,w.ensureFileSystemProviderError)(o).toString());throw o instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(c,o.stat,r):new w.FileOperationError(c,(0,w.toFileOperationResult)(o),r)}}readFileStreamed(l,u,r,a=Object.create(null)){const i=l.readFileStream(u,a,r);return(0,S.transform)(i,{data:t=>t instanceof T.VSBuffer?t:T.VSBuffer.wrap(t),error:t=>new w.FileOperationError((0,d.localize)(9,null,this.resourceForError(u),(0,w.ensureFileSystemProviderError)(t).toString()),(0,w.toFileOperationResult)(t),a)},t=>T.VSBuffer.concat(t))}readFileBuffered(l,u,r,a=Object.create(null)){const i=(0,T.newWriteableBufferStream)();return(0,p.readFileIntoStream)(l,u,i,t=>t,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new w.FileOperationError((0,d.localize)(10,null,this.resourceForError(u),(0,w.ensureFileSystemProviderError)(t).toString()),(0,w.toFileOperationResult)(t),a)},r),i}readFileUnbuffered(l,u,r){const a=(0,S.newWriteableStream)(i=>T.VSBuffer.concat(i));return(async()=>{try{let i;r?.atomic&&(0,w.hasFileAtomicReadCapability)(l)?i=await l.readFile(u,{atomic:!0}):i=await l.readFile(u),typeof r?.position=="number"&&(i=i.slice(r.position)),typeof r?.length=="number"&&(i=i.slice(0,r.length)),this.validateReadFileLimits(u,i.byteLength,r),a.end(T.VSBuffer.wrap(i))}catch(i){a.error(i),a.end()}})(),a}async validateReadFile(l,u){const r=await this.resolve(l,{resolveMetadata:!0});if(r.isDirectory)throw new w.FileOperationError((0,d.localize)(11,null,this.resourceForError(l)),0,u);if(typeof u?.etag=="string"&&u.etag!==w.ETAG_DISABLED&&u.etag===r.etag)throw new w.NotModifiedSinceFileOperationError((0,d.localize)(12,null),r,u);return this.validateReadFileLimits(l,r.size,u),r}validateReadFileLimits(l,u,r){if(r?.limits){let a;if(typeof r.limits.memory=="number"&&u>r.limits.memory&&(a=9),typeof r.limits.size=="number"&&u>r.limits.size&&(a=7),typeof a=="number")throw new w.FileOperationError((0,d.localize)(13,null,this.resourceForError(l)),a)}}async canMove(l,u,r){return this.doCanMoveCopy(l,u,"move",r)}async canCopy(l,u,r){return this.doCanMoveCopy(l,u,"copy",r)}async doCanMoveCopy(l,u,r,a){if(l.toString()!==u.toString())try{const i=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(i,l,t,u,r,a)}catch(i){return i}return!0}async move(l,u,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),t=await this.doMoveCopy(a,l,i,u,"move",!!r),s=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,t==="move"?2:3,s)),s}async copy(l,u,r){const a=await this.withReadProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),t=await this.doMoveCopy(a,l,i,u,"copy",!!r),s=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,t==="copy"?3:2,s)),s}async doMoveCopy(l,u,r,a,i,t){if(u.toString()===a.toString())return i;const{exists:s,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(l,u,r,a,i,t);if(s&&!o&&t&&await this.del(a,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(a)),i==="copy"){if(l===r&&(0,w.hasFileFolderCopyCapability)(l))await l.copy(u,a,{overwrite:t});else{const c=await this.resolve(u);c.isDirectory?await this.doCopyFolder(l,c,r,a):await this.doCopyFile(l,u,r,a)}return i}else return l===r?(await l.rename(u,a,{overwrite:t}),i):(await this.doMoveCopy(l,u,r,a,"copy",t),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(l,u,r,a){if((0,w.hasOpenReadWriteCloseCapability)(l)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(l,u,r,a);if((0,w.hasOpenReadWriteCloseCapability)(l)&&(0,w.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(l,u,r,a);if((0,w.hasReadWriteCapability)(l)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(l,u,r,a);if((0,w.hasReadWriteCapability)(l)&&(0,w.hasReadWriteCapability)(r))return this.doPipeUnbuffered(l,u,r,a)}async doCopyFolder(l,u,r,a){await r.mkdir(a),Array.isArray(u.children)&&await n.Promises.settled(u.children.map(async i=>{const t=this.getExtUri(r).providerExtUri.joinPath(a,i.name);return i.isDirectory?this.doCopyFolder(l,await this.resolve(i.resource),r,t):this.doCopyFile(l,i.resource,r,t)}))}async doValidateMoveCopy(l,u,r,a,i,t){let s=!1;if(l===r){const{providerExtUri:c,isPathCaseSensitive:h}=this.getExtUri(l);if(h||(s=c.isEqual(u,a)),s&&i==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(u),this.resourceForError(a)));if(!s&&c.isEqualOrParent(a,u))throw new Error((0,d.localize)(15,null,this.resourceForError(u),this.resourceForError(a)))}const o=await this.exists(a);if(o&&!s){if(!t)throw new w.FileOperationError((0,d.localize)(16,null,this.resourceForError(u),this.resourceForError(a)),4);if(l===r){const{providerExtUri:c}=this.getExtUri(l);if(c.isEqualOrParent(u,a))throw new Error((0,d.localize)(17,null,this.resourceForError(u),this.resourceForError(a)))}}return{exists:o,isSameResourceWithDifferentPathCase:s}}getExtUri(l){const u=this.isPathCaseSensitive(l);return{providerExtUri:u?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(u,l);const r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,0,r)),r}async mkdirp(l,u){const r=[],{providerExtUri:a}=this.getExtUri(l);for(;!a.isEqual(u,a.dirname(u));)try{if(((await l.stat(u)).type&w.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(u)));break}catch(i){if((0,w.toFileSystemProviderErrorCode)(i)!==w.FileSystemProviderErrorCode.FileNotFound)throw i;r.push(a.basename(u)),u=a.dirname(u)}for(let i=r.length-1;i>=0;i--){u=a.joinPath(u,r[i]);try{await l.mkdir(u)}catch(t){if((0,w.toFileSystemProviderErrorCode)(t)!==w.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(l,u){try{await this.doValidateDelete(l,u)}catch(r){return r}return!0}async doValidateDelete(l,u){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!u?.useTrash&&!(r.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(l)));let i;try{i=await r.stat(l)}catch{}if(i)this.throwIfFileIsReadonly(l,i);else throw new w.FileOperationError((0,d.localize)(20,null,this.resourceForError(l)),1);if(!!!u?.recursive){const s=await this.resolve(l);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(l)))}return r}async del(l,u){const r=await this.doValidateDelete(l,u),a=!!u?.useTrash,i=!!u?.recursive;await r.delete(l,{recursive:i,useTrash:a}),this._onDidRunOperation.fire(new w.FileOperationEvent(l,1))}onDidChangeFile(l,u){this._onDidChangeFilesRaw.fire({changes:l});let r,a;{for(const i of l)this.nonRecursiveWatchedResources.has(i.resource)?(r||(r=[]),r.push(i)):(a||(a=[]),a.push(i));r&&this._onDidFilesChange.fire(new w.FileChangesEvent(r,!u))}if(a){const i=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(a)&&Xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(l,u={recursive:!1,excludes:[]}){const r=new C.DisposableStore;let a=!1,i=()=>{a=!0};return r.add((0,C.toDisposable)(()=>i())),(async()=>{try{const t=await this.doWatch(l,u);a?(0,C.dispose)(t):i=()=>(0,C.dispose)(t)}catch(t){this.logService.error(t)}})(),u.recursive||(this.nonRecursiveWatchedResources.set(l,(this.nonRecursiveWatchedResources.get(l)??0)+1),r.add((0,C.toDisposable)(()=>{const t=this.nonRecursiveWatchedResources.get(l);typeof t=="number"&&(t<=1?this.nonRecursiveWatchedResources.delete(l):this.nonRecursiveWatchedResources.set(l,t-1))}))),r}async doWatch(l,u){const r=await this.withProvider(l),a=this.toWatchKey(r,l,u);let i=this.activeWatchers.get(a);return i||(i={count:0,disposable:r.watch(l,u)},this.activeWatchers.set(a,i)),i.count+=1,(0,C.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,C.dispose)(i.disposable),this.activeWatchers.delete(a)))})}toWatchKey(l,u,r){const{providerExtUri:a}=this.getExtUri(l);return[a.getComparisonKey(u),String(r.recursive),r.excludes.join()].join()}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,C.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,u,r,a){return this.writeQueue.queueFor(u,this.getExtUri(l).providerExtUri).queue(async()=>{const i=await l.open(u,{create:!0,unlock:r?.unlock??!1});try{(0,S.isReadableStream)(a)||(0,S.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(l,i,a):await this.doWriteReadableBufferedQueued(l,i,a)}catch(t){throw(0,w.ensureFileSystemProviderError)(t)}finally{await l.close(i)}})}async doWriteStreamBufferedQueued(l,u,r){let a=0,i;if((0,S.isReadableBufferedStream)(r)){if(r.buffer.length>0){const t=T.VSBuffer.concat(r.buffer);await this.doWriteBuffer(l,u,t,t.byteLength,a,0),a+=t.byteLength}if(r.ended)return;i=r.stream}else i=r;return new Promise((t,s)=>{(0,S.listenStream)(i,{onData:async o=>{i.pause();try{await this.doWriteBuffer(l,u,o,o.byteLength,a,0)}catch(c){return s(c)}a+=o.byteLength,setTimeout(()=>i.resume())},onError:o=>s(o),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(l,u,r){let a=0,i;for(;(i=r.read())!==null;)await this.doWriteBuffer(l,u,i,i.byteLength,a,0),a+=i.byteLength}async doWriteBuffer(l,u,r,a,i,t){let s=0;for(;s<a;)s+=await l.write(u,i+s,r.buffer,t+s,a-s)}async doWriteUnbuffered(l,u,r,a){return this.writeQueue.queueFor(u,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,u,r,a))}async doWriteUnbufferedQueued(l,u,r,a){let i;a instanceof T.VSBuffer?i=a:(0,S.isReadableStream)(a)?i=await(0,T.streamToBuffer)(a):(0,S.isReadableBufferedStream)(a)?i=await(0,T.bufferedStreamToBuffer)(a):i=(0,T.readableToBuffer)(a),await l.writeFile(u,i.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(l,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,u,r,a))}async doPipeBufferedQueued(l,u,r,a){let i,t;try{i=await l.open(u,{create:!1}),t=await r.open(a,{create:!0,unlock:!1});const s=T.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,c=0,h=0;do h=await l.read(i,o,s.buffer,c,s.byteLength-c),await this.doWriteBuffer(r,t,s,h,o,c),o+=h,c+=h,c===s.byteLength&&(c=0);while(h>0)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await n.Promises.settled([typeof i=="number"?l.close(i):Promise.resolve(),typeof t=="number"?r.close(t):Promise.resolve()])}}async doPipeUnbuffered(l,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,u,r,a))}async doPipeUnbufferedQueued(l,u,r,a){return r.writeFile(a,await l.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,u,r,a))}async doPipeUnbufferedToBufferedQueued(l,u,r,a){const i=await r.open(a,{create:!0,unlock:!1});try{const t=await l.readFile(u);await this.doWriteBuffer(r,i,T.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,w.ensureFileSystemProviderError)(t)}finally{await r.close(i)}}async doPipeBufferedToUnbuffered(l,u,r,a){const i=await(0,T.streamToBuffer)(this.readFileBuffered(l,u,_.CancellationToken.None));await this.doWriteUnbuffered(r,a,void 0,i)}throwIfFileSystemIsReadonly(l,u){if(l.capabilities&2048)throw new w.FileOperationError((0,d.localize)(22,null,this.resourceForError(u)),6);return l}throwIfFileIsReadonly(l,u){if((u.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,d.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===P.Schemas.file?l.fsPath:l.toString(!0)}};y.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},y=de([X(0,v.ILogService)],y),e.FileService=y}),define(ne[178],ie([0,1,50,251,5,39,17,3,41,2,9,4,19,40,22,139,14,82,166,167,175,37]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v,y,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(L)}catch(a){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(a)}`)}})();class r extends l.AbstractDiskFileSystemProvider{constructor(i,t){super(i);this.options=t,this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new _.ResourceMap(s=>f.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:t,symbolicLink:s}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(i){try{const t=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,f.joinPath)(i,o.name))).type:c=this.toType(o),s.push([o.name,c])}catch(c){this.logService.trace(c)}})),s}catch(t){throw this.toFileSystemProviderError(t)}}toType(i,t){let s;return t?.dangling?s=p.FileType.Unknown:i.isFile()?s=p.FileType.File:i.isDirectory()?s=p.FileType.Directory:s=p.FileType.Unknown,t&&(s|=p.FileType.SymbolicLink),s}async createResourceLock(i){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(i)})`);let t;for(;t=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(i)})`),await t.wait();const s=new T.Barrier;return this.resourceLocks.set(i,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(i)})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(i)})`),this.resourceLocks.delete(i),s.open()})}async readFile(i,t){let s;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const o=this.toFilePath(i);return await d.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{s?.dispose()}}readFileStream(i,t,s){const o=(0,S.newWriteableStream)(c=>k.VSBuffer.concat(c.map(h=>k.VSBuffer.wrap(h))).buffer);return(0,v.readFileIntoStream)(this,i,o,c=>c.buffer,{...t,bufferSize:256*1024},s),o}async writeFile(i,t,s){let o;try{const c=this.toFilePath(i);if(!s.create||!s.overwrite){if(await d.Promises.exists(c)){if(!s.overwrite)throw(0,p.createFileSystemProviderError)((0,w.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,p.createFileSystemProviderError)((0,w.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(o,0,t,0,t.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(i,c)}finally{typeof o=="number"&&await this.close(o)}}async open(i,t){let s;(0,p.isFileOpenForWriteOptions)(t)&&(s=await this.createResourceLock(i));let o;try{const c=this.toFilePath(i);if((0,p.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:m}=await d.SymlinkSupport.stat(c);m.mode&128||await d.Promises.chmod(c,m.mode|128)}catch(m){this.logService.trace(m)}let h;if((0,p.isFileOpenForWriteOptions)(t)){if(b.isWindows)try{await d.Promises.truncate(c,0),h="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}h||(h="w")}else h="r";o=await d.Promises.open(c,h)}catch(c){throw s?.dispose(),(0,p.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(i,c):this.toFileSystemProviderError(c)}return this.mapHandleToPos.set(o,0),(0,p.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(o,i),s&&this.mapHandleToLock.set(o,s),o}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await d.Promises.fdatasync(i)}catch(t){this.canFlush=!1,this.logService.error(t)}return await d.Promises.close(i)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(i);t&&(this.mapHandleToLock.delete(i),t.dispose())}}async read(i,t,s,o,c){const h=this.normalizePos(i,t);let m=null;try{const I=await d.Promises.read(i,s,o,c,h);return typeof I=="number"?m=I:m=I.bytesRead,m}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(i,h,m)}}normalizePos(i,t){return t===this.mapHandleToPos.get(i)?null:t}updatePos(i,t,s){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof t=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,o+s):this.mapHandleToPos.delete(i)))}async write(i,t,s,o,c){return(0,T.retry)(()=>this.doWrite(i,t,s,o,c),100,3)}async doWrite(i,t,s,o,c){const h=this.normalizePos(i,t);let m=null;try{const I=await d.Promises.write(i,s,o,c,h);return typeof I=="number"?m=I:m=I.bytesWritten,m}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),I)}finally{this.updatePos(i,h,m)}}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(i,t){try{const s=this.toFilePath(i);t.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,t,s){const o=this.toFilePath(i),c=this.toFilePath(t);if(o!==c)try{await this.validateTargetDeleted(i,t,"move",s.overwrite),await d.Promises.move(o,c)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,w.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(c)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(i,t,s){const o=this.toFilePath(i),c=this.toFilePath(t);if(o!==c)try{await this.validateTargetDeleted(i,t,"copy",s.overwrite),await d.Promises.copy(o,c,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,w.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(c)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(i,t,s,o){const c=this.toFilePath(i),h=this.toFilePath(t);let m=!1;if(!!(this.capabilities&1024)||(m=(0,C.isEqual)(c,h,!0)),m&&s==="copy")throw(0,p.createFileSystemProviderError)((0,w.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(!m&&await d.Promises.exists(h)){if(!o)throw(0,p.createFileSystemProviderError)((0,w.localize)(5,null),p.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(i,t,s){return new g.ParcelWatcherClient(o=>i(o),o=>t(o),s)}doWatch(i,t){const s=this.options?.watcher?.usePolling;if(s===!0)for(const o of t)o.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(s))for(const o of t)s.includes(o.path)&&(o.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(i,t)}createNonRecursiveWatcher(i,t,s,o){return new y.NodeJSFileWatcher(i,c=>t(c),c=>s(c),o)}toFileSystemProviderError(i){if(i instanceof p.FileSystemProviderError)return i;let t;switch(i.code){case"ENOENT":t=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=p.FileSystemProviderErrorCode.NoPermissions;break;default:t=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(i,t){let s=this.toFileSystemProviderError(t);if(i&&s.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await d.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(s=(0,p.createFileSystemProviderError)(t,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return s}}e.DiskFileSystemProvider=r}),define(ne[84],ie([0,1,3,7,10]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class _{constructor(f){this.service=f,this.onDidChangeLogLevel=L.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(f,S,d){switch(S){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=_;class k{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){k.setLevel(this.channel,f)}static setLevel(f,S){return f.call("setLevel",S)}}e.LogLevelChannelClient=k;class R{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,S){throw new Error(`Event not found: ${S}`)}async call(f,S,d){switch(S){case"createLogger":this.createLogger(n.URI.revive(d[0]),d[1]);return;case"log":return this.log(n.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${S}`)}createLogger(f,S){this.loggers.set(f.toString(),this.loggerService.createLogger(f,S))}consoleLog(f,S){let d=console.log;switch(f){case T.LogLevel.Error:d=console.error;break;case T.LogLevel.Warning:d=console.warn;break;case T.LogLevel.Info:d=console.info;break}d.call(console,...S)}log(f,S){const d=this.loggers.get(f.toString());if(!d)throw new Error("Create the logger before logging");for(const[w,p]of S)(0,T.log)(d,w,p)}}e.LoggerChannel=R;class C extends T.AbstractLoggerService{constructor(f,S,d){super(f,S);this.channel=d}createConsoleMainLogger(){return new T.AdapterLogger({log:(f,S)=>{this.channel.call("consoleLog",[f,S])}})}doCreateLogger(f,S,d){return new E(this.channel,f,S,d)}}e.LoggerChannelClient=C;class E extends T.AbstractMessageLogger{constructor(f,S,d,w){super(w?.always);this.channel=f,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[S,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,S){const d=[[f,S]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(f){this.channel.call("log",[this.file,f])}}class P extends T.LogService{constructor(f,S){super(S);this.parent=f,this._register(f.onDidChangeLogLevel(d=>S.setLevel(d)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=P}),define(ne[60],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(ne[85],ie([0,1,18,4,31,19]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const R=n.globals.vscode.context.configuration();if(R)k=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const R=(0,_.dirname)(L.FileAccess.asFileUri("",J));k=J.__$__nodeRequire((0,_.joinPath)(R,"product.json").fsPath);const C=J.__$__nodeRequire((0,_.joinPath)(R,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:C.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(ne[26],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[179],ie([0,1,5,8,2,9,22,10,26]),function(J,e,L,n,T,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends T.Disposable{constructor(b,f,S){super();this.productService=f,this.logService=S,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpCodeCaches(b)},30*1e3)).schedule()}async cleanUpCodeCaches(b){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),S=(0,_.dirname)(b),d=(0,_.basename)(b),w=await k.Promises.readdir(S);await Promise.all(w.map(async p=>{if(p===d)return;const v=(0,_.join)(S,p),y=await k.Promises.stat(v);if(y.isDirectory()&&f-y.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${p}.`),k.Promises.rm(v)}))}catch(f){(0,n.onUnexpectedError)(f)}}};E=de([X(1,C.IProductService),X(2,R.ILogService)],E),e.CodeCacheCleaner=E}),define(ne[180],ie([0,1,5,8,2,9,22,13,10,26]),function(J,e,L,n,T,_,k,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends T.Disposable{constructor(f,S,d){super();this.environmentService=f,this.logService=S,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),S=JSON.parse(await k.Promises.readFile((0,_.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let y of Object.keys(S)){const g=S[y];f[`${g.hash}.${y}`]=!0}const d=(0,_.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(d))return;const p=await k.Promises.readdir(d);for(const y of p){if(f[y]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${y}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${y}`),await k.Promises.rm((0,_.join)(d,y))}const v=Date.now();for(const y of Object.keys(f)){const g=(0,_.join)(d,y),l=await k.Promises.readdir(g);for(const u of l){if(u==="tcf.json")continue;const r=(0,_.join)(g,u),a=await k.Promises.stat(r);a.isDirectory()&&v-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,_.join)(y,u)}`),await k.Promises.rm(r))}}}catch(f){(0,n.onUnexpectedError)(f)}}};P=de([X(0,R.INativeEnvironmentService),X(1,C.ILogService),X(2,E.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(ne[181],ie([0,1,9,6]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var T;(function(_){function k(R,C="noAbsolutePaths"){for(const E of R.nodes)E.callFrame&&E.callFrame.url&&((0,L.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(E.callFrame.url))&&(E.callFrame.url=(0,L.join)(C,(0,L.basename)(E.callFrame.url)));return R}_.rewriteAbsolutePaths=k})(T=e.Utils||(e.Utils={}))}),define(ne[182],ie([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(_){const R=await(await new Promise((E,P)=>{J(["v8-inspect-profiler"],E,P)})).startProfiling({port:_.port,checkForPaused:!0}),C=(0,L.generateUuid)();return this._sessions.set(C,R),C}async stopProfiling(_){const k=this._sessions.get(_);if(!k)throw new Error(`UNKNOWN session '${_}'`);const R=await k.stop();return this._sessions.delete(_),R.profile}}e.InspectProfilingService=n}),define(ne[38],ie([0,1,98,15]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(k,R){L.ok(n.isString(k)),L.ok(n.isObject(R)),L.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,R)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new T}),define(ne[86],ie([0,1,3,38]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class _{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,E){this.schemasById[T(C)]=E,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new _;n.Registry.add(e.Extensions.JSONContribution,k)}),define(ne[42],ie([0,1,16,3,15,125,86,38]),function(J,e,L,n,T,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=R.Registry.as(k.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,r=!0){this.registerConfigurations([u],r)}registerConfigurations(u,r=!0){const a=this.doRegisterConfigurations(u,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(u){const r=this.doDeregisterConfigurations(u);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:u,remove:r}){const a=[];a.push(...this.doDeregisterConfigurations(r)),a.push(...this.doRegisterConfigurations(u,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,L.distinct)(a)})}registerDefaultConfigurations(u){const r=[],a=[];for(const{overrides:i,source:t}of u)for(const s in i)if(r.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o={...this.configurationDefaultsOverrides.get(s)?.value||{},...i[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:o});const c={type:"object",default:o,description:_.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:T.isString(t)?void 0:t};a.push(...d(s)),this.configurationProperties[s]=c,this.defaultLanguageConfigurationOverridesNode.properties[s]=c}else{this.configurationDefaultsOverrides.set(s,{value:i[s],source:t});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(u){const r=[];for(const{overrides:a,source:i}of u)for(const t in a){const s=this.configurationDefaultsOverrides.get(t),o=T.isString(i)?i:i?.id,c=T.isString(s?.source)?s?.source:s?.source?.id;if(o===c)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const h=this.configurationProperties[t];h&&(this.updatePropertyDefaultValue(t,h),this.updateSchema(t,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const r of u)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,r){const a=[];return u.forEach(i=>{a.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),a}doDeregisterConfigurations(u){const r=[],a=i=>{if(i.properties)for(const t in i.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,i.properties[t]);i.allOf&&i.allOf.forEach(t=>a(t))};for(const i of u){a(i);const t=this.configurationContributors.indexOf(i);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(u,r=!0,a,i,t=3){t=T.isUndefinedOrNull(u.scope)?t:u.scope;let s=[],o=u.properties;if(o)for(let h in o){if(r&&y(h)){delete o[h];continue}const m=o[h];if(m.source=a,m.defaultDefaultValue=o[h].default,this.updatePropertyDefaultValue(h,m),e.OVERRIDE_PROPERTY_REGEX.test(h)?m.scope=void 0:(m.scope=T.isUndefinedOrNull(m.scope)?t:m.scope,m.restricted=T.isUndefinedOrNull(m.restricted)?!!i?.includes(h):m.restricted),o[h].hasOwnProperty("included")&&!o[h].included){this.excludedConfigurationProperties[h]=o[h],delete o[h];continue}else this.configurationProperties[h]=o[h];!o[h].deprecationMessage&&o[h].markdownDeprecationMessage&&(o[h].deprecationMessage=o[h].markdownDeprecationMessage),s.push(h)}let c=u.allOf;if(c)for(let h of c)s.push(...this.validateAndRegisterProperties(h,r,a,i,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(u){const r=a=>{let i=a.properties;if(i)for(const s in i)this.updateSchema(s,i[s]);let t=a.allOf;t&&t.forEach(r)};r(u)}updateSchema(u,r){switch(e.allSettings.properties[u]=r,r.scope){case 1:e.applicationSettings.properties[u]=r;break;case 2:e.machineSettings.properties[u]=r;break;case 6:e.machineOverridableSettings.properties[u]=r;break;case 3:e.windowSettings.properties[u]=r;break;case 4:e.resourceSettings.properties[u]=r;break;case 5:e.resourceSettings.properties[u]=r,this.resourceLanguageSettingsSchema.properties[u]=r;break}}removeFromSchema(u,r){switch(delete e.allSettings.properties[u],r.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u],delete this.resourceLanguageSettingsSchema.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const r=`[${u}]`,a={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:_.localize(4,null),errorMessage:_.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,r){const a=this.configurationDefaultsOverrides.get(u);let i=a?.value,t=a?.source;T.isUndefined(i)&&(i=r.defaultDefaultValue,t=void 0),T.isUndefined(i)&&(i=p(r.type)),r.default=i,r.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",S=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(l){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let r=S.exec(l);for(;r?.length;){const a=r[1].trim();a&&u.push(a),r=S.exec(l)}}return(0,L.distinct)(u)}e.overrideIdentifiersFromKey=d;function w(l){return l.reduce((u,r)=>`${u}[${r}]`,"")}e.keyFromOverrideIdentifiers=w;function p(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const v=new b;R.Registry.add(e.Extensions.Configuration,v);function y(l){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?_.localize(7,null,l):v.getConfigurationProperties()[l]!==void 0?_.localize(8,null,l):null:_.localize(6,null)}e.validateProperty=y;function g(){const l=[],u=v.getConfigurationProperties();for(const r of Object.keys(u))l.push([r,u[r].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=g}),define(ne[87],ie([0,1,16,3,35,2,39,28,15,7,20,42,38]),function(J,e,L,n,T,_,k,R,C,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(i={},t=[],s=[]){this._contents=i,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const s=this.getContentsForOverrideIdentifer(t);return s?i?(0,P.getConfigurationValue)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const s of this.overrides)s.identifiers.includes(i)&&t.push(...s.keys);return L.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return L.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=R.deepClone(this.contents),s=R.deepClone(this.overrides),o=[...this.keys];for(const c of i){this.mergeContents(t,c.contents);for(const h of c.overrides){const[m]=s.filter(I=>L.equals(I.identifiers,h.identifiers));m?(this.mergeContents(m.contents,h.contents),m.keys.push(...h.keys),m.keys=L.distinct(m.keys)):s.push(R.deepClone(h))}for(const h of c.keys)o.indexOf(h)===-1&&o.push(h)}return new S(t,o,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const o of L.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o],h=t[o];h&&(typeof c=="object"&&typeof h=="object"?(c=R.deepClone(c),this.mergeContents(c,h)):c=h),s[o]=c}return new S(s,this.keys,this.overrides)}mergeContents(i,t){for(const s of Object.keys(t)){if(s in i&&C.isObject(i[s])&&C.isObject(t[s])){this.mergeContents(i[s],t[s]);continue}i[s]=R.deepClone(t[s])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?R.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,s=null;const o=c=>{c&&(s?this.mergeContents(s,c):s=R.deepClone(c))};for(const c of this.overrides)L.equals(c.identifiers,[i])?t=c.contents:c.identifiers.includes(i)&&o(c.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,P.addToValueTree)(this.contents,i,t,s=>{throw new Error(s)})}removeValue(i){this.removeKey(i)&&(0,P.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let s=0;s<t;s++)i.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=S;class d extends S{constructor(i={}){const t=f.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),o=Object.create(null),c=[];for(const h in t){const m=i[h],I=m!==void 0?m:t[h].default;(0,P.addToValueTree)(o,h,I,O=>console.error(`Conflict in default settings: ${O}`))}for(const h of Object.keys(o))b.OVERRIDE_PROPERTY_REGEX.test(h)&&c.push({identifiers:(0,b.overrideIdentifiersFromKey)(h),keys:Object.keys(o[h]),contents:(0,P.toValuesTree)(o[h],m=>console.error(`Conflict in default settings file: ${m}`))});super(o,s,c)}}e.DefaultConfigurationModel=d;class w{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!C.isUndefinedOrNull(i)){const s=this.doParseContent(i);this.parseRaw(s,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:s,keys:o,overrides:c,restricted:h}=this.doParseRaw(i,t);this._configurationModel=new S(s,o,c),this._restrictedConfigurations=h||[]}doParseContent(i){let t={},s=null,o=[],c=[],h=[];function m(O){Array.isArray(o)?o.push(O):s!==null&&(o[s]=O)}let I={onObjectBegin:()=>{let O={};m(O),c.push(o),o=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{let O=[];m(O),c.push(o),o=O,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:m,onError:(O,A,N)=>{h.push({error:O,offset:A,length:N})}};if(i)try{T.visit(i,I),t=o[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return t}doParseRaw(i,t){const s=f.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,s,!0,t);i=o.raw;const c=(0,P.toValuesTree)(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),h=Object.keys(i),m=this.toOverrides(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:c,keys:h,overrides:m,restricted:o.restricted}}filter(i,t,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const c={},h=[];for(let m in i)if(b.OVERRIDE_PROPERTY_REGEX.test(m)&&s){const I=this.filter(i[m],t,!1,o);c[m]=I.raw,h.push(...I.restricted)}else{const I=t[m],O=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&h.push(m),(O===void 0||o.scopes===void 0||o.scopes.includes(O))&&(o.skipRestricted&&I?.restricted||(c[m]=i[m]))}return{raw:c,restricted:h}}toOverrides(i,t){const s=[];for(const o of Object.keys(i))if(b.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const h in i[o])c[h]=i[o][h];s.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,P.toValuesTree)(c,t)})}return s}}e.ConfigurationModelParser=w;class p extends _.Disposable{constructor(i,t,s,o){super();this.userSettingsResource=i,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class v{constructor(i,t,s=new S,o=new S,c=new k.ResourceMap,h=new S,m=new k.ResourceMap,I=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=m,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(i,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(i)}updateValue(i,t,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new S,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(i):o.setValue(i,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,s){const o=this.getConsolidateConfigurationModel(t,s),c=this.getFolderConfigurationModelForResource(t.resource,s),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,m=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),I=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),O=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),A=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),N=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,$=c?t.overrideIdentifier?c.freeze().override(t.overrideIdentifier).getValue(i):c.freeze().getValue(i):void 0,D=t.overrideIdentifier?h.override(t.overrideIdentifier).getValue(i):h.getValue(i),M=o.getValue(i),W=L.distinct(L.flatten(o.overrides.map(U=>U.identifiers))).filter(U=>o.getOverrideValue(i,U)!==void 0);return{defaultValue:m,userValue:I,userLocalValue:O,userRemoteValue:A,workspaceValue:N,workspaceFolderValue:$,memoryValue:D,value:M,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:c?.freeze().getValue(i),override:t.overrideIdentifier?c?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:D!==void 0?{value:h.getValue(i),override:t.overrideIdentifier?h.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const s=[];if(!t){const{added:o,updated:c,removed:h}=u(this._defaultConfiguration,i);t=[...o,...c,...h]}for(const o of t)for(const c of(0,b.overrideIdentifiersFromKey)(o)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(c),m=i.getKeysForOverrideIdentifier(c),I=[...m.filter(O=>h.indexOf(O)===-1),...h.filter(O=>m.indexOf(O)===-1),...h.filter(O=>!R.equals(this._defaultConfiguration.override(c).getValue(O),i.override(c).getValue(O)))];s.push([c,I])}return this.updateDefaultConfiguration(i),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=u(this.localUserConfiguration,i),h=[...t,...s,...o];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=u(this.remoteUserConfiguration,i);let h=[...t,...s,...o];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=u(this.workspaceConfiguration,i);let h=[...t,...s,...o];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:c}}compareAndUpdateFolderConfiguration(i,t){const s=this.folderConfigurations.get(i),{added:o,updated:c,removed:h,overrides:m}=u(s,t);let I=[...o,...c,...h];return(I.length||!s)&&this.updateFolderConfiguration(i,t),{keys:I,overrides:m}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:o,removed:c,overrides:h}=u(t,void 0);return{keys:[...s,...o,...c],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let s=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?s.override(i.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:i},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const o=t.getFolder(i);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const c=this._memoryConfigurationByResource.get(i);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(t=s.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=s}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const s=t.getFolder(i);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:s,overrides:o,keys:c}=this._folderConfigurations.get(t);return i.push([t,{contents:s,overrides:o,keys:c}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>i.add(s))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),s=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((h,m)=>(h.set(E.URI.revive(m[0]),this.parseConfigurationModel(m[1])),h),new k.ResourceMap);return new v(t,s,new S,o,c,new S,new k.ResourceMap,!1)}static parseConfigurationModel(i){return new S(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=v;function y(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,t=new Map;for(const o of a)o.keys.forEach(c=>i.add(c)),o.overrides.forEach(([c,h])=>{const m=(0,k.getOrSet)(t,c,new Set);h.forEach(I=>m.add(I))});const s=[];return t.forEach((o,c)=>s.push([c,[...o.values()]])),{keys:[...i.values()],overrides:s}}e.mergeChanges=y;class g{constructor(i,t,s,o){this.change=i,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;i.keys.forEach(m=>c.add(m)),i.overrides.forEach(([,m])=>m.forEach(I=>c.add(I))),this.affectedKeys=[...c.values()];const h=new S;this.affectedKeys.forEach(m=>h.setValue(m,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!R.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let s=(0,P.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(i=i[o],!i)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=g;class l extends g{constructor(i,t,s,o){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=l;function u(a,i){const{added:t,removed:s,updated:o}=r(i,a),c=[],h=a?.getAllOverrideIdentifiers()||[],m=i?.getAllOverrideIdentifiers()||[];if(i){const I=m.filter(O=>!h.includes(O));for(const O of I)c.push([O,i.getKeysForOverrideIdentifier(O)])}if(a){const I=h.filter(O=>!m.includes(O));for(const O of I)c.push([O,a.getKeysForOverrideIdentifier(O)])}if(i&&a){for(const I of h)if(m.includes(I)){const O=r({contents:a.getOverrideValue(void 0,I)||{},keys:a.getKeysForOverrideIdentifier(I)},{contents:i.getOverrideValue(void 0,I)||{},keys:i.getKeysForOverrideIdentifier(I)});c.push([I,[...O.added,...O.removed,...O.updated]])}}return{added:t,removed:s,updated:o,overrides:c}}function r(a,i){const t=a?i?a.keys.filter(c=>i.keys.indexOf(c)===-1):[...a.keys]:[],s=i?a?i.keys.filter(c=>a.keys.indexOf(c)===-1):[...i.keys]:[],o=[];if(a&&i){for(const c of i.keys)if(a.keys.indexOf(c)!==-1){const h=(0,P.getConfigurationValue)(i.contents,c),m=(0,P.getConfigurationValue)(a.contents,c);R.equals(h,m)||o.push(c)}}return{added:t,removed:s,updated:o}}}),define(ne[183],ie([0,1,5,3,2,19,20,87,42,38]),function(J,e,L,n,T,_,k,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends T.Disposable{constructor(f,S){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,_.extUriBiasedIgnorePathCase,S)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:d})=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,S){const d=typeof f=="string"?f:void 0,w=(0,k.isConfigurationOverrides)(f)?f:(0,k.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(d,w,void 0)}updateValue(f,S,d,w){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const S=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(d,S,1)}onDidDefaultConfigurationChange(f){const S=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,f);this.trigger(d,S,6)}trigger(f,S,d){const w=new R.ConfigurationChangeEvent(f,{data:S},this.configuration);w.source=d,w.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(ne[184],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var n;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(k,R=n.Unknown,C){super(k);this._message=k,this._code=R,this._detail=C,this.isHandled=R===n.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(k){return k instanceof T&&k._code===n.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof T&&k._code===n.NoResolverFound}static isHandled(k){return k instanceof T&&k.isHandled}}e.RemoteAuthorityResolverError=T}),define(ne[185],ie([0,1,5,17,25,8,3,2,29,71,184]),function(J,e,L,n,T,_,k,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var f;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function S(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(H){const Z=new T.CancellationTokenSource;return setTimeout(()=>Z.cancel(),H),Z.token}function w(H,Z){if(H.isCancellationRequested||Z.isCancellationRequested)return T.CancellationToken.Cancelled;const K=new T.CancellationTokenSource;return H.onCancellationRequested(()=>K.cancel()),Z.onCancellationRequested(()=>K.cancel()),K.token}class p{constructor(Z){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((K,F)=>{this._resolvePromise=K,this._rejectPromise=F}),Z.isCancellationRequested?this._timeout():this._disposables.add(Z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Z){this._state==="pending"?this._disposables.add(Z):Z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Z))}reject(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Z))}}function v(H,Z){const K=new p(Z);return K.registerDisposable(H.onControlMessage(F=>{const j=JSON.parse(F.toString()),B=x(j);B?K.reject(B):K.resolve(j)})),K.promise}function y(H,Z,K,F,j,B,z){const V=new p(z);return Z.connect(K,F,j,B,(te,se)=>{V.didTimeout?(te&&H.error(te),se?.dispose()):te||!se?V.reject(te):V.resolve(se)}),V.promise}function g(H,Z){const K=new p(Z);return H.then(F=>{K.didTimeout||K.resolve(F)},F=>{K.didTimeout||K.reject(F)}),K.promise}async function l(H,Z,K,F){const j=q(H,Z);H.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let B;try{B=await y(H.logService,H.socketFactory,H.host,H.port,`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,`renderer-${S(Z)}-${H.reconnectionToken}`,F)}catch(ce){throw H.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ce),ce}H.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let z,V;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(B,null),z=H.reconnectionProtocol,V=!1):(z=new E.PersistentProtocol(B,null),V=!0),H.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const te=await g(H.signService.createNewMessage((0,C.generateUuid)()),F),se={type:"auth",auth:H.connectionToken||"00000000000000000000",data:te.data};z.sendControl(n.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await v(z,w(F,d(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(H.logService.trace(`${j} 4/6. received SignRequest control message.`),!await g(H.signService.validate(te,ce.signedData),F)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const me=await g(H.signService.sign(ce.data),F),ve={type:"connectionType",commit:H.commit,signedData:me,desiredConnectionType:Z};return K&&(ve.args=K),H.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(n.VSBuffer.fromString(JSON.stringify(ve))),{protocol:z,ownsProtocol:V}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(H.logService.error(`${j} the handshake timed out. Error:`),H.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${j} received error control message when negotiating connection. Error:`),H.logService.error(ce)),V&&U(z),ce}}async function u(H,Z,K,F){const j=Date.now(),B=q(H,Z),{protocol:z,ownsProtocol:V}=await l(H,Z,K,F),te=new p(F);return te.registerDisposable(z.onControlMessage(se=>{const ce=JSON.parse(se.toString()),he=x(ce);he?(H.logService.error(`${B} received error control message when negotiating connection. Error:`),H.logService.error(he),V&&U(z),te.reject(he)):(H.reconnectionProtocol&&H.reconnectionProtocol.endAcceptReconnection(),H.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${Y(j)}!`),te.resolve({protocol:z,firstMessage:ce}))})),te.promise}async function r(H,Z){const{protocol:K}=await u(H,1,void 0,Z);return{protocol:K}}async function a(H,Z,K){const{protocol:F,firstMessage:j}=await u(H,2,Z,K),B=j&&j.debugPort;return{protocol:F,debugPort:B}}async function i(H,Z,K){const F=Date.now(),j=q(H,3),{protocol:B}=await l(H,3,Z,K);return H.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${Y(F)}!`),B}async function t(H,Z,K){const{host:F,port:j,connectionToken:B}=await H.addressProvider.getAddress();return{commit:H.commit,host:F,port:j,connectionToken:B,reconnectionToken:Z,reconnectionProtocol:K,socketFactory:H.socketFactory,signService:H.signService,logService:H.logService}}async function s(H,Z,K){try{const F=(0,C.generateUuid)(),j=await t(H,F,null),{protocol:B}=await r(j,T.CancellationToken.None);return new M(H,Z,K,F,B)}catch(F){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(F),D.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(F)),F}}e.connectRemoteAgentManagement=s;async function o(H,Z){try{const K=(0,C.generateUuid)(),F=await t(H,K,null),{protocol:j,debugPort:B}=await a(F,Z,T.CancellationToken.None);return new W(H,Z,K,j,B)}catch(K){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(K),D.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentExtensionHost=o;async function c(H,Z,K){const F=await t(H,(0,C.generateUuid)(),null);return await i(F,{host:Z,port:K},T.CancellationToken.None)}e.connectRemoteAgentTunnel=c;function h(H){return(0,L.createCancelablePromise)(Z=>new Promise((K,F)=>{const j=setTimeout(K,H*1e3);Z.onCancellationRequested(()=>{clearTimeout(j),K()})}))}var m;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(m=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class I{constructor(Z,K){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.type=0}}e.ConnectionLostEvent=I;class O{constructor(Z,K,F,j){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.durationSeconds=F,this.cancellableTimer=j,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class A{constructor(Z,K,F){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.attempt=F,this.type=2}}e.ReconnectionRunningEvent=A;class N{constructor(Z,K,F){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.attempt=F,this.type=4}}e.ConnectionGainEvent=N;class ${constructor(Z,K,F,j){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.attempt=F,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class D extends R.Disposable{constructor(Z,K,F,j){super();this._connectionType=Z,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=K,this.reconnectionToken=F,this.protocol=j,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(j.onSocketClose(B=>{const z=G(this._connectionType,this.reconnectionToken,!0);B?B.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${B.hadError}).`),B.error&&this._options.logService.error(B.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this._options.logService.error(B.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register(j.onSocketTimeout(()=>{const B=G(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} received socket timeout event.`),this._beginReconnecting()})),D._instances.push(this),D._permanentFailure&&this._gotoPermanentFailure(D._permanentFailureMillisSinceLastIncomingData,D._permanentFailureAttempt,D._permanentFailureHandled)}static triggerPermanentFailure(Z,K,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Z,this._permanentFailureAttempt=K,this._permanentFailureHandled=F,this._instances.forEach(j=>j._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Z=>Z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Z=>Z._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(D._permanentFailure)return;const Z=G(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const K=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const j=F<K.length?K[F]:K[K.length-1];try{if(j>0){const z=h(j);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,z)),this._options.logService.info(`${Z} waiting for ${j} seconds before reconnecting...`);try{await z}catch{}}if(D._permanentFailure){this._options.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${Z} resolving connection...`);const B=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Z} connecting to ${B.host}:${B.port}...`),await this._reconnect(B,d(b)),this._options.logService.info(`${Z} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(B),D.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(B),D.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this._options.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this._options.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((0,_.isPromiseCanceledError)(B)){this._options.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if(B instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(B),D.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,P.RemoteAuthorityResolverError.isHandled(B));break}this._options.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(B),D.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!D._permanentFailure)}_gotoPermanentFailure(Z,K,F){this._onDidStateChange.fire(new $(this.reconnectionToken,Z,K,F)),U(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=D,D._permanentFailure=!1,D._permanentFailureMillisSinceLastIncomingData=0,D._permanentFailureAttempt=0,D._permanentFailureHandled=!1,D._instances=[];class M extends D{constructor(Z,K,F,j,B){super(1,Z,j,B);this.client=this._register(new E.Client(B,{remoteAuthority:K,clientId:F},Z.ipcLogger))}async _reconnect(Z,K){await r(Z,K)}}e.ManagementPersistentConnection=M;class W extends D{constructor(Z,K,F,j,B){super(2,Z,F,j);this._startArguments=K,this.debugPort=B}async _reconnect(Z,K){await a(Z,this._startArguments,K)}}e.ExtensionHostPersistentConnection=W;function U(H){try{H.acceptDisconnect();const Z=H.getSocket();H.dispose(),Z.dispose()}catch(Z){(0,_.onUnexpectedError)(Z)}}function x(H){if(H&&H.type==="error"){const Z=new Error(`Connection error: ${H.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function ee(H,Z){for(;H.length<Z;)H+=" ";return H}function G(H,Z,K){return`[remote-connection][${ee(S(H),13)}][${Z.substr(0,5)}\u2026][${K?"reconnect":"initial"}]`}function q(H,Z){return`${G(Z,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.host}:${H.port}]`}function Y(H){return`${Date.now()-H} ms`}}),define(ne[186],ie([0,1,18]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(E){return E.scheme===L.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=n;function T(E){if(!E)return;const P=E.indexOf("+");return P<0?E:E.substr(0,P)}e.getRemoteName=T;function _(E){return E.scheme!==L.Schemas.file&&E.scheme!==L.Schemas.vscodeRemote}e.isVirtualResource=_;function k(E){if(E.folders.length)return E.folders.every(P=>_(P.uri))?E.folders[0].uri:void 0;if(E.configuration&&_(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=k;function R(E){return k(E)?.scheme}e.getVirtualWorkspaceScheme=R;function C(E){return k(E)!==void 0}e.isVirtualWorkspace=C}),define(ne[88],ie([0,1,27,6,186]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=_;function k(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class C{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,d){if(typeof S=="undefined"||S===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof S=="string"||typeof d=="string"){let w=typeof S=="string"?S:S.value,p=typeof d=="string"?d:d.value;return L.equalsIgnoreCase(w,p)}return S._lower===d._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=C;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function P(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function b(f,S){if(S){const d=`onResolveRemoteAuthority:${(0,T.getRemoteName)(S)}`;return f.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[33],ie([0,1,27,88]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(d,w){return d.uuid&&w.uuid?d.uuid===w.uuid:d.id===w.id?!0:(0,L.compareIgnoreCase)(d.id,w.id)===0}e.areSameExtensions=T;class _{constructor(w,p){this.version=p,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof _?T(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=_;function k(d,w){return`${d}.${w}`}e.getExtensionId=k;function R(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function C(d,w){return R(k(d,w))}e.getGalleryExtensionId=C;function E(d,w){const p=[],v=y=>{for(const g of p)if(g.some(l=>T(w(l),w(y))))return g;return null};for(const y of d){const g=v(y);g?g.push(y):p.push([y])}return p}e.groupByExtension=E;function P(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function b(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function f(d){const w=new Set;if(d.malicious)for(const p of d.malicious)w.add(p.id);return w}e.getMaliciousExtensionsSet=f;function S(d,w){const p=[],v=w.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const y=v.shift();if(y&&p.every(g=>!T(g.identifier,{id:y}))){const g=d.filter(l=>T(l.identifier,{id:y}));g.length===1&&(p.push(g[0]),v.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=S}),define(ne[187],ie([0,1,5,8,2,4,19,61,7,29,22,13,30,33,14,10]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let v=class extends T.Disposable{constructor(g,l,u,r){super();this.fileService=l,this.extensionGalleryService=u,this.logService=r,this.extensionsDownloadDir=C.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,l){await this.cleanUpPromise;const u=this.getName(g),r=(0,k.joinPath)(this.extensionsDownloadDir,u);if(!await this.fileService.exists(r)){const a=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(g,a,l);try{await this.rename(a,r,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(a)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,a.path),i}}return r}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,l,u){try{await P.Promises.rename(g.fsPath,l.fsPath)}catch(r){if(_.isWindows&&r&&r.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${g} to ${l} with 'EPERM' error. Trying again...`),this.rename(g,l,u);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const l=[],u=[];for(const i of g.children){const t=this.parse(i.name);t&&u.push([t,i])}const r=(0,S.groupByExtension)(u,([i])=>i),a=[];for(const i of r)i.sort((t,s)=>R.rcompare(t[0].version,s[0].version)),l.push(...i.slice(1).map(t=>t[1].resource)),a.push(i[0][1]);a.sort((i,t)=>i.mtime-t.mtime),l.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(i=>i.resource)),await L.Promises.settled(l.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?`${new S.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase()}${g.properties.targetPlatform!=="undefined"?`-${g.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(g){const l=p.exec(g);return l&&l[1]&&l[2]?new S.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};v=de([X(0,b.INativeEnvironmentService),X(1,d.IFileService),X(2,f.IExtensionGalleryService),X(3,w.ILogService)],v),e.ExtensionsDownloader=v}),define(ne[188],ie([0,1,2,9,22,88]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends L.Disposable{constructor(C,E){super();this.environmentService=C,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,_.MANIFEST_CACHE_FOLDER,_.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(E.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(C){C.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(C){C.error||this.invalidate()}invalidate(){T.Promises.rm(this.extensionsManifestCache,T.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(ne[189],ie([0,1,81,16,5,2,18,9,22,13,30,33,59,10]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let d=class extends _.Disposable{constructor(v,y,g){super();this.extensionManagementService=v,this.logService=g,this.cache=this._register(new w(y,g)),this.extensionManagementService.registerParticipant({postInstall:async l=>this.postInstallExtension(l),postUninstall:async l=>this.postUninstallExtension(l)})}async getLanguageIds(){const v=await this.cache.getLanguagePacks(),y=["en",...Object.keys(v)];return(0,n.distinct)(y)}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const y=await this.cache.getLanguagePacks();Object.keys(y).some(g=>y[g]&&y[g].extensions.some(l=>(0,b.areSameExtensions)(l.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(y);return!(0,n.equals)(Object.keys(v),Object.keys(g))}};d=de([X(0,P.IExtensionManagementService),X(1,E.INativeEnvironmentService),X(2,S.ILogService)],d),e.LocalizationsService=d;let w=class extends _.Disposable{constructor(v,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new T.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(y=>{Object.keys(y).forEach(g=>delete y[g]),this.createLanguagePacksFromExtensions(y,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...y){for(const g of y)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,g);Object.keys(v).forEach(g=>this.updateHash(v[g]))}createLanguagePacksFromExtension(v,y){const g=y.identifier,l=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const u of l)if(y.location.scheme===k.Schemas.file&&(0,f.isValidLocalization)(u)){let r=v[u.languageId];r||(r={hash:"",extensions:[],translations:{}},v[u.languageId]=r);let a=r.extensions.filter(i=>(0,b.areSameExtensions)(i.extensionIdentifier,g))[0];a?a.version=y.manifest.version:r.extensions.push({extensionIdentifier:g,version:y.manifest.version});for(const i of u.translations)r.translations[i.id]=(0,R.join)(y.location.fsPath,i.path)}}updateHash(v){if(v){const y=(0,L.createHash)("md5");for(const g of v.extensions)y.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);v.hash=y.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return C.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(y=v(g),g)).then(g=>{for(const u of Object.keys(g))g[u]||delete g[u];this.languagePacks=g,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),C.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>y,g=>this.logService.error(g))})}};w=de([X(0,E.INativeEnvironmentService),X(1,S.ILogService)],w)}),define(ne[190],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[62],ie([0,1,3,4,6,10]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var k;(function(d){d.Http="http",d.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=b;function f(d,w){return w?w!==1&&d<1024:!n.isWindows&&d<1024}e.isPortPrivileged=f;let S=class{constructor(w){this.logService=w,this._onTunnelOpened=new L.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new L.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new L.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,p){return this._tunnelProvider=w,w?(this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],p=Array.from(this._tunnels.values());for(let v of p){const y=Array.from(v.values());for(let g of y){const l=await g.value;l&&w.push(l)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:p}of w.values())await p.then(v=>v?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,p,v,y,g=!1,l=R.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${v} on local port ${y}.`),!w)return;p||(p="localhost");const r=this.retainOrCreateTunnel(w,p,v,y,g,l,u);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(a);return(a.tunnelRemoteHost!==p||a.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const p=this._tunnels.get(w.tunnelRemoteHost);if(p){const v=p.get(w.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,v))}}}}async tryDisposeTunnel(w,p,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${p}.`);const y=v.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(p),y}}async closeTunnel(w,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${p} `);const v=this._tunnels.get(w);if(v&&v.has(p)){const y=v.get(p);y.refcount=0,await this.tryDisposeTunnel(w,p,y)}}addTunnelToMap(w,p,v){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(p,{refcount:1,value:v})}async removeEmptyTunnelFromMap(w,p){const v=this._tunnels.get(w);v&&(await v.get(p)||v.delete(p),v.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,p){let v=[w];P(w)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):b(w)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const y=v.map(g=>this._tunnels.get(g));for(const g of y){const l=g?.get(p);if(l)return l}}canTunnel(w){return!!E(w)}createWithProvider(w,p,v,y,g,l,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${v} on local port ${y}.`);const a={elevationRequired:g?f(y===void 0?v:y):!1},i={remoteAddress:{host:p,port:v},localAddressPort:y,privacy:l,public:l!==R.Private,protocol:u},t=w.forwardPort(i,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(p,v,t),t}};S=de([X(0,_.ILogService)],S),e.AbstractTunnelService=S}),define(ne[191],ie([0,1,10,62,2,8,5]),function(J,e,L,n,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends T.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new k.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let C=class It extends T.Disposable{constructor(P,b){super();this._tunnelService=P,this._logService=b,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++It._lastId)}}async startTunnel(P,b,f,S,d,w){const p=new R,v=await Promise.resolve(this._tunnelService.openTunnel(P,p,f,S,d,w));if(!v)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${S} (remote).`),p.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(b))throw this._disposedTunnels.delete(b),p.dispose(),await v.dispose(),(0,_.canceled)();return p.setTunnel(v),this._tunnels.set(b,p),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${v.localAddress} (local) to ${f}:${S} (remote).`),{tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress}}async setAddress(P,b){const f=this._tunnels.get(P);!f||f.setAddress(b)}async destroyTunnel(P){const b=this._tunnels.get(P);if(b){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await b.dispose();return}this._disposedTunnels.add(P)}};C._lastId=0,C=de([X(0,n.ISharedTunnelsService),X(1,L.ILogService)],C),e.SharedProcessTunnelService=C}),define(ne[192],ie([0,1,119,20,10]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let _=class{constructor(R,C){this.configurationService=R,this.logService=C}request(R,C){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,L.request)(R,C)}async resolveProxy(R){}};_=de([X(0,n.IConfigurationService),X(1,T.ILogService)],_),e.RequestService=_}),define(ne[43],ie([0,1,17,140,42,6,38]),function(J,e,L,n,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,_.createDecorator)("requestService");function R(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=R;function C(d){return d.res.statusCode===204}async function E(d){if(!R(d))throw new Error("Server returned "+d.res.statusCode);return C(d)?null:(await(0,L.streamToBuffer)(d.stream)).toString()}e.asText=E;async function P(d){if(!R(d))throw new Error("Server returned "+d.res.statusCode);if(C(d))return null;const p=(await(0,L.streamToBuffer)(d.stream)).toString();try{return JSON.parse(p)}catch(v){throw v.message+=`:
`+p,v}}e.asJson=P;function b(d){S(d)}e.updateProxyConfigurationsScope=b;let f;function S(d){const w=k.Registry.as(T.Extensions.Configuration),p=f;f={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[f],remove:p?[p]:[]})}S(2)}),define(ne[193],ie([0,1,25,18,14,43]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(C,E){this.requestService=C,this.fileService=E}async download(C,E,P=L.CancellationToken.None){if(C.scheme===n.Schemas.file||C.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(C,E);return}const b={type:"GET",url:C.toString()},f=await this.requestService.request(b,P);if(f.res.statusCode===200)await this.fileService.writeFile(E,f.stream);else{const S=await(0,_.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${S}`)}}};k=de([X(0,_.IRequestService),X(1,T.IFileService)],k),e.DownloadService=k}),define(ne[194],ie([0,1,16,25,66,2,19,154,14,10,26,43]),function(J,e,L,n,T,_,k,R,C,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends _.Disposable{constructor(d,w,p,v){super();this.fileService=d,this.productService=w,this.requestService=p,this.logService=v,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,T.forEach)(this.productService.configBasedExtensionTips,({value:y})=>this.allConfigBasedTips.set(y.configPath,y))}getConfigBasedTips(d){return this.getValidConfigBasedTips(d)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(d){const w=[];for(const[p,v]of this.allConfigBasedTips)if(!(v.configScheme&&v.configScheme!==d.scheme))try{const y=await this.fileService.readFile((0,k.joinPath)(d,p)),g=new Map;(0,T.forEach)(v.recommendations,({key:u,value:r})=>{if((0,L.isNonEmptyArray)(r.remotes))for(const a of r.remotes)g.set(a,{extensionId:u,extensionName:r.name,configName:v.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else w.push({extensionId:u,extensionName:r.name,configName:v.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const l=(0,R.getDomainsOfRemotes)(y.value.toString(),[...g.keys()]);for(const u of l){const r=g.get(u);r&&w.push(r)}}catch{}return w}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const d=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(d.res.statusCode!==200)return[];const w=await(0,b.asJson)(d);return w?w.workspaceRecommendations||[]:[]}catch(d){return this.logService.error(d),[]}}};f=de([X(0,C.IFileService),X(1,P.IProductService),X(2,b.IRequestService),X(3,E.ILogService)],f),e.ExtensionTipsService=f}),define(ne[46],ie([0,1,17,29]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function T(_,k,R){let C=R&&R.get("storage.serviceMachineId",0)||null;if(C)return C;try{const P=(await k.readFile(_.serviceMachineIdResource)).value.toString();C=(0,n.isUUID)(P)?P:null}catch{C=null}if(!C){C=(0,n.generateUuid)();try{await k.writeFile(_.serviceMachineIdResource,L.VSBuffer.fromString(C))}catch{}}return R&&R.store("storage.serviceMachineId",C,0,1),C}e.getServiceMachineId=T}),define(ne[89],ie([0,1,106,6]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function T(_){return(0,L.hash)({moduleId:_.process.moduleId,windowId:_.reply.windowId})}e.hash=T,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[195],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var L;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(L=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[196],ie([0,1,72,152,5,25,3,2,18,4,29,13,10,26,89,195]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(g,l,u){this.logService=g,this.productService=l,this.environmentService=u,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(g){const l=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${l})`);const u=(0,d.hash)(g);this.processeDisposables.has(u)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${l})`),this.doDisposeWorker(g));const r=new _.CancellationTokenSource;let a,i,t;this.processeDisposables.set(u,h=>{r.dispose(!0),a?.terminate(g,_.CancellationToken.None),i?.close(),t?.close(),this.processeDisposables.delete(u);const m=this.processResolvers.get(u);m&&(this.processResolvers.delete(u),m({reason:h}))}),a=await this.getOrCreateWebWorker(g);const s=new Promise(h=>{this.processResolvers.set(u,h)});if(r.token.isCancellationRequested)return s;const{port1:o,port2:c}=new MessageChannel;return i=o,t=c,await a.spawn(g,t,r.token),r.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${l})`),L.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",g,[i])),s}getOrCreateWebWorker(g){let l=this.workers.get(g.process.moduleId);if(!l){this.logService.trace(`SharedProcess: creating new web worker (${g.process.moduleId})`);const u=new v(g.process.type,this.logService,this.productService,this.environmentService);l=u.init(),u.onDidProcessSelfTerminate(({configuration:r,reason:a})=>{this.doDisposeWorker(r,a)}),this.workers.set(g.process.moduleId,l)}return l}async disposeWorker(g){return this.doDisposeWorker(g)}doDisposeWorker(g,l){const u=this.processeDisposables.get((0,d.hash)(g));u&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),u(l))}};p=de([X(0,f.ILogService),X(1,S.IProductService),X(2,b.INativeEnvironmentService)],p),e.SharedProcessWorkerService=p;class v extends R.Disposable{constructor(g,l,u,r){super();this.type=g,this.logService=l,this.productService=u,this.environmentService=r,this._onDidProcessSelfTerminate=this._register(new k.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const g=new T.DeferredPromise,l=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return l.onerror=u=>{this.logService.error(`SharedProcess: worker error (${this.type})`,u.message)},l.onmessageerror=u=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,u)},l.onmessage=u=>{const{id:r,message:a,configuration:i,nonce:t}=u.data;switch(r){case w.SharedProcessWorkerMessages.Ready:g.complete(l);break;case w.SharedProcessWorkerMessages.Ack:if(t){const s=this.mapMessageNonceToPendingMessageResolve.get(t);s&&(this.mapMessageNonceToPendingMessageResolve.delete(t),s())}break;case w.SharedProcessWorkerMessages.SelfTerminated:i&&a&&this._onDidProcessSelfTerminate.fire({configuration:i,reason:JSON.parse(a)});break;case w.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case w.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case w.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case w.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,u)}},l.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),g.p}async send(g,l,u){const r=await this.workerReady;if(!l.isCancellationRequested)return new Promise(a=>{const i=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(i,a);const t={...g,nonce:i};u?r.postMessage(t,[u]):r.postMessage(t),l.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(i)&&a()})})}spawn(g,l,u){const r={id:w.SharedProcessWorkerMessages.Spawn,configuration:g,environment:this.getSharedProcessWorkerEnvironment()};return this.send(r,u,l)}getSharedProcessWorkerEnvironment(){const g={bootstrapPath:C.FileAccess.asFileUri("bootstrap-fork",J).fsPath,env:Object.create(null)};if(E.isLinux){const l={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},u=this.environmentService.args["crash-reporter-id"],r=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&r&&u&&(0,P.isUUID)(u)){const t=r["linux-x64"];l.submitURL=t.concat("&uid=",u,"&iid=",u,"&sid=",u),l.uploadToServer=!0}const i=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;g.env.BREAKPAD_DUMP_LOCATION=(0,n.join)(i,this.type),g.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(l)}return g}terminate(g,l){const u={id:w.SharedProcessWorkerMessages.Terminate,configuration:g};return this.send(u,l)}}}),define(ne[197],ie([0,1,53,18,153]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class _ extends T.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.userData})}}de([L.memoize],_.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=_}),define(ne[90],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[198],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L{constructor(){this.validators=new Map}vsda(){return new Promise((T,_)=>J(["vsda"],T,_))}async createNewMessage(T){try{const _=await this.vsda(),k=new _.validator;if(k){const R=String(L._nextId++);return this.validators.set(R,k),{id:R,data:k.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,_){if(!T.id)return!0;const k=this.validators.get(T.id);if(!k)return!1;this.validators.delete(T.id);try{return k.validate(_)==="ok"}catch{return!1}}async sign(T){try{const _=await this.vsda(),k=new _.signer;if(k)return k.sign(T)}catch{}return T}}e.SignService=L,L._nextId=1}),define(ne[23],ie([0,1,5,3,2,177,15,73,6]),function(J,e,L,n,T,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,C.createDecorator)("storageService");var P;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(p){p[p.GLOBAL=0]="GLOBAL",p[p.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var f;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class S extends T.Disposable{constructor(v={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new T.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,T.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,_.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,_.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,y){y===E?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:y,target:this.getKeyTargets(v)[y]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,y,g){return this.getStorage(y)?.get(v,g)}getBoolean(v,y,g){return this.getStorage(y)?.getBoolean(v,g)}getNumber(v,y,g){return this.getStorage(y)?.getNumber(v,g)}store(v,y,g,l){if((0,k.isUndefinedOrNull)(y)){this.remove(v,g);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,g,l),this.getStorage(g)?.set(v,y)})}remove(v,y){this.withPausedEmitters(()=>{this.updateKeyTarget(v,y,void 0),this.getStorage(y)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,y){const g=[],l=this.getKeyTargets(v);for(const u of Object.keys(l))l[u]===y&&g.push(u);return g}updateKeyTarget(v,y,g){const l=this.getKeyTargets(y);typeof g=="number"?l[v]!==g&&(l[v]=g,this.getStorage(y)?.set(E,JSON.stringify(l))):typeof l[v]=="number"&&(delete l[v],this.getStorage(y)?.set(E,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const y=this.get(E,v);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=P.NONE){this._onWillSaveState.fire({reason:v});const y=this.getStorage(0),g=this.getStorage(1);switch(v){case P.NONE:await L.Promises.settled([y?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([y?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return w(v,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends S{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=d;async function w(p,v,y,g){const l=o=>{try{return JSON.parse(o)}catch{return o}},u=new Map,r=new Map;p.forEach((o,c)=>{u.set(c,o),r.set(c,l(o))});const a=new Map,i=new Map;v.forEach((o,c)=>{a.set(c,o),i.set(c,l(o))}),console.group(`Storage: Global (path: ${y})`);let t=[];u.forEach((o,c)=>{t.push({key:c,value:o})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${g})`);let s=[];a.forEach((o,c)=>{s.push({key:c,value:o})}),console.table(s),console.groupEnd(),console.log(i)}e.logStorage=w}),define(ne[199],ie([0,1,3,2,15,30,33,23]),function(J,e,L,n,T,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=class extends n.Disposable{constructor(b,f){super();this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(b)),this._register(this.storageManger.onDidChange(S=>this._onDidChangeEnablement.fire({extensions:S,source:"storage"}))),this._register(f.onDidInstallExtensions(S=>S.forEach(({local:d,operation:w})=>{d&&w===4&&this._removeFromDisabledExtensions(d.identifier)})))}async enableExtension(b,f){return this._removeFromDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:f}),!0):!1}async disableExtension(b,f){return this._addToDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(_.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(b){let f=this.getDisabledExtensions();return f.every(S=>!(0,k.areSameExtensions)(S,b))?(f.push(b),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(b){let f=this.getDisabledExtensions();for(let S=0;S<f.length;S++){const d=f[S];if((0,k.areSameExtensions)(d,b))return f.splice(S,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(b){this._setExtensions(_.DISABLED_EXTENSIONS_STORAGE_PATH,b)}_getExtensions(b){return this.storageManger.get(b,0)}_setExtensions(b,f){this.storageManger.set(b,f,0)}};C=de([X(0,R.IStorageService),X(1,_.IExtensionManagementService)],C),e.GlobalExtensionEnablementService=C;class E extends n.Disposable{constructor(b){super();this.storageService=b,this.storage=Object.create(null),this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this._register(b.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(b,f){let S;return f===0?((0,T.isUndefinedOrNull)(this.storage[b])&&(this.storage[b]=this._get(b,f)),S=this.storage[b]):S=this._get(b,f),JSON.parse(S)}set(b,f,S){let d=JSON.stringify(f.map(({id:p,uuid:v})=>({id:p,uuid:v})));this._get(b,S)!==d&&(S===0&&(f.length?this.storage[b]=d:delete this.storage[b]),this._set(b,f.length?d:void 0,S))}onDidStorageChange(b){if(b.scope===0&&!(0,T.isUndefinedOrNull)(this.storage[b.key])&&this._get(b.key,b.scope)!==this.storage[b.key]){const S=this.get(b.key,b.scope);delete this.storage[b.key];const d=this.get(b.key,b.scope),w=S.filter(v=>!d.some(y=>(0,k.areSameExtensions)(v,y))),p=d.filter(v=>!S.some(y=>(0,k.areSameExtensions)(y,v)));(w.length||p.length)&&this._onDidChange.fire([...w,...p])}}_get(b,f){return this.storageService.get(b,f,"[]")}_set(b,f,S){f?this.storageService.store(b,f,S,1):this.storageService.remove(b,S)}}e.StorageManager=E}),define(ne[200],ie([0,1,3,2]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class T extends n.Disposable{constructor(E,P){super();this.channel=E,this.workspace=P}async getItems(){const E={workspace:this.workspace},P=await this.channel.call("getItems",E);return new Map(P)}updateItems(E){const P={workspace:this.workspace};return E.insert&&(P.insert=Array.from(E.insert.entries())),E.delete&&(P.delete=Array.from(E.delete.values())),this.channel.call("updateItems",P)}}class _ extends T{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new L.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class k extends T{constructor(E,P){super(E,P);this.onDidChangeItemsExternal=L.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class R extends n.Disposable{constructor(E,P){super();this.channel=E,this.workspace=P,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new _(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new k(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(ne[201],ie([0,1,5,2,19,73,23,200]),function(J,e,L,n,T,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class C extends k.AbstractStorageService{constructor(P,b,f){super();this.mainProcessService=b,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new n.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(P)}createGlobalStorage(){const P=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),b=new _.Storage(P.globalStorage);return this._register(b.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),b}createWorkspaceStorage(P){const b=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),P);if(b.workspaceStorage){const f=new _.Storage(b.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(S=>this.emitDidChangeValue(1,S)),this.workspaceStorageId=P?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await L.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(k.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(P){const b=this.workspaceStorage,f=b?.items??new Map;b&&(await b.close(),b.dispose()),this.workspaceStorage=this.createWorkspaceStorage(P),await this.workspaceStorage.init();for(const[S,d]of f)this.workspaceStorage.set(S,d)}}e.NativeStorageService=C}),define(ne[202],ie([0,1,4,31,7,29]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(E){if(L.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function R(E,P,b,f,S,d,w,p,v,y){const g=Object.create(null);g["common.machineId"]=w,g.sessionID=(0,_.generateUuid)()+Date.now(),g.commitHash=S,g.version=d,g["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,L.PlatformToString)(L.platform),g["common.nodePlatform"]=n.platform,g["common.nodeArch"]=f,g["common.product"]=y||"desktop";const l=C(p||[]);l&&(g["common.msftInternal"]=l);let u=0;const r=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),L.isLinuxSnap&&(g["common.snap"]="true");const a=k(b);a&&(g["common.platformDetail"]=a);try{const i=await E.readFile(T.URI.file(v));g["common.source"]=i.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=R;function C(E){const P=n.env.USERDNSDOMAIN;if(!P)return!1;const b=P.toLowerCase();return E.some(f=>b===f)}e.verifyMicrosoftInternalDomain=C}),define(ne[21],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(_){_[_.NONE=0]="NONE",_[_.CRASH=1]="CRASH",_[_.ERROR=2]="ERROR",_[_.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var T;(function(_){_.OFF="off",_.CRASH="crash",_.ERROR="error",_.ON="all"})(T=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[203],ie([0,1,32,54,5,35,18,9,4,7,113,22,116,78,14,26,21]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(r,a){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let t;const s=L.homedir().toLowerCase();switch(process.platform){case"win32":t=[{tag:"gdrive",matcher:A=>/^[a-z]:\\(my drive|shared drives)\\/.test(A)||A.startsWith(s+"\\my drive\\")},{tag:"dropbox",matcher:A=>A.startsWith(s+"\\dropbox")},{tag:"onedrive",matcher:A=>A.startsWith(s+"\\onedrive")},{tag:"box",matcher:A=>A.startsWith(s+"\\box\\")},{tag:"nextcloud",matcher:A=>A.startsWith(s+"\\nextcloud\\")},{tag:"owncloud",matcher:A=>A.startsWith(s+"\\owncloud\\")}];break;case"darwin":t=[{tag:"gdrive",matcher:A=>A.startsWith("/volumes/googledrive/")||A.startsWith(s+"/my drive/")},{tag:"dropbox",matcher:A=>A.startsWith(s+"/dropbox")},{tag:"onedrive",matcher:A=>A.startsWith(s+"/onedrive")||A.startsWith(s+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:A=>A.startsWith(s+"/library/mobile documents/")},{tag:"box",matcher:A=>A.startsWith(s+"/box/")},{tag:"nextcloud",matcher:A=>A.startsWith(s+"/nextcloud/")},{tag:"owncloud",matcher:A=>A.startsWith(s+"/owncloud/")}];break}const o=new Map,c=new Map,h=2e4;function m(A,N,$,D){for(const W of t){const U=A.toLowerCase();W.matcher(U)&&c.set(W.tag,1)}const M=N.substring(A.length+1);return T.Promises.withAsyncBody(async W=>{let U;try{U=await b.Promises.readdir(N,{withFileTypes:!0})}catch{W();return}if(D.count>=h){D.count+=U.length,D.maxReached=!0,W();return}let x=U.length;if(x===0){W();return}let ee=U;D.count+U.length>h&&(D.maxReached=!0,x=h-D.count,ee=U.slice(0,x)),D.count+=U.length;for(const G of ee)if(G.isDirectory()){if($.includes(G.name)||await m(A,(0,R.join)(N,G.name),$,D),--x==0){W();return}}else{const q=G.name.lastIndexOf(".");if(q>=0){const Y=G.name.substring(q+1);Y&&o.set(Y,(o.get(Y)??0)+1)}for(const Y of i)Y.relativePathPattern?.test(M)!==!1&&Y.filePattern.test(G.name)&&c.set(Y.tag,(c.get(Y.tag)??0)+1);if(--x==0){W();return}}})}const I={count:0,maxReached:!1};await m(r,r,a,I);const O=await l(r);return{configFiles:y(c),fileTypes:y(o),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:O}}e.collectWorkspaceStats=v;function y(r){return[...n.Iterable.map(r.entries(),([a,i])=>({name:a,count:i}))].sort((a,i)=>i.count-a.count)}function g(){const r={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},a=L.cpus();return a&&a.length>0&&(r.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),r}e.getMachineInfo=g;async function l(r){try{const a=new Map,i=(0,R.join)(r,".vscode","launch.json"),t=await b.Promises.readFile(i),s=[],o=(0,_.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),[];if((0,_.getNodeType)(o)==="object"&&o.configurations)for(const c of o.configurations){const h=c.type;h&&(a.has(h)?a.set(h,a.get(h)+1):a.set(h,1))}return y(a)}catch{return[]}}e.collectLaunchConfigs=l;let u=class{constructor(a,i){this.telemetryService=a,this.productService=i}formatMachineInfo(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}formatEnvironment(a){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const t=L.cpus();return t&&t.length>0&&i.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),i.push(`Memory (System):  ${(L.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||i.push(`Load (avg):       ${L.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,f.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async t=>{let[s,o]=t,c=this.formatProcessList(a,s);return i.forEach(h=>{if((0,S.isRemoteDiagnosticError)(h))c+=`
${h.errorMessage}`,o+=`
${h.errorMessage}`;else if(c+=`

Remote: ${h.hostName}`,h.processes&&(c+=`
${this.formatProcessList(a,h.processes)}`),h.workspaceMetadata){o+=`
|  Remote: ${h.hostName}`;for(const m of Object.keys(h.workspaceMetadata)){const I=h.workspaceMetadata[m];let O=`${I.fileCount} files`;I.maxFilesReached&&(O=`more than ${O}`),o+=`|    Folder (${m}): ${O}`,o+=this.formatWorkspaceStats(I)}}}),{processInfo:c,workspaceInfo:o}})}async getSystemInfo(a,i){const{memory:t,vmHint:s,os:o,cpus:c}=g(),h={os:o,memory:t,cpus:c,vmHint:s,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return C.isWindows||(h.load=`${L.loadavg().map(m=>Math.round(m)).join(", ")}`),C.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(a,i){const t=[];return(0,f.listProcesses)(a.mainPID).then(async s=>(t.push(""),t.push(this.formatEnvironment(a)),t.push(""),t.push(this.formatProcessList(a,s)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(a))),i.forEach(o=>{if((0,S.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(a,o.processes)),o.workspaceMetadata)for(const c of Object.keys(o.workspaceMetadata)){const h=o.workspaceMetadata[c];let m=`${h.fileCount} files`;h.maxFilesReached&&(m=`more than ${m}`),t.push(`Folder (${c}): ${m}`),t.push(this.formatWorkspaceStats(h))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(a){const i=[],t=60;let s=0;const o=(I,O)=>{const A=` ${I}(${O})`;s+A.length>t?(i.push(c),c="|                 ",s=c.length):s+=A.length,c+=A};let c="|      File types:";const h=10;let m=a.fileTypes.length>h?h:a.fileTypes.length;for(let I=0;I<m;I++){const O=a.fileTypes[I];o(O.name,O.count)}if(i.push(c),a.configFiles.length>=0&&(c="|      Conf files:",s=0,a.configFiles.forEach(I=>{o(I.name,I.count)}),i.push(c)),a.launchConfigFiles.length>0){let I="|      Launch Configs:";a.launchConfigFiles.forEach(O=>{I+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(I)}return i.join(`
`)}expandGPUFeatures(a){const i=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(i-t.length)}  ${a[t]}`).join(`
                  `)}formatWorkspaceMetadata(a){const i=[],t=[];return a.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const c=E.URI.revive(o);if(c.scheme===k.Schemas.file){const h=c.fsPath;t.push(v(h,["node_modules",".git"]).then(m=>{let I=`${m.fileCount} files`;m.maxFilesReached&&(I=`more than ${I}`),i.push(`|    Folder (${(0,R.basename)(h)}): ${I}`),i.push(this.formatWorkspaceStats(m))}).catch(m=>{i.push(`|      Error: Unable to collect workspace stats for folder ${h} (${m.toString()})`)}))}else i.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(a,i){const t=new Map;a.windows.forEach(o=>t.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(a.mainPID,t,s,i,0),s.join(`
`)}formatProcessItem(a,i,t,s,o){const c=o===0;let h;c?h=s.pid===a?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(h=`${h} (${i.get(s.pid)})`));const m=process.platform==="win32"?s.mem:L.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(m/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(s.children)&&s.children.forEach(I=>this.formatProcessItem(a,i,t,I,o+1))}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const t=E.URI.revive(i);if(t.scheme!==k.Schemas.file)continue;const s=t.fsPath;try{const o=await v(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),o.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),o.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};u=de([X(0,p.ITelemetryService),X(1,w.IProductService)],u),e.DiagnosticsService=u}),define(ne[204],ie([0,1,16,5,25,8,3,2,4,15,7,129,30,33,10,26,21]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let v=class extends R.Disposable{constructor(a,i,t,s){super();this.galleryService=a,this.telemetryService=i,this.logService=t,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const i=await this.getTargetPlatform();return a.allTargetPlatforms.some(t=>(0,f.isTargetPlatformCompatible)(t,a.allTargetPlatforms,i))}async installFromGallery(a,i={}){try{if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(b.localize(0,null),f.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(a,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,i)}catch(t){throw l(this.telemetryService,"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(a),void 0,t),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(t),g(t)}}async migrateUnsupportedExtensions(){try{const a=await this.getExtensionsControlManifest();if(!a.unsupportedPreReleaseExtensions)return;const i=await this.getInstalled(1);for(const[t,s]of Object.entries(a.unsupportedPreReleaseExtensions)){const o=i.find(m=>(0,S.areSameExtensions)(m.identifier,{id:t}));if(!o)continue;const c=await this.galleryService.getCompatibleExtension({id:s.id},!0,await this.getTargetPlatform());if(!c){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the comaptible target '${s.id}' extension is not found`);continue}const h=await this.galleryService.getManifest(c,T.CancellationToken.None);if(!h){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the manifest for '${s.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${o.identifier.id}' extension to '${s.id}' extension...`),await Promise.allSettled([this.uninstall(o),this.installExtension(h,c,{installPreReleaseVersion:!0,isMachineScoped:o.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${o.identifier.id}' extension to '${s.id}' extension.`)}catch(m){this.logService.error(m)}}}catch(a){this.logService.error(a)}}async uninstall(a,i={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,i)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(b.localize(1,null));const i=await this.findGalleryExtension(a);if(!i)throw new Error(b.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,i,t){if(!P.URI.isUri(i)){let m=this.installingExtensions.get(new S.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(m)return this.logService.info("Extensions is already requested to install",i.identifier.id),m.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],o=[],c=this.createInstallExtensionTask(a,i,t);P.URI.isUri(i)||this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(c.identifier,a.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:i}),this.logService.info("Installing extension:",c.identifier.id),s.push({task:c,manifest:a});let h=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:O,manifest:A}of I)if(h=h||!!A.extensionDependencies?.some(N=>(0,S.areSameExtensions)({id:N},c.identifier)),this.installingExtensions.has(new S.ExtensionIdentifierWithVersion(O.identifier,O.version).key()))this.logService.info("Extension is already requested to install",O.identifier.id);else{const N=this.createInstallExtensionTask(A,O,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(N.identifier,A.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:O}),this.logService.info("Installing extension:",N.identifier.id),s.push({task:N,manifest:A})}}catch(I){if(P.URI.isUri(c.source))(0,L.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,I.message),(0,L.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),I}const m=s.reduce((I,{task:O,manifest:A})=>(I.set(O.identifier.id.toLowerCase(),{task:O,manifest:A}),I),new Map);for(;m.size;){let I;const O=[...m.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(N=>m.has(N.toLowerCase())));O.length?I=m.size===1?O:O.filter(({task:A})=>!(A===c&&!h)):(this.logService.info("Found extensions with circular dependencies",O.map(({task:A})=>A.identifier.id)),I=[...m.values()]),await this.joinAllSettled(I.map(async({task:A})=>{const N=new Date().getTime(),$=(0,E.isUndefined)(t.operation)?A.operation:t.operation;try{const D=await A.run();if(await this.joinAllSettled(this.participants.map(M=>M.postInstall(D,A.source,t,T.CancellationToken.None))),!P.URI.isUri(A.source)&&(l(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-N,void 0),C.isWeb&&$!==3))try{await this.galleryService.reportStatistic(D.manifest.publisher,D.manifest.name,D.manifest.version,"install")}catch{}o.push({local:D,identifier:A.identifier,operation:$,source:A.source})}catch(D){throw P.URI.isUri(A.source)||l(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-N,D),this.logService.error("Error while installing the extension:",A.identifier.id),D}finally{m.delete(A.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:I})=>(0,S.areSameExtensions)(I,c.identifier))[0].local}catch(m){if(s.forEach(({task:I})=>I.cancel()),o.length)try{const I=await Promise.allSettled(o.map(({local:O})=>this.createUninstallExtensionTask(O,{versionOnly:!0}).run()));for(let O=0;O<I.length;O++){const A=I[O],{identifier:N}=o[O];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,_.getErrorMessage)(A.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,_.getErrorMessage)(I),o.map(({identifier:O})=>O.id))}throw this._onDidInstallExtensions.fire(s.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),m}finally{for(const{task:m,manifest:I}of s)if(!P.URI.isUri(m.source)){const O=new S.ExtensionIdentifierWithVersion(m.identifier,I.version).key();this.installingExtensions.delete(O)||this.logService.warn("Installation task is not found in the cache",O)}}}async joinAllSettled(a){const i=[],t=[],s=await Promise.allSettled(a);for(const o of s)o.status==="fulfilled"?i.push(o.value):t.push(o.reason);if(t.length)throw y(t);return i}async getAllDepsAndPackExtensionsToInstall(a,i,t,s){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const c=[a,...o.map(I=>I.identifier)],h=[],m=async(I,O)=>{const A=O.extensionDependencies||[],N=[...A];if(O.extensionPack){const $=t?o.find(D=>(0,S.areSameExtensions)(D.identifier,I)):void 0;for(const D of O.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(M=>(0,S.areSameExtensions)({id:M},{id:D}))||N.every(M=>!(0,S.areSameExtensions)({id:M},{id:D}))&&N.push(D)}if(N.length){const $=[...c,...h.map(M=>M.gallery.identifier)],D=N.filter(M=>$.every(W=>!(0,S.areSameExtensions)(W,{id:M})));if(D.length){const M=await this.galleryService.query({names:D,pageSize:N.length},T.CancellationToken.None);for(const W of M.firstPage){if($.find(ee=>(0,S.areSameExtensions)(ee,W.identifier)))continue;const U=A.some(ee=>(0,S.areSameExtensions)({id:ee},W.identifier));let x;try{x=await this.checkAndGetCompatibleVersion(W,!0,s)}catch(ee){if(ee instanceof f.ExtensionManagementError&&ee.code===f.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!U){this.logService.info("Skipping the packed extension as it cannot be installed",W.identifier.id);continue}else throw ee}h.push({gallery:x.extension,manifest:x.manifest}),await m(x.extension.identifier,O)}}}};return await m(a,i),o=await this.getInstalled(),h.filter(I=>!o.some(O=>(0,S.areSameExtensions)(O.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(a,i,t){const s=await this.getExtensionsControlManifest();if((0,S.getMaliciousExtensionsSet)(s).has(a.identifier.id))throw new f.ExtensionManagementError(b.localize(3,null,a.identifier.id),f.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[a.identifier.id])throw new f.ExtensionManagementError(b.localize(4,null,a.identifier.id,s.unsupportedPreReleaseExtensions[a.identifier.id].displayName),f.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const h=await this.getTargetPlatform();throw new f.ExtensionManagementError(b.localize(5,null,a.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(h)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(a,i,t);if(o){if(t&&a.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new f.ExtensionManagementError(b.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new f.ExtensionManagementError(b.localize(7,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const c=await this.galleryService.getManifest(o,T.CancellationToken.None);if(c===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(c.version!==o.version)throw new f.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:c}}async getCompatibleVersion(a,i,t){const s=await this.getTargetPlatform();let o=null;return i&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==t&&(o=await this.galleryService.getCompatibleExtension(a.identifier,t,s)),!o&&await this.galleryService.isExtensionCompatible(a,t,s)&&(o=a),!o&&i&&(o=await this.galleryService.getCompatibleExtension(a,t,s)),o}async unininstallExtension(a,i){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const s=(m,I)=>{const O=this.createUninstallExtensionTask(m,I);return this.uninstallingExtensions.set(O.extension.identifier.id.toLowerCase(),O),this.logService.info("Uninstalling extension:",m.identifier.id),this._onUninstallExtension.fire(m.identifier),O},o=(m,I)=>{I?this.logService.error("Failed to uninstall extension:",m.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",m.identifier.id),l(this.telemetryService,"extensionGallery:uninstall",(0,S.getLocalExtensionTelemetryData)(m),void 0,I),this._onDidUninstallExtension.fire({identifier:m.identifier,error:I?.code})},c=[],h=[];try{c.push(s(a,{}));const m=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(a,m);for(const O of I)this.uninstallingExtensions.has(O.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):c.push(s(O,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(c.map(I=>I.extension),m,a),await this.joinAllSettled(c.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(I.extension,i,T.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}o(I.extension)}catch(O){const A=O instanceof f.ExtensionManagementError?O:new f.ExtensionManagementError((0,_.getErrorMessage)(O),f.ExtensionManagementErrorCode.Internal);throw o(I.extension,A),A}finally{h.push(I)}}))}catch(m){const I=m instanceof f.ExtensionManagementError?m:new f.ExtensionManagementError((0,_.getErrorMessage)(m),f.ExtensionManagementErrorCode.Internal);for(const O of c){try{O.cancel()}catch{}h.includes(O)||o(O.extension,I)}throw I}finally{for(const m of c)this.uninstallingExtensions.delete(m.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",m.extension.identifier.id)}}checkForDependents(a,i,t){for(const s of a){const o=this.getDependents(s,i);if(o.length){const c=o.filter(h=>!a.some(m=>(0,S.areSameExtensions)(m.identifier,h.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(s,c,t))}}}getDependentsErrorMessage(a,i,t){return t===a?i.length===1?b.localize(8,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?b.localize(9,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):b.localize(10,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?b.localize(11,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?b.localize(12,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):b.localize(13,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(a,i,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const s=a.manifest.extensionPack?a.manifest.extensionPack:[];if(s.length){const o=i.filter(h=>!h.isBuiltin&&s.some(m=>(0,S.areSameExtensions)({id:m},h.identifier))),c=[];for(const h of o)c.push(...this.getAllPackExtensionsToUninstall(h,i,t));return[...o,...c]}return[]}getDependents(a,i){return i.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(s=>(0,S.areSameExtensions)({id:s},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const i=await this.findGalleryExtensionById(a.identifier.uuid);return i||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},T.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},T.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};v=de([X(0,f.IExtensionGalleryService),X(1,p.ITelemetryService),X(2,d.ILogService),X(3,w.IProductService)],v),e.AbstractExtensionManagementService=v;function y(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((i,t)=>new Error(`${i.message}${i.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=y;function g(r){if(r instanceof f.ExtensionManagementError)return r;const a=new f.ExtensionManagementError(r.message,f.ExtensionManagementErrorCode.Internal);return a.stack=r.stack,a}function l(r,a,i,t,s){const o=s?s instanceof f.ExtensionManagementError?s.code:f.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(a,{...i,success:!s,duration:t,errorcode:o})}e.reportTelemetry=l;class u{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>new Promise((i,t)=>{const s=a.onCancellationRequested(()=>{s.dispose(),t((0,_.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=u}),define(ne[205],ie([0,1,16,5,66,3,9,4,31,7,131,13,30,194,80,14,10,60,26,43,23,21]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v,y,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let i=class extends S.ExtensionTipsService{constructor(s,o,c,h,m,I,O,A,N,$){super(O,A,N,$);this.environmentService=s,this.telemetryService=o,this.extensionManagementService=c,this.storageService=h,this.nativeHostService=m,this.extensionRecommendationNotificationService=I,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,A.exeBasedExtensionTips&&(0,T.forEach)(A.exeBasedExtensionTips,({key:D,value:M})=>{const W=[],U=[],x=[];(0,T.forEach)(M.recommendations,({key:ee,value:G})=>{G.important?M.important?W.push({extensionId:ee,extensionName:G.name,isExtensionPack:!!G.isExtensionPack}):U.push({extensionId:ee,extensionName:G.name,isExtensionPack:!!G.isExtensionPack}):x.push({extensionId:ee,extensionName:G.name,isExtensionPack:!!G.isExtensionPack})}),W.length&&this.highImportanceExecutableTips.set(D,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:W}),U.length&&this.mediumImportanceExecutableTips.set(D,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:U}),x.length&&this.allOtherExecutableTips.set(D,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:x})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),c=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,c),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,c)}groupImportantTipsByExe(s,o){const c=new Map;s.forEach(A=>c.set(A.extensionId.toLowerCase(),A));const{installed:h,uninstalled:m}=this.groupByInstalled([...c.keys()],o);for(const A of h){const N=c.get(A);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:A,exeName:N.exeName})}for(const A of m){const N=c.get(A);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:A,exeName:N.exeName})}const I=this.getPromptedExecutableTips(),O=new Map;for(const A of m){const N=c.get(A);if(N&&(!I[N.exeName]||!I[N.exeName].includes(N.extensionId))){let $=O.get(N.exeName);$||($=[],O.set(N.exeName,$)),$.push(N)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(c=>{switch(c){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const h=_.Event.once(_.Event.latch(_.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(h(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const h=this._register((0,n.disposableTimeout)(()=>{h.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),o=Date.now()-s,c=7*24*60*60*1e3;if(o<c){const I=this._register((0,n.disposableTimeout)(()=>{I.dispose(),this.promptMediumImportanceExeBasedTip()},c-o));return}const[h,m]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(m).then(I=>{switch(I){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(h),this.addToRecommendedExecutables(m[0].exeName,m);const O=this._register((0,n.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},c));break}case"ignored":this.mediumImportanceTipsByExe.delete(h),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const O=_.Event.once(_.Event.latch(_.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const O=this._register((0,n.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}promptExeRecommendations(s){const o=s.map(({extensionId:h})=>h.toLowerCase()),c=(0,P.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,c,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(a,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(a,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(s,o){const c=this.getPromptedExecutableTips();c[s]=o.map(({extensionId:h})=>h.toLowerCase()),this.storageService.store(r,JSON.stringify(c),0,0)}groupByInstalled(s,o){const c=[],h=[],m=o.reduce((I,O)=>(I.add(O.identifier.id.toLowerCase()),I),new Set);return s.forEach(I=>{m.has(I.toLowerCase())?c.push(I):h.push(I)}),{installed:c,uninstalled:h}}async getValidExecutableBasedExtensionTips(s){const o=[],c=new Map;for(const h of s.keys()){const m=s.get(h);if(!m||!(0,L.isNonEmptyArray)(m.recommendations))continue;const I=[];R.isWindows?m.windowsPath&&I.push(m.windowsPath.replace("%USERPROFILE%",C.env.USERPROFILE).replace("%ProgramFiles(x86)%",C.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",C.env.ProgramFiles).replace("%APPDATA%",C.env.APPDATA).replace("%WINDIR%",C.env.WINDIR)):(I.push((0,k.join)("/usr/local/bin",h)),I.push((0,k.join)("/usr/bin",h)),I.push((0,k.join)(this.environmentService.userHome.fsPath,h)));for(const O of I){let A=c.get(O);if(A===void 0&&(A=await this.fileService.exists(E.URI.file(O)),c.set(O,A)),A)for(const{extensionId:N,extensionName:$,isExtensionPack:D}of m.recommendations)o.push({extensionId:N,extensionName:$,isExtensionPack:D,exeName:h,exeFriendlyName:m.exeFriendlyName,windowsPath:m.windowsPath})}}return o}};i=de([X(0,b.INativeEnvironmentService),X(1,u.ITelemetryService),X(2,f.IExtensionManagementService),X(3,l.IStorageService),X(4,v.INativeHostService),X(5,d.IExtensionRecommendationNotificationService),X(6,w.IFileService),X(7,y.IProductService),X(8,g.IRequestService),X(9,p.ILogService)],i),e.ExtensionTipsService=i}),define(ne[91],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(_){this.appenders=_}listen(_,k){throw new Error(`Event not found: ${k}`)}call(_,k,{eventName:R,data:C}){return this.appenders.forEach(E=>E.log(R,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class n{constructor(_){this.channel=_}log(_,k){return this.channel.call("log",{eventName:_,data:k}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ne[44],ie([0,1,28,15,20,21]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,y){return Promise.resolve(void 0)}publicLog2(v,y){return this.publicLog(v,y)}publicLogError(v,y){return Promise.resolve(void 0)}publicLogError2(v,y){return this.publicLogError(v,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class R{async publicLog(v,y,g){}async publicLogError(v,y,g){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(p,v){return v.onDidChangeConfiguration(y=>{y.source!==6&&p.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(y.source),configurationKeys:d(y.sourceConfig)})})}e.configurationTelemetry=C;function E(p,v){return!(v.disableTelemetry||!p.enableTelemetry)}e.supportsTelemetry=E;function P(p){const v=p.getValue(_.TELEMETRY_SETTING_ID),y=p.getValue("telemetry.enableCrashReporter");if(p.getValue(_.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function b(p){const v=Object.create(null),y=Object.create(null),g=Object.create(null);S(p,g);for(let l in g){l=l.length>150?l.substr(l.length-149):l;const u=g[l];typeof u=="number"?y[l]=u:typeof u=="boolean"?y[l]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${u.length}`),v[l]=u.substring(0,8191)):typeof u!="undefined"&&u!==null&&(v[l]=u)}return{properties:v,measurements:y}}e.validateTelemetryData=b;function f(p){if(!p)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(g=>{p.indexOf(`${g}+`)===0&&(v=g)}),v}e.cleanRemoteAuthority=f;function S(p,v,y=0,g){if(!!p)for(let l of Object.getOwnPropertyNames(p)){const u=p[l],r=g?g+l:l;Array.isArray(u)?v[r]=(0,L.safeStringify)(u):u instanceof Date?v[r]=u.toISOString():(0,n.isObject)(u)?y<2?S(u,v,y+1,r+"."):v[r]=(0,L.safeStringify)(u):v[r]=u}}function d(p){if(!p)return[];const v=[];return w(v,"",p),v}function w(p,v,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(g=>w(p,v?`${v}.${g}`:g,y[g])):p.push(v)}}),define(ne[206],ie([0,1,44,149]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class T{constructor(){}setSharedProperty(C,E){}postEvent(C,E){}}class _{constructor(C,E,P,b,f){this.getMachineId=C,this.configurationService=E,this.productService=P,this.telemetry=b,this.keyValueStorage=f,this.networkInitialized=!1,P.tasConfig&&this.experimentsEnabled&&(0,L.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const S=this.configurationService.getValue("experiments.overrideDelay"),d=typeof S=="number"?S:0;this.overrideInitDelay=new Promise(w=>setTimeout(w,d))}get experimentsEnabled(){return!0}async getTreatment(C){await this.overrideInitDelay;const E=this.configurationService.getValue("experiments.override."+C);if(E!==void 0)return E;if(!this.tasClient||!this.experimentsEnabled)return;let P;const b=await this.tasClient;return this.networkInitialized?P=b.getTreatmentVariable("vscode",C):P=await b.getTreatmentVariableAsync("vscode",C,!0),P=b.getTreatmentVariable("vscode",C),P}async setupTASClient(){const C=this.productService.quality==="stable"?n.TargetPopulation.Public:n.TargetPopulation.Insiders,E=await this.getMachineId(),P=new n.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,E,C),b=this.productService.tasConfig,f=new(await new Promise((S,d)=>{J(["tas-client-umd"],S,d)})).ExperimentationService({filterProviders:[P],telemetry:this.telemetry,storageKey:n.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:b.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:b.assignmentContextTelemetryPropertyName,telemetryEventName:b.telemetryEventName,endpoint:b.endpoint,refetchInterval:n.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=_;class k extends _{constructor(C,E,P){super(()=>Promise.resolve(C),E,P,new T)}}e.AssignmentService=k}),define(ne[207],ie([0,1,16,25,8,28,4,31,15,7,20,13,30,33,76,14,10,26,43,46,23,21,44]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v,y,g,l,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const a=k.isWeb?"web":(0,f.getTargetPlatform)(k.platform,R.arch);var i;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished"})(i||(i={}));function t(...z){return String(z.reduce((V,te)=>V|te,0))}var s;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},m={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class I{constructor(V=m){this.state=V}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(V,te=this.state.pageSize){return new I({...this.state,pageNumber:V,pageSize:te})}withFilter(V,...te){const se=[...this.state.criteria,...te.length?te.map(ce=>({filterType:V,value:ce})):[{filterType:V}]];return new I({...this.state,criteria:se})}withSortBy(V){return new I({...this.state,sortBy:V})}withSortOrder(V){return new I({...this.state,sortOrder:V})}withFlags(...V){return new I({...this.state,flags:V.reduce((te,se)=>te|se,0)})}withAssetTypes(...V){return new I({...this.state,assetTypes:V})}get raw(){const{criteria:V,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he,flags:me,assetTypes:ve}=this.state;return{filters:[{criteria:V,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he}],assetTypes:ve,flags:me}}get searchText(){const V=this.state.criteria.filter(te=>te.filterType===s.SearchText)[0];return V&&V.value?V.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(V=>String(V.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(z,V){const te=(z||[]).filter(se=>se.statisticName===V)[0];return te?te.value:0}function A(z){const V="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(se=>se.assetType.indexOf(V)===0).reduce((se,ce)=>{const he=M(z,ce.assetType);return he&&se.push([ce.assetType.substring(V.length),he]),se},[])}function N(z){if(z.properties){const V=z.properties.filter(ce=>ce.key===o.Repository),te=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=V.filter(ce=>te.test(ce.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return M(z,o.Repository)}function $(z){return{uri:`${z.fallbackAssetUri}/${o.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${o.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function D(z){const V=M(z,o.Icon);if(V)return V;const te=f.DefaultIconPath;return{uri:te,fallbackUri:te}}function M(z,V){return z.files.filter(se=>se.assetType===V)[0]?{uri:`${z.assetUri}/${V}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${V}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}:null}function W(z,V){const te=z.properties?z.properties.filter(ce=>ce.key===V):[],se=te.length>0&&te[0].value;return se?se.split(",").map(ce=>(0,S.adoptToGalleryExtensionId)(ce)):[]}function U(z){const V=z.properties?z.properties.filter(te=>te.key===c.Engine):[];return V.length>0&&V[0].value||""}function x(z){const V=z.properties?z.properties.filter(te=>te.key===c.PreRelease):[];return V.length>0&&V[0].value==="true"}function ee(z){const V=z.properties?z.properties.filter(se=>se.key===c.LocalizedLanguages):[],te=V.length>0&&V[0].value||"";return te?te.split(","):[]}function G(z){return z.indexOf("preview")!==-1}function q(z){return z.targetPlatform?(0,f.toTargetPlatform)(z.targetPlatform):"undefined"}function Y(z){const V=(0,L.distinct)(z.versions.map(q)),te=!!z.tags?.includes(f.WEB_EXTENSION_TAG),se=V.indexOf("web");return te?se===-1&&V.push("web"):se!==-1&&V.splice(se,1),V}function H(z,V){const te=(0,f.getFallbackTargetPlarforms)(V);for(let se=0;se<z.length;se++){const ce=z[se];if(ce.version===z[se-1]?.version){let he=se;const me=q(ce);if(me===V)for(;he>0&&z[he-1].version===ce.version;)he--;else if(te.includes(me))for(;he>0&&z[he-1].version===ce.version&&q(z[he-1])!==V;)he--;he!==se&&(z.splice(se,1),z.splice(he,0,ce))}}return z}e.sortExtensionVersions=H;function Z(z,V,te,se,ce){const he=z.versions[0],me={manifest:M(V,o.Manifest),readme:M(V,o.Details),changelog:M(V,o.Changelog),license:M(V,o.License),repository:N(V),download:$(V),icon:D(V),coreTranslations:A(V)};return{identifier:{id:(0,S.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:V.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,description:z.shortDescription||"",installCount:O(z.statistics,"install"),rating:O(z.statistics,"averagerating"),ratingCount:O(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:te,assets:me,properties:{dependencies:W(V,c.Dependency),extensionPack:W(V,c.ExtensionPack),engine:U(V),localizedLanguages:ee(V),targetPlatform:q(V),isPreReleaseVersion:x(V)},hasPreReleaseVersion:x(he),hasReleaseVersion:se,preview:G(z.flags),telemetryData:ce}}let K=class{constructor(V,te,se,ce,he,me,ve,ge){this.requestService=te,this.logService=se,this.environmentService=ce,this.telemetryService=he,this.fileService=me,this.productService=ve,this.configurationService=ge;const ye=ve.extensionsGallery;this.extensionsGalleryUrl=ye&&ye.serviceUrl,this.extensionsControlUrl=ye&&ye.controlUrl,this.commonHeadersPromise=B(ve.version,ve,this.environmentService,this.configurationService,this.fileService,V)}api(V=""){return`${this.extensionsGalleryUrl}${V}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(V,te,se){const ce=(0,C.isBoolean)(te)?te:!1,he=(0,C.isBoolean)(te)?se:te;let me=new I().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,V.length).withFilter(s.ExtensionName,...V.map(({id:ye})=>ye.toLowerCase()));V.every(ye=>!ye.version)&&(me=me.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:ve}=await this.queryGallery(me,a,n.CancellationToken.None),ge=ve.map(ye=>{const Re=(0,S.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName);return{rawGalleryExtension:ye,version:V.find(Ee=>(0,S.areSameExtensions)(Ee,{id:Re}))?.version,preRelease:ce}});return this.converToGalleryExtensions(ge,a,()=>{},he)}async getExtensions2(V){const te=[],se=[];for(const ve of V)ve.uuid?se.push(ve.uuid):te.push(ve.id.toLowerCase());let ce=new I().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly).withPage(1,V.length);se.length&&(ce=ce.withFilter(s.ExtensionId,...se)),te.length&&(ce=ce.withFilter(s.ExtensionId,...te));const{galleryExtensions:he}=await this.queryGallery(ce,a,n.CancellationToken.None),me=he.map(ve=>{const ge=(0,S.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),ye=V.find(Re=>(0,S.areSameExtensions)(Re,{id:ge,uuid:ve.extensionId}));return{rawGalleryExtension:ve,preRelease:!!ye?.preRelease}});return this.converToGalleryExtensions(me,a,()=>{},n.CancellationToken.None)}async getCompatibleExtension(V,te,se){const ce=(0,f.isIExtensionIdentifier)(V)?null:V;if(ce){if((0,f.isNotWebExtensionInWebTargetPlatform)(ce.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(ce,te,se))return ce}const{id:he,uuid:me}=ce?ce.identifier:V;let ve=new I().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);me?ve=ve.withFilter(s.ExtensionId,me):ve=ve.withFilter(s.ExtensionName,he);const{galleryExtensions:ge}=await this.queryGallery(ve,se,n.CancellationToken.None),[ye]=ge;if(!ye||!ye.versions.length)return null;const Re=Y(ye);if((0,f.isNotWebExtensionInWebTargetPlatform)(Re,se))return null;for(let Ee of ye.versions){if(!U(Ee)){const De=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:c.Engine,value:De}]}}if(await this.isRawExtensionVersionCompatible(Ee,te,Re,se)){const De=ye.versions.some(_e=>!x(_e));return Z(ye,Ee,Re,De)}}return null}async isExtensionCompatible(V,te,se){if(!(0,f.isTargetPlatformCompatible)(V.properties.targetPlatform,V.allTargetPlatforms,se)||!te&&V.properties.isPreReleaseVersion)return!1;let ce=V.properties.engine;if(!ce){const he=await this.getManifest(V,n.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ce=he.engines.vscode}return(0,d.isEngineValid)(ce,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(V,te,se,ce){if(!(0,f.isTargetPlatformCompatible)(q(V),se,ce)||!te&&x(V))return!1;const he=await this.getEngine(V);return(0,d.isEngineValid)(he,this.productService.version,this.productService.date)}async query(V,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=V.text||"";const ce=(0,_.getOrDefault)(V,Ee=>Ee.pageSize,50);let he=new I().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,ce);se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,De,_e)=>(he=he.withFilter(s.Category,_e||De),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,De,_e)=>(he=he.withFilter(s.Tag,_e||De),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(s.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),he=he.withFilter(s.SearchText,se)),he=he.withSortBy(0)):V.ids?he=he.withFilter(s.ExtensionId,...V.ids):V.names?he=he.withFilter(s.ExtensionName,...V.names):he=he.withSortBy(4),typeof V.sortBy=="number"&&(he=he.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(he=he.withSortOrder(V.sortOrder));const{galleryExtensions:me,total:ve}=await this.queryGallery(he,a,te),ge=Ee=>({index:(he.pageNumber-1)*he.pageSize+Ee,querySource:V.source}),ye=await this.converToGalleryExtensions(me.map(Ee=>({rawGalleryExtension:Ee,preRelease:!!V.includePreRelease})),a,ge,te),Re=async(Ee,De)=>{if(De.isCancellationRequested)throw(0,T.canceled)();const _e=he.withPage(Ee+1),{galleryExtensions:Ne}=await this.queryGallery(_e,a,De);return await this.converToGalleryExtensions(Ne.map($e=>({rawGalleryExtension:$e,preRelease:!!V.includePreRelease})),a,ge,te)};return{firstPage:ye,total:ve,pageSize:he.pageSize,getPage:Re}}async converToGalleryExtensions(V,te,se,ce){const he=(ge,ye,Re,Ee)=>{const De=Y(ge);let _e=ge.versions[0];return _e=ge.versions.find(Ne=>Ne.version===_e.version&&(0,f.isTargetPlatformCompatible)(q(Ne),De,te))||_e,x(_e)&&!Ee&&(_e=ge.versions.find(Ne=>Ne.version!==_e.version&&!x(Ne))||_e),Z(ge,_e,De,Re,se(ye))},me=[],ve=new Map;for(let ge=0;ge<V.length;ge++){const{rawGalleryExtension:ye,version:Re,preRelease:Ee}=V[ge],De=ye.versions.some(_e=>!x(_e));if(Re){const _e=ye.versions.find(Ne=>Ne.version===Re);_e&&me.push([ge,Z(ye,_e,Y(ye),De)])}else{const _e=he(ye,ge,De,Ee);_e.properties.isPreReleaseVersion?ve.set(_e.identifier.uuid,{index:ge,preRelease:Ee}):me.push([ge,_e])}}if(ve.size){const ge=new Date().getTime(),ye=new I().withFlags(i.IncludeVersions,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,ve.size).withFilter(s.ExtensionId,...ve.keys()),{galleryExtensions:Re}=await this.queryGallery(ye,te,ce);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-ge,count:ve.size}),Re.length!==ve.size)throw new Error("Not all extensions with latest versions are returned");for(const Ee of Re){const De=Ee.versions.some(xe=>!x(xe)),{index:_e,preRelease:Ne}=ve.get(Ee.extensionId),$e=he(Ee,_e,De,Ne);me.push([_e,$e])}}return me.sort((ge,ye)=>ge[0]-ye[0]).map(([,ge])=>ge)}async queryGallery(V,te,se){if(!this.isEnabled())throw new Error("No extension gallery service configured.");V=V.withFlags(V.flags,i.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,t(i.Unpublished));const ce=await this.commonHeadersPromise,he=JSON.stringify(V.raw),me={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},ve=new Date().getTime();let ge,ye,Re=0;try{if(ge=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:he,headers:me},se),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:Re};const Ee=await(0,y.asJson)(ge);if(Ee){const De=Ee.results[0],_e=De.extensions;_e.forEach($e=>H($e.versions,te));const Ne=De.resultMetadata&&De.resultMetadata.filter($e=>$e.metadataType==="ResultCount")[0];return Re=Ne&&Ne.metadataItems.filter($e=>$e.name==="TotalCount")[0].count||0,{galleryExtensions:_e,total:Re}}return{galleryExtensions:[],total:Re}}catch(Ee){throw ye=Ee,Ee}finally{this.telemetryService.publicLog2("galleryService:query",{...V.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-ve,success:!!ge&&(0,y.isSuccess)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:ye?(0,T.isPromiseCanceledError)(ye)?"canceled":(0,T.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Re)})}}async reportStatistic(V,te,se,ce){if(!this.isEnabled())return;const he=k.isWeb?this.api(`/itemName/${V}.${te}/version/${se}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${V}/extensions/${te}/${se}/stats?statType=${ce}`),me=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:me};try{await this.requestService.request({type:"POST",url:he,headers:ge},n.CancellationToken.None)}catch{}}async download(V,te,se){this.logService.trace("ExtensionGalleryService#download",V.identifier.id);const ce=(0,S.getGalleryExtensionTelemetryData)(V),he=new Date().getTime(),me=Re=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Re}),ve=se===2?"install":se===3?"update":"",ge=ve?{uri:`${V.assets.download.uri}${E.URI.parse(V.assets.download.uri).query?"&":"?"}${ve}=true`,fallbackUri:`${V.assets.download.fallbackUri}${E.URI.parse(V.assets.download.fallbackUri).query?"&":"?"}${ve}=true`}:V.assets.download,ye=await this.getAsset(ge);await this.fileService.writeFile(te,ye.stream),me(new Date().getTime()-he)}async getReadme(V,te){if(V.assets.readme){const se=await this.getAsset(V.assets.readme,{},te);return await(0,y.asText)(se)||""}return""}async getManifest(V,te){if(V.assets.manifest){const se=await this.getAsset(V.assets.manifest,{},te),ce=await(0,y.asText)(se);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(V,te){const se=M(V,o.Manifest);if(!se)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},he=await this.getAsset(se,{headers:ce});return await(0,y.asJson)(he)}async getCoreTranslation(V,te){const se=V.assets.coreTranslations.filter(ce=>ce[0]===te.toUpperCase())[0];if(se){const ce=await this.getAsset(se[1]),he=await(0,y.asText)(ce);return he?JSON.parse(he):null}return null}async getChangelog(V,te){if(V.assets.changelog){const se=await this.getAsset(V.assets.changelog,{},te);return await(0,y.asText)(se)||""}return""}async getAllCompatibleVersions(V,te,se){let ce=new I().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);V.identifier.uuid?ce=ce.withFilter(s.ExtensionId,V.identifier.uuid):ce=ce.withFilter(s.ExtensionName,V.identifier.id);const{galleryExtensions:he}=await this.queryGallery(ce,se,n.CancellationToken.None);if(!he.length)return[];const me=Y(he[0]);if((0,f.isNotWebExtensionInWebTargetPlatform)(me,se))return[];const ve=[];for(const ge of he[0].versions)try{ve[ve.length-1]?.version!==ge.version&&await this.isRawExtensionVersionCompatible(ge,te,me,se)&&ve.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:x(ge)})}catch{}return ve}async getAsset(V,te={},se=n.CancellationToken.None){const ce=await this.commonHeadersPromise,he={type:"GET"},me={...ce,...te.headers||{}};te={...te,...he,headers:me};const ve=V.uri,ge=V.fallbackUri,ye={...te,url:ve};try{const Re=await this.requestService.request(ye,se);if(Re.res.statusCode===200)return Re;const Ee=await(0,y.asText)(Re);throw new Error(`Expected 200, got back ${Re.res.statusCode} instead.

${Ee}`)}catch(Re){if((0,T.isPromiseCanceledError)(Re))throw Re;const Ee=(0,T.getErrorMessage)(Re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ve,message:Ee});const De={...te,url:ge};return this.requestService.request(De,se)}}async getEngine(V){let te=U(V);if(!te){const se=await this.getManifestFromRawExtensionVersion(V,n.CancellationToken.None);if(!se)throw new Error("Manifest was not found");te=se.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const V=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(V.res.statusCode!==200)throw new Error("Could not get extensions report.");const te=await(0,y.asJson)(V),se=[],ce={};if(te){for(const he of te.malicious)se.push({id:he});if(te.unsupported)for(const he of Object.keys(te.unsupported)){const me=te.unsupported[he];(0,C.isBoolean)(me)||(ce[he.toLowerCase()]=me.preReleaseExtension)}}return{malicious:se,unsupportedPreReleaseExtensions:ce}}};K=de([X(1,y.IRequestService),X(2,p.ILogService),X(3,b.IEnvironmentService),X(4,u.ITelemetryService),X(5,w.IFileService),X(6,v.IProductService),X(7,P.IConfigurationService)],K);let F=class extends K{constructor(V,te,se,ce,he,me,ve,ge){super(V,te,se,ce,he,me,ve,ge)}};F=de([X(0,l.IStorageService),X(1,y.IRequestService),X(2,p.ILogService),X(3,b.IEnvironmentService),X(4,u.ITelemetryService),X(5,w.IFileService),X(6,v.IProductService),X(7,P.IConfigurationService)],F),e.ExtensionGalleryService=F;let j=class extends K{constructor(V,te,se,ce,he,me,ve){super(void 0,V,te,se,ce,he,me,ve)}};j=de([X(0,y.IRequestService),X(1,p.ILogService),X(2,b.IEnvironmentService),X(3,u.ITelemetryService),X(4,w.IFileService),X(5,v.IProductService),X(6,P.IConfigurationService)],j),e.ExtensionGalleryServiceWithNoStorageService=j;async function B(z,V,te,se,ce,he){const me={"X-Market-Client-Id":`VSCode ${z}`,"User-Agent":`VSCode ${z} (${V.nameShort})`},ve=await(0,g.getServiceMachineId)(te,ce,he);return(0,r.supportsTelemetry)(V,te)&&(0,r.getTelemetryLevel)(se)===3&&(me["X-Market-User-Id"]=ve),me}e.resolveMarketplaceHeaders=B}),define(ne[92],ie([0,1,2,13,10,44]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends L.Disposable{constructor(C,E,P=""){super();this.prefix=P;const b=C.getLogger(E.telemetryLogResource);b?this.logger=this._register(b):(this.logger=this._register(C.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(C,E){this.logger.trace(`${this.prefix}telemetry/${C}`,(0,_.validateTelemetryData)(E))}};k=de([X(0,T.ILoggerService),X(1,n.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(ne[93],ie([0,1,2,28,4,27,141,20,42,85,38,21,44]),function(J,e,L,n,T,_,k,R,C,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(p,v){this._configurationService=v,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(y),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(y=>{const g=/^[a-f0-9]+$/i.test(y["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!g})})}setExperimentProperty(p,v){this._experimentProperties[p]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const p=await this._commonProperties;let v=p.sessionID,y=p["common.machineId"],g=p["common.firstSessionDate"],l=p["common.msftInternal"];return{sessionId:v,machineId:y,firstSessionDate:g,msftInternal:l}}dispose(){this._disposables.dispose()}_log(p,v,y,g){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(l=>{y=(0,n.mixin)(y,l),y=(0,n.mixin)(y,this._experimentProperties),y=(0,n.cloneAndChange)(y,u=>{if(typeof u=="string")return this._cleanupInfo(u,g)}),this._appenders.forEach(u=>u.log(p,y))},l=>{console.error(l)})}publicLog(p,v,y){return this._log(p,3,v,y)}publicLog2(p,v,y){return this.publicLog(p,v,y)}publicLogError(p,v){return this.sendErrorTelemetry?this._log(p,2,v,!0):Promise.resolve(void 0)}publicLogError2(p,v){return this.publicLogError(p,v)}_anonymizeFilePaths(p){let v=p;const y=[];for(let r of this._cleanupPatterns)for(;;){const a=r.exec(p);if(!a)break;y.push([a.index,r.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(v="";;){const r=l.exec(p);if(!r)break;!g.test(r[0])&&y.every(([a,i])=>r.index<a||r.index>=i)&&(v+=p.substring(u,r.index)+"<REDACTED: user-file-path>",u=l.lastIndex)}return u<p.length&&(v+=p.substr(u)),v}_removePropertiesWithPossibleUserInfo(p){if(!p)return p;const v=p.toLowerCase(),y=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(v)?"<REDACTED: secret>":y.test(v)?"<REDACTED: email>":p}_cleanupInfo(p,v){let y=p;v&&(y=this._anonymizeFilePaths(y));for(let g of this._cleanupPatterns)y=y.replace(g,"");return y=this._removePropertiesWithPossibleUserInfo(y),y}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=de([X(1,R.IConfigurationService)],S),e.TelemetryService=S;function d(){const w=(0,k.localize)(0,null,E.default.nameLong),p=E.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=T.isWeb?"":(0,k.localize)(3,null),y=(0,k.localize)(4,null),g=(0,k.localize)(5,null),l=(0,k.localize)(6,null),u=(0,k.localize)(7,null),r=`
|       | ${y} | ${g} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,k.localize)(8,null);return`
${w} ${p} ${v}

&nbsp;

${u}
${r}

&nbsp;

${a}
`}P.Registry.as(C.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:d(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(C.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,k.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,k.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[208],ie([0,1,8,28,44]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function _(R,C){const E=await new Promise((b,f)=>{J(["applicationinsights"],b,f)});let P;return E.defaultClient?(P=new E.TelemetryClient(R),P.channel.setUseDiskRetryCaching(!0)):(E.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=E.defaultClient),R.indexOf("AIF-")===0&&(P.config.endpointUrl=C?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class k{constructor(C,E,P,b,f){this._eventPrefix=C,this._defaultData=E,this.testCollector=b,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(C){if(!!this._aiClient){if(typeof this._aiClient!="string"){C(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=_(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(E=>{C(E)},E=>{(0,L.onUnexpectedError)(E),console.error(E)})}}log(C,E){!this._aiClient||(E=(0,n.mixin)(E,this._defaultData),E=(0,T.validateTelemetryData)(E),this.testCollector&&(E.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+C,properties:E.properties,measurements:E.measurements})))}flush(){return this._aiClient?new Promise(C=>{this._withAIClient(E=>{E.flush({callback:()=>{this._aiClient=void 0,C(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(ne[209],ie([0,1,18,57,20,13,10,21,91,92,93]),function(J,e,L,n,T,_,k,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let b=class{constructor(S,d,w,p){this.configurationService=S,this.telemetryService=d,this.loggerService=w,this.environmentService=p,this.customTelemetryServices=new Map}async getCustomTelemetryService(S){if(!this.customTelemetryServices.has(S.id)){const{machineId:d,sessionId:w}=await this.telemetryService.getTelemetryInfo(),p=Object.create(null);p["common.vscodemachineid"]=d,p["common.vscodesessionid"]=w;const v=[S.id,JSON.stringify(p),S.aiKey],g=new n.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:v,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new C.TelemetryAppenderClient(g),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${S.id}] `)];this.customTelemetryServices.set(S.id,new P.TelemetryService({appenders:l,sendErrorTelemetry:S.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(S.id)}async publicLog(S,d,w){await(await this.getCustomTelemetryService(S)).publicLog(d,w)}async publicLogError(S,d,w){await(await this.getCustomTelemetryService(S)).publicLogError(d,w)}};b=de([X(0,T.IConfigurationService),X(1,R.ITelemetryService),X(2,k.ILoggerService),X(3,_.IEnvironmentService)],b),e.CustomEndpointTelemetryService=b}),define(ne[210],ie([0,1,5,25,3,2,10]),function(J,e,L,n,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends _.Disposable{constructor(E,P){super();this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new T.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((P,b)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,P),this._onCreateRequest.fire({requestId:f,...E});const S=new n.CancellationTokenSource;(0,L.timeout)(this._timeout,S.token).then(()=>b(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,_.toDisposable)(()=>S.cancel())])})}acceptReply(E,P){const b=this._pendingRequests.get(E);b?(this._pendingRequests.delete(E),(0,_.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),b(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};R=de([X(1,k.ILogService)],R),e.RequestStore=R}),define(ne[94],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(p){p.Shell="terminal.integrated.shell.",p.ShellArgs="terminal.integrated.shellArgs.",p.DefaultProfile="terminal.integrated.defaultProfile.",p.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var T;(function(p){p.ShellLinux="terminal.integrated.shell.linux",p.ShellMacOs="terminal.integrated.shell.osx",p.ShellWindows="terminal.integrated.shell.windows",p.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",p.AutomationShellLinux="terminal.integrated.automationShell.linux",p.AutomationShellMacOs="terminal.integrated.automationShell.osx",p.AutomationShellWindows="terminal.integrated.automationShell.windows",p.AutomationProfileLinux="terminal.integrated.automationProfile.linux",p.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",p.AutomationProfileWindows="terminal.integrated.automationProfile.windows",p.ShellArgsLinux="terminal.integrated.shellArgs.linux",p.ShellArgsMacOs="terminal.integrated.shellArgs.osx",p.ShellArgsWindows="terminal.integrated.shellArgs.windows",p.ProfilesWindows="terminal.integrated.profiles.windows",p.ProfilesMacOs="terminal.integrated.profiles.osx",p.ProfilesLinux="terminal.integrated.profiles.linux",p.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",p.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",p.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",p.UseWslProfiles="terminal.integrated.useWslProfiles",p.TabsEnabled="terminal.integrated.tabs.enabled",p.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",p.TabsHideCondition="terminal.integrated.tabs.hideCondition",p.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",p.TabsShowActions="terminal.integrated.tabs.showActions",p.TabsLocation="terminal.integrated.tabs.location",p.TabsFocusMode="terminal.integrated.tabs.focusMode",p.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",p.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",p.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",p.CopyOnSelection="terminal.integrated.copyOnSelection",p.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",p.FontFamily="terminal.integrated.fontFamily",p.FontSize="terminal.integrated.fontSize",p.LetterSpacing="terminal.integrated.letterSpacing",p.LineHeight="terminal.integrated.lineHeight",p.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",p.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",p.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",p.BellDuration="terminal.integrated.bellDuration",p.FontWeight="terminal.integrated.fontWeight",p.FontWeightBold="terminal.integrated.fontWeightBold",p.CursorBlinking="terminal.integrated.cursorBlinking",p.CursorStyle="terminal.integrated.cursorStyle",p.CursorWidth="terminal.integrated.cursorWidth",p.Scrollback="terminal.integrated.scrollback",p.DetectLocale="terminal.integrated.detectLocale",p.DefaultLocation="terminal.integrated.defaultLocation",p.GpuAcceleration="terminal.integrated.gpuAcceleration",p.TerminalTitleSeparator="terminal.integrated.tabs.separator",p.TerminalTitle="terminal.integrated.tabs.title",p.TerminalDescription="terminal.integrated.tabs.description",p.RightClickBehavior="terminal.integrated.rightClickBehavior",p.Cwd="terminal.integrated.cwd",p.ConfirmOnExit="terminal.integrated.confirmOnExit",p.ConfirmOnKill="terminal.integrated.confirmOnKill",p.EnableBell="terminal.integrated.enableBell",p.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",p.AllowChords="terminal.integrated.allowChords",p.AllowMnemonics="terminal.integrated.allowMnemonics",p.EnvMacOs="terminal.integrated.env.osx",p.EnvLinux="terminal.integrated.env.linux",p.EnvWindows="terminal.integrated.env.windows",p.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",p.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",p.ShowExitAlert="terminal.integrated.showExitAlert",p.SplitCwd="terminal.integrated.splitCwd",p.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",p.WordSeparators="terminal.integrated.wordSeparators",p.EnableFileLinks="terminal.integrated.enableFileLinks",p.UnicodeVersion="terminal.integrated.unicodeVersion",p.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",p.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",p.LocalEchoEnabled="terminal.integrated.localEchoEnabled",p.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",p.LocalEchoStyle="terminal.integrated.localEchoStyle",p.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",p.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",p.CustomGlyphs="terminal.integrated.customGlyphs",p.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",p.InheritEnv="terminal.integrated.inheritEnv",p.ShowLinkHover="terminal.integrated.showLinkHover",p.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",p.AutoReplies="terminal.integrated.autoReplies"})(T=e.TerminalSettingId||(e.TerminalSettingId={}));var _;(function(p){p.CommandPrompt="cmd",p.PowerShell="pwsh",p.Wsl="wsl",p.GitBash="gitbash"})(_=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(p){p[p.Api=0]="Api",p[p.Process=1]="Process",p[p.Sequence=2]="Sequence",p[p.Config=3]="Config"})(k=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(p){p.LocalPty="localPty",p.PtyHost="ptyHost",p.Log="log",p.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,L.createDecorator)("ptyService");var C;(function(p){p.Cwd="cwd",p.InitialCwd="initialCwd",p.FixedDimensions="fixedDimensions",p.Title="title",p.ShellType="shellType",p.HasChildProcesses="hasChildProcesses",p.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",p.OverrideDimensions="overrideDimensions"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(p){p[p.BeatInterval=5e3]="BeatInterval",p[p.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",p[p.SecondWaitMultiplier=1]="SecondWaitMultiplier",p[p.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(p){p[p.Panel=1]="Panel",p[p.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var b;(function(p){p.TerminalView="view",p.Editor="editor"})(b=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(p){p.CwdDetection="cwdDetection"})(f=e.ProcessCapability||(e.ProcessCapability={}));var S;(function(p){p[p.GraceTime=6e4]="GraceTime",p[p.ShortGraceTime=6e3]="ShortGraceTime"})(S=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var d;(function(p){p[p.HighWatermarkChars=1e5]="HighWatermarkChars",p[p.LowWatermarkChars=5e3]="LowWatermarkChars",p[p.CharCountAckSize=5e3]="CharCountAckSize"})(d=e.FlowControlConstants||(e.FlowControlConstants={}));var w;(function(p){p.GitBash="Git Bash",p.Pwsh="PowerShell"})(w=e.ProfileSource||(e.ProfileSource={}))}),define(ne[211],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,L.createDecorator)("localPtyService")}),define(ne[212],ie([0,1,32,28,9,4,31,15,22]),function(J,e,L,n,T,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(L.release());let f=0;return b&&b.length===4&&(f=parseInt(b[3])),f}e.getWindowsBuildNumber=E;async function P(b,f,S,d=k.env,w=C.Promises.exists){if(T.isAbsolute(b))return await w(b)?b:void 0;if(f===void 0&&(f=k.cwd()),T.dirname(b)!=="."){const g=T.join(f,b);return await w(g)?g:void 0}const v=(0,n.getCaseInsensitive)(d,"PATH");if(S===void 0&&(0,R.isString)(v)&&(S=v.split(T.delimiter)),S===void 0||S.length===0){const g=T.join(f,b);return await w(g)?g:void 0}for(let g of S){let l;if(T.isAbsolute(g)?l=T.join(g,b):l=T.join(f,g,b),await w(l))return l;if(_.isWindows){let u=l+".com";if(await w(u)||(u=l+".exe",await w(u)))return u}}const y=T.join(f,b);return await w(y)?y:void 0}e.findExecutable=P}),define(ne[213],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var L;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(L=e.ColorScheme||(e.ColorScheme={}))}),define(ne[95],ie([0,1,48,3,2,6,38,213]),function(J,e,L,n,T,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var C;(function(p){function v(y){return y&&typeof y=="object"&&typeof y.id=="string"}p.isThemeColor=v})(C=e.ThemeColor||(e.ThemeColor={}));function E(p){return{id:p}}e.themeColorFromId=E;var P;(function(p){function v(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||C.isThemeColor(t.color))}p.isThemeIcon=v;const y=new RegExp(`^\\$\\((${L.CSSIcon.iconNameExpression}(?:${L.CSSIcon.iconModifierExpression})?)\\)$`);function g(t){const s=y.exec(t);if(!s)return;let[,o]=s;return{id:o}}p.fromString=g;function l(t){return{id:t}}p.fromId=l;function u(t,s){let o=t.id;const c=o.lastIndexOf("~");return c!==-1&&(o=o.substring(0,c)),s&&(o=`${o}~${s}`),{id:o}}p.modify=u;function r(t){const s=t.id.lastIndexOf("~");if(s!==-1)return t.id.substring(s+1)}p.getModifier=r;function a(t,s){return t.id===s.id&&t.color?.id===s.color?.id}p.isEqual=a;function i(t,s){return{id:t.id,color:s?E(s):void 0}}p.asThemeIcon=i,p.asClassNameArray=L.CSSIcon.asClassNameArray,p.asClassName=L.CSSIcon.asClassName,p.asCSSSelector=L.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=L.Codicon.file,e.FolderThemeIcon=L.Codicon.folder;function b(p){switch(p){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,T.toDisposable)(()=>{const y=this.themingParticipants.indexOf(v);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new f;k.Registry.add(e.Extensions.ThemingContribution,S);function d(p){return S.onColorThemeChange(p)}e.registerThemingParticipant=d;class w extends T.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,y){let g=this.theme.getColor(v);return g&&y&&(g=y(g,this.theme)),g?g.toString():null}}e.Themable=w}),define(ne[214],ie([0,1,48,7,95]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function _(b,f){const S=b.map(d=>({name:d.profileName,description:k(d)}));return f&&S.push(...f.map(d=>({name:d.title,description:R(d)}))),{values:S.map(d=>d.name),markdownDescriptions:S.map(d=>d.description)}}e.createProfileSchemaEnums=_;function k(b){let f=`$(${T.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:L.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?f+=`
- args: "${b.args}"`:f+=`
- args: [${b.args.length===0?"":`'${b.args.join("','")}'`}]`),b.overrideName!==void 0&&(f+=`
- overrideName: ${b.overrideName}`),b.color&&(f+=`
- color: ${b.color}`),b.env&&(f+=`
- env: ${JSON.stringify(b.env)}`),f}function R(b){return`$(${T.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:L.Codicon.terminal.id}) ${b.title}
- extensionIdenfifier: ${b.extensionIdentifier}`}function C(b,f){if(!b&&!f)return!0;if(typeof b=="string"&&typeof f=="string")return b===f;if(Array.isArray(b)&&Array.isArray(f)){if(b.length!==f.length)return!1;for(let S=0;S<b.length;S++)if(b[S]!==f[S])return!1;return!0}return!1}e.terminalProfileArgsMatch=C;function E(b,f){if(!b&&!f)return!0;if(!b||!f)return!1;if(T.ThemeIcon.isThemeIcon(b)&&T.ThemeIcon.isThemeIcon(f))return b.id===f.id&&b.color===f.color;if(typeof b=="object"&&b&&"light"in b&&"dark"in b&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const S=b,d=f;if((n.URI.isUri(S.light)||P(S.light))&&(n.URI.isUri(S.dark)||P(S.dark))&&(n.URI.isUri(d.light)||P(d.light))&&(n.URI.isUri(d.dark)||P(d.dark)))return S.light.path===d.light.path&&S.dark.path===d.dark.path}if(n.URI.isUri(b)&&n.URI.isUri(f)||P(b)||P(f)){const S=b,d=f;return S.path===d.path&&S.scheme===d.scheme}return!1}e.terminalIconsEqual=E;function P(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}e.isUriComponents=P}),define(ne[215],ie([0,1,48,142,42,38,214]),function(J,e,L,n,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(L.Codicon.getAll(),l=>l.id),markdownEnumDescriptions:Array.from(L.Codicon.getAll(),l=>`$(${l.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},C={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},E={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),f=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),S=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),w=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),p={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,n.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,n.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:f},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function v(){_.Registry.as(T.Extensions.Configuration).registerConfiguration(p),g()}e.registerTerminalPlatformConfiguration=v;let y;function g(l,u){const r=_.Registry.as(T.Extensions.Configuration);let a;l&&(a=(0,k.createProfileSchemaEnums)(l?.profiles,u));const i=y;y={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:l?.os===3?a?.values:void 0,markdownEnumDescriptions:l?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:l?.os===2?a?.values:void 0,markdownEnumDescriptions:l?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:l?.os===1?a?.values:void 0,markdownEnumDescriptions:l?.os===1?a?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[y],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(ne[216],ie([0,1,45,48,9,4,22,70,212,95]),function(J,e,L,n,T,_,k,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,b=!0;function f(a,i,t,s,o=process.env,c,h,m,I){return c=c||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},_.isWindows?S(t,c,o,h,s.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:s.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:s.getValue("terminal.integrated.defaultProfile.windows"),I,m):l(c,h,t,a&&typeof a=="object"?{...a}:s.getValue(_.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:s.getValue(_.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,m,o)}e.detectAvailableProfiles=f;async function S(a,i,t,s,o,c,h,m,I){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),A=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let N=!1;(0,C.getWindowsBuildNumber)()>=16299&&(N=!0),await p(m);const $=new Map;a&&($.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${A}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),$.set("Command Prompt",{path:`${A}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),u(c,$);const D=await d($.entries(),h,i,t,s,I);if(a||!a&&o)try{const M=await y(`${A}\\${N?"wsl":"bash"}.exe`,h);for(const W of M)(!c||!(W.profileName in c))&&D.push(W)}catch{b&&(s?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return D}async function d(a,i,t,s=process.env,o,c){const h=[];for(const[m,I]of a){if(I===null)continue;let O,A,N;if("source"in I){const M=P?.get(I.source);if(!M)continue;O=M.paths,A=I.args||M.args,I.icon?N=w(I.icon):M.icon&&(N=M.icon)}else O=Array.isArray(I.path)?I.path:[I.path],A=_.isWindows||Array.isArray(I.args)?I.args:void 0,N=w(I.icon);const $=await c?.(O)||O.slice(),D=await r(m,i,$,t,s,A,I.env,I.overrideName,I.isAutoDetected,o);D?(D.isAutoDetected=I.isAutoDetected,D.icon=N,D.color=I.color,h.push(D)):o?.trace("profile not validated",m,O)}return h}function w(a){return typeof a=="string"?{id:a}:a}async function p(a){P&&!a||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),P.set("PowerShell",{profileName:"PowerShell",paths:a||await v(),icon:E.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function v(){const a=[];for await(const i of(0,R.enumeratePowerShellInstallations)())a.push(i.exePath);return a}async function y(a,i){const t=[],s=await new Promise((h,m)=>{L.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,O)=>{if(I)return m("Problem occurred when getting wsl distros");h(O)})});if(!s)return[];const o=new RegExp(/[\r?\n]/),c=s.split(o).filter(h=>h.trim().length>0&&h!=="");for(const h of c){if(h===""||h.startsWith("docker-desktop"))continue;const m=`${h} (WSL)`,I={profileName:m,path:a,args:["-d",`${h}`],isDefault:m===i,icon:g(h),isAutoDetected:!1};t.push(I)}return t}function g(a){return a.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):a.includes("Debian")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function l(a,i,t,s,o,c,h,m){const I=new Map;if(t){const O=(await a.readFile("/etc/shells")).toString(),A=c||O.split(`
`).filter($=>$.trim().indexOf("#")!==0&&$.trim().length>0),N=new Map;for(const $ of A){let D=(0,T.basename)($),M=N.get(D)||0;M++,M>1&&(D=`${D} (${M})`),N.set(D,M),I.set(D,{path:$,isAutoDetected:!0})}}return u(s,I),await d(I.entries(),o,a,m,i,h)}function u(a,i){if(!!a)for(const[t,s]of Object.entries(a))s===null||!("path"in s)&&!("source"in s)?i.delete(t):(s.icon=s.icon||i.get(t)?.icon,i.set(t,s))}async function r(a,i,t,s,o,c,h,m,I,O){if(t.length===0)return Promise.resolve(void 0);const A=t.shift();if(A==="")return r(a,i,t,s,o,c,h,m,I);const N={profileName:a,path:A,args:c,env:h,overrideName:m,isAutoDetected:I,isDefault:a===i};if((0,T.basename)(A)===A){const D=o.PATH?o.PATH.split(T.delimiter):void 0;return await(0,C.findExecutable)(A,void 0,D,void 0,s.existsFile)?N:r(a,i,t,s,o,c)}return await s.existsFile((0,T.normalize)(A))?N:r(a,i,t,s,o,c,h,m,I)}}),define(ne[217],ie([0,1,3,2,18,4,36,57,20,13,75,164,10,84,21,210,94,215,216]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let l=0,u=class extends n.Disposable{constructor(a,i,t,s,o){super();this._reconnectConstants=a,this._configurationService=i,this._environmentService=t,this._logService=s,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new L.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new L.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new L.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new L.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new L.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new L.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new L.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new L.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new L.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new L.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new L.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new L.Emitter),this.onProcessExit=this._onProcessExit.event,(0,v.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new w.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(_.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:l,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?a.debugBrk=i.port:!i.break&&i.port&&(a.debug=i.port));const t=new R.Client(T.FileAccess.asFileUri("bootstrap-fork",J).fsPath,a);this._onPtyHostStart.fire(),k.ProxyChannel.toService(t.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(h=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(h.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}, giving up`))}));const o=t.getChannel(p.TerminalIpcChannels.Log);S.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const c=k.ProxyChannel.toService(t.getChannel(p.TerminalIpcChannels.PtyHost));return this._register(c.onProcessData(h=>this._onProcessData.fire(h))),this._register(c.onProcessReady(h=>this._onProcessReady.fire(h))),this._register(c.onProcessExit(h=>this._onProcessExit.fire(h))),this._register(c.onDidChangeProperty(h=>this._onDidChangeProperty.fire(h))),this._register(c.onProcessReplay(h=>this._onProcessReplay.fire(h))),this._register(c.onProcessOrphanQuestion(h=>this._onProcessOrphanQuestion.fire(h))),this._register(c.onDidRequestDetach(h=>this._onDidRequestDetach.fire(h))),[t,c]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,i,t,s,o,c,h,m,I,O,A){const N=setTimeout(()=>this._handleUnresponsiveCreateProcess(),p.HeartbeatConstants.CreateProcessTimeout),$=await this._proxy.createProcess(a,i,t,s,o,c,h,m,I,O,A);return clearTimeout(N),l=Math.max(l,$),$}updateTitle(a,i,t){return this._proxy.updateTitle(a,i,t)}updateIcon(a,i,t){return this._proxy.updateIcon(a,i,t)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,i){return this._proxy.shutdown(a,i)}input(a,i){return this._proxy.input(a,i)}processBinary(a,i){return this._proxy.processBinary(a,i)}resize(a,i,t){return this._proxy.resize(a,i,t)}acknowledgeDataEvent(a,i){return this._proxy.acknowledgeDataEvent(a,i)}setUnicodeVersion(a,i){return this._proxy.setUnicodeVersion(a,i)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,i){return this._proxy.installAutoReply(a,i)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,i,t,s=!1){const o=await this._shellEnv;return(0,y.detectAvailableProfiles)(i,t,s,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,i){return this._proxy.requestDetachInstance(a,i)}async acceptDetachInstanceReply(a,i){return this._proxy.acceptDetachInstanceReply(a,i)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,i){return this._proxy.reviveTerminalProcesses(a,i)}async refreshProperty(a,i){return this._proxy.refreshProperty(a,i)}async updateProperty(a,i,t){return this._proxy.updateProperty(a,i,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:i})}async acceptPtyHostResolvedVariables(a,i){this._resolveVariablesRequestStore.acceptReply(a,i)}};u=de([X(1,C.IConfigurationService),X(2,E.IEnvironmentService),X(3,f.ILogService),X(4,d.ITelemetryService)],u),e.PtyHostService=u}),define(ne[34],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(ne[218],ie([0,1,3,2,7,13,33,14,10,34]),function(J,e,L,n,T,_,k,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends n.Disposable{constructor(f,S,d,w,p){super();this.extensionsManagementService=f,this.logService=w,this.uriIdentityService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(y=>this.onInstallExtension(y))),this._register(f.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(f.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const v=T.URI.file(d.extensionsPath);this._register(S.watch(v)),this._register(L.Event.filter(S.onDidChangeFilesRaw,y=>y.changes.some(g=>this.doesChangeAffects(g,v)))(()=>this.onDidChange()))}doesChangeAffects(f,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),S)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const S of f)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(S=>!(0,k.areSameExtensions)(S,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,k.areSameExtensions)(S,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),S=f.filter(w=>[...this.installingExtensions,...this.installedExtensions].some(p=>(0,k.areSameExtensions)(p,w.identifier))?!1:w.installedTimestamp&&w.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",w.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",w.identifier.id),!1)),d=this.installedExtensions.filter(w=>this.installingExtensions.some(p=>(0,k.areSameExtensions)(p,w))?!1:f.every(p=>!(0,k.areSameExtensions)(p.identifier,w))?(this.logService.info("Detected extension removed from another source",w.id),!0):!1);this.installedExtensions=f.map(w=>w.identifier),(S.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:d})}}};P=de([X(1,R.IFileService),X(2,_.INativeEnvironmentService),X(3,C.ILogService),X(4,E.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(ne[219],ie([0,1,34,77,14,19,103,3,2]),function(J,e,L,n,T,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(f){this.uri=f,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let P=class{constructor(f){this._fileService=f,this._dispooables=new C.DisposableStore,this._limit=2**16;const S=new Map,d=w=>{let p=S.get(w.scheme);return p===void 0&&(p=f.hasProvider(w)&&!this._fileService.hasCapability(w,1024),S.set(w.scheme,p)),p};this._dispooables.add(R.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(w=>{S.delete(w.scheme)})),this.extUri=new _.ExtUri(d),this._canonicalUris=new k.SkipList((w,p)=>this.extUri.compare(w,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,_.normalizePath)(f));let S=this._canonicalUris.get(f);return S?S.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new E(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((d,w)=>d[1].touch<w[1].touch?1:d[1].touch>w[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let d=0;d<S;d++)this._canonicalUris.set(f[d][0],f[d][1].touch())}};P=de([X(0,T.IFileService)],P),e.UriIdentityService=P,(0,n.registerSingleton)(L.IUriIdentityService,P,!0)}),define(ne[220],ie([0,1,3,2,40,39,17]),function(J,e,L,n,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends n.Disposable{constructor(E,P,b,f,S){super();this.fileSystemScheme=E,this.fileSystemProvider=P,this.userDataScheme=b,this.logService=S,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=_.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(f.onDidFilesChange(d=>this.handleFileChanges(d)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(E,P){this.watchResources.set(E,E);const b=this.fileSystemProvider.watch(this.toFileSystemResource(E),P);return(0,n.toDisposable)(()=>{this.watchResources.delete(E),b.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,P,b){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(P),b)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,P,b){const f=(0,T.newWriteableStream)(S=>k.VSBuffer.concat(S.map(d=>k.VSBuffer.wrap(d))).buffer);return(async()=>{try{const S=await this.readFile(E);f.end(S)}catch(S){f.error(S),f.end()}})(),f}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,P,b){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),P,b)}delete(E,P){return this.fileSystemProvider.delete(this.toFileSystemResource(E),P)}handleFileChanges(E){const P=[];for(const b of[{raw:E.rawAdded,type:1},{raw:E.rawUpdated,type:0},{raw:E.rawDeleted,type:2}])if(b.raw)for(const[f]of b.raw){if(f.scheme!==this.fileSystemScheme)continue;const S=this.toUserDataResource(f);this.watchResources.findSubstr(S)&&P.push({resource:S,type:b.type})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(ne[52],ie([0,1,68]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(k,R,C,E){const P=(0,L.setProperty)(k,R,C,E)[0];return P&&(k=k.substring(0,P.offset)+P.content+k.substring(P.offset+P.length)),k}e.edit=n;function T(k,R,C){let E=C;for(;E>=0;){if(k.charAt(E)===R.charAt(R.length-1)&&R.length===1)return E+1;if(E--,R.length===2&&E>=0&&k.charAt(E)===R.charAt(0))return E+2}return 0}e.getLineStartOffset=T;function _(k,R,C){let E=C;for(;E>=0;)if(k.charAt(E)===R.charAt(R.length-1)&&R.length===1||(E++,R.length===2&&E>=0&&k.charAt(E)===R.charAt(1)))return E;return k.length-1}e.getLineEndOffset=_}),define(ne[221],ie([0,1,28,61,15]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function _(f,S,d,w,p){const v=[],y=[],g=[];if(!S){const A=f.filter(({identifier:N})=>p.every($=>$.toLowerCase()!==N.id.toLowerCase()));return{local:{added:v,removed:y,updated:g},remote:A.length>0?{added:A,updated:[],removed:[],all:A}:null}}f=f.map(P),S=S.map(P),d=d?d.map(P):null;const l=new Map,u=A=>{A.uuid&&l.set(A.id.toLowerCase(),A.uuid)};f.forEach(({identifier:A})=>u(A)),S.forEach(({identifier:A})=>u(A)),d&&d.forEach(({identifier:A})=>u(A));const r=A=>{const N=A.identifier.uuid||l.get(A.identifier.id.toLowerCase());return N?`uuid:${N}`:`id:${A.identifier.id.toLowerCase()}`},a=(A,N)=>(A.set(r(N),N),A),i=f.reduce(a,new Map),t=S.reduce(a,new Map),s=S.reduce((A,N)=>{const $=r(N);N=(0,L.deepClone)(N);const D=i.get($);return D&&(D.installed&&(N.installed=!0),N.version||(N.version=D.version)),a(A,N)},new Map),o=d?d.reduce(a,new Map):null,c=w.reduce(a,new Map),h=p.reduce((A,N)=>{const $=l.get(N.toLowerCase());return A.add($?`uuid:${$}`:`id:${N.toLowerCase()}`)},new Set),m=k(i,t,h);if(m.added.size>0||m.removed.size>0||m.updated.size>0){const A=k(o,i,h),N=k(o,t,h),$=(D,M)=>{const W=i.get(D);if(W){const U=t.get(D),x=M?U:W;return{...x,version:(U.version&&n.gt(U.version,W.version),W.version),state:R(W,U,o?.get(D)),preRelease:(0,T.isUndefined)(x.preRelease)?W.preRelease:x.preRelease}}};for(const D of N.removed.values()){const M=i.get(D);M&&y.push(M.identifier)}for(const D of N.added.values())if(A.added.has(D)){if(m.updated.has(D)){const M=$(D,!0);M&&(g.push(b(M,D)),s.set(D,M))}}else{const M=t.get(D);M.installed&&v.push(b(M,D))}for(const D of N.updated.values()){const M=$(D,!0);M&&(g.push(b(M,D)),s.set(D,M))}for(const D of A.added.values())N.added.has(D)||s.set(D,i.get(D));for(const D of A.updated.values())if(!N.removed.has(D)&&!N.updated.has(D)){const M=$(D,!1);M&&(s.get(D)?.installed&&(M.installed=!0),s.set(D,M))}for(const D of A.removed.values())!c.has(D)&&!N.updated.has(D)&&o?.get(D)?.installed&&s.delete(D)}const I=[],O=k(t,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(O.added.size>0||O.updated.size>0||O.removed.size>0)&&s.forEach((A,N)=>I.push(b(A,N))),{local:{added:v,removed:y,updated:g},remote:I.length?{added:[...O.added].map(A=>s.get(A)),updated:[...O.updated].map(A=>s.get(A)),removed:[...O.removed].map(A=>t.get(A)),all:I}:null}}e.merge=_;function k(f,S,d,{checkInstalledProperty:w,checkVersionProperty:p}={checkInstalledProperty:!1,checkVersionProperty:!1}){const v=f?[...f.keys()].filter(r=>!d.has(r)):[],y=[...S.keys()].filter(r=>!d.has(r)),g=y.filter(r=>v.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),l=v.filter(r=>y.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),u=new Set;for(const r of v){if(l.has(r))continue;const a=f.get(r),i=S.get(r);(!i||a.disabled!==i.disabled||a.preRelease!==i.preRelease||!E(a.state,i.state)||p&&a.version!==i.version||w&&a.installed!==i.installed)&&u.add(r)}return{added:g,removed:l,updated:u}}function R(f,S,d){const w=f.state,p=S.state,v=d?.state;if(!S.version||w&&n.gt(f.version,S.version))return w;if(p&&n.gt(S.version,f.version)||!w)return p;if(!p)return w;const y=(0,L.deepClone)(w),g=v?C(v,p):{added:Object.keys(p).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set},l=v?C(v,w):{added:Object.keys(w).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set};for(const u of[...g.added.values(),...g.updated.values()])y[u]=p[u];for(const u of g.removed.values())l.updated.has(u)||delete y[u];return y}function C(f,S){const d=Object.keys(f),w=Object.keys(S),p=w.filter(g=>d.indexOf(g)===-1).reduce((g,l)=>(g.add(l),g),new Set),v=d.filter(g=>w.indexOf(g)===-1).reduce((g,l)=>(g.add(l),g),new Set),y=new Set;for(const g of d){if(v.has(g))continue;const l=f[g],u=S[g];(0,L.equals)(l,u)||y.add(g)}return{added:p,removed:v,updated:y}}function E(f={},S={}){const{added:d,removed:w,updated:p}=C(f,S);return d.size===0&&w.size===0&&p.size===0}function P(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function b(f,S){const d={identifier:{id:f.identifier.id,uuid:S.startsWith("uuid:")?S.substring("uuid:".length):void 0},preRelease:!!f.preRelease};return f.version&&(d.version=f.version),f.disabled&&(d.disabled=!0),f.installed&&(d.installed=!0),f.state&&(d.state=f.state),d}}),define(ne[96],ie([0,1,16,3,2,33,6,26,23]),function(J,e,L,n,T,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,k.createDecorator)("IExtensionsStorageSyncService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let P=class it extends T.Disposable{constructor(f,S){super();this.storageService=f,this.productService=S,this._onDidChangeExtensionsStorage=this._register(new n.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(d=>this.onDidChangeStorageValue(d)))}static toKey(f){return`extensionKeys/${(0,_.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const S=E.exec(f);if(S&&S[1])return{id:S[1],version:S[2]}}initialize(){const f=this.storageService.keys(0,1);for(const S of f){const d=it.fromKey(S);d&&this.extensionsWithKeysForSync.add(d.id.toLowerCase())}}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const S=it.fromKey(f.key);if(S){this.extensionsWithKeysForSync.add(S.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(f,S){this.storageService.store(it.toKey(f),JSON.stringify(S),0,1)}getKeysForSync(f){const S=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],d=this.storageService.get(it.toKey(f),0),w=d?JSON.parse(d):void 0;return w&&S?(0,L.distinct)([...w,...S]):w||S}};P=de([X(0,C.IStorageService),X(1,R.IProductService)],P),e.ExtensionsStorageSyncService=P}),define(ne[97],ie([0,1,16,20,6]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,T.createDecorator)("IIgnoredExtensionsManagementService");let _=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,C){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==R&&P!==`-${R}`),C&&E.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(R,C){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==R&&P!==`-${R}`),C&&E.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(R){const C=R.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),P=[],b=[];if(Array.isArray(E))for(const f of E)f.startsWith("-")?b.push(f.substring(1)):P.push(f);return(0,L.distinct)([...C,...P].filter(f=>b.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};_=de([X(0,n.IConfigurationService)],_),e.IgnoredExtensionsManagementService=_}),define(ne[222],ie([0,1,16,35,28,159,52]),function(J,e,L,n,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(l){return(0,n.parse)(l)||[]}e.parseKeybindings=R;async function C(l,u,r,a,i){const t=R(l),s=R(u),o=r?R(r):null,c=[...t,...s,...o||[]].map(U=>U.key),h=await i.resolveUserBindings(c);let m=P(t,s,o,h);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:l,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};const I=f(t),O=f(s),A=o?f(o):null,N=d(I,O,h),$=A?d(A,I,h):{added:[...I.keys()].reduce((U,x)=>(U.add(x),U),new Set),removed:new Set,updated:new Set},D=A?d(A,O,h):{added:[...O.keys()].reduce((U,x)=>(U.add(x),U),new Set),removed:new Set,updated:new Set},M=E(N,$,D);let W=l;for(const U of M.removed.values())M.conflicts.has(U)||(W=y(W,U,a));for(const U of M.added.values()){if(M.conflicts.has(U))continue;const x=O.get(U);if(x.some(ee=>ee.command!==`-${U}`&&m.conflicts.has(h[ee.key]))){M.conflicts.add(U);continue}W=v(W,x,a)}for(const U of M.updated.values()){if(M.conflicts.has(U))continue;const x=O.get(U);if(x.some(ee=>ee.command!==`-${U}`&&m.conflicts.has(h[ee.key]))){M.conflicts.add(U);continue}W=g(W,U,x,a)}return{mergeContent:W,hasChanges:!0,hasConflicts:M.conflicts.size>0}}e.merge=C;function E(l,u,r){const a=new Set,i=new Set,t=new Set,s=new Set;for(const o of u.removed.values())r.updated.has(o)&&s.add(o);for(const o of r.removed.values())s.has(o)||(u.updated.has(o)?s.add(o):i.add(o));for(const o of u.added.values())s.has(o)||r.added.has(o)&&l.updated.has(o)&&s.add(o);for(const o of r.added.values())s.has(o)||(u.added.has(o)?l.updated.has(o)&&s.add(o):a.add(o));for(const o of u.updated.values())s.has(o)||r.updated.has(o)&&l.updated.has(o)&&s.add(o);for(const o of r.updated.values())s.has(o)||(u.updated.has(o)?l.updated.has(o)&&s.add(o):t.add(o));return{added:a,removed:i,updated:t,conflicts:s}}function P(l,u,r,a){const i=new Set,t=b(l,a),s=b(u,a),o=r?b(r,a):null,c=S(t,s);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const h=o?S(o,t):{added:[...t.keys()].reduce(($,D)=>($.add(D),$),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const m=o?S(o,s):{added:[...s.keys()].reduce(($,D)=>($.add(D),$),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:I,removed:O,updated:A,conflicts:N}=E(c,h,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:I,removed:O,updated:A,conflicts:N}}function b(l,u){const r=new Map;for(const a of l){const i=u[a.key];let t=r.get(i);t||(t=[],r.set(i,t)),t.push(a)}return r}function f(l){const u=new Map;for(const r of l){const a=r.command[0]==="-"?r.command.substring(1):r.command;let i=u.get(a);i||(i=[],u.set(a,i)),i.push(r)}return u}function S(l,u){const r=[...l.keys()],a=[...u.keys()],i=a.filter(o=>r.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),t=r.filter(o=>a.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),s=new Set;for(const o of r){if(t.has(o))continue;const c=l.get(o).map(m=>({...m,key:o})),h=u.get(o).map(m=>({...m,key:o}));(0,L.equals)(c,h,(m,I)=>p(m,I))||s.add(o)}return{added:i,removed:t,updated:s}}function d(l,u,r){const a=[...l.keys()],i=[...u.keys()],t=i.filter(c=>a.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),s=a.filter(c=>i.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),o=new Set;for(const c of a){if(s.has(c))continue;const h=l.get(c).map(I=>({...I,key:r[I.key]})),m=u.get(c).map(I=>({...I,key:r[I.key]}));w(h,m)||o.add(c)}return{added:t,removed:s,updated:o}}function w(l,u){return!(!(0,L.equals)(l.filter(({command:r})=>r[0]!=="-"),u.filter(({command:r})=>r[0]!=="-"),(r,a)=>p(r,a))||!(0,L.equals)(l.filter(({command:r})=>r[0]==="-"),u.filter(({command:r})=>r[0]==="-"),(r,a)=>p(r,a)))}function p(l,u){if(l.command!==u.command||l.key!==u.key)return!1;const r=_.ContextKeyExpr.deserialize(l.when),a=_.ContextKeyExpr.deserialize(u.when);return!(r&&!a||!r&&a||r&&a&&!r.equals(a)||!T.equals(l.args,u.args))}function v(l,u,r){for(const a of u)l=k.edit(l,[-1],a,r);return l}function y(l,u,r){const a=R(l);for(let i=a.length-1;i>=0;i--)(a[i].command===u||a[i].command===`-${u}`)&&(l=k.edit(l,[i],void 0,r));return l}function g(l,u,r,a){const i=R(l),t=i.findIndex(s=>s.command===u||s.command===`-${u}`);for(let s=i.length-1;s>=0;s--)(i[s].command===u||i[s].command===`-${u}`)&&(l=k.edit(l,[s],void 0,a));for(let s=r.length-1;s>=0;s--)l=k.edit(l,[t],r[s],a);return l}}),define(ne[223],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(_,k,R){const C={},E={},P=new Set;if(!k)return{local:{added:C,updated:E,removed:[...P.values()]},remote:{added:_,updated:{},removed:[]},conflicts:[]};const b=n(_,k);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:C,updated:E,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=n(R,_),S=n(R,k),d={},w={},p=new Set,v=new Set;for(const y of f.removed.values())S.updated.has(y)?C[y]=k[y]:p.add(y);for(const y of S.removed.values())v.has(y)||(f.updated.has(y)?v.add(y):P.add(y));for(const y of f.updated.values())v.has(y)||(S.updated.has(y)?b.updated.has(y)&&v.add(y):w[y]=_[y]);for(const y of S.updated.values())v.has(y)||(f.updated.has(y)?b.updated.has(y)&&v.add(y):_[y]!==void 0&&(E[y]=k[y]));for(const y of f.added.values())v.has(y)||(S.added.has(y)?b.updated.has(y)&&v.add(y):d[y]=_[y]);for(const y of S.added.values())v.has(y)||(f.added.has(y)?b.updated.has(y)&&v.add(y):C[y]=k[y]);return{local:{added:C,removed:[...P.values()],updated:E},remote:{added:d,removed:[...p.values()],updated:w},conflicts:[...v.values()]}}e.merge=L;function n(_,k){const R=_?Object.keys(_):[],C=k?Object.keys(k):[],E=C.filter(f=>R.indexOf(f)===-1).reduce((f,S)=>(f.add(S),f),new Set),P=R.filter(f=>C.indexOf(f)===-1).reduce((f,S)=>(f.add(S),f),new Set),b=new Set;for(const f of R){if(P.has(f))continue;const S=_[f],d=k[f];S!==d&&b.add(f)}return{added:E,removed:P,updated:b}}function T(_,k){const{added:R,removed:C,updated:E}=n(_,k);return R.size===0&&C.size===0&&E.size===0}e.areSame=T}),define(ne[24],ie([0,1,16,19,15,147,42,30,6,86,38]),function(J,e,L,n,T,_,k,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function b(){const o=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(c=>!!o[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=b;function f(){const o=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(o).filter(I=>!!o[I].ignoreSync),h=Object.keys(o).filter(I=>o[I].scope===2||o[I].scope===6),m=b();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...h,...m])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function S(){const o="vscode://schemas/ignoredSettings",c=P.Registry.as(k.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,_.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,_.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,_.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,_.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,_.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=P.Registry.as(E.Extensions.JSONContribution),m=()=>{const I=b(),O=f().filter(D=>D!==e.CONFIGURATION_SYNC_STORE_KEY),A=Object.keys(k.allSettings.properties).filter(D=>O.indexOf(D)===-1),N=O.filter(D=>I.indexOf(D)===-1),$={items:{type:"string",enum:[...A,...N.map(D=>`-${D}`)]}};h.registerSchema(o,$)};return c.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=S;function d(o){return o&&(0,T.isObject)(o)&&(0,T.isString)(o.id)&&(0,T.isArray)(o.scopes)}e.isAuthenticationProvider=d;var w;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(w=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function p(o,c,h){return h.joinPath(c.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=p,e.IUserDataSyncStoreManagementService=(0,C.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,C.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,C.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function v(o){const c={};return c[e.HEADER_EXECUTION_ID]=o,c}e.createSyncHeaders=v;var y;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(y=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(c,h,m,I){super(c);this.code=h,this.resource=m,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class l extends g{constructor(c,h,m,I,O){super(c,m,void 0,O);this.url=h,this.serverCode=I}}e.UserDataSyncStoreError=l;class u extends g{constructor(c,h){super(c,h)}}e.UserDataAutoSyncError=u,function(o){function c(h){if(h instanceof o)return h;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(m&&m[1]){const I=m[2]==="unknown"?void 0:m[2],O=m[3]==="unknown"?void 0:m[3];return new o(h.message,m[1],I,O)}return new o(h.message,"Unknown")}o.toUserDataSyncError=c}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var a;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var i;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,C.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,C.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,C.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,C.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,C.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(o,c){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:c.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,n.isEqualOrParent)(o,(0,n.joinPath)(c.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(ne[47],ie([0,1,16,5,17,25,3,35,2,27,15,7,143,20,13,14,10,46,23,21,34,24]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v,y,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=r;let a=class extends C.Disposable{constructor(c,h,m,I,O,A,N,$,D,M,W){super();this.resource=c,this.fileService=h,this.environmentService=m,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=A,this.userDataSyncEnablementService=N,this.telemetryService=$,this.logService=D,this.configurationService=M,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,E.uppercaseFirstLetter)(this.resource),this.extUri=W.extUri,this.syncFolder=this.extUri.joinPath(m.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(c,m,this.extUri),this.currentMachineIdPromise=(0,v.getServiceMachineId)(m,h,I)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?await this.hasRemoteChanged(c):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const h=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),h==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,h={}){await this._sync(c,!0,this.getUserDataSyncConfiguration(),h)}async preview(c,h,m={}){return this._sync(c,!1,h,m)}async apply(c,h={}){try{this.syncHeaders={...h};const m=await this.doApply(c);return this.setStatus(m),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,h,m,I){try{if(this.syncHeaders={...I},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const A=await this.getLastSyncUserData(),N=await this.getLatestRemoteUserData(c,A);return O=await this.performSync(N,A,h,m),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(c){const h=await this.resolveContent(c);if(!h)return!1;const m=this.parseSyncData(h);if(!m)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,I),A=await this.isRemoteDataFromCurrentMachine(O),N=await this.generateSyncPreview({ref:O.ref,syncData:m},I,A,this.getUserDataSyncConfiguration(),_.CancellationToken.None),$=[];for(const D of N){const M=await this.getAcceptResult(D,D.remoteResource,void 0,_.CancellationToken.None),{remoteChange:W}=await this.getAcceptResult(D,D.previewResource,D.remoteContent,_.CancellationToken.None);$.push([D,{...M,remoteChange:W!==0?W:2}])}await this.applyResult(O,I,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const h=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===h}async getLatestRemoteUserData(c,h){if(h){const m=c&&c.latest?c.latest[this.resource]:void 0;if(h.ref===m||m===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(c,h,m,I){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,h,m,I)}catch(O){if(O instanceof u.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,h,m,I);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(c,h,m,I)}throw O}}async doSync(c,h,m,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(A=>this.doGenerateSyncResourcePreview(c,h,m,I,A)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":m?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(c){return await this.updateSyncResourcePreview(c,async h=>{const m=await this.getMergeResult(h,_.CancellationToken.None);await this.fileService.writeFile(h.previewResource,T.VSBuffer.fromString(m?.content||""));const I=m&&!m.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,_.CancellationToken.None):void 0;return h.acceptResult=I,h.mergeState=m.hasConflicts?"conflict":I?"accepted":"preview",h.localChange=I?I.localChange:m.localChange,h.remoteChange=I?I.remoteChange:m.remoteChange,h}),this.syncPreviewPromise}async accept(c,h){return await this.updateSyncResourcePreview(c,async m=>{const I=await this.getAcceptResult(m,c,h,_.CancellationToken.None);return m.acceptResult=I,m.mergeState="accepted",m.localChange=I.localChange,m.remoteChange=I.remoteChange,m}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async h=>{const m=await this.getMergeResult(h,_.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,T.VSBuffer.fromString(m.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=m.localChange,h.remoteChange=m.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(c,h){if(!this.syncPreviewPromise)return;let m=await this.syncPreviewPromise;const I=m.resourcePreviews.findIndex(({localResource:O,remoteResource:A,previewResource:N})=>this.extUri.isEqual(O,c)||this.extUri.isEqual(A,c)||this.extUri.isEqual(N,c));I!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async O=>{const A=[...m.resourcePreviews];return A[I]=await h(A[I]),{...m,resourcePreviews:A}}),m=await this.syncPreviewPromise,this.updateConflicts(m.resourcePreviews),m.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:m})=>m==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:m})=>m!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(m=>[m,m.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(c){const h=c.filter(({mergeState:m})=>m==="conflict");(0,L.equals)(this._conflicts,h,(m,I)=>this.extUri.isEqual(m.previewResource,I.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(h))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:h,ref:m})=>({created:h,uri:this.toRemoteBackupResource(m)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:h,ref:m})=>({created:h,uri:this.toLocalBackupResource(m)}))}toRemoteBackupResource(c){return b.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return b.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const h=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(h))){const{content:m}=await this.getUserData(h);if(m)return this.parseSyncData(m)?.machineId}}async resolveContent(c){const h=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(h))){const{content:m}=await this.getUserData(h);return m}return this.extUri.isEqual(c,this.toLocalBackupResource(h))?this.userDataSyncBackupStoreService.resolveContent(this.resource,h):null}async resolvePreviewContent(c){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const m of h.resourcePreviews){if(this.extUri.isEqual(m.acceptedResource,c))return m.acceptResult?m.acceptResult.content:null;if(this.extUri.isEqual(m.remoteResource,c))return m.remoteContent;if(this.extUri.isEqual(m.localResource,c))return m.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(c,h,m,I,O){const A=await this.isRemoteDataFromCurrentMachine(c),N=await this.generateSyncPreview(c,h,A,I,O),$=[];for(const D of N){const M=D.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(D.localChange===0&&D.remoteChange===0)$.push({...D,acceptedResource:M,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const W=m?await this.getMergeResult(D,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(D.previewResource,T.VSBuffer.fromString(W?.content||""));const U=W&&!W.hasConflicts?await this.getAcceptResult(D,D.previewResource,void 0,O):void 0;$.push({...D,acceptResult:U,mergeState:W?.hasConflicts?"conflict":U?"accepted":"preview",localChange:U?U.localChange:W?W.localChange:D.localChange,remoteChange:U?U.remoteChange:W?W.remoteChange:D.remoteChange})}}return{remoteUserData:c,lastSyncUserData:h,resourcePreviews:$,isLastSyncFromCurrentMachine:A}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(c.value.toString()),m=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=h.version&&m&&h.version!==m,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${m}.`),await this.resetLocal(),null;const I=h;if(I.content===null)return{ref:h.ref,syncData:null};const O=JSON.parse(I.content);if(r(O))return{...h,syncData:O,content:void 0}}catch(c){c instanceof w.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,h={}){if(h.ref||h.content||h.version)throw new Error("Cannot have core properties as additional");const m=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),I={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:m,...h};await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(I)))}async getRemoteUserData(c){const{ref:h,content:m}=await this.getUserData(c);let I=null;return m!==null&&(I=this.parseSyncData(m)),{ref:h,syncData:I}}parseSyncData(c){try{const h=JSON.parse(c);if(r(h))return h}catch(h){this.logService.error(h)}throw new u.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,P.isString)(c)){const h=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:h}}else{const h=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,h,this.syncHeaders)}}async updateRemoteUserData(c,h){const m=await this.currentMachineIdPromise,I={version:this.version,machineId:m,content:c};return h=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(I),h,this.syncHeaders),{ref:h,syncData:I}}async backupLocal(c){const h={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(h))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=de([X(1,w.IFileService),X(2,d.IEnvironmentService),X(3,y.IStorageService),X(4,u.IUserDataSyncStoreService),X(5,u.IUserDataSyncBackupStoreService),X(6,u.IUserDataSyncEnablementService),X(7,g.ITelemetryService),X(8,u.IUserDataSyncLogService),X(9,S.IConfigurationService),X(10,l.IUriIdentityService)],a),e.AbstractSynchroniser=a;let i=class extends a{constructor(c,h,m,I,O,A,N,$,D,M,W,U){super(h,m,I,O,A,N,$,D,M,W,U);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(x=>this.onFileChanges(x)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(c,h,m){try{h?await this.fileService.writeFile(this.file,T.VSBuffer.fromString(c),m?void 0:h):await this.fileService.createFile(this.file,T.VSBuffer.fromString(c),{overwrite:m})}catch(I){throw I instanceof w.FileOperationError&&I.fileOperationResult===1||I instanceof w.FileOperationError&&I.fileOperationResult===3?new u.UserDataSyncError(I.message,"LocalPreconditionFailed"):I}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};i=de([X(2,w.IFileService),X(3,d.IEnvironmentService),X(4,y.IStorageService),X(5,u.IUserDataSyncStoreService),X(6,u.IUserDataSyncBackupStoreService),X(7,u.IUserDataSyncEnablementService),X(8,g.ITelemetryService),X(9,u.IUserDataSyncLogService),X(10,S.IConfigurationService),X(11,l.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let t=class extends i{constructor(c,h,m,I,O,A,N,$,D,M,W,U,x){super(c,h,m,I,O,A,N,$,D,M,U,x);this.userDataSyncUtilService=W,this._formattingOptions=void 0}hasErrors(c){const h=[];return(0,R.parse)(c,h,{allowEmptyContent:!0,allowTrailingComma:!0}),h.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([X(2,w.IFileService),X(3,d.IEnvironmentService),X(4,y.IStorageService),X(5,u.IUserDataSyncStoreService),X(6,u.IUserDataSyncBackupStoreService),X(7,u.IUserDataSyncEnablementService),X(8,g.ITelemetryService),X(9,u.IUserDataSyncLogService),X(10,u.IUserDataSyncUtilService),X(11,S.IConfigurationService),X(12,l.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let s=class{constructor(c,h,m,I,O){this.resource=c,this.environmentService=h,this.logService=m,this.fileService=I,this.extUri=O.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(this.resource,h,this.extUri)}async initialize({ref:c,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const m=this.parseSyncData(h);if(!!m)try{await this.doInitialize({ref:c,syncData:m})}catch(I){this.logService.error(I)}}parseSyncData(c){try{const h=JSON.parse(c);if(r(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,h={}){const m={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...h};await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(m)))}};s=de([X(1,d.IEnvironmentService),X(2,p.ILogService),X(3,w.IFileService),X(4,l.IUriIdentityService)],s),e.AbstractInitializer=s}),define(ne[224],ie([0,1,5,25,8,3,49,27,7,20,13,30,33,14,10,23,21,34,47,221,96,97,24]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v,y,g,l,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function a(c,h){const m=JSON.parse(c.content);if(c.version===1||c.version===2){const I=(await h.getInstalled(0)).filter(O=>O.isBuiltin);for(const O of m)c.version===1&&(O.enabled===!1&&(O.disabled=!0),delete O.enabled),c.version===2&&I.every(A=>!(0,f.areSameExtensions)(A.identifier,O.identifier))&&(O.installed=!0)}return m}function i(c,h,m){const I=m.get((0,f.getExtensionId)(c,h),0)||"{}";return JSON.parse(I)}e.getExtensionStorageState=i;function t(c,h,m,I){I.store((0,f.getExtensionId)(c,h),JSON.stringify(m),0,1)}e.storeExtensionStorageState=t;let s=class vt extends y.AbstractSynchroniser{constructor(h,m,I,O,A,N,$,D,M,W,U,x,ee,G,q){super("extensions",m,h,I,O,A,x,ee,M,U,q);this.storageService=I,this.extensionManagementService=N,this.extensionEnablementService=$,this.ignoredExtensionsManagementService=D,this.extensionGalleryService=W,this.extensionsStorageSyncService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(_.Event.debounce(_.Event.any(_.Event.filter(this.extensionManagementService.onDidInstallExtensions,Y=>Y.some(({local:H})=>!!H)),_.Event.filter(this.extensionManagementService.onDidUninstallExtension,Y=>!Y.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}async generateSyncPreview(h,m){const I=h.syncData?await a(h.syncData,this.extensionManagementService):null,O=m?.skippedExtensions||[],A=m?.syncData?await a(m.syncData,this.extensionManagementService):null,N=await this.extensionManagementService.getInstalled(void 0,!0),$=this.getLocalExtensions(N),D=this.ignoredExtensionsManagementService.getIgnoredExtensions(N);I?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:M,remote:W}=(0,g.merge)($,I,A,O,D),U={local:M,remote:W,content:this.getPreviewContent($,M.added,M.updated,M.removed),localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:W!==null?2:0};return[{skippedExtensions:O,localResource:this.localResource,localContent:this.stringify($,!1),localExtensions:$,remoteResource:this.remoteResource,remoteContent:I?this.stringify(I,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const m=h.syncData?await a(h.syncData,this.extensionManagementService):null,I=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(I),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(I),{remote:N}=(0,g.merge)(O,m,m,h.skippedExtensions||[],A);return N!==null}getPreviewContent(h,m,I,O){const A=[...m,...I],N=new Set,$=D=>{N.add(D.id.toLowerCase()),D.uuid&&N.add(D.uuid)};A.forEach(({identifier:D})=>$(D)),O.forEach($);for(const D of h)N.has(D.identifier.id.toLowerCase())||D.identifier.uuid&&N.has(D.identifier.uuid)||A.push(D);return this.stringify(A,!1)}async getMergeResult(h,m){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,m,I,O){if(this.extUri.isEqual(m,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(m,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(m,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${m.toString()}`)}async acceptLocal(h){const m=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),O=(0,g.merge)(h.localExtensions,null,null,h.skippedExtensions,I),{local:A,remote:N}=O;return{content:h.localContent,local:A,remote:N,localChange:A.added.length>0||A.removed.length>0||A.updated.length>0?2:0,remoteChange:N!==null?2:0}}async acceptRemote(h){const m=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),O=h.remoteContent?JSON.parse(h.remoteContent):null;if(O!==null){const A=(0,g.merge)(h.localExtensions,O,h.localExtensions,[],I),{local:N,remote:$}=A;return{content:h.remoteContent,local:N,remote:$,localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:$!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(h,m,I,O){let{skippedExtensions:A,localExtensions:N}=I[0][0],{local:$,remote:D,localChange:M,remoteChange:W}=I[0][1];if(M===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(N)),A=await this.updateLocalExtensions($.added,$.removed,$.updated,A)),D){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const U=JSON.stringify(D.all);h=await this.updateRemoteUserData(U,O?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${D.added.length?` Added: ${JSON.stringify(D.added.map(x=>x.identifier.id))}.`:""}${D.updated.length?` Updated: ${JSON.stringify(D.updated.map(x=>x.identifier.id))}.`:""}${D.removed.length?` Removed: ${JSON.stringify(D.removed.map(x=>x.identifier.id))}.`:""}`)}m?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(h,{skippedExtensions:A}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${A.length?` Skipped: ${JSON.stringify(A.map(U=>U.identifier.id))}.`:""}`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"extensions.json"),comparableResource:vt.EXTENSIONS_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,vt.EXTENSIONS_DATA_URI)){const I=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(I),A=this.getLocalExtensions(I).filter(N=>!O.some($=>(0,f.areSameExtensions)({id:$},N.identifier)));return this.stringify(A,!0)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)){const I=await this.resolvePreviewContent(h);return I&&this.stringify(JSON.parse(I),!0)}let m=await super.resolveContent(h);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(h)),m){const I=this.parseSyncData(m);if(I)switch(this.extUri.basename(h)){case"extensions.json":return this.stringify(this.parseExtensions(I),!0)}}return null}stringify(h,m){return h.sort((I,O)=>!I.identifier.uuid&&O.identifier.uuid?-1:I.identifier.uuid&&!O.identifier.uuid?1:(0,R.compare)(I.identifier.id,O.identifier.id)),m?(0,k.toFormattedString)(h,{}):JSON.stringify(h)}async hasLocalData(){try{const h=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(h).some(I=>I.installed||I.disabled))return!0}catch{}return!1}async updateLocalExtensions(h,m,I,O){const A=[],N=[],$=await this.extensionManagementService.getInstalled();if(m.length){const M=$.filter(({identifier:W,isBuiltin:U})=>!U&&m.some(x=>(0,f.areSameExtensions)(W,x)));await L.Promises.settled(M.map(async W=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,W.identifier.id),await this.extensionManagementService.uninstall(W,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,W.identifier.id),A.push(W.identifier)}))}(h.length||I.length)&&await L.Promises.settled([...h,...I].map(async M=>{const W=$.find(x=>(0,f.areSameExtensions)(x.identifier,M.identifier));if(W&&W.isBuiltin){M.state&&W.manifest.version===M.version&&this.updateExtensionState(M.state,W.manifest.publisher,W.manifest.name,W.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(ee=>(0,f.areSameExtensions)(ee,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id))),A.push(M.identifier);return}const U=(await this.extensionGalleryService.getExtensions([M.identifier],!!M.preRelease,n.CancellationToken.None))[0];if(M.state&&(W?W.manifest.version===M.version:!!U)){const x=W?W.manifest.publisher:U.publisher,ee=W?W.manifest.name:U.name;this.updateExtensionState(M.state,x,ee,W?.manifest.version)}if(U)try{this.extensionEnablementService.getDisabledExtensions().some(ee=>(0,f.areSameExtensions)(ee,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,U.version),await this.extensionEnablementService.disableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,U.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,U.version),await this.extensionEnablementService.enableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,U.version))),(!W||W.preRelease!==M.preRelease)&&(await this.extensionManagementService.canInstall(U)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,U.version),await this.extensionManagementService.installFromGallery(U,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:M.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,U.version),A.push(U.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),N.push(M)))}catch(x){N.push(M),x instanceof b.ExtensionManagementError&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatiblePreRelease,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(x.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):(this.logService.error(x),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,U.displayName||U.identifier.id))}else N.push(M),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,M.identifier.id)}));const D=[];for(const M of O)A.some(W=>(0,f.areSameExtensions)(W,M.identifier))||D.push(M);for(const M of N)D.some(W=>(0,f.areSameExtensions)(W.identifier,M.identifier))||D.push(M);return D}updateExtensionState(h,m,I,O){const A=i(m,I,this.storageService),N=O?this.extensionsStorageSyncService.getKeysForSync({id:(0,f.getGalleryExtensionId)(m,I),version:O}):void 0;N?N.forEach($=>{A[$]=h[$]}):Object.keys(h).forEach($=>A[$]=h[$]),t(m,I,A,this.storageService)}parseExtensions(h){return JSON.parse(h.content)}getLocalExtensions(h){const m=this.extensionEnablementService.getDisabledExtensions();return h.map(({identifier:I,isBuiltin:O,manifest:A,preRelease:N})=>{const $={identifier:I,preRelease:N,version:A.version};m.some(D=>(0,f.areSameExtensions)(D,I))&&($.disabled=!0),O||($.installed=!0);try{const D=this.extensionsStorageSyncService.getKeysForSync({id:I.id,version:A.version});if(D){const M=i(A.publisher,A.name,this.storageService);$.state=Object.keys(M).reduce((W,U)=>(D.includes(U)&&(W[U]=M[U]),W),{})}}catch(D){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,T.getErrorMessage)(D))}return $})}};s.EXTENSIONS_DATA_URI=C.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),s=de([X(0,P.IEnvironmentService),X(1,S.IFileService),X(2,w.IStorageService),X(3,r.IUserDataSyncStoreService),X(4,r.IUserDataSyncBackupStoreService),X(5,b.IExtensionManagementService),X(6,b.IGlobalExtensionEnablementService),X(7,u.IIgnoredExtensionsManagementService),X(8,r.IUserDataSyncLogService),X(9,b.IExtensionGalleryService),X(10,E.IConfigurationService),X(11,r.IUserDataSyncEnablementService),X(12,p.ITelemetryService),X(13,l.IExtensionsStorageSyncService),X(14,v.IUriIdentityService)],s),e.ExtensionsSynchroniser=s;let o=class extends y.AbstractInitializer{constructor(h,m,I,O,A,N){super("extensions",O,A,I,N);this.extensionManagementService=h,this.ignoredExtensionsManagementService=m}async parseExtensions(h){return h.syncData?await a(h.syncData,this.extensionManagementService):null}generatePreview(h,m){const I=[],O=[],A=[];for(const N of h){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(N.identifier.id))continue;const $=m.find(D=>(0,f.areSameExtensions)(D.identifier,N.identifier));$?(I.push($),N.disabled&&A.push(N.identifier)):N.installed&&(O.push(N.identifier),N.disabled&&A.push(N.identifier))}return{installedExtensions:I,newExtensions:O,disabledExtensions:A,remoteExtensions:h}}};o=de([X(0,b.IExtensionManagementService),X(1,u.IIgnoredExtensionsManagementService),X(2,S.IFileService),X(3,P.IEnvironmentService),X(4,d.ILogService),X(5,v.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(ne[225],ie([0,1,28,24]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(R,C,E,P,b){if(!C)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const f=_(R,C);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const S=E?_(E,C):{added:Object.keys(C).reduce((y,g)=>(y.add(g),y),new Set),removed:new Set,updated:new Set},d=E?_(E,R):{added:Object.keys(R).reduce((y,g)=>(y.add(g),y),new Set),removed:new Set,updated:new Set},w={added:{},removed:[],updated:{}},p=L.deepClone(C),v=!E;for(const y of d.added.values())y!==n.SYNC_SERVICE_URL_TYPE&&v&&S.added.has(y)||(p[y]=R[y]);for(const y of d.updated.values())p[y]=R[y];for(const y of d.removed.values())P.unregistered.includes(y)||delete p[y];for(const y of S.added.values()){const g=C[y];if(P.machine.includes(y)){b.info(`GlobalState: Skipped adding ${y} in local storage because it is declared as machine scoped.`);continue}if(E&&d.added.has(y))continue;const l=R[y];l&&l.value===g.value||y===n.SYNC_SERVICE_URL_TYPE&&v&&d.added.has(y)||(l?w.updated[y]=g:w.added[y]=g)}for(const y of S.updated.values()){const g=C[y];if(P.machine.includes(y)){b.info(`GlobalState: Skipped updating ${y} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(y)||d.removed.has(y))continue;const l=R[y];l&&l.value===g.value||(w.updated[y]=g)}for(const y of S.removed.values()){if(P.machine.includes(y)){b.trace(`GlobalState: Skipped removing ${y} in local storage because it is declared as machine scoped.`);continue}d.updated.has(y)||d.removed.has(y)||w.removed.push(y)}return{local:w,remote:k(p,C)?null:p}}e.merge=T;function _(R,C){const E=Object.keys(R),P=Object.keys(C),b=P.filter(d=>E.indexOf(d)===-1).reduce((d,w)=>(d.add(w),d),new Set),f=E.filter(d=>P.indexOf(d)===-1).reduce((d,w)=>(d.add(w),d),new Set),S=new Set;for(const d of E){if(f.has(d))continue;const w=R[d],p=C[d];L.equals(w,p)||S.add(d)}return{added:b,removed:f,updated:S}}function k(R,C){const{added:E,removed:P,updated:b}=_(R,C);return E.size===0&&P.size===0&&b.size===0}}),define(ne[226],ie([0,1,17,8,3,35,49,4,7,29,20,13,14,10,46,23,21,34,47,52,225,24]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v,y,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",a=["locale"];function i(h,m){const I=h.storage?Object.keys(h.storage).sort():[],O={};return I.forEach(A=>O[A]=h.storage[A]),h.storage=O,m?(0,k.toFormattedString)(h,{}):JSON.stringify(h)}const t=1;let s=class pt extends y.AbstractSynchroniser{constructor(m,I,O,A,N,$,D,M,W,U){super("globalState",m,N,W,I,O,$,D,A,M,U);this.storageService=W,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(m.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(T.Event.any(T.Event.filter(m.onDidFilesChange,x=>x.contains(this.environmentService.argvResource)),T.Event.filter(W.onDidChangeValue,x=>x.scope===0&&x.target!==void 0?x.target===0:W.keys(0,0).includes(x.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(m,I,O){const A=m.syncData?JSON.parse(m.syncData.content):null;I=I===null&&O?m:I;const N=I&&I.syncData?JSON.parse(I.syncData.content):null,$=await this.getLocalGlobalState();A?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const D=this.getStorageKeys(N),{local:M,remote:W}=(0,l.merge)($.storage,A?A.storage:null,N?N.storage:null,D,this.logService),U={content:null,local:M,remote:W,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:W!==null?2:0};return[{localResource:this.localResource,localContent:i($,!1),localUserData:$,remoteResource:this.remoteResource,remoteContent:A?i(A,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource,storageKeys:D}]}async hasRemoteChanged(m){const I=m.syncData?JSON.parse(m.syncData.content):null;if(I===null)return!0;const O=await this.getLocalGlobalState(),A=this.getStorageKeys(I),{remote:N}=(0,l.merge)(O.storage,I.storage,I.storage,A,this.logService);return N!==null}async getMergeResult(m,I){return{...m.previewResult,hasConflicts:!1}}async getAcceptResult(m,I,O,A){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(m);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(m);if(this.extUri.isEqual(I,this.previewResource))return m.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(m){return{content:m.localContent,local:{added:{},removed:[],updated:{}},remote:m.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(m){if(m.remoteContent!==null){const I=JSON.parse(m.remoteContent),{local:O,remote:A}=(0,l.merge)(m.localUserData.storage,I.storage,null,m.storageKeys,this.logService);return{content:m.remoteContent,local:O,remote:A,localChange:Object.keys(O.added).length>0||Object.keys(O.updated).length>0||O.removed.length>0?2:0,remoteChange:A!==null?2:0}}else return{content:m.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(m,I,O,A){let{localUserData:N}=O[0][0],{local:$,remote:D,localChange:M,remoteChange:W}=O[0][1];if(M===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),W!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:D});m=await this.updateRemoteUserData(U,A?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}I?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:m}){return[{resource:this.extUri.joinPath(m,"globalState.json"),comparableResource:pt.GLOBAL_STATE_DATA_URI}]}async resolveContent(m){if(this.extUri.isEqual(m,pt.GLOBAL_STATE_DATA_URI)){const O=await this.getLocalGlobalState();return i(O,!0)}if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m)){const O=await this.resolvePreviewContent(m);return O&&i(JSON.parse(O),!0)}let I=await super.resolveContent(m);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(m)),I){const O=this.parseSyncData(I);if(O)switch(this.extUri.basename(m)){case"globalState.json":return i(JSON.parse(O.content),!0)}}return null}async hasLocalData(){try{const{storage:m}=await this.getLocalGlobalState();if(Object.keys(m).length>1||m[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const m={},I=await this.getLocalArgvContent(),O=(0,_.parse)(I);for(const A of a)O[A]!==void 0&&(m[`${r}${A}`]={version:1,value:O[A]});for(const A of this.storageService.keys(0,0)){const N=this.storageService.get(A,0);N&&(m[A]={version:1,value:N})}return{storage:m}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const m=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),m.value.toString()}catch(m){this.logService.debug((0,n.getErrorMessage)(m))}return"{}"}async writeLocalGlobalState({added:m,removed:I,updated:O}){const A={},N={},$=(M,W)=>{for(const U of M){if(U.startsWith(r)){A[U.substring(r.length)]=W?W[U].value:void 0;continue}if(W){const x=W[U];x.value!==String(this.storageService.get(U,0))&&(N[U]=x.value)}else this.storageService.get(U,0)!==void 0&&(N[U]=void 0)}};if($(Object.keys(m),m),$(Object.keys(O),O),$(I),Object.keys(A).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(A),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(N))this.storageService.store(M,N[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(m){const I=await this.getLocalArgvContent();let O=I;for(const A of Object.keys(m))O=(0,g.edit)(O,[A],m[A],{});I!==O&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(O)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(m){const I=this.storageService.keys(0,0),O=this.storageService.keys(0,1),A=[...I,...O],N=m?.storage?Object.keys(m.storage).filter($=>!$.startsWith(r)&&!A.includes($)&&this.storageService.get($,0)!==void 0):[];if(!R.isWeb){const $=[...u.ALL_SYNC_RESOURCES.map(D=>(0,u.getEnablementKey)(D)),u.SYNC_SERVICE_URL_TYPE];N.push(...$),O.push(...$)}return{user:I,machine:O,unregistered:N}}};s.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=de([X(0,f.IFileService),X(1,u.IUserDataSyncStoreService),X(2,u.IUserDataSyncBackupStoreService),X(3,u.IUserDataSyncLogService),X(4,b.IEnvironmentService),X(5,u.IUserDataSyncEnablementService),X(6,p.ITelemetryService),X(7,P.IConfigurationService),X(8,w.IStorageService),X(9,v.IUriIdentityService)],s),e.GlobalStateSynchroniser=s;let o=class extends y.AbstractInitializer{constructor(m,I,O,A,N){super("globalState",O,A,I,N);this.storageService=m}async doInitialize(m){const I=m.syncData?JSON.parse(m.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const O={},A={};for(const N of Object.keys(I.storage))N.startsWith(r)?O[N.substring(r.length)]=I.storage[N].value:this.storageService.get(N,0)===void 0&&(A[N]=I.storage[N].value);if(Object.keys(O).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(O))N=(0,g.edit)(N,[$],O[$],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(N))}if(Object.keys(A).length)for(const N of Object.keys(A))this.storageService.store(N,A[N],0,0)}};o=de([X(0,w.IStorageService),X(1,f.IFileService),X(2,b.IEnvironmentService),X(3,u.IUserDataSyncLogService),X(4,v.IUriIdentityService)],o),e.GlobalStateInitializer=o;let c=class{constructor(m,I,O,A,N){this.userDataSyncStoreClient=m,this.storageService=I,this.environmentService=O,this.fileService=A,this.logService=N}getSyncStoreType(m){return this.parseGlobalState(m)?.storage[u.SYNC_SERVICE_URL_TYPE]?.value}async sync(m){const I=(0,u.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(m,I)}catch(O){if(O instanceof u.UserDataSyncError)switch(O.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(m,I)}throw O}}async doSync(m,I){const O=await this.userDataSyncStoreClient.read("globalState",null,I),A=this.parseGlobalState(O)||{storage:{}};A.storage[u.SYNC_SERVICE_URL_TYPE]={value:m,version:t};const N=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:t,machineId:N,content:i(A,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify($),O.ref,I)}parseGlobalState({content:m}){if(!m)return null;const I=JSON.parse(m);if((0,y.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};c=de([X(1,w.IStorageService),X(2,b.IEnvironmentService),X(3,f.IFileService),X(4,S.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(ne[227],ie([0,1,16,17,3,35,4,15,144,20,13,14,23,21,34,47,222,24]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function y(u,r,a){try{const i=JSON.parse(u);if(!r)return(0,R.isUndefined)(i.all)?null:i.all;switch(k.OS){case 2:return(0,R.isUndefined)(i.mac)?null:i.mac;case 3:return(0,R.isUndefined)(i.linux)?null:i.linux;case 1:return(0,R.isUndefined)(i.windows)?null:i.windows}}catch(i){return a.error(i),null}}e.getKeybindingsContentFromSyncContent=y;let g=class extends w.AbstractJsonFileSynchroniser{constructor(r,a,i,t,s,o,c,h,m,I,O){super(c.keybindingsResource,"keybindings",o,c,h,r,a,s,I,i,m,t,O);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.filter(t.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,a,i,t){const s=r.syncData?y(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;a=a===null&&i?r:a;const o=a?this.getKeybindingsContentFromLastSyncUserData(a):null,c=await this.getLocalFileContent(),h=await this.getFormattingOptions();let m=null,I=!1,O=!1,A=!1;if(s){let $=c?c.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new v.UserDataSyncError((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==$||o!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const D=await(0,p.merge)($,s,o,h,this.userDataSyncUtilService);D.hasChanges&&(m=D.mergeContent,A=D.hasConflicts,I=A||D.mergeContent!==$,O=A||D.mergeContent!==s)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),m=c.value.toString(),O=!0);const N={content:m,localChange:I?c?2:1:0,remoteChange:O?2:0,hasConflicts:A};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getKeybindingsContentFromLastSyncUserData(r);if(a===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString():"",s=await this.getFormattingOptions(),o=await(0,p.merge)(t||"[]",a,a,s,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==a}async getMergeResult(r,a){return r.previewResult}async getAcceptResult(r,a,i,t){if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,i,t){const{fileContent:s}=i[0][0];let{content:o,localChange:c,remoteChange:h}=i[0][1];if(c===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new v.UserDataSyncError((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(o||"[]",s,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),h!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const m=this.toSyncContent(o||"[]",r.syncData?.content);r=await this.updateRemoteUserData(m,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=(0,_.parse)(r.value.toString());if((0,L.isNonEmptyArray)(a))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const i=this.parseSyncData(a);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return y(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:y(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,a){let i={};try{i=JSON.parse(a||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,k.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};g=de([X(0,v.IUserDataSyncStoreService),X(1,v.IUserDataSyncBackupStoreService),X(2,v.IUserDataSyncLogService),X(3,E.IConfigurationService),X(4,v.IUserDataSyncEnablementService),X(5,b.IFileService),X(6,P.IEnvironmentService),X(7,f.IStorageService),X(8,v.IUserDataSyncUtilService),X(9,S.ITelemetryService),X(10,d.IUriIdentityService)],g),e.KeybindingsSynchroniser=g;let l=class extends w.AbstractInitializer{constructor(r,a,i,t){super("keybindings",a,i,r,t)}async doInitialize(r){const a=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,n.VSBuffer.fromString(a)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),a=(0,_.parse)(r.value.toString());return!(0,L.isNonEmptyArray)(a)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return y(r,!0,this.logService)}catch(a){return this.logService.error(a),null}}};l=de([X(0,b.IFileService),X(1,P.IEnvironmentService),X(2,v.IUserDataSyncLogService),X(3,d.IUriIdentityService)],l),e.KeybindingsInitializer=l}),define(ne[228],ie([0,1,16,35,68,49,28,52,24]),function(J,e,L,n,T,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(o,c,h){let m=[];h?m=b(h):m=P(c);const I=[],O=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(m))for(const A of m)A.startsWith("-")?O.push(A.substring(1)):I.push(A);return(0,L.distinct)([...o,...I].filter(A=>O.indexOf(A)===-1))}e.getIgnoredSettings=E;function P(o){let c=o.inspect("settingsSync.ignoredSettings").userValue;return c!==void 0||(c=o.inspect("sync.ignoredSettings").userValue,c!==void 0)?c:o.getValue("settingsSync.ignoredSettings")||[]}function b(o){const c=(0,n.parse)(o);return c?c["settingsSync.ignoredSettings"]||c["sync.ignoredSettings"]||[]:[]}function f(o,c,h,m){if(h.length){const I=s(c),O=(0,n.parse)(c),A=(0,n.parse)(o),N=[];for(const $ of h){const D=O[$],M=A[$];D===void 0?o=R.edit(o,[$],void 0,m):M!==void 0?o=R.edit(o,[$],D,m):N.push(u($,I))}N.sort(($,D)=>$.startOffset-D.startOffset),N.forEach($=>o=v($.setting.key,c,o,m))}return o}e.updateIgnoredSettings=f;function S(o,c,h,m,I,O){const A=f(o,c,m,O),N=h!==A,$=h!==c;if(!N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:A,hasConflicts:!1};if($&&!N)return{conflictsSettings:[],localContent:f(c,o,m,O),remoteContent:null,hasConflicts:!1};if(h===null&&w(o)){const z=d(o,c,m)?null:f(c,o,m,O);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let D=o,M=c;const W=(0,n.parse)(o),U=(0,n.parse)(c),x=h?(0,n.parse)(h):null,ee=m.reduce((z,V)=>(z.add(V),z),new Set),G=p(W,U,ee),q=p(x,W,ee),Y=p(x,U,ee),H=new Map,Z=new Set,K=z=>{Z.add(z);const V=I.filter(({key:te})=>te===z)[0];V?(D=R.edit(D,[z],V.value,O),M=R.edit(M,[z],V.value,O)):H.set(z,{key:z,localValue:W[z],remoteValue:U[z]})};for(const z of q.removed.values())Y.updated.has(z)?K(z):M=R.edit(M,[z],void 0,O);for(const z of Y.removed.values())Z.has(z)||(q.updated.has(z)?K(z):D=R.edit(D,[z],void 0,O));for(const z of q.updated.values())Z.has(z)||(Y.updated.has(z)?G.updated.has(z)&&K(z):M=R.edit(M,[z],W[z],O));for(const z of Y.updated.values())Z.has(z)||(q.updated.has(z)?G.updated.has(z)&&K(z):D=R.edit(D,[z],U[z],O));for(const z of q.added.values())Z.has(z)||(Y.added.has(z)?G.updated.has(z)&&K(z):M=v(z,D,M,O));for(const z of Y.added.values())Z.has(z)||(q.added.has(z)?G.updated.has(z)&&K(z):D=v(z,M,D,O));const F=H.size>0||!d(D,M,m),j=F||!d(D,o,[]),B=F||!d(M,c,[]);return{localContent:j?D:null,remoteContent:B?M:null,conflictsSettings:[...H.values()],hasConflicts:F}}e.merge=S;function d(o,c,h){if(o===c)return!0;const m=(0,n.parse)(o),I=(0,n.parse)(c),O=h.reduce(($,D)=>($.add(D),$),new Set),A=s(o).filter($=>!($.setting&&O.has($.setting.key))),N=s(c).filter($=>!($.setting&&O.has($.setting.key)));if(A.length!==N.length)return!1;for(let $=0;$<A.length;$++){const D=A[$],M=N[$];if(D.setting&&M.setting){if(D.setting.key!==M.setting.key||!k.equals(m[D.setting.key],I[D.setting.key]))return!1}else if(!D.setting&&!M.setting){if(D.value!==M.value)return!1}else return!1}return!0}e.areSame=d;function w(o){return o?s(o).length===0:!0}e.isEmpty=w;function p(o,c,h){const m=o?Object.keys(o).filter($=>!h.has($)):[],I=Object.keys(c).filter($=>!h.has($)),O=I.filter($=>m.indexOf($)===-1).reduce(($,D)=>($.add(D),$),new Set),A=m.filter($=>I.indexOf($)===-1).reduce(($,D)=>($.add(D),$),new Set),N=new Set;if(o)for(const $ of m){if(A.has($))continue;const D=o[$],M=c[$];k.equals(D,M)||N.add($)}return{added:O,removed:A,updated:N}}function v(o,c,h,m){const I=(0,n.parse)(c),O=s(c),A=s(h),N=y(o,O,A);return g(h,o,I[o],N,A,m)}e.addSetting=v;function y(o,c,h){const m=c.findIndex(O=>O.setting?.key===o),I=c[m-1];if(I){if(I.setting){const A=u(I.setting.key,h);if(A)return{index:h.indexOf(A),insertAfter:!0}}else{const A=r(m,c);if(A){const N=u(A.setting.key,h);if(N){const $=a(h.indexOf(N),h),D=i(c,A,c[m]);if($){const M=i(h,N,$),W=t(D,M);return W?{index:h.indexOf(W),insertAfter:!0}:{index:h.indexOf($),insertAfter:!1}}else{const M=i(h,N,h[h.length-1]),W=t(D,M);return W?{index:h.indexOf(W),insertAfter:!0}:{index:h.length-1,insertAfter:!0}}}}}const O=c[m+1];if(O)if(O.setting){const A=u(O.setting.key,h);if(A)return{index:h.indexOf(A),insertAfter:!1}}else{const A=a(m,c);if(A){const N=u(A.setting.key,h);if(N){const $=r(h.indexOf(N),h),D=i(c,c[m],A);if($){const M=i(h,$,N),W=t(D.reverse(),M.reverse());return W?{index:h.indexOf(W),insertAfter:!1}:{index:h.indexOf($),insertAfter:!0}}else{const M=i(h,h[0],N),W=t(D.reverse(),M.reverse());return W?{index:h.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:h.length-1,insertAfter:!0}}function g(o,c,h,m,I,O){let A;return m.index===-1?A=(0,T.setProperty)(o,[c],h,O):A=l(o,c,h,m,I,O).map(N=>(0,T.withFormatting)(o,N,O)[0]),(0,T.applyEdits)(o,A)}function l(o,c,h,m,I,O){const A=`${JSON.stringify(c)}: ${JSON.stringify(h)}`,N=(0,_.getEOL)(O,o),$=I[m.index];if(m.insertAfter){const D=[];if($.setting)D.push({offset:$.endOffset,length:0,content:","+A});else{const M=a(m.index,I),W=r(m.index,I),U=W?.setting?.commaOffset;W&&U===void 0&&D.push({offset:W.endOffset,length:0,content:","});const x=U!==void 0&&U>$.endOffset;D.push({offset:x?U+1:$.endOffset,length:0,content:M?N+A+",":N+A})}return D}else{if($.setting)return[{offset:$.startOffset,length:0,content:A+","}];const D=(I[m.index-1]&&!I[m.index-1].setting?N:"")+A+(a(m.index,I)?",":"")+N;return[{offset:$.startOffset,length:0,content:D}]}}function u(o,c){return c.filter(h=>h.setting?.key===o)[0]}function r(o,c){for(let h=o-1;h>=0;h--)if(c[h].setting)return c[h]}function a(o,c){for(let h=o+1;h<c.length;h++)if(c[h].setting)return c[h]}function i(o,c,h){const m=o.indexOf(c),I=o.indexOf(h);return o.filter((O,A)=>m<A&&A<I)}function t(o,c){if(o.length&&c.length){let h=0;for(;h<c.length&&h<o.length;h++)if(o[h].value!==c[h].value)return c[h-1];return c[h-1]}}function s(o){const c=[];let h=-1,m,I;const O={onObjectBegin:A=>{h++},onObjectProperty:(A,N,$)=>{h===0&&(m=N,I=A)},onObjectEnd:(A,N)=>{h--,h===0&&c.push({startOffset:m,endOffset:A+N,value:o.substring(m,A+N),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(A,N)=>{h++},onArrayEnd:(A,N)=>{h--,h===0&&c.push({startOffset:m,endOffset:A+N,value:o.substring(m,A+N),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(A,N,$)=>{h===0&&c.push({startOffset:m,endOffset:N+$,value:o.substring(m,N+$),setting:{key:I,commaOffset:void 0}})},onSeparator:(A,N,$)=>{if(h===0&&A===","){let D=c.length-1;for(;D>=0&&!c[D].setting;D--);const M=c[D];M&&c.splice(D,1,{startOffset:M.startOffset,endOffset:M.endOffset,value:M.value,setting:{key:M.setting.key,commaOffset:N}})}},onComment:(A,N)=>{h===0&&c.push({startOffset:A,endOffset:A+N,value:o.substring(A,A+N)})}};return(0,n.visit)(o,O),c}}),define(ne[229],ie([0,1,17,3,145,20,87,13,30,14,23,21,34,47,52,228,24]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function v(u){return u&&u.settings&&typeof u.settings=="string"&&Object.keys(u).length===1}function y(u){const r=JSON.parse(u);return v(r)?r:{settings:u}}e.parseSettingsSyncContent=y;let g=class extends S.AbstractJsonFileSynchroniser{constructor(r,a,i,t,s,o,c,h,m,I,O,A){super(a.settingsResource,"settings",r,a,i,t,s,m,I,o,c,h,A);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const a=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,a),t=this.getSettingsSyncContent(i),s=new k.ConfigurationModelParser(p.USER_DATA_SYNC_CONFIGURATION_SCOPE);return t?.settings&&s.parse(t.settings),s.configurationModel.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,a,i){const t=await this.getLocalFileContent(),s=await this.getFormattingOptions(),o=this.getSettingsSyncContent(r);a=a===null&&i?r:a;const c=a?this.getSettingsSyncContent(a):null,h=await this.getIgnoredSettings();let m=null,I=!1,O=!1,A=!1;if(o){let $=t?t.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const D=(0,w.merge)($,o.settings,c?c.settings:null,h,[],s);m=D.localContent||D.remoteContent,I=D.localContent!==null,O=D.remoteContent!==null,A=D.hasConflicts}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),m=t.value.toString(),O=!0);const N={content:m,localChange:I?2:0,remoteChange:O?2:0,hasConflicts:A};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getSettingsSyncContent(r);if(a===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString().trim():"",s=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,w.merge)(t||"{}",a.settings,a.settings,s,[],o).remoteContent!==null}async getMergeResult(r,a){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,w.updateIgnoredSettings)(r.previewResult.content,"{}",t,i):null}}async getAcceptResult(r,a,i,t){const s=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?(0,w.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent!==null?(0,w.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,w.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,i,t){const{fileContent:s}=i[0][0];let{content:o,localChange:c,remoteChange:h}=i[0][1];if(c===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(o,s,t),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),h!==0){const m=await this.getFormattingOptions(),I=this.getSettingsSyncContent(r),O=await this.getIgnoredSettings(o);o=(0,w.updateIgnoredSettings)(o,I?I.settings:"{}",O,m),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=await this.getFormattingOptions(),i=(0,d.edit)(r.value.toString(),[p.CONFIGURATION_SYNC_STORE_KEY],void 0,a);return!(0,w.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const i=this.parseSyncData(a);if(i){const t=this.parseSettingsSyncContent(i.content);if(t)switch(this.extUri.basename(r)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(r){let a=await super.resolvePreviewContent(r);if(a){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();a=(0,w.updateIgnoredSettings)(a,"{}",t,i)}return a}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return y(r)}catch(a){this.logService.error(a)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,t=>t.some(({local:s})=>!!s)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,t=>!t.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const a=await this._defaultIgnoredSettings;return(0,w.getIgnoredSettings)(a,this.configurationService,r)}validateContent(r){if(this.hasErrors(r))throw new p.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}};g=de([X(0,E.IFileService),X(1,R.IEnvironmentService),X(2,P.IStorageService),X(3,p.IUserDataSyncStoreService),X(4,p.IUserDataSyncBackupStoreService),X(5,p.IUserDataSyncLogService),X(6,p.IUserDataSyncUtilService),X(7,_.IConfigurationService),X(8,p.IUserDataSyncEnablementService),X(9,b.ITelemetryService),X(10,C.IExtensionManagementService),X(11,f.IUriIdentityService)],g),e.SettingsSynchroniser=g;let l=class extends S.AbstractInitializer{constructor(r,a,i,t){super("settings",a,i,r,t)}async doInitialize(r){const a=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(a.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,w.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return y(r)}catch(a){this.logService.error(a)}return null}};l=de([X(0,E.IFileService),X(1,R.IEnvironmentService),X(2,p.IUserDataSyncLogService),X(3,f.IUriIdentityService)],l),e.SettingsInitializer=l}),define(ne[230],ie([0,1,17,3,28,20,13,14,23,21,34,47,223,24]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let d=class extends b.AbstractSynchroniser{constructor(v,y,g,l,u,r,a,i,t,s){super("snippets",y,v,g,l,u,i,t,r,a,s);this.version=1,this.snippetsFolder=v.snippetsHome,this._register(this.fileService.watch(v.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(v,y,g){const l=await this.getSnippetsFileContents(),u=this.toSnippetsContents(l),r=v.syncData?this.parseSnippets(v.syncData):null;y=y===null&&g?v:y;const a=y&&y.syncData?this.parseSnippets(y.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,f.merge)(u,r,a);return this.getResourcePreviews(i,l,r||{})}async hasRemoteChanged(v){const y=v.syncData?this.parseSnippets(v.syncData):null;if(y===null)return!0;const g=await this.getSnippetsFileContents(),l=this.toSnippetsContents(g),u=(0,f.merge)(l,y,y);return Object.keys(u.remote.added).length>0||Object.keys(u.remote.updated).length>0||u.remote.removed.length>0||u.conflicts.length>0}async getMergeResult(v,y){return v.previewResult}async getAcceptResult(v,y,g,l){if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:v.fileContent?v.fileContent.value.toString():null,localChange:0,remoteChange:v.fileContent?v.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:v.remoteContent,localChange:v.remoteContent!==null?v.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder))return g===void 0?{content:v.previewResult.content,localChange:v.previewResult.localChange,remoteChange:v.previewResult.remoteChange}:{content:g,localChange:g===null?v.fileContent!==null?3:0:2,remoteChange:g===null?v.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${y.toString()}`)}async applyResult(v,y,g,l){const u=g.map(([r,a])=>({...r,acceptResult:a}));u.every(({localChange:r,remoteChange:a})=>r===0&&a===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),u.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(u),await this.updateLocalSnippets(u,l)),u.some(({remoteChange:r})=>r!==0)&&(v=await this.updateRemoteSnippets(u,v,l)),y?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of u)try{await this.fileService.del(r)}catch{}}getResourcePreviews(v,y,g){const l=new Map;for(const u of Object.keys(v.local.added)){const r={content:v.local.added[u],hasConflicts:!1,localChange:1,remoteChange:0};l.set(u,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(v.local.updated)){const r={content:v.local.updated[u],hasConflicts:!1,localChange:2,remoteChange:0};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[u],localContent:y[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of v.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[u],localContent:y[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(v.remote.added)){const r={content:v.remote.added[u],hasConflicts:!1,localChange:0,remoteChange:1};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[u],localContent:y[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(v.remote.updated)){const r={content:v.remote.updated[u],hasConflicts:!1,localChange:0,remoteChange:2};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[u],localContent:y[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of v.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of v.conflicts){const r={content:y[u]?y[u].value.toString():null,hasConflicts:!0,localChange:y[u]?2:1,remoteChange:g[u]?2:1};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[u]||null,localContent:y[u]?y[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(y))if(!l.has(u)){const r={content:y[u]?y[u].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[u]||null,localContent:y[u]?y[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...l.values()]}async getAssociatedResources({uri:v}){let y=await super.resolveContent(v);if(y){const g=this.parseSyncData(y);if(g){const l=this.parseSnippets(g),u=[];for(const r of Object.keys(l)){const a=this.extUri.joinPath(v,r),i=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(i);u.push({resource:a,comparableResource:t?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return u}}return[]}async resolveContent(v){if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(v);let y=await super.resolveContent(v);if(y)return y;if(y=await super.resolveContent(this.extUri.dirname(v)),y){const g=this.parseSyncData(y);if(g)return this.parseSnippets(g)[this.extUri.basename(v)]||null}return null}async hasLocalData(){try{const v=await this.getSnippetsFileContents();if(Object.keys(v).length)return!0}catch{}return!1}async updateLocalBackup(v){const y={};for(const g of v)g.fileContent&&(y[this.extUri.basename(g.localResource)]=g.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(y)))}async updateLocalSnippets(v,y){for(const{fileContent:g,acceptResult:l,localResource:u,remoteResource:r,localChange:a}of v)if(a!==0){const i=r?this.extUri.basename(r):this.extUri.basename(u),t=this.extUri.joinPath(this.snippetsFolder,i);a===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):a===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,L.VSBuffer.fromString(l.content),{overwrite:y}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,L.VSBuffer.fromString(l.content),y?void 0:g),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(v,y,g){const l=y.syncData?this.parseSnippets(y.syncData):{},u=(0,T.deepClone)(l);for(const{acceptResult:r,localResource:a,remoteResource:i,remoteChange:t}of v)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(i);t===3?delete u[s]:u[s]=r.content}return(0,f.areSame)(l,u)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),y=await this.updateRemoteUserData(JSON.stringify(u),g?null:y.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),y}parseSnippets(v){return JSON.parse(v.content)}toSnippetsContents(v){const y={};for(const g of Object.keys(v))y[g]=v[g].value.toString();return y}async getSnippetsFileContents(){const v={};let y;try{y=await this.fileService.resolve(this.snippetsFolder)}catch(g){if(g instanceof R.FileOperationError&&g.fileOperationResult===1)return v;throw g}for(const g of y.children||[]){const l=g.resource,u=this.extUri.extname(l);if(u===".json"||u===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,l),a=await this.fileService.readFile(l);v[r]=a}}return v}};d=de([X(0,k.IEnvironmentService),X(1,R.IFileService),X(2,C.IStorageService),X(3,S.IUserDataSyncStoreService),X(4,S.IUserDataSyncBackupStoreService),X(5,S.IUserDataSyncLogService),X(6,_.IConfigurationService),X(7,S.IUserDataSyncEnablementService),X(8,E.ITelemetryService),X(9,P.IUriIdentityService)],d),e.SnippetsSynchroniser=d;let w=class extends b.AbstractInitializer{constructor(v,y,g,l){super("snippets",y,g,v,l)}async doInitialize(v){const y=v.syncData?JSON.parse(v.syncData.content):null;if(!y){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const l of Object.keys(y)){const u=y[l];if(u){const r=this.extUri.joinPath(this.environmentService.snippetsHome,l);await this.fileService.createFile(r,L.VSBuffer.fromString(u)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(v)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(v){return v.fileOperationResult===1}}};w=de([X(0,R.IFileService),X(1,k.IEnvironmentService),X(2,S.IUserDataSyncLogService),X(3,P.IUriIdentityService)],w),e.SnippetsInitializer=w}),define(ne[63],ie([0,1,3,2,6,24]),function(J,e,L,n,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,T.createDecorator)("IUserDataSyncAccountService");let k=class extends n.Disposable{constructor(C,E){super();this.userDataSyncStoreService=C,this.logService=E,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(C.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(C.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(C){(C&&this._account?C.token!==this._account.token||C.authenticationProviderId!==this._account.authenticationProviderId:C!==this._account)&&(this._account=C,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(C))}};k=de([X(0,_.IUserDataSyncStoreService),X(1,_.IUserDataSyncLogService)],k),e.UserDataSyncAccountService=k}),define(ne[231],ie([0,1,5,17,56,2,19,20,13,14,24]),function(J,e,L,n,T,_,k,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let b=class extends _.Disposable{constructor(S,d,w,p){super();this.environmentService=S,this.fileService=d,this.configurationService=w,this.logService=p,P.ALL_SYNC_RESOURCES.forEach(v=>this.cleanUpBackup(v))}async getAllRefs(S){const d=(0,k.joinPath)(this.environmentService.userDataSyncHome,S),w=await this.fileService.resolve(d);return w.children?w.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort().reverse().map(v=>({ref:v.name,created:this.getCreationTime(v)})):[]}async resolveContent(S,d){if(!d){const w=await this.getAllRefs(S);w.length&&(d=w[w.length-1].ref)}if(d){const w=(0,k.joinPath)(this.environmentService.userDataSyncHome,S,d);return(await this.fileService.readFile(w)).value.toString()}return null}async backup(S,d){const w=(0,k.joinPath)(this.environmentService.userDataSyncHome,S),p=(0,k.joinPath)(w,`${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(p,n.VSBuffer.fromString(d))}catch(v){this.logService.error(v)}try{this.cleanUpBackup(S)}catch{}}async cleanUpBackup(S){const d=(0,k.joinPath)(this.environmentService.userDataSyncHome,S);try{try{if(!await this.fileService.exists(d))return}catch{return}const w=await this.fileService.resolve(d);if(w.children){const p=w.children.filter(l=>l.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(l.name)).sort(),v=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let y=p.filter(l=>Date.now()-this.getCreationTime(l)>v);const g=p.length-y.length;g<10&&(y=y.slice(10-g)),await L.Promises.settled(y.map(async l=>{this.logService.info("Deleting from backup",l.resource.path),await this.fileService.del(l.resource)}))}}catch(w){this.logService.error(w)}}getCreationTime(S){return S.ctime||new Date(parseInt(S.name.substring(0,4)),parseInt(S.name.substring(4,6))-1,parseInt(S.name.substring(6,8)),parseInt(S.name.substring(9,11)),parseInt(S.name.substring(11,13)),parseInt(S.name.substring(13,15))).getTime()}};b=de([X(0,C.IEnvironmentService),X(1,E.IFileService),X(2,R.IConfigurationService),X(3,P.IUserDataSyncLogService)],b),e.UserDataSyncBackupStoreService=b}),define(ne[232],ie([0,1,3,2,4,13,23,21,24]),function(J,e,L,n,T,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let P=class extends n.Disposable{constructor(f,S,d,w){super();this.storageService=f,this.telemetryService=S,this.environmentService=d,this.userDataSyncStoreManagementService=w,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(p=>this.onDidStorageChange(p)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:f}),this.storageService.store(E,f,0,1))}isResourceEnabled(f){return this.storageService.getBoolean((0,C.getEnablementKey)(f),0,!0)}setResourceEnablement(f,S){if(this.isResourceEnabled(f)!==S){const d=(0,C.getEnablementKey)(f);this.telemetryService.publicLog2(d,{enabled:S}),this.storeResourceEnablement(d,S)}}getResourceSyncStateVersion(f){}storeResourceEnablement(f,S){this.storageService.store(f,S,0,T.isWeb?0:1)}onDidStorageChange(f){if(f.scope!==0)return;if(E===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const S=C.ALL_SYNC_RESOURCES.filter(d=>(0,C.getEnablementKey)(d)===f.key)[0];if(S){this._onDidChangeResourceEnablement.fire([S,this.isResourceEnabled(S)]);return}}};P=de([X(0,k.IStorageService),X(1,R.ITelemetryService),X(2,_.IEnvironmentService),X(3,C.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(ne[233],ie([0,1,2,7]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class T{constructor(f){this.service=f}listen(f,S){switch(S){case"onError":return this.service.onError}throw new Error(`Event not found: ${S}`)}call(f,S,d){switch(S){case"triggerSync":return this.service.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=T;class _{constructor(f){this.service=f}listen(f,S){throw new Error(`Event not found: ${S}`)}call(f,S,d){switch(S){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=_;class k{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=k;class R{constructor(f){this.service=f}listen(f,S){switch(S){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${S}`)}async call(f,S,d){switch(S){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(d[0],d[1]);case"setEnablement":return this.service.setEnablement(d[0],d[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class C{constructor(f){this.service=f}listen(f,S){switch(S){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${S}`)}call(f,S,d){switch(S){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class E{constructor(f){this.service=f}listen(f,S){switch(S){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${S}`)}call(f,S,d){switch(S){case"switch":return this.service.switch(d[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class P extends L.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:n.URI.revive(f.url),type:f.type,defaultUrl:n.URI.revive(f.defaultUrl),insidersUrl:n.URI.revive(f.insidersUrl),stableUrl:n.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(ne[234],ie([0,1,13,10]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let T=class extends n.AbstractLogger{constructor(k,R){super();this.logger=this._register(k.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(k,...R){this.logger.trace(k,...R)}debug(k,...R){this.logger.debug(k,...R)}info(k,...R){this.logger.info(k,...R)}warn(k,...R){this.logger.warn(k,...R)}error(k,...R){this.logger.error(k,...R)}critical(k,...R){this.logger.critical(k,...R)}flush(){this.logger.flush()}};T=de([X(0,n.ILoggerService),X(1,L.IEnvironmentService)],T),e.UserDataSyncLogService=T}),define(ne[64],ie([0,1,3,2,4,27,148,13,14,6,26,46,23,24]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName";let w=class et extends n.Disposable{constructor(v,y,g,l,u,r){super();this.storageService=g,this.userDataSyncStoreService=l,this.logService=u,this.productService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,b.getServiceMachineId)(v,y,g)}async getMachines(v){const y=await this.currentMachineIdPromise;return(await this.readMachinesData(v)).machines.map(l=>({...l,isCurrent:l.id===y}))}async addCurrentMachine(v){const y=await this.currentMachineIdPromise,g=await this.readMachinesData(v);g.machines.some(({id:l})=>l===y)||(g.machines.push({id:y,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(v){const y=await this.currentMachineIdPromise,g=await this.readMachinesData(v),l=g.machines.filter(({id:u})=>u!==y);l.length!==g.machines.length&&(g.machines=l,await this.writeMachinesData(g))}async renameMachine(v,y,g){const l=await this.currentMachineIdPromise,u=await this.readMachinesData(g),r=u.machines.find(({id:a})=>a===v);r&&(r.name=y,await this.writeMachinesData(u),u.machines.some(({id:a})=>a===l)&&this.storageService.store(d,y,0,1))}async setEnablement(v,y){const g=await this.readMachinesData(),l=g.machines.find(({id:u})=>u===v);l&&(l.disabled=y?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(v){const y=this.storageService.get(d,0);if(y)return y;const g=`${this.productService.nameLong} (${(0,T.PlatformToString)(T.isWeb?0:T.platform)})`,l=new RegExp(`${(0,_.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let u=0;for(const r of v){const a=l.exec(r.name),i=a?parseInt(a[1]):0;u=i>u?i:u}return`${g} #${u+1}`}async readMachinesData(v){this.userData=await this.readUserData(v);const y=this.parse(this.userData);if(y.version!==et.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return y}async writeMachinesData(v){const y=JSON.stringify(v),g=await this.userDataSyncStoreService.write(et.RESOURCE,y,this.userData?.ref||null);this.userData={ref:g,content:y},this._onDidChange.fire()}async readUserData(v){if(this.userData){const y=v&&v.latest?v.latest[et.RESOURCE]:void 0;if(this.userData.ref===y)return this.userData;if(y===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(v){if(v.content!==null)try{return JSON.parse(v.content)}catch(y){this.logService.error(y)}return{version:et.VERSION,machines:[]}}};w.VERSION=1,w.RESOURCE="machines",w=de([X(0,R.IEnvironmentService),X(1,C.IFileService),X(2,f.IStorageService),X(3,S.IUserDataSyncStoreService),X(4,S.IUserDataSyncLogService),X(5,P.IProductService)],w),e.UserDataSyncMachinesService=w}),define(ne[235],ie([0,1,5,56,37,8,3,2,4,19,7,146,26,23,21,24,63,64]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const y="sync.disableMachineEventually",g="sync.sessionId",l="sync.storeUrl",u="sync.productQuality";let r=class extends R.Disposable{constructor(t,s,o,c,h,m,I,O,A,N){super();this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=c,this.userDataSyncService=h,this.logService=m,this.userDataSyncAccountService=I,this.telemetryService=O,this.userDataSyncMachinesService=A,this.storageService=N,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new L.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(I.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(h.onDidChangeLocal,($,D)=>$?[...$,D]:[D],1e3)($=>this.triggerSync($,!1,!1))),this._register(k.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(l,0);return t?P.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(l,t.toString(),0,1):this.storageService.remove(l,0)}get productQuality(){return this.storageService.get(u,0)}set productQuality(t){t?this.storageService.store(u,t,0,1):this.storageService.remove(u,0)}updateAutoSync(){const{enabled:t,message:s}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,s,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(g,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(c){if(s)this.logService.error(c),this.updateEnablement(!1);else throw c}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const s=w.UserDataSyncError.toUserDataSyncError(t);s instanceof w.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"||s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?C.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(y,!0,0,1),await(0,L.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(y,0,!1)}stopDisableMachineEventually(){this.storageService.remove(y,0)}async triggerSync(t,s,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([X(0,f.IProductService),X(1,w.IUserDataSyncStoreManagementService),X(2,w.IUserDataSyncStoreService),X(3,w.IUserDataSyncEnablementService),X(4,w.IUserDataSyncService),X(5,w.IUserDataSyncLogService),X(6,p.IUserDataSyncAccountService),X(7,d.ITelemetryService),X(8,v.IUserDataSyncMachinesService),X(9,S.IStorageService)],r),e.UserDataAutoSyncService=r;class a extends R.Disposable{constructor(t,s,o,c,h,m,I,O){super();this.lastSyncUrl=t,this.interval=s,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=c,this.userDataSyncService=h,this.userDataSyncMachinesService=m,this.logService=I,this.storageService=O,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,L.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(t,s){const o=(0,L.createCancelablePromise)(async c=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,_.isPromiseCanceledError)(h))return}return this.doSync(t,s,c)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!t&&(!(0,E.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,E.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,E.isEqual)(s.stableUrl,t.stableUrl))}async doSync(t,s,o){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let c;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),o.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new w.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new w.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new w.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const h=this.storageService.get(g,0);if(h&&this.manifest&&h!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new w.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new w.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new w.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const m=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(o.isCancellationRequested)return;const I=m.find(O=>O.isCurrent);if(I?.disabled)throw new w.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(O){throw new w.UserDataAutoSyncError((0,T.toErrorMessage)(O),O instanceof w.UserDataSyncError?O.code:"Unknown")}if(this.manifest&&this.manifest.session!==h&&this.storageService.store(g,this.manifest.session,0,1),o.isCancellationRequested)return;I||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(h){this.logService.error(h),c=h}this._onDidFinishSync.fire(c)}register(t){return super._register(t)}}a.INTERVAL_SYNCING="Interval"}),define(ne[236],ie([0,1,16,5,37,3,2,19,15,29,20,30,6,23,21,224,226,227,229,230,24]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v,y,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const u="sync.lastSyncTime";let r=class extends k.Disposable{constructor(o,c,h,m,I,O,A,N){super();this.userDataSyncStoreService=o,this.userDataSyncStoreManagementService=c,this.instantiationService=h,this.configurationService=m,this.logService=I,this.telemetryService=O,this.storageService=A,this.userDataSyncEnablementService=N,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new _.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new _.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new k.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(u,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(o,c){this.checkEnablement();const h=(0,E.generateUuid)();try{const N=(0,l.createSyncHeaders)(h);c&&(N["Cache-Control"]="no-cache"),o=await this.userDataSyncStoreService.manifest(o,N)}catch(N){const $=l.UserDataSyncError.toUserDataSyncError(N);throw this.reportUserDataSyncError($,h),$}let m=!1;const I=this,O=this.getEnabledSynchronizers();let A;return{manifest:o,async run(){if(m)throw new Error("Can run a task only once");return A=(0,n.createCancelablePromise)(N=>I.sync(O,o,h,N)),A.finally(()=>A=void 0)},async stop(){if(A&&A.cancel(),I.status!=="idle")return I.stop(O)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new l.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const o=(0,E.generateUuid)(),c=(0,l.createSyncHeaders)(o);let h;try{h=await this.userDataSyncStoreService.manifest(null,c)}catch(I){const O=l.UserDataSyncError.toUserDataSyncError(I);throw this.reportUserDataSyncError(O,o),O}await this.resetLocal();const m=this.getEnabledSynchronizers();return new a(o,h,c,m,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(o,c,h,m){if(m.isCancellationRequested||!o.length)return;const I=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const O=(0,l.createSyncHeaders)(h);for(const A of o){if(m.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(A.resource))return;try{await A.sync(c,O)}catch(N){let $=!1;if(N instanceof l.UserDataSyncError)switch(N.code){case"TooLarge":N=new l.UserDataSyncError(N.message,N.code,A.resource),$=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":$=!0;break}const D=l.UserDataSyncError.toUserDataSyncError(N);if(this.reportUserDataSyncError(D,h),$)throw D;this.logService.error(N),this.logService.error(`${A.resource}: ${(0,T.toErrorMessage)(N)}`),this._syncErrors.push([A.resource,D])}}this.logService.info(`Sync done. Took ${new Date().getTime()-I}ms`),this.updateLastSyncTime()}catch(O){const A=l.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(A,h),A}finally{this.updateStatus(o),this._onSyncErrors.fire(this._syncErrors)}}async stop(o){if(this.status!=="idle")for(const c of o)try{c.status!=="idle"&&await c.stop()}catch(h){this.logService.error(h)}}async replace(o){this.checkEnablement(),await this.performSynchronizerAction(async c=>{if(await c.replace(o))return!0})}async accept(o,c,h,m){this.checkEnablement(),await this.performSynchronizerAction(async I=>{if(I.resource===o)return await I.accept(c,h),m&&await I.apply(!1,(0,l.createSyncHeaders)((0,E.generateUuid)())),!0})}async resolveContent(o){return this.performSynchronizerAction(async c=>{const h=await c.resolveContent(o);if(h)return h})}async getRemoteSyncResourceHandles(o){return await this.performSynchronizerAction(async h=>{if(h.resource===o)return h.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(o){return await this.performSynchronizerAction(async h=>{if(h.resource===o)return h.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(o,c){return await this.performSynchronizerAction(async m=>{if(m.resource===o)return m.getAssociatedResources(c)})||[]}async getMachineId(o,c){return await this.performSynchronizerAction(async m=>{if(m.resource===o)return await m.getMachineId(c)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async c=>{if(c.resource!=="globalState"&&await c.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async c=>{if(await c.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(o){this.logService.error(o)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(u,0),this.synchronizers.value){for(const o of this.synchronizers.value.enabled)try{await o.resetLocal()}catch(c){this.logService.error(`${o.resource}: ${(0,T.toErrorMessage)(c)}`),this.logService.error(c)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(o){const c=new k.DisposableStore;try{const h=this.synchronizers.value||c.add(this.instantiationService.createInstance(i,()=>{},()=>{},()=>{})),m=[...h.enabled,...h.disabled.map(I=>c.add(h.createSynchronizer(I)))];for(const I of m){const O=await o(I);if(!(0,C.isUndefined)(O))return O}return null}finally{c.dispose()}}setStatus(o){const c=this._status;this._status!==o&&(this._status=o,this._onDidChangeStatus.fire(o),c==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(o){this.updateConflicts(o);const c=this.computeStatus(o);this.setStatus(c)}updateConflicts(o){const c=this.computeConflicts(o);(0,L.equals)(this._conflicts,c,([h,m],[I,O])=>h===h&&(0,L.equals)(m,O,(A,N)=>(0,R.isEqual)(A.previewResource,N.previewResource)))||(this._conflicts=this.computeConflicts(o),this._onDidChangeConflicts.fire(c))}computeConflicts(o){return o.filter(c=>c.status==="hasConflicts").map(c=>[c.resource,c.conflicts.map(t)])}computeStatus(o){return this.userDataSyncStoreManagementService.userDataSyncStore?o.some(c=>c.status==="hasConflicts")?"hasConflicts":o.some(c=>c.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(u,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(o,c){this.telemetryService.publicLog2("sync/error",{code:o.code,serverCode:o instanceof l.UserDataSyncStoreError?String(o.serverCode):void 0,url:o instanceof l.UserDataSyncStoreError?o.url:void 0,resource:o.resource,executionId:c,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(i,o=>this.updateStatus(o),o=>this.updateConflicts(o),o=>this._onDidChangeLocal.fire(o))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=de([X(0,l.IUserDataSyncStoreService),X(1,l.IUserDataSyncStoreManagementService),X(2,f.IInstantiationService),X(3,P.IConfigurationService),X(4,l.IUserDataSyncLogService),X(5,d.ITelemetryService),X(6,S.IStorageService),X(7,l.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class a extends k.Disposable{constructor(o,c,h,m,I,O,A){super();this.id=o,this.manifest=c,this.syncHeaders=h,this.synchronisers=m,this.onStop=I,this.configurationService=O,this.logService=A,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new _.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(o=>o.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(o=>o.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(o=>this.getPreviews(o))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(o){throw this.logService.error(o),o}}async accept(o,c){try{return await this.performAction(o,h=>h.accept(o,c))}catch(h){throw this.logService.error(h),h}}async merge(o){try{return o?await this.performAction(o,c=>c.merge(o)):await this.mergeAll()}catch(c){throw this.logService.error(c),c}}async discard(o){try{return await this.performAction(o,c=>c.discard(o))}catch(c){throw this.logService.error(c),c}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const o=[];for(const[,c]of this.previews)for(const h of c.resourcePreviews)h.mergeState==="conflict"&&o.push(h.previewResource);for(const c of o)await this.discard(c);return this.previews}catch(o){throw this.logService.error(o),o}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const o=[];for(const[c,h]of this.previews){this.synchronizingResources.push([c,h.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const m=this.synchronisers.find(O=>O.resource===c);for(const O of h.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&await m.merge(O.previewResource);const I=await m.apply(!1,this.syncHeaders);I&&o.push(this.toSyncResourcePreview(m.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}catch(o){throw this.logService.error(o),o}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(m=>m.resource===o);for(const m of c.resourcePreviews)await h.accept(m.remoteResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(m=>m.resource===o);for(const m of c.resourcePreviews)await h.accept(m.localResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async stop(){await this.onStop(),this.reset()}async performAction(o,c){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const h=this.previews.findIndex(([,M])=>M.resourcePreviews.some(({localResource:W,previewResource:U,remoteResource:x})=>(0,R.isEqual)(o,W)||(0,R.isEqual)(o,U)||(0,R.isEqual)(o,x)));if(h===-1)return this.previews;const[m,I]=this.previews[h],O=I.resourcePreviews.find(({localResource:M,remoteResource:W,previewResource:U})=>(0,R.isEqual)(M,o)||(0,R.isEqual)(W,o)||(0,R.isEqual)(U,o));if(!O)return this.previews;let A=this.synchronizingResources.find(M=>M[0]===m);A||(A=[m,[]],this.synchronizingResources.push(A)),A[1].some(M=>(0,R.isEqual)(M,O.localResource))||(A[1].push(O.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const N=this.synchronisers.find(M=>M.resource===this.previews[h][0]),$=await c(N);$?this.previews.splice(h,1,this.toSyncResourcePreview(N.resource,$)):this.previews.splice(h,1);const D=this.synchronizingResources.findIndex(M=>M[0]===m);return this.synchronizingResources[D][1].splice(A[1].findIndex(M=>(0,R.isEqual)(M,O.localResource)),1),A[1].length||(this.synchronizingResources.splice(D,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const o=[];for(const[c,h]of this.previews){this.synchronizingResources.push([c,h.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const m=this.synchronisers.find(O=>O.resource===c);let I=h;for(const O of h.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&(I=await m.merge(O.previewResource));I&&o.push(this.toSyncResourcePreview(m.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}async getPreviews(o){const c=[],h=await this.getUserDataSyncConfiguration();for(const m of this.synchronisers){if(o.isCancellationRequested)return[];const I=await m.preview(this.manifest,h,this.syncHeaders);I&&c.push(this.toSyncResourcePreview(m.resource,I))}return c}async getUserDataSyncConfiguration(){const o=this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE),c=await this.synchronisers.find(h=>h instanceof y.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...o,...c}}toSyncResourcePreview(o,c){return[o,{isLastSyncFromCurrentMachine:c.isLastSyncFromCurrentMachine,resourcePreviews:c.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let i=class extends k.Disposable{constructor(o,c,h,m,I,O,A){super();this.onDidChangeStatus=o,this.onDidChangeConflicts=c,this.onDidChangeLocal=h,this.userDataSyncEnablementService=m,this.instantiationService=I,this.extensionGalleryService=O,this.logService=A,this._enabled=[],this._register(m.onDidChangeResourceEnablement(([N,$])=>this.onDidChangeResourceEnablement(N,$))),this._register((0,k.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,N])=>N.dispose())));for(const N of l.ALL_SYNC_RESOURCES)m.isResourceEnabled(N)&&this.registerSynchronizer(N)}get enabled(){return this._enabled.sort((o,c)=>o[1]-c[1]).map(([o])=>o)}get disabled(){return l.ALL_SYNC_RESOURCES.filter(o=>!this.userDataSyncEnablementService.isResourceEnabled(o))}onDidChangeResourceEnablement(o,c){c?this.registerSynchronizer(o):this.deRegisterSynchronizer(o)}registerSynchronizer(o){if(this._enabled.some(([I])=>I.resource===o))return;if(o==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const c=new k.DisposableStore,h=c.add(this.createSynchronizer(o));c.add(h.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),c.add(h.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),c.add(h.onDidChangeLocal(()=>this.onDidChangeLocal(o)));const m=this.getOrder(o);this._enabled.push([h,m,c])}deRegisterSynchronizer(o){const c=this._enabled.findIndex(([h])=>h.resource===o);if(c!==-1){const h=this._enabled.splice(c,1);for(const[m,,I]of h){if(m.status!=="idle"){const O=m.conflicts.length>0;m.stop(),O&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}I.dispose()}}}createSynchronizer(o){switch(o){case"settings":return this.instantiationService.createInstance(y.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(v.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(g.SnippetsSynchroniser);case"globalState":return this.instantiationService.createInstance(p.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(w.ExtensionsSynchroniser)}}getOrder(o){switch(o){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"globalState":return 3;case"extensions":return 4}}};i=de([X(3,l.IUserDataSyncEnablementService),X(4,f.IInstantiationService),X(5,b.IExtensionGalleryService),X(6,l.IUserDataSyncLogService)],i);function t(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(ne[237],ie([0,1,3,2,15,7,24]),function(J,e,L,n,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(b,f){this.service=b,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new L.Emitter}listen(b,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(b,f,S){try{return await this._call(b,f,S)}catch(d){throw this.logService.error(d),d}}async _call(b,f,S){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(_.URI.revive(S[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(S[0],_.URI.revive(S[1]),S[2],S[3]);case"resolveContent":return this.service.resolveContent(_.URI.revive(S[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(S[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(S[0]);case"getAssociatedResources":return this.service.getAssociatedResources(S[0],{created:S[1].created,uri:_.URI.revive(S[1].uri)});case"getMachineId":return this.service.getMachineId(S[0],{created:S[1].created,uri:_.URI.revive(S[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const d=f.substring("manualSync/".length),w=S[0],p=this.getManualSyncTask(w);switch(S=S.slice(1),d){case"preview":return p.preview();case"accept":return p.accept(_.URI.revive(S[0]),S[1]);case"merge":return p.merge(_.URI.revive(S[0]));case"discard":return p.discard(_.URI.revive(S[0]));case"discardConflicts":return p.discardConflicts();case"apply":return p.apply();case"pull":return p.pull();case"push":return p.push();case"stop":return p.stop();case"_getStatus":return p.status;case"dispose":return this.disposeManualSyncTask(p)}}throw new Error("Invalid call")}getManualSyncTask(b){const f=this.manualSyncTasks.get(this.createKey(b));if(!f)throw new Error(`Manual sync taks not found: ${b}`);return f.manualSyncTask}async createManualSyncTask(){const b=new n.DisposableStore,f=b.add(await this.service.createManualSyncTask());return b.add(f.onSynchronizeResources(S=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:S}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:b}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(b){b.dispose();const f=this.createKey(b.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(b){return`manualSyncTask-${b}`}}e.UserDataSyncChannel=R;class C extends n.Disposable{constructor(b){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,S,d){return b.call(f,S,d).then(null,w=>{throw k.UserDataSyncError.toUserDataSyncError(w)})},listen(f,S){return b.listen(f,S)}},this.channel.call("_getInitialData").then(([f,S,d])=>{this.updateStatus(f),this.updateConflicts(S),d&&this.updateLastSyncTime(d),this._register(this.channel.listen("onDidChangeStatus")(w=>this.updateStatus(w))),this._register(this.channel.listen("onDidChangeLastSyncTime")(w=>this.updateLastSyncTime(w)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([S,d])=>[S,k.UserDataSyncError.toUserDataSyncError(d)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:b,manifest:f,status:S}=await this.channel.call("createManualSyncTask"),d=this,w=new E(b,f,S,{async call(p,v,y){return d.channel.call(`manualSync/${p}`,[b,...(0,T.isArray)(v)?v:[v]],y)},listen(p,v){return L.Event.map(L.Event.filter(d.channel.listen(`manualSync/${p}`,v),y=>!w.isDiposed()&&y.manualSyncTaskId===b),y=>y.data)}});return w}replace(b){return this.channel.call("replace",[b])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(b,f,S,d){return this.channel.call("accept",[b,f,S,d])}resolveContent(b){return this.channel.call("resolveContent",[b])}async getLocalSyncResourceHandles(b){return(await this.channel.call("getLocalSyncResourceHandles",[b])).map(({created:S,uri:d})=>({created:S,uri:_.URI.revive(d)}))}async getRemoteSyncResourceHandles(b){return(await this.channel.call("getRemoteSyncResourceHandles",[b])).map(({created:S,uri:d})=>({created:S,uri:_.URI.revive(d)}))}async getAssociatedResources(b,f){return(await this.channel.call("getAssociatedResources",[b,f])).map(({resource:d,comparableResource:w})=>({resource:_.URI.revive(d),comparableResource:_.URI.revive(w)}))}async getMachineId(b,f){return this.channel.call("getMachineId",[b,f])}async updateStatus(b){this._status=b,this._onDidChangeStatus.fire(b)}async updateConflicts(b){this._conflicts=b.map(([f,S])=>[f,S.map(d=>({...d,localResource:_.URI.revive(d.localResource),remoteResource:_.URI.revive(d.remoteResource),previewResource:_.URI.revive(d.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(b){this._lastSyncTime!==b&&(this._lastSyncTime=b,this._onDidChangeLastSyncTime.fire(b))}}e.UserDataSyncChannelClient=C;class E extends n.Disposable{constructor(b,f,S,d){super();this.id=b,this.manifest=f,this._disposed=!1,this._status=S;const w=this;this.channel={async call(p,v,y){try{const g=await d.call(p,v,y);return w.isDiposed()||(w._status=await d.call("_getStatus")),g}catch(g){throw k.UserDataSyncError.toUserDataSyncError(g)}},listen(p,v){return d.listen(p,v)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const b=await this.channel.call("preview");return this.deserializePreviews(b)}async accept(b,f){const S=await this.channel.call("accept",[b,f]);return this.deserializePreviews(S)}async merge(b){const f=await this.channel.call("merge",[b]);return this.deserializePreviews(f)}async discard(b){const f=await this.channel.call("discard",[b]);return this.deserializePreviews(f)}async discardConflicts(){const b=await this.channel.call("discardConflicts");return this.deserializePreviews(b)}async apply(){const b=await this.channel.call("apply");return this.deserializePreviews(b)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(b){return b.map(([f,S])=>[f,{isLastSyncFromCurrentMachine:S.isLastSyncFromCurrentMachine,resourcePreviews:S.resourcePreviews.map(d=>({...d,localResource:_.URI.revive(d.localResource),remoteResource:_.URI.revive(d.remoteResource),previewResource:_.URI.revive(d.previewResource),acceptedResource:_.URI.revive(d.acceptedResource)}))}])}}}),define(ne[238],ie([0,1,5,25,8,3,2,101,4,19,15,7,29,20,13,14,26,43,46,23,24]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v,y,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const u="sync.previous.store",r="sync.donot-make-requests-until",a="sync.user-session-id",i="sync.machine-session-id",t=100,s=1e3*60*5;let o=class extends k.Disposable{constructor(A,N,$){super();this.productService=A,this.configurationService=N,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new _.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(_.Event.filter($.onDidChangeValue,D=>D.key===l.SYNC_SERVICE_URL_TYPE&&D.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(l.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(A){this.storageService.store(l.SYNC_SERVICE_URL_TYPE,A,0,C.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[l.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(l.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(A,N){A=C.isWeb&&A?.web?{...A,...A.web}:A;const $={...A||{},...N||{}};if($&&(0,P.isString)($.url)&&(0,P.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(D=>(0,P.isArray)($.authenticationProviders[D].scopes))){const D=$,M=!!D.canSwitch&&!N?.url,W=D.url===D.insidersUrl?"insiders":"stable",U=(M?this.userDataSyncStoreType:void 0)||W,x=N?.url||(U==="insiders"?D.insidersUrl:U==="stable"?D.stableUrl:D.url);return{url:b.URI.parse(x),type:U,defaultType:W,defaultUrl:b.URI.parse(D.url),stableUrl:b.URI.parse(D.stableUrl),insidersUrl:b.URI.parse(D.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(D.authenticationProviders).reduce((ee,G)=>(ee.push({id:G,scopes:D.authenticationProviders[G].scopes}),ee),[])}}}};o=de([X(0,p.IProductService),X(1,S.IConfigurationService),X(2,g.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let c=class extends o{constructor(A,N,$){super(A,N,$);const D=this.storageService.get(u,0);D&&(this.previousConfigurationSyncStore=JSON.parse(D));const M=this.productService[l.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(u,JSON.stringify(M),0,1):this.storageService.remove(u,0)}async switch(A){A!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=A,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};c=de([X(0,p.IProductService),X(1,S.IConfigurationService),X(2,g.IStorageService)],c),e.UserDataSyncStoreManagementService=c;let h=class extends k.Disposable{constructor(A,N,$,D,M,W,U){super();this.requestService=$,this.logService=D,this.storageService=U,this._onTokenFailed=this._register(new _.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new _.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new _.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(A),this.commonHeadersPromise=(0,y.getServiceMachineId)(M,W,U).then(x=>{const ee={"X-Client-Name":`${N.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(ee["X-Client-Commit"]=N.commit),ee}),this.session=new I(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(A,N){this.authToken={token:A,type:N}}updateUserDataSyncStoreUrl(A){this.userDataSyncStoreUrl=A?(0,E.joinPath)(A,"v1"):void 0}initDonotMakeRequestsUntil(){const A=this.storageService.getNumber(r,0);A&&Date.now()<A&&this.setDonotMakeRequestsUntil(new Date(A))}setDonotMakeRequestsUntil(A){this._donotMakeRequestsUntil?.getTime()!==A?.getTime()&&(this._donotMakeRequestsUntil=A,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,L.createCancelablePromise)(N=>(0,L.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(A){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",A),$={},D=await this.request(N.toString(),{type:"GET",headers:$},[],n.CancellationToken.None);return(await(0,v.asJson)(D)||[]).map(({url:W,created:U})=>({ref:(0,E.relativePath)(N,N.with({path:W})),created:U*1e3}))}async resolveContent(A,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",A,N).toString(),D={};D["Cache-Control"]="no-cache";const M=await this.request($,{type:"GET",headers:D},[],n.CancellationToken.None);return await(0,v.asText)(M)}async delete(A){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",A).toString(),$={};await this.request(N,{type:"DELETE",headers:$},[],n.CancellationToken.None)}async read(A,N,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",A,"latest").toString();$={...$},$["Cache-Control"]="no-cache",N&&($["If-None-Match"]=N.ref);const M=await this.request(D,{type:"GET",headers:$},[304],n.CancellationToken.None);let W=null;if(M.res.statusCode===304&&(W=N),W===null){const U=M.res.headers.etag;if(!U)throw new l.UserDataSyncStoreError("Server did not return the ref",D,"NoRef",M.res.statusCode,M.res.headers[l.HEADER_OPERATION_ID]);const x=await(0,v.asText)(M);if(!x&&M.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",D,"EmptyResponse",M.res.statusCode,M.res.headers[l.HEADER_OPERATION_ID]);W={ref:U,content:x}}return W}async write(A,N,$,D={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",A).toString();D={...D},D["Content-Type"]=R.Mimes.text,$&&(D["If-Match"]=$);const W=await this.request(M,{type:"POST",data:N,headers:D},[],n.CancellationToken.None),U=W.res.headers.etag;if(!U)throw new l.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",W.res.statusCode,W.res.headers[l.HEADER_OPERATION_ID]);return U}async manifest(A,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",A&&(N["If-None-Match"]=A.ref);const D=await this.request($,{type:"GET",headers:N},[304],n.CancellationToken.None);let M=null;if(D.res.statusCode===304&&(M=A),!M){const U=D.res.headers.etag;if(!U)throw new l.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",D.res.statusCode,D.res.headers[l.HEADER_OPERATION_ID]);const x=await(0,v.asText)(D);if(!x&&D.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",$,"EmptyResponse",D.res.statusCode,D.res.headers[l.HEADER_OPERATION_ID]);x&&(M={...JSON.parse(x),ref:U})}const W=this.storageService.get(a,0);return W&&M&&W!==M.session&&this.clearSession(),M===null&&W&&this.clearSession(),M&&this.storageService.store(a,M.session,0,1),M}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const A=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":R.Mimes.text};await this.request(A,{type:"DELETE",headers:N},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(i,0)}async request(A,N,$,D){if(!this.authToken)throw new l.UserDataSyncStoreError("No Auth Token Available",A,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;N.headers={...N.headers||{},...M,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:A,type:N.type,headers:{...N.headers,authorization:void 0}});let W;try{W=await this.session.request(A,N,D)}catch(G){if(!(G instanceof l.UserDataSyncStoreError)){let q="RequestFailed";const Y=(0,T.getErrorMessage)(G).toLowerCase();Y.includes("xhr timeout")?q="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?q="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?q="RequestPathNotEscaped":Y.includes("headers must be an object")?q="RequestHeadersNotObject":(0,T.isPromiseCanceledError)(G)&&(q="RequestCanceled"),G=new l.UserDataSyncStoreError(`Connection refused for the request '${A}'.`,A,q,void 0,void 0)}throw this.logService.info("Request failed",A),G}const U=W.res.headers[l.HEADER_OPERATION_ID],x={url:A,status:W.res.statusCode,"execution-id":N.headers[l.HEADER_EXECUTION_ID],"operation-id":U},ee=(0,v.isSuccess)(W)||W.res.statusCode&&$.indexOf(W.res.statusCode)!==-1;if(ee?this.logService.trace("Request succeeded",x):this.logService.info("Request failed",x),W.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new l.UserDataSyncStoreError(`Request '${A}' failed because of Unauthorized (401).`,A,"Unauthorized",W.res.statusCode,U);if(this._onTokenSucceed.fire(),W.res.statusCode===409)throw new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,A,"Conflict",W.res.statusCode,U);if(W.res.statusCode===410)throw new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because the requested resource is not longer available (410).`,A,"Gone",W.res.statusCode,U);if(W.res.statusCode===412)throw new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,A,"PreconditionFailed",W.res.statusCode,U);if(W.res.statusCode===413)throw new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too large payload (413).`,A,"TooLarge",W.res.statusCode,U);if(W.res.statusCode===426)throw new l.UserDataSyncStoreError(`${N.type} request '${A}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,A,"UpgradeRequired",W.res.statusCode,U);if(W.res.statusCode===429){const G=W.res.headers["retry-after"];throw G?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(G)*1e3)),new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",W.res.statusCode,U)):new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"RemoteTooManyRequests",W.res.statusCode,U)}if(!ee)throw new l.UserDataSyncStoreError("Server returned "+W.res.statusCode,A,"Unknown",W.res.statusCode,U);return W}addSessionHeaders(A){let N=this.storageService.get(i,0);N===void 0&&(N=(0,f.generateUuid)(),this.storageService.store(i,N,0,1)),A["X-Machine-Session-Id"]=N;const $=this.storageService.get(a,0);$!==void 0&&(A["X-User-Session-Id"]=$)}};h=de([X(1,p.IProductService),X(2,v.IRequestService),X(3,l.IUserDataSyncLogService),X(4,d.IEnvironmentService),X(5,w.IFileService),X(6,g.IStorageService)],h),e.UserDataSyncStoreClient=h;let m=class extends h{constructor(A,N,$,D,M,W,U){super(A.userDataSyncStore?.url,N,$,D,M,W,U);this._register(A.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(A.userDataSyncStore?.url)))}};m=de([X(0,l.IUserDataSyncStoreManagementService),X(1,p.IProductService),X(2,v.IRequestService),X(3,l.IUserDataSyncLogService),X(4,d.IEnvironmentService),X(5,w.IFileService),X(6,g.IStorageService)],m),e.UserDataSyncStoreService=m;class I{constructor(A,N,$,D){this.limit=A,this.interval=N,this.requestService=$,this.logService=D,this.requests=[],this.startTime=void 0}request(A,N,$){if(this.isExpired()&&this.reset(),N.url=A,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new l.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,A,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(A),this.requestService.request(N,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(ne[239],ie([0,1,3,60,26,23,21,235,24,63,64]),function(J,e,L,n,T,_,k,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends R.UserDataAutoSyncService{constructor(S,d,w,p,v,y,g,l,u,r,a){super(S,d,w,p,v,g,l,u,r,a);this._register(L.Event.debounce(L.Event.any(L.Event.map(y.onDidFocusWindow,()=>"windowFocus"),L.Event.map(y.onDidOpenWindow,()=>"windowOpen")),(i,t)=>i?[...i,t]:[t],1e3)(i=>this.triggerSync(i,!0,!1)))}};b=de([X(0,T.IProductService),X(1,C.IUserDataSyncStoreManagementService),X(2,C.IUserDataSyncStoreService),X(3,C.IUserDataSyncEnablementService),X(4,C.IUserDataSyncService),X(5,n.INativeHostService),X(6,C.IUserDataSyncLogService),X(7,E.IUserDataSyncAccountService),X(8,k.ITelemetryService),X(9,P.IUserDataSyncMachinesService),X(10,_.IStorageService)],b),e.UserDataAutoSyncService=b}),define(ne[240],ie([0,1,5,3,2]),function(J,e,L,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class _ extends T.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:C,getActiveWindowId:E}){super();this.disposables=this._register(new T.DisposableStore),n.Event.latch(n.Event.any(R,C))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>E()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=_}),define(ne[65],ie([0,1,50,5,9,15,22,124,252,253]),function(J,e,L,n,T,_,k,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(r,a){let i=a.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=a}}e.ExtractError=P;function b(u){const r=u.externalFileAttributes>>16||33188;return[448,56,7].map(a=>r&a).reduce((a,i)=>a+i,r&61440)}function f(u){if(u instanceof P)return u;let r;return/end of central directory record signature not found/.test(u.message)&&(r="CorruptZip"),new P(r,u)}function S(u,r,a,i,t,s){const o=T.dirname(r),c=T.join(i,o);if(!c.startsWith(i))return Promise.reject(new Error(R.localize(0,null,r)));const h=T.join(i,r);let m;return s.onCancellationRequested(()=>{m&&m.destroy()}),Promise.resolve(k.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((I,O)=>{if(!s.isCancellationRequested)try{m=(0,L.createWriteStream)(h,{mode:a}),m.once("close",()=>I()),m.once("error",O),u.once("error",O),u.pipe(m)}catch(A){O(A)}}))}function d(u,r,a,i){let t=(0,n.createCancelablePromise)(()=>Promise.resolve()),s=0;return i.onCancellationRequested(()=>{t.cancel(),u.close()}),new Promise((o,c)=>{const h=new n.Sequencer,m=I=>{I.isCancellationRequested||(s++,u.readEntry())};u.once("error",c),u.once("close",()=>t.then(()=>{i.isCancellationRequested||u.entryCount===s?o():c(new P("Incomplete",new Error(R.localize(1,null,s,u.entryCount))))},c)),u.readEntry(),u.on("entry",I=>{if(i.isCancellationRequested)return;if(!a.sourcePathRegex.test(I.fileName)){m(i);return}const O=I.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(O)){const $=T.join(r,O);t=(0,n.createCancelablePromise)(D=>k.Promises.mkdir($,{recursive:!0}).then(()=>m(D)).then(void 0,c));return}const A=p(u,I),N=b(I);t=(0,n.createCancelablePromise)($=>h.queue(()=>A.then(D=>S(D,O,N,r,a,$).then(()=>m($)))).then(null,c))})})}function w(u,r=!1){return new Promise((a,i)=>{(0,C.open)(u,r?{lazyEntries:!0}:void 0,(t,s)=>{t?i(f(t)):a((0,_.assertIsDefined)(s))})})}function p(u,r){return new Promise((a,i)=>{u.openReadStream(r,(t,s)=>{t?i(f(t)):a((0,_.assertIsDefined)(s))})})}function v(u,r){return new Promise((a,i)=>{const t=new E.ZipFile;r.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,L.createWriteStream)(u);t.outputStream.pipe(s),t.outputStream.once("error",i),s.once("error",i),s.once("finish",()=>a(u))})}e.zip=v;function y(u,r,a={},i){const t=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let s=w(u,!0);return a.overwrite&&(s=s.then(o=>k.Promises.rm(r).then(()=>o))),s.then(o=>d(o,r,{sourcePathRegex:t},i))}e.extract=y;function g(u,r){return w(u).then(a=>new Promise((i,t)=>{a.on("entry",s=>{s.fileName===r&&p(a,s).then(o=>i(o),o=>t(o))}),a.once("close",()=>t(new Error(R.localize(2,null,r))))}))}function l(u,r){return g(u,r).then(a=>new Promise((i,t)=>{const s=[];a.once("error",t),a.on("data",o=>s.push(o)),a.on("end",()=>i(Buffer.concat(s)))}))}e.buffer=l}),define(ne[241],ie([0,1,65,133]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function T(_){return(0,L.buffer)(_,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=T}),define(ne[242],ie([0,1,16,5,8,2,18,9,4,19,61,7,29,22,65,134,13,30,33,155,14,10,26]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v,y,g,l,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let a=class extends _.Disposable{constructor(t,s,o,c,h){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=o,this.environmentService=c,this.productService=h,this._devSystemExtensionsPath=null,this.systemExtensionsPath=c.builtinExtensionsPath,this.extensionsPath=c.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(o).message,v.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(o).message,v.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(s);return(0,L.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(c=>!s[new y.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).key()]),t&&(o=(0,y.groupByExtension)(o,h=>h.identifier).map(h=>h.sort((m,I)=>P.rcompare(m.manifest.version,I.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,o,c){const h=t.key(),m=R.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),I=R.join(this.extensionsPath,h);try{await S.Promises.rm(I)}catch{try{await S.Promises.rm(I)}catch{}throw new v.ExtensionManagementError((0,w.localize)(0,null,I,t.id),v.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,m,c);let O=await this.scanExtension(b.URI.file(m),1);if(!O)throw new Error((0,w.localize)(1,null,m));await this.storeMetadata(O,{...o,installedTimestamp:Date.now()});try{await this.rename(t,m,I,Date.now()+2*60*1e3),this.logService.info("Renamed to",I)}catch(A){try{await S.Promises.rm(m)}catch{}if(A.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(A)}. Deleted from extracted location`,m),A}try{O=await this.scanExtension(b.URI.file(I),1)}catch{}if(O)return O;throw new Error((0,w.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const o=R.join(t.location.fsPath,"package.json"),c=await S.Promises.readFile(o,"utf8"),{manifest:h}=await this.parseManifest(c);return h.__metadata=s,await S.Promises.writeFile(o,JSON.stringify(h,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(o=>new y.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{s.forEach(c=>o[c.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(c=>delete c[t.key()]);const o=(await this.scanExtensions(1)).find(c=>new y.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).equals(t))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(c){if(c.code!=="ENOENT")throw c}let o={};if(s)try{o=JSON.parse(s)}catch{}return t&&(t(o),Object.keys(o).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await S.Promises.rm(this.uninstalledPath)),o})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await S.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new y.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,o,c){this.logService.trace(`Started extracting the extension from ${s} to ${o}`);try{await S.Promises.rm(o)}catch(h){throw new v.ExtensionManagementError(this.joinErrors(h).message,v.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(s,o,{sourcePath:"extension",overwrite:!0},c),this.logService.info(`Extracted extension to ${o}:`,t.id)}catch(h){try{await S.Promises.rm(o)}catch{}let m=v.ExtensionManagementErrorCode.Extract;throw h instanceof d.ExtractError&&(h.type==="CorruptZip"?m=v.ExtensionManagementErrorCode.CorruptZip:h.type==="Incomplete"&&(m=v.ExtensionManagementErrorCode.IncompleteZip)),new v.ExtensionManagementError(h.message,m)}}async rename(t,s,o,c){try{await S.Promises.rename(s,o)}catch(h){if(C.isWindows&&h&&h.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${s} to ${o} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,o,c);throw new v.ExtensionManagementError(h.message||(0,w.localize)(3,null,s,o),h.code||v.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[o,c]=await Promise.all([t,s]);return[...o,...c]}async scanExtensionsInDir(t,s){const o=new n.Limiter(10),c=await this.fileService.resolve(b.URI.file(t));return c.children?(await Promise.all(c.children.filter(m=>m.isDirectory).map(m=>o.queue(async()=>s===1&&(0,E.basename)(m.resource).indexOf(".")===0?null:this.scanExtension(m.resource,s))))).filter(m=>m&&m.identifier):[]}async scanExtension(t,s){try{const o=await this.fileService.resolve(t);if(o.children){const{manifest:c,metadata:h}=await this.readManifest(t.fsPath),m=o.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,I=o.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource,O={id:(0,y.getGalleryExtensionId)(c.publisher,c.name)},A={type:s,identifier:O,manifest:c,location:t,readmeUrl:m,changelogUrl:I,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(A,h),A}}catch(o){s!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(o=>t.some(c=>(0,y.areSameExtensions)(o.identifier,{id:c})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s?.publisherDisplayName||null,t.publisherId=s?.publisherId||null,t.identifier.uuid=s?.id,t.isMachineScoped=!!s?.isMachineScoped,t.isPreReleaseVersion=!!s?.isPreReleaseVersion,t.preRelease=!!s?.preRelease,t.isBuiltin=t.type===0||!!s?.isBuiltin,t.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),o=new Set;for(const m of s)t[new y.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()]||o.add(m.identifier.id.toLowerCase());const c=(0,y.groupByExtension)(s,m=>m.identifier);await n.Promises.settled(c.map(async m=>{const I=m.sort((O,A)=>P.rcompare(O.manifest.version,A.manifest.version))[0];o.has(I.identifier.id.toLowerCase())||await this.beforeRemovingExtension(I)}));const h=s.filter(m=>t[new y.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()]);await n.Promises.settled(h.map(m=>this.removeUninstalledExtension(m)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],o=(0,y.groupByExtension)(t,c=>c.identifier);s.push(...(0,L.flatten)(o.map(c=>c.sort((h,m)=>P.rcompare(h.manifest.version,m.manifest.version)).slice(1)))),await n.Promises.settled(s.map(c=>this.removeExtension(c,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(k.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[S.Promises.readFile(R.join(t,"package.json"),"utf8").then(m=>this.parseManifest(m)),S.Promises.readFile(R.join(t,"package.nls.json"),"utf8").then(void 0,m=>m.code!=="ENOENT"?Promise.reject(m):"{}").then(m=>JSON.parse(m))],[{manifest:o,metadata:c},h]=await Promise.all(s);return{manifest:(0,g.localizeManifest)(o,h),metadata:c}}parseManifest(t){return new Promise((s,o)=>{try{const c=JSON.parse(t),h=c.__metadata||null;s({manifest:c,metadata:h})}catch{o(new Error((0,w.localize)(4,null)))}})}};a=de([X(1,l.IFileService),X(2,u.ILogService),X(3,p.INativeEnvironmentService),X(4,r.IProductService)],a),e.ExtensionsScanner=a}),define(ne[243],ie([0,1,37,8,18,9,4,31,19,61,7,29,22,65,132,79,13,204,30,33,187,174,241,188,242,218,76,14,6,10,26,21,34]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v,y,g,l,u,r,a,i,t,s,o,c,h,m,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let A=class extends v.AbstractExtensionManagementService{constructor(U,x,ee,G,q,Y,H,Z,K){super(U,x,ee,Z);this.environmentService=G,this.downloadService=q,this.fileService=H;const F=this._register(Y.createInstance(u.ExtensionsLifecycle));this.extensionsScanner=this._register(Y.createInstance(i.ExtensionsScanner,B=>F.postUninstall(B))),this.manifestCache=this._register(new a.ExtensionsManifestCache(G,this)),this.extensionsDownloader=this._register(Y.createInstance(l.ExtensionsDownloader));const j=this._register(new t.ExtensionsWatcher(this,H,G,ee,K));this._register(j.onDidChangeExtensionsByAnotherSource(({added:B,removed:z})=>{B.length&&this._onDidInstallExtensions.fire(B.map(V=>({identifier:V.identifier,operation:1,local:V}))),z.forEach(V=>this._onDidUninstallExtension.fire({identifier:V}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const U=await this.isAlpineLinux(),x=(0,y.getTargetPlatform)(U?"alpine":k.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",x),x})()),this._targetPlatformPromise}async isAlpineLinux(){if(!k.isLinux)return!1;let U;try{U=(await this.fileService.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{U=(await this.fileService.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(ee){this.logService.debug("Error while getting the os-release file.",(0,n.getErrorMessage)(ee))}}return!!U&&(U.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const x=await this.collectFiles(U),ee=await(0,S.zip)((0,C.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)()).fsPath,x);return P.URI.file(ee)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const x=await this.downloadVsix(U),ee=_.resolve(x.fsPath);return(0,r.getManifest)(ee)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async install(U,x={}){this.logService.trace("ExtensionManagementService#install",U.toString());const ee=await this.downloadVsix(U),G=await(0,r.getManifest)(_.resolve(ee.fsPath));if(G.engines&&G.engines.vscode&&!(0,s.isEngineValid)(G.engines.vscode,this.productService.version,this.productService.date))throw new Error(d.localize(0,null,(0,g.getGalleryExtensionId)(G.publisher,G.name),this.productService.version));return this.installExtension(G,ee,x)}async updateMetadata(U,x){this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id);const ee={...U.manifest.__metadata||{},...x};return x.isPreReleaseVersion&&(ee.preRelease=!0),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,ee),this.manifestCache.invalidate(),U}async updateExtensionScope(U,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:x}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===T.Schemas.file)return U;const x=(0,C.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)());return await this.downloadService.download(U,x),x}createInstallExtensionTask(U,x,ee){return P.URI.isUri(x)?new D(U,x,ee,this.galleryService,this.extensionsScanner,this.logService):new $(x,ee,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,x){return new M(U,x,this.extensionsScanner)}async collectFiles(U){const x=async G=>{let q=await f.Promises.readdir(G);q=q.map(Z=>_.join(G,Z));const Y=await Promise.all(q.map(Z=>f.Promises.stat(Z)));let H=Promise.resolve([]);return Y.forEach((Z,K)=>{const F=q[K];Z.isFile()&&(H=H.then(j=>[...j,F])),Z.isDirectory()&&(H=H.then(j=>x(F).then(B=>[...j,...B])))}),H};return(await x(U.location.fsPath)).map(G=>({path:`extension/${_.relative(U.location.fsPath,G)}`,localPath:G}))}};A=de([X(0,y.IExtensionGalleryService),X(1,I.ITelemetryService),X(2,h.ILogService),X(3,p.INativeEnvironmentService),X(4,w.IDownloadService),X(5,c.IInstantiationService),X(6,o.IFileService),X(7,m.IProductService),X(8,O.IUriIdentityService)],A),e.ExtensionManagementService=A;class N extends v.AbstractExtensionTask{constructor(U,x,ee,G){super();this.identifier=U,this.source=x,this.extensionsScanner=ee,this.logService=G,this._operation=2}get operation(){return this._operation}async installExtension(U,x){try{const ee=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(ee)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ee,{...ee.manifest.__metadata||{},...U.metadata}):ee}catch{throw k.isMacintosh?new y.ExtensionManagementError(d.localize(1,null),y.ExtensionManagementErrorCode.Internal):new y.ExtensionManagementError(d.localize(2,null),y.ExtensionManagementErrorCode.Internal)}return this.extract(U,x)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const ee=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),ee}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:x,metadata:ee},G){let q=await this.extensionsScanner.extractUserExtension(x,U,ee,G);return this.logService.info("Extracting completed.",x.id),q}}class $ extends N{constructor(U,x,ee,G,q){super(U.identifier,U,G,q);this.gallery=U,this.options=x,this.extensionsDownloader=ee}async doRun(U){const ee=(await this.extensionsScanner.scanExtensions(null)).find(q=>(0,g.areSameExtensions)(q.identifier,this.gallery.identifier));ee&&(this._operation=3);const G=await this.downloadInstallableExtension(this.gallery,this._operation);G.metadata.isMachineScoped=this.options.isMachineScoped||ee?.isMachineScoped,G.metadata.isBuiltin=this.options.isBuiltin||ee?.isBuiltin,G.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,G.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:ee?.preRelease;try{const q=await this.installExtension(G,U);return ee&&E.neq(ee.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ee),q}catch(q){throw await this.deleteDownloadedVSIX(G.zipPath),q}}async deleteDownloadedVSIX(U){try{await this.extensionsDownloader.delete(P.URI.file(U))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",U.toString(),(0,n.getErrorMessage)(x))}}async downloadInstallableExtension(U,x){const ee={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let G;try{this.logService.trace("Started downloading extension:",U.identifier.id),G=(await this.extensionsDownloader.downloadExtension(U,x)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,G)}catch(q){throw new y.ExtensionManagementError((0,v.joinErrors)(q).message,y.ExtensionManagementErrorCode.Download)}try{const q=await(0,r.getManifest)(G);return{zipPath:G,identifierWithVersion:new g.ExtensionIdentifierWithVersion(U.identifier,q.version),metadata:ee}}catch(q){throw await this.deleteDownloadedVSIX(G),new y.ExtensionManagementError((0,v.joinErrors)(q).message,y.ExtensionManagementErrorCode.Invalid)}}}class D extends N{constructor(U,x,ee,G,q,Y){super({id:(0,g.getGalleryExtensionId)(U.publisher,U.name)},x,q,Y);this.manifest=U,this.location=x,this.options=ee,this.galleryService=G}async doRun(U){const x=new g.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),G=(await this.extensionsScanner.scanExtensions(1)).find(Y=>(0,g.areSameExtensions)(this.identifier,Y.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,U);if(q.isMachineScoped=this.options.isMachineScoped||G?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||G?.isBuiltin,G)if(this._operation=3,x.equals(new g.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version)))try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(d.localize(3,null,this.manifest.displayName||this.manifest.name))}else E.gt(G.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(G);else{const Y=await this.unsetUninstalledAndGetLocal(x);if(Y)try{await this.extensionsScanner.removeExtension(Y,"existing")}catch{throw new Error(d.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:_.resolve(this.location.fsPath),identifierWithVersion:x,metadata:q},U)}async getMetadata(U,x,ee){try{let[G]=await this.galleryService.getExtensions([{id:U,version:x}],ee);if(G||([G]=await this.galleryService.getExtensions([{id:U}],ee)),G)return{id:G.identifier.uuid,publisherDisplayName:G.publisherDisplayName,publisherId:G.publisherId,isPreReleaseVersion:G.properties.isPreReleaseVersion,preRelease:G.properties.isPreReleaseVersion}}catch{}return{}}}class M extends v.AbstractExtensionTask{constructor(U,x,ee){super();this.extension=U,this.options=x,this.extensionsScanner=ee}async doRun(U){const x=[],ee=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const G=new g.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);x.push(...ee.filter(q=>G.equals(new g.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version))))}else x.push(...ee.filter(G=>(0,g.areSameExtensions)(G.identifier,this.extension.identifier)));if(!x.length)throw new Error(d.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const G of x)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(G)}catch(q){throw new Error(d.localize(6,null,(0,L.toErrorMessage)(q)))}}}}),define(ne[244],ie([0,1,81,55,32,17,8,3,2,9,4,29,36,71,254]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(I,O=""){this.debugLabel=O,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,k.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,O){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,O)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const O=A=>{this.traceSocketEvent("read",A),I(_.VSBuffer.wrap(A))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(I){const O=A=>{this.traceSocketEvent("close",{hadError:A}),I({type:0,hadError:A,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(I){const O=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,k.onUnexpectedError)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,k.onUnexpectedError)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=w;var p;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var v;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(v||(v={}));class y extends C.Disposable{constructor(I,O,A,N){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:A?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new g(this,O,A,N,this._onData,($,D)=>this._write($,D))),this._register(this._flowManager.onError($=>{console.error($),(0,k.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,O){this.socket.traceSocketEvent(I,O)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,O){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let A=2;I.byteLength<126?A+=0:I.byteLength<2**16?A+=2:A+=8;const N=_.VSBuffer.alloc(A);if(O?N.writeUInt8(194,0):N.writeUInt8(130,0),I.byteLength<126)N.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){N.writeUInt8(126,1);let $=1;N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}else{N.writeUInt8(127,1);let $=1;N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(I.byteLength>>>24&255,++$),N.writeUInt8(I.byteLength>>>16&255,++$),N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}this.socket.write(_.VSBuffer.concat([N,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const O=this._incomingData.peek(this._state.readLen),A=O.readUInt8(0),N=(A&128)>>>7,$=(A&64)>>>6,D=O.readUInt8(1),M=(D&128)>>>7,W=D&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const O=this._incomingData.read(this._state.readLen),A=O.readUInt8(1),N=(A&128)>>>7;let $=A&127,D=1;$===126?$=O.readUInt8(++D)*2**8+O.readUInt8(++D):$===127&&($=O.readUInt8(++D)*0+O.readUInt8(++D)*0+O.readUInt8(++D)*0+O.readUInt8(++D)*0+O.readUInt8(++D)*2**24+O.readUInt8(++D)*2**16+O.readUInt8(++D)*2**8+O.readUInt8(++D));let M=0;N&&(M=O.readUInt8(++D)*2**24+O.readUInt8(++D)*2**16+O.readUInt8(++D)*2**8+O.readUInt8(++D)),this._state.state=3,this._state.readLen=$,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const O=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),r(O,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(O,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class g extends C.Disposable{constructor(I,O,A,N,$,D){super();this._tracer=I,this._onData=$,this._writeFn=D,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,O?(this._zlibInflateStream=this._register(new l(this._tracer,N,A,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const O=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(O,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,O){return new Promise((A,N)=>{I.write(O),I.flush($=>A($))})}acceptFrame(I,O,A){this._readQueue.push({data:I,isCompressed:O,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const O=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(O)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,O,A){return new Promise((N,$)=>{I.write(O),A&&I.write(_.VSBuffer.fromByteArray([0,0,255,255])),I.flush(D=>N(D))})}}class l extends C.Disposable{constructor(I,O,A,N){super();this._tracer=I,this._recordInflateBytes=O,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=d.createInflateRaw(N),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(_.VSBuffer.wrap($))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const O=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(O)})}}class u extends C.Disposable{constructor(I,O){super();this._tracer=I,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(_.VSBuffer.wrap(A))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let O=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,O=O.slice(0,O.byteLength-4),I(O)})}}function r(m,I){if(I===0)return;let O=m.byteLength>>>2;for(let W=0;W<O;W++){const U=m.readUInt32BE(W*4);m.writeUInt32BE(U^I,W*4)}let A=O*4,N=m.byteLength-A;const $=I>>>24&255,D=I>>>16&255,M=I>>>8&255;N>=1&&m.writeUInt8(m.readUInt8(A)^$,A),N>=2&&m.writeUInt8(m.readUInt8(A+1)^D,A+1),N>=3&&m.writeUInt8(m.readUInt8(A+2)^M,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function i(){const m=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):I=(0,E.join)((0,T.tmpdir)(),`vscode-ipc-${m}.sock`),s(I),I}e.createRandomIPCHandle=i;function t(m,I,O){const A=(0,L.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${O}-${I}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${O}-${I}.sock`):N=(0,E.join)(m,`${O}-${I}.sock`),s(N),N}e.createStaticIPCHandle=t;function s(m){const I=a[P.platform];typeof I=="number"&&m.length>=I&&console.warn(`WARNING: IPC handle "${m}" is longer than ${I} chars, try a shorter --user-data-dir`)}class o extends f.IPCServer{constructor(I){super(o.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const O=R.Event.fromNodeEventEmitter(I,"connection");return R.Event.map(O,A=>({protocol:new S.Protocol(new w(A,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function c(m){return new Promise((I,O)=>{const A=(0,n.createServer)();A.on("error",O),A.listen(m,()=>{A.removeListener("error",O),I(new o(A))})})}e.serve=c;function h(m,I){return new Promise((O,A)=>{const N=(0,n.createConnection)(m,()=>{N.removeListener("error",A),O(S.Client.fromSocket(new w(N,`ipc-client${I}`),I))});N.once("error",A)})}e.connect=h}),define(ne[245],ie([0,1,55,244]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(T,_,k,R,C){const E=b=>C(b,void 0),P=L.createConnection({host:T,port:_},()=>{P.removeListener("error",E);const b=Buffer.alloc(16);for(let w=0;w<16;w++)b[w]=Math.round(Math.random()*256);const f=b.toString("base64"),S=[`GET ws://${/:/.test(T)?`[${T}]`:T}:${_}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];P.write(S.join(`\r
`)+`\r
\r
`);const d=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",d),C(void 0,new n.NodeSocket(P,R)))};P.on("data",d)});P.setNoDelay(!0),P.once("error",E)}}}),define(ne[246],ie([0,1,55,115,245,5,2,20,10,26,185,62,90]),function(J,e,L,n,T,_,k,R,C,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(y,g,l,u,r){let a;for(let i=3;i&&(a&&a.dispose(),a=await new d(y,g,l,u,r).waitForReady(),!(r&&n.BROWSER_RESTRICTED_PORTS[r]||!n.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));i--);return a}class d extends k.Disposable{constructor(g,l,u,r,a){super();this.defaultTunnelHost=l,this.suggestedLocalPort=a,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=L.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(l=>{l()})}async waitForReady(){let g=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),l=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address(),l||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(g){g.pause();const l=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,P.connectRemoteAgentTunnel)(this._options,l,this.tunnelRemotePort),r=u.getSocket().socket,a=u.readEntireBuffer();u.dispose(),a.byteLength>0&&g.write(a.buffer),g.on("end",()=>{this._socketsDispose.delete(g.localAddress),r.end()}),g.on("close",()=>r.end()),g.on("error",()=>{this._socketsDispose.delete(g.localAddress),r.destroy()}),r.on("end",()=>g.end()),r.on("close",()=>g.end()),r.on("error",()=>{g.destroy()}),g.pipe(r),r.pipe(g),this._socketsDispose.set(g.localAddress,()=>{g.end(),r.end()})}}let w=class extends b.AbstractTunnelService{constructor(g,l,u,r,a){super(l);this.socketFactory=g,this.signService=u,this.productService=r,this.configurationService=a}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,l,u,r,a,i,t){const s=this.getTunnelFromMap(l,u);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,l,u,r,a,i,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${l}:${u} on local port ${r}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},c=S(o,this.defaultTunnelHost,l,u,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(l,u,c),c}}};w=de([X(1,C.ILogService),X(2,f.ISignService),X(3,E.IProductService),X(4,R.IConfigurationService)],w),e.BaseTunnelService=w;let p=class extends w{constructor(g,l,u,r){super(T.nodeSocketFactory,g,l,u,r)}};p=de([X(0,C.ILogService),X(1,f.ISignService),X(2,E.IProductService),X(3,R.IConfigurationService)],p),e.TunnelService=p;let v=class extends k.Disposable{constructor(g,l,u,r){super();this.logService=g,this.productService=l,this.signService=u,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(g,l,u,r,a,i,t,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${r} on local port ${a}.`),!this._tunnelServices.has(g)){const o=new p(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(g,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(l,u,r,a,i,t,s)}};v=de([X(0,C.ILogService),X(1,E.IProductService),X(2,f.ISignService),X(3,R.IConfigurationService)],v),e.SharedTunnelsService=v}),define(ne[255],ie([0,1,72,32,37,8,2,18,19,7,36,118,179,160,180,171,172,173,158,162,20,183,78,203,79,193,13,197,199,207,30,161,205,243,80,156,14,176,178,51,6,168,83,169,170,59,189,10,84,60,85,26,192,43,23,201,202,21,91,92,93,44,208,209,94,211,217,96,97,24,63,231,233,234,64,232,236,237,238,239,240,90,198,62,246,190,191,89,196,206,34,219,4,220,165,182,181]),function(J,e,L,n,T,_,k,R,C,E,P,b,f,S,d,w,p,v,y,g,l,u,r,a,i,t,s,o,c,h,m,I,O,A,N,$,D,M,W,U,x,ee,G,q,Y,H,Z,K,F,j,B,z,V,te,se,ce,he,me,ve,ge,ye,Re,Ee,De,_e,Ne,$e,xe,re,ae,ue,be,Ce,Fe,Le,Me,Oe,Q,oe,le,fe,pe,Te,we,Pe,ke,Ie,Ae,ze,je,Be,Rt,Dt,kt,St,Tt,yt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends k.Disposable{constructor(Se){super();this.configuration=Se,this.server=this._register(new b.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const Se=()=>this.dispose();process.once("exit",Se),L.ipcRenderer.once("vscode:electron-main->shared-process=exit",Se);const Ue="vscode:electron-main->shared-process=disposeWorker",qe=(Ye,We)=>this.onDisposeWorker(We);L.ipcRenderer.on(Ue,qe),this._register((0,k.toDisposable)(()=>L.ipcRenderer.removeListener(Ue,qe)))}onDisposeWorker(Se){this.sharedProcessWorkerService?.disposeWorker(Se)}async open(){const Se=await this.initServices();(0,ae.registerConfiguration)(),Se.invokeFunction(Ue=>{const qe=Ue.get(K.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(qe)}),this._register((0,k.combinedDisposable)(Se.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),Se.createInstance(d.LanguagePackCachedDataCleaner),Se.createInstance(v.StorageDataCleaner,this.configuration.backupWorkspacesPath),Se.createInstance(p.LogsDataCleaner),Se.createInstance(w.LocalizationsUpdater),Se.createInstance(S.ExtensionsCleaner)))}async initServices(){const Se=new G.ServiceCollection,Ue={_serviceBrand:void 0,...B.default};Se.set(z.IProductService,Ue);const qe=new P.StaticRouter(Ge=>Ge==="main"),Ye=new q.MessagePortMainProcessService(this.server,qe);Se.set(Y.IMainProcessService,Ye);const We=new o.SharedProcessEnvironmentService(this.configuration.args,Ue);Se.set(s.INativeEnvironmentService,We);const rt=new F.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Qe=new F.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Ye.getChannel("logger"));Se.set(K.ILoggerService,Qe);const at=this._register(new K.MultiplexLogService([this._register(new K.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,C.joinPath)(E.URI.file(We.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new F.FollowerLogService(rt,at));Se.set(K.ILogService,Je),this.sharedProcessWorkerService=new ze.SharedProcessWorkerService(Je,Ue,We),Se.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ve=this._register(new M.FileService(Je));Se.set(D.IFileService,Ve);const ct=this._register(new W.DiskFileSystemProvider(Je));Ve.registerProvider(R.Schemas.file,ct);const lt=this._register(new kt.FileUserDataProvider(R.Schemas.file,this._register(new St.DiskFileSystemProviderClient(Ye.getChannel(St.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Dt.isLinux})),R.Schemas.userData,Ve,Je));Ve.registerProvider(R.Schemas.userData,lt);const He=this._register(new u.ConfigurationService(We.settingsResource,Ve));Se.set(l.IConfigurationService,He);const tt=new ce.NativeStorageService(void 0,Ye,We);Se.set(se.IStorageService,tt),this._register((0,k.toDisposable)(()=>tt.flush())),await Promise.all([He.initialize(),tt.initialize()]),Se.set(Be.IUriIdentityService,new Rt.UriIdentityService(Ve)),Se.set(te.IRequestService,new U.SyncDescriptor(V.RequestService)),Se.set(y.IChecksumService,new U.SyncDescriptor(g.ChecksumService)),Se.set(yt.IV8InspectProfilingService,new U.SyncDescriptor(Tt.InspectProfilingService));const st=P.ProxyChannel.toService(Ye.getChannel("nativeHost"),{context:this.configuration.windowId});Se.set(j.INativeHostService,st),Se.set(i.IDownloadService,new U.SyncDescriptor(t.DownloadService));const ut=this._register(new fe.ActiveWindowManager(st)),ht=new P.StaticRouter(Ge=>ut.getActiveClientId().then(ft=>Ge===ft));Se.set(N.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));const dt=new je.AssignmentService(this.configuration.machineId,He,Ue);let nt;const Ze=[];if((0,Re.supportsTelemetry)(Ue,We)){const Ge=new ge.TelemetryLogAppender(Qe,We);Ze.push(Ge);const{appRoot:ft,extensionsPath:Ot,installSourcePath:Mt}=We;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const ot=await dt.getTreatment("telemetryMigration")??!1,gt=Ue.quality!=="stable";if(gt&&ot){const Ct=new Ee.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,ot,!0);this._register((0,k.toDisposable)(()=>Ct.flush())),Ze.push(Ct)}const bt=new Ee.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,gt?!1:ot,ot&&gt);this._register((0,k.toDisposable)(()=>bt.flush())),Ze.push(bt)}nt=new ye.TelemetryService({appenders:Ze,commonProperties:(0,he.resolveCommonProperties)(Ve,(0,n.release)(),(0,n.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,Mt),sendErrorTelemetry:!0,piiPaths:[ft,Ot]},He)}else{nt=Re.NullTelemetryService;const Ge=Re.NullAppender;Ze.push(Ge)}this.server.registerChannel("telemetryAppender",new ve.TelemetryAppenderChannel(Ze)),Se.set(me.ITelemetryService,nt);const At=new De.CustomEndpointTelemetryService(He,nt,Qe,We);Se.set(me.ICustomEndpointTelemetryService,At),Se.set(m.IExtensionManagementService,new U.SyncDescriptor(A.ExtensionManagementService)),Se.set(m.IExtensionGalleryService,new U.SyncDescriptor(h.ExtensionGalleryService)),Se.set(m.IExtensionTipsService,new U.SyncDescriptor(O.ExtensionTipsService)),Se.set(H.ILocalizationsService,new U.SyncDescriptor(Z.LocalizationsService)),Se.set(r.IDiagnosticsService,new U.SyncDescriptor(a.DiagnosticsService)),Se.set(ue.IUserDataSyncAccountService,new U.SyncDescriptor(ue.UserDataSyncAccountService)),Se.set(ae.IUserDataSyncLogService,new U.SyncDescriptor(Fe.UserDataSyncLogService)),Se.set(ae.IUserDataSyncUtilService,new Ce.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),Se.set(m.IGlobalExtensionEnablementService,new U.SyncDescriptor(c.GlobalExtensionEnablementService)),Se.set(re.IIgnoredExtensionsManagementService,new U.SyncDescriptor(re.IgnoredExtensionsManagementService)),Se.set(xe.IExtensionsStorageSyncService,new U.SyncDescriptor(xe.ExtensionsStorageSyncService)),Se.set(ae.IUserDataSyncStoreManagementService,new U.SyncDescriptor(oe.UserDataSyncStoreManagementService)),Se.set(ae.IUserDataSyncStoreService,new U.SyncDescriptor(oe.UserDataSyncStoreService)),Se.set(Le.IUserDataSyncMachinesService,new U.SyncDescriptor(Le.UserDataSyncMachinesService)),Se.set(ae.IUserDataSyncBackupStoreService,new U.SyncDescriptor(be.UserDataSyncBackupStoreService)),Se.set(ae.IUserDataSyncEnablementService,new U.SyncDescriptor(Me.UserDataSyncEnablementService)),Se.set(ae.IUserDataSyncService,new U.SyncDescriptor(Oe.UserDataSyncService));const Et=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:He.getValue("terminal.integrated.persistentSessionScrollback")??100},He,We,Je,nt);return await Et.initialize(),Se.set(Ne.ILocalPtyService,this._register(Et)),Se.set(pe.ISignService,new U.SyncDescriptor(Te.SignService)),Se.set(we.ISharedTunnelsService,new U.SyncDescriptor(Pe.SharedTunnelsService)),Se.set(ke.ISharedProcessTunnelService,new U.SyncDescriptor(Ie.SharedProcessTunnelService)),new ee.InstantiationService(Se)}initChannels(Se){const Ue=new I.ExtensionManagementChannel(Se.get(m.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const qe=P.ProxyChannel.fromService(Se.get(H.ILocalizationsService));this.server.registerChannel("localizations",qe);const Ye=P.ProxyChannel.fromService(Se.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ye);const We=new I.ExtensionTipsChannel(Se.get(m.IExtensionTipsService));this.server.registerChannel("extensionTipsService",We);const rt=P.ProxyChannel.fromService(Se.get(y.IChecksumService));this.server.registerChannel("checksum",rt);const Qe=P.ProxyChannel.fromService(Se.get(yt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Qe);const at=new Ce.UserDataSyncMachinesServiceChannel(Se.get(Le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",at);const Je=P.ProxyChannel.fromService(Se.get(me.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Je);const Ve=new Ce.UserDataSyncAccountServiceChannel(Se.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const ct=new Ce.UserDataSyncStoreManagementServiceChannel(Se.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",ct);const lt=new Q.UserDataSyncChannel(Se.get(ae.IUserDataSyncService),Se.get(K.ILogService));this.server.registerChannel("userDataSync",lt);const He=this._register(Se.get(x.IInstantiationService).createInstance(le.UserDataAutoSyncService)),tt=new Ce.UserDataAutoSyncChannel(He);this.server.registerChannel("userDataAutoSync",tt);const st=Se.get(Ne.ILocalPtyService),ut=P.ProxyChannel.fromService(st);this.server.registerChannel(_e.TerminalIpcChannels.LocalPty,ut);const ht=P.ProxyChannel.fromService(Se.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ht);const dt=P.ProxyChannel.fromService(Se.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,dt)}registerErrorHandler(Se){window.addEventListener("unhandledrejection",Ue=>{(0,_.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,_.setUnexpectedErrorHandler)(Ue=>{const qe=(0,T.toErrorMessage)(Ue,!0);!qe||Se.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function _t(wt){const Se=new Lt(wt);L.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await Se.open(),L.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=_t})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f0054e049cd286ff317c738efe0fd8810b48ae98/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
