/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/errors","vs/base/common/resources","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/base/node/pfs","vs/base/common/strings","os","vs/base/common/extpath","fs","vs/platform/telemetry/common/telemetry","vs/platform/workspaces/common/workspaces","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/labels","vs/base/common/process","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/json","child_process","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/objects","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","crypto","net","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/remote/common/tunnel","vs/platform/url/common/url","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],ie=function(K){for(var e=[],v=0,n=K.length;v<n;v++)e[v]=te[K[v]];return e};define(te[102],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(n,D){if(!n)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=v}),define(te[103],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function v(k){return k?k.replace(/\$\((.*?)\)/g,(P,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=v;class n{constructor(P,f,m){this.id=P,this.definition=f,this.description=m,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function D(k,P){const f=["codicon","codicon-"+k];return P&&f.push("codicon-modifier-"+P),f}e.getClassNamesArray=D;var C;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function f(I){if(I instanceof n)return["codicon","codicon-"+I.id];const p=P.exec(I.id);if(!p)return f(n.error);let[,y,t]=p;const g=["codicon","codicon-"+y];return t&&g.push("codicon-modifier-"+t.substr(1)),g}k.asClassNameArray=f;function m(I){return f(I).join(" ")}k.asClassName=m;function b(I){return"."+f(I).join(".")}k.asCSSSelector=b})(C=e.CSSIcon||(e.CSSIcon={}))}),define(te[46],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(k){return(P,f,m)=>{let b=null,I=null;if(typeof m.value=="function"?(b="value",I=m.value):typeof m.get=="function"&&(b="get",I=m.get),!I)throw new Error("not supported");m[b]=k(I,f)}}e.createDecorator=v;function n(k,P,f){let m=null,b=null;if(typeof f.value=="function"?(m="value",b=f.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(m="get",b=f.get),!b)throw new Error("not supported");const I=`$memoize$${P}`;f[m]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,p)}),this[I]}}e.memoize=n;function D(k,P,f){return v((m,b)=>{const I=`$debounce$${b}`,p=`$debounce$result$${b}`;return function(...y){this[p]||(this[p]=f?f():void 0),clearTimeout(this[I]),P&&(this[p]=P(this[p],...y),y=[this[p]]),this[I]=setTimeout(()=>{m.apply(this,y),this[p]=f?f():void 0},k)}})}e.debounce=D;function C(k,P,f){return v((m,b)=>{const I=`$throttle$timer$${b}`,p=`$throttle$result$${b}`,y=`$throttle$lastRun$${b}`,t=`$throttle$pending$${b}`;return function(...g){if(this[p]||(this[p]=f?f():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...g)),this[t])return;const S=this[y]+k;S<=Date.now()?(this[y]=Date.now(),m.apply(this,[this[p]]),this[p]=f?f():void 0):(this[t]=!0,this[I]=setTimeout(()=>{this[t]=!1,this[y]=Date.now(),m.apply(this,[this[p]]),this[p]=f?f():void 0},S-Date.now()))}})}e.throttle=C}),define(te[15],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(h=>{h(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=v,e.errorHandler=new v;function n(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=n;function D(l){f(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function C(l){f(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=C;function k(l){if(l instanceof Error){let{name:o,message:h}=l;const r=l.stacktrace||l.stack;return{$isError:!0,name:o,message:h,stack:r}}return l}e.transformErrorForSerialization=k;const P="Canceled";function f(l){return l instanceof Error&&l.name===P&&l.message===P}e.isPromiseCanceledError=f;class m extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=m;function b(){const l=new Error(P);return l.name=l.message,l}e.canceled=b;function I(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=I;function p(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=p;function y(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function t(l){const o=new Error(`${l} has been disposed`);return o.name="DISPOSED",o}e.disposed=t;function g(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=g;class S extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=S;class w extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=w;class M extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=M;function c(l){const o=l;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=c;function a(l,o=Object.create(null)){const h=new Error(l);return o.actions&&(h.actions=o.actions),h}e.createErrorWithActions=a}),define(te[31],ie([0,1,15]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(A,_=0){return A[A.length-(1+_)]}e.tail=n;function D(A){if(A.length===0)throw new Error("Invalid tail call");return[A.slice(0,A.length-1),A[A.length-1]]}e.tail2=D;function C(A,_,U=(O,B)=>O===B){if(A===_)return!0;if(!A||!_||A.length!==_.length)return!1;for(let O=0,B=A.length;O<B;O++)if(!U(A[O],_[O]))return!1;return!0}e.equals=C;function k(A,_,U){let O=0,B=A.length-1;for(;O<=B;){const J=(O+B)/2|0,ee=U(A[J],_);if(ee<0)O=J+1;else if(ee>0)B=J-1;else return J}return-(O+1)}e.binarySearch=k;function P(A,_){let U=0,O=A.length;if(O===0)return 0;for(;U<O;){const B=Math.floor((U+O)/2);_(A[B])?O=B:U=B+1}return U}e.findFirstInSorted=P;function f(A,_,U){if(A=A|0,A>=_.length)throw new TypeError("invalid index");let O=_[Math.floor(_.length*Math.random())],B=[],J=[],ee=[];for(let oe of _){const x=U(oe,O);x<0?B.push(oe):x>0?J.push(oe):ee.push(oe)}return A<B.length?f(A,B,U):A<B.length+ee.length?ee[0]:f(A-(B.length+ee.length),J,U)}e.quickSelect=f;function m(A,_){const U=[];let O;for(const B of A.slice(0).sort(_))!O||_(O[0],B)!==0?(O=[B],U.push(O)):O.push(B);return U}e.groupBy=m;function b(A,_,U){const O=[];function B(oe,x,ce){if(x===0&&ce.length===0)return;const le=O[O.length-1];le&&le.start+le.deleteCount===oe?(le.deleteCount+=x,le.toInsert.push(...ce)):O.push({start:oe,deleteCount:x,toInsert:ce})}let J=0,ee=0;for(;;){if(J===A.length){B(J,0,_.slice(ee));break}if(ee===_.length){B(J,A.length-J,[]);break}const oe=A[J],x=_[ee],ce=U(oe,x);ce===0?(J+=1,ee+=1):ce<0?(B(J,1,[]),J+=1):ce>0&&(B(J,0,[x]),ee+=1)}return O}e.sortedDiff=b;function I(A,_,U){const O=b(A,_,U),B=[],J=[];for(const ee of O)B.push(...A.slice(ee.start,ee.start+ee.deleteCount)),J.push(...ee.toInsert);return{removed:B,added:J}}e.delta=I;function p(A,_,U){if(U===0)return[];const O=A.slice(0,U).sort(_);return t(A,_,O,U,A.length),O}e.top=p;function y(A,_,U,O,B){return U===0?Promise.resolve([]):new Promise((J,ee)=>{(async()=>{const oe=A.length,x=A.slice(0,U).sort(_);for(let ce=U,le=Math.min(U+O,oe);ce<oe;ce=le,le=Math.min(le+O,oe)){if(ce>U&&await new Promise(ue=>setTimeout(ue)),B&&B.isCancellationRequested)throw(0,v.canceled)();t(A,_,x,ce,le)}return x})().then(J,ee)})}e.topAsync=y;function t(A,_,U,O,B){for(const J=U.length;O<B;O++){const ee=A[O];if(_(ee,U[J-1])<0){U.pop();const oe=P(U,x=>_(ee,x)<0);U.splice(oe,0,ee)}}}function g(A){return A.filter(_=>!!_)}e.coalesce=g;function S(A){let _=0;for(let U=0;U<A.length;U++)A[U]&&(A[_]=A[U],_+=1);A.length=_}e.coalesceInPlace=S;function w(A,_,U){A.splice(U,0,A.splice(_,1)[0])}e.move=w;function M(A){return!Array.isArray(A)||A.length===0}e.isFalsyOrEmpty=M;function c(A){return Array.isArray(A)&&A.length>0}e.isNonEmptyArray=c;function a(A,_=U=>U){const U=new Set;return A.filter(O=>{const B=_(O);return U.has(B)?!1:(U.add(B),!0)})}e.distinct=a;function l(A){const _=Object.create(null);return U=>{const O=A(U);return _[O]?!1:(_[O]=!0,!0)}}e.uniqueFilter=l;function o(A,_){const U=h(A,_);if(U!==-1)return A[U]}e.findLast=o;function h(A,_){for(let U=A.length-1;U>=0;U--){const O=A[U];if(_(O))return U}return-1}e.lastIndex=h;function r(A,_){return A.length>0?A[0]:_}e.firstOrDefault=r;function i(A,_,U=(O,B)=>O===B){let O=0;for(let B=0,J=Math.min(A.length,_.length);B<J&&U(A[B],_[B]);B++)O++;return O}e.commonPrefixLength=i;function s(A){return[].concat(...A)}e.flatten=s;function u(A,_){let U=typeof _=="number"?A:0;typeof _=="number"?U=A:(U=0,_=A);const O=[];if(U<=_)for(let B=U;B<_;B++)O.push(B);else for(let B=U;B>_;B--)O.push(B);return O}e.range=u;function d(A,_,U){return A.reduce((O,B)=>(O[_(B)]=U?U(B):B,O),Object.create(null))}e.index=d;function E(A,_){return A.push(_),()=>L(A,_)}e.insert=E;function L(A,_){const U=A.indexOf(_);if(U>-1)return A.splice(U,1),_}e.remove=L;function R(A,_,U){const O=A.slice(0,_),B=A.slice(_);return O.concat(U,B)}e.arrayInsert=R;function T(A,_){let U;if(typeof _=="number"){let O=_;U=()=>{const B=Math.sin(O++)*179426549;return B-Math.floor(B)}}else U=Math.random;for(let O=A.length-1;O>0;O-=1){const B=Math.floor(U()*(O+1)),J=A[O];A[O]=A[B],A[B]=J}}e.shuffle=T;function N(A,_){const U=A.indexOf(_);U>-1&&(A.splice(U,1),A.unshift(_))}e.pushToStart=N;function Q(A,_){const U=A.indexOf(_);U>-1&&(A.splice(U,1),A.push(_))}e.pushToEnd=Q;function se(A,_){return Array.isArray(A)?A.map(_):_(A)}e.mapArrayOrNot=se;function ne(A){return Array.isArray(A)?A:[A]}e.asArray=ne;function V(A){return A[Math.floor(Math.random()*A.length)]}e.getRandomElement=V;function Z(A,_){for(const U of A){const O=_(U);if(O!==void 0)return O}}e.mapFind=Z;function H(A,_,U){const O=Y(A,_),B=A.length,J=U.length;A.length=B+J;for(let ee=B-1;ee>=O;ee--)A[ee+J]=A[ee];for(let ee=0;ee<J;ee++)A[ee+O]=U[ee]}e.insertInto=H;function q(A,_,U,O){const B=Y(A,_),J=A.splice(B,U);return H(A,B,O),J}e.splice=q;function Y(A,_){return _<0?Math.max(_+A.length,0):Math.min(_,A.length)}function j(A,_){return(U,O)=>_(A(U),A(O))}e.compareBy=j;const z=(A,_)=>A-_;e.numberComparator=z;function G(A,_){if(A.length===0)return;let U=A[0];for(let O=1;O<A.length;O++){const B=A[O];_(B,U)>0&&(U=B)}return U}e.findMaxBy=G;function $(A,_){if(A.length===0)return;let U=A[0];for(let O=1;O<A.length;O++){const B=A[O];_(B,U)>=0&&(U=B)}return U}e.findLastMaxBy=$;function F(A,_){return G(A,(U,O)=>-_(U,O))}e.findMinBy=F;class W{constructor(_){this.items=_,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(_){let U=this.firstIdx;for(;U<this.items.length&&_(this.items[U]);)U++;const O=U===this.firstIdx?null:this.items.slice(this.firstIdx,U);return this.firstIdx=U,O}takeFromEndWhile(_){let U=this.lastIdx;for(;U>=0&&_(this.items[U]);)U--;const O=U===this.lastIdx?null:this.items.slice(U+1,this.lastIdx+1);return this.lastIdx=U,O}peek(){return this.items[this.firstIdx]}dequeue(){const _=this.items[this.firstIdx];return this.firstIdx++,_}takeCount(_){const U=this.items.slice(this.firstIdx,this.firstIdx+_);return this.firstIdx+=_,U}}e.ArrayQueue=W}),define(te[42],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(n){const D=this;let C=!1,k;return function(){return C||(C=!0,k=n.apply(D,arguments)),k}}e.once=v}),define(te[69],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(n){function D(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}n.is=D;const C=Object.freeze([]);function k(){return C}n.empty=k;function*P(l){yield l}n.single=P;function f(l){return l||C}n.from=f;function m(l){return!l||l[Symbol.iterator]().next().done===!0}n.isEmpty=m;function b(l){return l[Symbol.iterator]().next().value}n.first=b;function I(l,o){for(const h of l)if(o(h))return!0;return!1}n.some=I;function p(l,o){for(const h of l)if(o(h))return h}n.find=p;function*y(l,o){for(const h of l)o(h)&&(yield h)}n.filter=y;function*t(l,o){let h=0;for(const r of l)yield o(r,h++)}n.map=t;function*g(...l){for(const o of l)for(const h of o)yield h}n.concat=g;function*S(l){for(const o of l)for(const h of o)yield h}n.concatNested=S;function w(l,o,h){let r=h;for(const i of l)r=o(r,i);return r}n.reduce=w;function*M(l,o,h=l.length){for(o<0&&(o+=l.length),h<0?h+=l.length:h>l.length&&(h=l.length);o<h;o++)yield l[o]}n.slice=M;function c(l,o=Number.POSITIVE_INFINITY){const h=[];if(o===0)return[h,l];const r=l[Symbol.iterator]();for(let i=0;i<o;i++){const s=r.next();if(s.done)return[h,n.empty()];h.push(s.value)}return[h,{[Symbol.iterator](){return r}}]}n.consume=c;function a(l,o,h=(r,i)=>r===i){const r=l[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const s=r.next(),u=i.next();if(s.done!==u.done)return!1;if(s.done)return!0;if(!h(s.value,u.value))return!1}}n.equals=a})(v=e.Iterable||(e.Iterable={}))}),define(te[43],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var n;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(o){o.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function k(o,h=!1){let r=0,i=o.length,s="",u=0,d=16,E=0;function L(V){let Z=0,H=0;for(;Z<V;){const q=o.charCodeAt(r);if(q>=48&&q<=57)H=H*16+q-48;else if(q>=65&&q<=70)H=H*16+q-65+10;else if(q>=97&&q<=102)H=H*16+q-97+10;else break;r++,Z++}return Z<V&&(H=-1),H}function R(V){r=V,s="",u=0,d=16,E=0}function T(){const V=r;if(o.charCodeAt(r)===48)r++;else for(r++;r<o.length&&m(o.charCodeAt(r));)r++;if(r<o.length&&o.charCodeAt(r)===46)if(r++,r<o.length&&m(o.charCodeAt(r)))for(r++;r<o.length&&m(o.charCodeAt(r));)r++;else return E=3,o.substring(V,r);let Z=r;if(r<o.length&&(o.charCodeAt(r)===69||o.charCodeAt(r)===101))if(r++,(r<o.length&&o.charCodeAt(r)===43||o.charCodeAt(r)===45)&&r++,r<o.length&&m(o.charCodeAt(r))){for(r++;r<o.length&&m(o.charCodeAt(r));)r++;Z=r}else E=3;return o.substring(V,Z)}function N(){let V="",Z=r;for(;;){if(r>=i){V+=o.substring(Z,r),E=2;break}const H=o.charCodeAt(r);if(H===34){V+=o.substring(Z,r),r++;break}if(H===92){if(V+=o.substring(Z,r),r++,r>=i){E=2;break}switch(o.charCodeAt(r++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const Y=L(4);Y>=0?V+=String.fromCharCode(Y):E=4;break}default:E=5}Z=r;continue}if(H>=0&&H<=31)if(f(H)){V+=o.substring(Z,r),E=2;break}else E=6;r++}return V}function Q(){if(s="",E=0,u=r,r>=i)return u=i,d=17;let V=o.charCodeAt(r);if(P(V)){do r++,s+=String.fromCharCode(V),V=o.charCodeAt(r);while(P(V));return d=15}if(f(V))return r++,s+=String.fromCharCode(V),V===13&&o.charCodeAt(r)===10&&(r++,s+=`
`),d=14;switch(V){case 123:return r++,d=1;case 125:return r++,d=2;case 91:return r++,d=3;case 93:return r++,d=4;case 58:return r++,d=6;case 44:return r++,d=5;case 34:return r++,s=N(),d=10;case 47:{const Z=r-1;if(o.charCodeAt(r+1)===47){for(r+=2;r<i&&!f(o.charCodeAt(r));)r++;return s=o.substring(Z,r),d=12}if(o.charCodeAt(r+1)===42){r+=2;const H=i-1;let q=!1;for(;r<H;){if(o.charCodeAt(r)===42&&o.charCodeAt(r+1)===47){r+=2,q=!0;break}r++}return q||(r++,E=1),s=o.substring(Z,r),d=13}return s+=String.fromCharCode(V),r++,d=16}case 45:if(s+=String.fromCharCode(V),r++,r===i||!m(o.charCodeAt(r)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=T(),d=11;default:for(;r<i&&se(V);)r++,V=o.charCodeAt(r);if(u!==r){switch(s=o.substring(u,r),s){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return s+=String.fromCharCode(V),r++,d=16}}function se(V){if(P(V)||f(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let V;do V=Q();while(V>=12&&V<=15);return V}return{setPosition:R,getPosition:()=>r,scan:h?ne:Q,getToken:()=>d,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>r-u,getTokenError:()=>E}}e.createScanner=k;function P(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function f(o){return o===10||o===13||o===8232||o===8233}function m(o){return o>=48&&o<=57}var b;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(b||(b={}));function I(o,h){const r=[],i=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function E(L,R,T,N){u.value=L,u.offset=R,u.length=T,u.type=N,u.colonOffset=void 0,s=u}try{c(o,{onObjectBegin:(L,R)=>{if(h<=L)throw i;s=void 0,d=h>L,r.push("")},onObjectProperty:(L,R,T)=>{if(h<R||(E(L,R,T,"property"),r[r.length-1]=L,h<=R+T))throw i},onObjectEnd:(L,R)=>{if(h<=L)throw i;s=void 0,r.pop()},onArrayBegin:(L,R)=>{if(h<=L)throw i;s=void 0,r.push(0)},onArrayEnd:(L,R)=>{if(h<=L)throw i;s=void 0,r.pop()},onLiteralValue:(L,R,T)=>{if(h<R||(E(L,R,T,l(L)),h<=R+T))throw i},onSeparator:(L,R,T)=>{if(h<=R)throw i;if(L===":"&&s&&s.type==="property")s.colonOffset=R,d=!1,s=void 0;else if(L===","){const N=r[r.length-1];typeof N=="number"?r[r.length-1]=N+1:(d=!0,r[r.length-1]=""),s=void 0}}})}catch(L){if(L!==i)throw L}return{path:r,previousNode:s,isAtPropertyKey:d,matches:L=>{let R=0;for(let T=0;R<L.length&&T<r.length;T++)if(L[R]===r[T]||L[R]==="*")R++;else if(L[R]!=="**")return!1;return R===L.length}}}e.getLocation=I;function p(o,h=[],r=C.DEFAULT){let i=null,s=[];const u=[];function d(L){Array.isArray(s)?s.push(L):i!==null&&(s[i]=L)}return c(o,{onObjectBegin:()=>{const L={};d(L),u.push(s),s=L,i=null},onObjectProperty:L=>{i=L},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const L=[];d(L),u.push(s),s=L,i=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:d,onError:(L,R,T)=>{h.push({error:L,offset:R,length:T})}},r),s[0]}e.parse=p;function y(o,h=[],r=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(L){i.type==="property"&&(i.length=L-i.offset,i=i.parent)}function u(L){return i.children.push(L),L}c(o,{onObjectBegin:L=>{i=u({type:"object",offset:L,length:-1,parent:i,children:[]})},onObjectProperty:(L,R,T)=>{i=u({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:L,offset:R,length:T,parent:i})},onObjectEnd:(L,R)=>{i.length=L+R-i.offset,i=i.parent,s(L+R)},onArrayBegin:(L,R)=>{i=u({type:"array",offset:L,length:-1,parent:i,children:[]})},onArrayEnd:(L,R)=>{i.length=L+R-i.offset,i=i.parent,s(L+R)},onLiteralValue:(L,R,T)=>{u({type:l(L),offset:R,length:T,parent:i,value:L}),s(R+T)},onSeparator:(L,R,T)=>{i.type==="property"&&(L===":"?i.colonOffset=R:L===","&&s(R))},onError:(L,R,T)=>{h.push({error:L,offset:R,length:T})}},r);const E=i.children[0];return E&&delete E.parent,E}e.parseTree=y;function t(o,h){if(!o)return;let r=o;for(let i of h)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const u of r.children)if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=t;function g(o){if(!o.parent||!o.parent.children)return[];const h=g(o.parent);if(o.parent.type==="property"){const r=o.parent.children[0].value;h.push(r)}else if(o.parent.type==="array"){const r=o.parent.children.indexOf(o);r!==-1&&h.push(r)}return h}e.getNodePath=g;function S(o){switch(o.type){case"array":return o.children.map(S);case"object":{const h=Object.create(null);for(let r of o.children){const i=r.children[1];i&&(h[r.children[0].value]=S(i))}return h}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=S;function w(o,h,r=!1){return h>=o.offset&&h<o.offset+o.length||r&&h===o.offset+o.length}e.contains=w;function M(o,h,r=!1){if(w(o,h,r)){const i=o.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=h;s++){const u=M(i[s],h,r);if(u)return u}return o}}e.findNodeAtOffset=M;function c(o,h,r=C.DEFAULT){const i=k(o,!1);function s(W){return W?()=>W(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(W){return W?A=>W(A,i.getTokenOffset(),i.getTokenLength()):()=>!0}const d=s(h.onObjectBegin),E=u(h.onObjectProperty),L=s(h.onObjectEnd),R=s(h.onArrayBegin),T=s(h.onArrayEnd),N=u(h.onLiteralValue),Q=u(h.onSeparator),se=s(h.onComment),ne=u(h.onError),V=r&&r.disallowComments,Z=r&&r.allowTrailingComma;function H(){for(;;){const W=i.scan();switch(i.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:V||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(W){case 12:case 13:V?q(10):se();break;case 16:q(1);break;case 15:case 14:break;default:return W}}}function q(W,A=[],_=[]){if(ne(W),A.length+_.length>0){let U=i.getToken();for(;U!==17;){if(A.indexOf(U)!==-1){H();break}else if(_.indexOf(U)!==-1)break;U=H()}}}function Y(W){const A=i.getTokenValue();return W?N(A):E(A),H(),!0}function j(){switch(i.getToken()){case 11:{let W=0;try{W=JSON.parse(i.getTokenValue()),typeof W!="number"&&(q(2),W=0)}catch{q(2)}N(W);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return H(),!0}function z(){return i.getToken()!==10?(q(3,[],[2,5]),!1):(Y(!1),i.getToken()===6?(Q(":"),H(),F()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function G(){d(),H();let W=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(W||q(4,[],[]),Q(","),H(),i.getToken()===2&&Z)break}else W&&q(6,[],[]);z()||q(4,[],[2,5]),W=!0}return L(),i.getToken()!==2?q(7,[2],[]):H(),!0}function $(){R(),H();let W=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(W||q(4,[],[]),Q(","),H(),i.getToken()===4&&Z)break}else W&&q(6,[],[]);F()||q(4,[],[4,5]),W=!0}return T(),i.getToken()!==4?q(8,[4],[]):H(),!0}function F(){switch(i.getToken()){case 3:return $();case 1:return G();case 10:return Y(!0);default:return j()}}return H(),i.getToken()===17?r.allowEmptyContent?!0:(q(4,[],[]),!1):F()?(i.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=c;function a(o,h){let r=k(o),i=[],s,u=0,d;do switch(d=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:u!==d&&i.push(o.substring(u,d)),h!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,h)),u=r.getPosition();break}while(s!==17);return i.join("")}e.stripComments=a;function l(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[104],ie([0,1,43]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(m,b,I){let p,y,t,g,S;if(b){for(g=b.offset,S=g+b.length,t=g;t>0&&!f(m,t-1);)t--;let d=S;for(;d<m.length&&!f(m,d);)d++;y=m.substring(t,d),p=k(y,I)}else y=m,p=0,t=0,g=0,S=m.length;const w=P(I,m);let M=!1,c=0,a;I.insertSpaces?a=C(" ",I.tabSize||4):a="	";const l=(0,v.createScanner)(y,!1);let o=!1;function h(){return w+C(a,p+c)}function r(){let d=l.scan();for(M=!1;d===15||d===14;)M=M||d===14,d=l.scan();return o=d===16||l.getTokenError()!==0,d}const i=[];function s(d,E,L){!o&&E<S&&L>g&&m.substring(E,L)!==d&&i.push({offset:E,length:L-E,content:d})}let u=r();if(u!==17){const d=l.getTokenOffset()+t,E=C(a,p);s(E,t,d)}for(;u!==17;){let d=l.getTokenOffset()+l.getTokenLength()+t,E=r(),L="";for(;!M&&(E===12||E===13);){const T=l.getTokenOffset()+t;s(" ",d,T),d=l.getTokenOffset()+l.getTokenLength()+t,L=E===12?h():"",E=r()}if(E===2)u!==1&&(c--,L=h());else if(E===4)u!==3&&(c--,L=h());else{switch(u){case 3:case 1:c++,L=h();break;case 5:case 12:L=h();break;case 13:M?L=h():L=" ";break;case 6:L=" ";break;case 10:if(E===6){L="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?L=" ":E!==5&&E!==17&&(o=!0);break;case 16:o=!0;break}M&&(E===12||E===13)&&(L=h())}const R=l.getTokenOffset()+t;s(L,d,R),u=E}return i}e.format=n;function D(m,b){const I=JSON.stringify(m,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?I.replace(/\r\n|\r|\n/g,b.eol):I}e.toFormattedString=D;function C(m,b){let I="";for(let p=0;p<b;p++)I+=m;return I}function k(m,b){let I=0,p=0;const y=b.tabSize||4;for(;I<m.length;){const t=m.charAt(I);if(t===" ")p++;else if(t==="	")p+=y;else break;I++}return Math.floor(p/y)}function P(m,b){for(let I=0;I<b.length;I++){const p=b.charAt(I);if(p==="\r")return I+1<b.length&&b.charAt(I+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=P;function f(m,b){return`\r
`.indexOf(m.charAt(b))!==-1}e.isEOL=f}),define(te[105],ie([0,1,43,104]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(m,b,I){return C(m,b,void 0,I)}e.removeProperty=D;function C(m,b,I,p,y){const t=b.slice(),g=[],S=(0,v.parseTree)(m,g);let w,M;for(;t.length>0&&(M=t.pop(),w=(0,v.findNodeAtLocation)(S,t),w===void 0&&I!==void 0);)typeof M=="string"?I={[M]:I}:I=[I];if(w)if(w.type==="object"&&typeof M=="string"&&Array.isArray(w.children)){const c=(0,v.findNodeAtLocation)(w,[M]);if(c!==void 0)if(I===void 0){if(!c.parent)throw new Error("Malformed AST");const a=w.children.indexOf(c.parent);let l,o=c.parent.offset+c.parent.length;if(a>0){const h=w.children[a-1];l=h.offset+h.length}else l=w.offset+1,w.children.length>1&&(o=w.children[1].offset);return k(m,{offset:l,length:o-l,content:""},p)}else return k(m,{offset:c.offset,length:c.length,content:JSON.stringify(I)},p);else{if(I===void 0)return[];const a=`${JSON.stringify(M)}: ${JSON.stringify(I)}`,l=y?y(w.children.map(h=>h.children[0].value)):w.children.length;let o;if(l>0){const h=w.children[l-1];o={offset:h.offset+h.length,length:0,content:","+a}}else w.children.length===0?o={offset:w.offset+1,length:0,content:a}:o={offset:w.offset+1,length:0,content:a+","};return k(m,o,p)}}else if(w.type==="array"&&typeof M=="number"&&Array.isArray(w.children))if(I!==void 0){const c=`${JSON.stringify(I)}`;let a;if(w.children.length===0||M===0)a={offset:w.offset+1,length:0,content:w.children.length===0?c:c+","};else{const l=M===-1||M>w.children.length?w.children.length:M,o=w.children[l-1];a={offset:o.offset+o.length,length:0,content:","+c}}return k(m,a,p)}else{const c=M,a=w.children[c];let l;if(w.children.length===1)l={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===c){const o=w.children[c-1],h=o.offset+o.length,r=w.offset+w.length;l={offset:h,length:r-2-h,content:""}}else l={offset:a.offset,length:w.children[c+1].offset-a.offset,content:""};return k(m,l,p)}else throw new Error(`Can not add ${typeof M!="number"?"index":"property"} to parent of type ${w.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return k(m,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(I)},p)}}e.setProperty=C;function k(m,b,I){let p=P(m,b),y=b.offset,t=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;y>0&&!(0,n.isEOL)(p,y-1);)y--;for(;t<p.length&&!(0,n.isEOL)(p,t);)t++}const g=(0,n.format)(p,{offset:y,length:t-y},I);for(let w=g.length-1;w>=0;w--){const M=g[w];p=P(p,M),y=Math.min(y,M.offset),t=Math.max(t,M.offset+M.length),t+=M.content.length-M.length}const S=m.length-(p.length-t)-y;return[{offset:y,length:S,content:p.substring(y,t)}]}e.withFormatting=k;function P(m,b){return m.substring(0,b.offset)+b.content+m.substring(b.offset+b.length)}e.applyEdit=P;function f(m,b){let I=b.slice(0).sort((y,t)=>{const g=y.offset-t.offset;return g===0?y.length-t.length:g}),p=m.length;for(let y=I.length-1;y>=0;y--){let t=I[y];if(t.offset+t.length<=p)m=P(m,t);else throw new Error("Overlapping edit");p=t.offset}return m}e.applyEdits=f}),define(te[80],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var v;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(v=e.KeyCode||(e.KeyCode={}));var n;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(n=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(g,S){this._keyCodeToStr[g]=S,this._strToKeyCode[S.toLowerCase()]=g}keyCodeToStr(g){return this._keyCodeToStr[g]}strToKeyCode(g){return this._strToKeyCode[g.toLowerCase()]||0}}const C=new D,k=new D,P=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const f=[],m=Object.create(null),b=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>b[t]||0,toEnum:t=>m[t]||0,toString:t=>f[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",g=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let S=[],w=[];for(const M of g){const[c,a,l,o,h,r,i,s,u,d]=M;if(w[l]||(w[l]=!0,f[l]=o,m[o]=l,b[o.toLowerCase()]=l,a&&(e.IMMUTABLE_CODE_TO_KEY_CODE[l]=h,h!==0&&h!==3&&h!==5&&h!==4&&h!==6&&h!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[h]=l))),!S[h]){if(S[h]=!0,!r)throw new Error(`String representation missing for key code ${h} around scan code ${o}`);C.define(h,r),k.define(h,u||r),P.define(h,d||u||r)}i&&(e.EVENT_KEY_CODE_MAP[i]=h),s&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[s]=h)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var I;(function(t){function g(l){return C.keyCodeToStr(l)}t.toString=g;function S(l){return C.strToKeyCode(l)}t.fromString=S;function w(l){return k.keyCodeToStr(l)}t.toUserSettingsUS=w;function M(l){return P.keyCodeToStr(l)}t.toUserSettingsGeneral=M;function c(l){return k.strToKeyCode(l)||P.strToKeyCode(l)}t.fromUserSettings=c;function a(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return C.keyCodeToStr(l)}t.toElectronAccelerator=a})(I=e.KeyCodeUtils||(e.KeyCodeUtils={}));var p;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(p=e.KeyMod||(e.KeyMod={}));function y(t,g){const S=(g&65535)<<16>>>0;return(t|S)>>>0}e.KeyChord=y}),define(te[59],ie([0,1,15]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var n;(function(I){I[I.CtrlCmd=2048]="CtrlCmd",I[I.Shift=1024]="Shift",I[I.Alt=512]="Alt",I[I.WinCtrl=256]="WinCtrl",I[I.KeyCode=255]="KeyCode"})(n||(n={}));function D(I,p){if(I===0)return null;const y=(I&65535)>>>0,t=(I&4294901760)>>>16;return t!==0?new P([C(y,p),C(t,p)]):new P([C(y,p)])}e.createKeybinding=D;function C(I,p){const y=!!(I&2048),t=!!(I&256),g=p===2?t:y,S=!!(I&1024),w=!!(I&512),M=p===2?y:t,c=I&255;return new k(g,S,w,M,c)}e.createSimpleKeybinding=C;class k{constructor(p,y,t,g,S){this.ctrlKey=p,this.shiftKey=y,this.altKey=t,this.metaKey=g,this.keyCode=S}equals(p){return this.ctrlKey===p.ctrlKey&&this.shiftKey===p.shiftKey&&this.altKey===p.altKey&&this.metaKey===p.metaKey&&this.keyCode===p.keyCode}getHashCode(){const p=this.ctrlKey?"1":"0",y=this.shiftKey?"1":"0",t=this.altKey?"1":"0",g=this.metaKey?"1":"0";return`${p}${y}${t}${g}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new P([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=k;class P{constructor(p){if(p.length===0)throw(0,v.illegalArgument)("parts");this.parts=p}getHashCode(){let p="";for(let y=0,t=this.parts.length;y<t;y++)y!==0&&(p+=";"),p+=this.parts[y].getHashCode();return p}equals(p){if(p===null||this.parts.length!==p.parts.length)return!1;for(let y=0;y<this.parts.length;y++)if(!this.parts[y].equals(p.parts[y]))return!1;return!0}}e.ChordKeybinding=P;class f{constructor(p,y,t,g,S){this.ctrlKey=p,this.shiftKey=y,this.altKey=t,this.metaKey=g,this.scanCode=S}equals(p){return this.ctrlKey===p.ctrlKey&&this.shiftKey===p.shiftKey&&this.altKey===p.altKey&&this.metaKey===p.metaKey&&this.scanCode===p.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=f;class m{constructor(p,y,t,g,S,w){this.ctrlKey=p,this.shiftKey=y,this.altKey=t,this.metaKey=g,this.keyLabel=S,this.keyAriaLabel=w}}e.ResolvedKeybindingPart=m;class b{}e.ResolvedKeybinding=b}),define(te[106],ie([0,1,80,59]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(k){k=k.toLowerCase().trim();let P=!1,f=!1,m=!1,b=!1,I;do I=!1,/^ctrl(\+|\-)/.test(k)&&(P=!0,k=k.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(k)&&(f=!0,k=k.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(k)&&(m=!0,k=k.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(k)&&(b=!0,k=k.substr("meta-".length),I=!0),/^win(\+|\-)/.test(k)&&(b=!0,k=k.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(k)&&(b=!0,k=k.substr("cmd-".length),I=!0);while(I);let p;const y=k.indexOf(" ");return y>0?(p=k.substring(0,y),k=k.substring(y)):(p=k,k=""),{remains:k,ctrl:P,shift:f,alt:m,meta:b,key:p}}static parseSimpleKeybinding(k){const P=this._readModifiers(k),f=v.KeyCodeUtils.fromUserSettings(P.key);return[new n.SimpleKeybinding(P.ctrl,P.shift,P.alt,P.meta,f),P.remains]}static parseKeybinding(k,P){if(!k)return null;const f=[];let m;do[m,k]=this.parseSimpleKeybinding(k),f.push(m);while(k.length>0);return new n.ChordKeybinding(f)}static parseSimpleUserBinding(k){const P=this._readModifiers(k),f=P.key.match(/^\[([^\]]+)\]$/);if(f){const b=f[1],I=v.ScanCodeUtils.lowerCaseToEnum(b);return[new n.ScanCodeBinding(P.ctrl,P.shift,P.alt,P.meta,I),P.remains]}const m=v.KeyCodeUtils.fromUserSettings(P.key);return[new n.SimpleKeybinding(P.ctrl,P.shift,P.alt,P.meta,m),P.remains]}static parseUserBinding(k){if(!k)return[];const P=[];let f;for(;k.length>0;)[f,k]=this.parseSimpleUserBinding(k),P.push(f);return P}}e.KeybindingParser=D}),define(te[107],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new v(()=>D(this.getValue()))}}e.Lazy=v}),define(te[2],ie([0,1,42,69]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function k(i){C=i}if(e.setDisposableTracker=k,D){const i="__is_disposable_tracked__";k(new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[i]||console.log(u)},3e3)}setParent(s,u){if(s&&s!==M.None)try{s[i]=!0}catch{}}markAsDisposed(s){if(s&&s!==M.None)try{s[i]=!0}catch{}}markAsSingleton(s){}})}function P(i){return C?.trackDisposable(i),i}function f(i){C?.markAsDisposed(i)}function m(i,s){C?.setParent(i,s)}function b(i,s){if(!!C)for(const u of i)C.setParent(u,s)}function I(i){return C?.markAsSingleton(i),i}e.markAsSingleton=I;class p extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=p;function y(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=y;function t(i){if(n.Iterable.is(i)){let s=[];for(const u of i)if(u)try{u.dispose()}catch(d){s.push(d)}if(s.length===1)throw s[0];if(s.length>1)throw new p(s);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function g(...i){const s=S(()=>t(i));return b(i,s),s}e.combinedDisposable=g;function S(i){const s=P({dispose:(0,v.once)(()=>{f(s),i()})});return s}e.toDisposable=S;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return m(s,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class M{constructor(){this._store=new w,P(this),m(this._store,this)}dispose(){f(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=M,M.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&m(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&m(s,null),s}}e.MutableDisposable=c;class a{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class l{constructor(){this.references=new Map}acquire(s,...u){let d=this.references.get(s);d||(d={counter:0,object:this.createReferencedObject(s,...u)},this.references.set(s,d));const{object:E}=d,L=(0,v.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(s,d.object),this.references.delete(s))});return d.counter++,{object:E,dispose:L}}}e.ReferenceCollection=l;class o{constructor(s){this.referenceCollection=s}async acquire(s,...u){const d=this.referenceCollection.acquire(s,...u);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(E){throw d.dispose(),E}}}e.AsyncReferenceCollection=o;class h{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=h;function r(i){const s=new w;try{i(s)}finally{s.dispose()}}e.disposeOnReturn=r}),define(te[108],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(C){this.element=C,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class n{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let C=this._first;for(;C!==v.Undefined;){const k=C.next;C.prev=v.Undefined,C.next=v.Undefined,C=k}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,k){const P=new v(C);if(this._first===v.Undefined)this._first=P,this._last=P;else if(k){const m=this._last;this._last=P,P.prev=m,m.next=P}else{const m=this._first;this._first=P,P.next=m,m.prev=P}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(P))}}shift(){if(this._first!==v.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==v.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==v.Undefined&&C.next!==v.Undefined){const k=C.prev;k.next=C.next,C.next.prev=k}else C.prev===v.Undefined&&C.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):C.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):C.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==v.Undefined;)yield C.element,C=C.next}}e.LinkedList=n}),function(){function K(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function k(f){C.push(f,Date.now())}function P(){const f=[];for(let m=0;m<C.length;m+=2)f.push({name:C[m],startTime:C[m+1]});return f}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))C.push({name:k.name,startTime:Math.round(D+k.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=v(n))}(),define(te[3],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const v="en";let n=!1,D=!1,C=!1,k=!1,P=!1,f=!1,m=!1,b=!1,I,p=v,y,t;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const S=typeof g?.versions?.electron=="string",w=S&&g?.type==="renderer";if(e.isElectronSandboxed=w&&g?.sandboxed,typeof navigator=="object"&&!w)t=navigator.userAgent,n=t.indexOf("Windows")>=0,D=t.indexOf("Macintosh")>=0,b=(t.indexOf("Macintosh")>=0||t.indexOf("iPad")>=0||t.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=t.indexOf("Linux")>=0,f=!0,I=navigator.language,p=I;else if(typeof g=="object"){n=g.platform==="win32",D=g.platform==="darwin",C=g.platform==="linux",k=C&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,m=S,I=v,p=v;const s=g.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),d=u.availableLanguages["*"];I=u.locale,p=d||v,y=u._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var M;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(M=e.Platform||(e.Platform={}));function c(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let a=0;D?a=1:n?a=3:C&&(a=2),e.isWindows=n,e.isMacintosh=D,e.isLinux=C,e.isLinuxSnap=k,e.isNative=P,e.isElectron=m,e.isWeb=f,e.isIOS=b,e.platform=a,e.userAgent=t,e.language=p;var l;(function(s){function u(){return e.language}s.value=u;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=d;function E(){return e.language==="en"}s.isDefault=E})(l=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=y,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let E=0,L=s.length;E<L;E++){const R=s[E];if(R.id===d.data.vscodeScheduleAsyncWork){s.splice(E,1),R.callback();return}}});let u=0;return d=>{const E=++u;s.push({id:E,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return s=>setTimeout(s)})();var o;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||b?2:n?1:3;let h=!0,r=!1;function i(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,h=new Uint16Array(s.buffer)[0]===(2<<8)+1}return h}e.isLittleEndian=i}),define(te[34],ie([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const D=v.globals.vscode.process;n={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(te[9],ie([0,1,34]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,D=97,C=90,k=122,P=46,f=47,m=92,b=58,I=63;class p extends Error{constructor(a,l,o){let h;typeof l=="string"&&l.indexOf("not ")===0?(h="must not be",l=l.replace(/^not /,"")):h="must be";const r=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${r} ${h} of type ${l}`;i+=`. Received type ${typeof o}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function y(c,a){if(typeof c!="string")throw new p(a,"string",c)}function t(c){return c===f||c===m}function g(c){return c===f}function S(c){return c>=n&&c<=C||c>=D&&c<=k}function w(c,a,l,o){let h="",r=0,i=-1,s=0,u=0;for(let d=0;d<=c.length;++d){if(d<c.length)u=c.charCodeAt(d);else{if(o(u))break;u=f}if(o(u)){if(!(i===d-1||s===1))if(s===2){if(h.length<2||r!==2||h.charCodeAt(h.length-1)!==P||h.charCodeAt(h.length-2)!==P){if(h.length>2){const E=h.lastIndexOf(l);E===-1?(h="",r=0):(h=h.slice(0,E),r=h.length-1-h.lastIndexOf(l)),i=d,s=0;continue}else if(h.length!==0){h="",r=0,i=d,s=0;continue}}a&&(h+=h.length>0?`${l}..`:"..",r=2)}else h.length>0?h+=`${l}${c.slice(i+1,d)}`:h=c.slice(i+1,d),r=d-i-1;i=d,s=0}else u===P&&s!==-1?++s:s=-1}return h}function M(c,a){if(a===null||typeof a!="object")throw new p("pathObject","Object",a);const l=a.dir||a.root,o=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${o}`:`${l}${c}${o}`:o}e.win32={resolve(...c){let a="",l="",o=!1;for(let h=c.length-1;h>=-1;h--){let r;if(h>=0){if(r=c[h],y(r,"path"),r.length===0)continue}else a.length===0?r=v.cwd():(r=v.env[`=${a}`]||v.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${a}\\`));const i=r.length;let s=0,u="",d=!1;const E=r.charCodeAt(0);if(i===1)t(E)&&(s=1,d=!0);else if(t(E))if(d=!0,t(r.charCodeAt(1))){let L=2,R=L;for(;L<i&&!t(r.charCodeAt(L));)L++;if(L<i&&L!==R){const T=r.slice(R,L);for(R=L;L<i&&t(r.charCodeAt(L));)L++;if(L<i&&L!==R){for(R=L;L<i&&!t(r.charCodeAt(L));)L++;(L===i||L!==R)&&(u=`\\\\${T}\\${r.slice(R,L)}`,s=L)}}}else s=1;else S(E)&&r.charCodeAt(1)===b&&(u=r.slice(0,2),s=2,i>2&&t(r.charCodeAt(2))&&(d=!0,s=3));if(u.length>0)if(a.length>0){if(u.toLowerCase()!==a.toLowerCase())continue}else a=u;if(o){if(a.length>0)break}else if(l=`${r.slice(s)}\\${l}`,o=d,d&&a.length>0)break}return l=w(l,!o,"\\",t),o?`${a}\\${l}`:`${a}${l}`||"."},normalize(c){y(c,"path");const a=c.length;if(a===0)return".";let l=0,o,h=!1;const r=c.charCodeAt(0);if(a===1)return g(r)?"\\":c;if(t(r))if(h=!0,t(c.charCodeAt(1))){let s=2,u=s;for(;s<a&&!t(c.charCodeAt(s));)s++;if(s<a&&s!==u){const d=c.slice(u,s);for(u=s;s<a&&t(c.charCodeAt(s));)s++;if(s<a&&s!==u){for(u=s;s<a&&!t(c.charCodeAt(s));)s++;if(s===a)return`\\\\${d}\\${c.slice(u)}\\`;s!==u&&(o=`\\\\${d}\\${c.slice(u,s)}`,l=s)}}}else l=1;else S(r)&&c.charCodeAt(1)===b&&(o=c.slice(0,2),l=2,a>2&&t(c.charCodeAt(2))&&(h=!0,l=3));let i=l<a?w(c.slice(l),!h,"\\",t):"";return i.length===0&&!h&&(i="."),i.length>0&&t(c.charCodeAt(a-1))&&(i+="\\"),o===void 0?h?`\\${i}`:i:h?`${o}\\${i}`:`${o}${i}`},isAbsolute(c){y(c,"path");const a=c.length;if(a===0)return!1;const l=c.charCodeAt(0);return t(l)||a>2&&S(l)&&c.charCodeAt(1)===b&&t(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let a,l;for(let r=0;r<c.length;++r){const i=c[r];y(i,"path"),i.length>0&&(a===void 0?a=l=i:a+=`\\${i}`)}if(a===void 0)return".";let o=!0,h=0;if(typeof l=="string"&&t(l.charCodeAt(0))){++h;const r=l.length;r>1&&t(l.charCodeAt(1))&&(++h,r>2&&(t(l.charCodeAt(2))?++h:o=!1))}if(o){for(;h<a.length&&t(a.charCodeAt(h));)h++;h>=2&&(a=`\\${a.slice(h)}`)}return e.win32.normalize(a)},relative(c,a){if(y(c,"from"),y(a,"to"),c===a)return"";const l=e.win32.resolve(c),o=e.win32.resolve(a);if(l===o||(c=l.toLowerCase(),a=o.toLowerCase(),c===a))return"";let h=0;for(;h<c.length&&c.charCodeAt(h)===m;)h++;let r=c.length;for(;r-1>h&&c.charCodeAt(r-1)===m;)r--;const i=r-h;let s=0;for(;s<a.length&&a.charCodeAt(s)===m;)s++;let u=a.length;for(;u-1>s&&a.charCodeAt(u-1)===m;)u--;const d=u-s,E=i<d?i:d;let L=-1,R=0;for(;R<E;R++){const N=c.charCodeAt(h+R);if(N!==a.charCodeAt(s+R))break;N===m&&(L=R)}if(R!==E){if(L===-1)return o}else{if(d>E){if(a.charCodeAt(s+R)===m)return o.slice(s+R+1);if(R===2)return o.slice(s+R)}i>E&&(c.charCodeAt(h+R)===m?L=R:R===2&&(L=3)),L===-1&&(L=0)}let T="";for(R=h+L+1;R<=r;++R)(R===r||c.charCodeAt(R)===m)&&(T+=T.length===0?"..":"\\..");return s+=L,T.length>0?`${T}${o.slice(s,u)}`:(o.charCodeAt(s)===m&&++s,o.slice(s,u))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const a=e.win32.resolve(c);if(a.length<=2)return c;if(a.charCodeAt(0)===m){if(a.charCodeAt(1)===m){const l=a.charCodeAt(2);if(l!==I&&l!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(S(a.charCodeAt(0))&&a.charCodeAt(1)===b&&a.charCodeAt(2)===m)return`\\\\?\\${a}`;return c},dirname(c){y(c,"path");const a=c.length;if(a===0)return".";let l=-1,o=0;const h=c.charCodeAt(0);if(a===1)return t(h)?c:".";if(t(h)){if(l=o=1,t(c.charCodeAt(1))){let s=2,u=s;for(;s<a&&!t(c.charCodeAt(s));)s++;if(s<a&&s!==u){for(u=s;s<a&&t(c.charCodeAt(s));)s++;if(s<a&&s!==u){for(u=s;s<a&&!t(c.charCodeAt(s));)s++;if(s===a)return c;s!==u&&(l=o=s+1)}}}}else S(h)&&c.charCodeAt(1)===b&&(l=a>2&&t(c.charCodeAt(2))?3:2,o=l);let r=-1,i=!0;for(let s=a-1;s>=o;--s)if(t(c.charCodeAt(s))){if(!i){r=s;break}}else i=!1;if(r===-1){if(l===-1)return".";r=l}return c.slice(0,r)},basename(c,a){a!==void 0&&y(a,"ext"),y(c,"path");let l=0,o=-1,h=!0,r;if(c.length>=2&&S(c.charCodeAt(0))&&c.charCodeAt(1)===b&&(l=2),a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,s=-1;for(r=c.length-1;r>=l;--r){const u=c.charCodeAt(r);if(t(u)){if(!h){l=r+1;break}}else s===-1&&(h=!1,s=r+1),i>=0&&(u===a.charCodeAt(i)?--i==-1&&(o=r):(i=-1,o=s))}return l===o?o=s:o===-1&&(o=c.length),c.slice(l,o)}for(r=c.length-1;r>=l;--r)if(t(c.charCodeAt(r))){if(!h){l=r+1;break}}else o===-1&&(h=!1,o=r+1);return o===-1?"":c.slice(l,o)},extname(c){y(c,"path");let a=0,l=-1,o=0,h=-1,r=!0,i=0;c.length>=2&&c.charCodeAt(1)===b&&S(c.charCodeAt(0))&&(a=o=2);for(let s=c.length-1;s>=a;--s){const u=c.charCodeAt(s);if(t(u)){if(!r){o=s+1;break}continue}h===-1&&(r=!1,h=s+1),u===P?l===-1?l=s:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||h===-1||i===0||i===1&&l===h-1&&l===o+1?"":c.slice(l,h)},format:M.bind(null,"\\"),parse(c){y(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.length;let o=0,h=c.charCodeAt(0);if(l===1)return t(h)?(a.root=a.dir=c,a):(a.base=a.name=c,a);if(t(h)){if(o=1,t(c.charCodeAt(1))){let L=2,R=L;for(;L<l&&!t(c.charCodeAt(L));)L++;if(L<l&&L!==R){for(R=L;L<l&&t(c.charCodeAt(L));)L++;if(L<l&&L!==R){for(R=L;L<l&&!t(c.charCodeAt(L));)L++;L===l?o=L:L!==R&&(o=L+1)}}}}else if(S(h)&&c.charCodeAt(1)===b){if(l<=2)return a.root=a.dir=c,a;if(o=2,t(c.charCodeAt(2))){if(l===3)return a.root=a.dir=c,a;o=3}}o>0&&(a.root=c.slice(0,o));let r=-1,i=o,s=-1,u=!0,d=c.length-1,E=0;for(;d>=o;--d){if(h=c.charCodeAt(d),t(h)){if(!u){i=d+1;break}continue}s===-1&&(u=!1,s=d+1),h===P?r===-1?r=d:E!==1&&(E=1):r!==-1&&(E=-1)}return s!==-1&&(r===-1||E===0||E===1&&r===s-1&&r===i+1?a.base=a.name=c.slice(i,s):(a.name=c.slice(i,r),a.base=c.slice(i,s),a.ext=c.slice(r,s))),i>0&&i!==o?a.dir=c.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let a="",l=!1;for(let o=c.length-1;o>=-1&&!l;o--){const h=o>=0?c[o]:v.cwd();y(h,"path"),h.length!==0&&(a=`${h}/${a}`,l=h.charCodeAt(0)===f)}return a=w(a,!l,"/",g),l?`/${a}`:a.length>0?a:"."},normalize(c){if(y(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===f,l=c.charCodeAt(c.length-1)===f;return c=w(c,!a,"/",g),c.length===0?a?"/":l?"./":".":(l&&(c+="/"),a?`/${c}`:c)},isAbsolute(c){return y(c,"path"),c.length>0&&c.charCodeAt(0)===f},join(...c){if(c.length===0)return".";let a;for(let l=0;l<c.length;++l){const o=c[l];y(o,"path"),o.length>0&&(a===void 0?a=o:a+=`/${o}`)}return a===void 0?".":e.posix.normalize(a)},relative(c,a){if(y(c,"from"),y(a,"to"),c===a||(c=e.posix.resolve(c),a=e.posix.resolve(a),c===a))return"";const l=1,o=c.length,h=o-l,r=1,i=a.length-r,s=h<i?h:i;let u=-1,d=0;for(;d<s;d++){const L=c.charCodeAt(l+d);if(L!==a.charCodeAt(r+d))break;L===f&&(u=d)}if(d===s)if(i>s){if(a.charCodeAt(r+d)===f)return a.slice(r+d+1);if(d===0)return a.slice(r+d)}else h>s&&(c.charCodeAt(l+d)===f?u=d:d===0&&(u=0));let E="";for(d=l+u+1;d<=o;++d)(d===o||c.charCodeAt(d)===f)&&(E+=E.length===0?"..":"/..");return`${E}${a.slice(r+u)}`},toNamespacedPath(c){return c},dirname(c){if(y(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===f;let l=-1,o=!0;for(let h=c.length-1;h>=1;--h)if(c.charCodeAt(h)===f){if(!o){l=h;break}}else o=!1;return l===-1?a?"/":".":a&&l===1?"//":c.slice(0,l)},basename(c,a){a!==void 0&&y(a,"ext"),y(c,"path");let l=0,o=-1,h=!0,r;if(a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,s=-1;for(r=c.length-1;r>=0;--r){const u=c.charCodeAt(r);if(u===f){if(!h){l=r+1;break}}else s===-1&&(h=!1,s=r+1),i>=0&&(u===a.charCodeAt(i)?--i==-1&&(o=r):(i=-1,o=s))}return l===o?o=s:o===-1&&(o=c.length),c.slice(l,o)}for(r=c.length-1;r>=0;--r)if(c.charCodeAt(r)===f){if(!h){l=r+1;break}}else o===-1&&(h=!1,o=r+1);return o===-1?"":c.slice(l,o)},extname(c){y(c,"path");let a=-1,l=0,o=-1,h=!0,r=0;for(let i=c.length-1;i>=0;--i){const s=c.charCodeAt(i);if(s===f){if(!h){l=i+1;break}continue}o===-1&&(h=!1,o=i+1),s===P?a===-1?a=i:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||o===-1||r===0||r===1&&a===o-1&&a===l+1?"":c.slice(a,o)},format:M.bind(null,"/"),parse(c){y(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.charCodeAt(0)===f;let o;l?(a.root="/",o=1):o=0;let h=-1,r=0,i=-1,s=!0,u=c.length-1,d=0;for(;u>=o;--u){const E=c.charCodeAt(u);if(E===f){if(!s){r=u+1;break}continue}i===-1&&(s=!1,i=u+1),E===P?h===-1?h=u:d!==1&&(d=1):h!==-1&&(d=-1)}if(i!==-1){const E=r===0&&l?1:r;h===-1||d===0||d===1&&h===i-1&&h===r+1?a.base=a.name=c.slice(E,i):(a.name=c.slice(E,h),a.base=c.slice(E,i),a.ext=c.slice(h,i))}return r>0?a.dir=c.slice(0,r-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[81],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var n;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(C,...k){const P=k.reduce((b,I)=>(b[I]=!0,b),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(b=>!P[b]).forEach(b=>{for(let I=0;I<f.length;I++)if(b.search(f[I])!==-1){delete C[b];break}})}e.sanitizeProcessEnvironment=D}),define(te[109],ie([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=v.globals.performance&&typeof v.globals.performance.now=="function";class D{constructor(k){this._highResolution=n&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(te[4],ie([0,1,15,42,2,108,109]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(a){a.None=()=>D.Disposable.None;function l(q){return(Y,j=null,z)=>{let G=!1,$;return $=q(F=>{if(!G)return $?$.dispose():G=!0,Y.call(j,F)},null,z),G&&$.dispose(),$}}a.once=l;function o(q,Y){return d((j,z=null,G)=>q($=>j.call(z,Y($)),null,G))}a.map=o;function h(q,Y){return d((j,z=null,G)=>q($=>{Y($),j.call(z,$)},null,G))}a.forEach=h;function r(q,Y){return d((j,z=null,G)=>q($=>Y($)&&j.call(z,$),null,G))}a.filter=r;function i(q){return q}a.signal=i;function s(...q){return(Y,j=null,z)=>(0,D.combinedDisposable)(...q.map(G=>G($=>Y.call(j,$),null,z)))}a.any=s;function u(q,Y,j){let z=j;return o(q,G=>(z=Y(z,G),z))}a.reduce=u;function d(q){let Y;const j=new p({onFirstListenerAdd(){Y=q(j.fire,j)},onLastListenerRemove(){Y.dispose()}});return j.event}function E(q,Y,j,z=100,G=!1){let $,F,W=0;return q(A=>{W++,$=j($,A),G&&!F&&(Y($),$=void 0),clearTimeout(F),F=setTimeout(()=>{const _=$;$=void 0,F=void 0,(!G||W>1)&&Y(_),W=0},z)})}a.debouncedListener=E;function L(q,Y,j=100,z=!1,G){let $,F,W,A=0;const _=new p({leakWarningThreshold:G,onFirstListenerAdd(){$=q(U=>{A++,F=Y(F,U),z&&!W&&(_.fire(F),F=void 0),clearTimeout(W),W=setTimeout(()=>{const O=F;F=void 0,W=void 0,(!z||A>1)&&_.fire(O),A=0},j)})},onLastListenerRemove(){$.dispose()}});return _.event}a.debounce=L;function R(q,Y=(j,z)=>j===z){let j=!0,z;return r(q,G=>{const $=j||!Y(G,z);return j=!1,z=G,$})}a.latch=R;function T(q,Y){return[a.filter(q,Y),a.filter(q,j=>!Y(j))]}a.split=T;function N(q,Y=!1,j=[]){let z=j.slice(),G=q(W=>{z?z.push(W):F.fire(W)});const $=()=>{z&&z.forEach(W=>F.fire(W)),z=null},F=new p({onFirstListenerAdd(){G||(G=q(W=>F.fire(W)))},onFirstListenerDidAdd(){z&&(Y?setTimeout($):$())},onLastListenerRemove(){G&&G.dispose(),G=null}});return F.event}a.buffer=N;class Q{constructor(Y){this.event=Y}map(Y){return new Q(o(this.event,Y))}forEach(Y){return new Q(h(this.event,Y))}filter(Y){return new Q(r(this.event,Y))}reduce(Y,j){return new Q(u(this.event,Y,j))}latch(){return new Q(R(this.event))}debounce(Y,j=100,z=!1,G){return new Q(L(this.event,Y,j,z,G))}on(Y,j,z){return this.event(Y,j,z)}once(Y,j,z){return l(this.event)(Y,j,z)}}function se(q){return new Q(q)}a.chain=se;function ne(q,Y,j=z=>z){const z=(...W)=>F.fire(j(...W)),G=()=>q.on(Y,z),$=()=>q.removeListener(Y,z),F=new p({onFirstListenerAdd:G,onLastListenerRemove:$});return F.event}a.fromNodeEventEmitter=ne;function V(q,Y,j=z=>z){const z=(...W)=>F.fire(j(...W)),G=()=>q.addEventListener(Y,z),$=()=>q.removeEventListener(Y,z),F=new p({onFirstListenerAdd:G,onLastListenerRemove:$});return F.event}a.fromDOMEventEmitter=V;function Z(q){return new Promise(Y=>l(q)(Y))}a.toPromise=Z;function H(q,Y){return Y(void 0),q(j=>Y(j))}a.runAndSubscribe=H})(P=e.Event||(e.Event={}));class f{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${f._idPool++}`}start(l){this._stopWatch=new k.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let m=-1;function b(a){const l=m;return m=a,{dispose(){m=l}}}e.setGlobalLeakWarningThreshold=b;class I{constructor(l,o=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let o=m;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||l<o)return;this._stacks||(this._stacks=new Map);const h=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(h)||0;if(this._stacks.set(h,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,s=0;for(const[u,d]of this._stacks)(!i||s<d)&&(i=u,s=d);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(h)||0;this._stacks.set(h,i-1)}}}class p{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=m>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(l,o,h)=>{this._listeners||(this._listeners=new C.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[l,o]:l);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,o);const s=this._leakageMon?.check(this._listeners.size),u=(0,D.toDisposable)(()=>{s&&s(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof D.DisposableStore?h.add(u):Array.isArray(h)&&h.push(u),u}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,h]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,h):o[0].call(o[1],h)}catch(r){(0,v.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=p;class y extends p{async fireAsync(l,o,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,l]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),s=[],u={...i,token:o,waitUntil:d=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");h&&(d=h(d,typeof r=="function"?r:r[0])),s.push(d)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(d){(0,v.onUnexpectedError)(d);continue}Object.freeze(s),await Promise.allSettled(s).then(d=>{for(const E of d)E.status==="rejected"&&(0,v.onUnexpectedError)(E.reason)})}}}}e.AsyncEmitter=y;class t extends p{constructor(l){super(l);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=t;class g extends t{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=g;class S extends p{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=S;class w{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const o={event:l,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const h=()=>{this.hasListeners&&this.unhook(o);const r=this.events.indexOf(o);this.events.splice(r,1)};return(0,D.toDisposable)((0,n.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(o=>this.emitter.fire(o))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=w;class M{constructor(){this.buffers=[]}wrapEvent(l){return(o,h,r)=>l(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>o.call(h,i)):o.call(h,i)},void 0,r)}bufferEvents(l){const o=[];this.buffers.push(o);const h=l();return this.buffers.pop(),o.forEach(r=>r()),h}}e.EventBufferer=M;class c{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=D.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(te[21],ie([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(P,f){const m=setTimeout(P.bind(f),0);return{dispose(){clearTimeout(m)}}});var D;(function(P){function f(m){return m===P.None||m===P.Cancelled||m instanceof C?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}P.isCancellationToken=f,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(te[110],ie([0,1,21]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new v.CancellationTokenSource,P=this.task(k.token);return this.result={promise:P,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=n;class D{constructor(k){this.computeFn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const P=JSON.stringify(k);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.computeFn(k)),this.lastCache}}e.LRUCachedComputed=D}),define(te[51],ie([0,1,15,2]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(c){const a=c;return a?[a.on,a.pause,a.resume,a.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=D;function C(c){const a=c;return a?D(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=C;function k(c,a){return new P(c,a)}e.newWriteableStream=k;class P{constructor(a,l){this.reducer=a,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(l=>l(a))}emitError(a){this.listeners.error.length===0?(0,v.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(l=>l(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,l){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(a,l){if(this.state.destroyed)return;let o;switch(a){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const h=o.indexOf(l);h>=0&&o.splice(h,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(c,a){const l=[];let o;for(;(o=c.read())!==null;)l.push(o);return a(l)}e.consumeReadable=f;function m(c,a,l){const o=[];let h;for(;(h=c.read())!==null&&o.length<l;)o.push(h);return h===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof h!="undefined"){const r=h;return h=void 0,r}return c.read()}}}e.peekReadable=m;function b(c,a){return new Promise((l,o)=>{const h=[];I(c,{onData:r=>{a&&h.push(r)},onError:r=>{a?o(r):l(void 0)},onEnd:()=>{l(a?a(h):void 0)}})})}e.consumeStream=b;function I(c,a){let l=!1;return c.on("error",o=>{l||a.onError(o)}),c.on("end",()=>{l||a.onEnd()}),c.on("data",o=>{l||a.onData(o)}),(0,n.toDisposable)(()=>l=!0)}e.listenStream=I;function p(c,a){return new Promise((l,o)=>{const h=new n.DisposableStore,r=[],i=d=>{if(r.push(d),r.length>a)return h.dispose(),c.pause(),l({stream:c,buffer:r,ended:!1})},s=d=>o(d),u=()=>l({stream:c,buffer:r,ended:!0});h.add((0,n.toDisposable)(()=>c.removeListener("error",s))),c.on("error",s),h.add((0,n.toDisposable)(()=>c.removeListener("end",u))),c.on("end",u),h.add((0,n.toDisposable)(()=>c.removeListener("data",i))),c.on("data",i)})}e.peekStream=p;function y(c,a){const l=k(a);return l.end(c),l}e.toStream=y;function t(){const c=k(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=t;function g(c){let a=!1;return{read:()=>a?null:(a=!0,c)}}e.toReadable=g;function S(c,a,l){const o=k(l);return I(c,{onData:h=>o.write(a.data(h)),onError:h=>o.error(a.error?a.error(h):h),onEnd:()=>o.end()}),o}e.transform=S;function w(c,a,l){let o=!1;return{read:()=>{const h=a.read();return o?h:(o=!0,h!==null?l([c,h]):c)}}}e.prefixedReadable=w;function M(c,a,l){let o=!1;const h=k(l);return I(a,{onData:r=>o?h.write(r):(o=!0,h.write(l([c,r]))),onError:r=>h.error(r),onEnd:()=>{o||(o=!0,h.write(c)),h.end()}}),h}e.prefixedStream=M}),define(te[17],ie([0,1,51]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let D,C;class k{constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}static alloc(E){return n?new k(Buffer.allocUnsafe(E)):new k(new Uint8Array(E))}static wrap(E){return n&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new k(E)}static fromString(E,L){return!(L?.dontUseNodeBuffer||!1)&&n?new k(Buffer.from(E)):(D||(D=new TextEncoder),new k(D.encode(E)))}static fromByteArray(E){const L=k.alloc(E.length);for(let R=0,T=E.length;R<T;R++)L.buffer[R]=E[R];return L}static concat(E,L){if(typeof L=="undefined"){L=0;for(let N=0,Q=E.length;N<Q;N++)L+=E[N].byteLength}const R=k.alloc(L);let T=0;for(let N=0,Q=E.length;N<Q;N++){const se=E[N];R.set(se,T),T+=se.byteLength}return R}clone(){const E=k.alloc(this.byteLength);return E.set(this),E}toString(){return n?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(E,L){return new k(this.buffer.subarray(E,L))}set(E,L){if(E instanceof k)this.buffer.set(E.buffer,L);else if(E instanceof Uint8Array)this.buffer.set(E,L);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),L);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),L);else throw new Error("Unkown argument 'array'")}readUInt32BE(E){return m(this.buffer,E)}writeUInt32BE(E,L){b(this.buffer,E,L)}readUInt32LE(E){return I(this.buffer,E)}writeUInt32LE(E,L){p(this.buffer,E,L)}readUInt8(E){return y(this.buffer,E)}writeUInt8(E,L){t(this.buffer,E,L)}}e.VSBuffer=k;function P(d,E){return d[E+0]<<0>>>0|d[E+1]<<8>>>0}e.readUInt16LE=P;function f(d,E,L){d[L+0]=E&255,E=E>>>8,d[L+1]=E&255}e.writeUInt16LE=f;function m(d,E){return d[E]*2**24+d[E+1]*2**16+d[E+2]*2**8+d[E+3]}e.readUInt32BE=m;function b(d,E,L){d[L+3]=E,E=E>>>8,d[L+2]=E,E=E>>>8,d[L+1]=E,E=E>>>8,d[L]=E}e.writeUInt32BE=b;function I(d,E){return d[E+0]<<0>>>0|d[E+1]<<8>>>0|d[E+2]<<16>>>0|d[E+3]<<24>>>0}e.readUInt32LE=I;function p(d,E,L){d[L+0]=E&255,E=E>>>8,d[L+1]=E&255,E=E>>>8,d[L+2]=E&255,E=E>>>8,d[L+3]=E&255}e.writeUInt32LE=p;function y(d,E){return d[E]}e.readUInt8=y;function t(d,E,L){d[L]=E}e.writeUInt8=t;function g(d){return v.consumeReadable(d,E=>k.concat(E))}e.readableToBuffer=g;function S(d){return v.toReadable(d)}e.bufferToReadable=S;function w(d){return v.consumeStream(d,E=>k.concat(E))}e.streamToBuffer=w;async function M(d){return d.ended?k.concat(d.buffer):k.concat([...d.buffer,await w(d.stream)])}e.bufferedStreamToBuffer=M;function c(d){return v.toStream(d,E=>k.concat(E))}e.bufferToStream=c;function a(d){return v.transform(d,{data:E=>typeof E=="string"?k.fromString(E):k.wrap(E)},E=>k.concat(E))}e.streamToBufferReadableStream=a;function l(d){return v.newWriteableStream(E=>k.concat(E),d)}e.newWriteableBufferStream=l;function o(d,E){return v.prefixedReadable(d,E,L=>k.concat(L))}e.prefixedBufferReadable=o;function h(d,E){return v.prefixedStream(d,E,L=>k.concat(L))}e.prefixedBufferStream=h;function r(d){let E=0,L=0,R=0;const T=new Uint8Array(Math.floor(d.length/4*3)),N=se=>{switch(L){case 3:T[R++]=E|se,L=0;break;case 2:T[R++]=E|se>>>2,E=se<<6,L=3;break;case 1:T[R++]=E|se>>>4,E=se<<4,L=2;break;default:E=se<<2,L=1}};for(let se=0;se<d.length;se++){const ne=d.charCodeAt(se);if(ne>=65&&ne<=90)N(ne-65);else if(ne>=97&&ne<=122)N(ne-97+26);else if(ne>=48&&ne<=57)N(ne-48+52);else if(ne===43||ne===45)N(62);else if(ne===47||ne===95)N(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${d[se]}`)}}const Q=R;for(;L>0;)N(0);return k.wrap(T).slice(0,Q)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:d},E=!0,L=!1){const R=L?s:i;let T="";const N=d.byteLength%3;let Q=0;for(;Q<d.byteLength-N;Q+=3){const se=d[Q+0],ne=d[Q+1],V=d[Q+2];T+=R[se>>>2],T+=R[(se<<4|ne>>>4)&63],T+=R[(ne<<2|V>>>6)&63],T+=R[V&63]}if(N===1){const se=d[Q+0];T+=R[se>>>2],T+=R[se<<4&63],E&&(T+="==")}else if(N===2){const se=d[Q+0],ne=d[Q+1];T+=R[se>>>2],T+=R[(se<<4|ne>>>4)&63],T+=R[ne<<2&63],E&&(T+="=")}return T}e.encodeBase64=u}),define(te[25],ie([0,1,110,107]),function(K,e,v,n){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=C;const k=/{(\d+)}/g;function P(X,...ae){return ae.length===0?X:X.replace(k,function(he,ve){const Ie=parseInt(ve,10);return isNaN(Ie)||Ie<0||Ie>=ae.length?he:ae[Ie]})}e.format=P;const f=/{([^}]+)}/g;function m(X,ae){return X.replace(f,(he,ve)=>ae[ve]??he)}e.format2=m;function b(X){return X.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=b;function I(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function p(X,ae){let he=0;const ve=ae.charCodeAt(0);for(let Ie=X.length-1;Ie>=0;Ie--)X.charCodeAt(Ie)===ve&&he++;return he}e.count=p;function y(X,ae,he="\u2026"){return X.length<=ae?X:`${X.substr(0,ae)}${he}`}e.truncate=y;function t(X,ae=" "){const he=g(X,ae);return S(he,ae)}e.trim=t;function g(X,ae){if(!X||!ae)return X;const he=ae.length;if(he===0||X.length===0)return X;let ve=0;for(;X.indexOf(ae,ve)===ve;)ve=ve+he;return X.substring(ve)}e.ltrim=g;function S(X,ae){if(!X||!ae)return X;const he=ae.length,ve=X.length;if(he===0||ve===0)return X;let Ie=ve,Re=-1;for(;Re=X.lastIndexOf(ae,Ie-1),!(Re===-1||Re+he!==Ie);){if(Re===0)return"";Ie=Re}return X.substring(0,Ie)}e.rtrim=S;function w(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function M(X){return X.replace(/\*/g,"")}e.stripWildcards=M;function c(X,ae,he={}){if(!X)throw new Error("Cannot create regex from empty string");ae||(X=I(X)),he.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let ve="";return he.global&&(ve+="g"),he.matchCase||(ve+="i"),he.multiline&&(ve+="m"),he.unicode&&(ve+="u"),new RegExp(X,ve)}e.createRegExp=c;function a(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function l(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function o(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=o;function h(X){return X.split(/\r\n|\r|\n/)}e.splitLines=h;function r(X){for(let ae=0,he=X.length;ae<he;ae++){const ve=X.charCodeAt(ae);if(ve!==32&&ve!==9)return ae}return-1}e.firstNonWhitespaceIndex=r;function i(X,ae=0,he=X.length){for(let ve=ae;ve<he;ve++){const Ie=X.charCodeAt(ve);if(Ie!==32&&Ie!==9)return X.substring(ae,ve)}return X.substring(ae,he)}e.getLeadingWhitespace=i;function s(X,ae=X.length-1){for(let he=ae;he>=0;he--){const ve=X.charCodeAt(he);if(ve!==32&&ve!==9)return he}return-1}e.lastNonWhitespaceIndex=s;function u(X,ae){return X<ae?-1:X>ae?1:0}e.compare=u;function d(X,ae,he=0,ve=X.length,Ie=0,Re=ae.length){for(;he<ve&&Ie<Re;he++,Ie++){let Ue=X.charCodeAt(he),Fe=ae.charCodeAt(Ie);if(Ue<Fe)return-1;if(Ue>Fe)return 1}const We=ve-he,Ke=Re-Ie;return We<Ke?-1:We>Ke?1:0}e.compareSubstring=d;function E(X,ae){return L(X,ae,0,X.length,0,ae.length)}e.compareIgnoreCase=E;function L(X,ae,he=0,ve=X.length,Ie=0,Re=ae.length){for(;he<ve&&Ie<Re;he++,Ie++){let Ue=X.charCodeAt(he),Fe=ae.charCodeAt(Ie);if(Ue===Fe)continue;if(Ue>=128||Fe>=128)return d(X.toLowerCase(),ae.toLowerCase(),he,ve,Ie,Re);R(Ue)&&(Ue-=32),R(Fe)&&(Fe-=32);const ze=Ue-Fe;if(ze!==0)return ze}const We=ve-he,Ke=Re-Ie;return We<Ke?-1:We>Ke?1:0}e.compareSubstringIgnoreCase=L;function R(X){return X>=97&&X<=122}e.isLowerAsciiLetter=R;function T(X){return X>=65&&X<=90}e.isUpperAsciiLetter=T;function N(X,ae){return X.length===ae.length&&L(X,ae)===0}e.equalsIgnoreCase=N;function Q(X,ae){const he=ae.length;return ae.length>X.length?!1:L(X,ae,0,he)===0}e.startsWithIgnoreCase=Q;function se(X,ae){let he,ve=Math.min(X.length,ae.length);for(he=0;he<ve;he++)if(X.charCodeAt(he)!==ae.charCodeAt(he))return he;return ve}e.commonPrefixLength=se;function ne(X,ae){let he,ve=Math.min(X.length,ae.length);const Ie=X.length-1,Re=ae.length-1;for(he=0;he<ve;he++)if(X.charCodeAt(Ie-he)!==ae.charCodeAt(Re-he))return he;return ve}e.commonSuffixLength=ne;function V(X){return 55296<=X&&X<=56319}e.isHighSurrogate=V;function Z(X){return 56320<=X&&X<=57343}e.isLowSurrogate=Z;function H(X,ae){return(X-55296<<10)+(ae-56320)+65536}e.computeCodePoint=H;function q(X,ae,he){const ve=X.charCodeAt(he);if(V(ve)&&he+1<ae){const Ie=X.charCodeAt(he+1);if(Z(Ie))return H(ve,Ie)}return ve}e.getNextCodePoint=q;function Y(X,ae){const he=X.charCodeAt(ae-1);if(Z(he)&&ae>1){const ve=X.charCodeAt(ae-2);if(V(ve))return H(ve,he)}return he}class j{constructor(ae,he=0){this._str=ae,this._len=ae.length,this._offset=he}get offset(){return this._offset}setOffset(ae){this._offset=ae}prevCodePoint(){const ae=Y(this._str,this._offset);return this._offset-=ae>=65536?2:1,ae}nextCodePoint(){const ae=q(this._str,this._len,this._offset);return this._offset+=ae>=65536?2:1,ae}eol(){return this._offset>=this._len}}e.CodePointIterator=j;class z{constructor(ae,he=0){this._iterator=new j(ae,he)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ae=Ne.getInstance(),he=this._iterator,ve=he.offset;let Ie=ae.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Re=he.offset,We=ae.getGraphemeBreakType(he.nextCodePoint());if(_e(Ie,We)){he.setOffset(Re);break}Ie=We}return he.offset-ve}prevGraphemeLength(){const ae=Ne.getInstance(),he=this._iterator,ve=he.offset;let Ie=ae.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Re=he.offset,We=ae.getGraphemeBreakType(he.prevCodePoint());if(_e(We,Ie)){he.setOffset(Re);break}Ie=We}return ve-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function G(X,ae){return new z(X,ae).nextGraphemeLength()}e.nextCharLength=G;function $(X,ae){return new z(X,ae).prevGraphemeLength()}e.prevCharLength=$;function F(X,ae){ae>0&&Z(X.charCodeAt(ae))&&ae--;const he=ae+G(X,ae);return[he-$(X,he),he]}e.getCharContainingOffset=F;const W=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function A(X){return W.test(X)}e.containsRTL=A;const _=/^[\t\n\r\x20-\x7E]*$/;function U(X){return _.test(X)}e.isBasicASCII=U,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function O(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=O;function B(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=B;function J(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=J;function ee(X,ae){if(X.length<ae)return X;const he=/\b/g;let ve=0;for(;he.test(X)&&!(X.length-he.lastIndex<ae);)ve=he.lastIndex,he.lastIndex+=1;return X.substring(ve).replace(/^\s/,"")}e.lcut=ee;const oe=/\x1B\x5B[12]?K/g,x=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function le(X){return X&&(X=X.replace(oe,""),X=X.replace(x,""),X=X.replace(ce,"")),X}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function me(X){return ue(X)?X.substr(1):X}e.stripUTF8BOM=me;function Ee(X,ae){if(!X||!ae||X.length<ae.length)return!1;const he=ae.length,ve=X.toLowerCase();let Ie=0,Re=-1;for(;Ie<he;){const We=ve.indexOf(ae[Ie],Re+1);if(We<0)return!1;Re=We,Ie++}return!0}e.fuzzyContains=Ee;function de(X,ae=!1){return X?(ae&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=de;function ge(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=ge;function we(X,ae=1){if(ae===0)return"";let he=-1;do he=X.indexOf(`
`,he+1),ae--;while(ae>0&&he>=0);return he===-1?X:(X[he-1]==="\r"&&he--,X.substr(0,he))}e.getNLines=we;function ke(X){const ae=90-65+1;return X=X%(2*ae),X<ae?String.fromCharCode(97+X):String.fromCharCode(65+X-ae)}e.singleLetterHash=ke;function Ce(X){return Ne.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=Ce;function _e(X,ae){return X===0?ae!==5&&ae!==7:X===2&&ae===3?!1:X===4||X===2||X===3||ae===4||ae===2||ae===3?!0:!(X===8&&(ae===8||ae===9||ae===11||ae===12)||(X===11||X===9)&&(ae===9||ae===10)||(X===12||X===10)&&ae===10||ae===5||ae===13||ae===7||X===1||X===13&&ae===14||X===6&&ae===6)}var qe;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ne{constructor(){this._data=He()}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const he=this._data,ve=he.length/3;let Ie=1;for(;Ie<=ve;)if(ae<he[3*Ie])Ie=2*Ie;else if(ae>he[3*Ie+1])Ie=2*Ie+1;else return he[3*Ie+2];return 0}}Ne._INSTANCE=null;function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function wt(X,ae){if(X===0)return 0;const he=at(X,ae);if(he!==void 0)return he;const ve=new j(ae,X);return ve.prevCodePoint(),ve.offset}e.getLeftDeleteOffset=wt;function at(X,ae){const he=new j(ae,X);let ve=he.prevCodePoint();for(;ct(ve)||ve===65039||ve===8419;){if(he.offset===0)return;ve=he.prevCodePoint()}if(!J(ve))return;let Ie=he.offset;return Ie>0&&he.prevCodePoint()===8205&&(Ie=he.offset),Ie}function ct(X){return 127995<=X&&X<=127999}var lt;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(lt||(lt={})),e.noBreakWhitespace="\xA0";class $e{constructor(ae){this.confusableDictionary=ae}static getInstance(ae){return $e.cache.get(Array.from(ae))}static getLocales(){return $e._locales.getValue()}isAmbiguous(ae){return this.confusableDictionary.has(ae)}getPrimaryConfusable(ae){return this.confusableDictionary.get(ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=$e,D=$e,$e.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')),$e.cache=new v.LRUCachedComputed(X=>{function ae(Fe){const ze=new Map;for(let Ve=0;Ve<Fe.length;Ve+=2)ze.set(Fe[Ve],Fe[Ve+1]);return ze}function he(Fe,ze){const Ve=new Map(Fe);for(const[Ye,ut]of ze)Ve.set(Ye,ut);return Ve}function ve(Fe,ze){if(!Fe)return ze;const Ve=new Map;for(const[Ye,ut]of Fe)ze.has(Ye)&&Ve.set(Ye,ut);return Ve}const Ie=D.ambiguousCharacterData.getValue();let Re=X.filter(Fe=>!Fe.startsWith("_")&&Fe in Ie);Re.length===0&&(Re=["_default"]);let We;for(const Fe of Re){const ze=ae(Ie[Fe]);We=ve(We,ze)}const Ke=ae(Ie._common),Ue=he(Ke,We);return new $e(Ue)}),$e._locales=new n.Lazy(()=>Object.keys($e.ambiguousCharacterData.getValue()).filter(X=>!X.startsWith("_")));class je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(je.getRawData())),this._data}static isInvisibleCharacter(ae){return je.getData().has(ae)}static get codePoints(){return je.getData()}}e.InvisibleCharacters=je,je._data=void 0}),define(te[82],ie([0,1,25]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(w){return D(w,0)}e.hash=n;function D(w,M){switch(typeof w){case"object":return w===null?C(349,M):Array.isArray(w)?f(w,M):m(w,M);case"string":return P(w,M);case"boolean":return k(w,M);case"number":return C(w,M);case"undefined":return C(937,M);default:return C(617,M)}}e.doHash=D;function C(w,M){return(M<<5)-M+w|0}e.numberHash=C;function k(w,M){return C(w?433:863,M)}function P(w,M){M=C(149417,M);for(let c=0,a=w.length;c<a;c++)M=C(w.charCodeAt(c),M);return M}e.stringHash=P;function f(w,M){return M=C(104579,M),w.reduce((c,a)=>D(a,c),M)}function m(w,M){return M=C(181387,M),Object.keys(w).sort().reduce((c,a)=>(c=P(a,c),D(w[a],c)),M)}class b{constructor(){this._value=0}get value(){return this._value}hash(M){return this._value=D(M,this._value),this._value}}e.Hasher=b;var I;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(w,M,c=32){const a=c-M,l=~((1<<a)-1);return(w<<M|(l&w)>>>a)>>>0}function y(w,M=0,c=w.byteLength,a=0){for(let l=0;l<c;l++)w[M+l]=a}function t(w,M,c="0"){for(;w.length<M;)w=c+w;return w}function g(w,M=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(c=>c.toString(16).padStart(2,"0")).join(""):t((w>>>0).toString(16),M/4)}e.toHexString=g;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(M){const c=M.length;if(c===0)return;const a=this._buff;let l=this._buffLen,o=this._leftoverHighSurrogate,h,r;for(o!==0?(h=o,r=-1,o=0):(h=M.charCodeAt(0),r=0);;){let i=h;if(v.isHighSurrogate(h))if(r+1<c){const s=M.charCodeAt(r+1);v.isLowSurrogate(s)?(r++,i=v.computeCodePoint(h,s)):i=65533}else{o=h;break}else v.isLowSurrogate(h)&&(i=65533);if(l=this._push(a,l,i),r++,r<c)h=M.charCodeAt(r);else break}this._buffLen=l,this._leftoverHighSurrogate=o}_push(M,c,a){return a<128?M[c++]=a:a<2048?(M[c++]=192|(a&1984)>>>6,M[c++]=128|(a&63)>>>0):a<65536?(M[c++]=224|(a&61440)>>>12,M[c++]=128|(a&4032)>>>6,M[c++]=128|(a&63)>>>0):(M[c++]=240|(a&1835008)>>>18,M[c++]=128|(a&258048)>>>12,M[c++]=128|(a&4032)>>>6,M[c++]=128|(a&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,M[0]=M[64+0],M[1]=M[64+1],M[2]=M[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const M=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(M/4294967296),!1),this._buffDV.setUint32(60,M%4294967296,!1),this._step()}_step(){const M=S._bigBlock32,c=this._buffDV;for(let d=0;d<64;d+=4)M.setUint32(d,c.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)M.setUint32(d,p(M.getUint32(d-12,!1)^M.getUint32(d-32,!1)^M.getUint32(d-56,!1)^M.getUint32(d-64,!1),1),!1);let a=this._h0,l=this._h1,o=this._h2,h=this._h3,r=this._h4,i,s,u;for(let d=0;d<80;d++)d<20?(i=l&o|~l&h,s=1518500249):d<40?(i=l^o^h,s=1859775393):d<60?(i=l&o|l&h|o&h,s=2400959708):(i=l^o^h,s=3395469782),u=p(a,5)+i+r+s+M.getUint32(d*4,!1)&4294967295,r=h,h=o,o=p(l,30),l=a,a=u;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+h&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))});var kt=this&&this.__classPrivateFieldSet||function(K,e,v,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!D:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(K,v):D?D.value=v:e.set(K,v),v},Ge=this&&this.__classPrivateFieldGet||function(K,e,v,n){if(v==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!n:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?n:v==="a"?n.call(K):n?n.value:e.get(K)};define(te[35],ie([0,1,31,25]),function(K,e,v,n){"use strict";var D,C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(r,i,s){let u=r.get(i);return u===void 0&&(u=s,r.set(i,u)),u}e.getOrSet=P;function f(r){const i=[];return r.forEach((s,u)=>{i.push(`${u} => ${s}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=f;function m(r){const i=[];return r.forEach(s=>{i.push(s)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=m;class b{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=b;class I{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class p{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const u=this._value.charCodeAt(s);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var y;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(y||(y={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(S||(S={}));class w{constructor(i){this._iter=i}static forUris(i=()=>!1){return new w(new t(i))}static forPaths(i=!1){return new w(new p(void 0,!i))}static forStrings(){return new w(new b)}static forConfigKeys(){return new w(new I)}clear(){this._root=void 0}fill(i,s){if(s){const u=s.slice(0);(0,v.shuffle)(u);for(let d of u)this.set(d,i)}else{const u=i.slice(0);(0,v.shuffle)(u);for(let d of u)this.set(d[0],d[1])}}set(i,s){const u=this._iter.reset(i);let d;this._root||(this._root=new g,this._root.segment=u.value());const E=[];for(d=this._root;;){const R=u.cmp(d.segment);if(R>0)d.left||(d.left=new g,d.left.segment=u.value()),E.push([-1,d]),d=d.left;else if(R<0)d.right||(d.right=new g,d.right.segment=u.value()),E.push([1,d]),d=d.right;else if(u.hasNext())u.next(),d.mid||(d.mid=new g,d.mid.segment=u.value()),E.push([0,d]),d=d.mid;else break}const L=d.value;d.value=s,d.key=i;for(let R=E.length-1;R>=0;R--){const T=E[R][1];T.updateHeight();const N=T.balanceFactor();if(N<-1||N>1){const Q=E[R][0],se=E[R+1][0];if(Q===1&&se===1)E[R][1]=T.rotateLeft();else if(Q===-1&&se===-1)E[R][1]=T.rotateRight();else if(Q===1&&se===-1)T.right=E[R+1][1]=E[R+1][1].rotateRight(),E[R][1]=T.rotateLeft();else if(Q===-1&&se===1)T.left=E[R+1][1]=E[R+1][1].rotateLeft(),E[R][1]=T.rotateRight();else throw new Error;if(R>0)switch(E[R-1][0]){case-1:E[R-1][1].left=E[R][1];break;case 1:E[R-1][1].right=E[R][1];break;case 0:E[R-1][1].mid=E[R][1];break}else this._root=E[0][1]}}return L}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let u=this._root;for(;u;){const d=s.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const u=this._iter.reset(i),d=[];let E=this._root;for(;E;){const L=u.cmp(E.segment);if(L>0)d.push([-1,E]),E=E.left;else if(L<0)d.push([1,E]),E=E.right;else if(u.hasNext())u.next(),d.push([0,E]),E=E.mid;else break}if(!!E){if(s?(E.left=void 0,E.mid=void 0,E.right=void 0,E.height=1):(E.key=void 0,E.value=void 0),!E.mid&&!E.value)if(E.left&&E.right){const L=this._min(E.right),{key:R,value:T,segment:N}=L;this._delete(L.key,!1),E.key=R,E.value=T,E.segment=N}else{const L=E.left??E.right;if(d.length>0){const[R,T]=d[d.length-1];switch(R){case-1:T.left=L;break;case 0:T.mid=L;break;case 1:T.right=L;break}}else this._root=L}for(let L=d.length-1;L>=0;L--){const R=d[L][1];R.updateHeight();const T=R.balanceFactor();if(T>1?(R.right.balanceFactor()>=0||(R.right=R.right.rotateRight()),d[L][1]=R.rotateLeft()):T<-1&&(R.left.balanceFactor()<=0||(R.left=R.left.rotateLeft()),d[L][1]=R.rotateRight()),L>0)switch(d[L-1][0]){case-1:d[L-1][1].left=d[L][1];break;case 1:d[L-1][1].right=d[L][1];break;case 0:d[L-1][1].mid=d[L][1];break}else this._root=d[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let u=this._root,d;for(;u;){const E=s.cmp(u.segment);if(E>0)u=u.left;else if(E<0)u=u.right;else if(s.hasNext())s.next(),d=u.value||d,u=u.mid;else break}return u&&u.value||d}findSuperstr(i){const s=this._iter.reset(i);let u=this._root;for(;u;){const d=s.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(i){for(const[s,u]of this)i(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=s=>{if(!s)return!0;const u=s.balanceFactor();return u<-1||u>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=w;class M{constructor(i,s){this.uri=i,this.value=s}}class c{constructor(i,s){this[D]="ResourceMap",i instanceof c?(this.map=new Map(i.map),this.toKey=s??c.defaultToKey):(this.map=new Map,this.toKey=i??c.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new M(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[u,d]of this.map)i(d.value,d.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=c,c.defaultToKey=r=>r.toString();var a;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class l{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const u=this._map.get(i);if(!!u)return s!==0&&this.touch(u,s),u.value}set(i,s,u=0){let d=this._map.get(i);if(d)d.value=s,u!==0&&this.touch(d,u);else{switch(d={key:i,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(i,d),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const u=this._state;let d=this._head;for(;d;){if(s?i.bind(s)(d.value,d.key,this):i(d.value,d.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const i=this,s=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const E={value:u.key,done:!1};return u=u.next,E}else return{value:void 0,done:!0}}};return d}values(){const i=this,s=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const E={value:u.value,done:!1};return u=u.next,E}else return{value:void 0,done:!0}}};return d}entries(){const i=this,s=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const E={value:[u.key,u.value],done:!1};return u=u.next,E}else return{value:void 0,done:!0}}};return d}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>i;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,u=i.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const u=i.next,d=i.previous;i===this._tail?(d.next=void 0,this._tail=d):(u.previous=d,d.next=u),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const u=i.next,d=i.previous;i===this._head?(u.previous=void 0,this._head=u):(u.previous=d,d.next=u),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,u)=>{i.push([u,s])}),i}fromJSON(i){this.clear();for(const[s,u]of i)this.set(s,u)}}e.LinkedMap=l;class o extends l{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class h{constructor(i){k.set(this,void 0),kt(this,k,i,"f")}get size(){return Ge(this,k,"f").size}forEach(i,s){Ge(this,k,"f").forEach(i,s)}get(i){return Ge(this,k,"f").get(i)}has(i){return Ge(this,k,"f").has(i)}entries(){return Ge(this,k,"f").entries()}keys(){return Ge(this,k,"f").keys()}values(){return Ge(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ge(this,k,"f").entries()}}e.ReadonlyMapView=h}),define(te[70],ie([0,1,35]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new v.LRUCache(1e4);function D(m){return f(m,"NFC",n)}e.normalizeNFC=D;const C=new v.LRUCache(1e4);function k(m){return f(m,"NFD",C)}e.normalizeNFD=k;const P=/[^\u0000-\u0080]/;function f(m,b,I){if(!m)return m;const p=I.get(m);if(p)return p;let y;return P.test(m)?y=m.normalize(b):y=m,I.set(m,y),y}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(b){return k(b).replace(m,"")}}()}),define(te[13],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(E){return Array.isArray(E)}e.isArray=v;function n(E){return typeof E=="string"}e.isString=n;function D(E){return Array.isArray(E)&&E.every(L=>n(L))}e.isStringArray=D;function C(E){return typeof E=="object"&&E!==null&&!Array.isArray(E)&&!(E instanceof RegExp)&&!(E instanceof Date)}e.isObject=C;function k(E){return typeof E=="number"&&!isNaN(E)}e.isNumber=k;function P(E){return!!E&&typeof E[Symbol.iterator]=="function"}e.isIterable=P;function f(E){return E===!0||E===!1}e.isBoolean=f;function m(E){return typeof E=="undefined"}e.isUndefined=m;function b(E){return!I(E)}e.isDefined=b;function I(E){return m(E)||E===null}e.isUndefinedOrNull=I;function p(E,L){if(!E)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}e.assertType=p;function y(E){if(I(E))throw new Error("Assertion Failed: argument is undefined or null");return E}e.assertIsDefined=y;function t(...E){const L=[];for(let R=0;R<E.length;R++){const T=E[R];if(I(T))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);L.push(T)}return L}e.assertAllDefined=t;const g=Object.prototype.hasOwnProperty;function S(E){if(!C(E))return!1;for(let L in E)if(g.call(E,L))return!1;return!0}e.isEmptyObject=S;function w(E){return typeof E=="function"}e.isFunction=w;function M(...E){return E.length>0&&E.every(w)}e.areFunctions=M;function c(E,L){const R=Math.min(E.length,L.length);for(let T=0;T<R;T++)a(E[T],L[T])}e.validateConstraints=c;function a(E,L){if(n(L)){if(typeof E!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(w(L)){try{if(E instanceof L)return}catch{}if(!I(E)&&E.constructor===L||L.length===1&&L.call(void 0,E)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function l(E){let L=[],R=Object.getPrototypeOf(E);for(;Object.prototype!==R;)L=L.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return L}e.getAllPropertyNames=l;function o(E){const L=[];for(const R of l(E))typeof E[R]=="function"&&L.push(R);return L}e.getAllMethodNames=o;function h(E,L){const R=N=>function(){const Q=Array.prototype.slice.call(arguments,0);return L(N,Q)};let T={};for(const N of E)T[N]=R(N);return T}e.createProxyObject=h;function r(E){return E===null?void 0:E}e.withNullAsUndefined=r;function i(E){return typeof E=="undefined"?null:E}e.withUndefinedAsNull=i;function s(E){return class{constructor(){return new Proxy({},{get(L,R){if(L[R])return L[R];throw new Error(`Not Implemented: ${E}->${String(R)}`)}})}}}e.NotImplementedProxy=s;function u(E,L="Unreachable"){throw new Error(L)}e.assertNever=u;function d(E){return!!E&&typeof E.then=="function"&&typeof E.catch=="function"}e.isPromise=d}),define(te[27],ie([0,1,9,3,25,13]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function P(s){return s.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=P;function f(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=f;function m(s,u=v.posix.sep){if(!s)return"";const d=s.length,E=s.charCodeAt(0);if(k(E)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let R=3;const T=R;for(;R<d&&!k(s.charCodeAt(R));R++);if(T!==R&&!k(s.charCodeAt(R+1))){for(R+=1;R<d;R++)if(k(s.charCodeAt(R)))return s.slice(0,R+1).replace(/[\\/]/g,u)}}return u}else if(w(E)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+u:s.slice(0,2);let L=s.indexOf("://");if(L!==-1){for(L+=3;L<d;L++)if(k(s.charCodeAt(L)))return s.slice(0,L+1)}return""}e.getRoot=m;function b(s){if(!n.isWindows||!s||s.length<5)return!1;let u=s.charCodeAt(0);if(u!==92||(u=s.charCodeAt(1),u!==92))return!1;let d=2;const E=d;for(;d<s.length&&(u=s.charCodeAt(d),u!==92);d++);return!(E===d||(u=s.charCodeAt(d+1),isNaN(u)||u===92))}e.isUNC=b;const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(s,u=n.isWindows){const d=u?I:p;return!(!s||s.length===0||/^\s+$/.test(s)||(d.lastIndex=0,d.test(s))||u&&y.test(s)||s==="."||s===".."||u&&s[s.length-1]==="."||u&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=t;function g(s,u,d){const E=s===u;return!d||E?E:!s||!u?!1:(0,D.equalsIgnoreCase)(s,u)}e.isEqual=g;function S(s,u,d,E=v.sep){if(s===u)return!0;if(!s||!u||u.length>s.length)return!1;if(d){if(!(0,D.startsWithIgnoreCase)(s,u))return!1;if(u.length===s.length)return!0;let R=u.length;return u.charAt(u.length-1)===E&&R--,s.charAt(R)===E}return u.charAt(u.length-1)!==E&&(u+=E),s.indexOf(u)===0}e.isEqualOrParent=S;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function M(s,u){return n.isWindows&&s.endsWith(":")&&(s+=v.sep),(0,v.isAbsolute)(s)||(s=(0,v.join)(u,s)),s=(0,v.normalize)(s),n.isWindows?(s=(0,D.rtrim)(s,v.sep),s.endsWith(":")&&(s+=v.sep)):(s=(0,D.rtrim)(s,v.sep),s||(s=v.sep)),s}e.sanitizeFilePath=M;function c(s){const u=(0,v.normalize)(s);return n.isWindows?s.length>3?!1:a(u)&&(s.length===2||u.charCodeAt(2)===92):u===v.posix.sep}e.isRootOrDriveLetter=c;function a(s,u){return(u!==void 0?u:n.isWindows)?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function l(s){return a(s)?s[0]:void 0}e.getDriveLetter=l;function o(s,u,d){return u.length>s.length?-1:s===u?0:(d&&(s=s.toLowerCase(),u=u.toLowerCase()),s.indexOf(u))}e.indexOfPath=o;function h(s){const u=s.split(":");let d,E,L;for(const R of u){const T=Number(R);(0,C.isNumber)(T)?E===void 0?E=T:L===void 0&&(L=T):d=d?[d,R].join(":"):R}if(!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:E!==void 0?E:void 0,column:L!==void 0?L:E!==void 0?1:void 0}}e.parseLineAndColumnAware=h;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,u,d=8){let E="";for(let R=0;R<d;R++)E+=r.charAt(Math.floor(Math.random()*r.length));let L;return u?L=`${u}-${E}`:L=E,s?(0,v.join)(s,L):L}e.randomPath=i}),define(te[47],ie([0,1,13]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const S=Array.isArray(g)?[]:{};return Object.keys(g).forEach(w=>{g[w]&&typeof g[w]=="object"?S[w]=n(g[w]):S[w]=g[w]}),S}e.deepClone=n;function D(g){if(!g||typeof g!="object")return g;const S=[g];for(;S.length>0;){const w=S.shift();Object.freeze(w);for(const M in w)if(C.call(w,M)){const c=w[M];typeof c=="object"&&!Object.isFrozen(c)&&S.push(c)}}return g}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function k(g,S){return P(g,S,new Set)}e.cloneAndChange=k;function P(g,S,w){if((0,v.isUndefinedOrNull)(g))return g;const M=S(g);if(typeof M!="undefined")return M;if((0,v.isArray)(g)){const c=[];for(const a of g)c.push(P(a,S,w));return c}if((0,v.isObject)(g)){if(w.has(g))throw new Error("Cannot clone recursive data-structure");w.add(g);const c={};for(let a in g)C.call(g,a)&&(c[a]=P(g[a],S,w));return w.delete(g),c}return g}function f(g,S,w=!0){return(0,v.isObject)(g)?((0,v.isObject)(S)&&Object.keys(S).forEach(M=>{M in g?w&&((0,v.isObject)(g[M])&&(0,v.isObject)(S[M])?f(g[M],S[M],w):g[M]=S[M]):g[M]=S[M]}),g):S}e.mixin=f;function m(g,S){if(g===S)return!0;if(g==null||S===null||S===void 0||typeof g!=typeof S||typeof g!="object"||Array.isArray(g)!==Array.isArray(S))return!1;let w,M;if(Array.isArray(g)){if(g.length!==S.length)return!1;for(w=0;w<g.length;w++)if(!m(g[w],S[w]))return!1}else{const c=[];for(M in g)c.push(M);c.sort();const a=[];for(M in S)a.push(M);if(a.sort(),!m(c,a))return!1;for(w=0;w<c.length;w++)if(!m(g[c[w]],S[c[w]]))return!1}return!0}e.equals=m;function b(g){const S=new Set;return JSON.stringify(g,(w,M)=>{if((0,v.isObject)(M)||Array.isArray(M)){if(S.has(M))return"[Circular]";S.add(M)}return M})}e.safeStringify=b;function I(g,S,w){const M=S(g);return typeof M=="undefined"?w:M}e.getOrDefault=I;function p(g,S){const w=Object.create(null);return!g||!S||Object.keys(S).forEach(c=>{const a=g[c],l=S[c];m(a,l)||(w[c]=l)}),w}e.distinct=p;function y(g,S){const w=S.toLowerCase(),M=Object.keys(g).find(c=>c.toLowerCase()===w);return M?g[M]:g[S]}e.getCaseInsensitive=y;function t(g,S){const w=Object.create(null);for(const[M,c]of Object.entries(g))S(M,c)&&(w[M]=c);return w}e.filter=t}),define(te[7],ie([0,1,9,3]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,k=/^\/\//;function P(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!C.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,i){return!r&&!i?"file":r}function m(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const b="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(i,s,u,d,E,L=!1){typeof i=="object"?(this.scheme=i.scheme||b,this.authority=i.authority||b,this.path=i.path||b,this.query=i.query||b,this.fragment=i.fragment||b):(this.scheme=f(i,L),this.authority=s||b,this.path=m(this.scheme,u||b),this.query=d||b,this.fragment=E||b,P(this,L))}static isUri(i){return i instanceof y?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return c(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:u,path:d,query:E,fragment:L}=i;return s===void 0?s=this.scheme:s===null&&(s=b),u===void 0?u=this.authority:u===null&&(u=b),d===void 0?d=this.path:d===null&&(d=b),E===void 0?E=this.query:E===null&&(E=b),L===void 0?L=this.fragment:L===null&&(L=b),s===this.scheme&&u===this.authority&&d===this.path&&E===this.query&&L===this.fragment?this:new g(s,u,d,E,L)}static parse(i,s=!1){const u=p.exec(i);return u?new g(u[2]||b,h(u[4]||b),h(u[5]||b),h(u[7]||b),h(u[9]||b),s):new g(b,b,b,b,b)}static file(i){let s=b;if(n.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const u=i.indexOf(I,2);u===-1?(s=i.substring(2),i=I):(s=i.substring(2,u),i=i.substring(u)||I)}return new g("file",s,i,b,b)}static from(i){const s=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return P(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return n.isWindows&&i.scheme==="file"?u=y.file(v.win32.join(c(i,!0),...s)).path:u=v.posix.join(i.path,...s),i.with({path:u})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof y)return i;{const s=new g(i);return s._formatted=i.external,s._fsPath=i._sep===t?i.fsPath:null,s}}else return i}}e.URI=y;const t=n.isWindows?1:void 0;class g extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(r,i){let s,u=-1;for(let d=0;d<r.length;d++){const E=r.charCodeAt(d);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||i&&E===47)u!==-1&&(s+=encodeURIComponent(r.substring(u,d)),u=-1),s!==void 0&&(s+=r.charAt(d));else{s===void 0&&(s=r.substr(0,d));const L=S[E];L!==void 0?(u!==-1&&(s+=encodeURIComponent(r.substring(u,d)),u=-1),s+=L):u===-1&&(u=d)}}return u!==-1&&(s+=encodeURIComponent(r.substring(u))),s!==void 0?s:r}function M(r){let i;for(let s=0;s<r.length;s++){const u=r.charCodeAt(s);u===35||u===63?(i===void 0&&(i=r.substr(0,s)),i+=S[u]):i!==void 0&&(i+=r[s])}return i!==void 0?i:r}function c(r,i){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,n.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=c;function a(r,i){const s=i?M:w;let u="",{scheme:d,authority:E,path:L,query:R,fragment:T}=r;if(d&&(u+=d,u+=":"),(E||d==="file")&&(u+=I,u+=I),E){let N=E.indexOf("@");if(N!==-1){const Q=E.substr(0,N);E=E.substr(N+1),N=Q.indexOf(":"),N===-1?u+=s(Q,!1):(u+=s(Q.substr(0,N),!1),u+=":",u+=s(Q.substr(N+1),!1)),u+="@"}E=E.toLowerCase(),N=E.indexOf(":"),N===-1?u+=s(E,!1):(u+=s(E.substr(0,N),!1),u+=E.substr(N))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const N=L.charCodeAt(1);N>=65&&N<=90&&(L=`/${String.fromCharCode(N+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const N=L.charCodeAt(0);N>=65&&N<=90&&(L=`${String.fromCharCode(N+32)}:${L.substr(2)}`)}u+=s(L,!0)}return R&&(u+="?",u+=s(R,!1)),T&&(u+="#",u+=i?T:w(T,!1)),u}function l(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+l(r.substr(3)):r}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(r){return r.match(o)?r.replace(o,i=>l(i)):r}}),define(te[111],ie([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(m){const b=m;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=n;function D(m){const b=[];let I;try{const p=JSON.parse(m.arguments),y=p[p.length-1];y&&y.__$stack&&(p.pop(),I=y.__$stack),b.push(...p)}catch{b.push("Unable to log remote console arguments",m.arguments)}return{args:b,stack:I}}e.parse=D;function C(m){if(typeof m!="string")return C(D(m).stack);const b=m;if(b){const I=k(b),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:v.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=C;function k(m){if(!m)return m;const b=m.indexOf(`
`);return b===-1?m:m.substring(0,b)}function P(m,b){const{args:I,stack:p}=D(m),y=typeof I[0]=="string"&&I.length===1;let t=k(p);t&&(t=`(${t.trim()})`);let g=[];if(typeof I[0]=="string"?t&&y?g=[`%c[${b}] %c${I[0]} %c${t}`,f("blue"),f(""),f("grey")]:g=[`%c[${b}] %c${I[0]}`,f("blue"),f(""),...I.slice(1)]:g=[`%c[${b}]%`,f("blue"),...I],t&&!y&&g.push(t),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,g)}e.log=P;function f(m){return`color: ${m}`}}),define(te[112],ie([0,1,17,25,7]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(b){return JSON.stringify(b,f)}e.stringify=C;function k(b){let I=JSON.parse(b);return I=m(I),I}e.parse=k;var P;(function(b){b[b.Uri=1]="Uri",b[b.Regexp=2]="Regexp",b[b.ScmResource=3]="ScmResource",b[b.ScmResourceGroup=4]="ScmResourceGroup",b[b.ScmProvider=5]="ScmProvider",b[b.CommentController=6]="CommentController",b[b.CommentThread=7]="CommentThread",b[b.CommentThreadReply=8]="CommentThreadReply",b[b.CommentNode=9]="CommentNode",b[b.CommentThreadNode=10]="CommentThreadNode",b[b.TimelineActionContext=11]="TimelineActionContext",b[b.NotebookCellActionContext=12]="NotebookCellActionContext",b[b.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function f(b,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,n.regExpFlags)(I)}:I}function m(b,I=0){if(!b||I>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return D.URI.revive(b);case 2:return new RegExp(b.source,b.flags)}if(b instanceof v.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let p=0;p<b.length;++p)b[p]=m(b[p],I+1);else for(const p in b)Object.hasOwnProperty.call(b,p)&&(b[p]=m(b[p],I+1))}return b}e.revive=m}),define(te[10],ie([0,1,3,7]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,m,b){this._hosts[f]=m,this._ports[f]=b}setConnectionToken(f,m){this._connectionTokens[f]=m}rewrite(f){if(this._delegate)return this._delegate(f);const m=f.authority;let b=this._hosts[m];b&&b.indexOf(":")!==-1&&(b=`[${b}]`);const I=this._ports[m],p=this._connectionTokens[m];let y=`path=${encodeURIComponent(f.path)}`;return typeof p=="string"&&(y+=`&tkn=${encodeURIComponent(p)}`),n.URI.from({scheme:v.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${b}:${I}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new C;class k{asBrowserUri(f,m){const b=this.toUri(f,m);return b.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===D.file&&(v.isNative||typeof v.globals.importScripts=="function"&&v.globals.origin===`${D.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?b.with({scheme:D.vscodeFileResource,authority:b.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(f,m){const b=this.toUri(f,m);return b.scheme===D.vscodeFileResource?b.with({scheme:D.file,authority:b.authority!==k.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(f,m){return n.URI.isUri(f)?f:n.URI.parse(m.toUrl(f))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(te[16],ie([0,1,27,10,9,3,25,7]),function(K,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(y){return(0,P.uriToFsPath)(y,!0)}e.originalFSPath=f;class m{constructor(t){this._ignorePathCasing=t}compare(t,g,S=!1){return t===g?0:(0,k.compare)(this.getComparisonKey(t,S),this.getComparisonKey(g,S))}isEqual(t,g,S=!1){return t===g?!0:!t||!g?!1:this.getComparisonKey(t,S)===this.getComparisonKey(g,S)}getComparisonKey(t,g=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,g,S=!1){if(t.scheme===g.scheme){if(t.scheme===n.Schemas.file)return v.isEqualOrParent(f(t),f(g),this._ignorePathCasing(t))&&t.query===g.query&&(S||t.fragment===g.fragment);if((0,e.isEqualAuthority)(t.authority,g.authority))return v.isEqualOrParent(t.path,g.path,this._ignorePathCasing(t),"/")&&t.query===g.query&&(S||t.fragment===g.fragment)}return!1}joinPath(t,...g){return P.URI.joinPath(t,...g)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let g;return t.scheme===n.Schemas.file?g=P.URI.file(D.dirname(f(t))).path:(g=D.posix.dirname(t.path),t.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),g="/")),t.with({path:g})}normalizePath(t){if(!t.path.length)return t;let g;return t.scheme===n.Schemas.file?g=P.URI.file(D.normalize(f(t))).path:g=D.posix.normalize(t.path),t.with({path:g})}relativePath(t,g){if(t.scheme!==g.scheme||!(0,e.isEqualAuthority)(t.authority,g.authority))return;if(t.scheme===n.Schemas.file){const M=D.relative(f(t),f(g));return C.isWindows?v.toSlashes(M):M}let S=t.path||"/",w=g.path||"/";if(this._ignorePathCasing(t)){let M=0;for(const c=Math.min(S.length,w.length);M<c&&!(S.charCodeAt(M)!==w.charCodeAt(M)&&S.charAt(M).toLowerCase()!==w.charAt(M).toLowerCase());M++);S=w.substr(0,M)+S.substr(M)}return D.posix.relative(S,w)}resolvePath(t,g){if(t.scheme===n.Schemas.file){const S=P.URI.file(D.resolve(f(t),g));return t.with({authority:S.authority,path:S.path})}return g=v.toPosixPath(g),t.with({path:D.posix.resolve(t.path,g)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,g){return t===g||t!==void 0&&g!==void 0&&(0,k.equalsIgnoreCase)(t,g)}hasTrailingPathSeparator(t,g=D.sep){if(t.scheme===n.Schemas.file){const S=f(t);return S.length>v.getRoot(S).length&&S[S.length-1]===g}else{const S=t.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,g=D.sep){return(0,e.hasTrailingPathSeparator)(t,g)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,g=D.sep){let S=!1;if(t.scheme===n.Schemas.file){const w=f(t);S=w!==void 0&&w.length===v.getRoot(w).length&&w[w.length-1]===g}else{g="/";const w=t.path;S=w.length===1&&w.charCodeAt(w.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(t,g)?t.with({path:t.path+"/"}):t}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(y=>y.scheme===n.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new m(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(y,t){const g=[];for(let S=0;S<y.length;S++){const w=t(y[S]);y.some((M,c)=>c===S?!1:(0,e.isEqualOrParent)(w,t(M)))||g.push(y[S])}return g}e.distinctParents=b;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function t(g){const S=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(c=>{const[a,l]=c.split(":");a&&l&&S.set(a,l)});const M=g.path.substring(0,g.path.indexOf(";"));return M&&S.set(y.META_DATA_MIME,M),S}y.parseMetaData=t})(I=e.DataUri||(e.DataUri={}));function p(y,t,g){if(t){let S=y.path;return S&&S[0]!==D.posix.sep&&(S=D.posix.sep+S),y.with({scheme:g,authority:t,path:S})}return y.with({scheme:g})}e.toLocalResource=p}),define(te[8],ie([0,1,21,15,4,2,16,3]),function(K,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(W){return!!W&&typeof W.then=="function"}e.isThenable=f;function m(W){const A=new v.CancellationTokenSource,_=W(A.token),U=new Promise((O,B)=>{const J=A.token.onCancellationRequested(()=>{J.dispose(),A.dispose(),B((0,n.canceled)())});Promise.resolve(_).then(ee=>{J.dispose(),A.dispose(),O(ee)},ee=>{J.dispose(),A.dispose(),B(ee)})});return new class{cancel(){A.cancel()}then(O,B){return U.then(O,B)}catch(O){return this.then(void 0,O)}finally(O){return U.finally(O)}}}e.createCancelablePromise=m;function b(W,A,_){return Promise.race([W,new Promise(U=>A.onCancellationRequested(()=>U(_)))])}e.raceCancellation=b;async function I(W){let A=-1;const _=W.map((O,B)=>O.then(J=>(A=B,J))),U=await Promise.race(_);return W.forEach((O,B)=>{B!==A&&O.cancel()}),U}e.raceCancellablePromises=I;function p(W,A,_){let U;const O=setTimeout(()=>{U?.(void 0),_?.()},A);return Promise.race([W.finally(()=>clearTimeout(O)),new Promise(B=>U=B)])}e.raceTimeout=p;function y(W){return new Promise((A,_)=>{const U=W();f(U)?U.then(A,_):A(U)})}e.asPromise=y;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const _=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(_,_).then(U)})}return new Promise((_,U)=>{this.queuedPromise.then(_,U)})}return this.activePromise=A(),new Promise((_,U)=>{this.activePromise.then(O=>{this.activePromise=null,_(O)},O=>{this.activePromise=null,U(O)})})}}e.Throttler=t;class g{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=g;class S{constructor(){this.promiseMap=new Map}queue(A,_){const O=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.promiseMap.get(A)===O&&this.promiseMap.delete(A)});return this.promiseMap.set(A,O),O}}e.SequencerByKey=S;const w=(W,A)=>{let _=!0;const U=setTimeout(()=>{_=!1,A()},W);return{isTriggered:()=>_,dispose:()=>{clearTimeout(U),_=!1}}},M=W=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,W())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,_=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,B)=>{this.doResolve=O,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}}));const U=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=_===e.MicrotaskDelay?M(U):w(_,U),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,n.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class a{constructor(A){this.delayer=new c(A),this.throttler=new t}trigger(A,_){return this.delayer.trigger(()=>this.throttler.queue(A),_)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=a;class l{constructor(){this._isOpen=!1,this._promise=new Promise((A,_)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class o extends l{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function h(W,A){return A?new Promise((_,U)=>{const O=setTimeout(()=>{B.dispose(),_()},W),B=A.onCancellationRequested(()=>{clearTimeout(O),B.dispose(),U((0,n.canceled)())})}):m(_=>h(W,_))}e.timeout=h;function r(W,A=0){const _=setTimeout(W,A);return(0,C.toDisposable)(()=>clearTimeout(_))}e.disposableTimeout=r;function i(W){const A=[];let _=0;const U=W.length;function O(){return _<U?W[_++]():null}function B(J){J!=null&&A.push(J);const ee=O();return ee?ee.then(B):Promise.resolve(A)}return Promise.resolve(null).then(B)}e.sequence=i;function s(W,A=U=>!!U,_=null){let U=0;const O=W.length,B=()=>{if(U>=O)return Promise.resolve(_);const J=W[U++];return Promise.resolve(J()).then(oe=>A(oe)?Promise.resolve(oe):B())};return B()}e.first=s;function u(W,A=U=>!!U,_=null){if(W.length===0)return Promise.resolve(_);let U=W.length;const O=()=>{U=-1;for(const B of W)B.cancel?.()};return new Promise((B,J)=>{for(const ee of W)ee.then(oe=>{--U>=0&&A(oe)?(O(),B(oe)):U===0&&B(_)}).catch(oe=>{--U>=0&&(O(),J(oe))})})}e.firstParallel=u;class d{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(A){return this._size++,new Promise((_,U)=>{this.outstandingPromises.push({factory:A,c:_,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const _=A.factory();_.then(A.c,A.e),_.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=d;class E extends d{constructor(){super(1)}}e.Queue=E;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new Y;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,_=k.extUri){const U=_.getComparisonKey(A);let O=this.queues.get(U);return O||(O=new E,D.Event.once(O.onFinished)(()=>{O?.dispose(),this.queues.delete(U),this.onDidQueueFinish()}),this.queues.set(U,O)),O}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class R{constructor(A,_){this._token=-1,typeof A=="function"&&typeof _=="number"&&this.setIfNotSet(A,_)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,_){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},_)}setIfNotSet(A,_){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},_))}}e.TimeoutTimer=R;class T{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,_){this.cancel(),this._token=setInterval(()=>{A()},_)}}e.IntervalTimer=T;class N{constructor(A,_){this.timeoutToken=-1,this.runner=A,this.timeout=_,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=N;class Q{constructor(A,_){_%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=_,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=Q;class se extends N{constructor(A,_){super(A,_);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner&&this.runner(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=se;class ne extends C.Disposable{constructor(A,_,U,O){super();this.maxWorkChunkSize=A,this.maxPendingWork=_,this.throttleDelay=U,this.handler=O,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.maxPendingWork)return!1}else if(this.pending+A.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{(0,P.setTimeout0)(()=>{if(A)return;const _=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(W,A)=>{const _=requestIdleCallback(W,typeof A=="number"?{timeout:A}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(_))}}}}();class V{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(_){this._error=_}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function Z(W,A,_){let U;for(let O=0;O<_;O++)try{return await W()}catch(B){U=B,await h(A)}throw U}e.retry=Z;class H{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,_,U){return this._pending={taskId:A,cancel:()=>U?.(),promise:_},_.then(()=>this.donePending(A),()=>this.donePending(A)),_}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let _,U;const O=new Promise((B,J)=>{_=B,U=J});this._next={run:A,promise:O,promiseResolve:_,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=H;class q{constructor(A,_=()=>Date.now()){this.interval=A,this.nowFn=_,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class Y{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,_)=>{this.completeCallback=A,this.errorCallback=_})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(_=>{this.completeCallback(A),this.resolved=!0,_()})}error(A){return new Promise(_=>{this.errorCallback(A),this.rejected=!0,_()})}cancel(){new Promise(A=>{this.errorCallback((0,n.canceled)()),this.rejected=!0,A()})}}e.DeferredPromise=Y;var j;(function(W){async function A(U){let O;const B=await Promise.all(U.map(J=>J.then(ee=>ee,ee=>{O||(O=ee)})));if(typeof O!="undefined")throw O;return B}W.settled=A;function _(U){return new Promise(async(O,B)=>{try{await U(O,B)}catch(J){B(J)}})}W.withAsyncBody=_})(j=e.Promises||(e.Promises={}));var z;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(z||(z={}));class G{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const _={emitOne:U=>this.emitOne(U),emitMany:U=>this.emitMany(U),reject:U=>this.reject(U)};try{await Promise.resolve(A(_)),this.resolve()}catch(U){this.reject(U)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}static fromArray(A){return new G(_=>{_.emitMany(A)})}static fromPromise(A){return new G(async _=>{_.emitMany(await A)})}static fromPromises(A){return new G(async _=>{await Promise.all(A.map(async U=>_.emitOne(await U)))})}static merge(A){return new G(async _=>{await Promise.all(A.map(async U=>{for await(const O of U)_.emitOne(O)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,_){return new G(async U=>{for await(const O of A)U.emitOne(_(O))})}map(A){return G.map(this,A)}static filter(A,_){return new G(async U=>{for await(const O of A)_(O)&&U.emitOne(O)})}filter(A){return G.filter(this,A)}static coalesce(A){return G.filter(A,_=>!!_)}coalesce(){return G.coalesce(this)}static async toPromise(A){const _=[];for await(const U of A)_.push(U);return _}toPromise(){return G.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=G,G.EMPTY=G.fromArray([]);class $ extends G{constructor(A,_){super(_);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=$;function F(W){const A=new v.CancellationTokenSource,_=W(A.token);return new $(A,async U=>{const O=A.token.onCancellationRequested(()=>{O.dispose(),A.dispose(),U.reject((0,n.canceled)())});try{for await(const B of _){if(A.token.isCancellationRequested)return;U.emitOne(B)}O.dispose(),A.dispose()}catch(B){O.dispose(),A.dispose(),U.reject(B)}})}e.createCancelableAsyncIterable=F}),define(te[113],ie([0,1,8,27,35,9,25]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const f="**",m="/",b="[/\\\\]",I="[^/\\\\]",p=/\//g;function y(z){switch(z){case 0:return"";case 1:return`${I}*?`;default:return`(?:${b}|${I}+${b}|${b}${I}+)*?`}}function t(z,G){if(!z)return[];const $=[];let F=!1,W=!1,A="";for(const _ of z){switch(_){case G:if(!F&&!W){$.push(A),A="";continue}break;case"{":F=!0;break;case"}":F=!1;break;case"[":W=!0;break;case"]":W=!1;break}A+=_}return A&&$.push(A),$}e.splitGlobAware=t;function g(z){if(!z)return"";let G="";const $=t(z,m);if($.every(F=>F===f))G=".*";else{let F=!1;$.forEach((W,A)=>{if(W===f){F||(G+=y(2),F=!0);return}let _=!1,U="",O=!1,B="";for(const J of W){if(J!=="}"&&_){U+=J;continue}if(O&&(J!=="]"||!B)){let ee;J==="-"?ee=J:(J==="^"||J==="!")&&!B?ee="^":J===m?ee="":ee=k.escapeRegExpCharacters(J),B+=ee;continue}switch(J){case"{":_=!0;continue;case"[":O=!0;continue;case"}":{G+=`(?:${t(U,",").map(x=>g(x)).join("|")})`,_=!1,U="";break}case"]":G+="["+B+"]",O=!1,B="";break;case"?":G+=I;continue;case"*":G+=y(1);continue;default:G+=k.escapeRegExpCharacters(J)}}A<$.length-1&&($[A+1]!==f||A+2<$.length)&&(G+=b),F=!1})}return G}const S=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,M=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new D.LRUCache(1e4),h=function(){return!1},r=function(){return null};function i(z,G){if(!z)return r;let $;typeof z!="string"?$=z.pattern:$=z,$=$.trim();const F=`${$}_${!!G.trimForExclusions}`;let W=o.get(F);if(W)return s(W,z);let A;if(S.test($)){const _=$.substr(4);W=function(U,O){return typeof U=="string"&&U.endsWith(_)?$:null}}else(A=w.exec(u($,G)))?W=d(A[1],$):(G.trimForExclusions?c:M).test($)?W=E($,G):(A=a.exec(u($,G)))?W=L(A[1].substr(1),$,!0):(A=l.exec(u($,G)))?W=L(A[1],$,!1):W=R($);return o.set(F,W),s(W,z)}function s(z,G){return typeof G=="string"?z:function($,F){return n.isEqualOrParent($,G.base)?z(C.relative(G.base,$),F):null}}function u(z,G){return G.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function d(z,G){const $=`/${z}`,F=`\\${z}`,W=function(_,U){return typeof _!="string"?null:U?U===z?G:null:_===z||_.endsWith($)||_.endsWith(F)?G:null},A=[z];return W.basenames=A,W.patterns=[G],W.allBasenames=A,W}function E(z,G){const $=j(z.slice(1,-1).split(",").map(U=>i(U,G)).filter(U=>U!==r),z),F=$.length;if(!F)return r;if(F===1)return $[0];const W=function(U,O){for(let B=0,J=$.length;B<J;B++)if($[B](U,O))return z;return null},A=$.find(U=>!!U.allBasenames);A&&(W.allBasenames=A.allBasenames);const _=$.reduce((U,O)=>O.allPaths?U.concat(O.allPaths):U,[]);return _.length&&(W.allPaths=_),W}function L(z,G,$){const F=C.sep===C.posix.sep,W=F?z:z.replace(p,C.sep),A=C.sep+W,_=C.posix.sep+z,U=$?function(O,B){return typeof O=="string"&&(O===W||O.endsWith(A)||!F&&(O===z||O.endsWith(_)))?G:null}:function(O,B){return typeof O=="string"&&(O===W||!F&&O===z)?G:null};return U.allPaths=[($?"*/":"./")+z],U}function R(z){try{const G=new RegExp(`^${g(z)}$`);return function($){return G.lastIndex=0,typeof $=="string"&&G.test($)?z:null}}catch{return r}}function T(z,G,$){return!z||typeof G!="string"?!1:N(z)(G,void 0,$)}e.match=T;function N(z,G={}){if(!z)return h;if(typeof z=="string"||V(z)){const $=i(z,G);if($===r)return h;const F=function(W,A){return!!$(W,A)};return $.allBasenames&&(F.allBasenames=$.allBasenames),$.allPaths&&(F.allPaths=$.allPaths),F}return q(z,G)}e.parse=N;function Q(z){if(!z)return;let G;return $=>(G||(G=(z()||Promise.resolve([])).then(F=>F?ne(F):{})),G.then(F=>!!F[$]))}e.hasSiblingPromiseFn=Q;function se(z){if(!z)return;let G;return $=>{if(!G){const F=z();G=F?ne(F):{}}return!!G[$]}}e.hasSiblingFn=se;function ne(z){const G={};for(const $ of z)G[$]=!0;return G}function V(z){const G=z;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=V;function Z(z){return z.allBasenames||[]}e.getBasenameTerms=Z;function H(z){return z.allPaths||[]}e.getPathTerms=H;function q(z,G){const $=j(Object.getOwnPropertyNames(z).map(U=>Y(U,z[U],G)).filter(U=>U!==r)),F=$.length;if(!F)return r;if(!$.some(U=>!!U.requiresSiblings)){if(F===1)return $[0];const U=function(J,ee){for(let oe=0,x=$.length;oe<x;oe++){const ce=$[oe](J,ee);if(ce)return ce}return null},O=$.find(J=>!!J.allBasenames);O&&(U.allBasenames=O.allBasenames);const B=$.reduce((J,ee)=>ee.allPaths?J.concat(ee.allPaths):J,[]);return B.length&&(U.allPaths=B),U}const W=function(U,O,B){let J;for(let ee=0,oe=$.length;ee<oe;ee++){const x=$[ee];x.requiresSiblings&&B&&(O||(O=C.basename(U)),J||(J=O.substr(0,O.length-C.extname(U).length)));const ce=x(U,O,J,B);if(ce)return ce}return null},A=$.find(U=>!!U.allBasenames);A&&(W.allBasenames=A.allBasenames);const _=$.reduce((U,O)=>O.allPaths?U.concat(O.allPaths):U,[]);return _.length&&(W.allPaths=_),W}function Y(z,G,$){if(G===!1)return r;const F=i(z,$);if(F===r)return r;if(typeof G=="boolean")return F;if(G){const W=G.when;if(typeof W=="string"){const A=(_,U,O,B)=>{if(!B||!F(_,U))return null;const J=W.replace("$(basename)",O),ee=B(J);return(0,v.isThenable)(ee)?ee.then(oe=>oe?z:null):ee?z:null};return A.requiresSiblings=!0,A}}return F}function j(z,G){const $=z.filter(U=>!!U.basenames);if($.length<2)return z;const F=$.reduce((U,O)=>{const B=O.basenames;return B?U.concat(B):U},[]);let W;if(G){W=[];for(let U=0,O=F.length;U<O;U++)W.push(G)}else W=$.reduce((U,O)=>{const B=O.patterns;return B?U.concat(B):U},[]);const A=function(U,O){if(typeof U!="string")return null;if(!O){let J;for(J=U.length;J>0;J--){const ee=U.charCodeAt(J-1);if(ee===47||ee===92)break}O=U.substr(J)}const B=F.indexOf(O);return B!==-1?W[B]:null};A.basenames=F,A.patterns=W,A.allBasenames=F;const _=z.filter(U=>!U.basenames);return _.push(A),_}}),define(te[33],ie([0,1,27,10,9,3,16,25,7]),function(K,e,v,n,D,C,k,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function m(i,s,u){if(typeof i=="string"&&(i=f.URI.file(i)),u){const E=u.getWorkspaceFolder(i);if(E){const L=u.getWorkspace().folders.length>1;let R;if((0,k.isEqual)(E.uri,i)?R="":R=(0,k.relativePath)(E.uri,i),L){const T=E.name?E.name:(0,k.basename)(E.uri);R=R?T+" \u2022 "+R:T}return R}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,v.hasDriveLetter)(i.fsPath))return(0,D.normalize)(I(i.fsPath));let d=(0,D.normalize)(i.fsPath);return!C.isWindows&&s?.userHome&&(d=y(d,s.userHome.fsPath)),d}e.getPathLabel=m;function b(i){if(!i)return;typeof i=="string"&&(i=f.URI.file(i));const s=(0,k.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,v.isRootOrDriveLetter)(s)?I(s):s}e.getBaseLabel=b;function I(i,s){return(0,v.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let p=Object.create(null);function y(i,s){if(C.isWindows||!i||!s)return i;let u=p.original===s?p.normalized:void 0;return u||(u=`${(0,P.rtrim)(s,D.posix.sep)}${D.posix.sep}`,p={original:s,normalized:u}),(C.isLinux?i.startsWith(u):(0,P.startsWithIgnoreCase)(i,u))&&(i=`~/${i.substr(u.length)}`),i}e.tildify=y;function t(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=t;const g="\u2026",S="\\\\",w="~";function M(i,s=D.sep){const u=new Array(i.length);let d=!1;for(let E=0;E<i.length;E++){let L=i[E];if(L===""){u[E]=`.${s}`;continue}if(!L){u[E]=L;continue}d=!0;let R="";L.indexOf(S)===0?(R=L.substr(0,L.indexOf(S)+S.length),L=L.substr(L.indexOf(S)+S.length)):L.indexOf(s)===0?(R=L.substr(0,L.indexOf(s)+s.length),L=L.substr(L.indexOf(s)+s.length)):L.indexOf(w)===0&&(R=L.substr(0,L.indexOf(w)+w.length),L=L.substr(L.indexOf(w)+w.length));const T=L.split(s);for(let N=1;d&&N<=T.length;N++)for(let Q=T.length-N;d&&Q>=0;Q--){d=!1;let se=T.slice(Q,Q+N).join(s);for(let ne=0;!d&&ne<i.length;ne++)if(ne!==E&&i[ne]&&i[ne].indexOf(se)>-1){const V=Q+N===T.length,Z=Q>0&&i[ne].indexOf(s)>-1?s+se:se,H=i[ne].endsWith(Z);d=!V||H}if(!d){let ne="";(T[0].endsWith(":")||R!=="")&&(Q===1&&(Q=0,N++,se=T[0]+s+se),Q>0&&(ne=T[0]+s),ne=R+ne),Q>0&&(ne=ne+g+s),ne=ne+se,Q+N<T.length&&(ne=ne+s+g),u[E]=ne}}d&&(u[E]=L)}return u}e.shorten=M;var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function a(i,s=Object.create(null)){const u=[];let d=!1,E="";for(const L of i)if(L==="$"||d&&L==="{")E&&u.push({value:E,type:c.TEXT}),E="",d=!0;else if(L==="}"&&d){const R=s[E];if(typeof R=="string")R.length&&u.push({value:R,type:c.VARIABLE});else if(R){const T=u[u.length-1];(!T||T.type!==c.SEPARATOR)&&u.push({value:R.label,type:c.SEPARATOR})}E="",d=!1}else E+=L;return E&&!d&&u.push({value:E,type:c.TEXT}),u.filter((L,R)=>{if(L.type===c.SEPARATOR){const T=u[R-1],N=u[R+1];return[T,N].every(Q=>Q&&(Q.type===c.VARIABLE||Q.type===c.TEXT)&&Q.value.length>0)}return!0}).map(L=>L.value).join("")}e.template=a;function l(i,s){return C.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function o(i,s){return C.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function h(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=h;function r(i){const s=i.indexOf("/")!==-1?D.posix:D.win32,u=s.basename(i),d=s.dirname(i);return u.length?{name:u,parentPath:d}:{name:d,parentPath:""}}e.splitName=r}),define(te[114],ie([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(b){return b.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const p=this._uriTransformer.transformIncoming(I);return p===I?I:n(v.URI.from(p))}transformOutgoing(I){const p=this._uriTransformer.transformOutgoing(I);return p===I?I:n(v.URI.from(p))}transformOutgoingURI(I){const p=this._uriTransformer.transformOutgoing(I);return p===I?I:v.URI.from(p)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function C(b,I,p){if(!b||p>200)return null;if(typeof b=="object"){if(b instanceof v.URI)return I.transformOutgoing(b);for(let y in b)if(Object.hasOwnProperty.call(b,y)){const t=C(b[y],I,p+1);t!==null&&(b[y]=t)}}return null}function k(b,I){const p=C(b,I,0);return p===null?b:p}e.transformOutgoingURIs=k;function P(b,I,p,y){if(!b||y>200)return null;if(typeof b=="object"){if(b.$mid===1)return p?v.URI.revive(I.transformIncoming(b)):I.transformIncoming(b);for(let t in b)if(Object.hasOwnProperty.call(b,t)){const g=P(b[t],I,p,y+1);g!==null&&(b[t]=g)}}return null}function f(b,I){const p=P(b,I,!1,0);return p===null?b:p}e.transformIncomingURIs=f;function m(b,I){const p=P(b,I,!0,0);return p===null?b:p}e.transformAndReviveIncomingURIs=m}),define(te[32],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(f){return v.test(f)}e.isUUID=n;const D=new Uint8Array(16),C=[];for(let f=0;f<256;f++)C.push(f.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(f){for(let m=0;m<f.length;m++)f[m]=Math.floor(Math.random()*256);return f};function P(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let f=0,m="";return m+=C[D[f++]],m+=C[D[f++]],m+=C[D[f++]],m+=C[D[f++]],m+="-",m+=C[D[f++]],m+=C[D[f++]],m+="-",m+=C[D[f++]],m+=C[D[f++]],m+="-",m+=C[D[f++]],m+=C[D[f++]],m+="-",m+=C[D[f++]],m+=C[D[f++]],m+=C[D[f++]],m+=C[D[f++]],m+=C[D[f++]],m+=C[D[f++]],m}e.generateUuid=P}),define(te[115],ie([0,1,15,4,2,3,13,25]),function(K,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const f="$initialize";let m=!1;function b(r){!C.isWeb||(m||(m=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(r.message))}e.logOnceWebWorkerWarning=b;var I;(function(r){r[r.Request=0]="Request",r[r.Reply=1]="Reply",r[r.SubscribeEvent=2]="SubscribeEvent",r[r.Event=3]="Event",r[r.UnsubscribeEvent=4]="UnsubscribeEvent"})(I||(I={}));class p{constructor(i,s,u,d){this.vsWorker=i,this.req=s,this.method=u,this.args=d,this.type=0}}class y{constructor(i,s,u,d){this.vsWorker=i,this.seq=s,this.res=u,this.err=d,this.type=1}}class t{constructor(i,s,u,d){this.vsWorker=i,this.req=s,this.eventName=u,this.arg=d,this.type=2}}class g{constructor(i,s,u){this.vsWorker=i,this.req=s,this.event=u,this.type=3}}class S{constructor(i,s){this.vsWorker=i,this.req=s,this.type=4}}class w{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,s){const u=String(++this._lastSentReq);return new Promise((d,E)=>{this._pendingReplies[u]={resolve:d,reject:E},this._send(new p(this._workerId,u,i,s))})}listen(i,s){let u=null;const d=new n.Emitter({onFirstListenerAdd:()=>{u=String(++this._lastSentReq),this._pendingEmitters.set(u,d),this._send(new t(this._workerId,u,i,s))},onLastListenerRemove:()=>{this._pendingEmitters.delete(u),this._send(new S(this._workerId,u)),u=null}});return d.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let s=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let u=i.err;i.err.$isError&&(u=new Error,u.name=i.err.name,u.message=i.err.message,u.stack=i.err.stack),s.reject(u);return}s.resolve(i.res)}_handleRequestMessage(i){let s=i.req;this._handler.handleMessage(i.method,i.args).then(d=>{this._send(new y(this._workerId,s,d,void 0))},d=>{d.detail instanceof Error&&(d.detail=(0,v.transformErrorForSerialization)(d.detail)),this._send(new y(this._workerId,s,void 0,(0,v.transformErrorForSerialization)(d)))})}_handleSubscribeEventMessage(i){const s=i.req,u=this._handler.handleEvent(i.eventName,i.arg)(d=>{this._send(new g(this._workerId,s,d))});this._pendingEvents.set(s,u)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let s=[];if(i.type===0)for(let u=0;u<i.args.length;u++)i.args[u]instanceof ArrayBuffer&&s.push(i.args[u]);else i.type===1&&i.res instanceof ArrayBuffer&&s.push(i.res);this._handler.sendMessage(i,s)}}class M extends D.Disposable{constructor(i,s,u){super();let d=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",N=>{this._protocol.handleMessage(N)},N=>{d&&d(N)})),this._protocol=new w({sendMessage:(N,Q)=>{this._worker.postMessage(N,Q)},handleMessage:(N,Q)=>{if(typeof u[N]!="function")return Promise.reject(new Error("Missing method "+N+" on main thread host."));try{return Promise.resolve(u[N].apply(u,Q))}catch(se){return Promise.reject(se)}},handleEvent:(N,Q)=>{if(a(N)){const se=u[N].call(u,Q);if(typeof se!="function")throw new Error(`Missing dynamic event ${N} on main thread host.`);return se}if(c(N)){const se=u[N];if(typeof se!="function")throw new Error(`Missing event ${N} on main thread host.`);return se}throw new Error(`Malformed event name ${N}`)}}),this._protocol.setWorkerId(this._worker.getId());let E=null;typeof C.globals.require!="undefined"&&typeof C.globals.require.getConfig=="function"?E=C.globals.require.getConfig():typeof C.globals.requirejs!="undefined"&&(E=C.globals.requirejs.s.contexts._.config);const L=k.getAllMethodNames(u);this._onModuleLoaded=this._protocol.sendMessage(f,[this._worker.getId(),JSON.parse(JSON.stringify(E)),s,L]);const R=(N,Q)=>this._request(N,Q),T=(N,Q)=>this._protocol.listen(N,Q);this._lazyProxy=new Promise((N,Q)=>{d=Q,this._onModuleLoaded.then(se=>{N(l(se,R,T))},se=>{Q(se),this._onError("Worker failed to load "+s,se)})})}getProxyObject(){return this._lazyProxy}_request(i,s){return new Promise((u,d)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,s).then(u,d)},d)})}_onError(i,s){console.error(i),console.info(s)}}e.SimpleWorkerClient=M;function c(r){return r[0]==="o"&&r[1]==="n"&&P.isUpperAsciiLetter(r.charCodeAt(2))}function a(r){return/^onDynamic/.test(r)&&P.isUpperAsciiLetter(r.charCodeAt(9))}function l(r,i,s){const u=L=>function(){const R=Array.prototype.slice.call(arguments,0);return i(L,R)},d=L=>function(R){return s(L,R)};let E={};for(const L of r){if(a(L)){E[L]=d(L);continue}if(c(L)){E[L]=s(L,void 0);continue}E[L]=u(L)}return E}class o{constructor(i,s){this._requestHandlerFactory=s,this._requestHandler=null,this._protocol=new w({sendMessage:(u,d)=>{i(u,d)},handleMessage:(u,d)=>this._handleMessage(u,d),handleEvent:(u,d)=>this._handleEvent(u,d)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,s){if(i===f)return this.initialize(s[0],s[1],s[2],s[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,s))}catch(u){return Promise.reject(u)}}_handleEvent(i,s){if(!this._requestHandler)throw new Error("Missing requestHandler");if(a(i)){const u=this._requestHandler[i].call(this._requestHandler,s);if(typeof u!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return u}if(c(i)){const u=this._requestHandler[i];if(typeof u!="function")throw new Error(`Missing event ${i} on request handler.`);return u}throw new Error(`Malformed event name ${i}`)}initialize(i,s,u,d){this._protocol.setWorkerId(i);const R=l(d,(T,N)=>this._protocol.sendMessage(T,N),(T,N)=>this._protocol.listen(T,N));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve(k.getAllMethodNames(this._requestHandler))):(s&&(typeof s.baseUrl!="undefined"&&delete s.baseUrl,typeof s.paths!="undefined"&&typeof s.paths.vs!="undefined"&&delete s.paths.vs,typeof s.trustedTypesPolicy!==void 0&&delete s.trustedTypesPolicy,s.catchError=!0,C.globals.require.config(s)),new Promise((T,N)=>{(C.globals.require||K)([u],se=>{if(this._requestHandler=se.create(R),!this._requestHandler){N(new Error("No RequestHandler!"));return}T(k.getAllMethodNames(this._requestHandler))},N)}))}}e.SimpleWorkerServer=o;function h(r){return new o(r,null)}e.create=h}),define(te[116],ie([0,1,60,28,42]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(k,P){if(await new Promise((b,I)=>{const p=n.createReadStream(k),y=v.createHash("sha1");p.pipe(y);const t=(0,D.once)((g,S)=>{p.removeAllListeners(),y.removeAllListeners(),g?I(g):b(S)});p.once("error",t),p.once("end",t),y.once("error",t),y.once("data",g=>t(void 0,g.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=C}),define(te[117],ie([0,1,247]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(C="utf8"){this.stringDecoder=new v.StringDecoder(C),this.remaining=null}write(C){const k=[],P=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(P.length<1)return k;let f=0,m,b=f;for(;b<P.length;)if(m=P.charCodeAt(b),m===13||m===10){if(k.push(P.substring(f,b)),b++,b<P.length){const I=m;m=P.charCodeAt(b),(I===13&&m===10||I===10&&m===13)&&b++}f=b}else b++;return this.remaining=f<P.length?P.substr(f):null,k}end(){return this.remaining}}e.LineDecoder=n}),define(te[118],ie([0,1,26]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(k){const P=k.replace(/\-/g,":").toLowerCase();return!n.has(P)}function C(){const k=(0,v.networkInterfaces)();for(let P in k){const f=k[P];if(f){for(const{mac:m}of f)if(D(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(te[71],ie([0,1,26,15,35,32,118]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(b){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(b)}value(){if(this._value===void 0){let b=0,I=0;const p=(0,v.networkInterfaces)();for(let y in p){const t=p[y];if(t)for(const{mac:g,internal:S}of t)S||(I+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(b+=1))}this._value=I>0?b/I:0}return this._value}};let P;async function f(){return P||(P=(async()=>await m()||C.generateUuid())()),P}e.getMachineId=f;async function m(){try{const b=await new Promise((p,y)=>{K(["crypto"],p,y)}),I=(0,k.getMac)();return b.createHash("sha256").update(I,"utf8").digest("hex")}catch(b){n.onUnexpectedError(b);return}}}),define(te[24],ie([0,1,28,26,119,8,27,70,9,3,16,7]),function(K,e,v,n,D,C,k,P,f,m,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function y(V,Z=p.UNLINK){if((0,k.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return Z===p.UNLINK?g(V):t(V)}async function t(V){try{const Z=(0,k.randomPath)((0,n.tmpdir)());try{await v.promises.rename(V,Z)}catch{return g(V)}g(Z).catch(H=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function g(V){return e.Promises.rmdir(V,{recursive:!0,maxRetries:3})}function S(V){if((0,k.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(V,{recursive:!0})}e.rimrafSync=S;async function w(V,Z){return a(await(Z?M(V):(0,D.promisify)(v.readdir)(V)))}async function M(V){try{return await(0,D.promisify)(v.readdir)(V,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const Z=[],H=await w(V);for(const q of H){let Y=!1,j=!1,z=!1;try{const G=await e.Promises.lstat((0,f.join)(V,q));Y=G.isFile(),j=G.isDirectory(),z=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}Z.push({name:q,isFile:()=>Y,isDirectory:()=>j,isSymbolicLink:()=>z})}return Z}function c(V){return a(v.readdirSync(V))}e.readdirSync=c;function a(V){return V.map(Z=>typeof Z=="string"?m.isMacintosh?(0,P.normalizeNFC)(Z):Z:(Z.name=m.isMacintosh?(0,P.normalizeNFC)(Z.name):Z.name,Z))}async function l(V){const Z=await w(V),H=[];for(const q of Z)await h.existsDirectory((0,f.join)(V,q))&&H.push(q);return H}function o(V,Z=1e3){return new Promise(H=>{let q=!1;const Y=setInterval(()=>{q||(q=!0,v.access(V,j=>{q=!1,j&&(clearInterval(Y),H(void 0))}))},Z)})}e.whenDeleted=o;var h;(function(V){async function Z(Y){let j;try{if(j=await e.Promises.lstat(Y),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(m.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw G}throw z}}V.stat=Z;async function H(Y){try{const{stat:j,symbolicLink:z}=await V.stat(Y);return j.isFile()&&z?.dangling!==!0}catch{}return!1}V.existsFile=H;async function q(Y){try{const{stat:j,symbolicLink:z}=await V.stat(Y);return j.isDirectory()&&z?.dangling!==!0}catch{}return!1}V.existsDirectory=q})(h=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new C.ResourceQueue;function i(V,Z,H){return r.queueFor(I.URI.file(V),b.extUriBiasedIgnorePathCase).queue(()=>{const q=E(H);return new Promise((Y,j)=>u(V,Z,q,z=>z?j(z):Y()))})}let s=!0;function u(V,Z,H,q){if(!s)return v.writeFile(V,Z,{mode:H.mode,flag:H.flag},q);v.open(V,H.flag,H.mode,(Y,j)=>{if(Y)return q(Y);v.writeFile(j,Z,z=>{if(z)return v.close(j,()=>q(z));v.fdatasync(j,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),s=!1),v.close(j,$=>q($))))})})}function d(V,Z,H){const q=E(H);if(!s)return v.writeFileSync(V,Z,{mode:q.mode,flag:q.flag});const Y=v.openSync(V,q.flag,q.mode);try{v.writeFileSync(Y,Z);try{v.fdatasyncSync(Y)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),s=!1}}finally{v.closeSync(Y)}}e.writeFileSync=d;function E(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function L(V,Z){if(V===Z)return;async function H(q){try{const Y=await e.Promises.lstat(q);if(Y.isDirectory()||Y.isSymbolicLink())return;await e.Promises.utimes(q,Y.atime,new Date)}catch{}}try{await e.Promises.rename(V,Z),await H(Z)}catch(q){if(V.toLowerCase()!==Z.toLowerCase()&&q.code==="EXDEV"||V.endsWith("."))await R(V,Z,{preserveSymlinks:!1}),await y(V,p.MOVE),await H(Z);else throw q}}async function R(V,Z,H){return N(V,Z,{root:{source:V,target:Z},options:H,handledSourcePaths:new Set})}const T=511;async function N(V,Z,H){if(H.handledSourcePaths.has(V))return;H.handledSourcePaths.add(V);const{stat:q,symbolicLink:Y}=await h.stat(V);if(Y){if(H.options.preserveSymlinks)try{return await ne(V,Z,H)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(Y.dangling)return}return q.isDirectory()?Q(V,Z,q.mode&T,H):se(V,Z,q.mode&T)}async function Q(V,Z,H,q){await e.Promises.mkdir(Z,{recursive:!0,mode:H});const Y=await w(V);for(const j of Y)await N((0,f.join)(V,j),(0,f.join)(Z,j),q)}async function se(V,Z,H){await e.Promises.copyFile(V,Z),await e.Promises.chmod(Z,H)}async function ne(V,Z,H){let q=await e.Promises.readlink(V);(0,k.isEqualOrParent)(q,H.root.source,!m.isLinux)&&(q=(0,f.join)(H.root.target,q.substr(H.root.source.length+1))),await e.Promises.symlink(q,Z)}e.Promises=new class{get access(){return(0,D.promisify)(v.access)}get stat(){return(0,D.promisify)(v.stat)}get lstat(){return(0,D.promisify)(v.lstat)}get utimes(){return(0,D.promisify)(v.utimes)}get read(){return(0,D.promisify)(v.read)}get readFile(){return(0,D.promisify)(v.readFile)}get write(){return(0,D.promisify)(v.write)}get appendFile(){return(0,D.promisify)(v.appendFile)}get fdatasync(){return(0,D.promisify)(v.fdatasync)}get truncate(){return(0,D.promisify)(v.truncate)}get rename(){return(0,D.promisify)(v.rename)}get copyFile(){return(0,D.promisify)(v.copyFile)}get open(){return(0,D.promisify)(v.open)}get close(){return(0,D.promisify)(v.close)}get symlink(){return(0,D.promisify)(v.symlink)}get readlink(){return(0,D.promisify)(v.readlink)}get chmod(){return(0,D.promisify)(v.chmod)}get mkdir(){return(0,D.promisify)(v.mkdir)}get unlink(){return(0,D.promisify)(v.unlink)}get rmdir(){return(0,D.promisify)(v.rmdir)}get realpath(){return(0,D.promisify)(v.realpath)}async exists(V){try{return await e.Promises.access(V),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return l}get writeFile(){return i}get rm(){return y}get move(){return L}get copy(){return R}}}),define(te[83],ie([0,1,28,9,3,25,24]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(p){if(D.isLinux)return p;const y=(0,n.dirname)(p);if(p===y)return p;const t=((0,n.basename)(p)||p).toLowerCase();try{const S=(0,k.readdirSync)(y).filter(w=>w.toLowerCase()===t);if(S.length===1){const w=P(y);if(w)return(0,n.join)(w,S[0])}else if(S.length>1){const w=S.indexOf(t);if(w>=0){const M=P(y);if(M)return(0,n.join)(M,S[w])}}}catch{}return null}e.realcaseSync=P;async function f(p){if(D.isLinux)return p;const y=(0,n.dirname)(p);if(p===y)return p;const t=((0,n.basename)(p)||p).toLowerCase();try{const S=(await k.Promises.readdir(y)).filter(w=>w.toLowerCase()===t);if(S.length===1){const w=await f(y);if(w)return(0,n.join)(w,S[0])}else if(S.length>1){const w=S.indexOf(t);if(w>=0){const M=await f(y);if(M)return(0,n.join)(M,S[w])}}}catch{}return null}e.realcase=f;async function m(p){try{return await k.Promises.realpath(p)}catch{const t=I(p);return await k.Promises.access(t,v.constants.R_OK),t}}e.realpath=m;function b(p){try{return v.realpathSync(p)}catch{const t=I(p);return v.accessSync(t,v.constants.R_OK),t}}e.realpathSync=b;function I(p){return(0,C.rtrim)((0,n.normalize)(p),n.sep)}}),define(te[120],ie([0,1,61]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(P,f,m,b=1){let I=!1;return new Promise(p=>{const y=setTimeout(()=>{if(!I)return I=!0,p(0)},m);D(P,f,b,t=>{if(!I)return I=!0,clearTimeout(y),p(t)})})}e.findFreePort=n;function D(P,f,m,b){if(f===0)return b(0);const I=new v.Socket;I.once("connect",()=>(k(I),D(P+m,f-1,m,b))),I.once("data",()=>{}),I.once("error",p=>(k(I),p.code!=="ECONNREFUSED"?D(P+m,f-1,m,b):b(P))),I.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(P,f,m){let b=!1,I,p=1;const y=v.createServer({pauseOnConnect:!0});function t(g,S){b||(b=!0,y.removeAllListeners(),y.close(),I&&clearTimeout(I),S(g))}return new Promise(g=>{I=setTimeout(()=>{t(0,g)},m),y.on("listening",()=>{t(P,g)}),y.on("error",S=>{S&&(S.code==="EADDRINUSE"||S.code==="EACCES")&&p<f?(P++,p++,y.listen(P,"127.0.0.1")):t(0,g)}),y.on("close",()=>{t(0,g)}),y.listen(P,"127.0.0.1")})}e.findFreePortFaster=C;function k(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(f){console.error(f)}}}),define(te[121],ie([0,1,26,9,24]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,k=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var f;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(f||(f={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class I{constructor(l,o,h){this.exePath=l,this.displayName=o,this.knownToExist=h}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:a=!1}={}){return a?m===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:a=!1,findPreview:l=!1}={}){const o=p({useAlternateBitness:a});if(!o)return null;const h=n.join(o,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(h))return null;let r=-1,i=null;for(const d of await D.Promises.readdir(h)){let E=-1;if(l){const R=d.indexOf("-");if(R<0)continue;const T=d.substring(0,R);if(!C.test(T)||d.substring(R+1)!=="preview")continue;E=parseInt(T,10)}else{if(!C.test(d))continue;E=parseInt(d,10)}if(E<=r)continue;const L=n.join(h,d,"pwsh.exe");!await D.SymlinkSupport.existsFile(L)||(i=L,r=E)}if(!i)return null;const s=o.includes("x86")?" (x86)":"",u=l?" Preview":"";return new I(i,`PowerShell${u}${s}`,!0)}async function t({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const l=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:o,pwshMsixName:h}=a?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const r of await D.Promises.readdir(l))if(o.test(r)){const i=n.join(l,r,"pwsh.exe");return new I(i,h)}return null}function g(){const a=n.join(v.homedir(),".dotnet","tools","pwsh.exe");return new I(a,".NET Core PowerShell Global Tool")}function S(){const a=n.join(process.env.windir,m===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(a,"Windows PowerShell",!0)}async function*w(){let a=await y();a&&(yield a),a=await y({useAlternateBitness:!0}),a&&(yield a),a=await t(),a&&(yield a),a=g(),a&&(yield a),a=await y({findPreview:!0}),a&&(yield a),a=await t({findPreview:!0}),a&&(yield a),a=await y({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=S(),a&&(yield a)}async function*M(){for await(const a of w())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=M;async function c(){for await(const a of M())return a;return null}e.getFirstAvailablePowerShellInstallation=c}),define(te[84],ie([0,1,44,10]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(k){return new Promise((P,f)=>{let m;const b=new Map;function I(y,t,g,S,w){const M=b.get(t);if(y===k||M){const c={name:p(g),cmd:g,pid:y,ppid:t,load:S,mem:w};b.set(y,c),y===k&&(m=c),M&&(M.children||(M.children=[]),M.children.push(c),M.children.length>1&&(M.children=M.children.sort((a,l)=>a.pid-l.pid)))}}function p(y){const t=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,S=/--vscode-window-kind=process-explorer/,w=/--utility-sub-type=network/,M=/--crashes-directory/,c=/\\pipe\\winpty-control/,a=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(M.exec(y))return"electron-crash-reporter";if(c.exec(y))return"winpty-process";if(a.exec(y))return"console-window-host (Windows internal process)";let o=l.exec(y);if(o&&o.length===2)return o[1]==="renderer"?t.exec(y)?"shared-process":g.exec(y)?"issue-reporter":S.exec(y)?"process-explorer":"window":o[1]==="utility"&&w.exec(y)?"utility-network-service":o[1];const h=/[a-zA-Z-]+\.js/g;let r="";do o=h.exec(y),o&&(r+=o+" ");while(o);return r&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${r}`:y}if(process.platform==="win32"){const y=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,g)=>{K(["windows-process-tree"],t,g)}).then(t=>{t.getProcessList(k,g=>{t.getProcessCpuUsage(g,S=>{const w=new Map;S.forEach(M=>{const c=y(M.commandLine||"");w.set(M.pid,{name:p(c),cmd:c,pid:M.pid,ppid:M.ppid,load:M.cpu||0,mem:M.memory||0})}),m=w.get(k),m?(w.forEach(M=>{const c=w.get(M.ppid);c&&(c.children||(c.children=[]),c.children.push(M))}),w.forEach(M=>{M.children&&(M.children=M.children.sort((c,a)=>c.pid-a.pid))}),P(m)):f(new Error(`Root process ${k} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let y=function(){let t=[m];const g=[];for(;t.length;){const w=t.shift();w&&(g.push(w.pid),w.children&&(t=t.concat(w.children)))}let S=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);S+=" "+g.join(" "),(0,v.exec)(S,{},(w,M,c)=>{if(w||c)f(w||new Error(c.toString()));else{const a=M.toString().split(`
`);for(let l=0;l<g.length;l++){const o=b.get(g[l]);o.load=parseFloat(a[l])}if(!m){f(new Error(`Root process ${k} not found`));return}P(m)}})};(0,v.exec)("which ps",{},(t,g,S)=>{if(t||S)if(process.platform!=="linux")f(t||new Error(S.toString()));else{const w=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,v.exec)(w,{},(M,c,a)=>{M||a?f(M||new Error(a.toString())):(C(c,I),y())})}else{const w=g.toString().trim(),M="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${w} ${M}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,a,l)=>{c||l&&!l.includes("screen size is bogus")?f(c||new Error(l.toString())):(C(a,I),process.platform==="linux"?y():m?P(m):f(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=D;function C(k,P){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=k.toString().split(`
`);for(const b of m){const I=f.exec(b.trim());I&&I.length===6&&P(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(te[122],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[123],ie([0,1,14,13,122]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){v.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(P,f,m,b,I)=>{const p=k(P,b,m);p.popup({window:(0,n.withNullAsUndefined)(v.BrowserWindow.fromWebContents(P.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{p&&P.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=C;function k(P,f,m){const b=new v.Menu;return m.forEach(I=>{let p;I.type==="separator"?p=new v.MenuItem({type:I.type}):Array.isArray(I.submenu)?p=new v.MenuItem({submenu:k(P,f,I.submenu),label:I.label}):p=new v.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(y,t,g)=>P.sender.send(f,I.id,g)}),b.append(p)}),b}});var fe=this&&this.__decorate||function(K,e,v,n){var D=arguments.length,C=D<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,v):n,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(K,e,v,n);else for(var P=K.length-1;P>=0;P--)(k=K[P])&&(C=(D<3?k(C):D>3?k(e,v,C):k(e,v))||C);return D>3&&C&&Object.defineProperty(e,v,C),C};define(te[37],ie([0,1,31,8,17,21,46,15,4,2,112,25,13]),function(K,e,v,n,D,C,k,P,f,m,b,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function t(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function S(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(w||(w={}));class M{constructor(z){this.buffer=z,this.pos=0}read(z){const G=this.buffer.slice(this.pos,this.pos+z);return this.pos+=G.byteLength,G}}class c{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var a;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(a||(a={}));function l(j){const z=D.VSBuffer.alloc(4);return z.writeUInt32BE(j,0),z}function o(j){return j.read(4).readUInt32BE(0)}function h(j){const z=D.VSBuffer.alloc(1);return z.writeUInt8(j,0),z}const r={Undefined:h(a.Undefined),String:h(a.String),Buffer:h(a.Buffer),VSBuffer:h(a.VSBuffer),Array:h(a.Array),Object:h(a.Object)},i=typeof Buffer!="undefined";function s(j,z){if(typeof z=="undefined")j.write(r.Undefined);else if(typeof z=="string"){const G=D.VSBuffer.fromString(z);j.write(r.String),j.write(l(G.byteLength)),j.write(G)}else if(i&&Buffer.isBuffer(z)){const G=D.VSBuffer.wrap(z);j.write(r.Buffer),j.write(l(G.byteLength)),j.write(G)}else if(z instanceof D.VSBuffer)j.write(r.VSBuffer),j.write(l(z.byteLength)),j.write(z);else if(Array.isArray(z)){j.write(r.Array),j.write(l(z.length));for(const G of z)s(j,G)}else{const G=D.VSBuffer.fromString(JSON.stringify(z));j.write(r.Object),j.write(l(G.byteLength)),j.write(G)}}function u(j){switch(j.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return j.read(o(j)).toString();case a.Buffer:return j.read(o(j)).buffer;case a.VSBuffer:return j.read(o(j));case a.Array:{const G=o(j),$=[];for(let F=0;F<G;F++)$.push(u(j));return $}case a.Object:return JSON.parse(j.read(o(j)).toString())}}class d{constructor(z,G,$=null,F=1e3){this.protocol=z,this.ctx=G,this.logger=$,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(z,G){this.channels.set(z,G),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const G=this.send([z.type]);this.logger&&this.logger.logOutgoing(G,0,1,S(z.type));return}case 201:case 202:case 204:case 203:{const G=this.send([z.type,z.id],z.data);this.logger&&this.logger.logOutgoing(G,z.id,1,S(z.type),z.data);return}}}send(z,G=void 0){const $=new c;return s($,z),s($,G),this.sendBuffer($.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const G=new M(z),$=u(G),F=u(G),W=$[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(z.byteLength,$[1],1,`${t(W)}: ${$[2]}.${$[3]}`,F),this.onPromise({type:W,id:$[1],channelName:$[2],name:$[3],arg:F});case 102:return this.logger&&this.logger.logIncoming(z.byteLength,$[1],1,`${t(W)}: ${$[2]}.${$[3]}`,F),this.onEventListen({type:W,id:$[1],channelName:$[2],name:$[3],arg:F});case 101:return this.logger&&this.logger.logIncoming(z.byteLength,$[1],1,`${t(W)}`),this.disposeActiveRequest({type:W,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(z.byteLength,$[1],1,`${t(W)}`),this.disposeActiveRequest({type:W,id:$[1]})}}onPromise(z){const G=this.channels.get(z.channelName);if(!G){this.collectPendingRequest(z);return}const $=new C.CancellationTokenSource;let F;try{F=G.call(this.ctx,z.name,z.arg,$.token)}catch(_){F=Promise.reject(_)}const W=z.id;F.then(_=>{this.sendResponse({id:W,data:_,type:201}),this.activeRequests.delete(z.id)},_=>{_ instanceof Error?this.sendResponse({id:W,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:W,data:_,type:203}),this.activeRequests.delete(z.id)});const A=(0,m.toDisposable)(()=>$.cancel());this.activeRequests.set(z.id,A)}onEventListen(z){const G=this.channels.get(z.channelName);if(!G){this.collectPendingRequest(z);return}const $=z.id,W=G.listen(this.ctx,z.name,z.arg)(A=>this.sendResponse({id:$,data:A,type:204}));this.activeRequests.set(z.id,W)}disposeActiveRequest(z){const G=this.activeRequests.get(z.id);G&&(G.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let G=this.pendingRequests.get(z.channelName);G||(G=[],this.pendingRequests.set(z.channelName,G));const $=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:z,timeoutTimer:$})}flushPendingRequests(z){const G=this.pendingRequests.get(z);if(G){for(const $ of G)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var E;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(z,G=null){this.protocol=z,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=G}getChannel(z){const G=this;return{call($,F,W){return G.isDisposed?Promise.reject(P.canceled()):G.requestPromise(z,$,F,W)},listen($,F){return G.isDisposed?Promise.reject(P.canceled()):G.requestEvent(z,$,F)}}}requestPromise(z,G,$,F=C.CancellationToken.None){const W=this.lastRequestId++,_={id:W,type:100,channelName:z,name:G,arg:$};if(F.isCancellationRequested)return Promise.reject(P.canceled());let U;return new Promise((B,J)=>{if(F.isCancellationRequested)return J(P.canceled());const ee=()=>{const le=ue=>{switch(ue.type){case 201:this.handlers.delete(W),B(ue.data);break;case 202:{this.handlers.delete(W);const me=new Error(ue.data.message);me.stack=ue.data.stack,me.name=ue.data.name,J(me);break}case 203:this.handlers.delete(W),J(ue.data);break}};this.handlers.set(W,le),this.sendRequest(_)};let oe=null;this.state===w.Idle?ee():(oe=(0,n.createCancelablePromise)(le=>this.whenInitialized()),oe.then(()=>{oe=null,ee()}));const x=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:W,type:101}),J(P.canceled())},ce=F.onCancellationRequested(x);U=(0,m.combinedDisposable)((0,m.toDisposable)(x),ce),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(z,G,$){const F=this.lastRequestId++,A={id:F,type:102,channelName:z,name:G,arg:$};let _=null;const U=new f.Emitter({onFirstListenerAdd:()=>{_=(0,n.createCancelablePromise)(B=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(U),this.sendRequest(A)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(U),this.sendRequest({id:F,type:103}))}}),O=B=>U.fire(B.data);return this.handlers.set(F,O),U.event}sendRequest(z){switch(z.type){case 100:case 102:{const G=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(G,z.id,0,`${t(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const G=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(G,z.id,0,t(z.type));return}}}send(z,G=void 0){const $=new c;return s($,z),s($,G),this.sendBuffer($.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const G=new M(z),$=u(G),F=u(G),W=$[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,S(W)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,$[1],0,S(W),F),this.onResponse({type:$[0],id:$[1],data:F})}}onResponse(z){if(z.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get(z.id);G&&G(z)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}fe([k.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class R{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:G,onDidClientDisconnect:$})=>{f.Event.once(G.onMessage)(W=>{const A=new M(W),_=u(A),U=new d(G,_),O=new L(G);this.channels.forEach((J,ee)=>U.registerChannel(ee,J));const B={channelServer:U,channelClient:O,ctx:_};this._connections.add(B),this._onDidAddConnection.fire(B),$(()=>{U.dispose(),O.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const z=[];return this._connections.forEach(G=>z.push(G)),z}getChannel(z,G){const $=this;return{call(F,W,A){let _;if((0,p.isFunction)(G)){let O=(0,v.getRandomElement)($.connections.filter(G));_=O?Promise.resolve(O):f.Event.toPromise(f.Event.filter($.onDidAddConnection,G))}else _=G.routeCall($,F,W);const U=_.then(O=>O.channelClient.getChannel(z));return N(U).call(F,W,A)},listen(F,W){if((0,p.isFunction)(G))return $.getMulticastEvent(z,G,F,W);const A=G.routeEvent($,F,W).then(_=>_.channelClient.getChannel(z));return N(A).listen(F,W)}}}getMulticastEvent(z,G,$,F){const W=this;let A=new m.DisposableStore;const _=new f.Emitter({onFirstListenerAdd:()=>{A=new m.DisposableStore;const U=new f.EventMultiplexer,O=new Map,B=ee=>{const x=ee.channelClient.getChannel(z).listen($,F),ce=U.add(x);O.set(ee,ce)},J=ee=>{const oe=O.get(ee);!oe||(oe.dispose(),O.delete(ee))};W.connections.filter(G).forEach(B),f.Event.filter(W.onDidAddConnection,G)(B,void 0,A),W.onDidRemoveConnection(J,void 0,A),U.event(_.fire,_,A),A.add(U)},onLastListenerRemove:()=>{A.dispose()}});return _.event}registerChannel(z,G){this.channels.set(z,G),this._connections.forEach($=>{$.channelServer.registerChannel(z,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class T{constructor(z,G,$=null){const F=new c;s(F,G),z.send(F.buffer),this.channelClient=new L(z,$),this.channelServer=new d(z,G,$)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,G){this.channelServer.registerChannel(z,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function N(j){return{call(z,G,$){return j.then(F=>F.call(z,G,$))},listen(z,G){const $=new f.Relay;return j.then(F=>$.input=F.listen(z,G)),$.event}}}e.getDelayedChannel=N;function Q(j){let z=!1;return{call(G,$,F){return z?j.call(G,$,F):(0,n.timeout)(0).then(()=>z=!0).then(()=>j.call(G,$,F))},listen(G,$){if(z)return j.listen(G,$);const F=new f.Relay;return(0,n.timeout)(0).then(()=>z=!0).then(()=>F.input=j.listen(G,$)),F.event}}}e.getNextTickChannel=Q;class se{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const G of z.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await f.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=se;var ne;(function(j){function z(W,A){const _=W,U=A&&A.disableMarshalling,O=new Map;for(const B in _)$(B)&&O.set(B,f.Event.buffer(_[B],!0));return new class{listen(B,J,ee){const oe=O.get(J);if(oe)return oe;if(F(J)){const x=_[J];if(typeof x=="function")return x.call(_,ee)}throw new Error(`Event not found: ${J}`)}call(B,J,ee){const oe=_[J];if(typeof oe=="function"){if(!U&&Array.isArray(ee))for(let x=0;x<ee.length;x++)ee[x]=(0,b.revive)(ee[x]);return oe.apply(_,ee)}throw new Error(`Method not found: ${J}`)}}}j.fromService=z;function G(W,A){const _=A&&A.disableMarshalling;return new Proxy({},{get(U,O){if(typeof O=="string")return A?.properties?.has(O)?A.properties.get(O):F(O)?function(B){return W.listen(O,B)}:$(O)?W.listen(O):async function(...B){let J;A&&!(0,p.isUndefinedOrNull)(A.context)?J=[A.context,...B]:J=B;const ee=await W.call(O,J);return _?ee:(0,b.revive)(ee)};throw new Error(`Property not found: ${String(O)}`)}})}j.toService=G;function $(W){return W[0]==="o"&&W[1]==="n"&&I.isUpperAsciiLetter(W.charCodeAt(2))}function F(W){return/^onDynamic/.test(W)&&I.isUpperAsciiLetter(W.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Z(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let z=j.toString();if(z!=="[object Object]")return z}return j}function H(j){return Array.isArray(j)?j.map(Z):Z(j)}function q(j,z,G,$,F,W,A){A=H(A);const _=V[F],U=_[$%_.length];let O=[`%c[${j}]%c[${String(z).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String($).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(W)?(O=O.concat(A),O.push(")")):O.push(A),console.log.apply(console,O)}e.logWithColors=q;class Y{constructor(z,G){this._outgoingPrefix=z,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,G,$,F,W){this._totalOutgoing+=z,q(this._outgoingPrefix,this._totalOutgoing,z,G,$,F,W)}logIncoming(z,G,$,F,W){this._totalIncoming+=z,q(this._incomingPrefix,this._totalIncoming,z,G,$,F,W)}}e.IPCLogger=Y}),define(te[124],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(D,C){this.sender=D,this.onMessage=C}send(D){try{this.sender.send("vscode:message",D.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(te[125],ie([0,1,17,4,37]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(f){this.port=f,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",m=>v.VSBuffer.wrap(m.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=C;class k extends D.IPCClient{constructor(f,m){const b=new C(f);super(b,m);this.protocol=b}dispose(){this.protocol.disconnect()}}e.Client=k}),define(te[85],ie([0,1,17,4,2,37]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let u=0;function d(L,R){if(!s.has(L)){const T=String(++u);s.set(L,T)}return s.get(L)}function E(L,R,T,N){if(!i.enableDiagnostics)return;const Q=d(L,R);if(N instanceof v.VSBuffer||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const se=v.VSBuffer.alloc(N.byteLength);se.set(N),i.records.push({timestamp:Date.now(),id:Q,label:R,type:T,buff:se})}else i.records.push({timestamp:Date.now(),id:Q,label:R,type:T,data:N})}i.traceSocketEvent=E})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function b(){return m||(m=v.VSBuffer.alloc(0)),m}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,u){if(s===0)return b();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const R=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=s),R}if(this._chunks[0].byteLength>s){const R=this._chunks[0].slice(0,s);return u&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),R}let d=v.VSBuffer.alloc(s),E=0,L=0;for(;s>0;){const R=this._chunks[L];if(R.byteLength>s){const T=R.slice(0,s);d.set(T,E),E+=s,u&&(this._chunks[L]=R.slice(s),this._totalLength-=s),s-=s}else d.set(R,E),E+=R.byteLength,u?(this._chunks.shift(),this._totalLength-=R.byteLength):L++,s-=R.byteLength}return d}}e.ChunkStream=I;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(p||(p={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(s,u,d,E){this.type=s,this.id=u,this.ack=d,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class S extends D.Disposable{constructor(s){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const d=this._state.messageType,E=this._state.id,L=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new g(d,E,L,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=v.VSBuffer.alloc(13);u.writeUInt8(s.type,0),u.writeUInt32BE(s.id,1),u.writeUInt32BE(s.ack,5),u.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(u,s.data)}_bufferAdd(s,u){const d=this._totalLength===0;return this._data.push(s,u),this._totalLength+=s.byteLength+u.byteLength,d}_bufferTake(){const s=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,u){this._bufferAdd(s,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class M extends D.Disposable{constructor(s){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new S(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new g(1,0,0,s))}}e.Protocol=M;class c extends C.IPCClient{constructor(s,u,d=null){super(s,u,d);this.protocol=s}static fromSocket(s,u){return new c(new M(s),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=c;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class l{constructor(s){this.data=s,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],u=0,d=this._first;for(;d;)s[u++]=d.data,d=d.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const u=new l(s);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class h{constructor(){this.lastRuns=[];const s=Date.now();for(let u=0;u<h._HISTORY_LENGTH;u++)this.lastRuns[u]=s-1e3*u;setInterval(()=>{for(let u=h._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return h._INSTANCE||(h._INSTANCE=new h),h._INSTANCE}load(){const s=Date.now(),u=(1+h._HISTORY_LENGTH)*1e3;let d=0;for(let E=0;E<h._HISTORY_LENGTH;E++)s-this.lastRuns[E]<=u&&d++;return 1-d/h._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}h._HISTORY_LENGTH=10,h._INSTANCE=null;class r{constructor(s,u=null,d=h.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=d,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new S(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(E=>this._receiveMessage(E))),this._socketDisposables.push(this._socket.onClose(E=>this._onSocketClose.fire(E))),u&&this._socketReader.acceptChunk(u)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new g(5,0,0,b());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new g(7,0,0,b());this._socketWriter.write(s)}sendResume(){const s=new g(8,0,0,b());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,u){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new S(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new g(3,0,this._incomingAckId,b());this._socketWriter.write(s);const u=this._outgoingUnackMsg.toArray();for(let d=0,E=u.length;d<E;d++)this._socketWriter.write(u[d]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new g(6,0,0,b())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let d=0,E=u.length;d<E;d++)this._socketWriter.write(u[d]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new g(1,u,this._incomingAckId,s);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(s){const u=new g(2,0,0,s);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),u=Date.now()-s.writtenTime,d=Date.now()-this._socketReader.lastReadTime,E=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&d>=2e4&&E>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const L=Math.max(2e4-u,2e4-d,2e4-E,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},L)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new g(3,0,this._incomingAckId,b());this._socketWriter.write(s)}}e.PersistentProtocol=r}),define(te[126],ie([0,1,14,17,4,2,37,124]),function(K,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(b,I){const p=D.Event.fromNodeEventEmitter(v.ipcMain,I,(t,g)=>({event:t,message:g})),y=D.Event.filter(p,({event:t})=>t.sender.id===b);return D.Event.map(y,({message:t})=>t&&n.VSBuffer.wrap(t))}class m extends k.IPCServer{constructor(){super(m.getOnDidClientConnect())}static getOnDidClientConnect(){const I=D.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:p})=>p);return D.Event.map(I,p=>{const y=p.id,t=m.Clients.get(y);t&&t.dispose();const g=new D.Emitter;m.Clients.set(y,(0,C.toDisposable)(()=>g.fire()));const S=f(y,"vscode:message"),w=D.Event.any(D.Event.signal(f(y,"vscode:disconnect")),g.event);return{protocol:new P.Protocol(p,S),onDidClientDisconnect:w}})}}e.Server=m,m.Clients=new Map}),define(te[86],ie([0,1,14,4,32,125]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class k extends C.Client{constructor(m,b){super({addEventListener:(I,p)=>m.addListener(I,p),removeEventListener:(I,p)=>m.removeListener(I,p),postMessage:I=>m.postMessage(I),start:()=>m.start(),close:()=>m.close()},b)}}e.Client=k;async function P(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,D.generateUuid)();f.webContents.send("vscode:createMessageChannel",m);const b=n.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(p,y)=>({nonce:y,port:p.ports[0]})),{port:I}=await n.Event.toPromise(n.Event.once(n.Event.filter(b,p=>p.nonce===m)));return I}e.connect=P}),define(te[87],ie([0,1,8,4,2,13]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function P(I){const p=I;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var f;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(f||(f={}));class m extends D.Disposable{constructor(p,y=Object.create(null)){super();this.database=p,this.options=y,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((y,t)=>this.accept(t,y)),p.deleted?.forEach(y=>this.accept(y,void 0))}accept(p,y){if(this.state===f.Closed)return;let t=!1;(0,C.isUndefinedOrNull)(y)?t=this.cache.delete(p):this.cache.get(p)!==y&&(this.cache.set(p,y),t=!0),t&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,y){const t=this.cache.get(p);return(0,C.isUndefinedOrNull)(t)?y:t}getBoolean(p,y){const t=this.get(p);return(0,C.isUndefinedOrNull)(t)?y:t==="true"}getNumber(p,y){const t=this.get(p);return(0,C.isUndefinedOrNull)(t)?y:parseInt(t,10)}async set(p,y){if(this.state===f.Closed)return;if((0,C.isUndefinedOrNull)(y))return this.delete(p);const t=String(y);if(this.cache.get(p)!==t)return this.cache.set(p,t),this.pendingInserts.set(p,t),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===f.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert&&p.insert.forEach((y,t)=>this.items.set(t,y)),p.delete&&p.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=b}),define(te[127],ie([0,1,8,4,35,9,24]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{constructor(b,I=Object.create(null)){this.path=b,this.options=I,this.name=(0,C.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return n.Event.None}async getItems(){const b=await this.whenConnected,I=new Map;return(await this.all(b,"SELECT * FROM ItemTable")).forEach(y=>I.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(b){const I=await this.whenConnected;return this.doUpdateItems(I,b)}doUpdateItems(b,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,D.mapToString)(I.insert):"0"}), delete(${I.delete?(0,D.setToString)(I.delete):"0"})`),this.transaction(b,()=>{const p=I.insert,y=I.delete;if(p&&p.size>0){const t=[];t.push([]);let g=0;p.forEach((S,w)=>{let M=t[g];M.length>P.MAX_HOST_PARAMETERS&&(g++,M=[],t.push(M)),M.push(w,S)}),t.forEach(S=>{this.prepare(b,`INSERT INTO ItemTable VALUES ${new Array(S.length/2).fill("(?,?)").join(",")}`,w=>w.run(S),()=>{const w=[];let M=0;return p.forEach((c,a)=>{w.push(a),M+=c.length}),`Keys: ${w.join(", ")} Length: ${M}`})})}if(y&&y.size){const t=[];t.push([]);let g=0;y.forEach(S=>{let w=t[g];w.length>P.MAX_HOST_PARAMETERS&&(g++,w=[],t.push(w)),w.push(S)}),t.forEach(S=>{this.prepare(b,`DELETE FROM ItemTable WHERE key IN (${new Array(S.length).fill("?").join(",")})`,w=>w.run(S),()=>{const w=[];return y.forEach(M=>{w.push(M)}),`Keys: ${w.join(", ")}`})})}})}async close(b){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,b)}doClose(b,I){return new Promise((p,y)=>{b.db.close(t=>(t&&this.handleSQLiteError(b,`[storage ${this.name}] close(): ${t}`),this.path===P.IN_MEMORY_PATH?p():!b.isErroneous&&!b.isInMemory?this.backup().then(p,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),p())):typeof I=="function"?k.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const S=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:I()}).then(()=>S(),w=>(S(),Promise.reject(w)))})).then(p,y):y(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const b=this.toBackupPath(this.path);return k.Promises.copy(this.path,b,{preserveSymlinks:!1})}toBackupPath(b){return`${b}.backup`}async checkIntegrity(b){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${b})`);const I=await this.whenConnected,p=await this.get(I,b?"PRAGMA integrity_check":"PRAGMA quick_check"),y=b?p.integrity_check:p.quick_check;return I.isErroneous?`${y} (last error: ${I.lastError})`:I.isInMemory?`${y} (in-memory!)`:y}async connect(b,I=!0){this.logger.trace(`[storage ${this.name}] open(${b}, retryOnBusy: ${I})`);try{return await this.doConnect(b)}catch(p){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&I)return await(0,v.timeout)(P.BUSY_OPEN_TIMEOUT),this.connect(b,!1);try{await k.Promises.unlink(b);try{await k.Promises.rename(this.toBackupPath(b),b)}catch{}return await this.doConnect(b)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(P.IN_MEMORY_PATH)}}}handleSQLiteError(b,I){b.isErroneous=!0,b.lastError=I,this.logger.error(I)}doConnect(b){return new Promise((I,p)=>{new Promise((y,t)=>{K(["@vscode/sqlite3"],y,t)}).then(y=>{const t={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(b,g=>g?t.db?t.db.close(()=>p(g)):p(g):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(t),S=>t.db.close(()=>p(S)))),isInMemory:b===P.IN_MEMORY_PATH};t.db.on("error",g=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&t.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},p)})}exec(b,I){return new Promise((p,y)=>{b.db.exec(I,t=>t?(this.handleSQLiteError(b,`[storage ${this.name}] exec(): ${t}`),y(t)):p())})}get(b,I){return new Promise((p,y)=>{b.db.get(I,(t,g)=>t?(this.handleSQLiteError(b,`[storage ${this.name}] get(): ${t}`),y(t)):p(g))})}all(b,I){return new Promise((p,y)=>{b.db.all(I,(t,g)=>t?(this.handleSQLiteError(b,`[storage ${this.name}] all(): ${t}`),y(t)):p(g))})}transaction(b,I){return new Promise((p,y)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),I(),b.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(b,`[storage ${this.name}] transaction(): ${t}`),y(t)):p())})})}prepare(b,I,p,y){const t=b.db.prepare(I),g=S=>{this.handleSQLiteError(b,`[storage ${this.name}] prepare(): ${S} (${I}). Details: ${y()}`)};t.on("error",g),p(t),t.finalize(S=>{S&&g(S),t.removeListener("error",g)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.BUSY_OPEN_TIMEOUT=2e3,P.MAX_HOST_PARAMETERS=256;class f{constructor(b){b&&typeof b.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=b.logTrace),b&&typeof b.logError=="function"&&(this.logError=b.logError)}get isTracing(){return!!this.logTrace}trace(b){this.logTrace&&this.logTrace(b)}error(b){this.logError&&this.logError(b)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(te[128],ie([12,11]),function(K,e){return K.create("vs/base/common/date",e)}),define(te[129],ie([0,1,128]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,D=n*60,C=D*24,k=C*7,P=C*30,f=C*365;function m(I,p){typeof I!="number"&&(I=I.getTime());const y=Math.round((new Date().getTime()-I)/1e3);if(y<-30)return(0,v.localize)(0,null,m(new Date().getTime()+y*1e3,!1));if(y<30)return(0,v.localize)(1,null);let t;return y<n?(t=y,p?t===1?(0,v.localize)(2,null,t):(0,v.localize)(3,null,t):t===1?(0,v.localize)(4,null,t):(0,v.localize)(5,null,t)):y<D?(t=Math.floor(y/n),p?t===1?(0,v.localize)(6,null,t):(0,v.localize)(7,null,t):t===1?(0,v.localize)(8,null,t):(0,v.localize)(9,null,t)):y<C?(t=Math.floor(y/D),p?t===1?(0,v.localize)(10,null,t):(0,v.localize)(11,null,t):t===1?(0,v.localize)(12,null,t):(0,v.localize)(13,null,t)):y<k?(t=Math.floor(y/C),p?t===1?(0,v.localize)(14,null,t):(0,v.localize)(15,null,t):t===1?(0,v.localize)(16,null,t):(0,v.localize)(17,null,t)):y<P?(t=Math.floor(y/k),p?t===1?(0,v.localize)(18,null,t):(0,v.localize)(19,null,t):t===1?(0,v.localize)(20,null,t):(0,v.localize)(21,null,t)):y<f?(t=Math.floor(y/P),p?t===1?(0,v.localize)(22,null,t):(0,v.localize)(23,null,t):t===1?(0,v.localize)(24,null,t):(0,v.localize)(25,null,t)):(t=Math.floor(y/f),p?t===1?(0,v.localize)(26,null,t):(0,v.localize)(27,null,t):t===1?(0,v.localize)(28,null,t):(0,v.localize)(29,null,t))}e.fromNow=m;function b(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(te[130],ie([12,11]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(te[39],ie([0,1,31,13,130]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(m,b){return b&&(m.stack||m.stacktrace)?D.localize(0,null,P(m),k(m.stack)||k(m.stacktrace)):P(m)}function k(m){return Array.isArray(m)?m.join(`
`):m}function P(m){return typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?D.localize(1,null,m.message):m.message||D.localize(2,null)}function f(m=null,b=!1){if(!m)return D.localize(3,null);if(Array.isArray(m)){const I=v.coalesce(m),p=f(I[0],b);return I.length>1?D.localize(4,null,p,I.length):p}if(n.isString(m))return m;if(m.detail){const I=m.detail;if(I.error)return C(I.error,b);if(I.exception)return C(I.exception,b)}return m.stack?C(m,b):m.message?m.message:D.localize(5,null)}e.toErrorMessage=f}),define(te[131],ie([12,11]),function(K,e){return K.create("vs/base/common/keybindingLabels",e)}),define(te[132],ie([0,1,131]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class n{constructor(k,P,f=P){this.modifierLabels=[null],this.modifierLabels[2]=k,this.modifierLabels[1]=P,this.modifierLabels[3]=f}toLabel(k,P,f){if(P.length===0)return null;const m=[];for(let b=0,I=P.length;b<I;b++){const p=P[b],y=f(p);if(y===null)return null;m[b]=D(p,y,this.modifierLabels[k])}return m.join(" ")}}e.ModifierLabelProvider=n,e.UILabelProvider=new n({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new n({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new n({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new n({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(C,k,P){if(k===null)return"";const f=[];return C.ctrlKey&&f.push(P.ctrlKey),C.shiftKey&&f.push(P.shiftKey),C.altKey&&f.push(P.altKey),C.metaKey&&f.push(P.metaKey),k!==""&&f.push(k),f.join(P.separator)}}),define(te[133],ie([12,11]),function(K,e){return K.create("vs/base/node/processes",e)}),define(te[72],ie([0,1,44,27,10,47,9,3,34,81,13,117,24,133]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return m.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return m.TerminateResponseCode}});function t(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(o,h){if(P.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};h&&(r.cwd=h);const i=v.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],r);return new Promise(s=>{i.once("error",u=>{s({success:!1,error:u})}),i.once("exit",(u,d)=>{s(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?t(r.status):1})}else if(P.isLinux||P.isMacintosh)try{const r=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(i=>{v.execFile(r,[o.pid.toString()],{encoding:"utf8",shell:!0},(s,u,d)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function S(o){!o||(delete o.DEBUG,P.isMacintosh&&delete o.DYLD_LIBRARY_PATH,P.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=S;function w(o=f.env){return o.comspec||"cmd.exe"}e.getWindowsShell=w;class M{constructor(h,r,i,s){if(r!==void 0&&i!==void 0&&s!==void 0)this.cmd=h,this.args=r,this.shell=i,this.options=s;else{const u=h;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(f.env).forEach(d=>{u[d]=f.env[d]}),Object.keys(this.options.env).forEach(d=>{u[d]=this.options.env[d]}),this.options.env=u}}getSanitizedCommand(){let h=this.cmd.toLowerCase();const r=h.lastIndexOf(k.sep);return r!==-1&&(h=h.substring(r+1)),M.WellKnowCommands[h]?h:"other"}start(h){return P.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(f.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(r=>{let i,s;const u=new Promise((d,E)=>{i=d,s=E});if(r){let d=this.cmd;this.args&&(d=d+" "+this.args.join(" ")),this.childProcess=v.exec(d,this.options,(E,L,R)=>{this.childProcess=null;const T=E;T&&T.killed?s({killed:this.terminateRequested,stdout:L.toString(),stderr:R.toString()}):this.handleExec(i,h,E,L,R)})}else{let d=null;const E=L=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(L,i,h,s);const R={terminated:this.terminateRequested};b.isNumber(L)&&(R.cmdCode=L),i(R)};if(this.shell&&P.isWindows){const L=C.deepClone(this.options);L.windowsVerbatimArguments=!0,L.detached=!1;let R=!1,T=!1;const N=[];let Q=this.ensureQuotes(this.cmd);N.push(Q.value),R=Q.quoted,this.args&&this.args.forEach(ne=>{Q=this.ensureQuotes(ne),N.push(Q.value),T=T&&Q.quoted});const se=["/s","/c"];R?T?se.push('"'+N.join(" ")+'"'):N.length>1?se.push('"'+N[0]+'" '+N.slice(1).join(" ")):se.push('"'+N[0]+'"'):se.push(N.join(" ")),d=v.spawn(w(),se,L)}else this.cmd&&(d=v.spawn(this.cmd,this.args,this.options));d&&(this.childProcess=d,this.childProcessPromise=Promise.resolve(d),this.pidResolve&&(this.pidResolve(b.isNumber(d.pid)?d.pid:-1),this.pidResolve=void 0),d.on("error",L=>{this.childProcess=null,s({terminated:this.terminateRequested,error:L})}),d.pid&&(this.childProcess.on("close",E),this.handleSpawn(d,i,h,s,!0)))}return u})}handleClose(h,r,i,s){}ensureQuotes(h){return M.regexp.test(h)?{value:'"'+h+'"',quoted:!0}:{value:h,quoted:h.length>0&&h[0]==='"'&&h[h.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(h=>h.pid,h=>-1):new Promise(h=>{this.pidResolve=h})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(h=>(this.terminateRequested=!0,g(h,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),h=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(h=>{if(!this.shell||!P.isWindows)return h(!1);const r=v.spawn(w(),["/s","/c"]);r.on("error",i=>h(!0)),r.on("exit",i=>h(!1))})}}e.AbstractProcess=M,M.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},M.regexp=/^[^"].* .*[^"]/;class c extends M{constructor(h,r,i,s){super(h,r,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(h,r,i,s,u){[s,u].forEach((d,E)=>{const L=new I.LineDecoder;L.write(d).forEach(N=>{r({line:N,source:E===0?0:1})});const T=L.end();T&&r({line:T,source:E===0?0:1})}),h({terminated:this.terminateRequested,error:i})}handleSpawn(h,r,i,s,u){const d=new I.LineDecoder,E=new I.LineDecoder;h.stdout.on("data",L=>{d.write(L).forEach(T=>i({line:T,source:0}))}),h.stderr.on("data",L=>{E.write(L).forEach(T=>i({line:T,source:1}))}),this.stdoutLineDecoder=d,this.stderrLineDecoder=E}handleClose(h,r,i,s){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&i({line:u,source:0});const d=this.stderrLineDecoder?this.stderrLineDecoder.end():null;d&&i({line:d,source:1})}}e.LineProcess=c;function a(o){let h=[],r=!1;const i=function(s){if(r){h.push(s);return}(!o.send(s,d=>{if(d&&console.error(d),r=!1,h.length>0){const E=h.slice(0);h=[],E.forEach(L=>i(L))}})||P.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=a;var l;(function(o){async function h(r,i,s){if(k.isAbsolute(r))return r;if(i===void 0&&(i=f.cwd()),k.dirname(r)!=="."||(s===void 0&&b.isString(f.env.PATH)&&(s=f.env.PATH.split(k.delimiter)),s===void 0||s.length===0))return k.join(i,r);async function d(E){if(await p.Promises.exists(E)){let L;try{L=await p.Promises.stat(E)}catch(R){R.message.startsWith("EACCES")&&(L=await p.Promises.lstat(E))}return L?!L.isDirectory():!1}return!1}for(let E of s){let L;if(k.isAbsolute(E)?L=k.join(E,r):L=k.join(i,E,r),await d(L))return L;let R=L+".com";if(await d(R)||(R=L+".exe",await d(R)))return R}return k.join(i,r)}o.findExecutable=h})(l=e.win32||(e.win32={}))}),define(te[134],ie([0,1,26,3,121,72]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(y,t){return y===1?n.isWindows?I():C.getWindowsShell(t):m(y,t)}e.getSystemShell=k;function P(y,t){return y===1?n.isWindows?p(t):C.getWindowsShell(t):m(y,t)}e.getSystemShellSync=P;let f=null;function m(y,t){if(n.isLinux&&y===2||n.isMacintosh&&y===3)return"/bin/bash";if(!f){let g;if(n.isWindows)g="/bin/bash";else{if(g=t.SHELL,!g)try{g=(0,v.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}f=g}return f}let b=null;async function I(){return b||(b=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),b}function p(y){if(b)return b;const t=n.isWindows&&parseFloat((0,v.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?S:C.getWindowsShell(y)}}),define(te[135],ie([0,1,44,8,17,21,111,15,4,2,47,72,37]),function(K,e,v,n,D,C,k,P,f,m,b,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends p.ChannelServer{constructor(S){super({send:w=>{try{process.send&&process.send(w.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",w=>D.VSBuffer.wrap(Buffer.from(w,"base64")))},S);process.once("disconnect",()=>this.dispose())}}e.Server=y;class t{constructor(S,w){this.modulePath=S,this.options=w,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const M=w&&w.timeout?w.timeout:6e4;this.disposeDelayer=new n.Delayer(M),this.child=null,this._client=null}getChannel(S){const w=this;return{call(M,c,a){return w.requestPromise(S,M,c,a)},listen(M,c){return w.requestEvent(S,M,c)}}}requestPromise(S,w,M,c=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(S),l=(0,n.createCancelablePromise)(r=>a.call(w,M,r)),o=c.onCancellationRequested(()=>l.cancel()),h=(0,m.toDisposable)(()=>l.cancel());return this.activeRequests.add(h),l.finally(()=>{o.dispose(),this.activeRequests.delete(h),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(S,w,M){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let c;const a=new f.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(S).listen(w,M)(a.fire,a),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const S=this.options&&this.options.args?this.options.args:[],w=Object.create(null);w.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(w.env={...w.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(w.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,I.removeDangerousEnvVariables)(w.env),this.child=(0,v.fork)(this.modulePath,S,w);const M=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,k.isRemoteConsoleLog)(i)){(0,k.log)(i,`IPC Library: ${this.options.serverName}`);return}M.fire(D.VSBuffer.wrap(Buffer.from(i,"base64")))});const a=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,l=i=>this.child&&this.child.connected&&a.send(i.buffer.toString("base64")),o=M.event,h={send:l,onMessage:o};this._client=new p.ChannelClient(h);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,s)=>{process.removeListener("exit",r),this.activeRequests.forEach(u=>(0,m.dispose)(u)),this.activeRequests.clear(),i!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:s})})}return this._client}getCachedChannel(S){let w=this.channels.get(S);return w||(w=this.client.getChannel(S),this.channels.set(S,w)),w}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(te[136],ie([12,11]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(te[137],ie([12,11]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[138],ie([12,11]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[139],ie([12,11]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(te[140],ie([12,11]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(te[141],ie([12,11]),function(K,e){return K.create("vs/platform/environment/node/shellEnv",e)}),define(te[142],ie([12,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[143],ie([12,11]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[144],ie([12,11]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[145],ie([12,11]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(te[146],ie([12,11]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(te[147],ie([12,11]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(te[148],ie([12,11]),function(K,e){return K.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[149],ie([12,11]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[150],ie([12,11]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[151],ie([12,11]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[152],ie([12,11]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[153],ie([12,11]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(te[154],ie([12,11]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[155],ie([12,11]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(te[156],ie([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/window",e)}),define(te[157],ie([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[158],ie([12,11]),function(K,e){return K.create("vs/platform/workspaces/common/workspaces",e)}),define(te[159],ie([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[160],ie([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[161],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function v(n){return typeof n?.backupFolder=="string"}e.isEmptyWindowBackupInfo=v}),define(te[162],ie([0,1,4,2]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(P,f,m){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(P,f,m){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class C extends n.Disposable{constructor(P){super();this.channel=P}reload(P){this.channel.call("reload",[P])}get onReload(){return this.channel.listen("reload")}close(P){this.channel.call("close",[P])}get onClose(){return this.channel.listen("close")}attachSession(P,f,m){this.channel.call("attach",[P,f,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(P,f){this.channel.call("terminate",[P,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(P,f){return this.channel.call("openExtensionDevelopmentHostWindow",[P,f])}}e.ExtensionHostDebugChannelClient=C}),define(te[163],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(k){this.driver=k}listen(k,P){throw new Error(`No event found: ${P}`)}call(k,P,f){switch(P){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${P}`)}}e.WindowDriverChannel=v;class n{constructor(k){this.channel=k}click(k,P,f){return this.channel.call("click",[k,P,f])}doubleClick(k){return this.channel.call("doubleClick",k)}setValue(k,P){return this.channel.call("setValue",[k,P])}getTitle(){return this.channel.call("getTitle")}isActiveElement(k){return this.channel.call("isActiveElement",k)}getElements(k,P){return this.channel.call("getElements",[k,P])}getElementXY(k,P,f){return this.channel.call("getElementXY",[k,P,f])}typeInEditor(k,P){return this.channel.call("typeInEditor",[k,P])}getTerminalBuffer(k){return this.channel.call("getTerminalBuffer",k)}writeInTerminal(k,P){return this.channel.call("writeInTerminal",[k,P])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=n;class D{constructor(k){this.channel=k}registerWindowDriver(k){return this.channel.call("registerWindowDriver",k)}reloadWindowDriver(k){return this.channel.call("reloadWindowDriver",k)}}e.WindowDriverRegistryChannelClient=D}),define(te[164],ie([0,1,129,46,10,9,34,16,7]),function(K,e,v,n,D,C,k,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(g,S,w){this._args=g,this.paths=S,this.productService=w}get appRoot(){return(0,C.dirname)(D.FileAccess.asFileUri("",K).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(f.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=k.env.VSCODE_PORTABLE;return g?f.URI.file((0,C.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,C.resolve)(g):(0,C.normalize)((0,C.join)(D.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,C.resolve)(g):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,C.resolve)(g);const S=k.env.VSCODE_EXTENSIONS;if(S)return S;const w=k.env.VSCODE_PORTABLE;return w?(0,C.join)(w,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(S=>/^[^:/?#]+?:\/\//.test(S)?f.URI.parse(S):f.URI.file((0,C.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,C.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([n.memoize],m.prototype,"appRoot",null),fe([n.memoize],m.prototype,"userHome",null),fe([n.memoize],m.prototype,"userDataPath",null),fe([n.memoize],m.prototype,"appSettingsHome",null),fe([n.memoize],m.prototype,"tmpDir",null),fe([n.memoize],m.prototype,"cacheHome",null),fe([n.memoize],m.prototype,"userRoamingDataHome",null),fe([n.memoize],m.prototype,"settingsResource",null),fe([n.memoize],m.prototype,"userDataSyncHome",null),fe([n.memoize],m.prototype,"userDataSyncLogResource",null),fe([n.memoize],m.prototype,"sync",null),fe([n.memoize],m.prototype,"machineSettingsResource",null),fe([n.memoize],m.prototype,"globalStorageHome",null),fe([n.memoize],m.prototype,"workspaceStorageHome",null),fe([n.memoize],m.prototype,"keybindingsResource",null),fe([n.memoize],m.prototype,"keyboardLayoutResource",null),fe([n.memoize],m.prototype,"argvResource",null),fe([n.memoize],m.prototype,"snippetsHome",null),fe([n.memoize],m.prototype,"isExtensionDevelopment",null),fe([n.memoize],m.prototype,"untitledWorkspacesHome",null),fe([n.memoize],m.prototype,"installSourcePath",null),fe([n.memoize],m.prototype,"builtinExtensionsPath",null),fe([n.memoize],m.prototype,"extensionsPath",null),fe([n.memoize],m.prototype,"extensionDevelopmentLocationURI",null),fe([n.memoize],m.prototype,"extensionDevelopmentKind",null),fe([n.memoize],m.prototype,"extensionTestsLocationURI",null),fe([n.memoize],m.prototype,"debugExtensionHost",null),fe([n.memoize],m.prototype,"serviceMachineIdResource",null),fe([n.memoize],m.prototype,"telemetryLogResource",null),fe([n.memoize],m.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=m;function b(t,g){return y(t["inspect-extensions"],t["inspect-brk-extensions"],5870,g,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=b;function I(t,g){return y(t["inspect-search"],t["inspect-brk-search"],5876,g,t.extensionEnvironment)}e.parseSearchPort=I;function p(t,g){return y(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,g,t.extensionEnvironment)}e.parsePtyHostPort=p;function y(t,g,S,w,M,c){const l=Number(g||t)||(w?null:S),o=l?Boolean(!!g):!1;let h;if(c)try{h=JSON.parse(c)}catch{}return{port:l,break:o,debugId:M,env:h}}}),define(te[88],ie([0,1,248,3,139]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function P(t,g,S=k){const w={},M=[],c=[];for(let h in g){const r=g[h];r.alias&&(w[h]=r.alias),r.type==="string"||r.type==="string[]"?(M.push(h),r.deprecates&&M.push(r.deprecates)):r.type==="boolean"&&(c.push(h),r.deprecates&&c.push(r.deprecates))}const a=v(t,{string:M,boolean:c,alias:w}),l={},o=a;l._=a._.map(h=>String(h)).filter(h=>h.length>0),delete o._;for(let h in g){const r=g[h];r.alias&&delete o[r.alias];let i=o[h];r.deprecates&&o.hasOwnProperty(r.deprecates)&&(i||(i=o[r.deprecates],i&&S.onDeprecatedOption(r.deprecates,h)),delete o[r.deprecates]),typeof i!="undefined"&&(r.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):r.type==="string"&&Array.isArray(i)&&(i=i.pop(),S.onMultipleValues(h,i)),l[h]=i),delete o[h]}for(let h in o)S.onUnknownOption(h);return l}e.parseArgs=P;function f(t,g){let S="";return g.args&&(Array.isArray(g.args)?S=` <${g.args.join("> <")}>`:S=` <${g.args}>`),g.alias?`-${g.alias} --${t}${S}`:`--${t}${S}`}function m(t,g){let S=0,w=[];for(const l in t){const o=t[l],h=f(l,o);S=Math.max(S,h.length),w.push([h,o.description])}let M=S+2+1;if(g-M<25)return w.reduce((l,o)=>l.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let c=g-M-1,a=[];for(const l of w){let o=l[0],h=I(l[1],c),r=b(M-o.length-2);a.push("  "+o+r+h[0]);for(let i=1;i<h.length;i++)a.push(b(M)+h[i])}return a}e.formatOptions=m;function b(t){return" ".repeat(t)}function I(t,g){let S=[];for(;t.length;){let w=t.length<g?t.length:t.lastIndexOf(" ",g),M=t.slice(0,w).trim();t=t.slice(w),S.push(M)}return S}function p(t,g,S,w,M){const c=process.stdout.isTTY&&process.stdout.columns||80,a=M?.noInputFiles!==!0?`[${(0,D.localize)(33,null)}...]`:"",l=[`${t} ${S}`];l.push(""),l.push(`${(0,D.localize)(34,null)}: ${g} [${(0,D.localize)(35,null)}]${a}`),l.push(""),M?.noPipe!==!0&&(n.isWindows?l.push((0,D.localize)(36,null,g)):l.push((0,D.localize)(37,null,g)),l.push(""));const o={};for(const h in w){const r=w[h];if(r.description&&r.cat){let i=o[r.cat];i||(o[r.cat]=i={}),i[h]=r}}for(let h in o){const r=h;let i=o[r];i&&(l.push(C[r]),l.push(...m(i,c)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=p;function y(t,g){return`${t||(0,D.localize)(38,null)}
${g||(0,D.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=y}),define(te[165],ie([0,1,61,162,88]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends n.ExtensionHostDebugBroadcastChannel{constructor(P){super();this.windowsMainService=P}call(P,f,m){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1]):super.call(P,f,m)}async openExtensionDevelopmentHostWindow(P,f){const m=(0,D.parseArgs)(P,D.OPTIONS);m.debugRenderer=f;const b=m.extensionDevelopmentPath;if(!b)return{success:!1};const[I]=this.windowsMainService.openExtensionDevelopmentHostWindow(b,{context:5,cli:m});if(!f)return{success:!0};const p=I.win;if(!p)return{success:!0};const y=p.webContents.debugger;let t=y.isAttached()?1/0:0;const g=(0,v.createServer)(S=>{t++==0&&y.attach();let w=!1;const M=l=>{w||S.write(JSON.stringify(l)+"\0")},c=(l,o,h,r)=>M({method:o,params:h,sessionId:r});p.on("close",()=>{y.removeListener("message",c),S.end(),w=!0}),y.addListener("message",c);let a=Buffer.alloc(0);S.on("data",l=>{a=Buffer.concat([a,l]);for(let o=a.indexOf(0);o!==-1;o=a.indexOf(0)){let h;try{const r=a.slice(0,o).toString("utf8");a=a.slice(o+1),h=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}y.sendCommand(h.method,h.params,h.sessionId).then(r=>M({id:h.id,sessionId:h.sessionId,result:r})).catch(r=>M({id:h.id,sessionId:h.sessionId,error:{code:0,message:r.message}}))}}),S.on("error",l=>{console.error("error on cdp pipe:",l)}),S.on("close",()=>{w=!0,--t==0&&y.detach()})});return await new Promise(S=>g.listen(0,S)),p.on("close",()=>g.close()),{rendererDebugPort:g.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),function(){"use strict";function K(e,v,n,D){function C(P){const f=k(P),m=[f];return e.isAbsolute(f)||m.unshift(D),e.resolve(...m)}function k(P){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,n);const b=P["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(I,"AppData","Roaming")}break;case"darwin":m=e.join(v.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,n)}return{getUserDataPath:C}}if(typeof define=="function")define(te[166],ie([0,249,26,10,16,34]),function(e,v,n,D,C,k){const P=C.dirname(D.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(C.joinPath(P,"package.json").fsPath);return K(v,n,f.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),n=require("os");module.exports=K(v,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[167],ie([0,1,26,164,166]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends n.AbstractNativeEnvironmentService{constructor(P,f){super(P,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P)},f)}}e.NativeEnvironmentService=C}),define(te[168],ie([0,1,28,26,27]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function C(k){const P=(0,D.randomPath)((0,n.tmpdir)());try{return(0,v.writeFileSync)(P,""),k&&console.log(`Marker file for --wait created: ${P}`),P}catch(f){k&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=C}),define(te[169],ie([0,1,143]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function C(p){return p=p.trim(),p==="*"||n.test(p)}e.isValidVersionStr=C;function k(p){if(!C(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=p.match(n);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=k;function P(p){if(!p)return null;let y=p.majorBase,t=p.majorMustEqual,g=p.minorBase,S=p.minorMustEqual,w=p.patchBase,M=p.patchMustEqual;p.hasCaret&&(y===0||(S=!1),M=!1);let c=0;if(p.preRelease){const a=D.exec(p.preRelease);if(a){const[,l,o,h]=a;c=Date.UTC(Number(l),Number(o)-1,Number(h))}}return{majorBase:y,majorMustEqual:t,minorBase:g,minorMustEqual:S,patchBase:w,patchMustEqual:M,isMinimum:p.hasGreaterEquals,notBefore:c}}e.normalizeVersion=P;function f(p,y,t){let g;typeof p=="string"?g=P(k(p)):g=p;let S;y instanceof Date?S=y.getTime():typeof y=="string"&&(S=new Date(y).getTime());let w;if(typeof t=="string"?w=P(k(t)):w=t,!g||!w)return!1;let M=g.majorBase,c=g.minorBase,a=g.patchBase,l=w.majorBase,o=w.minorBase,h=w.patchBase,r=w.notBefore,i=w.majorMustEqual,s=w.minorMustEqual,u=w.patchMustEqual;return w.isMinimum?M>l?!0:M<l?!1:c>o?!0:c<o||S&&S<r?!1:a>=h:(M===1&&l===0&&(!i||!s||!u)&&(l=1,o=0,h=0,i=!0,s=!1,u=!1),M<l?!1:M>l?!i:c<o?!1:c>o?!s:a<h?!1:a>h?!u:!(S&&S<r))}e.isValidVersion=f;function m(p,y,t,g){return t.isBuiltin||typeof t.main=="undefined"?!0:I(p,y,t.engines.vscode,g)}e.isValidExtensionVersion=m;function b(p,y,t){return p==="*"||I(y,t,p)}e.isEngineValid=b;function I(p,y,t,g=[]){let S=P(k(t));if(!S)return g.push(v.localize(0,null,t)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return g.push(v.localize(1,null,t)),!1}else if(!S.majorMustEqual)return g.push(v.localize(2,null,t)),!1;return f(p,y,S)?!0:(g.push(v.localize(3,null,p,t)),!1)}}),define(te[170],ie([0,1,4,2,17,51,21]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class P extends n.Disposable{constructor(m,b){super();this.provider=m,this.logService=b,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(m,b,I){const p=this.getUriTransformer(m);switch(b){case"stat":return this.stat(p,I[0]);case"readdir":return this.readdir(p,I[0]);case"open":return this.open(p,I[0],I[1]);case"close":return this.close(I[0]);case"read":return this.read(I[0],I[1],I[2]);case"readFile":return this.readFile(p,I[0],I[1]);case"write":return this.write(I[0],I[1],I[2],I[3],I[4]);case"writeFile":return this.writeFile(p,I[0],I[1],I[2]);case"rename":return this.rename(p,I[0],I[1],I[2]);case"copy":return this.copy(p,I[0],I[1],I[2]);case"mkdir":return this.mkdir(p,I[0]);case"delete":return this.delete(p,I[0],I[1]);case"watch":return this.watch(p,I[0],I[1],I[2],I[3]);case"unwatch":return this.unwatch(I[0],I[1])}throw new Error(`IPC Command ${b} not found`)}listen(m,b,I){const p=this.getUriTransformer(m);switch(b){case"fileChange":return this.onFileChange(p,I[0]);case"readFileStream":return this.onReadFileStream(p,I[0],I[1])}throw new Error(`Unknown event ${b}`)}stat(m,b){const I=this.transformIncoming(m,b,!0);return this.provider.stat(I)}readdir(m,b){const I=this.transformIncoming(m,b);return this.provider.readdir(I)}async readFile(m,b,I){const p=this.transformIncoming(m,b,!0),y=await this.provider.readFile(p,I);return D.VSBuffer.wrap(y)}onReadFileStream(m,b,I){const p=this.transformIncoming(m,b,!0),y=new k.CancellationTokenSource,t=new v.Emitter({onLastListenerRemove:()=>{y.cancel()}}),g=this.provider.readFileStream(p,I,y.token);return(0,C.listenStream)(g,{onData:S=>t.fire(D.VSBuffer.wrap(S)),onError:S=>t.fire(S),onEnd:()=>{t.fire("end"),t.dispose(),y.dispose()}}),t.event}writeFile(m,b,I,p){const y=this.transformIncoming(m,b);return this.provider.writeFile(y,I.buffer,p)}open(m,b,I){const p=this.transformIncoming(m,b,!0);return this.provider.open(p,I)}close(m){return this.provider.close(m)}async read(m,b,I){const p=D.VSBuffer.alloc(I),y=0,t=await this.provider.read(m,b,p.buffer,y,I);return[p,t]}write(m,b,I,p,y){return this.provider.write(m,b,I.buffer,p,y)}mkdir(m,b){const I=this.transformIncoming(m,b);return this.provider.mkdir(I)}delete(m,b,I){const p=this.transformIncoming(m,b);return this.provider.delete(p,I)}rename(m,b,I,p){const y=this.transformIncoming(m,b),t=this.transformIncoming(m,I);return this.provider.rename(y,t,p)}copy(m,b,I,p){const y=this.transformIncoming(m,b),t=this.transformIncoming(m,I);return this.provider.copy(y,t,p)}onFileChange(m,b){const I=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(b,this.createSessionFileWatcher(m,I))},onLastListenerRemove:()=>{(0,n.dispose)(this.sessionToWatcher.get(b)),this.sessionToWatcher.delete(b)}});return I.event}async watch(m,b,I,p,y){const t=this.sessionToWatcher.get(b);if(t){const g=this.transformIncoming(m,p),S=t.watch(I,g,y);this.watchRequests.set(b+I,S)}}async unwatch(m,b){const I=m+b,p=this.watchRequests.get(I);p&&((0,n.dispose)(p),this.watchRequests.delete(I))}dispose(){super.dispose();for(const[,m]of this.watchRequests)m.dispose();this.watchRequests.clear();for(const[,m]of this.sessionToWatcher)m.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=P}),define(te[73],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(D,C=[],k=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=v}),define(te[171],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=v;class n{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let k of this._nodes.values())k.outgoing.size===0&&C.push(k);return C}insertEdge(C,k){const P=this.lookupOrInsertNode(C),f=this.lookupOrInsertNode(k);P.outgoing.set(this._hashFn(k),f),f.incoming.set(this._hashFn(C),P)}removeNode(C){const k=this._hashFn(C);this._nodes.delete(k);for(let P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(C){const k=this._hashFn(C);let P=this._nodes.get(k);return P||(P=new v(C),this._nodes.set(k,P)),P}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[k,P]of this._nodes)C.push(`${k}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,k]of this._nodes){const P=new Set([C]),f=this._findCycle(k,P);if(f)return f}}_findCycle(C,k){for(let[P,f]of C.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const m=this._findCycle(f,k);if(m)return m;k.delete(P)}}}e.Graph=n}),define(te[5],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function P(f){return f[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=P})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function n(k,P,f,m){P[v.DI_TARGET]===P?P[v.DI_DEPENDENCIES].push({id:k,index:f,optional:m}):(P[v.DI_DEPENDENCIES]=[{id:k,index:f,optional:m}],P[v.DI_TARGET]=P)}function D(k){if(v.serviceIds.has(k))return v.serviceIds.get(k);const P=function(f,m,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(P,f,b,!1)};return P.toString=()=>k,v.serviceIds.set(k,P),P}e.createDecorator=D;function C(k){return k}e.refineServiceDecorator=C}),define(te[52],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService")}),define(te[19],ie([0,1,13,7,5]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(S){return S&&typeof S=="object"&&(!S.overrideIdentifier||typeof S.overrideIdentifier=="string")&&(!S.resource||S.resource instanceof n.URI)}e.isConfigurationOverrides=C;function k(S){return S&&typeof S=="object"&&(!S.overrideIdentifiers||v.isArray(S.overrideIdentifiers))&&!S.overrideIdentifier&&(!S.resource||S.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=k;var P;(function(S){S[S.USER=1]="USER",S[S.USER_LOCAL=2]="USER_LOCAL",S[S.USER_REMOTE=3]="USER_REMOTE",S[S.WORKSPACE=4]="WORKSPACE",S[S.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",S[S.DEFAULT=6]="DEFAULT",S[S.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(S){switch(S){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=f;function m(S,w){const M=Object.create(null);for(let c in S)b(M,c,S[c],w);return M}e.toValuesTree=m;function b(S,w,M,c){const a=w.split("."),l=a.pop();let o=S;for(let h=0;h<a.length;h++){let r=a[h],i=o[r];switch(typeof i){case"undefined":i=o[r]=Object.create(null);break;case"object":break;default:c(`Ignoring ${w} as ${a.slice(0,h+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[l]=M}catch{c(`Ignoring ${w} as ${a.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${w} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=b;function I(S,w){const M=w.split(".");p(S,M)}e.removeFromValueTree=I;function p(S,w){const M=w.shift();if(w.length===0){delete S[M];return}if(Object.keys(S).indexOf(M)!==-1){const c=S[M];typeof c=="object"&&!Array.isArray(c)&&(p(c,w),Object.keys(c).length===0&&delete S[M])}}function y(S,w,M){function c(o,h){let r=o;for(const i of h){if(typeof r!="object"||r===null)return;r=r[i]}return r}const a=w.split("."),l=c(S,a);return typeof l=="undefined"?M:l}e.getConfigurationValue=y;function t(S,w,M){Object.keys(w).forEach(c=>{c!=="__proto__"&&(c in S?v.isObject(S[c])&&v.isObject(w[c])?t(S[c],w[c],M):M&&(S[c]=w[c]):S[c]=w[c])})}e.merge=t;function g(S,w,M){const c=S.inspect(w),a=S.inspect(M);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:c.defaultValue}e.getMigratedSettingValue=g}),define(te[74],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function n(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=n}),define(te[89],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class n{constructor(C){this.machineId=C}encryption(){return new Promise((C,k)=>K(["vscode-encrypt"],C,k))}async encrypt(C){try{return(await this.encryption()).encrypt(this.machineId,C)}catch{return C}}async decrypt(C){try{return(await this.encryption()).decrypt(this.machineId,C)}catch{return C}}}e.EncryptionMainService=n}),define(te[53],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(te[172],ie([0,1,10,142,5]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function k(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function P(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function f(c,a){switch(c){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=f;function m(c,a){return a==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=m;function b(c,a,l){return m(a,l)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===l?!0:I(l).includes(c)}e.isTargetPlatformCompatible=b;function I(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function p(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=p;var y;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var t;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var g;(function(c){c.Install="install",c.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var S;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var w;(function(c){c.Unsupported="Unsupported",c.UnsupportedPreRelease="UnsupportedPreRelease",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class M extends Error{constructor(a,l){super(a);this.code=l,this.name=l}}e.ExtensionManagementError=M,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(te[173],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(te[174],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[90],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(te[175],ie([0,1,44,10,9,3,81,24,72,144,90]),function(K,e,v,n,D,C,k,P,f,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=m.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends p{openTerminal(a,l){return this.spawnTerminal(v,a,f.getWindowsShell(),l)}spawnTerminal(a,l,o,h){const r=l.windowsExec||y.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const i=D.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(r,h?[h]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return r.indexOf(" ")>=0&&s.push('""'),s.push(r),(i==="wt"||i==="wt.exe")&&s.push("-d ."),new Promise((u,d)=>{const E=S(process),L=a.spawn(o,s,{cwd:h,env:E});L.on("error",d),L.on("exit",()=>u())})}runInTerminal(a,l,o,h,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:y.getDefaultTerminalWindows();return new Promise((s,u)=>{const d=`"${l} - ${I}"`,E=`""${o.join('" "')}" & pause"`,L=["/c","start",d,"/wait",i,"/c",E],R=Object.assign({},S(process),h);Object.keys(R).filter(Q=>R[Q]===null).forEach(Q=>delete R[Q]);const T={cwd:l,env:R,windowsVerbatimArguments:!0};v.spawn(y.CMD,L,T).on("error",Q=>{u(w(Q))}),s(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class t extends p{openTerminal(a,l){return this.spawnTerminal(v,a,l)}runInTerminal(a,l,o,h,r){const i=r.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((s,u)=>{if(i===b.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const d=i===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,K).fsPath,"-t",a||I,"-w",l];for(let N of o)L.push("-a"),L.push(N);if(h){const N=Object.assign({},S(process),h);for(let Q in N){const se=N[Q];se===null?(L.push("-u"),L.push(Q)):(L.push("-e"),L.push(`${Q}=${se}`))}}let R="";const T=v.spawn(t.OSASCRIPT,L);T.on("error",N=>{u(w(N))}),T.stderr.on("data",N=>{R+=N.toString()}),T.on("exit",N=>{if(N===0)s(void 0);else if(R){const Q=R.split(`
`,1);u(new Error(Q[0]))}else u(new Error(m.localize(1,null,d,N)))})}else u(new Error(m.localize(2,null,i)))})}spawnTerminal(a,l,o){const h=l.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const s=["-a",h];o&&s.push(o);const u=S(process),d=a.spawn("/usr/bin/open",s,{cwd:o,env:u});d.on("error",i),d.on("exit",()=>r())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class g extends p{openTerminal(a,l){return this.spawnTerminal(v,a,l)}runInTerminal(a,l,o,h,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,u)=>{let d=[];i.then(E=>{E.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const L=`${M(o)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;d.push(`''${L}''`);const R=Object.assign({},S(process),h);Object.keys(R).filter(se=>R[se]===null).forEach(se=>delete R[se]);const T={cwd:l,env:R};let N="";const Q=v.spawn(E,d,T);Q.on("error",se=>{u(w(se))}),Q.stderr.on("data",se=>{N+=se.toString()}),Q.on("exit",se=>{if(se===0)s(void 0);else if(N){const ne=N.split(`
`,1);u(new Error(ne[0]))}else u(new Error(m.localize(4,null,E,se)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await P.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{a?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,l,o){const h=l.linuxExec?Promise.resolve(l.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{h.then(s=>{const u=S(process),d=a.spawn(s,[],{cwd:o,env:u});d.on("error",i),d.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=m.localize(3,null);function S(c){const a={...c.env};return(0,k.sanitizeProcessEnvironment)(a),a}function w(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(m.localize(5,null,c.path)):c}function M(c){let a="";for(let l of c)l.indexOf(" ")>=0?a+='"'+l+'"':a+=l,a+=" ";return a}}),define(te[18],ie([0,1,35,9,25,13,7,146,5]),function(K,e,v,n,D,C,k,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function m(H){return H.create===!0}e.isFileOpenForWriteOptions=m;var b;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var I;(function(H){H[H.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var p;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=y;function t(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=t;function g(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function S(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=S;function w(H){return y(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var M;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(M=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(q,Y){super(q);this.code=Y}}e.FileSystemProviderError=c;function a(H,q){const Y=new c(H.toString(),q);return o(Y,q),Y}e.createFileSystemProviderError=a;function l(H){return H||a((0,P.localize)(0,null),M.Unknown)}e.ensureFileSystemProviderError=l;function o(H,q){return H.name=q?`${q} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=o;function h(H){if(!H)return M.Unknown;if(H instanceof c)return H.code;const q=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!q)return M.Unknown;switch(q[1]){case M.FileExists:return M.FileExists;case M.FileIsADirectory:return M.FileIsADirectory;case M.FileNotADirectory:return M.FileNotADirectory;case M.FileNotFound:return M.FileNotFound;case M.FileExceedsMemoryLimit:return M.FileExceedsMemoryLimit;case M.FileTooLarge:return M.FileTooLarge;case M.FileWriteLocked:return M.FileWriteLocked;case M.NoPermissions:return M.NoPermissions;case M.Unavailable:return M.Unavailable}return M.Unknown}e.toFileSystemProviderErrorCode=h;function r(H){if(H instanceof L)return H.fileOperationResult;switch(h(H)){case M.FileNotFound:return 1;case M.FileIsADirectory:return 0;case M.FileNotADirectory:return 10;case M.FileWriteLocked:return 5;case M.NoPermissions:return 6;case M.FileExists:return 4;case M.FileExceedsMemoryLimit:return 9;case M.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(q,Y,j){this.resource=q,this.operation=Y,this.target=j}isOperation(q){return this.operation===q}}e.FileOperationEvent=s;var u;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class d{constructor(q,Y){this.added=void 0,this.updated=void 0,this.deleted=void 0;const j=new Map;for(const z of q){const G=j.get(z.type);G?G.push([z.resource,z]):j.set(z.type,[[z.resource,z]])}for(const[z,G]of j)switch(z){case 1:this.added=v.TernarySearchTree.forUris(()=>Y),this.added.fill(G);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>Y),this.updated.fill(G);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>Y),this.deleted.fill(G);break}}contains(q,...Y){return this.doContains(q,{includeChildren:!1},...Y)}affects(q,...Y){return this.doContains(q,{includeChildren:!0},...Y)}doContains(q,Y,...j){if(!q)return!1;const z=j.length>0;return!!((!z||j.includes(1))&&(this.added?.get(q)||Y.includeChildren&&this.added?.findSuperstr(q))||(!z||j.includes(0))&&(this.updated?.get(q)||Y.includeChildren&&this.updated?.findSuperstr(q))||(!z||j.includes(2))&&(this.deleted?.findSubstr(q)||Y.includeChildren&&this.deleted?.findSuperstr(q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawUpdated(){return this.updated}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function E(H,q,Y){return!H||!q||H===q||q.length>H.length?!1:(q.charAt(q.length-1)!==n.sep&&(q+=n.sep),Y?(0,D.startsWithIgnoreCase)(H,q):H.indexOf(q)===0)}e.isParent=E;class L extends Error{constructor(q,Y,j){super(q);this.fileOperationResult=Y,this.options=j}}e.FileOperationError=L;class R extends L{constructor(q,Y,j){super(q,2,j);this.stat=Y}}e.NotModifiedSinceFileOperationError=R;var T;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(N=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Q(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=Q;async function se(H,q){if(!q.hasProvider(k.URI.from({scheme:H.scheme})))return new Promise(Y=>{const j=q.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===H.scheme&&z.added&&(j.dispose(),Y())})})}e.whenProviderRegistered=se,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ne{static formatSize(q){return(0,C.isNumber)(q)||(q=0),q<ne.KB?(0,P.localize)(1,null,q.toFixed(0)):q<ne.MB?(0,P.localize)(2,null,(q/ne.KB).toFixed(2)):q<ne.GB?(0,P.localize)(3,null,(q/ne.MB).toFixed(2)):q<ne.TB?(0,P.localize)(4,null,(q/ne.GB).toFixed(2)):(0,P.localize)(5,null,(q/ne.TB).toFixed(2))}}e.ByteSize=ne,ne.KB=1024,ne.MB=ne.KB*ne.KB,ne.GB=ne.MB*ne.KB,ne.TB=ne.GB*ne.KB;var V;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function Z(H){return{maxFileSize:H===0?300*ne.MB:16*ne.GB,maxHeapSize:H===0?700*ne.MB:2*700*ne.MB}}e.getPlatformLimits=Z}),define(te[54],ie([0,1,250,140,88,18]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(p,y){const t={onUnknownOption:S=>{console.warn((0,n.localize)(0,null,S))},onMultipleValues:(S,w)=>{console.warn((0,n.localize)(1,null,S,w))},onDeprecatedOption:(S,w)=>{console.warn((0,n.localize)(2,null,S,w))}},g=(0,D.parseArgs)(p,D.OPTIONS,y?t:void 0);return g.goto&&g._.forEach(S=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,n.localize)(3,null))),g["max-memory"]&&v(parseInt(g["max-memory"])>=C.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${C.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function P(p){const y=p.findIndex(t=>!/^-/.test(t));if(y>-1)return[...p.slice(0,y),...p.slice(y+1)]}function f(p){let[,...y]=p;process.env.VSCODE_DEV&&(y=P(y)||[]);const t=!I(process.env);return k(y,t)}e.parseMainProcessArgv=f;function m(p){const[,,...y]=p;return k(y,!0)}e.parseCLIProcessArgv=m;function b(p,...y){const t=p.indexOf("--");return t===-1?p.push(...y):p.splice(t,0,...y),p}e.addArg=b;function I(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(te[91],ie([0,1,44,9,141,21,39,15,3,32,134,54,8]),function(K,e,v,n,D,C,k,P,f,m,b,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let t;async function g(w,M,c){return M["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(c)&&!M["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(c)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=p.Promises.withAsyncBody(async(a,l)=>{const o=new C.CancellationTokenSource,h=setTimeout(()=>{o.dispose(!0),l(new Error((0,D.localize)(0,null)))},y);try{a(await S(w,o.token))}catch(r){!(0,P.isPromiseCanceledError)(r)&&!o.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,k.toErrorMessage)(r)))):a({})}finally{clearTimeout(h),o.dispose()}})),t)}e.getResolvedShellEnv=g;async function S(w,M){const c=process.env.ELECTRON_RUN_AS_NODE;w.trace("getUnixShellEnvironment#runAsNode",c);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;w.trace("getUnixShellEnvironment#noAttach",a);const l=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(l+"(.*)"+l),h={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};w.trace("getUnixShellEnvironment#env",h);const r=await(0,b.getSystemShell)(f.OS,h);return w.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(M.isCancellationRequested)return s((0,P.canceled)());const u=(0,n.basename)(r);let d,E;const L=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(d=`& '${process.execPath}' ${L} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,E=["-Login","-Command"]):(d=`'${process.execPath}' ${L} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,u==="tcsh"?E=["-ic"]:E=["-ilc"]),w.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),d);const R=(0,v.spawn)(r,[...E,d],{detached:!0,stdio:["ignore","pipe","pipe"],env:h});M.onCancellationRequested(()=>(R.kill(),s((0,P.canceled)()))),R.on("error",Q=>{w.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(Q)),s(Q)});const T=[];R.stdout.on("data",Q=>T.push(Q));const N=[];R.stderr.on("data",Q=>N.push(Q)),R.on("close",(Q,se)=>{const ne=Buffer.concat(T).toString("utf8");w.trace("getUnixShellEnvironment#raw",ne);const V=Buffer.concat(N).toString("utf8");if(V.trim()&&w.trace("getUnixShellEnvironment#stderr",V),Q||se)return s(new Error((0,D.localize)(2,null,Q,se)));const Z=o.exec(ne),H=Z?Z[1]:"{}";try{const q=JSON.parse(H);c?q.ELECTRON_RUN_AS_NODE=c:delete q.ELECTRON_RUN_AS_NODE,a?q.ELECTRON_NO_ATTACH_CONSOLE=a:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,w.trace("getUnixShellEnvironment#result",q),i(q)}catch(q){w.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(q)),s(q)}})})}}),define(te[176],ie([0,1,17,39,15,4,2,51,7,32,18]),function(K,e,v,n,D,C,k,P,f,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends k.Disposable{constructor(y,t){super();this.channel=y,this.extraCapabilities=t,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,m.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,t){const{buffer:g}=await this.channel.call("readFile",[y,t]);return g}readFileStream(y,t,g){const S=(0,P.newWriteableStream)(M=>v.VSBuffer.concat(M.map(c=>v.VSBuffer.wrap(c))).buffer),w=this.channel.listen("readFileStream",[y,t])(M=>{if(M instanceof v.VSBuffer)S.write(M.buffer);else{if(M==="end")S.end();else{let c=M;c instanceof Error||(c=(0,b.createFileSystemProviderError)((0,n.toErrorMessage)(c),b.FileSystemProviderErrorCode.Unknown)),S.error(c),S.end()}w.dispose()}});return g.onCancellationRequested(()=>{S.error((0,D.canceled)()),S.end(),w.dispose()}),S}writeFile(y,t,g){return this.channel.call("writeFile",[y,v.VSBuffer.wrap(t),g])}open(y,t){return this.channel.call("open",[y,t])}close(y){return this.channel.call("close",[y])}async read(y,t,g,S,w){const[M,c]=await this.channel.call("read",[y,t,w]);return g.set(M.buffer.slice(0,c),S),c}write(y,t,g,S,w){return this.channel.call("write",[y,t,v.VSBuffer.wrap(g),S,w])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,t){return this.channel.call("delete",[y,t])}rename(y,t,g){return this.channel.call("rename",[y,t,g])}copy(y,t,g){return this.channel.call("copy",[y,t,g])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const t=y;this._onDidChange.fire(t.map(g=>({resource:f.URI.revive(g.resource),type:g.type})))}else{const t=y;this._onDidWatchError.fire(t)}}))}watch(y,t){const g=(0,m.generateUuid)();return this.channel.call("watch",[this.sessionId,g,y,t]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,g]))}}e.DiskFileSystemProviderClient=I}),define(te[92],ie([0,1,17,15,147,18]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(b,I,p,y,t,g){let S;try{await P(b,I,p,y,t,g)}catch(w){S=w}finally{S&&t.errorTransformer&&(S=t.errorTransformer(S)),typeof S!="undefined"&&p.error(S),p.end()}}e.readFileIntoStream=k;async function P(b,I,p,y,t,g){f(g);const S=await b.open(I,{create:!1});try{f(g);let w=0,M=0,c=t&&typeof t.length=="number"?t.length:void 0,a=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),l=t&&typeof t.position=="number"?t.position:0,o=0;do M=await b.read(S,l,a.buffer,o,a.byteLength-o),l+=M,o+=M,w+=M,typeof c=="number"&&(c-=M),o===a.byteLength&&(await p.write(y(a)),a=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),o=0);while(M>0&&(typeof c!="number"||c>0)&&f(g)&&m(w,t));if(o>0){let h=o;typeof c=="number"&&(h=Math.min(o,c)),p.write(y(a.slice(0,h)))}}catch(w){throw(0,C.ensureFileSystemProviderError)(w)}finally{await b.close(S)}}function f(b){if(b.isCancellationRequested)throw(0,n.canceled)();return!0}function m(b,I){if(I?.limits){if(typeof I.limits.memory=="number"&&b>I.limits.memory)throw(0,C.createFileSystemProviderError)((0,D.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&b>I.limits.size)throw(0,C.createFileSystemProviderError)((0,D.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[62],ie([0,1,2,3,7,18]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class k extends v.Disposable{constructor(I,p,y){super();this.onFileChanges=I,this.onLogMessage=p,this.verboseLogging=y,this.watcherDisposables=this._register(new v.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const I=new v.DisposableStore;this.watcherDisposables.value=I,this.watcher=this.createWatcher(I),this.watcher.setVerboseLogging(this.verboseLogging),I.add(this.watcher.onDidChangeFile(p=>this.onFileChanges(p))),I.add(this.watcher.onDidLogMessage(p=>this.onLogMessage(p))),I.add(this.watcher.onDidError(p=>this.onError(p)))}onError(I){this.restartCounter<k.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${I}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${I}`)}restart(I){this.restartCounter++,this.init(),this.watch(I)}async watch(I){this.requests=I,await this.watcher?.watch(I)}async setVerboseLogging(I){this.verboseLogging=I,await this.watcher?.setVerboseLogging(I)}error(I){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${I}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=k,k.MAX_RESTARTS=5;function P(b){return b.map(I=>({type:I.type,resource:D.URI.file(I.path)}))}e.toFileChanges=P;function f(b){const I=new m;for(const p of b)I.processEvent(p);return I.coalesce()}e.coalesceEvents=f;class m{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(I){return n.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const p=this.mapPathToChange.get(this.toKey(I));let y=!1;if(p){const t=p.type,g=I.type;p.path!==I.path&&(I.type===2||I.type===1)?y=!0:t===1&&g===2?(this.mapPathToChange.delete(this.toKey(I)),this.coalesced.delete(p)):t===2&&g===1?p.type=0:t===1&&g===0||(p.type=g)}else y=!0;y&&(this.coalesced.add(I),this.mapPathToChange.set(this.toKey(I),I))}coalesce(){const I=[],p=[];return Array.from(this.coalesced).filter(y=>y.type!==2?(I.push(y),!1):!0).sort((y,t)=>y.path.length-t.path.length).filter(y=>p.some(t=>(0,C.isParent)(y.path,t,!n.isLinux))?!1:(p.push(y.path),!0)).concat(I)}}}),define(te[93],ie([0,1,28,8,21,27,113,2,70,9,3,83,24,62]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcher=void 0;class t extends P.Disposable{constructor(w,M,c,a){super();this.request=w,this.onDidFilesChange=M,this.onLogMessage=c,this.verboseLogging=a,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(t.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(l=>(0,k.parse)(l)),this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;this.trace(`Request to start watching: ${w} (excludes: ${this.request.excludes}))}`);const M=await p.Promises.stat(w);this._register(await this.doWatch(w,M.isDirectory()))}catch(w){w.code!=="ENOENT"&&this.error(w)}}async normalizePath(w){let M=w.path;try{M=await p.Promises.realpath(w.path),w.path===M&&(M=await(0,I.realcase)(w.path)??w.path),w.path!==M&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${M})`)}catch{}return M}async doWatch(w,M){if(b.isMacintosh&&(0,C.isEqualOrParent)(w,"/Volumes/"))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),P.Disposable.None;const c=new D.CancellationTokenSource(this.cts.token);let a=new P.DisposableStore;try{const l=(0,v.watch)(w);a.add((0,P.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const o=new Set;if(M)try{for(const r of await p.Promises.readdir(w))o.add(r)}catch(r){this.error(r)}const h=new Map;a.add((0,P.toDisposable)(()=>{for(const[,r]of h)r.dispose();h.clear()})),l.on("error",(r,i)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${r}, ${i})`)}),l.on("change",(r,i)=>{if(c.token.isCancellationRequested)return;this.trace(`["${r}"] ${i} (fs.watch() raw event)`);let s="";if(i&&(s=i.toString(),b.isMacintosh&&(s=(0,f.normalizeNFC)(s))),!(!s||r!=="change"&&r!=="rename"))if(M)if(r==="rename"){h.get(s)?.dispose();const u=setTimeout(async()=>{if(h.delete(s),s===(0,m.basename)(w)&&!await p.Promises.exists(w))this.onFileChange({path:this.request.path,type:2});else{const d=await this.existsChildStrictCase((0,m.join)(w,s));if(c.token.isCancellationRequested)return;let E;d?o.has(s)?E=0:(E=1,o.add(s)):(o.delete(s),E=2),this.onFileChange({path:(0,m.join)(this.request.path,s),type:E})}},t.FILE_DELETE_HANDLER_DELAY);h.set(s,(0,P.toDisposable)(()=>clearTimeout(u)))}else{let u;o.has(s)?u=0:(u=1,o.add(s)),this.onFileChange({path:(0,m.join)(this.request.path,s),type:u})}else if(r==="rename"||s!==(0,m.basename)(w)){const u=setTimeout(async()=>{const d=await p.Promises.exists(w);c.token.isCancellationRequested||(d?(this.onFileChange({path:this.request.path,type:0}),a.add(await this.doWatch(w,!1))):this.onFileChange({path:this.request.path,type:2}))},t.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,P.toDisposable)(()=>clearTimeout(u)))}else this.onFileChange({path:this.request.path,type:0})})}catch(l){await p.Promises.exists(w)&&!c.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${l.toString()})`)}return(0,P.toDisposable)(()=>{c.dispose(!0),a.dispose()})}onFileChange(w){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),this.excludes.some(M=>M(w.path))?this.verboseLogging&&this.trace(` >> ignored ${w.path}`):this.fileChangesBuffer.push(w),this.fileChangesDelayer.trigger(async()=>{const M=this.fileChangesBuffer;this.fileChangesBuffer=[];const c=(0,y.coalesceEvents)(M);if(this.verboseLogging)for(const a of c)this.trace(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);c.length>0&&this.onDidFilesChange(c)}).catch(()=>{}))}async existsChildStrictCase(w){if(b.isLinux)return await p.Promises.exists(w);try{return(await p.Promises.readdir((0,m.dirname)(w))).some(c=>c===(0,m.basename)(w))}catch{return!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcher=t,t.FILE_DELETE_HANDLER_DELAY=25,t.FILE_CHANGES_HANDLER_DELAY=50;async function g(S,w,M,c=512){const a=await p.Promises.open(S,"r"),l=Buffer.allocUnsafe(c),o=new D.CancellationTokenSource(M);let h,r=!1;const i={path:S,excludes:[]},s=new t(i,u=>{(async()=>{for(const{type:d}of u)if(d===0){if(r)return;r=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:E}=await p.Promises.read(a,l,0,c,null);if(!E||o.token.isCancellationRequested)break;w(l.slice(0,E))}}catch(E){h=new Error(E),o.dispose(!0)}finally{r=!1}}})()});return new Promise((u,d)=>{o.token.onCancellationRequested(async()=>{s.dispose();try{await p.Promises.close(a)}catch(E){h=new Error(E)}h?d(h):u()})})}e.watchFileContents=g}),define(te[177],ie([0,1,10,37,135,62]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class k extends C.AbstractRecursiveWatcherClient{constructor(f,m,b){super(f,m,b);this.init()}createWatcher(f){const m=f.add(new D.Client(v.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(m.onDidProcessExit(({code:b,signal:I})=>this.onError(`terminated by itself with code ${b}, signal: ${I}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(m.getChannel("watcher")))}}e.ParcelWatcherClient=k}),define(te[75],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(let[C,k]of D)this.set(C,k)}set(D,C){const k=this._entries.get(D);return this._entries.set(D,C),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(te[178],ie([0,1,8,15,73,171,5,75]),function(K,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class m extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class b{constructor(t=new P.ServiceCollection,g=!1,S){this._activeInstantiations=new Set,this._services=t,this._strict=g,this._parent=S,this._services.set(k.IInstantiationService,this)}createChild(t){return new b(t,this._strict,this)}invokeFunction(t,...g){let S=p.traceInvocation(t),w=!1;try{return t({get:c=>{if(w)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(c,S);if(!a)throw new Error(`[invokeFunction] unknown service '${c}'`);return a}},...g)}finally{w=!0,S.stop()}}createInstance(t,...g){let S,w;return t instanceof D.SyncDescriptor?(S=p.traceCreation(t.ctor),w=this._createInstance(t.ctor,t.staticArguments.concat(g),S)):(S=p.traceCreation(t),w=this._createInstance(t,g,S)),S.stop(),w}_createInstance(t,g=[],S){let w=k._util.getServiceDependencies(t).sort((a,l)=>a.index-l.index),M=[];for(const a of w){let l=this._getOrCreateServiceInstance(a.id,S);if(!l&&this._strict&&!a.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${a.id}.`);M.push(l)}let c=w.length>0?w[0].index:g.length;if(g.length!==c){console.warn(`[createInstance] First service dependency of ${t.name} at position ${c+1} conflicts with ${g.length} static arguments`);let a=c-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,c)}return new t(...[...g,...M])}_setServiceInstance(t,g){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,g);else if(this._parent)this._parent._setServiceInstance(t,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let g=this._services.get(t);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):g}_getOrCreateServiceInstance(t,g){let S=this._getServiceInstanceOrDescriptor(t);return S instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,S,g.branch(t,!0)):(g.branch(t,!1),S)}_safeCreateAndCacheServiceInstance(t,g,S){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,g,S)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,g,S){const w=new C.Graph(a=>a.id.toString());let M=0;const c=[{id:t,desc:g,_trace:S}];for(;c.length;){const a=c.pop();if(w.lookupOrInsertNode(a),M++>1e3)throw new m(w);for(let l of k._util.getServiceDependencies(a.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(l.id);if(!o&&!l.optional&&console.warn(`[createInstance] ${t} depends on ${l.id} which is NOT registered.`),o instanceof D.SyncDescriptor){const h={id:l.id,desc:o,_trace:a._trace.branch(l.id,!0)};w.insertEdge(a,h),c.push(h)}}}for(;;){const a=w.roots();if(a.length===0){if(!w.isEmpty())throw new m(w);break}for(const{data:l}of a){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const h=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,h)}w.removeNode(l)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,g,S=[],w,M){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(g,S,w,M);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,g,S,w,M);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(t,g=[],S,w){if(S){const M=new v.IdleValue(()=>this._createInstance(t,g,w));return new Proxy(Object.create(null),{get(c,a){if(a in c)return c[a];let l=M.value,o=l[a];return typeof o!="function"||(o=o.bind(l),c[a]=o),o},set(c,a,l){return M.value[a]=l,!0}})}else return this._createInstance(t,g,w)}}e.InstantiationService=b;var I;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(I||(I={}));class p{constructor(t,g){this.type=t,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return f?new p(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(t){return f?new p(0,t.name):p._None}branch(t,g){let S=new p(2,t.toString());return this._dep.push([t,g,S]),S}stop(){let t=Date.now()-this._start;p._totals+=t;let g=!1;function S(M,c){let a=[],l=new Array(M+1).join("	");for(const[o,h,r]of c._dep)if(h&&r){g=!0,a.push(`${l}CREATES -> ${o}`);let i=S(M+1,r);i&&a.push(i)}else a.push(`${l}uses -> ${o}`);return a.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(t>2||g)&&console.log(w.join(`
`))}}p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(te[179],ie([0,1,15,132,59]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class C extends D.ResolvedKeybinding{constructor(P,f){super();if(f.length===0)throw(0,v.illegalArgument)("parts");this._os=P,this._parts=f}getLabel(){return n.UILabelProvider.toLabel(this._os,this._parts,P=>this._getLabel(P))}getAriaLabel(){return n.AriaLabelProvider.toLabel(this._os,this._parts,P=>this._getAriaLabel(P))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:n.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,P=>this._getElectronAccelerator(P))}getUserSettingsLabel(){return n.UserSettingsLabelProvider.toLabel(this._os,this._parts,P=>this._getUserSettingsLabel(P))}isWYSIWYG(){return this._parts.every(P=>this._isWYSIWYG(P))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(P=>this._getPart(P))}_getPart(P){return new D.ResolvedKeybindingPart(P.ctrlKey,P.shiftKey,P.altKey,P.metaKey,this._getLabel(P),this._getAriaLabel(P))}getDispatchParts(){return this._parts.map(P=>this._getDispatchPart(P))}getSingleModifierDispatchParts(){return this._parts.map(P=>this._getSingleModifierDispatchPart(P))}}e.BaseResolvedKeybinding=C}),define(te[180],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class v{constructor(C,k,P,f,m,b,I){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=C,this.keypressParts=C?n(C.getDispatchParts()):[],C&&this.keypressParts.length===0&&(this.keypressParts=n(C.getSingleModifierDispatchParts())),this.bubble=k?k.charCodeAt(0)===94:!1,this.command=this.bubble?k.substr(1):k,this.commandArgs=P,this.when=f,this.isDefault=m,this.extensionId=b,this.isBuiltinExtension=I}}e.ResolvedKeybindingItem=v;function n(D){let C=[];for(let k=0,P=D.length;k<P;k++){const f=D[k];if(!f)return C;C.push(f)}return C}e.removeElementsAfterNulls=n}),define(te[181],ie([0,1,80,59,179,180]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends D.BaseResolvedKeybinding{constructor(f,m){super(m,f.parts)}_keyCodeToUILabel(f){if(this._os===2)switch(f){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(f)}_getLabel(f){return f.isDuplicateModifierCase()?"":this._keyCodeToUILabel(f.keyCode)}_getAriaLabel(f){return f.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(f.keyCode)}_getElectronAccelerator(f){return v.KeyCodeUtils.toElectronAccelerator(f.keyCode)}_getUserSettingsLabel(f){if(f.isDuplicateModifierCase())return"";const m=v.KeyCodeUtils.toUserSettingsUS(f.keyCode);return m&&m.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(f){return k.getDispatchStr(f)}static getDispatchStr(f){if(f.isModifierKey())return null;let m="";return f.ctrlKey&&(m+="ctrl+"),f.shiftKey&&(m+="shift+"),f.altKey&&(m+="alt+"),f.metaKey&&(m+="meta+"),m+=v.KeyCodeUtils.toString(f.keyCode),m}_getSingleModifierDispatchPart(f){return f.keyCode===5&&!f.shiftKey&&!f.altKey&&!f.metaKey?"ctrl":f.keyCode===4&&!f.ctrlKey&&!f.altKey&&!f.metaKey?"shift":f.keyCode===6&&!f.ctrlKey&&!f.shiftKey&&!f.metaKey?"alt":f.keyCode===57&&!f.ctrlKey&&!f.shiftKey&&!f.altKey?"meta":null}static _scanCodeToKeyCode(f){const m=v.IMMUTABLE_CODE_TO_KEY_CODE[f];if(m!==-1)return m;switch(f){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(f){if(!f)return null;if(f instanceof n.SimpleKeybinding)return f;const m=this._scanCodeToKeyCode(f.scanCode);return m===0?null:new n.SimpleKeybinding(f.ctrlKey,f.shiftKey,f.altKey,f.metaKey,m)}static resolveUserBinding(f,m){const b=(0,C.removeElementsAfterNulls)(f.map(I=>this._resolveSimpleUserBinding(I)));return b.length>0?[new k(new n.ChordKeybinding(b),m)]:[]}}e.USLayoutResolvedKeybinding=k}),define(te[182],ie([0,1,8]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function n(D,C){if(D.length===0)return Promise.resolve(!1);const k=[];let P=!1;for(let f of D){if(f===!0)return Promise.resolve(!0);(0,v.isThenable)(f)&&k.push(f.then(m=>{m&&(P=!0)},m=>{C(m),P=!0}))}return v.Promises.settled(k).then(()=>P)}e.handleVetos=n}),define(te[6],ie([0,1,39,4,2,3,5]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function P(){return new Date().toISOString()}var f;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;function m(h,r,i){switch(r){case f.Trace:h.trace(i);break;case f.Debug:h.debug(i);break;case f.Info:h.info(i);break;case f.Warning:h.warn(i);break;case f.Error:h.error(i);break;case f.Critical:h.critical(i);break;default:throw new Error("Invalid log level")}}e.log=m;function b(h){let r="";for(let i=0;i<h.length;i++){let s=h[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}r+=(i>0?" ":"")+s}return r}e.format=b;class I extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class p extends I{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(f.Trace)&&this.log(f.Trace,b([r,...i]))}debug(r,...i){this.checkLogLevel(f.Debug)&&this.log(f.Debug,b([r,...i]))}info(r,...i){this.checkLogLevel(f.Info)&&this.log(f.Info,b([r,...i]))}warn(r,...i){this.checkLogLevel(f.Warning)&&this.log(f.Warning,b([r,...i]))}error(r,...i){if(this.checkLogLevel(f.Error))if(r instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=r.stack,this.log(f.Error,b(s))}else this.log(f.Error,b([r,...i]))}critical(r,...i){this.checkLogLevel(f.Critical)&&this.log(f.Critical,b([r,...i]))}flush(){}}e.AbstractMessageLogger=p;class y extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!C.isWindows}trace(r,...i){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...i):console.log(`[main ${P()}]`,r,...i))}debug(r,...i){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...i):console.log(`[main ${P()}]`,r,...i))}info(r,...i){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...i):console.log(`[main ${P()}]`,r,...i))}warn(r,...i){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,r,...i):console.warn(`[main ${P()}]`,r,...i))}error(r,...i){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,r,...i):console.error(`[main ${P()}]`,r,...i))}critical(r,...i){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,r,...i):console.error(`[main ${P()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class t extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class g extends I{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,v.toErrorMessage)(r,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class S extends I{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const s of this.logServices)s.trace(r,...i)}debug(r,...i){for(const s of this.logServices)s.debug(r,...i)}info(r,...i){for(const s of this.logServices)s.info(r,...i)}warn(r,...i){for(const s of this.logServices)s.warn(r,...i)}error(r,...i){for(const s of this.logServices)s.error(r,...i)}critical(r,...i){for(const s of this.logServices)s.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=S;class w extends D.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=w;class M extends D.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(s))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let s=this.loggers.get(r.toString());return s||(s=this.doCreateLogger(r,i?.always?f.Trace:this.logLevel,i),this.loggers.set(r.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=M;class c{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(r){}getLevel(){return f.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=c;function a(h){if(h.verbose)return f.Trace;if(typeof h.logLevel=="string"){const r=l(h.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(h){switch(h){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=l;function o(h){switch(h){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=o}),define(te[183],ie([0,1,31,8,15,4,2,9,62,6]),function(K,e,v,n,D,C,k,P,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends k.Disposable{constructor(p){super();this.logService=p,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(p,y){return y.recursive?this.watchRecursive(p,y):this.watchNonRecursive(p,y)}watchRecursive(p,y){const t={path:this.toFilePath(p),excludes:y.excludes},g=(0,v.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,k.toDisposable)(()=>{g(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(p=>(0,D.onUnexpectedError)(p))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(p=>this._onDidChangeFile.fire((0,f.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(p,y){return p.watch(y)}watchNonRecursive(p,y){const t=new k.DisposableStore,g=t.add(this.createNonRecursiveWatcher({path:this.toFilePath(p),excludes:y.excludes},S=>this._onDidChangeFile.fire((0,f.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===m.LogLevel.Trace));return t.add(this.logService.onDidChangeLogLevel(()=>{g.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})),t}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,P.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=b});var re=this&&this.__param||function(K,e){return function(v,n){e(v,n,K)}};define(te[184],ie([0,1,31,8,17,21,4,69,2,35,10,63,16,51,145,18,92,6]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let M=class Qe extends f.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new n.ThrottledWorker(Qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Qe.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new g.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new n.ThrottledWorker(Qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Qe.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new g.FileChangesEvent(l,!0)))),this.nonRecursiveWatchedResources=m.TernarySearchTree.forUris(l=>{const o=this.getProvider(l.scheme);return o?!this.isPathCaseSensitive(o):!1}),this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(a,l){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:l});const o=new f.DisposableStore;return o.add(l.onDidChangeFile(h=>this.onDidChangeFile(h,this.isPathCaseSensitive(l)))),o.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:a}))),typeof l.onDidWatchError=="function"&&o.add(l.onDidWatchError(h=>this._onDidWatchError.fire(new Error(h)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:l}),this.provider.delete(a),(0,f.dispose)(o)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(o){l.push(o)}}),!this.provider.has(a)&&await n.Promises.settled(l)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,l){const o=this.provider.get(a.scheme);return!!(o&&o.capabilities&l)}listCapabilities(){return P.Iterable.map(this.provider,([a,l])=>({scheme:a,capabilities:l.capabilities}))}async withProvider(a){if(!(0,p.isAbsolutePath)(a))throw new g.FileOperationError((0,t.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const l=this.provider.get(a.scheme);if(!l){const o=new Error;throw o.name="ENOPRO",o.message=(0,t.localize)(1,null,a.toString()),o}return l}async withReadProvider(a){const l=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasReadWriteCapability)(l)||(0,g.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const l=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,l){try{return await this.doResolveFile(a,l)}catch(o){throw(0,g.toFileSystemProviderErrorCode)(o)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,t.localize)(2,null,this.resourceForError(a)),1):(0,g.ensureFileSystemProviderError)(o)}}async doResolveFile(a,l){const o=await this.withProvider(a),h=this.isPathCaseSensitive(o),r=l?.resolveTo,i=l?.resolveSingleChildDescendants,s=l?.resolveMetadata,u=await o.stat(a);let d;return this.toFileStat(o,a,u,void 0,!!s,(E,L)=>(d||(d=m.TernarySearchTree.forUris(()=>!h),d.set(a,!0),r&&d.fill(!0,r)),d.get(E.resource)||d.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&i?L===1:!1))}async toFileStat(a,l,o,h,r,i){const{providerExtUri:s}=this.getExtUri(a),u={resource:l,name:s.basename(l),isFile:(o.type&g.FileType.File)!=0,isDirectory:(o.type&g.FileType.Directory)!=0,isSymbolicLink:(o.type&g.FileType.SymbolicLink)!=0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&g.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,g.etag)({mtime:o.mtime,size:o.size})};if(u.isDirectory&&i(u,h)){try{const d=await a.readdir(l),E=await n.Promises.settled(d.map(async([L,R])=>{try{const T=s.joinPath(l,L),N=r?await a.stat(T):{type:R};return await this.toFileStat(a,T,N,d.length,r,i)}catch(T){return this.logService.trace(T),null}}));u.children=(0,v.coalesce)(E)}catch(d){this.logService.trace(d),u.children=[]}return u}return u}async resolveAll(a){return n.Promises.settled(a.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async exists(a){const l=await this.withProvider(a);try{return!!await l.stat(a)}catch{return!1}}async canCreateFile(a,l){try{await this.doValidateCreateFile(a,l)}catch(o){return o}return!0}async doValidateCreateFile(a,l){if(!l?.overwrite&&await this.exists(a))throw new g.FileOperationError((0,t.localize)(3,null,this.resourceForError(a)),3,l)}async createFile(a,l=D.VSBuffer.fromString(""),o){await this.doValidateCreateFile(a,o);const h=await this.writeFile(a,l);return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,h)),h}async writeFile(a,l,o){const h=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(h);try{await this.validateWriteFile(h,a,o)||await this.mkdirp(h,r.dirname(a));let s;if((0,g.hasReadWriteCapability)(h)&&!(l instanceof D.VSBuffer))if((0,y.isReadableStream)(l)){const u=await(0,y.peekStream)(l,3);u.ended?s=D.VSBuffer.concat(u.buffer):s=u}else s=(0,y.peekReadable)(l,u=>D.VSBuffer.concat(u),3);else s=l;!(0,g.hasOpenReadWriteCloseCapability)(h)||(0,g.hasReadWriteCapability)(h)&&s instanceof D.VSBuffer?await this.doWriteUnbuffered(h,a,o,s):await this.doWriteBuffered(h,a,o,s instanceof D.VSBuffer?(0,D.bufferToReadable)(s):s)}catch(i){throw new g.FileOperationError((0,t.localize)(4,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(i).toString()),(0,g.toFileOperationResult)(i),o)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,l,o){if(!!o?.unlock&&!(a.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(l)));let r;try{r=await a.stat(l)}catch{return}if((r.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,t.localize)(6,null,this.resourceForError(l)),0,o);if(this.throwIfFileIsReadonly(l,r),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==g.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&o.mtime<r.mtime&&o.etag!==(0,g.etag)({mtime:o.mtime,size:r.size}))throw new g.FileOperationError((0,t.localize)(7,null),3,o);return r}async readFile(a,l,o){const h=await this.withReadProvider(a);return l?.atomic?this.doReadFileAtomic(h,a,l,o):this.doReadFile(h,a,l,o)}async doReadFileAtomic(a,l,o,h){return new Promise((r,i)=>{this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(a,l,o,h);r(s)}catch(s){i(s)}})})}async doReadFile(a,l,o,h){const r=await this.doReadFileStream(a,l,{...o,preferUnbuffered:!0},h);return{...r,value:await(0,D.streamToBuffer)(r.value)}}async readFileStream(a,l,o){const h=await this.withReadProvider(a);return this.doReadFileStream(h,a,l,o)}async doReadFileStream(a,l,o,h){const r=new C.CancellationTokenSource(h),i=this.validateReadFile(l,o).then(u=>u,u=>{throw r.cancel(),u});let s;try{return typeof o?.etag=="string"&&o.etag!==g.ETAG_DISABLED&&await i,o?.atomic&&(0,g.hasFileAtomicReadCapability)(a)||!((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasFileReadStreamCapability)(a))||(0,g.hasReadWriteCapability)(a)&&o?.preferUnbuffered?s=this.readFileUnbuffered(a,l,o):(0,g.hasFileReadStreamCapability)(a)?s=this.readFileStreamed(a,l,r.token,o):s=this.readFileBuffered(a,l,r.token,o),{...await i,value:s}}catch(u){s&&await(0,y.consumeStream)(s);const d=(0,t.localize)(8,null,this.resourceForError(l),(0,g.ensureFileSystemProviderError)(u).toString());throw u instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(d,u.stat,o):new g.FileOperationError(d,(0,g.toFileOperationResult)(u),o)}}readFileStreamed(a,l,o,h=Object.create(null)){const r=a.readFileStream(l,h,o);return(0,y.transform)(r,{data:i=>i instanceof D.VSBuffer?i:D.VSBuffer.wrap(i),error:i=>new g.FileOperationError((0,t.localize)(9,null,this.resourceForError(l),(0,g.ensureFileSystemProviderError)(i).toString()),(0,g.toFileOperationResult)(i),h)},i=>D.VSBuffer.concat(i))}readFileBuffered(a,l,o,h=Object.create(null)){const r=(0,D.newWriteableBufferStream)();return(0,S.readFileIntoStream)(a,l,r,i=>i,{...h,bufferSize:this.BUFFER_SIZE,errorTransformer:i=>new g.FileOperationError((0,t.localize)(10,null,this.resourceForError(l),(0,g.ensureFileSystemProviderError)(i).toString()),(0,g.toFileOperationResult)(i),h)},o),r}readFileUnbuffered(a,l,o){const h=(0,y.newWriteableStream)(r=>D.VSBuffer.concat(r));return(async()=>{try{let r;o?.atomic&&(0,g.hasFileAtomicReadCapability)(a)?r=await a.readFile(l,{atomic:!0}):r=await a.readFile(l),typeof o?.position=="number"&&(r=r.slice(o.position)),typeof o?.length=="number"&&(r=r.slice(0,o.length)),this.validateReadFileLimits(l,r.byteLength,o),h.end(D.VSBuffer.wrap(r))}catch(r){h.error(r),h.end()}})(),h}async validateReadFile(a,l){const o=await this.resolve(a,{resolveMetadata:!0});if(o.isDirectory)throw new g.FileOperationError((0,t.localize)(11,null,this.resourceForError(a)),0,l);if(typeof l?.etag=="string"&&l.etag!==g.ETAG_DISABLED&&l.etag===o.etag)throw new g.NotModifiedSinceFileOperationError((0,t.localize)(12,null),o,l);return this.validateReadFileLimits(a,o.size,l),o}validateReadFileLimits(a,l,o){if(o?.limits){let h;if(typeof o.limits.memory=="number"&&l>o.limits.memory&&(h=9),typeof o.limits.size=="number"&&l>o.limits.size&&(h=7),typeof h=="number")throw new g.FileOperationError((0,t.localize)(13,null,this.resourceForError(a)),h)}}async canMove(a,l,o){return this.doCanMoveCopy(a,l,"move",o)}async canCopy(a,l,o){return this.doCanMoveCopy(a,l,"copy",o)}async doCanMoveCopy(a,l,o,h){if(a.toString()!==l.toString())try{const r=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(r,a,i,l,o,h)}catch(r){return r}return!0}async move(a,l,o){const h=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=await this.doMoveCopy(h,a,r,l,"move",!!o),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,i==="move"?2:3,s)),s}async copy(a,l,o){const h=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=await this.doMoveCopy(h,a,r,l,"copy",!!o),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,i==="copy"?3:2,s)),s}async doMoveCopy(a,l,o,h,r,i){if(l.toString()===h.toString())return r;const{exists:s,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(a,l,o,h,r,i);if(s&&!u&&i&&await this.del(h,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(h)),r==="copy"){if(a===o&&(0,g.hasFileFolderCopyCapability)(a))await a.copy(l,h,{overwrite:i});else{const d=await this.resolve(l);d.isDirectory?await this.doCopyFolder(a,d,o,h):await this.doCopyFile(a,l,o,h)}return r}else return a===o?(await a.rename(l,h,{overwrite:i}),r):(await this.doMoveCopy(a,l,o,h,"copy",i),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(a,l,o,h){if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(a,l,o,h);if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(a,l,o,h);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(a,l,o,h);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasReadWriteCapability)(o))return this.doPipeUnbuffered(a,l,o,h)}async doCopyFolder(a,l,o,h){await o.mkdir(h),Array.isArray(l.children)&&await n.Promises.settled(l.children.map(async r=>{const i=this.getExtUri(o).providerExtUri.joinPath(h,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),o,i):this.doCopyFile(a,r.resource,o,i)}))}async doValidateMoveCopy(a,l,o,h,r,i){let s=!1;if(a===o){const{providerExtUri:d,isPathCaseSensitive:E}=this.getExtUri(a);if(E||(s=d.isEqual(l,h)),s&&r==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(l),this.resourceForError(h)));if(!s&&d.isEqualOrParent(h,l))throw new Error((0,t.localize)(15,null,this.resourceForError(l),this.resourceForError(h)))}const u=await this.exists(h);if(u&&!s){if(!i)throw new g.FileOperationError((0,t.localize)(16,null,this.resourceForError(l),this.resourceForError(h)),4);if(a===o){const{providerExtUri:d}=this.getExtUri(a);if(d.isEqualOrParent(l,h))throw new Error((0,t.localize)(17,null,this.resourceForError(l),this.resourceForError(h)))}}return{exists:u,isSameResourceWithDifferentPathCase:s}}getExtUri(a){const l=this.isPathCaseSensitive(a);return{providerExtUri:l?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(l,a);const o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,o)),o}async mkdirp(a,l){const o=[],{providerExtUri:h}=this.getExtUri(a);for(;!h.isEqual(l,h.dirname(l));)try{if(((await a.stat(l)).type&g.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(l)));break}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileNotFound)throw r;o.push(h.basename(l)),l=h.dirname(l)}for(let r=o.length-1;r>=0;r--){l=h.joinPath(l,o[r]);try{await a.mkdir(l)}catch(i){if((0,g.toFileSystemProviderErrorCode)(i)!==g.FileSystemProviderErrorCode.FileExists)throw i}}}async canDelete(a,l){try{await this.doValidateDelete(a,l)}catch(o){return o}return!0}async doValidateDelete(a,l){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!l?.useTrash&&!(o.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(a)));let r;try{r=await o.stat(a)}catch{}if(r)this.throwIfFileIsReadonly(a,r);else throw new g.FileOperationError((0,t.localize)(20,null,this.resourceForError(a)),1);if(!!!l?.recursive){const s=await this.resolve(a);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(a)))}return o}async del(a,l){const o=await this.doValidateDelete(a,l),h=!!l?.useTrash,r=!!l?.recursive;await o.delete(a,{recursive:r,useTrash:h}),this._onDidRunOperation.fire(new g.FileOperationEvent(a,1))}onDidChangeFile(a,l){this._onDidChangeFilesRaw.fire({changes:a});let o,h;{for(const r of a)this.nonRecursiveWatchedResources.has(r.resource)?(o||(o=[]),o.push(r)):(h||(h=[]),h.push(r));o&&this._onDidFilesChange.fire(new g.FileChangesEvent(o,!l))}if(h){const r=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(h)&&Qe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${h[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,l={recursive:!1,excludes:[]}){const o=new f.DisposableStore;let h=!1,r=()=>{h=!0};return o.add((0,f.toDisposable)(()=>r())),(async()=>{try{const i=await this.doWatch(a,l);h?(0,f.dispose)(i):r=()=>(0,f.dispose)(i)}catch(i){this.logService.error(i)}})(),l.recursive||(this.nonRecursiveWatchedResources.set(a,(this.nonRecursiveWatchedResources.get(a)??0)+1),o.add((0,f.toDisposable)(()=>{const i=this.nonRecursiveWatchedResources.get(a);typeof i=="number"&&(i<=1?this.nonRecursiveWatchedResources.delete(a):this.nonRecursiveWatchedResources.set(a,i-1))}))),o}async doWatch(a,l){const o=await this.withProvider(a),h=this.toWatchKey(o,a,l);let r=this.activeWatchers.get(h);return r||(r={count:0,disposable:o.watch(a,l)},this.activeWatchers.set(h,r)),r.count+=1,(0,f.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,f.dispose)(r.disposable),this.activeWatchers.delete(h)))})}toWatchKey(a,l,o){const{providerExtUri:h}=this.getExtUri(a);return[h.getComparisonKey(l),String(o.recursive),o.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,f.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,l,o,h){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{const r=await a.open(l,{create:!0,unlock:o?.unlock??!1});try{(0,y.isReadableStream)(h)||(0,y.isReadableBufferedStream)(h)?await this.doWriteStreamBufferedQueued(a,r,h):await this.doWriteReadableBufferedQueued(a,r,h)}catch(i){throw(0,g.ensureFileSystemProviderError)(i)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,l,o){let h=0,r;if((0,y.isReadableBufferedStream)(o)){if(o.buffer.length>0){const i=D.VSBuffer.concat(o.buffer);await this.doWriteBuffer(a,l,i,i.byteLength,h,0),h+=i.byteLength}if(o.ended)return;r=o.stream}else r=o;return new Promise((i,s)=>{(0,y.listenStream)(r,{onData:async u=>{r.pause();try{await this.doWriteBuffer(a,l,u,u.byteLength,h,0)}catch(d){return s(d)}h+=u.byteLength,setTimeout(()=>r.resume())},onError:u=>s(u),onEnd:()=>i()})})}async doWriteReadableBufferedQueued(a,l,o){let h=0,r;for(;(r=o.read())!==null;)await this.doWriteBuffer(a,l,r,r.byteLength,h,0),h+=r.byteLength}async doWriteBuffer(a,l,o,h,r,i){let s=0;for(;s<h;)s+=await a.write(l,r+s,o.buffer,i+s,h-s)}async doWriteUnbuffered(a,l,o,h){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,l,o,h))}async doWriteUnbufferedQueued(a,l,o,h){let r;h instanceof D.VSBuffer?r=h:(0,y.isReadableStream)(h)?r=await(0,D.streamToBuffer)(h):(0,y.isReadableBufferedStream)(h)?r=await(0,D.bufferedStreamToBuffer)(h):r=(0,D.readableToBuffer)(h),await a.writeFile(l,r.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(a,l,o,h){return this.writeQueue.queueFor(h,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,l,o,h))}async doPipeBufferedQueued(a,l,o,h){let r,i;try{r=await a.open(l,{create:!1}),i=await o.open(h,{create:!0,unlock:!1});const s=D.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,d=0,E=0;do E=await a.read(r,u,s.buffer,d,s.byteLength-d),await this.doWriteBuffer(o,i,s,E,u,d),u+=E,d+=E,d===s.byteLength&&(d=0);while(E>0)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await n.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof i=="number"?o.close(i):Promise.resolve()])}}async doPipeUnbuffered(a,l,o,h){return this.writeQueue.queueFor(h,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,l,o,h))}async doPipeUnbufferedQueued(a,l,o,h){return o.writeFile(h,await a.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,l,o,h){return this.writeQueue.queueFor(h,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,l,o,h))}async doPipeUnbufferedToBufferedQueued(a,l,o,h){const r=await o.open(h,{create:!0,unlock:!1});try{const i=await a.readFile(l);await this.doWriteBuffer(o,r,D.VSBuffer.wrap(i),i.byteLength,0,0)}catch(i){throw(0,g.ensureFileSystemProviderError)(i)}finally{await o.close(r)}}async doPipeBufferedToUnbuffered(a,l,o,h){const r=await(0,D.streamToBuffer)(this.readFileBuffered(a,l,C.CancellationToken.None));await this.doWriteUnbuffered(o,h,void 0,r)}throwIfFileSystemIsReadonly(a,l){if(a.capabilities&2048)throw new g.FileOperationError((0,t.localize)(22,null,this.resourceForError(l)),6);return a}throwIfFileIsReadonly(a,l){if((l.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,t.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===b.Schemas.file?a.fsPath:a.toString(!0)}};M.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},M=fe([re(0,w.ILogService)],M),e.FileService=M}),define(te[185],ie([0,1,14,148,3,7,18,93,9,2,62,6,170,114]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends p.AbstractDiskFileSystemProviderChannel{constructor(w,M){super(w,M)}getUriTransformer(w){return y.DefaultURITransformer}transformIncoming(w,M){return C.URI.revive(M)}async delete(w,M,c){if(!c.useTrash)return super.delete(w,M,c);const a=this.transformIncoming(w,M),l=(0,f.normalize)(a.fsPath);try{await v.shell.trashItem(l)}catch{throw(0,k.createFileSystemProviderError)(D.isWindows?(0,n.localize)(0,null,(0,f.basename)(l)):(0,n.localize)(1,null,(0,f.basename)(l)),k.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(w,M){return new g(M,this.logService)}}e.DiskFileSystemProviderChannel=t;class g extends m.Disposable{constructor(w,M){super();this.sessionEmitter=w,this.logService=M,this.watcherRequests=new Map}watch(w,M,c){if(c.recursive)throw(0,k.createFileSystemProviderError)("Recursive watcher is not supported from main process",k.FileSystemProviderErrorCode.Unavailable);const a=new m.DisposableStore;this.watcherRequests.set(w,a),a.add((0,m.toDisposable)(()=>this.watcherRequests.delete(w)));const l=a.add(new P.NodeJSFileWatcher({path:(0,f.normalize)(M.fsPath),excludes:c.excludes},o=>this.sessionEmitter.fire((0,b.toFileChanges)(o)),o=>this.onWatcherLogMessage(o),this.logService.getLevel()===I.LogLevel.Trace));return a.add(this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)})),a}onWatcherLogMessage(w){w.type==="error"&&this.sessionEmitter.fire(w.message),this.logService[w.type](w.message)}dispose(){super.dispose();for(const[,w]of this.watcherRequests)w.dispose();this.watcherRequests.clear()}}}),define(te[94],ie([0,1,28,251,8,35,17,4,27,2,9,3,16,51,24,149,18,92,93,177,183,39]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w,M,c,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(v)}catch(h){console.error(`Error enabling graceful-fs: ${(0,l.toErrorMessage)(h)}`)}})();class o extends a.AbstractDiskFileSystemProvider{constructor(r,i){super(r);this.options=i,this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new C.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:i,symbolicLink:s}=await t.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(r){try{const i=await t.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async u=>{try{let d;u.isSymbolicLink()?d=(await this.stat((0,p.joinPath)(r,u.name))).type:d=this.toType(u),s.push([u.name,d])}catch(d){this.logService.trace(d)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(r,i){let s;return i?.dangling?s=S.FileType.Unknown:r.isFile()?s=S.FileType.File:r.isDirectory()?s=S.FileType.Directory:s=S.FileType.Unknown,i&&(s|=S.FileType.SymbolicLink),s}async createResourceLock(r){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(r)})`);let i;for(;i=this.resourceLocks.get(r);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(r)})`),await i.wait();const s=new D.Barrier;return this.resourceLocks.set(r,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(r)})`),(0,m.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(r)})`),this.resourceLocks.delete(r),s.open()})}async readFile(r,i){let s;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),s=await this.createResourceLock(r));const u=this.toFilePath(r);return await t.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{s?.dispose()}}readFileStream(r,i,s){const u=(0,y.newWriteableStream)(d=>k.VSBuffer.concat(d.map(E=>k.VSBuffer.wrap(E))).buffer);return(0,w.readFileIntoStream)(this,r,u,d=>d.buffer,{...i,bufferSize:256*1024},s),u}async writeFile(r,i,s){let u;try{const d=this.toFilePath(r);if(!s.create||!s.overwrite){if(await t.Promises.exists(d)){if(!s.overwrite)throw(0,S.createFileSystemProviderError)((0,g.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,S.createFileSystemProviderError)((0,g.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(r,{create:!0,unlock:s.unlock}),await this.write(u,0,i,0,i.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(r,d)}finally{typeof u=="number"&&await this.close(u)}}async open(r,i){let s;(0,S.isFileOpenForWriteOptions)(i)&&(s=await this.createResourceLock(r));let u;try{const d=this.toFilePath(r);if((0,S.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:L}=await t.SymlinkSupport.stat(d);L.mode&128||await t.Promises.chmod(d,L.mode|128)}catch(L){this.logService.trace(L)}let E;if((0,S.isFileOpenForWriteOptions)(i)){if(I.isWindows)try{await t.Promises.truncate(d,0),E="r+"}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}E||(E="w")}else E="r";u=await t.Promises.open(d,E)}catch(d){throw s?.dispose(),(0,S.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(r,d):this.toFileSystemProviderError(d)}return this.mapHandleToPos.set(u,0),(0,S.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(u,r),s&&this.mapHandleToLock.set(u,s),u}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await t.Promises.fdatasync(r)}catch(i){this.canFlush=!1,this.logService.error(i)}return await t.Promises.close(r)}catch(i){throw this.toFileSystemProviderError(i)}finally{const i=this.mapHandleToLock.get(r);i&&(this.mapHandleToLock.delete(r),i.dispose())}}async read(r,i,s,u,d){const E=this.normalizePos(r,i);let L=null;try{const R=await t.Promises.read(r,s,u,d,E);return typeof R=="number"?L=R:L=R.bytesRead,L}catch(R){throw this.toFileSystemProviderError(R)}finally{this.updatePos(r,E,L)}}normalizePos(r,i){return i===this.mapHandleToPos.get(r)?null:i}updatePos(r,i,s){const u=this.mapHandleToPos.get(r);typeof u=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(r,u+s):this.mapHandleToPos.delete(r)))}async write(r,i,s,u,d){return(0,D.retry)(()=>this.doWrite(r,i,s,u,d),100,3)}async doWrite(r,i,s,u,d){const E=this.normalizePos(r,i);let L=null;try{const R=await t.Promises.write(r,s,u,d,E);return typeof R=="number"?L=R:L=R.bytesWritten,L}catch(R){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),R)}finally{this.updatePos(r,E,L)}}async mkdir(r){try{await t.Promises.mkdir(this.toFilePath(r))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(r,i){try{const s=this.toFilePath(r);i.recursive?await t.Promises.rm(s,t.RimRafMode.MOVE):await t.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(r,i,s){const u=this.toFilePath(r),d=this.toFilePath(i);if(u!==d)try{await this.validateTargetDeleted(r,i,"move",s.overwrite),await t.Promises.move(u,d)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,g.localize)(2,null,(0,b.basename)(u),(0,b.basename)((0,b.dirname)(d)),E.toString()))),this.toFileSystemProviderError(E)}}async copy(r,i,s){const u=this.toFilePath(r),d=this.toFilePath(i);if(u!==d)try{await this.validateTargetDeleted(r,i,"copy",s.overwrite),await t.Promises.copy(u,d,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,g.localize)(3,null,(0,b.basename)(u),(0,b.basename)((0,b.dirname)(d)),E.toString()))),this.toFileSystemProviderError(E)}}async validateTargetDeleted(r,i,s,u){const d=this.toFilePath(r),E=this.toFilePath(i);let L=!1;if(!!(this.capabilities&1024)||(L=(0,f.isEqual)(d,E,!0)),L&&s==="copy")throw(0,S.createFileSystemProviderError)((0,g.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!L&&await t.Promises.exists(E)){if(!u)throw(0,S.createFileSystemProviderError)((0,g.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,i,s){return new c.ParcelWatcherClient(u=>r(u),u=>i(u),s)}doWatch(r,i){const s=this.options?.watcher?.usePolling;if(s===!0)for(const u of i)u.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(s))for(const u of i)s.includes(u.path)&&(u.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(r,i)}createNonRecursiveWatcher(r,i,s,u){return new M.NodeJSFileWatcher(r,d=>i(d),d=>s(d),u)}toFileSystemProviderError(r){if(r instanceof S.FileSystemProviderError)return r;let i;switch(r.code){case"ENOENT":i=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=S.FileSystemProviderErrorCode.NoPermissions;break;default:i=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(r,i)}async toFileSystemProviderWriteError(r,i){let s=this.toFileSystemProviderError(i);if(r&&s.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await t.SymlinkSupport.stat(this.toFilePath(r));u.mode&128||(s=(0,S.createFileSystemProviderError)(i,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return s}}e.DiskFileSystemProvider=o}),define(te[95],ie([0,1,6]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function n(C,k){switch(k){case v.LogLevel.Trace:return C.trace;case v.LogLevel.Debug:return C.debug;case v.LogLevel.Info:return C.info;case v.LogLevel.Warning:return C.warn;case v.LogLevel.Error:return C.error;case v.LogLevel.Critical:return C.critical;default:throw new Error("Invalid log level")}}class D extends v.AbstractLogger{constructor(k=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(P=>{this._logger&&this._logger.setLevel(P)}))}set logger(k){this._logger=k;for(const{level:P,args:f}of this.buffer)n(k,P).apply(k,f);this.buffer=[]}_log(k,...P){this._logger?n(this._logger,k).apply(this._logger,P):this.getLevel()<=k&&this.buffer.push({level:k,args:P})}trace(k,...P){this._log(v.LogLevel.Trace,k,...P)}debug(k,...P){this._log(v.LogLevel.Debug,k,...P)}info(k,...P){this._log(v.LogLevel.Info,k,...P)}warn(k,...P){this._log(v.LogLevel.Warning,k,...P)}error(k,...P){this._log(v.LogLevel.Error,k,...P)}critical(k,...P){this._log(v.LogLevel.Critical,k,...P)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(te[186],ie([0,1,8,17,16,18,5,95,6]),function(K,e,v,n,D,C,k,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*C.ByteSize.MB;let b=class extends f.AbstractLogger{constructor(y,t,g,S,w){super();this.name=y,this.resource=t,this.donotUseFormatters=S,this.fileService=w,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,(0,f.format)(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,(0,f.format)(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,(0,f.format)(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,(0,f.format)(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=y.stack,this._log(f.LogLevel.Error,(0,f.format)(t))}else this._log(f.LogLevel.Error,(0,f.format)(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,(0,f.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,t){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>m&&(await this.fileService.writeFile(this.getBackupResource(),n.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=t:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${t}
`,await this.fileService.writeFile(this.resource,n.VSBuffer.fromString(g))})}getCurrentTimestamp(){const y=S=>S<10?`0${S}`:S,t=S=>S<10?`00${S}`:S<100?`0${S}`:S,g=new Date;return`${g.getFullYear()}-${y(g.getMonth()+1)}-${y(g.getDate())} ${y(g.getHours())}:${y(g.getMinutes())}:${y(g.getSeconds())}.${t(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(y){switch(y){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}};b=fe([re(4,C.IFileService)],b),e.FileLogger=b;let I=class extends f.AbstractLoggerService{constructor(y,t,g){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=t,this.fileService=g}doCreateLogger(y,t,g){const S=new P.BufferLogService(t);return(0,C.whenProviderRegistered)(y,this.fileService).then(()=>S.logger=this.instantiationService.createInstance(b,g?.name||(0,D.basename)(y),y,S.getLevel(),!!g?.donotUseFormatters)),S}};I=fe([re(0,f.ILogService),re(1,k.IInstantiationService),re(2,C.IFileService)],I),e.FileLoggerService=I}),define(te[187],ie([0,1,4,7,6]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(p){this.service=p,this.onDidChangeLogLevel=v.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(p,y,t){switch(y){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=C;class k{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){k.setLevel(this.channel,p)}static setLevel(p,y){return p.call("setLevel",y)}}e.LogLevelChannelClient=k;class P{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,y){throw new Error(`Event not found: ${y}`)}async call(p,y,t){switch(y){case"createLogger":this.createLogger(n.URI.revive(t[0]),t[1]);return;case"log":return this.log(n.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${y}`)}createLogger(p,y){this.loggers.set(p.toString(),this.loggerService.createLogger(p,y))}consoleLog(p,y){let t=console.log;switch(p){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...y)}log(p,y){const t=this.loggers.get(p.toString());if(!t)throw new Error("Create the logger before logging");for(const[g,S]of y)(0,D.log)(t,g,S)}}e.LoggerChannel=P;class f extends D.AbstractLoggerService{constructor(p,y,t){super(p,y);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(p,y)=>{this.channel.call("consoleLog",[p,y])}})}doCreateLogger(p,y,t){return new m(this.channel,p,y,t)}}e.LoggerChannelClient=f;class m extends D.AbstractMessageLogger{constructor(p,y,t,g){super(g?.always);this.channel=p,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[y,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,y){const t=[[p,y]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(p){this.channel.call("log",[this.file,p])}}class b extends D.LogService{constructor(p,y){super(y);this.parent=p,this._register(p.onDidChangeLogLevel(t=>y.setLevel(t)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=b}),define(te[96],ie([0,1,18,6]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(P,f,m,b,I){try{const p=await new Promise((t,g)=>{K(["spdlog"],t,g)});p.setFlushOn(n.LogLevel.Trace);const y=await p.createAsyncRotatingLogger(P,f,m,b);return I&&y.clearFormatters(),y}catch(p){console.error(p)}return null}function C(P,f,m){switch(f){case n.LogLevel.Trace:P.trace(m);break;case n.LogLevel.Debug:P.debug(m);break;case n.LogLevel.Info:P.info(m);break;case n.LogLevel.Warning:P.warn(m);break;case n.LogLevel.Error:P.error(m);break;case n.LogLevel.Critical:P.critical(m);break;default:throw new Error("Invalid log level")}}class k extends n.AbstractMessageLogger{constructor(f,m,b,I,p){super();this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(f,m,b,I),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}async _createSpdLogLogger(f,m,b,I){const p=b?6:1,y=30/p*v.ByteSize.MB,t=await D(f,m,y,p,I);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:g,message:S}of this.buffer)C(this._logger,g,S);this.buffer=[]}}log(f,m){this._logger?C(this._logger,f,m):this.getLevel()<=f&&this.buffer.push({level:f,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(te[188],ie([0,1,10,16,32,18,186,6,96]),function(K,e,v,n,D,C,k,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends P.AbstractLoggerService{constructor(I,p){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=p}doCreateLogger(I,p,y){return I.scheme===v.Schemas.file?new f.SpdLogLogger(y?.name||(0,D.generateUuid)(),I.fsPath,!y?.donotRotate,!!y?.donotUseFormatters,p):new k.FileLogger(y?.name??(0,n.basename)(I),I,p,!!y?.donotUseFormatters,this.fileService)}};m=fe([re(0,P.ILogService),re(1,C.IFileService)],m),e.LoggerService=m}),define(te[189],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(k){return k.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function n(k){return k.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=n;function D(k){return k.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function C(k){return!v(k)&&!n(k)&&!D(k)}e.isMenubarMenuItemAction=C}),define(te[55],ie([0,1,10,3,34,16]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const P=n.globals.vscode.context.configuration();if(P)k=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const P=(0,C.dirname)(v.FileAccess.asFileUri("",K));k=K.__$__nodeRequire((0,C.joinPath)(P,"product.json").fsPath);const f=K.__$__nodeRequire((0,C.joinPath)(P,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:f.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(te[22],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[190],ie([0,1,60,6,22]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(P,f){this.productService=P,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(P,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(f);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,b,I]=m;let p=this.trustedExtensionUrlPublicKeys.get(P);if(!p){if(p=this.productService.trustedExtensionUrlPublicKeys[P],!p||p.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.trustedExtensionUrlPublicKeys.set(P,[...p])}const y=Buffer.from(decodeURIComponent(I),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const t=y.slice(0,6),g=y.readUIntBE(0,6),S=Date.now()-g;if(S<0||S>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const w=y.slice(6),M=v.createVerify("SHA256");M.write(t),M.write(Buffer.from(b)),M.end();for(let c=0;c<p.length;c++){let a=p[c];if(a!==null){if(typeof a=="string")try{a=v.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),p[c]=a}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${P}:`,l),p[c]=null;continue}if(M.verify(a,w))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};C=fe([re(0,D.IProductService),re(1,n.ILogService)],C),e.ExtensionUrlTrustService=C}),define(te[56],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(te[191],ie([0,1,14,2,35,10,3,16,7,32,53,6]),function(K,e,v,n,D,C,k,P,f,m,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let p=class extends n.Disposable{constructor(t,g){super();this.logService=g,this.validRoots=D.TernarySearchTree.forUris(()=>!k.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(t.appRoot)),this.addValidFileRoot(f.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=v.session;t.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(g,S)=>this.handleResourceRequest(g,S)),t.protocol.interceptFileProtocol(C.Schemas.file,(g,S)=>this.handleFileRequest(g,S)),this._register((0,n.toDisposable)(()=>{t.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?n.Disposable.None:(this.validRoots.set(t,!0),(0,n.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,g){const S=f.URI.parse(t.url);return this.logService.error(`Refused to load resource ${S.fsPath} from ${C.Schemas.file}: protocol (original URL: ${t.url})`),g({error:-3})}handleResourceRequest(t,g){const S=f.URI.parse(t.url),w=C.FileAccess.asFileUri(S);return this.validRoots.findSubstr(w)?g({path:w.fsPath}):this.validExtensions.has((0,P.extname)(w))?g({path:w.fsPath}):(this.logService.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${w.fsPath} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),g({error:-3}))}createIPCObjectUrl(){let t;const g=f.URI.from({scheme:"vscode",path:(0,m.generateUuid)()}),S=g.toString(),w=async()=>t;return v.ipcMain.handle(S,w),this.logService.trace(`IPC Object URL: Registered new channel ${S}.`),{resource:g,update:M=>t=M,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${S}.`),v.ipcMain.removeHandler(S)}}}};p=fe([re(0,b.INativeEnvironmentService),re(1,I.ILogService)],p),e.ProtocolMainService=p}),define(te[40],ie([0,1,102,13]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,P){v.ok(n.isString(k)),v.ok(n.isObject(P)),v.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(te[192],ie([0,1,4,40]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class C{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,m){this.schemasById[D(f)]=m,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new C;n.Registry.add(e.Extensions.JSONContribution,k)}),define(te[57],ie([0,1,31,4,13,137,192,40]),function(K,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var f;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(f=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=P.Registry.as(k.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,o=!0){this.registerConfigurations([l],o)}registerConfigurations(l,o=!0){const h=this.doRegisterConfigurations(l,o);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}deregisterConfigurations(l){const o=this.doDeregisterConfigurations(l);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:l,remove:o}){const h=[];h.push(...this.doDeregisterConfigurations(o)),h.push(...this.doRegisterConfigurations(l,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,v.distinct)(h)})}registerDefaultConfigurations(l){const o=[],h=[];for(const{overrides:r,source:i}of l)for(const s in r)if(o.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const u={...this.configurationDefaultsOverrides.get(s)?.value||{},...r[s]};this.configurationDefaultsOverrides.set(s,{source:i,value:u});const d={type:"object",default:u,description:C.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:D.isString(i)?void 0:i};h.push(...t(s)),this.configurationProperties[s]=d,this.defaultLanguageConfigurationOverridesNode.properties[s]=d}else{this.configurationDefaultsOverrides.set(s,{value:r[s],source:i});const u=this.configurationProperties[s];u&&(this.updatePropertyDefaultValue(s,u),this.updateSchema(s,u))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const o=[];for(const{overrides:h,source:r}of l)for(const i in h){const s=this.configurationDefaultsOverrides.get(i),u=D.isString(r)?r:r?.id,d=D.isString(s?.source)?s?.source:s?.source?.id;if(u===d)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const E=this.configurationProperties[i];E&&(this.updatePropertyDefaultValue(i,E),this.updateSchema(i,E))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const o of l)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,o){const h=[];return l.forEach(r=>{h.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),h}doDeregisterConfigurations(l){const o=[],h=r=>{if(r.properties)for(const i in r.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>h(i))};for(const r of l){h(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(l,o=!0,h,r,i=3){i=D.isUndefinedOrNull(l.scope)?i:l.scope;let s=[],u=l.properties;if(u)for(let E in u){if(o&&M(E)){delete u[E];continue}const L=u[E];if(L.source=h,L.defaultDefaultValue=u[E].default,this.updatePropertyDefaultValue(E,L),e.OVERRIDE_PROPERTY_REGEX.test(E)?L.scope=void 0:(L.scope=D.isUndefinedOrNull(L.scope)?i:L.scope,L.restricted=D.isUndefinedOrNull(L.restricted)?!!r?.includes(E):L.restricted),u[E].hasOwnProperty("included")&&!u[E].included){this.excludedConfigurationProperties[E]=u[E],delete u[E];continue}else this.configurationProperties[E]=u[E];!u[E].deprecationMessage&&u[E].markdownDeprecationMessage&&(u[E].deprecationMessage=u[E].markdownDeprecationMessage),s.push(E)}let d=l.allOf;if(d)for(let E of d)s.push(...this.validateAndRegisterProperties(E,o,h,r,i));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const o=h=>{let r=h.properties;if(r)for(const s in r)this.updateSchema(s,r[s]);let i=h.allOf;i&&i.forEach(o)};o(l)}updateSchema(l,o){switch(e.allSettings.properties[l]=o,o.scope){case 1:e.applicationSettings.properties[l]=o;break;case 2:e.machineSettings.properties[l]=o;break;case 6:e.machineOverridableSettings.properties[l]=o;break;case 3:e.windowSettings.properties[l]=o;break;case 4:e.resourceSettings.properties[l]=o;break;case 5:e.resourceSettings.properties[l]=o,this.resourceLanguageSettingsSchema.properties[l]=o;break}}removeFromSchema(l,o){switch(delete e.allSettings.properties[l],o.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const o=`[${l}]`,h={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,h),e.allSettings.properties[o]=h,e.applicationSettings.properties[o]=h,e.machineSettings.properties[o]=h,e.machineOverridableSettings.properties[o]=h,e.windowSettings.properties[o]=h,e.resourceSettings.properties[o]=h}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,o){const h=this.configurationDefaultsOverrides.get(l);let r=h?.value,i=h?.source;D.isUndefined(r)&&(r=o.defaultDefaultValue,i=void 0),D.isUndefined(r)&&(r=S(o.type)),o.default=r,o.defaultValueSource=i}}const p="\\[([^\\]]+)\\]",y=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(a){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let o=y.exec(a);for(;o?.length;){const h=o[1].trim();h&&l.push(h),o=y.exec(a)}}return(0,v.distinct)(l)}e.overrideIdentifiersFromKey=t;function g(a){return a.reduce((l,o)=>`${l}[${o}]`,"")}e.keyFromOverrideIdentifiers=g;function S(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=S;const w=new I;P.Registry.add(e.Extensions.Configuration,w);function M(a){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?C.localize(7,null,a):w.getConfigurationProperties()[a]!==void 0?C.localize(8,null,a):null:C.localize(6,null)}e.validateProperty=M;function c(){const a=[],l=w.getConfigurationProperties();for(const o of Object.keys(l))a.push([o,l[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=c}),define(te[193],ie([0,1,31,4,43,2,35,47,13,7,19,57,40]),function(K,e,v,n,D,C,k,P,f,m,b,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(r={},i=[],s=[]){this._contents=r,this._keys=i,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,b.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const s=this.getContentsForOverrideIdentifer(i);return s?r?(0,b.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return v.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return v.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=P.deepClone(this.contents),s=P.deepClone(this.overrides),u=[...this.keys];for(const d of r){this.mergeContents(i,d.contents);for(const E of d.overrides){const[L]=s.filter(R=>v.equals(R.identifiers,E.identifiers));L?(this.mergeContents(L.contents,E.contents),L.keys.push(...E.keys),L.keys=v.distinct(L.keys)):s.push(P.deepClone(E))}for(const E of d.keys)u.indexOf(E)===-1&&u.push(E)}return new y(i,u,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const u of v.distinct([...Object.keys(this.contents),...Object.keys(i)])){let d=this.contents[u],E=i[u];E&&(typeof d=="object"&&typeof E=="object"?(d=P.deepClone(d),this.mergeContents(d,E)):d=E),s[u]=d}return new y(s,this.keys,this.overrides)}mergeContents(r,i){for(const s of Object.keys(i)){if(s in r&&f.isObject(r[s])&&f.isObject(i[s])){this.mergeContents(r[s],i[s]);continue}r[s]=P.deepClone(i[s])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?P.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,s=null;const u=d=>{d&&(s?this.mergeContents(s,d):s=P.deepClone(d))};for(const d of this.overrides)v.equals(d.identifiers,[r])?i=d.contents:d.identifiers.includes(r)&&u(d.contents);return u(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,b.addToValueTree)(this.contents,r,i,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,b.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let s=0;s<i;s++)r.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=y;class t extends y{constructor(r={}){const i=p.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(i),u=Object.create(null),d=[];for(const E in i){const L=r[E],R=L!==void 0?L:i[E].default;(0,b.addToValueTree)(u,E,R,T=>console.error(`Conflict in default settings: ${T}`))}for(const E of Object.keys(u))I.OVERRIDE_PROPERTY_REGEX.test(E)&&d.push({identifiers:(0,I.overrideIdentifiersFromKey)(E),keys:Object.keys(u[E]),contents:(0,b.toValuesTree)(u[E],L=>console.error(`Conflict in default settings file: ${L}`))});super(u,s,d)}}e.DefaultConfigurationModel=t;class g{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!f.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:s,keys:u,overrides:d,restricted:E}=this.doParseRaw(r,i);this._configurationModel=new y(s,u,d),this._restrictedConfigurations=E||[]}doParseContent(r){let i={},s=null,u=[],d=[],E=[];function L(T){Array.isArray(u)?u.push(T):s!==null&&(u[s]=T)}let R={onObjectBegin:()=>{let T={};L(T),d.push(u),u=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{let T=[];L(T),d.push(u),u=T,s=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:L,onError:(T,N,Q)=>{E.push({error:T,offset:N,length:Q})}};if(r)try{D.visit(r,R),i=u[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(r,i){const s=p.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),u=this.filter(r,s,!0,i);r=u.raw;const d=(0,b.toValuesTree)(r,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),E=Object.keys(r),L=this.toOverrides(r,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:d,keys:E,overrides:L,restricted:u.restricted}}filter(r,i,s,u){if(!u?.scopes&&!u?.skipRestricted)return{raw:r,restricted:[]};const d={},E=[];for(let L in r)if(I.OVERRIDE_PROPERTY_REGEX.test(L)&&s){const R=this.filter(r[L],i,!1,u);d[L]=R.raw,E.push(...R.restricted)}else{const R=i[L],T=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&E.push(L),(T===void 0||u.scopes===void 0||u.scopes.includes(T))&&(u.skipRestricted&&R?.restricted||(d[L]=r[L]))}return{raw:d,restricted:E}}toOverrides(r,i){const s=[];for(const u of Object.keys(r))if(I.OVERRIDE_PROPERTY_REGEX.test(u)){const d={};for(const E in r[u])d[E]=r[u][E];s.push({identifiers:(0,I.overrideIdentifiersFromKey)(u),keys:Object.keys(d),contents:(0,b.toValuesTree)(d,i)})}return s}}e.ConfigurationModelParser=g;class S extends C.Disposable{constructor(r,i,s,u){super();this.userSettingsResource=r,this.scopes=i,this.fileService=u,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class w{constructor(r,i,s=new y,u=new y,d=new k.ResourceMap,E=new y,L=new k.ResourceMap,R=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=u,this._folderConfigurations=d,this._memoryConfiguration=E,this._memoryConfigurationByResource=L,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(r,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(r)}updateValue(r,i,s={}){let u;s.resource?(u=this._memoryConfigurationByResource.get(s.resource),u||(u=new y,this._memoryConfigurationByResource.set(s.resource,u))):u=this._memoryConfiguration,i===void 0?u.removeValue(r):u.setValue(r,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,s){const u=this.getConsolidateConfigurationModel(i,s),d=this.getFolderConfigurationModelForResource(i.resource,s),E=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,L=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),R=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),N=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),Q=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,se=d?i.overrideIdentifier?d.freeze().override(i.overrideIdentifier).getValue(r):d.freeze().getValue(r):void 0,ne=i.overrideIdentifier?E.override(i.overrideIdentifier).getValue(r):E.getValue(r),V=u.getValue(r),Z=v.distinct(v.flatten(u.overrides.map(H=>H.identifiers))).filter(H=>u.getOverrideValue(r,H)!==void 0);return{defaultValue:L,userValue:R,userLocalValue:T,userRemoteValue:N,workspaceValue:Q,workspaceFolderValue:se,memoryValue:ne,value:V,default:L!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:N!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:se!==void 0?{value:d?.freeze().getValue(r),override:i.overrideIdentifier?d?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:E.getValue(r),override:i.overrideIdentifier?E.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Z.length?Z:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:u,updated:d,removed:E}=l(this._defaultConfiguration,r);i=[...u,...d,...E]}for(const u of i)for(const d of(0,I.overrideIdentifiersFromKey)(u)){const E=this._defaultConfiguration.getKeysForOverrideIdentifier(d),L=r.getKeysForOverrideIdentifier(d),R=[...L.filter(T=>E.indexOf(T)===-1),...E.filter(T=>L.indexOf(T)===-1),...E.filter(T=>!P.equals(this._defaultConfiguration.override(d).getValue(T),r.override(d).getValue(T)))];s.push([d,R])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:u,overrides:d}=l(this.localUserConfiguration,r),E=[...i,...s,...u];return E.length&&this.updateLocalUserConfiguration(r),{keys:E,overrides:d}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:u,overrides:d}=l(this.remoteUserConfiguration,r);let E=[...i,...s,...u];return E.length&&this.updateRemoteUserConfiguration(r),{keys:E,overrides:d}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:u,overrides:d}=l(this.workspaceConfiguration,r);let E=[...i,...s,...u];return E.length&&this.updateWorkspaceConfiguration(r),{keys:E,overrides:d}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:u,updated:d,removed:E,overrides:L}=l(s,i);let R=[...u,...d,...E];return(R.length||!s)&&this.updateFolderConfiguration(r,i),{keys:R,overrides:L}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:u,removed:d,overrides:E}=l(i,void 0);return{keys:[...s,...u,...d],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let s=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?s.override(r.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:r},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const u=i.getFolder(r);u&&(s=this.getFolderConsolidatedConfiguration(u.uri)||s);const d=this._memoryConfigurationByResource.get(r);d&&(s=s.merge(d))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(r);u?(i=s.merge(u),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=s}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:s,overrides:u,keys:d}=this._folderConfigurations.get(i);return r.push([i,{contents:s,overrides:u,keys:d}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(u=>i.add(u))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.user),u=this.parseConfigurationModel(r.workspace),d=r.folders.reduce((E,L)=>(E.set(m.URI.revive(L[0]),this.parseConfigurationModel(L[1])),E),new k.ResourceMap);return new w(i,s,new y,u,d,new y,new k.ResourceMap,!1)}static parseConfigurationModel(r){return new y(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=w;function M(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const r=new Set,i=new Map;for(const u of h)u.keys.forEach(d=>r.add(d)),u.overrides.forEach(([d,E])=>{const L=(0,k.getOrSet)(i,d,new Set);E.forEach(R=>L.add(R))});const s=[];return i.forEach((u,d)=>s.push([d,[...u.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=M;class c{constructor(r,i,s,u){this.change=r,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=u,this._previousConfiguration=void 0;const d=new Set;r.keys.forEach(L=>d.add(L)),r.overrides.forEach(([,L])=>L.forEach(R=>d.add(R))),this.affectedKeys=[...d.values()];const E=new y;this.affectedKeys.forEach(L=>E.setValue(L,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!P.equals(s,u)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let s=(0,b.toValuesTree)({[i]:!0},()=>{}),u;for(;typeof s=="object"&&(u=Object.keys(s)[0]);){if(r=r[u],!r)return!1;s=s[u]}return!0}}e.ConfigurationChangeEvent=c;class a extends c{constructor(r,i,s,u){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=s,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=a;function l(h,r){const{added:i,removed:s,updated:u}=o(r,h),d=[],E=h?.getAllOverrideIdentifiers()||[],L=r?.getAllOverrideIdentifiers()||[];if(r){const R=L.filter(T=>!E.includes(T));for(const T of R)d.push([T,r.getKeysForOverrideIdentifier(T)])}if(h){const R=E.filter(T=>!L.includes(T));for(const T of R)d.push([T,h.getKeysForOverrideIdentifier(T)])}if(r&&h){for(const R of E)if(L.includes(R)){const T=o({contents:h.getOverrideValue(void 0,R)||{},keys:h.getKeysForOverrideIdentifier(R)},{contents:r.getOverrideValue(void 0,R)||{},keys:r.getKeysForOverrideIdentifier(R)});d.push([R,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:s,updated:u,overrides:d}}function o(h,r){const i=h?r?h.keys.filter(d=>r.keys.indexOf(d)===-1):[...h.keys]:[],s=r?h?r.keys.filter(d=>h.keys.indexOf(d)===-1):[...r.keys]:[],u=[];if(h&&r){for(const d of r.keys)if(h.keys.indexOf(d)!==-1){const E=(0,b.getConfigurationValue)(r.contents,d),L=(0,b.getConfigurationValue)(h.contents,d);P.equals(E,L)||u.push(d)}}return{added:i,removed:s,updated:u}}}),define(te[194],ie([0,1,8,4,2,16,19,193,57,40]),function(K,e,v,n,D,C,k,P,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends D.Disposable{constructor(p,y){super();this.settingsResource=p,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,y)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const p=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(p,y){const t=typeof p=="string"?p:void 0,g=(0,k.isConfigurationOverrides)(p)?p:(0,k.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(t,g,void 0)}updateValue(p,y,t,g){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const y=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(t,y,1)}onDidDefaultConfigurationChange(p){const y=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,p);this.trigger(t,y,6)}trigger(p,y,t){const g=new P.ConfigurationChangeEvent(p,{data:y},this.configuration);g.source=t,g.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(p){switch(p){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(te[195],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var n;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,P=n.Unknown,f){super(k);this._message=k,this._code=P,this._detail=f,this.isHandled=P===n.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===n.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===n.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(te[196],ie([0,1,8,17,21,15,4,2,32,85,195]),function(K,e,v,n,D,C,k,P,f,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var p;(function($){$[$.Management=1]="Management",$[$.ExtensionHost=2]="ExtensionHost",$[$.Tunnel=3]="Tunnel"})(p=e.ConnectionType||(e.ConnectionType={}));function y($){switch($){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t($){const F=new D.CancellationTokenSource;return setTimeout(()=>F.cancel(),$),F.token}function g($,F){if($.isCancellationRequested||F.isCancellationRequested)return D.CancellationToken.Cancelled;const W=new D.CancellationTokenSource;return $.onCancellationRequested(()=>W.cancel()),F.onCancellationRequested(()=>W.cancel()),W.token}class S{constructor(F){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((W,A)=>{this._resolvePromise=W,this._rejectPromise=A}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function w($,F){const W=new S(F);return W.registerDisposable($.onControlMessage(A=>{const _=JSON.parse(A.toString()),U=q(_);U?W.reject(U):W.resolve(_)})),W.promise}function M($,F,W,A,_,U,O){const B=new S(O);return F.connect(W,A,_,U,(J,ee)=>{B.didTimeout?(J&&$.error(J),ee?.dispose()):J||!ee?B.reject(J):B.resolve(ee)}),B.promise}function c($,F){const W=new S(F);return $.then(A=>{W.didTimeout||W.resolve(A)},A=>{W.didTimeout||W.reject(A)}),W.promise}async function a($,F,W,A){const _=z($,F);$.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let U;try{U=await M($.logService,$.socketFactory,$.host,$.port,`reconnectionToken=${$.reconnectionToken}&reconnection=${$.reconnectionProtocol?"true":"false"}`,`renderer-${y(F)}-${$.reconnectionToken}`,A)}catch(oe){throw $.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),$.logService.error(oe),oe}$.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let O,B;$.reconnectionProtocol?($.reconnectionProtocol.beginAcceptReconnection(U,null),O=$.reconnectionProtocol,B=!1):(O=new m.PersistentProtocol(U,null),B=!0),$.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const J=await c($.signService.createNewMessage((0,f.generateUuid)()),A),ee={type:"auth",auth:$.connectionToken||"00000000000000000000",data:J.data};O.sendControl(n.VSBuffer.fromString(JSON.stringify(ee)));try{const oe=await w(O,g(A,t(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const ue=new Error("Unexpected handshake message");throw ue.code="VSCODE_CONNECTION_ERROR",ue}if($.logService.trace(`${_} 4/6. received SignRequest control message.`),!await c($.signService.validate(J,oe.signedData),A)){const ue=new Error("Refused to connect to unsupported server");throw ue.code="VSCODE_CONNECTION_ERROR",ue}const ce=await c($.signService.sign(oe.data),A),le={type:"connectionType",commit:$.commit,signedData:ce,desiredConnectionType:F};return W&&(le.args=W),$.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),O.sendControl(n.VSBuffer.fromString(JSON.stringify(le))),{protocol:O,ownsProtocol:B}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&($.logService.error(`${_} the handshake timed out. Error:`),$.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&($.logService.error(`${_} received error control message when negotiating connection. Error:`),$.logService.error(oe)),B&&H(O),oe}}async function l($,F,W,A){const _=Date.now(),U=z($,F),{protocol:O,ownsProtocol:B}=await a($,F,W,A),J=new S(A);return J.registerDisposable(O.onControlMessage(ee=>{const oe=JSON.parse(ee.toString()),x=q(oe);x?($.logService.error(`${U} received error control message when negotiating connection. Error:`),$.logService.error(x),B&&H(O),J.reject(x)):($.reconnectionProtocol&&$.reconnectionProtocol.endAcceptReconnection(),$.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${G(_)}!`),J.resolve({protocol:O,firstMessage:oe}))})),J.promise}async function o($,F){const{protocol:W}=await l($,1,void 0,F);return{protocol:W}}async function h($,F,W){const{protocol:A,firstMessage:_}=await l($,2,F,W),U=_&&_.debugPort;return{protocol:A,debugPort:U}}async function r($,F,W){const A=Date.now(),_=z($,3),{protocol:U}=await a($,3,F,W);return $.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${G(A)}!`),U}async function i($,F,W){const{host:A,port:_,connectionToken:U}=await $.addressProvider.getAddress();return{commit:$.commit,host:A,port:_,connectionToken:U,reconnectionToken:F,reconnectionProtocol:W,socketFactory:$.socketFactory,signService:$.signService,logService:$.logService}}async function s($,F,W){try{const A=(0,f.generateUuid)(),_=await i($,A,null),{protocol:U}=await o(_,D.CancellationToken.None);return new V($,F,W,A,U)}catch(A){throw $.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),$.logService.error(A),ne.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(A)),A}}e.connectRemoteAgentManagement=s;async function u($,F){try{const W=(0,f.generateUuid)(),A=await i($,W,null),{protocol:_,debugPort:U}=await h(A,F,D.CancellationToken.None);return new Z($,F,W,_,U)}catch(W){throw $.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),$.logService.error(W),ne.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentExtensionHost=u;async function d($,F,W){const A=await i($,(0,f.generateUuid)(),null);return await r(A,{host:F,port:W},D.CancellationToken.None)}e.connectRemoteAgentTunnel=d;function E($){return(0,v.createCancelablePromise)(F=>new Promise((W,A)=>{const _=setTimeout(W,$*1e3);F.onCancellationRequested(()=>{clearTimeout(_),W()})}))}var L;(function($){$[$.ConnectionLost=0]="ConnectionLost",$[$.ReconnectionWait=1]="ReconnectionWait",$[$.ReconnectionRunning=2]="ReconnectionRunning",$[$.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$[$.ConnectionGain=4]="ConnectionGain"})(L=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class R{constructor(F,W){this.reconnectionToken=F,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=R;class T{constructor(F,W,A,_){this.reconnectionToken=F,this.millisSinceLastIncomingData=W,this.durationSeconds=A,this.cancellableTimer=_,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=T;class N{constructor(F,W,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=W,this.attempt=A,this.type=2}}e.ReconnectionRunningEvent=N;class Q{constructor(F,W,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=W,this.attempt=A,this.type=4}}e.ConnectionGainEvent=Q;class se{constructor(F,W,A,_){this.reconnectionToken=F,this.millisSinceLastIncomingData=W,this.attempt=A,this.handled=_,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class ne extends P.Disposable{constructor(F,W,A,_){super();this._connectionType=F,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=W,this.reconnectionToken=A,this.protocol=_,this._isReconnecting=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(_.onSocketClose(U=>{const O=j(this._connectionType,this.reconnectionToken,!0);U?U.type===0?(this._options.logService.info(`${O} received socket close event (hadError: ${U.hadError}).`),U.error&&this._options.logService.error(U.error)):(this._options.logService.info(`${O} received socket close event (wasClean: ${U.wasClean}, code: ${U.code}, reason: ${U.reason}).`),U.event&&this._options.logService.error(U.event)):this._options.logService.info(`${O} received socket close event.`),this._beginReconnecting()})),this._register(_.onSocketTimeout(()=>{const U=j(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${U} received socket timeout event.`),this._beginReconnecting()})),ne._instances.push(this),ne._permanentFailure&&this._gotoPermanentFailure(ne._permanentFailureMillisSinceLastIncomingData,ne._permanentFailureAttempt,ne._permanentFailureHandled)}static triggerPermanentFailure(F,W,A){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=W,this._permanentFailureHandled=A,this._instances.forEach(_=>_._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(F=>F._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(F=>F._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(ne._permanentFailure)return;const F=j(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let A=-1;do{A++;const _=A<W.length?W[A]:W[W.length-1];try{if(_>0){const O=E(_);this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,O)),this._options.logService.info(`${F} waiting for ${_} seconds before reconnecting...`);try{await O}catch{}}if(ne._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1)),this._options.logService.info(`${F} resolving connection...`);const U=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${U.host}:${U.port}...`),await this._reconnect(U,t(I)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(U),ne.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(A>360){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(U),ne.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(U)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((0,C.isPromiseCanceledError)(U)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if(U instanceof b.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(U),ne.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,b.RemoteAuthorityResolverError.isHandled(U));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(U),ne.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}}while(!ne._permanentFailure)}_gotoPermanentFailure(F,W,A){this._onDidStateChange.fire(new se(this.reconnectionToken,F,W,A)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ne,ne._permanentFailure=!1,ne._permanentFailureMillisSinceLastIncomingData=0,ne._permanentFailureAttempt=0,ne._permanentFailureHandled=!1,ne._instances=[];class V extends ne{constructor(F,W,A,_,U){super(1,F,_,U);this.client=this._register(new m.Client(U,{remoteAuthority:W,clientId:A},F.ipcLogger))}async _reconnect(F,W){await o(F,W)}}e.ManagementPersistentConnection=V;class Z extends ne{constructor(F,W,A,_,U){super(2,F,A,_);this._startArguments=W,this.debugPort=U}async _reconnect(F,W){await h(F,this._startArguments,W)}}e.ExtensionHostPersistentConnection=Z;function H($){try{$.acceptDisconnect();const F=$.getSocket();$.dispose(),F.dispose()}catch(F){(0,C.onUnexpectedError)(F)}}function q($){if($&&$.type==="error"){const F=new Error(`Connection error: ${$.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function Y($,F){for(;$.length<F;)$+=" ";return $}function j($,F,W){return`[remote-connection][${Y(y($),13)}][${F.substr(0,5)}\u2026][${W?"reconnect":"initial"}]`}function z($,F){return`${j(F,$.reconnectionToken,!!$.reconnectionProtocol)}[${$.host}:${$.port}]`}function G($){return`${Date.now()-$} ms`}}),define(te[64],ie([0,1,10]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(m){return m.scheme===v.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=n;function D(m){if(!m)return;const b=m.indexOf("+");return b<0?m:m.substr(0,b)}e.getRemoteName=D;function C(m){return m.scheme!==v.Schemas.file&&m.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=C;function k(m){if(m.folders.length)return m.folders.every(b=>C(b.uri))?m.folders[0].uri:void 0;if(m.configuration&&C(m.configuration))return m.configuration}e.getVirtualWorkspaceLocation=k;function P(m){return k(m)?.scheme}e.getVirtualWorkspaceScheme=P;function f(m){return k(m)!==void 0}e.isVirtualWorkspace=f}),define(te[197],ie([0,1,25,5,64]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=C;function k(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class f{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,t){if(typeof y=="undefined"||y===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof y=="string"||typeof t=="string"){let g=typeof y=="string"?y:y.value,S=typeof t=="string"?t:t.value;return v.equalsIgnoreCase(g,S)}return y._lower===t._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=f;function m(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function b(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function I(p,y){if(y){const t=`onResolveRemoteAuthority:${(0,D.getRemoteName)(y)}`;return p.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[198],ie([0,1,25,197]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(t,g){return t.uuid&&g.uuid?t.uuid===g.uuid:t.id===g.id?!0:(0,v.compareIgnoreCase)(t.id,g.id)===0}e.areSameExtensions=D;class C{constructor(g,S){this.version=S,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof C?D(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=C;function k(t,g){return`${t}.${g}`}e.getExtensionId=k;function P(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function f(t,g){return P(k(t,g))}e.getGalleryExtensionId=f;function m(t,g){const S=[],w=M=>{for(const c of S)if(c.some(a=>D(g(a),g(M))))return c;return null};for(const M of t){const c=w(M);c?c.push(M):S.push([M])}return S}e.groupByExtension=m;function b(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function I(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function p(t){const g=new Set;if(t.malicious)for(const S of t.malicious)g.add(S.id);return g}e.getMaliciousExtensionsSet=p;function y(t,g){const S=[],w=g.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const M=w.shift();if(M&&S.every(c=>!D(c.identifier,{id:M}))){const c=t.filter(a=>D(a.identifier,{id:M}));c.length===1&&(S.push(c[0]),w.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=y}),define(te[97],ie([0,1,4,3,5,6]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var k;(function(t){t.Http="http",t.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=I;function p(t,g){return g?g!==1&&t<1024:!n.isWindows&&t<1024}e.isPortPrivileged=p;let y=class{constructor(g){this.logService=g,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g,S){return this._tunnelProvider=g,g?(this._canElevate=S.elevation,this._privacyOptions=S.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],S=Array.from(this._tunnels.values());for(let w of S){const M=Array.from(w.values());for(let c of M){const a=await c.value;a&&g.push(a)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:S}of g.values())await S.then(w=>w?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,S,w,M,c=!1,a=P.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${S}:${w} on local port ${M}.`),!g)return;S||(S="localhost");const o=this.retainOrCreateTunnel(g,S,w,M,c,a,l);return o?o.then(h=>{if(!h){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(S,w);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(h);return(h.tunnelRemoteHost!==S||h.tunnelRemotePort!==w)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const S=this._tunnels.get(g.tunnelRemoteHost);if(S){const w=S.get(g.tunnelRemotePort);w&&(w.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,w))}}}}async tryDisposeTunnel(g,S,w){if(w.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${S}.`);const M=w.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(S),M}}async closeTunnel(g,S){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${S} `);const w=this._tunnels.get(g);if(w&&w.has(S)){const M=w.get(S);M.refcount=0,await this.tryDisposeTunnel(g,S,M)}}addTunnelToMap(g,S,w){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(S,{refcount:1,value:w})}async removeEmptyTunnelFromMap(g,S){const w=this._tunnels.get(g);w&&(await w.get(S)||w.delete(S),w.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,S){let w=[g];b(g)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):I(g)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const M=w.map(c=>this._tunnels.get(c));for(const c of M){const a=c?.get(S);if(a)return a}}canTunnel(g){return!!m(g)}createWithProvider(g,S,w,M,c,a,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${S}:${w} on local port ${M}.`);const h={elevationRequired:c?p(M===void 0?w:M):!1},r={remoteAddress:{host:S,port:w},localAddressPort:M,privacy:a,public:a!==P.Private,protocol:l},i=g.forwardPort(r,h);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(S,w,i),i}};y=fe([re(0,C.ILogService)],y),e.AbstractTunnelService=y}),define(te[48],ie([0,1,17,153,57,5,40]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function P(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=P;function f(t){return t.res.statusCode===204}async function m(t){if(!P(t))throw new Error("Server returned "+t.res.statusCode);return f(t)?null:(await(0,v.streamToBuffer)(t.stream)).toString()}e.asText=m;async function b(t){if(!P(t))throw new Error("Server returned "+t.res.statusCode);if(f(t))return null;const S=(await(0,v.streamToBuffer)(t.stream)).toString();try{return JSON.parse(S)}catch(w){throw w.message+=`:
`+S,w}}e.asJson=b;function I(t){y(t)}e.updateProxyConfigurationsScope=I;let p;function y(t){const g=k.Registry.as(D.Extensions.Configuration),S=p;p={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[p],remove:S?[S]:[]})}y(2)}),define(te[199],ie([0,1,200,13]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(k,P){return k.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:k.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function C(k,P,f={}){const m=(0,v.parse)(k),b=f.proxyUrl||D(m,P);if(!b)return null;const I=(0,v.parse)(b);if(!/^https?:$/.test(I.protocol||""))return null;const p={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,n.isBoolean)(f.strictSSL)?f.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((y,t)=>{K(["http-proxy-agent"],y,t)}))(p):new(await new Promise((y,t)=>{K(["https-proxy-agent"],y,t)}))(p)}e.getProxyAgent=C}),define(te[201],ie([0,1,17,32]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(C,k,P){let f=P&&P.get("storage.serviceMachineId",0)||null;if(f)return f;try{const b=(await k.readFile(C.serviceMachineIdResource)).value.toString();f=(0,n.isUUID)(b)?b:null}catch{f=null}if(!f){f=(0,n.generateUuid)();try{await k.writeFile(C.serviceMachineIdResource,v.VSBuffer.fromString(f))}catch{}}return P&&P.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=D}),define(te[76],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[202],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((D,C)=>K(["vsda"],D,C))}async createNewMessage(D){try{const C=await this.vsda(),k=new C.validator;if(k){const P=String(v._nextId++);return this.validators.set(P,k),{id:P,data:k.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,C){if(!D.id)return!0;const k=this.validators.get(D.id);if(!k)return!1;this.validators.delete(D.id);try{return k.validate(C)==="ok"}catch{return!1}}async sign(D){try{const C=await this.vsda(),k=new C.signer;if(k)return k.sign(D)}catch{}return D}}e.SignService=v,v._nextId=1}),define(te[38],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(te[20],ie([0,1,14,8,4,2,3,34,13,5,182,6,38]),function(K,e,v,n,D,C,k,P,f,m,b,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,m.createDecorator)("lifecycleMainService");var y;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(y=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class gt extends C.Disposable{constructor(S,w){super();this.logService=S,this.stateMainService=w,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(gt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(gt.QUIT_AND_RESTART_KEY)}registerListeners(){const S=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),k.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};v.app.addListener("before-quit",S);const w=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!k.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",w),v.app.once("will-quit",M=>{this.logService.trace("Lifecycle#app.on(will-quit)"),M.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",S),v.app.removeListener("window-all-closed",w),v.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const S=[];return this._onWillShutdown.fire({join(w){S.push(w)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(S)}catch(w){this.logService.error(w)}try{await this.stateMainService.close()}catch(w){this.logService.error(w)}})(),this.pendingWillShutdownPromise}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===S)return;this.logService.trace(`lifecycle (main): phase changed (value: ${S})`),this._phase=S;const w=this.phaseWhen.get(this._phase);w&&(w.open(),this.phaseWhen.delete(this._phase))}async when(S){if(S<=this._phase)return;let w=this.phaseWhen.get(S);w||(w=new n.Barrier,this.phaseWhen.set(S,w)),await w.wait()}registerWindow(S){const w=new C.DisposableStore;this.windowCounter++,w.add(S.onWillLoad(c=>this._onWillLoadWindow.fire({window:S,workspace:c.workspace,reason:c.reason})));const M=(0,f.assertIsDefined)(S.win);M.on("close",c=>{const a=S.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${S.id}`),c.preventDefault(),this.unload(S,1).then(l=>{if(l){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(S),S.close()})}),M.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.windowCounter--,w.dispose(),this.windowCounter===0&&(!k.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(S,w){await this.unload(S,3)||S.reload(w)}async unload(S,w){if(!S.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${S.id}`);const M=this._quitRequested?2:w;let c=await this.onBeforeUnloadWindowInRenderer(S,M);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(S,M),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${S.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${S.id})`),await this.onWillUnloadWindowInRenderer(S,M),!1))}handleWindowUnloadVeto(S){return S?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(S){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(S),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(S,w){return new Promise(M=>{const c=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${c}`,l=`vscode:cancel${c}`;v.ipcMain.once(a,()=>{M(!1)}),v.ipcMain.once(l,()=>{M(!0)}),S.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:l,reason:w})})}onBeforeUnloadWindowInMain(S,w){const M=[];return this._onBeforeUnloadWindow.fire({reason:w,window:S,veto(c){M.push(c)}}),(0,b.handleVetos)(M,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(S,w){return new Promise(M=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(a,()=>M()),S.send("vscode:onWillUnload",{replyChannel:a,reason:w})})}quit(S){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${S}`),S&&this.stateMainService.setItem(gt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(w=>{this.pendingQuitPromiseResolve=w,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(S){this.logService.trace("Lifecycle#relaunch()");const w=process.argv.slice(1);if(S?.addArgs&&w.push(...S.addArgs),S?.removeArgs)for(const a of S.removeArgs){const l=w.indexOf(a);l>=0&&w.splice(l,1)}const M=()=>{try{if(k.isWindows){const a=(0,P.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:w})};v.app.once("quit",M),await this.quit(!0)&&v.app.removeListener("quit",M)}async kill(S){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const w of v.BrowserWindow.getAllWindows())if(w&&!w.isDestroyed()){let M;w.webContents&&!w.webContents.isDestroyed()?M=new Promise(c=>w.once("closed",c)):M=Promise.resolve(),w.destroy(),await M}})()]),v.app.exit(S)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=fe([re(0,I.ILogService),re(1,p.IStateMainService)],t),e.LifecycleMainService=t}),define(te[203],ie([0,1,4,2,5,20]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let k=class extends n.Disposable{constructor(m){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,m.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const m=await new Promise((b,I)=>{K(["native-keymap"],b,I)});this._keyboardLayoutData=P(m),m.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=P(m),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};k=fe([re(0,C.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function P(f){const m=f.getKeyMap(),b=f.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:b}}}),define(te[77],ie([0,1,8,4,2,63,13,87,5]),function(K,e,v,n,D,C,k,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";e.IStorageService=(0,f.createDecorator)("storageService");var b;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var I;(function(S){S[S.GLOBAL=0]="GLOBAL",S[S.WORKSPACE=1]="WORKSPACE"})(I=e.StorageScope||(e.StorageScope={}));var p;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));class y extends D.Disposable{constructor(w={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=w,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,M){M===m?(w===0?this._globalKeyTargets=void 0:w===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:w})):this._onDidChangeValue.fire({scope:w,key:M,target:this.getKeyTargets(w)[M]})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,M,c){return this.getStorage(M)?.get(w,c)}getBoolean(w,M,c){return this.getStorage(M)?.getBoolean(w,c)}getNumber(w,M,c){return this.getStorage(M)?.getNumber(w,c)}store(w,M,c,a){if((0,k.isUndefinedOrNull)(M)){this.remove(w,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(w,c,a),this.getStorage(c)?.set(w,M)})}remove(w,M){this.withPausedEmitters(()=>{this.updateKeyTarget(w,M,void 0),this.getStorage(M)?.delete(w)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,M){const c=[],a=this.getKeyTargets(w);for(const l of Object.keys(a))a[l]===M&&c.push(l);return c}updateKeyTarget(w,M,c){const a=this.getKeyTargets(M);typeof c=="number"?a[w]!==c&&(a[w]=c,this.getStorage(M)?.set(m,JSON.stringify(a))):typeof a[w]=="number"&&(delete a[w],this.getStorage(M)?.set(m,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(w){return w===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(w){const M=this.get(m,w);if(M)try{return JSON.parse(M)}catch{}return Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=b.NONE){this._onWillSaveState.fire({reason:w});const M=this.getStorage(0),c=this.getStorage(1);switch(w){case b.NONE:await v.Promises.settled([M?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await v.Promises.settled([M?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve()]);break}}async logStorage(){const w=this.getStorage(0)?.items??new Map,M=this.getStorage(1)?.items??new Map;return g(w,M,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends y{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.globalStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w)))}getStorage(w){return w===0?this.globalStorage:this.workspaceStorage}getLogDetails(w){return w===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(w){}}e.InMemoryStorageService=t;async function g(S,w,M,c){const a=u=>{try{return JSON.parse(u)}catch{return u}},l=new Map,o=new Map;S.forEach((u,d)=>{l.set(d,u),o.set(d,a(u))});const h=new Map,r=new Map;w.forEach((u,d)=>{h.set(d,u),r.set(d,a(u))}),console.group(`Storage: Global (path: ${M})`);let i=[];l.forEach((u,d)=>{i.push({key:d,value:u})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${c})`);let s=[];h.forEach((u,d)=>{s.push({key:d,value:u})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=g}),define(te[204],ie([0,1,3,34,7,32]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(m){if(v.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function P(m,b,I,p,y,t,g,S,w,M){const c=Object.create(null);c["common.machineId"]=g,c.sessionID=(0,C.generateUuid)()+Date.now(),c.commitHash=y,c.version=t,c["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,v.PlatformToString)(v.platform),c["common.nodePlatform"]=n.platform,c["common.nodeArch"]=p,c["common.product"]=M||"desktop";const a=f(S||[]);a&&(c["common.msftInternal"]=a);let l=0;const o=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),v.isLinuxSnap&&(c["common.snap"]="true");const h=k(I);h&&(c["common.platformDetail"]=h);try{const r=await m.readFile(D.URI.file(w));c["common.source"]=r.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=P;function f(m){const b=n.env.USERDNSDOMAIN;if(!b)return!1;const I=b.toLowerCase();return m.some(p=>I===p)}e.verifyMicrosoftInternalDomain=f}),define(te[29],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[205],ie([0,1,26,69,8,43,10,9,3,7,71,24,84,74,18,22,29]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function w(o,h){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let i;const s=v.homedir().toLowerCase();switch(process.platform){case"win32":i=[{tag:"gdrive",matcher:N=>/^[a-z]:\\(my drive|shared drives)\\/.test(N)||N.startsWith(s+"\\my drive\\")},{tag:"dropbox",matcher:N=>N.startsWith(s+"\\dropbox")},{tag:"onedrive",matcher:N=>N.startsWith(s+"\\onedrive")},{tag:"box",matcher:N=>N.startsWith(s+"\\box\\")},{tag:"nextcloud",matcher:N=>N.startsWith(s+"\\nextcloud\\")},{tag:"owncloud",matcher:N=>N.startsWith(s+"\\owncloud\\")}];break;case"darwin":i=[{tag:"gdrive",matcher:N=>N.startsWith("/volumes/googledrive/")||N.startsWith(s+"/my drive/")},{tag:"dropbox",matcher:N=>N.startsWith(s+"/dropbox")},{tag:"onedrive",matcher:N=>N.startsWith(s+"/onedrive")||N.startsWith(s+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:N=>N.startsWith(s+"/library/mobile documents/")},{tag:"box",matcher:N=>N.startsWith(s+"/box/")},{tag:"nextcloud",matcher:N=>N.startsWith(s+"/nextcloud/")},{tag:"owncloud",matcher:N=>N.startsWith(s+"/owncloud/")}];break}const u=new Map,d=new Map,E=2e4;function L(N,Q,se,ne){for(const Z of i){const H=N.toLowerCase();Z.matcher(H)&&d.set(Z.tag,1)}const V=Q.substring(N.length+1);return D.Promises.withAsyncBody(async Z=>{let H;try{H=await I.Promises.readdir(Q,{withFileTypes:!0})}catch{Z();return}if(ne.count>=E){ne.count+=H.length,ne.maxReached=!0,Z();return}let q=H.length;if(q===0){Z();return}let Y=H;ne.count+H.length>E&&(ne.maxReached=!0,q=E-ne.count,Y=H.slice(0,q)),ne.count+=H.length;for(const j of Y)if(j.isDirectory()){if(se.includes(j.name)||await L(N,(0,P.join)(Q,j.name),se,ne),--q==0){Z();return}}else{const z=j.name.lastIndexOf(".");if(z>=0){const G=j.name.substring(z+1);G&&u.set(G,(u.get(G)??0)+1)}for(const G of r)G.relativePathPattern?.test(V)!==!1&&G.filePattern.test(j.name)&&d.set(G.tag,(d.get(G.tag)??0)+1);if(--q==0){Z();return}}})}const R={count:0,maxReached:!1};await L(o,o,h,R);const T=await a(o);return{configFiles:M(d),fileTypes:M(u),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=w;function M(o){return[...n.Iterable.map(o.entries(),([h,r])=>({name:h,count:r}))].sort((h,r)=>r.count-h.count)}function c(){const o={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},h=v.cpus();return h&&h.length>0&&(o.cpus=`${h[0].model} (${h.length} x ${h[0].speed})`),o}e.getMachineInfo=c;async function a(o){try{const h=new Map,r=(0,P.join)(o,".vscode","launch.json"),i=await I.Promises.readFile(r),s=[],u=(0,C.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,C.getNodeType)(u)==="object"&&u.configurations)for(const d of u.configurations){const E=d.type;E&&(h.has(E)?h.set(E,h.get(E)+1):h.set(E,1))}return M(h)}catch{return[]}}e.collectLaunchConfigs=a;let l=class{constructor(h,r){this.telemetryService=h,this.productService=r}formatMachineInfo(h){const r=[];return r.push(`OS Version:       ${h.os}`),r.push(`CPUs:             ${h.cpus}`),r.push(`Memory (System):  ${h.memory}`),r.push(`VM:               ${h.vmHint}`),r.join(`
`)}formatEnvironment(h){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const i=v.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),f.isWindows||r.push(`Load (avg):       ${v.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${h.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${h.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(h.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(h,r){return Promise.all([(0,p.listProcesses)(h.mainPID),this.formatWorkspaceMetadata(h)]).then(async i=>{let[s,u]=i,d=this.formatProcessList(h,s);return r.forEach(E=>{if((0,y.isRemoteDiagnosticError)(E))d+=`
${E.errorMessage}`,u+=`
${E.errorMessage}`;else if(d+=`

Remote: ${E.hostName}`,E.processes&&(d+=`
${this.formatProcessList(h,E.processes)}`),E.workspaceMetadata){u+=`
|  Remote: ${E.hostName}`;for(const L of Object.keys(E.workspaceMetadata)){const R=E.workspaceMetadata[L];let T=`${R.fileCount} files`;R.maxFilesReached&&(T=`more than ${T}`),u+=`|    Folder (${L}): ${T}`,u+=this.formatWorkspaceStats(R)}}}),{processInfo:d,workspaceInfo:u}})}async getSystemInfo(h,r){const{memory:i,vmHint:s,os:u,cpus:d}=c(),E={os:u,memory:i,cpus:d,vmHint:s,processArgs:`${h.mainArguments.join(" ")}`,gpuStatus:h.gpuFeatureStatus,screenReader:`${h.screenReader?"yes":"no"}`,remoteData:r};return f.isWindows||(E.load=`${v.loadavg().map(L=>Math.round(L)).join(", ")}`),f.isLinux&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(h,r){const i=[];return(0,p.listProcesses)(h.mainPID).then(async s=>(i.push(""),i.push(this.formatEnvironment(h)),i.push(""),i.push(this.formatProcessList(h,s)),h.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(h))),r.forEach(u=>{if((0,y.isRemoteDiagnosticError)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.formatMachineInfo(u.machineInfo)),u.processes&&i.push(this.formatProcessList(h,u.processes)),u.workspaceMetadata)for(const d of Object.keys(u.workspaceMetadata)){const E=u.workspaceMetadata[d];let L=`${E.fileCount} files`;E.maxFilesReached&&(L=`more than ${L}`),i.push(`Folder (${d}): ${L}`),i.push(this.formatWorkspaceStats(E))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(h){const r=[],i=60;let s=0;const u=(R,T)=>{const N=` ${R}(${T})`;s+N.length>i?(r.push(d),d="|                 ",s=d.length):s+=N.length,d+=N};let d="|      File types:";const E=10;let L=h.fileTypes.length>E?E:h.fileTypes.length;for(let R=0;R<L;R++){const T=h.fileTypes[R];u(T.name,T.count)}if(r.push(d),h.configFiles.length>=0&&(d="|      Conf files:",s=0,h.configFiles.forEach(R=>{u(R.name,R.count)}),r.push(d)),h.launchConfigFiles.length>0){let R="|      Launch Configs:";h.launchConfigFiles.forEach(T=>{R+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),r.push(R)}return r.join(`
`)}expandGPUFeatures(h){const r=Math.max(...Object.keys(h).map(i=>i.length));return Object.keys(h).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${h[i]}`).join(`
                  `)}formatWorkspaceMetadata(h){const r=[],i=[];return h.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(u=>{const d=m.URI.revive(u);if(d.scheme===k.Schemas.file){const E=d.fsPath;i.push(w(E,["node_modules",".git"]).then(L=>{let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),r.push(`|    Folder (${(0,P.basename)(E)}): ${R}`),r.push(this.formatWorkspaceStats(L))}).catch(L=>{r.push(`|      Error: Unable to collect workspace stats for folder ${E} (${L.toString()})`)}))}else r.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(h,r){const i=new Map;h.windows.forEach(u=>i.set(u.pid,u.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(h.mainPID,i,s,r,0),s.join(`
`)}formatProcessItem(h,r,i,s,u){const d=u===0;let E;d?E=s.pid===h?`${this.productService.applicationName} main`:"remote agent":(E=`${"  ".repeat(u)} ${s.name}`,s.name==="window"&&(E=`${E} (${r.get(s.pid)})`));const L=process.platform==="win32"?s.mem:v.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(L/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(s.children)&&s.children.forEach(R=>this.formatProcessItem(h,r,i,R,u+1))}async reportWorkspaceStats(h){for(const{uri:r}of h.folders){const i=m.URI.revive(r);if(i.scheme!==k.Schemas.file)continue;const s=i.fsPath;try{const u=await w(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":h.telemetryId,rendererSessionId:h.rendererSessionId}),u.fileTypes.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:h.rendererSessionId,type:d.name,count:d.count})}),u.launchConfigFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:h.rendererSessionId,type:d.name,count:d.count})}),u.configFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:h.rendererSessionId,type:d.name,count:d.count})})}catch{}}}};l=fe([re(0,S.ITelemetryService),re(1,g.IProductService)],l),e.DiagnosticsService=l}),define(te[206],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(C){this.appenders=C}listen(C,k){throw new Error(`Event not found: ${k}`)}call(C,k,{eventName:P,data:f}){return this.appenders.forEach(m=>m.log(P,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class n{constructor(C){this.channel=C}log(C,k){return this.channel.call("log",{eventName:C,data:k}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(te[65],ie([0,1,47,13,19,29]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(w,M){return Promise.resolve(void 0)}publicLog2(w,M){return this.publicLog(w,M)}publicLogError(w,M){return Promise.resolve(void 0)}publicLogError2(w,M){return this.publicLogError(w,M)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class P{async publicLog(w,M,c){}async publicLogError(w,M,c){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(S,w){return w.onDidChangeConfiguration(M=>{M.source!==6&&S.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(M.source),configurationKeys:t(M.sourceConfig)})})}e.configurationTelemetry=f;function m(S,w){return!(w.disableTelemetry||!S.enableTelemetry)}e.supportsTelemetry=m;function b(S){const w=S.getValue(C.TELEMETRY_SETTING_ID),M=S.getValue("telemetry.enableCrashReporter");if(S.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||M===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function I(S){const w=Object.create(null),M=Object.create(null),c=Object.create(null);y(S,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const l=c[a];typeof l=="number"?M[a]=l:typeof l=="boolean"?M[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),w[a]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(w[a]=l)}return{properties:w,measurements:M}}e.validateTelemetryData=I;function p(S){if(!S)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(c=>{S.indexOf(`${c}+`)===0&&(w=c)}),w}e.cleanRemoteAuthority=p;function y(S,w,M=0,c){if(!!S)for(let a of Object.getOwnPropertyNames(S)){const l=S[a],o=c?c+a:a;Array.isArray(l)?w[o]=(0,v.safeStringify)(l):l instanceof Date?w[o]=l.toISOString():(0,n.isObject)(l)?M<2?y(l,w,M+1,o+"."):w[o]=(0,v.safeStringify)(l):w[o]=l}}function t(S){if(!S)return[];const w=[];return g(w,"",S),w}function g(S,w,M){M&&typeof M=="object"&&!Array.isArray(M)?Object.keys(M).forEach(c=>g(S,w?`${w}.${c}`:c,M[c])):S.push(w)}}),define(te[207],ie([0,1,31,21,15,47,3,34,13,7,19,53,172,198,169,18,6,22,48,201,77,29,65]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w,M,c,a,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const h=k.isWeb?"web":(0,p.getTargetPlatform)(k.platform,P.arch);var r;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished"})(r||(r={}));function i(...O){return String(O.reduce((B,J)=>B|J,0))}var s;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},d={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},L={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class R{constructor(B=L){this.state=B}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(B,J=this.state.pageSize){return new R({...this.state,pageNumber:B,pageSize:J})}withFilter(B,...J){const ee=[...this.state.criteria,...J.length?J.map(oe=>({filterType:B,value:oe})):[{filterType:B}]];return new R({...this.state,criteria:ee})}withSortBy(B){return new R({...this.state,sortBy:B})}withSortOrder(B){return new R({...this.state,sortOrder:B})}withFlags(...B){return new R({...this.state,flags:B.reduce((J,ee)=>J|ee,0)})}withAssetTypes(...B){return new R({...this.state,assetTypes:B})}get raw(){const{criteria:B,pageNumber:J,pageSize:ee,sortBy:oe,sortOrder:x,flags:ce,assetTypes:le}=this.state;return{filters:[{criteria:B,pageNumber:J,pageSize:ee,sortBy:oe,sortOrder:x}],assetTypes:le,flags:ce}}get searchText(){const B=this.state.criteria.filter(J=>J.filterType===s.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(B=>String(B.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(O,B){const J=(O||[]).filter(ee=>ee.statisticName===B)[0];return J?J.value:0}function N(O){const B="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(ee=>ee.assetType.indexOf(B)===0).reduce((ee,oe)=>{const x=V(O,oe.assetType);return x&&ee.push([oe.assetType.substring(B.length),x]),ee},[])}function Q(O){if(O.properties){const B=O.properties.filter(oe=>oe.key===u.Repository),J=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ee=B.filter(oe=>J.test(oe.value))[0];return ee?{uri:ee.value,fallbackUri:ee.value}:null}return V(O,u.Repository)}function se(O){return{uri:`${O.fallbackAssetUri}/${u.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${u.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function ne(O){const B=V(O,u.Icon);if(B)return B;const J=p.DefaultIconPath;return{uri:J,fallbackUri:J}}function V(O,B){return O.files.filter(ee=>ee.assetType===B)[0]?{uri:`${O.assetUri}/${B}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${B}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function Z(O,B){const J=O.properties?O.properties.filter(oe=>oe.key===B):[],ee=J.length>0&&J[0].value;return ee?ee.split(",").map(oe=>(0,y.adoptToGalleryExtensionId)(oe)):[]}function H(O){const B=O.properties?O.properties.filter(J=>J.key===d.Engine):[];return B.length>0&&B[0].value||""}function q(O){const B=O.properties?O.properties.filter(J=>J.key===d.PreRelease):[];return B.length>0&&B[0].value==="true"}function Y(O){const B=O.properties?O.properties.filter(ee=>ee.key===d.LocalizedLanguages):[],J=B.length>0&&B[0].value||"";return J?J.split(","):[]}function j(O){return O.indexOf("preview")!==-1}function z(O){return O.targetPlatform?(0,p.toTargetPlatform)(O.targetPlatform):"undefined"}function G(O){const B=(0,v.distinct)(O.versions.map(z)),J=!!O.tags?.includes(p.WEB_EXTENSION_TAG),ee=B.indexOf("web");return J?ee===-1&&B.push("web"):ee!==-1&&B.splice(ee,1),B}function $(O,B){const J=(0,p.getFallbackTargetPlarforms)(B);for(let ee=0;ee<O.length;ee++){const oe=O[ee];if(oe.version===O[ee-1]?.version){let x=ee;const ce=z(oe);if(ce===B)for(;x>0&&O[x-1].version===oe.version;)x--;else if(J.includes(ce))for(;x>0&&O[x-1].version===oe.version&&z(O[x-1])!==B;)x--;x!==ee&&(O.splice(ee,1),O.splice(x,0,oe))}}return O}e.sortExtensionVersions=$;function F(O,B,J,ee,oe){const x=O.versions[0],ce={manifest:V(B,u.Manifest),readme:V(B,u.Details),changelog:V(B,u.Changelog),license:V(B,u.License),repository:Q(B),download:se(B),icon:ne(B),coreTranslations:N(B)};return{identifier:{id:(0,y.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:B.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,description:O.shortDescription||"",installCount:T(O.statistics,"install"),rating:T(O.statistics,"averagerating"),ratingCount:T(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:J,assets:ce,properties:{dependencies:Z(B,d.Dependency),extensionPack:Z(B,d.ExtensionPack),engine:H(B),localizedLanguages:Y(B),targetPlatform:z(B),isPreReleaseVersion:q(B)},hasPreReleaseVersion:q(x),hasReleaseVersion:ee,preview:j(O.flags),telemetryData:oe}}let W=class{constructor(B,J,ee,oe,x,ce,le,ue){this.requestService=J,this.logService=ee,this.environmentService=oe,this.telemetryService=x,this.fileService=ce,this.productService=le,this.configurationService=ue;const me=le.extensionsGallery;this.extensionsGalleryUrl=me&&me.serviceUrl,this.extensionsControlUrl=me&&me.controlUrl,this.commonHeadersPromise=U(le.version,le,this.environmentService,this.configurationService,this.fileService,B)}api(B=""){return`${this.extensionsGalleryUrl}${B}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(B,J,ee){const oe=(0,f.isBoolean)(J)?J:!1,x=(0,f.isBoolean)(J)?ee:J;let ce=new R().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,B.length).withFilter(s.ExtensionName,...B.map(({id:me})=>me.toLowerCase()));B.every(me=>!me.version)&&(ce=ce.withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,h,n.CancellationToken.None),ue=le.map(me=>{const Ee=(0,y.getGalleryExtensionId)(me.publisher.publisherName,me.extensionName);return{rawGalleryExtension:me,version:B.find(de=>(0,y.areSameExtensions)(de,{id:Ee}))?.version,preRelease:oe}});return this.converToGalleryExtensions(ue,h,()=>{},x)}async getExtensions2(B){const J=[],ee=[];for(const le of B)le.uuid?ee.push(le.uuid):J.push(le.id.toLowerCase());let oe=new R().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly).withPage(1,B.length);ee.length&&(oe=oe.withFilter(s.ExtensionId,...ee)),J.length&&(oe=oe.withFilter(s.ExtensionId,...J));const{galleryExtensions:x}=await this.queryGallery(oe,h,n.CancellationToken.None),ce=x.map(le=>{const ue=(0,y.getGalleryExtensionId)(le.publisher.publisherName,le.extensionName),me=B.find(Ee=>(0,y.areSameExtensions)(Ee,{id:ue,uuid:le.extensionId}));return{rawGalleryExtension:le,preRelease:!!me?.preRelease}});return this.converToGalleryExtensions(ce,h,()=>{},n.CancellationToken.None)}async getCompatibleExtension(B,J,ee){const oe=(0,p.isIExtensionIdentifier)(B)?null:B;if(oe){if((0,p.isNotWebExtensionInWebTargetPlatform)(oe.allTargetPlatforms,ee))return null;if(await this.isExtensionCompatible(oe,J,ee))return oe}const{id:x,uuid:ce}=oe?oe.identifier:B;let le=new R().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);ce?le=le.withFilter(s.ExtensionId,ce):le=le.withFilter(s.ExtensionName,x);const{galleryExtensions:ue}=await this.queryGallery(le,ee,n.CancellationToken.None),[me]=ue;if(!me||!me.versions.length)return null;const Ee=G(me);if((0,p.isNotWebExtensionInWebTargetPlatform)(Ee,ee))return null;for(let de of me.versions){if(!H(de)){const ge=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:d.Engine,value:ge}]}}if(await this.isRawExtensionVersionCompatible(de,J,Ee,ee)){const ge=me.versions.some(we=>!q(we));return F(me,de,Ee,ge)}}return null}async isExtensionCompatible(B,J,ee){if(!(0,p.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,ee)||!J&&B.properties.isPreReleaseVersion)return!1;let oe=B.properties.engine;if(!oe){const x=await this.getManifest(B,n.CancellationToken.None);if(!x)throw new Error("Manifest was not found");oe=x.engines.vscode}return(0,t.isEngineValid)(oe,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(B,J,ee,oe){if(!(0,p.isTargetPlatformCompatible)(z(B),ee,oe)||!J&&q(B))return!1;const x=await this.getEngine(B);return(0,t.isEngineValid)(x,this.productService.version,this.productService.date)}async query(B,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ee=B.text||"";const oe=(0,C.getOrDefault)(B,de=>de.pageSize,50);let x=new R().withFlags(r.IncludeLatestVersionOnly,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,oe);ee?(ee=ee.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ge,we)=>(x=x.withFilter(s.Category,we||ge),"")),ee=ee.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ge,we)=>(x=x.withFilter(s.Tag,we||ge),"")),ee=ee.replace(/\bfeatured(\s+|\b|$)/g,()=>(x=x.withFilter(s.Featured),"")),ee=ee.trim(),ee&&(ee=ee.length<200?ee:ee.substring(0,200),x=x.withFilter(s.SearchText,ee)),x=x.withSortBy(0)):B.ids?x=x.withFilter(s.ExtensionId,...B.ids):B.names?x=x.withFilter(s.ExtensionName,...B.names):x=x.withSortBy(4),typeof B.sortBy=="number"&&(x=x.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(x=x.withSortOrder(B.sortOrder));const{galleryExtensions:ce,total:le}=await this.queryGallery(x,h,J),ue=de=>({index:(x.pageNumber-1)*x.pageSize+de,querySource:B.source}),me=await this.converToGalleryExtensions(ce.map(de=>({rawGalleryExtension:de,preRelease:!!B.includePreRelease})),h,ue,J),Ee=async(de,ge)=>{if(ge.isCancellationRequested)throw(0,D.canceled)();const we=x.withPage(de+1),{galleryExtensions:ke}=await this.queryGallery(we,h,ge);return await this.converToGalleryExtensions(ke.map(Ce=>({rawGalleryExtension:Ce,preRelease:!!B.includePreRelease})),h,ue,J)};return{firstPage:me,total:le,pageSize:x.pageSize,getPage:Ee}}async converToGalleryExtensions(B,J,ee,oe){const x=(ue,me,Ee,de)=>{const ge=G(ue);let we=ue.versions[0];return we=ue.versions.find(ke=>ke.version===we.version&&(0,p.isTargetPlatformCompatible)(z(ke),ge,J))||we,q(we)&&!de&&(we=ue.versions.find(ke=>ke.version!==we.version&&!q(ke))||we),F(ue,we,ge,Ee,ee(me))},ce=[],le=new Map;for(let ue=0;ue<B.length;ue++){const{rawGalleryExtension:me,version:Ee,preRelease:de}=B[ue],ge=me.versions.some(we=>!q(we));if(Ee){const we=me.versions.find(ke=>ke.version===Ee);we&&ce.push([ue,F(me,we,G(me),ge)])}else{const we=x(me,ue,ge,de);we.properties.isPreReleaseVersion?le.set(we.identifier.uuid,{index:ue,preRelease:de}):ce.push([ue,we])}}if(le.size){const ue=new Date().getTime(),me=new R().withFlags(r.IncludeVersions,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,le.size).withFilter(s.ExtensionId,...le.keys()),{galleryExtensions:Ee}=await this.queryGallery(me,J,oe);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-ue,count:le.size}),Ee.length!==le.size)throw new Error("Not all extensions with latest versions are returned");for(const de of Ee){const ge=de.versions.some(_e=>!q(_e)),{index:we,preRelease:ke}=le.get(de.extensionId),Ce=x(de,we,ge,ke);ce.push([we,Ce])}}return ce.sort((ue,me)=>ue[0]-me[0]).map(([,ue])=>ue)}async queryGallery(B,J,ee){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,r.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,i(r.Unpublished));const oe=await this.commonHeadersPromise,x=JSON.stringify(B.raw),ce={...oe,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)},le=new Date().getTime();let ue,me,Ee=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:x,headers:ce},ee),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:Ee};const de=await(0,M.asJson)(ue);if(de){const ge=de.results[0],we=ge.extensions;we.forEach(Ce=>$(Ce.versions,J));const ke=ge.resultMetadata&&ge.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return Ee=ke&&ke.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(de){throw me=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(x.length),duration:new Date().getTime()-le,success:!!ue&&(0,M.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:me?(0,D.isPromiseCanceledError)(me)?"canceled":(0,D.getErrorMessage)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(B,J,ee,oe){if(!this.isEnabled())return;const x=k.isWeb?this.api(`/itemName/${B}.${J}/version/${ee}/statType/${oe==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${B}/extensions/${J}/${ee}/stats?statType=${oe}`),ce=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:x,headers:ue},n.CancellationToken.None)}catch{}}async download(B,J,ee){this.logService.trace("ExtensionGalleryService#download",B.identifier.id);const oe=(0,y.getGalleryExtensionTelemetryData)(B),x=new Date().getTime(),ce=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...oe,duration:Ee}),le=ee===2?"install":ee===3?"update":"",ue=le?{uri:`${B.assets.download.uri}${m.URI.parse(B.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${B.assets.download.fallbackUri}${m.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:B.assets.download,me=await this.getAsset(ue);await this.fileService.writeFile(J,me.stream),ce(new Date().getTime()-x)}async getReadme(B,J){if(B.assets.readme){const ee=await this.getAsset(B.assets.readme,{},J);return await(0,M.asText)(ee)||""}return""}async getManifest(B,J){if(B.assets.manifest){const ee=await this.getAsset(B.assets.manifest,{},J),oe=await(0,M.asText)(ee);return oe?JSON.parse(oe):null}return null}async getManifestFromRawExtensionVersion(B,J){const ee=V(B,u.Manifest);if(!ee)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},x=await this.getAsset(ee,{headers:oe});return await(0,M.asJson)(x)}async getCoreTranslation(B,J){const ee=B.assets.coreTranslations.filter(oe=>oe[0]===J.toUpperCase())[0];if(ee){const oe=await this.getAsset(ee[1]),x=await(0,M.asText)(oe);return x?JSON.parse(x):null}return null}async getChangelog(B,J){if(B.assets.changelog){const ee=await this.getAsset(B.assets.changelog,{},J);return await(0,M.asText)(ee)||""}return""}async getAllCompatibleVersions(B,J,ee){let oe=new R().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?oe=oe.withFilter(s.ExtensionId,B.identifier.uuid):oe=oe.withFilter(s.ExtensionName,B.identifier.id);const{galleryExtensions:x}=await this.queryGallery(oe,ee,n.CancellationToken.None);if(!x.length)return[];const ce=G(x[0]);if((0,p.isNotWebExtensionInWebTargetPlatform)(ce,ee))return[];const le=[];for(const ue of x[0].versions)try{le[le.length-1]?.version!==ue.version&&await this.isRawExtensionVersionCompatible(ue,J,ce,ee)&&le.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:q(ue)})}catch{}return le}async getAsset(B,J={},ee=n.CancellationToken.None){const oe=await this.commonHeadersPromise,x={type:"GET"},ce={...oe,...J.headers||{}};J={...J,...x,headers:ce};const le=B.uri,ue=B.fallbackUri,me={...J,url:le};try{const Ee=await this.requestService.request(me,ee);if(Ee.res.statusCode===200)return Ee;const de=await(0,M.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${de}`)}catch(Ee){if((0,D.isPromiseCanceledError)(Ee))throw Ee;const de=(0,D.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:de});const ge={...J,url:ue};return this.requestService.request(ge,ee)}}async getEngine(B){let J=H(B);if(!J){const ee=await this.getManifestFromRawExtensionVersion(B,n.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");J=ee.engines.vscode}return J}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const B=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const J=await(0,M.asJson)(B),ee=[],oe={};if(J){for(const x of J.malicious)ee.push({id:x});if(J.unsupported)for(const x of Object.keys(J.unsupported)){const ce=J.unsupported[x];(0,f.isBoolean)(ce)||(oe[x.toLowerCase()]=ce.preReleaseExtension)}}return{malicious:ee,unsupportedPreReleaseExtensions:oe}}};W=fe([re(1,M.IRequestService),re(2,S.ILogService),re(3,I.IEnvironmentService),re(4,l.ITelemetryService),re(5,g.IFileService),re(6,w.IProductService),re(7,b.IConfigurationService)],W);let A=class extends W{constructor(B,J,ee,oe,x,ce,le,ue){super(B,J,ee,oe,x,ce,le,ue)}};A=fe([re(0,a.IStorageService),re(1,M.IRequestService),re(2,S.ILogService),re(3,I.IEnvironmentService),re(4,l.ITelemetryService),re(5,g.IFileService),re(6,w.IProductService),re(7,b.IConfigurationService)],A),e.ExtensionGalleryService=A;let _=class extends W{constructor(B,J,ee,oe,x,ce,le){super(void 0,B,J,ee,oe,x,ce,le)}};_=fe([re(0,M.IRequestService),re(1,S.ILogService),re(2,I.IEnvironmentService),re(3,l.ITelemetryService),re(4,g.IFileService),re(5,w.IProductService),re(6,b.IConfigurationService)],_),e.ExtensionGalleryServiceWithNoStorageService=_;async function U(O,B,J,ee,oe,x){const ce={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${B.nameShort})`},le=await(0,c.getServiceMachineId)(J,oe,x);return(0,o.supportsTelemetry)(B,J)&&(0,o.getTelemetryLevel)(ee)===3&&(ce["X-Market-User-Id"]=le),ce}e.resolveMarketplaceHeaders=U}),define(te[208],ie([0,1,2,47,3,25,154,19,57,55,40,29,65]),function(K,e,v,n,D,C,k,P,f,m,b,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(S,w){this._configurationService=w,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties||Promise.resolve({}),this._piiPaths=S.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let M of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(M),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(M=>{const c=/^[a-f0-9]+$/i.test(M["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!c})})}setExperimentProperty(S,w){this._experimentProperties[S]=w}_updateTelemetryLevel(){this._telemetryLevel=(0,p.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const S=await this._commonProperties;let w=S.sessionID,M=S["common.machineId"],c=S["common.firstSessionDate"],a=S["common.msftInternal"];return{sessionId:w,machineId:M,firstSessionDate:c,msftInternal:a}}dispose(){this._disposables.dispose()}_log(S,w,M,c){return this.telemetryLevel<w?Promise.resolve(void 0):this._commonProperties.then(a=>{M=(0,n.mixin)(M,a),M=(0,n.mixin)(M,this._experimentProperties),M=(0,n.cloneAndChange)(M,l=>{if(typeof l=="string")return this._cleanupInfo(l,c)}),this._appenders.forEach(l=>l.log(S,M))},a=>{console.error(a)})}publicLog(S,w,M){return this._log(S,3,w,M)}publicLog2(S,w,M){return this.publicLog(S,w,M)}publicLogError(S,w){return this.sendErrorTelemetry?this._log(S,2,w,!0):Promise.resolve(void 0)}publicLogError2(S,w){return this.publicLogError(S,w)}_anonymizeFilePaths(S){let w=S;const M=[];for(let o of this._cleanupPatterns)for(;;){const h=o.exec(S);if(!h)break;M.push([h.index,o.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(w="";;){const o=a.exec(S);if(!o)break;!c.test(o[0])&&M.every(([h,r])=>o.index<h||o.index>=r)&&(w+=S.substring(l,o.index)+"<REDACTED: user-file-path>",l=a.lastIndex)}return l<S.length&&(w+=S.substr(l)),w}_removePropertiesWithPossibleUserInfo(S){if(!S)return S;const w=S.toLowerCase(),M=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(w)?"<REDACTED: secret>":M.test(w)?"<REDACTED: email>":S}_cleanupInfo(S,w){let M=S;w&&(M=this._anonymizeFilePaths(M));for(let c of this._cleanupPatterns)M=M.replace(c,"");return M=this._removePropertiesWithPossibleUserInfo(M),M}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=fe([re(1,P.IConfigurationService)],y),e.TelemetryService=y;function t(){const g=(0,k.localize)(0,null,m.default.nameLong),S=m.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=D.isWeb?"":(0,k.localize)(3,null),M=(0,k.localize)(4,null),c=(0,k.localize)(5,null),a=(0,k.localize)(6,null),l=(0,k.localize)(7,null),o=`
|       | ${M} | ${c} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,h=(0,k.localize)(8,null);return`
${g} ${S} ${w}

&nbsp;

${l}
${o}

&nbsp;

${h}
`}b.Registry.as(f.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(f.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,k.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,k.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[209],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(te[210],ie([0,1,103,4,2,5,40,209]),function(K,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var f;(function(S){function w(M){return M&&typeof M=="object"&&typeof M.id=="string"}S.isThemeColor=w})(f=e.ThemeColor||(e.ThemeColor={}));function m(S){return{id:S}}e.themeColorFromId=m;var b;(function(S){function w(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||f.isThemeColor(i.color))}S.isThemeIcon=w;const M=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function c(i){const s=M.exec(i);if(!s)return;let[,u]=s;return{id:u}}S.fromString=c;function a(i){return{id:i}}S.fromId=a;function l(i,s){let u=i.id;const d=u.lastIndexOf("~");return d!==-1&&(u=u.substring(0,d)),s&&(u=`${u}~${s}`),{id:u}}S.modify=l;function o(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}S.getModifier=o;function h(i,s){return i.id===s.id&&i.color?.id===s.color?.id}S.isEqual=h;function r(i,s){return{id:i.id,color:s?m(s):void 0}}S.asThemeIcon=r,S.asClassNameArray=v.CSSIcon.asClassNameArray,S.asClassName=v.CSSIcon.asClassName,S.asCSSSelector=v.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function I(S){switch(S){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,D.toDisposable)(()=>{const M=this.themingParticipants.indexOf(w);this.themingParticipants.splice(M,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new p;k.Registry.add(e.Extensions.ThemingContribution,y);function t(S){return y.onColorThemeChange(S)}e.registerThemingParticipant=t;class g extends D.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(M=>this.onThemeChange(M)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,M){let c=this.theme.getColor(w);return c&&M&&(c=M(c,this.theme)),c?c.toString():null}}e.Themable=g}),define(te[66],ie([0,1,14,3,5,38]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const k="#FFFFFF",P="#1E1E1E",f="#000000",m="theme",b="themeBackground",I="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let p=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((n.isWindows||n.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return f;let t=this.stateMainService.getItem(b,null);if(!t){let g;(n.isWindows||n.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(m,"vs-dark").split(" ")[0],t=g==="hc-black"?f:g==="vs"?k:P}return n.isMacintosh&&t.toUpperCase()===P&&(t="#171717"),t}saveWindowSplash(t,g){this.stateMainService.setItems([{key:m,data:g.baseTheme},{key:b,data:g.colorInfo.background},{key:I,data:g}]),typeof t=="number"&&this.updateBackgroundColor(t,g)}updateBackgroundColor(t,g){for(const S of v.BrowserWindow.getAllWindows())if(S.id===t){S.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};p=fe([re(0,C.IStateMainService)],p),e.ThemeMainService=p}),define(te[41],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var n;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(n=e.StateType||(e.StateType={}));var D;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,k)=>({type:"idle",updateType:C,error:k}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(te[211],ie([0,1,3,155,57,40]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,n.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,n.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,n.localize)(2,null),(0,n.localize)(3,null),(0,n.localize)(4,null),(0,n.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,n.localize)(6,null),deprecationMessage:(0,n.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,n.localize)(8,null),description:(0,n.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,n.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[212],ie([0,1,4,41]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(P){this.service=P}listen(P,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(P,f,m){switch(f){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=D;class C{constructor(P){this.channel=P,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=n.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(P){this._state=P,this._onStateChange.fire(P)}checkForUpdates(P){return this.channel.call("checkForUpdates",P)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=C}),define(te[98],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(te[213],ie([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class n{constructor(P){this.handler=P}listen(P,f){throw new Error(`Event not found: ${f}`)}call(P,f,m){switch(f){case"handleURL":return this.handler.handleURL(v.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=n;class D{constructor(P){this.channel=P}handleURL(P,f){return this.channel.call("handleURL",[P.toJSON(),f])}}e.URLHandlerChannelClient=D;class C{constructor(P){this.next=P}async routeCall(P,f,m,b){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(m){const I=v.URI.revive(m);if(I&&I.query){const p=/\bwindowId=(\d+)/.exec(I.query);if(p){const y=p[1],t=new RegExp(`window:${y}`),g=P.connections.find(S=>t.test(S.ctx));if(g)return g}}}return this.next.routeCall(P,f,m,b)}routeEvent(P,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=C}),define(te[214],ie([0,1,8,2,7,22]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class k extends n.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(m,b){const I=[...this.handlers.values()];return(0,v.first)(I.map(p=>()=>p.handleURL(m,b)),void 0,!1).then(p=>p||!1)}registerHandler(m){return this.handlers.add(m),(0,n.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=k;let P=class extends k{constructor(m){super();this.productService=m}create(m){let{authority:b,path:I,query:p,fragment:y}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&I&&I.indexOf("/")!==0&&(I=`/${I}`),D.URI.from({scheme:this.productService.urlProtocol,authority:b,path:I,query:p,fragment:y})}};P=fe([re(0,C.IProductService)],P),e.NativeURLService=P}),define(te[215],ie([0,1,14,8,4,2,3,7]),function(K,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(b){try{return P.URI.parse(b)}catch{return null}}class m{constructor(I,p,y,t,g){if(this.urlService=p,this.uris=[],this.retryCount=0,this.flushDisposable=C.Disposable.None,this.disposables=new C.DisposableStore,this.uris=I,k.isWindows){const M=t.isBuilt?[]:[`"${t.appRoot}"`];M.push("--open-url","--"),v.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,M)}const S=D.Event.map(D.Event.fromNodeEventEmitter(v.app,"open-url",(M,c)=>({event:M,url:c})),({event:M,url:c})=>(M.preventDefault(),c));this.disposables.add(S(M=>{const c=f(M);!c||this.urlService.open(c,{originalUrl:M})})),y.getWindows().filter(M=>M.isReady).length>0?this.flush():D.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const p of this.uris)await this.urlService.open(p.uri,{originalUrl:p.url})||I.push(p);I.length!==0&&(this.uris=I,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(te[216],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(te[217],ie([0,1,14,2,10,7]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class k extends n.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(D.Schemas.vscodeWebview,f)}handleWebviewRequest(f,m){try{const b=C.URI.parse(f.url),I=k.validWebviewFilePaths.get(b.path);if(typeof I=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${I}`,y=D.FileAccess.asFileUri(p,K);return m(decodeURIComponent(y.fsPath))}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=k,k.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(te[67],ie([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(m){return!!m.workspaceUri}e.isWorkspaceToOpen=n;function D(m){return!!m.folderUri}e.isFolderToOpen=D;function C(m){return!!m.fileUri}e.isFileToOpen=C;function k(m){const b=P(m),I=m.getValue("window.menuBarVisibility");return I==="default"||b==="native"&&I==="compact"||v.isMacintosh&&v.isNative?"classic":I}e.getMenuBarVisibility=k;function P(m){if(v.isWeb)return"custom";const b=m.getValue("window");if(b){if(v.isMacintosh&&b.nativeTabs===!0||v.isMacintosh&&b.nativeFullScreen===!1)return"native";const y=m.getValue("workbench.colorCustomizations");if(y?.["window.activeBorder"]||y?.["window.inactiveBorder"])return"custom";const t=b.titleBarStyle;if(t==="native"||t==="custom")return t}return v.isLinux?"native":"custom"}e.getTitleBarStyle=P;function f(m=0){return Math.pow(1.2,m)}e.zoomLevelToZoomFactor=f}),define(te[36],ie([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var n;(function(m){m[m.INITIAL=1]="INITIAL",m[m.LOAD=2]="LOAD",m[m.RELOAD=3]="RELOAD"})(n=e.LoadReason||(e.LoadReason={}));var D;(function(m){m[m.CLOSE=1]="CLOSE",m[m.QUIT=2]="QUIT",m[m.RELOAD=3]="RELOAD",m[m.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var C;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})(C=e.OpenContext||(e.OpenContext={}));const k=function(m=1){return{width:1024,height:768,mode:m}};e.defaultWindowState=k;var P;(function(m){m[m.Maximized=0]="Maximized",m[m.Normal=1]="Normal",m[m.Minimized=2]="Minimized",m[m.Fullscreen=3]="Fullscreen"})(P=e.WindowMode||(e.WindowMode={}));var f;(function(m){m[m.UNRESPONSIVE=1]="UNRESPONSIVE",m[m.CRASHED=2]="CRASHED",m[m.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(te[218],ie([0,1,14,4,2,217,36]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends D.Disposable{constructor(m){super();this.windowsMainService=m,this._onFoundInFrame=this._register(new n.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,b){let I;if(typeof m.windowId=="number"){const{windowId:p}=m,y=this.windowsMainService.getWindowById(p);if(!y?.win)throw new Error(`Invalid windowId: ${p}`);I=y.win.webContents}else{const{webContentsId:p}=m;if(I=v.webContents.fromId(p),!I)throw new Error(`Invalid webContentsId: ${p}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(b)}async findInFrame(m,b,I,p){const y=this.getFrameByName(m,b),t=y;if(typeof t.findInFrame=="function"){t.findInFrame(I,{findNext:p.findNext,forward:p.forward});const g=(S,w)=>{w.finalUpdate&&(this._onFoundInFrame.fire(w),y.removeListener("found-in-frame",g))};y.on("found-in-frame",g)}}async stopFindInFrame(m,b,I){const y=this.getFrameByName(m,b);typeof y.stopFindInFrame=="function"&&y.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,b){const I=this.windowsMainService.getWindowById(m.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${m}`);const p=I.win.webContents.mainFrame.framesInSubtree.find(y=>y.name===b);if(!p)throw new Error(`Unknown frame: ${b}`);return p}};P=fe([re(0,k.IWindowsMainService)],P),e.WebviewMainService=P}),define(te[219],ie([0,1,8,4,2]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:f,getActiveWindowId:m}){super();this.disposables=this._register(new D.DisposableStore),n.Event.latch(n.Event.any(P,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>m()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=C}),define(te[220],ie([0,1,35,16,7,5]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var k;(function(p){p[p.EMPTY=1]="EMPTY",p[p.FOLDER=2]="FOLDER",p[p.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function P(p){const y=p;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=P;function f(p){const y=p;return!!(y&&typeof y=="object"&&D.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=f;class m{constructor(y,t,g,S,w){this._id=y,this._transient=g,this._configuration=S,this._ignorePathCasing=w,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(y){this._id=y.id,this._configuration=y.configuration,this._transient=y.transient,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class b{constructor(y,t){this.raw=t,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,n.joinPath)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=b;function I(p){return new b({uri:p,index:0,name:(0,n.basenameOrAuthority)(p)},{uri:p.toString()})}e.toWorkspaceFolder=I}),define(te[30],ie([0,1,27,43,105,33,10,9,3,16,7,158,5,64,220]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(q){return(typeof q=="string"?(0,P.extname)(q):(0,m.extname)(q))===g}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,p.createDecorator)("workspacesService");function w(q){return q.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function M(q){return q.hasOwnProperty("folderUri")}e.isRecentFolder=M;function c(q){return q.hasOwnProperty("fileUri")}e.isRecentFile=c;function a(q){return q&&q.hasOwnProperty("folderUri")}e.isFolderBackupInfo=a;function l(q){return q&&q.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=l;function o(q){const Y=q;return typeof Y?.id=="string"&&b.URI.isUri(Y.uri)}e.isSingleFolderWorkspaceIdentifier=o;function h(q){if(q.configuration)return{id:q.id,configPath:q.configuration};if(q.folders.length===1)return{id:q.id,uri:q.folders[0].uri}}e.toWorkspaceIdentifier=h;function r(q){const Y=q;return typeof Y?.id=="string"&&b.URI.isUri(Y.configPath)}e.isWorkspaceIdentifier=r;function i(q){const Y=q;if(Y?.uri)return{id:Y.id,uri:b.URI.revive(Y.uri)};const j=q;if(j?.configPath)return{id:j.id,configPath:b.URI.revive(j.configPath)};if(q?.id)return{id:q.id}}e.reviveIdentifier=i;function s(q,Y){return m.extUriBiasedIgnorePathCase.isEqualOrParent(q,Y.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function u(q){return d(q)||E(q)}e.isStoredWorkspaceFolder=u;function d(q){const Y=q;return typeof Y?.path=="string"&&(!Y.name||typeof Y.name=="string")}e.isRawFileWorkspaceFolder=d;function E(q){const Y=q;return typeof Y?.uri=="string"&&(!Y.name||typeof Y.name=="string")}e.isRawUriWorkspaceFolder=E;function L(q,Y,j,z,G=!f.isWindows,$){if(q.scheme!==z.scheme)return{name:j,uri:q.toString(!0)};let F=Y?void 0:$.relativePath(z,q);if(F!==void 0)F.length===0?F=".":f.isWindows&&q.scheme===k.Schemas.file&&!G&&(F=F.replace(/\//g,"\\"));else if(q.scheme===k.Schemas.file)F=q.fsPath,f.isWindows&&(F=(0,C.normalizeDriveLetter)(F),G&&(F=(0,v.toSlashes)(F)));else{if(!$.isEqualAuthority(q.authority,z.authority))return{name:j,uri:q.toString(!0)};F=q.path}return{name:j,path:F}}e.getStoredWorkspaceFolder=L;function R(q,Y,j){let z=[],G=new Set;const $=j.dirname(Y);for(let F of q){let W;if(d(F))F.path&&(W=j.resolvePath($,F.path));else if(E(F))try{W=b.URI.parse(F.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(A){console.warn(A)}if(W){let A=j.getComparisonKey(W);if(!G.has(A)){G.add(A);const _=F.name||j.basenameOrAuthority(W);z.push(new t.WorkspaceFolder({uri:W,name:_,index:z.length},F))}}}return z}e.toWorkspaceFolders=R;function T(q,Y,j,z,G){let $=N(Y,q);const F=G.dirname(Y),W=G.dirname(z),A=[],_=Q($.folders);for(const J of $.folders){const ee=d(J)?G.resolvePath(F,J.path):b.URI.parse(J.uri);let oe;j?oe=!1:oe=!d(J)||(0,P.isAbsolute)(J.path),A.push(L(ee,oe,J.name,W,_,G))}const U={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},O=D.setProperty(q,["folders"],A,U);let B=D.applyEdits(q,O);return(0,m.isEqualAuthority)($.remoteAuthority,(0,y.getRemoteAuthority)(z))&&(B=D.applyEdits(B,D.removeProperty(B,["remoteAuthority"],U))),B}e.rewriteWorkspaceFileForNewLocation=T;function N(q,Y){let j=n.parse(Y);if(j&&Array.isArray(j.folders))j.folders=j.folders.filter(z=>u(z));else throw new Error(`${q} looks like an invalid workspace file.`);return j}function Q(q){return f.isWindows?q.some(Y=>d(Y)&&Y.path.indexOf("/")>=0):!0}e.useSlashForPath=Q;function se(q){return q.workspace&&typeof q.workspace=="object"&&typeof q.workspace.id=="string"&&typeof q.workspace.configPath=="string"}function ne(q){return typeof q.folderUri=="string"}function V(q){return typeof q.fileUri=="string"}function Z(q,Y){const j={workspaces:[],files:[]};if(q){const z=function($,F){for(let W=0;W<$.length;W++)try{F($[W],W)}catch(A){Y.warn(`Error restoring recent entry ${JSON.stringify($[W])}: ${A.toString()}. Skip entry.`)}},G=q;if(Array.isArray(G.entries))z(G.entries,$=>{const F=$.label,W=$.remoteAuthority;se($)?j.workspaces.push({label:F,remoteAuthority:W,workspace:{id:$.workspace.id,configPath:b.URI.parse($.workspace.configPath)}}):ne($)?j.workspaces.push({label:F,remoteAuthority:W,folderUri:b.URI.parse($.folderUri)}):V($)&&j.files.push({label:F,remoteAuthority:W,fileUri:b.URI.parse($.fileUri)})});else{const $=q;Array.isArray($.workspaces3)&&z($.workspaces3,(F,W)=>{const A=Array.isArray($.workspaceLabels)&&$.workspaceLabels[W]||void 0;typeof F=="object"&&typeof F.id=="string"&&typeof F.configURIPath=="string"?j.workspaces.push({label:A,workspace:{id:F.id,configPath:b.URI.parse(F.configURIPath)}}):typeof F=="string"&&j.workspaces.push({label:A,folderUri:b.URI.parse(F)})}),Array.isArray($.files2)&&z($.files2,(F,W)=>{const A=Array.isArray($.fileLabels)&&$.fileLabels[W]||void 0;typeof F=="string"&&j.files.push({label:A,fileUri:b.URI.parse(F)})})}}return j}e.restoreRecentlyOpened=Z;function H(q){const Y={entries:[]};for(const j of q.workspaces)M(j)?Y.entries.push({folderUri:j.folderUri.toString(),label:j.label,remoteAuthority:j.remoteAuthority}):Y.entries.push({workspace:{id:j.workspace.id,configPath:j.workspace.configPath.toString()},label:j.label,remoteAuthority:j.remoteAuthority});for(const j of q.files)Y.entries.push({fileUri:j.fileUri.toString(),label:j.label,remoteAuthority:j.remoteAuthority});return Y}e.toStoreData=H}),define(te[49],ie([0,1,14,8,82,33,2,70,9,3,13,24,138,5,6,38,30]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let w=class yt{constructor(c,a){this.stateMainService=c,this.logService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new n.Queue}pickFileFolder(c,a){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,p.localize)(0,null)},a)}pickFolder(c,a){return this.doPick({...c,pickFolders:!0,title:(0,p.localize)(1,null)},a)}pickFile(c,a){return this.doPick({...c,pickFiles:!0,title:(0,p.localize)(2,null)},a)}pickWorkspace(c,a){const l=(0,p.localize)(3,null),o=(0,C.mnemonicButtonLabel)((0,p.localize)(4,null)),h=S.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:l,filters:h,buttonLabel:o},a)}async doPick(c,a){const l={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};l.defaultPath=c.defaultPath||this.stateMainService.getItem(yt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(l.properties=void 0,c.pickFiles&&c.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),m.isMacintosh&&l.properties.push("treatPackageAsDirectory");const o=a||v.BrowserWindow.getFocusedWindow(),h=await this.showOpenDialog(l,(0,b.withNullAsUndefined)(o));if(h&&h.filePaths&&h.filePaths.length>0)return this.stateMainService.setItem(yt.workingDirPickerStorageKey,(0,f.dirname)(h.filePaths[0])),h.filePaths}getWindowDialogQueue(c){if(c){let a=this.windowDialogQueues.get(c.id);return a||(a=new n.Queue,this.windowDialogQueues.set(c.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(c,a){return this.getWindowDialogQueue(a).queue(async()=>a?v.dialog.showMessageBox(a,c):v.dialog.showMessageBox(c))}async showSaveDialog(c,a){const l=this.acquireFileDialogLock(c,a);if(!l)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let o;return a?o=await v.dialog.showSaveDialog(a,c):o=await v.dialog.showSaveDialog(c),o.filePath=this.normalizePath(o.filePath),o})}finally{(0,k.dispose)(l)}}normalizePath(c){return c&&m.isMacintosh&&(c=(0,P.normalizeNFC)(c)),c}normalizePaths(c){return c.map(a=>this.normalizePath(a))}async showOpenDialog(c,a){c.defaultPath&&(await I.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const l=this.acquireFileDialogLock(c,a);if(!l)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let o;return a?o=await v.dialog.showOpenDialog(a,c):o=await v.dialog.showOpenDialog(c),o.filePaths=this.normalizePaths(o.filePaths),o})}finally{(0,k.dispose)(l)}}acquireFileDialogLock(c,a){if(!a)return k.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",c);let l=this.windowFileDialogLocks.get(a.id);l||(l=new Set,this.windowFileDialogLocks.set(a.id,l));const o=(0,D.hash)(c);if(!l.has(o))return this.logService.trace("[DialogMainService]: new file dialog lock created",c),l.add(o),(0,k.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",c),l?.delete(o),l?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};w.workingDirPickerStorageKey="pickerWorkingDir",w=fe([re(0,g.IStateMainService),re(1,t.ILogService)],w),e.DialogMainService=w}),define(te[221],ie([0,1,4,2,30]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends n.Disposable{constructor(P,f){super();this.logService=P,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(P,f)=>(P?P.push(f):P=[f],P),C.STORAGE_CHANGE_DEBOUNCE_TIME)(P=>{P.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(P))}))}serializeGlobalStorageEvents(P){const f=new Map,m=new Set;return P.forEach(b=>{const I=this.storageMainService.globalStorage.get(b.key);typeof I=="string"?f.set(b.key,I):m.add(b.key)}),{changed:Array.from(f.entries()),deleted:Array.from(m.values())}}listen(P,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(P,f,m){const b=(0,D.reviveIdentifier)(m.workspace),I=await this.withStorageInitialized(b);switch(f){case"getItems":return Array.from(I.items.entries());case"updateItems":{const p=m;if(p.insert)for(const[y,t]of p.insert)I.set(y,t);p.delete&&p.delete.forEach(y=>I.delete(y));break}case"close":{if(b)return I.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(P){const f=P?this.storageMainService.workspaceStorage(P):this.storageMainService.globalStorage;try{await f.init()}catch(m){this.logService.error(`StorageIPC#init: Unable to init ${P?"workspace":"global"} storage due to ${m}`)}return f}}e.StorageDatabaseChannel=C,C.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(te[222],ie([0,1,8,4,2,9,24,87,127,6,77,29,30]),function(K,e,v,n,D,C,k,P,f,m,b,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends D.Disposable{constructor(w){super();this.logService=w,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new P.Storage(new P.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new v.DeferredPromise,this.whenInit=this.whenInitPromise.p}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const w=await this.doCreate();this._storage.dispose(),this._storage=w,this._register(w.onDidChangeStorage(c=>this._onDidChangeStorage.fire({key:c}))),await this.doInit(w);const M=w.getBoolean(b.IS_NEW_KEY);M===void 0?w.set(b.IS_NEW_KEY,!0):M&&w.set(b.IS_NEW_KEY,!1)}catch(w){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${w}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===m.LogLevel.Trace?w=>this.logService.trace(w):void 0,logError:w=>this.logService.error(w)}}doInit(w){return w.init()}get items(){return this._storage.items}get(w,M){return this._storage.get(w,M)}set(w,M){return this._storage.set(w,M)}delete(w){return this._storage.delete(w)}async close(){this.initializePromise&&await this.initializePromise,await this._storage.close(),this._onDidCloseStorage.fire()}}class t extends y{constructor(w,M,c){super(M);this.options=w,this.environmentService=c}async doCreate(){let w;return this.options.useInMemoryStorage?w=f.SQLiteStorageDatabase.IN_MEMORY_PATH:w=(0,C.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new P.Storage(new f.SQLiteStorageDatabase(w,{logging:this.createLoggingOptions()}))}async doInit(w){await super.doInit(w),this.updateTelemetryState(w)}updateTelemetryState(w){w.get(I.firstSessionDateStorageKey,void 0)===void 0&&w.set(I.firstSessionDateStorageKey,new Date().toUTCString());const c=w.get(I.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();w.set(I.lastSessionDateStorageKey,typeof c=="undefined"?null:c),w.set(I.currentSessionDateStorageKey,a)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class g extends y{constructor(w,M,c,a){super(c);this.workspace=w,this.options=M,this.environmentService=a}async doCreate(){const{storageFilePath:w,wasCreated:M}=await this.prepareWorkspaceStorageFolder();return new P.Storage(new f.SQLiteStorageDatabase(w,{logging:this.createLoggingOptions()}),{hint:M?P.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const w=(0,C.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),M=(0,C.join)(w,g.WORKSPACE_STORAGE_NAME);return await k.Promises.exists(w)?{storageFilePath:M,wasCreated:!1}:(await k.Promises.mkdir(w,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(w),{storageFilePath:M,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(w){let M;if((0,p.isSingleFolderWorkspaceIdentifier)(this.workspace)?M={folder:this.workspace.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.workspace)&&(M={workspace:this.workspace.configPath.toString()}),M)try{const c=(0,C.join)(w,g.WORKSPACE_META_NAME);await k.Promises.exists(c)||await k.Promises.writeFile(c,JSON.stringify(M,void 0,2))}catch(c){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${c}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(te[99],ie([0,1,16,7,30]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function C(f,m,b){for(const p of f){const y=p.openedWorkspace;if((0,D.isWorkspaceIdentifier)(y)){const t=b(y);if(t){if(t.folders.some(g=>v.extUriBiasedIgnorePathCase.isEqualOrParent(m,g.uri)))return p}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(m,y.configPath))return p}}const I=f.filter(p=>(0,D.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(m,p.openedWorkspace.uri));if(I.length)return I.sort((p,y)=>-(p.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function k(f,m){for(const b of f)if((0,D.isWorkspaceIdentifier)(b.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,m)||(0,D.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,m))return b}e.findWindowOnWorkspaceOrFolder=k;function P(f,m){const b=I=>m.some(p=>v.extUriBiasedIgnorePathCase.isEqual(n.URI.file(p),n.URI.file(I)));for(const I of f)if(I.config?.extensionDevelopmentPath?.some(p=>b(p)))return I}e.findWindowOnExtensionDevelopmentPath=P}),define(te[223],ie([0,1,14,2,3,16,7,19,20,6,38,36,30]),function(K,e,v,n,D,C,k,P,f,m,b,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class St extends n.Disposable{constructor(c,a,l,o,h){super();this.windowsMainService=c,this.stateMainService=a,this.lifecycleMainService=l,this.logService=o,this.configurationService=h,this._state=t(this.stateMainService.getItem(St.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let o=this.windowsMainService.getLastActiveWindow();(!o||o.isExtensionDevelopmentHost)&&(o=this.windowsMainService.getWindows().find(h=>!h.isExtensionDevelopmentHost)),o&&(c.lastActiveWindow=this.toWindowState(o))}const a=this.windowsMainService.getWindows().find(o=>o.isExtensionDevelopmentHost&&!o.isExtensionTestHost);a&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(o=>!o.isExtensionDevelopmentHost).map(o=>this.toWindowState(o)));const l=S(c);this.stateMainService.setItem(St.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(c){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(l=>{const o=(0,p.isWorkspaceIdentifier)(c.openedWorkspace)&&l.workspace?.id===c.openedWorkspace.id,h=(0,p.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&l.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(l.folderUri,c.openedWorkspace.uri);(o||h)&&(l.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(c){return{workspace:(0,p.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,p.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const a=this.doGetNewWindowState(c),l=this.configurationService.getValue("window");let o;return a.hasDefaultState?o=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):(o=!!(this.lifecycleMainService.wasRestarted||l?.restoreFullscreen),o&&D.isMacintosh&&this.windowsMainService.getWindows().some(h=>h.isFullScreen)&&(o=!1)),a.mode===3&&!o&&(a.mode=1),a}doGetNewWindowState(c){const a=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const s=c.workspace;if((0,p.isWorkspaceIdentifier)(s)){const d=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===s.id).map(E=>E.uiState);if(d.length)return d[0]}if((0,p.isSingleFolderWorkspaceIdentifier)(s)){const d=this.state.openedWindows.filter(E=>E.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(E.folderUri,s.uri)).map(E=>E.uiState);if(d.length)return d[0]}else if(c.backupPath){const d=this.state.openedWindows.filter(E=>E.backupPath===c.backupPath).map(E=>E.uiState);if(d.length)return d[0]}const u=this.lastClosedState||this.state.lastActiveWindow;if(!a&&u)return u.uiState}let l;const o=v.screen.getAllDisplays();if(o.length===1)l=o[0];else{if(D.isMacintosh){const s=v.screen.getCursorScreenPoint();l=v.screen.getDisplayNearestPoint(s)}!l&&a&&(l=v.screen.getDisplayMatching(a.getBounds())),l||(l=v.screen.getPrimaryDisplay()||o[0])}let h=(0,I.defaultWindowState)();h.x=Math.round(l.bounds.x+l.bounds.width/2-h.width/2),h.y=Math.round(l.bounds.y+l.bounds.height/2-h.height/2);const r=this.configurationService.getValue("window");let i=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")h.mode=0,i=!1;else if(r.newWindowDimensions==="fullscreen")h.mode=3,i=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&a){const s=a.serializeWindowState();s.mode===3?h.mode=3:h=s,i=h.mode!==3&&r.newWindowDimensions==="offset"}}return i&&(h=this.ensureNoOverlap(h)),h.hasDefaultState=!0,h}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const a=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;a.some(l=>l.x===c.x||l.y===c.y);)c.x+=30,c.y+=30;return c}};y.windowsStateStorageKey="windowsState",y=fe([re(0,I.IWindowsMainService),re(1,b.IStateMainService),re(2,f.ILifecycleMainService),re(3,m.ILogService),re(4,P.IConfigurationService)],y),e.WindowsStateHandler=y;function t(M){const c={openedWindows:[]},a=M||{openedWindows:[]};return a.lastActiveWindow&&(c.lastActiveWindow=g(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=g(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(c.openedWindows=a.openedWindows.map(l=>g(l))),c}e.restoreWindowsState=t;function g(M){const c={uiState:M.uiState};return M.backupPath&&(c.backupPath=M.backupPath),M.remoteAuthority&&(c.remoteAuthority=M.remoteAuthority),M.folder&&(c.folderUri=k.URI.parse(M.folder)),M.workspaceIdentifier&&(c.workspace={id:M.workspaceIdentifier.id,configPath:k.URI.parse(M.workspaceIdentifier.configURIPath)}),c}function S(M){return{lastActiveWindow:M.lastActiveWindow&&w(M.lastActiveWindow),lastPluginDevelopmentHostWindow:M.lastPluginDevelopmentHostWindow&&w(M.lastPluginDevelopmentHostWindow),openedWindows:M.openedWindows.map(c=>w(c))}}e.getWindowsStateStoreData=S;function w(M){return{workspaceIdentifier:M.workspace&&{id:M.workspace.id,configURIPath:M.workspace.configPath.toString()},folder:M.folderUri&&M.folderUri.toString(),backupPath:M.backupPath,remoteAuthority:M.remoteAuthority,uiState:M.uiState}}}),define(te[100],ie([0,1,60,28,10,3,16]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function P(m){function b(){let I=m.scheme===D.Schemas.file?(0,k.originalFSPath)(m):m.toString();return C.isLinux||(I=I.toLowerCase()),(0,v.createHash)("md5").update(I).digest("hex")}return{id:b(),configPath:m}}e.getWorkspaceIdentifier=P;function f(m,b){function I(){if(m.scheme!==D.Schemas.file)return(0,v.createHash)("md5").update(m.toString()).digest("hex");if(!b)try{b=(0,n.statSync)(m.fsPath)}catch{return}let y;return C.isLinux?y=b.ino:C.isMacintosh?y=b.birthtime.getTime():C.isWindows&&(typeof b.birthtimeMs=="number"?y=Math.floor(b.birthtimeMs):y=b.birthtime.getTime()),(0,v.createHash)("md5").update(m.fsPath).update(y?String(y):"").digest("hex")}const p=I();if(typeof p=="string")return{id:p,uri:m}}e.getSingleFolderWorkspaceIdentifier=f}),define(te[224],ie([0,1,15,10,6,252,115,20]),function(K,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class f{constructor(p,y){this._worker=new C.Worker(n.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",K).fsPath),this._worker.on("message",p),this._worker.on("error",y)}getId(){return 1}postMessage(p,y){this._worker.postMessage(p,y)}dispose(){this._worker.terminate()}}let m=class{constructor(p){this._logService=p}async logInfo(p){this._logService.info(p)}};m=fe([re(0,D.ILogService)],m);let b=class{constructor(p,y){this._logService=p,this._shutdown=!1,this._proxy=null;const t={create:(g,S,w)=>{const M=new f(S,w);return M.postMessage(g,[]),M}};this._worker=new k.SimpleWorkerClient(t,"vs/platform/extensions/node/extensionHostStarterWorker",new m(this._logService)),this._initialize(),y.onWillShutdown(g=>{this._shutdown=!0,this._proxy&&g.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(p){return this._proxy.onDynamicStdout(p)}onDynamicStderr(p){return this._proxy.onDynamicStderr(p)}onDynamicMessage(p){return this._proxy.onDynamicMessage(p)}onDynamicError(p){return this._proxy.onDynamicError(p)}onDynamicExit(p){return this._proxy.onDynamicExit(p)}async createExtensionHost(){const p=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return p.createExtensionHost()}async start(p,y){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return t.start(p,y)}async enableInspectPort(p){const y=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return y.enableInspectPort(p)}async kill(p){const y=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return y.kill(p)}};b=fe([re(0,D.ILogService),re(1,P.ILifecycleMainService)],b),e.WorkerMainProcessExtensionHostStarter=b}),define(te[58],ie([0,1,60,61,26,17,15,4,2,9,3,32,37,85,225]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(R,T=""){this.debugLabel=T,this.socket=R,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=N=>{if(this.traceSocketEvent("error",{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,k.onUnexpectedError)(N)}},this.socket.on("error",this._errorListener)}traceSocketEvent(R,T){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,T)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(R){const T=N=>{this.traceSocketEvent("read",N),R(C.VSBuffer.wrap(N))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(R){const T=N=>{this.traceSocketEvent("close",{hadError:N}),R({type:0,hadError:N,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(R){const T=()=>{this.traceSocketEvent("nodeEndReceived"),R()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(R){if(!this.socket.destroyed)try{this.traceSocketEvent("write",R),this.socket.write(R.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((R,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),R();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent("nodeDrainEnd"),R()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.NodeSocket=g;var S;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var w;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(w||(w={}));class M extends f.Disposable{constructor(R,T,N,Q){super();this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=R,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:N?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new c(this,T,N,Q,this._onData,(se,ne)=>this._write(se,ne))),this._register(this._flowManager.onError(se=>{console.error(se),(0,k.onUnexpectedError)(se),this._onClose.fire({type:0,hadError:!0,error:se})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(se=>this._acceptChunk(se))),this._register(this.socket.onClose(se=>this._onClose.fire(se)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(R,T){this.socket.traceSocketEvent(R,T)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this._onData.event(R)}onClose(R){return this._onClose.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){this._flowManager.writeMessage(R)}_write(R,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",R);let N=2;R.byteLength<126?N+=0:R.byteLength<2**16?N+=2:N+=8;const Q=C.VSBuffer.alloc(N);if(T?Q.writeUInt8(194,0):Q.writeUInt8(130,0),R.byteLength<126)Q.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){Q.writeUInt8(126,1);let se=1;Q.writeUInt8(R.byteLength>>>8&255,++se),Q.writeUInt8(R.byteLength>>>0&255,++se)}else{Q.writeUInt8(127,1);let se=1;Q.writeUInt8(0,++se),Q.writeUInt8(0,++se),Q.writeUInt8(0,++se),Q.writeUInt8(0,++se),Q.writeUInt8(R.byteLength>>>24&255,++se),Q.writeUInt8(R.byteLength>>>16&255,++se),Q.writeUInt8(R.byteLength>>>8&255,++se),Q.writeUInt8(R.byteLength>>>0&255,++se)}this.socket.write(C.VSBuffer.concat([Q,R]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(R){if(R.byteLength!==0){for(this._incomingData.acceptChunk(R);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),N=T.readUInt8(0),Q=(N&128)>>>7,se=(N&64)>>>6,ne=T.readUInt8(1),V=(ne&128)>>>7,Z=ne&127;this._state.state=2,this._state.readLen=2+(V?4:0)+(Z===126?2:0)+(Z===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(se)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),N=T.readUInt8(1),Q=(N&128)>>>7;let se=N&127,ne=1;se===126?se=T.readUInt8(++ne)*2**8+T.readUInt8(++ne):se===127&&(se=T.readUInt8(++ne)*0+T.readUInt8(++ne)*0+T.readUInt8(++ne)*0+T.readUInt8(++ne)*0+T.readUInt8(++ne)*2**24+T.readUInt8(++ne)*2**16+T.readUInt8(++ne)*2**8+T.readUInt8(++ne));let V=0;Q&&(V=T.readUInt8(++ne)*2**24+T.readUInt8(++ne)*2**16+T.readUInt8(++ne)*2**8+T.readUInt8(++ne)),this._state.state=3,this._state.readLen=se,this._state.mask=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),o(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=M;class c extends f.Disposable{constructor(R,T,N,Q,se,ne){super();this._tracer=R,this._onData=se,this._writeFn=ne,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new a(this._tracer,Q,N,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(V=>this._onError.fire(V))),this._register(this._zlibDeflateStream.onError(V=>this._onError.fire(V)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(R){this._writeQueue.push(R),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const R=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,R);this._writeFn(T,!0)}else this._writeFn(R,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(R,T){return new Promise((N,Q)=>{R.write(T),R.flush(se=>N(se))})}acceptFrame(R,T,N){this._readQueue.push({data:R,isCompressed:T,isLastFrameOfMessage:N}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const R=this._readQueue.shift();if(this._zlibInflateStream&&R.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,R.data,R.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(R.data)}this._isProcessingReadQueue=!1}}_inflateFrame(R,T,N){return new Promise((Q,se)=>{R.write(T),N&&R.write(C.VSBuffer.fromByteArray([0,0,255,255])),R.flush(ne=>Q(ne))})}}class a extends f.Disposable{constructor(R,T,N,Q){super();this._tracer=R,this._recordInflateBytes=T,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(Q),this._zlibInflate.on("error",se=>{this._tracer.traceSocketEvent("zlibInflateError",{message:se?.message,code:se?.code}),this._onError.fire(se)}),this._zlibInflate.on("data",se=>{this._tracer.traceSocketEvent("zlibInflateData",se),this._pendingInflateData.push(C.VSBuffer.wrap(se))}),N&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",N.buffer),this._zlibInflate.write(N.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(R){this._recordInflateBytes&&this._recordedInflateBytes.push(R.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",R),this._zlibInflate.write(R.buffer)}flush(R){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,R(T)})}}class l extends f.Disposable{constructor(R,T){super();this._tracer=R,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",N=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibDeflate.on("data",N=>{this._tracer.traceSocketEvent("zlibDeflateData",N),this._pendingDeflateData.push(C.VSBuffer.wrap(N))})}write(R){this._tracer.traceSocketEvent("zlibDeflateWrite",R.buffer),this._zlibDeflate.write(R.buffer)}flush(R){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),R(T)})}}function o(L,R){if(R===0)return;let T=L.byteLength>>>2;for(let Z=0;Z<T;Z++){const H=L.readUInt32BE(Z*4);L.writeUInt32BE(H^R,Z*4)}let N=T*4,Q=L.byteLength-N;const se=R>>>24&255,ne=R>>>16&255,V=R>>>8&255;Q>=1&&L.writeUInt8(L.readUInt8(N)^se,N),Q>=2&&L.writeUInt8(L.readUInt8(N+1)^ne,N+1),Q>=3&&L.writeUInt8(L.readUInt8(N+2)^V,N+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={[2]:107,[1]:103};function r(){const L=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;let R;return e.XDG_RUNTIME_DIR?R=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${L}.sock`):R=(0,m.join)((0,D.tmpdir)(),`vscode-ipc-${L}.sock`),s(R),R}e.createRandomIPCHandle=r;function i(L,R,T){const N=(0,v.createHash)("md5").update(L).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${T}-${R}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-${N.substr(0,8)}-${T}-${R}.sock`):Q=(0,m.join)(L,`${T}-${R}.sock`),s(Q),Q}e.createStaticIPCHandle=i;function s(L){const R=h[b.platform];typeof R=="number"&&L.length>=R&&console.warn(`WARNING: IPC handle "${L}" is longer than ${R} chars, try a shorter --user-data-dir`)}class u extends p.IPCServer{constructor(R){super(u.toClientConnectionEvent(R));this.server=R}static toClientConnectionEvent(R){const T=P.Event.fromNodeEventEmitter(R,"connection");return P.Event.map(T,N=>({protocol:new y.Protocol(new g(N,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(N,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function d(L){return new Promise((R,T)=>{const N=(0,n.createServer)();N.on("error",T),N.listen(L,()=>{N.removeListener("error",T),R(new u(N))})})}e.serve=d;function E(L,R){return new Promise((T,N)=>{const Q=(0,n.createConnection)(L,()=>{Q.removeListener("error",N),T(y.Client.fromSocket(new g(Q,`ipc-client${R}`),R))});Q.once("error",N)})}e.connect=E}),define(te[226],ie([0,1,58]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class n{constructor(f){this.driver=f}listen(f,m){throw new Error("No event found")}call(f,m,b){switch(m){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(b);case"startTracing":return this.driver.startTracing(b[0],b[1]);case"stopTracing":return this.driver.stopTracing(b[0],b[1],b[2]);case"reloadWindow":return this.driver.reloadWindow(b);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(b[0],b[1]);case"click":return this.driver.click(b[0],b[1],b[2],b[3]);case"doubleClick":return this.driver.doubleClick(b[0],b[1]);case"setValue":return this.driver.setValue(b[0],b[1],b[2]);case"getTitle":return this.driver.getTitle(b[0]);case"isActiveElement":return this.driver.isActiveElement(b[0],b[1]);case"getElements":return this.driver.getElements(b[0],b[1],b[2]);case"getElementXY":return this.driver.getElementXY(b[0],b[1],b[2]);case"typeInEditor":return this.driver.typeInEditor(b[0],b[1],b[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(b[0],b[1]);case"writeInTerminal":return this.driver.writeInTerminal(b[0],b[1],b[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(b);case"getLocalizedStrings":return this.driver.getLocalizedStrings(b)}throw new Error(`Call not found: ${m}`)}}e.DriverChannel=n;class D{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}startTracing(f,m){return this.channel.call("startTracing",[f,m])}stopTracing(f,m,b){return this.channel.call("stopTracing",[f,m,b])}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,m){return this.channel.call("dispatchKeybinding",[f,m])}click(f,m,b,I){return this.channel.call("click",[f,m,b,I])}doubleClick(f,m){return this.channel.call("doubleClick",[f,m])}setValue(f,m,b){return this.channel.call("setValue",[f,m,b])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,m){return this.channel.call("isActiveElement",[f,m])}getElements(f,m,b){return this.channel.call("getElements",[f,m,b])}getElementXY(f,m,b,I){return this.channel.call("getElementXY",[f,m,b,I])}typeInEditor(f,m,b){return this.channel.call("typeInEditor",[f,m,b])}getTerminalBuffer(f,m){return this.channel.call("getTerminalBuffer",[f,m])}writeInTerminal(f,m,b){return this.channel.call("writeInTerminal",[f,m,b])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=D;class C{constructor(f){this.registry=f}listen(f,m){throw new Error(`Event not found: ${m}`)}call(f,m,b){switch(m){case"registerWindowDriver":return this.registry.registerWindowDriver(b);case"reloadWindowDriver":return this.registry.reloadWindowDriver(b)}throw new Error(`Call not found: ${m}`)}}e.WindowDriverRegistryChannel=C;async function k(P){const f=await(0,v.connect)(P,"driverClient"),m=f.getChannel("driver"),b=new D(m);return{client:f,driver:b}}e.connect=k}),define(te[23],ie([0,1,46,9,58,53,167,5]),function(K,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(C.IEnvironmentService);class f extends k.NativeEnvironmentService{get cachedLanguagesPath(){return(0,n.join)(this.userDataPath,"clp")}get backupHome(){return(0,n.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,n.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,n.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}fe([v.memoize],f.prototype,"cachedLanguagesPath",null),fe([v.memoize],f.prototype,"backupHome",null),fe([v.memoize],f.prototype,"backupWorkspacesPath",null),fe([v.memoize],f.prototype,"mainIPCHandle",null),fe([v.memoize],f.prototype,"mainLockfile",null),fe([v.memoize],f.prototype,"sandbox",null),fe([v.memoize],f.prototype,"driverVerbose",null),fe([v.memoize],f.prototype,"disableUpdates",null),fe([v.memoize],f.prototype,"disableKeytar",null),fe([v.memoize],f.prototype,"codeCachePath",null),fe([v.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(te[227],ie([0,1,60,28,27,10,9,3,16,7,24,161,19,23,18,6,30]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let w=class{constructor(c,a,l){this.configurationService=a,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(o,h)=>(0,D.isEqual)(o,h,!P.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await b.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{c=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos);let a=[];try{Array.isArray(c.rootURIWorkspaces)&&(a=c.rootURIWorkspaces.map(o=>({workspace:{id:o.id,configPath:m.URI.parse(o.configURIPath)},remoteAuthority:o.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(a);let l=[];try{Array.isArray(c.folderWorkspaceInfos)?l=c.folderWorkspaceInfos.map(o=>({folderUri:m.URI.parse(o.folderUri),remoteAuthority:o.remoteAuthority})):Array.isArray(c.folderURIWorkspaces)&&(l=c.folderURIWorkspaces.map(o=>({folderUri:m.URI.parse(o),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,a){this.workspaces.some(o=>c.workspace.id===o.workspace.id)||(this.workspaces.push(c),this.saveSync());const l=this.getBackupPath(c.workspace.id);return a&&this.moveBackupFolderSync(l,a),l}moveBackupFolderSync(c,a){if(n.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),n.existsSync(a))try{n.renameSync(a,c)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(c){const a=c.id,l=this.workspaces.findIndex(o=>o.workspace.id===a);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(a=>this.backupUriComparer.isEqual(c.folderUri,a.folderUri))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const a=this.folders.findIndex(l=>this.backupUriComparer.isEqual(c,l.folderUri));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(c,a){const l=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:a}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(c){const a=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,c));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(c){return(0,k.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const a=new Set,l=[];for(let o of c){const h=o.workspace;if(!(0,S.isWorkspaceIdentifier)(h))return[];if(!a.has(h.id)){a.add(h.id);const r=this.getBackupPath(h.id);await this.doHasBackups(r)?h.configPath.scheme!==C.Schemas.file||await b.Promises.exists(h.configPath.fsPath)?l.push(o):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return l}async validateFolders(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let o of c){const h=o.folderUri,r=this.backupUriComparer.getComparisonKey(h);if(!l.has(r)){l.add(r);const i=this.getBackupPath(this.getFolderHash(o));await this.doHasBackups(i)?h.scheme!==C.Schemas.file||await b.Promises.exists(h.fsPath)?a.push(o):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return a}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let o of c){const h=o.backupFolder;if(typeof h!="string")return[];if(!l.has(h)){l.add(h);const r=this.getBackupPath(h);await this.doHasBackups(r)?a.push(o):await this.deleteStaleBackup(r)}}return a}async deleteStaleBackup(c){try{await b.Promises.exists(c)&&await b.Promises.rm(c,b.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{await b.Promises.rename(c,l)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{n.renameSync(c,l)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const c=[];for(const a of this.workspaces)await this.hasBackups(a)&&c.push(a);for(const a of this.folders)await this.hasBackups(a)&&c.push(a);return c}hasBackups(c){let a;return(0,I.isEmptyWindowBackupInfo)(c)?a=c.backupFolder:(0,S.isFolderBackupInfo)(c)?a=this.getBackupPath(this.getFolderHash(c)):a=this.getBackupPath(c.workspace.id),this.doHasBackups(a)}async doHasBackups(c){try{const a=await b.Promises.readdir(c);for(const l of a)try{if((await b.Promises.readdir((0,k.join)(c,l))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,b.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await b.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderWorkspaceInfos:this.folders.map(c=>({folderUri:c.folderUri.toString(),remoteAuthority:c.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){const a=c.folderUri;let l;return a.scheme===C.Schemas.file?l=P.isLinux?a.fsPath:a.fsPath.toLowerCase():l=a.toString().toLowerCase(),(0,v.createHash)("md5").update(l).digest("hex")}};w=fe([re(0,y.IEnvironmentMainService),re(1,p.IConfigurationService),re(2,g.ILogService)],w),e.BackupMainService=w}),define(te[228],ie([0,1,8,4,106,59,2,3,37,58,163,226,23,181,20,36,18,7,9,17]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w,M,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function a(h){return h<21}let l=class{constructor(r,i,s,u,d,E){this.windowServer=r,this.options=i,this.windowsMainService=s,this.lifecycleMainService=u,this.fileService=d,this.environmentMainService=E,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(r){return this.registeredWindowIds.add(r),this.reloadingWindowIds.delete(r),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(r){this.reloadingWindowIds.add(r)}async getWindowIds(){return this.windowsMainService.getWindows().map(r=>r.id).filter(r=>this.registeredWindowIds.has(r)&&!this.reloadingWindowIds.has(r))}async capturePage(r){await this.whenUnfrozen(r);const i=this.windowsMainService.getWindowById(r)??this.windowsMainService.getLastActiveWindow();if(!i?.win)throw new Error("Invalid window");return(await i.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(r,i){}async stopTracing(r,i,s){if(!s)return;const u=await this.capturePage(r),d=Buffer.from(u,"base64");await this.fileService.writeFile(w.URI.file((0,M.join)(this.environmentMainService.logsPath,`${i}.png`)),c.VSBuffer.wrap(d))}async reloadWindow(r){await this.whenUnfrozen(r);const i=this.windowsMainService.getWindowById(r);if(!i)throw new Error("Invalid window");this.reloadingWindowIds.add(r),this.lifecycleMainService.reload(i)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(r,i){await this.whenUnfrozen(r);const s=D.KeybindingParser.parseUserBinding(i);for(let u of s)await this._dispatchKeybinding(r,u)}async _dispatchKeybinding(r,i){if(i instanceof C.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const s=this.windowsMainService.getWindowById(r);if(!s?.win)throw new Error("Invalid window");const u=s.win.webContents,d=new C.SimpleKeybinding(!1,!1,!1,!1,i.keyCode),L=new y.USLayoutResolvedKeybinding(d.toChord(),P.OS).getElectronAccelerator(),R=[];i.ctrlKey&&R.push("ctrl"),i.metaKey&&R.push("meta"),i.shiftKey&&R.push("shift"),i.altKey&&R.push("alt"),u.sendInputEvent({type:"keyDown",keyCode:L,modifiers:R}),a(i.keyCode)||u.sendInputEvent({type:"char",keyCode:L,modifiers:R}),u.sendInputEvent({type:"keyUp",keyCode:L,modifiers:R}),await(0,v.timeout)(100)}async click(r,i,s,u){await(await this.getWindowDriver(r)).click(i,s,u)}async doubleClick(r,i){await(await this.getWindowDriver(r)).doubleClick(i)}async setValue(r,i,s){await(await this.getWindowDriver(r)).setValue(i,s)}async getTitle(r){return await(await this.getWindowDriver(r)).getTitle()}async isActiveElement(r,i){return await(await this.getWindowDriver(r)).isActiveElement(i)}async getElements(r,i,s){return await(await this.getWindowDriver(r)).getElements(i,s)}async getElementXY(r,i,s,u){return await(await this.getWindowDriver(r)).getElementXY(i,s,u)}async typeInEditor(r,i,s){await(await this.getWindowDriver(r)).typeInEditor(i,s)}async getTerminalBuffer(r,i){return await(await this.getWindowDriver(r)).getTerminalBuffer(i)}async writeInTerminal(r,i,s){await(await this.getWindowDriver(r)).writeInTerminal(i,s)}async getLocaleInfo(r){return await(await this.getWindowDriver(r)).getLocaleInfo()}async getLocalizedStrings(r){return await(await this.getWindowDriver(r)).getLocalizedStrings()}async getWindowDriver(r){await this.whenUnfrozen(r);const i=`window:${r}`,s=new f.StaticRouter(d=>d===i),u=this.windowServer.getChannel("windowDriver",s);return new b.WindowDriverChannelClient(u)}async whenUnfrozen(r){for(;this.reloadingWindowIds.has(r);)await n.Event.toPromise(this.onDidReloadingChange.event)}};l=fe([re(2,g.IWindowsMainService),re(3,t.ILifecycleMainService),re(4,S.IFileService),re(5,p.IEnvironmentMainService)],l),e.Driver=l;async function o(h,r,i,s){const u=i.driverVerbose,d=s.createInstance(l,h,{verbose:u}),E=new I.WindowDriverRegistryChannel(d);h.registerChannel("windowDriverRegistry",E);const L=await(0,m.serve)(r),R=new I.DriverChannel(d);return L.registerChannel("driver",R),(0,k.combinedDisposable)(L,h)}e.serve=o}),define(te[229],ie([0,1,61,58]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,C,k,P,f){const m=I=>f(I,void 0),b=v.createConnection({host:D,port:C},()=>{b.removeListener("error",m);const I=Buffer.alloc(16);for(let g=0;g<16;g++)I[g]=Math.round(Math.random()*256);const p=I.toString("base64"),y=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${C}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`];b.write(y.join(`\r
`)+`\r
\r
`);const t=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",t),f(void 0,new n.NodeSocket(b,P)))};b.on("data",t)});b.setNoDelay(!0),b.once("error",m)}}}),define(te[230],ie([0,1,61,120,229,8,2,19,6,22,196,97,76]),function(K,e,v,n,D,C,k,P,f,m,b,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(M,c,a,l,o){let h;for(let r=3;r&&(h&&h.dispose(),h=await new t(M,c,a,l,o).waitForReady(),!(o&&n.BROWSER_RESTRICTED_PORTS[o]||!n.BROWSER_RESTRICTED_PORTS[h.tunnelLocalPort]));r--);return h}class t extends k.Disposable{constructor(c,a,l,o,h){super();this.defaultTunnelHost=a,this.suggestedLocalPort=h,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=v.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let c=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(c){c.pause();const a=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,b.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),o=l.getSocket().socket,h=l.readEntireBuffer();l.dispose(),h.byteLength>0&&c.write(h.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),o.end()}),c.on("close",()=>o.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),o.destroy()}),o.on("end",()=>c.end()),o.on("close",()=>c.end()),o.on("error",()=>{c.destroy()}),c.pipe(o),o.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),o.end()})}}let g=class extends I.AbstractTunnelService{constructor(c,a,l,o,h){super(a);this.socketFactory=c,this.signService=l,this.productService=o,this.configurationService=h}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,a,l,o,h,r,i){const s=this.getTunnelFromMap(a,l);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,l,o,h,r,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${l} on local port ${o}.`);const u={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},d=y(u,this.defaultTunnelHost,a,l,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,l,d),d}}};g=fe([re(1,f.ILogService),re(2,p.ISignService),re(3,m.IProductService),re(4,P.IConfigurationService)],g),e.BaseTunnelService=g;let S=class extends g{constructor(c,a,l,o){super(D.nodeSocketFactory,c,a,l,o)}};S=fe([re(0,f.ILogService),re(1,p.ISignService),re(2,m.IProductService),re(3,P.IConfigurationService)],S),e.TunnelService=S;let w=class extends k.Disposable{constructor(c,a,l,o){super();this.logService=c,this.productService=a,this.signService=l,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(c,a,l,o,h,r,i,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${o} on local port ${h}.`),!this._tunnelServices.has(c)){const u=new S(this.logService,this.signService,this.productService,this.configurationService);this._register(u),this._tunnelServices.set(c,u),u.onTunnelClosed(async()=>{(await u.tunnels).length===0&&(u.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(a,l,o,h,r,i,s)}};w=fe([re(0,f.ILogService),re(1,m.IProductService),re(2,p.ISignService),re(3,P.IConfigurationService)],w),e.SharedTunnelsService=w}),define(te[231],ie([0,1,200,8,17,15,2,13,19,53,91,6,199,225]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends k.Disposable{constructor(S,w,M){super();this.environmentService=w,this.logService=M,this.configure(S.getValue()),this._register(S.onDidChangeConfiguration(()=>this.configure(S.getValue()),this))}configure(S){this.proxyUrl=S.http&&S.http.proxy,this.strictSSL=!!(S.http&&S.http.proxyStrictSSL),this.authorization=S.http&&S.http.proxyAuthorization}async request(S,w){this.logService.trace("RequestService#request",S.url);const{proxyUrl:M,strictSSL:c}=this;let a;try{a=await(0,b.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(h){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",h))}const l={...process.env,...a},o=S.agent?S.agent:await(0,p.getProxyAgent)(S.url||"",l,{proxyUrl:M,strictSSL:c});return S.agent=o,S.strictSSL=c,this.authorization&&(S.headers={...S.headers||{},"Proxy-Authorization":this.authorization}),this._request(S,w)}async getNodeRequest(S){return((0,v.parse)(S.url).protocol==="https:"?await new Promise((c,a)=>{K(["https"],c,a)}):await new Promise((c,a)=>{K(["http"],c,a)})).request}_request(S,w){return n.Promises.withAsyncBody(async(M,c)=>{let a;const l=(0,v.parse)(S.url),o=S.getRawRequest?S.getRawRequest(S):await this.getNodeRequest(S),h={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:S.type||"GET",headers:S.headers,agent:S.agent,rejectUnauthorized:(0,P.isBoolean)(S.strictSSL)?S.strictSSL:!0};S.user&&S.password&&(h.auth=S.user+":"+S.password),a=o(h,r=>{const i=(0,P.isNumber)(S.followRedirects)?S.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&i>0&&r.headers.location)this._request({...S,url:r.headers.location,followRedirects:i-1},w).then(M,c);else{let s=r;r.headers["content-encoding"]==="gzip"&&(s=r.pipe((0,y.createGunzip)())),M({res:r,stream:(0,D.streamToBufferReadableStream)(s)})}}),a.on("error",c),S.timeout&&a.setTimeout(S.timeout),S.data&&typeof S.data=="string"&&a.write(S.data),a.end(),w.onCancellationRequested(()=>{a.abort(),c((0,C.canceled)())})})}async resolveProxy(S){}};t=fe([re(0,f.IConfigurationService),re(1,m.INativeEnvironmentService),re(2,I.ILogService)],t),e.RequestService=t}),define(te[232],ie([0,1,14,231]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(k){return v.net.request}class C extends n.RequestService{request(P,f){return super.request({...P||{},getRawRequest:D},f)}}e.RequestMainService=C}),define(te[233],ie([0,1,14,8,4,2,10,13,86,23,20,6,55,56,66,39]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let S=class extends C.Disposable{constructor(M,c,a,l,o,h,r){super();this.machineId=M,this.userEnv=c,this.environmentMainService=a,this.lifecycleMainService=l,this.logService=o,this.themeMainService=h,this.protocolMainService=r,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:createSharedProcessMessageChannel",(M,c)=>this.onWindowConnection(M,c)),v.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(M,c)=>this.onWorkerConnection(M,c)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(M,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(M.sender.isDestroyed())return a.close();M.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[a])}onWorkerConnection(M,c){this.logService.trace("SharedProcess: onWorkerConnection",c);const a=new C.DisposableStore,l=h=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${h}')`,c),a.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",c))},o=v.BrowserWindow.fromId(c.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!c.reply.channel){l("unavailable");return}a.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,h=>h.window.win===o)(()=>l("load"))),a.add(D.Event.fromNodeEventEmitter(o,"closed")(()=>l("closed"))),o.webContents.postMessage(c.reply.channel,c.reply.nonce,M.ports)}onWillShutdown(){const M=this.window;!M||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(M.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{M.close()}catch{}this.window=void 0},0))}send(M,...c){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${M}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(M,...c)}catch(a){this.logService.warn(`Error sending IPC message to channel '${M}' of shared process: ${(0,g.toErrorMessage)(a)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(M=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),M()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(M=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),M()}))})()),this._whenIpcReady}createWindow(){const M=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${M.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),M.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:p.default}),this.window.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",K).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=M=>{this.logService.trace("SharedProcess#close prevented"),M.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(M,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(M,c,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:c}})))}async connect(){await this.whenIpcReady;const M=(0,P.assertIsDefined)(this.window);return(0,f.connect)(M)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const M=this.window;return M?!M.isDestroyed()&&!M.webContents.isDestroyed():!1}};S=fe([re(2,m.IEnvironmentMainService),re(3,b.ILifecycleMainService),re(4,I.ILogService),re(5,t.IThemeMainService),re(6,y.IProtocolMainService)],S),e.SharedProcess=S}),define(te[234],ie([0,1,8,17,9,13,7,23,18,6]),function(K,e,v,n,D,C,k,P,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class b{constructor(y,t,g){this.storagePath=y,this.logService=t,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,t){const g=this.storage[y];return(0,C.isUndefinedOrNull)(g)?t:g}setItem(y,t){this.setItems([{key:y,data:t}])}setItems(y){let t=!1;for(const{key:g,data:S}of y)this.storage[g]!==S&&((0,C.isUndefinedOrNull)(S)?(0,C.isUndefined)(this.storage[g])||(this.storage[g]=void 0,t=!0):(this.storage[g]=S,t=!0));t&&this.save()}removeItem(y){(0,C.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,n.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=b;let I=class It{constructor(y,t,g){this.fileStorage=new b(k.URI.file((0,D.join)(y.userDataPath,It.STATE_FILE)),t,g)}async init(){return this.fileStorage.init()}getItem(y,t){return this.fileStorage.getItem(y,t)}setItem(y,t){this.fileStorage.setItem(y,t)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=fe([re(0,P.IEnvironmentMainService),re(1,m.ILogService),re(2,f.IFileService)],I),e.StateMainService=I}),define(te[78],ie([0,1,42,2,53,23,5,20,6,77,222]),function(K,e,v,n,D,C,k,P,f,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,k.createDecorator)("storageMainService");let I=class extends n.Disposable{constructor(t,g,S){super();this.logService=t,this.environmentService=g,this.lifecycleMainService=S,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async t=>{t.workspace&&this.workspaceStorage(t.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(t=>{t.join(this.globalStorage.close());for(const[,g]of this.mapWorkspaceToStorage)t.join(g.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const t=new b.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(t.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),t}createWorkspaceStorage(t){return new b.WorkspaceStorageMain(t,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(t){let g=this.mapWorkspaceToStorage.get(t.id);return g||(this.logService.trace(`StorageMainService: creating workspace storage (${t.id})`),g=this.createWorkspaceStorage(t),this.mapWorkspaceToStorage.set(t.id,g),(0,v.once)(g.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${t.id})`),this.mapWorkspaceToStorage.delete(t.id)})),g}};I=fe([re(0,f.ILogService),re(1,D.IEnvironmentService),re(2,P.ILifecycleMainService)],I),e.StorageMainService=I,e.IGlobalStorageMainService=(0,k.createDecorator)("globalStorageMainService");let p=class extends m.AbstractStorageService{constructor(t,g){super();this.environmentMainService=t,this.storageMainService=g,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(t){switch(t){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(t){return t===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};p=fe([re(0,C.IEnvironmentMainService),re(1,e.IStorageMainService)],p),e.GlobalStorageMainService=p}),define(te[79],ie([0,1,8,21,4,19,23,20,6,22,48,41]),function(K,e,v,n,D,C,k,P,f,m,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function p(t,g,S){return`${S.updateUrl}/api/update/${t}/${g}/${S.commit}`}e.createUpdateURL=p;let y=class{constructor(g,S,w,M,c,a){this.lifecycleMainService=g,this.configurationService=S,this.environmentMainService=w,this.requestService=M,this.logService=c,this.productService=a,this._state=I.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.getUpdateMode(),S=this.getProductQuality(g);if(!S){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(S),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,w=>this.logService.error(w))}getUpdateMode(){return(0,C.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,v.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},n.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};y=fe([re(0,P.ILifecycleMainService),re(1,C.IConfigurationService),re(2,k.IEnvironmentMainService),re(3,b.IRequestService),re(4,f.ILogService),re(5,m.IProductService)],y),e.AbstractUpdateService=y}),define(te[235],ie([0,1,14,46,4,2,19,23,20,6,22,48,29,41,79]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends t.AbstractUpdateService{constructor(w,M,c,a,l,o,h){super(w,M,a,l,o,h);this.telemetryService=c,this.disposables=new C.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"error",(w,M)=>M)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(w,M,c)=>({url:M,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(w,M,c,a)=>({releaseNotes:M,version:c,productVersion:c,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(w){this.logService.error("UpdateService error:",w);const c=(this.state.type==="checking for updates"?this.state.explicit:!0)?w:void 0;this.setState(y.State.Idle(1,c))}buildUpdateFeedUrl(w){let M;this.productService.darwinUniversalAssetId?M=this.productService.darwinUniversalAssetId:M=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,t.createUpdateURL)(M,w,this.productService);try{v.autoUpdater.setFeedURL({url:c})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return c}doCheckForUpdates(w){this.setState(y.State.CheckingForUpdates(w)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(w){this.state.type==="checking for updates"&&this.setState(y.State.Downloading(w))}onUpdateDownloaded(w){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:w.version}),this.setState(y.State.Ready(w)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(y.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};fe([n.memoize],g.prototype,"onRawError",null),fe([n.memoize],g.prototype,"onRawUpdateNotAvailable",null),fe([n.memoize],g.prototype,"onRawUpdateAvailable",null),fe([n.memoize],g.prototype,"onRawUpdateDownloaded",null),g=fe([re(0,f.ILifecycleMainService),re(1,k.IConfigurationService),re(2,p.ITelemetryService),re(3,P.IEnvironmentMainService),re(4,I.IRequestService),re(5,m.ILogService),re(6,b.IProductService)],g),e.DarwinUpdateService=g}),define(te[236],ie([0,1,44,28,8,4,9,23,20,6,29,41]),function(K,e,v,n,D,C,k,P,f,m,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let p=class{constructor(g,S,w){if(this.lifecycleMainService=g,this.logService=w,this._state=I.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,S.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,M=>this.logService.error(M))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,D.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};p=fe([re(0,f.ILifecycleMainService),re(1,P.IEnvironmentMainService),re(2,m.ILogService)],p);let y=class extends p{constructor(g,S,w,M,c,a){super(w,M,c);this.snap=g,this.snapRevision=S,this.telemetryService=a;const l=(0,n.watch)(k.dirname(this.snap)),o=C.Event.fromNodeEventEmitter(l,"change",(s,u)=>u),h=C.Event.filter(o,s=>s==="current"),i=C.Event.debounce(h,(s,u)=>u,2e3)(()=>this.checkForUpdates(!1));w.onWillShutdown(()=>{i.dispose(),l.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+k.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((w,M)=>(0,n.realpath)(`${k.dirname(this.snap)}/current`,(c,a)=>c?M(c):w(a))),S=k.basename(g);return this.snapRevision!==S}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=fe([re(2,f.ILifecycleMainService),re(3,P.IEnvironmentMainService),re(4,m.ILogService),re(5,b.ITelemetryService)],y),e.SnapUpdateService=y}),define(te[45],ie([0,1,14,28,4,43,33,2,10,9,3,16,13,24,160,52,49,23,5,6,22,99,30,100]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w,M,c,a,l,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,M.createDecorator)("workspacesManagementMainService");let r=class extends P.Disposable{constructor(s,u,d,E,L){super();this.environmentMainService=s,this.logService=u,this.backupMainService=d,this.dialogMainService=E,this.productService=L,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(s){return this.doResolveLocalWorkspace(s,u=>(0,n.readFileSync)(u,"utf8"))}resolveLocalWorkspace(s){return this.doResolveLocalWorkspace(s,u=>y.Promises.readFile(u,"utf8"))}doResolveLocalWorkspace(s,u){if(!!this.isWorkspacePath(s)&&s.scheme===f.Schemas.file)try{const d=u(s.fsPath);return d instanceof Promise?d.then(E=>this.doResolveWorkspace(s,E),E=>{}):this.doResolveWorkspace(s,d)}catch{return}}isWorkspacePath(s){return(0,o.isUntitledWorkspace)(s,this.environmentMainService)||(0,o.hasWorkspaceFileExtension)(s)}doResolveWorkspace(s,u){try{const d=this.doParseStoredWorkspace(s,u),E=(0,h.getWorkspaceIdentifier)(s);return{id:E.id,configPath:E.configPath,folders:(0,o.toWorkspaceFolders)(d.folders,E.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:d.remoteAuthority,transient:d.transient}}catch(d){this.logService.warn(d.toString())}}doParseStoredWorkspace(s,u){const d=(0,C.parse)(u);if(d&&Array.isArray(d.folders))d.folders=d.folders.filter(E=>(0,o.isStoredWorkspaceFolder)(E));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return d}async createUntitledWorkspace(s,u){const{workspace:d,storedWorkspace:E}=this.newUntitledWorkspace(s,u),L=d.configPath.fsPath;return await y.Promises.mkdir((0,m.dirname)(L),{recursive:!0}),await y.Promises.writeFile(L,JSON.stringify(E,null,"	")),d}createUntitledWorkspaceSync(s,u){const{workspace:d,storedWorkspace:E}=this.newUntitledWorkspace(s,u),L=d.configPath.fsPath;return(0,n.mkdirSync)((0,m.dirname)(L),{recursive:!0}),(0,y.writeFileSync)(L,JSON.stringify(E,null,"	")),d}newUntitledWorkspace(s=[],u){const d=(Date.now()+Math.round(Math.random()*1e3)).toString(),E=(0,I.joinPath)(this.untitledWorkspacesHome,d),L=(0,I.joinPath)(E,o.UNTITLED_WORKSPACE_NAME),R=[];for(const T of s)R.push((0,o.getStoredWorkspaceFolder)(T.uri,!0,T.name,E,!b.isWindows,I.extUriBiasedIgnorePathCase));return{workspace:(0,h.getWorkspaceIdentifier)(L),storedWorkspace:{folders:R,remoteAuthority:u}}}async getWorkspaceIdentifier(s){return(0,h.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,o.isUntitledWorkspace)(s.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(s){!this.isUntitledWorkspace(s)||(this.doDeleteUntitledWorkspaceSync(s),this._onDidDeleteUntitledWorkspace.fire(s))}async deleteUntitledWorkspace(s){this.deleteUntitledWorkspaceSync(s)}doDeleteUntitledWorkspaceSync(s){const u=(0,I.originalFSPath)(s.configPath);try{(0,y.rimrafSync)((0,m.dirname)(u));const d=(0,m.join)(this.environmentMainService.workspaceStorageHome.fsPath,s.id);(0,n.existsSync)(d)&&(0,y.writeFileSync)((0,m.join)(d,"obsolete"),"")}catch(d){this.logService.warn(`Unable to delete untitled workspace ${u} (${d}).`)}}getUntitledWorkspacesSync(){const s=[];try{const u=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(d=>(0,I.joinPath)(this.untitledWorkspacesHome,d,o.UNTITLED_WORKSPACE_NAME));for(const d of u){const E=(0,h.getWorkspaceIdentifier)(d),L=this.resolveLocalWorkspaceSync(d);L?s.push({workspace:E,remoteAuthority:L.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(E)}}catch(u){u.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${u}).`)}return s}async enterWorkspace(s,u,d){if(!s||!s.win||!s.isReady||!await this.isValidTargetWorkspacePath(s,u,d))return;const L=this.doEnterWorkspace(s,(0,h.getWorkspaceIdentifier)(d));if(!!L)return this._onDidEnterWorkspace.fire({window:s,workspace:L.workspace}),L}async isValidTargetWorkspacePath(s,u,d){if(!d)return!0;if((0,o.isWorkspaceIdentifier)(s.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,d))return!1;if((0,l.findWindowOnWorkspaceOrFolder)(u,d)){const E={title:this.productService.nameLong,type:"info",buttons:[(0,k.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,I.basename)(d)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(E,(0,p.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(s,u){if(!s.config)return;s.focus();let d;return s.config.extensionDevelopmentPath||(d=this.backupMainService.registerWorkspaceBackupSync({workspace:u,remoteAuthority:s.remoteAuthority},s.config.backupPath)),(0,o.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&this.deleteUntitledWorkspaceSync(s.openedWorkspace),s.config.workspace=u,s.config.backupPath=d,{workspace:u,backupPath:d}}};r=fe([re(0,w.IEnvironmentMainService),re(1,c.ILogService),re(2,g.IBackupMainService),re(3,S.IDialogMainService),re(4,a.IProductService)],r),e.WorkspacesManagementMainService=r}),define(te[101],ie([0,1,14,31,21,3,13,7,24,19,54,5,6,98,36,30,45]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,I.createDecorator)(e.ID);let w=class{constructor(c,a,l,o,h){this.logService=c,this.windowsMainService=a,this.urlService=l,this.workspacesManagementMainService=o,this.configurationService=h}async start(c,a){this.logService.trace("Received data from other instance: ",c,a),C.isMacintosh&&v.app.focus({steal:!0});const l=this.parseOpenUrl(c);if(l.length){let o=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(o=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),o.then(()=>{for(const{uri:h,url:r}of l)this.urlService.open(h,{originalUrl:r})})}else return this.startOpenWindow(c,a)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,n.coalesce)(c._urls.map(a=>{try{return{uri:P.URI.parse(a),url:a}}catch{return null}})):[]}async startOpenWindow(c,a){const l=(0,b.isLaunchedFromCli)(a)?0:4;let o=[];const h=c.wait&&c.waitMarkerFilePath?P.URI.file(c.waitMarkerFilePath):void 0,r=c.remote||void 0,i={context:l,cli:c,userEnv:a,waitMarkerFileURI:h,remoteAuthority:r};if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,i);else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let s=!1;if(c["new-window"]||c["unity-launch"])s=!0;else if(c["reuse-window"])s=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":s=!0;break;case"off":s=!1;break;default:s=!C.isMacintosh}if(s)o=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const u=this.windowsMainService.getLastActiveWindow();u?(this.windowsMainService.openExistingWindow(u,i),o=[u]):o=this.windowsMainService.open({...i,forceEmpty:!0})}}else o=this.windowsMainService.open({...i,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],gotoLineMode:c.goto});if(h&&o.length===1&&o[0])return Promise.race([o[0].whenClosedOrLoaded,(0,f.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return v.BrowserWindow.getAllWindows().forEach(a=>{const l=this.windowsMainService.getWindowById(a.id);l?c.push(this.codeWindowToInfo(l)):c.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(o=>new Promise(h=>{const r=o.remoteAuthority;if(r){const i=`vscode:getDiagnosticInfoResponse${o.id}`,s={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(o):void 0};o.sendWhenReady("vscode:getDiagnosticInfo",D.CancellationToken.None,{replyChannel:i,args:s}),v.ipcMain.once(i,(u,d)=>{d||h({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),h(d)}),setTimeout(()=>{h({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else h(void 0)})))).filter(o=>!!o)}getFolderURIs(c){const a=[],l=c.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(l))a.push(l.uri);else if((0,g.isWorkspaceIdentifier)(l)){const o=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);o&&o.folders.forEach(r=>{a.push(r.uri)})}return a}codeWindowToInfo(c){const a=this.getFolderURIs(c),l=(0,k.assertIsDefined)(c.win);return this.browserWindowToInfo(l,a,c.remoteAuthority)}browserWindowToInfo(c,a=[],l){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:a,remoteAuthority:l}}};w=fe([re(0,p.ILogService),re(1,t.IWindowsMainService),re(2,y.IURLService),re(3,S.IWorkspacesManagementMainService),re(4,m.IConfigurationService)],w),e.LaunchMainService=w}),define(te[50],ie([0,1,44,14,26,119,46,4,33,2,10,9,3,7,83,71,24,152,49,23,5,20,6,22,29,66,36,30,45]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w,M,c,a,l,o,h,r,i,s,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let E=class mt extends m.Disposable{constructor(R,T,N,Q,se,ne,V,Z,H,q){super();this.sharedProcess=R,this.windowsMainService=T,this.dialogMainService=N,this.lifecycleMainService=Q,this.environmentMainService=se,this.telemetryService=ne,this.logService=V,this.productService=Z,this.themeMainService=H,this.workspacesManagementMainService=q,this.onDidOpenWindow=P.Event.map(this.windowsMainService.onDidOpenWindow,Y=>Y.id),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(Y,j)=>j.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(Y,j)=>j.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(Y,j)=>j.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),Y=>!!Y),Y=>Y.id),P.Event.filter(P.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(Y,j)=>j.id),Y=>!!this.windowsMainService.getWindowById(Y))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new P.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new P.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(n.screen,"display-metrics-changed",(Y,j,z)=>z),Y=>!(Array.isArray(Y)&&Y.length===1&&Y[0]==="workArea")),P.Event.fromNodeEventEmitter(n.screen,"display-added"),P.Event.fromNodeEventEmitter(n.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){n.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(T=>({id:T.id,workspace:T.openedWorkspace,title:T.win?.getTitle()??"",filename:T.getRepresentedFilename(),dirty:T.isDocumentEdited()}))}async getWindowCount(R){return this.windowsMainService.getWindowCount()}async getActiveWindowId(R){const T=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(T)return T.id}openWindow(R,T,N){return Array.isArray(T)?this.doOpenWindow(R,T,N):this.doOpenEmptyWindow(R,T)}async doOpenWindow(R,T,N=Object.create(null)){T.length>0&&this.windowsMainService.open({context:5,contextWindowId:R,urisToOpen:T,cli:this.environmentMainService.args,forceNewWindow:N.forceNewWindow,forceReuseWindow:N.forceReuseWindow,preferNewWindow:N.preferNewWindow,diffMode:N.diffMode,addMode:N.addMode,gotoLineMode:N.gotoLineMode,noRecentEntry:N.noRecentEntry,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:N.remoteAuthority||void 0})}async doOpenEmptyWindow(R,T){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:R},T)}async toggleFullScreen(R){const T=this.windowById(R);T&&T.toggleFullScreen()}async handleTitleDoubleClick(R){const T=this.windowById(R);T&&T.handleTitleDoubleClick()}async isMaximized(R){const T=this.windowById(R);return T?.win?T.win.isMaximized():!1}async maximizeWindow(R){const T=this.windowById(R);T?.win&&T.win.maximize()}async unmaximizeWindow(R){const T=this.windowById(R);T?.win&&T.win.unmaximize()}async minimizeWindow(R){const T=this.windowById(R);T?.win&&T.win.minimize()}async focusWindow(R,T){T&&typeof T.windowId=="number"&&(R=T.windowId);const N=this.windowById(R);N&&N.focus({force:T?.force??!1})}async setMinimumSize(R,T,N){const Q=this.windowById(R);if(Q?.win){const[se,ne]=Q.win.getSize(),[V,Z]=Q.win.getMinimumSize(),[H,q]=[T??V,N??Z],[Y,j]=[Math.max(se,H),Math.max(ne,q)];(V!==H||Z!==q)&&Q.win.setMinimumSize(H,q),(se!==Y||ne!==j)&&Q.win.setSize(Y,j)}}async saveWindowSplash(R,T){this.themeMainService.saveWindowSplash(R,T)}async installShellCommand(R){const{source:T,target:N}=await this.getShellCommandLink();try{const{symbolicLink:Q}=await S.SymlinkSupport.stat(T);if(Q&&!Q.dangling){const se=await(0,t.realpath)(T);if(N===se)return}await S.Promises.unlink(T)}catch(Q){if(Q.code!=="ENOENT")throw Q}try{await S.Promises.symlink(N,T)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="ENOENT")throw Q;const{response:se}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,w.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,w.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,w.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const ne=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${N}' '${T}'\\" with administrator privileges"`;await(0,C.promisify)(v.exec)(ne)}catch{throw new Error((0,w.localize)(3,null,T))}}}async uninstallShellCommand(R){const{source:T}=await this.getShellCommandLink();try{await S.Promises.unlink(T)}catch(N){switch(N.code){case"EACCES":{const{response:Q}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,w.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,w.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(Q===0)try{const se=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,C.promisify)(v.exec)(se)}catch{throw new Error((0,w.localize)(7,null,T))}break}case"ENOENT":break;default:throw N}}}async getShellCommandLink(){const R=(0,I.resolve)(this.environmentMainService.appRoot,"bin","code"),T=`/usr/local/bin/${this.productService.applicationName}`;if(!await S.Promises.exists(R))throw new Error((0,w.localize)(8,null,R));return{source:T,target:R}}async showMessageBox(R,T){return this.dialogMainService.showMessageBox(T,this.toBrowserWindow(R))}async showSaveDialog(R,T){return this.dialogMainService.showSaveDialog(T,this.toBrowserWindow(R))}async showOpenDialog(R,T){return this.dialogMainService.showOpenDialog(T,this.toBrowserWindow(R))}toBrowserWindow(R){const T=this.windowById(R);if(T?.win)return T.win}async pickFileFolderAndOpen(R,T){const N=await this.dialogMainService.pickFileFolder(T);N&&(this.sendPickerTelemetry(N,T.telemetryEventName||"openFileFolder",T.telemetryExtraData),this.doOpenPicked(await Promise.all(N.map(async Q=>await S.SymlinkSupport.existsDirectory(Q)?{folderUri:y.URI.file(Q)}:{fileUri:y.URI.file(Q)})),T,R))}async pickFolderAndOpen(R,T){const N=await this.dialogMainService.pickFolder(T);N&&(this.sendPickerTelemetry(N,T.telemetryEventName||"openFolder",T.telemetryExtraData),this.doOpenPicked(N.map(Q=>({folderUri:y.URI.file(Q)})),T,R))}async pickFileAndOpen(R,T){const N=await this.dialogMainService.pickFile(T);N&&(this.sendPickerTelemetry(N,T.telemetryEventName||"openFile",T.telemetryExtraData),this.doOpenPicked(N.map(Q=>({fileUri:y.URI.file(Q)})),T,R))}async pickWorkspaceAndOpen(R,T){const N=await this.dialogMainService.pickWorkspace(T);N&&(this.sendPickerTelemetry(N,T.telemetryEventName||"openWorkspace",T.telemetryExtraData),this.doOpenPicked(N.map(Q=>({workspaceUri:y.URI.file(Q)})),T,R))}doOpenPicked(R,T,N){this.windowsMainService.open({context:3,contextWindowId:N,cli:this.environmentMainService.args,urisToOpen:R,forceNewWindow:T.forceNewWindow})}sendPickerTelemetry(R,T,N){const Q=R?R.length:0;this.telemetryService.publicLog(T,{...N,outcome:Q?"success":"canceled",numberOfPaths:Q})}async showItemInFolder(R,T){n.shell.showItemInFolder(T)}async setRepresentedFilename(R,T){const N=this.windowById(R);N&&N.setRepresentedFilename(T)}async setDocumentEdited(R,T){const N=this.windowById(R);N&&N.setDocumentEdited(T)}async openExternal(R,T){return p.isLinuxSnap?this.safeSnapOpenExternal(T):n.shell.openExternal(T),!0}safeSnapOpenExternal(R){const T=process.env.GDK_PIXBUF_MODULE_FILE,N=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(R),process.env.GDK_PIXBUF_MODULE_FILE=T,process.env.GDK_PIXBUF_MODULEDIR=N}moveItemToTrash(R,T){return n.shell.trashItem(T)}async isAdmin(){let R;return p.isWindows?R=(await new Promise((T,N)=>{K(["native-is-elevated"],T,N)}))():R=process.getuid()===0,R}async writeElevated(R,T,N,Q){const se=await new Promise((ne,V)=>{K(["@vscode/sudo-prompt"],ne,V)});return new Promise((ne,V)=>{const Z=[`"${this.cliPath}"`];Q?.unlock&&Z.push("--file-chmod"),Z.push("--file-write",`"${T.fsPath}"`,`"${N.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:p.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(Z.join(" "),H,(q,Y,j)=>{Y&&this.logService.trace(`[sudo-prompt] received stdout: ${Y}`),j&&this.logService.trace(`[sudo-prompt] received stderr: ${j}`),q?V(q):ne(void 0)})})}get cliPath(){return p.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):p.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}get osColorScheme(){return{highContrast:n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors,dark:n.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(R,T,N){process.kill(T,N)}async readClipboardText(R,T){return n.clipboard.readText(T)}async writeClipboardText(R,T,N){return n.clipboard.writeText(T,N)}async readClipboardFindText(R){return n.clipboard.readFindText()}async writeClipboardFindText(R,T){return n.clipboard.writeFindText(T)}async writeClipboardBuffer(R,T,N,Q){return n.clipboard.writeBuffer(T,Buffer.from(N),Q)}async readClipboardBuffer(R,T){return n.clipboard.readBuffer(T)}async hasClipboard(R,T,N){return n.clipboard.has(T,N)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(R,T){const N=this.windowById(R);N&&N.updateTouchBar(T)}async notifyReady(R){const T=this.windowById(R);T&&T.setReady()}async relaunch(R,T){return this.lifecycleMainService.relaunch(T)}async reload(R,T){const N=this.windowById(R);if(N){if((0,u.isWorkspaceIdentifier)(N.openedWorkspace)){const Q=N.openedWorkspace.configPath;if(Q.scheme===b.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(Q))?.transient)return this.openWindow(N.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(N,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(R){this.closeWindowById(R,R)}async closeWindowById(R,T){const N=this.windowById(T);if(N?.win)return N.win.close()}async quit(R){const T=this.windowsMainService.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&T.win?T.win.close():this.lifecycleMainService.quit()}async exit(R,T){await this.lifecycleMainService.kill(T)}async resolveProxy(R,T){const Q=this.windowById(R)?.win?.webContents?.session;if(Q)return Q.resolveProxy(T)}async openDevTools(R,T){const N=this.windowById(R);N?.win&&N.win.webContents.openDevTools(T)}async toggleDevTools(R){const T=this.windowById(R);T?.win&&T.win.webContents.toggleDevTools()}async sendInputEvent(R,T){const N=this.windowById(R);N?.win&&(T.type==="mouseDown"||T.type==="mouseUp")&&N.win.webContents.sendInputEvent(T)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(R,T,N,Q){if(!p.isWindows)return;const se=await new Promise((ne,V)=>{K(["vscode-windows-registry"],ne,V)});try{return se.GetStringRegKey(T,N,Q)}catch{return}}async getPassword(R,T,N){const Q=await this.withKeytar(),se=await Q.getPassword(T,N);if(se)try{let{content:ne,hasNextChunk:V}=JSON.parse(se);if(!ne||!V)return se;let Z=1;for(;V;){const H=await Q.getPassword(T,`${N}-${Z}`),q=JSON.parse(H);ne+=q.content,V=q.hasNextChunk,Z++}return ne}catch{return se}return se}async setPassword(R,T,N,Q){const se=await this.withKeytar(),ne=3,V=async(Z,H,q)=>{let Y=0,j;for(;Y<ne;)try{await se.setPassword(Z,H,q);return}catch(z){j=z,this.logService.warn("Error attempting to set a password: ",z),Y++,await new Promise(G=>setTimeout(G,200))}throw j};if(p.isWindows&&Q.length>mt.MAX_PASSWORD_LENGTH){let Z=0,H=0,q=!0;for(;q;){const Y=Q.substring(Z,Z+mt.PASSWORD_CHUNK_SIZE);Z+=mt.PASSWORD_CHUNK_SIZE,q=Q.length-Z>0;const j={content:Y,hasNextChunk:q};await V(T,H?`${N}-${H}`:N,JSON.stringify(j)),H++}}else await V(T,N,Q);this._onDidChangePassword.fire({service:T,account:N})}async deletePassword(R,T,N){const se=await(await this.withKeytar()).deletePassword(T,N);return se&&this._onDidChangePassword.fire({service:T,account:N}),se}async findPassword(R,T){return(await this.withKeytar()).findPassword(T)}async findCredentials(R,T){return(await this.withKeytar()).findCredentials(T)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((R,T)=>{K(["keytar"],R,T)})}windowById(R){if(typeof R=="number")return this.windowsMainService.getWindowById(R)}};E.MAX_PASSWORD_LENGTH=2500,E.PASSWORD_CHUNK_SIZE=E.MAX_PASSWORD_LENGTH-100,fe([k.memoize],E.prototype,"cliPath",null),E=fe([re(1,s.IWindowsMainService),re(2,M.IDialogMainService),re(3,l.ILifecycleMainService),re(4,c.IEnvironmentMainService),re(5,r.ITelemetryService),re(6,o.ILogService),re(7,h.IProductService),re(8,i.IThemeMainService),re(9,d.IWorkspacesManagementMainService)],E),e.NativeHostMainService=E}),define(te[237],ie([0,1,14,21,4,82,2,32,89,6,50,22,36]),function(K,e,v,n,D,C,k,P,f,m,b,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let t=class extends k.Disposable{constructor(S,w,M,c,a){super();this.logService=S,this.windowsMainService=w,this.nativeHostMainService=M,this.encryptionMainService=c,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const S=D.Event.fromNodeEventEmitter(v.app,"login",(w,M,c,a,l)=>({event:w,webContents:M,req:c,authInfo:a,callback:l}));this._register(S(this.onLogin,this))}async onLogin({event:S,authInfo:w,req:M,callback:c}){if(!w.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&M.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}S.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(w);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(a?.username,a?.password)}async resolveProxyCredentials(S){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.doResolveProxyCredentials(S);if(w)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(S){this.logService.trace("auth#doResolveProxyCredentials - enter",S);const w=String((0,C.hash)({scheme:S.scheme,host:S.host,port:S.port}));let M,c;try{const h=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,w);if(h){const r=JSON.parse(await this.encryptionMainService.decrypt(h));M=r.username,c=r.password}}catch(h){this.logService.error(h)}if(this.state!==y.StoredCredentialsUsed&&typeof M=="string"&&typeof c=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:M,password:c};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const l={authInfo:S,username:this.sessionCredentials?.username??M,password:this.sessionCredentials?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",n.CancellationToken.None,l),this.state=y.LoginDialogShown;const o=await new Promise(h=>{const r=async(i,s,u)=>{if(s===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",r),u){const d={username:u.username,password:u.password};try{if(u.remember){const E=await this.encryptionMainService.encrypt(JSON.stringify(d));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,w,E)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,w)}catch(E){this.logService.error(E)}h({username:d.username,password:d.password})}else h(void 0)};a.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=o,o}};t=fe([re(0,m.ILogService),re(1,p.IWindowsMainService),re(2,b.INativeHostMainService),re(3,f.IEncryptionMainService),re(4,I.IProductService)],t),e.ProxyAuthHandler=t}),define(te[238],ie([0,1,14,26,33,2,10,3,84,150,74,49,23,5,101,6,50,55,22,56,67]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w,M,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let l=class Pt{constructor(h,r,i,s,u,d,E,L,R){this.userEnv=h,this.environmentMainService=r,this.launchMainService=i,this.logService=s,this.diagnosticsService=u,this.dialogMainService=d,this.nativeHostMainService=E,this.protocolMainService=L,this.productService=R,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:issueSystemInfoRequest",async h=>{const[r,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(r,i);this.safeSend(h,"vscode:issueSystemInfoResponse",s)}),v.ipcMain.on("vscode:listProcesses",async h=>{const r=[];try{const i=await this.launchMainService.getMainProcessId();r.push({name:(0,m.localize)(0,null),rootProcess:await(0,f.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(u=>{(0,b.isRemoteDiagnosticError)(u)?r.push({name:u.hostName,rootProcess:u}):u.processes&&r.push({name:u.hostName,rootProcess:u.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(h,"vscode:listProcessesResponse",r)}),v.ipcMain.on("vscode:issueReporterClipboard",async h=>{const r={title:this.productService.nameLong,message:(0,m.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,m.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,m.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(h,"vscode:issueReporterClipboardResponse",i.response===0)}}),v.ipcMain.on("vscode:issuePerformanceInfoRequest",async h=>{const r=await this.getPerformanceInfo();this.safeSend(h,"vscode:issuePerformanceInfoResponse",r)}),v.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const h={title:this.productService.nameLong,message:(0,m.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,m.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,m.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(h,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),v.ipcMain.on("vscode:workbenchCommand",(h,r)=>{const{id:i,from:s,args:u}=r;let d;switch(s){case"issueReporter":d=this.issueReporterParentWindow;break;case"processExplorer":d=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}d&&d.webContents.send("vscode:runAction",{id:i,from:s,args:u})}),v.ipcMain.on("vscode:openExternal",(h,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),v.ipcMain.on("vscode:closeIssueReporter",h=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),v.ipcMain.on("vscode:closeProcessExplorer",h=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),v.ipcMain.on("vscode:windowsInfoRequest",async h=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(h,"vscode:windowsInfoResponse",r.windows)})}safeSend(h,r,...i){h.sender.isDestroyed()||h.sender.send(r,...i)}async openReporter(h){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new C.DisposableStore,i=r.add(this.protocolMainService.createIPCObjectUrl()),s=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(s,i,{backgroundColor:h.styles.backgroundColor,title:(0,m.localize)(7,null),zoomLevel:h.zoomLevel,alwaysOnTop:!1},"issue-reporter"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:h,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:w.default}),this.issueReporterWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",K).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(h){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new C.DisposableStore,i=r.add(this.protocolMainService.createIPCObjectUrl()),s=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(s,i,{backgroundColor:h.styles.backgroundColor,title:(0,m.localize)(8,null),zoomLevel:h.zoomLevel,alwaysOnTop:!0},"process-explorer"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:h,product:w.default}),this.processExplorerWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",K).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(h){h.isMinimized()&&h.restore(),h.focus()}createBrowserWindow(h,r,i,s){const u=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:h.width,height:h.height,minWidth:300,minHeight:200,x:h.x,y:h.y,title:i.title,backgroundColor:i.backgroundColor||Pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`,`--vscode-window-kind=${s}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(i.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:i.alwaysOnTop});return u.setMenuBarVisibility(!1),u}async getSystemStatus(){const[h,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(h,r)}getWindowPosition(h,r,i){let s;const u=v.screen.getAllDisplays();if(u.length===1)s=u[0];else{if(P.isMacintosh){const L=v.screen.getCursorScreenPoint();s=v.screen.getDisplayNearestPoint(L)}!s&&h&&(s=v.screen.getDisplayMatching(h.getBounds())),s||(s=v.screen.getPrimaryDisplay()||u[0])}const d={width:r,height:i},E=s.bounds;return d.x=E.x+E.width/2-d.width/2,d.y=E.y+E.height/2-d.height/2,E.width>0&&E.height>0&&(d.x<E.x&&(d.x=E.x),d.y<E.y&&(d.y=E.y),d.x>E.x+E.width&&(d.x=E.x),d.y>E.y+E.height&&(d.y=E.y),d.width>E.width&&(d.width=E.width),d.height>E.height&&(d.height=E.height)),d}async getPerformanceInfo(){try{const[h,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(h,r)}catch(h){throw this.logService.warn("issueService#getPerformanceInfo ",h.message),h}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=fe([re(1,p.IEnvironmentMainService),re(2,t.ILaunchMainService),re(3,g.ILogService),re(4,b.IDiagnosticsService),re(5,I.IDialogMainService),re(6,S.INativeHostMainService),re(7,c.IProtocolMainService),re(8,M.IProductService)],l),e.IssueMainService=l}),define(te[239],ie([0,1,21,19,23,20,6,50,22,48,29,41,79]),function(K,e,v,n,D,C,k,P,f,m,b,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends p.AbstractUpdateService{constructor(g,S,w,M,c,a,l,o){super(g,S,M,c,a,o);this.telemetryService=w,this.nativeHostMainService=l}buildUpdateFeedUrl(g){return(0,p.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(I.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},v.CancellationToken.None).then(m.asJson).then(S=>{!S||!S.url||!S.version||!S.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(S))}).then(void 0,S=>{this.logService.error(S),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const w=g?S.message||S:void 0;this.setState(I.State.Idle(1,w))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(I.State.Idle(1))}};y=fe([re(0,C.ILifecycleMainService),re(1,n.IConfigurationService),re(2,b.ITelemetryService),re(3,D.IEnvironmentMainService),re(4,m.IRequestService),re(5,k.ILogService),re(6,P.INativeHostMainService),re(7,f.IProductService)],y),e.LinuxUpdateService=y}),define(te[240],ie([0,1,44,28,26,8,21,46,9,7,116,24,19,23,18,20,6,50,22,48,29,41,79]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w,M,c,a,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function h(u,d=1e3){for(;!u();)await(0,C.timeout)(d)}let r;function i(){return typeof r=="undefined"&&(r=n.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),r}let s=class extends o.AbstractUpdateService{constructor(d,E,L,R,T,N,Q,se,ne){super(d,E,R,T,N,ne);this.telemetryService=L,this.fileService=Q,this.nativeHostMainService=se}get cachePath(){const d=f.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(d,{recursive:!0}).then(()=>d)}initialize(){super.initialize(),i()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(d){let E="win32";return process.arch!=="ia32"&&(E+=`-${process.arch}`),i()===1?E+="-archive":this.productService.target==="user"&&(E+="-user"),(0,o.createUpdateURL)(E,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(l.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},k.CancellationToken.None).then(c.asJson).then(E=>{const L=i();return!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(l.State.Idle(L)),Promise.resolve(null)):L===1?(this.setState(l.State.AvailableForDownload(E)),Promise.resolve(null)):(this.setState(l.State.Downloading(E)),this.cleanup(E.version).then(()=>this.getUpdatePackagePath(E.version).then(R=>I.Promises.exists(R).then(T=>{if(T)return Promise.resolve(R);const N=E.url,Q=E.hash,se=`${R}.tmp`;return this.requestService.request({url:N},k.CancellationToken.None).then(ne=>this.fileService.writeFile(m.URI.file(se),ne.stream)).then(Q?()=>(0,b.checksum)(se,E.hash):()=>{}).then(()=>I.Promises.rename(se,R)).then(()=>R)})).then(R=>{const T=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:R},T&&E.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(E)):this.setState(l.State.Ready(E))})))}).then(void 0,E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const L=d?E.message||E:void 0;this.setState(l.State.Idle(i(),L))}))}async doDownloadUpdate(d){d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(l.State.Idle(i()))}async getUpdatePackagePath(d){const E=await this.cachePath;return f.join(E,`CodeSetup-${this.productService.quality}-${d}.exe`)}async cleanup(d=null){const E=d?N=>!new RegExp(`${this.productService.quality}-${d}\\.exe$`).test(N):()=>!0,L=await this.cachePath,T=(await I.Promises.readdir(L)).filter(E).map(async N=>{try{await I.Promises.unlink(f.join(L,N))}catch{}});await Promise.all(T)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const d=this.state.update;this.setState(l.State.Updating(d));const E=await this.cachePath;this.availableUpdate.updateFilePath=f.join(E,`CodeSetup-${this.productService.quality}-${d.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(i()))});const R=`${this.productService.win32MutexName}-ready`,T=await new Promise((N,Q)=>{K(["windows-mutex"],N,Q)});h(()=>T.isActive(R)).then(()=>this.setState(l.State.Ready(d)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?n.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};fe([P.memoize],s.prototype,"cachePath",null),s=fe([re(0,g.ILifecycleMainService),re(1,p.IConfigurationService),re(2,a.ITelemetryService),re(3,y.IEnvironmentMainService),re(4,c.IRequestService),re(5,S.ILogService),re(6,t.IFileService),re(7,w.INativeHostMainService),re(8,M.IProductService)],s),e.Win32UpdateService=s}),define(te[241],ie([0,1,14,8,21,39,4,33,2,10,9,63,3,7,156,52,19,49,23,54,207,18,20,6,22,56,78,29,210,66,67,36,30,45]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w,M,c,a,l,o,h,r,i,s,u,d,E,L,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(ne){ne[ne.NONE=0]="NONE",ne[ne.LOADING=1]="LOADING",ne[ne.NAVIGATING=2]="NAVIGATING",ne[ne.READY=3]="READY"})(Q||(Q={}));let se=class extends f.Disposable{constructor(V,Z,H,q,Y,j,z,G,$,F,W,A,_,U,O){super();this.logService=Z,this.environmentMainService=H,this.fileService=q,this.globalStorageMainService=Y,this.configurationService=j,this.themeMainService=z,this.workspacesManagementMainService=G,this.backupMainService=$,this.telemetryService=F,this.dialogMainService=W,this.lifecycleMainService=A,this.productService=_,this.protocolMainService=U,this.windowsMainService=O,this._onWillLoad=this._register(new k.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new k.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new k.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new k.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[B,J]=this.restoreWindowState(V.state);this.windowState=B,this.logService.trace("window#ctor: using window state",B);const ee=this.windowState.mode===0||this.windowState.mode===3,oe=this.configurationService.getValue("window"),x={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:L.WindowMinimumSize.WIDTH,minHeight:L.WindowMinimumSize.HEIGHT,show:!ee,title:this.productService.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,L.zoomLevelToZoomFactor)(oe?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};p.isLinux?x.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):p.isWindows&&!this.environmentMainService.isBuilt&&(x.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),p.isMacintosh&&!this.useNativeFullScreen()&&(x.fullscreenable=!1),p.isMacintosh&&(x.acceptFirstMouse=!0,oe?.clickThroughInactive===!1&&(x.acceptFirstMouse=!1));const ce=p.isMacintosh&&oe?.nativeTabs===!0;ce&&(x.tabbingIdentifier=this.productService.nameShort);const le=(0,L.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(x.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,p.isMacintosh||(x.frame=!1)),(0,I.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(x),(0,I.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),p.isMacintosh&&le&&this._win.setSheetOffset(22),p.isMacintosh&&J&&(!ce||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ue=>typeof ue=="number")){const ue=this.windowState;this._win.setBounds({width:ue.width,height:ue.height,x:ue.x,y:ue.y})}ee&&((0,I.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,I.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(V){p.isMacintosh?this._win.setRepresentedFilename(V):this.representedFilename=V}getRepresentedFilename(){return p.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(V){p.isMacintosh&&this._win.setDocumentEdited(V),this.documentEdited=V}isDocumentEdited(){return p.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(V){p.isMacintosh&&V?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(V=>{if(this.isReady)return V(this);this.whenReadyCallbacks.push(V)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(V=>{function Z(){H.dispose(),q.dispose(),V()}const H=this.onDidClose(()=>Z()),q=this.onWillLoad(()=>Z())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(Y,j)=>this.onWindowError(2,j)),this._win.webContents.on("did-fail-load",(Y,j,z)=>this.onWindowError(3,{reason:z,exitCode:j})),this._win.webContents.on("will-prevent-unload",Y=>{Y.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const V=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,"devtools"]),Z=Y=>{for(let j=Y;j;j=j.parent)if(j.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1},H=Y=>Y.resourceType==="xhr"||Z(Y.frame);this._win.webContents.session.webRequest.onBeforeRequest((Y,j)=>{const z=y.URI.parse(Y.url);return z.path.endsWith(".svg")&&!V.has(z.scheme)?j({cancel:!H(Y)}):j({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((Y,j)=>{const z=Y.responseHeaders,G=z["content-type"]||z["Content-Type"];if(G&&Array.isArray(G)){const $=y.URI.parse(Y.url);if($.path.endsWith(".svg")&&V.has($.scheme))return z["Content-Type"]=["image/svg+xml"],j({cancel:!1,responseHeaders:z});if(!$.path.includes(m.Schemas.vscodeRemoteResource)&&G.some(F=>F.toLowerCase().includes("image/svg")))return j({cancel:!H(Y)})}return j({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",Y=>{this.currentConfig&&(this.currentConfig.maximized=!0),v.app.emit("browser-window-maximize",Y,this._win)}),this._win.on("unmaximize",Y=>{this.currentConfig&&(this.currentConfig.maximized=!1),v.app.emit("browser-window-unmaximize",Y,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(Y=>this.onDidDeleteUntitledWorkspace(Y)));const q=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:q},async(Y,j)=>{const z=await this.getMarketplaceHeaders();j({cancel:!1,requestHeaders:Object.assign(Y.requestHeaders,z)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,a.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(V,Z){switch(V){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${Z?.reason||"<unknown>"}, code: ${Z?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${Z?.reason||"<unknown>"}, code: ${Z?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:V,reason:Z?.reason,code:Z?.exitCode}),V){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(V===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const H=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(H.response!==1){const q=H.response===0;this.destroyWindow(q)}}else if(V===2){let H;Z?H=(0,t.localize)(6,null,Z.reason,Z.exitCode??"<unknown>"):H=(0,t.localize)(5,null);const Y=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,P.mnemonicButtonLabel)((0,t.localize)(8,null))],message:H,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(Y)}break}}destroyWindow(V){if(this._onDidDestroy.fire(),this._win?.destroy(),V&&this.config){let Z,H;(0,T.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?Z={folderUri:this.openedWorkspace.uri}:(0,T.isWorkspaceIdentifier)(this.openedWorkspace)?Z={workspaceUri:this.openedWorkspace.configPath}:H=!0;const[q]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:Z?[Z]:void 0,forceEmpty:H,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});q.focus()}}onDidDeleteUntitledWorkspace(V){this.openedWorkspace?.id===V.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const V=this.getMenuBarVisibility();V!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=V,this.setMenuBarVisibility(V));let Z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;Z?.endsWith("/")&&(Z=Z.substr(0,Z.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Z||"").indexOf("@")===-1&&(Z!==this.currentHttpProxy||H!==this.currentNoProxy)){this.currentHttpProxy=Z,this.currentNoProxy=H;const q=Z||"",Y=H?`${H},<local>`:"<local>";this.logService.trace(`Setting proxy to '${q}', bypassing '${Y}'`),this._win.webContents.session.setProxy({proxyRules:q,proxyBypassRules:Y,pacScript:""})}}addTabbedWindow(V){p.isMacintosh&&V.win&&this._win.addTabbedWindow(V.win)}load(V,Z=Object.create(null)){this.isDocumentEdited()&&(!Z.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Z.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(V,Z),this.readyState===0?this.currentConfig=V:(this.pendingLoadConfig=V,this.readyState=2),this._win.loadURL(m.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",K).toString(!0));const H=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new n.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:V.workspace,reason:Z.isReload?3:H?2:1})}updateConfiguration(V,Z){const H=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(H){const q=(0,c.isLaunchedFromCli)(H)&&!(0,c.isLaunchedFromCli)(V.userEnv),Y=this.isExtensionDevelopmentHost;(q||Y)&&(V.userEnv={...H,...V.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(V.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Z.disableExtensions!==void 0&&(V["disable-extensions"]=Z.disableExtensions),V.fullscreen=this.isFullScreen,V.maximized=this._win.isMaximized(),V.partsSplash=this.themeMainService.getWindowSplash(),(0,I.mark)("code/willOpenNewWindow"),V.perfMarks=(0,I.getMarks)(),this.configObjectUrl.update(V)}async reload(V){const Z=Object.assign({},this.currentConfig);Z.workspace=await this.validateWorkspaceBeforeReload(Z),delete Z.filesToOpenOrCreate,delete Z.filesToDiff,delete Z.filesToWait,this.isExtensionDevelopmentHost&&V&&(Z.verbose=V.verbose,Z.debugId=V.debugId,Z.extensionEnvironment=V.extensionEnvironment,Z["inspect-extensions"]=V["inspect-extensions"],Z["inspect-brk-extensions"]=V["inspect-brk-extensions"],Z["extensions-dir"]=V["extensions-dir"]),Z.isInitialStartup=!1,this.load(Z,{isReload:!0,disableExtensions:V?.["disable-extensions"]})}async validateWorkspaceBeforeReload(V){if((0,T.isWorkspaceIdentifier)(V.workspace)){const Z=V.workspace.configPath;if(Z.scheme===m.Schemas.file&&!await this.fileService.exists(Z))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(V.workspace)){const Z=V.workspace.uri;if(Z.scheme===m.Schemas.file&&!await this.fileService.exists(Z))return}return V.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let H;try{H=v.screen.getDisplayMatching(this.getBounds())}catch{}const q=(0,R.defaultWindowState)();return{mode:3,display:H?H.id:void 0,width:this.windowState.width||q.width,height:this.windowState.height||q.height,x:this.windowState.x||0,y:this.windowState.y||0}}const V=Object.create(null);let Z;if(!p.isMacintosh&&this._win.isMaximized()?Z=0:Z=1,Z===0?V.mode=0:V.mode=1,Z===1||Z===0){let H;Z===1?H=this.getBounds():H=this._win.getNormalBounds(),V.x=H.x,V.y=H.y,V.width=H.width,V.height=H.height}return V}restoreWindowState(V){(0,I.mark)("code/willRestoreCodeWindowState");let Z=!1;if(V)try{const H=v.screen.getAllDisplays();Z=H.length>1,V=this.validateWindowState(V,H)}catch(H){this.logService.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,I.mark)("code/didRestoreCodeWindowState"),[V||(0,R.defaultWindowState)(),Z]}validateWindowState(V,Z){if(this.logService.trace(`window#validateWindowState: validating window state on ${Z.length} display(s)`,V),typeof V.x!="number"||typeof V.y!="number"||typeof V.width!="number"||typeof V.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(V.width<=0||V.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Z.length===1){const Y=this.getWorkingArea(Z[0]);if(Y){let j=function(){!V||typeof V.x!="number"||typeof V.y!="number"||!Y||(V.x<Y.x&&(V.x=Y.x),V.y<Y.y&&(V.y=Y.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",Y),j(),V.width>Y.width&&(V.width=Y.width),V.height>Y.height&&(V.height=Y.height),V.x>Y.x+Y.width-128&&(V.x=Y.x+Y.width-V.width),V.y>Y.y+Y.height-128&&(V.y=Y.y+Y.height-V.height),j()}return V}if(V.display&&V.mode===3){const Y=Z.find(j=>j.id===V.display);if(Y&&typeof Y.bounds?.x=="number"&&typeof Y.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const j=(0,R.defaultWindowState)(3);return j.x=Y.bounds.x,j.y=Y.bounds.y,j}}let H,q;try{H=v.screen.getDisplayMatching({x:V.x,y:V.y,width:V.width,height:V.height}),q=this.getWorkingArea(H)}catch{}if(H&&q&&V.x+V.width>q.x&&V.y+V.height>q.y&&V.x<q.x+q.width&&V.y<q.y+q.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",q),V}getWorkingArea(V){if(V.workArea.width>0&&V.workArea.height>0)return V.workArea;if(V.bounds.width>0&&V.bounds.height>0)return V.bounds}getBounds(){const[V,Z]=this._win.getPosition(),[H,q]=this._win.getSize();return{x:V,y:Z,width:H,height:q}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(V){this.useNativeFullScreen()?this.setNativeFullScreen(V):this.setSimpleFullScreen(V),this.sendWhenReady(V?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(V){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(V)}setSimpleFullScreen(V){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(V),this._win.webContents.focus()}useNativeFullScreen(){const V=this.configurationService.getValue("window");return!V||typeof V.nativeFullScreen!="boolean"||V.nativeTabs?!0:V.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let V=(0,L.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(V)<0&&(V="classic"),V}setMenuBarVisibility(V,Z=!0){p.isMacintosh||(V==="toggle"&&Z&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),V==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(V)}):this.doSetMenuBarVisibility(V))}doSetMenuBarVisibility(V){const Z=this.isFullScreen;switch(V){case"classic":this._win.setMenuBarVisibility(!Z),this._win.autoHideMenuBar=Z;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(p.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(V,Z,...H){this.isReady?this.send(V,...H):this.ready().then(()=>{Z.isCancellationRequested||this.send(V,...H)})}send(V,...Z){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${V}' for window that is destroyed`);return}try{this._win.webContents.send(V,...Z)}catch(H){this.logService.warn(`Error sending IPC message to channel '${V}' of window ${this._id}: ${(0,C.toErrorMessage)(H)}`)}}}updateTouchBar(V){!p.isMacintosh||this.touchBarGroups.forEach((Z,H)=>{const q=V[H];Z.segments=this.createTouchBarGroupSegments(q)})}createTouchBar(){if(!!p.isMacintosh){for(let V=0;V<10;V++){const Z=this.createTouchBarGroup();this.touchBarGroups.push(Z)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(V=[]){const Z=this.createTouchBarGroupSegments(V),H=new v.TouchBar.TouchBarSegmentedControl({segments:Z,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:H.segments[q].id,from:"touchbar"})}});return H}createTouchBarGroupSegments(V=[]){return V.map(H=>{let q;H.icon&&!d.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===m.Schemas.file&&(q=v.nativeImage.createFromPath(y.URI.revive(H.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let Y;return typeof H.title=="string"?Y=H.title:Y=H.title.value,{id:H.id,label:q?void 0:Y,icon:q}})}dispose(){super.dispose(),this._win=null}};se=fe([re(1,h.ILogService),re(2,M.IEnvironmentMainService),re(3,l.IFileService),re(4,s.IGlobalStorageMainService),re(5,S.IConfigurationService),re(6,E.IThemeMainService),re(7,N.IWorkspacesManagementMainService),re(8,g.IBackupMainService),re(9,u.ITelemetryService),re(10,w.IDialogMainService),re(11,o.ILifecycleMainService),re(12,r.IProductService),re(13,i.IProtocolMainService),re(14,R.IWindowsMainService)],se),e.CodeWindow=se}),define(te[68],ie([0,1,14,31,8,4,33,2,10,3,16,7,24,159,5,20,6,38,78,30,45]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w,M,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let l=class Be extends P.Disposable{constructor(h,r,i,s,u){super();this.stateMainService=h,this.logService=r,this.workspacesManagementMainService=i,this.lifecycleMainService=s,this.globalStorageMainService=u,this._onDidChangeRecentlyOpened=this._register(new C.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(h=>this.addRecentlyOpened([{workspace:h.workspace,remoteAuthority:h.window.remoteAuthority}])))}async addRecentlyOpened(h){const r=[],i=[];for(let s of h)if((0,c.isRecentWorkspace)(s))!this.workspacesManagementMainService.isUntitledWorkspace(s.workspace)&&this.indexOfWorkspace(r,s.workspace)===-1&&r.push(s);else if((0,c.isRecentFolder)(s))this.indexOfFolder(r,s.folderUri)===-1&&r.push(s);else{const u=this.indexOfFile(i,s.fileUri)>=0,d=s.fileUri.scheme===f.Schemas.file&&Be.COMMON_FILES_FILTER.indexOf((0,b.basename)(s.fileUri))>=0;!u&&!d&&(i.push(s),m.isWindows&&s.fileUri.scheme===f.Schemas.file&&v.app.addRecentDocument(s.fileUri.fsPath))}await this.addEntriesFromStorage(r,i),r.length>Be.MAX_TOTAL_RECENT_ENTRIES&&(r.length=Be.MAX_TOTAL_RECENT_ENTRIES),i.length>Be.MAX_TOTAL_RECENT_ENTRIES&&(i.length=Be.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:r,files:i}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(h){const r=d=>{const E=this.location(d);for(const L of h)if(b.extUriBiasedIgnorePathCase.isEqual(L,E))return!1;return!0},i=await this.getRecentlyOpened(),s=i.workspaces.filter(r),u=i.files.filter(r);(s.length!==i.workspaces.length||u.length!==i.files.length)&&(await this.saveRecentlyOpened({files:u,workspaces:s}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(h){const r=[],i=[];if(h){const u=h.config?.workspace;(0,c.isWorkspaceIdentifier)(u)&&!this.workspacesManagementMainService.isUntitledWorkspace(u)?r.push({workspace:u,remoteAuthority:h.remoteAuthority}):(0,c.isSingleFolderWorkspaceIdentifier)(u)&&r.push({folderUri:u.uri,remoteAuthority:h.remoteAuthority})}const s=h?.config?.filesToOpenOrCreate;if(s)for(let u of s){const d=u.fileUri;d&&this.indexOfFile(i,d)===-1&&i.push({fileUri:d})}return await this.addEntriesFromStorage(r,i),{workspaces:r,files:i}}async addEntriesFromStorage(h,r){let i=await this.getRecentlyOpenedFromStorage();for(let s of i.workspaces){let u=(0,c.isRecentFolder)(s)?this.indexOfFolder(h,s.folderUri):this.indexOfWorkspace(h,s.workspace);u>=0?h[u].label=h[u].label||s.label:h.push(s)}for(let s of i.files){let u=this.indexOfFile(r,s.fileUri);u>=0?r[u].label=r[u].label||s.label:r.push(s)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let h;const r=this.globalStorageMainService.get(Be.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof r=="string")try{h=JSON.parse(r)}catch(i){this.logService.error("Unexpected error parsing opened paths list",i)}else h=this.stateMainService.getItem(Be.legacyRecentlyOpenedStorageKey),h&&(this.stateMainService.removeItem(Be.legacyRecentlyOpenedStorageKey),this.globalStorageMainService.store(Be.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify(h),0,1));return(0,c.restoreRecentlyOpened)(h,this.logService)}async saveRecentlyOpened(h){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store(Be.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,c.toStoreData)(h)),0,1)}location(h){return(0,c.isRecentFolder)(h)?h.folderUri:(0,c.isRecentFile)(h)?h.fileUri:h.workspace.configPath}indexOfWorkspace(h,r){return h.findIndex(i=>(0,c.isRecentWorkspace)(i)&&i.workspace.id===r.id)}indexOfFolder(h,r){return h.findIndex(i=>(0,c.isRecentFolder)(i)&&b.extUriBiasedIgnorePathCase.isEqual(i.folderUri,r))}indexOfFile(h,r){return h.findIndex(i=>b.extUriBiasedIgnorePathCase.isEqual(i.fileUri,r))}async handleWindowsJumpList(){!m.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!m.isWindows)return;const h=[];if(h.push({type:"tasks",items:[{type:"task",title:(0,y.localize)(0,null),description:(0,y.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let r=[];for(let u of v.app.getJumpListSettings().removedItems){const d=u.args;if(d){const E=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(d);E&&r.push(I.URI.parse(E[2]))}}await this.removeRecentlyOpened(r);let i=!1;const s=(0,n.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,Be.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(u=>{const d=(0,c.isRecentWorkspace)(u)?u.workspace:u.folderUri,{title:E,description:L}=this.getWindowsJumpListLabel(d,u.label);let R;return I.URI.isUri(d)?R=`--folder-uri "${d.toString()}"`:(i=!0,R=`--file-uri "${d.configPath.toString()}"`),{type:"task",title:E.substr(0,255),description:L.substr(0,255),program:process.execPath,args:R,iconPath:"explorer.exe",iconIndex:0}}));s.length>0&&h.push({type:"custom",name:i?(0,y.localize)(2,null):(0,y.localize)(3,null),items:s})}h.push({type:"recent"});try{v.app.setJumpList(h)}catch(r){this.logService.warn("updateWindowsJumpList#setJumpList",r)}}getWindowsJumpListLabel(h,r){if(r)return{title:(0,k.splitName)(r).name,description:r};if(I.URI.isUri(h))return{title:(0,b.basename)(h),description:this.renderJumpListPathDescription(h)};if(this.workspacesManagementMainService.isUntitledWorkspace(h))return{title:(0,y.localize)(4,null),description:""};let i=(0,b.basename)(h.configPath);return i.endsWith(c.WORKSPACE_EXTENSION)&&(i=i.substr(0,i.length-c.WORKSPACE_EXTENSION.length-1)),{title:(0,y.localize)(5,null,i),description:this.renderJumpListPathDescription(h.configPath)}}renderJumpListPathDescription(h){return h.scheme==="file"?(0,k.normalizeDriveLetter)(h.fsPath):h.toString()}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;v.app.clearRecentDocuments();const h=await this.getRecentlyOpened(),r=[];let i=0;for(let u=0;u<h.workspaces.length&&i<Be.MAX_MACOS_DOCK_RECENT_WORKSPACES;u++){const d=this.location(h.workspaces[u]);if(d.scheme===f.Schemas.file){const E=(0,b.originalFSPath)(d);await p.Promises.exists(E)&&(r.push(E),i++)}}const s=[];for(let u=0;u<h.files.length&&i<Be.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;u++){const d=this.location(h.files[u]);if(d.scheme===f.Schemas.file){const E=(0,b.originalFSPath)(d);if(Be.COMMON_FILES_FILTER.includes((0,b.basename)(d))||r.includes(E))continue;await p.Promises.exists(E)&&(s.push(E),i++)}}s.reverse().forEach(u=>v.app.addRecentDocument(u)),r.reverse().forEach(u=>v.app.addRecentDocument(u))}};l.MAX_TOTAL_RECENT_ENTRIES=500,l.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",l.legacyRecentlyOpenedStorageKey="openedPathsList",l.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,l.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,l.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,l.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],l=fe([re(0,w.IStateMainService),re(1,S.ILogService),re(2,a.IWorkspacesManagementMainService),re(3,g.ILifecycleMainService),re(4,M.IGlobalStorageMainService)],l),e.WorkspacesHistoryMainService=l}),define(te[242],ie([0,1,14,8,21,33,3,7,151,19,23,20,6,189,50,22,38,29,41,67,36,68]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w,M,c,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const o="menu";let h=class bt{constructor(s,u,d,E,L,R,T,N,Q,se,ne){this.updateService=s,this.configurationService=u,this.windowsMainService=d,this.environmentMainService=E,this.telemetryService=L,this.workspacesHistoryMainService=R,this.stateMainService=T,this.lifecycleMainService=N,this.logService=Q,this.nativeHostMainService=se,this.productService=ne,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new n.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new n.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(k.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(bt.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(R,T,N)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(R,T,N)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(R,T,N)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(N),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(R,T,N)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(N),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const u=this.productService.requestFeatureUrl;u&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(u,"openUserVoiceUrl"));const d=this.productService.reportIssueUrl;d&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(d,"openReportIssues"));const E=this.productService.licenseUrl;E&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(k.language){const R=E.indexOf("?")>0?"&":"?";this.openUrl(`${E}${R}lang=${k.language}`,"openLicenseUrl")}else this.openUrl(E,"openLicenseUrl")});const L=this.productService.privacyStatementUrl;L&&E&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(L,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!k.isMacintosh)return!1;let s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,u){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(bt.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!k.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!k.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=v.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(k.isMacintosh?new v.Menu:null);return}const u=new v.Menu;let d;if(k.isMacintosh){const L=new v.Menu;d=new v.MenuItem({label:this.productService.nameShort,submenu:L}),this.setMacApplicationMenu(L),u.append(d)}if(k.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const L=new v.Menu;L.append(new v.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(L)}if(this.shouldDrawMenu("File")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:L});this.setMenuById(L,"File"),u.append(R)}if(this.shouldDrawMenu("Edit")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:L});this.setMenuById(L,"Edit"),u.append(R)}if(this.shouldDrawMenu("Selection")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:L});this.setMenuById(L,"Selection"),u.append(R)}if(this.shouldDrawMenu("View")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:L});this.setMenuById(L,"View"),u.append(R)}if(this.shouldDrawMenu("Go")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:L});this.setMenuById(L,"Go"),u.append(R)}if(this.shouldDrawMenu("Run")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:L});this.setMenuById(L,"Run"),u.append(R)}if(this.shouldDrawMenu("Terminal")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:L});this.setMenuById(L,"Terminal"),u.append(R)}let E;if(this.shouldDrawMenu("Window")){const L=new v.Menu;E=new v.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:L,role:"window"}),this.setMacWindowMenu(L)}if(E&&u.append(E),this.shouldDrawMenu("Help")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:L,role:"help"});this.setMenuById(L,"Help"),u.append(R)}u.items&&u.items.length>0?v.Menu.setApplicationMenu(u):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const u=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),d=this.getUpdateMenuItems();let E;if(this.shouldDrawMenu("Preferences")){const V=new v.Menu;this.setMenuById(V,"Preferences"),E=new v.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:V})}const L=new v.Menu,R=new v.MenuItem({label:f.localize(12,null),role:"services",submenu:L}),T=new v.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),N=new v.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new v.MenuItem({label:f.localize(15,null),role:"unhide"}),se=new v.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const V=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||V?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),ne=[u];ne.push(...d),E&&ne.push(r(),E),ne.push(r(),R,r(),T,N,Q,r(),se),ne.forEach(V=>s.append(V))}shouldDrawMenu(s){if(!k.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,u){u.forEach(d=>{if((0,y.isMenubarMenuItemSeparator)(d))s.append(r());else if((0,y.isMenubarMenuItemSubmenu)(d)){const E=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(d.label),submenu:E});this.setMenu(E,d.submenu.items),s.append(L)}else(0,y.isMenubarMenuItemRecentAction)(d)?s.append(this.createOpenRecentMenuItem(d)):(0,y.isMenubarMenuItemAction)(d)&&(d.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),k.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[d.id]?s.append(new v.MenuItem(this.likeAction(d.id,{label:this.mnemonicLabel(d.label),click:this.fallbackMenuHandlers[d.id]}))):s.append(this.createMenuItem(d.label,d.id,!1,d.checked)):s.append(this.createMenuItem(d.label,d.id,d.enabled!==!1,!!d.checked)):s.append(this.createMenuItem(d.label,d.id,d.enabled!==!1,!!d.checked)))})}setMenuById(s,u){this.menubarMenus&&this.menubarMenus[u]&&this.setMenu(s,this.menubarMenus[u].items)}insertCheckForUpdatesItems(s){const u=this.getUpdateMenuItems();u.length&&(u.forEach(d=>s.append(d)),s.append(r()))}createOpenRecentMenuItem(s){const u=P.URI.revive(s.uri),d=s.id,E=d==="openRecentFile"?{fileUri:u}:d==="openRecentWorkspace"?{workspaceUri:u}:{folderUri:u};return new v.MenuItem(this.likeAction(d,{label:s.label,click:(L,R,T)=>{const N=this.isOptionClick(T);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[E],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:s.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([u])}},!1))}isOptionClick(s){return!!(s&&(!k.isMacintosh&&(s.ctrlKey||s.shiftKey)||k.isMacintosh&&(s.metaKey||s.altKey)))}createRoleMenuItem(s,u,d){const E={label:this.mnemonicLabel(s),role:d,enabled:!0};return new v.MenuItem(this.withKeybinding(u,E))}setMacWindowMenu(s){const u=new v.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),d=new v.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),E=new v.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),L=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),R=[];this.currentEnableNativeTabs&&(R.push(r()),R.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),R.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[u,d,r(),L,...R,r(),E].forEach(T=>s.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,u,d,E){const L=this.mnemonicLabel(s),R=typeof u=="function"?u:(ne,V,Z)=>{const H=ne?ne.userSettingsLabel:null;let q=u;Array.isArray(u)&&(q=this.isOptionClick(Z)?u[1]:u[0]),H&&Z.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:H}):this.runActionInRenderer({type:"commandId",commandId:q})},T=typeof d=="boolean"?d:this.windowsMainService.getWindowCount()>0,N=typeof E=="boolean"?E:!1,Q={label:L,click:R,enabled:T};N&&(Q.type="checkbox",Q.checked=N);let se;return typeof u=="string"?se=u:Array.isArray(u)&&(se=u[0]),k.isMacintosh&&(se==="editor.action.clipboardCutAction"?Q.role="cut":se==="editor.action.clipboardCopyAction"?Q.role="copy":se==="editor.action.clipboardPasteAction"&&(Q.role="paste"),se==="undo"?Q.click=this.makeContextAwareClickHandler(R,{inDevTools:ne=>ne.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?Q.click=this.makeContextAwareClickHandler(R,{inDevTools:ne=>ne.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(R,{inDevTools:ne=>ne.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(se,Q))}makeContextAwareClickHandler(s,u){return(d,E,L)=>{const R=v.BrowserWindow.getFocusedWindow();if(!R)return u.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return u.inDevTools(R.webContents.devToolsWebContents);s(d,E||R,L)}}runActionInRenderer(s){let u=v.BrowserWindow.getFocusedWindow();if(!u){const E=this.windowsMainService.getLastActiveWindow();E?.isMinimized()&&(u=E.win)}const d=u?this.windowsMainService.getWindowById(u.id):void 0;if(d){if(this.logService.trace("menubar#runActionInRenderer",s),k.isMacintosh&&!this.environmentMainService.isBuilt&&!d.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const E={id:s.commandId,from:"menu"};d.sendWhenReady("vscode:runAction",D.CancellationToken.None,E)}else{const E={userSettingsLabel:s.userSettingsLabel};d.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,E)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,u){const d=typeof s=="string"?this.keybindings[s]:void 0;if(d?.label){if(d.isNative!==!1)u.accelerator=d.label,u.userSettingsLabel=d.userSettingsLabel;else if(typeof u.label=="string"){const E=u.label.indexOf("[");E>=0?u.label=`${u.label.substr(0,E)} [${d.label}]`:u.label=`${u.label} [${d.label}]`}}else u.accelerator=void 0;return u}likeAction(s,u,d=!u.accelerator){d&&(u=this.withKeybinding(s,u));const E=u.click;return u.click=(L,R,T)=>{this.reportMenuActionTelemetry(s),E&&E(L,R,T)},u}openUrl(s,u){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(u)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:o})}mnemonicLabel(s){return(0,C.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};h.lastKnownMenubarStorageKey="lastKnownMenubarData",h=fe([re(0,M.IUpdateService),re(1,m.IConfigurationService),re(2,a.IWindowsMainService),re(3,b.IEnvironmentMainService),re(4,w.ITelemetryService),re(5,l.IWorkspacesHistoryMainService),re(6,S.IStateMainService),re(7,I.ILifecycleMainService),re(8,p.ILogService),re(9,t.INativeHostMainService),re(10,g.IProductService)],h),e.Menubar=h;function r(){return new v.MenuItem({type:"separator"})}}),define(te[243],ie([0,1,5,20,6,242]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let k=class{constructor(f,m,b){this.instantiationService=f,this.lifecycleMainService=m,this.logService=b,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(C.Menubar)}async updateMenubar(f,m){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(m,f)}};k=fe([re(0,v.IInstantiationService),re(1,n.ILifecycleMainService),re(2,D.ILogService)],k),e.MenubarMainService=k}),define(te[244],ie([0,1,14,28,26,31,21,4,27,42,33,2,10,9,63,3,34,16,13,7,157,52,19,49,23,18,5,20,6,55,22,56,64,38,67,241,99,223,30,100,68,45]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w,M,c,a,l,o,h,r,i,s,u,d,E,L,R,T,N,Q,se,ne,V,Z,H,q,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function j($){return(0,Z.isWorkspaceIdentifier)($?.workspace)}function z($){return(0,Z.isSingleFolderWorkspaceIdentifier)($?.workspace)}let G=class it extends I.Disposable{constructor(F,W,A,_,U,O,B,J,ee,oe,x,ce,le,ue,me){super();this.machineId=F,this.initialUserEnv=W,this.logService=A,this.stateMainService=_,this.environmentMainService=U,this.lifecycleMainService=O,this.backupMainService=B,this.configurationService=J,this.workspacesHistoryMainService=ee,this.workspacesManagementMainService=oe,this.instantiationService=x,this.dialogMainService=ce,this.fileService=le,this.productService=ue,this.protocolMainService=me,this._onDidOpenWindow=this._register(new P.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new P.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new P.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new P.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new V.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(F=>this._onDidSignalReadyWindow.fire(F.window))),this._register(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const W=new I.DisposableStore;if(W.add(P.Event.any(F.onDidClose,F.onDidDestroy)(()=>W.dispose())),F.config.extensionDevelopmentPath)for(const A of F.config.extensionDevelopmentPath)W.add(this.protocolMainService.addValidFileRoot(c.URI.file(A)));F.config.extensionTestsPath&&W.add(this.protocolMainService.addValidFileRoot(c.URI.file(F.config.extensionTestsPath)))}}))}openEmptyWindow(F,W){let A=this.environmentMainService.args;const _=W?.remoteAuthority||void 0,U=!0,O=W?.forceReuseWindow,B=!O;return this.open({...F,cli:A,forceEmpty:U,forceNewWindow:B,forceReuseWindow:O,remoteAuthority:_})}openExistingWindow(F,W){F.focus(),this.handleWaitMarkerFile(W,[F])}open(F){this.logService.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const W=[],A=[],_=[],U=[],O=[];let B,J=0;const ee=this.getPathsToOpen(F);this.logService.trace("windowsManager#open pathsToOpen",ee);for(const le of ee)z(le)?F.addMode?W.push(le):A.push(le):j(le)?_.push(le):le.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:le.remoteAuthority}),B.filesToOpenOrCreate.push(le)):le.backupPath?O.push({backupFolder:(0,y.basename)(le.backupPath),remoteAuthority:le.remoteAuthority}):J++;F.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),B&&F.waitMarkerFileURI&&(B.filesToWait={paths:[...B.filesToDiff,...B.filesToOpenOrCreate],waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(U.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),_.push(...U),O.push(...this.backupMainService.getEmptyWindowBackupPaths())):O.length=0;const{windows:oe,filesOpenedInWindow:x}=this.doOpen(F,_,A,O,J,B,W);if(this.logService.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${_.length}, foldersToOpen: ${A.length}, emptyToRestore: ${O.length}, emptyToOpen: ${J})`),oe.length>1)if(x)x.focus();else{const le=this.windowsStateHandler.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let ue=!0,me=!0;if(le){const Ee=oe.filter(de=>this.windowsStateHandler.state.lastActiveWindow&&de.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ee.length&&(Ee[0].focus(),ue=!1,me=!1)}if(ue)for(let Ee=oe.length-1;Ee>=0;Ee--){const de=oe[Ee];if(!(de.openedWorkspace&&U.some(ge=>de.openedWorkspace&&ge.workspace.id===de.openedWorkspace.id)||de.backupPath&&O.some(ge=>de.backupPath&&ge.backupFolder===(0,y.basename)(de.backupPath)))){de.focus(),me=!1;break}}me&&oe[oe.length-1].focus()}const ce=B&&B.filesToDiff.length>0;if(!oe.some(le=>le.isExtensionDevelopmentHost)&&!ce&&!F.noRecentEntry){const le=[];for(const ue of ee)j(ue)&&!ue.transient?le.push({label:ue.label,workspace:ue.workspace,remoteAuthority:ue.remoteAuthority}):z(ue)?le.push({label:ue.label,folderUri:ue.workspace.uri,remoteAuthority:ue.remoteAuthority}):ue.fileUri&&le.push({label:ue.label,fileUri:ue.fileUri,remoteAuthority:ue.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(le)}return this.handleWaitMarkerFile(F,oe),oe}handleWaitMarkerFile(F,W){const A=F.waitMarkerFileURI;F.context===0&&A&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.fileService.del(A)}catch{}})()}doOpen(F,W,A,_,U,O,B){const J=[];let ee;function oe(de,ge){J.push(de),ge&&(ee=de,O=void 0)}let{openFolderInNewWindow:x,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(F);if(!F.initialStartup&&B.length>0){const de=B[0].remoteAuthority,ge=this.getLastActiveWindowForAuthority(de);ge&&oe(this.doAddFoldersToExistingWindow(ge,B.map(we=>we.workspace.uri)))}const le=A.length+W.length+_.length;if(O&&le===0){const de=O.filesToOpenOrCreate[0]||O.filesToDiff[0],ge=this.getWindows().filter(ke=>O&&(0,w.isEqualAuthority)(ke.remoteAuthority,O.remoteAuthority));let we;de?.fileUri&&!ce&&((F.context===4||F.context===0||F.context===1)&&(we=(0,ne.findWindowOnFile)(ge,de.fileUri,ke=>ke.configPath.scheme===p.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),we||(we=this.doGetLastActiveWindow(ge))),we?(0,Z.isWorkspaceIdentifier)(we.openedWorkspace)?W.push({workspace:we.openedWorkspace,remoteAuthority:we.remoteAuthority}):(0,Z.isSingleFolderWorkspaceIdentifier)(we.openedWorkspace)?A.push({workspace:we.openedWorkspace,remoteAuthority:we.remoteAuthority}):oe(this.doOpenFilesInExistingWindow(F,we,O),!0):oe(this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:O,forceNewWindow:!0,remoteAuthority:O.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow}),!0)}const ue=(0,C.distinct)(W,de=>de.workspace.id);if(ue.length>0){const de=(0,C.coalesce)(ue.map(ge=>(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.configPath)));if(de.length>0){const ge=de[0],we=(0,w.isEqualAuthority)(O?.remoteAuthority,ge.remoteAuthority)?O:void 0;oe(this.doOpenFilesInExistingWindow(F,ge,we),!!we),x=!0}ue.forEach(ge=>{if(de.some(Ce=>Ce.openedWorkspace&&Ce.openedWorkspace.id===ge.workspace.id))return;const we=ge.remoteAuthority,ke=(0,w.isEqualAuthority)(O?.remoteAuthority,we)?O:void 0;oe(this.doOpenFolderOrWorkspace(F,ge,x,ke),!!ke),x=!0})}const me=(0,C.distinct)(A,de=>w.extUriBiasedIgnorePathCase.getComparisonKey(de.workspace.uri));if(me.length>0){const de=(0,C.coalesce)(me.map(ge=>(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.uri)));if(de.length>0){const ge=de[0],we=(0,w.isEqualAuthority)(O?.remoteAuthority,ge.remoteAuthority)?O:void 0;oe(this.doOpenFilesInExistingWindow(F,ge,we),!!we),x=!0}me.forEach(ge=>{if(de.some(Ce=>(0,Z.isSingleFolderWorkspaceIdentifier)(Ce.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(Ce.openedWorkspace.uri,ge.workspace.uri)))return;const we=ge.remoteAuthority,ke=(0,w.isEqualAuthority)(O?.remoteAuthority,we)?O:void 0;oe(this.doOpenFolderOrWorkspace(F,ge,x,ke),!!ke),x=!0})}const Ee=(0,C.distinct)(_,de=>de.backupFolder);if(Ee.length>0&&Ee.forEach(de=>{const ge=de.remoteAuthority,we=(0,w.isEqualAuthority)(O?.remoteAuthority,ge)?O:void 0;oe(this.doOpenEmpty(F,!0,ge,we,de),!!we),x=!0}),J.length===0||O){O&&!U&&U++;const de=O?O.remoteAuthority:F.remoteAuthority;for(let ge=0;ge<U;ge++)oe(this.doOpenEmpty(F,x,de,O),!!O),x=!0}return{windows:(0,C.distinct)(J),filesOpenedInWindow:ee}}doOpenFilesInExistingWindow(F,W,A){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:A}),W.focus();const _={filesToOpenOrCreate:A?.filesToOpenOrCreate,filesToDiff:A?.filesToDiff,filesToWait:A?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",k.CancellationToken.None,_),W}doAddFoldersToExistingWindow(F,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),F.focus();const A={foldersToAdd:W};return F.sendWhenReady("vscode:addFolders",k.CancellationToken.None,A),F}doOpenEmpty(F,W,A,_,U){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!U,remoteAuthority:A,filesToOpen:_,forceNewWindow:W});let O;return!W&&typeof F.contextWindowId=="number"&&(O=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:A,forceNewWindow:W,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:_,windowToUse:O,emptyWindowBackupInfo:U})}doOpenFolderOrWorkspace(F,W,A,_,U){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:_}),!A&&!U&&typeof F.contextWindowId=="number"&&(U=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:A,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:_,windowToUse:U})}getPathsToOpen(F){let W,A=!1,_=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(W=this.doExtractPathsFromAPI(F),A=!0):F.forceEmpty?W=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(W=this.doExtractPathsFromCLI(F.cli),W.length===0&&W.push(Object.create(null)),A=!0):(W=this.doGetPathsFromLastSession(),W.length===0&&W.push(Object.create(null)),_=!0),!F.addMode&&A){const U=W.filter(O=>z(O));if(U.length>1){const O=U[0].remoteAuthority;if(U.every(B=>(0,w.isEqualAuthority)(B.remoteAuthority,O))){const B=this.workspacesManagementMainService.createUntitledWorkspaceSync(U.map(J=>({uri:J.workspace.uri})));W.push({workspace:B,remoteAuthority:O}),W=W.filter(J=>!z(J))}}}return F.initialStartup&&!_&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&W.unshift(...this.doGetPathsFromLastSession().filter(U=>j(U)||z(U)||U.backupPath)),W}doExtractPathsFromAPI(F){const W=[],A={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority};for(const _ of(0,C.coalesce)(F.urisToOpen||[])){const U=this.resolveOpenable(_,A);if(U)U.label=_.label,W.push(U);else{const O=this.resourceFromOpenable(_),B={title:this.productService.nameLong,type:"info",buttons:[(0,b.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:O.scheme===p.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:O.scheme===p.Schemas.file?(0,a.localize)(3,null,(0,b.getPathLabel)(O.fsPath,this.environmentMainService)):(0,a.localize)(4,null,O.toString()),noLink:!0};this.dialogMainService.showMessageBox(B,(0,M.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(F){const W=[],A={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:!1},_=F["folder-uri"];if(_)for(const B of _){const J=this.cliArgToUri(B);if(J){const ee=this.resolveOpenable({folderUri:J},A);ee&&W.push(ee)}}const U=F["file-uri"];if(U)for(const B of U){const J=this.cliArgToUri(B);if(J){const ee=this.resolveOpenable((0,Z.hasWorkspaceFileExtension)(B)?{workspaceUri:J}:{fileUri:J},A);ee&&W.push(ee)}}const O=F._;for(const B of O){const J=A.remoteAuthority?this.doResolvePathRemote(B,A):this.doResolveFilePath(B,A);J&&W.push(J)}return W}cliArgToUri(F){try{const W=c.URI.parse(F);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${F}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${F}, ${W.message}`)}}doGetPathsFromLastSession(){const F=this.getRestoreWindowsSetting();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];F!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const A=[];for(const _ of W)if(_.workspace){const U=this.resolveOpenable({workspaceUri:_.workspace.configPath},{remoteAuthority:_.remoteAuthority,rejectTransientWorkspaces:!0});j(U)&&A.push(U)}else if(_.folderUri){const U=this.resolveOpenable({folderUri:_.folderUri},{remoteAuthority:_.remoteAuthority});z(U)&&A.push(U)}else F!=="folders"&&_.backupPath&&A.push({backupPath:_.backupPath,remoteAuthority:_.remoteAuthority});return A}}}getRestoreWindowsSetting(){let F;return this.lifecycleMainService.wasRestarted?F="all":(F=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}resolveOpenable(F,W=Object.create(null)){let A=this.resourceFromOpenable(F);return A.scheme===p.Schemas.file?((0,Q.isFileToOpen)(F)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(A.fsPath,W)):this.doResolveRemoteOpenable(F,W)}doResolveRemoteOpenable(F,W){let A=this.resourceFromOpenable(F);const _=(0,T.getRemoteAuthority)(A)||W.remoteAuthority;if(A=(0,w.removeTrailingPathSeparator)((0,w.normalizePath)(A)),(0,Q.isFileToOpen)(F)){if(W.gotoLineMode){const{path:U,line:O,column:B}=(0,f.parseLineAndColumnAware)(A.path);return{fileUri:A.with({path:U}),selection:O?{startLineNumber:O,startColumn:B||1}:void 0,remoteAuthority:_}}return{fileUri:A,remoteAuthority:_}}else if((0,Q.isWorkspaceToOpen)(F))return{workspace:(0,H.getWorkspaceIdentifier)(A),remoteAuthority:_};return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(A),remoteAuthority:_}}resourceFromOpenable(F){return(0,Q.isWorkspaceToOpen)(F)?F.workspaceUri:(0,Q.isFolderToOpen)(F)?F.folderUri:F.fileUri}doResolveFilePath(F,W){let A,_;W.gotoLineMode&&({path:F,line:A,column:_}=(0,f.parseLineAndColumnAware)(F)),F=(0,f.sanitizeFilePath)((0,y.normalize)(F),(0,S.cwd)());try{const U=(0,n.statSync)(F);if(U.isFile()){if(!W.forceOpenWorkspaceAsFile){const O=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.URI.file(F));if(O)return O.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:O.id,configPath:O.configPath},type:i.FileType.File,exists:!0,remoteAuthority:O.remoteAuthority,transient:O.transient}}return{fileUri:c.URI.file(F),type:i.FileType.File,exists:!0,selection:A?{startLineNumber:A,startColumn:_||1}:void 0}}else{if(U.isDirectory())return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(c.URI.file(F),U),type:i.FileType.Directory,exists:!0};if(!g.isWindows&&F==="/dev/null")return{fileUri:c.URI.file(F),type:i.FileType.File,exists:!0}}}catch{const O=c.URI.file(F);if(this.workspacesHistoryMainService.removeRecentlyOpened([O]),W.ignoreFileNotFound)return{fileUri:O,type:i.FileType.File,exists:!1}}}doResolvePathRemote(F,W){const A=F.charCodeAt(0),_=W.remoteAuthority;let U,O;W.gotoLineMode&&({path:F,line:U,column:O}=(0,f.parseLineAndColumnAware)(F)),A!==47&&((0,f.isWindowsDriveLetter)(A)&&F.charCodeAt(F.charCodeAt(1))===58&&(F=(0,f.toSlashes)(F)),F=`/${F}`);const B=c.URI.from({scheme:p.Schemas.vscodeRemote,authority:_,path:F});if(F.charCodeAt(F.length-1)!==47){if((0,Z.hasWorkspaceFileExtension)(F))return W.forceOpenWorkspaceAsFile?{fileUri:B,selection:U?{startLineNumber:U,startColumn:O||1}:void 0,remoteAuthority:W.remoteAuthority}:{workspace:(0,H.getWorkspaceIdentifier)(B),remoteAuthority:_};if(W.gotoLineMode||y.posix.basename(F).indexOf(".")!==-1)return{fileUri:B,selection:U?{startLineNumber:U,startColumn:O||1}:void 0,remoteAuthority:_}}return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:_}}shouldOpenNewWindow(F){const W=this.configurationService.getValue("window"),A=W?.openFoldersInNewWindow||"default",_=W?.openFilesInNewWindow||"off";let U=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(A==="on"||A==="off")&&(U=A==="on");let O=!1;return F.forceNewWindow||F.forceReuseWindow?O=!!F.forceNewWindow&&!F.forceReuseWindow:(g.isMacintosh?F.context===1&&(O=!0):F.context!==3&&F.context!==2&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(O=!0),!F.cli.extensionDevelopmentPath&&(_==="on"||_==="off")&&(O=_==="on")),{openFolderInNewWindow:!!U,openFilesInNewWindow:O}}openExtensionDevelopmentHostWindow(F,W){const A=(0,ne.findWindowOnExtensionDevelopmentPath)(this.getWindows(),F);if(A)return this.lifecycleMainService.reload(A,W.cli),A.focus(),[A];let _=W.cli["folder-uri"]||[],U=W.cli["file-uri"]||[],O=W.cli._;if(!O.length&&!_.length&&!U.length&&!W.cli.extensionTestsPath){const oe=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,x=oe&&(oe.workspace||oe.folderUri);x&&(c.URI.isUri(x)?x.scheme===p.Schemas.file?O=[x.fsPath]:_=[x.toString()]:x.configPath.scheme===p.Schemas.file?O=[(0,w.originalFSPath)(x.configPath)]:U=[x.configPath.toString()])}let B=W.remoteAuthority;for(const oe of F)if(oe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const x=c.URI.parse(oe),ce=(0,T.getRemoteAuthority)(x);ce&&(B?(0,w.isEqualAuthority)(ce,B)||this.logService.error("more than one extension development path authority"):B=ce)}O=O.filter(oe=>{const x=c.URI.file(oe);return(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),x)?!1:(0,w.isEqualAuthority)((0,T.getRemoteAuthority)(x),B)}),_=_.filter(oe=>{const x=this.cliArgToUri(oe);return x&&!!(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),x)?!1:x?(0,w.isEqualAuthority)((0,T.getRemoteAuthority)(x),B):!1}),U=U.filter(oe=>{const x=this.cliArgToUri(oe);return x&&!!(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),x)?!1:x?(0,w.isEqualAuthority)((0,T.getRemoteAuthority)(x),B):!1}),W.cli._=O,W.cli["folder-uri"]=_,W.cli["file-uri"]=U;const J=!O.length&&!_.length&&!U.length,ee={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:J,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:B};return this.open(ee)}openInBrowserWindow(F){const W=this.configurationService.getValue("window"),A={...this.environmentMainService.args,...F.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,y.join)(this.environmentMainService.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.initialUserEnv,...F.userEnv},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:E.default,isInitialStartup:F.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,autoDetectHighContrast:W?.autoDetectHighContrast??!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}};let _;if(!F.forceNewWindow&&!F.forceNewTabbedWindow&&(_=F.windowToUse||this.getLastActiveWindow(),_&&_.focus()),_){const U=_.config;!A.extensionDevelopmentPath&&U&&!!U.extensionDevelopmentPath&&(A.extensionDevelopmentPath=U.extensionDevelopmentPath,A.verbose=U.verbose,A["inspect-brk-extensions"]=U["inspect-brk-extensions"],A.debugId=U.debugId,A.extensionEnvironment=U.extensionEnvironment,A["inspect-extensions"]=U["inspect-extensions"],A["extensions-dir"]=U["extensions-dir"])}else{const U=this.windowsStateHandler.getNewWindowState(A);(0,t.mark)("code/willCreateCodeWindow");const O=_=this.instantiationService.createInstance(se.CodeWindow,{state:U,extensionDevelopmentPath:A.extensionDevelopmentPath,isExtensionTestHost:!!A.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow){const J=this.getLastActiveWindow();J&&J.addTabbedWindow(O)}it.WINDOWS.push(O),this._onDidOpenWindow.fire(O),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(O.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(O)),(0,m.once)(O.onDidClose)(()=>this.onWindowClosed(O)),(0,m.once)(O.onDidDestroy)(()=>this._onDidDestroyWindow.fire(O));const B=(0,M.assertIsDefined)(O.win?.webContents);B.removeAllListeners("devtools-reload-page"),B.on("devtools-reload-page",()=>this.lifecycleMainService.reload(O)),this.lifecycleMainService.registerWindow(O)}return A.windowId=_.id,_.isReady?this.lifecycleMainService.unload(_,4).then(U=>{U||this.doOpenInBrowserWindow(_,A,F)}):this.doOpenInBrowserWindow(_,A,F),_}doOpenInBrowserWindow(F,W,A){if(!W.extensionDevelopmentPath)if((0,Z.isWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if((0,Z.isSingleFolderWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority});else{const _=A.emptyWindowBackupInfo&&A.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(_,W.remoteAuthority)}F.load(W)}onWindowClosed(F){const W=it.WINDOWS.indexOf(F);it.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const F=v.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(F){return this.doGetLastActiveWindow(this.getWindows().filter(W=>(0,w.isEqualAuthority)(W.remoteAuthority,F)))}doGetLastActiveWindow(F){const W=Math.max.apply(Math,F.map(A=>A.lastFocusTime));return F.find(A=>A.lastFocusTime===W)}sendToFocused(F,...W){const A=this.getFocusedWindow()||this.getLastActiveWindow();A&&A.sendWhenReady(F,k.CancellationToken.None,...W)}sendToAll(F,W,A){for(const _ of this.getWindows())A&&A.indexOf(_.id)>=0||_.sendWhenReady(F,k.CancellationToken.None,W)}getWindows(){return it.WINDOWS}getWindowCount(){return it.WINDOWS.length}getWindowById(F){const W=this.getWindows().filter(A=>A.id===F);return(0,C.firstOrDefault)(W)}getWindowByWebContents(F){const W=v.BrowserWindow.fromWebContents(F);if(!!W)return this.getWindowById(W.id)}};G.WINDOWS=[],G=fe([re(2,d.ILogService),re(3,N.IStateMainService),re(4,r.IEnvironmentMainService),re(5,u.ILifecycleMainService),re(6,l.IBackupMainService),re(7,o.IConfigurationService),re(8,q.IWorkspacesHistoryMainService),re(9,Y.IWorkspacesManagementMainService),re(10,s.IInstantiationService),re(11,h.IDialogMainService),re(12,i.IFileService),re(13,L.IProductService),re(14,R.IProtocolMainService)],G),e.WindowsMainService=G}),define(te[245],ie([0,1,52,36,68,45]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let k=class{constructor(f,m,b,I){this.workspacesManagementMainService=f,this.windowsMainService=m,this.workspacesHistoryMainService=b,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,m){const b=this.windowsMainService.getWindowById(f);if(b)return this.workspacesManagementMainService.enterWorkspace(b,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(f,m,b){return this.workspacesManagementMainService.createUntitledWorkspace(m,b)}deleteUntitledWorkspace(f,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(f,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}addRecentlyOpened(f,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}removeRecentlyOpened(f,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};k=fe([re(0,C.IWorkspacesManagementMainService),re(1,n.IWindowsMainService),re(2,D.IWorkspacesHistoryMainService),re(3,v.IBackupMainService)],k),e.WorkspacesMainService=k}),define(te[246],ie([0,1,14,28,26,17,39,15,27,42,43,33,2,10,9,3,13,7,32,71,123,37,126,86,237,136,52,227,19,165,74,49,228,89,23,54,91,173,190,174,224,90,175,176,18,185,94,73,5,75,238,203,101,20,6,187,243,50,22,64,233,76,38,221,78,204,29,206,208,65,41,212,235,239,236,240,98,213,214,215,216,218,36,244,219,30,68,245,45]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w,M,c,a,l,o,h,r,i,s,u,d,E,L,R,T,N,Q,se,ne,V,Z,H,q,Y,j,z,G,$,F,W,A,_,U,O,B,J,ee,oe,x,ce,le,ue,me,Ee,de,ge,we,ke,Ce,_e,qe,Ne,He,wt,at,ct,lt,$e,je,X,ae,he,ve,Ie,Re,We,Ke,Ue,Fe,ze,Ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ye=class extends p.Disposable{constructor(pe,Se,be,ye,Pe,De,Me,Ae,Te,Xe){super();this.mainProcessNodeIpcServer=pe,this.userEnv=Se,this.mainInstantiationService=be,this.logService=ye,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Ae,this.fileService=Te,this.productService=Xe,this.configureSession(),this.registerListeners()}configureSession(){const pe=ye=>ye?.startsWith(`${y.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((ye,Pe,De,Me)=>pe(Me.requestingUrl)?De(Se.has(Pe)):De(!1)),v.session.defaultSession.setPermissionCheckHandler((ye,Pe,De,Me)=>pe(Me.requestingUrl)?Se.has(Pe):!1);const be=v.session.defaultSession;typeof be.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&be.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,P.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,P.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,P.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,a.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(be,ye)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ye)}),v.app.on("activate",(be,ye)=>{this.logService.trace("app#activate"),ye||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(be,ye)=>{ye.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),ye.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let pe=[],Se;v.app.on("open-file",(be,ye)=>{this.logService.trace("app#open-file: ",ye),be.preventDefault(),pe.push(this.getWindowOpenableFromPathSync(ye)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:pe,gotoLineMode:!1,preferNewWindow:!0}),pe=[],Se=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),v.ipcMain.handle("vscode:fetchShellEnv",be=>{const ye=this.windowsMainService?.getWindowByWebContents(be.sender);let Pe,De;return ye?.config?(Pe=ye.config,De={...process.env,...ye.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De,!1)}),v.ipcMain.handle("vscode:writeNlsFile",(be,ye,Pe)=>{const De=this.validateNlsPath([ye]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,C.VSBuffer.fromString(Pe))}),v.ipcMain.handle("vscode:readNlsFile",async(be,...ye)=>{const Pe=this.validateNlsPath(ye);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),v.ipcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),v.ipcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),v.ipcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(pe){let Se;for(const be of pe)typeof be=="string"&&(typeof Se!="string"?Se=be:Se=(0,t.join)(Se,be));if(!(typeof Se!="string"||!(0,t.isAbsolute)(Se)||!(0,f.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!g.isLinux)))return w.URI.file(Se)}onUnexpectedError(pe){if(pe){const Se={message:`[uncaught exception in main]: ${pe.message}`,stack:pe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${pe}`),pe.stack&&this.logService.error(pe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const pe=this.productService.win32AppUserModelId;g.isWindows&&pe&&v.app.setAppUserModelId(pe);try{g.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.logService.error(Te)}const Se=new o.Server;this.logService.trace("Resolving machine identifier...");const be=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:ye,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(be),Me=await this.initServices(be,ye,Pe);if(this.environmentMainService.driverHandle){const Te=await(0,T.serve)(Se,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Te)}this._register(Me.createInstance(r.ProxyAuthHandler)),Me.invokeFunction(Te=>this.initChannels(Te,Se,De));const Ae=Me.invokeFunction(Te=>this.openFirstWindow(Te,Se));Me.invokeFunction(Te=>this.afterWindowOpen(Te,ye)),this.environmentMainService.args.trace&&Me.invokeFunction(Te=>this.stopTracingEventually(Te,Ae))}async resolveMachineId(){let pe=this.stateMainService.getItem(Ce.machineIdKey);return(!pe||g.isMacintosh&&pe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(pe=await(0,c.getMachineId)(),this.stateMainService.setItem(Ce.machineIdKey,pe)),pe}setupSharedProcess(pe){const Se=this._register(this.mainInstantiationService.createInstance(me.SharedProcess,pe,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new h.Client(Pe,"main")})(),ye=(async()=>(await Se.whenReady(),be))();return{sharedProcess:Se,sharedProcessReady:ye,sharedProcessClient:be}}async initServices(pe,Se,be){const ye=new _.ServiceCollection;switch(process.platform){case"win32":ye.set(He.IUpdateService,new W.SyncDescriptor($e.Win32UpdateService));break;case"linux":g.isLinuxSnap?ye.set(He.IUpdateService,new W.SyncDescriptor(lt.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ye.set(He.IUpdateService,new W.SyncDescriptor(ct.LinuxUpdateService));break;case"darwin":ye.set(He.IUpdateService,new W.SyncDescriptor(at.DarwinUpdateService));break}ye.set(Re.IWindowsMainService,new W.SyncDescriptor(We.WindowsMainService,[pe,this.userEnv])),ye.set(R.IDialogMainService,new W.SyncDescriptor(R.DialogMainService)),ye.set(B.ILaunchMainService,new W.SyncDescriptor(B.LaunchMainService)),ye.set(L.IDiagnosticsService,l.ProxyChannel.toService((0,l.getDelayedChannel)(be.then(De=>De.getChannel("diagnostics"))))),ye.set(U.IIssueMainService,new W.SyncDescriptor(U.IssueMainService,[this.userEnv])),ye.set(N.IEncryptionMainService,new W.SyncDescriptor(N.EncryptionMainService,[pe])),ye.set(O.IKeyboardLayoutMainService,new W.SyncDescriptor(O.KeyboardLayoutMainService)),ye.set(ce.INativeHostMainService,new W.SyncDescriptor(ce.NativeHostMainService,[Se])),ye.set(ve.IWebviewManagerService,new W.SyncDescriptor(Ie.WebviewMainService)),ye.set(Ue.IWorkspacesService,new W.SyncDescriptor(ze.WorkspacesMainService)),ye.set(Ve.IWorkspacesManagementMainService,new W.SyncDescriptor(Ve.WorkspacesManagementMainService)),ye.set(Fe.IWorkspacesHistoryMainService,new W.SyncDescriptor(Fe.WorkspacesHistoryMainService)),ye.set(x.IMenubarMainService,new W.SyncDescriptor(x.MenubarMainService)),ye.set(V.IExtensionUrlTrustService,new W.SyncDescriptor(Z.ExtensionUrlTrustService)),ye.set(H.IExtensionHostStarter,new W.SyncDescriptor(q.WorkerMainProcessExtensionHostStarter)),ye.set(we.IStorageMainService,new W.SyncDescriptor(we.StorageMainService)),ye.set(we.IGlobalStorageMainService,new W.SyncDescriptor(we.GlobalStorageMainService)),g.isWindows?ye.set(Y.IExternalTerminalMainService,new W.SyncDescriptor(j.WindowsExternalTerminalService)):g.isMacintosh?ye.set(Y.IExternalTerminalMainService,new W.SyncDescriptor(j.MacExternalTerminalService)):g.isLinux&&ye.set(Y.IExternalTerminalMainService,new W.SyncDescriptor(j.LinuxExternalTerminalService));const Pe=new u.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ye.set(s.IBackupMainService,Pe),ye.set(je.IURLService,new W.SyncDescriptor(ae.NativeURLService)),(0,Ne.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,l.getDelayedChannel)(be.then(Je=>Je.getChannel("telemetryAppender"))),Me=new _e.TelemetryAppenderClient(De),Ae=(0,ke.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,pe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Te=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Xe={appenders:[Me],commonProperties:Ae,piiPaths:Te,sendErrorTelemetry:!0};ye.set(Ce.ITelemetryService,new W.SyncDescriptor(qe.TelemetryService,[Xe]))}else ye.set(Ce.ITelemetryService,Ne.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(ye)}initChannels(pe,Se,be){const ye=l.ProxyChannel.fromService(pe.get(B.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ye);const Pe=this.fileService.getProvider(y.Schemas.file);(0,S.assertType)(Pe instanceof F.DiskFileSystemProvider);const De=new $.DiskFileSystemProviderChannel(Pe,this.logService);Se.registerChannel(z.LOCAL_FILE_SYSTEM_CHANNEL_NAME,De),be.then(Le=>Le.registerChannel(z.LOCAL_FILE_SYSTEM_CHANNEL_NAME,De));const Me=new wt.UpdateChannel(pe.get(He.IUpdateService));Se.registerChannel("update",Me);const Ae=l.ProxyChannel.fromService(pe.get(U.IIssueMainService));Se.registerChannel("issue",Ae);const Te=l.ProxyChannel.fromService(pe.get(N.IEncryptionMainService));Se.registerChannel("encryption",Te);const Xe=l.ProxyChannel.fromService(pe.get(Ee.ISignService));Se.registerChannel("sign",Xe);const Je=l.ProxyChannel.fromService(pe.get(O.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",Je),this.nativeHostMainService=pe.get(ce.INativeHostMainService);const xe=l.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",xe),be.then(Le=>Le.registerChannel("nativeHost",xe));const nt=l.ProxyChannel.fromService(pe.get(Ue.IWorkspacesService));Se.registerChannel("workspaces",nt);const pt=l.ProxyChannel.fromService(pe.get(x.IMenubarMainService));Se.registerChannel("menubar",pt);const Oe=l.ProxyChannel.fromService(pe.get(je.IURLService));Se.registerChannel("url",Oe);const ht=l.ProxyChannel.fromService(pe.get(V.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",ht);const rt=l.ProxyChannel.fromService(pe.get(ve.IWebviewManagerService));Se.registerChannel("webview",rt);const Ze=this._register(new ge.StorageDatabaseChannel(this.logService,pe.get(we.IStorageMainService)));Se.registerChannel("storage",Ze),be.then(Le=>Le.registerChannel("storage",Ze));const dt=l.ProxyChannel.fromService(pe.get(Y.IExternalTerminalMainService));Se.registerChannel("externalTerminal",dt);const st=new oe.LogLevelChannel(pe.get(ee.ILogService));Se.registerChannel("logLevel",st),be.then(Le=>Le.registerChannel("logLevel",st));const et=new oe.LoggerChannel(pe.get(ee.ILoggerService));Se.registerChannel("logger",et),be.then(Le=>Le.registerChannel("logger",et));const ot=new E.ElectronExtensionHostDebugBroadcastChannel(pe.get(Re.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",ot);const ft=l.ProxyChannel.fromService(pe.get(H.IExtensionHostStarter));Se.registerChannel(H.ipcExtensionHostStarterChannelName,ft)}openFirstWindow(pe,Se){const be=this.windowsMainService=pe.get(Re.IWindowsMainService),ye=pe.get(je.IURLService),Pe=pe.get(ce.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Le=>{try{return{uri:w.URI.parse(Le),url:Le}}catch{return}}).filter(Le=>{if(!Le||this.shouldBlockURI(Le.uri))return!1;const tt=this.getWindowOpenableFromProtocolLink(Le.uri);return tt?(De.push(tt),!1):!0}),Ae=this,Te=this.environmentMainService,Xe=this.productService;ye.registerHandler({async handleURL(Le,tt){if(Le.scheme===Xe.urlProtocol&&Le.path==="workspace"&&(Le=Le.with({authority:"file",path:w.URI.parse(Le.query).path,query:""})),Ae.shouldBlockURI(Le))return!0;const Et=Ae.getWindowOpenableFromProtocolLink(Le);if(Et){const[vt]=be.open({context:5,cli:{...Te.args},urisToOpen:[Et],gotoLineMode:!0});return vt.focus(),!0}if(g.isMacintosh&&be.getWindowCount()===0){const[vt]=be.open({context:5,cli:{...Te.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ue.getRemoteAuthority)(Le)});return await vt.ready(),ye.open(Le,tt)}return!1}});const Je=this._register(new Ke.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),xe=new l.StaticRouter(Le=>Je.getActiveClientId().then(tt=>Le===tt)),nt=new X.URLHandlerRouter(xe),pt=Se.getChannel("urlHandler",nt);ye.registerHandler(new X.URLHandlerChannelClient(pt)),this._register(new he.ElectronURLListener(Me,ye,be,this.environmentMainService,this.productService));const Oe=this.environmentMainService.args,ht=global.macOpenFiles,rt=(0,se.isLaunchedFromCli)(process.env)?0:4,Ze=Oe._.length,dt=!!Oe["folder-uri"],st=!!Oe["file-uri"],et=Oe["skip-add-to-recently-opened"]===!0,ot=Oe.wait&&Oe.waitMarkerFilePath?w.URI.file(Oe.waitMarkerFilePath):void 0,ft=Oe.remote||void 0;return De.length>0?be.open({context:rt,cli:Oe,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Oe["new-window"]&&!Ze&&!dt&&!st?be.open({context:rt,cli:Oe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:et,waitMarkerFileURI:ot,initialStartup:!0,remoteAuthority:ft}):ht.length&&!Ze&&!dt&&!st?be.open({context:1,cli:Oe,urisToOpen:ht.map(Le=>this.getWindowOpenableFromPathSync(Le)),noRecentEntry:et,waitMarkerFileURI:ot,initialStartup:!0}):be.open({context:rt,cli:Oe,forceNewWindow:Oe["new-window"]||!Ze&&Oe["unity-launch"],diffMode:Oe.diff,noRecentEntry:et,waitMarkerFileURI:ot,gotoLineMode:Oe.goto,initialStartup:!0,remoteAuthority:ft})}shouldBlockURI(pe){return!!(pe.authority===y.Schemas.file&&g.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,I.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,I.getPathLabel)(pe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(pe){if(!!pe.path){if(pe.authority===y.Schemas.file){const Se=w.URI.file(pe.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Se)?{workspaceUri:Se}:{fileUri:Se}}else if(pe.authority===y.Schemas.vscodeRemote){const Se=pe.path.indexOf(t.posix.sep,1);if(Se!==-1){const be=pe.path.substring(1,Se),ye=pe.path.substring(Se),Pe=w.URI.from({scheme:y.Schemas.vscodeRemote,authority:be,path:ye,query:pe.query,fragment:pe.fragment});return(0,Ue.hasWorkspaceFileExtension)(ye)?{workspaceUri:Pe}:/:[\d]+$/.test(ye)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(pe){try{if((0,n.statSync)(pe).isDirectory())return{folderUri:w.URI.file(pe)};if((0,Ue.hasWorkspaceFileExtension)(pe))return{workspaceUri:w.URI.file(pe)}}catch{}return{fileUri:w.URI.file(pe)}}async afterWindowOpen(pe,Se){this.lifecycleMainService.phase=3;let be=!1;(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0);const ye=pe.get(Ce.ITelemetryService);this._register(Se.onDidError(({type:Me,details:Ae})=>{let Te;switch(Me){case 1:Te="SharedProcess: detected unresponsive window";break;case 2:Te=`SharedProcess: crashed (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break;case 3:Te=`SharedProcess: failed to load (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error(Te)),ye.publicLog2("sharedprocesserror",{type:Me,reason:Ae?.reason,code:Ae?.exitCode,visible:Se.isVisible(),shuttingdown:be})}));const Pe=this.productService.win32MutexName;if(g.isWindows&&Pe)try{const Me=K.__$__nodeRequire("windows-mutex").Mutex,Ae=new Me(Pe);(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>Ae.release())}catch(Me){this.logService.error(Me)}v.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Me,Ae)=>{Ae({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=pe.get(He.IUpdateService);(De instanceof $e.Win32UpdateService||De instanceof ct.LinuxUpdateService||De instanceof at.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Ae=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,b.stripComments)(Ae))["enable-crash-reporter"]===void 0){const Je=(0,Ne.getTelemetryLevel)(this.configurationService)>=1,xe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Je},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,M.generateUuid)()}"`,"}"],nt=Ae.substring(0,Ae.length-2).concat(`,
`,xe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(nt))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(pe,Se,be){try{return await(0,ne.getResolvedShellEnv)(this.logService,pe,Se)}catch(ye){const Pe=(0,k.toErrorMessage)(ye);be?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.logService.error(Pe)}return{}}stopTracingEventually(pe,Se){this.logService.info("Tracing: waiting for windows to get ready...");const be=pe.get(R.IDialogMainService);let ye=!1;const Pe=async Me=>{if(ye)return;ye=!0;const Ae=await v.contentTracing.stopRecording(`${(0,f.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ae}`):be.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,i.localize)(4,null),detail:(0,i.localize)(5,null,Ae),buttons:[(0,I.mnemonicButtonLabel)((0,i.localize)(6,null))],defaultId:0,noLink:!0},(0,S.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(Se.map(Me=>Me.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};Ye=fe([re(2,A.IInstantiationService),re(3,ee.ILogService),re(4,Q.IEnvironmentMainService),re(5,J.ILifecycleMainService),re(6,d.IConfigurationService),re(7,de.IStateMainService),re(8,G.IFileService),re(9,le.IProductService)],Ye),e.CodeApplication=Ye}),define(te[253],ie([0,1,14,28,31,8,39,15,27,42,33,10,9,63,3,34,25,24,37,58,246,11,19,194,205,23,54,168,18,184,94,73,178,75,20,95,6,188,96,55,22,56,191,97,230,48,232,76,202,38,234,65,66,211]),function(K,e,v,n,D,C,k,P,f,m,b,I,p,y,t,g,S,w,M,c,a,l,o,h,r,i,s,u,d,E,L,R,T,N,Q,se,ne,V,Z,H,q,Y,j,z,G,$,F,W,A,_,U,O,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class J{main(){try{this.startup()}catch(x){console.error(x.message),v.app.exit(1)}}async startup(){(0,P.setUnexpectedErrorHandler)(ge=>console.error(ge));const[x,ce,le,ue,me,Ee,de]=this.createServices();try{try{await this.initServices(le,ue,me)}catch(ge){throw this.handleStartupDataDirError(le,de.nameLong,ge),ge}await x.invokeFunction(async ge=>{const we=ge.get(ne.ILogService),ke=ge.get(Q.ILifecycleMainService),Ce=ge.get(d.IFileService),_e=await this.claimInstance(we,le,ke,x,de,!0);return w.Promises.writeFile(le.mainLockfile,String(process.pid)).catch(qe=>{we.warn(`Error writing main lockfile: ${qe.stack}`)}),Ee.logger=new Z.SpdLogLogger("main",(0,p.join)(le.logsPath,"main.log"),!0,!1,Ee.getLevel()),(0,m.once)(ke.onWillShutdown)(qe=>{Ce.dispose(),ue.dispose(),qe.join(w.Promises.unlink(le.mainLockfile).catch(()=>{}))}),x.createInstance(a.CodeApplication,_e,ce).startup()})}catch(ge){x.invokeFunction(this.quit,ge)}}createServices(){const x=new N.ServiceCollection,ce={_serviceBrand:void 0,...H.default};x.set(q.IProductService,ce);const le=new i.EnvironmentMainService(this.resolveArgs(),ce),ue=this.patchEnvironment(le);x.set(i.IEnvironmentMainService,le);const me=new se.BufferLogService,Ee=new ne.MultiplexLogService([new ne.ConsoleMainLogger((0,ne.getLogLevel)(le)),me]);process.once("exit",()=>Ee.dispose()),x.set(ne.ILogService,Ee);const de=new E.FileService(Ee);x.set(d.IFileService,de);const ge=new L.DiskFileSystemProvider(Ee);de.registerProvider(I.Schemas.file,ge),x.set(ne.ILoggerService,new V.LoggerService(Ee,de));const we=new h.ConfigurationService(le.settingsResource,de);x.set(o.IConfigurationService,we),x.set(Q.ILifecycleMainService,new R.SyncDescriptor(Q.LifecycleMainService));const ke=new U.StateMainService(le,Ee,de);return x.set(_.IStateMainService,ke),x.set($.IRequestService,new R.SyncDescriptor(F.RequestMainService)),x.set(B.IThemeMainService,new R.SyncDescriptor(B.ThemeMainService)),x.set(W.ISignService,new R.SyncDescriptor(A.SignService)),x.set(z.ITunnelService,new R.SyncDescriptor(G.TunnelService)),x.set(Y.IProtocolMainService,new R.SyncDescriptor(j.ProtocolMainService)),[new T.InstantiationService(x,!0),ue,le,we,ke,me,ce]}patchEnvironment(x){const ce={VSCODE_IPC_HOOK:x.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(le=>{const ue=process.env[le];typeof ue=="string"&&(ce[le]=ue)}),Object.assign(process.env,ce),ce}initServices(x,ce,le){return C.Promises.settled([Promise.all([x.extensionsPath,x.codeCachePath,x.logsPath,x.globalStorageHome.fsPath,x.workspaceStorageHome.fsPath,x.backupHome].map(ue=>ue?w.Promises.mkdir(ue,{recursive:!0}):void 0)),ce.initialize(),le.init()])}async claimInstance(x,ce,le,ue,me,Ee){let de;try{(0,y.mark)("code/willStartMainServer"),de=await(0,c.serve)(ce.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,m.once)(le.onWillShutdown)(()=>de.dispose())}catch(ge){if(ge.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,me.nameLong,ge),ge;let we;try{we=await(0,c.connect)(ce.mainIPCHandle,"main")}catch(_e){if(!Ee||t.isWindows||_e.code!=="ECONNREFUSED")throw _e.code==="EPERM"&&this.showStartupWarningDialog((0,l.localize)(0,null,me.nameShort),(0,l.localize)(1,null),me.nameLong),_e;try{(0,n.unlinkSync)(ce.mainIPCHandle)}catch(qe){throw x.warn("Could not delete obsolete instance handle",qe),qe}return this.claimInstance(x,ce,le,ue,me,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const _e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw x.error(_e),we.dispose(),new Error(_e)}let ke;!ce.args.wait&&!ce.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,l.localize)(2,null,me.nameShort),(0,l.localize)(3,null),me.nameLong)},1e4));const Ce=M.ProxyChannel.toService(we.getChannel("launch"),{disableMarshalling:!0});if(ce.args.status)return ue.invokeFunction(async()=>{const _e=new r.DiagnosticsService(O.NullTelemetryService,me),qe=await Ce.getMainProcessInfo(),Ne=await Ce.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),He=await _e.getDiagnostics(qe,Ne);throw console.log(He),new P.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Ce,x),x.trace("Sending env to running instance..."),await Ce.start(ce.args,process.env),we.dispose(),ke&&clearTimeout(ke),new P.ExpectedError("Sent env to running instance. Terminating...")}if(ce.args.status)throw x.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new P.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}handleStartupDataDirError(x,ce,le){if(le.code==="EACCES"||le.code==="EPERM"){const ue=(0,D.coalesce)([x.userDataPath,x.extensionsPath,c.XDG_RUNTIME_DIR]).map(me=>(0,b.getPathLabel)(me,x));this.showStartupWarningDialog((0,l.localize)(4,null),(0,l.localize)(5,null,(0,k.toErrorMessage)(le),ue.join(`
`)),ce)}}showStartupWarningDialog(x,ce,le){v.dialog.showMessageBoxSync({title:le,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,l.localize)(6,null))],message:x,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(x,ce){if(t.isWindows){const le=await x.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",le);try{(await new Promise((ue,me)=>{K(["windows-foreground-love"],ue,me)})).allowSetForegroundWindow(le)}catch(ue){ce.error(ue)}}}quit(x,ce){const le=x.get(ne.ILogService),ue=x.get(Q.ILifecycleMainService);let me=0;ce&&(ce.isExpected?ce.message&&le.trace(ce.message):(me=1,ce.stack?le.error(ce.stack):le.error(`Startup error: ${ce.toString()}`))),ue.kill(me)}resolveArgs(){const x=this.validatePaths((0,s.parseMainProcessArgv)(process.argv));if(x.wait&&!x.waitMarkerFilePath){const ce=(0,u.createWaitMarkerFile)(x.verbose);ce&&((0,s.addArg)(process.argv,"--waitMarkerFilePath",ce),x.waitMarkerFilePath=ce)}return x}validatePaths(x){if(x["open-url"]&&(x._urls=x._,x._=[]),!x.remote){const ce=this.doValidatePaths(x._,x.goto);x._=ce}return x}doValidatePaths(x,ce){const le=(0,g.cwd)(),ue=x.map(de=>{let ge=String(de),we;ce&&(we=(0,f.parseLineAndColumnAware)(ge),ge=we.path),ge&&(ge=this.preparePath(le,ge));const ke=(0,f.sanitizeFilePath)(ge,le),Ce=(0,p.basename)(ke);return Ce&&!(0,f.isValidBasename)(Ce)?null:ce&&we?(we.path=ke,this.toPath(we)):ke}),me=t.isWindows||t.isMacintosh,Ee=(0,D.distinct)(ue,de=>de&&me?de.toLowerCase():de||"");return(0,D.coalesce)(Ee)}preparePath(x,ce){return t.isWindows&&(ce=(0,S.rtrim)(ce,'"')),ce=(0,S.trim)((0,S.trim)(ce," "),"	"),t.isWindows&&(ce=(0,p.resolve)(x,ce),ce=(0,S.rtrim)(ce,".")),ce}toPath(x){const ce=[x.path];return typeof x.line=="number"&&ce.push(String(x.line)),typeof x.column=="number"&&ce.push(String(x.column)),ce.join(":")}}new J().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f0054e049cd286ff317c738efe0fd8810b48ae98/core/vs/code/electron-main/main.js.map
