/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/errors","vs/base/common/types","vs/base/common/event","vs/base/common/uri","vs/base/common/network","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/platform","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/base/common/strings","vs/platform/product/common/productService","os","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/files/common/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/common/iterator","graceful-fs","vs/platform/files/node/watcher/nodejs/nodejsWatcher","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(x){for(var t=[],L=0,D=x.length;L<D;L++)t[L]=Q[x[L]];return t};define(Q[54],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function L(D,S){if(!D)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}t.ok=L}),define(Q[44],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function L(C){return(b,l,m)=>{let P=null,O=null;if(typeof m.value=="function"?(P="value",O=m.value):typeof m.get=="function"&&(P="get",O=m.get),!O)throw new Error("not supported");m[P]=C(O,l)}}t.createDecorator=L;function D(C,b,l){let m=null,P=null;if(typeof l.value=="function"?(m="value",P=l.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(m="get",P=l.get),!P)throw new Error("not supported");const O=`$memoize$${b}`;l[m]=function(...g){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,g)}),this[O]}}t.memoize=D;function S(C,b,l){return L((m,P)=>{const O=`$debounce$${P}`,g=`$debounce$result$${P}`;return function(...I){this[g]||(this[g]=l?l():void 0),clearTimeout(this[O]),b&&(this[g]=b(this[g],...I),I=[this[g]]),this[O]=setTimeout(()=>{m.apply(this,I),this[g]=l?l():void 0},C)}})}t.debounce=S;function R(C,b,l){return L((m,P)=>{const O=`$throttle$timer$${P}`,g=`$throttle$result$${P}`,I=`$throttle$lastRun$${P}`,d=`$throttle$pending$${P}`;return function(...v){if(this[g]||(this[g]=l?l():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),b&&(this[g]=b(this[g],...v)),this[d])return;const h=this[I]+C;h<=Date.now()?(this[I]=Date.now(),m.apply(this,[this[g]]),this[g]=l?l():void 0):(this[d]=!0,this[O]=setTimeout(()=>{this[d]=!1,this[I]=Date.now(),m.apply(this,[this[g]]),this[g]=l?l():void 0},h-Date.now()))}})}t.throttle=R}),define(Q[55],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var L;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(L=t.ScanError||(t.ScanError={}));var D;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(D=t.SyntaxKind||(t.SyntaxKind={}));var S;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(S=t.ParseErrorCode||(t.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=t.ParseOptions||(t.ParseOptions={}));function C(n,o=!1){let e=0,i=n.length,s="",c=0,f=16,E=0;function y(te){let ge=0,W=0;for(;ge<te;){const $=n.charCodeAt(e);if($>=48&&$<=57)W=W*16+$-48;else if($>=65&&$<=70)W=W*16+$-65+10;else if($>=97&&$<=102)W=W*16+$-97+10;else break;e++,ge++}return ge<te&&(W=-1),W}function T(te){e=te,s="",c=0,f=16,E=0}function k(){const te=e;if(n.charCodeAt(e)===48)e++;else for(e++;e<n.length&&m(n.charCodeAt(e));)e++;if(e<n.length&&n.charCodeAt(e)===46)if(e++,e<n.length&&m(n.charCodeAt(e)))for(e++;e<n.length&&m(n.charCodeAt(e));)e++;else return E=3,n.substring(te,e);let ge=e;if(e<n.length&&(n.charCodeAt(e)===69||n.charCodeAt(e)===101))if(e++,(e<n.length&&n.charCodeAt(e)===43||n.charCodeAt(e)===45)&&e++,e<n.length&&m(n.charCodeAt(e))){for(e++;e<n.length&&m(n.charCodeAt(e));)e++;ge=e}else E=3;return n.substring(te,ge)}function B(){let te="",ge=e;for(;;){if(e>=i){te+=n.substring(ge,e),E=2;break}const W=n.charCodeAt(e);if(W===34){te+=n.substring(ge,e),e++;break}if(W===92){if(te+=n.substring(ge,e),e++,e>=i){E=2;break}switch(n.charCodeAt(e++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const re=y(4);re>=0?te+=String.fromCharCode(re):E=4;break}default:E=5}ge=e;continue}if(W>=0&&W<=31)if(l(W)){te+=n.substring(ge,e),E=2;break}else E=6;e++}return te}function J(){if(s="",E=0,c=e,e>=i)return c=i,f=17;let te=n.charCodeAt(e);if(b(te)){do e++,s+=String.fromCharCode(te),te=n.charCodeAt(e);while(b(te));return f=15}if(l(te))return e++,s+=String.fromCharCode(te),te===13&&n.charCodeAt(e)===10&&(e++,s+=`
`),f=14;switch(te){case 123:return e++,f=1;case 125:return e++,f=2;case 91:return e++,f=3;case 93:return e++,f=4;case 58:return e++,f=6;case 44:return e++,f=5;case 34:return e++,s=B(),f=10;case 47:{const ge=e-1;if(n.charCodeAt(e+1)===47){for(e+=2;e<i&&!l(n.charCodeAt(e));)e++;return s=n.substring(ge,e),f=12}if(n.charCodeAt(e+1)===42){e+=2;const W=i-1;let $=!1;for(;e<W;){if(n.charCodeAt(e)===42&&n.charCodeAt(e+1)===47){e+=2,$=!0;break}e++}return $||(e++,E=1),s=n.substring(ge,e),f=13}return s+=String.fromCharCode(te),e++,f=16}case 45:if(s+=String.fromCharCode(te),e++,e===i||!m(n.charCodeAt(e)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=k(),f=11;default:for(;e<i&&se(te);)e++,te=n.charCodeAt(e);if(c!==e){switch(s=n.substring(c,e),s){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return s+=String.fromCharCode(te),e++,f=16}}function se(te){if(b(te)||l(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let te;do te=J();while(te>=12&&te<=15);return te}return{setPosition:T,getPosition:()=>e,scan:o?ie:J,getToken:()=>f,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>e-c,getTokenError:()=>E}}t.createScanner=C;function b(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function l(n){return n===10||n===13||n===8232||n===8233}function m(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function O(n,o){const e=[],i=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function E(y,T,k,B){c.value=y,c.offset=T,c.length=k,c.type=B,c.colonOffset=void 0,s=c}try{u(n,{onObjectBegin:(y,T)=>{if(o<=y)throw i;s=void 0,f=o>y,e.push("")},onObjectProperty:(y,T,k)=>{if(o<T||(E(y,T,k,"property"),e[e.length-1]=y,o<=T+k))throw i},onObjectEnd:(y,T)=>{if(o<=y)throw i;s=void 0,e.pop()},onArrayBegin:(y,T)=>{if(o<=y)throw i;s=void 0,e.push(0)},onArrayEnd:(y,T)=>{if(o<=y)throw i;s=void 0,e.pop()},onLiteralValue:(y,T,k)=>{if(o<T||(E(y,T,k,a(y)),o<=T+k))throw i},onSeparator:(y,T,k)=>{if(o<=T)throw i;if(y===":"&&s&&s.type==="property")s.colonOffset=T,f=!1,s=void 0;else if(y===","){const B=e[e.length-1];typeof B=="number"?e[e.length-1]=B+1:(f=!0,e[e.length-1]=""),s=void 0}}})}catch(y){if(y!==i)throw y}return{path:e,previousNode:s,isAtPropertyKey:f,matches:y=>{let T=0;for(let k=0;T<y.length&&k<e.length;k++)if(y[T]===e[k]||y[T]==="*")T++;else if(y[T]!=="**")return!1;return T===y.length}}}t.getLocation=O;function g(n,o=[],e=R.DEFAULT){let i=null,s=[];const c=[];function f(y){Array.isArray(s)?s.push(y):i!==null&&(s[i]=y)}return u(n,{onObjectBegin:()=>{const y={};f(y),c.push(s),s=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const y=[];f(y),c.push(s),s=y,i=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:f,onError:(y,T,k)=>{o.push({error:y,offset:T,length:k})}},e),s[0]}t.parse=g;function I(n,o=[],e=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function c(y){return i.children.push(y),y}u(n,{onObjectBegin:y=>{i=c({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,T,k)=>{i=c({type:"property",offset:T,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:T,length:k,parent:i})},onObjectEnd:(y,T)=>{i.length=y+T-i.offset,i=i.parent,s(y+T)},onArrayBegin:(y,T)=>{i=c({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,T)=>{i.length=y+T-i.offset,i=i.parent,s(y+T)},onLiteralValue:(y,T,k)=>{c({type:a(y),offset:T,length:k,parent:i,value:y}),s(T+k)},onSeparator:(y,T,k)=>{i.type==="property"&&(y===":"?i.colonOffset=T:y===","&&s(T))},onError:(y,T,k)=>{o.push({error:y,offset:T,length:k})}},e);const E=i.children[0];return E&&delete E.parent,E}t.parseTree=I;function d(n,o){if(!n)return;let e=n;for(let i of o)if(typeof i=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let s=!1;for(const c of e.children)if(Array.isArray(c.children)&&c.children[0].value===i){e=c.children[1],s=!0;break}if(!s)return}else{const s=i;if(e.type!=="array"||s<0||!Array.isArray(e.children)||s>=e.children.length)return;e=e.children[s]}return e}t.findNodeAtLocation=d;function v(n){if(!n.parent||!n.parent.children)return[];const o=v(n.parent);if(n.parent.type==="property"){const e=n.parent.children[0].value;o.push(e)}else if(n.parent.type==="array"){const e=n.parent.children.indexOf(n);e!==-1&&o.push(e)}return o}t.getNodePath=v;function h(n){switch(n.type){case"array":return n.children.map(h);case"object":{const o=Object.create(null);for(let e of n.children){const i=e.children[1];i&&(o[e.children[0].value]=h(i))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}t.getNodeValue=h;function p(n,o,e=!1){return o>=n.offset&&o<n.offset+n.length||e&&o===n.offset+n.length}t.contains=p;function w(n,o,e=!1){if(p(n,o,e)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=o;s++){const c=w(i[s],o,e);if(c)return c}return n}}t.findNodeAtOffset=w;function u(n,o,e=R.DEFAULT){const i=C(n,!1);function s(K){return K?()=>K(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(K){return K?ee=>K(ee,i.getTokenOffset(),i.getTokenLength()):()=>!0}const f=s(o.onObjectBegin),E=c(o.onObjectProperty),y=s(o.onObjectEnd),T=s(o.onArrayBegin),k=s(o.onArrayEnd),B=c(o.onLiteralValue),J=c(o.onSeparator),se=s(o.onComment),ie=c(o.onError),te=e&&e.disallowComments,ge=e&&e.allowTrailingComma;function W(){for(;;){const K=i.scan();switch(i.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:te||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(K){case 12:case 13:te?$(10):se();break;case 16:$(1);break;case 15:case 14:break;default:return K}}}function $(K,ee=[],G=[]){if(ie(K),ee.length+G.length>0){let fe=i.getToken();for(;fe!==17;){if(ee.indexOf(fe)!==-1){W();break}else if(G.indexOf(fe)!==-1)break;fe=W()}}}function re(K){const ee=i.getTokenValue();return K?B(ee):E(ee),W(),!0}function M(){switch(i.getToken()){case 11:{let K=0;try{K=JSON.parse(i.getTokenValue()),typeof K!="number"&&($(2),K=0)}catch{$(2)}B(K);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return W(),!0}function F(){return i.getToken()!==10?($(3,[],[2,5]),!1):(re(!1),i.getToken()===6?(J(":"),W(),ne()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function j(){f(),W();let K=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(K||$(4,[],[]),J(","),W(),i.getToken()===2&&ge)break}else K&&$(6,[],[]);F()||$(4,[],[2,5]),K=!0}return y(),i.getToken()!==2?$(7,[2],[]):W(),!0}function H(){T(),W();let K=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(K||$(4,[],[]),J(","),W(),i.getToken()===4&&ge)break}else K&&$(6,[],[]);ne()||$(4,[],[4,5]),K=!0}return k(),i.getToken()!==4?$(8,[4],[]):W(),!0}function ne(){switch(i.getToken()){case 3:return H();case 1:return j();case 10:return re(!0);default:return M()}}return W(),i.getToken()===17?e.allowEmptyContent?!0:($(4,[],[]),!1):ne()?(i.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}t.visit=u;function r(n,o){let e=C(n),i=[],s,c=0,f;do switch(f=e.getPosition(),s=e.scan(),s){case 12:case 13:case 17:c!==f&&i.push(n.substring(c,f)),o!==void 0&&i.push(e.getTokenValue().replace(/[^\r\n]/g,o)),c=e.getPosition();break}while(s!==17);return i.join("")}t.stripComments=r;function a(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=a}),function(){function x(S){const R=[];typeof S=="number"&&R.push("code/timeOrigin",S);function C(l){R.push(l,Date.now())}function b(){const l=[];for(let m=0;m<R.length;m+=2)l.push({name:R[m],startTime:R[m+1]});return l}return{mark:C,getMarks:b}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const C of performance.getEntriesByType("mark"))R.push({name:C.name,startTime:Math.round(S+C.startTime)});return R}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function L(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=t()),S.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),define(Q[56],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var L;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(L=t.Source||(t.Source={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D=t.TerminateResponseCode||(t.TerminateResponseCode={}));function S(R,...C){const b=C.reduce((P,O)=>(P[O]=!0,P),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(P=>!b[P]).forEach(P=>{for(let O=0;O<l.length;O++)if(P.search(l[O])!==-1){delete R[P];break}})}t.sanitizeProcessEnvironment=S}),function(x,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var L=t();for(var D in L)(typeof exports=="object"?exports:x)[D]=L[D]}}(typeof self!="undefined"?self:this,function(){return function(x){var t={};function L(D){if(t[D])return t[D].exports;var S=t[D]={i:D,l:!1,exports:{}};return x[D].call(S.exports,S,S.exports,L),S.l=!0,S.exports}return L.m=x,L.c=t,L.d=function(D,S,R){L.o(D,S)||Object.defineProperty(D,S,{enumerable:!0,get:R})},L.r=function(D){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,S){if(1&S&&(D=L(D)),8&S||4&S&&typeof D=="object"&&D&&D.__esModule)return D;var R=Object.create(null);if(L.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:D}),2&S&&typeof D!="string")for(var C in D)L.d(R,C,function(b){return D[b]}.bind(null,C));return R},L.n=function(D){var S=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(S,"a",S),S},L.o=function(D,S){return Object.prototype.hasOwnProperty.call(D,S)},L.p="",L(L.s=0)}([function(x,t,L){(function(D){var S;t=x.exports=G,S=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var A=Array.prototype.slice.call(arguments,0);A.unshift("SEMVER"),console.log.apply(console,A)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var R=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,b=t.re=[],l=t.src=[],m=0,P=m++;l[P]="0|[1-9]\\d*";var O=m++;l[O]="[0-9]+";var g=m++;l[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=m++;l[I]="("+l[P]+")\\.("+l[P]+")\\.("+l[P]+")";var d=m++;l[d]="("+l[O]+")\\.("+l[O]+")\\.("+l[O]+")";var v=m++;l[v]="(?:"+l[P]+"|"+l[g]+")";var h=m++;l[h]="(?:"+l[O]+"|"+l[g]+")";var p=m++;l[p]="(?:-("+l[v]+"(?:\\."+l[v]+")*))";var w=m++;l[w]="(?:-?("+l[h]+"(?:\\."+l[h]+")*))";var u=m++;l[u]="[0-9A-Za-z-]+";var r=m++;l[r]="(?:\\+("+l[u]+"(?:\\."+l[u]+")*))";var a=m++,n="v?"+l[I]+l[p]+"?"+l[r]+"?";l[a]="^"+n+"$";var o="[v=\\s]*"+l[d]+l[w]+"?"+l[r]+"?",e=m++;l[e]="^"+o+"$";var i=m++;l[i]="((?:<|>)?=?)";var s=m++;l[s]=l[O]+"|x|X|\\*";var c=m++;l[c]=l[P]+"|x|X|\\*";var f=m++;l[f]="[v=\\s]*("+l[c]+")(?:\\.("+l[c]+")(?:\\.("+l[c]+")(?:"+l[p]+")?"+l[r]+"?)?)?";var E=m++;l[E]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[w]+")?"+l[r]+"?)?)?";var y=m++;l[y]="^"+l[i]+"\\s*"+l[f]+"$";var T=m++;l[T]="^"+l[i]+"\\s*"+l[E]+"$";var k=m++;l[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=m++;l[B]="(?:~>?)";var J=m++;l[J]="(\\s*)"+l[B]+"\\s+",b[J]=new RegExp(l[J],"g");var se=m++;l[se]="^"+l[B]+l[f]+"$";var ie=m++;l[ie]="^"+l[B]+l[E]+"$";var te=m++;l[te]="(?:\\^)";var ge=m++;l[ge]="(\\s*)"+l[te]+"\\s+",b[ge]=new RegExp(l[ge],"g");var W=m++;l[W]="^"+l[te]+l[f]+"$";var $=m++;l[$]="^"+l[te]+l[E]+"$";var re=m++;l[re]="^"+l[i]+"\\s*("+o+")$|^$";var M=m++;l[M]="^"+l[i]+"\\s*("+n+")$|^$";var F=m++;l[F]="(\\s*)"+l[i]+"\\s*("+o+"|"+l[f]+")",b[F]=new RegExp(l[F],"g");var j=m++;l[j]="^\\s*("+l[f]+")\\s+-\\s+("+l[f]+")\\s*$";var H=m++;l[H]="^\\s*("+l[E]+")\\s+-\\s+("+l[E]+")\\s*$";var ne=m++;l[ne]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)S(K,l[K]),b[K]||(b[K]=new RegExp(l[K]));function ee(A,V){if(A instanceof G)return A;if(typeof A!="string"||A.length>R||!(V?b[e]:b[a]).test(A))return null;try{return new G(A,V)}catch{return null}}function G(A,V){if(A instanceof G){if(A.loose===V)return A;A=A.version}else if(typeof A!="string")throw new TypeError("Invalid Version: "+A);if(A.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof G))return new G(A,V);S("SemVer",A,V),this.loose=V;var _=A.trim().match(V?b[e]:b[a]);if(!_)throw new TypeError("Invalid Version: "+A);if(this.raw=A,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var me=+de;if(me>=0&&me<C)return me}return de}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}t.parse=ee,t.valid=function(A,V){var _=ee(A,V);return _?_.version:null},t.clean=function(A,V){var _=ee(A.trim().replace(/^[=v]+/,""),V);return _?_.version:null},t.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(A){return S("SemVer.compare",this.version,this.loose,A),A instanceof G||(A=new G(A,this.loose)),this.compareMain(A)||this.comparePre(A)},G.prototype.compareMain=function(A){return A instanceof G||(A=new G(A,this.loose)),U(this.major,A.major)||U(this.minor,A.minor)||U(this.patch,A.patch)},G.prototype.comparePre=function(A){if(A instanceof G||(A=new G(A,this.loose)),this.prerelease.length&&!A.prerelease.length)return-1;if(!this.prerelease.length&&A.prerelease.length)return 1;if(!this.prerelease.length&&!A.prerelease.length)return 0;var V=0;do{var _=this.prerelease[V],de=A.prerelease[V];if(S("prerelease compare",V,_,de),_===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(_===void 0)return-1;if(_!==de)return U(_,de)}while(++V)},G.prototype.inc=function(A,V){switch(A){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",V);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",V);break;case"prepatch":this.prerelease.length=0,this.inc("patch",V),this.inc("pre",V);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",V),this.inc("pre",V);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}V&&(this.prerelease[0]===V?isNaN(this.prerelease[1])&&(this.prerelease=[V,0]):this.prerelease=[V,0]);break;default:throw new Error("invalid increment argument: "+A)}return this.format(),this.raw=this.version,this},t.inc=function(A,V,_,de){typeof _=="string"&&(de=_,_=void 0);try{return new G(A,_).inc(V,de).version}catch{return null}},t.diff=function(A,V){if(X(A,V))return null;var _=ee(A),de=ee(V);if(_.prerelease.length||de.prerelease.length){for(var me in _)if((me==="major"||me==="minor"||me==="patch")&&_[me]!==de[me])return"pre"+me;return"prerelease"}for(var me in _)if((me==="major"||me==="minor"||me==="patch")&&_[me]!==de[me])return me},t.compareIdentifiers=U;var fe=/^[0-9]+$/;function U(A,V){var _=fe.test(A),de=fe.test(V);return _&&de&&(A=+A,V=+V),_&&!de?-1:de&&!_?1:A<V?-1:A>V?1:0}function N(A,V,_){return new G(A,_).compare(new G(V,_))}function q(A,V,_){return N(A,V,_)>0}function z(A,V,_){return N(A,V,_)<0}function X(A,V,_){return N(A,V,_)===0}function Y(A,V,_){return N(A,V,_)!==0}function he(A,V,_){return N(A,V,_)>=0}function ae(A,V,_){return N(A,V,_)<=0}function oe(A,V,_,de){var me;switch(V){case"===":typeof A=="object"&&(A=A.version),typeof _=="object"&&(_=_.version),me=A===_;break;case"!==":typeof A=="object"&&(A=A.version),typeof _=="object"&&(_=_.version),me=A!==_;break;case"":case"=":case"==":me=X(A,_,de);break;case"!=":me=Y(A,_,de);break;case">":me=q(A,_,de);break;case">=":me=he(A,_,de);break;case"<":me=z(A,_,de);break;case"<=":me=ae(A,_,de);break;default:throw new TypeError("Invalid operator: "+V)}return me}function le(A,V){if(A instanceof le){if(A.loose===V)return A;A=A.value}if(!(this instanceof le))return new le(A,V);S("comparator",A,V),this.loose=V,this.parse(A),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}t.rcompareIdentifiers=function(A,V){return U(V,A)},t.major=function(A,V){return new G(A,V).major},t.minor=function(A,V){return new G(A,V).minor},t.patch=function(A,V){return new G(A,V).patch},t.compare=N,t.compareLoose=function(A,V){return N(A,V,!0)},t.rcompare=function(A,V,_){return N(V,A,_)},t.sort=function(A,V){return A.sort(function(_,de){return t.compare(_,de,V)})},t.rsort=function(A,V){return A.sort(function(_,de){return t.rcompare(_,de,V)})},t.gt=q,t.lt=z,t.eq=X,t.neq=Y,t.gte=he,t.lte=ae,t.cmp=oe,t.Comparator=le;var ye={};function ue(A,V){if(A instanceof ue)return A.loose===V?A:new ue(A.raw,V);if(A instanceof le)return new ue(A.value,V);if(!(this instanceof ue))return new ue(A,V);if(this.loose=V,this.raw=A,this.set=A.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+A);this.format()}function Ee(A){return!A||A.toLowerCase()==="x"||A==="*"}function Se(A,V,_,de,me,Ce,be,Ae,Re,ke,Ue,De,Te){return((V=Ee(_)?"":Ee(de)?">="+_+".0.0":Ee(me)?">="+_+"."+de+".0":">="+V)+" "+(Ae=Ee(Re)?"":Ee(ke)?"<"+(+Re+1)+".0.0":Ee(Ue)?"<"+Re+"."+(+ke+1)+".0":De?"<="+Re+"."+ke+"."+Ue+"-"+De:"<="+Ae)).trim()}function Oe(A,V){for(var _=0;_<A.length;_++)if(!A[_].test(V))return!1;if(V.prerelease.length){for(_=0;_<A.length;_++)if(S(A[_].semver),A[_].semver!==ye&&A[_].semver.prerelease.length>0){var de=A[_].semver;if(de.major===V.major&&de.minor===V.minor&&de.patch===V.patch)return!0}return!1}return!0}function Fe(A,V,_){try{V=new ue(V,_)}catch{return!1}return V.test(A)}function ze(A,V,_,de){var me,Ce,be,Ae,Re;switch(A=new G(A,de),V=new ue(V,de),_){case">":me=q,Ce=ae,be=z,Ae=">",Re=">=";break;case"<":me=z,Ce=he,be=q,Ae="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(A,V,de))return!1;for(var ke=0;ke<V.set.length;++ke){var Ue=V.set[ke],De=null,Te=null;if(Ue.forEach(function(Ne){Ne.semver===ye&&(Ne=new le(">=0.0.0")),De=De||Ne,Te=Te||Ne,me(Ne.semver,De.semver,de)?De=Ne:be(Ne.semver,Te.semver,de)&&(Te=Ne)}),De.operator===Ae||De.operator===Re||(!Te.operator||Te.operator===Ae)&&Ce(A,Te.semver)||Te.operator===Re&&be(A,Te.semver))return!1}return!0}le.prototype.parse=function(A){var V=this.loose?b[re]:b[M],_=A.match(V);if(!_)throw new TypeError("Invalid comparator: "+A);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new G(_[2],this.loose):this.semver=ye},le.prototype.toString=function(){return this.value},le.prototype.test=function(A){return S("Comparator.test",A,this.loose),this.semver===ye||(typeof A=="string"&&(A=new G(A,this.loose)),oe(A,this.operator,this.semver,this.loose))},le.prototype.intersects=function(A,V){if(!(A instanceof le))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new ue(A.value,V),Fe(this.value,_,V);if(A.operator==="")return _=new ue(this.value,V),Fe(A.semver,_,V);var de=!(this.operator!==">="&&this.operator!==">"||A.operator!==">="&&A.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||A.operator!=="<="&&A.operator!=="<"),Ce=this.semver.version===A.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||A.operator!==">="&&A.operator!=="<="),Ae=oe(this.semver,"<",A.semver,V)&&(this.operator===">="||this.operator===">")&&(A.operator==="<="||A.operator==="<"),Re=oe(this.semver,">",A.semver,V)&&(this.operator==="<="||this.operator==="<")&&(A.operator===">="||A.operator===">");return de||me||Ce&&be||Ae||Re},t.Range=ue,ue.prototype.format=function(){return this.range=this.set.map(function(A){return A.join(" ").trim()}).join("||").trim(),this.range},ue.prototype.toString=function(){return this.range},ue.prototype.parseRange=function(A){var V=this.loose;A=A.trim(),S("range",A,V);var _=V?b[H]:b[j];A=A.replace(_,Se),S("hyphen replace",A),A=A.replace(b[F],"$1$2$3"),S("comparator trim",A,b[F]),A=(A=(A=A.replace(b[J],"$1~")).replace(b[ge],"$1^")).split(/\s+/).join(" ");var de=V?b[re]:b[M],me=A.split(" ").map(function(Ce){return function(be,Ae){return S("comp",be),be=function(Re,ke){return Re.trim().split(/\s+/).map(function(Ue){return function(De,Te){S("caret",De,Te);var Ne=Te?b[$]:b[W];return De.replace(Ne,function(Me,pe,we,Ie,Pe){var Le;return S("caret",De,Me,pe,we,Ie,Pe),Ee(pe)?Le="":Ee(we)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Ee(Ie)?Le=pe==="0"?">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+".0 <"+(+pe+1)+".0.0":Pe?(S("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ie+Pe+" <"+pe+"."+we+"."+(+Ie+1):">="+pe+"."+we+"."+Ie+Pe+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ie+Pe+" <"+(+pe+1)+".0.0"):(S("no pr"),Le=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ie+" <"+pe+"."+we+"."+(+Ie+1):">="+pe+"."+we+"."+Ie+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ie+" <"+(+pe+1)+".0.0"),S("caret return",Le),Le})}(Ue,ke)}).join(" ")}(be,Ae),S("caret",be),be=function(Re,ke){return Re.trim().split(/\s+/).map(function(Ue){return function(De,Te){var Ne=Te?b[ie]:b[se];return De.replace(Ne,function(Me,pe,we,Ie,Pe){var Le;return S("tilde",De,Me,pe,we,Ie,Pe),Ee(pe)?Le="":Ee(we)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Ee(Ie)?Le=">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":Pe?(S("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=">="+pe+"."+we+"."+Ie+Pe+" <"+pe+"."+(+we+1)+".0"):Le=">="+pe+"."+we+"."+Ie+" <"+pe+"."+(+we+1)+".0",S("tilde return",Le),Le})}(Ue,ke)}).join(" ")}(be,Ae),S("tildes",be),be=function(Re,ke){return S("replaceXRanges",Re,ke),Re.split(/\s+/).map(function(Ue){return function(De,Te){De=De.trim();var Ne=Te?b[T]:b[y];return De.replace(Ne,function(Me,pe,we,Ie,Pe,Le){S("xRange",De,Me,pe,we,Ie,Pe,Le);var We=Ee(we),Ve=We||Ee(Ie),je=Ve||Ee(Pe);return pe==="="&&je&&(pe=""),We?Me=pe===">"||pe==="<"?"<0.0.0":"*":pe&&je?(Ve&&(Ie=0),je&&(Pe=0),pe===">"?(pe=">=",Ve?(we=+we+1,Ie=0,Pe=0):je&&(Ie=+Ie+1,Pe=0)):pe==="<="&&(pe="<",Ve?we=+we+1:Ie=+Ie+1),Me=pe+we+"."+Ie+"."+Pe):Ve?Me=">="+we+".0.0 <"+(+we+1)+".0.0":je&&(Me=">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0"),S("xRange return",Me),Me})}(Ue,ke)}).join(" ")}(be,Ae),S("xrange",be),be=function(Re,ke){return S("replaceStars",Re,ke),Re.trim().replace(b[ne],"")}(be,Ae),S("stars",be),be}(Ce,V)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Ce){return!!Ce.match(de)})),me=me.map(function(Ce){return new le(Ce,V)})},ue.prototype.intersects=function(A,V){if(!(A instanceof ue))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(de){return A.set.some(function(me){return me.every(function(Ce){return de.intersects(Ce,V)})})})})},t.toComparators=function(A,V){return new ue(A,V).set.map(function(_){return _.map(function(de){return de.value}).join(" ").trim().split(" ")})},ue.prototype.test=function(A){if(!A)return!1;typeof A=="string"&&(A=new G(A,this.loose));for(var V=0;V<this.set.length;V++)if(Oe(this.set[V],A))return!0;return!1},t.satisfies=Fe,t.maxSatisfying=function(A,V,_){var de=null,me=null;try{var Ce=new ue(V,_)}catch{return null}return A.forEach(function(be){Ce.test(be)&&(de&&me.compare(be)!==-1||(me=new G(de=be,_)))}),de},t.minSatisfying=function(A,V,_){var de=null,me=null;try{var Ce=new ue(V,_)}catch{return null}return A.forEach(function(be){Ce.test(be)&&(de&&me.compare(be)!==1||(me=new G(de=be,_)))}),de},t.validRange=function(A,V){try{return new ue(A,V).range||"*"}catch{return null}},t.ltr=function(A,V,_){return ze(A,V,"<",_)},t.gtr=function(A,V,_){return ze(A,V,">",_)},t.outside=ze,t.prerelease=function(A,V){var _=ee(A,V);return _&&_.prerelease.length?_.prerelease:null},t.intersects=function(A,V,_){return A=new ue(A,_),V=new ue(V,_),A.intersects(V)},t.coerce=function(A){if(A instanceof G)return A;if(typeof A!="string")return null;var V=A.match(b[k]);return V==null?null:ee((V[1]||"0")+"."+(V[2]||"0")+"."+(V[3]||"0"))}}).call(this,L(1))},function(x,t){var L,D,S=x.exports={};function R(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function b(h){if(L===setTimeout)return setTimeout(h,0);if((L===R||!L)&&setTimeout)return L=setTimeout,setTimeout(h,0);try{return L(h,0)}catch{try{return L.call(null,h,0)}catch{return L.call(this,h,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:R}catch{L=R}try{D=typeof clearTimeout=="function"?clearTimeout:C}catch{D=C}})();var l,m=[],P=!1,O=-1;function g(){P&&l&&(P=!1,l.length?m=l.concat(m):O=-1,m.length&&I())}function I(){if(!P){var h=b(g);P=!0;for(var p=m.length;p;){for(l=m,m=[];++O<p;)l&&l[O].run();O=-1,p=m.length}l=null,P=!1,function(w){if(D===clearTimeout)return clearTimeout(w);if((D===C||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(w);try{D(w)}catch{try{return D.call(null,w)}catch{return D.call(this,w)}}}(h)}}function d(h,p){this.fun=h,this.array=p}function v(){}S.nextTick=function(h){var p=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)p[w-1]=arguments[w];m.push(new d(h,p)),m.length!==1||P||b(I)},d.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=v,S.addListener=v,S.once=v,S.off=v,S.removeListener=v,S.removeAllListeners=v,S.emit=v,S.prependListener=v,S.prependOnceListener=v,S.listeners=function(h){return[]},S.binding=function(h){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(h){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Q[57],Z([0,1]),function(x,t){"use strict";var L;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class D{constructor(b,l,m){this.level=b,this.key=l,this.value=m,this.forward=[]}}const S=void 0;class R{constructor(b,l=2**16){this.comparator=b,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new D(this._maxLevel,S,S)}get size(){return this._size}clear(){this._header=new D(this._maxLevel,S,S)}has(b){return Boolean(R._search(this,b,this.comparator))}get(b){return R._search(this,b,this.comparator)?.value}set(b,l){return R._insert(this,b,l,this.comparator)&&(this._size+=1),this}delete(b){const l=R._delete(this,b,this.comparator);return l&&(this._size-=1),l}forEach(b,l){let m=this._header.forward[0];for(;m;)b.call(l,m.value,m.key,this),m=m.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",l=this._header.forward[0];for(;l;)b+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return b}static _search(b,l,m){let P=b._header;for(let O=b._level-1;O>=0;O--)for(;P.forward[O]&&m(P.forward[O].key,l)<0;)P=P.forward[O];if(P=P.forward[0],P&&m(P.key,l)===0)return P}static _insert(b,l,m,P){let O=[],g=b._header;for(let I=b._level-1;I>=0;I--){for(;g.forward[I]&&P(g.forward[I].key,l)<0;)g=g.forward[I];O[I]=g}if(g=g.forward[0],g&&P(g.key,l)===0)return g.value=m,!1;{let I=R._randomLevel(b);if(I>b._level){for(let d=b._level;d<I;d++)O[d]=b._header;b._level=I}g=new D(I,l,m);for(let d=0;d<I;d++)g.forward[d]=O[d].forward[d],O[d].forward[d]=g;return!0}}static _randomLevel(b,l=.5){let m=1;for(;Math.random()<l&&m<b._maxLevel;)m+=1;return m}static _delete(b,l,m){let P=[],O=b._header;for(let g=b._level-1;g>=0;g--){for(;O.forward[g]&&m(O.forward[g].key,l)<0;)O=O.forward[g];P[g]=O}if(O=O.forward[0],!O||m(O.key,l)!==0)return!1;for(let g=0;g<b._level&&P[g].forward[g]===O;g++)P[g].forward[g]=O.forward[g];for(;b._level>0&&b._header.forward[b._level-1]===S;)b._level-=1;return!0}}t.SkipList=R}),define(Q[37],Z([0,1,6,2]),function(x,t,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function S(u){const r=u;return r?[r.on,r.pause,r.resume,r.destroy].every(a=>typeof a=="function"):!1}t.isReadableStream=S;function R(u){const r=u;return r?S(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}t.isReadableBufferedStream=R;function C(u,r){return new b(u,r)}t.newWriteableStream=C;class b{constructor(r,a){this.reducer=r,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(a=>a(r))}emitError(r){this.listeners.error.length===0?(0,L.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(a=>a(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,a){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(r,a){if(this.state.destroyed)return;let n;switch(r){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const o=n.indexOf(a);o>=0&&n.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(u,r){const a=[];let n;for(;(n=u.read())!==null;)a.push(n);return r(a)}t.consumeReadable=l;function m(u,r,a){const n=[];let o;for(;(o=u.read())!==null&&n.length<a;)n.push(o);return o===null&&n.length>0?r(n):{read:()=>{if(n.length>0)return n.shift();if(typeof o!="undefined"){const e=o;return o=void 0,e}return u.read()}}}t.peekReadable=m;function P(u,r){return new Promise((a,n)=>{const o=[];O(u,{onData:e=>{r&&o.push(e)},onError:e=>{r?n(e):a(void 0)},onEnd:()=>{a(r?r(o):void 0)}})})}t.consumeStream=P;function O(u,r){let a=!1;return u.on("error",n=>{a||r.onError(n)}),u.on("end",()=>{a||r.onEnd()}),u.on("data",n=>{a||r.onData(n)}),(0,D.toDisposable)(()=>a=!0)}t.listenStream=O;function g(u,r){return new Promise((a,n)=>{const o=new D.DisposableStore,e=[],i=f=>{if(e.push(f),e.length>r)return o.dispose(),u.pause(),a({stream:u,buffer:e,ended:!1})},s=f=>n(f),c=()=>a({stream:u,buffer:e,ended:!0});o.add((0,D.toDisposable)(()=>u.removeListener("error",s))),u.on("error",s),o.add((0,D.toDisposable)(()=>u.removeListener("end",c))),u.on("end",c),o.add((0,D.toDisposable)(()=>u.removeListener("data",i))),u.on("data",i)})}t.peekStream=g;function I(u,r){const a=C(r);return a.end(u),a}t.toStream=I;function d(){const u=C(()=>{throw new Error("not supported")});return u.end(),u}t.emptyStream=d;function v(u){let r=!1;return{read:()=>r?null:(r=!0,u)}}t.toReadable=v;function h(u,r,a){const n=C(a);return O(u,{onData:o=>n.write(r.data(o)),onError:o=>n.error(r.error?r.error(o):o),onEnd:()=>n.end()}),n}t.transform=h;function p(u,r,a){let n=!1;return{read:()=>{const o=r.read();return n?o:(n=!0,o!==null?a([u,o]):u)}}}t.prefixedReadable=p;function w(u,r,a){let n=!1;const o=C(a);return O(r,{onData:e=>n?o.write(e):(n=!0,o.write(a([u,e]))),onError:e=>o.error(e),onEnd:()=>{n||(n=!0,o.write(u)),o.end()}}),o}t.prefixedStream=w}),define(Q[17],Z([0,1,37]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const D=typeof Buffer!="undefined";let S,R;class C{constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}static alloc(E){return D?new C(Buffer.allocUnsafe(E)):new C(new Uint8Array(E))}static wrap(E){return D&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new C(E)}static fromString(E,y){return!(y?.dontUseNodeBuffer||!1)&&D?new C(Buffer.from(E)):(S||(S=new TextEncoder),new C(S.encode(E)))}static fromByteArray(E){const y=C.alloc(E.length);for(let T=0,k=E.length;T<k;T++)y.buffer[T]=E[T];return y}static concat(E,y){if(typeof y=="undefined"){y=0;for(let B=0,J=E.length;B<J;B++)y+=E[B].byteLength}const T=C.alloc(y);let k=0;for(let B=0,J=E.length;B<J;B++){const se=E[B];T.set(se,k),k+=se.byteLength}return T}clone(){const E=C.alloc(this.byteLength);return E.set(this),E}toString(){return D?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(E,y){return new C(this.buffer.subarray(E,y))}set(E,y){if(E instanceof C)this.buffer.set(E.buffer,y);else if(E instanceof Uint8Array)this.buffer.set(E,y);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),y);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),y);else throw new Error("Unkown argument 'array'")}readUInt32BE(E){return m(this.buffer,E)}writeUInt32BE(E,y){P(this.buffer,E,y)}readUInt32LE(E){return O(this.buffer,E)}writeUInt32LE(E,y){g(this.buffer,E,y)}readUInt8(E){return I(this.buffer,E)}writeUInt8(E,y){d(this.buffer,E,y)}}t.VSBuffer=C;function b(f,E){return f[E+0]<<0>>>0|f[E+1]<<8>>>0}t.readUInt16LE=b;function l(f,E,y){f[y+0]=E&255,E=E>>>8,f[y+1]=E&255}t.writeUInt16LE=l;function m(f,E){return f[E]*2**24+f[E+1]*2**16+f[E+2]*2**8+f[E+3]}t.readUInt32BE=m;function P(f,E,y){f[y+3]=E,E=E>>>8,f[y+2]=E,E=E>>>8,f[y+1]=E,E=E>>>8,f[y]=E}t.writeUInt32BE=P;function O(f,E){return f[E+0]<<0>>>0|f[E+1]<<8>>>0|f[E+2]<<16>>>0|f[E+3]<<24>>>0}t.readUInt32LE=O;function g(f,E,y){f[y+0]=E&255,E=E>>>8,f[y+1]=E&255,E=E>>>8,f[y+2]=E&255,E=E>>>8,f[y+3]=E&255}t.writeUInt32LE=g;function I(f,E){return f[E]}t.readUInt8=I;function d(f,E,y){f[y]=E}t.writeUInt8=d;function v(f){return L.consumeReadable(f,E=>C.concat(E))}t.readableToBuffer=v;function h(f){return L.toReadable(f)}t.bufferToReadable=h;function p(f){return L.consumeStream(f,E=>C.concat(E))}t.streamToBuffer=p;async function w(f){return f.ended?C.concat(f.buffer):C.concat([...f.buffer,await p(f.stream)])}t.bufferedStreamToBuffer=w;function u(f){return L.toStream(f,E=>C.concat(E))}t.bufferToStream=u;function r(f){return L.transform(f,{data:E=>typeof E=="string"?C.fromString(E):C.wrap(E)},E=>C.concat(E))}t.streamToBufferReadableStream=r;function a(f){return L.newWriteableStream(E=>C.concat(E),f)}t.newWriteableBufferStream=a;function n(f,E){return L.prefixedReadable(f,E,y=>C.concat(y))}t.prefixedBufferReadable=n;function o(f,E){return L.prefixedStream(f,E,y=>C.concat(y))}t.prefixedBufferStream=o;function e(f){let E=0,y=0,T=0;const k=new Uint8Array(Math.floor(f.length/4*3)),B=se=>{switch(y){case 3:k[T++]=E|se,y=0;break;case 2:k[T++]=E|se>>>2,E=se<<6,y=3;break;case 1:k[T++]=E|se>>>4,E=se<<4,y=2;break;default:E=se<<2,y=1}};for(let se=0;se<f.length;se++){const ie=f.charCodeAt(se);if(ie>=65&&ie<=90)B(ie-65);else if(ie>=97&&ie<=122)B(ie-97+26);else if(ie>=48&&ie<=57)B(ie-48+52);else if(ie===43||ie===45)B(62);else if(ie===47||ie===95)B(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${f[se]}`)}}const J=T;for(;y>0;)B(0);return C.wrap(k).slice(0,J)}t.decodeBase64=e;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:f},E=!0,y=!1){const T=y?s:i;let k="";const B=f.byteLength%3;let J=0;for(;J<f.byteLength-B;J+=3){const se=f[J+0],ie=f[J+1],te=f[J+2];k+=T[se>>>2],k+=T[(se<<4|ie>>>4)&63],k+=T[(ie<<2|te>>>6)&63],k+=T[te&63]}if(B===1){const se=f[J+0];k+=T[se>>>2],k+=T[se<<4&63],E&&(k+="==")}else if(B===2){const se=f[J+0],ie=f[J+1];k+=T[se>>>2],k+=T[(se<<4|ie>>>4)&63],k+=T[ie<<2&63],E&&(k+="=")}return k}t.encodeBase64=c}),define(Q[21],Z([0,1,7]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function D(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const h=Array.isArray(v)?[]:{};return Object.keys(v).forEach(p=>{v[p]&&typeof v[p]=="object"?h[p]=D(v[p]):h[p]=v[p]}),h}t.deepClone=D;function S(v){if(!v||typeof v!="object")return v;const h=[v];for(;h.length>0;){const p=h.shift();Object.freeze(p);for(const w in p)if(R.call(p,w)){const u=p[w];typeof u=="object"&&!Object.isFrozen(u)&&h.push(u)}}return v}t.deepFreeze=S;const R=Object.prototype.hasOwnProperty;function C(v,h){return b(v,h,new Set)}t.cloneAndChange=C;function b(v,h,p){if((0,L.isUndefinedOrNull)(v))return v;const w=h(v);if(typeof w!="undefined")return w;if((0,L.isArray)(v)){const u=[];for(const r of v)u.push(b(r,h,p));return u}if((0,L.isObject)(v)){if(p.has(v))throw new Error("Cannot clone recursive data-structure");p.add(v);const u={};for(let r in v)R.call(v,r)&&(u[r]=b(v[r],h,p));return p.delete(v),u}return v}function l(v,h,p=!0){return(0,L.isObject)(v)?((0,L.isObject)(h)&&Object.keys(h).forEach(w=>{w in v?p&&((0,L.isObject)(v[w])&&(0,L.isObject)(h[w])?l(v[w],h[w],p):v[w]=h[w]):v[w]=h[w]}),v):h}t.mixin=l;function m(v,h){if(v===h)return!0;if(v==null||h===null||h===void 0||typeof v!=typeof h||typeof v!="object"||Array.isArray(v)!==Array.isArray(h))return!1;let p,w;if(Array.isArray(v)){if(v.length!==h.length)return!1;for(p=0;p<v.length;p++)if(!m(v[p],h[p]))return!1}else{const u=[];for(w in v)u.push(w);u.sort();const r=[];for(w in h)r.push(w);if(r.sort(),!m(u,r))return!1;for(p=0;p<u.length;p++)if(!m(v[u[p]],h[u[p]]))return!1}return!0}t.equals=m;function P(v){const h=new Set;return JSON.stringify(v,(p,w)=>{if((0,L.isObject)(w)||Array.isArray(w)){if(h.has(w))return"[Circular]";h.add(w)}return w})}t.safeStringify=P;function O(v,h,p){const w=h(v);return typeof w=="undefined"?p:w}t.getOrDefault=O;function g(v,h){const p=Object.create(null);return!v||!h||Object.keys(h).forEach(u=>{const r=v[u],a=h[u];m(r,a)||(p[u]=a)}),p}t.distinct=g;function I(v,h){const p=h.toLowerCase(),w=Object.keys(v).find(u=>u.toLowerCase()===p);return w?v[w]:v[h]}t.getCaseInsensitive=I;function d(v,h){const p=Object.create(null);for(const[w,u]of Object.entries(v))h(w,u)&&(p[w]=u);return p}t.filter=d}),define(Q[58],Z([0,1,9]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function D(m){const P=m;return P&&typeof P.type=="string"&&typeof P.severity=="string"}t.isRemoteConsoleLog=D;function S(m){const P=[];let O;try{const g=JSON.parse(m.arguments),I=g[g.length-1];I&&I.__$stack&&(g.pop(),O=I.__$stack),P.push(...g)}catch{P.push("Unable to log remote console arguments",m.arguments)}return{args:P,stack:O}}t.parse=S;function R(m){if(typeof m!="string")return R(S(m).stack);const P=m;if(P){const O=C(P),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(g&&g.length===4)return{uri:L.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}t.getFirstFrame=R;function C(m){if(!m)return m;const P=m.indexOf(`
`);return P===-1?m:m.substring(0,P)}function b(m,P){const{args:O,stack:g}=S(m),I=typeof O[0]=="string"&&O.length===1;let d=C(g);d&&(d=`(${d.trim()})`);let v=[];if(typeof O[0]=="string"?d&&I?v=[`%c[${P}] %c${O[0]} %c${d}`,l("blue"),l(""),l("grey")]:v=[`%c[${P}] %c${O[0]}`,l("blue"),l(""),...O.slice(1)]:v=[`%c[${P}]%`,l("blue"),...O],d&&!I&&v.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,v)}t.log=b;function l(m){return`color: ${m}`}}),define(Q[59],Z([0,1,17,31,9]),function(x,t,L,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function R(P){return JSON.stringify(P,l)}t.stringify=R;function C(P){let O=JSON.parse(P);return O=m(O),O}t.parse=C;var b;(function(P){P[P.Uri=1]="Uri",P[P.Regexp=2]="Regexp",P[P.ScmResource=3]="ScmResource",P[P.ScmResourceGroup=4]="ScmResourceGroup",P[P.ScmProvider=5]="ScmProvider",P[P.CommentController=6]="CommentController",P[P.CommentThread=7]="CommentThread",P[P.CommentThreadReply=8]="CommentThreadReply",P[P.CommentNode=9]="CommentNode",P[P.CommentThreadNode=10]="CommentThreadNode",P[P.TimelineActionContext=11]="TimelineActionContext",P[P.NotebookCellActionContext=12]="NotebookCellActionContext",P[P.TestItemContext=13]="TestItemContext"})(b=t.MarshalledId||(t.MarshalledId={}));function l(P,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,D.regExpFlags)(O)}:O}function m(P,O=0){if(!P||O>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return S.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof L.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let g=0;g<P.length;++g)P[g]=m(P[g],O+1);else for(const g in P)Object.hasOwnProperty.call(P,g)&&(P[g]=m(P[g],O+1))}return P}t.revive=m}),define(Q[60],Z([0,1,45,10,11,14,18,31,9]),function(x,t,L,D,S,R,C,b,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function m(i,s,c){if(typeof i=="string"&&(i=l.URI.file(i)),c){const E=c.getWorkspaceFolder(i);if(E){const y=c.getWorkspace().folders.length>1;let T;if((0,C.isEqual)(E.uri,i)?T="":T=(0,C.relativePath)(E.uri,i),y){const k=E.name?E.name:(0,C.basename)(E.uri);T=T?k+" \u2022 "+T:k}return T}}if(i.scheme!==D.Schemas.file&&i.scheme!==D.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,L.hasDriveLetter)(i.fsPath))return(0,S.normalize)(O(i.fsPath));let f=(0,S.normalize)(i.fsPath);return!R.isWindows&&s?.userHome&&(f=I(f,s.userHome.fsPath)),f}t.getPathLabel=m;function P(i){if(!i)return;typeof i=="string"&&(i=l.URI.file(i));const s=(0,C.basename)(i)||(i.scheme===D.Schemas.file?i.fsPath:i.path);return R.isWindows&&(0,L.isRootOrDriveLetter)(s)?O(s):s}t.getBaseLabel=P;function O(i,s){return(0,L.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}t.normalizeDriveLetter=O;let g=Object.create(null);function I(i,s){if(R.isWindows||!i||!s)return i;let c=g.original===s?g.normalized:void 0;return c||(c=`${(0,b.rtrim)(s,S.posix.sep)}${S.posix.sep}`,g={original:s,normalized:c}),(R.isLinux?i.startsWith(c):(0,b.startsWithIgnoreCase)(i,c))&&(i=`~/${i.substr(c.length)}`),i}t.tildify=I;function d(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}t.untildify=d;const v="\u2026",h="\\\\",p="~";function w(i,s=S.sep){const c=new Array(i.length);let f=!1;for(let E=0;E<i.length;E++){let y=i[E];if(y===""){c[E]=`.${s}`;continue}if(!y){c[E]=y;continue}f=!0;let T="";y.indexOf(h)===0?(T=y.substr(0,y.indexOf(h)+h.length),y=y.substr(y.indexOf(h)+h.length)):y.indexOf(s)===0?(T=y.substr(0,y.indexOf(s)+s.length),y=y.substr(y.indexOf(s)+s.length)):y.indexOf(p)===0&&(T=y.substr(0,y.indexOf(p)+p.length),y=y.substr(y.indexOf(p)+p.length));const k=y.split(s);for(let B=1;f&&B<=k.length;B++)for(let J=k.length-B;f&&J>=0;J--){f=!1;let se=k.slice(J,J+B).join(s);for(let ie=0;!f&&ie<i.length;ie++)if(ie!==E&&i[ie]&&i[ie].indexOf(se)>-1){const te=J+B===k.length,ge=J>0&&i[ie].indexOf(s)>-1?s+se:se,W=i[ie].endsWith(ge);f=!te||W}if(!f){let ie="";(k[0].endsWith(":")||T!=="")&&(J===1&&(J=0,B++,se=k[0]+s+se),J>0&&(ie=k[0]+s),ie=T+ie),J>0&&(ie=ie+v+s),ie=ie+se,J+B<k.length&&(ie=ie+s+v),c[E]=ie}}f&&(c[E]=y)}return c}t.shorten=w;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function r(i,s=Object.create(null)){const c=[];let f=!1,E="";for(const y of i)if(y==="$"||f&&y==="{")E&&c.push({value:E,type:u.TEXT}),E="",f=!0;else if(y==="}"&&f){const T=s[E];if(typeof T=="string")T.length&&c.push({value:T,type:u.VARIABLE});else if(T){const k=c[c.length-1];(!k||k.type!==u.SEPARATOR)&&c.push({value:T.label,type:u.SEPARATOR})}E="",f=!1}else E+=y;return E&&!f&&c.push({value:E,type:u.TEXT}),c.filter((y,T)=>{if(y.type===u.SEPARATOR){const k=c[T-1],B=c[T+1];return[k,B].every(J=>J&&(J.type===u.VARIABLE||J.type===u.TEXT)&&J.value.length>0)}return!0}).map(y=>y.value).join("")}t.template=r;function a(i,s){return R.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}t.mnemonicMenuLabel=a;function n(i,s){return R.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}t.mnemonicButtonLabel=n;function o(i){return i.replace(/&/g,"&&")}t.unmnemonicLabel=o;function e(i){const s=i.indexOf("/")!==-1?S.posix:S.win32,c=s.basename(i),f=s.dirname(i);return c.length?{name:c,parentPath:f}:{name:f,parentPath:""}}t.splitName=e}),define(Q[26],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(l){return L.test(l)}t.isUUID=D;const S=new Uint8Array(16),R=[];for(let l=0;l<256;l++)R.push(l.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let m=0;m<l.length;m++)l[m]=Math.floor(Math.random()*256);return l};function b(){C(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let l=0,m="";return m+=R[S[l++]],m+=R[S[l++]],m+=R[S[l++]],m+=R[S[l++]],m+="-",m+=R[S[l++]],m+=R[S[l++]],m+="-",m+=R[S[l++]],m+=R[S[l++]],m+="-",m+=R[S[l++]],m+=R[S[l++]],m+="-",m+=R[S[l++]],m+=R[S[l++]],m+=R[S[l++]],m+=R[S[l++]],m+=R[S[l++]],m+=R[S[l++]],m}t.generateUuid=b}),define(Q[61],Z([0,1,128]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class D{constructor(R="utf8"){this.stringDecoder=new L.StringDecoder(R),this.remaining=null}write(R){const C=[],b=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(b.length<1)return C;let l=0,m,P=l;for(;P<b.length;)if(m=b.charCodeAt(P),m===13||m===10){if(C.push(b.substring(l,P)),P++,P<b.length){const O=m;m=b.charCodeAt(P),(O===13&&m===10||O===10&&m===13)&&P++}l=P}else P++;return this.remaining=l<b.length?b.substr(l):null,C}end(){return this.remaining}}t.LineDecoder=D}),define(Q[62],Z([0,1,33,11,15]),function(x,t,L,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,C=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var l;(function(r){r[r.x64=0]="x64",r[r.x86=1]="x86",r[r.ARM=2]="ARM"})(l||(l={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class O{constructor(a,n,o){this.exePath=a,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:r=!1}={}){return r?m===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function I({useAlternateBitness:r=!1,findPreview:a=!1}={}){const n=g({useAlternateBitness:r});if(!n)return null;const o=D.join(n,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(o))return null;let e=-1,i=null;for(const f of await S.Promises.readdir(o)){let E=-1;if(a){const T=f.indexOf("-");if(T<0)continue;const k=f.substring(0,T);if(!R.test(k)||f.substring(T+1)!=="preview")continue;E=parseInt(k,10)}else{if(!R.test(f))continue;E=parseInt(f,10)}if(E<=e)continue;const y=D.join(o,f,"pwsh.exe");!await S.SymlinkSupport.existsFile(y)||(i=y,e=E)}if(!i)return null;const s=n.includes("x86")?" (x86)":"",c=a?" Preview":"";return new O(i,`PowerShell${c}${s}`,!0)}async function d({findPreview:r}={}){if(!process.env.LOCALAPPDATA)return null;const a=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=r?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const e of await S.Promises.readdir(a))if(n.test(e)){const i=D.join(a,e,"pwsh.exe");return new O(i,o)}return null}function v(){const r=D.join(L.homedir(),".dotnet","tools","pwsh.exe");return new O(r,".NET Core PowerShell Global Tool")}function h(){const r=D.join(process.env.windir,m===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(r,"Windows PowerShell",!0)}async function*p(){let r=await I();r&&(yield r),r=await I({useAlternateBitness:!0}),r&&(yield r),r=await d(),r&&(yield r),r=v(),r&&(yield r),r=await I({findPreview:!0}),r&&(yield r),r=await d({findPreview:!0}),r&&(yield r),r=await I({useAlternateBitness:!0,findPreview:!0}),r&&(yield r),r=h(),r&&(yield r)}async function*w(){for await(const r of p())await r.exists()&&(yield r)}t.enumeratePowerShellInstallations=w;async function u(){for await(const r of w())return r;return null}t.getFirstAvailablePowerShellInstallation=u});var ve=this&&this.__decorate||function(x,t,L,D){var S=arguments.length,R=S<3?t:D===null?D=Object.getOwnPropertyDescriptor(t,L):D,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(x,t,L,D);else for(var b=x.length-1;b>=0;b--)(C=x[b])&&(R=(S<3?C(R):S>3?C(t,L,R):C(t,L))||R);return S>3&&R&&Object.defineProperty(t,L,R),R};define(Q[46],Z([0,1,19,3,17,24,44,6,8,2,59,31,7]),function(x,t,L,D,S,R,C,b,l,m,P,O,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var I;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(I=t.RequestType||(t.RequestType={}));function d(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(v=t.ResponseType||(t.ResponseType={}));function h(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(p||(p={}));class w{constructor(F){this.buffer=F,this.pos=0}read(F){const j=this.buffer.slice(this.pos,this.pos+F);return this.pos+=j.byteLength,j}}class u{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var r;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(r||(r={}));function a(M){const F=S.VSBuffer.alloc(4);return F.writeUInt32BE(M,0),F}function n(M){return M.read(4).readUInt32BE(0)}function o(M){const F=S.VSBuffer.alloc(1);return F.writeUInt8(M,0),F}const e={Undefined:o(r.Undefined),String:o(r.String),Buffer:o(r.Buffer),VSBuffer:o(r.VSBuffer),Array:o(r.Array),Object:o(r.Object)},i=typeof Buffer!="undefined";function s(M,F){if(typeof F=="undefined")M.write(e.Undefined);else if(typeof F=="string"){const j=S.VSBuffer.fromString(F);M.write(e.String),M.write(a(j.byteLength)),M.write(j)}else if(i&&Buffer.isBuffer(F)){const j=S.VSBuffer.wrap(F);M.write(e.Buffer),M.write(a(j.byteLength)),M.write(j)}else if(F instanceof S.VSBuffer)M.write(e.VSBuffer),M.write(a(F.byteLength)),M.write(F);else if(Array.isArray(F)){M.write(e.Array),M.write(a(F.length));for(const j of F)s(M,j)}else{const j=S.VSBuffer.fromString(JSON.stringify(F));M.write(e.Object),M.write(a(j.byteLength)),M.write(j)}}function c(M){switch(M.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return M.read(n(M)).toString();case r.Buffer:return M.read(n(M)).buffer;case r.VSBuffer:return M.read(n(M));case r.Array:{const j=n(M),H=[];for(let ne=0;ne<j;ne++)H.push(c(M));return H}case r.Object:return JSON.parse(M.read(n(M)).toString())}}class f{constructor(F,j,H=null,ne=1e3){this.protocol=F,this.ctx=j,this.logger=H,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(F,j){this.channels.set(F,j),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const j=this.send([F.type]);this.logger&&this.logger.logOutgoing(j,0,1,h(F.type));return}case 201:case 202:case 204:case 203:{const j=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(j,F.id,1,h(F.type),F.data);return}}}send(F,j=void 0){const H=new u;return s(H,F),s(H,j),this.sendBuffer(H.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const j=new w(F),H=c(j),ne=c(j),K=H[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],1,`${d(K)}: ${H[2]}.${H[3]}`,ne),this.onPromise({type:K,id:H[1],channelName:H[2],name:H[3],arg:ne});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],1,`${d(K)}: ${H[2]}.${H[3]}`,ne),this.onEventListen({type:K,id:H[1],channelName:H[2],name:H[3],arg:ne});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],1,`${d(K)}`),this.disposeActiveRequest({type:K,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],1,`${d(K)}`),this.disposeActiveRequest({type:K,id:H[1]})}}onPromise(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const H=new R.CancellationTokenSource;let ne;try{ne=j.call(this.ctx,F.name,F.arg,H.token)}catch(G){ne=Promise.reject(G)}const K=F.id;ne.then(G=>{this.sendResponse({id:K,data:G,type:201}),this.activeRequests.delete(F.id)},G=>{G instanceof Error?this.sendResponse({id:K,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:K,data:G,type:203}),this.activeRequests.delete(F.id)});const ee=(0,m.toDisposable)(()=>H.cancel());this.activeRequests.set(F.id,ee)}onEventListen(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const H=F.id,K=j.listen(this.ctx,F.name,F.arg)(ee=>this.sendResponse({id:H,data:ee,type:204}));this.activeRequests.set(F.id,K)}disposeActiveRequest(F){const j=this.activeRequests.get(F.id);j&&(j.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let j=this.pendingRequests.get(F.channelName);j||(j=[],this.pendingRequests.set(F.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:F,timeoutTimer:H})}flushPendingRequests(F){const j=this.pendingRequests.get(F);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}t.ChannelServer=f;var E;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(E=t.RequestInitiator||(t.RequestInitiator={}));class y{constructor(F,j=null){this.protocol=F,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(F){const j=this;return{call(H,ne,K){return j.isDisposed?Promise.reject(b.canceled()):j.requestPromise(F,H,ne,K)},listen(H,ne){return j.isDisposed?Promise.reject(b.canceled()):j.requestEvent(F,H,ne)}}}requestPromise(F,j,H,ne=R.CancellationToken.None){const K=this.lastRequestId++,G={id:K,type:100,channelName:F,name:j,arg:H};if(ne.isCancellationRequested)return Promise.reject(b.canceled());let fe;return new Promise((N,q)=>{if(ne.isCancellationRequested)return q(b.canceled());const z=()=>{const ae=oe=>{switch(oe.type){case 201:this.handlers.delete(K),N(oe.data);break;case 202:{this.handlers.delete(K);const le=new Error(oe.data.message);le.stack=oe.data.stack,le.name=oe.data.name,q(le);break}case 203:this.handlers.delete(K),q(oe.data);break}};this.handlers.set(K,ae),this.sendRequest(G)};let X=null;this.state===p.Idle?z():(X=(0,D.createCancelablePromise)(ae=>this.whenInitialized()),X.then(()=>{X=null,z()}));const Y=()=>{X?(X.cancel(),X=null):this.sendRequest({id:K,type:101}),q(b.canceled())},he=ne.onCancellationRequested(Y);fe=(0,m.combinedDisposable)((0,m.toDisposable)(Y),he),this.activeRequests.add(fe)}).finally(()=>{this.activeRequests.delete(fe)})}requestEvent(F,j,H){const ne=this.lastRequestId++,ee={id:ne,type:102,channelName:F,name:j,arg:H};let G=null;const fe=new l.Emitter({onFirstListenerAdd:()=>{G=(0,D.createCancelablePromise)(N=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(fe),this.sendRequest(ee)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(fe),this.sendRequest({id:ne,type:103}))}}),U=N=>fe.fire(N.data);return this.handlers.set(ne,U),fe.event}sendRequest(F){switch(F.type){case 100:case 102:{const j=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(j,F.id,0,`${d(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const j=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(j,F.id,0,d(F.type));return}}}send(F,j=void 0){const H=new u;return s(H,F),s(H,j),this.sendBuffer(H.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const j=new w(F),H=c(j),ne=c(j),K=H[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,h(K)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],0,h(K),ne),this.onResponse({type:H[0],id:H[1],data:ne})}}onResponse(F){if(F.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(F.id);j&&j(F)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}ve([C.memoize],y.prototype,"onDidInitializePromise",null),t.ChannelClient=y;class T{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:j,onDidClientDisconnect:H})=>{l.Event.once(j.onMessage)(K=>{const ee=new w(K),G=c(ee),fe=new f(j,G),U=new y(j);this.channels.forEach((q,z)=>fe.registerChannel(z,q));const N={channelServer:fe,channelClient:U,ctx:G};this._connections.add(N),this._onDidAddConnection.fire(N),H(()=>{fe.dispose(),U.dispose(),this._connections.delete(N),this._onDidRemoveConnection.fire(N)})})})}get connections(){const F=[];return this._connections.forEach(j=>F.push(j)),F}getChannel(F,j){const H=this;return{call(ne,K,ee){let G;if((0,g.isFunction)(j)){let U=(0,L.getRandomElement)(H.connections.filter(j));G=U?Promise.resolve(U):l.Event.toPromise(l.Event.filter(H.onDidAddConnection,j))}else G=j.routeCall(H,ne,K);const fe=G.then(U=>U.channelClient.getChannel(F));return B(fe).call(ne,K,ee)},listen(ne,K){if((0,g.isFunction)(j))return H.getMulticastEvent(F,j,ne,K);const ee=j.routeEvent(H,ne,K).then(G=>G.channelClient.getChannel(F));return B(ee).listen(ne,K)}}}getMulticastEvent(F,j,H,ne){const K=this;let ee=new m.DisposableStore;const G=new l.Emitter({onFirstListenerAdd:()=>{ee=new m.DisposableStore;const fe=new l.EventMultiplexer,U=new Map,N=z=>{const Y=z.channelClient.getChannel(F).listen(H,ne),he=fe.add(Y);U.set(z,he)},q=z=>{const X=U.get(z);!X||(X.dispose(),U.delete(z))};K.connections.filter(j).forEach(N),l.Event.filter(K.onDidAddConnection,j)(N,void 0,ee),K.onDidRemoveConnection(q,void 0,ee),fe.event(G.fire,G,ee),ee.add(fe)},onLastListenerRemove:()=>{ee.dispose()}});return G.event}registerChannel(F,j){this.channels.set(F,j),this._connections.forEach(H=>{H.channelServer.registerChannel(F,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=T;class k{constructor(F,j,H=null){const ne=new u;s(ne,j),F.send(ne.buffer),this.channelClient=new y(F,H),this.channelServer=new f(F,j,H)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,j){this.channelServer.registerChannel(F,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=k;function B(M){return{call(F,j,H){return M.then(ne=>ne.call(F,j,H))},listen(F,j){const H=new l.Relay;return M.then(ne=>H.input=ne.listen(F,j)),H.event}}}t.getDelayedChannel=B;function J(M){let F=!1;return{call(j,H,ne){return F?M.call(j,H,ne):(0,D.timeout)(0).then(()=>F=!0).then(()=>M.call(j,H,ne))},listen(j,H){if(F)return M.listen(j,H);const ne=new l.Relay;return(0,D.timeout)(0).then(()=>F=!0).then(()=>ne.input=M.listen(j,H)),ne.event}}}t.getNextTickChannel=J;class se{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const j of F.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await l.Event.toPromise(F.onDidAddConnection),await this.route(F)}}t.StaticRouter=se;var ie;(function(M){function F(K,ee){const G=K,fe=ee&&ee.disableMarshalling,U=new Map;for(const N in G)H(N)&&U.set(N,l.Event.buffer(G[N],!0));return new class{listen(N,q,z){const X=U.get(q);if(X)return X;if(ne(q)){const Y=G[q];if(typeof Y=="function")return Y.call(G,z)}throw new Error(`Event not found: ${q}`)}call(N,q,z){const X=G[q];if(typeof X=="function"){if(!fe&&Array.isArray(z))for(let Y=0;Y<z.length;Y++)z[Y]=(0,P.revive)(z[Y]);return X.apply(G,z)}throw new Error(`Method not found: ${q}`)}}}M.fromService=F;function j(K,ee){const G=ee&&ee.disableMarshalling;return new Proxy({},{get(fe,U){if(typeof U=="string")return ee?.properties?.has(U)?ee.properties.get(U):ne(U)?function(N){return K.listen(U,N)}:H(U)?K.listen(U):async function(...N){let q;ee&&!(0,g.isUndefinedOrNull)(ee.context)?q=[ee.context,...N]:q=N;const z=await K.call(U,q);return G?z:(0,P.revive)(z)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=j;function H(K){return K[0]==="o"&&K[1]==="n"&&O.isUpperAsciiLetter(K.charCodeAt(2))}function ne(K){return/^onDynamic/.test(K)&&O.isUpperAsciiLetter(K.charCodeAt(9))}})(ie=t.ProxyChannel||(t.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let F=M.toString();if(F!=="[object Object]")return F}return M}function W(M){return Array.isArray(M)?M.map(ge):ge(M)}function $(M,F,j,H,ne,K,ee){ee=W(ee);const G=te[ne],fe=G[H%G.length];let U=[`%c[${M}]%c[${String(F).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${fe}`];/\($/.test(K)?(U=U.concat(ee),U.push(")")):U.push(ee),console.log.apply(console,U)}t.logWithColors=$;class re{constructor(F,j){this._outgoingPrefix=F,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,j,H,ne,K){this._totalOutgoing+=F,$(this._outgoingPrefix,this._totalOutgoing,F,j,H,ne,K)}logIncoming(F,j,H,ne,K){this._totalIncoming+=F,$(this._incomingPrefix,this._totalIncoming,F,j,H,ne,K)}}t.IPCLogger=re}),define(Q[63],Z([0,1,3,8,2,7]),function(x,t,L,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var C;(function(O){O[O.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(C=t.StorageHint||(t.StorageHint={}));function b(O){const g=O;return g?.changed instanceof Map||g?.deleted instanceof Set}t.isStorageItemsChangeEvent=b;var l;(function(O){O[O.None=0]="None",O[O.Initialized=1]="Initialized",O[O.Closed=2]="Closed"})(l||(l={}));class m extends S.Disposable{constructor(g,I=Object.create(null)){super();this.database=g,this.options=I,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((I,d)=>this.accept(d,I)),g.deleted?.forEach(I=>this.accept(I,void 0))}accept(g,I){if(this.state===l.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(I)?d=this.cache.delete(g):this.cache.get(g)!==I&&(this.cache.set(g,I),d=!0),d&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,I){const d=this.cache.get(g);return(0,R.isUndefinedOrNull)(d)?I:d}getBoolean(g,I){const d=this.get(g);return(0,R.isUndefinedOrNull)(d)?I:d==="true"}getNumber(g,I){const d=this.get(g);return(0,R.isUndefinedOrNull)(d)?I:parseInt(d,10)}async set(g,I){if(this.state===l.Closed)return;if((0,R.isUndefinedOrNull)(I))return this.delete(g);const d=String(I);if(this.cache.get(g)!==d)return this.cache.set(g,d),this.pendingInserts.set(g,d),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async delete(g){if(!(this.state===l.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(!!this.hasPending)return this.doFlush(g)}async doFlush(g){return this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((I,d)=>this.items.set(d,I)),g.delete&&g.delete.forEach(I=>this.items.delete(I))}async close(){}}t.InMemoryStorageDatabase=P}),define(Q[64],Z([4,5]),function(x,t){return x.create("vs/base/common/date",t)}),define(Q[65],Z([0,1,64]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const D=60,S=D*60,R=S*24,C=R*7,b=R*30,l=R*365;function m(O,g){typeof O!="number"&&(O=O.getTime());const I=Math.round((new Date().getTime()-O)/1e3);if(I<-30)return(0,L.localize)(0,null,m(new Date().getTime()+I*1e3,!1));if(I<30)return(0,L.localize)(1,null);let d;return I<D?(d=I,g?d===1?(0,L.localize)(2,null,d):(0,L.localize)(3,null,d):d===1?(0,L.localize)(4,null,d):(0,L.localize)(5,null,d)):I<S?(d=Math.floor(I/D),g?d===1?(0,L.localize)(6,null,d):(0,L.localize)(7,null,d):d===1?(0,L.localize)(8,null,d):(0,L.localize)(9,null,d)):I<R?(d=Math.floor(I/S),g?d===1?(0,L.localize)(10,null,d):(0,L.localize)(11,null,d):d===1?(0,L.localize)(12,null,d):(0,L.localize)(13,null,d)):I<C?(d=Math.floor(I/R),g?d===1?(0,L.localize)(14,null,d):(0,L.localize)(15,null,d):d===1?(0,L.localize)(16,null,d):(0,L.localize)(17,null,d)):I<b?(d=Math.floor(I/C),g?d===1?(0,L.localize)(18,null,d):(0,L.localize)(19,null,d):d===1?(0,L.localize)(20,null,d):(0,L.localize)(21,null,d)):I<l?(d=Math.floor(I/b),g?d===1?(0,L.localize)(22,null,d):(0,L.localize)(23,null,d):d===1?(0,L.localize)(24,null,d):(0,L.localize)(25,null,d)):(d=Math.floor(I/l),g?d===1?(0,L.localize)(26,null,d):(0,L.localize)(27,null,d):d===1?(0,L.localize)(28,null,d):(0,L.localize)(29,null,d))}t.fromNow=m;function P(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=P}),define(Q[66],Z([4,5]),function(x,t){return x.create("vs/base/common/errorMessage",t)}),define(Q[27],Z([0,1,19,7,66]),function(x,t,L,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function R(m,P){return P&&(m.stack||m.stacktrace)?S.localize(0,null,b(m),C(m.stack)||C(m.stacktrace)):b(m)}function C(m){return Array.isArray(m)?m.join(`
`):m}function b(m){return typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?S.localize(1,null,m.message):m.message||S.localize(2,null)}function l(m=null,P=!1){if(!m)return S.localize(3,null);if(Array.isArray(m)){const O=L.coalesce(m),g=l(O[0],P);return O.length>1?S.localize(4,null,g,O.length):g}if(D.isString(m))return m;if(m.detail){const O=m.detail;if(O.error)return R(O.error,P);if(O.exception)return R(O.exception,P)}return m.stack?R(m,P):m.message?m.message:S.localize(5,null)}t.toErrorMessage=l}),define(Q[67],Z([4,5]),function(x,t){return x.create("vs/base/node/processes",t)}),define(Q[47],Z([0,1,38,45,10,21,11,14,28,56,7,61,15,67]),function(x,t,L,D,S,R,C,b,l,m,P,O,g,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.removeDangerousEnvVariables=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return m.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return m.TerminateResponseCode}});function d(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(n,o){if(b.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};o&&(e.cwd=o);const i=L.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],e);return new Promise(s=>{i.once("error",c=>{s({success:!1,error:c})}),i.once("exit",(c,f)=>{s(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?d(e.status):1})}else if(b.isLinux||b.isMacintosh)try{const e=S.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(i=>{L.execFile(e,[n.pid.toString()],{encoding:"utf8",shell:!0},(s,c,f)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function h(n){!n||(delete n.DEBUG,b.isMacintosh&&delete n.DYLD_LIBRARY_PATH,b.isLinux&&delete n.LD_PRELOAD)}t.removeDangerousEnvVariables=h;function p(n=l.env){return n.comspec||"cmd.exe"}t.getWindowsShell=p;class w{constructor(o,e,i,s){if(e!==void 0&&i!==void 0&&s!==void 0)this.cmd=o,this.args=e,this.shell=i,this.options=s;else{const c=o;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(l.env).forEach(f=>{c[f]=l.env[f]}),Object.keys(this.options.env).forEach(f=>{c[f]=this.options.env[f]}),this.options.env=c}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const e=o.lastIndexOf(C.sep);return e!==-1&&(o=o.substring(e+1)),w.WellKnowCommands[o]?o:"other"}start(o){return b.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(l.cwd()))?Promise.reject(new Error(I.localize(0,null))):this.useExec().then(e=>{let i,s;const c=new Promise((f,E)=>{i=f,s=E});if(e){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=L.exec(f,this.options,(E,y,T)=>{this.childProcess=null;const k=E;k&&k.killed?s({killed:this.terminateRequested,stdout:y.toString(),stderr:T.toString()}):this.handleExec(i,o,E,y,T)})}else{let f=null;const E=y=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(y,i,o,s);const T={terminated:this.terminateRequested};P.isNumber(y)&&(T.cmdCode=y),i(T)};if(this.shell&&b.isWindows){const y=R.deepClone(this.options);y.windowsVerbatimArguments=!0,y.detached=!1;let T=!1,k=!1;const B=[];let J=this.ensureQuotes(this.cmd);B.push(J.value),T=J.quoted,this.args&&this.args.forEach(ie=>{J=this.ensureQuotes(ie),B.push(J.value),k=k&&J.quoted});const se=["/s","/c"];T?k?se.push('"'+B.join(" ")+'"'):B.length>1?se.push('"'+B[0]+'" '+B.slice(1).join(" ")):se.push('"'+B[0]+'"'):se.push(B.join(" ")),f=L.spawn(p(),se,y)}else this.cmd&&(f=L.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(P.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",y=>{this.childProcess=null,s({terminated:this.terminateRequested,error:y})}),f.pid&&(this.childProcess.on("close",E),this.handleSpawn(f,i,o,s,!0)))}return c})}handleClose(o,e,i,s){}ensureQuotes(o){return w.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,v(o,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!b.isWindows)return o(!1);const e=L.spawn(p(),["/s","/c"]);e.on("error",i=>o(!0)),e.on("exit",i=>o(!1))})}}t.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class u extends w{constructor(o,e,i,s){super(o,e,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,e,i,s,c){[s,c].forEach((f,E)=>{const y=new O.LineDecoder;y.write(f).forEach(B=>{e({line:B,source:E===0?0:1})});const k=y.end();k&&e({line:k,source:E===0?0:1})}),o({terminated:this.terminateRequested,error:i})}handleSpawn(o,e,i,s,c){const f=new O.LineDecoder,E=new O.LineDecoder;o.stdout.on("data",y=>{f.write(y).forEach(k=>i({line:k,source:0}))}),o.stderr.on("data",y=>{E.write(y).forEach(k=>i({line:k,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=E}handleClose(o,e,i,s){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&i({line:c,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&i({line:f,source:1})}}t.LineProcess=u;function r(n){let o=[],e=!1;const i=function(s){if(e){o.push(s);return}(!n.send(s,f=>{if(f&&console.error(f),e=!1,o.length>0){const E=o.slice(0);o=[],E.forEach(y=>i(y))}})||b.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=r;var a;(function(n){async function o(e,i,s){if(C.isAbsolute(e))return e;if(i===void 0&&(i=l.cwd()),C.dirname(e)!=="."||(s===void 0&&P.isString(l.env.PATH)&&(s=l.env.PATH.split(C.delimiter)),s===void 0||s.length===0))return C.join(i,e);async function f(E){if(await g.Promises.exists(E)){let y;try{y=await g.Promises.stat(E)}catch(T){T.message.startsWith("EACCES")&&(y=await g.Promises.lstat(E))}return y?!y.isDirectory():!1}return!1}for(let E of s){let y;if(C.isAbsolute(E)?y=C.join(E,e):y=C.join(i,E,e),await f(y))return y;let T=y+".com";if(await f(T)||(T=y+".exe",await f(T)))return T}return C.join(i,e)}n.findExecutable=o})(a=t.win32||(t.win32={}))}),define(Q[68],Z([0,1,33,14,62,47]),function(x,t,L,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function C(I,d){return I===1?D.isWindows?O():R.getWindowsShell(d):m(I,d)}t.getSystemShell=C;function b(I,d){return I===1?D.isWindows?g(d):R.getWindowsShell(d):m(I,d)}t.getSystemShellSync=b;let l=null;function m(I,d){if(D.isLinux&&I===2||D.isMacintosh&&I===3)return"/bin/bash";if(!l){let v;if(D.isWindows)v="/bin/bash";else{if(v=d.SHELL,!v)try{v=(0,L.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}l=v}return l}let P=null;async function O(){return P||(P=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),P}function g(I){if(P)return P;const d=D.isWindows&&parseFloat((0,L.release)())>=10,v=I.hasOwnProperty("PROCESSOR_ARCHITEW6432"),h=`${I.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?h:R.getWindowsShell(I)}}),define(Q[69],Z([0,1,38,3,17,24,58,6,8,2,21,47,46]),function(x,t,L,D,S,R,C,b,l,m,P,O,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class I extends g.ChannelServer{constructor(h){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",p=>S.VSBuffer.wrap(Buffer.from(p,"base64")))},h);process.once("disconnect",()=>this.dispose())}}t.Server=I;class d{constructor(h,p){this.modulePath=h,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new D.Delayer(w),this.child=null,this._client=null}getChannel(h){const p=this;return{call(w,u,r){return p.requestPromise(h,w,u,r)},listen(w,u){return p.requestEvent(h,w,u)}}}requestPromise(h,p,w,u=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(h),a=(0,D.createCancelablePromise)(e=>r.call(p,w,e)),n=u.onCancellationRequested(()=>a.cancel()),o=(0,m.toDisposable)(()=>a.cancel());return this.activeRequests.add(o),a.finally(()=>{n.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(h,p,w){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let u;const r=new l.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(h).listen(p,w)(r.fire,r),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const h=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,O.removeDangerousEnvVariables)(p.env),this.child=(0,L.fork)(this.modulePath,h,p);const w=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,C.isRemoteConsoleLog)(i)){(0,C.log)(i,`IPC Library: ${this.options.serverName}`);return}w.fire(S.VSBuffer.wrap(Buffer.from(i,"base64")))});const r=this.options.useQueue?(0,O.createQueuedSender)(this.child):this.child,a=i=>this.child&&this.child.connected&&r.send(i.buffer.toString("base64")),n=w.event,o={send:a,onMessage:n};this._client=new g.ChannelClient(o);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,s)=>{process.removeListener("exit",e),this.activeRequests.forEach(c=>(0,m.dispose)(c)),this.activeRequests.clear(),i!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:s})})}return this._client}getCachedChannel(h){let p=this.channels.get(h);return p||(p=this.client.getChannel(h),this.channels.set(h,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=d}),define(Q[70],Z([4,5]),function(x,t){return x.create("vs/base/node/zip",t)}),define(Q[71],Z([4,5]),function(x,t){return x.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[72],Z([4,5]),function(x,t){return x.create("vs/platform/environment/node/shellEnv",t)}),define(Q[73],Z([4,5]),function(x,t){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Q[74],Z([4,5]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[75],Z([4,5]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[76],Z([4,5]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[77],Z([4,5]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[78],Z([4,5]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[79],Z([4,5]),function(x,t){return x.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[80],Z([4,5]),function(x,t){return x.create("vs/platform/files/common/fileService",t)}),define(Q[81],Z([4,5]),function(x,t){return x.create("vs/platform/files/common/io",t)}),define(Q[82],Z([4,5]),function(x,t){return x.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[83],Z([4,5]),function(x,t){return x.create("vs/platform/request/common/request",t)}),define(Q[84],Z([4,5]),function(x,t){return x.create("vs/platform/telemetry/common/telemetryService",t)}),define(Q[85],Z([0,1,65,44,10,11,28,18,9]),function(x,t,L,D,S,R,C,b,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class m{constructor(v,h,p){this._args=v,this.paths=h,this.productService=p}get appRoot(){return(0,R.dirname)(S.FileAccess.asFileUri("",x).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(l.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=C.env.VSCODE_PORTABLE;return v?l.URI.file((0,R.join)(v,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,b.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,R.resolve)(v):(0,R.normalize)((0,R.join)(S.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const v=this.args["extensions-download-dir"];return v?(0,R.resolve)(v):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,R.resolve)(v);const h=C.env.VSCODE_EXTENSIONS;if(h)return h;const p=C.env.VSCODE_PORTABLE;return p?(0,R.join)(p,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(h=>/^[^:/?#]+?:\/\//.test(h)?l.URI.parse(h):l.URI.file((0,R.normalize)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?l.URI.parse(v):l.URI.file((0,R.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ve([D.memoize],m.prototype,"appRoot",null),ve([D.memoize],m.prototype,"userHome",null),ve([D.memoize],m.prototype,"userDataPath",null),ve([D.memoize],m.prototype,"appSettingsHome",null),ve([D.memoize],m.prototype,"tmpDir",null),ve([D.memoize],m.prototype,"cacheHome",null),ve([D.memoize],m.prototype,"userRoamingDataHome",null),ve([D.memoize],m.prototype,"settingsResource",null),ve([D.memoize],m.prototype,"userDataSyncHome",null),ve([D.memoize],m.prototype,"userDataSyncLogResource",null),ve([D.memoize],m.prototype,"sync",null),ve([D.memoize],m.prototype,"machineSettingsResource",null),ve([D.memoize],m.prototype,"globalStorageHome",null),ve([D.memoize],m.prototype,"workspaceStorageHome",null),ve([D.memoize],m.prototype,"keybindingsResource",null),ve([D.memoize],m.prototype,"keyboardLayoutResource",null),ve([D.memoize],m.prototype,"argvResource",null),ve([D.memoize],m.prototype,"snippetsHome",null),ve([D.memoize],m.prototype,"isExtensionDevelopment",null),ve([D.memoize],m.prototype,"untitledWorkspacesHome",null),ve([D.memoize],m.prototype,"installSourcePath",null),ve([D.memoize],m.prototype,"builtinExtensionsPath",null),ve([D.memoize],m.prototype,"extensionsPath",null),ve([D.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ve([D.memoize],m.prototype,"extensionDevelopmentKind",null),ve([D.memoize],m.prototype,"extensionTestsLocationURI",null),ve([D.memoize],m.prototype,"debugExtensionHost",null),ve([D.memoize],m.prototype,"serviceMachineIdResource",null),ve([D.memoize],m.prototype,"telemetryLogResource",null),ve([D.memoize],m.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=m;function P(d,v){return I(d["inspect-extensions"],d["inspect-brk-extensions"],5870,v,d.debugId,d.extensionEnvironment)}t.parseExtensionHostPort=P;function O(d,v){return I(d["inspect-search"],d["inspect-brk-search"],5876,v,d.extensionEnvironment)}t.parseSearchPort=O;function g(d,v){return I(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,v,d.extensionEnvironment)}t.parsePtyHostPort=g;function I(d,v,h,p,w,u){const a=Number(v||d)||(p?null:h),n=a?Boolean(!!v):!1;let o;if(u)try{o=JSON.parse(u)}catch{}return{port:a,break:n,debugId:w,env:o}}}),function(){"use strict";function x(t,L,D,S){function R(b){const l=C(b),m=[l];return t.isAbsolute(l)||m.unshift(S),t.resolve(...m)}function C(b){const l=process.env.VSCODE_PORTABLE;if(l)return t.join(l,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return t.join(m,D);const P=b["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=t.join(O,"AppData","Roaming")}break;case"darwin":m=t.join(L.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||t.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(m,D)}return{getUserDataPath:R}}if(typeof define=="function")define(Q[86],Z([0,129,33,10,18,28]),function(t,L,D,S,R,C){const b=R.dirname(S.FileAccess.asFileUri("",t)),l=t.__$__nodeRequire(R.joinPath(b,"package.json").fsPath);return x(L,D,l.name,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),L=require("path"),D=require("os");module.exports=x(L,D,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[87],Z([0,1,33,85,86]),function(x,t,L,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class R extends D.AbstractNativeEnvironmentService{constructor(b,l){super(b,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,S.getUserDataPath)(b)},l)}}t.NativeEnvironmentService=R}),define(Q[88],Z([0,1,21]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const D=/^%([\w\d.-]+)%$/i;function S(R,C){const b=l=>{if(typeof l!="string")return;const m=D.exec(l);if(!m)return;const P=C[m[1]]??l;return typeof P=="string"?P:typeof P.message=="string"?P.message:l};return(0,L.cloneAndChange)(R,b)}t.localizeManifest=S}),define(Q[48],Z([0,1,79]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function R(g){return g=g.trim(),g==="*"||D.test(g)}t.isValidVersionStr=R;function C(g){if(!R(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let I=g.match(D);return I?{hasCaret:I[1]==="^",hasGreaterEquals:I[1]===">=",majorBase:I[2]==="x"?0:parseInt(I[2],10),majorMustEqual:I[2]!=="x",minorBase:I[4]==="x"?0:parseInt(I[4],10),minorMustEqual:I[4]!=="x",patchBase:I[6]==="x"?0:parseInt(I[6],10),patchMustEqual:I[6]!=="x",preRelease:I[8]||null}:null}t.parseVersion=C;function b(g){if(!g)return null;let I=g.majorBase,d=g.majorMustEqual,v=g.minorBase,h=g.minorMustEqual,p=g.patchBase,w=g.patchMustEqual;g.hasCaret&&(I===0||(h=!1),w=!1);let u=0;if(g.preRelease){const r=S.exec(g.preRelease);if(r){const[,a,n,o]=r;u=Date.UTC(Number(a),Number(n)-1,Number(o))}}return{majorBase:I,majorMustEqual:d,minorBase:v,minorMustEqual:h,patchBase:p,patchMustEqual:w,isMinimum:g.hasGreaterEquals,notBefore:u}}t.normalizeVersion=b;function l(g,I,d){let v;typeof g=="string"?v=b(C(g)):v=g;let h;I instanceof Date?h=I.getTime():typeof I=="string"&&(h=new Date(I).getTime());let p;if(typeof d=="string"?p=b(C(d)):p=d,!v||!p)return!1;let w=v.majorBase,u=v.minorBase,r=v.patchBase,a=p.majorBase,n=p.minorBase,o=p.patchBase,e=p.notBefore,i=p.majorMustEqual,s=p.minorMustEqual,c=p.patchMustEqual;return p.isMinimum?w>a?!0:w<a?!1:u>n?!0:u<n||h&&h<e?!1:r>=o:(w===1&&a===0&&(!i||!s||!c)&&(a=1,n=0,o=0,i=!0,s=!1,c=!1),w<a?!1:w>a?!i:u<n?!1:u>n?!s:r<o?!1:r>o?!c:!(h&&h<e))}t.isValidVersion=l;function m(g,I,d,v){return d.isBuiltin||typeof d.main=="undefined"?!0:O(g,I,d.engines.vscode,v)}t.isValidExtensionVersion=m;function P(g,I,d){return g==="*"||O(I,d,g)}t.isEngineValid=P;function O(g,I,d,v=[]){let h=b(C(d));if(!h)return v.push(L.localize(0,null,d)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return v.push(L.localize(1,null,d)),!1}else if(!h.majorMustEqual)return v.push(L.localize(2,null,d)),!1;return l(g,I,h)?!0:(v.push(L.localize(3,null,g,d)),!1)}}),define(Q[39],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class L{constructor(S,R=[],C=!1){this.ctor=S,this.staticArguments=R,this.supportsDelayedInstantiation=C}}t.SyncDescriptor=L}),define(Q[89],Z([0,1,39]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const D=[];function S(C,b,l){b instanceof L.SyncDescriptor||(b=new L.SyncDescriptor(b,[],l)),D.push([C,b])}t.registerSingleton=S;function R(){return D}t.getSingletonServiceDescriptors=R}),define(Q[90],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class L{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}t.Node=L;class D{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let C of this._nodes.values())C.outgoing.size===0&&R.push(C);return R}insertEdge(R,C){const b=this.lookupOrInsertNode(R),l=this.lookupOrInsertNode(C);b.outgoing.set(this._hashFn(C),l),l.incoming.set(this._hashFn(R),b)}removeNode(R){const C=this._hashFn(R);this._nodes.delete(C);for(let b of this._nodes.values())b.outgoing.delete(C),b.incoming.delete(C)}lookupOrInsertNode(R){const C=this._hashFn(R);let b=this._nodes.get(C);return b||(b=new L(R),this._nodes.set(C,b)),b}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[C,b]of this._nodes)R.push(`${C}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,C]of this._nodes){const b=new Set([R]),l=this._findCycle(C,b);if(l)return l}}_findCycle(R,C){for(let[b,l]of R.outgoing){if(C.has(b))return[...C,b].join(" -> ");C.add(b);const m=this._findCycle(l,C);if(m)return m;C.delete(b)}}}t.Graph=D}),define(Q[25],Z([0,1,7,9,12]),function(x,t,L,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationUpdateOverrides=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,S.createDecorator)("configurationService");function R(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof D.URI)}t.isConfigurationOverrides=R;function C(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||L.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof D.URI)}t.isConfigurationUpdateOverrides=C;var b;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(b=t.ConfigurationTarget||(t.ConfigurationTarget={}));function l(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=l;function m(h,p){const w=Object.create(null);for(let u in h)P(w,u,h[u],p);return w}t.toValuesTree=m;function P(h,p,w,u){const r=p.split("."),a=r.pop();let n=h;for(let o=0;o<r.length;o++){let e=r[o],i=n[e];switch(typeof i){case"undefined":i=n[e]=Object.create(null);break;case"object":break;default:u(`Ignoring ${p} as ${r.slice(0,o+1).join(".")} is ${JSON.stringify(i)}`);return}n=i}if(typeof n=="object"&&n!==null)try{n[a]=w}catch{u(`Ignoring ${p} as ${r.join(".")} is ${JSON.stringify(n)}`)}else u(`Ignoring ${p} as ${r.join(".")} is ${JSON.stringify(n)}`)}t.addToValueTree=P;function O(h,p){const w=p.split(".");g(h,w)}t.removeFromValueTree=O;function g(h,p){const w=p.shift();if(p.length===0){delete h[w];return}if(Object.keys(h).indexOf(w)!==-1){const u=h[w];typeof u=="object"&&!Array.isArray(u)&&(g(u,p),Object.keys(u).length===0&&delete h[w])}}function I(h,p,w){function u(n,o){let e=n;for(const i of o){if(typeof e!="object"||e===null)return;e=e[i]}return e}const r=p.split("."),a=u(h,r);return typeof a=="undefined"?w:a}t.getConfigurationValue=I;function d(h,p,w){Object.keys(p).forEach(u=>{u!=="__proto__"&&(u in h?L.isObject(h[u])&&L.isObject(p[u])?d(h[u],p[u],w):w&&(h[u]=p[u]):h[u]=p[u])})}t.merge=d;function v(h,p,w){const u=h.inspect(p),r=h.inspect(w);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:u.defaultValue}t.getMigratedSettingValue=v}),define(Q[49],Z([0,1,12]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,L.createDecorator)("downloadService")}),define(Q[20],Z([0,1,12]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,L.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,L.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[22],Z([0,1,10,74,12]),function(x,t,L,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var R;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(R=t.TargetPlatform||(t.TargetPlatform={}));function C(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=C;function b(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=b;function l(u,r){switch(u){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=l;function m(u,r){return r==="web"&&!u.includes("web")}t.isNotWebExtensionInWebTargetPlatform=m;function P(u,r,a){return m(r,a)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===a?!0:O(a).includes(u)}t.isTargetPlatformCompatible=P;function O(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=O;function g(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}t.isIExtensionIdentifier=g;var I;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(I=t.SortBy||(t.SortBy={}));var d;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(d=t.SortOrder||(t.SortOrder={}));var v;(function(u){u.Install="install",u.Uninstall="uninstall"})(v=t.StatisticType||(t.StatisticType={}));var h;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(h=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,S.createDecorator)("extensionGalleryService");var p;(function(u){u.Unsupported="Unsupported",u.UnsupportedPreRelease="UnsupportedPreRelease",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(p=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class w extends Error{constructor(r,a){super(r);this.code=a,this.name=a}}t.ExtensionManagementError=w,t.IExtensionManagementService=(0,S.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,S.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,S.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),t.ExtensionsLabel=(0,D.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,D.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,S.createDecorator)("IExtensionManagementCLIService")}),define(Q[91],Z([0,1,38,11,72,24,27,6,14,26,68,130,3]),function(x,t,L,D,S,R,C,b,l,m,P,O,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getResolvedShellEnv=void 0;const I=1e4;let d;async function v(p,w,u){return w["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.isLaunchedFromCli)(u)&&!w["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.isLaunchedFromCli)(u)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=g.Promises.withAsyncBody(async(r,a)=>{const n=new R.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),a(new Error((0,S.localize)(0,null)))},I);try{r(await h(p,n.token))}catch(e){!(0,b.isPromiseCanceledError)(e)&&!n.token.isCancellationRequested?a(new Error((0,S.localize)(1,null,(0,C.toErrorMessage)(e)))):r({})}finally{clearTimeout(o),n.dispose()}})),d)}t.getResolvedShellEnv=v;async function h(p,w){const u=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",u);const r=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",r);const a=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(a+"(.*)"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",o);const e=await(0,P.getSystemShell)(l.OS,o);return p.trace("getUnixShellEnvironment#shell",e),new Promise((i,s)=>{if(w.isCancellationRequested)return s((0,b.canceled)());const c=(0,D.basename)(e);let f,E;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(f=`& '${process.execPath}' ${y} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,E=["-Login","-Command"]):(f=`'${process.execPath}' ${y} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c==="tcsh"?E=["-ic"]:E=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),f);const T=(0,L.spawn)(e,[...E,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});w.onCancellationRequested(()=>(T.kill(),s((0,b.canceled)()))),T.on("error",J=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(J)),s(J)});const k=[];T.stdout.on("data",J=>k.push(J));const B=[];T.stderr.on("data",J=>B.push(J)),T.on("close",(J,se)=>{const ie=Buffer.concat(k).toString("utf8");p.trace("getUnixShellEnvironment#raw",ie);const te=Buffer.concat(B).toString("utf8");if(te.trim()&&p.trace("getUnixShellEnvironment#stderr",te),J||se)return s(new Error((0,S.localize)(2,null,J,se)));const ge=n.exec(ie),W=ge?ge[1]:"{}";try{const $=JSON.parse(W);u?$.ELECTRON_RUN_AS_NODE=u:delete $.ELECTRON_RUN_AS_NODE,r?$.ELECTRON_NO_ATTACH_CONSOLE=r:delete $.ELECTRON_NO_ATTACH_CONSOLE,delete $.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",$),i($)}catch($){p.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)($)),s($)}})})}}),define(Q[50],Z([0,1,17,6,81,16]),function(x,t,L,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function C(P,O,g,I,d,v){let h;try{await b(P,O,g,I,d,v)}catch(p){h=p}finally{h&&d.errorTransformer&&(h=d.errorTransformer(h)),typeof h!="undefined"&&g.error(h),g.end()}}t.readFileIntoStream=C;async function b(P,O,g,I,d,v){l(v);const h=await P.open(O,{create:!1});try{l(v);let p=0,w=0,u=d&&typeof d.length=="number"?d.length:void 0,r=L.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),a=d&&typeof d.position=="number"?d.position:0,n=0;do w=await P.read(h,a,r.buffer,n,r.byteLength-n),a+=w,n+=w,p+=w,typeof u=="number"&&(u-=w),n===r.byteLength&&(await g.write(I(r)),r=L.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),n=0);while(w>0&&(typeof u!="number"||u>0)&&l(v)&&m(p,d));if(n>0){let o=n;typeof u=="number"&&(o=Math.min(n,u)),g.write(I(r.slice(0,o)))}}catch(p){throw(0,R.ensureFileSystemProviderError)(p)}finally{await P.close(h)}}function l(P){if(P.isCancellationRequested)throw(0,D.canceled)();return!0}function m(P,O){if(O?.limits){if(typeof O.limits.memory=="number"&&P>O.limits.memory)throw(0,R.createFileSystemProviderError)((0,S.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof O.limits.size=="number"&&P>O.limits.size)throw(0,R.createFileSystemProviderError)((0,S.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[92],Z([0,1,10,46,69,93]),function(x,t,L,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ParcelWatcherClient=void 0;class C extends R.AbstractRecursiveWatcherClient{constructor(l,m,P){super(l,m,P);this.init()}createWatcher(l){const m=l.add(new S.Client(L.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(m.onDidProcessExit(({code:P,signal:O})=>this.onError(`terminated by itself with code ${P}, signal: ${O}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(m.getChannel("watcher")))}}t.ParcelWatcherClient=C}),define(Q[51],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class L{constructor(...S){this._entries=new Map;for(let[R,C]of S)this.set(R,C)}set(S,R){const C=this._entries.get(S);return this._entries.set(S,R),C}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}t.ServiceCollection=L}),define(Q[94],Z([0,1,3,6,39,90,12,51]),function(x,t,L,D,S,R,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const l=!1;class m extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class P{constructor(d=new b.ServiceCollection,v=!1,h){this._activeInstantiations=new Set,this._services=d,this._strict=v,this._parent=h,this._services.set(C.IInstantiationService,this)}createChild(d){return new P(d,this._strict,this)}invokeFunction(d,...v){let h=g.traceInvocation(d),p=!1;try{return d({get:u=>{if(p)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(u,h);if(!r)throw new Error(`[invokeFunction] unknown service '${u}'`);return r}},...v)}finally{p=!0,h.stop()}}createInstance(d,...v){let h,p;return d instanceof S.SyncDescriptor?(h=g.traceCreation(d.ctor),p=this._createInstance(d.ctor,d.staticArguments.concat(v),h)):(h=g.traceCreation(d),p=this._createInstance(d,v,h)),h.stop(),p}_createInstance(d,v=[],h){let p=C._util.getServiceDependencies(d).sort((r,a)=>r.index-a.index),w=[];for(const r of p){let a=this._getOrCreateServiceInstance(r.id,h);if(!a&&this._strict&&!r.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${r.id}.`);w.push(a)}let u=p.length>0?p[0].index:v.length;if(v.length!==u){console.warn(`[createInstance] First service dependency of ${d.name} at position ${u+1} conflicts with ${v.length} static arguments`);let r=u-v.length;r>0?v=v.concat(new Array(r)):v=v.slice(0,u)}return new d(...[...v,...w])}_setServiceInstance(d,v){if(this._services.get(d)instanceof S.SyncDescriptor)this._services.set(d,v);else if(this._parent)this._parent._setServiceInstance(d,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let v=this._services.get(d);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):v}_getOrCreateServiceInstance(d,v){let h=this._getServiceInstanceOrDescriptor(d);return h instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,h,v.branch(d,!0)):(v.branch(d,!1),h)}_safeCreateAndCacheServiceInstance(d,v,h){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,v,h)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,v,h){const p=new R.Graph(r=>r.id.toString());let w=0;const u=[{id:d,desc:v,_trace:h}];for(;u.length;){const r=u.pop();if(p.lookupOrInsertNode(r),w++>1e3)throw new m(p);for(let a of C._util.getServiceDependencies(r.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(a.id);if(!n&&!a.optional&&console.warn(`[createInstance] ${d} depends on ${a.id} which is NOT registered.`),n instanceof S.SyncDescriptor){const o={id:a.id,desc:n,_trace:r._trace.branch(a.id,!0)};p.insertEdge(r,o),u.push(o)}}}for(;;){const r=p.roots();if(r.length===0){if(!p.isEmpty())throw new m(p);break}for(const{data:a}of r){if(this._getServiceInstanceOrDescriptor(a.id)instanceof S.SyncDescriptor){const o=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,o)}p.removeNode(a)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,v,h=[],p,w){if(this._services.get(d)instanceof S.SyncDescriptor)return this._createServiceInstance(v,h,p,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,v,h,p,w);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(d,v=[],h,p){if(h){const w=new L.IdleValue(()=>this._createInstance(d,v,p));return new Proxy(Object.create(null),{get(u,r){if(r in u)return u[r];let a=w.value,n=a[r];return typeof n!="function"||(n=n.bind(a),u[r]=n),n},set(u,r,a){return w.value[r]=a,!0}})}else return this._createInstance(d,v,p)}}t.InstantiationService=P;var O;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(O||(O={}));class g{constructor(d,v){this.type=d,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return l?new g(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(d){return l?new g(0,d.name):g._None}branch(d,v){let h=new g(2,d.toString());return this._dep.push([d,v,h]),h}stop(){let d=Date.now()-this._start;g._totals+=d;let v=!1;function h(w,u){let r=[],a=new Array(w+1).join("	");for(const[n,o,e]of u._dep)if(o&&e){v=!0,r.push(`${a}CREATES -> ${n}`);let i=h(w+1,e);i&&r.push(i)}else r.push(`${a}uses -> ${n}`);return r.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(d>2||v)&&console.log(p.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Q[52],Z([0,1,12]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,L.createDecorator)("localizationsService");function D(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const R of S.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}t.isValidLocalization=D}),define(Q[13],Z([0,1,27,8,2,14,12]),function(x,t,L,D,S,R,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,C.createDecorator)("logService"),t.ILoggerService=(0,C.createDecorator)("loggerService");function b(){return new Date().toISOString()}var l;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(l=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=l.Info;function m(o,e,i){switch(e){case l.Trace:o.trace(i);break;case l.Debug:o.debug(i);break;case l.Info:o.info(i);break;case l.Warning:o.warn(i);break;case l.Error:o.error(i);break;case l.Critical:o.critical(i);break;default:throw new Error("Invalid log level")}}t.log=m;function P(o){let e="";for(let i=0;i<o.length;i++){let s=o[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}e+=(i>0?" ":"")+s}return e}t.format=P;class O extends S.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=O;class g extends O{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(l.Trace)&&this.log(l.Trace,P([e,...i]))}debug(e,...i){this.checkLogLevel(l.Debug)&&this.log(l.Debug,P([e,...i]))}info(e,...i){this.checkLogLevel(l.Info)&&this.log(l.Info,P([e,...i]))}warn(e,...i){this.checkLogLevel(l.Warning)&&this.log(l.Warning,P([e,...i]))}error(e,...i){if(this.checkLogLevel(l.Error))if(e instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=e.stack,this.log(l.Error,P(s))}else this.log(l.Error,P([e,...i]))}critical(e,...i){this.checkLogLevel(l.Critical)&&this.log(l.Critical,P([e,...i]))}flush(){}}t.AbstractMessageLogger=g;class I extends O{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!R.isWindows}trace(e,...i){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,e,...i):console.log(`[main ${b()}]`,e,...i))}debug(e,...i){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,e,...i):console.log(`[main ${b()}]`,e,...i))}info(e,...i){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,e,...i):console.log(`[main ${b()}]`,e,...i))}warn(e,...i){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,e,...i):console.warn(`[main ${b()}]`,e,...i))}error(e,...i){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,e,...i):console.error(`[main ${b()}]`,e,...i))}critical(e,...i){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,e,...i):console.error(`[main ${b()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=I;class d extends O{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=d;class v extends O{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,L.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}t.AdapterLogger=v;class h extends O{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const s of this.logServices)s.trace(e,...i)}debug(e,...i){for(const s of this.logServices)s.debug(e,...i)}info(e,...i){for(const s of this.logServices)s.info(e,...i)}warn(e,...i){for(const s of this.logServices)s.warn(e,...i)}error(e,...i){for(const s of this.logServices)s.error(e,...i)}critical(e,...i){for(const s of this.logServices)s.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=h;class p extends S.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=p;class w extends S.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(s))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let s=this.loggers.get(e.toString());return s||(s=this.doCreateLogger(e,i?.always?l.Trace:this.logLevel,i),this.loggers.set(e.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=w;class u{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=u;function r(o){if(o.verbose)return l.Trace;if(typeof o.logLevel=="string"){const e=a(o.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=r;function a(o){switch(o){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}t.parseLogLevel=a;function n(o){switch(o){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}t.LogLevelToString=n});var ce=this&&this.__param||function(x,t){return function(L,D){t(L,D,x)}};define(Q[95],Z([0,1,38,3,27,8,2,10,11,15,20,13]),function(x,t,L,D,S,R,C,b,l,m,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let g=class extends C.Disposable{constructor(d,v){super();this.environmentService=d,this.logService=v,this.processesLimiter=new D.Limiter(5)}async postUninstall(d){const v=this.parseScript(d,"uninstall");return v&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(v.script,"uninstall",v.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),h=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${h}`)))),m.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,h=>this.logService.error("Error while removing extension storage path",h))}parseScript(d,v){const h=`vscode:${v}`;if(d.location.scheme===b.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[h]=="string"){const p=d.manifest.scripts[h].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${h} should be a node script`),null):{script:(0,l.join)(d.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(d,v,h,p,w){return new Promise((u,r)=>{const a=this.start(d,v,h,w);let n;const o=e=>{n&&(clearTimeout(n),n=null),e?r(e):u(void 0)};a.on("error",e=>{o((0,S.toErrorMessage)(e)||"Unknown")}),a.on("exit",(e,i)=>{o(e?`post-${v} process exited with code ${e}`:void 0)}),p&&(n=setTimeout(()=>{n=null,a.kill(),r("timed out")},5e3))})}start(d,v,h,p){const w={silent:!0,execArgv:void 0},u=(0,L.fork)(d,[`--type=extension-post-${v}`,...h],w);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const r=R.Event.fromNodeEventEmitter(u.stdout,"data"),a=R.Event.fromNodeEventEmitter(u.stderr,"data");r(e=>this.logService.info(p.identifier.id,p.manifest.version,`post-${v}`,e)),a(e=>this.logService.error(p.identifier.id,p.manifest.version,`post-${v}`,e));const n=R.Event.any(R.Event.map(r,e=>({data:`%c${e}`,format:[""]})),R.Event.map(a,e=>({data:`%c${e}`,format:["color: red"]})));return R.Event.debounce(n,(e,i)=>e?{data:e.data+i.data,format:[...e.format,...i.format]}:{data:i.data,format:i.format},100)(e=>{console.group(p.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),u}getExtensionStoragePath(d){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};g=ve([ce(0,P.IEnvironmentService),ce(1,O.ILogService)],g),t.ExtensionsLifecycle=g}),define(Q[96],Z([0,1,19,3,6,8,2,11,93,13]),function(x,t,L,D,S,R,C,b,l,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class P extends C.Disposable{constructor(g){super();this.logService=g,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(g,I){return I.recursive?this.watchRecursive(g,I):this.watchNonRecursive(g,I)}watchRecursive(g,I){const d={path:this.toFilePath(g),excludes:I.excludes},v=(0,L.insert)(this.recursiveFoldersToWatch,d);return this.refreshRecursiveWatchers(),(0,C.toDisposable)(()=>{v(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(g=>(0,S.onUnexpectedError)(g))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(g=>this._onDidChangeFile.fire((0,l.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(g,I){return g.watch(I)}watchNonRecursive(g,I){const d=new C.DisposableStore,v=d.add(this.createNonRecursiveWatcher({path:this.toFilePath(g),excludes:I.excludes},h=>this._onDidChangeFile.fire((0,l.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===m.LogLevel.Trace));return d.add(this.logService.onDidChangeLogLevel(()=>{v.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})),d}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,b.normalize)(g.fsPath)}}t.AbstractDiskFileSystemProvider=P}),define(Q[97],Z([0,1,19,3,17,24,8,131,2,53,10,98,18,37,80,16,50,13]),function(x,t,L,D,S,R,C,b,l,m,P,O,g,I,d,v,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let w=class xe extends l.Disposable{constructor(r){super();this.logService=r,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new C.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new C.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new C.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new C.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new D.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new v.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new D.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new v.FileChangesEvent(a,!0)))),this.nonRecursiveWatchedResources=m.TernarySearchTree.forUris(a=>{const n=this.getProvider(a.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(r,a){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,O.mark)(`code/registerFilesystem/${r}`),this.provider.set(r,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:a});const n=new l.DisposableStore;return n.add(a.onDidChangeFile(o=>this.onDidChangeFile(o,this.isPathCaseSensitive(a)))),n.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:r}))),typeof a.onDidWatchError=="function"&&n.add(a.onDidWatchError(o=>this._onDidWatchError.fire(new Error(o)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:a}),this.provider.delete(r),(0,l.dispose)(n)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(n){a.push(n)}}),!this.provider.has(r)&&await D.Promises.settled(a)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.provider.has(r.scheme)}hasCapability(r,a){const n=this.provider.get(r.scheme);return!!(n&&n.capabilities&a)}listCapabilities(){return b.Iterable.map(this.provider,([r,a])=>({scheme:r,capabilities:a.capabilities}))}async withProvider(r){if(!(0,g.isAbsolutePath)(r))throw new v.FileOperationError((0,d.localize)(0,null,this.resourceForError(r)),8);await this.activateProvider(r.scheme);const a=this.provider.get(r.scheme);if(!a){const n=new Error;throw n.name="ENOPRO",n.message=(0,d.localize)(1,null,r.toString()),n}return a}async withReadProvider(r){const a=await this.withProvider(r);if((0,v.hasOpenReadWriteCloseCapability)(a)||(0,v.hasReadWriteCapability)(a)||(0,v.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const a=await this.withProvider(r);if((0,v.hasOpenReadWriteCloseCapability)(a)||(0,v.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,a){try{return await this.doResolveFile(r,a)}catch(n){throw(0,v.toFileSystemProviderErrorCode)(n)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,d.localize)(2,null,this.resourceForError(r)),1):(0,v.ensureFileSystemProviderError)(n)}}async doResolveFile(r,a){const n=await this.withProvider(r),o=this.isPathCaseSensitive(n),e=a?.resolveTo,i=a?.resolveSingleChildDescendants,s=a?.resolveMetadata,c=await n.stat(r);let f;return this.toFileStat(n,r,c,void 0,!!s,(E,y)=>(f||(f=m.TernarySearchTree.forUris(()=>!o),f.set(r,!0),e&&f.fill(!0,e)),f.get(E.resource)||f.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&i?y===1:!1))}async toFileStat(r,a,n,o,e,i){const{providerExtUri:s}=this.getExtUri(r),c={resource:a,name:s.basename(a),isFile:(n.type&v.FileType.File)!=0,isDirectory:(n.type&v.FileType.Directory)!=0,isSymbolicLink:(n.type&v.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&v.FilePermission.Readonly)||Boolean(r.capabilities&2048),etag:(0,v.etag)({mtime:n.mtime,size:n.size})};if(c.isDirectory&&i(c,o)){try{const f=await r.readdir(a),E=await D.Promises.settled(f.map(async([y,T])=>{try{const k=s.joinPath(a,y),B=e?await r.stat(k):{type:T};return await this.toFileStat(r,k,B,f.length,e,i)}catch(k){return this.logService.trace(k),null}}));c.children=(0,L.coalesce)(E)}catch(f){this.logService.trace(f),c.children=[]}return c}return c}async resolveAll(r){return D.Promises.settled(r.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(r){const a=await this.withProvider(r);try{return!!await a.stat(r)}catch{return!1}}async canCreateFile(r,a){try{await this.doValidateCreateFile(r,a)}catch(n){return n}return!0}async doValidateCreateFile(r,a){if(!a?.overwrite&&await this.exists(r))throw new v.FileOperationError((0,d.localize)(3,null,this.resourceForError(r)),3,a)}async createFile(r,a=S.VSBuffer.fromString(""),n){await this.doValidateCreateFile(r,n);const o=await this.writeFile(r,a);return this._onDidRunOperation.fire(new v.FileOperationEvent(r,0,o)),o}async writeFile(r,a,n){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:e}=this.getExtUri(o);try{await this.validateWriteFile(o,r,n)||await this.mkdirp(o,e.dirname(r));let s;if((0,v.hasReadWriteCapability)(o)&&!(a instanceof S.VSBuffer))if((0,I.isReadableStream)(a)){const c=await(0,I.peekStream)(a,3);c.ended?s=S.VSBuffer.concat(c.buffer):s=c}else s=(0,I.peekReadable)(a,c=>S.VSBuffer.concat(c),3);else s=a;!(0,v.hasOpenReadWriteCloseCapability)(o)||(0,v.hasReadWriteCapability)(o)&&s instanceof S.VSBuffer?await this.doWriteUnbuffered(o,r,n,s):await this.doWriteBuffered(o,r,n,s instanceof S.VSBuffer?(0,S.bufferToReadable)(s):s)}catch(i){throw new v.FileOperationError((0,d.localize)(4,null,this.resourceForError(r),(0,v.ensureFileSystemProviderError)(i).toString()),(0,v.toFileOperationResult)(i),n)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,a,n){if(!!n?.unlock&&!(r.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(a)));let e;try{e=await r.stat(a)}catch{return}if((e.type&v.FileType.Directory)!=0)throw new v.FileOperationError((0,d.localize)(6,null,this.resourceForError(a)),0,n);if(this.throwIfFileIsReadonly(a,e),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==v.ETAG_DISABLED&&typeof e.mtime=="number"&&typeof e.size=="number"&&n.mtime<e.mtime&&n.etag!==(0,v.etag)({mtime:n.mtime,size:e.size}))throw new v.FileOperationError((0,d.localize)(7,null),3,n);return e}async readFile(r,a,n){const o=await this.withReadProvider(r);return a?.atomic?this.doReadFileAtomic(o,r,a,n):this.doReadFile(o,r,a,n)}async doReadFileAtomic(r,a,n,o){return new Promise((e,i)=>{this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(r,a,n,o);e(s)}catch(s){i(s)}})})}async doReadFile(r,a,n,o){const e=await this.doReadFileStream(r,a,{...n,preferUnbuffered:!0},o);return{...e,value:await(0,S.streamToBuffer)(e.value)}}async readFileStream(r,a,n){const o=await this.withReadProvider(r);return this.doReadFileStream(o,r,a,n)}async doReadFileStream(r,a,n,o){const e=new R.CancellationTokenSource(o),i=this.validateReadFile(a,n).then(c=>c,c=>{throw e.cancel(),c});let s;try{return typeof n?.etag=="string"&&n.etag!==v.ETAG_DISABLED&&await i,n?.atomic&&(0,v.hasFileAtomicReadCapability)(r)||!((0,v.hasOpenReadWriteCloseCapability)(r)||(0,v.hasFileReadStreamCapability)(r))||(0,v.hasReadWriteCapability)(r)&&n?.preferUnbuffered?s=this.readFileUnbuffered(r,a,n):(0,v.hasFileReadStreamCapability)(r)?s=this.readFileStreamed(r,a,e.token,n):s=this.readFileBuffered(r,a,e.token,n),{...await i,value:s}}catch(c){s&&await(0,I.consumeStream)(s);const f=(0,d.localize)(8,null,this.resourceForError(a),(0,v.ensureFileSystemProviderError)(c).toString());throw c instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(f,c.stat,n):new v.FileOperationError(f,(0,v.toFileOperationResult)(c),n)}}readFileStreamed(r,a,n,o=Object.create(null)){const e=r.readFileStream(a,o,n);return(0,I.transform)(e,{data:i=>i instanceof S.VSBuffer?i:S.VSBuffer.wrap(i),error:i=>new v.FileOperationError((0,d.localize)(9,null,this.resourceForError(a),(0,v.ensureFileSystemProviderError)(i).toString()),(0,v.toFileOperationResult)(i),o)},i=>S.VSBuffer.concat(i))}readFileBuffered(r,a,n,o=Object.create(null)){const e=(0,S.newWriteableBufferStream)();return(0,h.readFileIntoStream)(r,a,e,i=>i,{...o,bufferSize:this.BUFFER_SIZE,errorTransformer:i=>new v.FileOperationError((0,d.localize)(10,null,this.resourceForError(a),(0,v.ensureFileSystemProviderError)(i).toString()),(0,v.toFileOperationResult)(i),o)},n),e}readFileUnbuffered(r,a,n){const o=(0,I.newWriteableStream)(e=>S.VSBuffer.concat(e));return(async()=>{try{let e;n?.atomic&&(0,v.hasFileAtomicReadCapability)(r)?e=await r.readFile(a,{atomic:!0}):e=await r.readFile(a),typeof n?.position=="number"&&(e=e.slice(n.position)),typeof n?.length=="number"&&(e=e.slice(0,n.length)),this.validateReadFileLimits(a,e.byteLength,n),o.end(S.VSBuffer.wrap(e))}catch(e){o.error(e),o.end()}})(),o}async validateReadFile(r,a){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new v.FileOperationError((0,d.localize)(11,null,this.resourceForError(r)),0,a);if(typeof a?.etag=="string"&&a.etag!==v.ETAG_DISABLED&&a.etag===n.etag)throw new v.NotModifiedSinceFileOperationError((0,d.localize)(12,null),n,a);return this.validateReadFileLimits(r,n.size,a),n}validateReadFileLimits(r,a,n){if(n?.limits){let o;if(typeof n.limits.memory=="number"&&a>n.limits.memory&&(o=9),typeof n.limits.size=="number"&&a>n.limits.size&&(o=7),typeof o=="number")throw new v.FileOperationError((0,d.localize)(13,null,this.resourceForError(r)),o)}}async canMove(r,a,n){return this.doCanMoveCopy(r,a,"move",n)}async canCopy(r,a,n){return this.doCanMoveCopy(r,a,"copy",n)}async doCanMoveCopy(r,a,n,o){if(r.toString()!==a.toString())try{const e=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(e,r,i,a,n,o)}catch(e){return e}return!0}async move(r,a,n){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=await this.doMoveCopy(o,r,e,a,"move",!!n),s=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(r,i==="move"?2:3,s)),s}async copy(r,a,n){const o=await this.withReadProvider(r),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=await this.doMoveCopy(o,r,e,a,"copy",!!n),s=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(r,i==="copy"?3:2,s)),s}async doMoveCopy(r,a,n,o,e,i){if(a.toString()===o.toString())return e;const{exists:s,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(r,a,n,o,e,i);if(s&&!c&&i&&await this.del(o,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(o)),e==="copy"){if(r===n&&(0,v.hasFileFolderCopyCapability)(r))await r.copy(a,o,{overwrite:i});else{const f=await this.resolve(a);f.isDirectory?await this.doCopyFolder(r,f,n,o):await this.doCopyFile(r,a,n,o)}return e}else return r===n?(await r.rename(a,o,{overwrite:i}),e):(await this.doMoveCopy(r,a,n,o,"copy",i),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(r,a,n,o){if((0,v.hasOpenReadWriteCloseCapability)(r)&&(0,v.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(r,a,n,o);if((0,v.hasOpenReadWriteCloseCapability)(r)&&(0,v.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(r,a,n,o);if((0,v.hasReadWriteCapability)(r)&&(0,v.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(r,a,n,o);if((0,v.hasReadWriteCapability)(r)&&(0,v.hasReadWriteCapability)(n))return this.doPipeUnbuffered(r,a,n,o)}async doCopyFolder(r,a,n,o){await n.mkdir(o),Array.isArray(a.children)&&await D.Promises.settled(a.children.map(async e=>{const i=this.getExtUri(n).providerExtUri.joinPath(o,e.name);return e.isDirectory?this.doCopyFolder(r,await this.resolve(e.resource),n,i):this.doCopyFile(r,e.resource,n,i)}))}async doValidateMoveCopy(r,a,n,o,e,i){let s=!1;if(r===n){const{providerExtUri:f,isPathCaseSensitive:E}=this.getExtUri(r);if(E||(s=f.isEqual(a,o)),s&&e==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(a),this.resourceForError(o)));if(!s&&f.isEqualOrParent(o,a))throw new Error((0,d.localize)(15,null,this.resourceForError(a),this.resourceForError(o)))}const c=await this.exists(o);if(c&&!s){if(!i)throw new v.FileOperationError((0,d.localize)(16,null,this.resourceForError(a),this.resourceForError(o)),4);if(r===n){const{providerExtUri:f}=this.getExtUri(r);if(f.isEqualOrParent(a,o))throw new Error((0,d.localize)(17,null,this.resourceForError(a),this.resourceForError(o)))}}return{exists:c,isSameResourceWithDifferentPathCase:s}}getExtUri(r){const a=this.isPathCaseSensitive(r);return{providerExtUri:a?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(r){return!!(r.capabilities&1024)}async createFolder(r){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(a,r);const n=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(r,0,n)),n}async mkdirp(r,a){const n=[],{providerExtUri:o}=this.getExtUri(r);for(;!o.isEqual(a,o.dirname(a));)try{if(((await r.stat(a)).type&v.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(a)));break}catch(e){if((0,v.toFileSystemProviderErrorCode)(e)!==v.FileSystemProviderErrorCode.FileNotFound)throw e;n.push(o.basename(a)),a=o.dirname(a)}for(let e=n.length-1;e>=0;e--){a=o.joinPath(a,n[e]);try{await r.mkdir(a)}catch(i){if((0,v.toFileSystemProviderErrorCode)(i)!==v.FileSystemProviderErrorCode.FileExists)throw i}}}async canDelete(r,a){try{await this.doValidateDelete(r,a)}catch(n){return n}return!0}async doValidateDelete(r,a){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);if(!!a?.useTrash&&!(n.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(r)));let e;try{e=await n.stat(r)}catch{}if(e)this.throwIfFileIsReadonly(r,e);else throw new v.FileOperationError((0,d.localize)(20,null,this.resourceForError(r)),1);if(!!!a?.recursive){const s=await this.resolve(r);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(r)))}return n}async del(r,a){const n=await this.doValidateDelete(r,a),o=!!a?.useTrash,e=!!a?.recursive;await n.delete(r,{recursive:e,useTrash:o}),this._onDidRunOperation.fire(new v.FileOperationEvent(r,1))}onDidChangeFile(r,a){this._onDidChangeFilesRaw.fire({changes:r});let n,o;{for(const e of r)this.nonRecursiveWatchedResources.has(e.resource)?(n||(n=[]),n.push(e)):(o||(o=[]),o.push(e));n&&this._onDidFilesChange.fire(new v.FileChangesEvent(n,!a))}if(o){const e=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!e.work(o)&&xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),e.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${e.pending}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(r,a={recursive:!1,excludes:[]}){const n=new l.DisposableStore;let o=!1,e=()=>{o=!0};return n.add((0,l.toDisposable)(()=>e())),(async()=>{try{const i=await this.doWatch(r,a);o?(0,l.dispose)(i):e=()=>(0,l.dispose)(i)}catch(i){this.logService.error(i)}})(),a.recursive||(this.nonRecursiveWatchedResources.set(r,(this.nonRecursiveWatchedResources.get(r)??0)+1),n.add((0,l.toDisposable)(()=>{const i=this.nonRecursiveWatchedResources.get(r);typeof i=="number"&&(i<=1?this.nonRecursiveWatchedResources.delete(r):this.nonRecursiveWatchedResources.set(r,i-1))}))),n}async doWatch(r,a){const n=await this.withProvider(r),o=this.toWatchKey(n,r,a);let e=this.activeWatchers.get(o);return e||(e={count:0,disposable:n.watch(r,a)},this.activeWatchers.set(o,e)),e.count+=1,(0,l.toDisposable)(()=>{e&&(e.count--,e.count===0&&((0,l.dispose)(e.disposable),this.activeWatchers.delete(o)))})}toWatchKey(r,a,n){const{providerExtUri:o}=this.getExtUri(r);return[o.getComparisonKey(a),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,r]of this.activeWatchers)(0,l.dispose)(r.disposable);this.activeWatchers.clear()}async doWriteBuffered(r,a,n,o){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(async()=>{const e=await r.open(a,{create:!0,unlock:n?.unlock??!1});try{(0,I.isReadableStream)(o)||(0,I.isReadableBufferedStream)(o)?await this.doWriteStreamBufferedQueued(r,e,o):await this.doWriteReadableBufferedQueued(r,e,o)}catch(i){throw(0,v.ensureFileSystemProviderError)(i)}finally{await r.close(e)}})}async doWriteStreamBufferedQueued(r,a,n){let o=0,e;if((0,I.isReadableBufferedStream)(n)){if(n.buffer.length>0){const i=S.VSBuffer.concat(n.buffer);await this.doWriteBuffer(r,a,i,i.byteLength,o,0),o+=i.byteLength}if(n.ended)return;e=n.stream}else e=n;return new Promise((i,s)=>{(0,I.listenStream)(e,{onData:async c=>{e.pause();try{await this.doWriteBuffer(r,a,c,c.byteLength,o,0)}catch(f){return s(f)}o+=c.byteLength,setTimeout(()=>e.resume())},onError:c=>s(c),onEnd:()=>i()})})}async doWriteReadableBufferedQueued(r,a,n){let o=0,e;for(;(e=n.read())!==null;)await this.doWriteBuffer(r,a,e,e.byteLength,o,0),o+=e.byteLength}async doWriteBuffer(r,a,n,o,e,i){let s=0;for(;s<o;)s+=await r.write(a,e+s,n.buffer,i+s,o-s)}async doWriteUnbuffered(r,a,n,o){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(r,a,n,o))}async doWriteUnbufferedQueued(r,a,n,o){let e;o instanceof S.VSBuffer?e=o:(0,I.isReadableStream)(o)?e=await(0,S.streamToBuffer)(o):(0,I.isReadableBufferedStream)(o)?e=await(0,S.bufferedStreamToBuffer)(o):e=(0,S.readableToBuffer)(o),await r.writeFile(a,e.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(r,a,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(r,a,n,o))}async doPipeBufferedQueued(r,a,n,o){let e,i;try{e=await r.open(a,{create:!1}),i=await n.open(o,{create:!0,unlock:!1});const s=S.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,f=0,E=0;do E=await r.read(e,c,s.buffer,f,s.byteLength-f),await this.doWriteBuffer(n,i,s,E,c,f),c+=E,f+=E,f===s.byteLength&&(f=0);while(E>0)}catch(s){throw(0,v.ensureFileSystemProviderError)(s)}finally{await D.Promises.settled([typeof e=="number"?r.close(e):Promise.resolve(),typeof i=="number"?n.close(i):Promise.resolve()])}}async doPipeUnbuffered(r,a,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(r,a,n,o))}async doPipeUnbufferedQueued(r,a,n,o){return n.writeFile(o,await r.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(r,a,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(r,a,n,o))}async doPipeUnbufferedToBufferedQueued(r,a,n,o){const e=await n.open(o,{create:!0,unlock:!1});try{const i=await r.readFile(a);await this.doWriteBuffer(n,e,S.VSBuffer.wrap(i),i.byteLength,0,0)}catch(i){throw(0,v.ensureFileSystemProviderError)(i)}finally{await n.close(e)}}async doPipeBufferedToUnbuffered(r,a,n,o){const e=await(0,S.streamToBuffer)(this.readFileBuffered(r,a,R.CancellationToken.None));await this.doWriteUnbuffered(n,o,void 0,e)}throwIfFileSystemIsReadonly(r,a){if(r.capabilities&2048)throw new v.FileOperationError((0,d.localize)(22,null,this.resourceForError(a)),6);return r}throwIfFileIsReadonly(r,a){if((a.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,d.localize)(23,null,this.resourceForError(r)),6)}resourceForError(r){return r.scheme===P.Schemas.file?r.fsPath:r.toString(!0)}};w.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},w=ve([ce(0,p.ILogService)],w),t.FileService=w}),define(Q[99],Z([0,1,100,132,3,53,17,8,45,2,11,14,18,37,15,82,16,50,133,92,96,27]),function(x,t,L,D,S,R,C,b,l,m,P,O,g,I,d,v,h,p,w,u,r,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(o)}`)}})();class n extends r.AbstractDiskFileSystemProvider{constructor(e,i){super(e);this.options=i,this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new R.ResourceMap(s=>g.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,O.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:i,symbolicLink:s}=await d.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(e){try{const i=await d.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async c=>{try{let f;c.isSymbolicLink()?f=(await this.stat((0,g.joinPath)(e,c.name))).type:f=this.toType(c),s.push([c.name,f])}catch(f){this.logService.trace(f)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(e,i){let s;return i?.dangling?s=h.FileType.Unknown:e.isFile()?s=h.FileType.File:e.isDirectory()?s=h.FileType.Directory:s=h.FileType.Unknown,i&&(s|=h.FileType.SymbolicLink),s}async createResourceLock(e){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(e)})`);let i;for(;i=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(e)})`),await i.wait();const s=new S.Barrier;return this.resourceLocks.set(e,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(e)})`),(0,m.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(e)})`),this.resourceLocks.delete(e),s.open()})}async readFile(e,i){let s;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),s=await this.createResourceLock(e));const c=this.toFilePath(e);return await d.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{s?.dispose()}}readFileStream(e,i,s){const c=(0,I.newWriteableStream)(f=>C.VSBuffer.concat(f.map(E=>C.VSBuffer.wrap(E))).buffer);return(0,p.readFileIntoStream)(this,e,c,f=>f.buffer,{...i,bufferSize:256*1024},s),c}async writeFile(e,i,s){let c;try{const f=this.toFilePath(e);if(!s.create||!s.overwrite){if(await d.Promises.exists(f)){if(!s.overwrite)throw(0,h.createFileSystemProviderError)((0,v.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,h.createFileSystemProviderError)((0,v.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(e,{create:!0,unlock:s.unlock}),await this.write(c,0,i,0,i.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(e,f)}finally{typeof c=="number"&&await this.close(c)}}async open(e,i){let s;(0,h.isFileOpenForWriteOptions)(i)&&(s=await this.createResourceLock(e));let c;try{const f=this.toFilePath(e);if((0,h.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:y}=await d.SymlinkSupport.stat(f);y.mode&128||await d.Promises.chmod(f,y.mode|128)}catch(y){this.logService.trace(y)}let E;if((0,h.isFileOpenForWriteOptions)(i)){if(O.isWindows)try{await d.Promises.truncate(f,0),E="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}E||(E="w")}else E="r";c=await d.Promises.open(f,E)}catch(f){throw s?.dispose(),(0,h.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(e,f):this.toFileSystemProviderError(f)}return this.mapHandleToPos.set(c,0),(0,h.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(c,e),s&&this.mapHandleToLock.set(c,s),c}async close(e){try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await d.Promises.fdatasync(e)}catch(i){this.canFlush=!1,this.logService.error(i)}return await d.Promises.close(e)}catch(i){throw this.toFileSystemProviderError(i)}finally{const i=this.mapHandleToLock.get(e);i&&(this.mapHandleToLock.delete(e),i.dispose())}}async read(e,i,s,c,f){const E=this.normalizePos(e,i);let y=null;try{const T=await d.Promises.read(e,s,c,f,E);return typeof T=="number"?y=T:y=T.bytesRead,y}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(e,E,y)}}normalizePos(e,i){return i===this.mapHandleToPos.get(e)?null:i}updatePos(e,i,s){const c=this.mapHandleToPos.get(e);typeof c=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(e,c+s):this.mapHandleToPos.delete(e)))}async write(e,i,s,c,f){return(0,S.retry)(()=>this.doWrite(e,i,s,c,f),100,3)}async doWrite(e,i,s,c,f){const E=this.normalizePos(e,i);let y=null;try{const T=await d.Promises.write(e,s,c,f,E);return typeof T=="number"?y=T:y=T.bytesWritten,y}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),T)}finally{this.updatePos(e,E,y)}}async mkdir(e){try{await d.Promises.mkdir(this.toFilePath(e))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(e,i){try{const s=this.toFilePath(e);i.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(e,i,s){const c=this.toFilePath(e),f=this.toFilePath(i);if(c!==f)try{await this.validateTargetDeleted(e,i,"move",s.overwrite),await d.Promises.move(c,f)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,v.localize)(2,null,(0,P.basename)(c),(0,P.basename)((0,P.dirname)(f)),E.toString()))),this.toFileSystemProviderError(E)}}async copy(e,i,s){const c=this.toFilePath(e),f=this.toFilePath(i);if(c!==f)try{await this.validateTargetDeleted(e,i,"copy",s.overwrite),await d.Promises.copy(c,f,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,v.localize)(3,null,(0,P.basename)(c),(0,P.basename)((0,P.dirname)(f)),E.toString()))),this.toFileSystemProviderError(E)}}async validateTargetDeleted(e,i,s,c){const f=this.toFilePath(e),E=this.toFilePath(i);let y=!1;if(!!(this.capabilities&1024)||(y=(0,l.isEqual)(f,E,!0)),y&&s==="copy")throw(0,h.createFileSystemProviderError)((0,v.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!y&&await d.Promises.exists(E)){if(!c)throw(0,h.createFileSystemProviderError)((0,v.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(e,i,s){return new u.ParcelWatcherClient(c=>e(c),c=>i(c),s)}doWatch(e,i){const s=this.options?.watcher?.usePolling;if(s===!0)for(const c of i)c.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(s))for(const c of i)s.includes(c.path)&&(c.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(e,i)}createNonRecursiveWatcher(e,i,s,c){return new w.NodeJSFileWatcher(e,f=>i(f),f=>s(f),c)}toFileSystemProviderError(e){if(e instanceof h.FileSystemProviderError)return e;let i;switch(e.code){case"ENOENT":i=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=h.FileSystemProviderErrorCode.NoPermissions;break;default:i=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(e,i)}async toFileSystemProviderWriteError(e,i){let s=this.toFileSystemProviderError(i);if(e&&s.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.toFilePath(e));c.mode&128||(s=(0,h.createFileSystemProviderError)(i,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return s}}t.DiskFileSystemProvider=n}),define(Q[101],Z([0,1,16,13]),function(x,t,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=void 0;async function S(b,l,m,P,O){try{const g=await new Promise((d,v)=>{x(["spdlog"],d,v)});g.setFlushOn(D.LogLevel.Trace);const I=await g.createAsyncRotatingLogger(b,l,m,P);return O&&I.clearFormatters(),I}catch(g){console.error(g)}return null}function R(b,l,m){switch(l){case D.LogLevel.Trace:b.trace(m);break;case D.LogLevel.Debug:b.debug(m);break;case D.LogLevel.Info:b.info(m);break;case D.LogLevel.Warning:b.warn(m);break;case D.LogLevel.Error:b.error(m);break;case D.LogLevel.Critical:b.critical(m);break;default:throw new Error("Invalid log level")}}class C extends D.AbstractMessageLogger{constructor(l,m,P,O,g){super();this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(l,m,P,O),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}async _createSpdLogLogger(l,m,P,O){const g=P?6:1,I=30/g*L.ByteSize.MB,d=await S(l,m,I,g,O);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:v,message:h}of this.buffer)R(this._logger,v,h);this.buffer=[]}}log(l,m){this._logger?R(this._logger,l,m):this.getLevel()<=l&&this.buffer.push({level:l,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=C}),define(Q[32],Z([0,1,12]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.productSchemaId=t.IProductService=void 0,t.IProductService=(0,L.createDecorator)("productService"),t.productSchemaId="vscode://schemas/vscode-product"}),define(Q[29],Z([0,1,54,7]),function(x,t,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class S{constructor(){this.data=new Map}add(C,b){L.ok(D.isString(C)),L.ok(D.isObject(b)),L.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,b)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}t.Registry=new S}),define(Q[102],Z([0,1,8,29]),function(x,t,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function S(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,m){this.schemasById[S(l)]=m,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new R;D.Registry.add(t.Extensions.JSONContribution,C)}),define(Q[34],Z([0,1,19,8,7,71,102,29]),function(x,t,L,D,S,R,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.keyFromOverrideIdentifiers=t.overrideIdentifiersFromKey=t.OVERRIDE_PROPERTY_REGEX=t.OVERRIDE_PROPERTY_PATTERN=t.configurationDefaultsSchemaId=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var l;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(l=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var m;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",t.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=b.Registry.as(C.Extensions.JSONContribution);class O{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,n=!0){this.registerConfigurations([a],n)}registerConfigurations(a,n=!0){const o=this.doRegisterConfigurations(a,n);P.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}deregisterConfigurations(a){const n=this.doDeregisterConfigurations(a);P.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:a,remove:n}){const o=[];o.push(...this.doDeregisterConfigurations(n)),o.push(...this.doRegisterConfigurations(a,!1)),P.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,L.distinct)(o)})}registerDefaultConfigurations(a){const n=[],o=[];for(const{overrides:e,source:i}of a)for(const s in e)if(n.push(s),t.OVERRIDE_PROPERTY_REGEX.test(s)){const c={...this.configurationDefaultsOverrides.get(s)?.value||{},...e[s]};this.configurationDefaultsOverrides.set(s,{source:i,value:c});const f={type:"object",default:c,description:R.localize(1,null,s),$ref:t.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:S.isString(i)?void 0:i};o.push(...d(s)),this.configurationProperties[s]=f,this.defaultLanguageConfigurationOverridesNode.properties[s]=f}else{this.configurationDefaultsOverrides.set(s,{value:e[s],source:i});const c=this.configurationProperties[s];c&&(this.updatePropertyDefaultValue(s,c),this.updateSchema(s,c))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(a){const n=[];for(const{overrides:o,source:e}of a)for(const i in o){const s=this.configurationDefaultsOverrides.get(i),c=S.isString(e)?e:e?.id,f=S.isString(s?.source)?s?.source:s?.source?.id;if(c===f)if(n.push(i),this.configurationDefaultsOverrides.delete(i),t.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const E=this.configurationProperties[i];E&&(this.updatePropertyDefaultValue(i,E),this.updateSchema(i,E))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const n of a)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,n){const o=[];return a.forEach(e=>{o.push(...this.validateAndRegisterProperties(e,n,e.extensionInfo,e.restrictedProperties)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),o}doDeregisterConfigurations(a){const n=[],o=e=>{if(e.properties)for(const i in e.properties)n.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,e.properties[i]);e.allOf&&e.allOf.forEach(i=>o(i))};for(const e of a){o(e);const i=this.configurationContributors.indexOf(e);i!==-1&&this.configurationContributors.splice(i,1)}return n}validateAndRegisterProperties(a,n=!0,o,e,i=3){i=S.isUndefinedOrNull(a.scope)?i:a.scope;let s=[],c=a.properties;if(c)for(let E in c){if(n&&w(E)){delete c[E];continue}const y=c[E];if(y.source=o,y.defaultDefaultValue=c[E].default,this.updatePropertyDefaultValue(E,y),t.OVERRIDE_PROPERTY_REGEX.test(E)?y.scope=void 0:(y.scope=S.isUndefinedOrNull(y.scope)?i:y.scope,y.restricted=S.isUndefinedOrNull(y.restricted)?!!e?.includes(E):y.restricted),c[E].hasOwnProperty("included")&&!c[E].included){this.excludedConfigurationProperties[E]=c[E],delete c[E];continue}else this.configurationProperties[E]=c[E];!c[E].deprecationMessage&&c[E].markdownDeprecationMessage&&(c[E].deprecationMessage=c[E].markdownDeprecationMessage),s.push(E)}let f=a.allOf;if(f)for(let E of f)s.push(...this.validateAndRegisterProperties(E,n,o,e,i));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const n=o=>{let e=o.properties;if(e)for(const s in e)this.updateSchema(s,e[s]);let i=o.allOf;i&&i.forEach(n)};n(a)}updateSchema(a,n){switch(t.allSettings.properties[a]=n,n.scope){case 1:t.applicationSettings.properties[a]=n;break;case 2:t.machineSettings.properties[a]=n;break;case 6:t.machineOverridableSettings.properties[a]=n;break;case 3:t.windowSettings.properties[a]=n;break;case 4:t.resourceSettings.properties[a]=n;break;case 5:t.resourceSettings.properties[a]=n,this.resourceLanguageSettingsSchema.properties[a]=n;break}}removeFromSchema(a,n){switch(delete t.allSettings.properties[a],n.scope){case 1:delete t.applicationSettings.properties[a];break;case 2:delete t.machineSettings.properties[a];break;case 6:delete t.machineOverridableSettings.properties[a];break;case 3:delete t.windowSettings.properties[a];break;case 4:case 5:delete t.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const n=`[${a}]`,o={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,o),t.allSettings.properties[n]=o,t.applicationSettings.properties[n]=o,t.machineSettings.properties[n]=o,t.machineOverridableSettings.properties[n]=o,t.windowSettings.properties[n]=o,t.resourceSettings.properties[n]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=a,t.applicationSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=a,t.machineSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=a,t.machineOverridableSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=a,t.windowSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=a,t.resourceSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,n){const o=this.configurationDefaultsOverrides.get(a);let e=o?.value,i=o?.source;S.isUndefined(e)&&(e=n.defaultDefaultValue,i=void 0),S.isUndefined(e)&&(e=h(n.type)),n.default=e,n.defaultValueSource=i}}const g="\\[([^\\]]+)\\]",I=new RegExp(g,"g");t.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,t.OVERRIDE_PROPERTY_REGEX=new RegExp(t.OVERRIDE_PROPERTY_PATTERN);function d(r){const a=[];if(t.OVERRIDE_PROPERTY_REGEX.test(r)){let n=I.exec(r);for(;n?.length;){const o=n[1].trim();o&&a.push(o),n=I.exec(r)}}return(0,L.distinct)(a)}t.overrideIdentifiersFromKey=d;function v(r){return r.reduce((a,n)=>`${a}[${n}]`,"")}t.keyFromOverrideIdentifiers=v;function h(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=h;const p=new O;b.Registry.add(t.Extensions.Configuration,p);function w(r){return r.trim()?t.OVERRIDE_PROPERTY_REGEX.test(r)?R.localize(7,null,r):p.getConfigurationProperties()[r]!==void 0?R.localize(8,null,r):null:R.localize(6,null)}t.validateProperty=w;function u(){const r=[],a=p.getConfigurationProperties();for(const n of Object.keys(a))r.push([n,a[n].scope]);return r.push(["launch",4]),r.push(["task",4]),r}t.getScopes=u}),define(Q[103],Z([0,1,19,8,55,2,53,21,7,9,25,34,29]),function(x,t,L,D,S,R,C,b,l,m,P,O,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class I{constructor(e={},i=[],s=[]){this._contents=e,this._keys=i,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,P.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const s=this.getContentsForOverrideIdentifer(i);return s?e?(0,P.getConfigurationValue)(s,e):s:void 0}getKeysForOverrideIdentifier(e){const i=[];for(const s of this.overrides)s.identifiers.includes(e)&&i.push(...s.keys);return L.distinct(i)}getAllOverrideIdentifiers(){const e=[];for(const i of this.overrides)e.push(...i.identifiers);return L.distinct(e)}override(e){let i=this.overrideConfigurations.get(e);return i||(i=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,i)),i}merge(...e){const i=b.deepClone(this.contents),s=b.deepClone(this.overrides),c=[...this.keys];for(const f of e){this.mergeContents(i,f.contents);for(const E of f.overrides){const[y]=s.filter(T=>L.equals(T.identifiers,E.identifiers));y?(this.mergeContents(y.contents,E.contents),y.keys.push(...E.keys),y.keys=L.distinct(y.keys)):s.push(b.deepClone(E))}for(const E of f.keys)c.indexOf(E)===-1&&c.push(E)}return new I(i,c,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const c of L.distinct([...Object.keys(this.contents),...Object.keys(i)])){let f=this.contents[c],E=i[c];E&&(typeof f=="object"&&typeof E=="object"?(f=b.deepClone(f),this.mergeContents(f,E)):f=E),s[c]=f}return new I(s,this.keys,this.overrides)}mergeContents(e,i){for(const s of Object.keys(i)){if(s in e&&l.isObject(e[s])&&l.isObject(i[s])){this.mergeContents(e[s],i[s]);continue}e[s]=b.deepClone(i[s])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?b.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let i=null,s=null;const c=f=>{f&&(s?this.mergeContents(s,f):s=b.deepClone(f))};for(const f of this.overrides)L.equals(f.identifiers,[e])?i=f.contents:f.identifiers.includes(e)&&c(f.contents);return c(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,P.addToValueTree)(this.contents,e,i,s=>{throw new Error(s)})}removeValue(e){this.removeKey(e)&&(0,P.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let s=0;s<i;s++)e.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=I;class d extends I{constructor(e={}){const i=g.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(i),c=Object.create(null),f=[];for(const E in i){const y=e[E],T=y!==void 0?y:i[E].default;(0,P.addToValueTree)(c,E,T,k=>console.error(`Conflict in default settings: ${k}`))}for(const E of Object.keys(c))O.OVERRIDE_PROPERTY_REGEX.test(E)&&f.push({identifiers:(0,O.overrideIdentifiersFromKey)(E),keys:Object.keys(c[E]),contents:(0,P.toValuesTree)(c[E],y=>console.error(`Conflict in default settings file: ${y}`))});super(c,s,f)}}t.DefaultConfigurationModel=d;class v{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!l.isUndefinedOrNull(e)){const s=this.doParseContent(e);this.parseRaw(s,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:s,keys:c,overrides:f,restricted:E}=this.doParseRaw(e,i);this._configurationModel=new I(s,c,f),this._restrictedConfigurations=E||[]}doParseContent(e){let i={},s=null,c=[],f=[],E=[];function y(k){Array.isArray(c)?c.push(k):s!==null&&(c[s]=k)}let T={onObjectBegin:()=>{let k={};y(k),f.push(c),c=k,s=null},onObjectProperty:k=>{s=k},onObjectEnd:()=>{c=f.pop()},onArrayBegin:()=>{let k=[];y(k),f.push(c),c=k,s=null},onArrayEnd:()=>{c=f.pop()},onLiteralValue:y,onError:(k,B,J)=>{E.push({error:k,offset:B,length:J})}};if(e)try{S.visit(e,T),i=c[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return i}doParseRaw(e,i){const s=g.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),c=this.filter(e,s,!0,i);e=c.raw;const f=(0,P.toValuesTree)(e,T=>console.error(`Conflict in settings file ${this._name}: ${T}`)),E=Object.keys(e),y=this.toOverrides(e,T=>console.error(`Conflict in settings file ${this._name}: ${T}`));return{contents:f,keys:E,overrides:y,restricted:c.restricted}}filter(e,i,s,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:e,restricted:[]};const f={},E=[];for(let y in e)if(O.OVERRIDE_PROPERTY_REGEX.test(y)&&s){const T=this.filter(e[y],i,!1,c);f[y]=T.raw,E.push(...T.restricted)}else{const T=i[y],k=T?typeof T.scope!="undefined"?T.scope:3:void 0;T?.restricted&&E.push(y),(k===void 0||c.scopes===void 0||c.scopes.includes(k))&&(c.skipRestricted&&T?.restricted||(f[y]=e[y]))}return{raw:f,restricted:E}}toOverrides(e,i){const s=[];for(const c of Object.keys(e))if(O.OVERRIDE_PROPERTY_REGEX.test(c)){const f={};for(const E in e[c])f[E]=e[c][E];s.push({identifiers:(0,O.overrideIdentifiersFromKey)(c),keys:Object.keys(f),contents:(0,P.toValuesTree)(f,i)})}return s}}t.ConfigurationModelParser=v;class h extends R.Disposable{constructor(e,i,s,c){super();this.userSettingsResource=e,this.scopes=i,this.fileService=c,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=h;class p{constructor(e,i,s=new I,c=new I,f=new C.ResourceMap,E=new I,y=new C.ResourceMap,T=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=f,this._memoryConfiguration=E,this._memoryConfigurationByResource=y,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(e,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(e)}updateValue(e,i,s={}){let c;s.resource?(c=this._memoryConfigurationByResource.get(s.resource),c||(c=new I,this._memoryConfigurationByResource.set(s.resource,c))):c=this._memoryConfiguration,i===void 0?c.removeValue(e):c.setValue(e,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,s){const c=this.getConsolidateConfigurationModel(i,s),f=this.getFolderConfigurationModelForResource(i.resource,s),E=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,y=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),T=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),B=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),J=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,se=f?i.overrideIdentifier?f.freeze().override(i.overrideIdentifier).getValue(e):f.freeze().getValue(e):void 0,ie=i.overrideIdentifier?E.override(i.overrideIdentifier).getValue(e):E.getValue(e),te=c.getValue(e),ge=L.distinct(L.flatten(c.overrides.map(W=>W.identifiers))).filter(W=>c.getOverrideValue(e,W)!==void 0);return{defaultValue:y,userValue:T,userLocalValue:k,userRemoteValue:B,workspaceValue:J,workspaceFolderValue:se,memoryValue:ie,value:te,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:k!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:B!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:J!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:se!==void 0?{value:f?.freeze().getValue(e),override:i.overrideIdentifier?f?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:ie!==void 0?{value:E.getValue(e),override:i.overrideIdentifier?E.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ge.length?ge:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const s=[];if(!i){const{added:c,updated:f,removed:E}=a(this._defaultConfiguration,e);i=[...c,...f,...E]}for(const c of i)for(const f of(0,O.overrideIdentifiersFromKey)(c)){const E=this._defaultConfiguration.getKeysForOverrideIdentifier(f),y=e.getKeysForOverrideIdentifier(f),T=[...y.filter(k=>E.indexOf(k)===-1),...E.filter(k=>y.indexOf(k)===-1),...E.filter(k=>!b.equals(this._defaultConfiguration.override(f).getValue(k),e.override(f).getValue(k)))];s.push([f,T])}return this.updateDefaultConfiguration(e),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:s,removed:c,overrides:f}=a(this.localUserConfiguration,e),E=[...i,...s,...c];return E.length&&this.updateLocalUserConfiguration(e),{keys:E,overrides:f}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:s,removed:c,overrides:f}=a(this.remoteUserConfiguration,e);let E=[...i,...s,...c];return E.length&&this.updateRemoteUserConfiguration(e),{keys:E,overrides:f}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:s,removed:c,overrides:f}=a(this.workspaceConfiguration,e);let E=[...i,...s,...c];return E.length&&this.updateWorkspaceConfiguration(e),{keys:E,overrides:f}}compareAndUpdateFolderConfiguration(e,i){const s=this.folderConfigurations.get(e),{added:c,updated:f,removed:E,overrides:y}=a(s,i);let T=[...c,...f,...E];return(T.length||!s)&&this.updateFolderConfiguration(e,i),{keys:T,overrides:y}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:s,updated:c,removed:f,overrides:E}=a(i,void 0);return{keys:[...s,...c,...f],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let s=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?s.override(e.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:e},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const c=i.getFolder(e);c&&(s=this.getFolderConsolidatedConfiguration(c.uri)||s);const f=this._memoryConfigurationByResource.get(e);f&&(s=s.merge(f))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(e);c?(i=s.merge(c),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=s}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const s=i.getFolder(e);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:s,overrides:c,keys:f}=this._folderConfigurations.get(i);return e.push([i,{contents:s,overrides:c,keys:f}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>e.add(s))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>e.add(s))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(e).forEach(c=>i.add(c))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),s=this.parseConfigurationModel(e.user),c=this.parseConfigurationModel(e.workspace),f=e.folders.reduce((E,y)=>(E.set(m.URI.revive(y[0]),this.parseConfigurationModel(y[1])),E),new C.ResourceMap);return new p(i,s,new I,c,f,new I,new C.ResourceMap,!1)}static parseConfigurationModel(e){return new I(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=p;function w(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const e=new Set,i=new Map;for(const c of o)c.keys.forEach(f=>e.add(f)),c.overrides.forEach(([f,E])=>{const y=(0,C.getOrSet)(i,f,new Set);E.forEach(T=>y.add(T))});const s=[];return i.forEach((c,f)=>s.push([f,[...c.values()]])),{keys:[...e.values()],overrides:s}}t.mergeChanges=w;class u{constructor(e,i,s,c){this.change=e,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=c,this._previousConfiguration=void 0;const f=new Set;e.keys.forEach(y=>f.add(y)),e.overrides.forEach(([,y])=>y.forEach(T=>f.add(T))),this.affectedKeys=[...f.values()];const E=new I;this.affectedKeys.forEach(y=>E.setValue(y,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!b.equals(s,c)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let s=(0,P.toValuesTree)({[i]:!0},()=>{}),c;for(;typeof s=="object"&&(c=Object.keys(s)[0]);){if(e=e[c],!e)return!1;s=s[c]}return!0}}t.ConfigurationChangeEvent=u;class r extends u{constructor(e,i,s,c){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=s,this.sourceConfig=c}}t.AllKeysConfigurationChangeEvent=r;function a(o,e){const{added:i,removed:s,updated:c}=n(e,o),f=[],E=o?.getAllOverrideIdentifiers()||[],y=e?.getAllOverrideIdentifiers()||[];if(e){const T=y.filter(k=>!E.includes(k));for(const k of T)f.push([k,e.getKeysForOverrideIdentifier(k)])}if(o){const T=E.filter(k=>!y.includes(k));for(const k of T)f.push([k,o.getKeysForOverrideIdentifier(k)])}if(e&&o){for(const T of E)if(y.includes(T)){const k=n({contents:o.getOverrideValue(void 0,T)||{},keys:o.getKeysForOverrideIdentifier(T)},{contents:e.getOverrideValue(void 0,T)||{},keys:e.getKeysForOverrideIdentifier(T)});f.push([T,[...k.added,...k.removed,...k.updated]])}}return{added:i,removed:s,updated:c,overrides:f}}function n(o,e){const i=o?e?o.keys.filter(f=>e.keys.indexOf(f)===-1):[...o.keys]:[],s=e?o?e.keys.filter(f=>o.keys.indexOf(f)===-1):[...e.keys]:[],c=[];if(o&&e){for(const f of e.keys)if(o.keys.indexOf(f)!==-1){const E=(0,P.getConfigurationValue)(e.contents,f),y=(0,P.getConfigurationValue)(o.contents,f);b.equals(E,y)||c.push(f)}}return{added:i,removed:s,updated:c}}}),define(Q[104],Z([0,1,3,8,2,18,25,103,34,29]),function(x,t,L,D,S,R,C,b,l,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class P extends S.Disposable{constructor(g,I){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,I)),this.configuration=new b.Configuration(new b.DefaultConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(({properties:d})=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new b.Configuration(new b.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,I){const d=typeof g=="string"?g:void 0,v=(0,C.isConfigurationOverrides)(g)?g:(0,C.isConfigurationOverrides)(I)?I:{};return this.configuration.getValue(d,v,void 0)}updateValue(g,I,d,v){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const I=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(d,I,1)}onDidDefaultConfigurationChange(g){const I=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new b.DefaultConfigurationModel,g);this.trigger(d,I,6)}trigger(g,I,d){const v=new b.ConfigurationChangeEvent(g,{data:I},this.configuration);v.source=d,v.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=P}),define(Q[105],Z([0,1,10]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVirtualWorkspace=t.getVirtualWorkspaceScheme=t.getVirtualWorkspaceLocation=t.isVirtualResource=t.getRemoteName=t.getRemoteAuthority=void 0;function D(m){return m.scheme===L.Schemas.vscodeRemote?m.authority:void 0}t.getRemoteAuthority=D;function S(m){if(!m)return;const P=m.indexOf("+");return P<0?m:m.substr(0,P)}t.getRemoteName=S;function R(m){return m.scheme!==L.Schemas.file&&m.scheme!==L.Schemas.vscodeRemote}t.isVirtualResource=R;function C(m){if(m.folders.length)return m.folders.every(P=>R(P.uri))?m.folders[0].uri:void 0;if(m.configuration&&R(m.configuration))return m.configuration}t.getVirtualWorkspaceLocation=C;function b(m){return C(m)?.scheme}t.getVirtualWorkspaceScheme=b;function l(m){return C(m)!==void 0}t.isVirtualWorkspace=l}),define(Q[40],Z([0,1,31,12,105]),function(x,t,L,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}t.getWorkspaceSupportTypeMessage=R;function C(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}t.isIExtensionIdentifier=C,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(b=t.ExtensionType||(t.ExtensionType={}));class l{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,d){if(typeof I=="undefined"||I===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof I=="string"||typeof d=="string"){let v=typeof I=="string"?I:I.value,h=typeof d=="string"?d:d.value;return L.equalsIgnoreCase(v,h)}return I._lower===d._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}t.ExtensionIdentifier=l;function m(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}t.isLanguagePackExtension=m;function P(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=P;function O(g,I){if(I){const d=`onResolveRemoteAuthority:${(0,S.getRemoteName)(I)}`;return g.activationEvents?.indexOf(d)!==-1}return!1}t.isResolverExtension=O,t.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[23],Z([0,1,31,40]),function(x,t,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function S(d,v){return d.uuid&&v.uuid?d.uuid===v.uuid:d.id===v.id?!0:(0,L.compareIgnoreCase)(d.id,v.id)===0}t.areSameExtensions=S;class R{constructor(v,h){this.version=h,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof R?S(this,v)&&this.version===v.version:!1}}t.ExtensionIdentifierWithVersion=R;function C(d,v){return`${d}.${v}`}t.getExtensionId=C;function b(d){return d.toLocaleLowerCase()}t.adoptToGalleryExtensionId=b;function l(d,v){return b(C(d,v))}t.getGalleryExtensionId=l;function m(d,v){const h=[],p=w=>{for(const u of h)if(u.some(r=>S(v(r),v(w))))return u;return null};for(const w of d){const u=p(w);u?u.push(w):h.push([w])}return h}t.groupByExtension=m;function P(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=P;function O(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}t.getGalleryExtensionTelemetryData=O,t.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function g(d){const v=new Set;if(d.malicious)for(const h of d.malicious)v.add(h.id);return v}t.getMaliciousExtensionsSet=g;function I(d,v){const h=[],p=v.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const w=p.shift();if(w&&h.every(u=>!S(u.identifier,{id:w}))){const u=d.filter(r=>S(r.identifier,{id:w}));u.length===1&&(h.push(u[0]),p.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}t.getExtensionDependencies=I}),define(Q[106],Z([0,1,24,6,60,10,41,9,75,22,23,40]),function(x,t,L,D,S,R,C,b,l,m,P,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const g=w=>(0,l.localize)(0,null,w),I=(0,l.localize)(1,null,"ms-dotnettools.csharp");function d(w,u){return u?`${w.publisher}.${w.name}@${w.version}`:`${w.publisher}.${w.name}`}const v=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function h(w){const u=v.exec(w);return u&&u[1]?[(0,P.adoptToGalleryExtensionId)(u[1]),u[2]]:[(0,P.adoptToGalleryExtensionId)(w),void 0]}t.getIdAndVersion=h;let p=class{constructor(u,r){this.extensionManagementService=u,this.extensionGalleryService=r}get location(){}async listExtensions(u,r,a=console){let n=await this.extensionManagementService.getInstalled(1);const o=O.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(r&&r!==""){if(o.indexOf(r.toLowerCase())<0){a.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}n=n.filter(i=>i.manifest.categories?i.manifest.categories.map(c=>c.toLowerCase()).indexOf(r.toLowerCase())>-1:!1)}else if(r===""){a.log("Possible Categories: "),o.forEach(i=>{a.log(i)});return}this.location&&a.log((0,l.localize)(2,null,this.location)),n=n.sort((i,s)=>i.identifier.id.localeCompare(s.identifier.id));let e;for(let i of n)e!==i.identifier.id&&(e=i.identifier.id,a.log(d(i.manifest,u)))}async installExtensions(u,r,a,n,o=console){const e=[],i=[];u.length&&o.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const s=await this.extensionManagementService.getInstalled(1),c=(y,T)=>{const k=s.find(B=>(0,P.areSameExtensions)(B.identifier,{id:y}));if(k){if(!T&&!n)return o.log((0,l.localize)(5,null,y,k.manifest.version,y)),!1;if(T&&k.manifest.version===T)return o.log((0,l.localize)(6,null,`${y}@${T}`)),!1}return!0},f=[],E=[];for(const y of u)if(y instanceof b.URI)f.push(y);else{const[T,k]=h(y);c(T,k)&&E.push({id:T,version:k,installOptions:{...a,isBuiltin:!1}})}for(const y of r){const[T,k]=h(y);c(T,k)&&E.push({id:T,version:k,installOptions:{...a,isBuiltin:!0}})}if(f.length&&await Promise.all(f.map(async y=>{try{const T=await this.installVSIX(y,{...a,isBuiltin:!1},n,o);T&&i.push(T)}catch(T){o.error(T.message||T.stack||T),e.push(y.toString())}})),E.length){const y=await this.getGalleryExtensions(E);await Promise.all(E.map(async T=>{const k=y.get(T.id.toLowerCase());if(k)try{const B=await this.installFromGallery(T,k,s,n,o);B&&i.push(B)}catch(B){o.error(B.message||B.stack||B),e.push(T.id)}else o.error(`${g(T.version?`${T.id}@${T.version}`:T.id)}
${I}`),e.push(T.id)}))}if(e.length)throw new Error((0,l.localize)(7,null,e.join(", ")))}async installVSIX(u,r,a,n){const o=await this.extensionManagementService.getManifest(u);if(!o)throw new Error("Invalid vsix");if(await this.validateVSIX(o,a,n))try{return await this.extensionManagementService.install(u,r),n.log((0,l.localize)(8,null,(0,S.getBaseLabel)(u))),o}catch(i){if((0,D.isPromiseCanceledError)(i))return n.log((0,l.localize)(9,null,(0,S.getBaseLabel)(u))),null;throw i}return null}async getGalleryExtensions(u){const r=new Map,a=await this.extensionGalleryService.getExtensions(u,u.some(n=>n.installOptions.installPreReleaseVersion),L.CancellationToken.None);for(const n of a)r.set(n.identifier.id.toLowerCase(),n);return r}async installFromGallery({id:u,version:r,installOptions:a},n,o,e,i){const s=await this.extensionGalleryService.getManifest(n,L.CancellationToken.None);if(s&&!this.validateExtensionKind(s,i))return null;const c=o.find(f=>(0,P.areSameExtensions)(f.identifier,n.identifier));if(c){if(n.version===c.manifest.version)return i.log((0,l.localize)(10,null,r?`${u}@${r}`:u)),null;i.log((0,l.localize)(11,null,u,n.version))}try{return a.isBuiltin?i.log(r?(0,l.localize)(12,null,u,r):(0,l.localize)(13,null,u)):i.log(r?(0,l.localize)(14,null,u,r):(0,l.localize)(15,null,u)),await this.extensionManagementService.installFromGallery(n,{...a,installGivenVersion:!!r}),i.log((0,l.localize)(16,null,u,n.version)),s}catch(f){if((0,D.isPromiseCanceledError)(f))return i.log((0,l.localize)(17,null,u)),null;throw f}}validateExtensionKind(u,r){return!0}async validateVSIX(u,r,a){const n={id:(0,P.getGalleryExtensionId)(u.publisher,u.name)},e=(await this.extensionManagementService.getInstalled(1)).find(i=>(0,P.areSameExtensions)(n,i.identifier)&&(0,C.gt)(i.manifest.version,u.version));return e&&!r?(a.log((0,l.localize)(18,null,e.identifier.id,e.manifest.version,u.version)),!1):this.validateExtensionKind(u,a)}async uninstallExtensions(u,r,a=console){const n=async e=>{if(e instanceof b.URI){const i=await this.extensionManagementService.getManifest(e);return d(i)}return e},o=[];for(const e of u){const i=await n(e),c=(await this.extensionManagementService.getInstalled()).filter(f=>(0,P.areSameExtensions)(f.identifier,{id:i}));if(!c.length)throw new Error(`${this.notInstalled(i)}
${I}`);if(c.some(f=>f.type===0)){a.log((0,l.localize)(19,null,i));return}if(!r&&c.some(f=>f.isBuiltin)){a.log((0,l.localize)(20,null,i));return}a.log((0,l.localize)(21,null,i));for(const f of c)await this.extensionManagementService.uninstall(f),o.push(f);this.location?a.log((0,l.localize)(22,null,i,this.location)):a.log((0,l.localize)(23,null,i))}}async locateExtension(u,r=console){const a=await this.extensionManagementService.getInstalled();u.forEach(n=>{a.forEach(o=>{if(o.identifier.id===n&&o.location.scheme===R.Schemas.file){r.log(o.location.fsPath);return}})})}notInstalled(u){return this.location?(0,l.localize)(24,null,u,this.location):(0,l.localize)(25,null,u)}};p=ve([ce(0,m.IExtensionManagementService),ce(1,m.IExtensionGalleryService)],p),t.ExtensionManagementCLIService=p}),define(Q[107],Z([0,1,3,6,2,14,18,41,9,26,15,20,22,23,16,13]),function(x,t,L,D,S,R,C,b,l,m,P,O,g,I,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const h=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends S.Disposable{constructor(u,r,a,n){super();this.fileService=r,this.extensionGalleryService=a,this.logService=n,this.extensionsDownloadDir=l.URI.file(u.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(u,r){await this.cleanUpPromise;const a=this.getName(u),n=(0,C.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(n)){const o=(0,C.joinPath)(this.extensionsDownloadDir,`.${(0,m.generateUuid)()}`);await this.fileService.exists(o)||await this.extensionGalleryService.download(u,o,r);try{await this.rename(o,n,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(o)}catch{}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",u.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,o.path),e}}return n}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,r,a){try{await P.Promises.rename(u.fsPath,r.fsPath)}catch(n){if(R.isWindows&&n&&n.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${u} to ${r} with 'EPERM' error. Trying again...`),this.rename(u,r,a);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const r=[],a=[];for(const e of u.children){const i=this.parse(e.name);i&&a.push([i,e])}const n=(0,I.groupByExtension)(a,([e])=>e),o=[];for(const e of n)e.sort((i,s)=>b.rcompare(i[0].version,s[0].version)),r.push(...e.slice(1).map(i=>i[1].resource)),o.push(e[0][1]);o.sort((e,i)=>e.mtime-i.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(e=>e.resource)),await L.Promises.settled(r.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?`${new I.ExtensionIdentifierWithVersion(u.identifier,u.version).key().toLowerCase()}${u.properties.targetPlatform!=="undefined"?`-${u.properties.targetPlatform}`:""}`:(0,m.generateUuid)()}parse(u){const r=h.exec(u);return r&&r[1]&&r[2]?new I.ExtensionIdentifierWithVersion({id:r[1]},r[2]):null}};p=ve([ce(0,O.INativeEnvironmentService),ce(1,d.IFileService),ce(2,g.IExtensionGalleryService),ce(3,v.ILogService)],p),t.ExtensionsDownloader=p}),define(Q[108],Z([0,1,2,11,15,40]),function(x,t,L,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class C extends L.Disposable{constructor(l,m){super();this.environmentService=l,this.extensionsManifestCache=(0,D.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(m.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(m.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(l){l.some(m=>!!m.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){S.Promises.rm(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=C}),define(Q[109],Z([0,1,134,19,3,2,10,11,15,20,22,23,52,13]),function(x,t,L,D,S,R,C,b,l,m,P,O,g,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let d=class extends R.Disposable{constructor(p,w,u){super();this.extensionManagementService=p,this.logService=u,this.cache=this._register(new v(w,u)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getLanguageIds(){const p=await this.cache.getLanguagePacks(),w=["en",...Object.keys(p)];return(0,D.distinct)(w)}async postInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",p.identifier.id),await this.update())}async postUninstallExtension(p){const w=await this.cache.getLanguagePacks();Object.keys(w).some(u=>w[u]&&w[u].extensions.some(r=>(0,O.areSameExtensions)(r.extensionIdentifier,p.identifier)))&&(this.logService.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),u=await this.cache.update(w);return!(0,D.equals)(Object.keys(p),Object.keys(u))}};d=ve([ce(0,P.IExtensionManagementService),ce(1,m.INativeEnvironmentService),ce(2,I.ILogService)],d),t.LocalizationsService=d;let v=class extends R.Disposable{constructor(p,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,b.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new S.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(w=>{Object.keys(w).forEach(u=>delete w[u]),this.createLanguagePacksFromExtensions(w,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...w){for(const u of w)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,u);Object.keys(p).forEach(u=>this.updateHash(p[u]))}createLanguagePacksFromExtension(p,w){const u=w.identifier,r=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const a of r)if(w.location.scheme===C.Schemas.file&&(0,g.isValidLocalization)(a)){let n=p[a.languageId];n||(n={hash:"",extensions:[],translations:{}},p[a.languageId]=n);let o=n.extensions.filter(e=>(0,O.areSameExtensions)(e.extensionIdentifier,u))[0];o?o.version=w.manifest.version:n.extensions.push({extensionIdentifier:u,version:w.manifest.version});for(const e of a.translations)n.translations[e.id]=(0,b.join)(w.location.fsPath,e.path)}}updateHash(p){if(p){const w=(0,L.createHash)("md5");for(const u of p.extensions)w.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);p.hash=w.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>(w=p(u),u)).then(u=>{for(const a of Object.keys(u))u[a]||delete u[a];this.languagePacks=u,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),l.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>w,u=>this.logService.error(u))})}};v=ve([ce(0,m.INativeEnvironmentService),ce(1,I.ILogService)],v)}),define(Q[42],Z([0,1,17,83,34,12,29]),function(x,t,L,D,S,R,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,R.createDecorator)("requestService");function b(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}t.isSuccess=b;function l(d){return d.res.statusCode===204}async function m(d){if(!b(d))throw new Error("Server returned "+d.res.statusCode);return l(d)?null:(await(0,L.streamToBuffer)(d.stream)).toString()}t.asText=m;async function P(d){if(!b(d))throw new Error("Server returned "+d.res.statusCode);if(l(d))return null;const h=(await(0,L.streamToBuffer)(d.stream)).toString();try{return JSON.parse(h)}catch(p){throw p.message+=`:
`+h,p}}t.asJson=P;function O(d){I(d)}t.updateProxyConfigurationsScope=O;let g;function I(d){const v=C.Registry.as(S.Extensions.Configuration),h=g;g={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},v.updateConfigurations({add:[g],remove:h?[h]:[]})}I(2)}),define(Q[110],Z([0,1,24,10,16,42]),function(x,t,L,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let C=class{constructor(l,m){this.requestService=l,this.fileService=m}async download(l,m,P=L.CancellationToken.None){if(l.scheme===D.Schemas.file||l.scheme===D.Schemas.vscodeRemote){await this.fileService.copy(l,m);return}const O={type:"GET",url:l.toString()},g=await this.requestService.request(O,P);if(g.res.statusCode===200)await this.fileService.writeFile(m,g.stream);else{const I=await(0,R.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${I}`)}}};C=ve([ce(0,R.IRequestService),ce(1,S.IFileService)],C),t.DownloadService=C}),define(Q[111],Z([0,1,112,7]),function(x,t,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function S(C,b){return C.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:C.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function R(C,b,l={}){const m=(0,L.parse)(C),P=l.proxyUrl||S(m,b);if(!P)return null;const O=(0,L.parse)(P);if(!/^https?:$/.test(O.protocol||""))return null;const g={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,D.isBoolean)(l.strictSSL)?l.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((I,d)=>{x(["http-proxy-agent"],I,d)}))(g):new(await new Promise((I,d)=>{x(["https-proxy-agent"],I,d)}))(g)}t.getProxyAgent=R}),define(Q[113],Z([0,1,17,26]),function(x,t,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function S(R,C,b){let l=b&&b.get("storage.serviceMachineId",0)||null;if(l)return l;try{const P=(await C.readFile(R.serviceMachineIdResource)).value.toString();l=(0,D.isUUID)(P)?P:null}catch{l=null}if(!l){l=(0,D.generateUuid)();try{await C.writeFile(R.serviceMachineIdResource,L.VSBuffer.fromString(l))}catch{}}return b&&b.store("storage.serviceMachineId",l,0,1),l}t.getServiceMachineId=S}),define(Q[114],Z([0,1,3,8,2,98,7,63,12]),function(x,t,L,D,S,R,C,b,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";t.IStorageService=(0,l.createDecorator)("storageService");var P;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(P=t.WillSaveStateReason||(t.WillSaveStateReason={}));var O;(function(h){h[h.GLOBAL=0]="GLOBAL",h[h.WORKSPACE=1]="WORKSPACE"})(O=t.StorageScope||(t.StorageScope={}));var g;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(g=t.StorageTarget||(t.StorageTarget={}));class I extends S.Disposable{constructor(p={flushInterval:I.DEFAULT_FLUSH_INTERVAL}){super();this.options=p,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new S.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,S.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(p,w){w===m?(p===0?this._globalKeyTargets=void 0:p===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:p})):this._onDidChangeValue.fire({scope:p,key:w,target:this.getKeyTargets(p)[w]})}emitWillSaveState(p){this._onWillSaveState.fire({reason:p})}get(p,w,u){return this.getStorage(w)?.get(p,u)}getBoolean(p,w,u){return this.getStorage(w)?.getBoolean(p,u)}getNumber(p,w,u){return this.getStorage(w)?.getNumber(p,u)}store(p,w,u,r){if((0,C.isUndefinedOrNull)(w)){this.remove(p,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(p,u,r),this.getStorage(u)?.set(p,w)})}remove(p,w){this.withPausedEmitters(()=>{this.updateKeyTarget(p,w,void 0),this.getStorage(w)?.delete(p)})}withPausedEmitters(p){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{p()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(p,w){const u=[],r=this.getKeyTargets(p);for(const a of Object.keys(r))r[a]===w&&u.push(a);return u}updateKeyTarget(p,w,u){const r=this.getKeyTargets(w);typeof u=="number"?r[p]!==u&&(r[p]=u,this.getStorage(w)?.set(m,JSON.stringify(r))):typeof r[p]=="number"&&(delete r[p],this.getStorage(w)?.set(m,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(p){return p===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(p){const w=this.get(m,p);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(p){return this.getBoolean(t.IS_NEW_KEY,p)===!0}async flush(p=P.NONE){this._onWillSaveState.fire({reason:p});const w=this.getStorage(0),u=this.getStorage(1);switch(p){case P.NONE:await L.Promises.settled([w?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([w?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async logStorage(){const p=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return v(p,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=I,I.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends I{constructor(){super();this.globalStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(p=>this.emitDidChangeValue(1,p))),this._register(this.globalStorage.onDidChangeStorage(p=>this.emitDidChangeValue(0,p)))}getStorage(p){return p===0?this.globalStorage:this.workspaceStorage}getLogDetails(p){return p===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(p){}}t.InMemoryStorageService=d;async function v(h,p,w,u){const r=c=>{try{return JSON.parse(c)}catch{return c}},a=new Map,n=new Map;h.forEach((c,f)=>{a.set(f,c),n.set(f,r(c))});const o=new Map,e=new Map;p.forEach((c,f)=>{o.set(f,c),e.set(f,r(c))}),console.group(`Storage: Global (path: ${w})`);let i=[];a.forEach((c,f)=>{i.push({key:f,value:c})}),console.table(i),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${u})`);let s=[];o.forEach((c,f)=>{s.push({key:f,value:c})}),console.table(s),console.groupEnd(),console.log(e)}t.logStorage=v}),define(Q[115],Z([0,1,14,28,9,26]),function(x,t,L,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function C(m){if(L.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function b(m,P,O,g,I,d,v,h,p,w){const u=Object.create(null);u["common.machineId"]=v,u.sessionID=(0,R.generateUuid)()+Date.now(),u.commitHash=I,u.version=d,u["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,L.PlatformToString)(L.platform),u["common.nodePlatform"]=D.platform,u["common.nodeArch"]=g,u["common.product"]=w||"desktop";const r=l(h||[]);r&&(u["common.msftInternal"]=r);let a=0;const n=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),L.isLinuxSnap&&(u["common.snap"]="true");const o=C(O);o&&(u["common.platformDetail"]=o);try{const e=await m.readFile(S.URI.file(p));u["common.source"]=e.value.toString().slice(0,30)}catch{}return u}t.resolveCommonProperties=b;function l(m){const P=D.env.USERDNSDOMAIN;if(!P)return!1;const O=P.toLowerCase();return m.some(g=>O===g)}t.verifyMicrosoftInternalDomain=l}),define(Q[30],Z([0,1,12]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,L.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(D=t.TelemetryLevel||(t.TelemetryLevel={}));var S;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(S=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Q[116],Z([0,1,19,3,24,6,8,2,14,7,9,73,22,23,13,32,30]),function(x,t,L,D,S,R,C,b,l,m,P,O,g,I,d,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let p=class extends b.Disposable{constructor(o,e,i,s){super();this.galleryService=o,this.telemetryService=e,this.logService=i,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new C.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new C.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new C.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new C.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,b.toDisposable)(()=>{this.installingExtensions.forEach(c=>c.cancel()),this.uninstallingExtensions.forEach(c=>c.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(o){const e=await this.getTargetPlatform();return o.allTargetPlatforms.some(i=>(0,g.isTargetPlatformCompatible)(i,o.allTargetPlatforms,e))}async installFromGallery(o,e={}){try{if(!this.galleryService.isEnabled())throw new g.ExtensionManagementError(O.localize(0,null),g.ExtensionManagementErrorCode.Internal);const i=await this.checkAndGetCompatibleVersion(o,!e.installGivenVersion,!!e.installPreReleaseVersion);return await this.installExtension(i.manifest,i.extension,e)}catch(i){throw r(this.telemetryService,"extensionGallery:install",(0,I.getGalleryExtensionTelemetryData)(o),void 0,i),this.logService.error("Failed to install extension.",o.identifier.id),this.logService.error(i),u(i)}}async migrateUnsupportedExtensions(){try{const o=await this.getExtensionsControlManifest();if(!o.unsupportedPreReleaseExtensions)return;const e=await this.getInstalled(1);for(const[i,s]of Object.entries(o.unsupportedPreReleaseExtensions)){const c=e.find(y=>(0,I.areSameExtensions)(y.identifier,{id:i}));if(!c)continue;const f=await this.galleryService.getCompatibleExtension({id:s.id},!0,await this.getTargetPlatform());if(!f){this.logService.info(`Skipping migrating '${c.identifier.id}' extension because, the comaptible target '${s.id}' extension is not found`);continue}const E=await this.galleryService.getManifest(f,S.CancellationToken.None);if(!E){this.logService.info(`Skipping migrating '${c.identifier.id}' extension because, the manifest for '${s.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${c.identifier.id}' extension to '${s.id}' extension...`),await Promise.allSettled([this.uninstall(c),this.installExtension(E,f,{installPreReleaseVersion:!0,isMachineScoped:c.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${c.identifier.id}' extension to '${s.id}' extension.`)}catch(y){this.logService.error(y)}}}catch(o){this.logService.error(o)}}async uninstall(o,e={}){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.unininstallExtension(o,e)}async reinstallFromGallery(o){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",o.identifier.id),!this.galleryService.isEnabled())throw new Error(O.localize(1,null));const e=await this.findGalleryExtension(o);if(!e)throw new Error(O.localize(2,null));await this.createUninstallExtensionTask(o,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.extensionsControlManifest||o-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=o),this.extensionsControlManifest}registerParticipant(o){this.participants.push(o)}async installExtension(o,e,i){if(!P.URI.isUri(e)){let y=this.installingExtensions.get(new I.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(y)return this.logService.info("Extensions is already requested to install",e.identifier.id),y.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],c=[],f=this.createInstallExtensionTask(o,e,i);P.URI.isUri(e)||this.installingExtensions.set(new I.ExtensionIdentifierWithVersion(f.identifier,o.version).key(),f),this._onInstallExtension.fire({identifier:f.identifier,source:e}),this.logService.info("Installing extension:",f.identifier.id),s.push({task:f,manifest:o});let E=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",f.identifier.id);else try{const T=await this.getAllDepsAndPackExtensionsToInstall(f.identifier,o,!!i.installOnlyNewlyAddedFromExtensionPack,!!i.installPreReleaseVersion);for(const{gallery:k,manifest:B}of T)if(E=E||!!B.extensionDependencies?.some(J=>(0,I.areSameExtensions)({id:J},f.identifier)),this.installingExtensions.has(new I.ExtensionIdentifierWithVersion(k.identifier,k.version).key()))this.logService.info("Extension is already requested to install",k.identifier.id);else{const J=this.createInstallExtensionTask(B,k,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new I.ExtensionIdentifierWithVersion(J.identifier,B.version).key(),J),this._onInstallExtension.fire({identifier:J.identifier,source:k}),this.logService.info("Installing extension:",J.identifier.id),s.push({task:J,manifest:B})}}catch(T){if(P.URI.isUri(f.source))(0,L.isNonEmptyArray)(o.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",f.identifier.id,T.message),(0,L.isNonEmptyArray)(o.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",f.identifier.id,T.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",f.identifier.id),T}const y=s.reduce((T,{task:k,manifest:B})=>(T.set(k.identifier.id.toLowerCase(),{task:k,manifest:B}),T),new Map);for(;y.size;){let T;const k=[...y.values()].filter(({manifest:B})=>!B.extensionDependencies?.some(J=>y.has(J.toLowerCase())));k.length?T=y.size===1?k:k.filter(({task:B})=>!(B===f&&!E)):(this.logService.info("Found extensions with circular dependencies",k.map(({task:B})=>B.identifier.id)),T=[...y.values()]),await this.joinAllSettled(T.map(async({task:B})=>{const J=new Date().getTime(),se=(0,m.isUndefined)(i.operation)?B.operation:i.operation;try{const ie=await B.run();if(await this.joinAllSettled(this.participants.map(te=>te.postInstall(ie,B.source,i,S.CancellationToken.None))),!P.URI.isUri(B.source)&&(r(this.telemetryService,se===3?"extensionGallery:update":"extensionGallery:install",(0,I.getGalleryExtensionTelemetryData)(B.source),new Date().getTime()-J,void 0),l.isWeb&&se!==3))try{await this.galleryService.reportStatistic(ie.manifest.publisher,ie.manifest.name,ie.manifest.version,"install")}catch{}c.push({local:ie,identifier:B.identifier,operation:se,source:B.source})}catch(ie){throw P.URI.isUri(B.source)||r(this.telemetryService,se===3?"extensionGallery:update":"extensionGallery:install",(0,I.getGalleryExtensionTelemetryData)(B.source),new Date().getTime()-J,ie),this.logService.error("Error while installing the extension:",B.identifier.id),ie}finally{y.delete(B.identifier.id.toLowerCase())}}))}return c.forEach(({identifier:T})=>this.logService.info("Extension installed successfully:",T.id)),this._onDidInstallExtensions.fire(c),c.filter(({identifier:T})=>(0,I.areSameExtensions)(T,f.identifier))[0].local}catch(y){if(s.forEach(({task:T})=>T.cancel()),c.length)try{const T=await Promise.allSettled(c.map(({local:k})=>this.createUninstallExtensionTask(k,{versionOnly:!0}).run()));for(let k=0;k<T.length;k++){const B=T[k],{identifier:J}=c[k];B.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",J.id):this.logService.warn("Rollback: Error while uninstalling extension",J.id,(0,R.getErrorMessage)(B.reason))}}catch(T){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(T),c.map(({identifier:k})=>k.id))}throw this._onDidInstallExtensions.fire(s.map(({task:T})=>({identifier:T.identifier,operation:2,source:T.source}))),y}finally{for(const{task:y,manifest:T}of s)if(!P.URI.isUri(y.source)){const k=new I.ExtensionIdentifierWithVersion(y.identifier,T.version).key();this.installingExtensions.delete(k)||this.logService.warn("Installation task is not found in the cache",k)}}}async joinAllSettled(o){const e=[],i=[],s=await Promise.allSettled(o);for(const c of s)c.status==="fulfilled"?e.push(c.value):i.push(c.reason);if(i.length)throw w(i);return e}async getAllDepsAndPackExtensionsToInstall(o,e,i,s){if(!this.galleryService.isEnabled())return[];let c=await this.getInstalled();const f=[o,...c.map(T=>T.identifier)],E=[],y=async(T,k)=>{const B=k.extensionDependencies||[],J=[...B];if(k.extensionPack){const se=i?c.find(ie=>(0,I.areSameExtensions)(ie.identifier,T)):void 0;for(const ie of k.extensionPack)se&&se.manifest.extensionPack&&se.manifest.extensionPack.some(te=>(0,I.areSameExtensions)({id:te},{id:ie}))||J.every(te=>!(0,I.areSameExtensions)({id:te},{id:ie}))&&J.push(ie)}if(J.length){const se=[...f,...E.map(te=>te.gallery.identifier)],ie=J.filter(te=>se.every(ge=>!(0,I.areSameExtensions)(ge,{id:te})));if(ie.length){const te=await this.galleryService.query({names:ie,pageSize:J.length},S.CancellationToken.None);for(const ge of te.firstPage){if(se.find(re=>(0,I.areSameExtensions)(re,ge.identifier)))continue;const W=B.some(re=>(0,I.areSameExtensions)({id:re},ge.identifier));let $;try{$=await this.checkAndGetCompatibleVersion(ge,!0,s)}catch(re){if(re instanceof g.ExtensionManagementError&&re.code===g.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.logService.info("Skipping the packed extension as it cannot be installed",ge.identifier.id);continue}else throw re}E.push({gallery:$.extension,manifest:$.manifest}),await y($.extension.identifier,k)}}}};return await y(o,e),c=await this.getInstalled(),E.filter(T=>!c.some(k=>(0,I.areSameExtensions)(k.identifier,T.gallery.identifier)))}async checkAndGetCompatibleVersion(o,e,i){const s=await this.getExtensionsControlManifest();if((0,I.getMaliciousExtensionsSet)(s).has(o.identifier.id))throw new g.ExtensionManagementError(O.localize(3,null,o.identifier.id),g.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[o.identifier.id])throw new g.ExtensionManagementError(O.localize(4,null,o.identifier.id,s.unsupportedPreReleaseExtensions[o.identifier.id].displayName),g.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(o)){const E=await this.getTargetPlatform();throw new g.ExtensionManagementError(O.localize(5,null,o.identifier.id,this.productService.nameLong,(0,g.TargetPlatformToString)(E)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const c=await this.getCompatibleVersion(o,e,i);if(c){if(i&&o.hasPreReleaseVersion&&!c.properties.isPreReleaseVersion)throw new g.ExtensionManagementError(O.localize(6,null,o.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new g.ExtensionManagementError(O.localize(7,null,o.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",c.identifier.id);const f=await this.galleryService.getManifest(c,S.CancellationToken.None);if(f===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${o.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(f.version!==c.version)throw new g.ExtensionManagementError(`Cannot install '${o.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:c,manifest:f}}async getCompatibleVersion(o,e,i){const s=await this.getTargetPlatform();let c=null;return e&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==i&&(c=await this.galleryService.getCompatibleExtension(o.identifier,i,s)),!c&&await this.galleryService.isExtensionCompatible(o,i,s)&&(c=o),!c&&e&&(c=await this.galleryService.getCompatibleExtension(o,i,s)),c}async unininstallExtension(o,e){const i=this.uninstallingExtensions.get(o.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",o.identifier.id),i.waitUntilTaskIsFinished();const s=(y,T)=>{const k=this.createUninstallExtensionTask(y,T);return this.uninstallingExtensions.set(k.extension.identifier.id.toLowerCase(),k),this.logService.info("Uninstalling extension:",y.identifier.id),this._onUninstallExtension.fire(y.identifier),k},c=(y,T)=>{T?this.logService.error("Failed to uninstall extension:",y.identifier.id,T.message):this.logService.info("Successfully uninstalled extension:",y.identifier.id),r(this.telemetryService,"extensionGallery:uninstall",(0,I.getLocalExtensionTelemetryData)(y),void 0,T),this._onDidUninstallExtension.fire({identifier:y.identifier,error:T?.code})},f=[],E=[];try{f.push(s(o,{}));const y=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",o.identifier.id);else{const T=this.getAllPackExtensionsToUninstall(o,y);for(const k of T)this.uninstallingExtensions.has(k.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",k.identifier.id):f.push(s(k,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",o.identifier.id):this.checkForDependents(f.map(T=>T.extension),y,o),await this.joinAllSettled(f.map(async T=>{try{if(await T.run(),await this.joinAllSettled(this.participants.map(k=>k.postUninstall(T.extension,e,S.CancellationToken.None))),T.extension.identifier.uuid)try{await this.galleryService.reportStatistic(T.extension.manifest.publisher,T.extension.manifest.name,T.extension.manifest.version,"uninstall")}catch{}c(T.extension)}catch(k){const B=k instanceof g.ExtensionManagementError?k:new g.ExtensionManagementError((0,R.getErrorMessage)(k),g.ExtensionManagementErrorCode.Internal);throw c(T.extension,B),B}finally{E.push(T)}}))}catch(y){const T=y instanceof g.ExtensionManagementError?y:new g.ExtensionManagementError((0,R.getErrorMessage)(y),g.ExtensionManagementErrorCode.Internal);for(const k of f){try{k.cancel()}catch{}E.includes(k)||c(k.extension,T)}throw T}finally{for(const y of f)this.uninstallingExtensions.delete(y.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",y.extension.identifier.id)}}checkForDependents(o,e,i){for(const s of o){const c=this.getDependents(s,e);if(c.length){const f=c.filter(E=>!o.some(y=>(0,I.areSameExtensions)(y.identifier,E.identifier)));if(f.length)throw new Error(this.getDependentsErrorMessage(s,f,i))}}}getDependentsErrorMessage(o,e,i){return i===o?e.length===1?O.localize(8,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?O.localize(9,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):O.localize(10,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?O.localize(11,null,i.manifest.displayName||i.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?O.localize(12,null,i.manifest.displayName||i.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):O.localize(13,null,i.manifest.displayName||i.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(o,e,i=[]){if(i.indexOf(o)!==-1)return[];i.push(o);const s=o.manifest.extensionPack?o.manifest.extensionPack:[];if(s.length){const c=e.filter(E=>!E.isBuiltin&&s.some(y=>(0,I.areSameExtensions)({id:y},E.identifier))),f=[];for(const E of c)f.push(...this.getAllPackExtensionsToUninstall(E,e,i));return[...c,...f]}return[]}getDependents(o,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(s=>(0,I.areSameExtensions)({id:s},o.identifier)))}async findGalleryExtension(o){if(o.identifier.uuid){const e=await this.findGalleryExtensionById(o.identifier.uuid);return e||this.findGalleryExtensionByName(o.identifier.id)}return this.findGalleryExtensionByName(o.identifier.id)}async findGalleryExtensionById(o){return(await this.galleryService.query({ids:[o],pageSize:1},S.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(o){return(await this.galleryService.query({names:[o],pageSize:1},S.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const o=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",o),o}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};p=ve([ce(0,g.IExtensionGalleryService),ce(1,h.ITelemetryService),ce(2,d.ILogService),ce(3,v.IProductService)],p),t.AbstractExtensionManagementService=p;function w(n){const o=Array.isArray(n)?n:[n];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=w;function u(n){if(n instanceof g.ExtensionManagementError)return n;const o=new g.ExtensionManagementError(n.message,g.ExtensionManagementErrorCode.Internal);return o.stack=n.stack,o}function r(n,o,e,i,s){const c=s?s instanceof g.ExtensionManagementError?s.code:g.ExtensionManagementErrorCode.Internal:void 0;n.publicLogError(o,{...e,success:!s,duration:i,errorcode:c})}t.reportTelemetry=r;class a{constructor(){this.barrier=new D.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(o=>new Promise((e,i)=>{const s=o.onCancellationRequested(()=>{s.dispose(),i((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=a}),define(Q[35],Z([0,1,21,7,25,30]),function(x,t,L,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(p,w){return Promise.resolve(void 0)}publicLog2(p,w){return this.publicLog(p,w)}publicLogError(p,w){return Promise.resolve(void 0)}publicLogError2(p,w){return this.publicLogError(p,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=C,t.NullTelemetryService=new C;class b{async publicLog(p,w,u){}async publicLogError(p,w,u){}}t.NullEndpointTelemetryService=b,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(h,p){return p.onDidChangeConfiguration(w=>{w.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,S.ConfigurationTargetToString)(w.source),configurationKeys:d(w.sourceConfig)})})}t.configurationTelemetry=l;function m(h,p){return!(p.disableTelemetry||!h.enableTelemetry)}t.supportsTelemetry=m;function P(h){const p=h.getValue(R.TELEMETRY_SETTING_ID),w=h.getValue("telemetry.enableCrashReporter");if(h.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=P;function O(h){const p=Object.create(null),w=Object.create(null),u=Object.create(null);I(h,u);for(let r in u){r=r.length>150?r.substr(r.length-149):r;const a=u[r];typeof a=="number"?w[r]=a:typeof a=="boolean"?w[r]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${a.length}`),p[r]=a.substring(0,8191)):typeof a!="undefined"&&a!==null&&(p[r]=a)}return{properties:p,measurements:w}}t.validateTelemetryData=O;function g(h){if(!h)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{h.indexOf(`${u}+`)===0&&(p=u)}),p}t.cleanRemoteAuthority=g;function I(h,p,w=0,u){if(!!h)for(let r of Object.getOwnPropertyNames(h)){const a=h[r],n=u?u+r:r;Array.isArray(a)?p[n]=(0,L.safeStringify)(a):a instanceof Date?p[n]=a.toISOString():(0,D.isObject)(a)?w<2?I(a,p,w+1,n+"."):p[n]=(0,L.safeStringify)(a):p[n]=a}}function d(h){if(!h)return[];const p=[];return v(p,"",h),p}function v(h,p,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(u=>v(h,p?`${p}.${u}`:u,w[u])):h.push(p)}}),define(Q[117],Z([0,1,19,24,6,21,14,28,7,9,25,20,22,23,48,16,13,32,42,113,114,30,35]),function(x,t,L,D,S,R,C,b,l,m,P,O,g,I,d,v,h,p,w,u,r,a,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const o=C.isWeb?"web":(0,g.getTargetPlatform)(C.platform,b.arch);var e;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(e||(e={}));function i(...U){return String(U.reduce((N,q)=>N|q,0))}var s;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class T{constructor(N=y){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,q=this.state.pageSize){return new T({...this.state,pageNumber:N,pageSize:q})}withFilter(N,...q){const z=[...this.state.criteria,...q.length?q.map(X=>({filterType:N,value:X})):[{filterType:N}]];return new T({...this.state,criteria:z})}withSortBy(N){return new T({...this.state,sortBy:N})}withSortOrder(N){return new T({...this.state,sortOrder:N})}withFlags(...N){return new T({...this.state,flags:N.reduce((q,z)=>q|z,0)})}withAssetTypes(...N){return new T({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:q,pageSize:z,sortBy:X,sortOrder:Y,flags:he,assetTypes:ae}=this.state;return{filters:[{criteria:N,pageNumber:q,pageSize:z,sortBy:X,sortOrder:Y}],assetTypes:ae,flags:he}}get searchText(){const N=this.state.criteria.filter(q=>q.filterType===s.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function k(U,N){const q=(U||[]).filter(z=>z.statisticName===N)[0];return q?q.value:0}function B(U){const N="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(z=>z.assetType.indexOf(N)===0).reduce((z,X)=>{const Y=te(U,X.assetType);return Y&&z.push([X.assetType.substring(N.length),Y]),z},[])}function J(U){if(U.properties){const N=U.properties.filter(X=>X.key===c.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=N.filter(X=>q.test(X.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return te(U,c.Repository)}function se(U){return{uri:`${U.fallbackAssetUri}/${c.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${c.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ie(U){const N=te(U,c.Icon);if(N)return N;const q=g.DefaultIconPath;return{uri:q,fallbackUri:q}}function te(U,N){return U.files.filter(z=>z.assetType===N)[0]?{uri:`${U.assetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function ge(U,N){const q=U.properties?U.properties.filter(X=>X.key===N):[],z=q.length>0&&q[0].value;return z?z.split(",").map(X=>(0,I.adoptToGalleryExtensionId)(X)):[]}function W(U){const N=U.properties?U.properties.filter(q=>q.key===f.Engine):[];return N.length>0&&N[0].value||""}function $(U){const N=U.properties?U.properties.filter(q=>q.key===f.PreRelease):[];return N.length>0&&N[0].value==="true"}function re(U){const N=U.properties?U.properties.filter(z=>z.key===f.LocalizedLanguages):[],q=N.length>0&&N[0].value||"";return q?q.split(","):[]}function M(U){return U.indexOf("preview")!==-1}function F(U){return U.targetPlatform?(0,g.toTargetPlatform)(U.targetPlatform):"undefined"}function j(U){const N=(0,L.distinct)(U.versions.map(F)),q=!!U.tags?.includes(g.WEB_EXTENSION_TAG),z=N.indexOf("web");return q?z===-1&&N.push("web"):z!==-1&&N.splice(z,1),N}function H(U,N){const q=(0,g.getFallbackTargetPlarforms)(N);for(let z=0;z<U.length;z++){const X=U[z];if(X.version===U[z-1]?.version){let Y=z;const he=F(X);if(he===N)for(;Y>0&&U[Y-1].version===X.version;)Y--;else if(q.includes(he))for(;Y>0&&U[Y-1].version===X.version&&F(U[Y-1])!==N;)Y--;Y!==z&&(U.splice(z,1),U.splice(Y,0,X))}}return U}t.sortExtensionVersions=H;function ne(U,N,q,z,X){const Y=U.versions[0],he={manifest:te(N,c.Manifest),readme:te(N,c.Details),changelog:te(N,c.Changelog),license:te(N,c.License),repository:J(N),download:se(N),icon:ie(N),coreTranslations:B(N)};return{identifier:{id:(0,I.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:N.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:k(U.statistics,"install"),rating:k(U.statistics,"averagerating"),ratingCount:k(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:q,assets:he,properties:{dependencies:ge(N,f.Dependency),extensionPack:ge(N,f.ExtensionPack),engine:W(N),localizedLanguages:re(N),targetPlatform:F(N),isPreReleaseVersion:$(N)},hasPreReleaseVersion:$(Y),hasReleaseVersion:z,preview:M(U.flags),telemetryData:X}}let K=class{constructor(N,q,z,X,Y,he,ae,oe){this.requestService=q,this.logService=z,this.environmentService=X,this.telemetryService=Y,this.fileService=he,this.productService=ae,this.configurationService=oe;const le=ae.extensionsGallery;this.extensionsGalleryUrl=le&&le.serviceUrl,this.extensionsControlUrl=le&&le.controlUrl,this.commonHeadersPromise=fe(ae.version,ae,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,q,z){const X=(0,l.isBoolean)(q)?q:!1,Y=(0,l.isBoolean)(q)?z:q;let he=new T().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,N.length).withFilter(s.ExtensionName,...N.map(({id:le})=>le.toLowerCase()));N.every(le=>!le.version)&&(he=he.withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly));const{galleryExtensions:ae}=await this.queryGallery(he,o,D.CancellationToken.None),oe=ae.map(le=>{const ye=(0,I.getGalleryExtensionId)(le.publisher.publisherName,le.extensionName);return{rawGalleryExtension:le,version:N.find(ue=>(0,I.areSameExtensions)(ue,{id:ye}))?.version,preRelease:X}});return this.converToGalleryExtensions(oe,o,()=>{},Y)}async getExtensions2(N){const q=[],z=[];for(const ae of N)ae.uuid?z.push(ae.uuid):q.push(ae.id.toLowerCase());let X=new T().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly).withPage(1,N.length);z.length&&(X=X.withFilter(s.ExtensionId,...z)),q.length&&(X=X.withFilter(s.ExtensionId,...q));const{galleryExtensions:Y}=await this.queryGallery(X,o,D.CancellationToken.None),he=Y.map(ae=>{const oe=(0,I.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),le=N.find(ye=>(0,I.areSameExtensions)(ye,{id:oe,uuid:ae.extensionId}));return{rawGalleryExtension:ae,preRelease:!!le?.preRelease}});return this.converToGalleryExtensions(he,o,()=>{},D.CancellationToken.None)}async getCompatibleExtension(N,q,z){const X=(0,g.isIExtensionIdentifier)(N)?null:N;if(X){if((0,g.isNotWebExtensionInWebTargetPlatform)(X.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(X,q,z))return X}const{id:Y,uuid:he}=X?X.identifier:N;let ae=new T().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);he?ae=ae.withFilter(s.ExtensionId,he):ae=ae.withFilter(s.ExtensionName,Y);const{galleryExtensions:oe}=await this.queryGallery(ae,z,D.CancellationToken.None),[le]=oe;if(!le||!le.versions.length)return null;const ye=j(le);if((0,g.isNotWebExtensionInWebTargetPlatform)(ye,z))return null;for(let ue of le.versions){if(!W(ue)){const Ee=await this.getEngine(ue);ue={...ue,properties:[...ue.properties||[],{key:f.Engine,value:Ee}]}}if(await this.isRawExtensionVersionCompatible(ue,q,ye,z)){const Ee=le.versions.some(Se=>!$(Se));return ne(le,ue,ye,Ee)}}return null}async isExtensionCompatible(N,q,z){if(!(0,g.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,z)||!q&&N.properties.isPreReleaseVersion)return!1;let X=N.properties.engine;if(!X){const Y=await this.getManifest(N,D.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");X=Y.engines.vscode}return(0,d.isEngineValid)(X,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,q,z,X){if(!(0,g.isTargetPlatformCompatible)(F(N),z,X)||!q&&$(N))return!1;const Y=await this.getEngine(N);return(0,d.isEngineValid)(Y,this.productService.version,this.productService.date)}async query(N,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let z=N.text||"";const X=(0,R.getOrDefault)(N,ue=>ue.pageSize,50);let Y=new T().withFlags(e.IncludeLatestVersionOnly,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,X);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,Ee,Se)=>(Y=Y.withFilter(s.Category,Se||Ee),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,Ee,Se)=>(Y=Y.withFilter(s.Tag,Se||Ee),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(s.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),Y=Y.withFilter(s.SearchText,z)),Y=Y.withSortBy(0)):N.ids?Y=Y.withFilter(s.ExtensionId,...N.ids):N.names?Y=Y.withFilter(s.ExtensionName,...N.names):Y=Y.withSortBy(4),typeof N.sortBy=="number"&&(Y=Y.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(Y=Y.withSortOrder(N.sortOrder));const{galleryExtensions:he,total:ae}=await this.queryGallery(Y,o,q),oe=ue=>({index:(Y.pageNumber-1)*Y.pageSize+ue,querySource:N.source}),le=await this.converToGalleryExtensions(he.map(ue=>({rawGalleryExtension:ue,preRelease:!!N.includePreRelease})),o,oe,q),ye=async(ue,Ee)=>{if(Ee.isCancellationRequested)throw(0,S.canceled)();const Se=Y.withPage(ue+1),{galleryExtensions:Oe}=await this.queryGallery(Se,o,Ee);return await this.converToGalleryExtensions(Oe.map(Fe=>({rawGalleryExtension:Fe,preRelease:!!N.includePreRelease})),o,oe,q)};return{firstPage:le,total:ae,pageSize:Y.pageSize,getPage:ye}}async converToGalleryExtensions(N,q,z,X){const Y=(oe,le,ye,ue)=>{const Ee=j(oe);let Se=oe.versions[0];return Se=oe.versions.find(Oe=>Oe.version===Se.version&&(0,g.isTargetPlatformCompatible)(F(Oe),Ee,q))||Se,$(Se)&&!ue&&(Se=oe.versions.find(Oe=>Oe.version!==Se.version&&!$(Oe))||Se),ne(oe,Se,Ee,ye,z(le))},he=[],ae=new Map;for(let oe=0;oe<N.length;oe++){const{rawGalleryExtension:le,version:ye,preRelease:ue}=N[oe],Ee=le.versions.some(Se=>!$(Se));if(ye){const Se=le.versions.find(Oe=>Oe.version===ye);Se&&he.push([oe,ne(le,Se,j(le),Ee)])}else{const Se=Y(le,oe,Ee,ue);Se.properties.isPreReleaseVersion?ae.set(Se.identifier.uuid,{index:oe,preRelease:ue}):he.push([oe,Se])}}if(ae.size){const oe=new Date().getTime(),le=new T().withFlags(e.IncludeVersions,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,ae.size).withFilter(s.ExtensionId,...ae.keys()),{galleryExtensions:ye}=await this.queryGallery(le,q,X);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-oe,count:ae.size}),ye.length!==ae.size)throw new Error("Not all extensions with latest versions are returned");for(const ue of ye){const Ee=ue.versions.some(ze=>!$(ze)),{index:Se,preRelease:Oe}=ae.get(ue.extensionId),Fe=Y(ue,Se,Ee,Oe);he.push([Se,Fe])}}return he.sort((oe,le)=>oe[0]-le[0]).map(([,oe])=>oe)}async queryGallery(N,q,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,e.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,i(e.Unpublished));const X=await this.commonHeadersPromise,Y=JSON.stringify(N.raw),he={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Y.length)},ae=new Date().getTime();let oe,le,ye=0;try{if(oe=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Y,headers:he},z),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:ye};const ue=await(0,w.asJson)(oe);if(ue){const Ee=ue.results[0],Se=Ee.extensions;Se.forEach(Fe=>H(Fe.versions,q));const Oe=Ee.resultMetadata&&Ee.resultMetadata.filter(Fe=>Fe.metadataType==="ResultCount")[0];return ye=Oe&&Oe.metadataItems.filter(Fe=>Fe.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:ye}}return{galleryExtensions:[],total:ye}}catch(ue){throw le=ue,ue}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(Y.length),duration:new Date().getTime()-ae,success:!!oe&&(0,w.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:le?(0,S.isPromiseCanceledError)(le)?"canceled":(0,S.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(N,q,z,X){if(!this.isEnabled())return;const Y=C.isWeb?this.api(`/itemName/${N}.${q}/version/${z}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${q}/${z}/stats?statType=${X}`),he=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",oe={...await this.commonHeadersPromise,Accept:he};try{await this.requestService.request({type:"POST",url:Y,headers:oe},D.CancellationToken.None)}catch{}}async download(N,q,z){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const X=(0,I.getGalleryExtensionTelemetryData)(N),Y=new Date().getTime(),he=ye=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:ye}),ae=z===2?"install":z===3?"update":"",oe=ae?{uri:`${N.assets.download.uri}${m.URI.parse(N.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${N.assets.download.fallbackUri}${m.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:N.assets.download,le=await this.getAsset(oe);await this.fileService.writeFile(q,le.stream),he(new Date().getTime()-Y)}async getReadme(N,q){if(N.assets.readme){const z=await this.getAsset(N.assets.readme,{},q);return await(0,w.asText)(z)||""}return""}async getManifest(N,q){if(N.assets.manifest){const z=await this.getAsset(N.assets.manifest,{},q),X=await(0,w.asText)(z);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(N,q){const z=te(N,c.Manifest);if(!z)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},Y=await this.getAsset(z,{headers:X});return await(0,w.asJson)(Y)}async getCoreTranslation(N,q){const z=N.assets.coreTranslations.filter(X=>X[0]===q.toUpperCase())[0];if(z){const X=await this.getAsset(z[1]),Y=await(0,w.asText)(X);return Y?JSON.parse(Y):null}return null}async getChangelog(N,q){if(N.assets.changelog){const z=await this.getAsset(N.assets.changelog,{},q);return await(0,w.asText)(z)||""}return""}async getAllCompatibleVersions(N,q,z){let X=new T().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?X=X.withFilter(s.ExtensionId,N.identifier.uuid):X=X.withFilter(s.ExtensionName,N.identifier.id);const{galleryExtensions:Y}=await this.queryGallery(X,z,D.CancellationToken.None);if(!Y.length)return[];const he=j(Y[0]);if((0,g.isNotWebExtensionInWebTargetPlatform)(he,z))return[];const ae=[];for(const oe of Y[0].versions)try{ae[ae.length-1]?.version!==oe.version&&await this.isRawExtensionVersionCompatible(oe,q,he,z)&&ae.push({version:oe.version,date:oe.lastUpdated,isPreReleaseVersion:$(oe)})}catch{}return ae}async getAsset(N,q={},z=D.CancellationToken.None){const X=await this.commonHeadersPromise,Y={type:"GET"},he={...X,...q.headers||{}};q={...q,...Y,headers:he};const ae=N.uri,oe=N.fallbackUri,le={...q,url:ae};try{const ye=await this.requestService.request(le,z);if(ye.res.statusCode===200)return ye;const ue=await(0,w.asText)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${ue}`)}catch(ye){if((0,S.isPromiseCanceledError)(ye))throw ye;const ue=(0,S.getErrorMessage)(ye);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:ue});const Ee={...q,url:oe};return this.requestService.request(Ee,z)}}async getEngine(N){let q=W(N);if(!q){const z=await this.getManifestFromRawExtensionVersion(N,D.CancellationToken.None);if(!z)throw new Error("Manifest was not found");q=z.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,w.asJson)(N),z=[],X={};if(q){for(const Y of q.malicious)z.push({id:Y});if(q.unsupported)for(const Y of Object.keys(q.unsupported)){const he=q.unsupported[Y];(0,l.isBoolean)(he)||(X[Y.toLowerCase()]=he.preReleaseExtension)}}return{malicious:z,unsupportedPreReleaseExtensions:X}}};K=ve([ce(1,w.IRequestService),ce(2,h.ILogService),ce(3,O.IEnvironmentService),ce(4,a.ITelemetryService),ce(5,v.IFileService),ce(6,p.IProductService),ce(7,P.IConfigurationService)],K);let ee=class extends K{constructor(N,q,z,X,Y,he,ae,oe){super(N,q,z,X,Y,he,ae,oe)}};ee=ve([ce(0,r.IStorageService),ce(1,w.IRequestService),ce(2,h.ILogService),ce(3,O.IEnvironmentService),ce(4,a.ITelemetryService),ce(5,v.IFileService),ce(6,p.IProductService),ce(7,P.IConfigurationService)],ee),t.ExtensionGalleryService=ee;let G=class extends K{constructor(N,q,z,X,Y,he,ae){super(void 0,N,q,z,X,Y,he,ae)}};G=ve([ce(0,w.IRequestService),ce(1,h.ILogService),ce(2,O.IEnvironmentService),ce(3,a.ITelemetryService),ce(4,v.IFileService),ce(5,p.IProductService),ce(6,P.IConfigurationService)],G),t.ExtensionGalleryServiceWithNoStorageService=G;async function fe(U,N,q,z,X,Y){const he={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U} (${N.nameShort})`},ae=await(0,u.getServiceMachineId)(q,X,Y);return(0,n.supportsTelemetry)(N,q)&&(0,n.getTelemetryLevel)(z)===3&&(he["X-Market-User-Id"]=ae),he}t.resolveMarketplaceHeaders=fe}),define(Q[118],Z([0,1,2,21,14,31,84,25,34,119,29,30,35]),function(x,t,L,D,S,R,C,b,l,m,P,O,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let I=class{constructor(h,p){this._configurationService=p,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=h.appenders,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const u=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!u})})}setExperimentProperty(h,p){this._experimentProperties[h]=p}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const h=await this._commonProperties;let p=h.sessionID,w=h["common.machineId"],u=h["common.firstSessionDate"],r=h["common.msftInternal"];return{sessionId:p,machineId:w,firstSessionDate:u,msftInternal:r}}dispose(){this._disposables.dispose()}_log(h,p,w,u){return this.telemetryLevel<p?Promise.resolve(void 0):this._commonProperties.then(r=>{w=(0,D.mixin)(w,r),w=(0,D.mixin)(w,this._experimentProperties),w=(0,D.cloneAndChange)(w,a=>{if(typeof a=="string")return this._cleanupInfo(a,u)}),this._appenders.forEach(a=>a.log(h,w))},r=>{console.error(r)})}publicLog(h,p,w){return this._log(h,3,p,w)}publicLog2(h,p,w){return this.publicLog(h,p,w)}publicLogError(h,p){return this.sendErrorTelemetry?this._log(h,2,p,!0):Promise.resolve(void 0)}publicLogError2(h,p){return this.publicLogError(h,p)}_anonymizeFilePaths(h){let p=h;const w=[];for(let n of this._cleanupPatterns)for(;;){const o=n.exec(h);if(!o)break;w.push([o.index,n.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(p="";;){const n=r.exec(h);if(!n)break;!u.test(n[0])&&w.every(([o,e])=>n.index<o||n.index>=e)&&(p+=h.substring(a,n.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<h.length&&(p+=h.substr(a)),p}_removePropertiesWithPossibleUserInfo(h){if(!h)return h;const p=h.toLowerCase(),w=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(p)?"<REDACTED: secret>":w.test(p)?"<REDACTED: email>":h}_cleanupInfo(h,p){let w=h;p&&(w=this._anonymizeFilePaths(w));for(let u of this._cleanupPatterns)w=w.replace(u,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};I.IDLE_START_EVENT_NAME="UserIdleStart",I.IDLE_STOP_EVENT_NAME="UserIdleStop",I=ve([ce(1,b.IConfigurationService)],I),t.TelemetryService=I;function d(){const v=(0,C.localize)(0,null,m.default.nameLong),h=m.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=S.isWeb?"":(0,C.localize)(3,null),w=(0,C.localize)(4,null),u=(0,C.localize)(5,null),r=(0,C.localize)(6,null),a=(0,C.localize)(7,null),n=`
|       | ${w} | ${u} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,C.localize)(8,null);return`
${v} ${h} ${p}

&nbsp;

${a}
${n}

&nbsp;

${o}
`}P.Registry.as(l.Extensions.Configuration).registerConfiguration({id:O.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(9,null),properties:{[O.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:d(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(l.Extensions.Configuration).registerConfiguration({id:O.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[O.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,C.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,C.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${O.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[120],Z([0,1,6,21,35]),function(x,t,L,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function R(b,l){const m=await new Promise((O,g)=>{x(["applicationinsights"],O,g)});let P;return m.defaultClient?(P=new m.TelemetryClient(b),P.channel.setUseDiskRetryCaching(!0)):(m.setup(b).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=m.defaultClient),b.indexOf("AIF-")===0&&(P.config.endpointUrl=l?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class C{constructor(l,m,P,O,g){this._eventPrefix=l,this._defaultData=m,this.testCollector=O,this.mirrored=g,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(m=>{l(m)},m=>{(0,L.onUnexpectedError)(m),console.error(m)})}}log(l,m){!this._aiClient||(m=(0,D.mixin)(m,this._defaultData),m=(0,S.validateTelemetryData)(m),this.testCollector&&(m.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+l,properties:m.properties,measurements:m.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(m=>{m.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=C}),define(Q[121],Z([0,1,11,15]),function(x,t,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function S(R,C){const b=Object.create(null),l=(P,O)=>{const g=JSON.parse(P);b[O]=g};if(C){const P=[],O=await D.Promises.readdir(C);for(const I of O)try{(await D.Promises.stat((0,L.join)(C,I))).isDirectory()&&P.push(I)}catch{}const g=[];for(const I of P)(await D.Promises.readdir((0,L.join)(C,I))).filter(v=>v==="telemetry.json").length===1&&g.push(I);for(const I of g){const d=(await D.Promises.readFile((0,L.join)(C,I,"telemetry.json"))).toString();l(d,I)}}let m=(await D.Promises.readFile((0,L.join)(R,"telemetry-core.json"))).toString();return l(m,"vscode-core"),m=(await D.Promises.readFile((0,L.join)(R,"telemetry-extensions.json"))).toString(),l(m,"vscode-extensions"),JSON.stringify(b,null,4)}t.buildTelemetryMessage=S}),define(Q[36],Z([0,1,12]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(Q[122],Z([0,1,8,2,9,20,23,16,13,36]),function(x,t,L,D,S,R,C,b,l,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let P=class extends D.Disposable{constructor(g,I,d,v,h){super();this.extensionsManagementService=g,this.logService=v,this.uriIdentityService=h,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(u=>u.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(w=>this.onInstallExtension(w))),this._register(g.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(g.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const p=S.URI.file(d.extensionsPath);this._register(I.watch(p)),this._register(L.Event.filter(I.onDidChangeFilesRaw,w=>w.changes.some(u=>this.doesChangeAffects(u,p)))(()=>this.onDidChange()))}doesChangeAffects(g,I){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(g.resource),I)?this.uriIdentityService.extUri.isEqual(g.resource,this.uriIdentityService.extUri.joinPath(I,".obsolete"))?!0:!(g.type!==1&&g.type!==2||this.uriIdentityService.extUri.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const I of g)this.removeInstallingExtension(I.identifier),I.local&&this.addInstalledExtension(I.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(I=>!(0,C.areSameExtensions)(I,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(I=>!(0,C.areSameExtensions)(I,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),I=g.filter(v=>[...this.installingExtensions,...this.installedExtensions].some(h=>(0,C.areSameExtensions)(h,v.identifier))?!1:v.installedTimestamp&&v.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",v.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",v.identifier.id),!1)),d=this.installedExtensions.filter(v=>this.installingExtensions.some(h=>(0,C.areSameExtensions)(h,v))?!1:g.every(h=>!(0,C.areSameExtensions)(h.identifier,v))?(this.logService.info("Detected extension removed from another source",v.id),!0):!1);this.installedExtensions=g.map(v=>v.identifier),(I.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:I,removed:d})}}};P=ve([ce(1,b.IFileService),ce(2,R.INativeEnvironmentService),ce(3,l.ILogService),ce(4,m.IUriIdentityService)],P),t.ExtensionsWatcher=P}),define(Q[123],Z([0,1,36,89,16,18,57,8,2]),function(x,t,L,D,S,R,C,b,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class m{constructor(g){this.uri=g,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let P=class{constructor(g){this._fileService=g,this._dispooables=new l.DisposableStore,this._limit=2**16;const I=new Map,d=v=>{let h=I.get(v.scheme);return h===void 0&&(h=g.hasProvider(v)&&!this._fileService.hasCapability(v,1024),I.set(v.scheme,h)),h};this._dispooables.add(b.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(v=>{I.delete(v.scheme)})),this.extUri=new R.ExtUri(d),this._canonicalUris=new C.SkipList((v,h)=>this.extUri.compare(v,h,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,R.normalizePath)(g));let I=this._canonicalUris.get(g);return I?I.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new m(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((d,v)=>d[1].touch<v[1].touch?1:d[1].touch>v[1].touch?-1:0);m._clock=0,this._canonicalUris.clear();const I=this._limit*.5;for(let d=0;d<I;d++)this._canonicalUris.set(g[d][0],g[d][1].touch())}};P=ve([ce(0,S.IFileService)],P),t.UriIdentityService=P,(0,D.registerSingleton)(L.IUriIdentityService,P,!0)}),define(Q[43],Z([0,1,100,3,11,7,15,70,135,136]),function(x,t,L,D,S,R,C,b,l,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class P extends Error{constructor(n,o){let e=o.message;switch(n){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=n,this.cause=o}}t.ExtractError=P;function O(a){const n=a.externalFileAttributes>>16||33188;return[448,56,7].map(o=>n&o).reduce((o,e)=>o+e,n&61440)}function g(a){if(a instanceof P)return a;let n;return/end of central directory record signature not found/.test(a.message)&&(n="CorruptZip"),new P(n,a)}function I(a,n,o,e,i,s){const c=S.dirname(n),f=S.join(e,c);if(!f.startsWith(e))return Promise.reject(new Error(b.localize(0,null,n)));const E=S.join(e,n);let y;return s.onCancellationRequested(()=>{y&&y.destroy()}),Promise.resolve(C.Promises.mkdir(f,{recursive:!0})).then(()=>new Promise((T,k)=>{if(!s.isCancellationRequested)try{y=(0,L.createWriteStream)(E,{mode:o}),y.once("close",()=>T()),y.once("error",k),a.once("error",k),a.pipe(y)}catch(B){k(B)}}))}function d(a,n,o,e){let i=(0,D.createCancelablePromise)(()=>Promise.resolve()),s=0;return e.onCancellationRequested(()=>{i.cancel(),a.close()}),new Promise((c,f)=>{const E=new D.Sequencer,y=T=>{T.isCancellationRequested||(s++,a.readEntry())};a.once("error",f),a.once("close",()=>i.then(()=>{e.isCancellationRequested||a.entryCount===s?c():f(new P("Incomplete",new Error(b.localize(1,null,s,a.entryCount))))},f)),a.readEntry(),a.on("entry",T=>{if(e.isCancellationRequested)return;if(!o.sourcePathRegex.test(T.fileName)){y(e);return}const k=T.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(k)){const se=S.join(n,k);i=(0,D.createCancelablePromise)(ie=>C.Promises.mkdir(se,{recursive:!0}).then(()=>y(ie)).then(void 0,f));return}const B=h(a,T),J=O(T);i=(0,D.createCancelablePromise)(se=>E.queue(()=>B.then(ie=>I(ie,k,J,n,o,se).then(()=>y(se)))).then(null,f))})})}function v(a,n=!1){return new Promise((o,e)=>{(0,l.open)(a,n?{lazyEntries:!0}:void 0,(i,s)=>{i?e(g(i)):o((0,R.assertIsDefined)(s))})})}function h(a,n){return new Promise((o,e)=>{a.openReadStream(n,(i,s)=>{i?e(g(i)):o((0,R.assertIsDefined)(s))})})}function p(a,n){return new Promise((o,e)=>{const i=new m.ZipFile;n.forEach(c=>{c.contents?i.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&i.addFile(c.localPath,c.path)}),i.end();const s=(0,L.createWriteStream)(a);i.outputStream.pipe(s),i.outputStream.once("error",e),s.once("error",e),s.once("finish",()=>o(a))})}t.zip=p;function w(a,n,o={},e){const i=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=v(a,!0);return o.overwrite&&(s=s.then(c=>C.Promises.rm(n).then(()=>c))),s.then(c=>d(c,n,{sourcePathRegex:i},e))}t.extract=w;function u(a,n){return v(a).then(o=>new Promise((e,i)=>{o.on("entry",s=>{s.fileName===n&&h(o,s).then(c=>e(c),c=>i(c))}),o.once("close",()=>i(new Error(b.localize(2,null,n))))}))}function r(a,n){return u(a,n).then(o=>new Promise((e,i)=>{const s=[];o.once("error",i),o.on("data",c=>s.push(c)),o.on("end",()=>e(Buffer.concat(s)))}))}t.buffer=r}),define(Q[124],Z([0,1,43,77]),function(x,t,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function S(R){return(0,L.buffer)(R,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}t.getManifest=S}),define(Q[125],Z([0,1,19,3,6,2,10,11,14,18,41,9,26,15,43,78,20,22,23,88,16,13,32]),function(x,t,L,D,S,R,C,b,l,m,P,O,g,I,d,v,h,p,w,u,r,a,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let o=class extends R.Disposable{constructor(i,s,c,f,E){super();this.beforeRemovingExtension=i,this.fileService=s,this.logService=c,this.environmentService=f,this.productService=E,this._devSystemExtensionsPath=null,this.systemExtensionsPath=f.builtinExtensionsPath,this.extensionsPath=f.extensionsPath,this.uninstalledPath=b.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(i){const s=[];(i===null||i===0)&&s.push(this.scanSystemExtensions().then(null,c=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(c).message,p.ExtensionManagementErrorCode.Internal)))),(i===null||i===1)&&s.push(this.scanUserExtensions(!0).then(null,c=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(c).message,p.ExtensionManagementErrorCode.Internal))));try{const c=await Promise.all(s);return(0,L.flatten)(c)}catch(c){throw this.joinErrors(c)}}async scanUserExtensions(i){this.logService.trace("Started scanning user extensions");let[s,c]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return c=c.filter(f=>!s[new w.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version).key()]),i&&(c=(0,w.groupByExtension)(c,E=>E.identifier).map(E=>E.sort((y,T)=>P.rcompare(y.manifest.version,T.manifest.version))[0])),this.logService.trace("Scanned user extensions:",c.length),c}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(i,s,c,f){const E=i.key(),y=b.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),T=b.join(this.extensionsPath,E);try{await I.Promises.rm(T)}catch{try{await I.Promises.rm(T)}catch{}throw new p.ExtensionManagementError((0,v.localize)(0,null,T,i.id),p.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(i,s,y,f);let k=await this.scanExtension(O.URI.file(y),1);if(!k)throw new Error((0,v.localize)(1,null,y));await this.storeMetadata(k,{...c,installedTimestamp:Date.now()});try{await this.rename(i,y,T,Date.now()+2*60*1e3),this.logService.info("Renamed to",T)}catch(B){try{await I.Promises.rm(y)}catch{}if(B.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",i.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(B)}. Deleted from extracted location`,y),B}try{k=await this.scanExtension(O.URI.file(T),1)}catch{}if(k)return k;throw new Error((0,v.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(i,s){return this.setMetadata(i,s),await this.storeMetadata(i,{...s,installedTimestamp:i.installedTimestamp}),i}async storeMetadata(i,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const c=b.join(i.location.fsPath,"package.json"),f=await I.Promises.readFile(c,"utf8"),{manifest:E}=await this.parseManifest(f);return E.__metadata=s,await I.Promises.writeFile(c,JSON.stringify(E,null,"	")),i}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...i){const s=i.map(c=>new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version));await this.withUninstalledExtensions(c=>{s.forEach(f=>c[f.key()]=!0)})}async setInstalled(i){await this.withUninstalledExtensions(f=>delete f[i.key()]);const c=(await this.scanExtensions(1)).find(f=>new w.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version).equals(i))||null;return c?(await this.storeMetadata(c,{installedTimestamp:Date.now()}),this.scanExtension(c.location,1)):null}async withUninstalledExtensions(i){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await I.Promises.readFile(this.uninstalledPath,"utf8")}catch(f){if(f.code!=="ENOENT")throw f}let c={};if(s)try{c=JSON.parse(s)}catch{}return i&&(i(c),Object.keys(c).length?await I.Promises.writeFile(this.uninstalledPath,JSON.stringify(c)):await I.Promises.rm(this.uninstalledPath)),c})}async removeExtension(i,s){this.logService.trace(`Deleting ${s} extension from disk`,i.identifier.id,i.location.fsPath),await I.Promises.rm(i.location.fsPath),this.logService.info("Deleted from disk",i.identifier.id,i.location.fsPath)}async removeUninstalledExtension(i){await this.removeExtension(i,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new w.ExtensionIdentifierWithVersion(i.identifier,i.manifest.version).key()])}async extractAtLocation(i,s,c,f){this.logService.trace(`Started extracting the extension from ${s} to ${c}`);try{await I.Promises.rm(c)}catch(E){throw new p.ExtensionManagementError(this.joinErrors(E).message,p.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(s,c,{sourcePath:"extension",overwrite:!0},f),this.logService.info(`Extracted extension to ${c}:`,i.id)}catch(E){try{await I.Promises.rm(c)}catch{}let y=p.ExtensionManagementErrorCode.Extract;throw E instanceof d.ExtractError&&(E.type==="CorruptZip"?y=p.ExtensionManagementErrorCode.CorruptZip:E.type==="Incomplete"&&(y=p.ExtensionManagementErrorCode.IncompleteZip)),new p.ExtensionManagementError(E.message,y)}}async rename(i,s,c,f){try{await I.Promises.rename(s,c)}catch(E){if(l.isWindows&&E&&E.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${s} to ${c} with 'EPERM' error. Trying again...`,i.id),this.rename(i,s,c,f);throw new p.ExtensionManagementError(E.message||(0,v.localize)(3,null,s,c),E.code||p.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const i=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return i;const s=this.scanDevSystemExtensions(),[c,f]=await Promise.all([i,s]);return[...c,...f]}async scanExtensionsInDir(i,s){const c=new D.Limiter(10),f=await this.fileService.resolve(O.URI.file(i));return f.children?(await Promise.all(f.children.filter(y=>y.isDirectory).map(y=>c.queue(async()=>s===1&&(0,m.basename)(y.resource).indexOf(".")===0?null:this.scanExtension(y.resource,s))))).filter(y=>y&&y.identifier):[]}async scanExtension(i,s){try{const c=await this.fileService.resolve(i);if(c.children){const{manifest:f,metadata:E}=await this.readManifest(i.fsPath),y=c.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,T=c.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource,k={id:(0,w.getGalleryExtensionId)(f.publisher,f.name)},B={type:s,identifier:k,manifest:f,location:i,readmeUrl:y,changelogUrl:T,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(B,E),B}}catch(c){s!==0&&this.logService.trace(c)}return null}async scanDefaultSystemExtensions(){const i=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",i.length),i}async scanDevSystemExtensions(){const i=this.getDevSystemExtensionsList();if(i.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(c=>i.some(f=>(0,w.areSameExtensions)(c.identifier,{id:f})))}else return[]}setMetadata(i,s){i.publisherDisplayName=s?.publisherDisplayName||null,i.publisherId=s?.publisherId||null,i.identifier.uuid=s?.id,i.isMachineScoped=!!s?.isMachineScoped,i.isPreReleaseVersion=!!s?.isPreReleaseVersion,i.preRelease=!!s?.preRelease,i.isBuiltin=i.type===0||!!s?.isBuiltin,i.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const i=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),c=new Set;for(const y of s)i[new w.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).key()]||c.add(y.identifier.id.toLowerCase());const f=(0,w.groupByExtension)(s,y=>y.identifier);await D.Promises.settled(f.map(async y=>{const T=y.sort((k,B)=>P.rcompare(k.manifest.version,B.manifest.version))[0];c.has(T.identifier.id.toLowerCase())||await this.beforeRemovingExtension(T)}));const E=s.filter(y=>i[new w.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).key()]);await D.Promises.settled(E.map(y=>this.removeUninstalledExtension(y)))}async removeOutdatedExtensions(){const i=await this.scanAllUserExtensions(),s=[],c=(0,w.groupByExtension)(i,f=>f.identifier);s.push(...(0,L.flatten)(c.map(f=>f.sort((E,y)=>P.rcompare(E.manifest.version,y.manifest.version)).slice(1)))),await D.Promises.settled(s.map(f=>this.removeExtension(f,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(i=>i.name)}joinErrors(i){const s=Array.isArray(i)?i:[i];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((c,f)=>new Error(`${c.message}${c.message?",":""}${f instanceof Error?f.message:f}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=b.normalize(b.join(C.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(i){const s=[I.Promises.readFile(b.join(i,"package.json"),"utf8").then(y=>this.parseManifest(y)),I.Promises.readFile(b.join(i,"package.nls.json"),"utf8").then(void 0,y=>y.code!=="ENOENT"?Promise.reject(y):"{}").then(y=>JSON.parse(y))],[{manifest:c,metadata:f},E]=await Promise.all(s);return{manifest:(0,u.localizeManifest)(c,E),metadata:f}}parseManifest(i){return new Promise((s,c)=>{try{const f=JSON.parse(i),E=f.__metadata||null;s({manifest:f,metadata:E})}catch{c(new Error((0,v.localize)(4,null)))}})}};o=ve([ce(1,r.IFileService),ce(2,a.ILogService),ce(3,h.INativeEnvironmentService),ce(4,n.IProductService)],o),t.ExtensionsScanner=o}),define(Q[126],Z([0,1,27,6,10,11,14,28,18,41,9,26,15,43,76,49,20,116,22,23,107,95,124,108,125,122,48,16,12,13,32,30,36]),function(x,t,L,D,S,R,C,b,l,m,P,O,g,I,d,v,h,p,w,u,r,a,n,o,e,i,s,c,f,E,y,T,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let B=class extends p.AbstractExtensionManagementService{constructor(W,$,re,M,F,j,H,ne,K){super(W,$,re,ne);this.environmentService=M,this.downloadService=F,this.fileService=H;const ee=this._register(j.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(j.createInstance(e.ExtensionsScanner,fe=>ee.postUninstall(fe))),this.manifestCache=this._register(new o.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(j.createInstance(r.ExtensionsDownloader));const G=this._register(new i.ExtensionsWatcher(this,H,M,re,K));this._register(G.onDidChangeExtensionsByAnotherSource(({added:fe,removed:U})=>{fe.length&&this._onDidInstallExtensions.fire(fe.map(N=>({identifier:N.identifier,operation:1,local:N}))),U.forEach(N=>this._onDidUninstallExtension.fire({identifier:N}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const W=await this.isAlpineLinux(),$=(0,w.getTargetPlatform)(W?"alpine":C.platform,b.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",$),$})()),this._targetPlatformPromise}async isAlpineLinux(){if(!C.isLinux)return!1;let W;try{W=(await this.fileService.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{W=(await this.fileService.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(re){this.logService.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(re))}}return!!W&&(W.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const $=await this.collectFiles(W),re=await(0,I.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,O.generateUuid)()).fsPath,$);return P.URI.file(re)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const $=await this.downloadVsix(W),re=R.resolve($.fsPath);return(0,n.getManifest)(re)}getInstalled(W=null){return this.extensionsScanner.scanExtensions(W)}async install(W,$={}){this.logService.trace("ExtensionManagementService#install",W.toString());const re=await this.downloadVsix(W),M=await(0,n.getManifest)(R.resolve(re.fsPath));if(M.engines&&M.engines.vscode&&!(0,s.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(d.localize(0,null,(0,u.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,re,$)}async updateMetadata(W,$){this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id);const re={...W.manifest.__metadata||{},...$};return $.isPreReleaseVersion&&(re.preRelease=!0),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,re),this.manifestCache.invalidate(),W}async updateExtensionScope(W,$){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},isMachineScoped:$}),this.manifestCache.invalidate(),W}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(W){if(W.scheme===S.Schemas.file)return W;const $=(0,l.joinPath)(this.environmentService.tmpDir,(0,O.generateUuid)());return await this.downloadService.download(W,$),$}createInstallExtensionTask(W,$,re){return P.URI.isUri($)?new ie(W,$,re,this.galleryService,this.extensionsScanner,this.logService):new se($,re,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(W,$){return new te(W,$,this.extensionsScanner)}async collectFiles(W){const $=async M=>{let F=await g.Promises.readdir(M);F=F.map(ne=>R.join(M,ne));const j=await Promise.all(F.map(ne=>g.Promises.stat(ne)));let H=Promise.resolve([]);return j.forEach((ne,K)=>{const ee=F[K];ne.isFile()&&(H=H.then(G=>[...G,ee])),ne.isDirectory()&&(H=H.then(G=>$(ee).then(fe=>[...G,...fe])))}),H};return(await $(W.location.fsPath)).map(M=>({path:`extension/${R.relative(W.location.fsPath,M)}`,localPath:M}))}};B=ve([ce(0,w.IExtensionGalleryService),ce(1,T.ITelemetryService),ce(2,E.ILogService),ce(3,h.INativeEnvironmentService),ce(4,v.IDownloadService),ce(5,f.IInstantiationService),ce(6,c.IFileService),ce(7,y.IProductService),ce(8,k.IUriIdentityService)],B),t.ExtensionManagementService=B;class J extends p.AbstractExtensionTask{constructor(W,$,re,M){super();this.identifier=W,this.source=$,this.extensionsScanner=re,this.logService=M,this._operation=2}get operation(){return this._operation}async installExtension(W,$){try{const re=await this.unsetUninstalledAndGetLocal(W.identifierWithVersion);if(re)return W.metadata?this.extensionsScanner.saveMetadataForLocalExtension(re,{...re.manifest.__metadata||{},...W.metadata}):re}catch{throw C.isMacintosh?new w.ExtensionManagementError(d.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(d.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(W,$)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const re=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),re}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.key()]}async extract({zipPath:W,identifierWithVersion:$,metadata:re},M){let F=await this.extensionsScanner.extractUserExtension($,W,re,M);return this.logService.info("Extracting completed.",$.id),F}}class se extends J{constructor(W,$,re,M,F){super(W.identifier,W,M,F);this.gallery=W,this.options=$,this.extensionsDownloader=re}async doRun(W){const re=(await this.extensionsScanner.scanExtensions(null)).find(F=>(0,u.areSameExtensions)(F.identifier,this.gallery.identifier));re&&(this._operation=3);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||re?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||re?.isBuiltin,M.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,M.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:re?.preRelease;try{const F=await this.installExtension(M,W);return re&&m.neq(re.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(re),F}catch(F){throw await this.deleteDownloadedVSIX(M.zipPath),F}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(P.URI.file(W))}catch($){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,D.getErrorMessage)($))}}async downloadInstallableExtension(W,$){const re={id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",W.identifier.id),M=(await this.extensionsDownloader.downloadExtension(W,$)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,M)}catch(F){throw new w.ExtensionManagementError((0,p.joinErrors)(F).message,w.ExtensionManagementErrorCode.Download)}try{const F=await(0,n.getManifest)(M);return{zipPath:M,identifierWithVersion:new u.ExtensionIdentifierWithVersion(W.identifier,F.version),metadata:re}}catch(F){throw await this.deleteDownloadedVSIX(M),new w.ExtensionManagementError((0,p.joinErrors)(F).message,w.ExtensionManagementErrorCode.Invalid)}}}class ie extends J{constructor(W,$,re,M,F,j){super({id:(0,u.getGalleryExtensionId)(W.publisher,W.name)},$,F,j);this.manifest=W,this.location=$,this.options=re,this.galleryService=M}async doRun(W){const $=new u.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(j=>(0,u.areSameExtensions)(this.identifier,j.identifier)),F=await this.getMetadata(this.identifier.id,this.manifest.version,W);if(F.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,F.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=3,$.equals(new u.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(d.localize(3,null,this.manifest.displayName||this.manifest.name))}else m.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const j=await this.unsetUninstalledAndGetLocal($);if(j)try{await this.extensionsScanner.removeExtension(j,"existing")}catch{throw new Error(d.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:$,metadata:F},W)}async getMetadata(W,$,re){try{let[M]=await this.galleryService.getExtensions([{id:W,version:$}],re);if(M||([M]=await this.galleryService.getExtensions([{id:W}],re)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion}}catch{}return{}}}class te extends p.AbstractExtensionTask{constructor(W,$,re){super();this.extension=W,this.options=$,this.extensionsScanner=re}async doRun(W){const $=[],re=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new u.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);$.push(...re.filter(F=>M.equals(new u.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version))))}else $.push(...re.filter(M=>(0,u.areSameExtensions)(M.identifier,this.extension.identifier)));if(!$.length)throw new Error(d.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...$),this.options.remove)for(const M of $)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(F){throw new Error(d.localize(6,null,(0,L.toErrorMessage)(F)))}}}}),define(Q[127],Z([0,1,112,3,17,6,2,7,25,20,91,13,111,137]),function(x,t,L,D,S,R,C,b,l,m,P,O,g,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let d=class extends C.Disposable{constructor(h,p,w){super();this.environmentService=p,this.logService=w,this.configure(h.getValue()),this._register(h.onDidChangeConfiguration(()=>this.configure(h.getValue()),this))}configure(h){this.proxyUrl=h.http&&h.http.proxy,this.strictSSL=!!(h.http&&h.http.proxyStrictSSL),this.authorization=h.http&&h.http.proxyAuthorization}async request(h,p){this.logService.trace("RequestService#request",h.url);const{proxyUrl:w,strictSSL:u}=this;let r;try{r=await(0,P.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",o))}const a={...process.env,...r},n=h.agent?h.agent:await(0,g.getProxyAgent)(h.url||"",a,{proxyUrl:w,strictSSL:u});return h.agent=n,h.strictSSL=u,this.authorization&&(h.headers={...h.headers||{},"Proxy-Authorization":this.authorization}),this._request(h,p)}async getNodeRequest(h){return((0,L.parse)(h.url).protocol==="https:"?await new Promise((u,r)=>{x(["https"],u,r)}):await new Promise((u,r)=>{x(["http"],u,r)})).request}_request(h,p){return D.Promises.withAsyncBody(async(w,u)=>{let r;const a=(0,L.parse)(h.url),n=h.getRawRequest?h.getRawRequest(h):await this.getNodeRequest(h),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,b.isBoolean)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(o.auth=h.user+":"+h.password),r=n(o,e=>{const i=(0,b.isNumber)(h.followRedirects)?h.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&i>0&&e.headers.location)this._request({...h,url:e.headers.location,followRedirects:i-1},p).then(w,u);else{let s=e;e.headers["content-encoding"]==="gzip"&&(s=e.pipe((0,I.createGunzip)())),w({res:e,stream:(0,S.streamToBufferReadableStream)(s)})}}),r.on("error",u),h.timeout&&r.setTimeout(h.timeout),h.data&&typeof h.data=="string"&&r.write(h.data),r.end(),p.onCancellationRequested(()=>{r.abort(),u((0,R.canceled)())})})}async resolveProxy(h){}};d=ve([ce(0,l.IConfigurationService),ce(1,m.INativeEnvironmentService),ce(2,O.ILogService)],d),t.RequestService=d}),define(Q[138],Z([0,1,33,3,17,27,6,2,10,11,28,9,15,25,104,49,110,20,87,117,22,106,126,16,97,99,39,94,51,52,109,13,101,119,32,42,127,115,30,118,35,120,121,36,123]),function(x,t,L,D,S,R,C,b,l,m,P,O,g,I,d,v,h,p,w,u,r,a,n,o,e,i,s,c,f,E,y,T,k,B,J,se,ie,te,ge,W,$,re,M,F,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class H extends b.Disposable{constructor(ee){super();this.argv=ee,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ee,G]=await this.initServices();return ee.invokeFunction(async fe=>{const U=fe.get(T.ILogService),N=fe.get(o.IFileService),q=fe.get(p.INativeEnvironmentService),z=fe.get(r.IExtensionManagementCLIService);U.info("CLI main",this.argv),this.registerErrorHandler(U),await this.doRun(q,z,N),await Promise.all(G.map(X=>{(0,D.raceTimeout)(X.flush(),1e3)}))})}async initServices(){const ee=new f.ServiceCollection,G={_serviceBrand:void 0,...B.default};ee.set(J.IProductService,G);const fe=new w.NativeEnvironmentService(this.argv,G);ee.set(p.INativeEnvironmentService,fe),await Promise.all([fe.appSettingsHome.fsPath,fe.extensionsPath].map(ae=>ae?g.Promises.mkdir(ae,{recursive:!0}):void 0));const U=(0,T.getLogLevel)(fe),N=[];N.push(new k.SpdLogLogger("cli",(0,m.join)(fe.logsPath,"cli.log"),!0,!1,U)),U===T.LogLevel.Trace&&N.push(new T.ConsoleLogger(U));const q=this._register(new T.MultiplexLogService(N));ee.set(T.ILogService,q);const z=this._register(new e.FileService(q));ee.set(o.IFileService,z);const X=this._register(new i.DiskFileSystemProvider(q));z.registerProvider(l.Schemas.file,X);const Y=this._register(new d.ConfigurationService(fe.settingsResource,z));ee.set(I.IConfigurationService,Y),await Y.initialize(),ee.set(F.IUriIdentityService,new j.UriIdentityService(z)),ee.set(se.IRequestService,new s.SyncDescriptor(ie.RequestService)),ee.set(v.IDownloadService,new s.SyncDescriptor(h.DownloadService)),ee.set(r.IExtensionManagementService,new s.SyncDescriptor(n.ExtensionManagementService)),ee.set(r.IExtensionGalleryService,new s.SyncDescriptor(u.ExtensionGalleryServiceWithNoStorageService)),ee.set(r.IExtensionManagementCLIService,new s.SyncDescriptor(a.ExtensionManagementCLIService)),ee.set(E.ILocalizationsService,new s.SyncDescriptor(y.LocalizationsService));const he=[];if((0,$.supportsTelemetry)(G,fe)){G.aiConfig&&G.aiConfig.asimovKey&&he.push(new re.AppInsightsAppender("monacoworkbench",null,G.aiConfig.asimovKey));const{appRoot:ae,extensionsPath:oe,installSourcePath:le}=fe,ye={appenders:he,sendErrorTelemetry:!1,commonProperties:(async()=>{let ue;try{const Ee=await g.Promises.readFile((0,m.join)(fe.userDataPath,"storage.json"));ue=JSON.parse(Ee.toString())[ge.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&q.error(Ee)}return(0,te.resolveCommonProperties)(z,(0,L.release)(),(0,L.hostname)(),process.arch,G.commit,G.version,ue,G.msftInternalDomains,le)})(),piiPaths:[ae,oe]};ee.set(ge.ITelemetryService,new s.SyncDescriptor(W.TelemetryService,[ye]))}else ee.set(ge.ITelemetryService,$.NullTelemetryService);return[new c.InstantiationService(ee),he]}registerErrorHandler(ee){(0,C.setUnexpectedErrorHandler)(G=>{const fe=(0,R.toErrorMessage)(G,!0);!fe||ee.error(`[uncaught exception in CLI]: ${fe}`)}),process.on("uncaughtException",G=>(0,C.onUnexpectedError)(G)),process.on("unhandledRejection",G=>(0,C.onUnexpectedError)(G))}async doRun(ee,G,fe){if(this.argv["install-source"])return this.setInstallSource(ee,fe,this.argv["install-source"]);if(this.argv["list-extensions"])return G.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const U={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return G.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],U,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return G.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return G.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(ee.appRoot,ee.extensionsPath))}}asExtensionIdOrVSIX(ee){return ee.map(G=>/\.vsix$/i.test(G)?O.URI.file((0,m.isAbsolute)(G)?G:(0,m.join)((0,P.cwd)(),G)):G)}async setInstallSource(ee,G,fe){await G.writeFile(O.URI.file(ee.installSourcePath),S.VSBuffer.fromString(fe.slice(0,30)))}}async function ne(K){const ee=new H(K);try{await ee.run()}finally{ee.dispose()}}t.main=ne})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f0054e049cd286ff317c738efe0fd8810b48ae98/core/vs/code/node/cliProcessMain.js.map
