/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["require","exports","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/codicons","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/languages/languageSelector","vs/base/common/hash","vs/editor/common/languages","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(Z){for(var e=[],s=0,t=Z.length;s<t;s++)e[s]=ye[Z[s]];return e};define(ye[42],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function s(t,y){if(!t)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=s}),define(ye[52],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function s(k){return k?k.replace(/\$\((.*?)\)/g,(P,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=s;class t{constructor(P,C,A){this.id=P,this.definition=C,this.description=A,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function y(k,P){const C=["codicon","codicon-"+k];return P&&C.push("codicon-modifier-"+P),C}e.getClassNamesArray=y;var T;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function C(w){if(w instanceof t)return["codicon","codicon-"+w.id];const i=P.exec(w.id);if(!i)return C(t.error);let[,p,o]=i;const u=["codicon","codicon-"+p];return o&&u.push("codicon-modifier-"+o.substr(1)),u}k.asClassNameArray=C;function A(w){return C(w).join(" ")}k.asClassName=A;function R(w){return"."+C(w).join(".")}k.asCSSSelector=R})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ye[74],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const s=Object.prototype.hasOwnProperty;function t(R){const w=[];for(let i in R)s.call(R,i)&&w.push(R[i]);return w}e.values=t;function y(R,w){for(let i in R)if(s.call(R,i)&&w({key:i,value:R[i]},function(){delete R[i]})===!1)return}e.forEach=y;function T(R,w){const i=Object.create(null);for(const p of R){const o=w(p);let u=i[o];u||(u=i[o]=[]),u.push(p)}return i}e.groupBy=T;function k(R){const w=Object.create(null);return R&&R.forEach((i,p)=>{w[p]=i}),w}e.fromMap=k;function P(R,w){const i=[],p=[];for(let o of R)w.has(o)||i.push(o);for(let o of w)R.has(o)||p.push(o);return{removed:i,added:p}}e.diffSets=P;function C(R,w){const i=[],p=[];for(let[o,u]of R)w.has(o)||i.push(u);for(let[o,u]of w)R.has(o)||p.push(u);return{removed:i,added:p}}e.diffMaps=C;class A{constructor(){this.map=new Map}add(w,i){let p=this.map.get(w);p||(p=new Set,this.map.set(w,p)),p.add(i)}delete(w,i){const p=this.map.get(w);!p||(p.delete(i),p.size===0&&this.map.delete(w))}forEach(w,i){const p=this.map.get(w);!p||p.forEach(i)}}e.SetMap=A}),define(ye[53],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function s(k){return(P,C,A)=>{let R=null,w=null;if(typeof A.value=="function"?(R="value",w=A.value):typeof A.get=="function"&&(R="get",w=A.get),!w)throw new Error("not supported");A[R]=k(w,C)}}e.createDecorator=s;function t(k,P,C){let A=null,R=null;if(typeof C.value=="function"?(A="value",R=C.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(A="get",R=C.get),!R)throw new Error("not supported");const w=`$memoize$${P}`;C[A]=function(...i){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,i)}),this[w]}}e.memoize=t;function y(k,P,C){return s((A,R)=>{const w=`$debounce$${R}`,i=`$debounce$result$${R}`;return function(...p){this[i]||(this[i]=C?C():void 0),clearTimeout(this[w]),P&&(this[i]=P(this[i],...p),p=[this[i]]),this[w]=setTimeout(()=>{A.apply(this,p),this[i]=C?C():void 0},k)}})}e.debounce=y;function T(k,P,C){return s((A,R)=>{const w=`$throttle$timer$${R}`,i=`$throttle$result$${R}`,p=`$throttle$lastRun$${R}`,o=`$throttle$pending$${R}`;return function(...u){if(this[i]||(this[i]=C?C():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),P&&(this[i]=P(this[i],...u)),this[o])return;const d=this[p]+k;d<=Date.now()?(this[p]=Date.now(),A.apply(this,[this[i]]),this[i]=C?C():void 0):(this[o]=!0,this[w]=setTimeout(()=>{this[o]=!1,this[p]=Date.now(),A.apply(this,[this[i]]),this[i]=C?C():void 0},d-Date.now()))}})}e.throttle=T}),define(ye[54],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class s{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=s,e.defaultGenerator=new s("id#")}),define(ye[100],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var s;(function(l){l[l.None=0]="None",l[l.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=2]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",l[l.InvalidUnicode=4]="InvalidUnicode",l[l.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",l[l.InvalidCharacter=6]="InvalidCharacter"})(s=e.ScanError||(e.ScanError={}));var t;(function(l){l[l.OpenBraceToken=1]="OpenBraceToken",l[l.CloseBraceToken=2]="CloseBraceToken",l[l.OpenBracketToken=3]="OpenBracketToken",l[l.CloseBracketToken=4]="CloseBracketToken",l[l.CommaToken=5]="CommaToken",l[l.ColonToken=6]="ColonToken",l[l.NullKeyword=7]="NullKeyword",l[l.TrueKeyword=8]="TrueKeyword",l[l.FalseKeyword=9]="FalseKeyword",l[l.StringLiteral=10]="StringLiteral",l[l.NumericLiteral=11]="NumericLiteral",l[l.LineCommentTrivia=12]="LineCommentTrivia",l[l.BlockCommentTrivia=13]="BlockCommentTrivia",l[l.LineBreakTrivia=14]="LineBreakTrivia",l[l.Trivia=15]="Trivia",l[l.Unknown=16]="Unknown",l[l.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(l){l[l.InvalidSymbol=1]="InvalidSymbol",l[l.InvalidNumberFormat=2]="InvalidNumberFormat",l[l.PropertyNameExpected=3]="PropertyNameExpected",l[l.ValueExpected=4]="ValueExpected",l[l.ColonExpected=5]="ColonExpected",l[l.CommaExpected=6]="CommaExpected",l[l.CloseBraceExpected=7]="CloseBraceExpected",l[l.CloseBracketExpected=8]="CloseBracketExpected",l[l.EndOfFileExpected=9]="EndOfFileExpected",l[l.InvalidCommentToken=10]="InvalidCommentToken",l[l.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=12]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",l[l.InvalidUnicode=14]="InvalidUnicode",l[l.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",l[l.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(l){l.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function k(l,M=!1){let r=0,n=l.length,b="",g=0,c=16,h=0;function v(O){let z=0,U=0;for(;z<O;){const $=l.charCodeAt(r);if($>=48&&$<=57)U=U*16+$-48;else if($>=65&&$<=70)U=U*16+$-65+10;else if($>=97&&$<=102)U=U*16+$-97+10;else break;r++,z++}return z<O&&(U=-1),U}function a(O){r=O,b="",g=0,c=16,h=0}function S(){const O=r;if(l.charCodeAt(r)===48)r++;else for(r++;r<l.length&&A(l.charCodeAt(r));)r++;if(r<l.length&&l.charCodeAt(r)===46)if(r++,r<l.length&&A(l.charCodeAt(r)))for(r++;r<l.length&&A(l.charCodeAt(r));)r++;else return h=3,l.substring(O,r);let z=r;if(r<l.length&&(l.charCodeAt(r)===69||l.charCodeAt(r)===101))if(r++,(r<l.length&&l.charCodeAt(r)===43||l.charCodeAt(r)===45)&&r++,r<l.length&&A(l.charCodeAt(r))){for(r++;r<l.length&&A(l.charCodeAt(r));)r++;z=r}else h=3;return l.substring(O,z)}function I(){let O="",z=r;for(;;){if(r>=n){O+=l.substring(z,r),h=2;break}const U=l.charCodeAt(r);if(U===34){O+=l.substring(z,r),r++;break}if(U===92){if(O+=l.substring(z,r),r++,r>=n){h=2;break}switch(l.charCodeAt(r++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const V=v(4);V>=0?O+=String.fromCharCode(V):h=4;break}default:h=5}z=r;continue}if(U>=0&&U<=31)if(C(U)){O+=l.substring(z,r),h=2;break}else h=6;r++}return O}function N(){if(b="",h=0,g=r,r>=n)return g=n,c=17;let O=l.charCodeAt(r);if(P(O)){do r++,b+=String.fromCharCode(O),O=l.charCodeAt(r);while(P(O));return c=15}if(C(O))return r++,b+=String.fromCharCode(O),O===13&&l.charCodeAt(r)===10&&(r++,b+=`
`),c=14;switch(O){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,b=I(),c=10;case 47:{const z=r-1;if(l.charCodeAt(r+1)===47){for(r+=2;r<n&&!C(l.charCodeAt(r));)r++;return b=l.substring(z,r),c=12}if(l.charCodeAt(r+1)===42){r+=2;const U=n-1;let $=!1;for(;r<U;){if(l.charCodeAt(r)===42&&l.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,h=1),b=l.substring(z,r),c=13}return b+=String.fromCharCode(O),r++,c=16}case 45:if(b+=String.fromCharCode(O),r++,r===n||!A(l.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=S(),c=11;default:for(;r<n&&B(O);)r++,O=l.charCodeAt(r);if(g!==r){switch(b=l.substring(g,r),b){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return b+=String.fromCharCode(O),r++,c=16}}function B(O){if(P(O)||C(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function E(){let O;do O=N();while(O>=12&&O<=15);return O}return{setPosition:a,getPosition:()=>r,scan:M?E:N,getToken:()=>c,getTokenValue:()=>b,getTokenOffset:()=>g,getTokenLength:()=>r-g,getTokenError:()=>h}}e.createScanner=k;function P(l){return l===32||l===9||l===11||l===12||l===160||l===5760||l>=8192&&l<=8203||l===8239||l===8287||l===12288||l===65279}function C(l){return l===10||l===13||l===8232||l===8233}function A(l){return l>=48&&l<=57}var R;(function(l){l[l.nullCharacter=0]="nullCharacter",l[l.maxAsciiCharacter=127]="maxAsciiCharacter",l[l.lineFeed=10]="lineFeed",l[l.carriageReturn=13]="carriageReturn",l[l.lineSeparator=8232]="lineSeparator",l[l.paragraphSeparator=8233]="paragraphSeparator",l[l.nextLine=133]="nextLine",l[l.space=32]="space",l[l.nonBreakingSpace=160]="nonBreakingSpace",l[l.enQuad=8192]="enQuad",l[l.emQuad=8193]="emQuad",l[l.enSpace=8194]="enSpace",l[l.emSpace=8195]="emSpace",l[l.threePerEmSpace=8196]="threePerEmSpace",l[l.fourPerEmSpace=8197]="fourPerEmSpace",l[l.sixPerEmSpace=8198]="sixPerEmSpace",l[l.figureSpace=8199]="figureSpace",l[l.punctuationSpace=8200]="punctuationSpace",l[l.thinSpace=8201]="thinSpace",l[l.hairSpace=8202]="hairSpace",l[l.zeroWidthSpace=8203]="zeroWidthSpace",l[l.narrowNoBreakSpace=8239]="narrowNoBreakSpace",l[l.ideographicSpace=12288]="ideographicSpace",l[l.mathematicalSpace=8287]="mathematicalSpace",l[l.ogham=5760]="ogham",l[l._=95]="_",l[l.$=36]="$",l[l._0=48]="_0",l[l._1=49]="_1",l[l._2=50]="_2",l[l._3=51]="_3",l[l._4=52]="_4",l[l._5=53]="_5",l[l._6=54]="_6",l[l._7=55]="_7",l[l._8=56]="_8",l[l._9=57]="_9",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.ampersand=38]="ampersand",l[l.asterisk=42]="asterisk",l[l.at=64]="at",l[l.backslash=92]="backslash",l[l.bar=124]="bar",l[l.caret=94]="caret",l[l.closeBrace=125]="closeBrace",l[l.closeBracket=93]="closeBracket",l[l.closeParen=41]="closeParen",l[l.colon=58]="colon",l[l.comma=44]="comma",l[l.dot=46]="dot",l[l.doubleQuote=34]="doubleQuote",l[l.equals=61]="equals",l[l.exclamation=33]="exclamation",l[l.greaterThan=62]="greaterThan",l[l.lessThan=60]="lessThan",l[l.minus=45]="minus",l[l.openBrace=123]="openBrace",l[l.openBracket=91]="openBracket",l[l.openParen=40]="openParen",l[l.percent=37]="percent",l[l.plus=43]="plus",l[l.question=63]="question",l[l.semicolon=59]="semicolon",l[l.singleQuote=39]="singleQuote",l[l.slash=47]="slash",l[l.tilde=126]="tilde",l[l.backspace=8]="backspace",l[l.formFeed=12]="formFeed",l[l.byteOrderMark=65279]="byteOrderMark",l[l.tab=9]="tab",l[l.verticalTab=11]="verticalTab"})(R||(R={}));function w(l,M){const r=[],n=new Object;let b;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function h(v,a,S,I){g.value=v,g.offset=a,g.length=S,g.type=I,g.colonOffset=void 0,b=g}try{m(l,{onObjectBegin:(v,a)=>{if(M<=v)throw n;b=void 0,c=M>v,r.push("")},onObjectProperty:(v,a,S)=>{if(M<a||(h(v,a,S,"property"),r[r.length-1]=v,M<=a+S))throw n},onObjectEnd:(v,a)=>{if(M<=v)throw n;b=void 0,r.pop()},onArrayBegin:(v,a)=>{if(M<=v)throw n;b=void 0,r.push(0)},onArrayEnd:(v,a)=>{if(M<=v)throw n;b=void 0,r.pop()},onLiteralValue:(v,a,S)=>{if(M<a||(h(v,a,S,D(v)),M<=a+S))throw n},onSeparator:(v,a,S)=>{if(M<=a)throw n;if(v===":"&&b&&b.type==="property")b.colonOffset=a,c=!1,b=void 0;else if(v===","){const I=r[r.length-1];typeof I=="number"?r[r.length-1]=I+1:(c=!0,r[r.length-1]=""),b=void 0}}})}catch(v){if(v!==n)throw v}return{path:r,previousNode:b,isAtPropertyKey:c,matches:v=>{let a=0;for(let S=0;a<v.length&&S<r.length;S++)if(v[a]===r[S]||v[a]==="*")a++;else if(v[a]!=="**")return!1;return a===v.length}}}e.getLocation=w;function i(l,M=[],r=T.DEFAULT){let n=null,b=[];const g=[];function c(v){Array.isArray(b)?b.push(v):n!==null&&(b[n]=v)}return m(l,{onObjectBegin:()=>{const v={};c(v),g.push(b),b=v,n=null},onObjectProperty:v=>{n=v},onObjectEnd:()=>{b=g.pop()},onArrayBegin:()=>{const v=[];c(v),g.push(b),b=v,n=null},onArrayEnd:()=>{b=g.pop()},onLiteralValue:c,onError:(v,a,S)=>{M.push({error:v,offset:a,length:S})}},r),b[0]}e.parse=i;function p(l,M=[],r=T.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(v){n.type==="property"&&(n.length=v-n.offset,n=n.parent)}function g(v){return n.children.push(v),v}m(l,{onObjectBegin:v=>{n=g({type:"object",offset:v,length:-1,parent:n,children:[]})},onObjectProperty:(v,a,S)=>{n=g({type:"property",offset:a,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:v,offset:a,length:S,parent:n})},onObjectEnd:(v,a)=>{n.length=v+a-n.offset,n=n.parent,b(v+a)},onArrayBegin:(v,a)=>{n=g({type:"array",offset:v,length:-1,parent:n,children:[]})},onArrayEnd:(v,a)=>{n.length=v+a-n.offset,n=n.parent,b(v+a)},onLiteralValue:(v,a,S)=>{g({type:D(v),offset:a,length:S,parent:n,value:v}),b(a+S)},onSeparator:(v,a,S)=>{n.type==="property"&&(v===":"?n.colonOffset=a:v===","&&b(a))},onError:(v,a,S)=>{M.push({error:v,offset:a,length:S})}},r);const h=n.children[0];return h&&delete h.parent,h}e.parseTree=p;function o(l,M){if(!l)return;let r=l;for(let n of M)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let b=!1;for(const g of r.children)if(Array.isArray(g.children)&&g.children[0].value===n){r=g.children[1],b=!0;break}if(!b)return}else{const b=n;if(r.type!=="array"||b<0||!Array.isArray(r.children)||b>=r.children.length)return;r=r.children[b]}return r}e.findNodeAtLocation=o;function u(l){if(!l.parent||!l.parent.children)return[];const M=u(l.parent);if(l.parent.type==="property"){const r=l.parent.children[0].value;M.push(r)}else if(l.parent.type==="array"){const r=l.parent.children.indexOf(l);r!==-1&&M.push(r)}return M}e.getNodePath=u;function d(l){switch(l.type){case"array":return l.children.map(d);case"object":{const M=Object.create(null);for(let r of l.children){const n=r.children[1];n&&(M[r.children[0].value]=d(n))}return M}case"null":case"string":case"number":case"boolean":return l.value;default:return}}e.getNodeValue=d;function F(l,M,r=!1){return M>=l.offset&&M<l.offset+l.length||r&&M===l.offset+l.length}e.contains=F;function _(l,M,r=!1){if(F(l,M,r)){const n=l.children;if(Array.isArray(n))for(let b=0;b<n.length&&n[b].offset<=M;b++){const g=_(n[b],M,r);if(g)return g}return l}}e.findNodeAtOffset=_;function m(l,M,r=T.DEFAULT){const n=k(l,!1);function b(ae){return ae?()=>ae(n.getTokenOffset(),n.getTokenLength()):()=>!0}function g(ae){return ae?le=>ae(le,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=b(M.onObjectBegin),h=g(M.onObjectProperty),v=b(M.onObjectEnd),a=b(M.onArrayBegin),S=b(M.onArrayEnd),I=g(M.onLiteralValue),N=g(M.onSeparator),B=b(M.onComment),E=g(M.onError),O=r&&r.disallowComments,z=r&&r.allowTrailingComma;function U(){for(;;){const ae=n.scan();switch(n.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:O||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ae){case 12:case 13:O?$(10):B();break;case 16:$(1);break;case 15:case 14:break;default:return ae}}}function $(ae,le=[],Ce=[]){if(E(ae),le.length+Ce.length>0){let Ee=n.getToken();for(;Ee!==17;){if(le.indexOf(Ee)!==-1){U();break}else if(Ce.indexOf(Ee)!==-1)break;Ee=U()}}}function V(ae){const le=n.getTokenValue();return ae?I(le):h(le),U(),!0}function ue(){switch(n.getToken()){case 11:{let ae=0;try{ae=JSON.parse(n.getTokenValue()),typeof ae!="number"&&($(2),ae=0)}catch{$(2)}I(ae);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return U(),!0}function K(){return n.getToken()!==10?($(3,[],[2,5]),!1):(V(!1),n.getToken()===6?(N(":"),U(),we()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function re(){c(),U();let ae=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ae||$(4,[],[]),N(","),U(),n.getToken()===2&&z)break}else ae&&$(6,[],[]);K()||$(4,[],[2,5]),ae=!0}return v(),n.getToken()!==2?$(7,[2],[]):U(),!0}function pe(){a(),U();let ae=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ae||$(4,[],[]),N(","),U(),n.getToken()===4&&z)break}else ae&&$(6,[],[]);we()||$(4,[],[4,5]),ae=!0}return S(),n.getToken()!==4?$(8,[4],[]):U(),!0}function we(){switch(n.getToken()){case 3:return pe();case 1:return re();case 10:return V(!0);default:return ue()}}return U(),n.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):we()?(n.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=m;function f(l,M){let r=k(l),n=[],b,g=0,c;do switch(c=r.getPosition(),b=r.scan(),b){case 12:case 13:case 17:g!==c&&n.push(l.substring(g,c)),M!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,M)),g=r.getPosition();break}while(b!==17);return n.join("")}e.stripComments=f;function D(l){switch(typeof l){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(l){if(Array.isArray(l))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Ae,De){for(var ve=0;ve<De.length;ve++){var ie=De[ve];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(Ae,ie.key,ie)}}function e(Ae,De,ve){return De&&Z(Ae.prototype,De),ve&&Z(Ae,ve),Ae}function s(Ae,De){if(!!Ae){if(typeof Ae=="string")return t(Ae,De);var ve=Object.prototype.toString.call(Ae).slice(8,-1);if(ve==="Object"&&Ae.constructor&&(ve=Ae.constructor.name),ve==="Map"||ve==="Set")return Array.from(Ae);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return t(Ae,De)}}function t(Ae,De){(De==null||De>Ae.length)&&(De=Ae.length);for(var ve=0,ie=new Array(De);ve<De;ve++)ie[ve]=Ae[ve];return ie}function y(Ae,De){var ve=typeof Symbol!="undefined"&&Ae[Symbol.iterator]||Ae["@@iterator"];if(ve)return(ve=ve.call(Ae)).next.bind(ve);if(Array.isArray(Ae)||(ve=s(Ae))||De&&Ae&&typeof Ae.length=="number"){ve&&(Ae=ve);var ie=0;return function(){return ie>=Ae.length?{done:!0}:{done:!1,value:Ae[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var T={exports:{}};function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function P(Ae){T.exports.defaults=Ae}T.exports={defaults:k(),getDefaults:k,changeDefaults:P};var C=/[&<>"']/,A=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,i={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(De){return i[De]};function o(Ae,De){if(De){if(C.test(Ae))return Ae.replace(A,p)}else if(R.test(Ae))return Ae.replace(w,p);return Ae}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Ae){return Ae.replace(u,function(De,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var F=/(^|[^\[])\^/g;function _(Ae,De){Ae=Ae.source||Ae,De=De||"";var ve={replace:function(se,de){return de=de.source||de,de=de.replace(F,"$1"),Ae=Ae.replace(se,de),ve},getRegex:function(){return new RegExp(Ae,De)}};return ve}var m=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(Ae,De,ve){if(Ae){var ie;try{ie=decodeURIComponent(d(ve)).replace(m,"").toLowerCase()}catch{return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}De&&!f.test(ve)&&(ve=b(De,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch{return null}return ve}var l={},M=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(Ae,De){l[" "+Ae]||(M.test(Ae)?l[" "+Ae]=Ae+"/":l[" "+Ae]=v(Ae,"/",!0)),Ae=l[" "+Ae];var ve=Ae.indexOf(":")===-1;return De.substring(0,2)==="//"?ve?De:Ae.replace(r,"$1")+De:De.charAt(0)==="/"?ve?De:Ae.replace(n,"$1")+De:Ae+De}var g={exec:function(){}};function c(Ae){for(var De=1,ve,ie;De<arguments.length;De++){ve=arguments[De];for(ie in ve)Object.prototype.hasOwnProperty.call(ve,ie)&&(Ae[ie]=ve[ie])}return Ae}function h(Ae,De){var ve=Ae.replace(/\|/g,function(de,me,Te){for(var We=!1,Le=me;--Le>=0&&Te[Le]==="\\";)We=!We;return We?"|":" |"}),ie=ve.split(/ \|/),se=0;if(ie[0].trim()||ie.shift(),ie[ie.length-1].trim()||ie.pop(),ie.length>De)ie.splice(De);else for(;ie.length<De;)ie.push("");for(;se<ie.length;se++)ie[se]=ie[se].trim().replace(/\\\|/g,"|");return ie}function v(Ae,De,ve){var ie=Ae.length;if(ie===0)return"";for(var se=0;se<ie;){var de=Ae.charAt(ie-se-1);if(de===De&&!ve)se++;else if(de!==De&&ve)se++;else break}return Ae.substr(0,ie-se)}function a(Ae,De){if(Ae.indexOf(De[1])===-1)return-1;for(var ve=Ae.length,ie=0,se=0;se<ve;se++)if(Ae[se]==="\\")se++;else if(Ae[se]===De[0])ie++;else if(Ae[se]===De[1]&&(ie--,ie<0))return se;return-1}function S(Ae){Ae&&Ae.sanitize&&!Ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(Ae,De){if(De<1)return"";for(var ve="";De>1;)De&1&&(ve+=Ae),De>>=1,Ae+=Ae;return ve+Ae}var N={escape:o,unescape:d,edit:_,cleanUrl:D,resolveUrl:b,noopTest:g,merge:c,splitCells:h,rtrim:v,findClosingBracket:a,checkSanitizeDeprecation:S,repeatString:I},B=T.exports.defaults,E=N.rtrim,O=N.splitCells,z=N.escape,U=N.findClosingBracket;function $(Ae,De,ve,ie){var se=De.href,de=De.title?z(De.title):null,me=Ae[1].replace(/\\([\[\]])/g,"$1");if(Ae[0].charAt(0)!=="!"){ie.state.inLink=!0;var Te={type:"link",raw:ve,href:se,title:de,text:me,tokens:ie.inlineTokens(me,[])};return ie.state.inLink=!1,Te}else return{type:"image",raw:ve,href:se,title:de,text:z(me)}}function V(Ae,De){var ve=Ae.match(/^(\s+)(?:```)/);if(ve===null)return De;var ie=ve[1];return De.split(`
`).map(function(se){var de=se.match(/^\s+/);if(de===null)return se;var me=de[0];return me.length>=ie.length?se.slice(ie.length):se}).join(`
`)}var ue=function(){function Ae(ve){this.options=ve||B}var De=Ae.prototype;return De.space=function(ie){var se=this.rules.block.newline.exec(ie);if(se)return se[0].length>1?{type:"space",raw:se[0]}:{raw:`
`}},De.code=function(ie){var se=this.rules.block.code.exec(ie);if(se){var de=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?de:E(de,`
`)}}},De.fences=function(ie){var se=this.rules.block.fences.exec(ie);if(se){var de=se[0],me=V(de,se[3]||"");return{type:"code",raw:de,lang:se[2]?se[2].trim():se[2],text:me}}},De.heading=function(ie){var se=this.rules.block.heading.exec(ie);if(se){var de=se[2].trim();if(/#$/.test(de)){var me=E(de,"#");(this.options.pedantic||!me||/ $/.test(me))&&(de=me.trim())}var Te={type:"heading",raw:se[0],depth:se[1].length,text:de,tokens:[]};return this.lexer.inline(Te.text,Te.tokens),Te}},De.hr=function(ie){var se=this.rules.block.hr.exec(ie);if(se)return{type:"hr",raw:se[0]}},De.blockquote=function(ie){var se=this.rules.block.blockquote.exec(ie);if(se){var de=se[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens(de,[]),text:de}}},De.list=function(ie){var se=this.rules.block.list.exec(ie);if(se){var de,me,Te,We,Le,Ke,it,rt,ne,ge,te=se[1].trim(),W=te.length>1,be={type:"list",raw:"",ordered:W,start:W?+te.slice(0,-1):"",loose:!1,items:[]};te=W?"\\d{1,9}\\"+te.slice(-1):"\\"+te,this.options.pedantic&&(te=W?te:"[*+-]");for(var Pe=new RegExp("^( {0,3}"+te+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ie&&!(this.rules.block.hr.test(ie)||!(se=Pe.exec(ie)));){ne=se[2].split(`
`),this.options.pedantic?(We=2,ge=ne[0].trimLeft()):(We=se[2].search(/[^ ]/),We=se[1].length+(We>4?1:We),ge=ne[0].slice(We-se[1].length)),Ke=!1,de=se[0],!ne[0]&&/^ *$/.test(ne[1])&&(de=se[1]+ne.slice(0,2).join(`
`)+`
`,be.loose=!0,ne=[]);var Ye=new RegExp("^ {0,"+Math.min(3,We-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<ne.length;Le++){if(rt=ne[Le],this.options.pedantic&&(rt=rt.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ye.test(rt)){de=se[1]+ne.slice(0,Le).join(`
`)+`
`;break}if(!Ke){rt.trim()||(Ke=!0),rt.search(/[^ ]/)>=We?ge+=`
`+rt.slice(We):ge+=`
`+rt;continue}if(rt.search(/[^ ]/)>=We||!rt.trim()){ge+=`
`+rt.slice(We);continue}else{de=se[1]+ne.slice(0,Le).join(`
`)+`
`;break}}be.loose||(it?be.loose=!0:/\n *\n *$/.test(de)&&(it=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ge),me&&(Te=me[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),be.items.push({type:"list_item",raw:de,task:!!me,checked:Te,loose:!1,text:ge}),be.raw+=de,ie=ie.slice(de.length)}be.items[be.items.length-1].raw=de.trimRight(),be.items[be.items.length-1].text=ge.trimRight(),be.raw=be.raw.trimRight();var xe=be.items.length;for(Le=0;Le<xe;Le++)this.lexer.state.top=!1,be.items[Le].tokens=this.lexer.blockTokens(be.items[Le].text,[]),be.items[Le].tokens.some(function(ut){return ut.type==="space"})&&(be.loose=!0,be.items[Le].loose=!0);return be}},De.html=function(ie){var se=this.rules.block.html.exec(ie);if(se){var de={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};return this.options.sanitize&&(de.type="paragraph",de.text=this.options.sanitizer?this.options.sanitizer(se[0]):z(se[0]),de.tokens=[],this.lexer.inline(de.text,de.tokens)),de}},De.def=function(ie){var se=this.rules.block.def.exec(ie);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var de=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:de,raw:se[0],href:se[2],title:se[3]}}},De.table=function(ie){var se=this.rules.block.table.exec(ie);if(se){var de={type:"table",header:O(se[1]).map(function(it){return{text:it}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]?se[3].replace(/\n$/,"").split(`
`):[]};if(de.header.length===de.align.length){de.raw=se[0];var me=de.align.length,Te,We,Le,Ke;for(Te=0;Te<me;Te++)/^ *-+: *$/.test(de.align[Te])?de.align[Te]="right":/^ *:-+: *$/.test(de.align[Te])?de.align[Te]="center":/^ *:-+ *$/.test(de.align[Te])?de.align[Te]="left":de.align[Te]=null;for(me=de.rows.length,Te=0;Te<me;Te++)de.rows[Te]=O(de.rows[Te],de.header.length).map(function(it){return{text:it}});for(me=de.header.length,We=0;We<me;We++)de.header[We].tokens=[],this.lexer.inlineTokens(de.header[We].text,de.header[We].tokens);for(me=de.rows.length,We=0;We<me;We++)for(Ke=de.rows[We],Le=0;Le<Ke.length;Le++)Ke[Le].tokens=[],this.lexer.inlineTokens(Ke[Le].text,Ke[Le].tokens);return de}}},De.lheading=function(ie){var se=this.rules.block.lheading.exec(ie);if(se){var de={type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},De.paragraph=function(ie){var se=this.rules.block.paragraph.exec(ie);if(se){var de={type:"paragraph",raw:se[0],text:se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},De.text=function(ie){var se=this.rules.block.text.exec(ie);if(se){var de={type:"text",raw:se[0],text:se[0],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},De.escape=function(ie){var se=this.rules.inline.escape.exec(ie);if(se)return{type:"escape",raw:se[0],text:z(se[1])}},De.tag=function(ie){var se=this.rules.inline.tag.exec(ie);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):z(se[0]):se[0]}},De.link=function(ie){var se=this.rules.inline.link.exec(ie);if(se){var de=se[2].trim();if(!this.options.pedantic&&/^</.test(de)){if(!/>$/.test(de))return;var me=E(de.slice(0,-1),"\\");if((de.length-me.length)%2==0)return}else{var Te=U(se[2],"()");if(Te>-1){var We=se[0].indexOf("!")===0?5:4,Le=We+se[1].length+Te;se[2]=se[2].substring(0,Te),se[0]=se[0].substring(0,Le).trim(),se[3]=""}}var Ke=se[2],it="";if(this.options.pedantic){var rt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ke);rt&&(Ke=rt[1],it=rt[3])}else it=se[3]?se[3].slice(1,-1):"";return Ke=Ke.trim(),/^</.test(Ke)&&(this.options.pedantic&&!/>$/.test(de)?Ke=Ke.slice(1):Ke=Ke.slice(1,-1)),$(se,{href:Ke&&Ke.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},De.reflink=function(ie,se){var de;if((de=this.rules.inline.reflink.exec(ie))||(de=this.rules.inline.nolink.exec(ie))){var me=(de[2]||de[1]).replace(/\s+/g," ");if(me=se[me.toLowerCase()],!me||!me.href){var Te=de[0].charAt(0);return{type:"text",raw:Te,text:Te}}return $(de,me,de[0],this.lexer)}},De.emStrong=function(ie,se,de){de===void 0&&(de="");var me=this.rules.inline.emStrong.lDelim.exec(ie);if(!!me&&!(me[3]&&de.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=me[1]||me[2]||"";if(!Te||Te&&(de===""||this.rules.inline.punctuation.exec(de))){var We=me[0].length-1,Le,Ke,it=We,rt=0,ne=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ne.lastIndex=0,se=se.slice(-1*ie.length+We);(me=ne.exec(se))!=null;)if(Le=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Le){if(Ke=Le.length,me[3]||me[4]){it+=Ke;continue}else if((me[5]||me[6])&&We%3&&!((We+Ke)%3)){rt+=Ke;continue}if(it-=Ke,!(it>0)){if(Ke=Math.min(Ke,Ke+it+rt),Math.min(We,Ke)%2){var ge=ie.slice(1,We+me.index+Ke);return{type:"em",raw:ie.slice(0,We+me.index+Ke+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var te=ie.slice(2,We+me.index+Ke-1);return{type:"strong",raw:ie.slice(0,We+me.index+Ke+1),text:te,tokens:this.lexer.inlineTokens(te,[])}}}}}},De.codespan=function(ie){var se=this.rules.inline.code.exec(ie);if(se){var de=se[2].replace(/\n/g," "),me=/[^ ]/.test(de),Te=/^ /.test(de)&&/ $/.test(de);return me&&Te&&(de=de.substring(1,de.length-1)),de=z(de,!0),{type:"codespan",raw:se[0],text:de}}},De.br=function(ie){var se=this.rules.inline.br.exec(ie);if(se)return{type:"br",raw:se[0]}},De.del=function(ie){var se=this.rules.inline.del.exec(ie);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2],[])}},De.autolink=function(ie,se){var de=this.rules.inline.autolink.exec(ie);if(de){var me,Te;return de[2]==="@"?(me=z(this.options.mangle?se(de[1]):de[1]),Te="mailto:"+me):(me=z(de[1]),Te=me),{type:"link",raw:de[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},De.url=function(ie,se){var de;if(de=this.rules.inline.url.exec(ie)){var me,Te;if(de[2]==="@")me=z(this.options.mangle?se(de[0]):de[0]),Te="mailto:"+me;else{var We;do We=de[0],de[0]=this.rules.inline._backpedal.exec(de[0])[0];while(We!==de[0]);me=z(de[0]),de[1]==="www."?Te="http://"+me:Te=me}return{type:"link",raw:de[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},De.inlineText=function(ie,se){var de=this.rules.inline.text.exec(ie);if(de){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):z(de[0]):de[0]:me=z(this.options.smartypants?se(de[0]):de[0]),{type:"text",raw:de[0],text:me}}},Ae}(),K=N.noopTest,re=N.edit,pe=N.merge,we={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:K,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};we._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,we._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,we.def=re(we.def).replace("label",we._label).replace("title",we._title).getRegex(),we.bullet=/(?:[*+-]|\d{1,9}[.)])/,we.listItemStart=re(/^( *)(bull) */).replace("bull",we.bullet).getRegex(),we.list=re(we.list).replace(/bull/g,we.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+we.def.source+")").getRegex(),we._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",we._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,we.html=re(we.html,"i").replace("comment",we._comment).replace("tag",we._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),we.paragraph=re(we._paragraph).replace("hr",we.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",we._tag).getRegex(),we.blockquote=re(we.blockquote).replace("paragraph",we.paragraph).getRegex(),we.normal=pe({},we),we.gfm=pe({},we.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),we.gfm.table=re(we.gfm.table).replace("hr",we.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",we._tag).getRegex(),we.pedantic=pe({},we.normal,{html:re(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",we._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:K,paragraph:re(we.normal._paragraph).replace("hr",we.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",we.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ae={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:K,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:K,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ae._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ae.punctuation=re(ae.punctuation).replace(/punctuation/g,ae._punctuation).getRegex(),ae.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ae.escapedEmSt=/\\\*|\\_/g,ae._comment=re(we._comment).replace("(?:-->|$)","-->").getRegex(),ae.emStrong.lDelim=re(ae.emStrong.lDelim).replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimAst=re(ae.emStrong.rDelimAst,"g").replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimUnd=re(ae.emStrong.rDelimUnd,"g").replace(/punct/g,ae._punctuation).getRegex(),ae._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ae._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ae._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ae.autolink=re(ae.autolink).replace("scheme",ae._scheme).replace("email",ae._email).getRegex(),ae._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ae.tag=re(ae.tag).replace("comment",ae._comment).replace("attribute",ae._attribute).getRegex(),ae._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ae._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ae._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ae.link=re(ae.link).replace("label",ae._label).replace("href",ae._href).replace("title",ae._title).getRegex(),ae.reflink=re(ae.reflink).replace("label",ae._label).getRegex(),ae.reflinkSearch=re(ae.reflinkSearch,"g").replace("reflink",ae.reflink).replace("nolink",ae.nolink).getRegex(),ae.normal=pe({},ae),ae.pedantic=pe({},ae.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:re(/^!?\[(label)\]\((.*?)\)/).replace("label",ae._label).getRegex(),reflink:re(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae._label).getRegex()}),ae.gfm=pe({},ae.normal,{escape:re(ae.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ae.gfm.url=re(ae.gfm.url,"i").replace("email",ae.gfm._extended_email).getRegex(),ae.breaks=pe({},ae.gfm,{br:re(ae.br).replace("{2,}","*").getRegex(),text:re(ae.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var le={block:we,inline:ae},Ce=ue,Ee=T.exports.defaults,Fe=le.block,$e=le.inline,Ve=N.repeatString;function je(Ae){return Ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Ae){var De="",ve,ie,se=Ae.length;for(ve=0;ve<se;ve++)ie=Ae.charCodeAt(ve),Math.random()>.5&&(ie="x"+ie.toString(16)),De+="&#"+ie+";";return De}var G=function(){function Ae(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||Ee,this.options.tokenizer=this.options.tokenizer||new Ce,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ie={block:Fe.normal,inline:$e.normal};this.options.pedantic?(ie.block=Fe.pedantic,ie.inline=$e.pedantic):this.options.gfm&&(ie.block=Fe.gfm,this.options.breaks?ie.inline=$e.breaks:ie.inline=$e.gfm),this.tokenizer.rules=ie}Ae.lex=function(ie,se){var de=new Ae(se);return de.lex(ie)},Ae.lexInline=function(ie,se){var de=new Ae(se);return de.inlineTokens(ie)};var De=Ae.prototype;return De.lex=function(ie){ie=ie.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ie,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},De.blockTokens=function(ie,se){var de=this;se===void 0&&(se=[]),this.options.pedantic&&(ie=ie.replace(/^ +$/gm,""));for(var me,Te,We,Le;ie;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(me=it.call({lexer:de},ie,se))?(ie=ie.substring(me.raw.length),se.push(me),!0):!1}))){if(me=this.tokenizer.space(ie)){ie=ie.substring(me.raw.length),me.type&&se.push(me);continue}if(me=this.tokenizer.code(ie)){ie=ie.substring(me.raw.length),Te=se[se.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):se.push(me);continue}if(me=this.tokenizer.fences(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.heading(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.hr(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.blockquote(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.list(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.html(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.def(ie)){ie=ie.substring(me.raw.length),Te=se[se.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.lheading(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(We=ie,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=1/0,rt=ie.slice(1),ne=void 0;de.options.extensions.startBlock.forEach(function(ge){ne=ge.call({lexer:this},rt),typeof ne=="number"&&ne>=0&&(it=Math.min(it,ne))}),it<1/0&&it>=0&&(We=ie.substring(0,it+1))}(),this.state.top&&(me=this.tokenizer.paragraph(We))){Te=se[se.length-1],Le&&Te.type==="paragraph"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):se.push(me),Le=We.length!==ie.length,ie=ie.substring(me.raw.length);continue}if(me=this.tokenizer.text(ie)){ie=ie.substring(me.raw.length),Te=se[se.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):se.push(me);continue}if(ie){var Ke="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(Ke);break}else throw new Error(Ke)}}return this.state.top=!0,se},De.inline=function(ie,se){this.inlineQueue.push({src:ie,tokens:se})},De.inlineTokens=function(ie,se){var de=this;se===void 0&&(se=[]);var me,Te,We,Le=ie,Ke,it,rt;if(this.tokens.links){var ne=Object.keys(this.tokens.links);if(ne.length>0)for(;(Ke=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)ne.includes(Ke[0].slice(Ke[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ke.index)+"["+Ve("a",Ke[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ke=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ke.index)+"["+Ve("a",Ke[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ke=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ke.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;)if(it||(rt=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(te){return(me=te.call({lexer:de},ie,se))?(ie=ie.substring(me.raw.length),se.push(me),!0):!1}))){if(me=this.tokenizer.escape(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.tag(ie)){ie=ie.substring(me.raw.length),Te=se[se.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):se.push(me);continue}if(me=this.tokenizer.link(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(me.raw.length),Te=se[se.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):se.push(me);continue}if(me=this.tokenizer.emStrong(ie,Le,rt)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.codespan(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.br(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.del(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.autolink(ie,H)){ie=ie.substring(me.raw.length),se.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(ie,H))){ie=ie.substring(me.raw.length),se.push(me);continue}if(We=ie,this.options.extensions&&this.options.extensions.startInline&&function(){var te=1/0,W=ie.slice(1),be=void 0;de.options.extensions.startInline.forEach(function(Pe){be=Pe.call({lexer:this},W),typeof be=="number"&&be>=0&&(te=Math.min(te,be))}),te<1/0&&te>=0&&(We=ie.substring(0,te+1))}(),me=this.tokenizer.inlineText(We,je)){ie=ie.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(rt=me.raw.slice(-1)),it=!0,Te=se[se.length-1],Te&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):se.push(me);continue}if(ie){var ge="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return se},e(Ae,null,[{key:"rules",get:function(){return{block:Fe,inline:$e}}}]),Ae}(),X=T.exports.defaults,oe=N.cleanUrl,q=N.escape,ee=function(){function Ae(ve){this.options=ve||X}var De=Ae.prototype;return De.code=function(ie,se,de){var me=(se||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(ie,me);Te!=null&&Te!==ie&&(de=!0,ie=Te)}return ie=ie.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+q(me,!0)+'">'+(de?ie:q(ie,!0))+`</code></pre>
`:"<pre><code>"+(de?ie:q(ie,!0))+`</code></pre>
`},De.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},De.html=function(ie){return ie},De.heading=function(ie,se,de,me){return this.options.headerIds?"<h"+se+' id="'+this.options.headerPrefix+me.slug(de)+'">'+ie+"</h"+se+`>
`:"<h"+se+">"+ie+"</h"+se+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ie,se,de){var me=se?"ol":"ul",Te=se&&de!==1?' start="'+de+'"':"";return"<"+me+Te+`>
`+ie+"</"+me+`>
`},De.listitem=function(ie){return"<li>"+ie+`</li>
`},De.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ie){return"<p>"+ie+`</p>
`},De.table=function(ie,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+se+`</table>
`},De.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},De.tablecell=function(ie,se){var de=se.header?"th":"td",me=se.align?"<"+de+' align="'+se.align+'">':"<"+de+">";return me+ie+"</"+de+`>
`},De.strong=function(ie){return"<strong>"+ie+"</strong>"},De.em=function(ie){return"<em>"+ie+"</em>"},De.codespan=function(ie){return"<code>"+ie+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ie){return"<del>"+ie+"</del>"},De.link=function(ie,se,de){if(ie=oe(this.options.sanitize,this.options.baseUrl,ie),ie===null)return de;var me='<a href="'+q(ie)+'"';return se&&(me+=' title="'+se+'"'),me+=">"+de+"</a>",me},De.image=function(ie,se,de){if(ie=oe(this.options.sanitize,this.options.baseUrl,ie),ie===null)return de;var me='<img src="'+ie+'" alt="'+de+'"';return se&&(me+=' title="'+se+'"'),me+=this.options.xhtml?"/>":">",me},De.text=function(ie){return ie},Ae}(),he=function(){function Ae(){}var De=Ae.prototype;return De.strong=function(ie){return ie},De.em=function(ie){return ie},De.codespan=function(ie){return ie},De.del=function(ie){return ie},De.html=function(ie){return ie},De.text=function(ie){return ie},De.link=function(ie,se,de){return""+de},De.image=function(ie,se,de){return""+de},De.br=function(){return""},Ae}(),Re=function(){function Ae(){this.seen={}}var De=Ae.prototype;return De.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ie,se){var de=ie,me=0;if(this.seen.hasOwnProperty(de)){me=this.seen[ie];do me++,de=ie+"-"+me;while(this.seen.hasOwnProperty(de))}return se||(this.seen[ie]=me,this.seen[de]=0),de},De.slug=function(ie,se){se===void 0&&(se={});var de=this.serialize(ie);return this.getNextSafeSlug(de,se.dryrun)},Ae}(),Ue=ee,ze=he,Qe=Re,et=T.exports.defaults,st=N.unescape,Xe=function(){function Ae(ve){this.options=ve||et,this.options.renderer=this.options.renderer||new Ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ze,this.slugger=new Qe}Ae.parse=function(ie,se){var de=new Ae(se);return de.parse(ie)},Ae.parseInline=function(ie,se){var de=new Ae(se);return de.parseInline(ie)};var De=Ae.prototype;return De.parse=function(ie,se){se===void 0&&(se=!0);var de="",me,Te,We,Le,Ke,it,rt,ne,ge,te,W,be,Pe,Ye,xe,ut,wt,Ct,bt,ft=ie.length;for(me=0;me<ft;me++){if(te=ie[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[te.type]&&(bt=this.options.extensions.renderers[te.type].call({parser:this},te),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(te.type))){de+=bt||"";continue}switch(te.type){case"space":continue;case"hr":{de+=this.renderer.hr();continue}case"heading":{de+=this.renderer.heading(this.parseInline(te.tokens),te.depth,st(this.parseInline(te.tokens,this.textRenderer)),this.slugger);continue}case"code":{de+=this.renderer.code(te.text,te.lang,te.escaped);continue}case"table":{for(ne="",rt="",Le=te.header.length,Te=0;Te<Le;Te++)rt+=this.renderer.tablecell(this.parseInline(te.header[Te].tokens),{header:!0,align:te.align[Te]});for(ne+=this.renderer.tablerow(rt),ge="",Le=te.rows.length,Te=0;Te<Le;Te++){for(it=te.rows[Te],rt="",Ke=it.length,We=0;We<Ke;We++)rt+=this.renderer.tablecell(this.parseInline(it[We].tokens),{header:!1,align:te.align[We]});ge+=this.renderer.tablerow(rt)}de+=this.renderer.table(ne,ge);continue}case"blockquote":{ge=this.parse(te.tokens),de+=this.renderer.blockquote(ge);continue}case"list":{for(W=te.ordered,be=te.start,Pe=te.loose,Le=te.items.length,ge="",Te=0;Te<Le;Te++)xe=te.items[Te],ut=xe.checked,wt=xe.task,Ye="",xe.task&&(Ct=this.renderer.checkbox(ut),Pe?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=Ct+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=Ct+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:Ct}):Ye+=Ct),Ye+=this.parse(xe.tokens,Pe),ge+=this.renderer.listitem(Ye,wt,ut);de+=this.renderer.list(ge,W,be);continue}case"html":{de+=this.renderer.html(te.text);continue}case"paragraph":{de+=this.renderer.paragraph(this.parseInline(te.tokens));continue}case"text":{for(ge=te.tokens?this.parseInline(te.tokens):te.text;me+1<ft&&ie[me+1].type==="text";)te=ie[++me],ge+=`
`+(te.tokens?this.parseInline(te.tokens):te.text);de+=se?this.renderer.paragraph(ge):ge;continue}default:{var pt='Token with "'+te.type+'" type was not found.';if(this.options.silent){console.error(pt);return}else throw new Error(pt)}}}return de},De.parseInline=function(ie,se){se=se||this.renderer;var de="",me,Te,We,Le=ie.length;for(me=0;me<Le;me++){if(Te=ie[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(We=this.options.extensions.renderers[Te.type].call({parser:this},Te),We!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){de+=We||"";continue}switch(Te.type){case"escape":{de+=se.text(Te.text);break}case"html":{de+=se.html(Te.text);break}case"link":{de+=se.link(Te.href,Te.title,this.parseInline(Te.tokens,se));break}case"image":{de+=se.image(Te.href,Te.title,Te.text);break}case"strong":{de+=se.strong(this.parseInline(Te.tokens,se));break}case"em":{de+=se.em(this.parseInline(Te.tokens,se));break}case"codespan":{de+=se.codespan(Te.text);break}case"br":{de+=se.br();break}case"del":{de+=se.del(this.parseInline(Te.tokens,se));break}case"text":{de+=se.text(Te.text);break}default:{var Ke='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Ke);return}else throw new Error(Ke)}}}return de},Ae}(),nt=G,lt=Xe,vt=ue,Oe=ee,Rt=he,j=Re,Q=N.merge,fe=N.checkSanitizeDeprecation,Ne=N.escape,qe=T.exports.getDefaults,ot=T.exports.changeDefaults,ht=T.exports.defaults;function Je(Ae,De,ve){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");if(typeof De=="function"&&(ve=De,De=null),De=Q({},Je.defaults,De||{}),fe(De),ve){var ie=De.highlight,se;try{se=nt.lex(Ae,De)}catch(We){return ve(We)}var de=function(Le){var Ke;if(!Le)try{De.walkTokens&&Je.walkTokens(se,De.walkTokens),Ke=lt.parse(se,De)}catch(it){Le=it}return De.highlight=ie,Le?ve(Le):ve(null,Ke)};if(!ie||ie.length<3||(delete De.highlight,!se.length))return de();var me=0;Je.walkTokens(se,function(We){We.type==="code"&&(me++,setTimeout(function(){ie(We.text,We.lang,function(Le,Ke){if(Le)return de(Le);Ke!=null&&Ke!==We.text&&(We.text=Ke,We.escaped=!0),me--,me===0&&de()})},0))}),me===0&&de();return}try{var Te=nt.lex(Ae,De);return De.walkTokens&&Je.walkTokens(Te,De.walkTokens),lt.parse(Te,De)}catch(We){if(We.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ne(We.message+"",!0)+"</pre>";throw We}}Je.options=Je.setOptions=function(Ae){return Q(Je.defaults,Ae),ot(Je.defaults),Je},Je.getDefaults=qe,Je.defaults=ht,Je.use=function(){for(var Ae=this,De=arguments.length,ve=new Array(De),ie=0;ie<De;ie++)ve[ie]=arguments[ie];var se=Q.apply(void 0,[{}].concat(ve)),de=Je.defaults.extensions||{renderers:{},childTokens:{}},me;ve.forEach(function(Te){if(Te.extensions&&(me=!0,Te.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var Ke=de.renderers?de.renderers[Le.name]:null;Ke?de.renderers[Le.name]=function(){for(var it=arguments.length,rt=new Array(it),ne=0;ne<it;ne++)rt[ne]=arguments[ne];var ge=Le.renderer.apply(this,rt);return ge===!1&&(ge=Ke.apply(this,rt)),ge}:de.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Le.level]?de[Le.level].unshift(Le.tokenizer):de[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?de.startBlock?de.startBlock.push(Le.start):de.startBlock=[Le.start]:Le.level==="inline"&&(de.startInline?de.startInline.push(Le.start):de.startInline=[Le.start]))}Le.childTokens&&(de.childTokens[Le.name]=Le.childTokens)})),Te.renderer&&function(){var Le=Je.defaults.renderer||new Oe,Ke=function(ne){var ge=Le[ne];Le[ne]=function(){for(var te=arguments.length,W=new Array(te),be=0;be<te;be++)W[be]=arguments[be];var Pe=Te.renderer[ne].apply(Le,W);return Pe===!1&&(Pe=ge.apply(Le,W)),Pe}};for(var it in Te.renderer)Ke(it);se.renderer=Le}(),Te.tokenizer&&function(){var Le=Je.defaults.tokenizer||new vt,Ke=function(ne){var ge=Le[ne];Le[ne]=function(){for(var te=arguments.length,W=new Array(te),be=0;be<te;be++)W[be]=arguments[be];var Pe=Te.tokenizer[ne].apply(Le,W);return Pe===!1&&(Pe=ge.apply(Le,W)),Pe}};for(var it in Te.tokenizer)Ke(it);se.tokenizer=Le}(),Te.walkTokens){var We=Je.defaults.walkTokens;se.walkTokens=function(Le){Te.walkTokens.call(Ae,Le),We&&We(Le)}}me&&(se.extensions=de),Je.setOptions(se)})},Je.walkTokens=function(Ae,De){for(var ve=function(){var me=se.value;switch(De(me),me.type){case"table":{for(var Te=y(me.header),We;!(We=Te()).done;){var Le=We.value;Je.walkTokens(Le.tokens,De)}for(var Ke=y(me.rows),it;!(it=Ke()).done;)for(var rt=it.value,ne=y(rt),ge;!(ge=ne()).done;){var te=ge.value;Je.walkTokens(te.tokens,De)}break}case"list":{Je.walkTokens(me.items,De);break}default:Je.defaults.extensions&&Je.defaults.extensions.childTokens&&Je.defaults.extensions.childTokens[me.type]?Je.defaults.extensions.childTokens[me.type].forEach(function(W){Je.walkTokens(me[W],De)}):me.tokens&&Je.walkTokens(me.tokens,De)}},ie=y(Ae),se;!(se=ie()).done;)ve()},Je.parseInline=function(Ae,De){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");De=Q({},Je.defaults,De||{}),fe(De);try{var ve=nt.lexInline(Ae,De);return De.walkTokens&&Je.walkTokens(ve,De.walkTokens),lt.parseInline(ve,De)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ne(ie.message+"",!0)+"</pre>";throw ie}},Je.Parser=lt,Je.parser=lt.parse,Je.Renderer=Oe,Je.TextRenderer=Rt,Je.Lexer=nt,Je.lexer=nt.lex,Je.Tokenizer=vt,Je.Slugger=j,Je.parse=Je;var Tt=Je;return Tt}),define(ye[75],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function s(k,P,C){return Math.min(Math.max(k,P),C)}e.clamp=s;function t(k,P){return(P+k%P)%P}e.rot=t;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class T{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function Z(y){const T=[];typeof y=="number"&&T.push("code/timeOrigin",y);function k(C){T.push(C,Date.now())}function P(){const C=[];for(let A=0;A<T.length;A+=2)C.push({name:T[A],startTime:T[A+1]});return C}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const k of performance.getEntriesByType("mark"))T.push({name:k.name,startTime:Math.round(y+k.startTime)});return T}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function s(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=s(t))}(),define(ye[76],_e([0,1,17]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(w){w.text="text/plain",w.binary="application/octet-stream",w.unknown="application/unknown",w.markdown="text/markdown",w.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(w){const i=(0,s.extname)(w),p=y[i.toLowerCase()];return p!==void 0?p:P(w)}e.getMediaOrTextMime=k;function P(w){const i=(0,s.extname)(w);return T[i.toLowerCase()]}e.getMediaMime=P;function C(w){for(const i in T)if(T[i]===w)return i}e.getExtensionForMimeType=C;const A=/^(.+)\/(.+?)(;.+)?$/;function R(w,i){const p=A.exec(w);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:i?void 0:w}e.normalizeMimeType=R}),define(ye[101],_e([0,1,15,6]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function y(m){const f=m;return f?[f.on,f.pause,f.resume,f.destroy].every(D=>typeof D=="function"):!1}e.isReadableStream=y;function T(m){const f=m;return f?y(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=T;function k(m,f){return new P(m,f)}e.newWriteableStream=k;class P{constructor(f,D){this.reducer=f,this.options=D,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(D=>this.pendingWritePromises.push(D))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(D=>D(f))}emitError(f){this.listeners.error.length===0?(0,s.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(D=>D(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,D){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(D),this.resume();break;case"end":this.listeners.end.push(D),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(D),this.state.flowing&&this.flowErrors();break}}removeListener(f,D){if(this.state.destroyed)return;let l;switch(f){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const M=l.indexOf(D);M>=0&&l.splice(M,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const D=[...this.pendingWritePromises];this.pendingWritePromises.length=0,D.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(m,f){const D=[];let l;for(;(l=m.read())!==null;)D.push(l);return f(D)}e.consumeReadable=C;function A(m,f,D){const l=[];let M;for(;(M=m.read())!==null&&l.length<D;)l.push(M);return M===null&&l.length>0?f(l):{read:()=>{if(l.length>0)return l.shift();if(typeof M!="undefined"){const r=M;return M=void 0,r}return m.read()}}}e.peekReadable=A;function R(m,f){return new Promise((D,l)=>{const M=[];w(m,{onData:r=>{f&&M.push(r)},onError:r=>{f?l(r):D(void 0)},onEnd:()=>{D(f?f(M):void 0)}})})}e.consumeStream=R;function w(m,f){let D=!1;return m.on("error",l=>{D||f.onError(l)}),m.on("end",()=>{D||f.onEnd()}),m.on("data",l=>{D||f.onData(l)}),(0,t.toDisposable)(()=>D=!0)}e.listenStream=w;function i(m,f){return new Promise((D,l)=>{const M=new t.DisposableStore,r=[],n=c=>{if(r.push(c),r.length>f)return M.dispose(),m.pause(),D({stream:m,buffer:r,ended:!1})},b=c=>l(c),g=()=>D({stream:m,buffer:r,ended:!0});M.add((0,t.toDisposable)(()=>m.removeListener("error",b))),m.on("error",b),M.add((0,t.toDisposable)(()=>m.removeListener("end",g))),m.on("end",g),M.add((0,t.toDisposable)(()=>m.removeListener("data",n))),m.on("data",n)})}e.peekStream=i;function p(m,f){const D=k(f);return D.end(m),D}e.toStream=p;function o(){const m=k(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=o;function u(m){let f=!1;return{read:()=>f?null:(f=!0,m)}}e.toReadable=u;function d(m,f,D){const l=k(D);return w(m,{onData:M=>l.write(f.data(M)),onError:M=>l.error(f.error?f.error(M):M),onEnd:()=>l.end()}),l}e.transform=d;function F(m,f,D){let l=!1;return{read:()=>{const M=f.read();return l?M:(l=!0,M!==null?D([m,M]):m)}}}e.prefixedReadable=F;function _(m,f,D){let l=!1;const M=k(D);return w(f,{onData:r=>l?M.write(r):(l=!0,M.write(D([m,r]))),onError:r=>M.error(r),onEnd:()=>{l||(l=!0,M.write(m)),M.end()}}),M}e.prefixedStream=_}),define(ye[22],_e([0,1,101]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let y,T;class k{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return t?new k(Buffer.allocUnsafe(h)):new k(new Uint8Array(h))}static wrap(h){return t&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new k(h)}static fromString(h,v){return!(v?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(h)):(y||(y=new TextEncoder),new k(y.encode(h)))}static fromByteArray(h){const v=k.alloc(h.length);for(let a=0,S=h.length;a<S;a++)v.buffer[a]=h[a];return v}static concat(h,v){if(typeof v=="undefined"){v=0;for(let I=0,N=h.length;I<N;I++)v+=h[I].byteLength}const a=k.alloc(v);let S=0;for(let I=0,N=h.length;I<N;I++){const B=h[I];a.set(B,S),S+=B.byteLength}return a}clone(){const h=k.alloc(this.byteLength);return h.set(this),h}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(h,v){return new k(this.buffer.subarray(h,v))}set(h,v){if(h instanceof k)this.buffer.set(h.buffer,v);else if(h instanceof Uint8Array)this.buffer.set(h,v);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),v);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),v);else throw new Error("Unkown argument 'array'")}readUInt32BE(h){return A(this.buffer,h)}writeUInt32BE(h,v){R(this.buffer,h,v)}readUInt32LE(h){return w(this.buffer,h)}writeUInt32LE(h,v){i(this.buffer,h,v)}readUInt8(h){return p(this.buffer,h)}writeUInt8(h,v){o(this.buffer,h,v)}}e.VSBuffer=k;function P(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0}e.readUInt16LE=P;function C(c,h,v){c[v+0]=h&255,h=h>>>8,c[v+1]=h&255}e.writeUInt16LE=C;function A(c,h){return c[h]*2**24+c[h+1]*2**16+c[h+2]*2**8+c[h+3]}e.readUInt32BE=A;function R(c,h,v){c[v+3]=h,h=h>>>8,c[v+2]=h,h=h>>>8,c[v+1]=h,h=h>>>8,c[v]=h}e.writeUInt32BE=R;function w(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0|c[h+2]<<16>>>0|c[h+3]<<24>>>0}e.readUInt32LE=w;function i(c,h,v){c[v+0]=h&255,h=h>>>8,c[v+1]=h&255,h=h>>>8,c[v+2]=h&255,h=h>>>8,c[v+3]=h&255}e.writeUInt32LE=i;function p(c,h){return c[h]}e.readUInt8=p;function o(c,h,v){c[v]=h}e.writeUInt8=o;function u(c){return s.consumeReadable(c,h=>k.concat(h))}e.readableToBuffer=u;function d(c){return s.toReadable(c)}e.bufferToReadable=d;function F(c){return s.consumeStream(c,h=>k.concat(h))}e.streamToBuffer=F;async function _(c){return c.ended?k.concat(c.buffer):k.concat([...c.buffer,await F(c.stream)])}e.bufferedStreamToBuffer=_;function m(c){return s.toStream(c,h=>k.concat(h))}e.bufferToStream=m;function f(c){return s.transform(c,{data:h=>typeof h=="string"?k.fromString(h):k.wrap(h)},h=>k.concat(h))}e.streamToBufferReadableStream=f;function D(c){return s.newWriteableStream(h=>k.concat(h),c)}e.newWriteableBufferStream=D;function l(c,h){return s.prefixedReadable(c,h,v=>k.concat(v))}e.prefixedBufferReadable=l;function M(c,h){return s.prefixedStream(c,h,v=>k.concat(v))}e.prefixedBufferStream=M;function r(c){let h=0,v=0,a=0;const S=new Uint8Array(Math.floor(c.length/4*3)),I=B=>{switch(v){case 3:S[a++]=h|B,v=0;break;case 2:S[a++]=h|B>>>2,h=B<<6,v=3;break;case 1:S[a++]=h|B>>>4,h=B<<4,v=2;break;default:h=B<<2,v=1}};for(let B=0;B<c.length;B++){const E=c.charCodeAt(B);if(E>=65&&E<=90)I(E-65);else if(E>=97&&E<=122)I(E-97+26);else if(E>=48&&E<=57)I(E-48+52);else if(E===43||E===45)I(62);else if(E===47||E===95)I(63);else{if(E===61)break;throw new SyntaxError(`Unexpected base64 character ${c[B]}`)}}const N=a;for(;v>0;)I(0);return k.wrap(S).slice(0,N)}e.decodeBase64=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:c},h=!0,v=!1){const a=v?b:n;let S="";const I=c.byteLength%3;let N=0;for(;N<c.byteLength-I;N+=3){const B=c[N+0],E=c[N+1],O=c[N+2];S+=a[B>>>2],S+=a[(B<<4|E>>>4)&63],S+=a[(E<<2|O>>>6)&63],S+=a[O&63]}if(I===1){const B=c[N+0];S+=a[B>>>2],S+=a[B<<4&63],h&&(S+="==")}else if(I===2){const B=c[N+0],E=c[N+1];S+=a[B>>>2],S+=a[(B<<4|E>>>4)&63],S+=a[E<<2&63],h&&(S+="=")}return S}e.encodeBase64=g});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!y:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(Z,s):y?y.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[21],_e([0,1,16,9]),function(Z,e,s,t){"use strict";var y,T,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(r,n,b){let g=r.get(n);return g===void 0&&(g=b,r.set(n,g)),g}e.getOrSet=P;function C(r){const n=[];return r.forEach((b,g)=>{n.push(`${g} => ${b}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=C;function A(r){const n=[];return r.forEach(b=>{n.push(b)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=A;class R{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const b=n.charCodeAt(0),g=this._value.charCodeAt(this._pos);return b-g}value(){return this._value[this._pos]}}e.StringIterator=R;class w{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class i{constructor(n=!0,b=!0){this._splitOnBackslash=n,this._caseSensitive=b}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let b=n.length-1;b>=0;b--,this._valueLen--){const g=this._value.charCodeAt(b);if(!(g===47||this._splitOnBackslash&&g===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const b=this._value.charCodeAt(this._to);if(b===47||this._splitOnBackslash&&b===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=i;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class o{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new i(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(d||(d={}));class F{constructor(n){this._iter=n}static forUris(n=()=>!1){return new F(new o(n))}static forPaths(n=!1){return new F(new i(void 0,!n))}static forStrings(){return new F(new R)}static forConfigKeys(){return new F(new w)}clear(){this._root=void 0}fill(n,b){if(b){const g=b.slice(0);(0,s.shuffle)(g);for(let c of g)this.set(c,n)}else{const g=n.slice(0);(0,s.shuffle)(g);for(let c of g)this.set(c[0],c[1])}}set(n,b){const g=this._iter.reset(n);let c;this._root||(this._root=new u,this._root.segment=g.value());const h=[];for(c=this._root;;){const a=g.cmp(c.segment);if(a>0)c.left||(c.left=new u,c.left.segment=g.value()),h.push([-1,c]),c=c.left;else if(a<0)c.right||(c.right=new u,c.right.segment=g.value()),h.push([1,c]),c=c.right;else if(g.hasNext())g.next(),c.mid||(c.mid=new u,c.mid.segment=g.value()),h.push([0,c]),c=c.mid;else break}const v=c.value;c.value=b,c.key=n;for(let a=h.length-1;a>=0;a--){const S=h[a][1];S.updateHeight();const I=S.balanceFactor();if(I<-1||I>1){const N=h[a][0],B=h[a+1][0];if(N===1&&B===1)h[a][1]=S.rotateLeft();else if(N===-1&&B===-1)h[a][1]=S.rotateRight();else if(N===1&&B===-1)S.right=h[a+1][1]=h[a+1][1].rotateRight(),h[a][1]=S.rotateLeft();else if(N===-1&&B===1)S.left=h[a+1][1]=h[a+1][1].rotateLeft(),h[a][1]=S.rotateRight();else throw new Error;if(a>0)switch(h[a-1][0]){case-1:h[a-1][1].left=h[a][1];break;case 1:h[a-1][1].right=h[a][1];break;case 0:h[a-1][1].mid=h[a][1];break}else this._root=h[0][1]}}return v}get(n){return this._getNode(n)?.value}_getNode(n){const b=this._iter.reset(n);let g=this._root;for(;g;){const c=b.cmp(g.segment);if(c>0)g=g.left;else if(c<0)g=g.right;else if(b.hasNext())b.next(),g=g.mid;else break}return g}has(n){const b=this._getNode(n);return!(b?.value===void 0&&b?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,b){const g=this._iter.reset(n),c=[];let h=this._root;for(;h;){const v=g.cmp(h.segment);if(v>0)c.push([-1,h]),h=h.left;else if(v<0)c.push([1,h]),h=h.right;else if(g.hasNext())g.next(),c.push([0,h]),h=h.mid;else break}if(!!h){if(b?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const v=this._min(h.right),{key:a,value:S,segment:I}=v;this._delete(v.key,!1),h.key=a,h.value=S,h.segment=I}else{const v=h.left??h.right;if(c.length>0){const[a,S]=c[c.length-1];switch(a){case-1:S.left=v;break;case 0:S.mid=v;break;case 1:S.right=v;break}}else this._root=v}for(let v=c.length-1;v>=0;v--){const a=c[v][1];a.updateHeight();const S=a.balanceFactor();if(S>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),c[v][1]=a.rotateLeft()):S<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),c[v][1]=a.rotateRight()),v>0)switch(c[v-1][0]){case-1:c[v-1][1].left=c[v][1];break;case 1:c[v-1][1].right=c[v][1];break;case 0:c[v-1][1].mid=c[v][1];break}else this._root=c[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const b=this._iter.reset(n);let g=this._root,c;for(;g;){const h=b.cmp(g.segment);if(h>0)g=g.left;else if(h<0)g=g.right;else if(b.hasNext())b.next(),c=g.value||c,g=g.mid;else break}return g&&g.value||c}findSuperstr(n){const b=this._iter.reset(n);let g=this._root;for(;g;){const c=b.cmp(g.segment);if(c>0)g=g.left;else if(c<0)g=g.right;else if(b.hasNext())b.next(),g=g.mid;else return g.mid?this._entries(g.mid):void 0}}forEach(n){for(const[b,g]of this)n(g,b)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=b=>{if(!b)return!0;const g=b.balanceFactor();return g<-1||g>1?!1:n(b.left)&&n(b.right)};return n(this._root)}}e.TernarySearchTree=F;class _{constructor(n,b){this.uri=n,this.value=b}}class m{constructor(n,b){this[y]="ResourceMap",n instanceof m?(this.map=new Map(n.map),this.toKey=b??m.defaultToKey):(this.map=new Map,this.toKey=n??m.defaultToKey)}set(n,b){return this.map.set(this.toKey(n),new _(n,b)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,b){typeof b!="undefined"&&(n=n.bind(b));for(let[g,c]of this.map)n(c.value,c.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=m,m.defaultToKey=r=>r.toString();var f;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(f=e.Touch||(e.Touch={}));class D{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,b=0){const g=this._map.get(n);if(!!g)return b!==0&&this.touch(g,b),g.value}set(n,b,g=0){let c=this._map.get(n);if(c)c.value=b,g!==0&&this.touch(c,g);else{switch(c={key:n,value:b,next:void 0,previous:void 0},g){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(n,c),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const b=this._map.get(n);if(!!b)return this._map.delete(n),this.removeItem(b),this._size--,b.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,b){const g=this._state;let c=this._head;for(;c;){if(b?n.bind(b)(c.value,c.key,this):n(c.value,c.key,this),this._state!==g)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,b=this._state;let g=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==b)throw new Error("LinkedMap got modified during iteration.");if(g){const h={value:g.key,done:!1};return g=g.next,h}else return{value:void 0,done:!0}}};return c}values(){const n=this,b=this._state;let g=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==b)throw new Error("LinkedMap got modified during iteration.");if(g){const h={value:g.value,done:!1};return g=g.next,h}else return{value:void 0,done:!0}}};return c}entries(){const n=this,b=this._state;let g=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==b)throw new Error("LinkedMap got modified during iteration.");if(g){const h={value:[g.key,g.value],done:!1};return g=g.next,h}else return{value:void 0,done:!0}}};return c}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let b=this._head,g=this.size;for(;b&&g>n;)this._map.delete(b.key),b=b.next,g--;this._head=b,this._size=g,b&&(b.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const b=n.next,g=n.previous;if(!b||!g)throw new Error("Invalid list");b.previous=g,g.next=b}n.next=void 0,n.previous=void 0,this._state++}touch(n,b){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(n===this._head)return;const g=n.next,c=n.previous;n===this._tail?(c.next=void 0,this._tail=c):(g.previous=c,c.next=g),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(b===2){if(n===this._tail)return;const g=n.next,c=n.previous;n===this._head?(g.previous=void 0,this._head=g):(g.previous=c,c.next=g),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((b,g)=>{n.push([g,b])}),n}fromJSON(n){this.clear();for(const[b,g]of n)this.set(b,g)}}e.LinkedMap=D;class l extends D{constructor(n,b=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,b),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,b=2){return super.get(n,b)}peek(n){return super.get(n,0)}set(n,b){return super.set(n,b,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class M{constructor(n){k.set(this,void 0),Ze(this,k,n,"f")}get size(){return Ie(this,k,"f").size}forEach(n,b){Ie(this,k,"f").forEach(n,b)}get(n){return Ie(this,k,"f").get(n)}has(n){return Ie(this,k,"f").has(n)}entries(){return Ie(this,k,"f").entries()}keys(){return Ie(this,k,"f").keys()}values(){return Ie(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ie(this,k,"f").entries()}}e.ReadonlyMapView=M}),define(ye[102],_e([0,1,21,9]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...q){return function(ee,he){for(let Re=0,Ue=q.length;Re<Ue;Re++){const ze=q[Re](ee,he);if(ze)return ze}return null}}e.or=y,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(q,ee,he){if(!he||he.length<ee.length)return null;let Re;return q?Re=t.startsWithIgnoreCase(he,ee):Re=he.indexOf(ee)===0,Re?ee.length>0?[{start:0,end:ee.length}]:[]:null}function k(q,ee){const he=ee.toLowerCase().indexOf(q.toLowerCase());return he===-1?null:[{start:he,end:he+q.length}]}e.matchesContiguousSubString=k;function P(q,ee){return C(q.toLowerCase(),ee.toLowerCase(),0,0)}e.matchesSubString=P;function C(q,ee,he,Re){if(he===q.length)return[];if(Re===ee.length)return null;if(q[he]===ee[Re]){let Ue=null;return(Ue=C(q,ee,he+1,Re+1))?F({start:Re,end:Re+1},Ue):null}return C(q,ee,he,Re+1)}function A(q){return 97<=q&&q<=122}function R(q){return 65<=q&&q<=90}e.isUpper=R;function w(q){return 48<=q&&q<=57}function i(q){return q===32||q===9||q===10||q===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(q=>p.add(q.charCodeAt(0)));function o(q){return i(q)||p.has(q)}function u(q,ee){return q===ee||o(q)&&o(ee)}function d(q){return A(q)||R(q)||w(q)}function F(q,ee){return ee.length===0?ee=[q]:q.end===ee[0].start?ee[0].start=q.start:ee.unshift(q),ee}function _(q,ee){for(let he=ee;he<q.length;he++){const Re=q.charCodeAt(he);if(R(Re)||w(Re)||he>0&&!d(q.charCodeAt(he-1)))return he}return q.length}function m(q,ee,he,Re){if(he===q.length)return[];if(Re===ee.length)return null;if(q[he]!==ee[Re].toLowerCase())return null;{let Ue=null,ze=Re+1;for(Ue=m(q,ee,he+1,Re+1);!Ue&&(ze=_(ee,ze))<ee.length;)Ue=m(q,ee,he+1,ze),ze++;return Ue===null?null:F({start:Re,end:Re+1},Ue)}}function f(q){let ee=0,he=0,Re=0,Ue=0,ze=0;for(let nt=0;nt<q.length;nt++)ze=q.charCodeAt(nt),R(ze)&&ee++,A(ze)&&he++,d(ze)&&Re++,w(ze)&&Ue++;const Qe=ee/q.length,et=he/q.length,st=Re/q.length,Xe=Ue/q.length;return{upperPercent:Qe,lowerPercent:et,alphaPercent:st,numericPercent:Xe}}function D(q){const{upperPercent:ee,lowerPercent:he}=q;return he===0&&ee>.6}function l(q){const{upperPercent:ee,lowerPercent:he,alphaPercent:Re,numericPercent:Ue}=q;return he>.2&&ee<.8&&Re>.6&&Ue<.2}function M(q){let ee=0,he=0,Re=0,Ue=0;for(let ze=0;ze<q.length;ze++)Re=q.charCodeAt(ze),R(Re)&&ee++,A(Re)&&he++,i(Re)&&Ue++;return(ee===0||he===0)&&Ue===0?q.length<=30:ee<=5}function r(q,ee){if(!ee||(ee=ee.trim(),ee.length===0)||!M(q)||ee.length>60)return null;const he=f(ee);if(!l(he)){if(!D(he))return null;ee=ee.toLowerCase()}let Re=null,Ue=0;for(q=q.toLowerCase();Ue<ee.length&&(Re=m(q,ee,0,Ue))===null;)Ue=_(ee,Ue+1);return Re}e.matchesCamelCase=r;function n(q,ee,he=!1){if(!ee||ee.length===0)return null;let Re=null,Ue=0;for(q=q.toLowerCase(),ee=ee.toLowerCase();Ue<ee.length&&(Re=b(q,ee,0,Ue,he))===null;)Ue=g(ee,Ue+1);return Re}e.matchesWords=n;function b(q,ee,he,Re,Ue){if(he===q.length)return[];if(Re===ee.length)return null;if(u(q.charCodeAt(he),ee.charCodeAt(Re))){let ze=null,Qe=Re+1;if(ze=b(q,ee,he+1,Re+1,Ue),!Ue)for(;!ze&&(Qe=g(ee,Qe))<ee.length;)ze=b(q,ee,he+1,Qe,Ue),Qe++;return ze===null?null:F({start:Re,end:Re+1},ze)}else return null}function g(q,ee){for(let he=ee;he<q.length;he++)if(o(q.charCodeAt(he))||he>0&&o(q.charCodeAt(he-1)))return he;return q.length}const c=y(e.matchesPrefix,r,k),h=y(e.matchesPrefix,r,P),v=new s.LRUCache(1e4);function a(q,ee,he=!1){if(typeof q!="string"||typeof ee!="string")return null;let Re=v.get(q);Re||(Re=new RegExp(t.convertSimple2RegExpPattern(q),"i"),v.set(q,Re));const Ue=Re.exec(ee);return Ue?[{start:Ue.index,end:Ue.index+Ue[0].length}]:he?h(q,ee):c(q,ee)}e.matchesFuzzy=a;function S(q,ee){const he=$e(q,q.toLowerCase(),0,ee,ee.toLowerCase(),0,!0);return he?N(he):null}e.matchesFuzzy2=S;function I(q,ee,he,Re,Ue,ze){const Qe=Math.min(13,q.length);for(;he<Qe;he++){const et=$e(q,ee,he,Re,Ue,ze,!1);if(et)return et}return[0,ze]}e.anyScore=I;function N(q){if(typeof q=="undefined")return[];const ee=[],he=q[1];for(let Re=q.length-1;Re>1;Re--){const Ue=q[Re]+he,ze=ee[ee.length-1];ze&&ze.end===Ue?ze.end=Ue+1:ee.push({start:Ue,end:Ue+1})}return ee}e.createMatches=N;const B=128;function E(){const q=[],ee=[];for(let he=0;he<=B;he++)ee[he]=0;for(let he=0;he<=B;he++)q.push(ee.slice(0));return q}function O(q){const ee=[];for(let he=0;he<=q;he++)ee[he]=0;return ee}const z=O(2*B),U=O(2*B),$=E(),V=E(),ue=E(),K=!1;function re(q,ee,he,Re,Ue){function ze(et,st,Xe=" "){for(;et.length<st;)et=Xe+et;return et}let Qe=` |   |${Re.split("").map(et=>ze(et,3)).join("|")}
`;for(let et=0;et<=he;et++)et===0?Qe+=" |":Qe+=`${ee[et-1]}|`,Qe+=q[et].slice(0,Ue+1).map(st=>ze(st.toString(),3)).join("|")+`
`;return Qe}function pe(q,ee,he,Re){q=q.substr(ee),he=he.substr(Re),console.log(re(V,q,q.length,he,he.length)),console.log(re(ue,q,q.length,he,he.length)),console.log(re($,q,q.length,he,he.length))}function we(q,ee){if(ee<0||ee>=q.length)return!1;const he=q.codePointAt(ee);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(he)}}function ae(q,ee){if(ee<0||ee>=q.length)return!1;switch(q.charCodeAt(ee)){case 32:case 9:return!0;default:return!1}}function le(q,ee,he){return ee[q]!==he[q]}function Ce(q,ee,he,Re,Ue,ze,Qe=!1){for(;ee<he&&Ue<ze;)q[ee]===Re[Ue]&&(Qe&&(z[ee]=Ue),ee+=1),Ue+=1;return ee===he}e.isPatternInWord=Ce;var Ee;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var Fe;(function(q){q.Default=[-100,0];function ee(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}q.isDefault=ee})(Fe=e.FuzzyScore||(e.FuzzyScore={}));function $e(q,ee,he,Re,Ue,ze,Qe){const et=q.length>B?B:q.length,st=Re.length>B?B:Re.length;if(he>=et||ze>=st||et-he>st-ze||!Ce(ee,he,et,Ue,ze,st,!0))return;Ve(et,st,he,ze,ee,Ue);let Xe=1,nt=1,lt=he,vt=ze;const Oe=[!1];for(Xe=1,lt=he;lt<et;Xe++,lt++){const Ne=z[lt],qe=U[lt],ot=lt+1<et?U[lt+1]:st;for(nt=Ne-ze+1,vt=Ne;vt<ot;nt++,vt++){let ht=Number.MIN_SAFE_INTEGER,Je=!1;vt<=qe&&(ht=je(q,ee,lt,he,Re,Ue,vt,st,ze,$[Xe-1][nt-1]===0,Oe));let Tt=0;ht!==Number.MAX_SAFE_INTEGER&&(Je=!0,Tt=ht+V[Xe-1][nt-1]);const Ae=vt>Ne,De=Ae?V[Xe][nt-1]+($[Xe][nt-1]>0?-5:0):0,ve=vt>Ne+1&&$[Xe][nt-1]>0,ie=ve?V[Xe][nt-2]+($[Xe][nt-2]>0?-5:0):0;if(ve&&(!Ae||ie>=De)&&(!Je||ie>=Tt))V[Xe][nt]=ie,ue[Xe][nt]=3,$[Xe][nt]=0;else if(Ae&&(!Je||De>=Tt))V[Xe][nt]=De,ue[Xe][nt]=2,$[Xe][nt]=0;else if(Je)V[Xe][nt]=Tt,ue[Xe][nt]=1,$[Xe][nt]=$[Xe-1][nt-1]+1;else throw new Error("not possible")}}if(K&&pe(q,he,Re,ze),!Oe[0]&&!Qe)return;Xe--,nt--;const Rt=[V[Xe][nt],ze];let j=0,Q=0;for(;Xe>=1;){let Ne=nt;do{const qe=ue[Xe][Ne];if(qe===3)Ne=Ne-2;else if(qe===2)Ne=Ne-1;else break}while(Ne>=1);j>1&&ee[he+Xe-1]===Ue[ze+nt-1]&&!le(Ne+ze-1,Re,Ue)&&j+1>$[Xe][Ne]&&(Ne=nt),Ne===nt?j++:j=1,Q||(Q=Ne),Xe--,nt=Ne-1,Rt.push(nt)}st===et&&(Rt[0]+=2);const fe=Q-et;return Rt[0]-=fe,Rt}e.fuzzyScore=$e;function Ve(q,ee,he,Re,Ue,ze){let Qe=q-1,et=ee-1;for(;Qe>=he&&et>=Re;)Ue[Qe]===ze[et]&&(U[Qe]=et,Qe--),et--}function je(q,ee,he,Re,Ue,ze,Qe,et,st,Xe,nt){if(ee[he]!==ze[Qe])return Number.MIN_SAFE_INTEGER;let lt=1,vt=!1;return Qe===he-Re?lt=q[he]===Ue[Qe]?7:5:le(Qe,Ue,ze)&&(Qe===0||!le(Qe-1,Ue,ze))?(lt=q[he]===Ue[Qe]?7:5,vt=!0):we(ze,Qe)&&(Qe===0||!we(ze,Qe-1))?lt=5:(we(ze,Qe-1)||ae(ze,Qe-1))&&(lt=5,vt=!0),lt>1&&he===Re&&(nt[0]=!0),vt||(vt=le(Qe,Ue,ze)||we(ze,Qe-1)||ae(ze,Qe-1)),he===Re?Qe>st&&(lt-=vt?3:5):Xe?lt+=vt?2:0:lt+=vt?0:1,Qe+1===et&&(lt-=vt?3:5),lt}function H(q,ee,he,Re,Ue,ze,Qe){return X(q,ee,he,Re,Ue,ze,!0,Qe)}e.fuzzyScoreGracefulAggressive=H;function G(q,ee,he,Re,Ue,ze,Qe){return X(q,ee,he,Re,Ue,ze,!1,Qe)}e.fuzzyScoreGraceful=G;function X(q,ee,he,Re,Ue,ze,Qe,et){let st=$e(q,ee,he,Re,Ue,ze,et);if(st&&!Qe)return st;if(q.length>=3){const Xe=Math.min(7,q.length-1);for(let nt=he+1;nt<Xe;nt++){const lt=oe(q,nt);if(lt){const vt=$e(lt,lt.toLowerCase(),he,Re,Ue,ze,et);vt&&(vt[0]-=3,(!st||vt[0]>st[0])&&(st=vt))}}}return st}function oe(q,ee){if(ee+1>=q.length)return;const he=q[ee],Re=q[ee+1];if(he!==Re)return q.slice(0,ee)+Re+he+q.slice(ee+2)}}),define(ye[103],_e([0,1,52,102,9]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(s.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${T.source}`,"g");function C(d){return d.replace(P,(F,_)=>_?F:`\\${F}`)}e.escapeIcons=C;const A=new RegExp(`\\\\${T.source}`,"g");function R(d){return d.replace(A,F=>`\\${F}`)}e.markdownEscapeEscapedIcons=R;const w=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function i(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(w,(F,_,m,f)=>m?F:_||f||"")}e.stripIcons=i;function p(d){const F=d.indexOf(e.iconStartMarker);return F===-1?{text:d}:o(d,F)}e.parseLabelWithIcons=p;function o(d,F){const _=[];let m="";function f(c){if(c){m+=c;for(const h of c)_.push(M)}}let D=-1,l="",M=0,r,n,b=F;const g=d.length;for(f(d.substr(0,F));b<g;)r=d[b],n=d[b+1],r===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(D=b,f(l),l=e.iconStartMarker,b++):r===")"&&D!==-1?(M+=b-D+1,D=-1,l=""):D!==-1?k.test(r)?l+=r:(f(l),D=-1,l=""):f(r),b++;return f(l),{text:m,iconOffsets:_}}function u(d,F,_=!1){const{text:m,iconOffsets:f}=F;if(!f||f.length===0)return(0,t.matchesFuzzy)(d,m,_);const D=(0,y.ltrim)(m," "),l=m.length-D.length,M=(0,t.matchesFuzzy)(d,D,_);if(M)for(const r of M){const n=f[r.start+l]+l;r.start+=n,r.end+=n}return M}e.matchesFuzzyIconAware=u}),define(ye[77],_e([0,1,15,103]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(p="",o=!1){if(this.value=p,typeof this.value!="string")throw(0,s.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(p,o=0){return this.value+=A(this.supportThemeIcons?(0,t.escapeIcons)(p):p).replace(/([ \t]+)/g,(u,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,o){return this.value+="\n```",this.value+=p,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=T;function k(i){return P(i)?!i.value:Array.isArray(i)?i.every(k):!0}e.isEmptyMarkdownString=k;function P(i){return i instanceof T?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function C(i,p){return i===p?!0:!i||!p?!1:i.value===p.value&&i.isTrusted===p.isTrusted&&i.supportThemeIcons===p.supportThemeIcons}e.markdownStringEqual=C;function A(i){return i.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function R(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function w(i){const p=[],o=i.split("|").map(d=>d.trim());i=o[0];const u=o[1];if(u){const d=/height=(\d+)/.exec(u),F=/width=(\d+)/.exec(u),_=d?d[1]:"",m=F?F[1]:"",f=isFinite(parseInt(m)),D=isFinite(parseInt(_));f&&p.push(`width="${m}"`),D&&p.push(`height="${_}"`)}return{href:i,dimensions:p}}e.parseHrefAndDimensions=w}),define(ye[34],_e([0,1,9]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(t||(t={})),function(y){const T="error",k="warning",P="warn",C="info",A="ignore";function R(i){return i?s.equalsIgnoreCase(T,i)?y.Error:s.equalsIgnoreCase(k,i)||s.equalsIgnoreCase(P,i)?y.Warning:s.equalsIgnoreCase(C,i)?y.Info:y.Ignore:y.Ignore}y.fromValue=R;function w(i){switch(i){case y.Error:return T;case y.Warning:return k;case y.Info:return C;default:return A}}y.toString=w}(t||(t={})),e.default=t}),define(ye[35],_e([0,1,17,23,9,10]),function(Z,e,s,t,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(b){return b===47||b===92}e.isPathSeparator=k;function P(b){return b.replace(/[\\/]/g,s.posix.sep)}e.toSlashes=P;function C(b){return b.indexOf("/")===-1&&(b=P(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}e.toPosixPath=C;function A(b,g=s.posix.sep){if(!b)return"";const c=b.length,h=b.charCodeAt(0);if(k(h)){if(k(b.charCodeAt(1))&&!k(b.charCodeAt(2))){let a=3;const S=a;for(;a<c&&!k(b.charCodeAt(a));a++);if(S!==a&&!k(b.charCodeAt(a+1))){for(a+=1;a<c;a++)if(k(b.charCodeAt(a)))return b.slice(0,a+1).replace(/[\\/]/g,g)}}return g}else if(F(h)&&b.charCodeAt(1)===58)return k(b.charCodeAt(2))?b.slice(0,2)+g:b.slice(0,2);let v=b.indexOf("://");if(v!==-1){for(v+=3;v<c;v++)if(k(b.charCodeAt(v)))return b.slice(0,v+1)}return""}e.getRoot=A;function R(b){if(!t.isWindows||!b||b.length<5)return!1;let g=b.charCodeAt(0);if(g!==92||(g=b.charCodeAt(1),g!==92))return!1;let c=2;const h=c;for(;c<b.length&&(g=b.charCodeAt(c),g!==92);c++);return!(h===c||(g=b.charCodeAt(c+1),isNaN(g)||g===92))}e.isUNC=R;const w=/[\\/:\*\?"<>\|]/g,i=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(b,g=t.isWindows){const c=g?w:i;return!(!b||b.length===0||/^\s+$/.test(b)||(c.lastIndex=0,c.test(b))||g&&p.test(b)||b==="."||b===".."||g&&b[b.length-1]==="."||g&&b.length!==b.trim().length||b.length>255)}e.isValidBasename=o;function u(b,g,c){const h=b===g;return!c||h?h:!b||!g?!1:(0,y.equalsIgnoreCase)(b,g)}e.isEqual=u;function d(b,g,c,h=s.sep){if(b===g)return!0;if(!b||!g||g.length>b.length)return!1;if(c){if(!(0,y.startsWithIgnoreCase)(b,g))return!1;if(g.length===b.length)return!0;let a=g.length;return g.charAt(g.length-1)===h&&a--,b.charAt(a)===h}return g.charAt(g.length-1)!==h&&(g+=h),b.indexOf(g)===0}e.isEqualOrParent=d;function F(b){return b>=65&&b<=90||b>=97&&b<=122}e.isWindowsDriveLetter=F;function _(b,g){return t.isWindows&&b.endsWith(":")&&(b+=s.sep),(0,s.isAbsolute)(b)||(b=(0,s.join)(g,b)),b=(0,s.normalize)(b),t.isWindows?(b=(0,y.rtrim)(b,s.sep),b.endsWith(":")&&(b+=s.sep)):(b=(0,y.rtrim)(b,s.sep),b||(b=s.sep)),b}e.sanitizeFilePath=_;function m(b){const g=(0,s.normalize)(b);return t.isWindows?b.length>3?!1:f(g)&&(b.length===2||g.charCodeAt(2)===92):g===s.posix.sep}e.isRootOrDriveLetter=m;function f(b,g){return(g!==void 0?g:t.isWindows)?F(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function D(b){return f(b)?b[0]:void 0}e.getDriveLetter=D;function l(b,g,c){return g.length>b.length?-1:b===g?0:(c&&(b=b.toLowerCase(),g=g.toLowerCase()),b.indexOf(g))}e.indexOfPath=l;function M(b){const g=b.split(":");let c,h,v;for(const a of g){const S=Number(a);(0,T.isNumber)(S)?h===void 0?h=S:v===void 0&&(v=S):c=c?[c,a].join(":"):a}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:h!==void 0?h:void 0,column:v!==void 0?v:h!==void 0?1:void 0}}e.parseLineAndColumnAware=M;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(b,g,c=8){let h="";for(let a=0;a<c;a++)h+=r.charAt(Math.floor(Math.random()*r.length));let v;return g?v=`${g}-${h}`:v=h,b?(0,s.join)(b,v):v}e.randomPath=n}),define(ye[55],_e([0,1,22,9,2]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(R){return JSON.stringify(R,C)}e.stringify=T;function k(R){let w=JSON.parse(R);return w=A(w),w}e.parse=k;var P;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function C(R,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,t.regExpFlags)(w)}:w}function A(R,w=0){if(!R||w>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return y.URI.revive(R);case 2:return new RegExp(R.source,R.flags)}if(R instanceof s.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let i=0;i<R.length;++i)R[i]=A(R[i],w+1);else for(const i in R)Object.hasOwnProperty.call(R,i)&&(R[i]=A(R[i],w+1))}return R}e.revive=A}),define(ye[11],_e([0,1,23,2]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var y;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(y=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,A,R){this._hosts[C]=A,this._ports[C]=R}setConnectionToken(C,A){this._connectionTokens[C]=A}rewrite(C){if(this._delegate)return this._delegate(C);const A=C.authority;let R=this._hosts[A];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const w=this._ports[A],i=this._connectionTokens[A];let p=`path=${encodeURIComponent(C.path)}`;return typeof i=="string"&&(p+=`&tkn=${encodeURIComponent(i)}`),t.URI.from({scheme:s.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${R}:${w}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new T;class k{asBrowserUri(C,A){const R=this.toUri(C,A);return R.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===y.file&&(s.isNative||typeof s.globals.importScripts=="function"&&s.globals.origin===`${y.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?R.with({scheme:y.vscodeFileResource,authority:R.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(C,A){const R=this.toUri(C,A);return R.scheme===y.vscodeFileResource?R.with({scheme:y.file,authority:R.authority!==k.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(C,A){return t.URI.isUri(C)?C:t.URI.parse(A.toUrl(C))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(ye[24],_e([0,1,35,11,17,23,9,2]),function(Z,e,s,t,y,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(p){return(0,P.uriToFsPath)(p,!0)}e.originalFSPath=C;class A{constructor(o){this._ignorePathCasing=o}compare(o,u,d=!1){return o===u?0:(0,k.compare)(this.getComparisonKey(o,d),this.getComparisonKey(u,d))}isEqual(o,u,d=!1){return o===u?!0:!o||!u?!1:this.getComparisonKey(o,d)===this.getComparisonKey(u,d)}getComparisonKey(o,u=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,u,d=!1){if(o.scheme===u.scheme){if(o.scheme===t.Schemas.file)return s.isEqualOrParent(C(o),C(u),this._ignorePathCasing(o))&&o.query===u.query&&(d||o.fragment===u.fragment);if((0,e.isEqualAuthority)(o.authority,u.authority))return s.isEqualOrParent(o.path,u.path,this._ignorePathCasing(o),"/")&&o.query===u.query&&(d||o.fragment===u.fragment)}return!1}joinPath(o,...u){return P.URI.joinPath(o,...u)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return y.posix.basename(o.path)}extname(o){return y.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let u;return o.scheme===t.Schemas.file?u=P.URI.file(y.dirname(C(o))).path:(u=y.posix.dirname(o.path),o.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),u="/")),o.with({path:u})}normalizePath(o){if(!o.path.length)return o;let u;return o.scheme===t.Schemas.file?u=P.URI.file(y.normalize(C(o))).path:u=y.posix.normalize(o.path),o.with({path:u})}relativePath(o,u){if(o.scheme!==u.scheme||!(0,e.isEqualAuthority)(o.authority,u.authority))return;if(o.scheme===t.Schemas.file){const _=y.relative(C(o),C(u));return T.isWindows?s.toSlashes(_):_}let d=o.path||"/",F=u.path||"/";if(this._ignorePathCasing(o)){let _=0;for(const m=Math.min(d.length,F.length);_<m&&!(d.charCodeAt(_)!==F.charCodeAt(_)&&d.charAt(_).toLowerCase()!==F.charAt(_).toLowerCase());_++);d=F.substr(0,_)+d.substr(_)}return y.posix.relative(d,F)}resolvePath(o,u){if(o.scheme===t.Schemas.file){const d=P.URI.file(y.resolve(C(o),u));return o.with({authority:d.authority,path:d.path})}return u=s.toPosixPath(u),o.with({path:y.posix.resolve(o.path,u)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,u){return o===u||o!==void 0&&u!==void 0&&(0,k.equalsIgnoreCase)(o,u)}hasTrailingPathSeparator(o,u=y.sep){if(o.scheme===t.Schemas.file){const d=C(o);return d.length>s.getRoot(d).length&&d[d.length-1]===u}else{const d=o.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,u=y.sep){return(0,e.hasTrailingPathSeparator)(o,u)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,u=y.sep){let d=!1;if(o.scheme===t.Schemas.file){const F=C(o);d=F!==void 0&&F.length===s.getRoot(F).length&&F[F.length-1]===u}else{u="/";const F=o.path;d=F.length===1&&F.charCodeAt(F.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(o,u)?o.with({path:o.path+"/"}):o}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(p=>p.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new A(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(p,o){const u=[];for(let d=0;d<p.length;d++){const F=o(p[d]);p.some((_,m)=>m===d?!1:(0,e.isEqualOrParent)(F,o(_)))||u.push(p[d])}return u}e.distinctParents=R;var w;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function o(u){const d=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(m=>{const[f,D]=m.split(":");f&&D&&d.set(f,D)});const _=u.path.substring(0,u.path.indexOf(";"));return _&&d.set(p.META_DATA_MIME,_),d}p.parseMetaData=o})(w=e.DataUri||(e.DataUri={}));function i(p,o,u){if(o){let d=p.path;return d&&d[0]!==y.posix.sep&&(d=y.posix.sep+d),p.with({scheme:u,authority:o,path:d})}return p.with({scheme:u})}e.toLocalResource=i}),define(ye[14],_e([0,1,20,15,4,6,24,23]),function(Z,e,s,t,y,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(ae){return!!ae&&typeof ae.then=="function"}e.isThenable=C;function A(ae){const le=new s.CancellationTokenSource,Ce=ae(le.token),Ee=new Promise((Fe,$e)=>{const Ve=le.token.onCancellationRequested(()=>{Ve.dispose(),le.dispose(),$e((0,t.canceled)())});Promise.resolve(Ce).then(je=>{Ve.dispose(),le.dispose(),Fe(je)},je=>{Ve.dispose(),le.dispose(),$e(je)})});return new class{cancel(){le.cancel()}then(Fe,$e){return Ee.then(Fe,$e)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Ee.finally(Fe)}}}e.createCancelablePromise=A;function R(ae,le,Ce){return Promise.race([ae,new Promise(Ee=>le.onCancellationRequested(()=>Ee(Ce)))])}e.raceCancellation=R;async function w(ae){let le=-1;const Ce=ae.map((Fe,$e)=>Fe.then(Ve=>(le=$e,Ve))),Ee=await Promise.race(Ce);return ae.forEach((Fe,$e)=>{$e!==le&&Fe.cancel()}),Ee}e.raceCancellablePromises=w;function i(ae,le,Ce){let Ee;const Fe=setTimeout(()=>{Ee?.(void 0),Ce?.()},le);return Promise.race([ae.finally(()=>clearTimeout(Fe)),new Promise($e=>Ee=$e)])}e.raceTimeout=i;function p(ae){return new Promise((le,Ce)=>{const Ee=ae();C(Ee)?Ee.then(le,Ce):le(Ee)})}e.asPromise=p;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(le){if(this.activePromise){if(this.queuedPromiseFactory=le,!this.queuedPromise){const Ce=()=>{this.queuedPromise=null;const Ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ee};this.queuedPromise=new Promise(Ee=>{this.activePromise.then(Ce,Ce).then(Ee)})}return new Promise((Ce,Ee)=>{this.queuedPromise.then(Ce,Ee)})}return this.activePromise=le(),new Promise((Ce,Ee)=>{this.activePromise.then(Fe=>{this.activePromise=null,Ce(Fe)},Fe=>{this.activePromise=null,Ee(Fe)})})}}e.Throttler=o;class u{constructor(){this.current=Promise.resolve(null)}queue(le){return this.current=this.current.then(()=>le(),()=>le())}}e.Sequencer=u;class d{constructor(){this.promiseMap=new Map}queue(le,Ce){const Fe=(this.promiseMap.get(le)??Promise.resolve()).catch(()=>{}).then(Ce).finally(()=>{this.promiseMap.get(le)===Fe&&this.promiseMap.delete(le)});return this.promiseMap.set(le,Fe),Fe}}e.SequencerByKey=d;const F=(ae,le)=>{let Ce=!0;const Ee=setTimeout(()=>{Ce=!1,le()},ae);return{isTriggered:()=>Ce,dispose:()=>{clearTimeout(Ee),Ce=!1}}},_=ae=>{let le=!0;return queueMicrotask(()=>{le&&(le=!1,ae())}),{isTriggered:()=>le,dispose:()=>{le=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class m{constructor(le){this.defaultDelay=le,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(le,Ce=this.defaultDelay){this.task=le,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,$e)=>{this.doResolve=Fe,this.doReject=$e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Ee=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Ce===e.MicrotaskDelay?_(Ee):F(Ce,Ee),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,t.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=m;class f{constructor(le){this.delayer=new m(le),this.throttler=new o}trigger(le,Ce){return this.delayer.trigger(()=>this.throttler.queue(le),Ce)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=f;class D{constructor(){this._isOpen=!1,this._promise=new Promise((le,Ce)=>{this._completePromise=le})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=D;class l extends D{constructor(le){super();this._timeout=setTimeout(()=>this.open(),le)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function M(ae,le){return le?new Promise((Ce,Ee)=>{const Fe=setTimeout(()=>{$e.dispose(),Ce()},ae),$e=le.onCancellationRequested(()=>{clearTimeout(Fe),$e.dispose(),Ee((0,t.canceled)())})}):A(Ce=>M(ae,Ce))}e.timeout=M;function r(ae,le=0){const Ce=setTimeout(ae,le);return(0,T.toDisposable)(()=>clearTimeout(Ce))}e.disposableTimeout=r;function n(ae){const le=[];let Ce=0;const Ee=ae.length;function Fe(){return Ce<Ee?ae[Ce++]():null}function $e(Ve){Ve!=null&&le.push(Ve);const je=Fe();return je?je.then($e):Promise.resolve(le)}return Promise.resolve(null).then($e)}e.sequence=n;function b(ae,le=Ee=>!!Ee,Ce=null){let Ee=0;const Fe=ae.length,$e=()=>{if(Ee>=Fe)return Promise.resolve(Ce);const Ve=ae[Ee++];return Promise.resolve(Ve()).then(H=>le(H)?Promise.resolve(H):$e())};return $e()}e.first=b;function g(ae,le=Ee=>!!Ee,Ce=null){if(ae.length===0)return Promise.resolve(Ce);let Ee=ae.length;const Fe=()=>{Ee=-1;for(const $e of ae)$e.cancel?.()};return new Promise(($e,Ve)=>{for(const je of ae)je.then(H=>{--Ee>=0&&le(H)?(Fe(),$e(H)):Ee===0&&$e(Ce)}).catch(H=>{--Ee>=0&&(Fe(),Ve(H))})})}e.firstParallel=g;class c{constructor(le){this._size=0,this.maxDegreeOfParalellism=le,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new y.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(le){return this._size++,new Promise((Ce,Ee)=>{this.outstandingPromises.push({factory:le,c:Ce,e:Ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const le=this.outstandingPromises.shift();this.runningPromises++;const Ce=le.factory();Ce.then(le.c,le.e),Ce.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class h extends c{constructor(){super(1)}}e.Queue=h;class v{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const le=new V;return this.drainers.add(le),le.p}isDrained(){for(const[,le]of this.queues)if(le.size>0)return!1;return!0}queueFor(le,Ce=k.extUri){const Ee=Ce.getComparisonKey(le);let Fe=this.queues.get(Ee);return Fe||(Fe=new h,y.Event.once(Fe.onFinished)(()=>{Fe?.dispose(),this.queues.delete(Ee),this.onDidQueueFinish()}),this.queues.set(Ee,Fe)),Fe}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const le of this.drainers)le.complete();this.drainers.clear()}dispose(){for(const[,le]of this.queues)le.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=v;class a{constructor(le,Ce){this._token=-1,typeof le=="function"&&typeof Ce=="number"&&this.setIfNotSet(le,Ce)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(le,Ce){this.cancel(),this._token=setTimeout(()=>{this._token=-1,le()},Ce)}setIfNotSet(le,Ce){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,le()},Ce))}}e.TimeoutTimer=a;class S{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(le,Ce){this.cancel(),this._token=setInterval(()=>{le()},Ce)}}e.IntervalTimer=S;class I{constructor(le,Ce){this.timeoutToken=-1,this.runner=le,this.timeout=Ce,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(le=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,le)}get delay(){return this.timeout}set delay(le){this.timeout=le}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=I;class N{constructor(le,Ce){Ce%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Ce}ms is not a multiple of 1000ms.`),this.runner=le,this.timeout=Ce,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(le=this.timeout){le%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(le/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class B extends I{constructor(le,Ce){super(le,Ce);this.units=[]}work(le){this.units.push(le),this.isScheduled()||this.schedule()}doRun(){const le=this.units;this.units=[],this.runner&&this.runner(le)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B;class E extends T.Disposable{constructor(le,Ce,Ee,Fe){super();this.maxWorkChunkSize=le,this.maxPendingWork=Ce,this.throttleDelay=Ee,this.handler=Fe,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(le){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+le.length>this.maxPendingWork)return!1}else if(this.pending+le.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...le),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new I(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=E,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ae=>{(0,P.setTimeout0)(()=>{if(le)return;const Ce=Date.now()+15;ae(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Ce-Date.now())}}))});let le=!1;return{dispose(){le||(le=!0)}}}:e.runWhenIdle=(ae,le)=>{const Ce=requestIdleCallback(ae,typeof le=="number"?{timeout:le}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(Ce))}}}}();class O{constructor(le){this._didRun=!1,this._executor=()=>{try{this._value=le()}catch(Ce){this._error=Ce}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function z(ae,le,Ce){let Ee;for(let Fe=0;Fe<Ce;Fe++)try{return await ae()}catch($e){Ee=$e,await M(le)}throw Ee}e.retry=z;class U{hasPending(le){return this._pending?typeof le=="number"?this._pending.taskId===le:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(le,Ce,Ee){return this._pending={taskId:le,cancel:()=>Ee?.(),promise:Ce},Ce.then(()=>this.donePending(le),()=>this.donePending(le)),Ce}donePending(le){this._pending&&le===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const le=this._next;this._next=void 0,le.run().then(le.promiseResolve,le.promiseReject)}}setNext(le){if(this._next)this._next.run=le;else{let Ce,Ee;const Fe=new Promise(($e,Ve)=>{Ce=$e,Ee=Ve});this._next={run:le,promise:Fe,promiseResolve:Ce,promiseReject:Ee}}return this._next.promise}}e.TaskSequentializer=U;class ${constructor(le,Ce=()=>Date.now()){this.interval=le,this.nowFn=Ce,this.lastIncrementTime=0,this.value=0}increment(){const le=this.nowFn();return le-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=le,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((le,Ce)=>{this.completeCallback=le,this.errorCallback=Ce})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(le){return new Promise(Ce=>{this.completeCallback(le),this.resolved=!0,Ce()})}error(le){return new Promise(Ce=>{this.errorCallback(le),this.rejected=!0,Ce()})}cancel(){new Promise(le=>{this.errorCallback((0,t.canceled)()),this.rejected=!0,le()})}}e.DeferredPromise=V;var ue;(function(ae){async function le(Ee){let Fe;const $e=await Promise.all(Ee.map(Ve=>Ve.then(je=>je,je=>{Fe||(Fe=je)})));if(typeof Fe!="undefined")throw Fe;return $e}ae.settled=le;function Ce(Ee){return new Promise(async(Fe,$e)=>{try{await Ee(Fe,$e)}catch(Ve){$e(Ve)}})}ae.withAsyncBody=Ce})(ue=e.Promises||(e.Promises={}));var K;(function(ae){ae[ae.Initial=0]="Initial",ae[ae.DoneOK=1]="DoneOK",ae[ae.DoneError=2]="DoneError"})(K||(K={}));class re{constructor(le){this._state=0,this._results=[],this._error=null,this._onStateChanged=new y.Emitter,queueMicrotask(async()=>{const Ce={emitOne:Ee=>this.emitOne(Ee),emitMany:Ee=>this.emitMany(Ee),reject:Ee=>this.reject(Ee)};try{await Promise.resolve(le(Ce)),this.resolve()}catch(Ee){this.reject(Ee)}finally{Ce.emitOne=void 0,Ce.emitMany=void 0,Ce.reject=void 0}})}static fromArray(le){return new re(Ce=>{Ce.emitMany(le)})}static fromPromise(le){return new re(async Ce=>{Ce.emitMany(await le)})}static fromPromises(le){return new re(async Ce=>{await Promise.all(le.map(async Ee=>Ce.emitOne(await Ee)))})}static merge(le){return new re(async Ce=>{await Promise.all(le.map(async Ee=>{for await(const Fe of Ee)Ce.emitOne(Fe)}))})}[Symbol.asyncIterator](){let le=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(le<this._results.length)return{done:!1,value:this._results[le++]};if(this._state===1)return{done:!0,value:void 0};await y.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(le,Ce){return new re(async Ee=>{for await(const Fe of le)Ee.emitOne(Ce(Fe))})}map(le){return re.map(this,le)}static filter(le,Ce){return new re(async Ee=>{for await(const Fe of le)Ce(Fe)&&Ee.emitOne(Fe)})}filter(le){return re.filter(this,le)}static coalesce(le){return re.filter(le,Ce=>!!Ce)}coalesce(){return re.coalesce(this)}static async toPromise(le){const Ce=[];for await(const Ee of le)Ce.push(Ee);return Ce}toPromise(){return re.toPromise(this)}emitOne(le){this._state===0&&(this._results.push(le),this._onStateChanged.fire())}emitMany(le){this._state===0&&(this._results=this._results.concat(le),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(le){this._state===0&&(this._state=2,this._error=le,this._onStateChanged.fire())}}e.AsyncIterableObject=re,re.EMPTY=re.fromArray([]);class pe extends re{constructor(le,Ce){super(Ce);this._source=le}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=pe;function we(ae){const le=new s.CancellationTokenSource,Ce=ae(le.token);return new pe(le,async Ee=>{const Fe=le.token.onCancellationRequested(()=>{Fe.dispose(),le.dispose(),Ee.reject((0,t.canceled)())});try{for await(const $e of Ce){if(le.token.isCancellationRequested)return;Ee.emitOne($e)}Fe.dispose(),le.dispose()}catch($e){Fe.dispose(),le.dispose(),Ee.reject($e)}})}e.createCancelableAsyncIterable=we}),define(ye[104],_e([0,1,14,17]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new s.IdleValue(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),T=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(v,a,S=!1){const I=v||"",N=a||"",B=y.value.collator.compare(I,N);return y.value.collatorIsNumeric&&B===0&&I!==N?I<N?-1:1:B}e.compareFileNames=P;function C(v,a){const S=T.value.collator;return v=v||"",a=a||"",D(S,v,a)}e.compareFileNamesDefault=C;function A(v,a){const S=T.value.collator;return v=v||"",a=a||"",n(v,a)||D(S,v,a)}e.compareFileNamesUpper=A;function R(v,a){const S=T.value.collator;return v=v||"",a=a||"",r(v,a)||D(S,v,a)}e.compareFileNamesLower=R;function w(v,a){return v=v||"",a=a||"",v===a?0:v<a?-1:1}e.compareFileNamesUnicode=w;function i(v,a,S=!1){S||(v=v&&v.toLowerCase(),a=a&&a.toLowerCase());const[I,N]=m(v),[B,E]=m(a);return I!==B?I<B?-1:1:N===E?0:N<E?-1:1}e.noIntlCompareFileNames=i;function p(v,a){const[S,I]=m(v),[N,B]=m(a);let E=y.value.collator.compare(I,B);if(E===0){if(y.value.collatorIsNumeric&&I!==B)return I<B?-1:1;if(E=y.value.collator.compare(S,N),y.value.collatorIsNumeric&&E===0&&S!==N)return S<N?-1:1}return E}e.compareFileExtensions=p;function o(v,a){v=v||"",a=a||"";const S=f(v),I=f(a),N=T.value.collator,B=k.value.collator;return D(B,S,I)||D(N,v,a)}e.compareFileExtensionsDefault=o;function u(v,a){v=v||"",a=a||"";const S=f(v),I=f(a),N=T.value.collator,B=k.value.collator;return D(B,S,I)||n(v,a)||D(N,v,a)}e.compareFileExtensionsUpper=u;function d(v,a){v=v||"",a=a||"";const S=f(v),I=f(a),N=T.value.collator,B=k.value.collator;return D(B,S,I)||r(v,a)||D(N,v,a)}e.compareFileExtensionsLower=d;function F(v,a){v=v||"",a=a||"";const S=f(v).toLowerCase(),I=f(a).toLowerCase();return S!==I?S<I?-1:1:v!==a?v<a?-1:1:0}e.compareFileExtensionsUnicode=F;const _=/^(.*?)(\.([^.]*))?$/;function m(v,a=!1){const S=v?_.exec(v):[];let I=[S&&S[1]||"",S&&S[3]||""];return a&&(!I[0]&&I[1]||I[0]&&I[0].charAt(0)===".")&&(I=[I[0]+"."+I[1],""]),I}function f(v){const a=v?_.exec(v):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function D(v,a,S){let I=v.compare(a,S);return I!==0?I:a.length!==S.length?a.length<S.length?-1:1:0}function l(v){const a=v.charAt(0);return a.toLocaleUpperCase()!==a}function M(v){const a=v.charAt(0);return a.toLocaleLowerCase()!==a}function r(v,a){return l(v)&&M(a)?-1:M(v)&&l(a)?1:0}function n(v,a){return M(v)&&l(a)?-1:l(v)&&M(a)?1:0}function b(v,a,S=!1){return S||(v=v&&v.toLowerCase(),a=a&&a.toLowerCase()),v===a?0:v<a?-1:1}function g(v,a,S=!1){const I=v.split(t.sep),N=a.split(t.sep),B=I.length-1,E=N.length-1;let O,z;for(let U=0;;U++){if(O=B===U,z=E===U,O&&z)return P(I[U],N[U],S);if(O)return-1;if(z)return 1;const $=b(I[U],N[U],S);if($!==0)return $}}e.comparePaths=g;function c(v,a,S){const I=v.toLowerCase(),N=a.toLowerCase(),B=h(v,a,S);if(B)return B;const E=I.endsWith(S),O=N.endsWith(S);if(E!==O)return E?-1:1;const z=P(I,N);return z!==0?z:I.localeCompare(N)}e.compareAnything=c;function h(v,a,S){const I=v.toLowerCase(),N=a.toLowerCase(),B=I.startsWith(S),E=N.startsWith(S);if(B!==E)return B?-1:1;if(B&&E){if(I.length<N.length)return-1;if(I.length>N.length)return 1}return 0}e.compareByPrefix=h}),define(ye[29],_e([0,1,14,35,21,17,9]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const C="**",A="/",R="[/\\\\]",w="[^/\\\\]",i=/\//g;function p(K){switch(K){case 0:return"";case 1:return`${w}*?`;default:return`(?:${R}|${w}+${R}|${R}${w}+)*?`}}function o(K,re){if(!K)return[];const pe=[];let we=!1,ae=!1,le="";for(const Ce of K){switch(Ce){case re:if(!we&&!ae){pe.push(le),le="";continue}break;case"{":we=!0;break;case"}":we=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}le+=Ce}return le&&pe.push(le),pe}e.splitGlobAware=o;function u(K){if(!K)return"";let re="";const pe=o(K,A);if(pe.every(we=>we===C))re=".*";else{let we=!1;pe.forEach((ae,le)=>{if(ae===C){we||(re+=p(2),we=!0);return}let Ce=!1,Ee="",Fe=!1,$e="";for(const Ve of ae){if(Ve!=="}"&&Ce){Ee+=Ve;continue}if(Fe&&(Ve!=="]"||!$e)){let je;Ve==="-"?je=Ve:(Ve==="^"||Ve==="!")&&!$e?je="^":Ve===A?je="":je=k.escapeRegExpCharacters(Ve),$e+=je;continue}switch(Ve){case"{":Ce=!0;continue;case"[":Fe=!0;continue;case"}":{re+=`(?:${o(Ee,",").map(G=>u(G)).join("|")})`,Ce=!1,Ee="";break}case"]":re+="["+$e+"]",Fe=!1,$e="";break;case"?":re+=w;continue;case"*":re+=p(1);continue;default:re+=k.escapeRegExpCharacters(Ve)}}le<pe.length-1&&(pe[le+1]!==C||le+2<pe.length)&&(re+=R),we=!1})}return re}const d=/^\*\*\/\*\.[\w\.-]+$/,F=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new y.LRUCache(1e4),M=function(){return!1},r=function(){return null};function n(K,re){if(!K)return r;let pe;typeof K!="string"?pe=K.pattern:pe=K,pe=pe.trim();const we=`${pe}_${!!re.trimForExclusions}`;let ae=l.get(we);if(ae)return b(ae,K);let le;if(d.test(pe)){const Ce=pe.substr(4);ae=function(Ee,Fe){return typeof Ee=="string"&&Ee.endsWith(Ce)?pe:null}}else(le=F.exec(g(pe,re)))?ae=c(le[1],pe):(re.trimForExclusions?m:_).test(pe)?ae=h(pe,re):(le=f.exec(g(pe,re)))?ae=v(le[1].substr(1),pe,!0):(le=D.exec(g(pe,re)))?ae=v(le[1],pe,!1):ae=a(pe);return l.set(we,ae),b(ae,K)}function b(K,re){return typeof re=="string"?K:function(pe,we){return t.isEqualOrParent(pe,re.base)?K(T.relative(re.base,pe),we):null}}function g(K,re){return re.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function c(K,re){const pe=`/${K}`,we=`\\${K}`,ae=function(Ce,Ee){return typeof Ce!="string"?null:Ee?Ee===K?re:null:Ce===K||Ce.endsWith(pe)||Ce.endsWith(we)?re:null},le=[K];return ae.basenames=le,ae.patterns=[re],ae.allBasenames=le,ae}function h(K,re){const pe=ue(K.slice(1,-1).split(",").map(Ee=>n(Ee,re)).filter(Ee=>Ee!==r),K),we=pe.length;if(!we)return r;if(we===1)return pe[0];const ae=function(Ee,Fe){for(let $e=0,Ve=pe.length;$e<Ve;$e++)if(pe[$e](Ee,Fe))return K;return null},le=pe.find(Ee=>!!Ee.allBasenames);le&&(ae.allBasenames=le.allBasenames);const Ce=pe.reduce((Ee,Fe)=>Fe.allPaths?Ee.concat(Fe.allPaths):Ee,[]);return Ce.length&&(ae.allPaths=Ce),ae}function v(K,re,pe){const we=T.sep===T.posix.sep,ae=we?K:K.replace(i,T.sep),le=T.sep+ae,Ce=T.posix.sep+K,Ee=pe?function(Fe,$e){return typeof Fe=="string"&&(Fe===ae||Fe.endsWith(le)||!we&&(Fe===K||Fe.endsWith(Ce)))?re:null}:function(Fe,$e){return typeof Fe=="string"&&(Fe===ae||!we&&Fe===K)?re:null};return Ee.allPaths=[(pe?"*/":"./")+K],Ee}function a(K){try{const re=new RegExp(`^${u(K)}$`);return function(pe){return re.lastIndex=0,typeof pe=="string"&&re.test(pe)?K:null}}catch{return r}}function S(K,re,pe){return!K||typeof re!="string"?!1:I(K)(re,void 0,pe)}e.match=S;function I(K,re={}){if(!K)return M;if(typeof K=="string"||O(K)){const pe=n(K,re);if(pe===r)return M;const we=function(ae,le){return!!pe(ae,le)};return pe.allBasenames&&(we.allBasenames=pe.allBasenames),pe.allPaths&&(we.allPaths=pe.allPaths),we}return $(K,re)}e.parse=I;function N(K){if(!K)return;let re;return pe=>(re||(re=(K()||Promise.resolve([])).then(we=>we?E(we):{})),re.then(we=>!!we[pe]))}e.hasSiblingPromiseFn=N;function B(K){if(!K)return;let re;return pe=>{if(!re){const we=K();re=we?E(we):{}}return!!re[pe]}}e.hasSiblingFn=B;function E(K){const re={};for(const pe of K)re[pe]=!0;return re}function O(K){const re=K;return re&&typeof re.base=="string"&&typeof re.pattern=="string"}e.isRelativePattern=O;function z(K){return K.allBasenames||[]}e.getBasenameTerms=z;function U(K){return K.allPaths||[]}e.getPathTerms=U;function $(K,re){const pe=ue(Object.getOwnPropertyNames(K).map(Ee=>V(Ee,K[Ee],re)).filter(Ee=>Ee!==r)),we=pe.length;if(!we)return r;if(!pe.some(Ee=>!!Ee.requiresSiblings)){if(we===1)return pe[0];const Ee=function(Ve,je){for(let H=0,G=pe.length;H<G;H++){const X=pe[H](Ve,je);if(X)return X}return null},Fe=pe.find(Ve=>!!Ve.allBasenames);Fe&&(Ee.allBasenames=Fe.allBasenames);const $e=pe.reduce((Ve,je)=>je.allPaths?Ve.concat(je.allPaths):Ve,[]);return $e.length&&(Ee.allPaths=$e),Ee}const ae=function(Ee,Fe,$e){let Ve;for(let je=0,H=pe.length;je<H;je++){const G=pe[je];G.requiresSiblings&&$e&&(Fe||(Fe=T.basename(Ee)),Ve||(Ve=Fe.substr(0,Fe.length-T.extname(Ee).length)));const X=G(Ee,Fe,Ve,$e);if(X)return X}return null},le=pe.find(Ee=>!!Ee.allBasenames);le&&(ae.allBasenames=le.allBasenames);const Ce=pe.reduce((Ee,Fe)=>Fe.allPaths?Ee.concat(Fe.allPaths):Ee,[]);return Ce.length&&(ae.allPaths=Ce),ae}function V(K,re,pe){if(re===!1)return r;const we=n(K,pe);if(we===r)return r;if(typeof re=="boolean")return we;if(re){const ae=re.when;if(typeof ae=="string"){const le=(Ce,Ee,Fe,$e)=>{if(!$e||!we(Ce,Ee))return null;const Ve=ae.replace("$(basename)",Fe),je=$e(Ve);return(0,s.isThenable)(je)?je.then(H=>H?K:null):je?K:null};return le.requiresSiblings=!0,le}}return we}function ue(K,re){const pe=K.filter(Ee=>!!Ee.basenames);if(pe.length<2)return K;const we=pe.reduce((Ee,Fe)=>{const $e=Fe.basenames;return $e?Ee.concat($e):Ee},[]);let ae;if(re){ae=[];for(let Ee=0,Fe=we.length;Ee<Fe;Ee++)ae.push(re)}else ae=pe.reduce((Ee,Fe)=>{const $e=Fe.patterns;return $e?Ee.concat($e):Ee},[]);const le=function(Ee,Fe){if(typeof Ee!="string")return null;if(!Fe){let Ve;for(Ve=Ee.length;Ve>0;Ve--){const je=Ee.charCodeAt(Ve-1);if(je===47||je===92)break}Fe=Ee.substr(Ve)}const $e=we.indexOf(Fe);return $e!==-1?ae[$e]:null};le.basenames=we,le.patterns=ae,le.allBasenames=we;const Ce=K.filter(Ee=>!Ee.basenames);return Ce.push(le),Ce}}),define(ye[78],_e([0,1,35,11,17,23,24,9,2]),function(Z,e,s,t,y,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(n,b,g){if(typeof n=="string"&&(n=C.URI.file(n)),g){const h=g.getWorkspaceFolder(n);if(h){const v=g.getWorkspace().folders.length>1;let a;if((0,k.isEqual)(h.uri,n)?a="":a=(0,k.relativePath)(h.uri,n),v){const S=h.name?h.name:(0,k.basename)(h.uri);a=a?S+" \u2022 "+a:S}return a}}if(n.scheme!==t.Schemas.file&&n.scheme!==t.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,s.hasDriveLetter)(n.fsPath))return(0,y.normalize)(w(n.fsPath));let c=(0,y.normalize)(n.fsPath);return!T.isWindows&&b?.userHome&&(c=p(c,b.userHome.fsPath)),c}e.getPathLabel=A;function R(n){if(!n)return;typeof n=="string"&&(n=C.URI.file(n));const b=(0,k.basename)(n)||(n.scheme===t.Schemas.file?n.fsPath:n.path);return T.isWindows&&(0,s.isRootOrDriveLetter)(b)?w(b):b}e.getBaseLabel=R;function w(n,b){return(0,s.hasDriveLetter)(n,b)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=w;let i=Object.create(null);function p(n,b){if(T.isWindows||!n||!b)return n;let g=i.original===b?i.normalized:void 0;return g||(g=`${(0,P.rtrim)(b,y.posix.sep)}${y.posix.sep}`,i={original:b,normalized:g}),(T.isLinux?n.startsWith(g):(0,P.startsWithIgnoreCase)(n,g))&&(n=`~/${n.substr(g.length)}`),n}e.tildify=p;function o(n,b){return n.replace(/^~($|\/|\\)/,`${b}$1`)}e.untildify=o;const u="\u2026",d="\\\\",F="~";function _(n,b=y.sep){const g=new Array(n.length);let c=!1;for(let h=0;h<n.length;h++){let v=n[h];if(v===""){g[h]=`.${b}`;continue}if(!v){g[h]=v;continue}c=!0;let a="";v.indexOf(d)===0?(a=v.substr(0,v.indexOf(d)+d.length),v=v.substr(v.indexOf(d)+d.length)):v.indexOf(b)===0?(a=v.substr(0,v.indexOf(b)+b.length),v=v.substr(v.indexOf(b)+b.length)):v.indexOf(F)===0&&(a=v.substr(0,v.indexOf(F)+F.length),v=v.substr(v.indexOf(F)+F.length));const S=v.split(b);for(let I=1;c&&I<=S.length;I++)for(let N=S.length-I;c&&N>=0;N--){c=!1;let B=S.slice(N,N+I).join(b);for(let E=0;!c&&E<n.length;E++)if(E!==h&&n[E]&&n[E].indexOf(B)>-1){const O=N+I===S.length,z=N>0&&n[E].indexOf(b)>-1?b+B:B,U=n[E].endsWith(z);c=!O||U}if(!c){let E="";(S[0].endsWith(":")||a!=="")&&(N===1&&(N=0,I++,B=S[0]+b+B),N>0&&(E=S[0]+b),E=a+E),N>0&&(E=E+u+b),E=E+B,N+I<S.length&&(E=E+b+u),g[h]=E}}c&&(g[h]=v)}return g}e.shorten=_;var m;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function f(n,b=Object.create(null)){const g=[];let c=!1,h="";for(const v of n)if(v==="$"||c&&v==="{")h&&g.push({value:h,type:m.TEXT}),h="",c=!0;else if(v==="}"&&c){const a=b[h];if(typeof a=="string")a.length&&g.push({value:a,type:m.VARIABLE});else if(a){const S=g[g.length-1];(!S||S.type!==m.SEPARATOR)&&g.push({value:a.label,type:m.SEPARATOR})}h="",c=!1}else h+=v;return h&&!c&&g.push({value:h,type:m.TEXT}),g.filter((v,a)=>{if(v.type===m.SEPARATOR){const S=g[a-1],I=g[a+1];return[S,I].every(N=>N&&(N.type===m.VARIABLE||N.type===m.TEXT)&&N.value.length>0)}return!0}).map(v=>v.value).join("")}e.template=f;function D(n,b){return T.isMacintosh||b?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):n.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function l(n,b){return T.isMacintosh||b?n.replace(/\(&&\w\)|&&/g,""):T.isWindows?n.replace(/&&|&/g,g=>g==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function M(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=M;function r(n){const b=n.indexOf("/")!==-1?y.posix:y.win32,g=b.basename(n),c=b.dirname(n);return g.length?{name:g,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(ye[105],_e([0,1,2]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class y{constructor(w){this._uriTransformer=w}transformIncoming(w){const i=this._uriTransformer.transformIncoming(w);return i===w?w:t(s.URI.from(i))}transformOutgoing(w){const i=this._uriTransformer.transformOutgoing(w);return i===w?w:t(s.URI.from(i))}transformOutgoingURI(w){const i=this._uriTransformer.transformOutgoing(w);return i===w?w:s.URI.from(i)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function T(R,w,i){if(!R||i>200)return null;if(typeof R=="object"){if(R instanceof s.URI)return w.transformOutgoing(R);for(let p in R)if(Object.hasOwnProperty.call(R,p)){const o=T(R[p],w,i+1);o!==null&&(R[p]=o)}}return null}function k(R,w){const i=T(R,w,0);return i===null?R:i}e.transformOutgoingURIs=k;function P(R,w,i,p){if(!R||p>200)return null;if(typeof R=="object"){if(R.$mid===1)return i?s.URI.revive(w.transformIncoming(R)):w.transformIncoming(R);for(let o in R)if(Object.hasOwnProperty.call(R,o)){const u=P(R[o],w,i,p+1);u!==null&&(R[o]=u)}}return null}function C(R,w){const i=P(R,w,!1,0);return i===null?R:i}e.transformIncomingURIs=C;function A(R,w){const i=P(R,w,!0,0);return i===null?R:i}e.transformAndReviveIncomingURIs=A}),define(ye[36],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return s.test(C)}e.isUUID=t;const y=new Uint8Array(16),T=[];for(let C=0;C<256;C++)T.push(C.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(C){for(let A=0;A<C.length;A++)C[A]=Math.floor(Math.random()*256);return C};function P(){k(y),y[6]=y[6]&15|64,y[8]=y[8]&63|128;let C=0,A="";return A+=T[y[C++]],A+=T[y[C++]],A+=T[y[C++]],A+=T[y[C++]],A+="-",A+=T[y[C++]],A+=T[y[C++]],A+="-",A+=T[y[C++]],A+=T[y[C++]],A+="-",A+=T[y[C++]],A+=T[y[C++]],A+="-",A+=T[y[C++]],A+=T[y[C++]],A+=T[y[C++]],A+=T[y[C++]],A+=T[y[C++]],A+=T[y[C++]],A}e.generateUuid=P}),define(ye[106],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var s;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(s=e.IndentAction||(e.IndentAction={}));class t{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let C=0,A=P.notIn.length;C<A;C++)switch(P.notIn[C]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,C){if(P.getTokenCount()===0)return!0;const A=P.findTokenIndexAtOffset(C-2),R=P.getStandardTokenType(A);return this.isOK(R)}_findNeutralCharacterInRange(P,C){for(let A=P;A<=C;A++){const R=String.fromCharCode(A);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class y{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of P)T(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),T(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),T(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),T(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&T(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=y;function T(k,P,C){k.has(P)?k.get(P).push(C):k.set(P,[C])}}),define(ye[56],_e([0,1,29,17]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(T,k,P,C){if(Array.isArray(T)){let A=0;for(const R of T){const w=y(R,k,P,C);if(w===10)return w;w>A&&(A=w)}return A}else{if(typeof T=="string")return C?T==="*"?5:T===P?10:0:0;if(T){const{language:A,pattern:R,scheme:w,hasAccessToAllModels:i}=T;if(!C&&!i)return 0;let p=0;if(w)if(w===k.scheme)p=10;else if(w==="*")p=5;else return 0;if(A)if(A===P)p=10;else if(A==="*")p=Math.max(p,5);else return 0;if(R){let o;if(typeof R=="string"?o=R:o={...R,base:(0,t.normalize)(R.base)},o===k.fsPath||(0,s.match)(o,k.fsPath))p=10;else return 0}return p}else return 0}}e.score=y}),define(ye[107],_e([0,1,4,6]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class y{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new s.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,C){return this._map.set(P,C),this.fire([P]),(0,t.toDisposable)(()=>{this._map.get(P)===C&&(this._map.delete(P),this.fire([P]))})}registerFactory(P,C){this._factories.get(P)?.dispose();const A=new T(this,P,C);return this._factories.set(P,A),(0,t.toDisposable)(()=>{const R=this._factories.get(P);!R||R!==A||(this._factories.delete(P),R.dispose())})}async getOrCreate(P){const C=this.get(P);if(C)return C;const A=this._factories.get(P);return!A||A.isResolved?null:(await A.resolve(),this.get(P))}get(P){return this._map.get(P)||null}isResolved(P){if(this.get(P))return!0;const A=this._factories.get(P);return!!(!A||A.isResolved)}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=y;class T extends t.Disposable{constructor(P,C,A){super();this._registry=P,this._languageId=C,this._factory=A,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const P=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,P&&!this._isDisposed&&this._register(this._registry.register(this._languageId,P))}}}),define(ye[79],_e([0,1,22,23]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(y||(y={}));function T(w){for(let i=0,p=w.length;i<p;i+=4){const o=w[i+0],u=w[i+1],d=w[i+2],F=w[i+3];w[i+0]=F,w[i+1]=d,w[i+2]=u,w[i+3]=o}}function k(w){const i=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return t.isLittleEndian()||T(i),s.VSBuffer.wrap(i)}function P(w){const i=w.buffer;if(t.isLittleEndian()||T(i),i.byteOffset%4==0)return new Uint32Array(i.buffer,i.byteOffset,i.length/4);{const p=new Uint8Array(i.byteLength);return p.set(i),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function C(w){const i=new Uint32Array(A(w));let p=0;if(i[p++]=w.id,w.type==="full")i[p++]=1,i[p++]=w.data.length,i.set(w.data,p),p+=w.data.length;else{i[p++]=2,i[p++]=w.deltas.length;for(const o of w.deltas)i[p++]=o.start,i[p++]=o.deleteCount,o.data?(i[p++]=o.data.length,i.set(o.data,p),p+=o.data.length):i[p++]=0}return k(i)}e.encodeSemanticTokensDto=C;function A(w){let i=0;if(i+=1+1,w.type==="full")i+=1+w.data.length;else{i+=1,i+=(1+1+1)*w.deltas.length;for(const p of w.deltas)p.data&&(i+=p.data.length)}return i}function R(w){const i=P(w);let p=0;const o=i[p++];if(i[p++]===1){const _=i[p++],m=i.subarray(p,p+_);return p+=_,{id:o,type:"full",data:m}}const d=i[p++],F=[];for(let _=0;_<d;_++){const m=i[p++],f=i[p++],D=i[p++];let l;D>0&&(l=i.subarray(p,p+D),p+=D),F[_]={start:m,deleteCount:f,data:l}}return{id:o,type:"delta",deltas:F}}e.decodeSemanticTokensDto=R}),define(ye[108],_e([18,19]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(ye[109],_e([0,1,108]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,y=t*60,T=y*24,k=T*7,P=T*30,C=T*365;function A(w,i){typeof w!="number"&&(w=w.getTime());const p=Math.round((new Date().getTime()-w)/1e3);if(p<-30)return(0,s.localize)(0,null,A(new Date().getTime()+p*1e3,!1));if(p<30)return(0,s.localize)(1,null);let o;return p<t?(o=p,i?o===1?(0,s.localize)(2,null,o):(0,s.localize)(3,null,o):o===1?(0,s.localize)(4,null,o):(0,s.localize)(5,null,o)):p<y?(o=Math.floor(p/t),i?o===1?(0,s.localize)(6,null,o):(0,s.localize)(7,null,o):o===1?(0,s.localize)(8,null,o):(0,s.localize)(9,null,o)):p<T?(o=Math.floor(p/y),i?o===1?(0,s.localize)(10,null,o):(0,s.localize)(11,null,o):o===1?(0,s.localize)(12,null,o):(0,s.localize)(13,null,o)):p<k?(o=Math.floor(p/T),i?o===1?(0,s.localize)(14,null,o):(0,s.localize)(15,null,o):o===1?(0,s.localize)(16,null,o):(0,s.localize)(17,null,o)):p<P?(o=Math.floor(p/k),i?o===1?(0,s.localize)(18,null,o):(0,s.localize)(19,null,o):o===1?(0,s.localize)(20,null,o):(0,s.localize)(21,null,o)):p<C?(o=Math.floor(p/P),i?o===1?(0,s.localize)(22,null,o):(0,s.localize)(23,null,o):o===1?(0,s.localize)(24,null,o):(0,s.localize)(25,null,o)):(o=Math.floor(p/C),i?o===1?(0,s.localize)(26,null,o):(0,s.localize)(27,null,o):o===1?(0,s.localize)(28,null,o):(0,s.localize)(29,null,o))}e.fromNow=A;function R(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ye[110],_e([18,19]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(ye[43],_e([0,1,16,10,110]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(A,R){return R&&(A.stack||A.stacktrace)?y.localize(0,null,P(A),k(A.stack)||k(A.stacktrace)):P(A)}function k(A){return Array.isArray(A)?A.join(`
`):A}function P(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?y.localize(1,null,A.message):A.message||y.localize(2,null)}function C(A=null,R=!1){if(!A)return y.localize(3,null);if(Array.isArray(A)){const w=s.coalesce(A),i=C(w[0],R);return w.length>1?y.localize(4,null,i,w.length):i}if(t.isString(A))return A;if(A.detail){const w=A.detail;if(w.error)return T(w.error,R);if(w.exception)return T(w.exception,R)}return A.stack?T(A,R):A.message?A.message:y.localize(5,null)}e.toErrorMessage=C}),define(ye[111],_e([18,19]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(ye[112],_e([0,1,111,23,113,16,26]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=C;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class R{constructor(Q,fe,Ne,qe){this.id=Q,this.name=fe,this.defaultValue=Ne,this.schema=qe}applyUpdate(Q,fe){return i(Q,fe)}compute(Q,fe,Ne){return Ne}}class w{constructor(Q,fe){this.newValue=Q,this.didChange=fe}}e.ApplyUpdateResult=w;function i(j,Q){if(typeof j!="object"||typeof Q!="object"||!j||!Q)return new w(Q,j!==Q);if(Array.isArray(j)||Array.isArray(Q)){const Ne=Array.isArray(j)&&Array.isArray(Q)&&T.equals(j,Q);return new w(Q,Ne)}let fe=!1;for(const Ne in Q)if(Q.hasOwnProperty(Ne)){const qe=i(j[Ne],Q[Ne]);qe.didChange&&(j[Ne]=qe.newValue,fe=!0)}return new w(j,fe)}class p{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,fe){return i(Q,fe)}validate(Q){return this.defaultValue}}class o{constructor(Q,fe,Ne,qe){this.id=Q,this.name=fe,this.defaultValue=Ne,this.schema=qe}applyUpdate(Q,fe){return i(Q,fe)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,fe,Ne){return Ne}}function u(j,Q){return typeof j=="undefined"?Q:j==="false"?!1:Boolean(j)}e.boolean=u;class d extends o{constructor(Q,fe,Ne,qe=void 0){typeof qe!="undefined"&&(qe.type="boolean",qe.default=Ne);super(Q,fe,Ne,qe)}validate(Q){return u(Q,this.defaultValue)}}function F(j,Q,fe,Ne){if(typeof j=="undefined")return Q;let qe=parseInt(j,10);return isNaN(qe)?Q:(qe=Math.max(fe,qe),qe=Math.min(Ne,qe),qe|0)}e.clampedInt=F;class _ extends o{constructor(Q,fe,Ne,qe,ot,ht=void 0){typeof ht!="undefined"&&(ht.type="integer",ht.default=Ne,ht.minimum=qe,ht.maximum=ot);super(Q,fe,Ne,ht);this.minimum=qe,this.maximum=ot}static clampedInt(Q,fe,Ne,qe){return F(Q,fe,Ne,qe)}validate(Q){return _.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class m extends o{constructor(Q,fe,Ne,qe,ot){typeof ot!="undefined"&&(ot.type="number",ot.default=Ne);super(Q,fe,Ne,ot);this.validationFn=qe}static clamp(Q,fe,Ne){return Q<fe?fe:Q>Ne?Ne:Q}static float(Q,fe){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return fe;const Ne=parseFloat(Q);return isNaN(Ne)?fe:Ne}validate(Q){return this.validationFn(m.float(Q,this.defaultValue))}}class f extends o{static string(Q,fe){return typeof Q!="string"?fe:Q}constructor(Q,fe,Ne,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.default=Ne);super(Q,fe,Ne,qe)}validate(Q){return f.string(Q,this.defaultValue)}}function D(j,Q,fe){return typeof j!="string"||fe.indexOf(j)===-1?Q:j}e.stringSet=D;class l extends o{constructor(Q,fe,Ne,qe,ot=void 0){typeof ot!="undefined"&&(ot.type="string",ot.enum=qe,ot.default=Ne);super(Q,fe,Ne,ot);this._allowedValues=qe}validate(Q){return D(Q,this.defaultValue,this._allowedValues)}}class M extends R{constructor(Q,fe,Ne,qe,ot,ht,Je=void 0){typeof Je!="undefined"&&(Je.type="string",Je.enum=ot,Je.default=qe);super(Q,fe,Ne,Je);this._allowedValues=ot,this._convert=ht}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function r(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends R{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(0,null),s.localize(1,null),s.localize(2,null)],default:"auto",description:s.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,fe,Ne){return Ne===0?Q.accessibilitySupport:Ne}}class b extends R{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:s.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:s.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{insertSpace:u(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var g;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(g=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function v(j){switch(j){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function a(j){switch(j){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class S extends p{constructor(){super(127)}compute(Q,fe,Ne){const qe=["monaco-editor"];return fe.get(33)&&qe.push(fe.get(33)),Q.extraEditorClassName&&qe.push(Q.extraEditorClassName),fe.get(65)==="default"?qe.push("mouse-default"):fe.get(65)==="copy"&&qe.push("mouse-copy"),fe.get(99)&&qe.push("showUnused"),fe.get(125)&&qe.push("showDeprecated"),qe.join(" ")}}class I extends d{constructor(){super(32,"emptySelectionClipboard",!0,{description:s.localize(6,null)})}compute(Q,fe,Ne){return Ne&&Q.emptySelectionClipboard}}class N extends R{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:s.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[s.localize(8,null),s.localize(9,null),s.localize(10,null)],description:s.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[s.localize(12,null),s.localize(13,null),s.localize(14,null)],description:s.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:s.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:s.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:s.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{cursorMoveOnType:u(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":D(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":D(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(fe.loop,this.defaultValue.loop)}}}class B extends R{constructor(){super(44,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:s.localize(19,null)},{type:"string",description:s.localize(20,null)}],description:s.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?B.OFF:Q==="true"?B.ON:Q:Boolean(Q)?B.ON:B.OFF}}e.EditorFontLigatures=B,B.OFF='"liga" off, "calt" off',B.ON='"liga" on, "calt" on';class E extends p{constructor(){super(43)}compute(Q,fe,Ne){return Q.fontInfo}}class O extends o{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(22,null)})}validate(Q){const fe=m.float(Q,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(fe,6,100)}compute(Q,fe,Ne){return Q.fontInfo.fontSize}}class z extends R{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:s.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(_.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class U extends R{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[s.localize(25,null),s.localize(26,null),s.localize(27,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:s.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:s.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:s.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ne,description:s.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ne,description:s.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ne,description:s.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ne,description:s.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ne,description:s.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{multiple:D(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??D(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??D(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??D(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??D(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??D(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:f.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:f.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:f.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:f.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:f.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends R{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:s.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,description:s.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:s.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:s.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),delay:_.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:u(fe.sticky,this.defaultValue.sticky),above:u(fe.above,this.defaultValue.above)}}}var V;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class ue extends p{constructor(){super(130)}compute(Q,fe,Ne){return ue.computeLayout(fe,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const fe=Q.height/Q.lineHeight,Ne=Q.scrollBeyondLastLine?fe-1:0,qe=(Q.viewLineCount+Ne)/(Q.pixelRatio*Q.height),ot=Math.floor(Q.viewLineCount/qe);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:Ne,desiredRatio:qe,minimapLineCount:ot}}static _computeMinimapLayout(Q,fe){const Ne=Q.outerWidth,qe=Q.outerHeight,ot=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const ht=fe.stableMinimapLayoutInput,Je=ht&&Q.outerHeight===ht.outerHeight&&Q.lineHeight===ht.lineHeight&&Q.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&Q.pixelRatio===ht.pixelRatio&&Q.scrollBeyondLastLine===ht.scrollBeyondLastLine&&Q.minimap.enabled===ht.minimap.enabled&&Q.minimap.side===ht.minimap.side&&Q.minimap.size===ht.minimap.size&&Q.minimap.showSlider===ht.minimap.showSlider&&Q.minimap.renderCharacters===ht.minimap.renderCharacters&&Q.minimap.maxColumn===ht.minimap.maxColumn&&Q.minimap.scale===ht.minimap.scale&&Q.verticalScrollbarWidth===ht.verticalScrollbarWidth&&Q.isViewportWrapping===ht.isViewportWrapping,Tt=Q.lineHeight,Ae=Q.typicalHalfwidthCharacterWidth,De=Q.scrollBeyondLastLine,ve=Q.minimap.renderCharacters;let ie=ot>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const se=Q.minimap.maxColumn,de=Q.minimap.size,me=Q.minimap.side,Te=Q.verticalScrollbarWidth,We=Q.viewLineCount,Le=Q.remainingWidth,Ke=Q.isViewportWrapping,it=ve?2:3;let rt=Math.floor(ot*qe);const ne=rt/ot;let ge=!1,te=!1,W=it*ie,be=ie/ot,Pe=1;if(de==="fill"||de==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:pt,desiredRatio:yt,minimapLineCount:Ot}=ue.computeContainedMinimapLineCount({viewLineCount:We,scrollBeyondLastLine:De,height:qe,lineHeight:Tt,pixelRatio:ot});if(We/Ot>1)ge=!0,te=!0,ie=1,W=1,be=ie/ot;else{let It=!1,At=ie+1;if(de==="fit"){const St=Math.ceil((We+pt)*W);Ke&&Je&&Le<=fe.stableFitRemainingWidth?(It=!0,At=fe.stableFitMaxMinimapScale):It=St>rt}if(de==="fill"||It){ge=!0;const St=ie;W=Math.min(Tt*ot,Math.max(1,Math.floor(1/yt))),Ke&&Je&&Le<=fe.stableFitRemainingWidth&&(At=fe.stableFitMaxMinimapScale),ie=Math.min(At,Math.max(1,Math.floor(W/it))),ie>St&&(Pe=Math.min(2,ie/St)),be=ie/ot/Pe,rt=Math.ceil(Math.max(ft,We+pt)*W),Ke?(fe.stableMinimapLayoutInput=Q,fe.stableFitRemainingWidth=Le,fe.stableFitMaxMinimapScale=ie):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const Ye=Math.floor(se*be),xe=Math.min(Ye,Math.max(0,Math.floor((Le-Te-2)*be/(Ae+be)))+e.MINIMAP_GUTTER_WIDTH);let ut=Math.floor(ot*xe);const wt=ut/ot;ut=Math.floor(ut*Pe);const Ct=ve?1:2,bt=me==="left"?0:Ne-xe-Te;return{renderMinimap:Ct,minimapLeft:bt,minimapWidth:xe,minimapHeightIsEditorHeight:ge,minimapIsSampling:te,minimapScale:ie,minimapLineHeight:W,minimapCanvasInnerWidth:ut,minimapCanvasInnerHeight:rt,minimapCanvasOuterWidth:wt,minimapCanvasOuterHeight:ne}}static computeLayout(Q,fe){const Ne=fe.outerWidth|0,qe=fe.outerHeight|0,ot=fe.lineHeight|0,ht=fe.lineNumbersDigitCount|0,Je=fe.typicalHalfwidthCharacterWidth,Tt=fe.maxDigitWidth,Ae=fe.pixelRatio,De=fe.viewLineCount,ve=Q.get(122),ie=ve==="inherit"?Q.get(121):ve,se=ie==="inherit"?Q.get(117):ie,de=Q.get(120),me=Q.get(2),Te=fe.isDominatedByLongLines,We=Q.get(49),Le=Q.get(59).renderType!==0,Ke=Q.get(60),it=Q.get(93),rt=Q.get(64),ne=Q.get(91),ge=ne.verticalScrollbarSize,te=ne.verticalHasArrows,W=ne.arrowSize,be=ne.horizontalScrollbarSize,Pe=Q.get(57),Ye=Q.get(37);let xe;if(typeof Pe=="string"&&/^\d+(\.\d+)?ch$/.test(Pe)){const Et=parseFloat(Pe.substr(0,Pe.length-2));xe=_.clampedInt(Et*Je,0,0,1e3)}else xe=_.clampedInt(Pe,0,0,1e3);Ye&&(xe+=16);let ut=0;if(Le){const Et=Math.max(ht,Ke);ut=Math.round(Et*Tt)}let wt=0;We&&(wt=ot);let Ct=0,bt=Ct+wt,ft=bt+ut,pt=ft+xe;const yt=Ne-wt-ut-xe;let Ot=!1,kt=!1,It=-1;me!==2&&(ie==="inherit"&&Te?(Ot=!0,kt=!0):se==="on"||se==="bounded"?kt=!0:se==="wordWrapColumn"&&(It=de));const At=ue._computeMinimapLayout({outerWidth:Ne,outerHeight:qe,lineHeight:ot,typicalHalfwidthCharacterWidth:Je,pixelRatio:Ae,scrollBeyondLastLine:it,minimap:rt,verticalScrollbarWidth:ge,viewLineCount:De,remainingWidth:yt,isViewportWrapping:kt},fe.memory||new A);At.renderMinimap!==0&&At.minimapLeft===0&&(Ct+=At.minimapWidth,bt+=At.minimapWidth,ft+=At.minimapWidth,pt+=At.minimapWidth);const St=yt-At.minimapWidth,zt=Math.max(1,Math.floor((St-ge-2)/Je)),Lt=te?W:0;return kt&&(It=Math.max(1,zt),se==="bounded"&&(It=Math.min(It,de))),{width:Ne,height:qe,glyphMarginLeft:Ct,glyphMarginWidth:wt,lineNumbersLeft:bt,lineNumbersWidth:ut,decorationsLeft:ft,decorationsWidth:xe,contentLeft:pt,contentWidth:St,minimap:At,viewportColumn:zt,isWordWrapMinified:Ot,isViewportWrapping:kt,wrappingColumn:It,verticalScrollbarWidth:ge,horizontalScrollbarHeight:be,overviewRuler:{top:Lt,width:ge,height:qe-2*Lt,right:0}}}}e.EditorLayoutInfoComputer=ue;class K extends R{constructor(){const Q={enabled:!0};super(56,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:s.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}class re extends R{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:s.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:s.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:s.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),fontSize:_.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:f.string(fe.fontFamily,this.defaultValue.fontFamily)}}}class pe extends m{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>m.clamp(Q,0,150),{markdownDescription:s.localize(47,null)})}compute(Q,fe,Ne){return Q.fontInfo.lineHeight}}class we extends R{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:s.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(49,null),s.localize(50,null),s.localize(51,null)],default:Q.size,description:s.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:s.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:s.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:s.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:s.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),size:D(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:D(fe.side,this.defaultValue.side,["right","left"]),showSlider:D(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(fe.renderCharacters,this.defaultValue.renderCharacters),scale:_.clampedInt(fe.scale,1,1,3),maxColumn:_.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ae(j){return j==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class le extends R{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{top:_.clampedInt(fe.top,0,0,1e3),bottom:_.clampedInt(fe.bottom,0,0,1e3)}}}class Ce extends R{constructor(){const Q={enabled:!0,cycle:!1};super(75,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:s.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:s.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),cycle:u(fe.cycle,this.defaultValue.cycle)}}}class Ee extends p{constructor(){super(128)}compute(Q,fe,Ne){return Q.pixelRatio}}class Fe extends R{constructor(){const Q={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:s.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:s.localize(63,null)},other:{type:"boolean",default:Q.other,description:s.localize(64,null)}}}],default:Q,description:s.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const fe=Q,Ne={other:u(fe.other,this.defaultValue.other),comments:u(fe.comments,this.defaultValue.comments),strings:u(fe.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var $e;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})($e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ve extends R{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(66,null),s.localize(67,null),s.localize(68,null),s.localize(69,null)],default:"on",description:s.localize(70,null)})}validate(Q){let fe=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(fe=4,Ne=Q):Q==="interval"?fe=3:Q==="relative"?fe=2:Q==="on"?fe=1:fe=0),{renderType:fe,renderFn:Ne}}}function je(j){const Q=j.get(86);return Q==="editable"?j.get(80):Q!=="on"}e.filterValidationDecorations=je;class H extends R{constructor(){const Q=[],fe={type:"number",description:s.localize(71,null)};super(90,"rulers",Q,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:s.localize(72,null),format:"color-hex"}}}]},default:Q,description:s.localize(73,null)})}validate(Q){if(Array.isArray(Q)){const fe=[];for(let Ne of Q)if(typeof Ne=="number")fe.push({column:_.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const qe=Ne;fe.push({column:_.clampedInt(qe.column,0,0,1e4),color:qe.color})}return fe.sort((Ne,qe)=>Ne.column-qe.column),fe}return this.defaultValue}}function G(j,Q){if(typeof j!="string")return Q;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class X extends R{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(74,null),s.localize(75,null),s.localize(76,null)],default:"auto",description:s.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(78,null),s.localize(79,null),s.localize(80,null)],default:"auto",description:s.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:s.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:s.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:s.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q,Ne=_.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=_.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:_.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:G(fe.vertical,this.defaultValue.vertical),horizontal:G(fe.horizontal,this.defaultValue.horizontal),useShadows:u(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:_.clampedInt(fe.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:_.clampedInt(fe.verticalSliderSize,qe,0,1e3),scrollByPage:u(fe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class oe extends R{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(112,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:s.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:s.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:s.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:s.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:s.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:s.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:s.localize(91,null)}})}applyUpdate(Q,fe){let Ne=!1;fe.allowedCharacters&&(k.equals(Q.allowedCharacters,fe.allowedCharacters)||(Q={...Q,allowedCharacters:fe.allowedCharacters},Ne=!0)),fe.allowedLocales&&(k.equals(Q.allowedLocales,fe.allowedLocales)||(Q={...Q,allowedLocales:fe.allowedLocales},Ne=!0));const qe=super.applyUpdate(Q,fe);return Ne?new w(qe.newValue,!0):qe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{nonBasicASCII:Re(fe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(fe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(fe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Re(fe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Re(fe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,fe){if(typeof Q!="object"||!Q)return fe;const Ne={};for(const[qe,ot]of Object.entries(Q))ot===!0&&(Ne[qe]=!0);return Ne}}class q extends R{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:s.localize(92,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:u(fe.enabled,this.defaultValue.enabled),mode:D(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends R{constructor(){const Q={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:s.localize(93,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}class he extends R{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(94,null),s.localize(95,null),s.localize(96,null)],default:Q.bracketPairs,description:s.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(98,null),s.localize(99,null),s.localize(100,null)],default:Q.bracketPairsHorizontal,description:s.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:s.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:s.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:s.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{bracketPairs:Re(fe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Re(fe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(fe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(fe.indentation,this.defaultValue.indentation),highlightActiveIndentation:u(fe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Re(j,Q,fe){const Ne=fe.indexOf(j);return Ne===-1?Q:fe[Ne]}class Ue extends R{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(105,null),s.localize(106,null)],default:Q.insertMode,description:s.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:s.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:s.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:s.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:s.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:s.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:s.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:s.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:s.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(146,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{insertMode:D(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(fe.showIcons,this.defaultValue.showIcons),showStatusBar:u(fe.showStatusBar,this.defaultValue.showStatusBar),preview:u(fe.preview,this.defaultValue.preview),previewMode:D(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(fe.showMethods,this.defaultValue.showMethods),showFunctions:u(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:u(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:u(fe.showFields,this.defaultValue.showFields),showVariables:u(fe.showVariables,this.defaultValue.showVariables),showClasses:u(fe.showClasses,this.defaultValue.showClasses),showStructs:u(fe.showStructs,this.defaultValue.showStructs),showInterfaces:u(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:u(fe.showModules,this.defaultValue.showModules),showProperties:u(fe.showProperties,this.defaultValue.showProperties),showEvents:u(fe.showEvents,this.defaultValue.showEvents),showOperators:u(fe.showOperators,this.defaultValue.showOperators),showUnits:u(fe.showUnits,this.defaultValue.showUnits),showValues:u(fe.showValues,this.defaultValue.showValues),showConstants:u(fe.showConstants,this.defaultValue.showConstants),showEnums:u(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:u(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(fe.showKeywords,this.defaultValue.showKeywords),showWords:u(fe.showWords,this.defaultValue.showWords),showColors:u(fe.showColors,this.defaultValue.showColors),showFiles:u(fe.showFiles,this.defaultValue.showFiles),showReferences:u(fe.showReferences,this.defaultValue.showReferences),showFolders:u(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:u(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(fe.showSnippets,this.defaultValue.showSnippets),showUsers:u(fe.showUsers,this.defaultValue.showUsers),showIssues:u(fe.showIssues,this.defaultValue.showIssues)}}}class ze extends R{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(147,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Qe extends p{constructor(){super(129)}compute(Q,fe,Ne){return fe.get(80)?!0:Q.tabFocusMode}}var et;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(et=e.WrappingIndent||(e.WrappingIndent={}));function st(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Xe extends p{constructor(){super(131)}compute(Q,fe,Ne){const qe=fe.get(130);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}const nt="Consolas, 'Courier New', monospace",lt="Menlo, Monaco, 'Courier New', monospace",vt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?lt:t.isLinux?vt:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Oe(j){return e.editorOptionsRegistry[j.id]=j,j}var Rt;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.bracketPairColorization=12]="bracketPairColorization",j[j.guides=13]="guides",j[j.codeLens=14]="codeLens",j[j.codeLensFontFamily=15]="codeLensFontFamily",j[j.codeLensFontSize=16]="codeLensFontSize",j[j.colorDecorators=17]="colorDecorators",j[j.columnSelection=18]="columnSelection",j[j.comments=19]="comments",j[j.contextmenu=20]="contextmenu",j[j.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",j[j.cursorBlinking=22]="cursorBlinking",j[j.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",j[j.cursorStyle=24]="cursorStyle",j[j.cursorSurroundingLines=25]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",j[j.cursorWidth=27]="cursorWidth",j[j.disableLayerHinting=28]="disableLayerHinting",j[j.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",j[j.domReadOnly=30]="domReadOnly",j[j.dragAndDrop=31]="dragAndDrop",j[j.emptySelectionClipboard=32]="emptySelectionClipboard",j[j.extraEditorClassName=33]="extraEditorClassName",j[j.fastScrollSensitivity=34]="fastScrollSensitivity",j[j.find=35]="find",j[j.fixedOverflowWidgets=36]="fixedOverflowWidgets",j[j.folding=37]="folding",j[j.foldingStrategy=38]="foldingStrategy",j[j.foldingHighlight=39]="foldingHighlight",j[j.foldingImportsByDefault=40]="foldingImportsByDefault",j[j.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=42]="fontFamily",j[j.fontInfo=43]="fontInfo",j[j.fontLigatures=44]="fontLigatures",j[j.fontSize=45]="fontSize",j[j.fontWeight=46]="fontWeight",j[j.formatOnPaste=47]="formatOnPaste",j[j.formatOnType=48]="formatOnType",j[j.glyphMargin=49]="glyphMargin",j[j.gotoLocation=50]="gotoLocation",j[j.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",j[j.hover=52]="hover",j[j.inDiffEditor=53]="inDiffEditor",j[j.inlineSuggest=54]="inlineSuggest",j[j.letterSpacing=55]="letterSpacing",j[j.lightbulb=56]="lightbulb",j[j.lineDecorationsWidth=57]="lineDecorationsWidth",j[j.lineHeight=58]="lineHeight",j[j.lineNumbers=59]="lineNumbers",j[j.lineNumbersMinChars=60]="lineNumbersMinChars",j[j.linkedEditing=61]="linkedEditing",j[j.links=62]="links",j[j.matchBrackets=63]="matchBrackets",j[j.minimap=64]="minimap",j[j.mouseStyle=65]="mouseStyle",j[j.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=67]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",j[j.multiCursorModifier=69]="multiCursorModifier",j[j.multiCursorPaste=70]="multiCursorPaste",j[j.occurrencesHighlight=71]="occurrencesHighlight",j[j.overviewRulerBorder=72]="overviewRulerBorder",j[j.overviewRulerLanes=73]="overviewRulerLanes",j[j.padding=74]="padding",j[j.parameterHints=75]="parameterHints",j[j.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",j[j.quickSuggestions=78]="quickSuggestions",j[j.quickSuggestionsDelay=79]="quickSuggestionsDelay",j[j.readOnly=80]="readOnly",j[j.renameOnType=81]="renameOnType",j[j.renderControlCharacters=82]="renderControlCharacters",j[j.renderFinalNewline=83]="renderFinalNewline",j[j.renderLineHighlight=84]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=86]="renderValidationDecorations",j[j.renderWhitespace=87]="renderWhitespace",j[j.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",j[j.roundedSelection=89]="roundedSelection",j[j.rulers=90]="rulers",j[j.scrollbar=91]="scrollbar",j[j.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=93]="scrollBeyondLastLine",j[j.scrollPredominantAxis=94]="scrollPredominantAxis",j[j.selectionClipboard=95]="selectionClipboard",j[j.selectionHighlight=96]="selectionHighlight",j[j.selectOnLineNumbers=97]="selectOnLineNumbers",j[j.showFoldingControls=98]="showFoldingControls",j[j.showUnused=99]="showUnused",j[j.snippetSuggestions=100]="snippetSuggestions",j[j.smartSelect=101]="smartSelect",j[j.smoothScrolling=102]="smoothScrolling",j[j.stickyTabStops=103]="stickyTabStops",j[j.stopRenderingLineAfter=104]="stopRenderingLineAfter",j[j.suggest=105]="suggest",j[j.suggestFontSize=106]="suggestFontSize",j[j.suggestLineHeight=107]="suggestLineHeight",j[j.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",j[j.suggestSelection=109]="suggestSelection",j[j.tabCompletion=110]="tabCompletion",j[j.tabIndex=111]="tabIndex",j[j.unicodeHighlighting=112]="unicodeHighlighting",j[j.unusualLineTerminators=113]="unusualLineTerminators",j[j.useShadowDOM=114]="useShadowDOM",j[j.useTabStops=115]="useTabStops",j[j.wordSeparators=116]="wordSeparators",j[j.wordWrap=117]="wordWrap",j[j.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=120]="wordWrapColumn",j[j.wordWrapOverride1=121]="wordWrapOverride1",j[j.wordWrapOverride2=122]="wordWrapOverride2",j[j.wrappingIndent=123]="wrappingIndent",j[j.wrappingStrategy=124]="wrappingStrategy",j[j.showDeprecated=125]="showDeprecated",j[j.inlayHints=126]="inlayHints",j[j.editorClassName=127]="editorClassName",j[j.pixelRatio=128]="pixelRatio",j[j.tabFocusMode=129]="tabFocusMode",j[j.layoutInfo=130]="layoutInfo",j[j.wrappingInfo=131]="wrappingInfo"})(Rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(148,null)})),acceptSuggestionOnEnter:Oe(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(149,null),""],markdownDescription:s.localize(150,null)})),accessibilitySupport:Oe(new n),accessibilityPageSize:Oe(new _(3,"accessibilityPageSize",10,1,1073741824,{description:s.localize(151,null)})),ariaLabel:Oe(new f(4,"ariaLabel",s.localize(152,null))),autoClosingBrackets:Oe(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(153,null),s.localize(154,null),""],description:s.localize(155,null)})),autoClosingDelete:Oe(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(156,null),""],description:s.localize(157,null)})),autoClosingOvertype:Oe(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(158,null),""],description:s.localize(159,null)})),autoClosingQuotes:Oe(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(160,null),s.localize(161,null),""],description:s.localize(162,null)})),autoIndent:Oe(new M(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[s.localize(163,null),s.localize(164,null),s.localize(165,null),s.localize(166,null),s.localize(167,null)],description:s.localize(168,null)})),automaticLayout:Oe(new d(10,"automaticLayout",!1)),autoSurround:Oe(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(169,null),s.localize(170,null),s.localize(171,null),""],description:s.localize(172,null)})),bracketPairColorization:Oe(new ee),bracketPairGuides:Oe(new he),stickyTabStops:Oe(new d(103,"stickyTabStops",!1,{description:s.localize(173,null)})),codeLens:Oe(new d(14,"codeLens",!0,{description:s.localize(174,null)})),codeLensFontFamily:Oe(new f(15,"codeLensFontFamily","",{description:s.localize(175,null)})),codeLensFontSize:Oe(new _(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(176,null)})),colorDecorators:Oe(new d(17,"colorDecorators",!0,{description:s.localize(177,null)})),columnSelection:Oe(new d(18,"columnSelection",!1,{description:s.localize(178,null)})),comments:Oe(new b),contextmenu:Oe(new d(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new d(21,"copyWithSyntaxHighlighting",!0,{description:s.localize(179,null)})),cursorBlinking:Oe(new M(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:s.localize(180,null)})),cursorSmoothCaretAnimation:Oe(new d(23,"cursorSmoothCaretAnimation",!1,{description:s.localize(181,null)})),cursorStyle:Oe(new M(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],a,{description:s.localize(182,null)})),cursorSurroundingLines:Oe(new _(25,"cursorSurroundingLines",0,0,1073741824,{description:s.localize(183,null)})),cursorSurroundingLinesStyle:Oe(new l(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(184,null),s.localize(185,null)],description:s.localize(186,null)})),cursorWidth:Oe(new _(27,"cursorWidth",0,0,1073741824,{markdownDescription:s.localize(187,null)})),disableLayerHinting:Oe(new d(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new d(29,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new d(30,"domReadOnly",!1)),dragAndDrop:Oe(new d(31,"dragAndDrop",!0,{description:s.localize(188,null)})),emptySelectionClipboard:Oe(new I),extraEditorClassName:Oe(new f(33,"extraEditorClassName","")),fastScrollSensitivity:Oe(new m(34,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:s.localize(189,null)})),find:Oe(new N),fixedOverflowWidgets:Oe(new d(36,"fixedOverflowWidgets",!1)),folding:Oe(new d(37,"folding",!0,{description:s.localize(190,null)})),foldingStrategy:Oe(new l(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(191,null),s.localize(192,null)],description:s.localize(193,null)})),foldingHighlight:Oe(new d(39,"foldingHighlight",!0,{description:s.localize(194,null)})),foldingImportsByDefault:Oe(new d(40,"foldingImportsByDefault",!1,{description:s.localize(195,null)})),unfoldOnClickAfterEndOfLine:Oe(new d(41,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(196,null)})),fontFamily:Oe(new f(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(197,null)})),fontInfo:Oe(new E),fontLigatures2:Oe(new B),fontSize:Oe(new O),fontWeight:Oe(new z),formatOnPaste:Oe(new d(47,"formatOnPaste",!1,{description:s.localize(198,null)})),formatOnType:Oe(new d(48,"formatOnType",!1,{description:s.localize(199,null)})),glyphMargin:Oe(new d(49,"glyphMargin",!0,{description:s.localize(200,null)})),gotoLocation:Oe(new U),hideCursorInOverviewRuler:Oe(new d(51,"hideCursorInOverviewRuler",!1,{description:s.localize(201,null)})),hover:Oe(new $),inDiffEditor:Oe(new d(53,"inDiffEditor",!1)),letterSpacing:Oe(new m(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>m.clamp(j,-5,20),{description:s.localize(202,null)})),lightbulb:Oe(new K),lineDecorationsWidth:Oe(new o(57,"lineDecorationsWidth",10)),lineHeight:Oe(new pe),lineNumbers:Oe(new Ve),lineNumbersMinChars:Oe(new _(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new d(61,"linkedEditing",!1,{description:s.localize(203,null)})),links:Oe(new d(62,"links",!0,{description:s.localize(204,null)})),matchBrackets:Oe(new l(63,"matchBrackets","always",["always","near","never"],{description:s.localize(205,null)})),minimap:Oe(new we),mouseStyle:Oe(new l(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new m(66,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:s.localize(206,null)})),mouseWheelZoom:Oe(new d(67,"mouseWheelZoom",!1,{markdownDescription:s.localize(207,null)})),multiCursorMergeOverlapping:Oe(new d(68,"multiCursorMergeOverlapping",!0,{description:s.localize(208,null)})),multiCursorModifier:Oe(new M(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ae,{markdownEnumDescriptions:[s.localize(209,null),s.localize(210,null)],markdownDescription:s.localize(211,null)})),multiCursorPaste:Oe(new l(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(212,null),s.localize(213,null)],markdownDescription:s.localize(214,null)})),occurrencesHighlight:Oe(new d(71,"occurrencesHighlight",!0,{description:s.localize(215,null)})),overviewRulerBorder:Oe(new d(72,"overviewRulerBorder",!0,{description:s.localize(216,null)})),overviewRulerLanes:Oe(new _(73,"overviewRulerLanes",3,0,3)),padding:Oe(new le),parameterHints:Oe(new Ce),peekWidgetDefaultFocus:Oe(new l(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(217,null),s.localize(218,null)],description:s.localize(219,null)})),definitionLinkOpensInPeek:Oe(new d(77,"definitionLinkOpensInPeek",!1,{description:s.localize(220,null)})),quickSuggestions:Oe(new Fe),quickSuggestionsDelay:Oe(new _(79,"quickSuggestionsDelay",10,0,1073741824,{description:s.localize(221,null)})),readOnly:Oe(new d(80,"readOnly",!1)),renameOnType:Oe(new d(81,"renameOnType",!1,{description:s.localize(222,null),markdownDeprecationMessage:s.localize(223,null)})),renderControlCharacters:Oe(new d(82,"renderControlCharacters",!0,{description:s.localize(224,null),restricted:!0})),renderFinalNewline:Oe(new d(83,"renderFinalNewline",!0,{description:s.localize(225,null)})),renderLineHighlight:Oe(new l(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(226,null)],description:s.localize(227,null)})),renderLineHighlightOnlyWhenFocus:Oe(new d(85,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(228,null)})),renderValidationDecorations:Oe(new l(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new l(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(229,null),s.localize(230,null),s.localize(231,null),""],description:s.localize(232,null)})),revealHorizontalRightPadding:Oe(new _(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Oe(new d(89,"roundedSelection",!0,{description:s.localize(233,null)})),rulers:Oe(new H),scrollbar:Oe(new X),scrollBeyondLastColumn:Oe(new _(92,"scrollBeyondLastColumn",5,0,1073741824,{description:s.localize(234,null)})),scrollBeyondLastLine:Oe(new d(93,"scrollBeyondLastLine",!0,{description:s.localize(235,null)})),scrollPredominantAxis:Oe(new d(94,"scrollPredominantAxis",!0,{description:s.localize(236,null)})),selectionClipboard:Oe(new d(95,"selectionClipboard",!0,{description:s.localize(237,null),included:t.isLinux})),selectionHighlight:Oe(new d(96,"selectionHighlight",!0,{description:s.localize(238,null)})),selectOnLineNumbers:Oe(new d(97,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new l(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[s.localize(239,null),s.localize(240,null)],description:s.localize(241,null)})),showUnused:Oe(new d(99,"showUnused",!0,{description:s.localize(242,null)})),showDeprecated:Oe(new d(125,"showDeprecated",!0,{description:s.localize(243,null)})),inlayHints:Oe(new re),snippetSuggestions:Oe(new l(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(244,null),s.localize(245,null),s.localize(246,null),s.localize(247,null)],description:s.localize(248,null)})),smartSelect:Oe(new ze),smoothScrolling:Oe(new d(102,"smoothScrolling",!1,{description:s.localize(249,null)})),stopRenderingLineAfter:Oe(new _(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new Ue),inlineSuggest:Oe(new q),suggestFontSize:Oe(new _(106,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(250,null)})),suggestLineHeight:Oe(new _(107,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(251,null)})),suggestOnTriggerCharacters:Oe(new d(108,"suggestOnTriggerCharacters",!0,{description:s.localize(252,null)})),suggestSelection:Oe(new l(109,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(253,null),s.localize(254,null),s.localize(255,null)],description:s.localize(256,null)})),tabCompletion:Oe(new l(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(257,null),s.localize(258,null),s.localize(259,null)],description:s.localize(260,null)})),tabIndex:Oe(new _(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new oe),unusualLineTerminators:Oe(new l(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(261,null),s.localize(262,null),s.localize(263,null)],description:s.localize(264,null)})),useShadowDOM:Oe(new d(114,"useShadowDOM",!0)),useTabStops:Oe(new d(115,"useTabStops",!0,{description:s.localize(265,null)})),wordSeparators:Oe(new f(116,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:s.localize(266,null)})),wordWrap:Oe(new l(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(267,null),s.localize(268,null),s.localize(269,null),s.localize(270,null)],description:s.localize(271,null)})),wordWrapBreakAfterCharacters:Oe(new f(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new f(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new _(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:s.localize(272,null)})),wordWrapOverride1:Oe(new l(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new l(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Oe(new M(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],st,{enumDescriptions:[s.localize(273,null),s.localize(274,null),s.localize(275,null),s.localize(276,null)],description:s.localize(277,null)})),wrappingStrategy:Oe(new l(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[s.localize(278,null),s.localize(279,null)],description:s.localize(280,null)})),editorClassName:Oe(new S),pixelRatio:Oe(new Ee),tabFocusMode:Oe(new Qe),layoutInfo:Oe(new ue),wrappingInfo:Oe(new Xe)}}),define(ye[114],_e([18,19]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[115],_e([18,19]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[116],_e([18,19]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(ye[117],_e([18,19]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(ye[118],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[119],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[120],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[121],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[122],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[123],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[124],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[125],_e([18,19]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(ye[126],_e([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[127],_e([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ye[128],_e([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ye[129],_e([18,19]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[130],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var s;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(s=e.EditorActivation||(e.EditorActivation={}));var t;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var y;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(y=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ye[131],_e([0,1,115]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function T(i){return i=i.trim(),i==="*"||t.test(i)}e.isValidVersionStr=T;function k(i){if(!T(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=i.match(t);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=k;function P(i){if(!i)return null;let p=i.majorBase,o=i.majorMustEqual,u=i.minorBase,d=i.minorMustEqual,F=i.patchBase,_=i.patchMustEqual;i.hasCaret&&(p===0||(d=!1),_=!1);let m=0;if(i.preRelease){const f=y.exec(i.preRelease);if(f){const[,D,l,M]=f;m=Date.UTC(Number(D),Number(l)-1,Number(M))}}return{majorBase:p,majorMustEqual:o,minorBase:u,minorMustEqual:d,patchBase:F,patchMustEqual:_,isMinimum:i.hasGreaterEquals,notBefore:m}}e.normalizeVersion=P;function C(i,p,o){let u;typeof i=="string"?u=P(k(i)):u=i;let d;p instanceof Date?d=p.getTime():typeof p=="string"&&(d=new Date(p).getTime());let F;if(typeof o=="string"?F=P(k(o)):F=o,!u||!F)return!1;let _=u.majorBase,m=u.minorBase,f=u.patchBase,D=F.majorBase,l=F.minorBase,M=F.patchBase,r=F.notBefore,n=F.majorMustEqual,b=F.minorMustEqual,g=F.patchMustEqual;return F.isMinimum?_>D?!0:_<D?!1:m>l?!0:m<l||d&&d<r?!1:f>=M:(_===1&&D===0&&(!n||!b||!g)&&(D=1,l=0,M=0,n=!0,b=!1,g=!1),_<D?!1:_>D?!n:m<l?!1:m>l?!b:f<M?!1:f>M?!g:!(d&&d<r))}e.isValidVersion=C;function A(i,p,o,u){return o.isBuiltin||typeof o.main=="undefined"?!0:w(i,p,o.engines.vscode,u)}e.isValidExtensionVersion=A;function R(i,p,o){return i==="*"||w(p,o,i)}e.isEngineValid=R;function w(i,p,o,u=[]){let d=P(k(o));if(!d)return u.push(s.localize(0,null,o)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return u.push(s.localize(1,null,o)),!1}else if(!d.majorMustEqual)return u.push(s.localize(2,null,o)),!1;return C(i,p,d)?!0:(u.push(s.localize(3,null,i,o)),!1)}}),define(ye[80],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class s{constructor(y,T=[],k=!1){this.ctor=y,this.staticArguments=T,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=s}),define(ye[44],_e([0,1,80]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function y(k,P,C){P instanceof s.SyncDescriptor||(P=new s.SyncDescriptor(P,[],C)),t.push([k,P])}e.registerSingleton=y;function T(){return t}e.getSingletonServiceDescriptors=T}),define(ye[132],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class s{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=s;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let k of this._nodes.values())k.outgoing.size===0&&T.push(k);return T}insertEdge(T,k){const P=this.lookupOrInsertNode(T),C=this.lookupOrInsertNode(k);P.outgoing.set(this._hashFn(k),C),C.incoming.set(this._hashFn(T),P)}removeNode(T){const k=this._hashFn(T);this._nodes.delete(k);for(let P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(T){const k=this._hashFn(T);let P=this._nodes.get(k);return P||(P=new s(T),this._nodes.set(k,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[k,P]of this._nodes)T.push(`${k}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,k]of this._nodes){const P=new Set([T]),C=this._findCycle(k,P);if(C)return C}}_findCycle(T,k){for(let[P,C]of T.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const A=this._findCycle(C,k);if(A)return A;k.delete(P)}}}e.Graph=t}),define(ye[3],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var s;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function P(C){return C[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=P})(s=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function t(k,P,C,A){P[s.DI_TARGET]===P?P[s.DI_DEPENDENCIES].push({id:k,index:C,optional:A}):(P[s.DI_DEPENDENCIES]=[{id:k,index:C,optional:A}],P[s.DI_TARGET]=P)}function y(k){if(s.serviceIds.has(k))return s.serviceIds.get(k);const P=function(C,A,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,C,R,!1)};return P.toString=()=>k,s.serviceIds.set(k,P),P}e.createDecorator=y;function T(k){return k}e.refineServiceDecorator=T}),define(ye[133],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,s.createDecorator)("modelService");function t(y){return!y.isTooLargeForSyncing()&&!y.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(ye[134],_e([0,1,4,57,6,21,75,56,133]),function(Z,e,s,t,y,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function A(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(A):!!u.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new s.Emitter}get onDidChange(){return this._onDidChange.event}register(d,F){let _={selector:d,provider:F,_score:-1,_time:this._clock++};return this._entries.push(_),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,y.toDisposable)(()=>{if(_){const m=this._entries.indexOf(_);m>=0&&(this._entries.splice(m,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),_=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const F=[];for(let _ of this._entries)_._score>0&&F.push(_.provider);return F}ordered(d){const F=[];return this._orderedForEach(d,_=>F.push(_.provider)),F}orderedGroups(d){const F=[];let _,m;return this._orderedForEach(d,f=>{_&&m===f._score?_.push(f.provider):(m=f._score,_=[f.provider],F.push(_))}),F}_orderedForEach(d,F){if(!!d){this._updateScores(d);for(const _ of this._entries)_._score>0&&F(_)}}_updateScores(d){const F={uri:d.uri.toString(),language:d.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===F.language&&this._lastCandidate.uri===F.uri)){this._lastCandidate=F;for(let _ of this._entries)if(_._score=(0,P.score)(_.selector,d.uri,d.getLanguageId(),(0,C.shouldSynchronizeModel)(d)),A(_.selector)&&_._score>0){for(let m of this._entries)m._score=0;_._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(d,F){return d._score<F._score?1:d._score>F._score?-1:d._time<F._time?1:d._time>F._time?-1:0}}e.LanguageFeatureRegistry=R;const w=new WeakMap;let i=0;function p(u){let d=w.get(u);return d===void 0&&(d=++i,w.set(u,d)),d}class o{constructor(d,F,_=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=F,this.max=_,this._cache=new T.LRUCache(50,.7)}_key(d){return d.id+this._registry.all(d).reduce((F,_)=>(0,t.doHash)(p(_),F),0)}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const F=this._key(d),_=this._cache.get(F);return this._clamp(_?.value)}update(d,F){const _=this._key(d);let m=this._cache.get(_);return m||(m=new k.MovingAverage,this._cache.set(_,m)),m.update(F),this.get(d)}}e.LanguageFeatureRequestDelays=o}),define(ye[58],_e([0,1,2,59,134,107,52]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));var C;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline",a[a.Strikethrough=8]="Strikethrough"})(C=e.FontStyle||(e.FontStyle={}));var A;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(A=e.ColorId||(e.ColorId={}));var R;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var w;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=1024]="ITALIC_MASK",a[a.BOLD_MASK=2048]="BOLD_MASK",a[a.UNDERLINE_MASK=4096]="UNDERLINE_MASK",a[a.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",a[a.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(w=e.MetadataConsts||(e.MetadataConsts={}));class i{static getLanguageId(S){return(S&255)>>>0}static getTokenType(S){return(S&768)>>>8}static getFontStyle(S){return(S&15360)>>>10}static getForeground(S){return(S&8372224)>>>14}static getBackground(S){return(S&4286578688)>>>23}static getClassNameFromMetadata(S){const I=this.getForeground(S);let N="mtk"+I;const B=this.getFontStyle(S);return B&1&&(N+=" mtki"),B&2&&(N+=" mtkb"),B&4&&(N+=" mtku"),B&8&&(N+=" mtks"),N}static getInlineStyleFromMetadata(S,I){const N=this.getForeground(S),B=this.getFontStyle(S);let E=`color: ${I[N]};`;B&1&&(E+="font-style: italic;"),B&2&&(E+="font-weight: bold;");let O="";return B&4&&(O+=" underline"),B&8&&(O+=" line-through"),O&&(E+=`text-decoration:${O};`),E}}e.TokenMetadata=i;var p;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(p=e.CompletionItemKind||(e.CompletionItemKind={}));var o;(function(a){const S=new Map;S.set(0,k.Codicon.symbolMethod),S.set(1,k.Codicon.symbolFunction),S.set(2,k.Codicon.symbolConstructor),S.set(3,k.Codicon.symbolField),S.set(4,k.Codicon.symbolVariable),S.set(5,k.Codicon.symbolClass),S.set(6,k.Codicon.symbolStruct),S.set(7,k.Codicon.symbolInterface),S.set(8,k.Codicon.symbolModule),S.set(9,k.Codicon.symbolProperty),S.set(10,k.Codicon.symbolEvent),S.set(11,k.Codicon.symbolOperator),S.set(12,k.Codicon.symbolUnit),S.set(13,k.Codicon.symbolValue),S.set(15,k.Codicon.symbolEnum),S.set(14,k.Codicon.symbolConstant),S.set(15,k.Codicon.symbolEnum),S.set(16,k.Codicon.symbolEnumMember),S.set(17,k.Codicon.symbolKeyword),S.set(27,k.Codicon.symbolSnippet),S.set(18,k.Codicon.symbolText),S.set(19,k.Codicon.symbolColor),S.set(20,k.Codicon.symbolFile),S.set(21,k.Codicon.symbolReference),S.set(22,k.Codicon.symbolCustomColor),S.set(23,k.Codicon.symbolFolder),S.set(24,k.Codicon.symbolTypeParameter),S.set(25,k.Codicon.account),S.set(26,k.Codicon.issues);function I(E){let O=S.get(E);return O||(console.info("No codicon found for CompletionItemKind "+E),O=k.Codicon.symbolProperty),O}a.toIcon=I;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function B(E,O){let z=N.get(E);return typeof z=="undefined"&&!O&&(z=9),z}a.fromString=B})(o=e.CompletionItemKinds||(e.CompletionItemKinds={}));var u;(function(a){a[a.Deprecated=1]="Deprecated"})(u=e.CompletionItemTag||(e.CompletionItemTag={}));var d;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(d=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var F;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(F=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var m;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(m=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var D;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(D=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function l(a){return a&&s.URI.isUri(a.uri)&&t.Range.isIRange(a.range)&&(t.Range.isIRange(a.originSelectionRange)||t.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=l;var M;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(M=e.SymbolKind||(e.SymbolKind={}));var r;(function(a){a[a.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var n;(function(a){const S=new Map;S.set(0,k.Codicon.symbolFile),S.set(1,k.Codicon.symbolModule),S.set(2,k.Codicon.symbolNamespace),S.set(3,k.Codicon.symbolPackage),S.set(4,k.Codicon.symbolClass),S.set(5,k.Codicon.symbolMethod),S.set(6,k.Codicon.symbolProperty),S.set(7,k.Codicon.symbolField),S.set(8,k.Codicon.symbolConstructor),S.set(9,k.Codicon.symbolEnum),S.set(10,k.Codicon.symbolInterface),S.set(11,k.Codicon.symbolFunction),S.set(12,k.Codicon.symbolVariable),S.set(13,k.Codicon.symbolConstant),S.set(14,k.Codicon.symbolString),S.set(15,k.Codicon.symbolNumber),S.set(16,k.Codicon.symbolBoolean),S.set(17,k.Codicon.symbolArray),S.set(18,k.Codicon.symbolObject),S.set(19,k.Codicon.symbolKey),S.set(20,k.Codicon.symbolNull),S.set(21,k.Codicon.symbolEnumMember),S.set(22,k.Codicon.symbolStruct),S.set(23,k.Codicon.symbolEvent),S.set(24,k.Codicon.symbolOperator),S.set(25,k.Codicon.symbolTypeParameter);function I(N){let B=S.get(N);return B||(console.info("No codicon found for SymbolKind "+N),B=k.Codicon.symbolProperty),B}a.toIcon=I})(n=e.SymbolKinds||(e.SymbolKinds={}));class b{constructor(S){this.value=S}}e.FoldingRangeKind=b,b.Comment=new b("comment"),b.Imports=new b("imports"),b.Region=new b("region");var g;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(g=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var h;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(h=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new y.LanguageFeatureRegistry,e.RenameProviderRegistry=new y.LanguageFeatureRegistry,e.CompletionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new y.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new y.LanguageFeatureRegistry,e.HoverProviderRegistry=new y.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new y.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new y.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new y.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new y.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new y.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.LinkProviderRegistry=new y.LanguageFeatureRegistry,e.ColorProviderRegistry=new y.LanguageFeatureRegistry,e.SelectionRangeRegistry=new y.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistry;var v;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[81],_e([0,1,10,2,3]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationOverrides=T;function k(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||s.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var P;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function A(d,F){const _=Object.create(null);for(let m in d)R(_,m,d[m],F);return _}e.toValuesTree=A;function R(d,F,_,m){const f=F.split("."),D=f.pop();let l=d;for(let M=0;M<f.length;M++){let r=f[M],n=l[r];switch(typeof n){case"undefined":n=l[r]=Object.create(null);break;case"object":break;default:m(`Ignoring ${F} as ${f.slice(0,M+1).join(".")} is ${JSON.stringify(n)}`);return}l=n}if(typeof l=="object"&&l!==null)try{l[D]=_}catch{m(`Ignoring ${F} as ${f.join(".")} is ${JSON.stringify(l)}`)}else m(`Ignoring ${F} as ${f.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=R;function w(d,F){const _=F.split(".");i(d,_)}e.removeFromValueTree=w;function i(d,F){const _=F.shift();if(F.length===0){delete d[_];return}if(Object.keys(d).indexOf(_)!==-1){const m=d[_];typeof m=="object"&&!Array.isArray(m)&&(i(m,F),Object.keys(m).length===0&&delete d[_])}}function p(d,F,_){function m(l,M){let r=l;for(const n of M){if(typeof r!="object"||r===null)return;r=r[n]}return r}const f=F.split("."),D=m(d,f);return typeof D=="undefined"?_:D}e.getConfigurationValue=p;function o(d,F,_){Object.keys(F).forEach(m=>{m!=="__proto__"&&(m in d?s.isObject(d[m])&&s.isObject(F[m])?o(d[m],F[m],_):_&&(d[m]=F[m]):d[m]=F[m])})}e.merge=o;function u(d,F,_){const m=d.inspect(F),f=d.inspect(_);return typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:m.defaultValue}e.getMigratedSettingValue=u}),define(ye[45],_e([0,1,23,9,3]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=s.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",s.isMacintosh),k.set("isLinux",s.isLinux),k.set("isWindows",s.isWindows),k.set("isWeb",s.isWeb),k.set("isMacNative",s.isMacintosh&&!s.isWeb),k.set("isEdge",T.indexOf("Edg/")>=0),k.set("isFirefox",T.indexOf("Firefox")>=0),k.set("isChrome",T.indexOf("Chrome")>=0),k.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var C;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class A{static false(){return i.INSTANCE}static true(){return p.INSTANCE}static has(E){return o.create(E)}static equals(E,O){return u.create(E,O)}static notEquals(E,O){return _.create(E,O)}static regex(E,O){return n.create(E,O)}static in(E,O){return d.create(E,O)}static not(E){return m.create(E)}static and(...E){return c.create(E,null)}static or(...E){return h.create(E,null,!0)}static greater(E,O){return D.create(E,O)}static greaterEquals(E,O){return l.create(E,O)}static smaller(E,O){return M.create(E,O)}static smallerEquals(E,O){return r.create(E,O)}static deserialize(E,O=!1){if(!!E)return this._deserializeOrExpression(E,O)}static _deserializeOrExpression(E,O){let z=E.split("||");return h.create(z.map(U=>this._deserializeAndExpression(U,O)),null,!0)}static _deserializeAndExpression(E,O){let z=E.split("&&");return c.create(z.map(U=>this._deserializeOne(U,O)),null)}static _deserializeOne(E,O){if(E=E.trim(),E.indexOf("!=")>=0){let z=E.split("!=");return _.create(z[0].trim(),this._deserializeValue(z[1],O))}if(E.indexOf("==")>=0){let z=E.split("==");return u.create(z[0].trim(),this._deserializeValue(z[1],O))}if(E.indexOf("=~")>=0){let z=E.split("=~");return n.create(z[0].trim(),this._deserializeRegexValue(z[1],O))}if(E.indexOf(" in ")>=0){let z=E.split(" in ");return d.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const z=E.split(">=");return l.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const z=E.split(">");return D.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const z=E.split("<=");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const z=E.split("<");return M.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(E)?m.create(E.substr(1).trim()):o.create(E)}static _deserializeValue(E,O){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let z=/^'([^']*)'$/.exec(E);return z?z[1].trim():E}static _deserializeRegexValue(E,O){if((0,t.isFalsyOrWhitespace)(E)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=E.indexOf("/"),U=E.lastIndexOf("/");if(z===U||z<0){if(O)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let $=E.slice(z+1,U),V=E[U+1]==="i"?"i":"";try{return new RegExp($,V)}catch(ue){if(O)throw new Error(`bad regexp-value '${E}', parse error: ${ue}`);return console.warn(`bad regexp-value '${E}', parse error: ${ue}`),null}}}e.ContextKeyExpr=A;function R(B,E){const O=B?B.substituteConstants():void 0,z=E?E.substituteConstants():void 0;return!O&&!z?!0:!O||!z?!1:O.equals(z)}e.expressionsAreEqualWithConstantSubstitution=R;function w(B,E){return B.cmp(E)}class i{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=i,i.INSTANCE=new i;class p{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return i.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class o{constructor(E,O){this.key=E,this.negated=O,this.type=2}static create(E,O=null){const z=k.get(E);return typeof z=="boolean"?z?p.INSTANCE:i.INSTANCE:new o(E,O)}cmp(E){return E.type!==this.type?this.type-E.type:a(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=k.get(this.key);return typeof E=="boolean"?E?p.INSTANCE:i.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=o;class u{constructor(E,O,z){this.key=E,this.value=O,this.negated=z,this.type=4}static create(E,O,z=null){if(typeof O=="boolean")return O?o.create(E,z):m.create(E,z);const U=k.get(E);return typeof U=="boolean"?O===(U?"true":"false")?p.INSTANCE:i.INSTANCE:new u(E,O,z)}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=k.get(this.key);if(typeof E=="boolean"){const O=E?"true":"false";return this.value===O?p.INSTANCE:i.INSTANCE}return this}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class d{constructor(E,O){this.key=E,this.valueKey=O,this.type=10,this.negated=null}static create(E,O){return new d(E,O)}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}substituteConstants(){return this}evaluate(E){const O=E.getValue(this.valueKey),z=E.getValue(this.key);return Array.isArray(O)?O.indexOf(z)>=0:typeof z=="string"&&typeof O=="object"&&O!==null?P.call(O,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=F.create(this)),this.negated}}e.ContextKeyInExpr=d;class F{constructor(E){this._actual=E,this.type=11}static create(E){return new F(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new F(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=F;class _{constructor(E,O,z){this.key=E,this.value=O,this.negated=z,this.type=5}static create(E,O,z=null){if(typeof O=="boolean")return O?m.create(E,z):o.create(E,z);const U=k.get(E);return typeof U=="boolean"?O===(U?"true":"false")?i.INSTANCE:p.INSTANCE:new _(E,O,z)}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=k.get(this.key);if(typeof E=="boolean"){const O=E?"true":"false";return this.value===O?i.INSTANCE:p.INSTANCE}return this}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=_;class m{constructor(E,O){this.key=E,this.negated=O,this.type=3}static create(E,O=null){const z=k.get(E);return typeof z=="boolean"?z?i.INSTANCE:p.INSTANCE:new m(E,O)}cmp(E){return E.type!==this.type?this.type-E.type:a(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=k.get(this.key);return typeof E=="boolean"?E?i.INSTANCE:p.INSTANCE:this}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function f(B,E){if(typeof B=="string"){const O=parseFloat(B);isNaN(O)||(B=O)}return typeof B=="string"||typeof B=="number"?E(B):i.INSTANCE}class D{constructor(E,O,z){this.key=E,this.value=O,this.negated=z,this.type=12}static create(E,O,z=null){return f(O,U=>new D(E,U,z))}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=D;class l{constructor(E,O,z){this.key=E,this.value=O,this.negated=z,this.type=13}static create(E,O,z=null){return f(O,U=>new l(E,U,z))}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class M{constructor(E,O,z){this.key=E,this.value=O,this.negated=z,this.type=14}static create(E,O,z=null){return f(O,U=>new M(E,U,z))}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class r{constructor(E,O,z){this.key=E,this.value=O,this.negated=z,this.type=15}static create(E,O,z=null){return f(O,U=>new r(E,U,z))}cmp(E){return E.type!==this.type?this.type-E.type:S(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class n{constructor(E,O){this.key=E,this.regexp=O,this.type=7,this.negated=null}static create(E,O){return new n(E,O)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const O=this.regexp?this.regexp.source:"",z=E.regexp?E.regexp.source:"";return O<z?-1:O>z?1:0}equals(E){if(E.type===this.type){const O=this.regexp?this.regexp.source:"",z=E.regexp?E.regexp.source:"";return this.key===E.key&&O===z}return!1}substituteConstants(){return this}evaluate(E){let O=E.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=b.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class b{constructor(E){this._actual=E,this.type=8}static create(E){return new b(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new b(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=b;function g(B){let E=null;for(let O=0,z=B.length;O<z;O++){const U=B[O].substituteConstants();if(B[O]!==U&&E===null){E=[];for(let $=0;$<O;$++)E[$]=B[$]}E!==null&&(E[O]=U)}return E===null?B:E}class c{constructor(E,O){this.expr=E,this.negated=O,this.type=6}static create(E,O){return c._normalizeArr(E,O)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const U=w(this.expr[O],E.expr[O]);if(U!==0)return U}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(E.expr[O]))return!1;return!0}return!1}substituteConstants(){const E=g(this.expr);return E===this.expr?this:c.create(E,this.negated)}evaluate(E){for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].evaluate(E))return!1;return!0}static _normalizeArr(E,O){const z=[];let U=!1;for(const $ of E)if(!!$){if($.type===1){U=!0;continue}if($.type===0)return i.INSTANCE;if($.type===6){z.push(...$.expr);continue}z.push($)}if(z.length===0&&U)return p.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(w);for(let $=1;$<z.length;$++)z[$-1].equals(z[$])&&(z.splice($,1),$--);if(z.length===1)return z[0];for(;z.length>1;){const $=z[z.length-1];if($.type!==9)break;z.pop();const V=z.pop(),ue=z.length===0,K=h.create($.expr.map(re=>c.create([re,V],null)),null,ue);K&&(z.push(K),z.sort(w))}return z.length===1?z[0]:new c(z,O)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let O of this.expr)E.push(...O.keys());return E}map(E){return new c(this.expr.map(O=>O.map(E)),null)}negate(){if(!this.negated){const E=[];for(let O of this.expr)E.push(O.negate());this.negated=h.create(E,this,!0)}return this.negated}}class h{constructor(E,O){this.expr=E,this.negated=O,this.type=9}static create(E,O,z){return h._normalizeArr(E,O,z)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const U=w(this.expr[O],E.expr[O]);if(U!==0)return U}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(E.expr[O]))return!1;return!0}return!1}substituteConstants(){const E=g(this.expr);return E===this.expr?this:h.create(E,this.negated,!1)}evaluate(E){for(let O=0,z=this.expr.length;O<z;O++)if(this.expr[O].evaluate(E))return!0;return!1}static _normalizeArr(E,O,z){let U=[],$=!1;if(E){for(let V=0,ue=E.length;V<ue;V++){const K=E[V];if(!!K){if(K.type===0){$=!0;continue}if(K.type===1)return p.INSTANCE;if(K.type===9){U=U.concat(K.expr);continue}U.push(K)}}if(U.length===0&&$)return i.INSTANCE;U.sort(w)}if(U.length!==0){if(U.length===1)return U[0];for(let V=1;V<U.length;V++)U[V-1].equals(U[V])&&(U.splice(V,1),V--);if(U.length===1)return U[0];if(z){for(let V=0;V<U.length;V++)for(let ue=V+1;ue<U.length;ue++)I(U[V],U[ue])&&(U.splice(ue,1),ue--);if(U.length===1)return U[0]}return new h(U,O)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let O of this.expr)E.push(...O.keys());return E}map(E){return new h(this.expr.map(O=>O.map(E)),null)}negate(){if(!this.negated){let E=[];for(let O of this.expr)E.push(O.negate());for(;E.length>1;){const O=E.shift(),z=E.shift(),U=[];for(const V of N(O))for(const ue of N(z))U.push(c.create([V,ue],null));const $=E.length===0;E.unshift(h.create(U,null,$))}this.negated=E[0]}return this.negated}}class v extends o{constructor(E,O,z){super(E,null);this._defaultValue=O,typeof z=="object"?v._info.push({...z,key:E}):z!==!0&&v._info.push({key:E,description:z,type:O!=null?typeof O:void 0})}static all(){return v._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return u.create(this.key,E)}notEqualsTo(E){return _.create(this.key,E)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function a(B,E){return B<E?-1:B>E?1:0}function S(B,E,O,z){return B<O?-1:B>O?1:E<z?-1:E>z?1:0}function I(B,E){if(E.type===6&&B.type!==9&&B.type!==6){for(const U of E.expr)if(B.equals(U))return!0}const O=B.negate(),z=N(O).concat(N(E));z.sort(w);for(let U=0;U<z.length;U++){const V=z[U].negate();for(let ue=U+1;ue<z.length;ue++){const K=z[ue];if(V.equals(K))return!0}}return!1}e.implies=I;function N(B){return B.type===9?B.expr:[B]}}),define(ye[135],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,s.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,s.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[46],_e([0,1,21,17,9,10,2,116,3]),function(Z,e,s,t,y,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function A(U){return U.create===!0}e.isFileOpenForWriteOptions=A;var R;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var w;(function(U){U[U.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var i;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead"})(i=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=p;function o(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=o;function u(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function d(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=d;function F(U){return p(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=F;var _;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(_=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor($,V){super($);this.code=V}}e.FileSystemProviderError=m;function f(U,$){const V=new m(U.toString(),$);return l(V,$),V}e.createFileSystemProviderError=f;function D(U){return U||f((0,P.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=D;function l(U,$){return U.name=$?`${$} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=l;function M(U){if(!U)return _.Unknown;if(U instanceof m)return U.code;const $=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!$)return _.Unknown;switch($[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileExceedsMemoryLimit:return _.FileExceedsMemoryLimit;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=M;function r(U){if(U instanceof v)return U.fileOperationResult;switch(M(U)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 10;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileExceedsMemoryLimit:return 9;case _.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var n;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class b{constructor($,V,ue){this.resource=$,this.operation=V,this.target=ue}isOperation($){return this.operation===$}}e.FileOperationEvent=b;var g;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(g=e.FileChangeType||(e.FileChangeType={}));class c{constructor($,V){this.added=void 0,this.updated=void 0,this.deleted=void 0;const ue=new Map;for(const K of $){const re=ue.get(K.type);re?re.push([K.resource,K]):ue.set(K.type,[[K.resource,K]])}for(const[K,re]of ue)switch(K){case 1:this.added=s.TernarySearchTree.forUris(()=>V),this.added.fill(re);break;case 0:this.updated=s.TernarySearchTree.forUris(()=>V),this.updated.fill(re);break;case 2:this.deleted=s.TernarySearchTree.forUris(()=>V),this.deleted.fill(re);break}}contains($,...V){return this.doContains($,{includeChildren:!1},...V)}affects($,...V){return this.doContains($,{includeChildren:!0},...V)}doContains($,V,...ue){if(!$)return!1;const K=ue.length>0;return!!((!K||ue.includes(1))&&(this.added?.get($)||V.includeChildren&&this.added?.findSuperstr($))||(!K||ue.includes(0))&&(this.updated?.get($)||V.includeChildren&&this.updated?.findSuperstr($))||(!K||ue.includes(2))&&(this.deleted?.findSubstr($)||V.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawUpdated(){return this.updated}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function h(U,$,V){return!U||!$||U===$||$.length>U.length?!1:($.charAt($.length-1)!==t.sep&&($+=t.sep),V?(0,y.startsWithIgnoreCase)(U,$):U.indexOf($)===0)}e.isParent=h;class v extends Error{constructor($,V,ue){super($);this.fileOperationResult=V,this.options=ue}}e.FileOperationError=v;class a extends v{constructor($,V,ue){super($,2,ue);this.stat=V}}e.NotModifiedSinceFileOperationError=a;var S;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(S=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=N;async function B(U,$){if(!$.hasProvider(k.URI.from({scheme:U.scheme})))return new Promise(V=>{const ue=$.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===U.scheme&&K.added&&(ue.dispose(),V())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class E{static formatSize($){return(0,T.isNumber)($)||($=0),$<E.KB?(0,P.localize)(1,null,$.toFixed(0)):$<E.MB?(0,P.localize)(2,null,($/E.KB).toFixed(2)):$<E.GB?(0,P.localize)(3,null,($/E.MB).toFixed(2)):$<E.TB?(0,P.localize)(4,null,($/E.GB).toFixed(2)):(0,P.localize)(5,null,($/E.TB).toFixed(2))}}e.ByteSize=E,E.KB=1024,E.MB=E.KB*E.KB,E.GB=E.MB*E.KB,E.TB=E.GB*E.KB;var O;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function z(U){return{maxFileSize:U===0?300*E.MB:16*E.GB,maxHeapSize:U===0?700*E.MB:2*700*E.MB}}e.getPlatformLimits=z}),define(ye[60],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class s{constructor(...y){this._entries=new Map;for(let[T,k]of y)this.set(T,k)}set(y,T){const k=this._entries.get(y);return this._entries.set(y,T),k}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=s}),define(ye[136],_e([0,1,14,15,80,132,3,60]),function(Z,e,s,t,y,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class A extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class R{constructor(o=new P.ServiceCollection,u=!1,d){this._activeInstantiations=new Set,this._services=o,this._strict=u,this._parent=d,this._services.set(k.IInstantiationService,this)}createChild(o){return new R(o,this._strict,this)}invokeFunction(o,...u){let d=i.traceInvocation(o),F=!1;try{return o({get:m=>{if(F)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(m,d);if(!f)throw new Error(`[invokeFunction] unknown service '${m}'`);return f}},...u)}finally{F=!0,d.stop()}}createInstance(o,...u){let d,F;return o instanceof y.SyncDescriptor?(d=i.traceCreation(o.ctor),F=this._createInstance(o.ctor,o.staticArguments.concat(u),d)):(d=i.traceCreation(o),F=this._createInstance(o,u,d)),d.stop(),F}_createInstance(o,u=[],d){let F=k._util.getServiceDependencies(o).sort((f,D)=>f.index-D.index),_=[];for(const f of F){let D=this._getOrCreateServiceInstance(f.id,d);if(!D&&this._strict&&!f.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${f.id}.`);_.push(D)}let m=F.length>0?F[0].index:u.length;if(u.length!==m){console.warn(`[createInstance] First service dependency of ${o.name} at position ${m+1} conflicts with ${u.length} static arguments`);let f=m-u.length;f>0?u=u.concat(new Array(f)):u=u.slice(0,m)}return new o(...[...u,..._])}_setServiceInstance(o,u){if(this._services.get(o)instanceof y.SyncDescriptor)this._services.set(o,u);else if(this._parent)this._parent._setServiceInstance(o,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let u=this._services.get(o);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):u}_getOrCreateServiceInstance(o,u){let d=this._getServiceInstanceOrDescriptor(o);return d instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,d,u.branch(o,!0)):(u.branch(o,!1),d)}_safeCreateAndCacheServiceInstance(o,u,d){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,u,d)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,u,d){const F=new T.Graph(f=>f.id.toString());let _=0;const m=[{id:o,desc:u,_trace:d}];for(;m.length;){const f=m.pop();if(F.lookupOrInsertNode(f),_++>1e3)throw new A(F);for(let D of k._util.getServiceDependencies(f.desc.ctor)){let l=this._getServiceInstanceOrDescriptor(D.id);if(!l&&!D.optional&&console.warn(`[createInstance] ${o} depends on ${D.id} which is NOT registered.`),l instanceof y.SyncDescriptor){const M={id:D.id,desc:l,_trace:f._trace.branch(D.id,!0)};F.insertEdge(f,M),m.push(M)}}}for(;;){const f=F.roots();if(f.length===0){if(!F.isEmpty())throw new A(F);break}for(const{data:D}of f){if(this._getServiceInstanceOrDescriptor(D.id)instanceof y.SyncDescriptor){const M=this._createServiceInstanceWithOwner(D.id,D.desc.ctor,D.desc.staticArguments,D.desc.supportsDelayedInstantiation,D._trace);this._setServiceInstance(D.id,M)}F.removeNode(D)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,u,d=[],F,_){if(this._services.get(o)instanceof y.SyncDescriptor)return this._createServiceInstance(u,d,F,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,u,d,F,_);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(o,u=[],d,F){if(d){const _=new s.IdleValue(()=>this._createInstance(o,u,F));return new Proxy(Object.create(null),{get(m,f){if(f in m)return m[f];let D=_.value,l=D[f];return typeof l!="function"||(l=l.bind(D),m[f]=l),l},set(m,f,D){return _.value[f]=D,!0}})}else return this._createInstance(o,u,F)}}e.InstantiationService=R;var w;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(w||(w={}));class i{constructor(o,u){this.type=o,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return C?new i(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):i._None}static traceCreation(o){return C?new i(0,o.name):i._None}branch(o,u){let d=new i(2,o.toString());return this._dep.push([o,u,d]),d}stop(){let o=Date.now()-this._start;i._totals+=o;let u=!1;function d(_,m){let f=[],D=new Array(_+1).join("	");for(const[l,M,r]of m._dep)if(M&&r){u=!0,f.push(`${D}CREATES -> ${l}`);let n=d(_+1,r);n&&f.push(n)}else f.push(`${D}uses -> ${l}`);return f.join(`
`)}let F=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${i._totals.toFixed(2)}ms)`];(o>2||u)&&console.log(F.join(`
`))}}i._None=new class extends i{constructor(){super(-1,null)}stop(){}branch(){return this}},i._totals=0}),define(ye[12],_e([0,1,43,4,6,23,3]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function P(){return new Date().toISOString()}var C;(function(M){M[M.Trace=0]="Trace",M[M.Debug=1]="Debug",M[M.Info=2]="Info",M[M.Warning=3]="Warning",M[M.Error=4]="Error",M[M.Critical=5]="Critical",M[M.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function A(M,r,n){switch(r){case C.Trace:M.trace(n);break;case C.Debug:M.debug(n);break;case C.Info:M.info(n);break;case C.Warning:M.warn(n);break;case C.Error:M.error(n);break;case C.Critical:M.critical(n);break;default:throw new Error("Invalid log level")}}e.log=A;function R(M){let r="";for(let n=0;n<M.length;n++){let b=M[n];if(typeof b=="object")try{b=JSON.stringify(b)}catch{}r+=(n>0?" ":"")+b}return r}e.format=R;class w extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class i extends w{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...n){this.checkLogLevel(C.Trace)&&this.log(C.Trace,R([r,...n]))}debug(r,...n){this.checkLogLevel(C.Debug)&&this.log(C.Debug,R([r,...n]))}info(r,...n){this.checkLogLevel(C.Info)&&this.log(C.Info,R([r,...n]))}warn(r,...n){this.checkLogLevel(C.Warning)&&this.log(C.Warning,R([r,...n]))}error(r,...n){if(this.checkLogLevel(C.Error))if(r instanceof Error){const b=Array.prototype.slice.call(arguments);b[0]=r.stack,this.log(C.Error,R(b))}else this.log(C.Error,R([r,...n]))}critical(r,...n){this.checkLogLevel(C.Critical)&&this.log(C.Critical,R([r,...n]))}flush(){}}e.AbstractMessageLogger=i;class p extends w{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!T.isWindows}trace(r,...n){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...n):console.log(`[main ${P()}]`,r,...n))}debug(r,...n){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...n):console.log(`[main ${P()}]`,r,...n))}info(r,...n){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...n):console.log(`[main ${P()}]`,r,...n))}warn(r,...n){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,r,...n):console.warn(`[main ${P()}]`,r,...n))}error(r,...n){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,r,...n):console.error(`[main ${P()}]`,r,...n))}critical(r,...n){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,r,...n):console.error(`[main ${P()}]`,r,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class o extends w{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...n){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",r,...n)}debug(r,...n){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...n)}info(r,...n){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",r,...n)}warn(r,...n){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",r,...n)}error(r,...n){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",r,...n)}critical(r,...n){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...n)}dispose(){}flush(){}}e.ConsoleLogger=o;class u extends w{constructor(r,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(n)}trace(r,...n){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(r),...n])}debug(r,...n){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(r),...n])}info(r,...n){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(r),...n])}warn(r,...n){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(r),...n])}error(r,...n){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(r),...n])}critical(r,...n){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(r),...n])}extractMessage(r){return typeof r=="string"?r:(0,s.toErrorMessage)(r,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class d extends w{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const n of this.logServices)n.setLevel(r);super.setLevel(r)}trace(r,...n){for(const b of this.logServices)b.trace(r,...n)}debug(r,...n){for(const b of this.logServices)b.debug(r,...n)}info(r,...n){for(const b of this.logServices)b.info(r,...n)}warn(r,...n){for(const b of this.logServices)b.warn(r,...n)}error(r,...n){for(const b of this.logServices)b.error(r,...n)}critical(r,...n){for(const b of this.logServices)b.critical(r,...n)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=d;class F extends y.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...n){this.logger.trace(r,...n)}debug(r,...n){this.logger.debug(r,...n)}info(r,...n){this.logger.info(r,...n)}warn(r,...n){this.logger.warn(r,...n)}error(r,...n){this.logger.error(r,...n)}critical(r,...n){this.logger.critical(r,...n)}flush(){this.logger.flush()}}e.LogService=F;class _ extends y.Disposable{constructor(r,n){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(b=>{this.logLevel=b,this.logLevelChangeableLoggers.forEach(g=>g.setLevel(b))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,n){let b=this.loggers.get(r.toString());return b||(b=this.doCreateLogger(r,n?.always?C.Trace:this.logLevel,n),this.loggers.set(r.toString(),b),n?.always||this.logLevelChangeableLoggers.push(b)),b}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class m{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return C.Info}trace(r,...n){}debug(r,...n){}info(r,...n){}warn(r,...n){}error(r,...n){}critical(r,...n){}dispose(){}flush(){}}e.NullLogService=m;function f(M){if(M.verbose)return C.Trace;if(typeof M.logLevel=="string"){const r=D(M.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function D(M){switch(M){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=D;function l(M){switch(M){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=l}),define(ye[82],_e([0,1,34,117,3]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var k;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function A(o,u){return u-o}C.compare=A;const R=Object.create(null);R[C.Error]=(0,t.localize)(0,null),R[C.Warning]=(0,t.localize)(1,null),R[C.Info]=(0,t.localize)(2,null);function w(o){return R[o]||""}C.toString=w;function i(o){switch(o){case s.default.Error:return C.Error;case s.default.Warning:return C.Warning;case s.default.Info:return C.Info;case s.default.Ignore:return C.Hint}}C.fromSeverity=i;function p(o){switch(o){case C.Error:return s.default.Error;case C.Warning:return s.default.Warning;case C.Info:return s.default.Info;case C.Hint:return s.default.Ignore}}C.toSeverity=p}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(C){const A="";function R(i){return w(i,!0)}C.makeKey=R;function w(i,p){let o=[A];return i.source?o.push(i.source.replace("\xA6","\\\xA6")):o.push(A),i.code?typeof i.code=="string"?o.push(i.code.replace("\xA6","\\\xA6")):o.push(i.code.value.replace("\xA6","\\\xA6")):o.push(A),i.severity!==void 0&&i.severity!==null?o.push(k.toString(i.severity)):o.push(A),i.message&&p?o.push(i.message.replace("\xA6","\\\xA6")):o.push(A),i.startLineNumber!==void 0&&i.startLineNumber!==null?o.push(i.startLineNumber.toString()):o.push(A),i.startColumn!==void 0&&i.startColumn!==null?o.push(i.startColumn.toString()):o.push(A),i.endLineNumber!==void 0&&i.endLineNumber!==null?o.push(i.endLineNumber.toString()):o.push(A),i.endColumn!==void 0&&i.endColumn!==null?o.push(i.endColumn.toString()):o.push(A),o.push(A),o.join("\xA6")}C.makeKeyOptionalMessage=w})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(ye[137],_e([0,1,4,34,3]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,y.createDecorator)("notificationService");var T;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new C,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=P;class C{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=C}),define(ye[138],_e([0,1,6,9,2,3]),function(Z,e,s,t,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return s.Disposable.None},registerValidator(){return s.Disposable.None},registerExternalUriResolver(){return s.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return s.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function k(C,A){return y.URI.isUri(C)?(0,t.equalsIgnoreCase)(C.scheme,A):(0,t.startsWithIgnoreCase)(C,A+":")}e.matchesScheme=k;function P(C,...A){return A.some(R=>k(C,R))}e.matchesSomeScheme=P});var Be=this&&this.__decorate||function(Z,e,s,t){var y=arguments.length,T=y<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,s):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Z,e,s,t);else for(var P=Z.length-1;P>=0;P--)(k=Z[P])&&(T=(y<3?k(T):y>3?k(e,s,T):k(e,s))||T);return y>3&&T&&Object.defineProperty(e,s,T),T},He=this&&this.__param||function(Z,e){return function(s,t){e(s,t,Z)}};define(ye[139],_e([0,1,14,20,6,3]),function(Z,e,s,t,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var k;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(w){this.callback=w}get value(){return this._value}report(w){this._value=w,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let C=class extends y.Disposable{constructor(w,i){super();this.deferred=new s.DeferredPromise,i.withProgress(w,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(w){this.reporter?this.reporter.report(w):this.lastStep=w}};C=Be([He(1,e.IProgressService)],C),e.UnmanagedProgress=C;class A extends y.Disposable{constructor(w){super();this.progressIndicator=w,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(w){this.stop();const i=++this.currentOperationId,p=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{i===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},w),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:i,token:p.token,stop:()=>this.doStop(i),isCurrent:()=>this.currentOperationId===i}}stop(){this.doStop(this.currentOperationId)}doStop(w){this.currentOperationId===w&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(ye[37],_e([0,1,42,10]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(k,P){s.ok(t.isString(k)),s.ok(t.isObject(P)),s.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new y}),define(ye[140],_e([0,1,4,37]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new s.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,A){this.schemasById[y(C)]=A,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new T;t.Registry.add(e.Extensions.JSONContribution,k)}),define(ye[83],_e([0,1,16,4,10,114,140,37]),function(Z,e,s,t,y,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=P.Registry.as(k.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(D,l=!0){this.registerConfigurations([D],l)}registerConfigurations(D,l=!0){const M=this.doRegisterConfigurations(D,l);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:M})}deregisterConfigurations(D){const l=this.doDeregisterConfigurations(D);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:D,remove:l}){const M=[];M.push(...this.doDeregisterConfigurations(l)),M.push(...this.doRegisterConfigurations(D,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,s.distinct)(M)})}registerDefaultConfigurations(D){const l=[],M=[];for(const{overrides:r,source:n}of D)for(const b in r)if(l.push(b),e.OVERRIDE_PROPERTY_REGEX.test(b)){const g={...this.configurationDefaultsOverrides.get(b)?.value||{},...r[b]};this.configurationDefaultsOverrides.set(b,{source:n,value:g});const c={type:"object",default:g,description:T.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:y.isString(n)?void 0:n};M.push(...o(b)),this.configurationProperties[b]=c,this.defaultLanguageConfigurationOverridesNode.properties[b]=c}else{this.configurationDefaultsOverrides.set(b,{value:r[b],source:n});const g=this.configurationProperties[b];g&&(this.updatePropertyDefaultValue(b,g),this.updateSchema(b,g))}this.registerOverrideIdentifiers(M),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(D){const l=[];for(const{overrides:M,source:r}of D)for(const n in M){const b=this.configurationDefaultsOverrides.get(n),g=y.isString(r)?r:r?.id,c=y.isString(b?.source)?b?.source:b?.source?.id;if(g===c)if(l.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const h=this.configurationProperties[n];h&&(this.updatePropertyDefaultValue(n,h),this.updateSchema(n,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...D){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(D){for(const l of D)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(D,l){const M=[];return D.forEach(r=>{M.push(...this.validateAndRegisterProperties(r,l,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),M}doDeregisterConfigurations(D){const l=[],M=r=>{if(r.properties)for(const n in r.properties)l.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,r.properties[n]);r.allOf&&r.allOf.forEach(n=>M(n))};for(const r of D){M(r);const n=this.configurationContributors.indexOf(r);n!==-1&&this.configurationContributors.splice(n,1)}return l}validateAndRegisterProperties(D,l=!0,M,r,n=3){n=y.isUndefinedOrNull(D.scope)?n:D.scope;let b=[],g=D.properties;if(g)for(let h in g){if(l&&_(h)){delete g[h];continue}const v=g[h];if(v.source=M,v.defaultDefaultValue=g[h].default,this.updatePropertyDefaultValue(h,v),e.OVERRIDE_PROPERTY_REGEX.test(h)?v.scope=void 0:(v.scope=y.isUndefinedOrNull(v.scope)?n:v.scope,v.restricted=y.isUndefinedOrNull(v.restricted)?!!r?.includes(h):v.restricted),g[h].hasOwnProperty("included")&&!g[h].included){this.excludedConfigurationProperties[h]=g[h],delete g[h];continue}else this.configurationProperties[h]=g[h];!g[h].deprecationMessage&&g[h].markdownDeprecationMessage&&(g[h].deprecationMessage=g[h].markdownDeprecationMessage),b.push(h)}let c=D.allOf;if(c)for(let h of c)b.push(...this.validateAndRegisterProperties(h,l,M,r,n));return b}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(D){const l=M=>{let r=M.properties;if(r)for(const b in r)this.updateSchema(b,r[b]);let n=M.allOf;n&&n.forEach(l)};l(D)}updateSchema(D,l){switch(e.allSettings.properties[D]=l,l.scope){case 1:e.applicationSettings.properties[D]=l;break;case 2:e.machineSettings.properties[D]=l;break;case 6:e.machineOverridableSettings.properties[D]=l;break;case 3:e.windowSettings.properties[D]=l;break;case 4:e.resourceSettings.properties[D]=l;break;case 5:e.resourceSettings.properties[D]=l,this.resourceLanguageSettingsSchema.properties[D]=l;break}}removeFromSchema(D,l){switch(delete e.allSettings.properties[D],l.scope){case 1:delete e.applicationSettings.properties[D];break;case 2:delete e.machineSettings.properties[D];break;case 6:delete e.machineOverridableSettings.properties[D];break;case 3:delete e.windowSettings.properties[D];break;case 4:case 5:delete e.resourceSettings.properties[D],delete this.resourceLanguageSettingsSchema.properties[D];break}}updateOverridePropertyPatternKey(){for(const D of this.overrideIdentifiers.values()){const l=`[${D}]`,M={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,M),e.allSettings.properties[l]=M,e.applicationSettings.properties[l]=M,e.machineSettings.properties[l]=M,e.machineOverridableSettings.properties[l]=M,e.windowSettings.properties[l]=M,e.resourceSettings.properties[l]=M}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const D={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(D,l){const M=this.configurationDefaultsOverrides.get(D);let r=M?.value,n=M?.source;y.isUndefined(r)&&(r=l.defaultDefaultValue,n=void 0),y.isUndefined(r)&&(r=d(l.type)),l.default=r,l.defaultValueSource=n}}const i="\\[([^\\]]+)\\]",p=new RegExp(i,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${i})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function o(f){const D=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let l=p.exec(f);for(;l?.length;){const M=l[1].trim();M&&D.push(M),l=p.exec(f)}}return(0,s.distinct)(D)}e.overrideIdentifiersFromKey=o;function u(f){return f.reduce((D,l)=>`${D}[${l}]`,"")}e.keyFromOverrideIdentifiers=u;function d(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const F=new w;P.Registry.add(e.Extensions.Configuration,F);function _(f){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?T.localize(7,null,f):F.getConfigurationProperties()[f]!==void 0?T.localize(8,null,f):null:T.localize(6,null)}e.validateProperty=_;function m(){const f=[],D=F.getConfigurationProperties();for(const l of Object.keys(D))f.push([l,D[l].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=m}),define(ye[141],_e([0,1,16,4,100,6,21,26,10,2,81,83,37]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(r={},n=[],b=[]){this._contents=r,this._keys=n,this._overrides=b,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,n){const b=this.getContentsForOverrideIdentifer(n);return b?r?(0,R.getConfigurationValue)(b,r):b:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const b of this.overrides)b.identifiers.includes(r)&&n.push(...b.keys);return s.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return s.distinct(r)}override(r){let n=this.overrideConfigurations.get(r);return n||(n=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,n)),n}merge(...r){const n=P.deepClone(this.contents),b=P.deepClone(this.overrides),g=[...this.keys];for(const c of r){this.mergeContents(n,c.contents);for(const h of c.overrides){const[v]=b.filter(a=>s.equals(a.identifiers,h.identifiers));v?(this.mergeContents(v.contents,h.contents),v.keys.push(...h.keys),v.keys=s.distinct(v.keys)):b.push(P.deepClone(h))}for(const h of c.keys)g.indexOf(h)===-1&&g.push(h)}return new p(n,g,b)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const n=this.getContentsForOverrideIdentifer(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let b={};for(const g of s.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[g],h=n[g];h&&(typeof c=="object"&&typeof h=="object"?(c=P.deepClone(c),this.mergeContents(c,h)):c=h),b[g]=c}return new p(b,this.keys,this.overrides)}mergeContents(r,n){for(const b of Object.keys(n)){if(b in r&&C.isObject(r[b])&&C.isObject(n[b])){this.mergeContents(r[b],n[b]);continue}r[b]=P.deepClone(n[b])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?P.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let n=null,b=null;const g=c=>{c&&(b?this.mergeContents(b,c):b=P.deepClone(c))};for(const c of this.overrides)s.equals(c.identifiers,[r])?n=c.contents:c.identifiers.includes(r)&&g(c.contents);return g(n),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.addKey(r),(0,R.addToValueTree)(this.contents,r,n,b=>{throw new Error(b)})}removeValue(r){this.removeKey(r)&&(0,R.removeFromValueTree)(this.contents,r)}addKey(r){let n=this.keys.length;for(let b=0;b<n;b++)r.indexOf(this.keys[b])===0&&(n=b);this.keys.splice(n,1,r)}removeKey(r){let n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class o extends p{constructor(r={}){const n=i.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),b=Object.keys(n),g=Object.create(null),c=[];for(const h in n){const v=r[h],a=v!==void 0?v:n[h].default;(0,R.addToValueTree)(g,h,a,S=>console.error(`Conflict in default settings: ${S}`))}for(const h of Object.keys(g))w.OVERRIDE_PROPERTY_REGEX.test(h)&&c.push({identifiers:(0,w.overrideIdentifiersFromKey)(h),keys:Object.keys(g[h]),contents:(0,R.toValuesTree)(g[h],v=>console.error(`Conflict in default settings file: ${v}`))});super(g,b,c)}}e.DefaultConfigurationModel=o;class u{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,n){if(!C.isUndefinedOrNull(r)){const b=this.doParseContent(r);this.parseRaw(b,n)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,n){this._raw=r;const{contents:b,keys:g,overrides:c,restricted:h}=this.doParseRaw(r,n);this._configurationModel=new p(b,g,c),this._restrictedConfigurations=h||[]}doParseContent(r){let n={},b=null,g=[],c=[],h=[];function v(S){Array.isArray(g)?g.push(S):b!==null&&(g[b]=S)}let a={onObjectBegin:()=>{let S={};v(S),c.push(g),g=S,b=null},onObjectProperty:S=>{b=S},onObjectEnd:()=>{g=c.pop()},onArrayBegin:()=>{let S=[];v(S),c.push(g),g=S,b=null},onArrayEnd:()=>{g=c.pop()},onLiteralValue:v,onError:(S,I,N)=>{h.push({error:S,offset:I,length:N})}};if(r)try{y.visit(r,a),n=g[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return n}doParseRaw(r,n){const b=i.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),g=this.filter(r,b,!0,n);r=g.raw;const c=(0,R.toValuesTree)(r,a=>console.error(`Conflict in settings file ${this._name}: ${a}`)),h=Object.keys(r),v=this.toOverrides(r,a=>console.error(`Conflict in settings file ${this._name}: ${a}`));return{contents:c,keys:h,overrides:v,restricted:g.restricted}}filter(r,n,b,g){if(!g?.scopes&&!g?.skipRestricted)return{raw:r,restricted:[]};const c={},h=[];for(let v in r)if(w.OVERRIDE_PROPERTY_REGEX.test(v)&&b){const a=this.filter(r[v],n,!1,g);c[v]=a.raw,h.push(...a.restricted)}else{const a=n[v],S=a?typeof a.scope!="undefined"?a.scope:3:void 0;a?.restricted&&h.push(v),(S===void 0||g.scopes===void 0||g.scopes.includes(S))&&(g.skipRestricted&&a?.restricted||(c[v]=r[v]))}return{raw:c,restricted:h}}toOverrides(r,n){const b=[];for(const g of Object.keys(r))if(w.OVERRIDE_PROPERTY_REGEX.test(g)){const c={};for(const h in r[g])c[h]=r[g][h];b.push({identifiers:(0,w.overrideIdentifiersFromKey)(g),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,n)})}return b}}e.ConfigurationModelParser=u;class d extends T.Disposable{constructor(r,n,b,g){super();this.userSettingsResource=r,this.scopes=n,this.fileService=g,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(b.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class F{constructor(r,n,b=new p,g=new p,c=new k.ResourceMap,h=new p,v=new k.ResourceMap,a=!0){this._defaultConfiguration=r,this._localUserConfiguration=n,this._remoteUserConfiguration=b,this._workspaceConfiguration=g,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=v,this._freeze=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(r,n,b){return this.getConsolidateConfigurationModel(n,b).getValue(r)}updateValue(r,n,b={}){let g;b.resource?(g=this._memoryConfigurationByResource.get(b.resource),g||(g=new p,this._memoryConfigurationByResource.set(b.resource,g))):g=this._memoryConfiguration,n===void 0?g.removeValue(r):g.setValue(r,n),b.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,n,b){const g=this.getConsolidateConfigurationModel(n,b),c=this.getFolderConfigurationModelForResource(n.resource,b),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,v=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),a=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),S=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),I=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),N=b?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,B=c?n.overrideIdentifier?c.freeze().override(n.overrideIdentifier).getValue(r):c.freeze().getValue(r):void 0,E=n.overrideIdentifier?h.override(n.overrideIdentifier).getValue(r):h.getValue(r),O=g.getValue(r),z=s.distinct(s.flatten(g.overrides.map(U=>U.identifiers))).filter(U=>g.getOverrideValue(r,U)!==void 0);return{defaultValue:v,userValue:a,userLocalValue:S,userRemoteValue:I,workspaceValue:N,workspaceFolderValue:B,memoryValue:E,value:O,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,user:a!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userRemote:I!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:c?.freeze().getValue(r),override:n.overrideIdentifier?c?.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,memory:E!==void 0?{value:h.getValue(r),override:n.overrideIdentifier?h.getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(r){const n=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,n){this._folderConfigurations.set(r,n),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const b=[];if(!n){const{added:g,updated:c,removed:h}=D(this._defaultConfiguration,r);n=[...g,...c,...h]}for(const g of n)for(const c of(0,w.overrideIdentifiersFromKey)(g)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(c),v=r.getKeysForOverrideIdentifier(c),a=[...v.filter(S=>h.indexOf(S)===-1),...h.filter(S=>v.indexOf(S)===-1),...h.filter(S=>!P.equals(this._defaultConfiguration.override(c).getValue(S),r.override(c).getValue(S)))];b.push([c,a])}return this.updateDefaultConfiguration(r),{keys:n,overrides:b}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:b,removed:g,overrides:c}=D(this.localUserConfiguration,r),h=[...n,...b,...g];return h.length&&this.updateLocalUserConfiguration(r),{keys:h,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:b,removed:g,overrides:c}=D(this.remoteUserConfiguration,r);let h=[...n,...b,...g];return h.length&&this.updateRemoteUserConfiguration(r),{keys:h,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:b,removed:g,overrides:c}=D(this.workspaceConfiguration,r);let h=[...n,...b,...g];return h.length&&this.updateWorkspaceConfiguration(r),{keys:h,overrides:c}}compareAndUpdateFolderConfiguration(r,n){const b=this.folderConfigurations.get(r),{added:g,updated:c,removed:h,overrides:v}=D(b,n);let a=[...g,...c,...h];return(a.length||!b)&&this.updateFolderConfiguration(r,n),{keys:a,overrides:v}}compareAndDeleteFolderConfiguration(r){const n=this.folderConfigurations.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:b,updated:g,removed:c,overrides:h}=D(n,void 0);return{keys:[...b,...g,...c],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,n){let b=this.getConsolidatedConfigurationModelForResource(r,n);return r.overrideIdentifier?b.override(r.overrideIdentifier):b}getConsolidatedConfigurationModelForResource({resource:r},n){let b=this.getWorkspaceConsolidatedConfiguration();if(n&&r){const g=n.getFolder(r);g&&(b=this.getFolderConsolidatedConfiguration(g.uri)||b);const c=this._memoryConfigurationByResource.get(r);c&&(b=b.merge(c))}return b}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let n=this._foldersConsolidatedConfigurations.get(r);if(!n){const b=this.getWorkspaceConsolidatedConfiguration(),g=this._folderConfigurations.get(r);g?(n=b.merge(g),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(r,n)):n=b}return n}getFolderConfigurationModelForResource(r,n){if(n&&r){const b=n.getFolder(r);if(b)return this._folderConfigurations.get(b.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,n)=>{const{contents:b,overrides:g,keys:c}=this._folderConfigurations.get(n);return r.push([n,{contents:b,overrides:g,keys:c}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(b=>r.add(b))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(b=>r.add(b))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(b=>n.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(b=>n.add(b)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(b=>n.add(b)),this._folderConfigurations.forEach(b=>b.getKeysForOverrideIdentifier(r).forEach(g=>n.add(g))),[...n.values()]}static parse(r){const n=this.parseConfigurationModel(r.defaults),b=this.parseConfigurationModel(r.user),g=this.parseConfigurationModel(r.workspace),c=r.folders.reduce((h,v)=>(h.set(A.URI.revive(v[0]),this.parseConfigurationModel(v[1])),h),new k.ResourceMap);return new F(n,b,new p,g,c,new p,new k.ResourceMap,!1)}static parseConfigurationModel(r){return new p(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=F;function _(...M){if(M.length===0)return{keys:[],overrides:[]};if(M.length===1)return M[0];const r=new Set,n=new Map;for(const g of M)g.keys.forEach(c=>r.add(c)),g.overrides.forEach(([c,h])=>{const v=(0,k.getOrSet)(n,c,new Set);h.forEach(a=>v.add(a))});const b=[];return n.forEach((g,c)=>b.push([c,[...g.values()]])),{keys:[...r.values()],overrides:b}}e.mergeChanges=_;class m{constructor(r,n,b,g){this.change=r,this.previous=n,this.currentConfiguraiton=b,this.currentWorkspace=g,this._previousConfiguration=void 0;const c=new Set;r.keys.forEach(v=>c.add(v)),r.overrides.forEach(([,v])=>v.forEach(a=>c.add(a))),this.affectedKeys=[...c.values()];const h=new p;this.affectedKeys.forEach(v=>h.setValue(v,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=F.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(n){const b=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.previous?.workspace):void 0,g=this.currentConfiguraiton.getValue(r,n,this.currentWorkspace);return!P.equals(b,g)}return!0}return!1}doesAffectedKeysTreeContains(r,n){let b=(0,R.toValuesTree)({[n]:!0},()=>{}),g;for(;typeof b=="object"&&(g=Object.keys(b)[0]);){if(r=r[g],!r)return!1;b=b[g]}return!0}}e.ConfigurationChangeEvent=m;class f extends m{constructor(r,n,b,g){super({keys:r.allKeys(),overrides:[]},void 0,r,n);this.source=b,this.sourceConfig=g}}e.AllKeysConfigurationChangeEvent=f;function D(M,r){const{added:n,removed:b,updated:g}=l(r,M),c=[],h=M?.getAllOverrideIdentifiers()||[],v=r?.getAllOverrideIdentifiers()||[];if(r){const a=v.filter(S=>!h.includes(S));for(const S of a)c.push([S,r.getKeysForOverrideIdentifier(S)])}if(M){const a=h.filter(S=>!v.includes(S));for(const S of a)c.push([S,M.getKeysForOverrideIdentifier(S)])}if(r&&M){for(const a of h)if(v.includes(a)){const S=l({contents:M.getOverrideValue(void 0,a)||{},keys:M.getKeysForOverrideIdentifier(a)},{contents:r.getOverrideValue(void 0,a)||{},keys:r.getKeysForOverrideIdentifier(a)});c.push([a,[...S.added,...S.removed,...S.updated]])}}return{added:n,removed:b,updated:g,overrides:c}}function l(M,r){const n=M?r?M.keys.filter(c=>r.keys.indexOf(c)===-1):[...M.keys]:[],b=r?M?r.keys.filter(c=>M.keys.indexOf(c)===-1):[...r.keys]:[],g=[];if(M&&r){for(const c of r.keys)if(M.keys.indexOf(c)!==-1){const h=(0,R.getConfigurationValue)(r.contents,c),v=(0,R.getConfigurationValue)(M.contents,c);P.equals(h,v)||g.push(c)}}return{added:n,removed:b,updated:g}}}),define(ye[84],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,s.createDecorator)("remoteAuthorityResolverService");var t;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class y extends Error{constructor(k,P=t.Unknown,C){super(k);this._message=k,this._code=P,this._detail=C,this.isHandled=P===t.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype)}static isTemporarilyNotAvailable(k){return k instanceof y&&k._code===t.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof y&&k._code===t.NoResolverFound}static isHandled(k){return k instanceof y&&k.isHandled}}e.RemoteAuthorityResolverError=y}),define(ye[61],_e([0,1,11]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(A){return A.scheme===s.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=t;function y(A){if(!A)return;const R=A.indexOf("+");return R<0?A:A.substr(0,R)}e.getRemoteName=y;function T(A){return A.scheme!==s.Schemas.file&&A.scheme!==s.Schemas.vscodeRemote}e.isVirtualResource=T;function k(A){if(A.folders.length)return A.folders.every(R=>T(R.uri))?A.folders[0].uri:void 0;if(A.configuration&&T(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=k;function P(A){return k(A)?.scheme}e.getVirtualWorkspaceScheme=P;function C(A){return k(A)!==void 0}e.isVirtualWorkspace=C}),define(ye[25],_e([0,1,9,3,61]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=T;function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class C{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,o){if(typeof p=="undefined"||p===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof p=="string"||typeof o=="string"){let u=typeof p=="string"?p:p.value,d=typeof o=="string"?o:o.value;return s.equalsIgnoreCase(u,d)}return p._lower===o._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=C;function A(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=A;function R(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function w(i,p){if(p){const o=`onResolveRemoteAuthority:${(0,y.getRemoteName)(p)}`;return i.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=w,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[142],_e([0,1,9,25]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function y(o,u){return o.uuid&&u.uuid?o.uuid===u.uuid:o.id===u.id?!0:(0,s.compareIgnoreCase)(o.id,u.id)===0}e.areSameExtensions=y;class T{constructor(u,d){this.version=d,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof T?y(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=T;function k(o,u){return`${o}.${u}`}e.getExtensionId=k;function P(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function C(o,u){return P(k(o,u))}e.getGalleryExtensionId=C;function A(o,u){const d=[],F=_=>{for(const m of d)if(m.some(f=>y(u(f),u(_))))return m;return null};for(const _ of o){const m=F(_);m?m.push(_):d.push([_])}return d}e.groupByExtension=A;function R(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function w(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function i(o){const u=new Set;if(o.malicious)for(const d of o.malicious)u.add(d.id);return u}e.getMaliciousExtensionsSet=i;function p(o,u){const d=[],F=u.manifest.extensionDependencies?.slice(0)??[];for(;F.length;){const _=F.shift();if(_&&d.every(m=>!y(m.identifier,{id:_}))){const m=o.filter(f=>y(f.identifier,{id:_}));m.length===1&&(d.push(m[0]),F.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=p}),define(ye[143],_e([0,1,4,23,3,12]),function(Z,e,s,t,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var k;(function(o){o.Http="http",o.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function A(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=w;function i(o,u){return u?u!==1&&o<1024:!t.isWindows&&o<1024}e.isPortPrivileged=i;let p=class{constructor(u){this.logService=u,this._onTunnelOpened=new s.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new s.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new s.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u,d){return this._tunnelProvider=u,u?(this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],d=Array.from(this._tunnels.values());for(let F of d){const _=Array.from(F.values());for(let m of _){const f=await m.value;f&&u.push(f)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:d}of u.values())await d.then(F=>F?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,d,F,_,m=!1,f=P.Private,D){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${F} on local port ${_}.`),!u)return;d||(d="localhost");const l=this.retainOrCreateTunnel(u,d,F,_,m,f,D);return l?l.then(M=>{if(!M){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,F);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(M);return(M.tunnelRemoteHost!==d||M.tunnelRemotePort!==F)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const d=this._tunnels.get(u.tunnelRemoteHost);if(d){const F=d.get(u.tunnelRemotePort);F&&(F.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,F))}}}}async tryDisposeTunnel(u,d,F){if(F.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${d}.`);const _=F.value.then(async m=>{m&&(await m.dispose(!0),this._onTunnelClosed.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(d),_}}async closeTunnel(u,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${d} `);const F=this._tunnels.get(u);if(F&&F.has(d)){const _=F.get(d);_.refcount=0,await this.tryDisposeTunnel(u,d,_)}}addTunnelToMap(u,d,F){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(d,{refcount:1,value:F})}async removeEmptyTunnelFromMap(u,d){const F=this._tunnels.get(u);F&&(await F.get(d)||F.delete(d),F.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,d){let F=[u];R(u)?(F.push(...e.LOCALHOST_ADDRESSES),F.push(...e.ALL_INTERFACES_ADDRESSES)):w(u)&&F.push(...e.ALL_INTERFACES_ADDRESSES);const _=F.map(m=>this._tunnels.get(m));for(const m of _){const f=m?.get(d);if(f)return f}}canTunnel(u){return!!A(u)}createWithProvider(u,d,F,_,m,f,D){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${F} on local port ${_}.`);const M={elevationRequired:m?i(_===void 0?F:_):!1},r={remoteAddress:{host:d,port:F},localAddressPort:_,privacy:f,public:f!==P.Private,protocol:D},n=u.forwardPort(r,M);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(d,F,n),n}};p=Be([He(0,T.ILogService)],p),e.AbstractTunnelService=p}),define(ye[144],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class s{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,T,k=5){let P;return P=T(C=>{const A=typeof C=="string"?C:C.data;let R=this._terminalBufferMap.get(y);if(R){R.data.push(A);return}const w=setTimeout(()=>this.flushBuffer(y),k);R={data:[A],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(y),P.dispose()}},this._terminalBufferMap.set(y,R)}),P}stopBuffering(y){const T=this._terminalBufferMap.get(y);T&&T.dispose()}flushBuffer(y){const T=this._terminalBufferMap.get(y);T&&(this._terminalBufferMap.delete(y),this._callback(y,T.data.join("")))}}e.TerminalDataBufferer=s}),define(ye[145],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var s;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(s=e.ColorScheme||(e.ColorScheme={}))}),define(ye[62],_e([0,1,52,4,6,3,37,145]),function(Z,e,s,t,y,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var C;(function(d){function F(_){return _&&typeof _=="object"&&typeof _.id=="string"}d.isThemeColor=F})(C=e.ThemeColor||(e.ThemeColor={}));function A(d){return{id:d}}e.themeColorFromId=A;var R;(function(d){function F(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||C.isThemeColor(n.color))}d.isThemeIcon=F;const _=new RegExp(`^\\$\\((${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?)\\)$`);function m(n){const b=_.exec(n);if(!b)return;let[,g]=b;return{id:g}}d.fromString=m;function f(n){return{id:n}}d.fromId=f;function D(n,b){let g=n.id;const c=g.lastIndexOf("~");return c!==-1&&(g=g.substring(0,c)),b&&(g=`${g}~${b}`),{id:g}}d.modify=D;function l(n){const b=n.id.lastIndexOf("~");if(b!==-1)return n.id.substring(b+1)}d.getModifier=l;function M(n,b){return n.id===b.id&&n.color?.id===b.color?.id}d.isEqual=M;function r(n,b){return{id:n.id,color:b?A(b):void 0}}d.asThemeIcon=r,d.asClassNameArray=s.CSSIcon.asClassNameArray,d.asClassName=s.CSSIcon.asClassName,d.asCSSSelector=s.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=s.Codicon.file,e.FolderThemeIcon=s.Codicon.folder;function w(d){switch(d){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class i{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(F){return this.themingParticipants.push(F),this.onThemingParticipantAddedEmitter.fire(F),(0,y.toDisposable)(()=>{const _=this.themingParticipants.indexOf(F);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new i;k.Registry.add(e.Extensions.ThemingContribution,p);function o(d){return p.onColorThemeChange(d)}e.registerThemingParticipant=o;class u extends y.Disposable{constructor(F){super();this.themeService=F,this.theme=F.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(F){this.theme=F,this.updateStyles()}updateStyles(){}getColor(F,_){let m=this.theme.getColor(F);return m&&_&&(m=_(m,this.theme)),m?m.toString():null}}e.Themable=u}),define(ye[47],_e([0,1,21,24,2,3]),function(Z,e,s,t,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var k;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function P(i){const p=i;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=P;function C(i){const p=i;return!!(p&&typeof p=="object"&&y.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=C;class A{constructor(p,o,u,d,F){this._id=p,this._transient=u,this._configuration=d,this._ignorePathCasing=F,this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=A;class R{constructor(p,o){this.raw=o,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,t.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function w(i){return new R({uri:i,index:0,name:(0,t.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w}),define(ye[63],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class s{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const T=this._idPool++;return this._data.set(T,y),this.logDebugInfo(),T}get(y,T){return this._data.has(y)?this._data.get(y)[T]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!s.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=s,s.enableDebugLogging=!1}),define(ye[30],_e([0,1,11,24,3]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(s.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(P=>{const C=this._providerInfo.get(P.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(P,C){C===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,C)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(ye[28],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,s.createDecorator)("IExtHostInitDataService")}),define(ye[146],_e([0,1,14]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(k,P,C){this._deferredPromises=new Map,this._id=k,this._shared=P,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new s.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of A.values())R.complete()}catch(R){for(const w of A.values())w.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(k,P){let C=this._value[k];return typeof C=="undefined"&&(C=P),C}update(k,P){this._value[k]=P;let C=this._deferredPromises.get(k);if(C!==void 0)return C.p;const A=new s.DeferredPromise;return this._deferredPromises.set(k,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class y extends t{constructor(k,P){super(k.identifier.value,!0,P);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=y}),define(ye[147],_e([0,1,4,2,12]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(P,C){this._logService=P,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new s.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new s.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,C,A){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptModelChanged(C.value,A)}$acceptDirtyStateChanged(P,C){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptDirty(C)}$acceptModelSaved(P){const C=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(P,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,C);const A=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));A.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};T=Be([He(0,y.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(ye[13],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,s.createDecorator)("IExtHostRpcService");class t{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=t});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!y:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(Z,s):y?y.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[148],_e([0,1,25,4]),function(Z,e,s,t){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(P,C){y.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=s.ExtensionIdentifier.toKey(P.identifier),Ze(this,y,C,"f"),Ie(this,y,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(P){return Ie(this,y,"f").get(this._id,P)}store(P,C){return Ie(this,y,"f").store(this._id,P,C)}delete(P){return Ie(this,y,"f").delete(this._id,P)}}e.ExtensionSecrets=T,y=new WeakMap}),define(ye[85],_e([0,1,3,4]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class y{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=y,e.IExtHostTelemetry=(0,s.createDecorator)("IExtHostTelemetry")}),define(ye[48],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var s;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(s=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,y=(_,m)=>{const f={controllerId:m};return t.set(_,f),f};e.createPrivateApiFor=y;const T=_=>t.get(_);e.getPrivateApiFor=T;const k=(_,m,f,D)=>{let l=f;return{enumerable:!0,configurable:!1,get(){return l},set(M){if(!D(l,M)){const r=l;l=M,_.listener?.({op:3,key:m,value:M,previous:r})}}}},P=(_,m)=>_===m,C={range:(_,m)=>_===m?!0:!_||!m?!1:_.isEqual(m),label:P,description:P,busy:P,error:P,canResolveChildren:P,tags:(_,m)=>!(_.length!==m.length||_.some(f=>!m.find(D=>f.id===D.id)))},A=Object.keys(C),R=(_,m)=>({range:k(_,"range",void 0,C.range),label:k(_,"label",m,C.label),description:k(_,"description",void 0,C.description),canResolveChildren:k(_,"canResolveChildren",!1,C.canResolveChildren),busy:k(_,"busy",!1,C.busy),error:k(_,"error",void 0,C.error),tags:k(_,"tags",[],C.tags)}),w=(_,m)=>{const f=new Map;for(const D of A)C[D](_[D],m[D])||f.set(D,m[D]);return f};e.diffTestItems=w;class i extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.DuplicateTestItemError=i;class p extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class o extends Error{constructor(m,f,D){super(`TestItem with ID "${m}" is from controller "${f}" and cannot be added as a child of an item from controller "${D}".`)}}e.MixedTestItemController=o;const u=_=>{const m=(0,e.getPrivateApiFor)(_);let f=new Map;return{get size(){return f.size},forEach(D,l){for(const M of f.values())D.call(l,M,this)},replace(D){const l=new Map,M=new Set(f.keys()),r={op:4,ops:[]};for(const n of D){if(!(n instanceof d))throw new p(n.id);const b=(0,e.getPrivateApiFor)(n).controllerId;if(b!==m.controllerId)throw new o(n.id,b,m.controllerId);if(l.has(n.id))throw new i(n.id);l.set(n.id,n),M.delete(n.id),r.ops.push({op:0,item:n})}for(const n of M.keys())r.ops.push({op:1,id:n});m.listener?.(r),f=l},add(D){if(!(D instanceof d))throw new p(D.id);f.set(D.id,D),m.listener?.({op:0,item:D})},delete(D){f.delete(D)&&m.listener?.({op:1,id:D})},get(D){return f.get(D)},toJSON(){return Array.from(f.values())},[Symbol.iterator](){return f.values()}}};class d{constructor(m,f,D,l){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const M=(0,e.createPrivateApiFor)(this,m);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return M.parent instanceof F?void 0:M.parent}},children:{value:u(this),enumerable:!0,writable:!1},...R(M,D)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=d;class F extends d{constructor(m,f){super(m,m,f,void 0)}}e.TestItemRootImpl=F}),define(ye[64],_e([0,1,3,143,4,13]),function(Z,e,s,t,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var k;(function(C){function A(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:w.protocol}}C.fromApiTunnel=A;function R(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==t.TunnelPrivacyId.ConstantPrivate&&w.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}C.fromServiceTunnel=R})(k=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,s.createDecorator)("IExtHostTunnelService");let P=class{constructor(A){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(A){return A}async openTunnel(A,R){}async getTunnels(){return[]}async setTunnelExtensionFunctions(A){return{dispose:()=>{}}}registerPortsAttributesProvider(A,R){return{dispose:()=>{}}}async $providePortAttributes(A,R,w,i,p){return[]}async $forwardPort(A,R){}async $closeTunnel(A){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=Be([He(0,T.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!y:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(Z,s):y?y.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[7],_e([0,1,16,15,77,21,76,9,10,2,36,46,84]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i){"use strict";var p,o,u,d,F,_,m,f,D,l,M,r,n,b,g,c,h,v,a,S;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(x){function L(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(L,x),Object.setPrototypeOf(L.prototype,x.prototype),L}let N=F=class{constructor(L){p.set(this,void 0),Ze(this,p,L,"f")}static from(...L){let J=L;return new F(function(){if(J){for(const Se of J)Se&&typeof Se.dispose=="function"&&Se.dispose();J=void 0}})}dispose(){typeof Ie(this,p,"f")=="function"&&(Ie(this,p,"f").call(this),Ze(this,p,void 0,"f"))}};p=new WeakMap,N=F=Be([I],N),e.Disposable=N;let B=_=class{constructor(L,J){if(L<0)throw(0,t.illegalArgument)("line must be non-negative");if(J<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=L,this._character=J}static Min(...L){if(L.length===0)throw new TypeError;let J=L[0];for(let Se=1;Se<L.length;Se++){const Ge=L[Se];Ge.isBefore(J)&&(J=Ge)}return J}static Max(...L){if(L.length===0)throw new TypeError;let J=L[0];for(let Se=1;Se<L.length;Se++){const Ge=L[Se];Ge.isAfter(J)&&(J=Ge)}return J}static isPosition(L){if(!L)return!1;if(L instanceof _)return!0;let{line:J,character:Se}=L;return typeof J=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,J=0){if(L===null||J===null)throw(0,t.illegalArgument)();let Se;return typeof L=="undefined"?Se=0:typeof L=="number"?Se=L:(Se=typeof L.lineDelta=="number"?L.lineDelta:0,J=typeof L.characterDelta=="number"?L.characterDelta:0),Se===0&&J===0?this:new _(this.line+Se,this.character+J)}with(L,J=this.character){if(L===null||J===null)throw(0,t.illegalArgument)();let Se;return typeof L=="undefined"?Se=this.line:typeof L=="number"?Se=L:(Se=typeof L.line=="number"?L.line:this.line,J=typeof L.character=="number"?L.character:this.character),Se===this.line&&J===this.character?this:new _(Se,J)}toJSON(){return{line:this.line,character:this.character}}};B=_=Be([I],B),e.Position=B;let E=m=class{constructor(L,J,Se,Ge){let tt,at;if(typeof L=="number"&&typeof J=="number"&&typeof Se=="number"&&typeof Ge=="number"?(tt=new B(L,J),at=new B(Se,Ge)):L instanceof B&&J instanceof B&&(tt=L,at=J),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(L){return L instanceof m?!0:L?B.isPosition(L.start)&&B.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof m?this.contains(L._start)&&this.contains(L._end):L instanceof B?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const J=B.Max(L.start,this._start),Se=B.Min(L.end,this._end);if(!J.isAfter(Se))return new m(J,Se)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const J=B.Min(L.start,this._start),Se=B.Max(L.end,this.end);return new m(J,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,J=this.end){if(L===null||J===null)throw(0,t.illegalArgument)();let Se;return L?B.isPosition(L)?Se=L:(Se=L.start||this.start,J=L.end||this.end):Se=this.start,Se.isEqual(this._start)&&J.isEqual(this.end)?this:new m(Se,J)}toJSON(){return[this.start,this.end]}};E=m=Be([I],E),e.Range=E;let O=f=class extends E{constructor(L,J,Se,Ge){let tt,at;if(typeof L=="number"&&typeof J=="number"&&typeof Se=="number"&&typeof Ge=="number"?(tt=new B(L,J),at=new B(Se,Ge)):L instanceof B&&J instanceof B&&(tt=L,at=J),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(L){return L instanceof f?!0:L?E.isRange(L)&&B.isPosition(L.anchor)&&B.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=f=Be([I],O),e.Selection=O;class z{constructor(L,J,Se){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("host");if(typeof J!="number"||J===0||Math.round(J)!==J)throw(0,t.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,t.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(J),this.connectionToken=Se}}e.ResolvedAuthority=z;class U extends Error{constructor(L,J=i.RemoteAuthorityResolverErrorCode.Unknown,Se){super(L);this._message=L,this._code=J,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable(L,J){return new U(L,i.RemoteAuthorityResolverErrorCode.NotAvailable,J)}static TemporarilyNotAvailable(L){return new U(L,i.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var $;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var V;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(V=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ue=D=class{constructor(L,J){this._range=L,this._newText=J}static isTextEdit(L){return L instanceof D?!0:L?E.isRange(L)&&typeof L.newText=="string":!1}static replace(L,J){return new D(L,J)}static insert(L,J){return D.replace(new E(L,L),J)}static delete(L){return D.replace(L,"")}static setEndOfLine(L){const J=new D(new E(new B(0,0),new B(0,0)),"");return J.newEol=L,J}get range(){return this._range}set range(L){if(L&&!E.isRange(L))throw(0,t.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,t.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,t.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ue=D=Be([I],ue),e.TextEdit=ue;var K;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(K=e.FileEditType||(e.FileEditType={}));let re=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,J,Se,Ge){this._edits.push({_type:1,from:L,to:J,options:Se,metadata:Ge})}createFile(L,J,Se){this._edits.push({_type:1,from:void 0,to:L,options:J,metadata:Se})}deleteFile(L,J,Se){this._edits.push({_type:1,from:L,to:void 0,options:J,metadata:Se})}replaceNotebookMetadata(L,J,Se){this._edits.push({_type:3,metadata:Se,uri:L,edit:{editType:5,metadata:J},notebookMetadata:J})}replaceNotebookCells(L,J,Se,Ge,tt){let at,dt,Pt=[],Mt;if(Me.isNotebookRange(J)&&xt.isNotebookCellDataArray(Se)&&!xt.isNotebookCellDataArray(Ge)?(at=J.start,dt=J.end,Pt=Se,Mt=Ge):typeof J=="number"&&typeof Se=="number"&&xt.isNotebookCellDataArray(Ge)&&(at=J,dt=Se,Pt=Ge,Mt=tt),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||Pt.length>0)&&this._edits.push({_type:5,uri:L,index:at,count:dt-at,cells:Pt,metadata:Mt})}replaceNotebookCellMetadata(L,J,Se,Ge){this._edits.push({_type:3,metadata:Ge,uri:L,edit:{editType:8,index:J,metadata:Se}})}replace(L,J,Se,Ge){this._edits.push({_type:2,uri:L,edit:new ue(J,Se),metadata:Ge})}insert(L,J,Se,Ge){this.replace(L,new E(J,J),Se,Ge)}delete(L,J,Se){this.replace(L,J,"",Se)}has(L){return this._edits.some(J=>J._type===2&&J.uri.toString()===L.toString())}set(L,J){if(J)for(const Se of J)Se&&this._edits.push({_type:2,uri:L,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const Ge=this._edits[Se];Ge._type===2&&Ge.uri.toString()===L.toString()&&(this._edits[Se]=void 0)}(0,s.coalesceInPlace)(this._edits)}}get(L){const J=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===L.toString()&&J.push(Se.edit);return J}entries(){const L=new T.ResourceMap;for(let J of this._edits)if(J._type===2){let Se=L.get(J.uri);Se||(Se=[J.uri,[]],L.set(J.uri,Se)),Se[1].push(J.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};re=Be([I],re),e.WorkspaceEdit=re;let pe=l=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof l?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=l._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,J=this._tabstop++){if(typeof L=="function"){const Se=new l;Se._tabstop=this._tabstop,L(Se),this._tabstop=Se._tabstop,L=Se.value}else L=l._escape(L);return this.value+="${",this.value+=J,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,J=this._tabstop++){const Se=L.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=J,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(L,J){if(typeof J=="function"){const Se=new l;Se._tabstop=this._tabstop,J(Se),this._tabstop=Se._tabstop,J=Se.value}else typeof J=="string"&&(J=J.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,J&&(this.value+=":",this.value+=J),this.value+="}",this}};pe=l=Be([I],pe),e.SnippetString=pe;var we;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(we=e.DiagnosticTag||(e.DiagnosticTag={}));var ae;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let le=M=class{constructor(L,J){if(this.uri=L,J)if(J instanceof E)this.range=J;else if(J instanceof B)this.range=new E(J,J);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof M?!0:L?E.isRange(L.range)&&A.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};le=M=Be([I],le),e.Location=le;let Ce=class{constructor(L,J){this.location=L,this.message=J}static is(L){return L?typeof L.message=="string"&&L.location&&E.isRange(L.location.range)&&A.URI.isUri(L.location.uri):!1}static isEqual(L,J){return L===J?!0:!L||!J?!1:L.message===J.message&&L.location.range.isEqual(J.location.range)&&L.location.uri.toString()===J.location.uri.toString()}};Ce=Be([I],Ce),e.DiagnosticRelatedInformation=Ce;let Ee=class{constructor(L,J,Se=ae.Error){if(!E.isRange(L))throw new TypeError("range must be set");if(!J)throw new TypeError("message must be set");this.range=L,this.message=J,this.severity=Se}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,J){return L===J?!0:!L||!J?!1:L.message===J.message&&L.severity===J.severity&&L.code===J.code&&L.severity===J.severity&&L.source===J.source&&L.range.isEqual(J.range)&&(0,s.equals)(L.tags,J.tags)&&(0,s.equals)(L.relatedInformation,J.relatedInformation,Ce.isEqual)}};Ee=Be([I],Ee),e.Diagnostic=Ee;let Fe=class{constructor(L,J){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=J}};Fe=Be([I],Fe),e.Hover=Fe;var $e;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})($e=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ve=class{constructor(L,J=$e.Text){this.range=L,this.kind=J}toJSON(){return{range:this.range,kind:$e[this.kind]}}};Ve=Be([I],Ve),e.DocumentHighlight=Ve;var je;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(je=e.SymbolKind||(e.SymbolKind={}));var H;(function(x){x[x.Deprecated=1]="Deprecated"})(H=e.SymbolTag||(e.SymbolTag={}));let G=r=class{constructor(L,J,Se,Ge,tt){this.name=L,this.kind=J,this.containerName=tt,typeof Se=="string"&&(this.containerName=Se),Ge instanceof le?this.location=Ge:Se instanceof E&&(this.location=new le(Ge,Se)),r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};G=r=Be([I],G),e.SymbolInformation=G;let X=n=class{constructor(L,J,Se,Ge,tt){this.name=L,this.detail=J,this.kind=Se,this.range=Ge,this.selectionRange=tt,this.children=[],n.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(n.validate)}};X=n=Be([I],X),e.DocumentSymbol=X;var oe;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(oe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let q=class{constructor(L,J){this.title=L,this.kind=J}};q=Be([I],q),e.CodeAction=q;let ee=b=class{constructor(L){this.value=L}append(L){return new b(this.value?this.value+b.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+b.sep)}};ee.sep=".",ee=b=Be([I],ee),e.CodeActionKind=ee,ee.Empty=new ee(""),ee.QuickFix=ee.Empty.append("quickfix"),ee.Refactor=ee.Empty.append("refactor"),ee.RefactorExtract=ee.Refactor.append("extract"),ee.RefactorInline=ee.Refactor.append("inline"),ee.RefactorRewrite=ee.Refactor.append("rewrite"),ee.Source=ee.Empty.append("source"),ee.SourceOrganizeImports=ee.Source.append("organizeImports"),ee.SourceFixAll=ee.Source.append("fixAll");let he=class{constructor(L,J){if(this.range=L,this.parent=J,J&&!J.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};he=Be([I],he),e.SelectionRange=he;class Re{constructor(L,J,Se,Ge,tt,at){this.kind=L,this.name=J,this.detail=Se,this.uri=Ge,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=Re;class Ue{constructor(L,J){this.fromRanges=J,this.from=L}}e.CallHierarchyIncomingCall=Ue;class ze{constructor(L,J){this.fromRanges=J,this.to=L}}e.CallHierarchyOutgoingCall=ze;var Qe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(L,J){this.range=L,this.command=J}get isResolved(){return!!this.command}};et=Be([I],et),e.CodeLens=et;let st=g=class{constructor(L,J=!1){o.set(this,void 0),Ze(this,o,new y.MarkdownString(L,{supportThemeIcons:J}),"f")}static isMarkdownString(L){return L instanceof g?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Ie(this,o,"f").value}set value(L){Ie(this,o,"f").value=L}get isTrusted(){return Ie(this,o,"f").isTrusted}set isTrusted(L){Ie(this,o,"f").isTrusted=L}get supportThemeIcons(){return Ie(this,o,"f").supportThemeIcons}set supportThemeIcons(L){Ie(this,o,"f").supportThemeIcons=L}get supportHtml(){return Ie(this,o,"f").supportHtml}set supportHtml(L){Ie(this,o,"f").supportHtml=L}appendText(L){return Ie(this,o,"f").appendText(L),this}appendMarkdown(L){return Ie(this,o,"f").appendMarkdown(L),this}appendCodeblock(L,J){return Ie(this,o,"f").appendCodeblock(J??"",L),this}};o=new WeakMap,st=g=Be([I],st),e.MarkdownString=st;let Xe=class{constructor(L,J){this.label=L,this.documentation=J}};Xe=Be([I],Xe),e.ParameterInformation=Xe;let nt=class{constructor(L,J){this.label=L,this.documentation=J,this.parameters=[]}};nt=Be([I],nt),e.SignatureInformation=nt;let lt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};lt=Be([I],lt),e.SignatureHelp=lt;var vt;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(vt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Oe;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Oe=e.InlayHintKind||(e.InlayHintKind={}));let Rt=class{constructor(L,J,Se){this.text=L,this.position=J,this.kind=Se}};Rt=Be([I],Rt),e.InlayHint=Rt;var j;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(j=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Q;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var fe;(function(x){x[x.Deprecated=1]="Deprecated"})(fe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ne=class{constructor(L,J){this.label=L,this.kind=J}toJSON(){return{label:this.label,kind:this.kind&&Q[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ne=Be([I],Ne),e.CompletionItem=Ne;let qe=class{constructor(L=[],J=!1){this.items=L,this.isIncomplete=J}};qe=Be([I],qe),e.CompletionList=qe;let ot=class{constructor(L,J,Se){this.text=L,this.range=J,this.command=Se}};ot=Be([I],ot),e.InlineSuggestion=ot;let ht=class{constructor(L){this.items=L}};ht=Be([I],ht),e.InlineSuggestions=ht;var Je;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Je=e.ViewColumn||(e.ViewColumn={}));var Tt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ie;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(ie=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var se;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(se=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var de;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function L(J){switch(J){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=L}(ie=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let me=class{constructor(L,J){if(J&&!A.URI.isUri(J))throw(0,t.illegalArgument)("target");if(!E.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.target=J}};me=Be([I],me),e.DocumentLink=me;let Te=class{constructor(L,J,Se,Ge){this.red=L,this.green=J,this.blue=Se,this.alpha=Ge}};Te=Be([I],Te),e.Color=Te;let We=class{constructor(L,J){if(J&&!(J instanceof Te))throw(0,t.illegalArgument)("color");if(!E.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.color=J}};We=Be([I],We),e.ColorInformation=We;let Le=class{constructor(L){if(!L||typeof L!="string")throw(0,t.illegalArgument)("label");this.label=L}};Le=Be([I],Le),e.ColorPresentation=Le;var Ke;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Ke=e.ColorFormat||(e.ColorFormat={}));var it;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class rt{constructor(L,J,Se){if(this.startIndex=L,this.length=J,this.tooltip=Se,typeof L!="number"||L<0)throw(0,t.illegalArgument)("startIndex");if(typeof J!="number"||J<1)throw(0,t.illegalArgument)("length");if(Se!==void 0&&typeof Se!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=rt;var ne;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(L){this.options=L,typeof L!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=ge;var te;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(te=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let be=c=class{constructor(L,J){if(this.label=J,typeof L!="string"||typeof J!="string")throw(0,t.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};be.Clean=new c("clean","Clean"),be.Build=new c("build","Build"),be.Rebuild=new c("rebuild","Rebuild"),be.Test=new c("test","Test"),be=c=Be([I],be),e.TaskGroup=be;function Pe(x){let L="";for(let J=0;J<x.length;J++)L+=x[J].replace(/,/g,",,")+",";return L}let Ye=class{constructor(L,J,Se){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=L,J!==void 0&&(Array.isArray(J)?(this._args=J,this._options=Se):this._options=J)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let J of this._args)L.push(J);return Pe(L)}};Ye=Be([I],Ye),e.ProcessExecution=Ye;let xe=class{constructor(L,J,Se){if(this._args=[],Array.isArray(J)){if(!L)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L,this._args=J,this._options=Se}else{if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L,this._options=J}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let J of this._args)L.push(typeof J=="string"?J:J.value);return Pe(L)}};xe=Be([I],xe),e.ShellExecution=xe;var ut;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(ut=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class Ct{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=Ct;let bt=h=class{constructor(L,J,Se,Ge,tt,at){this.__deprecated=!1,this._definition=this.definition=L;let dt;typeof J=="string"?(this._name=this.name=J,this._source=this.source=Se,this.execution=Ge,dt=tt,this.__deprecated=!0):J===wt.Global||J===wt.Workspace?(this.target=J,this._name=this.name=Se,this._source=this.source=Ge,this.execution=tt,dt=at):(this.target=J,this._name=this.name=Se,this._source=this.source=Ge,this.execution=tt,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ye?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof Ct?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const J=this._definition.type;(h.EmptyType===J||h.ProcessType===J||h.ShellType===J||h.ExtensionCallbackType===J)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=h=Be([I],bt),e.Task=bt;var ft;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let pt=class{constructor(L,J=yt.None){this.collapsibleState=J,A.URI.isUri(L)?this.resourceUri=L:this.label=L}};pt=Be([I],pt),e.TreeItem=pt;var yt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(yt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ot=class{constructor(L){this._value=L}async asString(){return JSON.stringify(this._value)}};Ot=Be([I],Ot),e.TreeDataTransferItem=Ot;let kt=class{constructor(){this._items=new Map}get(L){return this._items.get(L)}set(L,J){this._items.set(L,J)}forEach(L){this._items.forEach(L)}};kt=Be([I],kt),e.TreeDataTransfer=kt;let It=class{constructor(L,J){this.id=L,this.color=J}};It=Be([I],It),e.ThemeIcon=It,It.File=new It("file"),It.Folder=new It("folder");let At=class{constructor(L){this.id=L}};At=Be([I],At),e.ThemeColor=At;var St;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(St=e.ConfigurationTarget||(e.ConfigurationTarget={}));let zt=class{constructor(L,J){if(typeof L!="string"&&(!L||!A.URI.isUri(L)&&!A.URI.isUri(L.uri)))throw(0,t.illegalArgument)("base");if(typeof J!="string")throw(0,t.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=A.URI.file(L),this.base=L):A.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=J}};zt=Be([I],zt),e.RelativePattern=zt;let Lt=class{constructor(L,J,Se,Ge){this.enabled=typeof L=="boolean"?L:!0,typeof J=="string"&&(this.condition=J),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Lt=Be([I],Lt),e.Breakpoint=Lt;let Et=class extends Lt{constructor(L,J,Se,Ge,tt){super(J,Se,Ge,tt);if(L===null)throw(0,t.illegalArgument)("location");this.location=L}};Et=Be([I],Et),e.SourceBreakpoint=Et;let Qt=class extends Lt{constructor(L,J,Se,Ge,tt){super(J,Se,Ge,tt);this.functionName=L}};Qt=Be([I],Qt),e.FunctionBreakpoint=Qt;let Vt=class extends Lt{constructor(L,J,Se,Ge,tt,at,dt){super(Ge,tt,at,dt);if(!J)throw(0,t.illegalArgument)("dataId");this.label=L,this.dataId=J,this.canPersist=Se}};Vt=Be([I],Vt),e.DataBreakpoint=Vt;let Yt=class{constructor(L,J,Se){this.command=L,this.args=J||[],this.options=Se}};Yt=Be([I],Yt),e.DebugAdapterExecutable=Yt;let si=class{constructor(L,J){this.port=L,this.host=J}};si=Be([I],si),e.DebugAdapterServer=si;let Ft=class{constructor(L){this.path=L}};Ft=Be([I],Ft),e.DebugAdapterNamedPipeServer=Ft;let Xt=class{constructor(L){this.implementation=L}};Xt=Be([I],Xt),e.DebugAdapterInlineImplementation=Xt;let ai=class{constructor(L,J){this.range=L,this.expression=J}};ai=Be([I],ai),e.EvaluatableExpression=ai;var Jt;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(Jt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(L,J){this.range=L,this.text=J}};Wt=Be([I],Wt),e.InlineValueText=Wt;let gt=class{constructor(L,J,Se=!0){this.range=L,this.variableName=J,this.caseSensitiveLookup=Se}};gt=Be([I],gt),e.InlineValueVariableLookup=gt;let li=class{constructor(L,J){this.range=L,this.expression=J}};li=Be([I],li),e.InlineValueEvaluatableExpression=li;let Nt=class{constructor(L,J){this.frameId=L,this.stoppedLocation=J}};Nt=Be([I],Nt),e.InlineValueContext=Nt;var jt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let Zt=v=class extends Error{constructor(L,J=w.FileSystemProviderErrorCode.Unknown,Se){super(A.URI.isUri(L)?L.toString(!0):L);this.code=Se?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,J),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(L){return new v(L,w.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(L){return new v(L,w.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(L){return new v(L,w.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(L){return new v(L,w.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(L){return new v(L,w.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(L){return new v(L,w.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}};Zt=v=Be([I],Zt),e.FileSystemError=Zt;let ci=class{constructor(L,J,Se){this.start=L,this.end=J,this.kind=Se}};ci=Be([I],ci),e.FoldingRange=ci;var fi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class ei{constructor(L,J=[]){this.tokenTypes=L,this.tokenModifiers=J}}e.SemanticTokensLegend=ei;function yi(x){return typeof x=="undefined"||(0,C.isStringArray)(x)}class qt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let J=0,Se=L.tokenTypes.length;J<Se;J++)this._tokenTypeStrToInt.set(L.tokenTypes[J],J);for(let J=0,Se=L.tokenModifiers.length;J<Se;J++)this._tokenModifierStrToInt.set(L.tokenModifiers[J],J)}}push(L,J,Se,Ge,tt){if(typeof L=="number"&&typeof J=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(L,J,Se,Ge,tt);if(E.isRange(L)&&typeof J=="string"&&yi(Se))return this._push(L,J,Se);throw(0,t.illegalArgument)()}_push(L,J,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(J))throw new Error("`tokenType` is not in the provided legend");const Ge=L.start.line,tt=L.start.character,at=L.end.character-L.start.character,dt=this._tokenTypeStrToInt.get(J);let Pt=0;if(Se)for(const Mt of Se){if(!this._tokenModifierStrToInt.has(Mt))throw new Error("`tokenModifier` is not in the provided legend");const Ut=this._tokenModifierStrToInt.get(Mt);Pt|=1<<Ut>>>0}this._pushEncoded(Ge,tt,at,dt,Pt)}_pushEncoded(L,J,Se,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&J<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Pt=this._data.length/5|0;let Mt=0,Ut=0;for(let Bt=0;Bt<Pt;Bt++){let $t=this._data[5*Bt],di=this._data[5*Bt+1];$t===0?($t=Mt,di+=Ut):$t+=Mt,this._data[5*Bt]=$t,this._data[5*Bt+1]=di,Mt=$t,Ut=di}}let at=L,dt=J;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=L,this._prevChar=J}static _sortAndDeltaEncode(L){let J=[];const Se=L.length/5|0;for(let dt=0;dt<Se;dt++)J[dt]=dt;J.sort((dt,Pt)=>{const Mt=L[5*dt],Ut=L[5*Pt];if(Mt===Ut){const Bt=L[5*dt+1],$t=L[5*Pt+1];return Bt-$t}return Mt-Ut});const Ge=new Uint32Array(L.length);let tt=0,at=0;for(let dt=0;dt<Se;dt++){const Pt=5*J[dt],Mt=L[Pt+0],Ut=L[Pt+1],Bt=L[Pt+2],$t=L[Pt+3],di=L[Pt+4],Hi=Mt-tt,Yi=Hi===0?Ut-at:Ut,hi=5*dt;Ge[hi+0]=Hi,Ge[hi+1]=Yi,Ge[hi+2]=Bt,Ge[hi+3]=$t,Ge[hi+4]=di,tt=Mt,at=Ut}return Ge}build(L){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),L):new Kt(qt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=qt;class Kt{constructor(L,J){this.resultId=J,this.data=L}}e.SemanticTokens=Kt;class _i{constructor(L,J,Se){this.start=L,this.deleteCount=J,this.data=Se}}e.SemanticTokensEdit=_i;class Si{constructor(L,J){this.resultId=J,this.edits=L}}e.SemanticTokensEdits=Si;var Gt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ci;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(Ci=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ti=class{constructor(){}};ti.Back={iconPath:new It("arrow-left")},ti=Be([I],ti),e.QuickInputButtons=ti;var Di;(function(x){x[x.Separator=-1]="Separator",x[x.Default=1]="Default"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(L,J,Se){this.badge=L,this.tooltip=J,this.color=Se}static validate(L){if(L.badge){let J=(0,P.nextCharLength)(L.badge,0);if(J<L.badge.length&&(J+=(0,P.nextCharLength)(L.badge,J)),L.badge.length>J)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ii=class{constructor(L){this.kind=L}};ii=Be([I],ii),e.ColorTheme=ii;var gi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Me{constructor(L,J){if(L<0)throw(0,t.illegalArgument)("start must be positive");if(J<0)throw(0,t.illegalArgument)("end must be positive");L<=J?(this._start=L,this._end=J):(this._start=J,this._end=L)}static isNotebookRange(L){return L instanceof Me?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let J=this._start,Se=this._end;return L.start!==void 0&&(J=L.start),L.end!==void 0&&(Se=L.end),J===this._start&&Se===this._end?this:new Me(J,Se)}}e.NotebookRange=Me;class xt{constructor(L,J,Se,Ge,tt,at,dt){this.kind=L,this.value=J,this.languageId=Se,this.mime=Ge,this.outputs=tt??[],this.metadata=at,this.executionSummary=dt,xt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(J=>xt.isNotebookCellData(J))}static isNotebookCellData(L){return!0}}e.NotebookCellData=xt;class pi{constructor(L){this.cells=L}}e.NotebookData=pi;class mt{constructor(L,J){this.data=L,this.mime=J;const Se=(0,k.normalizeMimeType)(J,!0);if(!Se)throw new Error(`INVALID mime type: ${J}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}static isNotebookCellOutputItem(L){return L instanceof mt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const J={name:L.name,message:L.message,stack:L.stack};return mt.json(J,"application/vnd.code.notebook.error")}static stdout(L){return mt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return mt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,J="application/octet-stream"){return new mt(L,J)}static text(L,J=k.Mimes.text){const Se=Ie(mt,u,"f",d).encode(String(L));return new mt(Se,J)}static json(L,J="application/json"){const Se=JSON.stringify(L,void 0,"	");return mt.text(Se,J)}}e.NotebookCellOutputItem=mt,u=mt,d={value:new TextEncoder};class ni{constructor(L,J,Se){this.items=ni.ensureUniqueMimeTypes(L,!0),typeof J=="string"?(this.id=J,this.metadata=Se):(this.id=(0,R.generateUuid)(),this.metadata=J??Se)}static isNotebookCellOutput(L){return L instanceof ni?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,C.isArray)(L.items)}static ensureUniqueMimeTypes(L,J=!1){const Se=new Set,Ge=new Set;for(let tt=0;tt<L.length;tt++){const at=L[tt],dt=(0,k.normalizeMimeType)(at.mime);if(!Se.has(dt)){Se.add(dt);continue}Ge.add(tt),J&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?L:L.filter((tt,at)=>!Ge.has(at))}}e.NotebookCellOutput=ni;var Ii;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var bi;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(bi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(L,J){this.text=L,this.alignment=J}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(L,J=[]){this.uri=L,this.provides=(0,s.asArray)(J)}}e.NotebookRendererScript=Ri;let ri=class{constructor(L,J){this.label=L,this.timestamp=J}};ri=Be([I],ri),e.TimelineItem=ri;var Fi;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Oi;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(Oi=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(L,J){this.ranges=L,this.wordPattern=J}}e.LinkedEditingRanges=Li;class Ni{constructor(L,J){this._port=L,this._autoForwardAction=J}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var Y;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(Y=e.TestResultState||(e.TestResultState={}));var ce;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(ce=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ke=class{constructor(L=void 0,J=void 0,Se=void 0){this.include=L,this.exclude=J,this.profile=Se}};ke=Be([I],ke),e.TestRunRequest=ke;let ct=a=class{constructor(L){this.message=L}static diff(L,J,Se){const Ge=new a(L);return Ge.expectedOutput=J,Ge.actualOutput=Se,Ge}};ct=a=Be([I],ct),e.TestMessage=ct;let _t=class{constructor(L){this.id=L}};_t=Be([I],_t),e.TestTag=_t;let Dt=class{constructor(L,J){this.covered=L,this.total=J}};Dt=Be([I],Dt),e.CoveredCount=Dt;let xi=S=class{constructor(L,J,Se,Ge){this.uri=L,this.statementCoverage=J,this.branchCoverage=Se,this.functionCoverage=Ge}static fromDetails(L,J){const Se=new Dt(0,0),Ge=new Dt(0,0),tt=new Dt(0,0);for(const dt of J)if("branches"in dt){Se.total+=1,Se.covered+=dt.executionCount>0?1:0;for(const Pt of dt.branches)Ge.total+=1,Ge.covered+=Pt.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const at=new S(L,Se,Ge.total>0?Ge:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=J,at}};xi=S=Be([I],xi),e.FileCoverage=xi;let Ui=class{constructor(L,J,Se=[]){this.executionCount=L,this.location=J,this.branches=Se}};Ui=Be([I],Ui),e.StatementCoverage=Ui;let Bi=class{constructor(L,J){this.executionCount=L,this.location=J}};Bi=Be([I],Bi),e.BranchCoverage=Bi;let $i=class{constructor(L,J){this.executionCount=L,this.location=J}};$i=Be([I],$i),e.FunctionCoverage=$i;var qi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ki;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(Ki=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Gi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(Gi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(L,J,Se,Ge,tt,at){this.kind=L,this.name=J,this.detail=Se,this.uri=Ge,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=Qi}),define(ye[86],_e([0,1,42,11,9,223,113,7,16]),function(Z,e,s,t,y,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function R(o,u){u?A.set(o,u):A.delete(o)}e.setWordDefinitionFor=R;function w(o){return A.get(o)}e.getWordDefinitionFor=w;class i extends T.MirrorTextModel{constructor(u,d,F,_,m,f,D,l){super(d,F,_,m);this._proxy=u,this._languageId=f,this._isDirty=D,this._notebook=l,this._isDisposed=!1}dispose(){(0,s.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,C.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===t.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(d){return d?u._getTextInRange(d):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(d){return u._lineAt(d)},offsetAt(d){return u._offsetAt(d)},positionAt(d){return u._positionAt(d)},validateRange(d){return u._validateRange(d)},validatePosition(d){return u._validatePosition(d)},getWordRangeAtPosition(d,F){return u._getWordRangeAtPosition(d,F)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,s.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,s.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const d=this._validateRange(u);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const F=this._eol,_=d.start.line,m=d.end.line,f=[];f.push(this._lines[_].substring(d.start.character));for(let D=_+1;D<m;D++)f.push(this._lines[D]);return f.push(this._lines[m].substring(0,d.end.character)),f.join(F)}_lineAt(u){let d;if(u instanceof P.Position?d=u.line:typeof u=="number"&&(d=u),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new p(d,this._lines[d],d===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(u),F=this._lines[d.index].length;return new P.Position(d.index,Math.min(d.remainder,F))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const d=this._validatePosition(u.start),F=this._validatePosition(u.end);return d===u.start&&F===u.end?u:new P.Range(d.line,d.character,F.line,F.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:d,character:F}=u,_=!1;if(d<0)d=0,F=0,_=!0;else if(d>=this._lines.length)d=this._lines.length-1,F=this._lines[d].length,_=!0;else{const m=this._lines[d].length;F<0?(F=0,_=!0):F>m&&(F=m,_=!0)}return _?new P.Position(d,F):u}_getWordRangeAtPosition(u,d){const F=this._validatePosition(u);if(!d)d=w(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const _=(0,k.getWordAtText)(F.character+1,(0,k.ensureValidWordDefinition)(d),this._lines[F.line],0);if(_)return new P.Range(F.line,_.startColumn-1,F.line,_.endColumn-1)}}e.ExtHostDocumentData=i;class p{constructor(u,d,F){this._line=u,this._text=d,this._isLastLine=F}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(ye[149],_e([0,1,7,4,224,6,56,21,2,36]),function(Z,e,s,t,y,T,k,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(i,p,o,u){this._notebook=o,this._selector=u,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(F=>{const _=this._cellUris.get(F.document.uri);_!==void 0&&(this._cellLengths.setValue(_,this._cells[_].document.getText().length+1),this._cellLines.setValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const d=F=>{F===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(i.onDidChangeNotebookCells(F=>d(F.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const i=[],p=[];for(const o of this._notebook.getCells())o.kind===s.NotebookCellKind.Code&&(!this._selector||(0,k.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),i.push(o.document.getText().length+1),p.push(o.document.lineCount));this._cellLengths=new y.PrefixSumComputer(new Uint32Array(i)),this._cellLines=new y.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(i){if(!i){let _="";for(const m of this._cells)_+=m.document.getText()+`
`;return _=_.slice(0,-1),_}if(i.isEmpty)return"";const p=this.locationAt(i.start),o=this.locationAt(i.end),u=this._cellUris.get(p.uri),d=this._cellUris.get(o.uri);if(u===void 0||d===void 0)return"";if(u===d)return this._cells[u].document.getText(new s.Range(p.range.start,o.range.end));const F=[this._cells[u].document.getText(new s.Range(p.range.start,new s.Position(this._cells[u].document.lineCount,0)))];for(let _=u+1;_<d;_++)F.push(this._cells[_].document.getText());return F.push(this._cells[d].document.getText(new s.Range(new s.Position(0,0),o.range.end))),F.join(`
`)}offsetAt(i){const p=this._cellLines.getIndexOf(i.line),o=this._cellLengths.getPrefixSum(p.index-1),u=this._cells[p.index].document.offsetAt(i.with(p.remainder));return o+u}positionAt(i){if(typeof i=="number"){const o=this._cellLengths.getIndexOf(i),u=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(u)}const p=this._cellUris.get(i.uri);if(p!==void 0){const o=this._cellLines.getPrefixSum(p-1);return new s.Position(o+i.range.start.line,i.range.start.character)}return new s.Position(0,0)}locationAt(i){s.Range.isRange(i)||(i=new s.Range(i,i));const p=this._cellLines.getIndexOf(i.start.line);let o=p;i.isEmpty||(o=this._cellLines.getIndexOf(i.end.line));const u=new s.Position(p.remainder,i.start.character),d=new s.Position(o.remainder,i.end.character),F=new s.Range(u,d),_=this._cells[p.index];return new s.Location(_.document.uri,_.document.validateRange(F))}contains(i){return this._cellUris.has(i)}validateRange(i){const p=this.validatePosition(i.start),o=this.validatePosition(i.end);return i.with(p,o)}validatePosition(i){const p=this._cellLines.getIndexOf(i.line),o=new s.Position(p.remainder,i.character),u=this._cells[p.index].document.validatePosition(o),d=this._cellLines.getPrefixSum(p.index-1);return new s.Position(d+u.line,u.character)}}e.ExtHostNotebookConcatDocument=R}),define(ye[150],_e([0,1,7,13,4]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(P){this._actual=new s.ColorTheme(s.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let C=P==="light"?s.ColorThemeKind.Light:P==="dark"?s.ColorThemeKind.Dark:s.ColorThemeKind.HighContrast;this._actual=new s.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Be([He(0,t.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(ye[65],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,s.createDecorator)("IURITransformerService");class t{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=t}),define(ye[151],_e([0,1,22]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(C){let A=this.buffers.indexOf(C);return A<0&&(A=this.buffers.length,this.buffers.push(C)),A}}function y(P,C){if(C.serializeBuffersForPostMessage){const A=new t,R=(p,o)=>{if(o instanceof ArrayBuffer){const u=A.add(o);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(o)){const u=T(o);if(u){const d=A.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:u,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},w=JSON.stringify(P,R),i=A.buffers.map(p=>{const o=new Uint8Array(p);return s.VSBuffer.wrap(o)});return{message:w,buffers:i}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=y;function T(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(P,C){const A=C.map(i=>{const p=new ArrayBuffer(i.byteLength);return new Uint8Array(p).set(i.buffer),p}),R=C.length?(i,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const o=p,{index:u}=o,d=A[u];if(o.view)switch(o.view.type){case 1:return new Int8Array(d,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return p}:void 0;return{message:JSON.parse(P,R),arrayBuffers:A}}e.deserializeWebviewMessage=k}),define(ye[152],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var s;(function(t){function y(k){const P=new Map;return k.types.forEach((C,A)=>{P.set(C,{asString:async()=>k.items[A].asString})}),P}t.toITreeDataTransfer=y;async function T(k){const P={types:[],items:[]},C=Array.from(k.entries());for(const A of C)P.types.push(A[0]),P.items.push({asString:await A[1].asString()});return P}t.toTreeDataTransferDTO=T})(s=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ye[66],_e([0,1,11,2]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function y(P,C){return P.scheme===s.Schemas.http||P.scheme===s.Schemas.https?P:(C&&C.authority&&C.isRemote&&P.scheme===s.Schemas.file&&(P=t.URI.from({scheme:s.Schemas.vscodeRemote,authority:C.authority,path:P.path})),t.URI.from({scheme:s.Schemas.https,authority:`${P.scheme}+${T(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=y;function T(P){return P.replace(/./g,C=>{const A=C.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?C:"-"+A.toString(16).padStart(4,"0")})}function k(P){return P.replace(/-([0-9a-f]{4})/g,(C,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=k}),define(ye[153],_e([0,1,4,6,66]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(P,C,A){this._proxy=P,this._editors=C,this._initData=A,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const R=C.getVisibleTextEditors();for(const w of this._insets.values())R.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,C,A,R,w){let i;for(const m of this._editors.getVisibleTextEditors(!0))if(m.value===P){i=m;break}if(!i)throw new Error("not a visible editor");const p=this,o=this._handlePool++,u=new s.Emitter,d=new s.Emitter,F=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(m){return(0,y.asWebviewUri)(m,p._initData.remote)}get cspSource(){return y.webviewGenericCspSource}set options(m){this._options=m,p._proxy.$setOptions(o,m)}get options(){return this._options}set html(m){this._html=m,p._proxy.$setHtml(o,m)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(m){return p._proxy.$postMessage(o,m)}},_=new class{constructor(){this.editor=P,this.line=C,this.height=A,this.webview=F,this.onDidDispose=d.event}dispose(){p._insets.has(o)&&(p._insets.delete(o),p._proxy.$disposeEditorInset(o),d.fire(),d.dispose(),u.dispose())}};return this._proxy.$createEditorInset(o,i.id,i.value.document.uri,C+1,A,R||{},w.identifier,w.extensionLocation),this._insets.set(o,{editor:P,inset:_,onDidReceiveMessage:u}),_}$onDidDispose(P){const C=this._insets.get(P);C&&C.inset.dispose()}$onDidReceiveMessage(P,C){const A=this._insets.get(P);A&&A.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=T}),define(ye[154],_e([0,1,125,10,2,6,3,45,37,46,16,11]),function(Z,e,s,t,y,T,k,P,C,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,s.localize)(0,null),providerDisplayName:(0,s.localize)(1,null)},e.ActiveEditorDirtyContext=new P.RawContextKey("activeEditorIsDirty",!1,(0,s.localize)(2,null)),e.ActiveEditorPinnedContext=new P.RawContextKey("activeEditorIsNotPreview",!1,(0,s.localize)(3,null)),e.ActiveEditorStickyContext=new P.RawContextKey("activeEditorIsPinned",!1,(0,s.localize)(4,null)),e.ActiveEditorReadonlyContext=new P.RawContextKey("activeEditorIsReadonly",!1,(0,s.localize)(5,null)),e.ActiveEditorCanRevertContext=new P.RawContextKey("activeEditorCanRevert",!1,(0,s.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new P.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new P.RawContextKey("activeEditor",null,{type:"string",description:(0,s.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new P.RawContextKey("activeEditorAvailableEditorIds","",(0,s.localize)(8,null)),e.TextCompareEditorVisibleContext=new P.RawContextKey("textCompareEditorVisible",!1,(0,s.localize)(9,null)),e.TextCompareEditorActiveContext=new P.RawContextKey("textCompareEditorActive",!1,(0,s.localize)(10,null)),e.SideBySideEditorActiveContext=new P.RawContextKey("sideBySideEditorActive",!1,(0,s.localize)(11,null)),e.EditorGroupEditorsCountContext=new P.RawContextKey("groupEditorsCount",0,(0,s.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new P.RawContextKey("activeEditorGroupEmpty",!1,(0,s.localize)(13,null)),e.ActiveEditorGroupIndexContext=new P.RawContextKey("activeEditorGroupIndex",0,(0,s.localize)(14,null)),e.ActiveEditorGroupLastContext=new P.RawContextKey("activeEditorGroupLast",!1,(0,s.localize)(15,null)),e.ActiveEditorGroupLockedContext=new P.RawContextKey("activeEditorGroupLocked",!1,(0,s.localize)(16,null)),e.MultipleEditorGroupsContext=new P.RawContextKey("multipleEditorGroups",!1,(0,s.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new P.RawContextKey("editorIsOpen",!1,(0,s.localize)(18,null)),e.InEditorZenModeContext=new P.RawContextKey("inZenMode",!1,(0,s.localize)(19,null)),e.IsCenteredLayoutContext=new P.RawContextKey("isCenteredLayout",!1,(0,s.localize)(20,null)),e.SplitEditorsVertically=new P.RawContextKey("splitEditorsVertically",!1,(0,s.localize)(21,null)),e.EditorAreaVisibleContext=new P.RawContextKey("editorAreaVisible",!0,(0,s.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function i(E,O,z){for(const U of z.visibleEditorPanes)if(U.group.id===O&&E.matches(U.input))return U.getViewState()}e.findViewStateForEditor=i;function p(E){if(D(E))return!1;const O=E;return y.URI.isUri(O?.resource)}e.isResourceEditorInput=p;function o(E){if(D(E))return!1;const O=E;return O?.original!==void 0&&O.modified!==void 0}e.isResourceDiffEditorInput=o;function u(E){if(D(E)||o(E))return!1;const O=E;return O?.primary!==void 0&&O.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function d(E){if(D(E))return!1;const O=E;return O?O.resource===void 0||O.resource.scheme===w.Schemas.untitled||O.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=d;var F;(function(E){E[E.SHORT=0]="SHORT",E[E.MEDIUM=1]="MEDIUM",E[E.LONG=2]="LONG"})(F=e.Verbosity||(e.Verbosity={}));var _;(function(E){E[E.EXPLICIT=1]="EXPLICIT",E[E.AUTO=2]="AUTO",E[E.FOCUS_CHANGE=3]="FOCUS_CHANGE",E[E.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));var m;(function(E){E[E.None=0]="None",E[E.Readonly=2]="Readonly",E[E.Untitled=4]="Untitled",E[E.Singleton=8]="Singleton",E[E.RequiresTrust=16]="RequiresTrust",E[E.CanSplitInGroup=32]="CanSplitInGroup",E[E.ForceDescription=64]="ForceDescription"})(m=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class f extends T.Disposable{}e.AbstractEditorInput=f;function D(E){return E instanceof f}e.isEditorInput=D;function l(E){const O=E;return y.URI.isUri(O?.preferredResource)}function M(E){const O=E;return D(O?.primary)&&D(O?.secondary)}e.isSideBySideEditorInput=M;function r(E){const O=E;return D(O?.modified)&&D(O?.original)}e.isDiffEditorInput=r;function n(E){return D(E?.editor)}e.isEditorInputWithOptions=n;function b(E){const O=E;return n(E)&&O?.group!==void 0}e.isEditorInputWithOptionsAndGroup=b;function g(E){const O=E;return typeof O?.groupId=="number"&&D(O.editor)}e.isEditorIdentifier=g;var c;(function(E){E[E.UNKNOWN=0]="UNKNOWN",E[E.REPLACE=1]="REPLACE",E[E.MOVE=2]="MOVE",E[E.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var h;(function(E){E[E.GROUP_ACTIVE=0]="GROUP_ACTIVE",E[E.GROUP_INDEX=1]="GROUP_INDEX",E[E.GROUP_LOCKED=2]="GROUP_LOCKED",E[E.EDITOR_OPEN=3]="EDITOR_OPEN",E[E.EDITOR_CLOSE=4]="EDITOR_CLOSE",E[E.EDITOR_MOVE=5]="EDITOR_MOVE",E[E.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",E[E.EDITOR_LABEL=7]="EDITOR_LABEL",E[E.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",E[E.EDITOR_PIN=9]="EDITOR_PIN",E[E.EDITOR_STICKY=10]="EDITOR_STICKY",E[E.EDITOR_DIRTY=11]="EDITOR_DIRTY",E[E.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(h=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var v;(function(E){E[E.PRIMARY=1]="PRIMARY",E[E.SECONDARY=2]="SECONDARY",E[E.BOTH=3]="BOTH",E[E.ANY=4]="ANY"})(v=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:$,secondary:V}=this.getSideEditors(O);if($&&V){if(z?.supportSideBySide===v.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(V,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===v.ANY)return this.getOriginalUri($,{filterByScheme:z.filterByScheme})??this.getOriginalUri(V,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===v.PRIMARY?$:V}}if(o(O)||u(O))return;const U=l(O)?O.preferredResource:O.resource;return!U||!z||!z.filterByScheme?U:this.filterUri(U,z.filterByScheme)}getSideEditors(O){return M(O)||u(O)?{primary:O.primary,secondary:O.secondary}:r(O)||o(O)?{primary:O.modified,secondary:O.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:$,secondary:V}=this.getSideEditors(O);if($&&V){if(z?.supportSideBySide===v.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(V,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===v.ANY)return this.getCanonicalUri($,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(V,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===v.PRIMARY?$:V}}if(o(O)||u(O))return;const U=O.resource;return!U||!z||!z.filterByScheme?U:this.filterUri(U,z.filterByScheme)}filterUri(O,z){if(Array.isArray(z)){if(z.some(U=>O.scheme===U))return O}else if(z===O.scheme)return O}}e.EditorResourceAccessor=new a;var S;(function(E){E[E.LEFT=0]="LEFT",E[E.RIGHT=1]="RIGHT"})(S=e.CloseDirection||(e.CloseDirection={}));class I{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(O){const z=this.instantiationService=O.get(k.IInstantiationService);for(const[U,$]of this.editorSerializerConstructors)this.createEditorSerializer(U,$,z);this.editorSerializerConstructors.clear()}createEditorSerializer(O,z,U){const $=U.createInstance(z);this.editorSerializerInstances.set(O,$)}registerFileEditorFactory(O){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=O}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(O,z){if(this.editorSerializerConstructors.has(O)||this.editorSerializerInstances.has(O))throw new Error(`A editor serializer with type ID '${O}' was already registered.`);return this.instantiationService?this.createEditorSerializer(O,z,this.instantiationService):this.editorSerializerConstructors.set(O,z),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(O),this.editorSerializerInstances.delete(O)})}getEditorSerializer(O){return this.editorSerializerInstances.get(typeof O=="string"?O:O.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new I);async function N(E,O){if(!E||!E.length)return[];const z=await Promise.all(E.map(async U=>{const $=y.URI.revive(U.fileUri);if(!$||!await O.canHandleResource($))return;let ue=U.exists,K=U.type;if(typeof ue!="boolean"||typeof K!="number")try{K=(await O.resolve($)).isDirectory?A.FileType.Directory:A.FileType.Unknown,ue=!0}catch{ue=!1}if(!ue&&U.openOnlyIfExists||K===A.FileType.Directory)return;const re={selection:ue?U.selection:void 0,pinned:!0,override:U.editorOverrideId};let pe;return ue?pe={resource:$,options:re}:pe={resource:$,options:re,forceUntitled:!0},pe}));return(0,R.coalesce)(z)}e.pathsToEditors=N;var B;(function(E){E[E.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",E[E.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(ye[155],_e([0,1,4,14,126]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new s.Emitter,this._onExit=new s.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,C,A,R){const w={command:P};if(C&&Object.keys(C).length>0&&(w.arguments=C),this.internalSend("request",w),typeof R=="number"){const i=setTimeout(()=>{clearTimeout(i);const p=this.pendingRequests.get(w.seq);if(p){this.pendingRequests.delete(w.seq);const o={type:"response",seq:0,request_seq:w.seq,success:!1,command:P,message:(0,y.localize)(0,null,R,P)};p(o)}},R)}return A&&this.pendingRequests.set(w.seq,A),w.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,C){return P.type!=="event"||C.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,t.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":{const C=P,A=this.pendingRequests.get(C.request_seq);A&&(this.pendingRequests.delete(C.request_seq),A(C));break}}}}internalSend(P,C){C.type=P,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((C,A)=>P.set(A,C)),await(0,t.timeout)(500),P.forEach((C,A)=>{C({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(ye[156],_e([0,1,9,2,17,26,11]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function C(r,n,b){return r.replace(P,function(g,c){return n&&c.length>0&&c[0]!=="_"?g:b&&b.hasOwnProperty(c)?b[c]:g})}e.formatPII=C;function A(r){const n={};for(const b of Object.keys(r))b.startsWith("!")||(n[b]=r[b]);return n}e.filterExceptionsFromTelemetry=A;function R(r){return r.configuration.request==="attach"&&!w(r)&&(!r.parentSession||R(r.parentSession))}e.isSessionAttach=R;function w(r){let n=r.configuration.type;if(!!n)return n==="vslsShare"&&(n=r.configuration.adapterProxy.configuration.type),(0,s.equalsIgnoreCase)(n,"extensionhost")||(0,s.equalsIgnoreCase)(n,"pwa-extensionhost")?r:r.parentSession?w(r.parentSession):void 0}e.getExtensionHostDebugSession=w;function i(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=i;function p(r,n,b){let g,c=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let v=null;for(;v=h.exec(r);){const a=v.index+1,S=a+v[0].length;if(a<=n&&S>=b){g=v[0],c=a;break}}if(g){const a=/\w+/g;let S=null;for(;(S=a.exec(g))&&!(S.index+1+c+S[0].length>=b););S&&(g=g.substring(0,a.lastIndex))}return g?{start:c,end:c+g.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(r){return!!(r&&r.match(o))}e.isUri=u;function d(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(u(r.path))return t.URI.parse(r.path);if((0,y.isAbsolute)(r.path))return t.URI.file(r.path)}return r.path}function F(r){if(typeof r.path=="object"){const n=t.URI.revive(r.path);if(n)return n.scheme===k.Schemas.file?n.fsPath:n.toString()}return r.path}function _(r,n){const b=n?d:F,g=(0,T.deepClone)(r);return f(g,(c,h)=>{c&&h&&(h.path=b(h))}),g}e.convertToDAPaths=_;function m(r,n){const b=n?d:F,g=(0,T.deepClone)(r);return f(g,(c,h)=>{!c&&h&&(h.path=b(h))}),g}e.convertToVSCPaths=m;function f(r,n){switch(r.type){case"event":{const b=r;switch(b.event){case"output":n(!1,b.body.source);break;case"loadedSource":n(!1,b.body.source);break;case"breakpoint":n(!1,b.body.breakpoint.source);break;default:break}break}case"request":{const b=r;switch(b.command){case"setBreakpoints":n(!0,b.arguments.source);break;case"breakpointLocations":n(!0,b.arguments.source);break;case"source":n(!0,b.arguments.source);break;case"gotoTargets":n(!0,b.arguments.source);break;case"launchVSCode":b.arguments.args.forEach(g=>n(!1,g));break;default:break}break}case"response":{const b=r;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(g=>n(!1,g.source));break;case"loadedSources":b.body.sources.forEach(g=>n(!1,g));break;case"scopes":b.body.scopes.forEach(g=>n(!1,g.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(g=>n(!1,g.source));break;case"setBreakpoints":b.body.breakpoints.forEach(g=>n(!1,g.source));break;default:break}break}}}function D(r){return r.filter(n=>!n.presentation?.hidden).sort((n,b)=>n.presentation?b.presentation?n.presentation.group?b.presentation.group?n.presentation.group!==b.presentation.group?n.presentation.group.localeCompare(b.presentation.group):l(n.presentation.order,b.presentation.order):-1:b.presentation.group?1:l(n.presentation.order,b.presentation.order):-1:b.presentation?1:0)}e.getVisibleAndSorted=D;function l(r,n){return typeof r!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:r-n}async function M(r,n){const b=r.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(b!=="none"&&(await n.saveAll(),b==="allEditorsInActiveGroup")){const g=n.activeEditorPane;g&&g.input.resource?.scheme===k.Schemas.untitled&&await n.save({editor:g.input,groupId:g.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=M}),define(ye[87],_e([0,1,29,157,76,11,17,23,45]),function(Z,e,s,t,y,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var A;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var w;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(w=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var i;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var o;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(o=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var F;(function(a){a.scheme=T.Schemas.vscodeNotebookCell;const S=/^ch(\d{7,})/;function I(U,$){return U.with({scheme:a.scheme,fragment:`ch${$.toString().padStart(7,"0")}${U.scheme!==T.Schemas.file?U.scheme:""}`})}a.generate=I;function N(U){if(U.scheme!==a.scheme)return;const $=S.exec(U.fragment);return $?{handle:Number($[1]),notebook:U.with({scheme:U.fragment.substring($[0].length)||T.Schemas.file,fragment:null})}:void 0}a.parse=N;function B(U,$,V){return U.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`ch${$.toString().padStart(7,"0")},${V??""},${U.scheme!==T.Schemas.file?U.scheme:""}`})}a.generateCellOutputUri=B;function E(U){if(U.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const $=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(U.fragment);if(!$)return;const V=Number($[1]),ue=$[2]&&$[2]!==""?$[2]:void 0,K=$[3];return{handle:V,outputId:ue,notebook:U.with({scheme:K||T.Schemas.file,fragment:null})}}a.parseCellOutputUri=E;function O(U,$,V){return U.with({scheme:V,fragment:`ch${$.toString().padStart(7,"0")}${U.scheme!==T.Schemas.file?U.scheme:""}`})}a.generateCellUri=O;function z(U,$){if(U.scheme!==$)return;const V=S.exec(U.fragment);return V?{handle:Number(V[1]),notebook:U.with({scheme:U.fragment.substring(V[0].length)||T.Schemas.file,fragment:null})}:void 0}a.parseCellUri=z})(F=e.CellUri||(e.CellUri={}));const _=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(a){return _.get(a)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=m;function f(a){return _.get(a)?.supportedByCore??!1}e.mimeTypeSupportedByCore=f;function D(a){return _.get(a)?.mergeable??!1}e.mimeTypeIsMergeable=D;const l=a=>P.isWindows?a.replace(/\//g,"\\"):a;class M{constructor(S=[],I=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=I,this.order=[...new Set(S)].map(N=>({pattern:N,matches:s.parse(l(N))}))}sort(S){const I=new Map(t.Iterable.map(S,B=>[B,l(B)]));let N=[];for(const{matches:B}of this.order)for(const[E,O]of I)if(B(O)){N.push(E),I.delete(E);break}return I.size&&(N=N.concat([...I.keys()].sort((B,E)=>this.defaultOrder.indexOf(B)-this.defaultOrder.indexOf(E)))),N}prioritize(S,I){const N=this.findIndex(S);if(N===-1){this.order.unshift({pattern:S,matches:s.parse(l(S))});return}const B=new Set(I.map(O=>this.findIndex(O,N)));B.delete(-1);const E=Array.from(B).sort();this.order.splice(N+1,0,...E.map(O=>this.order[O]));for(let O=E.length-1;O>=0;O--)this.order.splice(E[O],1)}toArray(){return this.order.map(S=>S.pattern)}findIndex(S,I=this.order.length){const N=l(S);for(let B=0;B<I;B++)if(this.order[B].matches(N))return B;return-1}}e.MimeTypeDisplayOrder=M;function r(a,S,I,N=(B,E)=>B===E){const B=[];function E(U,$,V){if($===0&&V.length===0)return;const ue=B[B.length-1];ue&&ue.start+ue.deleteCount===U?(ue.deleteCount+=$,ue.toInsert.push(...V)):B.push({start:U,deleteCount:$,toInsert:V})}let O=0,z=0;for(;;){if(O===a.length){E(O,0,S.slice(z));break}if(z===S.length){E(O,a.length-O,[]);break}const U=a[O],$=S[z];if(N(U,$)){O+=1,z+=1;continue}I($)?(E(O,1,[]),O+=1):(E(O,0,[$]),z+=1)}return B}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(a){a.default="default",a.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function b(a){const S=a;return!!((typeof S.include=="string"||s.isRelativePattern(S.include))&&(typeof S.exclude=="string"||s.isRelativePattern(S.exclude)))}e.isDocumentExcludePattern=b;function g(a,S,I){if(Array.isArray(a.viewType)&&a.viewType.indexOf(S)>=0||a.viewType===S)return!0;if(a.filenamePattern){const N=b(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,B=b(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(s.match(N,(0,k.basename)(I.fsPath).toLowerCase()))return!(B&&s.match(B,(0,k.basename)(I.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=g;class c{constructor(S){this.textModel=S}getElements(){const S=new Int32Array(this.textModel.cells.length);for(let I=0;I<this.textModel.cells.length;I++)S[I]=this.textModel.cells[I].getHashValue();return S}}e.CellSequence=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var h;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class v{static create(S){return`${v._prefix}${S}`}static parse(S){if(S.startsWith(v._prefix))return S.substring(v._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=v,v._prefix="notebook/"}),define(ye[158],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,s.createDecorator)("INotebookExecutionService")}),define(ye[159],_e([0,1,3,45]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,s.createDecorator)(e.OUTPUT_SERVICE_ID);var y;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ye[160],_e([0,1,128,3,45]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new y.RawContextKey("customExecutionSupported",!0,s.localize(0,null)),e.ShellExecutionSupportedContext=new y.RawContextKey("shellExecutionSupported",!1,s.localize(1,null)),e.ProcessExecutionSupportedContext=new y.RawContextKey("processExecutionSupported",!1,s.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ye[161],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function s(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=s;function t(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=t}),define(ye[88],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var s;(function(w){w[w.Unset=0]="Unset",w[w.Queued=1]="Queued",w[w.Running=2]="Running",w[w.Passed=3]="Passed",w[w.Failed=4]="Failed",w[w.Skipped=5]="Skipped",w[w.Errored=6]="Errored"})(s=e.TestResultState||(e.TestResultState={}));var t;(function(w){w[w.Run=2]="Run",w[w.Debug=4]="Debug",w[w.Coverage=8]="Coverage",w[w.HasNonDefaultProfile=16]="HasNonDefaultProfile",w[w.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(w){w[w.Error=0]="Error",w[w.Info=1]="Info"})(y=e.TestMessageType||(e.TestMessageType={}));var T;(function(w){w[w.NotExpandable=0]="NotExpandable",w[w.Expandable=1]="Expandable",w[w.BusyExpanding=2]="BusyExpanding",w[w.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(w,i)=>{i.expand!==void 0&&(w.expand=i.expand),i.item!==void 0&&(w.item=w.item?Object.assign(w.item,i.item):i.item)};e.applyTestItemUpdate=k;var P;(function(w){w[w.Function=0]="Function",w[w.Statement=1]="Statement"})(P=e.DetailType||(e.DetailType={}));var C;(function(w){w[w.Add=0]="Add",w[w.Update=1]="Update",w[w.Remove=2]="Remove",w[w.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",w[w.Retire=4]="Retire",w[w.AddTag=5]="AddTag",w[w.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(i){}update(i){}remove(i,p){}complete(){}}e.IncrementalChangeCollector=A;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const p=this.createChangeCollector();for(const o of i)switch(o[0]){case 0:{const u=o[1];if(u.parent){if(this.items.has(u.parent)){const d=this.items.get(u.parent);d.children.add(u.item.extId);const F=this.createItem(u,d);this.items.set(u.item.extId,F),p.add(F)}}else{const d=this.createItem(u);this.roots.add(d),this.items.set(u.item.extId,d),p.add(d)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=o[1],d=this.items.get(u.extId);if(!d)break;u.expand!==void 0&&(d.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(d,u),p.update(d);break}case 2:{const u=this.items.get(o[1]);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const d=[[o[1]]];for(;d.length;)for(const F of d.pop()){const _=this.items.get(F);_&&(d.push(_.children),this.items.delete(F),p.remove(_,_!==u),_.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}p.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=R}),define(ye[67],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(T){T.Delimiter="\0"})(s=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class y{constructor(k,P=k.length){if(this.path=k,this.viewEnd=P,k.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,P,C=k.parent){if(k.id===P)return new y([P]);let A=[k.id];for(let R=C;R&&R.id!==P;R=R.parent)A.push(R.id);return A.push(P),new y(A.reverse())}static isRoot(k){return!k.includes("\0")}static fromString(k){return new y(k.split("\0"))}static join(k,P){return new y([...k.path,P])}static joinToString(k,P){return k.toString()+"\0"+P}static compare(k,P){return k===P?0:P.startsWith(k+"\0")?2:k.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new y(this.path,k)}compare(k){if(typeof k=="string")return y.compare(this.toString(),k);for(let P=0;P<k.viewEnd&&P<this.viewEnd;P++)if(k.path[P]!==this.path[P])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=y}),define(ye[162],_e([0,1,17,89,10,26,23,78,129]),function(Z,e,s,t,y,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(w,i,p){this._contributedVariables=new Map,this._context=w,this._labelService=i,p&&(this._envVariablesPromise=p.then(o=>this.prepareEnv(o)))}prepareEnv(w){if(k.isWindows){const i=Object.create(null);return Object.keys(w).forEach(p=>{i[p.toLowerCase()]=w[p]}),i}return w}resolveWithEnvironment(w,i,p){return this.recursiveResolve(this.prepareEnv(w),i?i.uri:void 0,p)}async resolveAsync(w,i){return this.recursiveResolve(await this._envVariablesPromise,w?w.uri:void 0,i)}async resolveAnyBase(w,i,p,o){const u=T.deepClone(i);return k.isWindows&&u.windows?Object.keys(u.windows).forEach(d=>u[d]=u.windows[d]):k.isMacintosh&&u.osx?Object.keys(u.osx).forEach(d=>u[d]=u.osx[d]):k.isLinux&&u.linux&&Object.keys(u.linux).forEach(d=>u[d]=u.linux[d]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,w?w.uri:void 0,u,p,o)}async resolveAnyAsync(w,i,p){return this.resolveAnyBase(w,i,p)}async resolveAnyMap(w,i,p){const o=new Map;return{newConfig:await this.resolveAnyBase(w,i,p,o),resolvedVariables:o}}resolveWithInteractionReplace(w,i,p,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,i,p,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,i){if(this._contributedVariables.has(w))throw new Error("Variable "+w+" is contributed twice.");this._contributedVariables.set(w,i)}recursiveResolve(w,i,p,o,u){if(y.isString(p))return this.resolveString(w,i,p,o,u);if(y.isArray(p))return p.map(d=>this.recursiveResolve(w,i,d,o,u));if(y.isObject(p)){let d=Object.create(null);return Object.keys(p).forEach(F=>{const _=this.resolveString(w,i,F,o,u);d[_]=this.recursiveResolve(w,i,p[F],o,u)}),d}return p}resolveString(w,i,p,o,u){return p.replace(A.VARIABLE_REGEXP,(F,_)=>{if(_.includes(A.VARIABLE_LHS))return F;let m=this.evaluateSingleVariable(w,F,_,i,o);return u&&u.set(_,m),m!==F&&y.isString(m)&&m.match(A.VARIABLE_REGEXP)&&(m=this.resolveString(w,i,m,o,u)),m})}fsPath(w){return this._labelService?this._labelService.getUriLabel(w,{noPrefix:!0}):w.fsPath}evaluateSingleVariable(w,i,p,o,u){let d;const F=p.split(":");F.length>1&&(p=F[0],d=F[1]);const _=()=>{const D=this._context.getFilePath();if(D)return D;throw new Error((0,C.localize)(0,null,i))},m=()=>{const D=_();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,C.localize)(1,null,i,s.basename(D)))},f=()=>{if(d){const D=this._context.getFolderUri(d);if(D)return D;throw new Error((0,C.localize)(2,null,i,d))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,i)):new Error((0,C.localize)(4,null,i))};switch(p){case"env":if(d){if(w){const D=w[k.isWindows?d.toLowerCase():d];if(y.isString(D))return D}return""}throw new Error((0,C.localize)(5,null,i));case"config":if(d){const D=this._context.getConfigurationValue(o,d);if(y.isUndefinedOrNull(D))throw new Error((0,C.localize)(6,null,i,d));if(y.isObject(D))throw new Error((0,C.localize)(7,null,i,d));return D}throw new Error((0,C.localize)(8,null,i));case"command":return this.resolveFromMap(i,d,u,"command");case"input":return this.resolveFromMap(i,d,u,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return o||d?(0,P.normalizeDriveLetter)(this.fsPath(f())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return s.basename(this.fsPath(f()));case"lineNumber":{const D=this._context.getLineNumber();if(D)return D;throw new Error((0,C.localize)(9,null,i))}case"selectedText":{const D=this._context.getSelectedText();if(D)return D;throw new Error((0,C.localize)(10,null,i))}case"file":return _();case"fileWorkspaceFolder":return m();case"relativeFile":return o||d?s.relative(this.fsPath(f()),_()):_();case"relativeFileDirname":{const D=s.dirname(_());if(o||d){const l=s.relative(this.fsPath(f()),D);return l.length===0?".":l}return D}case"fileDirname":return s.dirname(_());case"fileExtname":return s.extname(_());case"fileBasename":return s.basename(_());case"fileBasenameNoExtension":{const D=s.basename(_());return D.slice(0,D.length-s.extname(D).length)}case"fileDirnameBasename":return s.basename(s.dirname(_()));case"execPath":{const D=this._context.getExecPath();return D||i}case"execInstallFolder":{const D=this._context.getAppRoot();return D||i}case"pathSeparator":return s.sep;default:try{const D=d?`${p}:${d}`:p;return this.resolveFromMap(i,D,u,void 0)}catch{return i}}}}resolveFromMap(w,i,p,o){if(i&&p){const u=o===void 0?p[i]:p[o+":"+i];if(typeof u=="string")return u;throw new Error((0,C.localize)(11,null,w))}return w}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[90],_e([0,1,3,154]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,s.createDecorator)("editorGroupsService");var y;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var T;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var P;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function A(o){const u=o;return(0,t.isEditorInput)(u?.editor)&&(0,t.isEditorInput)(u?.replacement)}e.isEditorReplacement=A;var R;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function i(o){const u=o;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.isEditorGroup=i;function p(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(ye[163],_e([0,1,3,90]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,s.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(T){const k=T;return typeof T=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=y}),define(ye[8],_e([0,1,16,22,77,225,55,26,10,2,59,58,130,82,48,87,67,163,7]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var m;(function(ne){function ge(W){const{selectionStartLineNumber:be,selectionStartColumn:Pe,positionLineNumber:Ye,positionColumn:xe}=W,ut=new _.Position(be-1,Pe-1),wt=new _.Position(Ye-1,xe-1);return new _.Selection(ut,wt)}ne.to=ge;function te(W){const{anchor:be,active:Pe}=W;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}ne.from=te})(m=e.Selection||(e.Selection={}));var f;(function(ne){function ge(W){if(!W)return;const{start:be,end:Pe}=W;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}ne.from=ge;function te(W){if(!W)return;const{startLineNumber:be,startColumn:Pe,endLineNumber:Ye,endColumn:xe}=W;return new _.Range(be-1,Pe-1,Ye-1,xe-1)}ne.to=te})(f=e.Range||(e.Range={}));var D;(function(ne){function ge(te){switch(te){case 1:return _.StandardTokenType.Comment;case 0:return _.StandardTokenType.Other;case 3:return _.StandardTokenType.RegEx;case 2:return _.StandardTokenType.String}}ne.to=ge})(D=e.TokenType||(e.TokenType={}));var l;(function(ne){function ge(W){return new _.Position(W.lineNumber-1,W.column-1)}ne.to=ge;function te(W){return{lineNumber:W.line+1,column:W.character+1}}ne.from=te})(l=e.Position||(e.Position={}));var M;(function(ne){function ge(be,Pe){return(0,s.coalesce)((0,s.asArray)(be).map(Ye=>te(Ye,Pe)))}ne.from=ge;function te(be,Pe){if(typeof be=="string")return{$serialized:!0,language:be};if(be)return{$serialized:!0,language:be.language,scheme:W(be.scheme,Pe),pattern:typeof be.pattern=="undefined"?void 0:Q.from(be.pattern),exclusive:be.exclusive}}function W(be,Pe){return Pe&&typeof be=="string"?Pe.transformOutgoingScheme(be):be}})(M=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ne){function ge(W){switch(W){case _.DiagnosticTag.Unnecessary:return 1;case _.DiagnosticTag.Deprecated:return 2}}ne.from=ge;function te(W){switch(W){case 1:return _.DiagnosticTag.Unnecessary;case 2:return _.DiagnosticTag.Deprecated;default:return}}ne.to=te})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(ne){function ge(W){let be;return W.code&&((0,C.isString)(W.code)||(0,C.isNumber)(W.code)?be=String(W.code):be={value:String(W.code.value),target:W.code.target}),{...f.from(W.range),message:W.message,source:W.source,code:be,severity:g.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(b.from),tags:Array.isArray(W.tags)?(0,s.coalesce)(W.tags.map(r.from)):void 0}}ne.from=ge;function te(W){const be=new _.Diagnostic(f.to(W),W.message,g.to(W.severity));return be.source=W.source,be.code=(0,C.isString)(W.code)?W.code:W.code?.value,be.relatedInformation=W.relatedInformation&&W.relatedInformation.map(b.to),be.tags=W.tags&&(0,s.coalesce)(W.tags.map(r.to)),be}ne.to=te})(n=e.Diagnostic||(e.Diagnostic={}));var b;(function(ne){function ge(W){return{...f.from(W.location.range),message:W.message,resource:W.location.uri}}ne.from=ge;function te(W){return new _.DiagnosticRelatedInformation(new _.Location(W.resource,f.to(W)),W.message)}ne.to=te})(b=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var g;(function(ne){function ge(W){switch(W){case _.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case _.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case _.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case _.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}ne.from=ge;function te(W){switch(W){case p.MarkerSeverity.Info:return _.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return _.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return _.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return _.DiagnosticSeverity.Hint;default:return _.DiagnosticSeverity.Error}}ne.to=te})(g=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(ne){function ge(W){return typeof W=="number"&&W>=_.ViewColumn.One?W-1:W===_.ViewColumn.Beside?F.SIDE_GROUP:F.ACTIVE_GROUP}ne.from=ge;function te(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}ne.to=te})(c=e.ViewColumn||(e.ViewColumn={}));function h(ne){return typeof ne.range!="undefined"}function v(ne){return ne.length===0?!0:!!h(ne[0])}e.isDecorationOptionsArr=v;var a;(function(ne){function ge(xe){return xe.map(ne.from)}ne.fromMany=ge;function te(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function W(xe){let ut;if(te(xe)){const{language:ft,value:pt}=xe;ut={value:"```"+ft+`
`+pt+"\n```\n"}}else _.MarkdownString.isMarkdownString(xe)?ut={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml}:typeof xe=="string"?ut={value:xe}:ut={value:""};const wt=Object.create(null);ut.uris=wt;const Ct=ft=>{try{let pt=A.URI.parse(ft,!0);pt=pt.with({query:be(pt.query,wt)}),wt[ft]=pt}catch{}return""},bt=new T.Renderer;return bt.link=Ct,bt.image=ft=>Ct(y.parseHrefAndDimensions(ft).href),T(ut.value,{renderer:bt}),ut}ne.from=W;function be(xe,ut){if(!xe)return xe;let wt;try{wt=(0,k.parse)(xe)}catch{}if(!wt)return xe;let Ct=!1;return wt=(0,P.cloneAndChange)(wt,bt=>{if(A.URI.isUri(bt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ft]=bt,Ct=!0,ft}else return}),Ct?JSON.stringify(wt):xe}function Pe(xe){const ut=new _.MarkdownString(xe.value,xe.supportThemeIcons);return ut.isTrusted=xe.isTrusted,ut.supportHtml=xe.supportHtml,ut}ne.to=Pe;function Ye(xe){if(!!xe)return typeof xe=="string"?xe:ne.from(xe)}ne.fromStrict=Ye})(a=e.MarkdownString||(e.MarkdownString={}));function S(ne){return v(ne)?ne.map(ge=>({range:f.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?a.fromMany(ge.hoverMessage):ge.hoverMessage?a.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):ne.map(ge=>({range:f.from(ge)}))}e.fromRangeOrRangeWithMessage=S;function I(ne){return typeof ne=="undefined"?ne:typeof ne=="string"?A.URI.file(ne):ne}e.pathOrURIToURI=I;var N;(function(ne){function ge(te){return typeof te=="undefined"?te:{contentText:te.contentText,contentIconPath:te.contentIconPath?I(te.contentIconPath):void 0,border:te.border,borderColor:te.borderColor,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,color:te.color,backgroundColor:te.backgroundColor,margin:te.margin,width:te.width,height:te.height}}ne.from=ge})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(ne){function ge(te){return typeof te=="undefined"?te:{backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?I(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?N.from(te.before):void 0,after:te.after?N.from(te.after):void 0}}ne.from=ge})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var E;(function(ne){function ge(te){if(typeof te=="undefined")return te;switch(te){case _.DecorationRangeBehavior.OpenOpen:return 0;case _.DecorationRangeBehavior.ClosedClosed:return 1;case _.DecorationRangeBehavior.OpenClosed:return 2;case _.DecorationRangeBehavior.ClosedOpen:return 3}}ne.from=ge})(E=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(ne){function ge(te){return{isWholeLine:te.isWholeLine,rangeBehavior:te.rangeBehavior?E.from(te.rangeBehavior):void 0,overviewRulerLane:te.overviewRulerLane,light:te.light?B.from(te.light):void 0,dark:te.dark?B.from(te.dark):void 0,backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?I(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?N.from(te.before):void 0,after:te.after?N.from(te.after):void 0}}ne.from=ge})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(ne){function ge(W){return{text:W.newText,eol:W.newEol&&lt.from(W.newEol),range:f.from(W.range)}}ne.from=ge;function te(W){const be=new _.TextEdit(f.to(W.range),W.text);return be.newEol=typeof W.eol=="undefined"?void 0:lt.to(W.eol),be}ne.to=te})(z=e.TextEdit||(e.TextEdit={}));var U;(function(ne){function ge(W,be,Pe){const Ye={edits:[]};if(W instanceof _.WorkspaceEdit)for(let xe of W._allEntries())if(xe._type===1)Ye.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const ut=be?.getDocument(xe.uri);Ye.edits.push({_type:2,resource:xe.uri,edit:z.from(xe.edit),modelVersionId:ut?.version,metadata:xe.metadata})}else xe._type===3?Ye.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&Ye.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:Pe?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Je.from)}});return Ye}ne.from=ge;function te(W){const be=new _.WorkspaceEdit;for(const Pe of W.edits)Pe.edit?be.replace(A.URI.revive(Pe.resource),f.to(Pe.edit.range),Pe.edit.text):be.renameFile(A.URI.revive(Pe.oldUri),A.URI.revive(Pe.newUri),Pe.options);return be}ne.to=te})(U=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(ne){const ge=Object.create(null);ge[_.SymbolKind.File]=0,ge[_.SymbolKind.Module]=1,ge[_.SymbolKind.Namespace]=2,ge[_.SymbolKind.Package]=3,ge[_.SymbolKind.Class]=4,ge[_.SymbolKind.Method]=5,ge[_.SymbolKind.Property]=6,ge[_.SymbolKind.Field]=7,ge[_.SymbolKind.Constructor]=8,ge[_.SymbolKind.Enum]=9,ge[_.SymbolKind.Interface]=10,ge[_.SymbolKind.Function]=11,ge[_.SymbolKind.Variable]=12,ge[_.SymbolKind.Constant]=13,ge[_.SymbolKind.String]=14,ge[_.SymbolKind.Number]=15,ge[_.SymbolKind.Boolean]=16,ge[_.SymbolKind.Array]=17,ge[_.SymbolKind.Object]=18,ge[_.SymbolKind.Key]=19,ge[_.SymbolKind.Null]=20,ge[_.SymbolKind.EnumMember]=21,ge[_.SymbolKind.Struct]=22,ge[_.SymbolKind.Event]=23,ge[_.SymbolKind.Operator]=24,ge[_.SymbolKind.TypeParameter]=25;function te(be){return typeof ge[be]=="number"?ge[be]:6}ne.from=te;function W(be){for(const Pe in ge)if(ge[Pe]===be)return Number(Pe);return _.SymbolKind.Property}ne.to=W})($=e.SymbolKind||(e.SymbolKind={}));var V;(function(ne){function ge(W){switch(W){case _.SymbolTag.Deprecated:return 1}}ne.from=ge;function te(W){switch(W){case 1:return _.SymbolTag.Deprecated}}ne.to=te})(V=e.SymbolTag||(e.SymbolTag={}));var ue;(function(ne){function ge(W){return{name:W.name,kind:$.from(W.kind),tags:W.tags&&W.tags.map(V.from),containerName:W.containerName,location:ae.from(W.location)}}ne.from=ge;function te(W){const be=new _.SymbolInformation(W.name,$.to(W.kind),W.containerName,ae.to(W.location));return be.tags=W.tags&&W.tags.map(V.to),be}ne.to=te})(ue=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(ne){function ge(W){const be={name:W.name||"!!MISSING: name!!",detail:W.detail,range:f.from(W.range),selectionRange:f.from(W.selectionRange),kind:$.from(W.kind),tags:W.tags?.map(V.from)??[]};return W.children&&(be.children=W.children.map(ge)),be}ne.from=ge;function te(W){const be=new _.DocumentSymbol(W.name,W.detail,$.to(W.kind),f.to(W.range),f.to(W.selectionRange));return(0,s.isNonEmptyArray)(W.tags)&&(be.tags=W.tags.map(V.to)),W.children&&(be.children=W.children.map(te)),be}ne.to=te})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var re;(function(ne){function ge(W){const be=new _.CallHierarchyItem($.to(W.kind),W.name,W.detail||"",A.URI.revive(W.uri),f.to(W.range),f.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=ge;function te(W,be,Pe){if(be=be??W._sessionId,Pe=Pe??W._itemId,be===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:Pe,name:W.name,detail:W.detail,kind:$.from(W.kind),uri:W.uri,range:f.from(W.range),selectionRange:f.from(W.selectionRange),tags:W.tags?.map(V.from)}}ne.from=te})(re=e.CallHierarchyItem||(e.CallHierarchyItem={}));var pe;(function(ne){function ge(te){return new _.CallHierarchyIncomingCall(re.to(te.from),te.fromRanges.map(W=>f.to(W)))}ne.to=ge})(pe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var we;(function(ne){function ge(te){return new _.CallHierarchyOutgoingCall(re.to(te.to),te.fromRanges.map(W=>f.to(W)))}ne.to=ge})(we=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ae;(function(ne){function ge(W){return{range:W.range&&f.from(W.range),uri:W.uri}}ne.from=ge;function te(W){return new _.Location(A.URI.revive(W.uri),f.to(W.range))}ne.to=te})(ae=e.location||(e.location={}));var le;(function(ne){function ge(W){const be=W,Pe=W;return{originSelectionRange:be.originSelectionRange?f.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:Pe.uri,range:f.from(be.targetRange?be.targetRange:Pe.range),targetSelectionRange:be.targetSelectionRange?f.from(be.targetSelectionRange):void 0}}ne.from=ge;function te(W){return{targetUri:A.URI.revive(W.uri),targetRange:f.to(W.range),targetSelectionRange:W.targetSelectionRange?f.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?f.to(W.originSelectionRange):void 0}}ne.to=te})(le=e.DefinitionLink||(e.DefinitionLink={}));var Ce;(function(ne){function ge(W){return{range:f.from(W.range),contents:a.fromMany(W.contents)}}ne.from=ge;function te(W){return new _.Hover(W.contents.map(a.to),f.to(W.range))}ne.to=te})(Ce=e.Hover||(e.Hover={}));var Ee;(function(ne){function ge(W){return{range:f.from(W.range),expression:W.expression}}ne.from=ge;function te(W){return new _.EvaluatableExpression(f.to(W.range),W.expression)}ne.to=te})(Ee=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Fe;(function(ne){function ge(W){if(W instanceof _.InlineValueText)return{type:"text",range:f.from(W.range),text:W.text};if(W instanceof _.InlineValueVariableLookup)return{type:"variable",range:f.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof _.InlineValueEvaluatableExpression)return{type:"expression",range:f.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}ne.from=ge;function te(W){switch(W.type){case"text":return{range:f.to(W.range),text:W.text};case"variable":return{range:f.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:f.to(W.range),expression:W.expression}}}ne.to=te})(Fe=e.InlineValue||(e.InlineValue={}));var $e;(function(ne){function ge(W){return{frameId:W.frameId,stoppedLocation:f.from(W.stoppedLocation)}}ne.from=ge;function te(W){return new _.InlineValueContext(W.frameId,f.to(W.stoppedLocation))}ne.to=te})($e=e.InlineValueContext||(e.InlineValueContext={}));var Ve;(function(ne){function ge(W){return{range:f.from(W.range),kind:W.kind}}ne.from=ge;function te(W){return new _.DocumentHighlight(f.to(W.range),W.kind)}ne.to=te})(Ve=e.DocumentHighlight||(e.DocumentHighlight={}));var je;(function(ne){function ge(te){switch(te){case 1:return _.CompletionTriggerKind.TriggerCharacter;case 2:return _.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return _.CompletionTriggerKind.Invoke}}ne.to=ge})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var H;(function(ne){function ge(te){return{triggerKind:je.to(te.triggerKind),triggerCharacter:te.triggerCharacter}}ne.to=ge})(H=e.CompletionContext||(e.CompletionContext={}));var G;(function(ne){function ge(W){switch(W){case _.CompletionItemTag.Deprecated:return 1}}ne.from=ge;function te(W){switch(W){case 1:return _.CompletionItemTag.Deprecated}}ne.to=te})(G=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(ne){const ge=new Map([[_.CompletionItemKind.Method,0],[_.CompletionItemKind.Function,1],[_.CompletionItemKind.Constructor,2],[_.CompletionItemKind.Field,3],[_.CompletionItemKind.Variable,4],[_.CompletionItemKind.Class,5],[_.CompletionItemKind.Interface,7],[_.CompletionItemKind.Struct,6],[_.CompletionItemKind.Module,8],[_.CompletionItemKind.Property,9],[_.CompletionItemKind.Unit,12],[_.CompletionItemKind.Value,13],[_.CompletionItemKind.Constant,14],[_.CompletionItemKind.Enum,15],[_.CompletionItemKind.EnumMember,16],[_.CompletionItemKind.Keyword,17],[_.CompletionItemKind.Snippet,27],[_.CompletionItemKind.Text,18],[_.CompletionItemKind.Color,19],[_.CompletionItemKind.File,20],[_.CompletionItemKind.Reference,21],[_.CompletionItemKind.Folder,23],[_.CompletionItemKind.Event,10],[_.CompletionItemKind.Operator,11],[_.CompletionItemKind.TypeParameter,24],[_.CompletionItemKind.Issue,26],[_.CompletionItemKind.User,25]]);function te(Pe){return ge.get(Pe)??9}ne.from=te;const W=new Map([[0,_.CompletionItemKind.Method],[1,_.CompletionItemKind.Function],[2,_.CompletionItemKind.Constructor],[3,_.CompletionItemKind.Field],[4,_.CompletionItemKind.Variable],[5,_.CompletionItemKind.Class],[7,_.CompletionItemKind.Interface],[6,_.CompletionItemKind.Struct],[8,_.CompletionItemKind.Module],[9,_.CompletionItemKind.Property],[12,_.CompletionItemKind.Unit],[13,_.CompletionItemKind.Value],[14,_.CompletionItemKind.Constant],[15,_.CompletionItemKind.Enum],[16,_.CompletionItemKind.EnumMember],[17,_.CompletionItemKind.Keyword],[27,_.CompletionItemKind.Snippet],[18,_.CompletionItemKind.Text],[19,_.CompletionItemKind.Color],[20,_.CompletionItemKind.File],[21,_.CompletionItemKind.Reference],[23,_.CompletionItemKind.Folder],[10,_.CompletionItemKind.Event],[11,_.CompletionItemKind.Operator],[24,_.CompletionItemKind.TypeParameter],[25,_.CompletionItemKind.User],[26,_.CompletionItemKind.Issue]]);function be(Pe){return W.get(Pe)??_.CompletionItemKind.Property}ne.to=be})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var oe;(function(ne){function ge(te,W){const be=new _.CompletionItem(te.label);return be.insertText=te.insertText,be.kind=X.to(te.kind),be.tags=te.tags?.map(G.to),be.detail=te.detail,be.documentation=y.isMarkdownString(te.documentation)?a.to(te.documentation):te.documentation,be.sortText=te.sortText,be.filterText=te.filterText,be.preselect=te.preselect,be.commitCharacters=te.commitCharacters,R.Range.isIRange(te.range)?be.range=f.to(te.range):typeof te.range=="object"&&(be.range={inserting:f.to(te.range.insert),replacing:f.to(te.range.replace)}),be.keepWhitespace=typeof te.insertTextRules=="undefined"?!1:Boolean(te.insertTextRules&1),typeof te.insertTextRules!="undefined"&&te.insertTextRules&4?be.insertText=new _.SnippetString(te.insertText):(be.insertText=te.insertText,be.textEdit=be.range instanceof _.Range?new _.TextEdit(be.range,be.insertText):void 0),te.additionalTextEdits&&te.additionalTextEdits.length>0&&(be.additionalTextEdits=te.additionalTextEdits.map(Pe=>z.to(Pe))),be.command=W&&te.command?W.fromInternal(te.command):void 0,be}ne.to=ge})(oe=e.CompletionItem||(e.CompletionItem={}));var q;(function(ne){function ge(W){return{label:W.label,documentation:W.documentation?a.fromStrict(W.documentation):void 0}}ne.from=ge;function te(W){return{label:W.label,documentation:y.isMarkdownString(W.documentation)?a.to(W.documentation):W.documentation}}ne.to=te})(q=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(ne){function ge(W){return{label:W.label,documentation:W.documentation?a.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(q.from):[],activeParameter:W.activeParameter}}ne.from=ge;function te(W){return{label:W.label,documentation:y.isMarkdownString(W.documentation)?a.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(q.to):[],activeParameter:W.activeParameter}}ne.to=te})(ee=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(ne){function ge(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(ee.from):[]}}ne.from=ge;function te(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(ee.to):[]}}ne.to=te})(he=e.SignatureHelp||(e.SignatureHelp={}));var Re;(function(ne){function ge(W){return{text:W.text,position:l.from(W.position),kind:Ue.from(W.kind??_.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}ne.from=ge;function te(W){const be=new _.InlayHint(W.text,l.to(W.position),Ue.to(W.kind));return be.whitespaceAfter=W.whitespaceAfter,be.whitespaceBefore=W.whitespaceBefore,be}ne.to=te})(Re=e.InlayHint||(e.InlayHint={}));var Ue;(function(ne){function ge(W){return W}ne.from=ge;function te(W){return W}ne.to=te})(Ue=e.InlayHintKind||(e.InlayHintKind={}));var ze;(function(ne){function ge(W){return{range:f.from(W.range),url:W.target,tooltip:W.tooltip}}ne.from=ge;function te(W){let be;if(W.url)try{be=typeof W.url=="string"?A.URI.parse(W.url,!0):A.URI.revive(W.url)}catch{}return new _.DocumentLink(f.to(W.range),be)}ne.to=te})(ze=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(ne){function ge(W){const be=new _.ColorPresentation(W.label);return W.textEdit&&(be.textEdit=z.to(W.textEdit)),W.additionalTextEdits&&(be.additionalTextEdits=W.additionalTextEdits.map(Pe=>z.to(Pe))),be}ne.to=ge;function te(W){return{label:W.label,textEdit:W.textEdit?z.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(be=>z.from(be)):void 0}}ne.from=te})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(ne){function ge(W){return new _.Color(W[0],W[1],W[2],W[3])}ne.to=ge;function te(W){return[W.red,W.green,W.blue,W.alpha]}ne.from=te})(et=e.Color||(e.Color={}));var st;(function(ne){function ge(W){return{range:f.from(W.range)}}ne.from=ge;function te(W){return new _.SelectionRange(f.to(W.range))}ne.to=te})(st=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(ne){function ge(te){switch(te){case 2:return _.TextDocumentSaveReason.AfterDelay;case 1:return _.TextDocumentSaveReason.Manual;case 3:case 4:return _.TextDocumentSaveReason.FocusOut}}ne.to=ge})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(ne){function ge(W){switch(W){case _.TextEditorLineNumbersStyle.Off:return 0;case _.TextEditorLineNumbersStyle.Relative:return 2;case _.TextEditorLineNumbersStyle.On:default:return 1}}ne.from=ge;function te(W){switch(W){case 0:return _.TextEditorLineNumbersStyle.Off;case 2:return _.TextEditorLineNumbersStyle.Relative;case 1:default:return _.TextEditorLineNumbersStyle.On}}ne.to=te})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var lt;(function(ne){function ge(W){if(W===_.EndOfLine.CRLF)return 1;if(W===_.EndOfLine.LF)return 0}ne.from=ge;function te(W){if(W===1)return _.EndOfLine.CRLF;if(W===0)return _.EndOfLine.LF}ne.to=te})(lt=e.EndOfLine||(e.EndOfLine={}));var vt;(function(ne){function ge(te){if(typeof te=="object")return te.viewId;switch(te){case _.ProgressLocation.SourceControl:return 3;case _.ProgressLocation.Window:return 10;case _.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ne.from=ge})(vt=e.ProgressLocation||(e.ProgressLocation={}));var Oe;(function(ne){function ge(te){const W={start:te.start+1,end:te.end+1};return te.kind&&(W.kind=Rt.from(te.kind)),W}ne.from=ge})(Oe=e.FoldingRange||(e.FoldingRange={}));var Rt;(function(ne){function ge(te){if(te)switch(te){case _.FoldingRangeKind.Comment:return w.FoldingRangeKind.Comment;case _.FoldingRangeKind.Imports:return w.FoldingRangeKind.Imports;case _.FoldingRangeKind.Region:return w.FoldingRangeKind.Region}}ne.from=ge})(Rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var j;(function(ne){function ge(te){if(te)return{pinned:typeof te.preview=="boolean"?!te.preview:void 0,inactive:te.background,preserveFocus:te.preserveFocus,selection:typeof te.selection=="object"?f.from(te.selection):void 0,override:typeof te.override=="boolean"?i.EditorResolution.DISABLED:void 0}}ne.from=ge})(j=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(ne){function ge(W){return W instanceof _.RelativePattern||typeof W=="string"?W:te(W)?new _.RelativePattern(W.base,W.pattern):W}ne.from=ge;function te(W){const be=W;return be&&typeof be.base=="string"&&typeof be.pattern=="string"}})(Q=e.GlobPattern||(e.GlobPattern={}));var fe;(function(ne){function ge(te){if(te){if(Array.isArray(te))return te.map(ge);if(typeof te=="string")return te;{const W=te;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:Q.from(W.pattern),exclusive:W.exclusive}}}else return}ne.from=ge})(fe=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(ne){function ge(W){return{start:W.start,end:W.end}}ne.from=ge;function te(W){return new _.NotebookRange(W.start,W.end)}ne.to=te})(Ne=e.NotebookRange||(e.NotebookRange={}));var qe;(function(ne){function ge(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}ne.to=ge;function te(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}ne.from=te})(qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ot;(function(ne){function ge(W){switch(W){case _.NotebookCellKind.Markup:return u.CellKind.Markup;case _.NotebookCellKind.Code:default:return u.CellKind.Code}}ne.from=ge;function te(W){switch(W){case u.CellKind.Markup:return _.NotebookCellKind.Markup;case u.CellKind.Code:default:return _.NotebookCellKind.Code}}ne.to=te})(ot=e.NotebookCellKind||(e.NotebookCellKind={}));var ht;(function(ne){function ge(W){const be={metadata:W.metadata??Object.create(null),cells:[]};for(let Pe of W.cells)_.NotebookCellData.validate(Pe),be.cells.push(Je.from(Pe));return be}ne.from=ge;function te(W){const be=new _.NotebookData(W.cells.map(Je.to));return(0,C.isEmptyObject)(W.metadata)||(be.metadata=W.metadata),be}ne.to=te})(ht=e.NotebookData||(e.NotebookData={}));var Je;(function(ne){function ge(W){return{cellKind:ot.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:qe.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Ae.from):[]}}ne.from=ge;function te(W){return new _.NotebookCellData(ot.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Ae.to):void 0,W.metadata,W.internalMetadata?qe.to(W.internalMetadata):void 0)}ne.to=te})(Je=e.NotebookCellData||(e.NotebookCellData={}));var Tt;(function(ne){function ge(W){return{mime:W.mime,valueBytes:t.VSBuffer.wrap(W.data)}}ne.from=ge;function te(W){return new _.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}ne.to=te})(Tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(ne){function ge(W){return{outputId:W.id,items:W.items.map(Tt.from),metadata:W.metadata}}ne.from=ge;function te(W){const be=W.items.map(Tt.to);return new _.NotebookCellOutput(be,W.outputId,W.metadata)}ne.to=te})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(ne){function ge(Pe){if(Pe!=null){if(Pe instanceof _.RelativePattern||typeof Pe=="string")return Pe;if(be(Pe))return new _.RelativePattern(Pe.base,Pe.pattern);if(W(Pe))return{include:Q.from(Pe.include)||void 0,exclude:Q.from(Pe.exclude)||void 0}}}ne.from=ge;function te(Pe){return typeof Pe=="string"?Pe:be(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}ne.to=te;function W(Pe){const Ye=Pe,xe=Q.from(Ye.include);if(!(xe&&xe instanceof _.RelativePattern||typeof xe=="string"))return!1;const ut=Q.from(Ye.exclude);return!!(ut&&ut instanceof _.RelativePattern||typeof ut=="string")}function be(Pe){const Ye=Pe;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ve;(function(ne){function ge(te){return{backgroundColor:te.backgroundColor,borderColor:te.borderColor,top:te.top?N.from(te.top):void 0}}ne.from=ge})(ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ie;(function(ne){function ge(te,W,be){const Pe=typeof te.command=="string"?{title:"",command:te.command}:te.command;return{alignment:te.alignment===_.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(Pe,be),text:te.text,tooltip:te.tooltip,accessibilityInformation:te.accessibilityInformation,priority:te.priority}}ne.from=ge})(ie=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var se;(function(ne){function ge(te){return{transientOutputs:te?.transientOutputs??!1,transientCellMetadata:te?.transientCellMetadata??{},transientDocumentMetadata:te?.transientDocumentMetadata??{}}}ne.from=ge})(se=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var de;(function(ne){function ge(W){return{uri:W.uri,provides:W.provides}}ne.from=ge;function te(W){return new _.NotebookRendererScript(A.URI.revive(W.uri),W.provides)}ne.to=te})(de=e.NotebookRendererScript||(e.NotebookRendererScript={}));var me;(function(ne){function ge(W){return{message:a.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?ae.from(W.location):void 0}}ne.from=ge;function te(W){const be=new _.TestMessage(typeof W.message=="string"?W.message:a.to(W.message));return be.actualOutput=W.actual,be.expectedOutput=W.expected,be.location=W.location?ae.to(W.location):void 0,be}ne.to=te})(me=e.TestMessage||(e.TestMessage={}));var Te;(function(ne){let ge;(function(te){te.Delimiter="\0"})(ge||(ge={})),ne.namespace=(te,W)=>te+"\0"+W,ne.denamespace=te=>{const W=te.indexOf("\0");return{ctrlId:te.slice(0,W),tagId:te.slice(W+1)}}})(Te=e.TestTag||(e.TestTag={}));var We;(function(ne){function ge(Pe){const Ye=(0,o.getPrivateApiFor)(Pe).controllerId;return{extId:d.TestId.fromExtHostTestItem(Pe,Ye).toString(),label:Pe.label,uri:Pe.uri,tags:Pe.tags.map(xe=>Te.namespace(Ye,xe.id)),range:f.from(Pe.range)||null,description:Pe.description||null,error:Pe.error&&a.fromStrict(Pe.error)||null}}ne.from=ge;function te(Pe){return{parent:void 0,error:void 0,id:d.TestId.fromString(Pe.extId).localId,label:Pe.label,uri:A.URI.revive(Pe.uri),tags:(Pe.tags||[]).map(Ye=>{const{tagId:xe}=Te.denamespace(Ye);return new _.TestTag(xe)}),range:f.to(Pe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Pe.description||void 0}}ne.toPlain=te;function W(Pe){const Ye=d.TestId.fromString(Pe.extId),xe=new o.TestItemImpl(Ye.controllerId,Ye.localId,Pe.label,A.URI.revive(Pe.uri));return xe.range=f.to(Pe.range||void 0),xe.description=Pe.description||void 0,xe}function be(Pe){let Ye;for(const xe of Pe.tests){const ut=W(xe.item);(0,o.getPrivateApiFor)(ut).parent=Ye,Ye=ut}return Ye}ne.toItemFromContext=be})(We=e.TestItem||(e.TestItem={})),function(ne){function ge(W){return{id:W.id}}ne.from=ge;function te(W){return new _.TestTag(W.id)}ne.to=te}(Te=e.TestTag||(e.TestTag={}));var Le;(function(ne){const ge=(W,be)=>{const Pe={...We.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(xe=>xe.type===0).map(me.to)})),children:W.children.map(Ye=>be.get(Ye)).filter(C.isDefined).map(Ye=>ge(Ye,be))};for(const Ye of Pe.children)Ye.parent=Pe;return Pe};function te(W){const be=[],Pe=new Map;for(const Ye of W.items)Pe.set(Ye.item.extId,Ye),W.request.targets.some(xe=>xe.controllerId===Ye.controllerId&&xe.testIds.includes(Ye.item.extId))&&be.push(Ye);return{completedAt:W.completedAt,results:be.map(Ye=>ge(Ye,Pe))}}ne.to=te})(Le=e.TestResults||(e.TestResults={}));var Ke;(function(ne){function ge(Pe){return{covered:Pe.covered,total:Pe.covered}}function te(Pe){return"line"in Pe?l.from(Pe):f.from(Pe)}function W(Pe){return"branches"in Pe?{count:Pe.executionCount,location:te(Pe.location),type:1,branches:Pe.branches.length?Pe.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&te(Ye.location)})):void 0}:{type:0,count:Pe.executionCount,location:te(Pe.location)}}ne.fromDetailed=W;function be(Pe){return{uri:Pe.uri,statement:ge(Pe.statementCoverage),branch:Pe.branchCoverage&&ge(Pe.branchCoverage),function:Pe.functionCoverage&&ge(Pe.functionCoverage),details:Pe.detailedCoverage?.map(W)}}ne.fromFile=be})(Ke=e.TestCoverage||(e.TestCoverage={}));var it;(function(ne){function ge(te){switch(te){case 1:return _.CodeActionTriggerKind.Invoke;case 2:return _.CodeActionTriggerKind.Automatic}}ne.to=ge})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var rt;(function(ne){function ge(W){const be=new _.TypeHierarchyItem($.to(W.kind),W.name,W.detail||"",A.URI.revive(W.uri),f.to(W.range),f.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=ge;function te(W,be,Pe){if(be=be??W._sessionId,Pe=Pe??W._itemId,be===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:Pe,kind:$.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:f.from(W.range),selectionRange:f.from(W.selectionRange),tags:W.tags?.map(V.from)}}ne.from=te})(rt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ye[164],_e([0,1,2,15,7,8,226]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(A,R,w,i={timeout:1500,errors:3}){this._logService=A,this._documents=R,this._mainThreadBulkEdits=w,this._thresholds=i,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(R,w,i)=>{const o={dispose:this._callbacks.push([R,w,A])};return Array.isArray(i)&&i.push(o),o}}async $participateInSave(A,R){const w=s.URI.revive(A);let i=!1;const p=setTimeout(()=>i=!0,this._thresholds.timeout),o=[];try{for(let u of[...this._callbacks]){if(i)break;const d=this._documents.getDocument(w),F=await this._deliverEventAsyncAndBlameBadListeners(u,{document:d,reason:T.TextDocumentSaveReason.to(R)});o.push(F)}}finally{clearTimeout(p)}return o}_deliverEventAsyncAndBlameBadListeners([A,R,w],i){const p=this._badListeners.get(A);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(w,A,R,i).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const u=this._badListeners.get(A);this._badListeners.set(A,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,R,w,i){const p=[],o=Date.now(),{document:u,reason:d}=i,{version:F}=u,_=Object.freeze({document:u,reason:d,waitUntil(m){if(Object.isFrozen(p))throw(0,t.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(m))}});try{R.apply(w,[_])}catch(m){return Promise.reject(m)}return Object.freeze(p),new Promise((m,f)=>{const D=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(l=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(D),m(l)}).catch(l=>{clearTimeout(D),f(l)})}).then(m=>{const f={edits:[]};for(const D of m)if(Array.isArray(D)&&D.every(l=>l instanceof y.TextEdit))for(const{newText:l,newEol:M,range:r}of D)f.edits.push({_type:2,resource:u.uri,edit:{range:r&&T.Range.from(r),text:l,eol:M&&T.EndOfLine.from(M)}});if(f.edits.length!==0)return F===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ye[165],_e([0,1,4,29,2,8,7]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class P{constructor(R,w,i,p,o){this._onDidCreate=new s.Emitter,this._onDidChange=new s.Emitter,this._onDidDelete=new s.Emitter,this._config=0,i&&(this._config+=1),p&&(this._config+=2),o&&(this._config+=4);const u=(0,t.parse)(w),d=R(F=>{if(!i)for(let _ of F.created){const m=y.URI.revive(_);u(m.fsPath)&&this._onDidCreate.fire(m)}if(!p)for(let _ of F.changed){const m=y.URI.revive(_);u(m.fsPath)&&this._onDidChange.fire(m)}if(!o)for(let _ of F.deleted){const m=y.URI.revive(_);u(m.fsPath)&&this._onDidDelete.fire(m)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,d)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(R,w,i){this._logService=w,this._extHostDocumentsAndEditors=i,this._onFileSystemEvent=new s.Emitter,this._onDidRenameFile=new s.Emitter,this._onDidCreateFile=new s.Emitter,this._onDidDeleteFile=new s.Emitter,this._onWillRenameFile=new s.AsyncEmitter,this._onWillCreateFile=new s.AsyncEmitter,this._onWillDeleteFile=new s.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(R,w,i,p){return new P(this._onFileSystemEvent.event,R,w,i,p)}$onFileEvent(R){this._onFileSystemEvent.fire(R)}$onDidRunFileOperation(R,w){switch(R){case 2:this._onDidRenameFile.fire(Object.freeze({files:w.map(i=>({oldUri:y.URI.revive(i.source),newUri:y.URI.revive(i.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:w.map(i=>y.URI.revive(i.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:w.map(i=>y.URI.revive(i.target))}));break;default:}}getOnWillRenameFileEvent(R){return this._createWillExecuteEvent(R,this._onWillRenameFile)}getOnWillCreateFileEvent(R){return this._createWillExecuteEvent(R,this._onWillCreateFile)}getOnWillDeleteFileEvent(R){return this._createWillExecuteEvent(R,this._onWillDeleteFile)}_createWillExecuteEvent(R,w){return(i,p,o)=>{const u=function(F){i.call(p,F)};return u.extension=R,w.event(u,void 0,o)}}async $onWillRunFileOperation(R,w,i,p){switch(R){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:w.map(o=>({oldUri:y.URI.revive(o.source),newUri:y.URI.revive(o.target)}))},i,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:w.map(o=>y.URI.revive(o.target))},i,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:w.map(o=>y.URI.revive(o.target))},i,p)}}async _fireWillEvent(R,w,i,p){const o=new Set,u=[];if(await R.fireAsync(w,p,async(F,_)=>{const m=Date.now(),f=await Promise.resolve(F);f instanceof k.WorkspaceEdit&&(u.push(f),o.add(_.extension.displayName??_.extension.identifier.value)),Date.now()-m>i&&this._logService.warn("SLOW file-participant",_.extension.identifier)}),p.isCancellationRequested||u.length===0)return;const d={edits:[]};for(let F of u){let{edits:_}=T.WorkspaceEdit.from(F,this._extHostDocumentsAndEditors);d.edits=d.edits.concat(_)}return{edit:d,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=C}),define(ye[166],_e([0,1,11,26,2,8,87]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(w,i,p,o){this.start=w,this.deletedCount=i,this.deletedItems=p,this.items=o}static asApiEvents(w){return w.map(i=>({start:i.start,deletedCount:i.deletedCount,deletedItems:i.deletedItems,items:i.items.map(p=>p.apiCell)}))}}class C{constructor(w,i,p){this.notebook=w,this._extHostDocument=i,this._cellData=p,this.handle=p.handle,this.uri=y.URI.revive(p.uri),this.cellKind=p.cellKind,this._outputs=p.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=p.internalMetadata??{},this._metadata=Object.freeze(p.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}static asModelAddData(w,i){return{EOL:i.eol,lines:i.source,languageId:i.language,uri:i.uri,isDirty:!1,versionId:1,notebook:w}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const w=this,i=this._extHostDocument.getDocument(this.uri);if(!i)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:i.document,get mime(){return w._mime},set mime(p){w._mime=p},get outputs(){return w._outputs.slice(0)},get metadata(){return w._metadata},get executionSummary(){return w._previousResult}})}return this._apiCell}setOutputs(w){this._outputs=w.map(T.NotebookCellOutput.to)}setOutputItems(w,i,p){const o=p.map(T.NotebookCellOutputItem.to),u=this._outputs.find(d=>d.id===w);u&&(i||(u.items.length=0),u.items.push(...o))}setMetadata(w){this._metadata=Object.freeze(w)}setInternalMetadata(w){this._internalMetadata=w,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=C;class A{constructor(w,i,p,o,u,d){this._proxy=w,this._textDocumentsAndEditors=i,this._textDocuments=p,this._emitter=o,this.uri=u,this.handle=A._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=d.viewType,this._metadata=Object.freeze(d.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,d.cells]],!0),this._versionId=d.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const w=this;this._notebook={get uri(){return w.uri},get version(){return w._versionId},get notebookType(){return w._notebookType},get isDirty(){return w._isDirty},get isUntitled(){return w.uri.scheme===s.Schemas.untitled},get isClosed(){return w._disposed},get metadata(){return w._metadata},get cellCount(){return w._cells.length},cellAt(i){return i=w._validateIndex(i),w._cells[i].apiCell},getCells(i){return(i?w._getCells(i):w._cells).map(o=>o.apiCell)},save(){return w._save()}}}return this._notebook}updateBackup(w){this._backup?.delete(),this._backup=w}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(w){w.metadata&&(this._metadata=Object.freeze({...this._metadata,...w.metadata}))}acceptDirty(w){this._isDirty=w}acceptModelChanged(w,i){this._versionId=w.versionId,this._isDirty=i;for(const p of w.rawEvents)p.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(p.changes,!1):p.kind===k.NotebookCellsChangeType.Move?this._moveCell(p.index,p.newIdx):p.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(p.index,p.outputs):p.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(p.index,p.outputId,p.append,p.outputItems):p.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(p.index,p.language):p.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(p.index,p.mime):p.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(p.index,p.metadata):p.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(p.index,p.internalMetadata)}_validateIndex(w){return w=w|0,w<0?0:w>=this._cells.length?this._cells.length-1:w}_validateRange(w){let i=w.start|0,p=w.end|0;return i<0&&(i=0),p>this._cells.length&&(p=this._cells.length),w.with({start:i,end:p})}_getCells(w){w=this._validateRange(w);const i=[];for(let p=w.start;p<w.end;p++)i.push(this._cells[p]);return i}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(w,i){if(this._disposed)return;const p=[],o=[],u=[];w.reverse().forEach(d=>{const _=d[2].map(D=>{const l=new C(this,this._textDocumentsAndEditors,D);return i||o.push(C.asModelAddData(this.apiNotebook,D)),l}),m=new P(d[0],d[1],[],_),f=this._cells.splice(d[0],d[1],..._);for(const D of f)u.push(D.uri),m.deletedItems.push(D.apiCell);p.push(m)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:u}),i||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:P.asApiEvents(p)}))}_moveCell(w,i){const p=this._cells.splice(w,1);this._cells.splice(i,0,...p);const o=[new P(w,1,p.map(u=>u.apiCell),[]),new P(i,0,[],p)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:P.asApiEvents(o)}))}_setCellOutputs(w,i){const p=this._cells[w];p.setOutputs(i),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_setCellOutputItems(w,i,p,o){const u=this._cells[w];u.setOutputItems(i,p,o),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_changeCellLanguage(w,i){const p=this._cells[w];p.apiCell.document.languageId!==i&&this._textDocuments.$acceptModelLanguageChanged(p.uri,i)}_changeCellMime(w,i){const p=this._cells[w];p.apiCell.mime=i}_changeCellMetadata(w,i){const p=this._cells[w],o=p.apiCell.metadata;p.setMetadata(i);const u=p.apiCell.metadata;(0,t.equals)(o,u)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:p.apiCell}))}_changeCellInternalMetadata(w,i){this._cells[w].setInternalMetadata(i)}getCellFromApiCell(w){return this._cells.find(i=>i.apiCell===w)}getCellFromIndex(w){return this._cells[w]}getCell(w){return this._cells.find(i=>i.handle===w)}getCellIndex(w){return this._cells.indexOf(w)}}e.ExtHostNotebookDocument=A,A._handlePool=0}),define(ye[91],_e([0,1,7,8,15]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:A})}replaceCells(C,A,R){this._throwIfFinalized(),!(C===A&&R.length===0)&&this._collectedEdits.push({editType:1,index:C,count:A-C,cells:R.map(t.NotebookCellData.from)})}}class k{constructor(C,A,R,w,i,p){this.id=C,this._proxy=A,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=i,this._visibleRanges=w,this._viewColumn=p}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(A){if(!Array.isArray(A)||!A.every(s.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");C._selections=A,C._trySetSelections(A)},get visibleRanges(){return C._visibleRanges},revealRange(A,R){C._proxy.$tryRevealRange(C.id,t.NotebookRange.from(A),R??s.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(A){const R=new T(this.document.version);return A(R),C._applyEdit(R.finalize())},setDecorations(A,R){return C.setDecorations(A,R)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(t.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const A=[];let R=-1;for(let w=0;w<C.cellEdits.length;w++){if(R<0){A.push(C.cellEdits[w]),R++;continue}const p=A[R],o=C.cellEdits[w];if(p.editType===1&&o.editType===1&&p.index===o.index){p.cells.push(...C.cellEdits[w].cells),p.count+=C.cellEdits[w].count;continue}A.push(C.cellEdits[w]),R++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,A)}setDecorations(C,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return A.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(A),C.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(ye[167],_e([0,1,8,139,120,20,53,15]),function(Z,e,s,t,y,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(i){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=i}async withProgress(i,p,o){const u=this._handles++,{title:d,location:F,cancellable:_}=p,m={label:(0,y.localize)(0,null,i.displayName||i.name),id:i.identifier.value};return this._proxy.$startProgress(u,{location:s.ProgressLocation.from(F),title:d,source:m,cancellable:_},i).catch(P.onUnexpectedExternalError),this._withProgress(u,o,!!_)}_withProgress(i,p,o){let u;o&&(u=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(i,u));const d=_=>{this._proxy.$progressEnd(_),this._mapHandleToCancellationSource.delete(_),u&&u.dispose()};let F;try{F=p(new R(this._proxy,i),o&&u?u.token:T.CancellationToken.None)}catch(_){throw d(i),_}return F.then(_=>d(i),_=>d(i)),F}$acceptProgressCanceled(i){const p=this._mapHandleToCancellationSource.get(i);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(i))}}e.ExtHostProgress=C;function A(w,i){return w.message=i.message,typeof i.increment=="number"&&(typeof w.increment=="number"?w.increment+=i.increment:w.increment=i.increment),w}class R extends t.Progress{constructor(i,p){super(o=>this.throttledReport(o));this._proxy=i,this._handle=p}throttledReport(i){this._proxy.$progressReport(this._handle,i)}}Be([(0,k.throttle)(100,(w,i)=>A(w,i),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(ye[92],_e([0,1,42,15,54,8,7]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(i,p,o){const u=P._Keys.nextId();i.$registerTextEditorDecorationType(p.identifier,u,T.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:u,dispose(){i.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=P,P._Keys=new y.IdGenerator("TextEditorDecorationType");class C{constructor(i,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=i,this._documentVersionId=i.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(i,p){this._throwIfFinalized();let o=null;if(i instanceof k.Position)o=new k.Range(i,i);else if(i instanceof k.Range)o=i;else throw new Error("Unrecognized location");this._pushEdit(o,p,!1)}insert(i,p){this._throwIfFinalized(),this._pushEdit(new k.Range(i,i),p,!0)}delete(i){this._throwIfFinalized();let p=null;if(i instanceof k.Range)p=i;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(i,p,o){const u=this._document.validateRange(i);this._collectedEdits.push({range:u,text:p,forceMoveMarkers:o})}setEndOfLine(i){if(this._throwIfFinalized(),i!==k.EndOfLine.LF&&i!==k.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=i}}e.TextEditorEdit=C;class A{constructor(i,p,o,u){this._proxy=i,this._id=p,this._accept(o),this._logService=u;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(F){d._setTabSize(F)},get insertSpaces(){return d._insertSpaces},set insertSpaces(F){d._setInsertSpaces(F)},get cursorStyle(){return d._cursorStyle},set cursorStyle(F){d._setCursorStyle(F)},get lineNumbers(){return d._lineNumbers},set lineNumbers(F){d._setLineNumbers(F)}}}_accept(i){this._tabSize=i.tabSize,this._insertSpaces=i.insertSpaces,this._cursorStyle=i.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(i.lineNumbers)}_validateTabSize(i){if(i==="auto")return"auto";if(typeof i=="number"){const p=Math.floor(i);return p>0?p:null}if(typeof i=="string"){const p=parseInt(i,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(i){const p=this._validateTabSize(i);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(i){return i==="auto"?"auto":i==="false"?!1:Boolean(i)}_setInsertSpaces(i){const p=this._validateInsertSpaces(i);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(i){this._cursorStyle!==i&&(this._cursorStyle=i,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:i})))}_setLineNumbers(i){this._lineNumbers!==i&&(this._lineNumbers=i,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(i)})))}assign(i){const p={};let o=!1;if(typeof i.tabSize!="undefined"){const u=this._validateTabSize(i.tabSize);u==="auto"?(o=!0,p.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,o=!0,p.tabSize=u)}if(typeof i.insertSpaces!="undefined"){const u=this._validateInsertSpaces(i.insertSpaces);u==="auto"?(o=!0,p.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,o=!0,p.insertSpaces=u)}typeof i.cursorStyle!="undefined"&&this._cursorStyle!==i.cursorStyle&&(this._cursorStyle=i.cursorStyle,o=!0,p.cursorStyle=i.cursorStyle),typeof i.lineNumbers!="undefined"&&this._lineNumbers!==i.lineNumbers&&(this._lineNumbers=i.lineNumbers,o=!0,p.lineNumbers=T.TextEditorLineNumbersStyle.from(i.lineNumbers)),o&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,p))}_warnOnError(i,p){p.catch(o=>{this._logService.warn(`ExtHostTextEditorOptions '${i}' failed:'`),this._logService.warn(o)})}}e.ExtHostTextEditorOptions=A;class R{constructor(i,p,o,u,d,F,_,m){this.id=i,this._proxy=p,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new A(this._proxy,this.id,F,o),this._visibleRanges=_,this._viewColumn=m;const f=this;this.value=Object.freeze({get document(){return u.getValue()},set document(D){throw(0,t.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(D){if(!(D instanceof k.Selection))throw(0,t.illegalArgument)("selection");f._selections=[D],f._trySetSelection()},get selections(){return f._selections},set selections(D){if(!Array.isArray(D)||D.some(l=>!(l instanceof k.Selection)))throw(0,t.illegalArgument)("selections");f._selections=D,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(D){throw(0,t.readonly)("visibleRanges")},get options(){return f._options.value},set options(D){f._disposed||f._options.assign(D)},get viewColumn(){return f._viewColumn},set viewColumn(D){throw(0,t.readonly)("viewColumn")},edit(D,l={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const M=new C(u.getValue(),l);return D(M),f._applyEdit(M)},insertSnippet(D,l,M={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!l||Array.isArray(l)&&l.length===0)r=f._selections.map(n=>T.Range.from(n));else if(l instanceof k.Position){const{lineNumber:n,column:b}=T.Position.from(l);r=[{startLineNumber:n,startColumn:b,endLineNumber:n,endColumn:b}]}else if(l instanceof k.Range)r=[T.Range.from(l)];else{r=[];for(const n of l)if(n instanceof k.Range)r.push(T.Range.from(n));else{const{lineNumber:b,column:g}=T.Position.from(n);r.push({startLineNumber:b,startColumn:g,endLineNumber:b,endColumn:g})}}return p.$tryInsertSnippet(i,D.value,r,M)},setDecorations(D,l){const M=l.length===0;M&&!f._hasDecorationsForKey.has(D.key)||(M?f._hasDecorationsForKey.delete(D.key):f._hasDecorationsForKey.add(D.key),f._runOnProxy(()=>{if(T.isDecorationOptionsArr(l))return p.$trySetDecorations(i,D.key,T.fromRangeOrRangeWithMessage(l));{const r=new Array(4*l.length);for(let n=0,b=l.length;n<b;n++){const g=l[n];r[4*n]=g.start.line+1,r[4*n+1]=g.start.character+1,r[4*n+2]=g.end.line+1,r[4*n+3]=g.end.character+1}return p.$trySetDecorationsFast(i,D.key,r)}}))},revealRange(D,l){f._runOnProxy(()=>p.$tryRevealRange(i,T.Range.from(D),l||k.TextEditorRevealType.Default))},show(D){p.$tryShowEditor(i,T.ViewColumn.from(D))},hide(){p.$tryHideEditor(i)}})}dispose(){(0,s.ok)(!this._disposed),this._disposed=!0}_acceptOptions(i){(0,s.ok)(!this._disposed),this._options._accept(i)}_acceptVisibleRanges(i){(0,s.ok)(!this._disposed),this._visibleRanges=i}_acceptViewColumn(i){(0,s.ok)(!this._disposed),this._viewColumn=i}_acceptSelections(i){(0,s.ok)(!this._disposed),this._selections=i}async _trySetSelection(){const i=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,i)),this.value}_applyEdit(i){const p=i.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const o=p.edits.map(d=>d.range);o.sort((d,F)=>d.end.line===F.end.line?d.end.character===F.end.character?d.start.line===F.start.line?d.start.character-F.start.character:d.start.line-F.start.line:d.end.character-F.end.character:d.end.line-F.end.line);for(let d=0,F=o.length-1;d<F;d++){const _=o[d].end;if(o[d+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=p.edits.map(d=>({range:T.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,u,{setEndOfLine:typeof p.setEndOfLine=="number"?T.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(i){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):i().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=R}),define(ye[168],_e([0,1,14,4,6,10,48,8,88,67]),function(Z,e,s,t,y,T,k,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends y.Disposable{constructor(i){super();this.controllerId=i,this.debounceSendDiff=this._register(new s.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new k.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const p of this.tree.values())this.updateExpandability(p)}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){const p=this.diff[this.diff.length-1];if(p&&i[0]===1){if(p[0]===1&&p[1].extId===i[1].extId){(0,C.applyTestItemUpdate)(p[1],i[1]);return}if(p[0]===0&&p[1].item.extId===i[1].extId){(0,C.applyTestItemUpdate)(p[1],i[1]);return}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,p){const o=this.tree.get(i);if(!!o){if((o.expandLevels===void 0||p>o.expandLevels)&&(o.expandLevels=p),o.expand===1){const u=this.resolveChildren(o);return u.isOpen()?this.expandChildren(o,p-1):u.wait().then(()=>this.expandChildren(o,p-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,p-1)):this.expandChildren(o,p-1)}}dispose(){for(const i of this.tree.values())(0,k.getPrivateApiFor)(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,p){switch(p.op){case 2:this.pushDiff([4,i.fullId.toString()]);break;case 1:this.removeItem(A.TestId.joinToString(i.fullId,p.id));break;case 0:this.upsertItem(p.item,i);break;case 4:for(const o of p.ops)this.onTestItemEvent(i,o);break;case 3:{const{key:o,value:u,previous:d}=p,F=i.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(i);break;case"tags":this.diffTagRefs(u,d,F);break;case"range":this.pushDiff([1,{extId:F,item:{range:P.Range.from(u)}}]);break;case"error":this.pushDiff([1,{extId:F,item:{error:P.MarkdownString.fromStrict(u)||null}}]);break;default:this.pushDiff([1,{extId:F,item:{[o]:u??null}}]);break}break}default:(0,T.assertNever)(p)}}upsertItem(i,p){if(!(i instanceof k.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${i.id} did not`);const o=A.TestId.fromExtHostTestItem(i,this.root.id,p?.actual),u=(0,k.getPrivateApiFor)(i);u.parent&&u.parent!==p?.actual&&u.parent.children.delete(i.id);let d=this.tree.get(o.toString());if(!d){d={fullId:o,actual:i,parent:p?o.parentId:null,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(d.fullId.toString(),d),this.setItemParent(i,p),this.pushDiff([0,{parent:d.parent&&d.parent.toString(),controllerId:this.controllerId,expand:d.expand,item:P.TestItem.from(i)}]),this.connectItemAndChildren(i,d,p);return}if(d.actual===i){this.connectItem(i,d,p);return}const F=d.actual.children,_=d.actual,m=(0,k.diffTestItems)(_,i);(0,k.getPrivateApiFor)(_).listener=void 0,d.actual=i,d.expand=0;for(const[f,D]of m)this.onTestItemEvent(d,{op:3,key:f,value:D,previous:_[f]});this.connectItemAndChildren(i,d,p);for(const f of F)i.children.get(f.id)||this.removeItem(A.TestId.joinToString(o,f.id))}diffTagRefs(i,p,o){const u=new Set(p.map(d=>d.id));for(const d of i)u.delete(d.id)||this.incrementTagRefs(d);this.pushDiff([1,{extId:o,item:{tags:i.map(d=>P.TestTag.namespace(this.controllerId,d.id))}}]),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const p=this.tags.get(i.id);p?p.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff([5,{id:P.TestTag.namespace(this.controllerId,i.id),ctrlLabel:this.root.label}]))}decrementTagRefs(i){const p=this.tags.get(i);p&&!--p.refCount&&(this.tags.delete(i),this.pushDiff([6,P.TestTag.namespace(this.controllerId,i)]))}setItemParent(i,p){(0,k.getPrivateApiFor)(i).parent=p&&p.actual!==this.root?p.actual:void 0}connectItem(i,p,o){this.setItemParent(i,o);const u=(0,k.getPrivateApiFor)(i);u.parent=o?.actual,u.listener=d=>this.onTestItemEvent(p,d),this.updateExpandability(p)}connectItemAndChildren(i,p,o){this.connectItem(i,p,o);for(const u of i.children)this.upsertItem(u,p)}updateExpandability(i){let p;this._resolveHandler?i.resolveBarrier?p=i.resolveBarrier.isOpen()?3:2:p=i.actual.canResolveChildren?1:0:p=0,p!==i.expand&&(i.expand=p,this.pushDiff([1,{extId:i.fullId.toString(),expand:p}]),p===1&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,p){if(p<0)return;const o=[];for(const u of i.actual.children){const d=this.expand(A.TestId.joinToString(i.fullId,u.id),p);(0,s.isThenable)(d)&&o.push(d)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const d=new s.Barrier;return d.open(),d}i.expand=2,this.pushExpandStateUpdate(i);const p=i.resolveBarrier=new s.Barrier,o=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),i.actual!==this.root&&(i.actual.error=d.stack||d.message||String(d))};let u;try{u=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(d){o(d)}return(0,s.isThenable)(u)?u.catch(o).then(()=>{p.open(),this.updateExpandability(i)}):(p.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff([1,{extId:i.fullId.toString(),expand:i.expand}])}removeItem(i){const p=this.tree.get(i);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff([2,i]);const o=[p];for(;o.length;){const u=o.pop();if(!!u){(0,k.getPrivateApiFor)(u.actual).listener=void 0;for(const d of u.actual.tags)this.decrementTagRefs(d.id);this.tree.delete(u.fullId.toString());for(const d of u.actual.children)o.push(this.tree.get(A.TestId.joinToString(u.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.SingleUseTestCollection=R}),define(ye[169],_e([0,1,3,135]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,s.refineServiceDecorator)(t.IEnvironmentService)}),define(ye[170],_e([0,1,25,4,17]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=T;class k{constructor(R){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(s.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(s.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let w of R.activationEvents)w==="onUri"&&(w=`onUri:${s.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(w)||this._activationMap.set(w,[]),this._activationMap.get(w).push(R)}}keepOnly(R){const w=new Set;R.forEach(i=>w.add(s.ExtensionIdentifier.toKey(i))),this._extensionDescriptions=this._extensionDescriptions.filter(i=>w.has(s.ExtensionIdentifier.toKey(i.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,w){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const i=k._findLoopingExtensions(this._extensionDescriptions);if(w=w.concat(i.map(p=>p.identifier)),w.length>0){const p=new Set;w.forEach(o=>p.add(s.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!p.has(s.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(i)}static _findLoopingExtensions(R){const w=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,F){this.addNode(d),this.addNode(F),this._arcs.has(d)?this._arcs.get(d).push(F):this._arcs.set(d,[F])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,F){const _=w.getArcs(d);for(let m=0;m<_.length;m++)if(!F.has(_[m]))return!1;return!0}getNodes(){return this._nodesArr}};let i=new Map;for(let d of R){const F=s.ExtensionIdentifier.toKey(d.identifier);if(i.set(F,d),d.extensionDependencies)for(let _ of d.extensionDependencies){const m=s.ExtensionIdentifier.toKey(_);w.addArc(F,m)}}let p=new Set;w.getNodes().filter(d=>w.getArcs(d).length===0).forEach(d=>p.add(d));let o=w.getNodes().filter(d=>!p.has(d)),u;do{u=!1;for(let d=0;d<o.length;d++){const F=o[d];w.hasOnlyGoodArcs(F,p)&&(o.splice(d,1),d--,p.add(F),u=!0)}}while(u);return o.map(d=>i.get(d))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(s.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const w=this._activationMap.get(R);return w?w.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const w=this._extensionsMap.get(s.ExtensionIdentifier.toKey(R));return w||void 0}}e.ExtensionDescriptionRegistry=k;var P;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(P||(P={}));function C(A,R){const w=A.isBuiltin?0:A.isUnderDevelopment?2:1,i=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(w!==i)return w-i;const p=y.posix.basename(A.extensionLocation.path),o=y.posix.basename(R.extensionLocation.path);return p<o?-1:p>o?1:0}}),define(ye[171],_e([0,1,22]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var y;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(y=e.MessageType||(e.MessageType={}));function T(P){const C=s.VSBuffer.alloc(1);switch(P){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=T;function k(P,C){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=k}),define(ye[27],_e([0,1,4,2,3,25,142]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");var P;(function(f){f[f.None=0]="None",f[f.LocalProcess=1]="LocalProcess",f[f.LocalWebWorker=2]="LocalWebWorker",f[f.Remote=3]="Remote"})(P=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(f){switch(f){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class A{constructor(D){this.dependency=D}}e.MissingExtensionDependency=A;var R;(function(f){f[f.LocalProcess=0]="LocalProcess",f[f.LocalWebWorker=1]="LocalWebWorker",f[f.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function w(f){switch(f){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=w;function i(f,D){return f.enabledApiProposals?f.enabledApiProposals.includes(D):!1}e.isProposedApiEnabled=i;function p(f,D){if(!i(f,D))throw new Error(`Extension '${f.identifier.value}' CANNOT use API proposal: ${D}.
Its package.json#enabledApiProposals-property declares: ${f.enabledApiProposals?.join(", ")??"[]"} but NOT ${D}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.checkProposedApiEnabled=p;class o{constructor(D,l,M,r){this.codeLoadingTime=D,this.activateCallTime=l,this.activateResolvedTime=M,this.activationReason=r}}e.ActivationTimes=o;class u{constructor(D,l){this.description=D,this.value=l}}e.ExtensionPointContribution=u,e.ExtensionHostLogFileName="exthost";var d;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(d=e.ActivationKind||(e.ActivationKind={}));function F(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation}}e.toExtension=F;function _(f,D){return{identifier:new T.ExtensionIdentifier(f.identifier.id),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!!D,extensionLocation:f.location,...f.manifest,uuid:f.identifier.uuid}}e.toExtensionDescription=_;class m{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None}activateByEvent(D){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(D){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(D){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(D){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(D,l){return Promise.resolve()}_onWillActivateExtension(D){}_onDidActivateExtension(D,l,M,r,n){}_onDidActivateExtensionError(D,l){}_onExtensionRuntimeError(D,l){}_onExtensionHostExit(D){}}e.NullExtensionService=m}),define(ye[172],_e([0,1,15,25,27,12]),function(Z,e,s,t,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const k=Promise.resolve(void 0);class P{constructor(u,d,F,_){this.startup=u,this.codeLoadingTime=d,this.activateCallTime=F,this.activateResolvedTime=_}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class C{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,d){return u===-1||d===-1?-1:d-u}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class A{constructor(u,d,F,_,m,f){this.activationFailed=u,this.activationFailedError=d,this.activationTimes=F,this.module=_,this.exports=m,this.subscriptions=f}}e.ActivatedExtension=A;class R extends A{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class w extends A{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=w;class i extends A{constructor(u){super(!0,u,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=i;let p=class{constructor(u,d,F,_,m){this._logService=m,this._isDisposed=!1,this._registry=u,this._resolvedExtensionsSet=new Set,d.forEach(f=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(f))),this._hostExtensionsMap=new Map,F.forEach(f=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(f),f)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(u){const d=t.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(d)}getActivatedExtension(u){const d=t.ExtensionIdentifier.toKey(u),F=this._activatedExtensions.get(d);if(!F)throw new Error("Extension `"+u.value+"` is not known or not activated");return F}activateByEvent(u,d){if(this._alreadyActivatedEvents[u])return k;const F=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(F.map(_=>({id:_.identifier,reason:{startup:d,extensionId:_.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,d){const F=this._registry.getExtensionDescription(u);if(!F)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:F.identifier,reason:d}])}_handleActivateRequest(u,d,F){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(u.id))){d[t.ExtensionIdentifier.toKey(u.id)]=u;return}const _=this._registry.getExtensionDescription(u.id);if(!_){const D=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,D,new y.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(u.id),new i(D));return}const m=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let f=!0;for(let D=0,l=m.length;D<l;D++){const M=m[D];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(M)))continue;const r=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(M));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const c=_.displayName||_.identifier.value,h=this._registry.getExtensionDescription(M),v=h&&h.displayName||M,a=new Error(`Cannot activate the '${c}' extension because its dependency '${v}' failed to activate`);a.detail=r.activationFailedError,this._host.onExtensionActivationError(_.identifier,a,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(_.identifier),new i(a));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(M))){f=!1,d[t.ExtensionIdentifier.toKey(M)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(M)),reason:u.reason};continue}const n=this._registry.getExtensionDescription(M);if(n){if(!n.main&&!n.browser)continue;f=!1,d[t.ExtensionIdentifier.toKey(M)]={id:n.identifier,reason:u.reason};continue}const b=_.displayName||_.identifier.value,g=new Error(`Cannot activate the '${b}' extension because it depends on unknown extension '${M}'`);this._host.onExtensionActivationError(_.identifier,g,new y.MissingExtensionDependency(M)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(_.identifier),new i(g));return}f?d[t.ExtensionIdentifier.toKey(_.identifier)]=u:F.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(m=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(m.id))),u.length===0))return Promise.resolve(void 0);const d=Object.create(null),F=[];for(let m=0,f=u.length;m<f;m++)this._handleActivateRequest(u[m],d,F);for(let m=0,f=F.length;m<f;m++){const D=t.ExtensionIdentifier.toKey(F[m].id);d[D]&&delete d[D]}const _=Object.keys(d).map(m=>d[m]);return F.length===0?Promise.all(_.map(m=>this._activateExtension(m.id,m.reason))).then(m=>{}):this._activateExtensions(_).then(m=>this._activateExtensions(F))}_activateExtension(u,d){const F=t.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(F))return Promise.resolve(void 0);const _=this._activatingExtensions.get(F);if(_)return _;const m=this._host.actualActivateExtension(u,d).then(void 0,f=>{const D=new Error;return f&&f.name&&(D.name=f.name),f&&f.message?D.message=`Activating extension '${u.value}' failed: ${f.message}.`:D.message=`Activating extension '${u.value}' failed: ${f}.`,f&&f.stack&&(D.stack=f.stack),this._isDisposed&&s.isPromiseCanceledError(f)?new i(f):(this._host.onExtensionActivationError(u,D,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(f),new i(f))}).then(f=>{this._activatedExtensions.set(F,f),this._activatingExtensions.delete(F)});return this._activatingExtensions.set(F,m),m}};p=Be([He(4,T.ILogService)],p),e.ExtensionsActivator=p}),define(ye[173],_e([0,1,12,28,27]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends s.LogService{constructor(P,C){super(P.createLogger(C.logFile,{name:y.ExtensionHostLogFileName}))}};T=Be([He(0,s.ILoggerService),He(1,t.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(ye[174],_e([0,1,15]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,k)=>{this._actualOk=T,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,s.onUnexpectedError)(T))}then(T,k){return this._ensureActual().then(T,k)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=t}),define(ye[38],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class s{constructor(A,R){this._proxyIdentifierBrand=void 0,this.isMain=A,this.sid=R,this.nid=++s.count}}e.ProxyIdentifier=s,s.count=0;const t=[];function y(C){const A=new s(!0,C);return t[A.nid]=A,A}e.createMainContextProxyIdentifier=y;function T(C){const A=new s(!1,C);return t[A.nid]=A,A}e.createExtHostContextProxyIdentifier=T;function k(C){return t[C].sid}e.getStringIdentifierForProxy=k;class P{constructor(A){this.value=A}}e.SerializableObjectWithBuffers=P}),define(ye[5],_e([0,1,55,2,38]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var k;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var w;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(w=e.CandidatePortSource||(e.CandidatePortSource={}));var i;(function(m){m.name="$ident";function f(l,M){return Object.defineProperty(l,m.name,{value:M,enumerable:!0}),l}m.mixin=f;function D(l){return l[m.name]}m.of=D})(i=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(f){return f._id=p._n++,f}}e.IdObject=p,p._n=0;var o;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.command="m",m.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(m){m[m.File=1]="File",m[m.Text=2]="Text",m[m.Cell=3]="Cell"})(d=e.WorkspaceEditType||(e.WorkspaceEditType={}));function F(m){if(m&&m.edits)for(const f of m.edits)typeof f.resource=="object"?f.resource=t.URI.revive(f.resource):(f.newUri=t.URI.revive(f.newUri),f.oldUri=t.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,s.revive)(f.metadata));return m}e.reviveWorkspaceEditDto=F;var _;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ye[68],_e([0,1,5,4,3]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(P){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(s.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,C){return this._proxy.$getPassword(P,C)}store(P,C,A){return this._proxy.$setPassword(P,C,A)}delete(P,C){return this._proxy.$deletePassword(P,C)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(ye[69],_e([0,1,3,12,5,13]),function(Z,e,s,t,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,s.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(C,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(y.MainContext.MainThreadTelemetry)}report(C,A,R){const w=this.getUsageKey(C,A);this._reportedUsages.has(w)||(this._reportedUsages.add(w),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:C}))}getUsageKey(C,A){return`${C}-${A.identifier.value}`}};k=Be([He(0,T.IExtHostRpcService),He(1,t.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(P,C,A){}})}),define(ye[175],_e([0,1,4,5,7,25]),function(Z,e,s,t,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new s.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,A,R,w={}){const i=T.ExtensionIdentifier.toKey(C.identifier),p=this._inFlightRequests.get(i)||[],o=[...R].sort().join(" ");let u=p.find(d=>d.scopes===o);if(u)return u.result;{const d=this._getSession(C,i,A,R,w);u={scopes:o,result:d},p.push(u),this._inFlightRequests.set(i,p);try{await d}finally{const F=p.findIndex(_=>_.scopes===o);F>-1&&(p.splice(F),this._inFlightRequests.set(i,p))}return d}}async _getSession(C,A,R,w,i={}){await this._proxy.$ensureProvider(R);const p=C.displayName||C.name;return this._proxy.$getSession(R,w,A,p,i)}async removeSession(C,A){const R=this._authenticationProviders.get(C);return R?R.provider.removeSession(A):this._proxy.$removeSession(C,A)}registerAuthenticationProvider(C,A,R,w){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:A,provider:R,options:w??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===C)||this._providers.push({id:C,label:A});const i=R.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(C,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,A,w?.supportsMultipleAccounts??!1),new y.Disposable(()=>{i.dispose(),this._authenticationProviders.delete(C);const p=this._providers.findIndex(o=>o.id===C);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,A){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,A){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,A){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,A){return this._onDidChangeSessions.fire({provider:{id:C,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(ye[176],_e([0,1,5,13,8]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(P,C){this._extHostDocumentsAndEditors=C,this._proxy=P.getProxy(s.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const C=y.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};T=Be([He(0,t.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(ye[177],_e([0,1,5]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(T){const k=T.getProxy(s.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(P){return k.$writeText(P)}})}}e.ExtHostClipboard=t});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!y:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(Z,s):y?y.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[39],_e([0,1,10,7,8,26,5,16,12,55,59,227,2,6,3,13,48,22,38,43]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let D=class{constructor(g,c){f.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Ze(this,f,g.getProxy(k.MainContext.MainThreadCommands),"f"),this._logService=c,this.converter=new l(this,h=>{const v=this._apiCommands.get(h);return v?.result===r.Void?v:void 0},c),this._argumentProcessors=[{processArgument(h){return(0,A.revive)(h)}},{processArgument(h){return(0,T.cloneAndChange)(h,function(v){if(R.Range.isIRange(v))return y.Range.to(v);if(w.Position.isIPosition(v))return y.Position.to(v);if(R.Range.isIRange(v.range)&&i.URI.isUri(v.uri))return y.location.to(v);if(v instanceof F.VSBuffer)return v.buffer.buffer;if(!Array.isArray(v))return v})}}]}registerArgumentProcessor(g){this._argumentProcessors.push(g)}registerApiCommand(g){const c=this.registerCommand(!1,g.id,async(...h)=>{const v=g.args.map((S,I)=>{if(!S.validate(h[I]))throw new Error(`Invalid argument '${S.name}' when running '${g.id}', received: ${h[I]}`);return S.convert(h[I])}),a=await this.executeCommand(g.internalId,...v);return g.result.convert(a,h,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this._apiCommands.set(g.id,g),new t.Disposable(()=>{c.dispose(),this._apiCommands.delete(g.id)})}registerCommand(g,c,h,v,a,S){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:h,thisArg:v,description:a,extension:S}),g&&Ie(this,f,"f").$registerCommand(c),new t.Disposable(()=>{this._commands.delete(c)&&g&&Ie(this,f,"f").$unregisterCommand(c)})}executeCommand(g,...c){return this._logService.trace("ExtHostCommands#executeCommand",g),this._doExecuteCommand(g,c,!0)}async _doExecuteCommand(g,c,h){if(this._commands.has(g))return this._executeContributedCommand(g,c,!1);{let v=!1;const a=(0,T.cloneAndChange)(c,function(S){if(S instanceof t.Position)return y.Position.from(S);if(S instanceof t.Range)return y.Range.from(S);if(S instanceof t.Location)return y.location.from(S);if(t.NotebookRange.isNotebookRange(S))return y.NotebookRange.from(S);if(S instanceof ArrayBuffer)return v=!0,F.VSBuffer.wrap(new Uint8Array(S));if(S instanceof Uint8Array)return v=!0,F.VSBuffer.wrap(S);if(!Array.isArray(S))return S});try{const S=await Ie(this,f,"f").$executeCommand(g,v?new _.SerializableObjectWithBuffers(a):a,h);return(0,A.revive)(S)}catch(S){if(S instanceof Error&&S.message==="$executeCommand:retry")return this._doExecuteCommand(g,c,!1);throw S}}}async _executeContributedCommand(g,c,h){const v=this._commands.get(g);if(!v)throw new Error("Unknown command");let{callback:a,thisArg:S,description:I}=v;if(I)for(let N=0;N<I.args.length;N++)try{(0,s.validateConstraint)(c[N],I.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${I.args[N].name}' - ${I.args[N].description}`)}try{return await a.apply(S,c)}catch(N){if(g===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...c);B&&(g=B.command)}throw this._logService.error(N,g,v.extension?.identifier),h?new class extends Error{constructor(){super((0,m.toErrorMessage)(N));this.id=g,this.source=v.extension?.displayName??v.extension?.name}}:N}}$executeContributedCommand(g,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",g),this._commands.has(g)?(c=c.map(h=>this._argumentProcessors.reduce((v,a)=>a.processArgument(v),h)),this._executeContributedCommand(g,c,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this._logService.trace("ExtHostCommands#getCommands",g),Ie(this,f,"f").$getCommands().then(c=>(g&&(c=c.filter(h=>h[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(let[c,h]of this._commands){let{description:v}=h;v&&(g[c]=v)}return Promise.resolve(g)}};f=new WeakMap,D=Be([He(0,u.IExtHostRpcService),He(1,C.ILogService)],D),e.ExtHostCommands=D,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class l{constructor(g,c,h){this._commands=g,this._lookupApiCommand=c,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(g,c){if(!g)return;const h={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return h;const v=this._lookupApiCommand(g.command);if(v)h.id=v.internalId,h.arguments=v.args.map((a,S)=>a.convert(g.arguments&&g.arguments[S]));else if((0,P.isNonEmptyArray)(g.arguments)){const a=++this._cachIdPool;this._cache.set(a,g),c.add((0,p.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),h.$ident=a,h.id=this.delegatingCommandId,h.arguments=[a],this._logService.trace("CommandsConverter#CREATE",g.command,a)}return h}fromInternal(g){const c=k.ObjectIdentifier.of(g);return typeof c=="number"?this._cache.get(c):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this._cache.get(g[0])}_executeConvertedCommand(...g){const c=this.getActualCommand(...g);return this._logService.trace("CommandsConverter#EXECUTE",g[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=l;class M{constructor(g,c,h,v){this.name=g,this.description=c,this.validate=h,this.convert=v}optional(){return new M(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,c){return new M(g??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=M,M.Uri=new M("uri","Uri of a text document",b=>i.URI.isUri(b),b=>b),M.Position=new M("position","A position in a text document",b=>t.Position.isPosition(b),y.Position.from),M.Range=new M("range","A range in a text document",b=>t.Range.isRange(b),y.Range.from),M.Selection=new M("selection","A selection in a text document",b=>t.Selection.isSelection(b),y.Selection.from),M.Number=new M("number","",b=>typeof b=="number",b=>b),M.String=new M("string","",b=>typeof b=="string",b=>b),M.CallHierarchyItem=new M("item","A call hierarchy item",b=>b instanceof t.CallHierarchyItem,y.CallHierarchyItem.from),M.TypeHierarchyItem=new M("item","A type hierarchy item",b=>b instanceof t.TypeHierarchyItem,y.TypeHierarchyItem.from),M.TestItem=new M("testItem","A VS Code TestItem",b=>b instanceof d.TestItemImpl,y.TestItem.from);class r{constructor(g,c){this.description=g,this.convert=c}}e.ApiCommandResult=r,r.Void=new r("no result",b=>b);class n{constructor(g,c,h,v,a){this.id=g,this.internalId=c,this.description=h,this.args=v,this.result=a}}e.ApiCommand=n}),define(ye[178],_e([0,1,8,7,58,39,16,79]),function(Z,e,s,t,y,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(s.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,p)=>{if((0,k.isFalsyOrEmpty)(i))return;class o extends t.SymbolInformation{static to(d){const F=new o(d.name,s.SymbolKind.to(d.kind),d.containerName||"",new t.Location(p[0],s.Range.to(d.range)));return F.detail=d.detail,F.range=F.location.range,F.selectionRange=s.Range.to(d.selectionRange),F.children=d.children?d.children.map(o.to):[],F}}return i.map(o.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(s.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(s.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new T.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(s.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(s.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(s.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(p=>t.Position.isPosition(p)),i=>i.map(s.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(p=>{let o;for(const u of p.reverse())o=new t.SelectionRange(s.Range.to(u),o);return o}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(s.WorkspaceSymbol.to))),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(s.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(s.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(s.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(!!i)return{range:s.Range.to(i.range),placeholder:i.text}})),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return s.WorkspaceEdit.to(i)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(s.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new t.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const p=(0,P.decodeSemanticTokensDto)(i);if(p.type==="full")return new t.SemanticTokens(p.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range.optional()],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new t.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const p=(0,P.decodeSemanticTokensDto)(i);if(p.type==="full")return new t.SemanticTokens(p.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,p,o)=>{if(!i)return new t.CompletionList([]);const u=i.suggestions.map(d=>s.CompletionItem.to(d,o));return new t.CompletionList(u,i.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return s.SignatureHelp.to(i)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,p,o)=>R(u=>new t.CodeLens(s.Range.to(u.range),u.command&&o.fromInternal(u.command)))(i))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>t.Range.isRange(i),i=>t.Selection.isSelection(i)?s.Selection.from(i):s.Range.from(i)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,p,o)=>R(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(u.command)}else{const d=new t.CodeAction(u.title,u.kind?new t.CodeActionKind(u.kind):void 0);return u.edit&&(d.edit=s.WorkspaceEdit.to(u.edit)),u.command&&(d.command=o.fromInternal(u.command)),d.isPreferred=u.isPreferred,d}})(i))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(p=>new t.ColorInformation(s.Range.to(p.range),s.Color.to(p.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",i=>i instanceof t.Color,s.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:s.Range.from(i.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(s.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",i=>i.map(s.InlayHint.to))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(p=>s.NotebookExclusiveDocumentPattern.to(p))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(s.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[s.ViewColumn.from(i),void 0]:[s.ViewColumn.from(i.viewColumn),s.TextEditorOpenOptions.from(i)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[s.ViewColumn.from(i),void 0]:[s.ViewColumn.from(i.viewColumn),s.TextEditorOpenOptions.from(i)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[s.ViewColumn.from(i.viewColumn),s.TextEditorOpenOptions.from(i)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(s.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(s.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(s.TypeHierarchyItem.to))),new T.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[T.ApiCommandArgument.TestItem],T.ApiCommandResult.Void)];class A{static register(p){C.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=A;function R(i){return p=>{if(Array.isArray(p))return p.map(i)}}function w(i){if(!Array.isArray(i))return;const p=[];for(const o of i)y.isLocationLink(o)?p.push(s.DefinitionLink.to(o)):p.push(s.location.to(o));return p}}),define(ye[179],_e([0,1,14,53,4,6,2,58,25,8,7,5]),function(Z,e,s,t,y,T,k,P,C,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function i(p,o,u){const d=p.getProxy(w.MainContext.MainThreadComments);class F{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const b=this._commentControllers.get(n.handle);return b||n}else if(n&&n.$mid===7){const b=this._commentControllers.get(n.commentControlHandle);if(!b)return n;const g=b.getCommentThread(n.commentThreadHandle);return g||n}else if(n&&n.$mid===8){const b=this._commentControllers.get(n.thread.commentControlHandle);if(!b)return n;const g=b.getCommentThread(n.thread.commentThreadHandle);return g?{thread:g,text:n.text}:n}else if(n&&n.$mid===9){const b=this._commentControllers.get(n.thread.commentControlHandle);if(!b)return n;const g=b.getCommentThread(n.thread.commentThreadHandle);if(!g)return n;let c=n.commentUniqueId,h=g.getCommentByUniqueId(c);return h||n}else if(n&&n.$mid===10){const b=this._commentControllers.get(n.thread.commentControlHandle);if(!b)return n;const g=b.getCommentThread(n.thread.commentThreadHandle);if(!g)return n;let c=n.text,h=n.commentUniqueId,v=g.getCommentByUniqueId(h);return v?(v.body=c,v):n}return n}})}createCommentController(n,b,g){const c=F.handlePool++,h=new m(n,c,b,g);this._commentControllers.set(h.handle,h);const v=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(n.identifier))||[];return v.push(h),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(n.identifier),v),h.value}$createCommentThreadTemplate(n,b,g){const c=this._commentControllers.get(n);!c||c.$createCommentThreadTemplate(b,g)}async $updateCommentThreadTemplate(n,b,g){const c=this._commentControllers.get(n);!c||c.$updateCommentThreadTemplate(b,g)}$deleteCommentThread(n,b){const g=this._commentControllers.get(n);g&&g.$deleteCommentThread(b)}$provideCommentingRanges(n,b,g){const c=this._commentControllers.get(n);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const h=u.getDocument(k.URI.revive(b));return(0,s.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(h,g)).then(v=>v?v.map(a=>A.Range.from(a)):void 0)}$toggleReaction(n,b,g,c,h){const v=this._commentControllers.get(n);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,s.asPromise)(()=>{const a=v.getCommentThread(b);if(a){const S=a.getCommentByUniqueId(c.uniqueIdInThread);if(v!==void 0&&S&&v.reactionHandler)return v.reactionHandler(S,l(h))}return Promise.resolve(void 0)})}dispose(){}}F.handlePool=0;class _{constructor(n,b,g,c,h,v,a){this._commentControllerHandle=b,this._id=g,this._uri=c,this._range=h,this._comments=v,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),d.$createCommentThread(b,this.handle,this._id,this._uri,A.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(b,this.handle)}});const S=this;this.value={get uri(){return S.uri},get range(){return S.range},set range(I){S.range=I},get comments(){return S.comments},set comments(I){S.comments=I},get collapsibleState(){return S.collapsibleState},set collapsibleState(I){S.collapsibleState=I},get canReply(){return S.canReply},set canReply(I){S.canReply=I},get contextValue(){return S.contextValue},set contextValue(I){S.contextValue=I},get label(){return S.label},set label(I){S.label=I},dispose:()=>{S.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const n=g=>Object.prototype.hasOwnProperty.call(this.modifications,g),b={};n("range")&&(b.range=A.Range.from(this._range)),n("label")&&(b.label=this.label),n("contextValue")&&(b.contextValue=this.contextValue??null),n("comments")&&(b.comments=this._comments.map(g=>f(this,g,this._commentsMap))),n("collapsibleState")&&(b.collapseState=M(this._collapseState)),n("canReply")&&(b.canReply=this.canReply),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,b)}getCommentByUniqueId(n){for(let b of this._commentsMap){let g=b[0],c=b[1];if(n===c)return g}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}_._handlePool=0,Be([(0,t.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class m{constructor(n,b,g,c){this._extension=n,this._handle=b,this._id=g,this._label=c,this._threads=new Map,d.$registerCommentController(this.handle,g,c);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(v){h.options=v},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(v){h.commentingRangeProvider=v},get reactionHandler(){return h.reactionHandler},set reactionHandler(v){h.reactionHandler=v},createCommentThread(v,a,S){return h.createCommentThread(v,a,S).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,b,g,c){if(typeof n=="string"){const h=new _(this.id,this.handle,n,b,g,c,this._extension.identifier);return this._threads.set(h.handle,h),h}else{const h=new _(this.id,this.handle,void 0,n,b,g,this._extension.identifier);return this._threads.set(h.handle,h),h}}$createCommentThreadTemplate(n,b){const g=new _(this.id,this.handle,void 0,k.URI.revive(n),A.Range.to(b),[],this._extension.identifier);return g.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(g.handle,g),g}$updateCommentThreadTemplate(n,b){let g=this._threads.get(n);g&&(g.range=A.Range.to(b))}$deleteCommentThread(n){let b=this._threads.get(n);b&&b.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function f(r,n,b){let g=b.get(n);g||(g=++r.commentHandle,b.set(n,g));const c=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:g,body:A.MarkdownString.from(n.body),userName:n.author.name,userIconPath:c,label:n.label,commentReactions:n.reactions?n.reactions.map(h=>D(h)):void 0}}function D(r){return{label:r.label,iconPath:r.iconPath?A.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function l(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?k.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function M(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}return new F}e.createExtHostComments=i}),define(ye[93],_e([0,1,2,5,7,3,13,12,16,9,17]),function(Z,e,s,t,y,T,k,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=class wi{constructor(p,o){this._logService=o,this._provider=new Map,this._proxy=p.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,o){const u=wi._handlePool++;this._provider.set(u,{provider:p,extensionId:o}),this._proxy.$registerDecorationProvider(u,o.value);const d=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(F=>{if(!F){this._proxy.$onDidChange(u,null);return}let _=(0,C.asArray)(F);if(_.length<=wi._maxEventSize){this._proxy.$onDidChange(u,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,_.length);const m=_.map(l=>({uri:l,rank:(0,A.count)(l.path,"/")})),f=(0,C.groupBy)(m,(l,M)=>l.rank-M.rank||(0,A.compare)(l.uri.path,M.uri.path));let D=[];e:for(let l of f){let M;for(let r of l){let n=(0,R.dirname)(r.uri.path);if(M!==n&&(M=n,D.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(u,D)});return new y.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(p,o,u){if(!this._provider.has(p))return Object.create(null);const d=Object.create(null),{provider:F,extensionId:_}=this._provider.get(p);return await Promise.all(o.map(async m=>{try{const{uri:f,id:D}=m,l=await Promise.resolve(F.provideFileDecoration(s.URI.revive(f),u));if(!l)return;try{y.FileDecoration.validate(l),d[D]=[l.propagate,l.tooltip,l.badge,l.color]}catch(M){this._logService.warn(`INVALID decoration from extension '${_.value}': ${M}`)}}catch(f){this._logService.error(f)}})),d}};w._handlePool=0,w._maxEventSize=250,w=Be([He(0,k.IExtHostRpcService),He(1,P.ILogService)],w),e.ExtHostDecorations=w,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!y:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(Z,s):y?y.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[180],_e([0,1,118,82,2,5,7,8,4,12,21,30]),function(Z,e,s,t,y,T,k,P,C,A,R,w){"use strict";var i,p,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(_,m,f,D,l,M){this._name=_,this._owner=m,this._maxDiagnosticsPerFile=f,i.set(this,void 0),p.set(this,void 0),o.set(this,void 0),this._isDisposed=!1,Ze(this,o,new R.ResourceMap(r=>D.getComparisonKey(r)),"f"),Ze(this,i,l,"f"),Ze(this,p,M,"f")}dispose(){this._isDisposed||(Ie(this,p,"f").fire([...Ie(this,o,"f").keys()]),Ie(this,i,"f")&&Ie(this,i,"f").$clear(this._owner),Ie(this,o,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(_,m){if(!_){this.clear();return}this._checkDisposed();let f=[];if(y.URI.isUri(_)){if(!m){this.delete(_);return}Ie(this,o,"f").set(_,m.slice()),f=[_]}else if(Array.isArray(_)){f=[];let l;_=[..._].sort(u._compareIndexedTuplesByUri);for(const M of _){const[r,n]=M;if((!l||r.toString()!==l.toString())&&(l&&Ie(this,o,"f").get(l).length===0&&Ie(this,o,"f").delete(l),l=r,f.push(r),Ie(this,o,"f").set(r,[])),n){const b=Ie(this,o,"f").get(r);b&&b.push(...n)}else{const b=Ie(this,o,"f").get(r);b&&(b.length=0)}}}if(Ie(this,p,"f").fire(f),!Ie(this,i,"f"))return;const D=[];for(let l of f){let M=[];const r=Ie(this,o,"f").get(l);if(r)if(r.length>this._maxDiagnosticsPerFile){M=[];const n=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let b=0;b<4;b++)for(let g of r)if(g.severity===n[b]&&M.push(P.Diagnostic.from(g))===this._maxDiagnosticsPerFile)break e;M.push({severity:t.MarkerSeverity.Info,message:(0,s.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:M[M.length-1].startLineNumber,startColumn:M[M.length-1].startColumn,endLineNumber:M[M.length-1].endLineNumber,endColumn:M[M.length-1].endColumn})}else M=r.map(n=>P.Diagnostic.from(n));D.push([l,M])}Ie(this,i,"f").$changeMany(this._owner,D)}delete(_){this._checkDisposed(),Ie(this,p,"f").fire([_]),Ie(this,o,"f").delete(_),Ie(this,i,"f")&&Ie(this,i,"f").$changeMany(this._owner,[[_,void 0]])}clear(){this._checkDisposed(),Ie(this,p,"f").fire([...Ie(this,o,"f").keys()]),Ie(this,o,"f").clear(),Ie(this,i,"f")&&Ie(this,i,"f").$clear(this._owner)}forEach(_,m){this._checkDisposed();for(let f of Ie(this,o,"f").keys())_.apply(m,[f,this.get(f),this])}get(_){this._checkDisposed();const m=Ie(this,o,"f").get(_);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(_){return this._checkDisposed(),Array.isArray(Ie(this,o,"f").get(_))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(_,m){return _[0].toString()<m[0].toString()?-1:_[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=u,i=new WeakMap,p=new WeakMap,o=new WeakMap;let d=class oi{constructor(_,m,f){this._logService=m,this._fileSystemInfoService=f,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:D=>D.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=_.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(_){const m=new R.ResourceMap;for(const f of _)m.set(f,f);return{uris:Object.freeze(Array.from(m.values()))}}createDiagnosticCollection(_,m){const{_collections:f,_proxy:D,_onDidChangeDiagnostics:l,_logService:M,_fileSystemInfoService:r}=this,n=new class{$changeMany(c,h){D.$changeMany(c,h),M.trace("[DiagnosticCollection] change many (extension, owner, uris)",_.value,c,h.length===0?"CLEARING":h)}$clear(c){D.$clear(c),M.trace("[DiagnosticCollection] remove all (extension, owner)",_.value,c)}dispose(){D.dispose()}};let b;if(!m)m="_generated_diagnostic_collection_name_#"+oi._idPool++,b=m;else if(!f.has(m))b=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do b=m+oi._idPool++;while(f.has(b))}return new class extends u{constructor(){super(m,b,oi._maxDiagnosticsPerFile,r.extUri,n,l);f.set(b,this)}dispose(){super.dispose(),f.delete(b)}}}getDiagnostics(_){if(_)return this._getDiagnostics(_);{const m=new Map,f=[];for(const D of this._collections.values())D.forEach((l,M)=>{let r=m.get(l.toString());typeof r=="undefined"&&(r=f.length,m.set(l.toString(),r),f.push([l,[]])),f[r][1]=f[r][1].concat(...M)});return f}}_getDiagnostics(_){let m=[];for(let f of this._collections.values())f.has(_)&&(m=m.concat(f.get(_)));return m}$acceptMarkersChange(_){if(!this._mirrorCollection){const m="_generated_mirror",f=new u(m,m,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(m,f),this._mirrorCollection=f}for(const[m,f]of _)this._mirrorCollection.set(y.URI.revive(m),f.map(P.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=Be([He(1,A.ILogService),He(2,w.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(ye[181],_e([0,1,2,5]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(k){this._proxy=k.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(P=>P?P.map(C=>s.URI.revive(C)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(P=>P?s.URI.revive(P):void 0)}}e.ExtHostDialogs=y}),define(ye[182],_e([0,1,15,2,7,5,11,20,9]),function(Z,e,s,t,y,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(w,i,p){this._documentsAndEditors=i,this._logService=p,this._documentContentProviders=new Map,this._proxy=w.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,i){if(Object.keys(k.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const p=A._handlePool++;this._documentContentProviders.set(p,i),this._proxy.$registerTextContentProvider(p,w);let o;return typeof i.onDidChange=="function"&&(o=i.onDidChange(u=>{if(u.scheme!==w){this._logService.warn(`Provider for scheme '${w}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(p,u).then(d=>{if(!d&&typeof d!="string")return;const F=this._documentsAndEditors.getDocument(u);if(!F)return;const _=(0,C.splitLines)(d);if(!F.equalLines(_))return this._proxy.$onVirtualDocumentChange(u,d)},s.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(w,i){const p=this._documentContentProviders.get(w);return p?Promise.resolve(p.provideTextDocumentContent(t.URI.revive(i),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${i.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(ye[183],_e([0,1,4,6,2,5,86,8,10,26,7]),function(Z,e,s,t,y,T,k,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(p,o){this._onDidAddDocument=new s.Emitter,this._onDidRemoveDocument=new s.Emitter,this._onDidChangeDocument=new s.Emitter,this._onDidSaveDocument=new s.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const d of u)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const d of u)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const o=this._documentsAndEditors.getDocument(p);if(o)return o}getDocument(p){const o=this.getDocumentData(p);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return o.document}ensureDocumentData(p){const o=this._documentsAndEditors.getDocument(p);if(o)return Promise.resolve(o);let u=this._documentLoader.get(p.toString());return u||(u=this._proxy.$tryOpenDocument(p).then(d=>{this._documentLoader.delete(p.toString());const F=y.URI.revive(d);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(F))},d=>(this._documentLoader.delete(p.toString()),Promise.reject(d))),this._documentLoader.set(p.toString(),u)),u}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(o=>y.URI.revive(o))}$acceptModelLanguageChanged(p,o){const u=y.URI.revive(p),d=this._documentsAndEditors.getDocument(u);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(o),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(p){const o=y.URI.revive(p),u=this._documentsAndEditors.getDocument(o);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(p,o){const u=y.URI.revive(p),d=this._documentsAndEditors.getDocument(u);if(!d)throw new Error("unknown document");d._acceptIsDirty(o),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,o,u){const d=y.URI.revive(p),F=this._documentsAndEditors.getDocument(d);if(!F)throw new Error("unknown document");F._acceptIsDirty(u),F.onEvents(o);let _;o.isUndoing?_=R.TextDocumentChangeReason.Undo:o.isRedoing&&(_=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:F.document,contentChanges:o.changes.map(m=>({range:P.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:_}))}setWordDefinitionFor(p,o){(0,k.setWordDefinitionFor)(p,o)}}e.ExtHostDocuments=w}),define(ye[49],_e([0,1,42,4,6,2,3,5,86,13,92,8,12,21,11,157,228]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class F{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(f,D){this._extHostRpc=f,this._logService=D,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const D=[],l=[],M=[];if(f.removedDocuments)for(const r of f.removedDocuments){const n=T.URI.revive(r),b=this._documents.get(n);b?.unref()&&(this._documents.delete(n),D.push(b.value))}if(f.addedDocuments)for(const r of f.addedDocuments){const n=T.URI.revive(r.uri);let b=this._documents.get(n);if(b&&n.scheme!==o.Schemas.vscodeNotebookCell&&n.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);b||(b=new F(new C.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),n,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(n,b),l.push(b.value)),b.ref()}if(f.removedEditors)for(const r of f.removedEditors){const n=this._editors.get(r);this._editors.delete(r),n&&M.push(n)}if(f.addedEditors)for(const r of f.addedEditors){const n=T.URI.revive(r.documentUri);s.ok(this._documents.has(n),`document '${n}' does not exist`),s.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const b=this._documents.get(n).value,g=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>b.document),r.selections.map(w.Selection.to),r.options,r.visibleRanges.map(c=>w.Range.to(c)),typeof r.editorPosition=="number"?w.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,g)}f.newActiveEditor!==void 0&&(s.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,y.dispose)(D),(0,y.dispose)(M),f.removedDocuments&&this._onDidRemoveDocuments.fire(D),f.addedDocuments&&this._onDidAddDocuments.fire(l),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const D=this._editors.get(this._activeEditorId);return f?D:D?.value}allEditors(){return[...this._editors.values()]}};_=Be([He(0,A.IExtHostRpcService),He(1,i.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[70],_e([0,1,8,5,2,4,3,13,14]),function(Z,e,s,t,y,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");let A=class{constructor(w){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new T.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=w.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(w){let i=-1;this._tabs=w.map((o,u)=>(o.isActive&&(i=u),Object.freeze({label:o.label,viewColumn:s.ViewColumn.to(o.viewColumn),index:u,resource:y.URI.revive(o.resource),additionalResourcesAndViewIds:o.additionalResourcesAndViewIds.map(({resource:d,viewId:F})=>({resource:y.URI.revive(d),viewId:F})),viewId:o.editorId,isActive:o.isActive,move:async(d,F)=>{this._proxy.$moveTab(o,d,s.ViewColumn.from(F)),await(0,C.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(o),await(0,C.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((o,u)=>o.viewColumn===u.viewColumn?o.index-u.index:o.viewColumn-u.viewColumn);const p=this._activeTab;this._activeTab=i===-1?void 0:this._tabs[i],this._activeTab!==p&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};A=Be([He(0,P.IExtHostRpcService)],A),e.ExtHostEditorTabs=A}),define(ye[184],_e([0,1,2,5,6,7,8,229,9,22,27]),function(Z,e,s,t,y,T,k,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this._schemes=[]}add(o){this._stateMachine=void 0,this._schemes.push(o)}delete(o){const u=this._schemes.indexOf(o);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const o=this._schemes.sort(),u=[];let d,F,_=14,m=14;for(const f of o){let D=d?(0,C.commonPrefixLength)(d,f):0;for(D===0?F=1:F=m;D<f.length;D++)D+1===f.length?(_=m,m=9):m+=1,u.push([F,f.toUpperCase().charCodeAt(D),m]),u.push([F,f.toLowerCase().charCodeAt(D),m]),F=m;d=f,m=_}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new P.StateMachine(u)}}provideDocumentLinks(o){this._initStateMachine();const u=[],d=P.LinkComputer.computeLinks({getLineContent(F){return o.lineAt(F-1).text},getLineCount(){return o.lineCount}},this._stateMachine);for(const F of d){const _=k.DocumentLink.to(F);_.target&&u.push(_)}return u}}class i{constructor(o,u){this._extHostLanguageFeatures=u,this._linkProvider=new w,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=o.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(o,u,d,F={}){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const _=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(_,d);let m=2;F.isCaseSensitive&&(m+=1024),F.isReadonly&&(m+=2048),typeof d.copy=="function"&&(m+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,R.checkProposedApiEnabled)(o,"fsChunks"),m+=4),this._proxy.$registerFileSystemProvider(_,u,m).catch(D=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${u}`),console.error(D)});const f=d.onDidChangeFile(D=>{const l=[];for(const M of D){let{uri:r,type:n}=M;if(r.scheme!==u)continue;let b;switch(n){case T.FileChangeType.Changed:b=0;break;case T.FileChangeType.Created:b=1;break;case T.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:r,type:b})}this._proxy.$onFileSystemChange(_,l)});return(0,y.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(_),this._proxy.$unregisterProvider(_)})}static _asIStat(o){const{type:u,ctime:d,mtime:F,size:_,permissions:m}=o;return{type:u,ctime:d,mtime:F,size:_,permissions:m}}$stat(o,u){return Promise.resolve(this._getFsProvider(o).stat(s.URI.revive(u))).then(d=>i._asIStat(d))}$readdir(o,u){return Promise.resolve(this._getFsProvider(o).readDirectory(s.URI.revive(u)))}$readFile(o,u){return Promise.resolve(this._getFsProvider(o).readFile(s.URI.revive(u))).then(d=>A.VSBuffer.wrap(d))}$writeFile(o,u,d,F){return Promise.resolve(this._getFsProvider(o).writeFile(s.URI.revive(u),d.buffer,F))}$delete(o,u,d){return Promise.resolve(this._getFsProvider(o).delete(s.URI.revive(u),d))}$rename(o,u,d,F){return Promise.resolve(this._getFsProvider(o).rename(s.URI.revive(u),s.URI.revive(d),F))}$copy(o,u,d,F){const _=this._getFsProvider(o);if(!_.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(_.copy(s.URI.revive(u),s.URI.revive(d),F))}$mkdir(o,u){return Promise.resolve(this._getFsProvider(o).createDirectory(s.URI.revive(u)))}$watch(o,u,d,F){const _=this._getFsProvider(o).watch(s.URI.revive(d),F);this._watches.set(u,_)}$unwatch(o,u){const d=this._watches.get(u);d&&(d.dispose(),this._watches.delete(u))}$open(o,u,d){const F=this._getFsProvider(o);if(!F.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(F.open(s.URI.revive(u),d))}$close(o,u){const d=this._getFsProvider(o);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(u))}$read(o,u,d,F){const _=this._getFsProvider(o);if(!_.read)throw new Error('FileSystemProvider does not implement "read"');const m=A.VSBuffer.alloc(F);return Promise.resolve(_.read(u,d,m.buffer,0,F)).then(f=>m.slice(0,f))}$write(o,u,d,F){const _=this._getFsProvider(o);if(!_.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(_.write(u,d,F.buffer,0,F.byteLength))}_getFsProvider(o){const u=this._fsProvider.get(o);if(!u){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return u}}e.ExtHostFileSystem=i}),define(ye[50],_e([0,1,5,46,7,22,3,13,30,6]),function(Z,e,s,t,y,T,k,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Ht{constructor(i,p){this._fileSystemProvider=new Map,this._proxy=i.getProxy(s.MainContext.MainThreadFileSystem);const o=this;this.value=Object.freeze({async stat(u){try{const d=o._fileSystemProvider.get(u.scheme);if(!d)return await o._proxy.$stat(u);await o._proxy.$ensureActivation(u.scheme);const F=await d.stat(u);return{type:F.type,ctime:F.ctime,mtime:F.mtime,size:F.size,permissions:F.permissions}}catch(d){Ht._handleError(d)}},async readDirectory(u){try{const d=o._fileSystemProvider.get(u.scheme);return d?(await o._proxy.$ensureActivation(u.scheme),(await d.readDirectory(u)).slice()):await o._proxy.$readdir(u)}catch(d){return Ht._handleError(d)}},async createDirectory(u){try{return await o._proxy.$mkdir(u)}catch(d){return Ht._handleError(d)}},async readFile(u){try{const d=o._fileSystemProvider.get(u.scheme);return d?(await o._proxy.$ensureActivation(u.scheme),(await d.readFile(u)).slice()):(await o._proxy.$readFile(u)).buffer}catch(d){return Ht._handleError(d)}},async writeFile(u,d){try{return await o._proxy.$writeFile(u,T.VSBuffer.wrap(d))}catch(F){return Ht._handleError(F)}},async delete(u,d){try{const F=o._fileSystemProvider.get(u.scheme);return F?(await o._proxy.$ensureActivation(u.scheme),await F.delete(u,{recursive:!1,...d})):await o._proxy.$delete(u,{recursive:!1,useTrash:!1,...d})}catch(F){return Ht._handleError(F)}},async rename(u,d,F){try{return await o._proxy.$rename(u,d,{overwrite:!1,...F})}catch(_){return Ht._handleError(_)}},async copy(u,d,F){try{return await o._proxy.$copy(u,d,{overwrite:!1,...F})}catch(_){return Ht._handleError(_)}},isWritableFileSystem(u){const d=p.getCapabilities(u);if(typeof d=="number")return!(d&2048)}})}static _handleError(i){if(i instanceof y.FileSystemError)throw i;if(!(i instanceof Error))throw new y.FileSystemError(String(i));if(i.name==="ENOPRO")throw y.FileSystemError.Unavailable(i.message);switch(i.name){case t.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(i.message);case t.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(i.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(i.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(i.message);case t.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(i.message);case t.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(i.message);default:throw new y.FileSystemError(i.message,i.name)}}addFileSystemProvider(i,p){return this._fileSystemProvider.set(i,p),(0,A.toDisposable)(()=>this._fileSystemProvider.delete(i))}};R=Be([He(0,P.IExtHostRpcService),He(1,C.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[185],_e([0,1,2,39]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(k,P,C,A){this._extHostNotebooks=P,this._textDocumentsAndEditors=C,this._commands=A;const R=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",w=>!0,w=>w),new t.ApiCommandArgument("resource","Interactive resource Uri",w=>!0,w=>w),new t.ApiCommandArgument("controllerId","Notebook controller Id",w=>!0,w=>w),new t.ApiCommandArgument("title","Interactive editor title",w=>!0,w=>w)],new t.ApiCommandResult("Notebook and input URI",w=>{if(w.notebookEditorId!==void 0){const i=this._extHostNotebooks.getEditorById(w.notebookEditorId);return{notebookUri:s.URI.revive(w.notebookUri),inputUri:s.URI.revive(w.inputUri),notebookEditor:i.apiEditor}}return{notebookUri:s.URI.revive(w.notebookUri),inputUri:s.URI.revive(w.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(k,P,C,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:C,uri:k,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(s.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(k,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[k]})}}e.ExtHostInteractive=y}),define(ye[186],_e([0,1,6,5]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(k){this._handlePool=0,this._proxy=k.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,k),(0,s.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=y}),define(ye[187],_e([0,1,2,26,8,7,5,9,59,16,10,230,6,79,54,63,188,15,4]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor(H,G){this._documents=H,this._provider=G}async provideDocumentSymbols(H,G){const X=this._documents.getDocument(H),oe=await this._provider.provideDocumentSymbols(X,G);if(!(0,A.isFalsyOrEmpty)(oe))return oe[0]instanceof T.DocumentSymbol?oe.map(y.DocumentSymbol.from):m._asDocumentSymbolTree(oe)}static _asDocumentSymbolTree(H){H=H.slice(0).sort((oe,q)=>{let ee=oe.location.range.start.compareTo(q.location.range.start);return ee===0&&(ee=q.location.range.end.compareTo(oe.location.range.end)),ee});const G=[],X=[];for(const oe of H){const q={name:oe.name||"!!MISSING: name!!",kind:y.SymbolKind.from(oe.kind),tags:oe.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:y.Range.from(oe.location.range),selectionRange:y.Range.from(oe.location.range),children:[]};for(;;){if(X.length===0){X.push(q),G.push(q);break}const ee=X[X.length-1];if(C.Range.containsRange(ee.range,q.range)&&!C.Range.equalsRange(ee.range,q.range)){ee.children&&ee.children.push(q),X.push(q);break}X.pop()}}return G}}class f{constructor(H,G,X){this._documents=H,this._commands=G,this._provider=X,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,G){const X=this._documents.getDocument(H),oe=await this._provider.provideCodeLenses(X,G);if(!oe||G.isCancellationRequested)return;const q=this._cache.add(oe),ee=new i.DisposableStore;this._disposables.set(q,ee);const he={cacheId:q,lenses:[]};for(let Re=0;Re<oe.length;Re++)he.lenses.push({cacheId:[q,Re],range:y.Range.from(oe[Re].range),command:this._commands.toInternal(oe[Re].command,ee)});return he}async resolveCodeLens(H,G){const X=H.cacheId&&this._cache.get(...H.cacheId);if(!X)return;let oe;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?oe=X:oe=await this._provider.resolveCodeLens(X,G),oe||(oe=X),G.isCancellationRequested)return;const q=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!q)return H.command=this._commands.toInternal(oe.command??f._badCmd,q),H}releaseCodeLenses(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function D(je){return Array.isArray(je)?je.map(y.DefinitionLink.from):je?[y.DefinitionLink.from(je)]:[]}class l{constructor(H,G){this._documents=H,this._provider=G}async provideDefinition(H,G,X){const oe=this._documents.getDocument(H),q=y.Position.to(G),ee=await this._provider.provideDefinition(oe,q,X);return D(ee)}}class M{constructor(H,G){this._documents=H,this._provider=G}async provideDeclaration(H,G,X){const oe=this._documents.getDocument(H),q=y.Position.to(G),ee=await this._provider.provideDeclaration(oe,q,X);return D(ee)}}class r{constructor(H,G){this._documents=H,this._provider=G}async provideImplementation(H,G,X){const oe=this._documents.getDocument(H),q=y.Position.to(G),ee=await this._provider.provideImplementation(oe,q,X);return D(ee)}}class n{constructor(H,G){this._documents=H,this._provider=G}async provideTypeDefinition(H,G,X){const oe=this._documents.getDocument(H),q=y.Position.to(G),ee=await this._provider.provideTypeDefinition(oe,q,X);return D(ee)}}class b{constructor(H,G){this._documents=H,this._provider=G}async provideHover(H,G,X){const oe=this._documents.getDocument(H),q=y.Position.to(G),ee=await this._provider.provideHover(oe,q,X);if(!(!ee||(0,A.isFalsyOrEmpty)(ee.contents)))return ee.range||(ee.range=oe.getWordRangeAtPosition(q)),ee.range||(ee.range=new T.Range(q,q)),y.Hover.from(ee)}}class g{constructor(H,G){this._documents=H,this._provider=G}async provideEvaluatableExpression(H,G,X){const oe=this._documents.getDocument(H),q=y.Position.to(G),ee=await this._provider.provideEvaluatableExpression(oe,q,X);if(ee)return y.EvaluatableExpression.from(ee)}}class c{constructor(H,G){this._documents=H,this._provider=G}async provideInlineValues(H,G,X,oe){const q=this._documents.getDocument(H),ee=await this._provider.provideInlineValues(q,y.Range.to(G),y.InlineValueContext.to(X),oe);if(Array.isArray(ee))return ee.map(he=>y.InlineValue.from(he))}}class h{constructor(H,G){this._documents=H,this._provider=G}async provideDocumentHighlights(H,G,X){const oe=this._documents.getDocument(H),q=y.Position.to(G),ee=await this._provider.provideDocumentHighlights(oe,q,X);if(Array.isArray(ee))return ee.map(y.DocumentHighlight.from)}}class v{constructor(H,G){this._documents=H,this._provider=G}async provideLinkedEditingRanges(H,G,X){const oe=this._documents.getDocument(H),q=y.Position.to(G),ee=await this._provider.provideLinkedEditingRanges(oe,q,X);if(ee&&Array.isArray(ee.ranges))return{ranges:(0,A.coalesce)(ee.ranges.map(y.Range.from)),wordPattern:ee.wordPattern}}}class a{constructor(H,G){this._documents=H,this._provider=G}async provideReferences(H,G,X,oe){const q=this._documents.getDocument(H),ee=y.Position.to(G),he=await this._provider.provideReferences(q,ee,X,oe);if(Array.isArray(he))return he.map(y.location.from)}}class S{constructor(H,G,X,oe,q,ee,he){this._documents=H,this._commands=G,this._diagnostics=X,this._provider=oe,this._logService=q,this._extension=ee,this._apiDeprecation=he,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(H,G,X,oe){const q=this._documents.getDocument(H),ee=w.Selection.isISelection(G)?y.Selection.to(G):y.Range.to(G),he=[];for(const st of this._diagnostics.getDiagnostics(H))if(ee.intersection(st.range)&&he.push(st)>S._maxCodeActionsPerFile)break;const Re={diagnostics:he,only:X.only?new T.CodeActionKind(X.only):void 0,triggerKind:y.CodeActionTriggerKind.to(X.trigger)},Ue=await this._provider.provideCodeActions(q,ee,Re,oe);if(!(0,A.isNonEmptyArray)(Ue)||oe.isCancellationRequested)return;const ze=this._cache.add(Ue),Qe=new i.DisposableStore;this._disposables.set(ze,Qe);const et=[];for(let st=0;st<Ue.length;st++){const Xe=Ue[st];!Xe||(S._isCommand(Xe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Xe.title,command:this._commands.toInternal(Xe,Qe)})):(Re.only&&(Xe.kind?Re.only.contains(Xe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[ze,st],title:Xe.title,command:Xe.command&&this._commands.toInternal(Xe.command,Qe),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(y.Diagnostic.from),edit:Xe.edit&&y.WorkspaceEdit.from(Xe.edit),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:ze,actions:et}}async resolveCodeAction(H,G){const[X,oe]=H,q=this._cache.get(X,oe);if(!q||S._isCommand(q)||!this._provider.resolveCodeAction)return;const ee=await this._provider.resolveCodeAction(q,G)??q;return ee?.edit?y.WorkspaceEdit.from(ee.edit):void 0}releaseCodeActions(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}S._maxCodeActionsPerFile=1e3;class I{constructor(H,G){this._documents=H,this._provider=G}async provideDocumentFormattingEdits(H,G,X){const oe=this._documents.getDocument(H),q=await this._provider.provideDocumentFormattingEdits(oe,G,X);if(Array.isArray(q))return q.map(y.TextEdit.from)}}class N{constructor(H,G){this._documents=H,this._provider=G}async provideDocumentRangeFormattingEdits(H,G,X,oe){const q=this._documents.getDocument(H),ee=y.Range.to(G),he=await this._provider.provideDocumentRangeFormattingEdits(q,ee,X,oe);if(Array.isArray(he))return he.map(y.TextEdit.from)}}class B{constructor(H,G){this._documents=H,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,G,X,oe,q){const ee=this._documents.getDocument(H),he=y.Position.to(G),Re=await this._provider.provideOnTypeFormattingEdits(ee,he,X,oe,q);if(Array.isArray(Re))return Re.map(y.TextEdit.from)}}class E{constructor(H,G){this._provider=H,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(H,G){const X=k.IdObject.mixin({symbols:[]}),oe=await this._provider.provideWorkspaceSymbols(H,G);if((0,A.isNonEmptyArray)(oe))for(const q of oe){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const ee=k.IdObject.mixin(y.WorkspaceSymbol.from(q));this._symbolCache.set(ee._id,q),X.symbols.push(ee)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(H,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return H;const X=this._symbolCache.get(H._id);if(X){const oe=await this._provider.resolveWorkspaceSymbol(X,G);return oe&&(0,t.mixin)(H,y.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(H){const G=this._resultCache.get(H);if(G){for(let[X,oe]=G;X<=oe;X++)this._symbolCache.delete(X);this._resultCache.delete(H)}}}class O{constructor(H,G,X){this._documents=H,this._provider=G,this._logService=X}static supportsResolving(H){return typeof H.prepareRename=="function"}async provideRenameEdits(H,G,X,oe){const q=this._documents.getDocument(H),ee=y.Position.to(G);try{const he=await this._provider.provideRenameEdits(q,ee,X,oe);return he?y.WorkspaceEdit.from(he):void 0}catch(he){const Re=O._asMessage(he);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(H,G,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(H),q=y.Position.to(G);try{const ee=await this._provider.prepareRename(oe,q,X);let he,Re;if(T.Range.isRange(ee)?(he=ee,Re=oe.getText(ee)):(0,R.isObject)(ee)&&(he=ee.range,Re=ee.placeholder),!he||!Re)return;if(he.start.line>q.line||he.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(he),text:Re}}catch(ee){const he=O._asMessage(ee);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(ee)}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class z{constructor(H,G){this.resultId=H,this.tokens=G}}class U{constructor(H,G){this._documents=H,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(H,G,X){const oe=this._documents.getDocument(H),q=G!==0?this._previousResults.get(G):null;let ee=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(oe,q.resultId,X):await this._provider.provideDocumentSemanticTokens(oe,X);return q&&this._previousResults.delete(G),ee?(ee=U._fixProvidedSemanticTokens(ee),this._send(U._convertToEdits(q,ee),ee)):null}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return U._isSemanticTokens(H)?U._isCorrectSemanticTokens(H)?H:new T.SemanticTokens(new Uint32Array(H.data),H.resultId):U._isSemanticTokensEdits(H)?U._isCorrectSemanticTokensEdits(H)?H:new T.SemanticTokensEdits(H.edits.map(G=>new T.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const G of H.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,G){if(!U._isSemanticTokens(G)||!H||!H.tokens)return G;const X=H.tokens,oe=X.length,q=G.data,ee=q.length;let he=0;const Re=Math.min(oe,ee);for(;he<Re&&X[he]===q[he];)he++;if(he===oe&&he===ee)return new T.SemanticTokensEdits([],G.resultId);let Ue=0;const ze=Re-he;for(;Ue<ze&&X[oe-Ue-1]===q[ee-Ue-1];)Ue++;return new T.SemanticTokensEdits([{start:he,deleteCount:oe-he-Ue,data:q.subarray(he,ee-Ue)}],G.resultId)}_send(H,G){if(U._isSemanticTokens(H)){const X=this._nextResultId++;return this._previousResults.set(X,new z(H.resultId,H.data)),(0,p.encodeSemanticTokensDto)({id:X,type:"full",data:H.data})}if(U._isSemanticTokensEdits(H)){const X=this._nextResultId++;return U._isSemanticTokens(G)?this._previousResults.set(X,new z(G.resultId,G.data)):this._previousResults.set(X,new z(H.resultId)),(0,p.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(H.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class ${constructor(H,G){this._documents=H,this._provider=G}async provideDocumentRangeSemanticTokens(H,G,X){const oe=this._documents.getDocument(H),q=await this._provider.provideDocumentRangeSemanticTokens(oe,y.Range.to(G),X);return q?this._send(q):null}_send(H){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=$;class V{constructor(H,G,X,oe,q){this._documents=H,this._commands=G,this._provider=X,this._apiDeprecation=oe,this._extension=q,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,G,X,oe){const q=this._documents.getDocument(H),ee=y.Position.to(G),he=q.getWordRangeAtPosition(ee)||new T.Range(ee,ee),Re=he.with({end:ee}),Ue=new d.StopWatch(!0),ze=await this._provider.provideCompletionItems(q,ee,oe,y.CompletionContext.to(X));if(!ze||oe.isCancellationRequested)return;const Qe=Array.isArray(ze)?new T.CompletionList(ze):ze,et=V.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),st=new i.DisposableStore;this._disposables.set(et,st);const Xe=[],nt={x:et,b:Xe,a:{replace:y.Range.from(he),insert:y.Range.from(Re)},c:Qe.isIncomplete||void 0,d:Ue.elapsed()};for(let lt=0;lt<Qe.items.length;lt++){const vt=Qe.items[lt],Oe=this._convertCompletionItem(vt,[et,lt],Re,he);Xe.push(Oe)}return nt}async resolveCompletionItem(H,G){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...H);if(!X)return;const oe=await this._provider.resolveCompletionItem(X,G);if(!!oe)return this._convertCompletionItem(oe,H)}releaseCompletionItems(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,G,X,oe){const q=this._disposables.get(G[0]);if(!q)throw Error("DisposableStore is missing...");const ee={x:G,a:H.label,b:H.kind!==void 0?y.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(y.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:y.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(y.TextEdit.from),m:this._commands.toInternal(H.command,q)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ee.h=H.textEdit.newText):typeof H.insertText=="string"?ee.h=H.insertText:H.insertText instanceof T.SnippetString&&(ee.h=H.insertText.value,ee.i|=4);let he;return H.textEdit?he=H.textEdit.range:H.range&&(he=H.range),T.Range.isRange(he)?ee.j=y.Range.from(he):he&&(!X?.isEqual(he.inserting)||!oe?.isEqual(he.replacing))&&(ee.j={insert:y.Range.from(he.inserting),replace:y.Range.from(he.replacing)}),ee}}class ue{constructor(H,G,X){this._documents=H,this._provider=G,this._commands=X,this._cache=new u.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(H,G,X,oe){const q=this._documents.getDocument(H),ee=y.Position.to(G),he=await this._provider.provideInlineCompletionItems(q,ee,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:y.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text,isSnippetText:X.selectedSuggestionInfo.isSnippetText,completionKind:y.CompletionItemKind.to(X.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:X.triggerKind},oe);if(!he||oe.isCancellationRequested)return;const Re=(0,R.isArray)(he)?{items:he}:he,Ue=this._cache.add(Re.items);let ze;return{pid:Ue,items:Re.items.map((Qe,et)=>{let st;return Qe.command&&(ze||(ze=new i.DisposableStore,this._disposables.set(Ue,ze)),st=this._commands.toInternal(Qe.command,ze)),{text:Qe.text,range:Qe.range?y.Range.from(Qe.range):void 0,command:st,idx:et}})}}disposeCompletions(H){this._cache.delete(H);const G=this._disposables.get(H);G&&G.clear(),this._disposables.delete(H)}handleDidShowCompletionItem(H,G){const X=this._cache.get(H,G);X&&K.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class K{constructor(){this._onDidShowCompletionItemEmitter=new _.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(H){let G=K.map.get(H);return G||(G=new K,K.map.set(H,G)),G}fireOnDidShowCompletionItem(H){this._onDidShowCompletionItemEmitter.fire(H)}}e.InlineCompletionController=K,K.map=new WeakMap;class re{constructor(H,G){this._documents=H,this._provider=G,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(H,G,X,oe){const q=this._documents.getDocument(H),ee=y.Position.to(G),he=this.reviveContext(X),Re=await this._provider.provideSignatureHelp(q,ee,oe,he);if(Re){const Ue=this._cache.add([Re]);return{...y.SignatureHelp.from(Re),id:Ue}}}reviveContext(H){let G;if(H.activeSignatureHelp){const X=y.SignatureHelp.to(H.activeSignatureHelp),oe=this._cache.get(H.activeSignatureHelp.id,0);oe?(G=oe,G.activeSignature=X.activeSignature,G.activeParameter=X.activeParameter):G=X}return{...H,activeSignatureHelp:G}}releaseSignatureHelp(H){this._cache.delete(H)}}class pe{constructor(H,G){this._documents=H,this._provider=G}async provideInlayHints(H,G,X){const oe=this._documents.getDocument(H),q=await this._provider.provideInlayHints(oe,y.Range.to(G),X);return q?{hints:q.map(y.InlayHint.from)}:void 0}}class we{constructor(H,G){this._documents=H,this._provider=G,this._cache=new u.Cache("DocumentLink")}async provideLinks(H,G){const X=this._documents.getDocument(H),oe=await this._provider.provideDocumentLinks(X,G);if(!(!Array.isArray(oe)||oe.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.filter(we._validateLink).map(y.DocumentLink.from)};{const q=this._cache.add(oe),ee={links:[],id:q};for(let he=0;he<oe.length;he++){if(!we._validateLink(oe[he]))continue;const Re=y.DocumentLink.from(oe[he]);Re.cacheId=[q,he],ee.links.push(Re)}return ee}}}static _validateLink(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,G){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...H);if(!X)return;const oe=await this._provider.resolveDocumentLink(X,G);if(!(!oe||!we._validateLink(oe)))return y.DocumentLink.from(oe)}releaseLinks(H){this._cache.delete(H)}}class ae{constructor(H,G){this._documents=H,this._provider=G}async provideColors(H,G){const X=this._documents.getDocument(H),oe=await this._provider.provideDocumentColors(X,G);return Array.isArray(oe)?oe.map(ee=>({color:y.Color.from(ee.color),range:y.Range.from(ee.range)})):[]}async provideColorPresentations(H,G,X){const oe=this._documents.getDocument(H),q=y.Range.to(G.range),ee=y.Color.to(G.color),he=await this._provider.provideColorPresentations(ee,{document:oe,range:q},X);if(!!Array.isArray(he))return he.map(y.ColorPresentation.from)}}class le{constructor(H,G){this._documents=H,this._provider=G}async provideFoldingRanges(H,G,X){const oe=this._documents.getDocument(H),q=await this._provider.provideFoldingRanges(oe,G,X);if(!!Array.isArray(q))return q.map(y.FoldingRange.from)}}class Ce{constructor(H,G,X){this._documents=H,this._provider=G,this._logService=X}async provideSelectionRanges(H,G,X){const oe=this._documents.getDocument(H),q=G.map(y.Position.to),ee=await this._provider.provideSelectionRanges(oe,q,X);if(!(0,A.isNonEmptyArray)(ee))return[];if(ee.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Re=0;Re<q.length;Re++){const Ue=[];he.push(Ue);let ze=q[Re],Qe=ee[Re];for(;;){if(!Qe.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(y.SelectionRange.from(Qe)),!Qe.parent)break;ze=Qe.range,Qe=Qe.parent}}return he}}class Ee{constructor(H,G){this._documents=H,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(H,G,X){const oe=this._documents.getDocument(H),q=y.Position.to(G),ee=await this._provider.prepareCallHierarchy(oe,q,X);if(!ee)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(ee)?ee.map(Re=>this._cacheAndConvertItem(he,Re)):[this._cacheAndConvertItem(he,ee)]}async provideCallsTo(H,G,X){const oe=this._itemFromCache(H,G);if(!oe)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(oe,X);if(!!q)return q.map(ee=>({from:this._cacheAndConvertItem(H,ee.from),fromRanges:ee.fromRanges.map(he=>y.Range.from(he))}))}async provideCallsFrom(H,G,X){const oe=this._itemFromCache(H,G);if(!oe)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(oe,X);if(!!q)return q.map(ee=>({to:this._cacheAndConvertItem(H,ee.to),fromRanges:ee.fromRanges.map(he=>y.Range.from(he))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,G){const X=this._cache.get(H),oe=y.CallHierarchyItem.from(G,H,X.size.toString(36));return X.set(oe._itemId,G),oe}_itemFromCache(H,G){return this._cache.get(H)?.get(G)}}class Fe{constructor(H,G){this._documents=H,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(H,G,X){const oe=this._documents.getDocument(H),q=y.Position.to(G),ee=await this._provider.prepareTypeHierarchy(oe,q,X);if(!ee)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(ee)?ee.map(Re=>this._cacheAndConvertItem(he,Re)):[this._cacheAndConvertItem(he,ee)]}async provideSupertypes(H,G,X){const oe=this._itemFromCache(H,G);if(!oe)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(oe,X);if(!!q)return q.map(ee=>this._cacheAndConvertItem(H,ee))}async provideSubtypes(H,G,X){const oe=this._itemFromCache(H,G);if(!oe)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(oe,X);if(!!q)return q.map(ee=>this._cacheAndConvertItem(H,ee))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,G){const X=this._cache.get(H),oe=y.TypeHierarchyItem.from(G,H,X.size.toString(36));return X.set(oe._itemId,G),oe}_itemFromCache(H,G){return this._cache.get(H)?.get(G)}}class $e{constructor(H,G){this.adapter=H,this.extension=G}}class Ve{constructor(H,G,X,oe,q,ee,he){this._adapter=new Map,this._uriTransformer=G,this._proxy=H.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=oe,this._diagnostics=q,this._logService=ee,this._apiDeprecation=he}_transformDocumentSelector(H){return y.DocumentSelector.from(H,this._uriTransformer)}_createDisposable(H){return new T.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return Ve._handlePool++}_withAdapter(H,G,X,oe,q=!1){const ee=this._adapter.get(H);if(!ee)return Promise.resolve(oe);if(ee.adapter instanceof G){let he;ee.extension&&(he=Date.now(),this._logService.trace(`[${ee.extension.identifier.value}] INVOKE provider '${G.name}'`));const Re=X(ee.adapter,ee.extension),Ue=ee.extension;return Ue&&Promise.resolve(Re).then(()=>this._logService.trace(`[${Ue.identifier.value}] provider DONE after ${Date.now()-he}ms`),ze=>{q&&ze instanceof F.CancellationError||(this._logService.error(`[${Ue.identifier.value}] provider FAILED`),this._logService.error(ze))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(H,G){const X=this._nextHandle();return this._adapter.set(X,new $e(H,G)),X}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,G,X,oe){const q=this._addNewAdapter(new m(this._documents,X),H),ee=oe&&oe.label||Ve._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(G),ee),this._createDisposable(q)}$provideDocumentSymbols(H,G,X){return this._withAdapter(H,m,oe=>oe.provideDocumentSymbols(s.URI.revive(G),X),void 0)}registerCodeLensProvider(H,G,X){const oe=this._nextHandle(),q=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new $e(new f(this._documents,this._commands.converter,X),H)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(G),q);let ee=this._createDisposable(oe);if(q!==void 0){const he=X.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(q));ee=T.Disposable.from(ee,he)}return ee}$provideCodeLenses(H,G,X){return this._withAdapter(H,f,oe=>oe.provideCodeLenses(s.URI.revive(G),X),void 0)}$resolveCodeLens(H,G,X){return this._withAdapter(H,f,oe=>oe.resolveCodeLens(G,X),void 0)}$releaseCodeLenses(H,G){this._withAdapter(H,f,X=>Promise.resolve(X.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(H,G,X){const oe=this._addNewAdapter(new l(this._documents,X),H);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDefinition(H,G,X,oe){return this._withAdapter(H,l,q=>q.provideDefinition(s.URI.revive(G),X,oe),[])}registerDeclarationProvider(H,G,X){const oe=this._addNewAdapter(new M(this._documents,X),H);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDeclaration(H,G,X,oe){return this._withAdapter(H,M,q=>q.provideDeclaration(s.URI.revive(G),X,oe),[])}registerImplementationProvider(H,G,X){const oe=this._addNewAdapter(new r(this._documents,X),H);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideImplementation(H,G,X,oe){return this._withAdapter(H,r,q=>q.provideImplementation(s.URI.revive(G),X,oe),[])}registerTypeDefinitionProvider(H,G,X){const oe=this._addNewAdapter(new n(this._documents,X),H);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideTypeDefinition(H,G,X,oe){return this._withAdapter(H,n,q=>q.provideTypeDefinition(s.URI.revive(G),X,oe),[])}registerHoverProvider(H,G,X,oe){const q=this._addNewAdapter(new b(this._documents,X),H);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideHover(H,G,X,oe){return this._withAdapter(H,b,q=>q.provideHover(s.URI.revive(G),X,oe),void 0)}registerEvaluatableExpressionProvider(H,G,X,oe){const q=this._addNewAdapter(new g(this._documents,X),H);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideEvaluatableExpression(H,G,X,oe){return this._withAdapter(H,g,q=>q.provideEvaluatableExpression(s.URI.revive(G),X,oe),void 0)}registerInlineValuesProvider(H,G,X,oe){const q=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ee=this._addNewAdapter(new c(this._documents,X),H);this._proxy.$registerInlineValuesProvider(ee,this._transformDocumentSelector(G),q);let he=this._createDisposable(ee);if(q!==void 0){const Re=X.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(q));he=T.Disposable.from(he,Re)}return he}$provideInlineValues(H,G,X,oe,q){return this._withAdapter(H,c,ee=>ee.provideInlineValues(s.URI.revive(G),X,oe,q),void 0)}registerDocumentHighlightProvider(H,G,X){const oe=this._addNewAdapter(new h(this._documents,X),H);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDocumentHighlights(H,G,X,oe){return this._withAdapter(H,h,q=>q.provideDocumentHighlights(s.URI.revive(G),X,oe),void 0)}registerLinkedEditingRangeProvider(H,G,X){const oe=this._addNewAdapter(new v(this._documents,X),H);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideLinkedEditingRanges(H,G,X,oe){return this._withAdapter(H,v,async q=>{const ee=await q.provideLinkedEditingRanges(s.URI.revive(G),X,oe);if(ee)return{ranges:ee.ranges,wordPattern:ee.wordPattern?Ve._serializeRegExp(ee.wordPattern):void 0}},void 0)}registerReferenceProvider(H,G,X){const oe=this._addNewAdapter(new a(this._documents,X),H);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideReferences(H,G,X,oe,q){return this._withAdapter(H,a,ee=>ee.provideReferences(s.URI.revive(G),X,oe,q),void 0)}registerCodeActionProvider(H,G,X,oe){const q=new i.DisposableStore,ee=this._addNewAdapter(new S(this._documents,this._commands.converter,this._diagnostics,X,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(ee,this._transformDocumentSelector(G),{providedKinds:oe?.providedCodeActionKinds?.map(he=>he.value),documentation:oe?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,q)}))},Ve._extLabel(H),Boolean(X.resolveCodeAction)),q.add(this._createDisposable(ee)),q}$provideCodeActions(H,G,X,oe,q){return this._withAdapter(H,S,ee=>ee.provideCodeActions(s.URI.revive(G),X,oe,q),void 0)}$resolveCodeAction(H,G,X){return this._withAdapter(H,S,oe=>oe.resolveCodeAction(G,X),void 0)}$releaseCodeActions(H,G){this._withAdapter(H,S,X=>Promise.resolve(X.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(H,G,X){const oe=this._addNewAdapter(new I(this._documents,X),H);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(G),H.identifier,H.displayName||H.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(H,G,X,oe){return this._withAdapter(H,I,q=>q.provideDocumentFormattingEdits(s.URI.revive(G),X,oe),void 0)}registerDocumentRangeFormattingEditProvider(H,G,X){const oe=this._addNewAdapter(new N(this._documents,X),H);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(G),H.identifier,H.displayName||H.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(H,G,X,oe,q){return this._withAdapter(H,N,ee=>ee.provideDocumentRangeFormattingEdits(s.URI.revive(G),X,oe,q),void 0)}registerOnTypeFormattingEditProvider(H,G,X,oe){const q=this._addNewAdapter(new B(this._documents,X),H);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(G),oe,H.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(H,G,X,oe,q,ee){return this._withAdapter(H,B,he=>he.provideOnTypeFormattingEdits(s.URI.revive(G),X,oe,q,ee),void 0)}registerWorkspaceSymbolProvider(H,G){const X=this._addNewAdapter(new E(G,this._logService),H);return this._proxy.$registerNavigateTypeSupport(X,typeof G.resolveWorkspaceSymbol=="function"),this._createDisposable(X)}$provideWorkspaceSymbols(H,G,X){return this._withAdapter(H,E,oe=>oe.provideWorkspaceSymbols(G,X),{symbols:[]})}$resolveWorkspaceSymbol(H,G,X){return this._withAdapter(H,E,oe=>oe.resolveWorkspaceSymbol(G,X),void 0)}$releaseWorkspaceSymbols(H,G){this._withAdapter(H,E,X=>X.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(H,G,X){const oe=this._addNewAdapter(new O(this._documents,X,this._logService),H);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(G),O.supportsResolving(X)),this._createDisposable(oe)}$provideRenameEdits(H,G,X,oe,q){return this._withAdapter(H,O,ee=>ee.provideRenameEdits(s.URI.revive(G),X,oe,q),void 0)}$resolveRenameLocation(H,G,X,oe){return this._withAdapter(H,O,q=>q.resolveRenameLocation(s.URI.revive(G),X,oe),void 0)}registerDocumentSemanticTokensProvider(H,G,X,oe){const q=this._nextHandle(),ee=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new $e(new U(this._documents,X),H)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(G),oe,ee);let he=this._createDisposable(q);if(ee){const Re=X.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(ee));he=T.Disposable.from(he,Re)}return he}$provideDocumentSemanticTokens(H,G,X,oe){return this._withAdapter(H,U,q=>q.provideDocumentSemanticTokens(s.URI.revive(G),X,oe),null,!0)}$releaseDocumentSemanticTokens(H,G){this._withAdapter(H,U,X=>X.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(H,G,X,oe){const q=this._addNewAdapter(new $(this._documents,X),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(G),oe),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(H,G,X,oe){return this._withAdapter(H,$,q=>q.provideDocumentRangeSemanticTokens(s.URI.revive(G),X,oe),null,!0)}registerCompletionItemProvider(H,G,X,oe){const q=this._addNewAdapter(new V(this._documents,this._commands.converter,X,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(G),oe,V.supportsResolving(X),`${H.identifier.value}(${oe.join("")})`),this._createDisposable(q)}$provideCompletionItems(H,G,X,oe,q){return this._withAdapter(H,V,ee=>ee.provideCompletionItems(s.URI.revive(G),X,oe,q),void 0)}$resolveCompletionItem(H,G,X){return this._withAdapter(H,V,oe=>oe.resolveCompletionItem(G,X),void 0)}$releaseCompletionItems(H,G){this._withAdapter(H,V,X=>X.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider(H,G,X){const oe=this._addNewAdapter(new ue(this._documents,X,this._commands.converter),H);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideInlineCompletions(H,G,X,oe,q){return this._withAdapter(H,ue,ee=>ee.provideInlineCompletions(s.URI.revive(G),X,oe,q),void 0)}$handleInlineCompletionDidShow(H,G,X){this._withAdapter(H,ue,async oe=>{oe.handleDidShowCompletionItem(G,X)},void 0)}$freeInlineCompletionsList(H,G){this._withAdapter(H,ue,async X=>{X.disposeCompletions(G)},void 0)}registerSignatureHelpProvider(H,G,X,oe){const q=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ee=this._addNewAdapter(new re(this._documents,X),H);return this._proxy.$registerSignatureHelpProvider(ee,this._transformDocumentSelector(G),q),this._createDisposable(ee)}$provideSignatureHelp(H,G,X,oe,q){return this._withAdapter(H,re,ee=>ee.provideSignatureHelp(s.URI.revive(G),X,oe,q),void 0)}$releaseSignatureHelp(H,G){this._withAdapter(H,re,X=>X.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider(H,G,X){const oe=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new pe(this._documents,X),H);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(G),oe);let ee=this._createDisposable(q);if(oe!==void 0){const he=X.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(oe));ee=T.Disposable.from(ee,he)}return ee}$provideInlayHints(H,G,X,oe){return this._withAdapter(H,pe,q=>q.provideInlayHints(s.URI.revive(G),X,oe),void 0)}registerDocumentLinkProvider(H,G,X){const oe=this._addNewAdapter(new we(this._documents,X),H);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(G),typeof X.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(H,G,X){return this._withAdapter(H,we,oe=>oe.provideLinks(s.URI.revive(G),X),void 0)}$resolveDocumentLink(H,G,X){return this._withAdapter(H,we,oe=>oe.resolveLink(G,X),void 0)}$releaseDocumentLinks(H,G){this._withAdapter(H,we,X=>X.releaseLinks(G),void 0)}registerColorProvider(H,G,X){const oe=this._addNewAdapter(new ae(this._documents,X),H);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDocumentColors(H,G,X){return this._withAdapter(H,ae,oe=>oe.provideColors(s.URI.revive(G),X),[])}$provideColorPresentations(H,G,X,oe){return this._withAdapter(H,ae,q=>q.provideColorPresentations(s.URI.revive(G),X,oe),void 0)}registerFoldingRangeProvider(H,G,X){const oe=this._nextHandle(),q=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new $e(new le(this._documents,X),H)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(G),q);let ee=this._createDisposable(oe);if(q!==void 0){const he=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));ee=T.Disposable.from(ee,he)}return ee}$provideFoldingRanges(H,G,X,oe){return this._withAdapter(H,le,q=>q.provideFoldingRanges(s.URI.revive(G),X,oe),void 0)}registerSelectionRangeProvider(H,G,X){const oe=this._addNewAdapter(new Ce(this._documents,X,this._logService),H);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideSelectionRanges(H,G,X,oe){return this._withAdapter(H,Ce,q=>q.provideSelectionRanges(s.URI.revive(G),X,oe),[])}registerCallHierarchyProvider(H,G,X){const oe=this._addNewAdapter(new Ee(this._documents,X),H);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$prepareCallHierarchy(H,G,X,oe){return this._withAdapter(H,Ee,q=>Promise.resolve(q.prepareSession(s.URI.revive(G),X,oe)),void 0)}$provideCallHierarchyIncomingCalls(H,G,X,oe){return this._withAdapter(H,Ee,q=>q.provideCallsTo(G,X,oe),void 0)}$provideCallHierarchyOutgoingCalls(H,G,X,oe){return this._withAdapter(H,Ee,q=>q.provideCallsFrom(G,X,oe),void 0)}$releaseCallHierarchy(H,G){this._withAdapter(H,Ee,X=>Promise.resolve(X.releaseSession(G)),void 0)}registerTypeHierarchyProvider(H,G,X){const oe=this._addNewAdapter(new Fe(this._documents,X),H);return this._proxy.$registerTypeHierarchyProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$prepareTypeHierarchy(H,G,X,oe){return this._withAdapter(H,Fe,q=>Promise.resolve(q.prepareSession(s.URI.revive(G),X,oe)),void 0)}$provideTypeHierarchySupertypes(H,G,X,oe){return this._withAdapter(H,Fe,q=>q.provideSupertypes(G,X,oe),void 0)}$provideTypeHierarchySubtypes(H,G,X,oe){return this._withAdapter(H,Fe,q=>q.provideSubtypes(G,X,oe),void 0)}$releaseTypeHierarchy(H,G){this._withAdapter(H,Fe,X=>Promise.resolve(X.releaseSession(G)),void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,P.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:Ve._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:Ve._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?Ve._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?Ve._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:Ve._serializeRegExp(H.beforeText),afterText:H.afterText?Ve._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?Ve._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(Ve._serializeOnEnterRule)}setLanguageConfiguration(H,G,X){let{wordPattern:oe}=X;if(oe&&(0,P.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(G,oe):this._documents.setWordDefinitionFor(G,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const q=this._nextHandle(),ee={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ve._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?Ve._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ve._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,G,ee),this._createDisposable(q)}$setWordDefinitions(H){for(const G of H)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Ve,Ve._handlePool=0}),define(ye[189],_e([0,1,5,8,7,34,14,6]),function(Z,e,s,t,y,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(R,w,i,p){this._documents=w,this._commands=i,this._uriTransformer=p,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(s.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,w){await this._proxy.$changeLanguage(R,w);const i=this._documents.getDocumentData(R);if(!i)throw new Error(`document '${R.toString}' NOT found`);return i.document}async tokenAtPosition(R,w){const i=R.version,p=t.Position.from(w),o=await this._proxy.$tokensAtPosition(R.uri,p),u={type:y.StandardTokenType.Other,range:R.getWordRangeAtPosition(w)??new y.Range(w.line,w.character,w.line,w.character)};if(!o)return u;const d={range:t.Range.to(o.range),type:t.TokenType.to(o.type)};return!d.range.contains(w)||i!==R.version?u:d}createLanguageStatusItem(R,w,i){const p=this._handlePool++,o=this._proxy,u=this._ids,d=`${R.identifier.value}/${w}`;if(u.has(d))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);u.add(d);const F={selector:i,id:w,name:R.displayName??R.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let _,m=new P.DisposableStore;const f=()=>{_?.dispose(),_=(0,k.disposableTimeout)(()=>{m.clear(),this._proxy.$setLanguageStatus(p,{id:d,name:F.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(F.selector,this._uriTransformer),label:F.text,detail:F.detail??"",severity:F.severity===y.LanguageStatusSeverity.Error?T.default.Error:F.severity===y.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:F.command&&this._commands.toInternal(F.command,m),accessibilityInfo:F.accessibilityInformation,busy:F.busy})},0)},D={dispose(){m.dispose(),_?.dispose(),o.$removeLanguageStatus(p),u.delete(d)},get id(){return F.id},get name(){return F.name},set name(l){F.name=l,f()},get selector(){return F.selector},set selector(l){F.selector=l,f()},get text(){return F.text},set text(l){F.text=l,f()},get detail(){return F.detail},set detail(l){F.detail=l,f()},get severity(){return F.severity},set severity(l){F.severity=l,f()},get accessibilityInformation(){return F.accessibilityInformation},set accessibilityInformation(l){F.accessibilityInformation=l,f()},get command(){return F.command},set command(l){F.command=l,f()},get busy(){return F.busy},set busy(l){F.busy=l,f()}};return f(),D}}e.ExtHostLanguages=C}),define(ye[190],_e([0,1,12,5,28,13,4]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends s.AbstractLoggerService{constructor(R,w){const i=new k.Emitter;super(w.logLevel,i.event);this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(i)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,w,i){return new C(this._proxy,R,w,i)}};P=Be([He(0,T.IExtHostRpcService),He(1,y.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class C extends s.AbstractMessageLogger{constructor(R,w,i,p){super(p?.always);this.proxy=R,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(i),this.proxy.$createLogger(w,p).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,w){const i=[[R,w]];this.isLoggerCreated?this.doLog(i):this.buffer.push(...i)}doLog(R){this.proxy.$log(this.file,R)}}}),define(ye[191],_e([0,1,5,12,27]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(P){return P&&P.title}let k=class{constructor(C,A){this._logService=A,this._proxy=C.getProxy(s.MainContext.MainThreadMessageService)}showMessage(C,A,R,w,i){const p={extension:C};let o;typeof w=="string"||T(w)?o=[w,...i]:(p.modal=w?.modal,p.useCustom=w?.useCustom,p.detail=w?.detail,o=i),p.useCustom&&(0,y.checkProposedApiEnabled)(C,"resolvers");const u=[];for(let d=0;d<o.length;d++){const F=o[d];if(typeof F=="string")u.push({title:F,handle:d,isCloseAffordance:!1});else if(typeof F=="object"){let{title:_,isCloseAffordance:m}=F;u.push({title:_,isCloseAffordance:!!m,handle:d})}else this._logService.warn("Invalid message item:",F)}return this._proxy.$showMessage(A,R,p,u).then(d=>{if(typeof d=="number")return o[d]})}};k=Be([He(1,t.ILogService)],k),e.ExtHostMessageService=k}),define(ye[192],_e([0,1,22,4,57,6,21,9,10,2,63,5,8,7,38,166,91]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class F{constructor(m,f,D,l,M){this._textDocumentsAndEditors=D,this._textDocuments=l,this._extensionStoragePaths=M,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=m.getProxy(w.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(w.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(w.MainContext.MainThreadNotebookEditors),this._commandsConverter=f.converter,f.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const n=r.notebookEditor?.notebookUri,b=r.cell.handle,c=this._documents.get(n)?.getCell(b);if(c)return c.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.apiEditor)}getEditorById(m){const f=this._editors.get(m);if(!f)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);return f}getIdByEditor(m){for(const[f,D]of this._editors)if(D.apiEditor===m)return f}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(m,f){const D=this._documents.get(m);if(!D&&!f)throw new Error(`NO notebook document for '${m}'`);return D}_getProviderData(m){const f=this._notebookContentProviders.get(m);if(!f)throw new Error(`NO provider for '${m}'`);return f}registerNotebookContentProvider(m,f,D,l,M){if((0,P.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(f))throw new Error(`Notebook provider for '${f}' already registered`);this._notebookContentProviders.set(f,{extension:m,provider:D});let r;return D.onDidChangeNotebookContentOptions&&(r=D.onDidChangeNotebookContentOptions(()=>{const n=i.NotebookDocumentContentOptions.from(D.options);this._notebookProxy.$updateNotebookProviderOptions(f,n)})),this._notebookProxy.$registerNotebookProvider({id:m.identifier,location:m.extensionLocation},f,i.NotebookDocumentContentOptions.from(l),F._convertNotebookRegistrationData(m,M)),new p.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(f),this._notebookProxy.$unregisterNotebookProvider(f)})}static _convertNotebookRegistrationData(m,f){if(!f)return;const D=f.filenamePattern.map(l=>i.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(f.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:f.displayName,filenamePattern:D,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,f,D){const l=F._notebookStatusBarItemProviderHandlePool++,M=typeof D.onDidChangeCellStatusBarItems=="function"?F._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,D),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,M,f);let r;return M!==void 0&&(r=D.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(M))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,M),r&&r.dispose()})}async createNotebookDocument(m){const f=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:m.viewType,content:m.content&&i.NotebookData.from(m.content)});return A.URI.revive(f)}async openNotebookDocument(m){const f=this._documents.get(m);if(f)return f.apiNotebook;const D=await this._notebookDocumentsProxy.$tryOpenNotebook(m),l=this._documents.get(A.URI.revive(D));return(0,C.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(m,f){A.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let D;typeof f=="object"?D={position:i.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(i.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:D={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.notebookType,D),M=l&&this._editors.get(l)?.apiEditor;if(M)return M;throw l?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,f,D,l){const M=this._notebookStatusBarItemProviders.get(m),r=A.URI.revive(f),n=this._documents.get(r);if(!n||!M)return;const b=n.getCellFromIndex(D);if(!b)return;const g=await M.provideCellStatusBarItems(b.apiCell,l);if(!g)return;const c=new T.DisposableStore,h=this._statusBarCache.add([c]),a=(Array.isArray(g)?g:[g]).map(S=>i.NotebookStatusBarItem.from(S,this._commandsConverter,c));return{cacheId:h,items:a}}$releaseNotebookCellStatusBarItems(m){this._statusBarCache.delete(m)}registerNotebookSerializer(m,f,D,l,M){if((0,P.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,D),this._notebookProxy.$registerNotebookSerializer(r,{id:m.identifier,location:m.extensionLocation},f,i.NotebookDocumentContentOptions.from(l),F._convertNotebookRegistrationData(m,M)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(m,f,D){const l=this._notebookSerializer.get(m);if(!l)throw new Error("NO serializer found");const M=await l.deserializeNotebook(f.buffer,D);return new o.SerializableObjectWithBuffers(i.NotebookData.from(M))}async $notebookToData(m,f,D){const l=this._notebookSerializer.get(m);if(!l)throw new Error("NO serializer found");const M=await l.serializeNotebook(i.NotebookData.to(f.value),D);return s.VSBuffer.wrap(M)}async $openNotebook(m,f,D,l,M){const{provider:r}=this._getProviderData(m),n=await r.openNotebook(A.URI.revive(f),{backupId:D,untitledDocumentData:l?.buffer},M);return new o.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(i.NotebookCellData.from)})}async $saveNotebook(m,f,D){const l=this.getNotebookDocument(A.URI.revive(f)),{provider:M}=this._getProviderData(m);return await M.saveNotebook(l.apiNotebook,D),!0}async $saveNotebookAs(m,f,D,l){const M=this.getNotebookDocument(A.URI.revive(f)),{provider:r}=this._getProviderData(m);return await r.saveNotebookAs(A.URI.revive(D),M.apiNotebook,l),!0}async $backupNotebook(m,f,D){const l=this.getNotebookDocument(A.URI.revive(f)),M=this._getProviderData(m),r=this._extensionStoragePaths.workspaceValue(M.extension)??this._extensionStoragePaths.globalValue(M.extension),n=String((0,y.hash)([l.uri.toString(),this._backupIdPool++])),b=A.URI.joinPath(r,n),g=await M.provider.backupNotebook(l.apiNotebook,{destination:b},D);return l.updateBackup(g),g.id}_createExtHostEditor(m,f,D){if(this._editors.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const l=new d.ExtHostNotebookEditor(f,this._notebookEditorsProxy,m,D.visibleRanges.map(i.NotebookRange.to),D.selections.map(i.NotebookRange.to),typeof D.viewColumn=="number"?i.ViewColumn.to(D.viewColumn):void 0);this._editors.set(f,l)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const D of m.value.removedDocuments){const l=A.URI.revive(D),M=this._documents.get(l);M&&(M.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:M.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(M.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===l.toString()&&this._editors.delete(r.id)}if(m.value.addedDocuments){const D=[];for(const l of m.value.addedDocuments){const M=A.URI.revive(l.uri);if(this._documents.has(M))throw new Error(`adding EXISTING notebook ${M} `);const r=this,n=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(b){r._onDidChangeNotebookCells.fire(b)},emitCellOutputsChange(b){r._onDidChangeCellOutputs.fire(b)},emitCellMetadataChange(b){r._onDidChangeCellMetadata.fire(b)}},M,l);D.push(...l.cells.map(b=>u.ExtHostCell.asModelAddData(n.apiNotebook,b))),this._documents.get(M)?.dispose(),this._documents.set(M,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(m.value.addedEditors)for(const D of m.value.addedEditors){if(this._editors.has(D.id))return;const l=A.URI.revive(D.documentUri),M=this._documents.get(l);M&&this._createExtHostEditor(M,D.id,D)}const f=[];if(m.value.removedEditors)for(const D of m.value.removedEditors){const l=this._editors.get(D);l&&(this._editors.delete(D),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),f.push(l))}if(m.value.visibleEditors){this._visibleNotebookEditors=m.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const D=new Set;this._visibleNotebookEditors.forEach(l=>D.add(l.id));for(const l of this._editors.values()){const M=D.has(l.id);l._acceptVisibility(M)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this._activeNotebookEditor=void 0:m.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=F,F._notebookStatusBarItemProviderHandlePool=0}),define(ye[193],_e([0,1,4,54,12,5,13,8]),function(Z,e,s,t,y,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(w,i){const p=C._Keys.nextId();w.$registerNotebookEditorDecorationType(p,P.NotebookDecorationRenderOptions.from(i)),this.value={key:p,dispose(){w.$removeNotebookEditorDecorationType(p)}}}}C._Keys=new t.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(w,i,p){this._logService=w,this._extHostRpc=i,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new s.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new s.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(w){return new C(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),w).value}$acceptEditorPropertiesChanged(w,i){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,i);const p=this._notebooksAndEditors.getEditorById(w);i.visibleRanges&&p._acceptVisibleRanges(i.visibleRanges.ranges.map(P.NotebookRange.to)),i.selections&&p._acceptSelections(i.selections.selections.map(P.NotebookRange.to)),i.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.apiEditor,visibleRanges:p.apiEditor.visibleRanges}),i.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.apiEditor,selections:p.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const i in w)this._notebooksAndEditors.getEditorById(i)._acceptViewColumn(P.ViewColumn.to(w[i]))}};A=Be([He(0,y.ILogService),He(1,k.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(ye[194],_e([0,1,16,14,20,4,6,21,2,25,12,5,39,8,7,66,158,27,38]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let m=class{constructor(r,n,b,g,c){this._initData=n,this._extHostNotebook=b,this._commands=g,this._logService=c,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=r.getProxy(w.MainContext.MainThreadNotebookKernels);const h=new i.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new i.ApiCommandArgument("options","Select kernel options",v=>!0,v=>{if(v&&"notebookEditor"in v&&"id"in v){const a=this._extHostNotebook.getIdByEditor(v.notebookEditor);return{id:v.id,extension:v.extension,notebookEditorId:a}}else if(v&&"notebookEditor"in v){const a=this._extHostNotebook.getIdByEditor(v.notebookEditor);if(a===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${v.notebookEditor.document.uri.toString()}`);return{notebookEditorId:a}}return v})],i.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(r,n,b,g,c,h){for(const re of this._kernelData.values())if(re.controller.id===n&&A.ExtensionIdentifier.equals(r.identifier,re.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const v=this._handlePool++,a=this;this._logService.trace(`NotebookController[${v}], CREATED by ${r.identifier.value}, ${n}`);const S=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${r.identifier}'`);let I=!1;const N=new k.DisposableStore,B=new T.Emitter,E=new T.Emitter,O={id:`${r.identifier.value}/${n}`,notebookType:b,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:g||r.identifier.value,preloads:h?h.map(p.NotebookRendererScript.from):[]};let z=c??S,U;this._proxy.$addKernel(v,O).catch(re=>{console.log(re),I=!0});let $=0;const V=()=>{if(I)return;const re=++$;Promise.resolve().then(()=>{re===$&&this._proxy.$updateKernel(v,O)})},ue=new P.ResourceMap,K={get id(){return n},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return O.label},set label(re){O.label=re??r.displayName??r.name,V()},get detail(){return O.detail??""},set detail(re){O.detail=re,V()},get description(){return O.description??""},set description(re){O.description=re,V()},get kind(){return(0,F.checkProposedApiEnabled)(r,"notebookControllerKind"),O.kind??""},set kind(re){(0,F.checkProposedApiEnabled)(r,"notebookControllerKind"),O.kind=re,V()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(re){O.supportedLanguages=re,V()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(re){O.supportsExecutionOrder=re,V()},get rendererScripts(){return O.preloads?O.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(re){z=re??S},get interruptHandler(){return U},set interruptHandler(re){U=re,O.supportsInterrupt=Boolean(re),V()},createNotebookCellExecution(re){if(I)throw new Error("notebook controller is DISPOSED");if(!ue.has(re.notebook.uri))throw a._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(pe=>pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return a._createNotebookCellExecution(re)},dispose:()=>{I||(this._logService.trace(`NotebookController[${v}], DISPOSED`),I=!0,this._kernelData.delete(v),N.dispose(),B.dispose(),E.dispose(),this._proxy.$removeKernel(v))},updateNotebookAffinity(re,pe){a._proxy.$updateNotebookPriority(v,re.uri,pe)},onDidReceiveMessage:E.event,postMessage(re,pe){return(0,F.checkProposedApiEnabled)(r,"notebookMessaging"),a._proxy.$postMessage(v,pe&&a._extHostNotebook.getIdByEditor(pe),re)},asWebviewUri(re){return(0,F.checkProposedApiEnabled)(r,"notebookMessaging"),(0,u.asWebviewUri)(re,a._initData.remote)}};return this._kernelData.set(v,{extensionId:r.identifier,controller:K,onDidReceiveMessage:E,onDidChangeSelection:B,associatedNotebooks:ue}),K}$acceptNotebookAssociation(r,n,b){const g=this._kernelData.get(r);if(g){const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(n));b?g.associatedNotebooks.set(c.uri,!0):g.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,c.uri.toString(),b),g.onDidChangeSelection.fire({selected:b,notebook:c.apiNotebook})}}async $executeCells(r,n,b){const g=this._kernelData.get(r);if(!g)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(n)),h=[];for(const v of b){const a=c.getCell(v);a&&h.push(a.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,c.uri.toString(),h.length),await g.controller.executeHandler.call(g.controller,h,c.apiNotebook,g.controller)}catch(v){this._logService.error(`NotebookController[${r}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(r,n,b){const g=this._kernelData.get(r);if(!g)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(n));if(g.controller.interruptHandler)await g.controller.interruptHandler.call(g.controller,c.apiNotebook);else for(const h of b){const v=c.getCell(h);v&&this._activeExecutions.get(v.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,n,b){const g=this._kernelData.get(r);if(!g)return;const c=this._extHostNotebook.getEditorById(n);g.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:b}))}$cellExecutionChanged(r,n,b){const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(r)).getCell(n);c&&this._onDidChangeCellExecutionState.fire({cell:c.apiCell,state:b??o.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const b=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!b)throw new Error("invalid cell");if(this._activeExecutions.has(b.uri))throw new Error(`duplicate execution for ${b.uri}`);const g=new D(b.notebook,b,this._proxy);this._activeExecutions.set(b.uri,g);const c=g.onDidChangeState(()=>{g.state===f.Resolved&&(g.dispose(),c.dispose(),this._activeExecutions.delete(b.uri))});return g.asApiObject()}};m=Be([He(4,R.ILogService)],m),e.ExtHostNotebookKernels=m;var f;(function(M){M[M.Init=0]="Init",M[M.Started=1]="Started",M[M.Resolved=2]="Resolved"})(f||(f={}));class D extends k.Disposable{constructor(r,n,b){super();this._document=r,this._cell=n,this._proxy=b,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=f.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new l(10,g=>this.update(g)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$addExecution(this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const n=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new _.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===f.Init)throw new Error("Must call start before modifying cell output");if(this._state===f.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let n=this._cell;if(r&&(n=this._document.getCellFromApiCell(r)),!n)throw new Error("INVALID cell");return n.handle}validateAndConvertOutputs(r){return r.map(n=>{const b=o.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return b===n.items?p.NotebookCellOutput.from(n):p.NotebookCellOutput.from({items:b,id:n.id,metadata:n.metadata})})}async updateOutputs(r,n,b){const g=this.cellIndexToHandle(n),c=this.validateAndConvertOutputs((0,s.asArray)(r));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,uri:this._document.uri,cellHandle:g,append:b,outputs:c})}async updateOutputItems(r,n,b){return r=o.NotebookCellOutput.ensureUniqueMimeTypes((0,s.asArray)(r),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,uri:this._document.uri,cellHandle:this._cell.handle,items:r.map(p.NotebookCellOutputItem.from),outputId:n.id,append:b})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(b){r._executionOrder=b,r.update([{editType:d.CellExecutionUpdateType.ExecutionState,uri:r._document.uri,cellHandle:r._cell.handle,executionOrder:r._executionOrder}])},start(b){if(r._state===f.Resolved||r._state===f.Started)throw new Error("Cannot call start again");r._state=f.Started,r._onDidChangeState.fire(),r.update({editType:d.CellExecutionUpdateType.ExecutionState,uri:r._document.uri,cellHandle:r._cell.handle,runStartTime:b})},end(b,g){if(r._state===f.Resolved)throw new Error("Cannot call resolve twice");r._state=f.Resolved,r._onDidChangeState.fire(),r._collector.flush(),r._proxy.$completeExecution(r._document.uri,r._cell.handle,new _.SerializableObjectWithBuffers({uri:r._document.uri,cellHandle:r._cell.handle,runEndTime:g,lastRunSuccess:b}))},clearOutput(b){return r.verifyStateForOutput(),r.updateOutputs([],b,!1)},appendOutput(b,g){return r.verifyStateForOutput(),r.updateOutputs(b,g,!0)},replaceOutput(b,g){return r.verifyStateForOutput(),r.updateOutputs(b,g,!1)},appendOutputItems(b,g){return r.verifyStateForOutput(),r.updateOutputItems(b,g,!0)},replaceOutputItems(b,g){return r.verifyStateForOutput(),r.updateOutputItems(b,g,!1)}})}}class l{constructor(r,n){this.delay=r,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>r.complete())}}}),define(ye[195],_e([0,1,4,5,91,27]),function(Z,e,s,t,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(C,A){this._extHostNotebook=A,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,A,R){const w=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(A)?.fire({editor:w.apiEditor,message:R})}createRendererMessaging(C,A){if(!C.contributes?.notebookRenderer?.some(p=>p.id===A))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${A})`);const R=(0,T.isProposedApiEnabled)(C,"notebookEditor"),w=new WeakMap;return{onDidReceiveMessage:(p,o,u)=>{const d=R?p:F=>{const _={};w.set(_,F.editor),p({editor:_,message:F.message})};return this.getOrCreateEmitterFor(A).event(d,o,u)},postMessage:(p,o)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(p)&&([p,o]=[o,p]);const u=R?o:w.get(o),d=u&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(d?.id,A,p)}}}getOrCreateEmitterFor(C){let A=this._rendererMessageEmitters.get(C);return A||(A=new s.Emitter({onLastListenerRemove:()=>{A?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,A),A)}}e.ExtHostNotebookRenderers=k}),define(ye[94],_e([0,1,5,6,3,13,12,159,50,28,30,109,22]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class p extends t.Disposable{constructor(d,F,_,m){super();this.id=d,this.name=F,this.logger=_,this.proxy=m,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(d){this.append(d+`
`)}append(d){this.write(d),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const d=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,d)}replace(d){const F=this.offset;this.write(d),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,F),this.visible&&this.logger.flush()}show(d,F){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof d=="boolean"?d:F))}hide(){this.proxy.$close(this.id)}write(d){this.offset+=i.VSBuffer.fromString(d).byteLength,this.logger.info(d)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=p;let o=class{constructor(d,F,_,m,f){this.extHostFileSystem=_,this.extHostFileSystemInfo=m,this.loggerService=f,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=d.getProxy(s.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(F.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.visibleChannelId=d;for(const[F,_]of this.channels)_.visible=F===this.visibleChannelId}createOutputChannel(d,F){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const _=this.doCreateOutputChannel(d,F);return _.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(d,_)}async doCreateOutputChannel(d,F){const _=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(_,`${this.namePool++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),D=await this.proxy.$register(d,!1,m,F.identifier.value);return new p(D,d,f,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(d,F){let _=!1;const m=()=>{if(_)throw new Error("Channel has been closed")};return{get name(){return d},append(f){m(),F.then(D=>D.append(f))},appendLine(f){m(),F.then(D=>D.appendLine(f))},clear(){m(),F.then(f=>f.clear())},replace(f){m(),F.then(D=>D.replace(f))},show(f,D){m(),F.then(l=>l.show(f,D))},hide(){m(),F.then(f=>f.hide())},dispose(){_=!0,F.then(f=>f.dispose())}}}};o=Be([He(0,T.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,C.IExtHostConsumerFileSystem),He(3,R.IExtHostFileSystemInfo),He(4,k.ILoggerService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(ye[196],_e([0,1,14,20,4,6,5,2,7,15,16,34,62,27]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(u,d,F){const _=u.getProxy(k.MainContext.MainThreadQuickOpen);class m{constructor(c,h){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=h}showQuickPick(c,h,v=t.CancellationToken.None){this._onDidSelectItem=void 0;const a=Promise.resolve(c),S=++this._instances,I=_.$show(S,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},v),N={},B=I.then(()=>N);return Promise.race([B,a]).then(E=>{if(E!==N)return a.then(O=>{const z=[];for(let U=0;U<O.length;U++){const $=O[U];typeof $=="string"?z.push({label:$,handle:U}):$.kind===C.QuickPickItemKind.Separator?z.push({type:"separator",label:$.label}):z.push({label:$.label,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,handle:U})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{h.onDidSelectItem(O[U])}),_.$setItems(S,z),I.then(U=>{if(typeof U=="number")return O[U];if(Array.isArray(U))return U.map($=>O[$])})})}).then(void 0,E=>{if(!(0,A.isPromiseCanceledError)(E))return _.$setError(S,E),Promise.reject(E)})}$onItemSelected(c){this._onDidSelectItem&&this._onDidSelectItem(c)}showInput(c,h=t.CancellationToken.None){return this._validateInput=c?c.validateInput:void 0,_.$input(c,typeof this._validateInput=="function",h).then(void 0,v=>{if(!(0,A.isPromiseCanceledError)(v))return Promise.reject(v)})}$validateInput(c){return this._validateInput?(0,s.asPromise)(()=>this._validateInput(c)):Promise.resolve(void 0)}async showWorkspaceFolderPick(c,h=t.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!v)return;const a=await this._workspace.getWorkspaceFolders2();if(!!a)return a.find(S=>S.uri.toString()===v.uri.toString())}createQuickPick(c){const h=new n(c,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(c){const h=new b(c,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(c,h){const v=this._sessions.get(c);v&&v._fireDidChangeValue(h)}$onDidAccept(c){const h=this._sessions.get(c);h&&h._fireDidAccept()}$onDidChangeActive(c,h){const v=this._sessions.get(c);v instanceof n&&v._fireDidChangeActive(h)}$onDidChangeSelection(c,h){const v=this._sessions.get(c);v instanceof n&&v._fireDidChangeSelection(h)}$onDidTriggerButton(c,h){const v=this._sessions.get(c);v&&v._fireDidTriggerButton(h)}$onDidTriggerItemButton(c,h,v){const a=this._sessions.get(c);a instanceof n&&a._fireDidTriggerItemButton(h,v)}$onDidHide(c){const h=this._sessions.get(c);h&&h._fireDidHide()}}class f{constructor(c,h){this._extensionId=c,this._onDidDispose=h,this._id=n._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((h,v)=>{const a=h===C.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(a,h)}),this.update({buttons:c.map((h,v)=>({...r(h),tooltip:h.tooltip,handle:h===C.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const h=this._handlesToButtons.get(c);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(c){if(!this._disposed){for(const h of Object.keys(c)){const v=c[h];this._pendingUpdate[h]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}f._nextId=1;function D(g){if(g instanceof C.ThemeIcon)return{id:g.id};const c=M(g),h=l(g);return{dark:typeof c=="string"?P.URI.file(c):c,light:typeof h=="string"?P.URI.file(h):h}}function l(g){return typeof g=="object"&&"light"in g?g.light:g}function M(g){return typeof g=="object"&&"dark"in g?g.dark:g}function r(g){const c=D(g.iconPath);let h,v;return"id"in c?v=i.ThemeIcon.asClassName(c):h=c,{iconPath:h,iconClass:v}}class n extends f{constructor(c,h){super(c.identifier,h);this.extension=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){c.some(v=>v.kind!==void 0)&&(0,p.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((v,a)=>{this._handlesToItems.set(a,v),this._itemsToHandles.set(v,a)});const h=[];for(let v=0;v<c.length;v++){const a=c[v];a.kind===C.QuickPickItemKind.Separator?h.push({type:"separator",label:a.label}):h.push({handle:v,label:a.label,description:a.description,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow,buttons:a.buttons?.map((S,I)=>({...r(S),tooltip:S.tooltip,handle:I}))})}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(c){const h=(0,R.coalesce)(c.map(v=>this._handlesToItems.get(v)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(c){const h=(0,R.coalesce)(c.map(v=>this._handlesToItems.get(v)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(c,h){const v=this._handlesToItems.get(c);if(!v||!v.buttons||!v.buttons.length)return;const a=v.buttons[h];a&&this._onDidTriggerItemButtonEmitter.fire({button:a,item:v})}}class b extends f{constructor(c,h){super(c,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,this.update({validationMessage:c,severity:c?w.default.Error:w.default.Ignore})}}return new m(d,F)}e.createExtHostQuickOpen=o});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!y:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(Z,s):y?y.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[197],_e([0,1,2,4,53,6,14,5,16,104,12,25,62,8,27]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o){"use strict";var u,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function F(h){if(h)return typeof h.iconPath=="string"?s.URI.file(h.iconPath):s.URI.isUri(h.iconPath)||i.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function _(h,v){if(!h.iconPath&&!v.iconPath)return 0;if(h.iconPath){if(!v.iconPath)return 1}else return-1;const a=typeof h.iconPath=="string"?h.iconPath:s.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,S=typeof v.iconPath=="string"?v.iconPath:s.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,A.comparePaths)(a,S)}function m(h,v){let a=0;if(h.strikeThrough!==v.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==v.faded)return h.faded?1:-1;if(h.tooltip!==v.tooltip)return(h.tooltip||"").localeCompare(v.tooltip||"");if(a=_(h,v),a!==0)return a;if(h.light&&v.light)a=_(h.light,v.light);else{if(h.light)return 1;if(v.light)return-1}if(a!==0)return a;if(h.dark&&v.dark)a=_(h.dark,v.dark);else{if(h.dark)return 1;if(v.dark)return-1}return a}function f(h,v){if(h.command!==v.command)return h.command<v.command?-1:1;if(h.title!==v.title)return h.title<v.title?-1:1;if(h.tooltip!==v.tooltip){if(h.tooltip!==void 0&&v.tooltip!==void 0)return h.tooltip<v.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(h.arguments===v.arguments)return 0;if(h.arguments)if(v.arguments){if(h.arguments.length!==v.arguments.length)return h.arguments.length-v.arguments.length}else return 1;else return-1;for(let a=0;a<h.arguments.length;a++){const S=h.arguments[a],I=v.arguments[a];if(S!==I)return S<I?-1:1}return 0}function D(h,v){let a=(0,A.comparePaths)(h.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(a!==0)return a;if(h.command&&v.command)a=f(h.command,v.command);else{if(h.command)return 1;if(v.command)return-1}if(a!==0)return a;if(h.decorations&&v.decorations)a=m(h.decorations,v.decorations);else{if(h.decorations)return 1;if(v.decorations)return-1}return a}function l(h,v){for(let a=0;a<h.length;a++)if(h[a]!==v[a])return!1;return!0}function M(h,v){return h.command===v.command&&h.title===v.title&&h.tooltip===v.tooltip&&(h.arguments&&v.arguments?l(h.arguments,v.arguments):h.arguments===v.arguments)}function r(h,v){return(0,C.equals)(h,v,M)}class n{constructor(v,a,S){this._extension=v,this._sourceControlHandle=S,u.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Ze(this,u,a,"f")}get value(){return this._value}set value(v){v=v??"",Ie(this,u,"f").$setInputBoxValue(this._sourceControlHandle,v),this.updateValue(v)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(v){Ie(this,u,"f").$setInputBoxPlaceholder(this._sourceControlHandle,v),this._placeholder=v}get validateInput(){return(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(v){if((0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=v,Ie(this,u,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!v)}get visible(){return this._visible}set visible(v){v=!!v,this._visible!==v&&(this._visible=v,Ie(this,u,"f").$setInputBoxVisibility(this._sourceControlHandle,v))}showValidationMessage(v,a){(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),Ie(this,u,"f").$showValidationMessage(this._sourceControlHandle,v,a)}$onInputBoxValueChange(v){this.updateValue(v)}updateValue(v){this._value=v,this._onDidChange.fire(v)}}e.ExtHostSCMInputBox=n,u=new WeakMap;class b{constructor(v,a,S,I,N){this._proxy=v,this._commands=a,this._sourceControlHandle=S,this._id=I,this._label=N,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=b._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(v){this._label=v,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,v)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(v){this._hideWhenEmpty=v,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(v){this._resourceStates=[...v],this._onDidUpdateResourceStates.fire()}getResourceState(v){return this._resourceStatesMap.get(v)}$executeResourceCommand(v,a){const S=this._resourceStatesCommandsMap.get(v);return S?(0,k.asPromise)(()=>this._commands.executeCommand(S.command,...S.arguments||[],a)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this._resourceStates].sort(D),S=(0,C.sortedDiff)(this._resourceSnapshot,v,D).map(B=>{const E=B.toInsert.map(O=>{const z=this._resourceHandlePool++;this._resourceStatesMap.set(z,O);const U=O.resourceUri;let $;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const Ee=new T.DisposableStore;$=this._commands.converter.toInternal(O.command,Ee),this._resourceStatesDisposablesMap.set(z,Ee)}else this._resourceStatesCommandsMap.set(z,O.command);const V=F(O.decorations),ue=O.decorations&&F(O.decorations.light)||V,K=O.decorations&&F(O.decorations.dark)||V,re=[ue,K],pe=O.decorations&&O.decorations.tooltip||"",we=O.decorations&&!!O.decorations.strikeThrough,ae=O.decorations&&!!O.decorations.faded,le=O.contextValue||"";return{rawResource:[z,U,re,pe,we,ae,le,$],handle:z}});return{start:B.start,deleteCount:B.deleteCount,toInsert:E}}),I=S.map(({start:B,deleteCount:E,toInsert:O})=>[B,E,O.map(z=>z.rawResource)]),N=S.reverse();for(const{start:B,deleteCount:E,toInsert:O}of N){const z=O.map($=>$.handle),U=this._handlesSnapshot.splice(B,E,...z);for(const $ of U)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=v,I}dispose(){this._disposed=!0,this._onDidDispose.fire()}}b._handlePool=0;class g{constructor(v,a,S,I,N,B){this._extension=v,this._commands=S,this._id=I,this._label=N,this._rootUri=B,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=g._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ze(this,d,a,"f"),this._inputBox=new n(v,Ie(this,d,"f"),this.handle),Ie(this,d,"f").$registerSourceControl(this.handle,I,N,B)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(v){this._count!==v&&(this._count=v,Ie(this,d,"f").$updateSourceControl(this.handle,{count:v}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(v){this._quickDiffProvider=v,Ie(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!v})}get commitTemplate(){return this._commitTemplate}set commitTemplate(v){v!==this._commitTemplate&&(this._commitTemplate=v,Ie(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:v}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(v){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=v;const a=this._commands.converter.toInternal(v,this._acceptInputDisposables.value);Ie(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:a})}get actionButton(){return(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(v){(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=v;const a=v!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Ie(this,d,"f").$updateSourceControl(this.handle,{actionButton:a??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(v){if(this._statusBarCommands&&v&&r(this._statusBarCommands,v))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=v;const a=(v||[]).map(S=>this._commands.converter.toInternal(S,this._statusBarDisposables.value));Ie(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:a})}get selected(){return this._selected}createResourceGroup(v,a){const S=new b(Ie(this,d,"f"),this._commands,this.handle,v,a),I=t.Event.once(S.onDidDispose)(()=>this.createdResourceGroups.delete(S));return this.createdResourceGroups.set(S,I),this.eventuallyAddResourceGroups(),S}eventuallyAddResourceGroups(){const v=[],a=[];for(const[S,I]of this.createdResourceGroups){I.dispose();const N=S.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(S),this.eventuallyUpdateResourceStates()});t.Event.once(S.onDidDispose)(()=>{this.updatedResourceGroups.delete(S),N.dispose(),this._groups.delete(S.handle),Ie(this,d,"f").$unregisterGroup(this.handle,S.handle)}),v.push([S.handle,S.id,S.label,S.features]);const B=S._takeResourceStateSnapshot();B.length>0&&a.push([S.handle,B]),this._groups.set(S.handle,S)}Ie(this,d,"f").$registerGroups(this.handle,v,a),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const v=[];this.updatedResourceGroups.forEach(a=>{const S=a._takeResourceStateSnapshot();S.length!==0&&v.push([a.handle,S])}),v.length>0&&Ie(this,d,"f").$spliceResourceStates(this.handle,v),this.updatedResourceGroups.clear()}getResourceGroup(v){return this._groups.get(v)}setSelectionState(v){this._selected=v,this._onDidChangeSelection.fire(v)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(v=>v.dispose()),Ie(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,g._handlePool=0,Be([(0,y.debounce)(100)],g.prototype,"eventuallyAddResourceGroups",null),Be([(0,y.debounce)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let c=class zi{constructor(v,a,S){this._commands=a,this.logService=S,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=v.getProxy(P.MainContext.MainThreadSCM),this._telemetry=v.getProxy(P.MainContext.MainThreadTelemetry),a.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===3){const N=this._sourceControls.get(I.sourceControlHandle);if(!N)return I;const B=N.getResourceGroup(I.groupHandle);return B?B.getResourceState(I.handle):I}else if(I&&I.$mid===4){const N=this._sourceControls.get(I.sourceControlHandle);return N?N.getResourceGroup(I.groupHandle):I}else if(I&&I.$mid===5){const N=this._sourceControls.get(I.handle);return N||I}return I}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(v,a,S,I){this.logService.trace("ExtHostSCM#createSourceControl",v.identifier.value,a,S,I),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const N=zi._handlePool++,B=new g(v,this._proxy,this._commands,a,S,I);this._sourceControls.set(N,B);const E=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(v.identifier))||[];return E.push(B),this._sourceControlsByExtension.set(w.ExtensionIdentifier.toKey(v.identifier),E),B}getLastInputBox(v){this.logService.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const a=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(v.identifier)),S=a&&a[a.length-1];return S&&S.inputBox}$provideOriginalResource(v,a,S){const I=s.URI.revive(a);this.logService.trace("ExtHostSCM#$provideOriginalResource",v,I.toString());const N=this._sourceControls.get(v);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(I,S)).then(B=>B||null)}$onInputBoxValueChange(v,a){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",v);const S=this._sourceControls.get(v);return S&&S.inputBox.$onInputBoxValueChange(a),Promise.resolve(void 0)}$executeResourceCommand(v,a,S,I){this.logService.trace("ExtHostSCM#$executeResourceCommand",v,a,S);const N=this._sourceControls.get(v);if(!N)return Promise.resolve(void 0);const B=N.getResourceGroup(a);return B?B.$executeResourceCommand(S,I):Promise.resolve(void 0)}$validateInput(v,a,S){this.logService.trace("ExtHostSCM#$validateInput",v);const I=this._sourceControls.get(v);return!I||!I.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>I.inputBox.validateInput(a,S)).then(N=>{if(!N)return Promise.resolve(void 0);const B=p.MarkdownString.fromStrict(N.message);return B?Promise.resolve([B,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this._sourceControls.get(v)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=v,Promise.resolve(void 0)}};c._handlePool=0,c=Be([He(2,R.ILogService)],c),e.ExtHostSCM=c});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!y:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(Z,s):y?y.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[198],_e([0,1,7,5,121,6,8,10]),function(Z,e,s,t,y,T,k,P){"use strict";var C,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(o,u,d,F,_=s.StatusBarAlignment.Left,m){C.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Ze(this,C,o,"f"),Ze(this,A,u,"f"),this._entryId=R.ID_GEN++,this._extension=d,this._id=F,this._alignment=_,this._priority=this.validatePriority(m)}validatePriority(o){if(!!(0,P.isNumber)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!R.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){this._command?.fromApi!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:Ie(this,A,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:Ie(this,A,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ie(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let o;this._extension?this._id?o=`${this._extension.identifier.value}.${this._id}`:o=this._extension.identifier.value:o=this._id;let u;this._name?u=this._name:u=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const F=this._tooltip?k.MarkdownString.fromStrict(this._tooltip):void 0;Ie(this,C,"f").$setEntry(this._entryId,o,u,this._text,F,this._command?.internal,d,this._backgroundColor,this._alignment===s.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,C=new WeakMap,A=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new s.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.ThemeColor("statusBarItem.warningForeground")]]);class w{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const u={message:o};return this._messages.unshift(u),this._update(),new s.Disposable(()=>{const d=this._messages.indexOf(u);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(o,u){this._proxy=o.getProxy(t.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new w(this)}createStatusBarEntry(o,u,d,F){return new R(this._proxy,this._commands,o,u,d,F)}setStatusBarMessage(o,u){const d=this._statusMessage.setMessage(o);let F;return typeof u=="number"?F=setTimeout(()=>d.dispose(),u):typeof u!="undefined"&&u.then(()=>d.dispose(),()=>d.dispose()),new s.Disposable(()=>{d.dispose(),clearTimeout(F)})}}e.ExtHostStatusBar=i}),define(ye[71],_e([0,1,5,4,3]),function(Z,e,s,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(P){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(s.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,C){this._proxy.$registerExtensionStorageKeysToSync(P,C)}getValue(P,C,A){return this._proxy.$getValue(P,C).then(R=>R||A)}setValue(P,C,A){return this._proxy.$setValue(P,C,A)}$acceptValue(P,C,A){this._onDidChangeStorage.fire({shared:P,key:C,value:A})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(ye[72],_e([0,1,3,28,12,50,2]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,s.createDecorator)("IExtensionStoragePaths");let P=class{constructor(A,R,w){this._logService=R,this._extHostFileSystem=w,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(i=>this._value=i)}async _getWorkspaceStorageURI(A){return k.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,R=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:k.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(A){if(this._value)return k.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return k.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=Be([He(0,t.IExtHostInitDataService),He(1,y.ILogService),He(2,T.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ye[40],_e([0,1,4,5,3,2,13,6,7,122,15,161,20,36,144,62,10,14]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class _{constructor(g,c,h,v){this._proxy=g,this._id=c,this._creationOptions=h,this._name=v,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(S=>this._pidPromiseComplete=S);const a=this;this.value={get name(){return a._name||""},get processId(){return a._pidPromise},get creationOptions(){return a._creationOptions},get exitStatus(){return a._exitStatus},get state(){return a._state},sendText(S,I=!0){a._checkDisposed(),a._proxy.$sendText(a._id,S,I)},show(S){a._checkDisposed(),a._proxy.$show(a._id,S)},hide(){a._checkDisposed(),a._proxy.$hide(a._id)},dispose(){a._disposed||(a._disposed=!0,a._proxy.$dispose(a._id))},get dimensions(){if(!(a._cols===void 0||a._rows===void 0))return{columns:a._cols,rows:a._rows}}}}async create(g,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:g.name,shellPath:(0,d.withNullAsUndefined)(g.shellPath),shellArgs:(0,d.withNullAsUndefined)(g.shellArgs),cwd:(0,d.withNullAsUndefined)(g.cwd),env:(0,d.withNullAsUndefined)(g.env),icon:(0,d.withNullAsUndefined)(r(g.iconPath)),color:u.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:(0,d.withNullAsUndefined)(g.message),strictEnv:(0,d.withNullAsUndefined)(g.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(g.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(g.location,c?.resolvedExtHostIdentifier),disablePersistence:(0,d.withNullAsUndefined)(g.disablePersistence)})}async createExtensionTerminal(g,c,h,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:u.ThemeColor.isThemeColor(v)?v.id:void 0,location:this._serializeParentTerminal(g,c),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(g,c){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in g?{viewColumn:g.viewColumn,preserveFocus:g.preserveFocus}:void 0:g}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(g){this._name=g}setExitCode(g){this._exitStatus=Object.freeze({code:g})}setDimensions(g,c){return g===this._cols&&c===this._rows||g===0||c===0?!1:(this._cols=g,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(g){this._pidPromiseComplete?(this._pidPromiseComplete(g),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==g&&(this._pidPromise=Promise.resolve(g))})}}e.ExtHostTerminal=_;class m{constructor(g){this._pty=g,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new s.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new s.Emitter,this._onDidChangeProperty=new s.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new s.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(g){this._pty.handleInput?.(g)}resize(g,c){this._pty.setDimensions?.({columns:g,rows:c})}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(g){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(g||void 0),g&&this._pty.setDimensions?.(g),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=m;let f=1,D=class extends P.Disposable{constructor(g,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new s.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new s.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new s.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new s.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new s.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new s.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(g),this._register({dispose:()=>{for(const[h,v]of this._terminalProcesses)v.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(g=>g.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(g,c){const h=new _(this._proxy,(0,p.generateUuid)(),g,g.name),v=new m(g.pty);return h.createExtensionTerminal(g.location,this._serializeParentTerminal(g,c).resolvedExtHostIdentifier,r(g.iconPath),n(g.color)).then(a=>{const S=this._setupExtHostProcessListeners(a,v);this._terminalProcessDisposables[a]=S}),this._terminals.push(h),h.value}_serializeParentTerminal(g,c){if(c=c||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const h=g.location.parentTerminal;if(h){const v=this._terminals.find(a=>a.value===h);v&&(c.resolvedExtHostIdentifier=v._id)}}else g.location&&typeof g.location!="object"?c.location=g.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(g,c){if(!this._getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const v=new m(c),a=this._setupExtHostProcessListeners(g,v);this._terminalProcessDisposables[g]=a}async $acceptActiveTerminalChanged(g){const c=this._activeTerminal;if(g===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(g);h&&(this._activeTerminal=h,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(g,c){const h=this._getTerminalById(g);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:c})}async $acceptTerminalDimensions(g,c,h){const v=this._getTerminalById(g);v&&v.setDimensions(c,h)&&this._onDidChangeTerminalDimensions.fire({terminal:v.value,dimensions:v.value.dimensions})}async $acceptTerminalMaximumDimensions(g,c,h){this._terminalProcesses.get(g)?.resize(c,h)}async $acceptTerminalTitleChange(g,c){const h=this._getTerminalById(g);h&&(h.name=c)}async $acceptTerminalClosed(g,c){const h=this._getTerminalObjectIndexById(this._terminals,g);if(h!==null){const v=this._terminals.splice(h,1)[0];v.setExitCode(c),this._onDidCloseTerminal.fire(v.value)}}$acceptTerminalOpened(g,c,h,v){if(c){const I=this._getTerminalObjectIndexById(this._terminals,c);if(I!==null){this._terminals[I]._id=g,this._onDidOpenTerminal.fire(this.terminals[I]),this._terminals[I].isOpen=!0;return}}const a={name:v.name,shellPath:v.executable,shellArgs:v.args,cwd:typeof v.cwd=="string"?v.cwd:T.URI.revive(v.cwd),env:v.env,hideFromUser:v.hideFromUser},S=new _(this._proxy,g,a,h);this._terminals.push(S),this._onDidOpenTerminal.fire(S.value),S.isOpen=!0}async $acceptTerminalProcessId(g,c){const h=this._getTerminalById(g);h&&h._setProcessId(c)}async $startExtensionTerminal(g,c){const h=this._getTerminalById(g);if(!h)return{message:(0,A.localize)(0,null,g)};h.isOpen||await new Promise(a=>{const S=this.onDidOpenTerminal(async I=>{I===h.value&&(S.dispose(),a())})});const v=this._terminalProcesses.get(g);v?v.startSendingEvents(c):this._extensionTerminalAwaitingStart[g]={initialDimensions:c}}_setupExtHostProcessListeners(g,c){const h=new P.DisposableStore;h.add(c.onProcessReady(a=>this._proxy.$sendProcessReady(g,a.pid,a.cwd))),h.add(c.onDidChangeProperty(a=>this._proxy.$sendProcessProperty(g,a))),this._bufferer.startBuffering(g,c.onProcessData),h.add(c.onProcessExit(a=>this._onProcessExit(g,a))),this._terminalProcesses.set(g,c);const v=this._extensionTerminalAwaitingStart[g];return v&&c instanceof m&&(c.startSendingEvents(v.initialDimensions),delete this._extensionTerminalAwaitingStart[g]),h}$acceptProcessAckDataEvent(g,c){this._terminalProcesses.get(g)?.acknowledgeDataEvent(c)}$acceptProcessInput(g,c){this._terminalProcesses.get(g)?.input(c)}$acceptTerminalInteraction(g){const c=this._getTerminalById(g);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(g,c,h){try{this._terminalProcesses.get(g)?.resize(c,h)}catch(v){if(v.code!=="EPIPE"&&v.code!=="ERR_IPC_CHANNEL_CLOSED")throw v}}$acceptProcessShutdown(g,c){this._terminalProcesses.get(g)?.shutdown(c)}$acceptProcessRequestInitialCwd(g){this._terminalProcesses.get(g)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(g,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(g){this._terminalProcesses.get(g)?.getCwd().then(c=>this._proxy.$sendProcessProperty(g,{type:"cwd",value:c}))}$acceptProcessRequestLatency(g){return g}registerLinkProvider(g){return this._linkProviders.add(g),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(g),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(g,c,h){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,h),this._proxy.$registerProfileProvider(c,g.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(g,c){const h=new i.CancellationTokenSource().token;let v=await this._profileProviders.get(g)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(v&&!("options"in v)&&(v={options:v}),!v||!("options"in v))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in v.options){this.createExtensionTerminal(v.options,c);return}this.createTerminalFromOptions(v.options,c)}}async $provideLinks(g,c){const h=this._getTerminalById(g);if(!h)return[];this._terminalLinkCache.delete(g);const v=this._terminalLinkCancellationSource.get(g);v&&v.dispose(!0);const a=new i.CancellationTokenSource;this._terminalLinkCancellationSource.set(g,a);const S=[],I={terminal:h.value,line:c},N=[];for(const O of this._linkProviders)N.push(F.Promises.withAsyncBody(async z=>{a.token.onCancellationRequested(()=>z({provider:O,links:[]}));const U=await O.provideTerminalLinks(I,a.token)||[];a.token.isCancellationRequested||z({provider:O,links:U})}));const B=await Promise.all(N);if(a.token.isCancellationRequested)return[];const E=new Map;for(const O of B)O&&O.links.length>0&&S.push(...O.links.map(z=>{const U={id:f++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return E.set(U.id,{provider:O.provider,link:z}),U}));return this._terminalLinkCache.set(g,E),S}$activateLink(g,c){const h=this._terminalLinkCache.get(g)?.get(c);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(g,c){this._bufferer.stopBuffering(g),this._terminalProcesses.delete(g),delete this._extensionTerminalAwaitingStart[g];const h=this._terminalProcessDisposables[g];h&&(h.dispose(),delete this._terminalProcessDisposables[g]),this._proxy.$sendProcessExit(g,c)}_getTerminalById(g){return this._getTerminalObjectById(this._terminals,g)}_getTerminalObjectById(g,c){const h=this._getTerminalObjectIndexById(g,c);return h!==null?g[h]:null}_getTerminalObjectIndexById(g,c){let h=null;return g.some((v,a)=>v._id===c?(h=a,!0):!1),h}getEnvironmentVariableCollection(g){let c=this._environmentVariableCollections.get(g.identifier.value);return c||(c=new l,this._setEnvironmentVariableCollection(g.identifier.value,c)),c}_syncEnvironmentVariableCollection(g,c){const h=(0,w.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(g,c.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(g){g.forEach(c=>{const h=c[0],v=new l(c[1]);this._setEnvironmentVariableCollection(h,v)})}$acceptDefaultProfile(g,c){this._defaultProfile=g,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(g,c){this._environmentVariableCollections.set(g,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(g,c)})}};D=Be([He(1,k.IExtHostRpcService)],D),e.BaseExtHostTerminalService=D;class l{constructor(g){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new s.Emitter,this.map=new Map(g)}get persistent(){return this._persistent}set persistent(g){this._persistent=g,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(g,c){this._setIfDiffers(g,{value:c,type:C.EnvironmentVariableMutatorType.Replace})}append(g,c){this._setIfDiffers(g,{value:c,type:C.EnvironmentVariableMutatorType.Append})}prepend(g,c){this._setIfDiffers(g,{value:c,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(g,c){const h=this.map.get(g);(!h||h.value!==c.value||h.type!==c.type)&&(this.map.set(g,c),this._onDidChangeCollection.fire())}get(g){return this.map.get(g)}forEach(g,c){this.map.forEach((h,v)=>g.call(c,v,h,this))}delete(g){this.map.delete(g),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let M=class extends D{constructor(g){super(!1,g)}createTerminal(g,c,h){throw new R.NotSupportedError}createTerminalFromOptions(g,c){throw new R.NotSupportedError}};M=Be([He(0,k.IExtHostRpcService)],M),e.WorkerExtHostTerminalService=M;function r(b){if(!(!b||typeof b=="string"))return"id"in b?{id:b.id,color:b.color}:b}function n(b){return u.ThemeColor.isThemeColor(b)?b:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!y:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(Z,s):y?y.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[199],_e([0,1,16,22,20,4,231,57,6,26,10,36,5,13,48,8,7,168,88,67]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let D=class{constructor(I,N){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=I.getProxy(i.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new M(this.proxy),N.registerArgumentProcessor({processArgument:B=>B?.$mid===13?u.TestItem.toItemFromContext(B):B})}createTestController(I,N){if(this.controllers.has(I))throw new Error(`Attempt to insert a duplicate controller with ID "${I}"`);const B=new C.DisposableStore,E=B.add(new F.SingleUseTestCollection(I));E.root.label=N;const O=new Map,z=this.proxy,U={items:E.root.children,get label(){return N},set label(V){N=V,E.root.label=V,z.$updateControllerLabel(I,N)},get id(){return I},createRunProfile:(V,ue,K,re,pe)=>{let we=(0,P.hash)(V);for(;O.has(we);)we++;const ae=new v(this.proxy,I,we,V,ue,K,re,pe);return O.set(we,ae),ae},createTestItem(V,ue,K){return new o.TestItemImpl(I,V,ue,K)},createTestRun:(V,ue,K=!0)=>this.runTracker.createTestRun(I,E,V,ue,K),set resolveHandler(V){E.resolveHandler=V},get resolveHandler(){return E.resolveHandler},dispose:()=>{B.dispose()}};U.createRunConfiguration=U.createRunProfile,z.$registerTestController(I,N),B.add((0,C.toDisposable)(()=>z.$unregisterTestController(I)));const $={controller:U,collection:E,profiles:O};return this.controllers.set(I,$),B.add((0,C.toDisposable)(()=>this.controllers.delete(I))),B.add(E.onDidGenerateDiff(V=>z.$publishDiff(I,V))),U}createTestObserver(){return this.observer.checkout()}async runTests(I,N=y.CancellationToken.None){const B=r(I);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const E=this.controllers.get(B.controllerId);if(!E)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:I.include?.map(O=>O.id)??[E.collection.root.id],profileGroup:a[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:I.exclude?.map(O=>O.id)},N)}$provideFileCoverage(I,N,B){return(0,s.mapFind)(this.runTracker.trackers,O=>O.id===I?O.getCoverage(N):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(I,N,B,E){return(0,s.mapFind)(this.runTracker.trackers,z=>z.id===I?z.getCoverage(N):void 0)?.resolveFileCoverage(B,E)??Promise.resolve([])}$configureRunProfile(I,N){this.controllers.get(I)?.profiles.get(N)?.configureHandler?.()}$publishTestResults(I){this.results=Object.freeze(I.map(N=>(0,A.deepFreeze)(u.TestResults.to(N))).concat(this.results).sort((N,B)=>B.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(I,N){const B=this.controllers.get(m.TestId.fromString(I).controllerId)?.collection;B&&(await B.expand(I,N<0?1/0:N),B.flushDiff())}$acceptDiff(I){this.observer.applyDiff(I)}async $runControllerTests(I,N){const B=this.controllers.get(I.controllerId);if(!B)return;const{collection:E,profiles:O}=B,z=O.get(I.profileId);if(!z)return;const U=I.testIds.map(K=>E.tree.get(K)).filter(R.isDefined),$=I.excludeExtIds.map(K=>B.collection.tree.get(K)).filter(R.isDefined).filter(K=>U.some(re=>re.fullId.compare(K.fullId)===2));if(!U.length)return;const V=new d.TestRunRequest(U.some(K=>K.actual instanceof o.TestItemRootImpl)?void 0:U.map(K=>K.actual),$.map(K=>K.actual),z),ue=this.runTracker.prepareForMainThreadTestRun(V,n.fromInternal(I,B.collection),N);try{await z.runHandler(V,N)}finally{ue.isRunning&&!N.isCancellationRequested&&await T.Event.toPromise(ue.onEnd),ue.dispose()}}$cancelExtensionTestRun(I){I===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(I)}};D=Be([He(0,p.IExtHostRpcService)],D),e.ExtHostTesting=D;class l extends C.Disposable{constructor(I,N,B){super();this.dto=I,this.proxy=N,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:E}of this.tasks.values())E.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(I){return this.tasks.get(I)?.coverage}createRun(I){const N=this.dto.id,B=this.dto.controllerId,E=(0,w.generateUuid)(),O=new b(this.proxy,N,E),z=ue=>(K,...re)=>{if($){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(K)||(this.ensureTestIsKnown(K),ue(K,...re))},U=(ue,K)=>{const re=K instanceof Array?K.map(u.TestMessage.from):[u.TestMessage.from(K)];if(ue.uri&&ue.range){const pe={range:u.Range.from(ue.range),uri:ue.uri};for(const we of re)we.location=we.location||pe}this.proxy.$appendTestMessagesInRun(N,E,m.TestId.fromExtHostTestItem(ue,B).toString(),re)};let $=!1;const V={isPersisted:this.dto.isPersisted,token:this.cts.token,name:I,get coverageProvider(){return O.coverageProvider},set coverageProvider(ue){O.coverageProvider=ue},enqueued:z(ue=>{this.proxy.$updateTestStateInRun(N,E,m.TestId.fromExtHostTestItem(ue,B).toString(),1)}),skipped:z(ue=>{this.proxy.$updateTestStateInRun(N,E,m.TestId.fromExtHostTestItem(ue,B).toString(),5)}),started:z(ue=>{this.proxy.$updateTestStateInRun(N,E,m.TestId.fromExtHostTestItem(ue,B).toString(),2)}),errored:z((ue,K,re)=>{U(ue,K),this.proxy.$updateTestStateInRun(N,E,m.TestId.fromExtHostTestItem(ue,B).toString(),6,re)}),failed:z((ue,K,re)=>{U(ue,K),this.proxy.$updateTestStateInRun(N,E,m.TestId.fromExtHostTestItem(ue,B).toString(),4,re)}),passed:z((ue,K)=>{this.proxy.$updateTestStateInRun(N,E,m.TestId.fromExtHostTestItem(ue,this.dto.controllerId).toString(),3,K)}),appendOutput:(ue,K,re)=>{$||(re&&(this.dto.isIncluded(re)?this.ensureTestIsKnown(re):re=void 0),this.proxy.$appendOutputToRun(N,E,t.VSBuffer.fromString(ue),K&&u.location.from(K),re&&m.TestId.fromExtHostTestItem(re,B).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(N,E),this.tasks.delete(E),this.isRunning||this.dispose())}};return this.tasks.set(E,{run:V,coverage:O}),this.proxy.$startedTestRunTask(N,{id:E,name:I,running:!0}),V}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(I){if(!(I instanceof o.TestItemImpl))throw new o.InvalidTestItemError(I.id);if(this.sharedTestIds.has(m.TestId.fromExtHostTestItem(I,this.dto.controllerId).toString()))return;const N=[],B=this.dto.colllection.root;for(;;){const E=u.TestItem.from(I);if(N.unshift(E),this.sharedTestIds.has(E.extId)||(this.sharedTestIds.add(E.extId),I===B))break;I=I.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class M{constructor(I){this.proxy=I,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(I,N,B){return this.getTracker(I,N,B)}cancelRunById(I){for(const N of this.tracked.values())if(N.id===I){N.dispose();return}}cancelAllRuns(){for(const I of this.tracked.values())I.dispose()}createTestRun(I,N,B,E,O){const z=this.tracked.get(B);if(z)return z.createRun(E);const U=n.fromPublic(I,N,B,O),$=r(B);this.proxy.$startedExtensionTestRun({controllerId:I,profile:$&&{group:a[$.kind],id:$.profileId},exclude:B.exclude?.map(ue=>ue.id)??[],id:U.id,include:B.include?.map(ue=>ue.id)??[N.root.id],persist:O});const V=this.getTracker(B,U);return V.onEnd(()=>this.proxy.$finishedExtensionTestRun(U.id)),V.createRun(E)}getTracker(I,N,B){const E=new l(N,this.proxy,B);return this.tracked.set(I,E),E.onEnd(()=>this.tracked.delete(I)),E}}e.TestRunCoordinator=M;const r=S=>{if(!!S.profile){if(!(S.profile instanceof v))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return S.profile}};class n{constructor(I,N,B,E,O,z){this.controllerId=I,this.id=N,this.isPersisted=O,this.colllection=z,this.includePrefix=B.map(U=>U+"\0"),this.excludePrefix=E.map(U=>U+"\0")}static fromPublic(I,N,B,E){return new n(I,(0,w.generateUuid)(),B.include?.map(O=>m.TestId.fromExtHostTestItem(O,I).toString())??[I],B.exclude?.map(O=>m.TestId.fromExtHostTestItem(O,I).toString())??[],E,N)}static fromInternal(I,N){return new n(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,N)}isIncluded(I){const N=m.TestId.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(N===B||N.startsWith(B))return!1;for(const B of this.includePrefix)if(N===B||N.startsWith(B))return!0;return!1}}e.TestRunDto=n;class b{constructor(I,N,B){this.proxy=I,this.runId=N,this.taskId=B}set coverageProvider(I){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!I||(this._coverageProvider=I,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(I){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(I))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(I,N){const B=await this.fileCoverage;let E=B?.[I];return!this._coverageProvider||!B||!E?[]:(E.detailedCoverage||(E=B[I]=await this._coverageProvider.resolveFileCoverage?.(E,N)??E),E.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class g extends _.IncrementalChangeCollector{constructor(I){super();this.emitter=I,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(I){this.added.add(I)}update(I){Object.assign(I.revived,u.TestItem.toPlain(I.item)),this.added.has(I)||this.updated.add(I)}remove(I){if(this.added.has(I)){this.added.delete(I);return}if(this.updated.delete(I),I.parent&&this.alreadyRemoved.has(I.parent)){this.alreadyRemoved.add(I.item.extId);return}this.removed.add(I)}getChangeEvent(){const{added:I,updated:N,removed:B}=this;return{get added(){return[...I].map(E=>E.revived)},get updated(){return[...N].map(E=>E.revived)},get removed(){return[...B].map(E=>E.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(I){return this.items.get(I)}getMirroredTestDataByReference(I){return this.items.get(I.id)}createItem(I,N){return{...I,revived:u.TestItem.toPlain(I.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new g(this.changeEmitter)}}e.MirroredTestCollection=c;class h{constructor(I){this.proxy=I}checkout(){this.current||(this.current=this.createObserverData());const I=this.current;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(N=>N.revived)},dispose:(0,k.once)(()=>{--I.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(I){return this.current?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.current?.tests.apply(I)}createObserverData(){const I=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:I}}}class v{constructor(I,N,B,E,O,z,U=!1,$=void 0){this.controllerId=N,this.profileId=B,this._label=E,this.kind=O,this.runHandler=z,this._isDefault=U,this._tag=$,f.set(this,void 0),Ze(this,f,I,"f");const V=a[O];if(typeof V!="number")throw new Error(`Unknown TestRunProfile.group ${O}`);Ie(this,f,"f").$publishTestRunProfile({profileId:B,controllerId:N,tag:$?u.TestTag.namespace(this.controllerId,$.id):null,label:E,group:V,isDefault:U,hasConfigurationHandler:!1})}get label(){return this._label}set label(I){I!==this._label&&(this._label=I,Ie(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:I}))}get isDefault(){return this._isDefault}set isDefault(I){I!==this._isDefault&&(this._isDefault=I,Ie(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,Ie(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:I?u.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(I){I!==this._configureHandler&&(this._configureHandler=I,Ie(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!I}))}dispose(){Ie(this,f,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=v,f=new WeakMap;const a={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(ye[200],_e([0,1,4,16,5,92,8,7]),function(Z,e,s,t,y,T,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(R,w){this._extHostDocumentsAndEditors=w,this._onDidChangeTextEditorSelection=new s.Emitter,this._onDidChangeTextEditorOptions=new s.Emitter,this._onDidChangeTextEditorVisibleRanges=new s.Emitter,this._onDidChangeTextEditorViewColumn=new s.Emitter,this._onDidChangeActiveTextEditor=new s.Emitter,this._onDidChangeVisibleTextEditors=new s.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(i=>this._onDidChangeVisibleTextEditors.fire(i)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(i=>this._onDidChangeActiveTextEditor.fire(i))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const w=this._extHostDocumentsAndEditors.allEditors();return R?w:w.map(i=>i.value)}async showTextDocument(R,w,i){let p;typeof w=="number"?p={position:k.ViewColumn.from(w),preserveFocus:i}:typeof w=="object"?p={position:k.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?k.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:p={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(R.uri,p),u=o&&this._extHostDocumentsAndEditors.getEditor(o);if(u)return u.value;throw o?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,w){return new T.TextEditorDecorationType(this._proxy,R,w).value}$acceptEditorPropertiesChanged(R,w){const i=this._extHostDocumentsAndEditors.getEditor(R);if(!i)throw new Error("unknown text editor");if(w.options&&i._acceptOptions(w.options),w.selections){const p=w.selections.selections.map(k.Selection.to);i._acceptSelections(p)}if(w.visibleRanges){const p=t.coalesce(w.visibleRanges.map(k.Range.to));i._acceptVisibleRanges(p)}if(w.options&&this._onDidChangeTextEditorOptions.fire({textEditor:i.value,options:{...w.options,lineNumbers:k.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const p=P.TextEditorSelectionChangeKind.fromValue(w.selections.source),o=w.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:i.value,selections:o,kind:p})}if(w.visibleRanges){const p=t.coalesce(w.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:i.value,visibleRanges:p})}}$acceptEditorPositionData(R){for(const w in R){const i=this._extHostDocumentsAndEditors.getEditor(w);if(!i)throw new Error("Unknown text editor");const p=k.ViewColumn.to(R[w]);i.value.viewColumn!==p&&(i._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:i.value,viewColumn:p}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=C}),define(ye[201],_e([0,1,2,3,5,6,7]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class P{constructor(R,w){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(y.MainContext.MainThreadTimeline),w.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===11){const p=i.uri===void 0?void 0:s.URI.revive(i.uri);return this._itemsBySourceAndUriMap.get(i.source)?.get(C(p))?.get(i.handle)}return i}})}async $getTimeline(R,w,i,p,o){return this._providers.get(R)?.provideTimeline(s.URI.revive(w),i,p,o)}registerTimelineProvider(R,w,i,p){const o=new T.DisposableStore,u=this.convertTimelineItem(w.id,p,o).bind(this);let d;w.onDidChange&&(d=w.onDidChange(_=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,..._,id:w.id}),this));const F=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...w,scheme:R,onDidChange:void 0,async provideTimeline(_,m,f,D){D?.resetCache&&(o.clear(),F.get(w.id)?.clear());const l=await w.provideTimeline(_,m,f);if(l==null)return;const M=u(_,D);return{...l,source:w.id,items:l.items.map(M)}},dispose(){for(const _ of F.values())_.get(w.id)?.clear();d?.dispose(),o.dispose()}})}convertTimelineItem(R,w,i){return(p,o)=>{let u;if(o?.cacheResults){let d=this._itemsBySourceAndUriMap.get(R);d===void 0&&(d=new Map,this._itemsBySourceAndUriMap.set(R,d));const F=C(p);u=d.get(F),u===void 0&&(u=new Map,d.set(F,u))}return d=>{const{iconPath:F,..._}=d,m=`${R}|${d.id??d.timestamp}`;u?.set(m,d);let f,D,l;return d.iconPath&&(F instanceof k.ThemeIcon?l={id:F.id,color:F.color}:s.URI.isUri(F)?(f=F,D=F):{light:f,dark:D}=F),{..._,id:_.id??void 0,handle:m,source:R,command:d.command?w.toInternal(d.command,i):void 0,icon:f,iconDark:D,themeIcon:l,accessibilityInformation:d.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,T.toDisposable)(()=>{for(const i of this._itemsBySourceAndUriMap.values())i.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=P;function C(A){return A?.toString()}}),define(ye[202],_e([0,1,6,11,2,5]),function(Z,e,s,t,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(C){this._openers=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,A,R,w){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const i=w.schemes.find(p=>!k.supportedSchemes.has(p));if(i)throw new Error(`Scheme '${i}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,R),this._proxy.$registerUriOpener(A,w.schemes,C,w.label),(0,s.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(C,A,R){const w=this._openers.get(C);if(!w)throw new Error(`Unknown opener with id: ${C}`);const i=y.URI.revive(A);return w.canOpenExternalUri(i,R)}async $openUri(C,A,R){const w=this._openers.get(C);if(!w)throw new Error(`Unknown opener id: '${C}'`);return w.openExternalUri(y.URI.revive(A.resolvedUri),{sourceUri:y.URI.revive(A.sourceUri)},R)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(ye[203],_e([0,1,5,2,6,15,25]),function(Z,e,s,t,y,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(s.MainContext.MainThreadUrls)}registerUriHandler(A,R){if(this.handles.has(k.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const w=P.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(A)),this.handlers.set(w,R),this._proxy.$registerUriHandler(w,A),(0,y.toDisposable)(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(A)),this.handlers.delete(w),this._proxy.$unregisterUriHandler(w)})}$handleExternalUri(A,R){const w=this.handlers.get(A);if(!w)return Promise.resolve(void 0);try{w.handleUri(t.URI.revive(R))}catch(i){(0,T.onUnexpectedError)(i)}return Promise.resolve(void 0)}async createAppUri(A){return t.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=P,P.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!y:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(Z,s):y?y.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[51],_e([0,1,4,11,2,131,151,66,5]),function(Z,e,s,t,y,T,k,P,C){"use strict";var A,R,w,i,p,o,u,d,F,_,m,f;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class D{constructor(h,v,a,S,I,N,B){A.set(this,void 0),R.set(this,void 0),w.set(this,void 0),i.set(this,void 0),p.set(this,void 0),o.set(this,void 0),u.set(this,""),d.set(this,void 0),F.set(this,!1),_.set(this,!1),m.set(this,!1),this._onMessageEmitter=new s.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,f.set(this,new s.Emitter),this._onDidDispose=Ie(this,f,"f").event,Ze(this,A,h,"f"),Ze(this,R,v,"f"),Ze(this,d,a,"f"),Ze(this,i,S,"f"),Ze(this,p,I,"f"),Ze(this,o,N,"f"),Ze(this,m,l(N),"f"),Ze(this,w,B,"f")}dispose(){Ze(this,F,!0,"f"),Ie(this,f,"f").fire(),Ie(this,f,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return Ze(this,_,!0,"f"),(0,P.asWebviewUri)(h,Ie(this,i,"f").remote)}get cspSource(){const h=Ie(this,o,"f").extensionLocation;if(h.scheme===t.Schemas.https||h.scheme===t.Schemas.http){let v=h.toString();return v.endsWith("/")||(v+="/"),v+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ie(this,u,"f")}set html(h){this.assertNotDisposed(),Ie(this,u,"f")!==h&&(Ze(this,u,h,"f"),!Ie(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(Ze(this,_,!0,"f"),Ie(this,w,"f").report("Webview vscode-resource: uris",Ie(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ie(this,R,"f").$setHtml(Ie(this,A,"f"),h))}get options(){return this.assertNotDisposed(),Ie(this,d,"f")}set options(h){this.assertNotDisposed(),Ie(this,R,"f").$setOptions(Ie(this,A,"f"),n(Ie(this,o,"f"),Ie(this,p,"f"),h)),Ze(this,d,h,"f")}async postMessage(h){if(Ie(this,F,"f"))return!1;const v=(0,k.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Ie(this,m,"f")});return Ie(this,R,"f").$postMessage(Ie(this,A,"f"),v.message,...v.buffers)}assertNotDisposed(){if(Ie(this,F,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=D,A=new WeakMap,R=new WeakMap,w=new WeakMap,i=new WeakMap,p=new WeakMap,o=new WeakMap,u=new WeakMap,d=new WeakMap,F=new WeakMap,_=new WeakMap,m=new WeakMap,f=new WeakMap;function l(c){try{const h=(0,T.normalizeVersion)((0,T.parseVersion)(c.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;class M{constructor(h,v,a,S,I){this.initData=v,this.workspace=a,this._logService=S,this._deprecationService=I,this._webviews=new Map,this._webviewProxy=h.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(h,v,a){const S=this.getWebview(h);if(S){const{message:I}=(0,k.deserializeWebviewMessage)(v,a.value);S._onMessageEmitter.fire(I)}}$onMissingCsp(h,v){this._logService.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,v,a){const S=new D(h,this._webviewProxy,b(v),this.initData,this.workspace,a,this._deprecationService);return this._webviews.set(h,S),S._onDidDispose(()=>{this._webviews.delete(h)}),S}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=M;function r(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=r;function n(c,h,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||g(c,h)}}e.serializeWebviewOptions=n;function b(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(h=>y.URI.from(h))}}e.reviveOptions=b;function g(c,h){return[...(h?.getWorkspaceFolders()||[]).map(v=>v.uri),c.extensionLocation]}}),define(ye[204],_e([0,1,20,57,6,11,24,2,8,51,63,5,7]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(l,M){this.document=l,this._storagePath=M,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,M){await this.getEdit(l).undo(),M||this.disposeBackup()}async redo(l,M){await this.getEdit(l).redo(),M||this.disposeBackup()}disposeEdits(l){for(const M of l)this._edits.delete(M)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=f(this.document.uri)+this._backupCounter++;return(0,k.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const M=this._edits.get(l,0);if(!M)throw new Error("No edit found");return M}}class o{constructor(){this._documents=new Map}get(l,M){return this._documents.get(this.key(l,M))}add(l,M,r){const n=this.key(l,M.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${l} resource:${M.uri}`);const b=new p(M,r);return this._documents.set(n,b),b}delete(l,M){const r=this.key(l,M.uri);this._documents.delete(r)}key(l,M){return`${l}@@@${M}`}}var u;(function(D){D[D.Text=0]="Text",D[D.Custom=1]="Custom"})(u||(u={}));class d{constructor(){this._providers=new Map}addTextProvider(l,M,r){return this.add(0,l,M,r)}addCustomProvider(l,M,r){return this.add(1,l,M,r)}get(l){return this._providers.get(l)}add(l,M,r,n){if(this._providers.has(M))throw new Error(`Provider for viewType:${M} already registered`);return this._providers.set(M,{type:l,extension:r,provider:n}),new i.Disposable(()=>this._providers.delete(M))}}class F{constructor(l,M,r,n,b){this._extHostDocuments=M,this._extensionStoragePaths=r,this._extHostWebview=n,this._extHostWebviewPanels=b,this._editorProviders=new d,this._documents=new o,this._proxy=l.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,M,r,n){const b=new y.DisposableStore;return _(r)?(b.add(this._editorProviders.addTextProvider(M,l,r)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(l),M,n.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(l))):(b.add(this._editorProviders.addCustomProvider(M,l,r)),this.supportEditing(r)&&b.add(r.onDidChangeCustomDocument(g=>{const c=this.getCustomDocumentEntry(M,g.document.uri);if(m(g)){const h=c.addEdit(g);this._proxy.$onDidEdit(g.document.uri,M,h,g.label)}else this._proxy.$onContentChange(g.document.uri,M)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(l),M,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(l))),i.Disposable.from(b,new i.Disposable(()=>{this._proxy.$unregisterEditorProvider(M)}))}async $createCustomDocument(l,M,r,n,b){const g=this._editorProviders.get(M);if(!g)throw new Error(`No provider found for '${M}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${M}'`);const c=P.URI.revive(l),h=await g.provider.openCustomDocument(c,{backupId:r,untitledDocumentData:n?.buffer},b);let v;return this.supportEditing(g.provider)&&this._extensionStoragePaths&&(v=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(M,h,v),{editable:this.supportEditing(g.provider)}}async $disposeCustomDocument(l,M){const r=this._editorProviders.get(M);if(!r)throw new Error(`No provider found for '${M}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${M}'`);const n=P.URI.revive(l),{document:b}=this.getCustomDocumentEntry(M,n);this._documents.delete(M,b),b.dispose()}async $resolveWebviewEditor(l,M,r,n,b,g){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);const h=C.ViewColumn.to(b),v=this._extHostWebview.createNewWebview(M,n.webviewOptions,c.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(M,r,n.title,h,n.panelOptions,v),S=P.URI.revive(l);switch(c.type){case 1:{const{document:I}=this.getCustomDocumentEntry(r,S);return c.provider.resolveCustomEditor(I,a,g)}case 0:{const I=this._extHostDocuments.getDocument(S);return c.provider.resolveCustomTextEditor(I,a,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,M,r){this.getCustomDocumentEntry(M,l).disposeEdits(r)}async $onMoveCustomEditor(l,M,r){const n=this._editorProviders.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const b=this._extHostWebviewPanels.getWebviewPanel(l);if(!b)throw new Error("No webview found");const g=P.URI.revive(M),c=this._extHostDocuments.getDocument(g);await n.provider.moveCustomTextEditor(c,b,s.CancellationToken.None)}async $undo(l,M,r,n){return this.getCustomDocumentEntry(M,l).undo(r,n)}async $redo(l,M,r,n){return this.getCustomDocumentEntry(M,l).redo(r,n)}async $revert(l,M,r){const n=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).revertCustomDocument(n.document,r),n.disposeBackup()}async $onSave(l,M,r){const n=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).saveCustomDocument(n.document,r),n.disposeBackup()}async $onSaveAs(l,M,r,n){const b=this.getCustomDocumentEntry(M,l);return this.getCustomEditorProvider(M).saveCustomDocumentAs(b.document,P.URI.revive(r),n)}async $backup(l,M,r){const n=this.getCustomDocumentEntry(M,l),g=await this.getCustomEditorProvider(M).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},r);return n.updateBackup(g),g.id}getCustomDocumentEntry(l,M){const r=this._documents.get(l,P.URI.revive(M));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(l){const r=this._editorProviders.get(l)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(l){return!!l.onDidChangeCustomDocument}}e.ExtHostCustomEditors=F;function _(D){return typeof D.resolveCustomTextEditor=="function"}function m(D){return typeof D.undo=="function"&&typeof D.redo=="function"}function f(D){const l=D.scheme===T.Schemas.file||D.scheme===T.Schemas.untitled?D.fsPath:D.toString();return(0,t.hash)(l)+""}});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!y:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(Z,s):y?y.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[205],_e([0,1,4,6,2,36,8,51,5,7]),function(Z,e,s,t,y,T,k,P,C,A){"use strict";var R,w,i,p,o,u,d,F,_,m,f,D,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class M extends t.Disposable{constructor(g,c,h,v,a,S,I){super();R.set(this,void 0),w.set(this,void 0),i.set(this,void 0),p.set(this,void 0),o.set(this,void 0),u.set(this,void 0),d.set(this,void 0),F.set(this,void 0),_.set(this,!0),m.set(this,!0),f.set(this,!1),D.set(this,this._register(new s.Emitter)),this.onDidDispose=Ie(this,D,"f").event,l.set(this,this._register(new s.Emitter)),this.onDidChangeViewState=Ie(this,l,"f").event,Ze(this,R,g,"f"),Ze(this,w,c,"f"),Ze(this,i,h,"f"),Ze(this,o,S,"f"),Ze(this,F,a,"f"),Ze(this,u,v,"f"),Ze(this,p,I,"f")}dispose(){Ie(this,f,"f")||(Ze(this,f,!0,"f"),Ie(this,D,"f").fire(),Ie(this,w,"f").$disposeWebview(Ie(this,R,"f")),Ie(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ie(this,p,"f")}get viewType(){return this.assertNotDisposed(),Ie(this,i,"f")}get title(){return this.assertNotDisposed(),Ie(this,u,"f")}set title(g){this.assertNotDisposed(),Ie(this,u,"f")!==g&&(Ze(this,u,g,"f"),Ie(this,w,"f").$setTitle(Ie(this,R,"f"),g))}get iconPath(){return this.assertNotDisposed(),Ie(this,d,"f")}set iconPath(g){this.assertNotDisposed(),Ie(this,d,"f")!==g&&(Ze(this,d,g,"f"),Ie(this,w,"f").$setIconPath(Ie(this,R,"f"),y.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return Ie(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ie(this,F,"f")=="number"&&Ie(this,F,"f")<0))return Ie(this,F,"f")}get active(){return this.assertNotDisposed(),Ie(this,m,"f")}get visible(){return this.assertNotDisposed(),Ie(this,_,"f")}_updateViewState(g){Ie(this,f,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(Ze(this,m,g.active,"f"),Ze(this,_,g.visible,"f"),Ze(this,F,g.viewColumn,"f"),Ie(this,l,"f").fire({webviewPanel:this}))}reveal(g,c){this.assertNotDisposed(),Ie(this,w,"f").$reveal(Ie(this,R,"f"),{viewColumn:g?k.ViewColumn.from(g):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Ie(this,f,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,w=new WeakMap,i=new WeakMap,p=new WeakMap,o=new WeakMap,u=new WeakMap,d=new WeakMap,F=new WeakMap,_=new WeakMap,m=new WeakMap,f=new WeakMap,D=new WeakMap,l=new WeakMap;class r{constructor(g,c,h){this.webviews=c,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(g,c,h,v,a={}){const S=typeof v=="object"?v.viewColumn:v,I={viewColumn:k.ViewColumn.from(S),preserveFocus:typeof v=="object"&&!!v.preserveFocus},N=(0,P.shouldSerializeBuffersForPostMessage)(g),B=r.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(g),B,c,{title:h,panelOptions:n(a),webviewOptions:(0,P.serializeWebviewOptions)(g,this.workspace,a),serializeBuffersForPostMessage:N},I);const E=this.webviews.createNewWebview(B,a,g);return this.createNewWebviewPanel(B,c,h,S,a,E)}$onDidChangeWebviewPanelViewStates(g){const c=Object.keys(g);c.sort((h,v)=>{const a=g[h],S=g[v];return a.active?1:S.active?-1:+a.visible-+S.visible});for(const h of c){const v=this.getWebviewPanel(h);if(!v)continue;const a=g[h];v._updateViewState({active:a.active,visible:a.visible,viewColumn:k.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,c,h){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:h,extension:g}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(g)}),new A.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(g,c,h,v){const a=this._serializers.get(c);if(!a)throw new Error(`No serializer found for '${c}'`);const{serializer:S,extension:I}=a,N=this.webviews.createNewWebview(g,h.webviewOptions,I),B=this.createNewWebviewPanel(g,c,h.title,v,h.panelOptions,N);await S.deserializeWebviewPanel(B,h.state)}createNewWebviewPanel(g,c,h,v,a,S){const I=new M(g,this._proxy,c,h,v,a,S);return this._webviewPanels.set(g,I),I}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=r;function n(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!y:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(Z,s):y?y.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[206],_e([0,1,4,6,51,5,7]),function(Z,e,s,t,y,T,k){"use strict";var P,C,A,R,w,i,p,o,u,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class F extends t.Disposable{constructor(f,D,l,M,r,n){super();P.set(this,void 0),C.set(this,void 0),A.set(this,void 0),R.set(this,void 0),w.set(this,!1),i.set(this,void 0),p.set(this,void 0),o.set(this,void 0),u.set(this,this._register(new s.Emitter)),this.onDidChangeVisibility=Ie(this,u,"f").event,d.set(this,this._register(new s.Emitter)),this.onDidDispose=Ie(this,d,"f").event,Ze(this,A,l,"f"),Ze(this,p,M,"f"),Ze(this,P,f,"f"),Ze(this,C,D,"f"),Ze(this,R,r,"f"),Ze(this,i,n,"f")}dispose(){Ie(this,w,"f")||(Ze(this,w,!0,"f"),Ie(this,d,"f").fire(),Ie(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ie(this,p,"f")}set title(f){this.assertNotDisposed(),Ie(this,p,"f")!==f&&(Ze(this,p,f,"f"),Ie(this,C,"f").$setWebviewViewTitle(Ie(this,P,"f"),f))}get description(){return this.assertNotDisposed(),Ie(this,o,"f")}set description(f){this.assertNotDisposed(),Ie(this,o,"f")!==f&&(Ze(this,o,f,"f"),Ie(this,C,"f").$setWebviewViewDescription(Ie(this,P,"f"),f))}get visible(){return Ie(this,i,"f")}get webview(){return Ie(this,R,"f")}get viewType(){return Ie(this,A,"f")}_setVisible(f){f===Ie(this,i,"f")||Ie(this,w,"f")||(Ze(this,i,f,"f"),Ie(this,u,"f").fire())}show(f){this.assertNotDisposed(),Ie(this,C,"f").$show(Ie(this,P,"f"),!!f)}assertNotDisposed(){if(Ie(this,w,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,C=new WeakMap,A=new WeakMap,R=new WeakMap,w=new WeakMap,i=new WeakMap,p=new WeakMap,o=new WeakMap,u=new WeakMap,d=new WeakMap;class _{constructor(f,D){this._extHostWebview=D,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,D,l,M){if(this._viewProviders.has(D))throw new Error(`View provider for '${D}' already registered`);return this._viewProviders.set(D,{provider:l,extension:f}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(f),D,{retainContextWhenHidden:M?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(D),this._proxy.$unregisterWebviewViewProvider(D)})}async $resolveWebviewView(f,D,l,M,r){const n=this._viewProviders.get(D);if(!n)throw new Error(`No view provider found for '${D}'`);const{provider:b,extension:g}=n,c=this._extHostWebview.createNewWebview(f,{},g),h=new F(f,this._proxy,D,l,c,!0);this._webviewViews.set(f,h),await b.resolveWebviewView(h,{state:M},r)}async $onDidChangeWebviewViewVisibility(f,D){this.getWebviewView(f)._setVisible(D)}async $disposeWebviewView(f){const D=this.getWebviewView(f);this._webviewViews.delete(f),D.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const D=this._webviewViews.get(f);if(!D)throw new Error("No webview found");return D}}e.ExtHostWebviewViews=_}),define(ye[95],_e([0,1,4,5,2,11,9,3,13]),function(Z,e,s,t,y,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class Wi{constructor(w){this._onDidChangeWindowState=new s.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wi.InitialState,this._proxy=w.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(i=>this.$onDidChangeWindowFocus(i))}get state(){return this._state}$onDidChangeWindowFocus(w){w!==this._state.focused&&(this._state={...this._state,focused:w},this._onDidChangeWindowState.fire(this._state))}openUri(w,i){let p;if(typeof w=="string"){p=w;try{w=y.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,k.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this._proxy.$openUri(w,p,i)}async asExternalUri(w,i){if((0,k.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(w,i);return y.URI.from(p)}};A.InitialState={focused:!0},A=Be([He(0,C.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ye[207],_e([0,1,14,22,20,15,4,6,105,174,38]),function(Z,e,s,t,y,T,k,P,C,A,R){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function i(a,S){try{return JSON.stringify(a,S)}catch{return"null"}}const p="$$ref$$",o={[p]:-1};class u{constructor(S,I){this.jsonString=S,this.referencedBuffers=I}}function d(a,S=null,I=!1){const N=[];return{jsonString:(I?i:JSON.stringify)(a,(E,O)=>{if(typeof O=="undefined")return o;if(typeof O=="object"){if(O instanceof t.VSBuffer){const z=N.push(O)-1;return{[p]:z}}if(S)return S(E,O)}return O}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=d;function F(a,S,I){return JSON.parse(a,(N,B)=>{if(B){const E=B[p];if(typeof E=="number")return S[E];if(I&&B.$mid===1)return I.transformIncoming(B)}return B})}e.parseJsonAndRestoreBufferRefs=F;function _(a,S){return JSON.stringify(a,S)}function m(a){return a?(S,I)=>I&&I.$mid===1?a.transformOutgoing(I):I:null}var f;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var D;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(D=e.ResponsiveState||(e.ResponsiveState={}));const l=()=>{},M=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class n extends P.Disposable{constructor(S,I=null,N=null){super();this[w]=!0,this._onDidChangeResponsiveState=this._register(new k.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=S,this._logger=I,this._uriTransformer=N,this._uriReplacer=m(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let B=0,E=R.ProxyIdentifier.count;B<E;B++)this._locals[B]=null,this._proxies[B]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new s.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(B=>this._receiveOneMessage(B))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(S=>{this._pendingRPCReplies[S].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(S){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(S){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(S){this._responsiveState!==S&&(this._responsiveState=S,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(S){return this._uriTransformer?(0,C.transformIncomingURIs)(S,this._uriTransformer):S}getProxy(S){const{nid:I,sid:N}=S;return this._proxies[I]||(this._proxies[I]=this._createProxy(I,N)),this._proxies[I]}_createProxy(S,I){let N={get:(B,E)=>(typeof E=="string"&&!B[E]&&E.charCodeAt(0)===36&&(B[E]=(...O)=>this._remoteCall(S,E,O)),E===r?I:B[E])};return new Proxy(Object.create(null),N)}set(S,I){return this._locals[S.nid]=I,I}assertRegistered(S){for(let I=0,N=S.length;I<N;I++){const B=S[I];if(!this._locals[B.nid])throw new Error(`Missing actor ${B.sid} (isMain: ${B.isMain})`)}}_receiveOneMessage(S){if(this._isDisposed)return;const I=S.byteLength,N=b.read(S,0),B=N.readUInt8(),E=N.readUInt32();switch(B){case 1:case 2:{let{rpcId:O,method:z,args:U}=c.deserializeRequestJSONArgs(N);this._uriTransformer&&(U=(0,C.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(I,E,O,z,U,B===2);break}case 3:case 4:{let{rpcId:O,method:z,args:U}=c.deserializeRequestMixedArgs(N);this._uriTransformer&&(U=(0,C.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(I,E,O,z,U,B===4);break}case 5:{this._logger&&this._logger.logIncoming(I,E,0,"ack"),this._onDidReceiveAcknowledge(E);break}case 6:{this._receiveCancel(I,E);break}case 7:{this._receiveReply(I,E,void 0);break}case 9:{let O=c.deserializeReplyOKJSON(N);this._uriTransformer&&(O=(0,C.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReply(I,E,O);break}case 10:{const O=c.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(I,E,O);break}case 8:{let O=c.deserializeReplyOKVSBuffer(N);this._receiveReply(I,E,O);break}case 11:{let O=c.deserializeReplyErrError(N);this._uriTransformer&&(O=(0,C.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReplyErr(I,E,O);break}case 12:{this._receiveReplyErr(I,E,void 0);break}default:console.error("received unexpected message"),console.error(S)}}_receiveRequest(S,I,N,B,E,O){this._logger&&this._logger.logIncoming(S,I,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(N)}.${B}(`,E);const z=String(I);let U,$;if(O){const ue=new y.CancellationTokenSource;E.push(ue.token),U=this._invokeHandler(N,B,E),$=()=>ue.cancel()}else U=this._invokeHandler(N,B,E),$=l;this._cancelInvokedHandlers[z]=$;const V=c.serializeAcknowledged(I);this._logger&&this._logger.logOutgoing(V.byteLength,I,1,"ack"),this._protocol.send(V),U.then(ue=>{delete this._cancelInvokedHandlers[z];const K=c.serializeReplyOK(I,ue,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,I,1,"reply:",ue),this._protocol.send(K)},ue=>{delete this._cancelInvokedHandlers[z];const K=c.serializeReplyErr(I,ue);this._logger&&this._logger.logOutgoing(K.byteLength,I,1,"replyErr:",ue),this._protocol.send(K)})}_receiveCancel(S,I){this._logger&&this._logger.logIncoming(S,I,1,"receiveCancel");const N=String(I);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(S,I,N){this._logger&&this._logger.logIncoming(S,I,0,"receiveReply:",N);const B=String(I);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const E=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B],E.resolveOk(N)}_receiveReplyErr(S,I,N){this._logger&&this._logger.logIncoming(S,I,0,"receiveReplyErr:",N);const B=String(I);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const E=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B];let O;N&&(N.$isError?(O=new Error,O.name=N.name,O.message=N.message,O.stack=N.stack):O=N),E.resolveErr(O)}_invokeHandler(S,I,N){try{return Promise.resolve(this._doInvokeHandler(S,I,N))}catch(B){return Promise.reject(B)}}_doInvokeHandler(S,I,N){const B=this._locals[S];if(!B)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(S));let E=B[I];if(typeof E!="function")throw new Error("Unknown method "+I+" on actor "+(0,R.getStringIdentifierForProxy)(S));return E.apply(B,N)}_remoteCall(S,I,N){if(this._isDisposed)return Promise.reject(T.canceled());let B=null;if(N.length>0&&y.CancellationToken.isCancellationToken(N[N.length-1])&&(B=N.pop()),B&&B.isCancellationRequested)return Promise.reject(T.canceled());const E=c.serializeRequestArguments(N,this._uriReplacer),O=++this._lastMessageId,z=String(O),U=new A.LazyPromise;B&&B.onCancellationRequested(()=>{const V=c.serializeCancel(O);this._logger&&this._logger.logOutgoing(V.byteLength,O,0,"cancel"),this._protocol.send(c.serializeCancel(O))}),this._pendingRPCReplies[z]=U,this._onWillSendRequest(O);const $=c.serializeRequest(O,S,I,E,!!B);return this._logger&&this._logger.logOutgoing($.byteLength,O,0,`request: ${(0,R.getStringIdentifierForProxy)(S)}.${I}(`,N),this._protocol.send($),U}}e.RPCProtocol=n,w=M,n.UNRESPONSIVE_TIME=3*1e3;class b{constructor(S,I){this._buff=S,this._offset=I}static alloc(S,I,N){let B=new b(t.VSBuffer.alloc(N+1+4),0);return B.writeUInt8(S),B.writeUInt32(I),B}static read(S,I){return new b(S,I)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(S){this._buff.writeUInt8(S,this._offset),this._offset+=1}readUInt8(){const S=this._buff.readUInt8(this._offset);return this._offset+=1,S}writeUInt32(S){this._buff.writeUInt32BE(S,this._offset),this._offset+=4}readUInt32(){const S=this._buff.readUInt32BE(this._offset);return this._offset+=4,S}static sizeShortString(S){return 1+S.byteLength}writeShortString(S){this._buff.writeUInt8(S.byteLength,this._offset),this._offset+=1,this._buff.set(S,this._offset),this._offset+=S.byteLength}readShortString(){const S=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,N}static sizeLongString(S){return 4+S.byteLength}writeLongString(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readLongString(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,N}writeBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}static sizeVSBuffer(S){return 4+S.byteLength}writeVSBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readVSBuffer(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const I=this._buff.slice(this._offset,this._offset+S);return this._offset+=S,I}static sizeMixedArray(S){let I=0;I+=1;for(let N=0,B=S.length;N<B;N++){const E=S[N];switch(I+=1,E.type){case 1:I+=this.sizeLongString(E.value);break;case 2:I+=this.sizeVSBuffer(E.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(E.value);for(let O=0;O<E.buffers.length;++O)I+=this.sizeVSBuffer(E.buffers[O]);break;case 4:break}}return I}writeMixedArray(S){this._buff.writeUInt8(S.length,this._offset),this._offset+=1;for(let I=0,N=S.length;I<N;I++){const B=S[I];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let E=0;E<B.buffers.length;++E)this.writeBuffer(B.buffers[E]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const S=this._buff.readUInt8(this._offset);this._offset+=1;let I=new Array(S);for(let N=0;N<S;N++)switch(this.readUInt8()){case 1:I[N]=this.readLongString();break;case 2:I[N]=this.readVSBuffer();break;case 3:{const E=this.readUInt32(),O=this.readLongString(),z=[];for(let U=0;U<E;++U)z.push(this.readVSBuffer());I[N]=new R.SerializableObjectWithBuffers(F(O,z,null));break}case 4:I[N]=void 0;break}return I}}b.sizeUInt32=4;var g;(function(a){a[a.Simple=0]="Simple",a[a.Mixed=1]="Mixed"})(g||(g={}));class c{static _useMixedArgSerialization(S){for(let I=0,N=S.length;I<N;I++)if(S[I]instanceof t.VSBuffer||S[I]instanceof R.SerializableObjectWithBuffers||typeof S[I]=="undefined")return!0;return!1}static serializeRequestArguments(S,I){if(this._useMixedArgSerialization(S)){const N=[];for(let B=0,E=S.length;B<E;B++){const O=S[B];if(O instanceof t.VSBuffer)N[B]={type:2,value:O};else if(typeof O=="undefined")N[B]={type:4};else if(O instanceof R.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:U}=d(O.value,I);N[B]={type:3,value:t.VSBuffer.fromString(z),buffers:U}}else N[B]={type:1,value:t.VSBuffer.fromString(_(O,I))}}return{type:1,args:N}}return{type:0,args:_(S,I)}}static serializeRequest(S,I,N,B,E){switch(B.type){case 0:return this._requestJSONArgs(S,I,N,B.args,E);case 1:return this._requestMixedArgs(S,I,N,B.args,E)}}static _requestJSONArgs(S,I,N,B,E){const O=t.VSBuffer.fromString(N),z=t.VSBuffer.fromString(B);let U=0;U+=b.sizeUInt8(),U+=b.sizeShortString(O),U+=b.sizeLongString(z);let $=b.alloc(E?2:1,S,U);return $.writeUInt8(I),$.writeShortString(O),$.writeLongString(z),$.buffer}static deserializeRequestJSONArgs(S){const I=S.readUInt8(),N=S.readShortString(),B=S.readLongString();return{rpcId:I,method:N,args:JSON.parse(B)}}static _requestMixedArgs(S,I,N,B,E){const O=t.VSBuffer.fromString(N);let z=0;z+=b.sizeUInt8(),z+=b.sizeShortString(O),z+=b.sizeMixedArray(B);let U=b.alloc(E?4:3,S,z);return U.writeUInt8(I),U.writeShortString(O),U.writeMixedArray(B),U.buffer}static deserializeRequestMixedArgs(S){const I=S.readUInt8(),N=S.readShortString(),B=S.readMixedArray(),E=new Array(B.length);for(let O=0,z=B.length;O<z;O++){const U=B[O];typeof U=="string"?E[O]=JSON.parse(U):E[O]=U}return{rpcId:I,method:N,args:E}}static serializeAcknowledged(S){return b.alloc(5,S,0).buffer}static serializeCancel(S){return b.alloc(6,S,0).buffer}static serializeReplyOK(S,I,N){if(typeof I=="undefined")return this._serializeReplyOKEmpty(S);if(I instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(S,I);if(I instanceof R.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:E}=d(I.value,N,!0);return this._serializeReplyOKJSONWithBuffers(S,B,E)}else return this._serializeReplyOKJSON(S,i(I,N))}static _serializeReplyOKEmpty(S){return b.alloc(7,S,0).buffer}static _serializeReplyOKVSBuffer(S,I){let N=0;N+=b.sizeVSBuffer(I);let B=b.alloc(8,S,N);return B.writeVSBuffer(I),B.buffer}static deserializeReplyOKVSBuffer(S){return S.readVSBuffer()}static _serializeReplyOKJSON(S,I){const N=t.VSBuffer.fromString(I);let B=0;B+=b.sizeLongString(N);let E=b.alloc(9,S,B);return E.writeLongString(N),E.buffer}static _serializeReplyOKJSONWithBuffers(S,I,N){const B=t.VSBuffer.fromString(I);let E=0;E+=b.sizeUInt32,E+=b.sizeLongString(B);for(const z of N)E+=b.sizeVSBuffer(z);let O=b.alloc(10,S,E);O.writeUInt32(N.length),O.writeLongString(B);for(const z of N)O.writeBuffer(z);return O.buffer}static deserializeReplyOKJSON(S){const I=S.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(S,I){const N=S.readUInt32(),B=S.readLongString(),E=[];for(let O=0;O<N;++O)E.push(S.readVSBuffer());return new R.SerializableObjectWithBuffers(F(B,E,I))}static serializeReplyErr(S,I){return I?this._serializeReplyErrEror(S,I):this._serializeReplyErrEmpty(S)}static _serializeReplyErrEror(S,I){const N=t.VSBuffer.fromString(i(T.transformErrorForSerialization(I),null));let B=0;B+=b.sizeLongString(N);let E=b.alloc(11,S,B);return E.writeLongString(N),E.buffer}static deserializeReplyErrError(S){const I=S.readLongString();return JSON.parse(I)}static _serializeReplyErrEmpty(S){return b.alloc(12,S,0).buffer}}var h;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",a[a.ReplyErrError=11]="ReplyErrError",a[a.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var v;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",a[a.Undefined=4]="Undefined"})(v||(v={}))}),define(ye[208],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const s=function(T){const k=P=>{self.removeEventListener("message",k);const C=P.data;Object.defineProperties(self,{postMessage:{value(A,R){C.postMessage(A,R)}},onmessage:{get(){return C.onmessage},set(A){C.onmessage=A}}}),C.addEventListener("message",A=>{self.dispatchEvent(new MessageEvent("message",{data:A.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",k)}.toString();class t extends EventTarget{constructor(T,k,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${s})('${k}'))`,A=new Blob([C],{type:"application/javascript"}),R=URL.createObjectURL(A),w=new MessageChannel,i=R,p={type:"_newWorker",id:i,port:w.port2,url:R,options:P};T(p,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:i};w.port1.postMessage(o),URL.revokeObjectURL(R),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(o){w.port1.onmessage=o}},onmessageerror:{get(){return w.port1.onmessageerror},set(o){w.port1.onmessageerror=o}}}),w.port1.addEventListener("messageerror",o=>{const u=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(u)}),w.port1.addEventListener("message",o=>{const u=new MessageEvent("message",{data:o.data});this.dispatchEvent(u)}),w.port1.start()}}e.NestedWorker=t}),define(ye[209],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,s.createDecorator)("remoteAgentService")}),define(ye[210],_e([0,1,35,11,17,23,24,2,3,61,47,169,209]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let p=class Vi{constructor(u,d,F,_){this.localUserHome=u,this.remoteAgentService=d,this.environmentService=F,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||T.OS)(),this.resolveUserHome=(async()=>{const m=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=m?.userHome||u})()}hasValidBasename(u,d,F){return typeof d=="string"||typeof d=="undefined"?this.resolveOS.then(_=>this.doHasValidBasename(u,_,d)):this.doHasValidBasename(u,d,F)}doHasValidBasename(u,d,F){return u.scheme===t.Schemas.file||u.scheme===t.Schemas.vscodeRemote?(0,s.isValidBasename)(F??(0,k.basename)(u),d===1):!0}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(u,d){if(u.remoteAuthority)return t.Schemas.vscodeRemote;const F=(0,A.getVirtualWorkspaceScheme)(d.getWorkspace());if(F)return F;const _=d.getWorkspace().folders[0];if(_)return _.uri.scheme;const m=d.getWorkspace().configuration;return m?m.scheme:t.Schemas.file}async userHome(u){return u?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(u=>u===1?y.win32:y.posix)}async fileURI(u){let d="";if(await this.resolveOS===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const _=u.indexOf("/",2);_===-1?(d=u.substring(2),u="/"):(d=u.substring(2,_),u=u.substring(_)||"/")}return P.URI.from({scheme:t.Schemas.file,authority:d,path:u,query:"",fragment:""})}};p=Be([He(1,i.IRemoteAgentService),He(2,w.IWorkbenchEnvironmentService),He(3,R.IWorkspaceContextService)],p),e.AbstractPathService=p}),define(ye[96],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class s{constructor(k,P){this.line=k,this.character=P}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,P){return new s(0,0)}with(k){return new s(0,0)}}e.Position=s;class t{constructor(k,P,C,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(k,P),this.end=new s(C,A)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new t(0,0,0,0)}with(k){return new t(0,0,0,0)}}e.Range=t;var y;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[41],_e([0,1,16,29,26,35,9,3,17,15,96,10]),function(Z,e,s,t,y,T,k,P,C,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const i="\u27EA ",p=" characters skipped \u27EB",o=(i.length+p.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var u;(function(V){V[V.file=0]="file",V[V.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(V){V[V.File=1]="File",V[V.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function F(V){return!!V.preview}e.resultIsMatch=F;function _(V){return!!V.resource}e.isFileMatch=_;function m(V){return!!V.message}e.isProgressMessage=m;var f;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class D{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=D;class l{constructor(ue,K,re){this.ranges=K;const pe=Array.isArray(K)?K:[K];if(re&&re.matchLines===1&&M(pe)){ue=(0,k.getNLines)(ue,re.matchLines);let we="",ae=0,le=0;const Ce=Math.floor(re.charsPerLine/5),Ee=[];for(const Fe of pe){const $e=Math.max(Fe.startColumn-Ce,0),Ve=Fe.startColumn+re.charsPerLine;if($e>le+Ce+o){const je=i+($e-le)+p;we+=je+ue.slice($e,Ve),ae+=$e-(le+je.length)}else we+=ue.slice(le,Ve);Ee.push(new n(0,Fe.startColumn-ae,Fe.endColumn-ae)),le=Ve}this.preview={text:we,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const we=Array.isArray(K)?K[0].startLineNumber:K.startLineNumber;this.preview={text:ue,matches:(0,s.mapArrayOrNot)(K,ae=>new r(ae.startLineNumber-we,ae.startColumn,ae.endLineNumber-we,ae.endColumn))}}}}e.TextSearchMatch=l;function M(V){const ue=V[0].startLineNumber;for(const K of V)if(K.startLineNumber!==ue||K.endLineNumber!==ue)return!1;return!0}class r{constructor(ue,K,re,pe){this.startLineNumber=ue,this.startColumn=K,this.endLineNumber=re,this.endColumn=pe}}e.SearchRange=r;class n extends r{constructor(ue,K,re){super(ue,K,ue,re)}}e.OneLineRange=n;var b;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})(b=e.SearchSortOrder||(e.SearchSortOrder={}));function g(V,ue=!0){const K=V&&V.files&&V.files.exclude,re=ue&&V&&V.search&&V.search.exclude;if(!K&&!re)return;if(!K||!re)return K||re;let pe=Object.create(null);return pe=y.mixin(pe,y.deepClone(K)),pe=y.mixin(pe,y.deepClone(re),!0),pe}e.getExcludes=g;function c(V,ue){return V.excludePattern&&t.match(V.excludePattern,ue)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&t.match(V.includePattern,ue)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(K=>{const re=K.folder.fsPath;if(T.isEqualOrParent(ue,re)){const pe=C.relative(re,ue);return!K.includePattern||!!t.match(K.includePattern,pe)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var h;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class v extends Error{constructor(ue,K){super(ue);this.code=K}}e.SearchError=v;function a(V){const ue=V.message;if((0,A.isPromiseCanceledError)(V))return new v(ue,h.canceled);try{const K=JSON.parse(ue);return new v(K.message,K.code)}catch{return new v(ue,h.other)}}e.deserializeSearchError=a;function S(V){const ue={message:V.message,code:V.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=S;function I(V){return V.type==="error"?!0:V.type==="success"}e.isSerializedSearchComplete=I;function N(V){return V.type==="success"}e.isSerializedSearchSuccess=N;function B(V){return!!V.path}e.isSerializedFileMatch=B;function E(V,ue){const K=V.searchPath?V.searchPath:V.relativePath;return(0,k.fuzzyContains)(K,ue)}e.isFilePatternMatch=E;class O{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function z(V,ue){const K={...V||{},...ue||{}};return Object.keys(K).filter(re=>{const pe=K[re];return typeof pe=="boolean"&&pe})}e.resolvePatternsForProvider=z;class U{constructor(ue,K){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...K.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let re=ue.includePattern;K.includePattern&&(re?re={...re,...K.includePattern}:re=K.includePattern),re&&(this._parsedIncludeExpression=t.parse(re))}matchesExcludesSync(ue,K,re){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,re))}includedInQuerySync(ue,K,re){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,re)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,K,re))}includedInQuery(ue,K,re){const pe=this._parsedExcludeExpression(ue,K,re),we=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,K,re):!0;return(0,w.isPromise)(pe)?pe.then(ae=>ae?!1:we()):we()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=U;function $(V){for(const ue in V)if(typeof V[ue]!="boolean")return!0;return!1}}),define(ye[31],_e([0,1,16,14,20,4,21,11,75,24,9,10,2,124,3,12,137,47,30,28,13,7,41,5]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m,f,D,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(S,I,N){return new A.ExtUri(B=>c(B,N)).isEqual(S,I)}function n(S,I,N){return r(S.uri,I.uri,N)?0:(0,R.compare)(S.uri.toString(),I.uri.toString())}function b(S,I,N){return S.index!==I.index?S.index<I.index?-1:1:r(S.uri,I.uri,N)?(0,R.compare)(S.name,I.name):(0,R.compare)(S.uri.toString(),I.uri.toString())}function g(S,I,N,B){const E=S.slice(0).sort((z,U)=>N(z,U,B)),O=I.slice(0).sort((z,U)=>N(z,U,B));return(0,s.delta)(E,O,(z,U)=>N(z,U,B))}function c(S,I){const N=I.getCapabilities(S.scheme);return!(N&&N&1024)}class h extends F.Workspace{constructor(I,N,B,E,O,z,U){super(I,B.map($=>new F.WorkspaceFolder($)),E,O,U);this._name=N,this._isUntitled=z,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(U),B.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(I,N,B,E){if(!I)return{workspace:null,added:[],removed:[]};const{id:O,name:z,folders:U,configuration:$,transient:V,isUntitled:ue}=I,K=[],re=N;N?U.forEach((le,Ce)=>{const Ee=i.URI.revive(le.uri),Fe=h._findFolder(B||N,Ee,E);Fe?(Fe.name=le.name,Fe.index=le.index,K.push(Fe)):K.push({uri:Ee,name:le.name,index:Ce})}):K.push(...U.map(({uri:le,name:Ce,index:Ee})=>({uri:i.URI.revive(le),name:Ce,index:Ee}))),K.sort((le,Ce)=>le.index<Ce.index?-1:1);const pe=new h(O,z,K,!!V,$?i.URI.revive($):null,!!ue,le=>c(le,E)),{added:we,removed:ae}=g(re?re.workspaceFolders:[],pe.workspaceFolders,n,E);return{workspace:pe,added:we,removed:ae}}static _findFolder(I,N,B){for(let E=0;E<I.folders.length;E++){const O=I.workspaceFolders[E];if(r(O.uri,N,B))return O}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(I,N){return N&&this._structure.get(I)&&(I=(0,A.dirname)(I)),this._structure.findSubstr(I)}resolveWorkspaceFolder(I){return this._structure.get(I)}}let v=class{constructor(I,N,B,E){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=E,this._extHostFileSystemInfo=B,this._requestIdProvider=new C.Counter,this._barrier=new t.Barrier,this._proxy=I.getProxy(M.MainContext.MainThreadWorkspace),this._messageService=I.getProxy(M.MainContext.MainThreadMessageService);const O=N.workspace;this._confirmedWorkspace=O?new h(O.id,O.name,[],!!O.transient,O.configuration?i.URI.revive(O.configuration):null,!!O.isUntitled,z=>c(z,B)):void 0}$initializeWorkspace(I,N){this._trusted=N,this.$acceptWorkspaceData(I),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?i.URI.from({scheme:P.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(I,N,B,...E){const O=[];if(Array.isArray(E)&&E.forEach(ue=>{i.URI.isUri(ue.uri)&&!O.some(K=>r(K.uri,ue.uri,this._extHostFileSystemInfo))&&O.push({uri:ue.uri,name:ue.name||(0,A.basenameOrAuthority)(ue.uri)})}),this._unconfirmedWorkspace||[N,B].some(ue=>typeof ue!="number"||ue<0)||B===0&&O.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+B>z.length)return!1;const U=z.slice(0);U.splice(N,B,...O.map(ue=>({uri:ue.uri,name:ue.name||(0,A.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<U.length;ue++){const K=U[ue];if(U.some((re,pe)=>pe!==ue&&r(K.uri,re.uri,this._extHostFileSystemInfo)))return!1}U.forEach((ue,K)=>ue.index=K);const{added:$,removed:V}=g(z,U,b,this._extHostFileSystemInfo);if($.length===0&&V.length===0)return!1;if(this._proxy){const ue=I.displayName||I.name;this._proxy.$updateWorkspaceFolders(ue,N,B,O).then(void 0,K=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(d.Severity.Error,(0,p.localize)(0,null,ue,K.toString()),{extension:I},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(I,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,N)}async getWorkspaceFolder2(I,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,N)}async resolveWorkspaceFolder(I){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(I)}getPath(){if(!this._actualWorkspace)return;const{folders:I}=this._actualWorkspace;if(I.length!==0)return I[0].uri.fsPath}getRelativePath(I,N){let B,E="";if(typeof I=="string"?(B=i.URI.file(I),E=I):typeof I!="undefined"&&(B=I,E=I.fsPath),!B)return E;const O=this.getWorkspaceFolder(B,!0);if(!O)return E;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let z=(0,A.relativePath)(O.uri,B);return N&&O.name&&(z=`${O.name}/${z}`),z}trySetWorkspaceFolders(I){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:I,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(I){const{workspace:N,added:B,removed:E}=h.toExtHostWorkspace(I,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:E}))}findFiles(I,N,B,E,O=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${E.value}, entryPoint: findFiles`);let z;if(N===null?z=!1:N&&(typeof N=="string"?z=N:z=N.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:$}=a(I);return this._proxy.$startFileSearch((0,w.withUndefinedAsNull)(U),(0,w.withUndefinedAsNull)($),(0,w.withUndefinedAsNull)(z),(0,w.withUndefinedAsNull)(B),O).then(V=>Array.isArray(V)?V.map(ue=>i.URI.revive(ue)):[])}async findTextInFiles(I,N,B,E,O=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${E.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),U=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:$,folder:V}=a(N.include),ue=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,K={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:U,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:$,excludePattern:ue},re=!1;if(this._activeSearchCallbacks[z]=pe=>{if(re)return;const we=i.URI.revive(pe.resource);pe.results.forEach(ae=>{(0,l.resultIsMatch)(ae)?B({uri:we,preview:{text:ae.preview.text,matches:(0,s.mapArrayOrNot)(ae.preview.matches,le=>new D.Range(le.startLineNumber,le.startColumn,le.endLineNumber,le.endColumn))},ranges:(0,s.mapArrayOrNot)(ae.ranges,le=>new D.Range(le.startLineNumber,le.startColumn,le.endLineNumber,le.endColumn))}):B({uri:we,text:ae.text,lineNumber:ae.lineNumber})})},O.isCancellationRequested)return{};try{const pe=await this._proxy.$startTextSearch(I,(0,w.withUndefinedAsNull)(V),K,z,O);return delete this._activeSearchCallbacks[z],pe||{}}catch(pe){throw delete this._activeSearchCallbacks[z],pe}}$handleTextSearchResult(I,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](I)}saveAll(I){return this._proxy.$saveAll(I)}resolveProxy(I){return this._proxy.$resolveProxy(I)}get trusted(){return this._trusted}requestWorkspaceTrust(I){return this._proxy.$requestWorkspaceTrust(I)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};v=Be([He(0,f.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,_.IExtHostFileSystemInfo),He(3,u.ILogService)],v),e.ExtHostWorkspace=v,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function a(S){let I,N;return S&&(typeof S=="string"?I=S:(I=S.pattern,N=S.baseFolder||i.URI.file(S.base))),{includePattern:I,folder:N}}}),define(ye[32],_e([0,1,26,4,31,5,7,141,83,10,14,3,13,12,2]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(M,r){if(r){const n=r.split(".");let b=M;for(let g=0;b&&g<n.length;g++)b=b[n[g]];return b}}function d(M){return M instanceof o.URI}function F(M){return M&&M.uri instanceof o.URI&&M.languageId&&typeof M.languageId=="string"}function _(M){return M&&!M.uri&&M.languageId&&typeof M.languageId=="string"}function m(M){return M&&M.uri instanceof o.URI&&(!M.name||typeof M.name=="string")&&(!M.index||typeof M.index=="number")}function f(M){if(d(M))return{resource:M};if(F(M))return{resource:M.uri,overrideIdentifier:M.languageId};if(_(M))return{overrideIdentifier:M.languageId};if(m(M))return{resource:M.uri};if(M===null)return{resource:null}}let D=class{constructor(r,n,b){this._proxy=r.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=b,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new l(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,n){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(r,n))}};D=Be([He(0,i.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,p.ILogService)],D),e.ExtHostConfiguration=D;class l{constructor(r,n,b,g){this._onDidChangeConfiguration=new t.Emitter,this._proxy=r,this._logService=g,this._extHostWorkspace=n,this._configuration=P.Configuration.parse(b),this._configurationScopes=this._toMap(b.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,n){const b={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,b))}getConfiguration(r,n,b){const g=f(n)||{},c=this._toReadonlyValue(r?u(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,g,b?.identifier);function h(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const v={has(a){return typeof u(c,a)!="undefined"},get:(a,S)=>{this._validateConfigurationAccess(r?`${r}.${a}`:a,g,b?.identifier);let I=u(c,a);if(typeof I=="undefined")I=S;else{let N;const B=(E,O)=>{let z;const U=()=>{N=N||(0,s.deepClone)(c),z=z||u(N,O)};return(0,A.isObject)(E)?new Proxy(E,{get:($,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return U(),()=>z;if(N)return z=z||u(N,O),z[V];const ue=$[V];return typeof V=="string"?B(ue,`${O}.${V}`):ue},set:($,V,ue)=>(U(),z&&(z[V]=ue),!0),deleteProperty:($,V)=>(U(),z&&delete z[V],!0),defineProperty:($,V,ue)=>(U(),z&&Object.defineProperty(z,V,ue),!0)}):E};I=B(I,a)}return I},update:(a,S,I,N)=>{a=r?`${r}.${a}`:a;const B=h(I);return S!==void 0?this._proxy.$updateConfigurationOption(B,a,S,g,N):this._proxy.$removeConfigurationOption(B,a,g,N)},inspect:a=>{a=r?`${r}.${a}`:a;const S=(0,s.deepClone)(this._configuration.inspect(a,g,this._extHostWorkspace.workspace));if(S)return{key:a,defaultValue:S.default?.value,globalValue:S.user?.value,workspaceValue:S.workspace?.value,workspaceFolderValue:S.workspaceFolder?.value,defaultLanguageValue:S.default?.override,globalLanguageValue:S.user?.override,workspaceLanguageValue:S.workspace?.override,workspaceFolderLanguageValue:S.workspaceFolder?.override,languageIds:S.overrideIdentifiers}}};return typeof c=="object"&&(0,s.mixin)(v,c,!1),Object.freeze(v)}_toReadonlyValue(r){const n=b=>(0,A.isObject)(b)?new Proxy(b,{get:(g,c)=>n(g[c]),set:(g,c,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(g,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(g,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return n(r)}_validateConfigurationAccess(r,n,b){const g=C.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),c=b?`[${b.value}] `:"";if(g===4){typeof n?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){n?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,n){const b=new P.ConfigurationChangeEvent(r,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,c)=>b.affectsConfiguration(g,f(c))})}_toMap(r){return r.reduce((n,b)=>(n.set(b[0],b[1]),n),new Map)}}e.ExtHostConfigProvider=l,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!y:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(Z,s):y?y.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[97],_e([0,1,2,14,4,5,7,31,49,32,20,40,13,28,3,11,23,12,69,160,15]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m,f){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var l;(function(O){function z($){if($!=null)return $}O.from=z;function U($){if($!=null)return $}O.to=U})(l=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var M;(function(O){function z($){if($!=null)return $}O.from=z;function U($){if($!=null)return $}O.to=U})(M=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(O){function z($){if($!=null)return $}O.from=z;function U($){if($!=null)return $}O.to=U})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(O){function z(V){if(V){const ue=V;return ue&&!!ue.process}else return!1}O.is=z;function U(V){if(V==null)return;const ue={process:V.process,args:V.args};return V.options&&(ue.options=r.from(V.options)),ue}O.from=U;function $(V){if(V!=null)return new k.ProcessExecution(V.process,V.args,V.options)}O.to=$})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var b;(function(O){function z($){if($!=null)return $}O.from=z;function U($){if($!=null)return $}O.to=U})(b=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var g;(function(O){function z(V){if(V){const ue=V;return ue&&(!!ue.commandLine||!!ue.command)}else return!1}O.is=z;function U(V){if(V==null)return;const ue={};return V.commandLine!==void 0?ue.commandLine=V.commandLine:(ue.command=V.command,ue.args=V.args),V.options&&(ue.options=b.from(V.options)),ue}O.from=U;function $(V){if(!(V==null||V.command===void 0&&V.commandLine===void 0))return V.commandLine?new k.ShellExecution(V.commandLine,V.options):new k.ShellExecution(V.command,V.args?V.args:[],V.options)}O.to=$})(g=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(O){function z(V){if(V){let ue=V;return ue&&ue.customExecution==="customExecution"}else return!1}O.is=z;function U(V){return{customExecution:"customExecution"}}O.from=U;function $(V,ue){return ue.get(V)}O.to=$})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(O){function z(U,$){let V;return U.scope!==void 0&&typeof U.scope!="number"?V=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===k.TaskScope.Workspace&&$&&$.workspaceFile?V=$.workspaceFile:V=m.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:V}}O.from=z})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(O){function z(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}O.from=z})(v=e.TaskGroupDTO||(e.TaskGroupDTO={}));var a;(function(O){function z(V,ue){if(V==null)return[];const K=[];for(let re of V){const pe=U(re,ue);pe&&K.push(pe)}return K}O.fromMany=z;function U(V,ue){if(V==null)return;let K;V.execution instanceof k.ProcessExecution?K=n.from(V.execution):V.execution instanceof k.ShellExecution?K=g.from(V.execution):V.execution&&V.execution instanceof k.CustomExecution&&(K=c.from(V.execution));const re=l.from(V.definition);let pe;return V.scope?typeof V.scope=="number"?pe=V.scope:pe=V.scope.uri:pe=k.TaskScope.Workspace,!re||!pe?void 0:{_id:V._id,definition:re,name:V.name,source:{extensionId:ue.identifier.value,label:V.source,scope:pe},execution:K,isBackground:V.isBackground,group:v.from(V.group),presentationOptions:M.from(V.presentationOptions),problemMatchers:V.problemMatchers,hasDefinedMatchers:V.hasDefinedMatchers,runOptions:V.runOptions?V.runOptions:{reevaluateOnRerun:!0},detail:V.detail}}O.from=U;async function $(V,ue,K){if(V==null)return;let re;n.is(V.execution)?re=n.to(V.execution):g.is(V.execution)?re=g.to(V.execution):c.is(V.execution)&&(re=c.to(V._id,K));const pe=l.to(V.definition);let we;if(V.source&&(V.source.scope!==void 0?typeof V.source.scope=="number"?we=V.source.scope:we=await ue.resolveWorkspaceFolder(s.URI.revive(V.source.scope)):we=k.TaskScope.Workspace),!pe||!we)return;const ae=new k.Task(pe,we,V.name,V.source.label,re,V.problemMatchers);return V.isBackground!==void 0&&(ae.isBackground=V.isBackground),V.group!==void 0&&(ae.group=k.TaskGroup.from(V.group._id),ae.group&&V.group.isDefault&&(ae.group=new k.TaskGroup(ae.group.id,ae.group.label),V.group.isDefault&&(ae.group.isDefault=V.group.isDefault))),V.presentationOptions&&(ae.presentationOptions=M.to(V.presentationOptions)),V._id&&(ae._id=V._id),V.detail&&(ae.detail=V.detail),ae}O.to=$})(a=e.TaskDTO||(e.TaskDTO={}));var S;(function(O){function z($){return $}O.from=z;function U($){if(!!$)return Object.assign(Object.create(null),$)}O.to=U})(S=e.TaskFilterDTO||(e.TaskFilterDTO={}));class I{constructor(z,U,$){this._id=U,this._task=$,D.set(this,void 0),Ze(this,D,z,"f")}get task(){return this._task}terminate(){Ie(this,D,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}D=new WeakMap;var N;(function(O){function z(U){return{id:U._id,task:void 0}}O.from=z})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(z,U,$,V,ue,K,re,pe){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=z.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=V,this._configurationService=ue,this._terminalService=K,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=re,this._deprecationService=pe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,U,$){if(!$)return new k.Disposable(()=>{});const V=this.nextHandle();return this._handlers.set(V,{type:U,provider:$,extension:z}),this._proxy.$registerTaskProvider(V,U),new k.Disposable(()=>{this._handlers.delete(V),this._proxy.$unregisterTaskProvider(V)})}registerTaskSystem(z,U){this._proxy.$registerTaskSystem(z,U)}fetchTasks(z){return this._proxy.$fetchTasks(S.from(z)).then(async U=>{const $=[];for(let V of U){const ue=await a.to(V,this._workspaceProvider,this._providedCustomExecutions2);ue&&$.push(ue)}return $})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(U=>z.push(U)),z}terminateTask(z){if(!(z instanceof I))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,U,$){const V=this._providedCustomExecutions2.get(z.id);V&&(this._activeCustomExecutions2.set(z.id,V),this._terminalService.attachPtyToTerminal(U,await V.callback($))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const U=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:U})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const U=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:U,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const U=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:U,exitCode:z.exitCode})}$provideTasks(z,U){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));const V=[],ue=(0,t.asPromise)(()=>$.provider.provideTasks(R.CancellationToken.None)).then(K=>this.provideTasksInternal(U,V,$,K));return new Promise(K=>{ue.then(re=>{Promise.all(V).then(()=>{K(re)})})})}async $resolveTask(z,U){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));if(U.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${$.type}].`);const V=await a.to(U,this._workspaceProvider,this._providedCustomExecutions2);if(!V)throw new Error("Unexpected: Task cannot be resolved.");const ue=await $.provider.resolveTask(V,R.CancellationToken.None);if(!ue)return;this.checkDeprecation(ue,$);const K=a.from(ue,$.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(ue.definition!==V.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(K.execution)&&await this.addCustomExecution(K,ue,!0),await this.resolveTaskInternal(K)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,U,$){const V=await this._proxy.$createTaskId(z);!$&&!this._providedCustomExecutions2.has(V)&&(this._notProvidedCustomExecutions.add(V),this._activeCustomExecutions2.set(V,U.execution)),this._providedCustomExecutions2.set(V,U.execution)}async getTaskExecution(z,U){if(typeof z=="string"){const ue=this._taskExecutionPromises.get(z);if(!ue)throw new Error("Unexpected: The specified task is missing an execution");return ue}let $=this._taskExecutionPromises.get(z.id);if($)return $;const V=new Promise((ue,K)=>{function re(pe,we,ae){ae?ue(new I(pe,we.id,ae)):K("Unexpected: Task does not exist.")}U?re(this,z,U):a.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(pe=>re(this,z,pe))});return this._taskExecutionPromises.set(z.id,V),V.then(ue=>(this._taskExecutions.set(z.id,ue),ue),ue=>Promise.reject(ue))}checkDeprecation(z,U){z._deprecated&&this._deprecationService.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let $=this._notProvidedCustomExecutions.values(),V=$.next();for(;!V.done;)!this._activeCustomExecutions2.has(V.value)&&this._lastStartedTask!==V.value&&(this._providedCustomExecutions2.delete(V.value),this._notProvidedCustomExecutions.delete(V.value)),V=$.next()}};B=Be([He(0,i.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,A.IExtHostConfiguration),He(5,w.IExtHostTerminalService),He(6,F.ILogService),He(7,_.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let E=class extends B{constructor(z,U,$,V,ue,K,re,pe){super(z,U,$,V,ue,K,re,pe);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(z,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const $=a.from(U,z);if($===void 0)throw new Error("Task is not valid");if(c.is($.execution))await this.addCustomExecution($,U,!1);else throw new f.NotSupportedError;const V=await this.getTaskExecution(await this._proxy.$getTaskExecution($),U);return this._proxy.$executeTask($).catch(ue=>{throw new Error(ue)}),V}provideTasksInternal(z,U,$,V){const ue=[];if(V)for(let K of V){this.checkDeprecation(K,$),(!K.definition||!z[K.definition.type])&&this._logService.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const re=a.from(K,$.extension);re&&c.is(re.execution)?(ue.push(re),U.push(this.addCustomExecution(re,K,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ue,extension:$.extension}}async resolveTaskInternal(z){if(c.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,U,$){}};E=Be([He(0,i.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,A.IExtHostConfiguration),He(5,w.IExtHostTerminalService),He(6,F.ILogService),He(7,_.IExtHostApiDeprecationService)],E),e.WorkerExtHostTask=E,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(ye[211],_e([0,1,16,74,29,78,21,11,17,24,9,10,2,232,127,81,47,90,210,41]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(h,v,a,S){this.configurationService=h,this.workspaceContextService=v,this.editorGroupsService=a,this.pathService=S}text(h,v,a={}){h=this.getContentPattern(h,a);const S=this.configurationService.getValue(),I=v&&v.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(v?.map(d.toWorkspaceFolder),a),type:2,contentPattern:h,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:S.search.usePCRE2||I||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles}}getContentPattern(h,v){const a=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const S={...h,wordSeparators:a.editor.wordSeparators};return this.isCaseSensitive(h,v)&&(S.isCaseSensitive=!0),this.isMultiline(h)&&(S.isMultiline=!0),S}file(h,v={}){return{...this.commonQuery(h,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}handleIncludeExclude(h,v){return h?(h=Array.isArray(h)?h.map(n):n(h),v?this.parseSearchPaths(h):{pattern:l(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],v={}){const a=this.handleIncludeExclude(v.includePattern,v.expandPatterns),S=this.handleIncludeExclude(v.excludePattern,v.expandPatterns),I=h.length>1,N=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,v,S)):h.map(O=>this.getFolderQueryForRoot(O,v,S,I))).filter(O=>!!O),B={_reason:v._reason,folderQueries:N,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:S.pattern,includePattern:a.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const z=s.coalesce(s.flatten(this.editorGroupsService.groups.map($=>$.editors.map(V=>V.resource)))).filter($=>(0,m.pathIncludedInQuery)(B,$.fsPath)),U=this.commonQueryFromFileList(z);return{...B,...U}}const E=v.extraFileResources&&v.extraFileResources.filter(O=>(0,m.pathIncludedInQuery)(B,O.fsPath));return B.extraFileResources=E&&E.length?E:void 0,B}commonQueryFromFileList(h){const v=[],a=new k.ResourceMap,S={};let I=!1;return h.forEach(N=>{if(N.scheme===P.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(N)){const E=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:C.dirname(N.fsPath)});let O=a.get(E);O||(I=!0,O={folder:E,includePattern:{}},v.push(O),a.set(E,O));const z=C.relative(E.fsPath,N.fsPath);(0,w.assertIsDefined)(O.includePattern)[z.replace(/\\/g,"/")]=!0}else N.fsPath&&(I=!0,S[N.fsPath]=!0)}),{folderQueries:v,includePattern:S,usingSearchPaths:!0,excludePattern:I?void 0:{"**/*":!0}}}isCaseSensitive(h,v){if(v.isSmartCase){if(h.isRegExp){if(R.containsUppercaseCharacter(h.pattern,!0))return!0}else if(R.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,p.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const v=U=>C.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),S=(Array.isArray(h)?h:M(h)).map(U=>{const $=this.pathService.resolvedUserHome;return $?(0,T.untildify)(U,$.scheme===P.Schemas.file?$.fsPath:$.path):U}),I=t.groupBy(S,U=>v(U)?"searchPaths":"exprSegments"),N=(I.exprSegments||[]).map(U=>R.rtrim(U,"/")).map(U=>R.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),r(U))),B={},E=this.expandSearchPathPatterns(I.searchPaths||[]);E&&E.length&&(B.searchPaths=E);const O=s.flatten(N),z=l(...O);return z&&(B.pattern=z),B}getExcludesForFolder(h,v){return v.disregardExcludeSettings?void 0:(0,m.getExcludes)(h,!v.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const v=s.flatten(h.map(S=>{let{pathPortion:I,globPortion:N}=D(S);N&&(N=b(N));const B=this.expandOneSearchPath(I);return s.flatten(B.map(E=>this.resolveOneSearchPathPattern(E,N)))})),a=new Map;return v.forEach(S=>{const I=S.searchPath.toString(),N=a.get(I);N?S.pattern&&(N.pattern=N.pattern||{},N.pattern[S.pattern]=!0):a.set(I,{searchPath:S.searchPath,pattern:S.pattern?l(S.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(h){if(C.isAbsolute(h)){const v=this.workspaceContextService.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==P.Schemas.file?[{searchPath:v[0].uri.with({path:h})}]:[{searchPath:i.URI.file(C.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const v=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=n(h),h.startsWith("../")||h===".."){const S=C.posix.resolve(v.path,h);return[{searchPath:v.with({path:S})}]}const a=b(h);return[{searchPath:v,pattern:a}]}else{if(h==="./"||h===".\\")return[];{const v=h.replace(/^\.[\/\\]/,""),S=this.workspaceContextService.getWorkspace().folders.map(I=>{const N=v.match(new RegExp(`^${R.escapeRegExpCharacters(I.name)}(?:/(.*)|$)`));return N?{match:N,folder:I}:null}).filter(w.isDefined);if(S.length)return S.map(I=>{const N=I.match[1];return{searchPath:I.folder.uri,pattern:N&&b(N)}});{const I=h.match(/\.[\/\\](.+)[\/\\]?/),N=I?I[1]:h,B=o.localize(0,null,N);throw new Error(B)}}}}resolveOneSearchPathPattern(h,v){const a=h.pattern&&v?`${h.pattern}/${v}`:h.pattern||v,S=[{searchPath:h.searchPath,pattern:a}];return a&&!a.endsWith("**")&&S.push({searchPath:h.searchPath,pattern:a+"/**"}),S}getFolderQueryForSearchPath(h,v,a){const S=this.getFolderQueryForRoot((0,d.toWorkspaceFolder)(h.searchPath),v,a,!1);return S?{...S,includePattern:h.pattern}:null}getFolderQueryForRoot(h,v,a,S){let I;const N=i.URI.isUri(h)?h:h.uri;if(a.searchPaths){const U=a.searchPaths.filter($=>(0,A.isEqual)($.searchPath,N))[0];if(U&&!U.pattern)return null;U&&(I=U.pattern)}const B=this.configurationService.getValue({resource:N}),O={...this.getExcludesForFolder(B,v)||{},...I||{}},z=i.URI.isUri(h)?(0,A.basename)(h):h.name;return{folder:N,folderName:S?z:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!B.search.followSymlinks}}};f=Be([He(0,u.IConfigurationService),He(1,d.IWorkspaceContextService),He(2,F.IEditorGroupsService),He(3,_.IPathService)],f),e.QueryBuilder=f;function D(c){const h=c.match(/[\*\{\}\(\)\[\]\?]/);if(h){const v=h.index,a=c.substr(0,v).match(/[/|\\][^/\\]*$/);if(a){let S=c.substr(0,a.index);return S.match(/[/\\]/)||(S+="/"),{pathPortion:S,globPortion:c.substr((a.index||0)+1)}}}return{pathPortion:c}}function l(...c){return c.length?c.reduce((h,v)=>(h[v]=!0,h),Object.create(null)):void 0}function M(c){return y.splitGlobAware(c,",").map(h=>h.trim()).filter(h=>!!h.length)}function r(c){return[`**/${c}/**`,`**/${c}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function n(c){return c.replace(/\\/g,"/")}function b(c){return n(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(c,h){c=s.distinct(c,S=>S.toString());const v=[],a=h.getWorkspace();return c&&c.forEach(S=>{let I;if(h.getWorkbenchState()===2)I=(0,A.relativePath)(a.folders[0].uri,S),I&&I!=="."&&(I="./"+I);else{const N=h.getWorkspaceFolder(S);if(N){const B=N.name;if(a.folders.filter(O=>O.name===B).length===1){const O=(0,A.relativePath)(N.uri,S);O===""?I=`./${N.name}`:I=`./${N.name}/${O}`}else I=S.fsPath}}I&&v.push(I)}),v}e.resolveResourcesForSearchIncludes=g}),define(ye[212],_e([0,1,24,2,20,15,3,211,41,47]),function(Z,e,s,t,y,T,k,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function w(u,d){const F=d.activationEvents;if(!F)return Promise.resolve(void 0);const _=[],m=[];for(const n of F)if(/^workspaceContains:/.test(n)){const b=n.substr("workspaceContains:".length);b.indexOf("*")>=0||b.indexOf("?")>=0||u.forceUsingSearch?m.push(b):_.push(b)}if(_.length===0&&m.length===0)return Promise.resolve(void 0);let f;const D=new Promise((n,b)=>{f=n}),l=n=>f({activationEvent:n}),M=Promise.all(_.map(n=>i(u,n,l))).then(()=>{}),r=p(u,d.identifier,m,l);return Promise.all([M,r]).then(()=>{f(void 0)}),D}e.checkActivateWorkspaceContainsExtension=w;async function i(u,d,F){for(const _ of u.folders)if(await u.exists(s.joinPath(t.URI.revive(_),d))){F(`workspaceContains:${d}`);return}}async function p(u,d,F,_){if(F.length===0)return Promise.resolve(void 0);const m=new y.CancellationTokenSource,f=u.checkExists(u.folders,F,m.token),D=setTimeout(async()=>{m.cancel(),u.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${F.join(",")}`)},R);let l=!1;try{l=await f}catch(M){T.isPromiseCanceledError(M)||T.onUnexpectedError(M)}m.dispose(),clearTimeout(D),l&&_(`workspaceContains:${F.join(",")}`)}function o(u,d,F,_){const m=u.get(k.IInstantiationService),f=u.get(C.ISearchService),l=m.createInstance(P.QueryBuilder).file(d.map(M=>(0,A.toWorkspaceFolder)(t.URI.revive(M))),{_reason:"checkExists",includePattern:F,exists:!0});return f.fileSearch(l,_).then(M=>!!M.limitHit,M=>T.isPromiseCanceledError(M)?!1:Promise.reject(M))}e.checkGlobFileExists=o});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!y:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(Z,s):y?y.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[33],_e([0,1,119,17,73,24,14,6,21,2,12,5,32,172,71,31,27,170,15,25,22,146,7,84,3,28,72,13,60,64,40,4,212,68,148,11]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m,f,D,l,M,r,n,b,g,c,h,v,a,S,I,N,B){"use strict";var E,O,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let U=class ji extends P.Disposable{constructor(K,re,pe,we,ae,le,Ce,Ee,Fe,$e){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=re,this._extHostContext=pe,this._initData=Ce,this._extHostWorkspace=we,this._extHostConfiguration=ae,this._logService=le,this._extHostTunnelService=Fe,this._extHostTerminalService=$e,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(w.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(w.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(w.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new F.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new I.ExtHostSecretState(this._extHostContext),this._storagePath=Ee,this._instaService=K.createChild(new c.ServiceCollection([o.IExtHostStorage,this._storage],[I.IExtHostSecretState,this._secretState]));const Ve=new Set;this._initData.hostExtensions.forEach(je=>Ve.add(m.ExtensionIdentifier.toKey(je))),this._activator=this._register(new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(je,H,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(je,_.transformErrorForSerialization(H),G)},actualActivateExtension:async(je,H)=>{if(Ve.has(m.ExtensionIdentifier.toKey(je)))return await this._mainThreadExtensionsProxy.$activateExtension(je,H),new p.HostExtension;const G=this._registry.getExtensionDescription(je);return this._activateExtension(G,H)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(K){_.onUnexpectedError(K)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let K=[];try{K=this._registry.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this._deactivate(ae))}catch{}await Promise.all(K)}isActivated(K){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(K):!1}_activateByEvent(K,re){return this._activator.activateByEvent(K,re)}_activateById(K,re){return this._activator.activateById(K,re)}activateByIdWithErrors(K,re){return this._activateById(K,re).then(()=>{const pe=this._activator.getActivatedExtension(K);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(K=>this._registry)}getExtensionExports(K){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(K).exports:null}async _realPathExtensionUri(K){if(K.scheme!==B.Schemas.file)return K;const re=await this._hostUtils.realpath(K.fsPath);return A.URI.file(re)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const K=C.TernarySearchTree.forUris(re=>T.extUriBiasedIgnorePathCase.ignorePathCasing(re));for(const re of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(re)){const pe=await this._realPathExtensionUri(re.extensionLocation);K.set(pe,re)}return K})()),this._extensionPathIndex}_deactivate(K){let re=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(K))return re;const pe=this._activator.getActivatedExtension(K);if(!pe)return re;try{typeof pe.module.deactivate=="function"&&(re=Promise.resolve(pe.module.deactivate()).then(void 0,we=>(this._logService.error(we),Promise.resolve(void 0))))}catch(we){this._logService.error(`An error occurred when deactivating the extension '${K.value}':`),this._logService.error(we)}try{(0,P.dispose)(pe.subscriptions)}catch(we){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this._logService.error(we)}return re}async _activateExtension(K,re){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier),this._doActivateExtension(K,re).then(pe=>{const we=pe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(K.identifier,we.codeLoadingTime,we.activateCallTime,we.activateResolvedTime,re),this._logExtensionActivationTimes(K,re,"success",we),pe},pe=>{throw this._logExtensionActivationTimes(K,re,"failure"),pe})}_logExtensionActivationTimes(K,re,pe,we){const ae=$(K,re);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ae,...we||{},outcome:pe})}_doActivateExtension(K,re){const pe=$(K,re);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",pe);const we=this._getEntryPoint(K);if(!we)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${re.startup}, activationEvent: '${re.activationEvent}'${K.identifier.value!==re.extensionId.value?`, root cause: ${re.extensionId.value}`:""}`),this._logService.flush();const ae=new p.ExtensionActivationTimesBuilder(re.startup);return Promise.all([this._loadCommonJSModule(K.identifier,(0,T.joinPath)(K.extensionLocation,we),ae),this._loadExtensionContext(K)]).then(le=>(y.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),ji._callActivate(this._logService,K.identifier,le[0],le[1],ae))).then(le=>(y.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),le))}_loadExtensionContext(K){const re=new D.ExtensionGlobalMemento(K,this._storage),pe=new D.ExtensionMemento(K.identifier.value,!1,this._storage),we=new N.ExtensionSecrets(K,this._secretState),ae=K.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,le=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([re.whenReady,pe.whenReady,this._storagePath.whenReady]).then(()=>{const Ce=this;let Ee;return Object.freeze({globalState:re,workspaceState:pe,secrets:we,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(Fe){return t.join(K.extensionLocation.fsPath,Fe)},get storagePath(){return Ce._storagePath.workspaceValue(K)?.fsPath},get globalStoragePath(){return Ce._storagePath.globalValue(K).fsPath},get logPath(){return t.join(Ce._initData.logsLocation.fsPath,K.identifier.value)},get logUri(){return A.URI.joinPath(Ce._initData.logsLocation,K.identifier.value)},get storageUri(){return Ce._storagePath.workspaceValue(K)},get globalStorageUri(){return Ce._storagePath.globalValue(K)},get extensionMode(){return ae},get extension(){return Ee===void 0&&(Ee=new V(Ce,K.identifier,K,le)),Ee},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(K,"extensionRuntime"),Ce.extensionRuntime},get environmentVariableCollection(){return Ce._extHostTerminalService.getEnvironmentVariableCollection(K)}})})}static _callActivate(K,re,pe,we,ae){return pe=pe||{activate:void 0,deactivate:void 0},this._callActivateOptional(K,re,pe,we,ae).then(le=>new p.ActivatedExtension(!1,null,ae.build(),pe,le,we.subscriptions))}static _callActivateOptional(K,re,pe,we,ae){if(typeof pe.activate=="function")try{ae.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${re.value}`);const le=typeof global=="object"?global:self,Ce=pe.activate.apply(le,[we]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(Ce).then(Ee=>(ae.activateResolveStop(),Ee))}catch(le){return Promise.reject(le)}else return Promise.resolve(pe)}_activateOneStartupFinished(K,re){this._activateById(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:re}).then(void 0,pe=>{this._logService.error(pe)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const K of this._registry.getAllExtensionDescriptions())if(K.activationEvents)for(const re of K.activationEvents)re==="onStartupFinished"&&this._activateOneStartupFinished(K,re)}_handleEagerExtensions(){const K=this._activateByEvent("*",!0).then(void 0,ae=>{this._logService.error(ae)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ae=>this._handleWorkspaceContainsEagerExtensions(ae.added)));const re=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],pe=this._handleWorkspaceContainsEagerExtensions(re),we=Promise.all([K,pe]).then(()=>{});return Promise.race([we,(0,k.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),we}_handleWorkspaceContainsEagerExtensions(K){return K.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(re=>this._handleWorkspaceContainsEagerExtension(K,re))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(K,re){if(this.isActivated(re.identifier))return;const pe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,we={logService:this._logService,folders:K.map(le=>le.uri),forceUsingSearch:pe,exists:le=>this._hostUtils.exists(le.fsPath),checkExists:(le,Ce,Ee)=>this._mainThreadWorkspaceProxy.$checkExists(le,Ce,Ee)},ae=await(0,S.checkActivateWorkspaceContainsExtension)(we,re);if(!!ae)return this._activateById(re.identifier,{startup:!0,extensionId:re.identifier,activationEvent:ae.activationEvent}).then(void 0,le=>this._logService.error(le))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(K){throw console.error(K),K}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:re}=this._initData.environment;if(!K||!re)throw new Error(s.localize(0,null));const pe=await this._loadCommonJSModule(null,re,new p.ExtensionActivationTimesBuilder(!1));if(!pe||typeof pe.run!="function")throw new Error(s.localize(1,null,re.toString()));return new Promise((we,ae)=>{const le=(Fe,$e)=>{Fe?ae(Fe):we(typeof $e=="number"&&$e>0?1:0)},Ce=(0,T.originalFSPath)(re),Ee=pe.run(Ce,le);Ee&&Ee.then&&Ee.then(()=>{we(0)}).catch(Fe=>{ae(Fe instanceof Error&&Fe.stack?Fe.stack:String(Fe))})})}async $extensionTestsExit(K){this._logService.info(`Extension host terminating: test runner requested exit with code ${K}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${K}`),this._logService.flush(),this._hostUtils.exit(K)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,re){return this._resolvers[K]=re,(0,P.toDisposable)(()=>{delete this._resolvers[K]})}async _activateAndGetResolver(K){const re=K.indexOf("+");if(re===-1)throw new Error("Not an authority that can be resolved!");const pe=K.substr(0,re);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this._resolvers[pe]}}async $resolveAuthority(K,re){const{authorityPrefix:pe,resolver:we}=await this._activateAndGetResolver(K);if(!we)return{type:"error",error:{code:M.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${pe}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(we)),y.mark(`code/extHost/willResolveAuthority/${pe}`);const ae=await we.resolve(K,{resolveAttempt:re});y.mark(`code/extHost/didResolveAuthorityOK/${pe}`);const le={authority:K,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},Ce={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:le,options:Ce,tunnelInformation:{environmentTunnels:ae.environmentTunnels}}}}catch(ae){if(y.mark(`code/extHost/didResolveAuthorityError/${pe}`),ae instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(K,re){const{authorityPrefix:pe,resolver:we}=await this._activateAndGetResolver(K);if(!we)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${pe}`);const ae=A.URI.revive(re);if(typeof we.getCanonicalURI=="undefined")return ae;const le=await(0,k.asPromise)(()=>we.getCanonicalURI(ae));return le||ae}$startExtensionHost(K){return this._registry.keepOnly(K),this._startExtensionHost()}$activateByEvent(K,re){return re===1?this._activateByEvent(K,!1):this._readyToRunExtensions.wait().then(pe=>this._activateByEvent(K,!1))}async $activate(K,re){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(K)?(await this._activateById(K,re),!0):!1}async $deltaExtensions(K,re){K.forEach(we=>we.extensionLocation=A.URI.revive(we.extensionLocation));const pe=await this.getExtensionPathIndex();return await Promise.all(re.map(async we=>{const ae=this._registry.getExtensionDescription(we);ae&&pe.delete(await this._realPathExtensionUri(ae.extensionLocation))})),await Promise.all(K.map(async we=>{const ae=await this._realPathExtensionUri(we.extensionLocation);pe.set(ae,we)})),this._registry.deltaExtensions(K,re),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){let re=f.VSBuffer.alloc(K),pe=Math.random()%256;for(let we=0;we<K;we++)re.writeUInt8(pe,we);return re}async $updateRemoteConnectionData(K){this._remoteConnectionData=K,this._onDidChangeRemoteConnectionData.fire()}};U=Be([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,g.IExtHostRpcService),He(3,u.IExtHostWorkspace),He(4,i.IExtHostConfiguration),He(5,R.ILogService),He(6,n.IExtHostInitDataService),He(7,b.IExtensionStoragePaths),He(8,h.IExtHostTunnelService),He(9,v.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function $(ue,K){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class V{constructor(K,re,pe,we){E.set(this,void 0),O.set(this,void 0),z.set(this,void 0),Ze(this,E,K,"f"),Ze(this,O,re,"f"),Ze(this,z,pe.identifier,"f"),this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=t.normalize((0,T.originalFSPath)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=we}get isActive(){return Ie(this,E,"f").isActivated(Ie(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ie(this,E,"f").getExtensionExports(Ie(this,z,"f"))}activate(){return Ie(this,E,"f").activateByIdWithErrors(Ie(this,z,"f"),{startup:!1,extensionId:Ie(this,O,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=V,E=new WeakMap,O=new WeakMap,z=new WeakMap}),define(ye[98],_e([0,1,17,2,4,14,5,7,155,31,33,49,162,32,156,13,3,10,89,70]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,d.createDecorator)("IExtHostDebugService");let f=class{constructor(c,h,v,a,S,I){this._workspaceService=h,this._extensionService=v,this._editorsService=a,this._configurationService=S,this._editorTabs=I,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=c.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange(B=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,h){const v=c;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let a=`debug:${encodeURIComponent(v.path||"")}`,S="?";return h&&(a+=`${S}session=${encodeURIComponent(h.id)}`,S="&"),a+=`${S}ref=${v.sourceReference}`,t.URI.parse(a)}else{if(v.path)return t.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const h=[];for(const v of c.getAllExtensionDescriptions())if(v.contributes){const a=v.contributes.debuggers;if(a&&a.length>0)for(const S of a)(0,o.isDebuggerMainContribution)(S)&&h.push(S.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(h=>c.push(h)),c}addBreakpoints(c){this.startBreakpoints();const h=c.filter(S=>{const I=S.id;return this._breakpoints.has(I)?!1:(this._breakpoints.set(I,S),!0)});this.fireBreakpointChanges(h,[],[]);const v=[],a=new Map;for(const S of h)if(S instanceof P.SourceBreakpoint){let I=a.get(S.location.uri.toString());I||(I={type:"sourceMulti",uri:S.location.uri,lines:[]},a.set(S.location.uri.toString(),I),v.push(I)),I.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character})}else S instanceof P.FunctionBreakpoint&&v.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName});return this._debugServiceProxy.$registerBreakpoints(v)}removeBreakpoints(c){this.startBreakpoints();const h=c.filter(I=>this._breakpoints.delete(I.id));this.fireBreakpointChanges([],h,[]);const v=h.filter(I=>I instanceof P.SourceBreakpoint).map(I=>I.id),a=h.filter(I=>I instanceof P.FunctionBreakpoint).map(I=>I.id),S=h.filter(I=>I instanceof P.DataBreakpoint).map(I=>I.id);return this._debugServiceProxy.$unregisterBreakpoints(v,a,S)}startDebugging(c,h,v){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,h,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,debugUI:v.debugUI,suppressSaveBeforeStart:v.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,h,v){if(!h)return new P.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:a,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,v,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,a),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(S=>S.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(c,h,v){if(!v)return new P.Disposable(()=>{});if(!this.definesDebugType(c,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:a,factory:v}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,a),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(S=>S.factory!==v),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(c,h){if(!h)return new P.Disposable(()=>{});const v=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:v,factory:h}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==h)})}async $runInTerminal(c,h){return Promise.resolve(void 0)}async $substituteVariables(c,h){if(!this._variableResolver){const[S,I]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(S||[],this._editorsService,I)}let v;const a=await this.getFolder(c);return a&&(v={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(v,h)}createDebugAdapter(c,h){if(c.type==="implementation")return new n(c.implementation)}createSignService(){}async $startDASession(c,h){const v=this,a=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const I=this.convertToDto(S),N=this.createDebugAdapter(I,a);if(!N)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const B=N;return this._debugAdapters.set(c,B),this.getDebugAdapterTrackers(a).then(E=>(E&&this._debugAdaptersTrackers.set(c,E),B.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const z=O,U={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(z.arguments.value);U.body={signature:$},B.sendResponse(U)}else throw new Error("no signer")}catch($){U.success=!1,U.message=$.message,B.sendResponse(U)}}else E&&E.onDidSendMessage&&E.onDidSendMessage(O),O=(0,o.convertToVSCPaths)(O,!0),v._debugServiceProxy.$acceptDAMessage(c,O)}),B.onError(O=>{E&&E.onError&&E.onError(O),this._debugServiceProxy.$acceptDAError(c,O.name,O.message,O.stack)}),B.onExit(O=>{E&&E.onExit&&E.onExit((0,F.withNullAsUndefined)(O),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,F.withNullAsUndefined)(O),void 0)}),E&&E.onWillStartSession&&E.onWillStartSession(),B.startSession()))})}$sendDAMessage(c,h){h=(0,o.convertToDAPaths)(h,!1);const v=this._debugAdaptersTrackers.get(c);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(h);const a=this._debugAdapters.get(c);a&&a.sendMessage(h)}$stopDASession(c){const h=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),h&&h.onWillStopSession&&h.onWillStopSession();const v=this._debugAdapters.get(c);return this._debugAdapters.delete(c),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const h=[],v=[],a=[];if(c.added)for(const S of c.added){const I=S.id;if(I&&!this._breakpoints.has(I)){let N;if(S.type==="function")N=new P.FunctionBreakpoint(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage);else if(S.type==="data")N=new P.DataBreakpoint(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage);else{const B=t.URI.revive(S.uri);N=new P.SourceBreakpoint(new P.Location(B,new P.Position(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage)}N._id=I,this._breakpoints.set(I,N),h.push(N)}}if(c.removed)for(const S of c.removed){const I=this._breakpoints.get(S);I&&(this._breakpoints.delete(S),v.push(I))}if(c.changed){for(const S of c.changed)if(S.id){const I=this._breakpoints.get(S.id);if(I){if(I instanceof P.FunctionBreakpoint&&S.type==="function"){const N=I;N.enabled=S.enabled,N.condition=S.condition,N.hitCondition=S.hitCondition,N.logMessage=S.logMessage,N.functionName=S.functionName}else if(I instanceof P.SourceBreakpoint&&S.type==="source"){const N=I;N.enabled=S.enabled,N.condition=S.condition,N.hitCondition=S.hitCondition,N.logMessage=S.logMessage,N.location=new P.Location(t.URI.revive(S.uri),new P.Position(S.line,S.character))}a.push(I)}}}this.fireBreakpointChanges(h,v,a)}$provideDebugConfigurations(c,h,v){return(0,T.asPromise)(async()=>{const a=this.getConfigProviderByHandle(c);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.getFolder(h);return a.provideDebugConfigurations(S,v)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(c,h,v,a){return(0,T.asPromise)(async()=>{const S=this.getConfigProviderByHandle(c);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.getFolder(h);return S.resolveDebugConfiguration(I,v,a)})}$resolveDebugConfigurationWithSubstitutedVariables(c,h,v,a){return(0,T.asPromise)(async()=>{const S=this.getConfigProviderByHandle(c);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.getFolder(h);return S.resolveDebugConfigurationWithSubstitutedVariables(I,v,a)})}async $provideDebugAdapter(c,h){const v=this.getAdapterDescriptorFactoryByHandle(c);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(h);return this.getAdapterDescriptor(v,a).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(S)})}async $acceptDebugSessionStarted(c){const h=await this.getSession(c);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(c){const h=await this.getSession(c);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,h){const v=await this.getSession(c);v&&v._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(c,h){const a={session:await this.getSession(c),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(c){if(c instanceof P.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof P.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const h=this._adapterFactories.filter(v=>v.type===c);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(c){const h=this._adapterFactories.filter(v=>v.handle===c);if(h.length>0)return h[0].factory}getConfigProviderByHandle(c){const h=this._configProviders.filter(v=>v.handle===c);if(h.length>0)return h[0].provider}definesDebugType(c,h){if(c.contributes){const v=c.contributes.debuggers;if(v&&v.length>0){for(const a of v)if(a.label&&a.type&&a.type===h)return!0}}return!1}getDebugAdapterTrackers(c){const v=c.configuration.type,a=this._trackerFactories.filter(S=>S.type===v||S.type==="*").map(S=>(0,T.asPromise)(()=>S.factory.createDebugAdapterTracker(c)).then(I=>I,I=>null));return Promise.race([Promise.all(a).then(S=>{const I=S.filter(N=>!!N);if(I.length>0)return new r(I)}),new Promise((S,I)=>{const N=setTimeout(()=>{clearTimeout(N),I(new Error("timeout"))},1e3)})]).catch(S=>{})}async getAdapterDescriptor(c,h){const v=h.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new P.DebugAdapterServer(v));if(c){const S=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>c.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,S))).then(I=>{if(I)return I})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,a))}daExecutableFromPackage(c,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,h,v){(c.length>0||h.length>0||v.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:h,changed:v}))}async getSession(c){if(c)if(typeof c=="string"){const h=this._debugSessions.get(c);if(h)return h}else{let h=this._debugSessions.get(c.id);if(!h){const v=await this.getFolder(c.folderUri),a=c.parent?this._debugSessions.get(c.parent):void 0;h=new D(this._debugServiceProxy,c.id,c.type,c.name,v,c.configuration,a),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(c){if(c){const h=t.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};f=Be([He(0,u.IExtHostRpcService),He(1,A.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,w.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,m.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class D{constructor(c,h,v,a,S,I,N){this._debugServiceProxy=c,this._id=h,this._type=v,this._name=a,this._workspaceFolder=S,this._configuration=I,this._parentSession=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,h)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=D;class l{constructor(c){this.value=Object.freeze({append(h){c.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=l;class M extends i.AbstractVariableResolverService{constructor(c,h,v,a,S){function I(){if(h){const N=h.activeEditor();if(N)return N.document.uri;const B=a.tabs.filter(E=>E.isActive);if(B.length>0){const E=B[0].resource;return E&&(E.primary||E.secondary)?E.primary??E.secondary:B[0].resource}}}super({getFolderUri:N=>{const B=c.filter(E=>E.name===N);if(B&&B.length>0)return B[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(N,B)=>v.getConfiguration(void 0,N).get(B),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const N=I();if(N)return s.normalize(N.fsPath)},getWorkspaceFolderPathForFile:()=>{if(S){const N=I();if(N){const B=S.getWorkspaceFolder(N);if(B)return s.normalize(B.uri.fsPath)}}},getSelectedText:()=>{if(h){const N=h.activeEditor();if(N&&!N.selection.isEmpty)return N.document.getText(N.selection)}},getLineNumber:()=>{if(h){const N=h.activeEditor();if(N)return String(N.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=M;class r{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(h=>h.onError?h.onError(c):void 0)}onExit(c,h){this.trackers.forEach(v=>v.onExit?v.onExit(c,h):void 0)}}class n extends C.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let b=class extends f{constructor(c,h,v,a,S,I){super(c,h,v,a,S,I)}createVariableResolver(c,h,v){return new M(c,h,v,this._editorTabs)}};b=Be([He(0,u.IExtHostRpcService),He(1,A.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,w.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,m.IExtHostEditorTabs)],b),e.WorkerExtHostDebugService=b}),define(ye[213],_e([0,1,73,2,5,32,27,25,13,28,3,33,89,12]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(m,f,D,l,M,r,n){this._apiFactory=m,this._extensionRegistry=f,this._instaService=D,this._extHostConfiguration=l,this._extHostExtensionService=M,this._initData=r,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),s.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,f,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(d,f)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(F,f,this._initData.environment.appUriScheme))}register(m){if(Array.isArray(m.nodeModuleName))for(let f of m.nodeModuleName)this._factories.set(f,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(f=>m.alternativeModuleName(f))}};o=Be([He(2,R.IInstantiationService),He(3,T.IExtHostConfiguration),He(4,w.IExtHostExtensionService),He(5,A.IExtHostInitDataService),He(6,p.ILogService)],o),e.RequireInterceptor=o;class u{constructor(m,f,D,l,M){this._apiFactory=m,this._extensionPaths=f,this._extensionRegistry=D,this._configProvider=l,this._logService=M,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,f){const D=this._extensionPaths.findSubstr(f);if(D){let l=this._extApiImpl.get(P.ExtensionIdentifier.toKey(D.identifier));return l||(l=this._apiFactory(D,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(D.identifier),l)),l}if(!this._defaultApiImpl){let l="";this._extensionPaths.forEach((M,r)=>l+=`	${r} -> ${M.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f}. These are the extension path mappings: 
${l}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let d=class{constructor(m,f,D){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=f.getProxy(y.MainContext.MainThreadTelemetry);const{environment:l}=D,M=f.getProxy(y.MainContext.MainThreadKeytar);if(l.appRoot){let r=l.appRoot.fsPath;i.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,n)=>M.$getPassword(r,n),setPassword:(r,n,b)=>M.$setPassword(r,n,b),deletePassword:(r,n)=>M.$deletePassword(r,n),findPassword:r=>M.$findPassword(r),findCredentials(r){return M.$findCredentials(r)}}}load(m,f){const D=this._extensionPaths.findSubstr(f);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:D?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const f=m.length;if(f<=7||!this.alternativeNames)return;const D=f-7;if((m.charAt(D)==="/"||m.charAt(D)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};d=Be([He(1,C.IExtHostRpcService),He(2,A.IExtHostInitDataService)],d);let F=class{constructor(m,f,D){this._extensionPaths=m,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=D.getProxy(y.MainContext.MainThreadTelemetry);const l=D.getProxy(y.MainContext.MainThreadWindow);this._impl=(M,r)=>{const n=t.URI.parse(M);return r?this.callOriginal(M,r):n.scheme==="http"||n.scheme==="https"?l.$openUri(n,M,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?l.$openUri(n,M,{}):this.callOriginal(M,r)}}load(m,f,D){const l=this._extensionPaths.findSubstr(f);return l&&(this._extensionId=l.identifier.value,this.sendShimmingTelemetry()),this._original=D(m),this._impl}callOriginal(m,f){return this.sendNoForwardTelemetry(),this._original(m,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};F=Be([He(2,C.IExtHostRpcService)],F)}),define(ye[214],_e([0,1,14,15,73,6,2,5,207,12,44,60,28,136,13,65,33,40]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(f,D,l,M){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=l,this._rpcProtocol=new C.RPCProtocol(f,null,M),D=_._transform(D,this._rpcProtocol);const r=new w.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());r.set(i.IExtHostInitDataService,{_serviceBrand:void 0,...D}),r.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),r.set(u.IURITransformerService,new u.URITransformerService(M)),r.set(d.IHostUtils,l);const n=new p.InstantiationService(r,!0);this._disposables.add(n.invokeFunction(h=>h.get(F.IExtHostTerminalService))),this._disposables.add(n.invokeFunction(h=>h.get(d.IExtHostExtensionService))),this._logService=n.invokeFunction(h=>h.get(A.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",D),this._extensionService=n.invokeFunction(h=>h.get(d.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const b=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(v,a)=>{let S="",I,N;for(const B of a)S+=`
	at ${B.toString()}`,N=B.getFileName(),!I&&N&&(I=h.findSubstr(k.URI.file(N)));return b.set(v,I),`${v.name||"Error"}: ${v.message||""}${S}`}});const g=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),c=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(h=>{const v=t.transformErrorForSerialization(h),a=b.get(h);a?g.$onExtensionRuntimeError(a.identifier,v):c.$onUnexpectedError(v)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(l=>{this._logService.error(l)}),this._rpcProtocol.dispose();const D=this._extensionService.deactivateAll();Promise.race([(0,s.timeout)(5e3),D]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(f,D){f.extensions.forEach(M=>M.extensionLocation=k.URI.revive(D.transformIncomingURIs(M.extensionLocation))),f.environment.appRoot=k.URI.revive(D.transformIncomingURIs(f.environment.appRoot));const l=f.environment.extensionDevelopmentLocationURI;return l&&(f.environment.extensionDevelopmentLocationURI=l.map(M=>k.URI.revive(D.transformIncomingURIs(M)))),f.environment.extensionTestsLocationURI=k.URI.revive(D.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=k.URI.revive(D.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=k.URI.revive(D.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=k.URI.revive(D.transformIncomingURIs(f.logsLocation)),f.logFile=k.URI.revive(D.transformIncomingURIs(f.logFile)),f.workspace=D.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=_}),define(ye[215],_e([0,1,17,20,43,29,24,188,41]),function(Z,e,s,t,y,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(i,p,o){this.config=i,this.provider=p,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=i.filePattern,this.includePattern=i.includePattern&&T.parse(i.includePattern),this.maxResults=i.maxResults||void 0,this.exists=i.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=i.excludePattern&&T.parse(i.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(i=>i.cancel()),this.activeCancellationTokens=new Set}search(i){const p=this.config.folderQueries||[];return new Promise((o,u)=>{const d=F=>{this.resultCount++,i(F)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(F=>{const _=F.toString(),m=s.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,m)||this.matchFile(d,{base:F,basename:m})}),Promise.all(p.map(F=>this.searchInFolder(F,d))).then(F=>{o({limitHit:this.isLimitHit,stats:F[0]||void 0})},F=>{u(new Error((0,y.toErrorMessage)(F)))})})}async searchInFolder(i,p){const o=new t.CancellationTokenSource,u=this.getSearchOptionsForFolder(i),d=this.initDirectoryTree(),F=new C.QueryGlobTester(this.config,i),_=!F.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(o),m=P.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,o.token),D=m.elapsed(),l=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(M=>{const r=s.posix.relative(i.folder.path,M.path);if(_){const n=s.basename(M.path);this.matchFile(p,{base:i.folder,relativePath:r,basename:n});return}this.addDirectoryEntries(d,i.folder,r,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,F,p),{providerTime:D,postProcessTime:l.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(i){const p=(0,C.resolvePatternsForProvider)(this.config.includePattern,i.includePattern),o=(0,C.resolvePatternsForProvider)(this.config.excludePattern,i.excludePattern);return{folder:i.folder,excludes:o,includes:p,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries({pathToEntries:i},p,o,u){if(o===this.filePattern){const F=s.basename(this.filePattern);this.matchFile(u,{base:p,relativePath:this.filePattern,basename:F})}function d(F){const _=s.basename(F),m=s.dirname(F);let f=i[m];f||(f=i[m]=[],d(m)),f.push({base:p,relativePath:F,basename:_})}d(o)}matchDirectoryTree({rootEntries:i,pathToEntries:p},o,u){const d=this,F=this.filePattern;function _(m){const f=T.hasSiblingFn(()=>m.map(D=>D.basename));for(let D=0,l=m.length;D<l;D++){const M=m[D],{relativePath:r,basename:n}=M;if(o.matchesExcludesSync(r,n,F!==n?f:void 0))continue;const b=p[r];if(b)_(b);else{if(r===F)continue;d.matchFile(u,M)}if(d.isLimitHit)break}}_(i)}matchFile(i,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||i(p))}}class R{constructor(){this.sessions=new Map}fileSearch(i,p,o,u){const d=this.getSessionTokenSource(i.cacheKey),F=new A(i,p,d&&d.token);let _=0;const m=f=>{_+=f.length,o(f.map(D=>this.rawMatchToSearchItem(D)))};return this.doSearch(F,R.BATCH_SIZE,m,u).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:f.stats}}))}clearCache(i){const p=this.getSessionTokenSource(i);p&&p.cancel()}getSessionTokenSource(i){if(!!i)return this.sessions.has(i)||this.sessions.set(i,new t.CancellationTokenSource),this.sessions.get(i)}rawMatchToSearchItem(i){return i.relativePath?{resource:k.joinPath(i.base,i.relativePath)}:{resource:i.base}}doSearch(i,p,o,u){u.onCancellationRequested(()=>{i.cancel()});const d=_=>{_&&(F.push(_),p>0&&F.length>=p&&(o(F),F=[]))};let F=[];return i.search(d).then(_=>(F.length&&o(F),_),_=>(F.length&&o(F),Promise.reject(_)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(ye[216],_e([0,1,16,20,43,29,11,17,24,10,2,41]),function(Z,e,s,t,y,T,k,P,C,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class i{constructor(m,f,D,l){this.query=m,this.provider=f,this.fileUtils=D,this.processType=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(m,f){const D=this.query.folderQueries||[],l=new t.CancellationTokenSource;return f.onCancellationRequested(()=>l.cancel()),new Promise((M,r)=>{this.collector=new o(m);let n=!1;const b=(g,c)=>{if(!n&&!this.isLimitHit){const h=this.resultSize(g);d(g)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,n=!0,l.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const v=this.resultSize(g);this.resultCount+=v,(v>0||!d(g))&&this.collector.add(g,c)}};Promise.all(D.map((g,c)=>this.searchInFolder(g,h=>b(h,c),l.token))).then(g=>{l.dispose(),this.collector.flush();const c=g.some(h=>!!h&&!!h.limitHit);M({limitHit:this.isLimitHit||c,messages:(0,s.flatten)(g.map(h=>h?.message?(0,A.isArray)(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},g=>{l.dispose();const c=(0,y.toErrorMessage)(g);r(new Error(c))})})}resultSize(m){return d(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}trimResultToSize(m,f){const D=Array.isArray(m.ranges)?m.ranges:[m.ranges],l=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:D.slice(0,f),preview:{matches:l.slice(0,f),text:m.preview.text},uri:m.uri}}async searchInFolder(m,f,D){const l=new w.QueryGlobTester(this.query,m),M=[],r={report:g=>{if(!this.validateProviderResult(g))return;const c=m.folder.scheme===k.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(g.uri))):void 0,h=C.relativePath(m.folder,g.uri);if(h){const v=l.includedInQuery(h,P.basename(h),c);(0,A.isPromise)(v)?M.push(v.then(a=>{a&&f(g)})):v&&f(g)}}},n=this.getSearchOptionsForFolder(m),b=await this.provider.provideTextSearchResults(p(this.query.contentPattern),n,r,D);return M.length&&await Promise.all(M),b}validateProviderResult(m){if(d(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(m){const f=(0,w.resolvePatternsForProvider)(this.query.includePattern,m.includePattern),D=(0,w.resolvePatternsForProvider)(this.query.excludePattern,m.excludePattern),l={folder:R.URI.from(m.folder),excludes:D,includes:f,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.fileUtils.toCanonicalName(m.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=i;function p(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class o{constructor(m){this._onResult=m,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new F(512,f=>this.sendItems(f))}add(m,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!C.isEqual(this._currentUri,m.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:m.uri,results:[]}),this._currentFileMatch.results.push(u(m))}pushToCollector(){const m=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,m)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(m){this._onResult(m)}}e.TextSearchResultsCollector=o;function u(_){return d(_)?{preview:{matches:(0,s.mapArrayOrNot)(_.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:_.preview.text},ranges:(0,s.mapArrayOrNot)(_.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function d(_){return!!_.preview}e.extensionResultIsMatch=d;class F{constructor(m,f){this.maxBatchSize=m,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(m,f){!m||this.addItemToBatch(m,f)}addItems(m,f){!m||this.addItemsToBatch(m,f)}addItemToBatch(m,f){this.batch.push(m),this.batchSize+=f,this.onUpdate()}addItemsToBatch(m,f){this.batch=this.batch.concat(m),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<F.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},F.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=F,F.TIMEOUT=4e3,F.START_BATCH_AFTER_COUNT=50}),define(ye[99],_e([0,1,6,5,3,215,13,65,12,2,216]),function(Z,e,s,t,y,T,k,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let w=class{constructor(u,d,F){this.extHostRpc=u,this._uriTransformer=d,this._logService=F,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,d){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const F=this._handlePool++;return this._textSearchProvider.set(F,d),this._proxy.$registerTextSearchProvider(F,this._transformScheme(u)),(0,s.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}registerFileSearchProvider(u,d){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const F=this._handlePool++;return this._fileSearchProvider.set(F,d),this._proxy.$registerFileSearchProvider(F,this._transformScheme(u)),(0,s.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}$provideFileSearchResults(u,d,F,_){const m=i(F),f=this._fileSearchProvider.get(u);if(f)return this._fileSearchManager.fileSearch(m,f,D=>{this._proxy.$handleFileMatch(u,d,D.map(l=>l.resource))},_);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,d,F,_){const m=this._textSearchProvider.get(u);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const f=i(F);return this.createTextSearchManager(f,m).search(l=>this._proxy.$handleTextMatch(u,d,l),_)}$enableExtensionHostSearch(){}createTextSearchManager(u,d){return new R.TextSearchManager(u,d,{readdir:F=>Promise.resolve([]),toCanonicalName:F=>F},"textSearchProvider")}};w=Be([He(0,k.IExtHostRpcService),He(1,P.IURITransformerService),He(2,C.ILogService)],w),e.ExtHostSearch=w;function i(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(p),extraFileResources:o.extraFileResources&&o.extraFileResources.map(u=>A.URI.revive(u))}}e.reviveQuery=i;function p(o){return{...o,folder:A.URI.revive(o.folder)}}}),define(ye[217],_e([0,1,44,94,31,93,32,39,49,40,97,98,99,71,64,69,95,50,30,68,85,70,190,12,173]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m,f,D,l,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(M.ILoggerService,l.ExtHostLoggerService),(0,s.registerSingleton)(M.ILogService,r.ExtHostLogService),(0,s.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,s.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,s.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration),(0,s.registerSingleton)(F.IExtHostConsumerFileSystem,F.ExtHostConsumerFileSystem),(0,s.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService),(0,s.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,s.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,s.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,s.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,s.registerSingleton)(i.IExtHostSearch,i.ExtHostSearch),(0,s.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage),(0,s.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,s.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,s.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,s.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow),(0,s.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace),(0,s.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState),(0,s.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,s.registerSingleton)(D.IExtHostEditorTabs,D.ExtHostEditorTabs)}),define(ye[218],_e([0,1,44,3]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class y{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(k){if(k&&this._dragOperations.has(k)){const P=this._dragOperations.get(k);return this._dragOperations.delete(k),P}}addDragOperationTransfer(k,P){this._dragOperations.set(k,P)}}e.TreeViewsDragAndDropService=y,(0,s.registerSingleton)(e.ITreeViewsDragAndDropService,y)}),define(ye[219],_e([0,1,123,24,2,4,6,14,7,10,16,8,20,152,218]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(_,m){if((0,A.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let f;return Array.isArray(_.highlights)&&(f=_.highlights.filter(D=>D.length===2&&typeof D[0]=="number"&&typeof D[1]=="number"),f=f.length?f:void 0),{label:_.label,highlights:f}}}class d{constructor(m,f,D){this._proxy=m,this.commands=f,this.logService=D,this.treeViews=new Map,this.treeDragAndDropService=new o.TreeViewsDragAndDropService;function l(M){return M&&M.$treeViewId&&M.$treeItemHandle}f.registerArgumentProcessor({processArgument:M=>l(M)?this.convertArgument(M):Array.isArray(M)&&M.length>0?M.map(r=>l(r)?this.convertArgument(r):r):M})}registerTreeDataProvider(m,f,D){const l=this.createTreeView(m,{treeDataProvider:f},D);return{dispose:()=>l.dispose()}}createTreeView(m,f,D){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=f.dragAndDropController?.supportedMimeTypes,M=!!f.dragAndDropController?.onWillDrop,r=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,dragAndDropMimeTypes:l,hasWillDrop:M}),n=this.createExtHostTreeView(m,f,D);return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get message(){return n.message},set message(b){n.message=b},get title(){return n.title},set title(b){n.title=b},get description(){return n.description},set description(b){n.description=b},reveal:(b,g)=>n.reveal(b,g),dispose:async()=>{await r,this.treeViews.delete(m),n.dispose()}}}$getChildren(m,f){const D=this.treeViews.get(m);return D?D.getChildren(f):Promise.reject(new Error((0,s.localize)(0,null,m)))}async $onDrop(m,f,D,l,M,r){const n=this.treeViews.get(m);if(!n)return Promise.reject(new Error((0,s.localize)(1,null,m)));const b=p.TreeDataTransferConverter.toITreeDataTransfer(f);return M===m&&r&&await this.addAdditionalTransferItems(b,n,r,l),n.onDrop(b,D)}async addAdditionalTransferItems(m,f,D,l){const M=this.treeDragAndDropService.removeDragOperationTransfer(l);let r;if(M)r=await M;else if(l&&f.onWillDrop){const n=f.onWillDrop(D);this.treeDragAndDropService.addDragOperationTransfer(l,n),r=await n}return r&&r.forEach((n,b)=>{n&&m.set(b,n)}),m}async $onWillDrop(m,f,D){const l=this.treeViews.get(m);if(!l)return Promise.reject(new Error((0,s.localize)(2,null,m)));const M=await this.addAdditionalTransferItems(new Map,l,f,D);if(!!M)return p.TreeDataTransferConverter.toTreeDataTransferDTO(M)}async $hasResolve(m){const f=this.treeViews.get(m);if(!f)throw new Error((0,s.localize)(3,null,m));return f.hasResolve}$resolve(m,f,D){const l=this.treeViews.get(m);if(!l)throw new Error((0,s.localize)(4,null,m));return l.resolveTreeItem(f,D)}$setExpanded(m,f,D){const l=this.treeViews.get(m);if(!l)throw new Error((0,s.localize)(5,null,m));l.setExpanded(f,D)}$setSelection(m,f){const D=this.treeViews.get(m);if(!D)throw new Error((0,s.localize)(6,null,m));D.setSelection(f)}$setVisible(m,f){const D=this.treeViews.get(m);if(!D)throw new Error((0,s.localize)(7,null,m));D.setVisible(f)}createExtHostTreeView(m,f,D){const l=new F(m,f,this._proxy,this.commands.converter,this.logService,D);return this.treeViews.set(m,l),l}convertArgument(m){const f=this.treeViews.get(m.$treeViewId);return f?f.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=d;class F extends k.Disposable{constructor(m,f,D,l,M,r){super();if(this.viewId=m,this.proxy=D,this.commands=l,this.logService=M,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new i.CancellationTokenSource,r.contributes&&r.contributes.views)for(const g in r.contributes.views)for(const c of r.contributes.views[g])c.id===m&&(this._title=c.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(g=>this._onDidChangeData.fire({message:!1,element:g}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(g=>this._onDidChangeData.fire({message:!1,element:g})));let n,b;this._register(T.Event.debounce(this._onDidChangeData.event,(g,c)=>(g||(g={message:!1,elements:[]}),c.element!==!1&&(n||(n=new Promise(h=>b=h),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(c.element)?g.elements.push(...c.element):g.elements.push(c.element)),c.message&&(g.message=!0),g),200,!0)(({message:g,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=b;return n=null,this.refresh(c).then(()=>h())})),g&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,A.isUndefinedOrNull)(m))}async getChildren(m){const f=m?this.getExtensionElement(m):void 0;if(m&&!f)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);let D=this.getChildrenNodes(m);return D||(D=await this.fetchChildrenNodes(f)),D?D.map(l=>l.item):void 0}getExtensionElement(m){return this.elements.get(m)}reveal(m,f){f=f||{select:!0,focus:!1};const D=(0,A.isUndefinedOrNull)(f.select)?!0:f.select,l=(0,A.isUndefinedOrNull)(f.focus)?!1:f.focus,M=(0,A.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(r=>this.resolveTreeNode(m,r[r.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:r.map(b=>b.item)},{select:D,focus:l,expand:M})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:D,focus:l,expand:M})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,f){const D=this.getExtensionElement(m);D&&(f?this._onDidExpandElement.fire(Object.freeze({element:D})):this._onDidCollapseElement.fire(Object.freeze({element:D})))}setSelection(m){(0,R.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(m){const f=[];for(const D of m){const l=this.getExtensionElement(D);l&&f.push(l)}if(!(!this.dndController?.onWillDrop||f.length===0))return this.dndController.onWillDrop(f)}get hasOnWillDrop(){return!!this.dndController?.onWillDrop}async onDrop(m,f){const D=this.getExtensionElement(f);if(!!D)return(0,P.asPromise)(()=>this.dndController?.onDrop(m,D))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,f){if(!this.dataProvider.resolveTreeItem)return;const D=this.elements.get(m);if(D){const l=this.nodes.get(D);if(l){const M=await this.dataProvider.resolveTreeItem(l.extensionItem,D,f)??l.extensionItem;return l.item.tooltip=this.getTooltip(M.tooltip),l.item.command=this.getCommand(l.disposableStore,M.command),l.item}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(f=>f?this.resolveUnknownParentChain(f).then(D=>this.resolveTreeNode(f,D[D.length-1]).then(l=>(D.push(l),D))):Promise.resolve([]))}resolveParent(m){const f=this.nodes.get(m);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,f){const D=this.nodes.get(m);return D?Promise.resolve(D):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(l=>this.createHandle(m,l,f,!0)).then(l=>this.getChildren(f?f.item.handle:void 0).then(()=>{const M=this.getExtensionElement(l);if(M){const r=this.nodes.get(M);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(m){if(m){let f;if(typeof m=="string"){const D=this.getExtensionElement(m);f=D?this.nodes.get(D):void 0}else f=m;return f&&f.children||void 0}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const f=new i.CancellationTokenSource(this._refreshCancellationSource.token);try{const D=m?this.nodes.get(m):void 0,l=await this.dataProvider.getChildren(m);if(f.token.isCancellationRequested)return;const M=await Promise.all((0,R.coalesce)(l||[]).map(async r=>{const n=await this.dataProvider.getTreeItem(r);return n&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(r,n,D):null}));return f.token.isCancellationRequested?void 0:(0,R.coalesce)(M)}finally{f.dispose()}}refresh(m){if(m.some(D=>!D))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new i.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const D=this.getHandlesToRefresh(m);if(D.length)return this.refreshHandles(D)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const f=new Set,D=m.map(M=>this.nodes.get(M));for(const M of D)if(M&&!f.has(M.item.handle)){let r=M;for(;r&&r.parent&&D.findIndex(n=>r&&r.parent&&n&&n.item.handle===r.parent.item.handle)===-1;){const n=this.elements.get(r.parent.item.handle);r=n?this.nodes.get(n):void 0}r&&!r.parent&&f.add(M.item.handle)}const l=[];return f.forEach(M=>{const r=this.elements.get(M);if(r){const n=this.nodes.get(r);n&&(!n.parent||!f.has(n.parent.item.handle))&&l.push(M)}}),l}refreshHandles(m){const f={};return Promise.all(m.map(D=>this.refreshNode(D).then(l=>{l&&(f[D]=l.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(m){const f=this.getExtensionElement(m);if(f){const D=this.nodes.get(f);if(D)return this.clearChildren(f),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(l=>{if(l){const M=this.createTreeNode(f,l,D.parent);return this.updateNodeCache(f,M,D,D.parent),D.dispose(),M}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,f,D){const l=this.createTreeNode(m,f,D);if(f.id&&this.elements.has(l.item.handle))throw new Error((0,s.localize)(8,null,f.id));return this.addNodeToCache(m,l),this.addNodeToParentCache(l,D),l}getTooltip(m){return C.MarkdownString.isMarkdownString(m)?w.MarkdownString.from(m):m}getCommand(m,f){return f?this.commands.toInternal(f,m):void 0}createTreeNode(m,f,D){const l=new k.DisposableStore,M=this.createHandle(m,f,D),r=this.getLightIconPath(f);return{item:{handle:M,parentHandle:D?D.item.handle:void 0,label:u(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(l,f.command),contextValue:f.contextValue,icon:r,iconDark:this.getDarkIconPath(f)||r,themeIcon:this.getThemeIcon(f),collapsibleState:(0,A.isUndefinedOrNull)(f.collapsibleState)?C.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:D,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(m){return m.iconPath instanceof C.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:f,label:D,resourceUri:l},M,r){if(f)return`${F.ID_HANDLE_PREFIX}/${f}`;const n=u(D,this.extension),b=M?M.item.handle:F.LABEL_HANDLE_PREFIX;let g=n?n.label:l?(0,t.basename)(l):"";g=g.indexOf("/")!==-1?g.replace("/","//"):g;const c=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,h=this.getChildrenNodes(M)||[];let v,a=0;do{if(v=`${b}/${a}:${g}`,r||!this.elements.has(v)||c===v)break;a++}while(a<=h.length);return v}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof C.ThemeIcon))return typeof m.iconPath=="string"||y.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof C.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return y.URI.isUri(m)?m:y.URI.file(m)}addNodeToCache(m,f){this.elements.set(f.item.handle,m),this.nodes.set(m,f)}updateNodeCache(m,f,D,l){this.elements.delete(f.item.handle),this.nodes.delete(m),f.item.handle!==D.item.handle&&this.elements.delete(D.item.handle),this.addNodeToCache(m,f);const M=this.getChildrenNodes(l)||[],r=M.filter(n=>n.item.handle===D.item.handle)[0];r&&M.splice(M.indexOf(r),1,f)}addNodeToParentCache(m,f){f?(f.children||(f.children=[]),f.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const f=this.nodes.get(m);if(f){if(f.children)for(const D of f.children){const l=this.elements.get(D.item.handle);l&&this.clear(l)}f.children=void 0}}else this.clearAll()}clear(m){const f=this.nodes.get(m);if(f){if(f.children)for(const D of f.children){const l=this.elements.get(D.item.handle);l&&this.clear(l)}this.nodes.delete(m),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}F.LABEL_HANDLE_PREFIX="0",F.ID_HANDLE_PREFIX="1"}),define(ye[220],_e([0,1,20,15,4,34,2,112,233,106,56,46,5,178,177,39,179,32,180,181,182,164,183,49,33,184,165,187,189,191,94,167,196,197,198,71,40,200,219,8,7,203,51,95,31,74,153,186,61,93,97,98,99,12,65,13,28,192,150,64,69,175,201,149,72,50,206,204,205,176,30,199,202,68,70,85,194,96,195,11,138,193,147,185,6,27]),function(Z,e,s,t,y,T,k,P,C,A,R,w,i,p,o,u,d,F,_,m,f,D,l,M,r,n,b,g,c,h,v,a,S,I,N,B,E,O,z,U,$,V,ue,K,re,pe,we,ae,le,Ce,Ee,Fe,$e,Ve,je,H,G,X,oe,q,ee,he,Re,Ue,ze,Qe,et,st,Xe,nt,lt,vt,Oe,Rt,j,Q,fe,Ne,qe,ot,ht,Je,Tt,Ae,De,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ie(se){const de=se.get(G.IExtHostInitDataService),me=se.get(lt.IExtHostFileSystemInfo),Te=se.get(Qe.IExtHostConsumerFileSystem),We=se.get(r.IExtHostExtensionService),Le=se.get(re.IExtHostWorkspace),Ke=se.get(Q.IExtHostTelemetry),it=se.get(F.IExtHostConfiguration),rt=se.get(je.IURITransformerService),ne=se.get(H.IExtHostRpcService),ge=se.get(B.IExtHostStorage),te=se.get(ze.IExtensionStoragePaths),W=se.get(Ve.ILoggerService),be=se.get(Ve.ILogService),Pe=se.get(q.IExtHostTunnelService),Ye=se.get(ee.IExtHostApiDeprecationService),xe=se.get(K.IExtHostWindow),ut=se.get(Rt.IExtHostSecretState),wt=se.get(j.IExtHostEditorTabs);ne.set(i.ExtHostContext.ExtHostFileSystemInfo,me),ne.set(i.ExtHostContext.ExtHostLogLevelServiceShape,W),ne.set(i.ExtHostContext.ExtHostWorkspace,Le),ne.set(i.ExtHostContext.ExtHostConfiguration,it),ne.set(i.ExtHostContext.ExtHostExtensionService,We),ne.set(i.ExtHostContext.ExtHostStorage,ge),ne.set(i.ExtHostContext.ExtHostTunnelService,Pe),ne.set(i.ExtHostContext.ExtHostWindow,xe),ne.set(i.ExtHostContext.ExtHostSecretState,ut),ne.set(i.ExtHostContext.ExtHostTelemetry,Ke),ne.set(i.ExtHostContext.ExtHostEditorTabs,wt);const Ct=ne.set(i.ExtHostContext.ExtHostDecorations,se.get(Ce.IExtHostDecorations)),bt=ne.set(i.ExtHostContext.ExtHostDocumentsAndEditors,se.get(M.IExtHostDocumentsAndEditors)),ft=ne.set(i.ExtHostContext.ExtHostCommands,se.get(u.IExtHostCommands)),pt=ne.set(i.ExtHostContext.ExtHostTerminalService,se.get(E.IExtHostTerminalService)),yt=ne.set(i.ExtHostContext.ExtHostDebugService,se.get(Fe.IExtHostDebugService)),Ot=ne.set(i.ExtHostContext.ExtHostSearch,se.get($e.IExtHostSearch)),kt=ne.set(i.ExtHostContext.ExtHostTask,se.get(Ee.IExtHostTask)),It=ne.set(i.ExtHostContext.ExtHostOutputService,se.get(v.IExtHostOutputService)),At=ne.set(i.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(ne)),St=ne.set(i.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(ne,bt)),zt=ne.set(i.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(ne,bt,be)),Lt=ne.set(i.ExtHostContext.ExtHostDocumentSaveParticipant,new D.ExtHostDocumentSaveParticipant(be,St,ne.getProxy(i.MainContext.MainThreadBulkEdits))),Et=ne.set(i.ExtHostContext.ExtHostNotebook,new X.ExtHostNotebookController(ne,ft,bt,St,te)),Qt=ne.set(i.ExtHostContext.ExtHostNotebookDocuments,new Tt.ExtHostNotebookDocuments(be,Et)),Vt=ne.set(i.ExtHostContext.ExtHostNotebookEditors,new Je.ExtHostNotebookEditors(be,ne,Et)),Yt=ne.set(i.ExtHostContext.ExtHostNotebookKernels,new fe.ExtHostNotebookKernels(ne,de,Et,ft,be)),si=ne.set(i.ExtHostContext.ExtHostNotebookRenderers,new qe.ExtHostNotebookRenderers(ne,Et)),Ft=ne.set(i.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(ne,bt)),Xt=ne.set(i.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(ne.getProxy(i.MainContext.MainThreadTreeViews),ft,be)),ai=ne.set(i.ExtHostContext.ExtHostEditorInsets,new we.ExtHostEditorInsets(ne.getProxy(i.MainContext.MainThreadEditorInsets),Ft,de)),Jt=ne.set(i.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(ne,be,me)),Wt=ne.set(i.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(ne,St,ft.converter,rt)),gt=ne.set(i.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(ne,rt,St,ft,Jt,be,Ye)),li=ne.set(i.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(ne,gt)),Nt=ne.set(i.ExtHostContext.ExtHostFileSystemEventService,new b.ExtHostFileSystemEventService(ne,be,bt)),jt=ne.set(i.ExtHostContext.ExtHostQuickOpen,(0,S.createExtHostQuickOpen)(ne,Le,ft)),Zt=ne.set(i.ExtHostContext.ExtHostSCM,new I.ExtHostSCM(ne,ft,be)),ci=ne.set(i.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(ne,ft,St)),fi=ne.set(i.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(ne.getProxy(i.MainContext.MainThreadProgress))),Ei=ne.set(i.ExtHostContext.ExtHosLabelService,new ae.ExtHostLabelService(ne)),mi=ne.set(i.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(ne)),ei=ne.set(i.ExtHostContext.ExtHostAuthentication,new he.ExtHostAuthentication(ne)),yi=ne.set(i.ExtHostContext.ExtHostTimeline,new Re.ExtHostTimeline(ne,ft)),qt=ne.set(i.ExtHostContext.ExtHostWebviews,new ue.ExtHostWebviews(ne,{remote:de.remote},Le,be,Ye)),Kt=ne.set(i.ExtHostContext.ExtHostWebviewPanels,new Xe.ExtHostWebviewPanels(ne,qt,Le)),_i=ne.set(i.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(ne,St,te,qt,Kt)),Si=ne.set(i.ExtHostContext.ExtHostWebviewViews,new et.ExtHostWebviewViews(ne,qt)),Gt=ne.set(i.ExtHostContext.ExtHostTesting,new vt.ExtHostTesting(ne,ft)),Ci=ne.set(i.ExtHostContext.ExtHostUriOpeners,new Oe.ExtHostUriOpeners(ne));ne.set(i.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(ne,Et,bt,ft));const ti=(0,pe.values)(i.ExtHostContext);ne.assertRegistered(ti);const Di=new nt.ExtHostBulkEdits(ne,bt),ki=new o.ExtHostClipboard(ne),ui=new h.ExtHostMessageService(ne,be),ii=new m.ExtHostDialogs(ne),gi=new N.ExtHostStatusBar(ne,ft.converter);return p.ExtHostApiCommands.register(ft),function(Me,xt,pi){const mt=function(){let Y=!Me.isUnderDevelopment;function ce(){Y||(be.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function ke(ct){if(Array.isArray(ct))ct.forEach(ke);else if(typeof ct=="string")ce();else{const _t=ct;typeof _t.scheme=="undefined"&&ce(),typeof _t.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ct}}(),ni={getSession(Y,ce,ke){return ei.getSession(Me,Y,ce,ke)},async hasSession(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"authSession"),!!await ei.getSession(Me,Y,ce,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider(Y,ce,ke,ct){return ei.registerAuthenticationProvider(Y,ce,ke,ct)}},Ii={registerCommand(Y,ce,ke){return ft.registerCommand(!0,Y,ce,ke,void 0,Me)},registerTextEditorCommand(Y,ce,ke){return ft.registerCommand(!0,Y,(...ct)=>{const _t=Ft.getActiveTextEditor();if(!_t){be.warn("Cannot execute "+Y+" because there is no active text editor.");return}return _t.edit(Dt=>{ce.apply(ke,[_t,Dt,...ct])}).then(Dt=>{Dt||be.warn("Edits from command "+Y+" were not applied.")},Dt=>{be.warn("An error occurred while running command "+Y,Dt)})},void 0,void 0,Me)},registerDiffInformationCommand:(Y,ce,ke)=>((0,ve.checkProposedApiEnabled)(Me,"diffCommand"),ft.registerCommand(!0,Y,async(...ct)=>{const _t=bt.activeEditor(!0);if(!_t){be.warn("Cannot execute "+Y+" because there is no active text editor.");return}const Dt=await Ft.getDiffInformation(_t.id);ce.apply(ke,[Dt,...ct])},void 0,void 0,Me)),executeCommand(Y,...ce){return ft.executeCommand(Y,...ce)},getCommands(Y=!1){return ft.getCommands(Y)}},vi={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get appHost(){return de.environment.appHost},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return pt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ke.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ke.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ce){return xe.openUri(Y,{allowTunneling:!!de.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===de.environment.appUriScheme)return At.createAppUri(Y);try{return await xe.asExternalUri(Y,{allowTunneling:!!de.remote.authority})}catch(ce){if((0,ht.matchesScheme)(Y,ot.Schemas.http)||(0,ht.matchesScheme)(Y,ot.Schemas.https))return Y;throw ce}},get remoteName(){return(0,le.getRemoteName)(de.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),de.remote.authority},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(vi);const bi=de.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Pi={createTestController(Y,ce){return Gt.createTestController(Y,ce)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Gt.createTestObserver()},runTests(Y){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Gt.runTests(Y)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Gt.results}},Ti={getExtension(Y){const ce=xt.getExtensionDescription(Y);if(ce)return new r.Extension(We,Me.identifier,ce,bi)},get all(){return xt.getAllExtensionDescriptions().map(Y=>new r.Extension(We,Me.identifier,Y,bi))},get onDidChange(){return xt.onDidChange}},Ai={createDiagnosticCollection(Y){return Jt.createDiagnosticCollection(Me.identifier,Y)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:Y=>Jt.getDiagnostics(Y),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Y,ce){return Wt.changeLanguage(Y.uri,ce)},match(Y,ce){return(0,R.score)(U.LanguageSelector.from(Y),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(Y,ce,ke){return gt.registerCodeActionProvider(Me,mt(Y),ce,ke)},registerCodeLensProvider(Y,ce){return gt.registerCodeLensProvider(Me,mt(Y),ce)},registerDefinitionProvider(Y,ce){return gt.registerDefinitionProvider(Me,mt(Y),ce)},registerDeclarationProvider(Y,ce){return gt.registerDeclarationProvider(Me,mt(Y),ce)},registerImplementationProvider(Y,ce){return gt.registerImplementationProvider(Me,mt(Y),ce)},registerTypeDefinitionProvider(Y,ce){return gt.registerTypeDefinitionProvider(Me,mt(Y),ce)},registerHoverProvider(Y,ce){return gt.registerHoverProvider(Me,mt(Y),ce,Me.identifier)},registerEvaluatableExpressionProvider(Y,ce){return gt.registerEvaluatableExpressionProvider(Me,mt(Y),ce,Me.identifier)},registerInlineValuesProvider(Y,ce){return gt.registerInlineValuesProvider(Me,mt(Y),ce,Me.identifier)},registerDocumentHighlightProvider(Y,ce){return gt.registerDocumentHighlightProvider(Me,mt(Y),ce)},registerLinkedEditingRangeProvider(Y,ce){return gt.registerLinkedEditingRangeProvider(Me,mt(Y),ce)},registerReferenceProvider(Y,ce){return gt.registerReferenceProvider(Me,mt(Y),ce)},registerRenameProvider(Y,ce){return gt.registerRenameProvider(Me,mt(Y),ce)},registerDocumentSymbolProvider(Y,ce,ke){return gt.registerDocumentSymbolProvider(Me,mt(Y),ce,ke)},registerWorkspaceSymbolProvider(Y){return gt.registerWorkspaceSymbolProvider(Me,Y)},registerDocumentFormattingEditProvider(Y,ce){return gt.registerDocumentFormattingEditProvider(Me,mt(Y),ce)},registerDocumentRangeFormattingEditProvider(Y,ce){return gt.registerDocumentRangeFormattingEditProvider(Me,mt(Y),ce)},registerOnTypeFormattingEditProvider(Y,ce,ke,...ct){return gt.registerOnTypeFormattingEditProvider(Me,mt(Y),ce,[ke].concat(ct))},registerDocumentSemanticTokensProvider(Y,ce,ke){return gt.registerDocumentSemanticTokensProvider(Me,mt(Y),ce,ke)},registerDocumentRangeSemanticTokensProvider(Y,ce,ke){return gt.registerDocumentRangeSemanticTokensProvider(Me,mt(Y),ce,ke)},registerSignatureHelpProvider(Y,ce,ke,...ct){return typeof ke=="object"?gt.registerSignatureHelpProvider(Me,mt(Y),ce,ke):gt.registerSignatureHelpProvider(Me,mt(Y),ce,typeof ke=="undefined"?[]:[ke,...ct])},registerCompletionItemProvider(Y,ce,...ke){return gt.registerCompletionItemProvider(Me,mt(Y),ce,ke)},registerInlineCompletionItemProvider(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),gt.registerInlineCompletionsProvider(Me,mt(Y),ce)},registerDocumentLinkProvider(Y,ce){return gt.registerDocumentLinkProvider(Me,mt(Y),ce)},registerColorProvider(Y,ce){return gt.registerColorProvider(Me,mt(Y),ce)},registerFoldingRangeProvider(Y,ce){return gt.registerFoldingRangeProvider(Me,mt(Y),ce)},registerSelectionRangeProvider(Y,ce){return gt.registerSelectionRangeProvider(Me,Y,ce)},registerCallHierarchyProvider(Y,ce){return gt.registerCallHierarchyProvider(Me,Y,ce)},registerTypeHierarchyProvider(Y,ce){return gt.registerTypeHierarchyProvider(Me,Y,ce)},setLanguageConfiguration:(Y,ce)=>gt.setLanguageConfiguration(Me,Y,ce),getTokenInformationAtPosition(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"tokenInformation"),Wt.tokenAtPosition(Y,ce)},registerInlayHintsProvider(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"inlayHints"),gt.registerInlayHintsProvider(Me,Y,ce)},createLanguageStatusItem(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"languageStatus"),Wt.createLanguageStatusItem(Me,Y,ce)}},Ri={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(Y,ce,ke){const ct=await(k.URI.isUri(Y)?Promise.resolve(ri.openTextDocument(Y)):Promise.resolve(Y));return Ft.showTextDocument(ct,ce,ke)},createTextEditorDecorationType(Y){return Ft.createTextEditorDecorationType(Me,Y)},onDidChangeActiveTextEditor(Y,ce,ke){return Ft.onDidChangeActiveTextEditor(Y,ce,ke)},onDidChangeVisibleTextEditors(Y,ce,ke){return Ft.onDidChangeVisibleTextEditors(Y,ce,ke)},onDidChangeTextEditorSelection(Y,ce,ke){return Ft.onDidChangeTextEditorSelection(Y,ce,ke)},onDidChangeTextEditorOptions(Y,ce,ke){return Ft.onDidChangeTextEditorOptions(Y,ce,ke)},onDidChangeTextEditorVisibleRanges(Y,ce,ke){return Ft.onDidChangeTextEditorVisibleRanges(Y,ce,ke)},onDidChangeTextEditorViewColumn(Y,ce,ke){return Ft.onDidChangeTextEditorViewColumn(Y,ce,ke)},onDidCloseTerminal(Y,ce,ke){return pt.onDidCloseTerminal(Y,ce,ke)},onDidOpenTerminal(Y,ce,ke){return pt.onDidOpenTerminal(Y,ce,ke)},onDidChangeActiveTerminal(Y,ce,ke){return pt.onDidChangeActiveTerminal(Y,ce,ke)},onDidChangeTerminalDimensions(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDimensions"),pt.onDidChangeTerminalDimensions(Y,ce,ke)},onDidChangeTerminalState(Y,ce,ke){return pt.onDidChangeTerminalState(Y,ce,ke)},onDidWriteTerminalData(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),pt.onDidWriteTerminalData(Y,ce,ke)},get state(){return xe.state},onDidChangeWindowState(Y,ce,ke){return xe.onDidChangeWindowState(Y,ce,ke)},showInformationMessage(Y,...ce){return ui.showMessage(Me,T.default.Info,Y,ce[0],ce.slice(1))},showWarningMessage(Y,...ce){return ui.showMessage(Me,T.default.Warning,Y,ce[0],ce.slice(1))},showErrorMessage(Y,...ce){return ui.showMessage(Me,T.default.Error,Y,ce[0],ce.slice(1))},showQuickPick(Y,ce,ke){return Array.isArray(Y)&&Y.some(ct=>ct.kind===$.QuickPickItemKind.Separator)&&(0,ve.checkProposedApiEnabled)(Me,"quickPickSeparators"),jt.showQuickPick(Y,ce,ke)},showWorkspaceFolderPick(Y){return jt.showWorkspaceFolderPick(Y)},showInputBox(Y,ce){return jt.showInput(Y,ce)},showOpenDialog(Y){return ii.showOpenDialog(Y)},showSaveDialog(Y){return ii.showSaveDialog(Y)},createStatusBarItem(Y,ce,ke){let ct,_t,Dt;return typeof Y=="string"?(ct=Y,_t=ce,Dt=ke):(_t=Y,Dt=ce),gi.createStatusBarEntry(Me,ct,_t,Dt)},setStatusBarMessage(Y,ce){return gi.setStatusBarMessage(Y,ce)},withScmProgress(Y){return Ye.report("window.withScmProgress",Me,"Use 'withProgress' instead."),fi.withProgress(Me,{location:$.ProgressLocation.SourceControl},(ce,ke)=>Y({report(ct){}}))},withProgress(Y,ce){return fi.withProgress(Me,Y,ce)},createOutputChannel(Y){return It.createOutputChannel(Y,Me)},createWebviewPanel(Y,ce,ke,ct){return Kt.createWebviewPanel(Me,Y,ce,ke,ct)},createWebviewTextEditorInset(Y,ce,ke,ct){return(0,ve.checkProposedApiEnabled)(Me,"editorInsets"),ai.createWebviewEditorInset(Y,ce,ke,ct,Me)},createTerminal(Y,ce,ke){return typeof Y=="object"?"pty"in Y?pt.createExtensionTerminal(Y):pt.createTerminalFromOptions(Y):pt.createTerminal(Y,ce,ke)},registerTerminalLinkProvider(Y){return pt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,ce){return pt.registerProfileProvider(Me,Y,ce)},registerTreeDataProvider(Y,ce){return Xt.registerTreeDataProvider(Y,ce,Me)},createTreeView(Y,ce){return Xt.createTreeView(Y,ce,Me)},registerWebviewPanelSerializer:(Y,ce)=>Kt.registerWebviewPanelSerializer(Me,Y,ce),registerCustomEditorProvider:(Y,ce,ke={})=>_i.registerCustomEditorProvider(Me,Y,ce,ke),registerFileDecorationProvider(Y){return Ct.registerFileDecorationProvider(Y,Me.identifier)},registerUriHandler(Y){return At.registerUriHandler(Me.identifier,Y)},createQuickPick(){return jt.createQuickPick(Me)},createInputBox(){return jt.createInputBox(Me.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Y,ce,ke){return mi.onDidChangeActiveColorTheme(Y,ce,ke)},registerWebviewViewProvider(Y,ce,ke){return Si.registerWebviewViewProvider(Me,Y,ce,ke?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(Y,ce,ke)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Vt.onDidChangeNotebookEditorSelection(Y,ce,ke)},onDidChangeNotebookEditorVisibleRanges(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Vt.onDidChangeNotebookEditorVisibleRanges(Y,ce,ke)},showNotebookDocument(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.showNotebookDocument(Y,ce)},registerExternalUriOpener(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"externalUriOpener"),Ci.registerExternalUriOpener(Me.identifier,Y,ce,ke)},get tabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),wt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),wt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),wt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),wt.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),g.InlineCompletionController.get(Y)}},ri={get rootPath(){return Ye.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(Y){throw t.readonly()},getWorkspaceFolder(Y){return Le.getWorkspaceFolder(Y)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(Y){throw t.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(Y){throw t.readonly()},updateWorkspaceFolders:(Y,ce,...ke)=>Le.updateWorkspaceFolders(Me,Y,ce||0,...ke),onDidChangeWorkspaceFolders:function(Y,ce,ke){return Le.onDidChangeWorkspace(Y,ce,ke)},asRelativePath:(Y,ce)=>Le.getRelativePath(Y,ce),findFiles:(Y,ce,ke,ct)=>Le.findFiles(U.GlobPattern.from(Y),U.GlobPattern.from(ce),ke,Me.identifier,ct),findTextInFiles:(Y,ce,ke,ct)=>{(0,ve.checkProposedApiEnabled)(Me,"findTextInFiles");let _t,Dt;return typeof ce=="object"?(_t=ce,Dt=ke):(_t={},Dt=ce,ct=ke),Le.findTextInFiles(Y,_t||{},Dt,Me.identifier,ct)},saveAll:Y=>Le.saveAll(Y),applyEdit(Y){return Di.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ce,ke,ct)=>Nt.createFileSystemWatcher(U.GlobPattern.from(Y),ce,ke,ct),get textDocuments(){return St.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw t.readonly()},openTextDocument(Y){let ce;const ke=Y;if(typeof Y=="string")ce=Promise.resolve(k.URI.file(Y));else if(k.URI.isUri(Y))ce=Promise.resolve(Y);else if(!ke||typeof ke=="object")ce=St.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(ct=>St.ensureDocumentData(ct).then(_t=>_t.document))},onDidOpenTextDocument:(Y,ce,ke)=>St.onDidAddDocument(Y,ce,ke),onDidCloseTextDocument:(Y,ce,ke)=>St.onDidRemoveDocument(Y,ce,ke),onDidChangeTextDocument:(Y,ce,ke)=>St.onDidChangeDocument(Y,ce,ke),onDidSaveTextDocument:(Y,ce,ke)=>St.onDidSaveDocument(Y,ce,ke),onWillSaveTextDocument:(Y,ce,ke)=>Lt.getOnWillSaveTextDocumentEvent(Me)(Y,ce,ke),get notebookDocuments(){return Et.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,ce){let ke;if(k.URI.isUri(Y))ke=Y,await Et.openNotebookDocument(Y);else if(typeof Y=="string")ke=k.URI.revive(await Et.createNotebookDocument({viewType:Y,content:ce}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(Y,ce,ke,ct){return Et.registerNotebookSerializer(Me,Y,ce,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(Y,ce,ke,ct)=>((0,ve.checkProposedApiEnabled)(Me,"notebookContentProvider"),Et.registerNotebookContentProvider(Me,Y,ce,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(Y,ce,ke)=>pi.onDidChangeConfiguration(Y,ce,ke),getConfiguration(Y,ce){return ce=arguments.length===1?void 0:ce,pi.getConfiguration(Y,ce,Me)},registerTextDocumentContentProvider(Y,ce){return zt.registerTextDocumentContentProvider(Y,ce)},registerTaskProvider:(Y,ce)=>(Ye.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Me,Y,ce)),registerFileSystemProvider(Y,ce,ke){return(0,De.combinedDisposable)(li.registerFileSystemProvider(Me,Y,ce,ke),Te.addFileSystemProvider(Y,ce))},get fs(){return Te.value},registerFileSearchProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"fileSearchProvider"),Ot.registerFileSearchProvider(Y,ce)),registerTextSearchProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"textSearchProvider"),Ot.registerTextSearchProvider(Y,ce)),registerRemoteAuthorityResolver:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),We.registerRemoteAuthorityResolver(Y,ce)),registerResourceLabelFormatter:Y=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Ei.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ce,ke)=>Nt.onDidCreateFile(Y,ce,ke),onDidDeleteFiles:(Y,ce,ke)=>Nt.onDidDeleteFile(Y,ce,ke),onDidRenameFiles:(Y,ce,ke)=>Nt.onDidRenameFile(Y,ce,ke),onWillCreateFiles:(Y,ce,ke)=>Nt.getOnWillCreateFileEvent(Me)(Y,ce,ke),onWillDeleteFiles:(Y,ce,ke)=>Nt.getOnWillDeleteFileEvent(Me)(Y,ce,ke),onWillRenameFiles:(Y,ce,ke)=>Nt.getOnWillRenameFileEvent(Me)(Y,ce,ke),openTunnel:Y=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Pe.openTunnel(Me,Y).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),Pe.getTunnels()},onDidChangeTunnels:(Y,ce,ke)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Pe.onDidChangeTunnels(Y,ce,ke)),registerPortAttributesProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"portsAttributes"),Pe.registerPortsAttributesProvider(Y,ce)),registerTimelineProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"timeline"),yi.registerTimelineProvider(Y,ce,Me.identifier,ft.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:Y=>((0,ve.checkProposedApiEnabled)(Me,"workspaceTrust"),Le.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,ce,ke)=>Le.onDidGrantWorkspaceTrust(Y,ce,ke)},Fi={get inputBox(){return Ye.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),Zt.getLastInputBox(Me)},createSourceControl(Y,ce,ke){return Zt.createSourceControl(Me,Y,ce,ke)}},Mi={createCommentController(Y,ce){return ci.createCommentController(Me,Y,ce)}},Oi={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},onDidStartDebugSession(Y,ce,ke){return yt.onDidStartDebugSession(Y,ce,ke)},onDidTerminateDebugSession(Y,ce,ke){return yt.onDidTerminateDebugSession(Y,ce,ke)},onDidChangeActiveDebugSession(Y,ce,ke){return yt.onDidChangeActiveDebugSession(Y,ce,ke)},onDidReceiveDebugSessionCustomEvent(Y,ce,ke){return yt.onDidReceiveDebugSessionCustomEvent(Y,ce,ke)},onDidChangeBreakpoints(Y,ce,ke){return yt.onDidChangeBreakpoints(Y,ce,ke)},registerDebugConfigurationProvider(Y,ce,ke){return yt.registerDebugConfigurationProvider(Y,ce,ke||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ce){return yt.registerDebugAdapterDescriptorFactory(Me,Y,ce)},registerDebugAdapterTrackerFactory(Y,ce){return yt.registerDebugAdapterTrackerFactory(Y,ce)},startDebugging(Y,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?yt.startDebugging(Y,ce,{parentSession:ke}):yt.startDebugging(Y,ce,ke||{})},stopDebugging(Y){return yt.stopDebugging(Y)},addBreakpoints(Y){return yt.addBreakpoints(Y)},removeBreakpoints(Y){return yt.removeBreakpoints(Y)},asDebugSourceUri(Y,ce){return yt.asDebugSourceUri(Y,ce)}},Li={registerTaskProvider:(Y,ce)=>kt.registerTaskProvider(Me,Y,ce),fetchTasks:Y=>kt.fetchTasks(Y),executeTask:Y=>kt.executeTask(Me,Y),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(Y,ce,ke)=>kt.onDidStartTask(Y,ce,ke),onDidEndTask:(Y,ce,ke)=>kt.onDidEndTask(Y,ce,ke),onDidStartTaskProcess:(Y,ce,ke)=>kt.onDidStartTaskProcess(Y,ce,ke),onDidEndTaskProcess:(Y,ce,ke)=>kt.onDidEndTaskProcess(Y,ce,ke)},Ni={createNotebookController(Y,ce,ke,ct,_t){return Yt.createNotebookController(Me,Y,ce,ke,ct,(0,ve.isProposedApiEnabled)(Me,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(Y,ce)=>Et.registerNotebookCellStatusBarItemProvider(Me,Y,ce),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditorDecorationType"),Vt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return si.createRendererMessaging(Me,Y)},onDidChangeNotebookDocumentMetadata(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(Y,ce,ke)},onDidChangeNotebookCells(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.onDidChangeNotebookCells(Y,ce,ke)},onDidChangeNotebookCellExecutionState(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(Y,ce,ke)},onDidChangeCellOutputs(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.onDidChangeCellOutputs(Y,ce,ke)},onDidChangeCellMetadata(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.onDidChangeCellMetadata(Y,ce,ke)},createConcatTextDocument(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"notebookConcatTextDocument"),new Ue.ExtHostNotebookConcatDocument(Et,St,Y,ce)}};return{version:de.version,authentication:ni,commands:Ii,comments:Mi,debug:Oi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Fi,tasks:Li,tests:Pi,window:Ri,workspace:ri,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:s.CancellationTokenSource,CandidatePortSource:i.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:A.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:i.UIKind,Uri:k.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:Ne.TextSearchCompleteMessageType,TreeDataTransfer:$.TreeDataTransfer,TreeDataTransferItem:$.TreeDataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ie}),define(ye[221],_e([0,1,220,33,213,7,14,5,11]),function(Z,e,s,t,y,T,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class A extends y.RequireInterceptor{_installInterceptor(){}getModule(o,u){for(let d of this._alternatives){let F=d(o);if(F){o=F;break}}if(this._factories.has(o))return this._factories.get(o).load(o,u,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends t.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const o=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);i(o,this._initData.environment.isExtensionDevelopmentDebug);const u=this._instaService.invokeFunction(s.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(A,u,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(o){return o.browser}async _loadCommonJSModule(o,u,d){u=u.with({path:w(u.path,".js")}),o&&performance.mark(`code/extHost/willFetchExtensionCode/${o.value}`);const F=await fetch(C.FileAccess.asBrowserUri(u).toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o.value}`),F.status!==200)throw new Error(F.statusText);const _=await F.text(),m=`${u.toString(!0)}#vscode-extension`,f=`${_}
//# sourceURL=${m}`;let D;try{D=new Function("module","exports","require",f)}catch(n){throw console.error(o?`Loading code for extension ${o.value} failed: ${n.message}`:`Loading code failed: ${n.message}`),console.error(`${u.toString(!0)}${typeof n.line=="number"?` line ${n.line}`:""}${typeof n.column=="number"?` column ${n.column}`:""}`),console.error(n),n}const l={},M={exports:l},r=n=>{const b=this._fakeModules.getModule(n,u);if(b===void 0)throw new Error(`Cannot load module '${n}'`);return b};try{return d.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o.value}`),D(M,l,r),M.exports!==l?M.exports:l}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o.value}`),d.codeLoadingStop()}}async $setRemoteEnvironment(o){}async _waitForDebuggerAttachment(o=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const u=Date.now()+o;for(;Date.now()<u&&!("__jsDebugIsReady"in globalThis);)await(0,k.timeout)(10)}}e.ExtHostExtensionService=R;function w(p,o){return p.endsWith(o)?p:p+o}function i(p,o){u("info","log"),u("log","log"),u("warn","warn"),u("error","error");function u(_,m){const f=console[_];console[_]=function(){p.$logExtensionHostMessage({type:"__$console",severity:m,arguments:F(arguments)}),o&&f.apply(console,arguments)}}const d=1e5;function F(_){const m=[],f=[];if(_.length)for(let D=0;D<_.length;D++){if(typeof _[D]=="undefined")_[D]="undefined";else if(_[D]instanceof Error){const l=_[D];l.stack?_[D]=l.stack:_[D]=l.toString()}f.push(_[D])}try{const D=JSON.stringify(f,function(l,M){if(M&&typeof M=="object"){if(m.indexOf(M)!==-1)return"[Circular]";m.push(M)}return M});return D.length>d?"Output omitted for a large object that exceeds the limits":D}catch(D){return`Output omitted for an object that cannot be inspected ('${D.toString()}')`}}}}),define(ye[222],_e([0,1,44,33,72,221]),function(Z,e,s,t,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(t.IExtHostExtensionService,T.ExtHostExtensionService),(0,s.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths)}),define(ye[234],_e([0,1,22,4,171,214,208,17,73,11,2,217,222]),function(Z,e,s,t,y,T,k,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const i=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const p=fetch.bind(self);if(self.fetch=function(m,f){return m instanceof Request||/^file:/i.test(String(m))&&(m=A.FileAccess.asBrowserUri(R.URI.parse(String(m))).toString(!0)),p(m,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(m,f,D,l,M){return/^file:/i.test(f.toString())&&(f=A.FileAccess.asBrowserUri(R.URI.parse(f.toString())).toString(!0)),super.open(m,f,D??!0,l,M)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const m=self.Worker;Worker=function(f,D){/^file:/i.test(f.toString())&&(f=A.FileAccess.asBrowserUri(R.URI.parse(f.toString())).toString(!0));const M=`(${function(g){function c(a){return typeof a=="string"||a instanceof URL?String(a).replace(/^file:\/\//i,"vscode-file://vscode-app"):a}const h=fetch.bind(self);self.fetch=function(a,S){return a instanceof Request?h(a,S):h(c(a),S)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,S,I,N,B){return super.open(a,c(S),I??!0,N,B)}};const v=importScripts.bind(self);self.importScripts=(...a)=>{v(...a.map(c))},v(g)}.toString()}('${f}'))`;D=D||{},D.name=D.name||P.basename(f.toString());const r=new Blob([M],{type:"application/javascript"}),n=URL.createObjectURL(r);return new m(n,D)}}else self.Worker=class extends k.NestedWorker{constructor(m,f){super(i,m,{name:P.basename(m.toString()),...f})}};const o=new class{constructor(){this.pid=void 0}exit(m){w()}async exists(m){return!0}async realpath(m){return m}};class u{constructor(){const f=new MessageChannel,D=new t.Emitter;let l=!1;i(f.port2,[f.port2]),f.port1.onmessage=M=>{const{data:r}=M;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const n=s.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,y.isMessageOfType)(n,2)){l=!0,F("received terminate message from renderer");return}D.fire(n)},this.protocol={onMessage:D.event,send:M=>{if(!l){const r=M.buffer.buffer.slice(M.buffer.byteOffset,M.buffer.byteOffset+M.buffer.byteLength);f.port1.postMessage(r,[r])}}}}}function d(m){return new Promise(f=>{const D=m.onMessage(l=>{D.dispose();const M=JSON.parse(l.toString());m.send((0,y.createMessageOfType)(0)),f({protocol:m,initData:M})});m.send((0,y.createMessageOfType)(1))})}let F=m=>w();function _(){const m=new u;C.mark("code/extHost/willConnectToRenderer"),d(m.protocol).then(f=>{C.mark("code/extHost/didWaitForInitData");const D=new T.ExtensionHostMain(f.protocol,f.initData,o,null);F=l=>D.terminate(l)})}e.create=_})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f0054e049cd286ff317c738efe0fd8810b48ae98/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
